C     --- ALIGN_DB.f---
C --------------------------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
C ----
      CHARACTER NAME_1*256,NAME_2*256 
      CHARACTER NAME_OUT1*256,NAME_OUT2*256
      CHARACTER NAME_OUT*256,CORR*1
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80,JOB*80
      CHARACTER PATH*1,EXT*1
      CHARACTER DIST*1,VAR*1,ADOM*1
C ---
      INCLUDE 'align_DB_version.fh'
C --------------------------------------------------------------------
      M = 0
      PATH_OUT = ' '
      MDOC    = 1
      PROG = 'align_DB'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------
      LINE = VERSION
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.75) LEN = 75
      LINE = 'Sol_'//LINE(1:LEN)
      CALL MSGDOC(M,'Sol_ ')
      CALL MSGDOC(M,LINE)
      CALL MSGDOC(M,'Sol_ ')
C -------------------------------------------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
c ----------------------------
      JOB  = 'align_DB'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(M,LINE)
        IERR = 9
        GO TO 900
      ENDIF
      CLOSE(IOUT)
C -----------------------
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      NAME_OUT  = ' '
      NAME_OUT1 = ' '
      NAME_OUT2 = ' '

      ITRANS = 0
      PO = 0.0
      PE = 0.0
      DP = 0.0
      VAR  = ' '
      DIST = ' '
      ADOM = ' '
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      DIST = 'N'
      CALL SET_DEFAULT(
     *'FILE_1:  filename - PDB or sequence file')
      CALL SET_DEFAULT(
     *'FILE_2:  filename - PDB or sequence file')
      CALL SET_DEFAULT(
     *'FILE_O:  filename - output PDB file')
      CALL SET_DEFAULT(
     *'DIST:    <N>/D/P/W - ')
      CALL SET_DEFAULT(
     *'ROT:    <0>/1     -  1 rotate file_2 (corr=2)')
      CALL SET_DEFAULT(
     *'CORR:    <N>/Y/2  - Y output rotated full file_2')
      CALL SET_DEFAULT(
     *'                    2 two output aligned files')
      CALL SET_DEFAULT(
     *'                    N output aligned file_2')
      CALL SET_DEFAULT(
     *'                    P create profile ')

      CALL SET_DEFAULT('PO:          - ')
      CALL SET_DEFAULT('PE:          - ')
      CALL SET_DEFAULT('DP:          - ')
      CALL SET_DEFAULT('VAR: <N>,S,D - ')
      CALL SET_DEFAULT('DOM: <C>,D   - ')

      CALL SET_DEFAULT(
     *'PATH_SCR:   < >   - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_1'
      CALL ASK(LINE)
      NAME_1=LINE
      CALL CORR_NAME_ALL(NAME_1)
c ----
      LINE='FILE_O'
      CALL ASK(LINE)
      NAME_OUT=LINE
      CALL CORR_NAME_ALL(NAME_OUT)
c ----
      LINE='FILE_2'
      CALL ASK(LINE)
      NAME_2=LINE
      CALL CORR_NAME_ALL(NAME_2)
c ----
      LINE='PO'
      CALL ASK(LINE)
      READ(LINE,*) PO
c ----
      LINE='PE'
      CALL ASK(LINE)
      READ(LINE,*) PE
c ----
      LINE='DP'
      CALL ASK(LINE)
      READ(LINE,*) DP
c ----
      LINE='ROT'
      CALL ASK(LINE)
      READ(LINE,*) ITRANS
C ----
      LINE='CORR'
      CALL ASK(LINE)
      CORR=LINE(1:1)
C ----
      LINE='DIST'
      CALL ASK(LINE)
      DIST=LINE(1:1)
C ----
      LINE='VAR'
      CALL ASK(LINE)
      VAR=LINE(1:1)
C ----
      LINE='DOM'
      CALL ASK(LINE)
      ADOM=LINE(1:1)
c ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C -----------------------
      CALL CLOSE_BATCH(MDOC)

      CALL ALIGN_DB(MDOC,DIST
     * ,NAME_1,NAME_2,NAME_OUT,NAME_OUT1,NAME_OUT2
     * ,PO,PE,DP,VAR,CORR,ITRANS,ADOM
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C -----------------------
      CALL WRITE_ALIGN_DB_XML(MDOC,IERR
     *     ,RESULT,IPRROW,JOB,PATH_OUT,JERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE  WRITE_ALIGN_DB_XML(MDOC,IERR_INPUT
     *     ,RESULT,IPRROW
     *     ,JOB,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR,IERR_INPUT
      CHARACTER JOB*(*)
      REAL      RESULT (IPRROW)
      CHARACTER LINE*256,FILE_2*256,MESSAGE*80
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM
C       RESULT(6) = SUM_SCORE 

        NAA1 = RESULT(1)
        NAA2 = RESULT(2) 
        NAA_ALIGN = RESULT(3)
        NAA_IDENT = RESULT(4)
        FDENT = RESULT(5)
        SCORE = RESULT(6)

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_1 <naa_1> ',NAA1,' </naa_1>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_2 <naa_2> ',NAA2,' </naa_2>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'naa_align <naa_align> ',NAA_ALIGN,' </naa_align>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *   'naa_ident <naa_ident> ',NAA_IDENT,' </naa_ident>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F8.3,A)',ERR=510) 
     *   'ident <ident> ',FDENT,' </ident>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
 
        WRITE(LINE,'(A,F8.3,A)',ERR=510) 
     *   'score <score> ',SCORE,' </score>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE ALIGN_DB(MDOC,DIST
     * ,NAME_1,NAME_2,NAME_OUT,NAME_OUT1,NAME_OUT2
     * ,PO,PE,DP,VAR,CORR,ITRANS,ADOM
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT(IPRROW)    
      CHARACTER NAME_1*(*),NAME_2*(*) 
      CHARACTER NAME_OUT1*(*),NAME_OUT2*(*)
      CHARACTER NAME_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ----
      INTEGER   MDOC,IERR
      CHARACTER LINE*256
      CHARACTER PAR_ALIGN*16
      CHARACTER PATH*1,EXT*1,CHAIN*1,DIST*1,CORR*1
      CHARACTER FULL*1,VAR*1,ADOM*1
      CHARACTER FILE_PAIR*256

c      PARAMETER ( MEMORY = 8000000 )
c      REAL      POOL(MEMORY)
c      PARAMETER ( IPRSYM = 1 )
c      INTEGER*2 ISYM(5,3,IPRSYM)
c      REAL      RESULT2(21)    

C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C -----------------------

C      ITRANS = ??

      IF(CORR.EQ.'y') CORR = 'Y'
      IF(CORR.EQ.'p') CORR = 'P'
      IF(CORR.NE.'Y'.AND.CORR.NE.'2'.AND.CORR.NE.'P') CORR = 'N'

      IF(VAR.EQ.'s') VAR = 'S'
      IF(VAR.EQ.'d') VAR = 'D'
      IF(VAR.NE.'S'.AND.VAR.NE.'D') VAR = 'N'

      IF(ADOM.EQ.'d') ADOM = 'D'
      IF(ADOM.NE.'D') ADOM = 'C'

c      IF(MODE.NE.'1'.AND.MODE.NE.'H'.AND.MODE.NE.'B'.AND.
c     *   MODE.NE.'S'.AND.MODE.NE.'K') MODE='G'
c      WRITE(LINE,'('' MATRIX (UNIT-1,GOMOLOGY-<G>,HYDROPHOB-H '')')
c      CALL MSGDOC(MDOC,LINE)

c --
C         MODE    = PAR_ALIGN(1:1) matrix 
cC       2: CORR --> Y output file(pdb) (name with ext) (default: align.pdb)
c          PAR_ALIGN(2:2) = 'Y'
c          CORR = S : output file: sequence with SS and SURF (SS=Y,D3=Y)
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
cC       4: SS_FLAG  use SS
cc       5: remove surf from output
cc       6: OCC_FLAG - set ss_flag to second pdb file

      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B' 
c      PAR_ALIGN(1:1) = 'S' 

      PAR_ALIGN(2:2) = 'N' 
      PAR_ALIGN(2:2) = CORR 

      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 

      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 

      IF(DIST.EQ.'p') DIST = 'P'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.EQ.'w') DIST = 'W'
      IF(DIST.NE.'D'.AND.DIST.NE.'P'.AND.DIST.NE.'W') DIST = 'N'
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
C        PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
cc        DPENR   = 0.346
      ELSE
c       'B'
cc        DPENR   = 0.312
      ENDIF
      OPENR   = 0.462
      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
      DPENR   = 0.0

      IF(PO.GT.0.001)  OPENR  = PO
      IF(PO.LT.-0.001) OPENR  = 0.0
      IF(PE.GT.0.001)  PENEXR = PE
      IF(PE.LT.-0.001) PENEXR = 0.0
      IF(DP.GT.0.001)  DPENR  = DP
c     IF(DP.LT.-0.001) DPENR  = 0.0
      IF(DP.LE.0.0)    DPENR  = 0.0

      MODEL    = 1
      CHAIN    = ' '
c     NAME_OUT = 'model.pdb'
      IPRINT   = 2
c     IPRINT   = 1
      IERR = 0
      IF(ITRANS.EQ.1) IERR = 1

      FILE_PAIR = ' '
      FILE_PAIR = 'align_pair.txt'
      FULL      = 'N'

      CALL ALIGN_4(MDOC,NAME_1,NAME_2,NAME_OUT,PATH_SCR
     *    ,FILE_PAIR,FULL,ADOM
     *    ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *    ,RESULT,IPRROW,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: in ALIGN_4')
        GO TO 900
      ENDIF
C -------------------------------------------------
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c      IF(IPRROW.GE.42) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c        RESULT(42) = Q
c      ENDIF
C -------------------------------------------------
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5)
          SCORE = RESULT(18)
  900 CONTINUE
C -----------------------
      RETURN
      END

      SUBROUTINE ALIGN_5(MDOC,FILE_11,FILE_22,FILE_OUT,PATH_SCR
     * ,FILE_PAIR,FULL,ADOM
     * ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     * ,RESULT,IPRROW,IERR)
C ------------------------------------------------------------
C -P- 
C ALIGN   alignes optimally 2 aminoacid sequences. 
C -S-
C         File with sequence is ASCII file:
C
C        !>prot_id
C        !# sequence 
C        !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C        !# this is comment
C        !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C        !NRGTRITKEVFDNLTNWKNSAQ
C
C         If first symbol in the line is "#" it means the line is comments
C         Blancs are ignored.
C         
C      
C      Dialogue and Batch:
C
C   FILE_1:           - Input coordinate file-1 (sequence)
C   FILE_2:           - Input coordinate file-2 (sequence)
C   MODE: <G>,1,H,S,K - matrix of comparison which will be used
C                   G - gomology
C                   1 - unit
C                   H - hydrophobic
C                   S - structure
C                   K - kodon
C   PEN:     <0>      - gap-penalty factor. From 0 to 1
C
C      Parameters of subroutine:
C
C      MDOC  - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C
C      IERR   - signal of error / =1 -error , =o - OK / 
C      RESULT /real RESULT(21)/ - array for output information:
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c      IF(IPRROW.GE.42) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c        RESULT(42) = Q
c      ENDIF
C -I-
C ---------------------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      RESULT2(21)    
      INTEGER   MDOC,IERR
      CHARACTER PAR_ALIGN*16,CHAIN*1

      CHARACTER FULL*1,ADOM*1
      CHARACTER FILE_PAIR*(*)

      REAL      OPENR,DPENR,PENEXR
      CHARACTER PATH_SCR*(*)
      CHARACTER FILE_11*(*),FILE_22*(*),FILE_OUT*(*)
C ---
C      REAL      COORD1(NMAX1,3)
C      REAL      COORD2(NMAX1,3)
C      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX1),ISS1(NMAX1),ISS2(NMAX1)
C      INTEGER   ICHAIN1(NMAX1),ICHAIN2(NMAX1)
C      INTEGER   IRES1(NMAX1),IRES2(NMAX1)

      real,      allocatable :: COORD1(:,:)
      real,      allocatable :: ASEQ1(:)
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: IPROFILE1(:,:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)

      real,      allocatable :: COORD2(:,:)
      real,      allocatable :: ASEQ2(:)
      integer,   allocatable :: NSEQ2(:)
      integer,   allocatable :: IRES2(:)
      integer,   allocatable :: SURF2(:)
      integer,   allocatable :: ICHAIN2(:)
      integer,   allocatable :: IPROFILE2(:,:)
      integer,   allocatable :: IDOMAIN2(:)
      integer,   allocatable :: SS2(:)
      integer,   allocatable :: ISS2(:)
      character(LEN=6), allocatable :: PNUM2(:)

C      REAL      AMATRIX(NMAX1,NMAX2)
c      REAL      SCORE(NMAX12,3)
c      INTEGER   IPAIR(2,NMAX12)

      real,      allocatable :: AMATRIX(:,:)
      real,      allocatable :: SCORE(:,:)
      integer,   allocatable :: IPAIR(:,:)
      integer,   allocatable :: IPAIR_STOR(:,:)

C ---
      CHARACTER MODE*1,CORR*1,PAIR*1
      CHARACTER SS_FLAG*1,D3_FLAG*1,WS_FLAG*1,OCC_FLAG*1,DIST*1
      CHARACTER FILE_OUT1*256,FILE_OUT2*256
      CHARACTER FILE_1*256,FILE_2*256,FILE_SCR*256
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C -----
C ---------------------------------------
      CHARACTER NAM1*4,NAM2*4,CODE8*8
      CHARACTER CODE8_1*8,CODE8_2*8
      CHARACTER PATH*1,EXT*1
C ----
      REAL AMAT(25,25),TRMAT(3,3),TR(3)
C ----
      CHARACTER LINE*256
C --------------------------------------------------------
      ITRANS = 0
      IF(IERR.EQ.1) ITRANS = 1
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --
      NSEQ_PROFILE1 = 0
      NSEQ_PROFILE2 = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      MODE    = PAR_ALIGN(1:1) 
      CORR    = PAR_ALIGN(2:2) 
      D3_FLAG = PAR_ALIGN(3:3)
      SS_FLAG = PAR_ALIGN(4:4)
      WS_FLAG = PAR_ALIGN(5:5)
C     if y remove surf
c ---
      OCC_FLAG = PAR_ALIGN(6:6)
      DIST     = PAR_ALIGN(7:7)
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
c       SS_FLAG = 'N'
        D3_FLAG = 'N'
      ENDIF
      PAIR = 'N'
      CALL LENSTR_BL(FILE_PAIR,LEN)
      IF(LEN.GT.0) PAIR = 'Y'

      WRITE(LINE,'(''Flag D3,SS,OCC,CORR,DIST:'',A,A,A,A,A)') 
     * D3_FLAG,SS_FLAG,OCC_FLAG,CORR,DIST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''PAIR,FULL,ADOM:'',A,A,A)') PAIR,FULL,ADOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''MODE:'',A)') MODE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''ITRANS:'',I5)') ITRANS
      CALL MSGDOC(MDOC,LINE)

      FILE_1 = FILE_11
      CALL CORR_NAME_ALL(FILE_1)
      CALL LENSTR_BL(FILE_1,LEN1)

      FILE_2 = FILE_22
      CALL CORR_NAME_ALL(FILE_2)
      CALL LENSTR_BL(FILE_2,LEN2)

      NO_COORD1=0
      IF(LEN1.GT.4.AND.(FILE_1(LEN1-3:LEN1).EQ.'.seq'.OR.
     *                  FILE_1(LEN1-3:LEN1).EQ.'.sqb'.OR.
     *                  FILE_1(LEN1-3:LEN1).EQ.'.prf'    )) 
     *   NO_COORD1 = 1
 
      NO_COORD2 = 0
      IF(LEN2.GT.4.AND.(FILE_2(LEN2-3:LEN2).EQ.'.seq'.OR.
     *                  FILE_2(LEN2-3:LEN2).EQ.'.prf'.OR.
     *                  FILE_2(LEN2-3:LEN2).EQ.'.sqb'    ))
     *   NO_COORD2 = 1 
c ////////////////
C ---------------------------------------------------------------
      CALL MSGDOC(MDoc,'read file protein-1')

      IPDB1 = 0

      CALL LENSTR_BL(FILE_1,LEN)

      L = LEN
      IF(LEN.GT.72) L = 72
      IF(LEN.LE. 0) L =  1
      LINE = 'File: '//FILE_1(1:L)
      CALL MSGDOC(MDoc,LINE)

      IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_1 = 'align_1_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_1 = PATH_SCR(1:LEN)//'align_1_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_11,FILE_1
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-1')
            GO TO 900
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_1 = FILE_11  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE8_1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(ASEQ1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)
        deallocate(IPROFILE1,STAT=ISTAT)

        NMAX1 = NC
        ITEST = 0

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE8_1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)

        IPDB1 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,NC
     *     ,COORD1(1,1),COORD1(1,2),COORD1(1,3),SS1,SURF1
     *     ,PSS,PH,PB,NMAX1,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-1(pdb)')
            GO TO 800
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.dat') THEN

        IPDB1 = 2
        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_1,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-1')
          GO TO 900
        ENDIF
        READ(IN,ERR=910) NMAX1,NC,CODE8
        IF(NMAX1.LE.0.OR.NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-1 = 0')
          IERR = 1
          GO TO 900
        ENDIF

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        READ(IN,ERR=915) (IRES1(I),I=1,NC)
        READ(IN,ERR=915) (NSEQ1(I),I=1,NC)
        READ(IN,ERR=915) (SS1(I),I=1,NC)
        READ(IN,ERR=915) (SURF1(I),I=1,NC)
        IF(NO_COORD1.EQ.0) 
     *  READ(IN,ERR=915) ((COORD1(J,I),J=1,NC),I=1,3)

        CLOSE(IN)     
        NAM1 = CODE8(1:4)

        CALL CORR_BINARY_SEQ(MDOC,NC,NMAX1,PNUM1
     *       ,NSEQ1,IRES1,SS1,SURF1,ICHAIN1,IDOMAIN1
     *       ,NO_COORD1,COORD1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ1')
          GO TO 800
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.sqb') THEN

        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_1,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-1')
          GO TO 900
        ENDIF
        READ(IN,ERR=910) NMAX1,NC,CODE8_1
        IF(NMAX1.LE.0.OR.NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-1 = 0')
          IERR = 1
          GO TO 900
        ENDIF

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)


        READ(IN,ERR=915) (IRES1(I),I=1,NC)
        READ(IN,ERR=915) (NSEQ1(I),I=1,NC)
        READ(IN,ERR=915) (SS1(I),I=1,NC)
        READ(IN,ERR=915) (SURF1(I),I=1,NC)
        CLOSE(IN)     
        NAM1 = CODE8_1(1:4)

        CALL CORR_BINARY_SEQ(MDOC,NC,NMAX1,PNUM1
     *       ,NSEQ1,IRES1,SS1,SURF1,ICHAIN1,IDOMAIN1
     *       ,NO_COORD1,COORD1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ1')
          GO TO 800
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.prf') THEN
        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_1,NMAX1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF

        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)
        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        CALL READ_SEQ_PROFILE(MDOC,CODE8_1,FILE_1
     *       ,NSEQ_PROFILE1,NC,NMAX1,IPROFILE1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_SEQ_PROFILE-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in PROFILE-1 = 0.')
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)
c        D3_FLAG = 'N'
C        SS_FLAG = 'Y'   
        DIST    = 'N' 
        IPDB1   =-1
      ELSE

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,CODE8_1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1 test')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0.')
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(ASEQ1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)
        deallocate(IPROFILE1,STAT=ISTAT)

        NMAX1 = NC

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,CODE8_1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1')
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)

      ENDIF
      
      CALL MSGDOC(MDoc,'read file protein-2')

      IPDB2 = 0

      CALL LENSTR_BL(FILE_2,LEN)

      L = LEN
      IF(LEN.GT.72) L = 72
      IF(LEN.LE. 0) L =  1
      LINE = 'File: '//FILE_2(1:L)
      CALL MSGDOC(MDoc,LINE)

      IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_2 = 'align_2_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_2 = PATH_SCR(1:LEN)//'align_2_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_22,FILE_2
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-2')
            GO TO 800
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_2 = FILE_22  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,CODE8_2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(ASEQ2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)
        deallocate(IPROFILE2,STAT=ISTAT)

        NMAX2 = KC
        ITEST = 0

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,CODE8_2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4) 

        IPDB2 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,KC
     *     ,COORD2(1,1),COORD2(1,2),COORD2(1,3),SS2,SURF2
     *     ,PSS,PH,PB,NMAX2,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-2(pdb)')
            GO TO 700
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.dat') THEN

        IPDB2 = 2
        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-2')
          GO TO 800
        ENDIF

        READ(IN,ERR=920) NMAX2,KC,CODE8_2
        IF(NMAX2.LE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-2 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        READ(IN,ERR=925) (IRES2(I),I=1,KC)
        READ(IN,ERR=925) (NSEQ2(I),I=1,KC)
        READ(IN,ERR=925) (SS2(I),I=1,KC)
        READ(IN,ERR=925) (SURF2(I),I=1,KC)
        IF(NO_COORD2.EQ.0) 
     *  READ(IN,ERR=925) ((COORD2(J,I),J=1,KC),I=1,3)

        CLOSE(IN)     

        NAM2 = CODE8_2(1:4)

        CALL CORR_BINARY_SEQ(MDOC,KC,NMAX2,PNUM2
     *       ,NSEQ2,IRES2,SS2,SURF2,ICHAIN2,IDOMAIN2
     *       ,NO_COORD2,COORD2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ2')
          GO TO 700
        ENDIF

 
      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.sqb') THEN

        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-2 (.sqb)')
          GO TO 800
        ENDIF

        READ(IN,ERR=920) NMAX2,KC,CODE8_2
        IF(NMAX2.LE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-2 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        READ(IN,ERR=925) (IRES2(I),I=1,KC)
        READ(IN,ERR=925) (NSEQ2(I),I=1,KC)
        READ(IN,ERR=925) (SS2(I),I=1,KC)
        READ(IN,ERR=925) (SURF2(I),I=1,KC)

        CLOSE(IN)     
        
        NAM2 = CODE8_2(1:4)
        CALL CORR_BINARY_SEQ(MDOC,KC,NMAX2,PNUM2
     *       ,NSEQ2,IRES2,SS2,SURF2,ICHAIN2,IDOMAIN2
     *       ,NO_COORD2,COORD2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ2')
          GO TO 700
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.prf') THEN
        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_2,NMAX2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 800
        ENDIF

        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)
        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        CALL READ_SEQ_PROFILE(MDOC,CODE8_2,FILE_2
     *       ,NSEQ_PROFILE2,KC,NMAX2,IPROFILE2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_SEQ_PROFILE-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in PROFILE-2 = 0.')
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4)
c        D3_FLAG = 'N'
C        SS_FLAG = 'Y'   
        CORR    = 'P'
        IPDB2   =-1
c        IF(IPDB1.GE.0) THEN
c          CALL MSGERR(MDOC,'ERROR: 1st file must be PROFILE')
c          IERR = 1
c          GO TO 700
c        ENDIF
      ELSE

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,CODE8_2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2_test')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0.')
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(ASEQ2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)
        deallocate(IPROFILE2,STAT=ISTAT)

        NMAX2 = KC

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,CODE8_2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2')
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4)

      ENDIF
C ---
      CALL ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     * ,OPENR,DPEN0,PENEXR
     * ,ATOM_INDEX,ATOM_NAME     
     * ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     * ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
  
      NMAX12 = NMAX1
      IF(NMAX2.GT.NMAX1) NMAX12 = NMAX2

      allocate(AMATRIX(1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(SCORE(1:NMAX12,1:3),STAT=ISTAT)
      allocate(IPAIR(1:2,1:NMAX12),STAT=ISTAT)
      allocate(IPAIR_STOR(1:2,1:NMAX12),STAT=ISTAT)

      DPEN0P =-1
      IF(IPDB1.GE.0.AND.IPDB2.GE.0) THEN
        CALL SET_AMATRIX4(MDOC,DIST,AMATRIX,AMAT
     *   ,NC,NSEQ1,ASEQ1,COORD1,SURF1,KC,NSEQ2,ASEQ2,COORD2,SURF2
     *   ,SS_FLAG,SS1,SS2
     *   ,NMAX1,NMAX2,IERR)
      ELSE
        CALL SET_AMATRIX_PROFILE(MDOC,AMATRIX,AMAT,DPEN0P
     *    ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *    ,NC,IPROFILE1,NSEQ1,ASEQ1,KC,NSEQ2,ASEQ2,IPROFILE2
     *    ,NMAX1,NMAX2,IERR)
        CALL SET_SURF_PROFILE(MDOC,AMATRIX,AMAT
     *    ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *    ,NC,IPROFILE1,SURF1,KC,IPROFILE2,SURF2
     *    ,NMAX1,NMAX2,IERR)
      ENDIF

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SET_AMATRIX')
        GO TO 600
      ENDIF

      IF(DPENR.LE.0.0) DPENR = DPEN0

C -----
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
        IF(ADOM.NE.'D') SS_FLAG = 'N'
        D3_FLAG = 'N'
      ENDIF

      CALL ALIGNMENT4(MDOC
     *  ,AMATRIX,AMAT,D3_FLAG,SS_FLAG,ADOM
     *  ,OPENR,DPENR,PENEXR,DPEN0P
     *  ,NC,KC
     *  ,ISS1,ISS2,SURF1,SURF2,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *  ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *  ,NPAIR,IPAIR,SCORE(1,1),SCORE(1,2),Q
     *  ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *  ,IPROFILE1,IPROFILE2
     *  ,IDOMAIN1,IDOMAIN2
     *  ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in ALIGNMENT4')
        GO TO 600
      ENDIF
      IF(IPRROW.GE.42) THEN
        RESULT(42) = Q
      ENDIF

      IF(IPRINT.GT.0) THEN 
        CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *  ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *  ,ICHAIN1,ICHAIN2,D3_FLAG
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
      ENDIF
      IF(NPAIR.LE.3) THEN
        CALL MSGERR(MDOC,'ERROR: NPAIR < 4')
        IERR = 1
        GO TO 600
      ENDIF

      IFLAG_COOR = 0
   
      IF(IPDB1.GT.0.AND.IPDB2.GT.0) THEN

        IDOUBLE = 0
        IF(DIST.EQ.'W') THEN

          NPAIR_STOR = NPAIR
          DO IP=1,NPAIR
            IPAIR_STOR(1,IP)= IPAIR(1,IP)
            IPAIR_STOR(2,IP)= IPAIR(2,IP)
          ENDDO

          Q_LIM = 0.01

          WRITE(LINE,
     *    '(''Q :'',F8.3,'' (limit:'',F8.3,'')'')') Q,Q_LIM
          CALL MSGDOC(MDOC,LINE)

          IF(Q.LT.Q_LIM) THEN
            Q_FIN     = 0.0
            DRMS_BEST =-0.1
            NPAIR_BEST= 0
            RESULT(15) = Q_FIN
            RESULT(16) = DRMS_BEST 
            RESULT(17) = NPAIR_BEST 

            GO TO 610

          ELSE

            DO I=1,NC
              SCORE(I,3) = SCORE(I,1)
            ENDDO
            CALL CHECK_FIT_D(MDOC,COORD1,COORD2
     *       ,NSEQ1,NSEQ2,SURF1,SURF2,IRES1,IRES2,NC,KC,SCORE(1,3)
     *       ,NPAIR,IPAIR,NMAX1,NMAX2,NMAX12,AMAT,IPRINT
     *       ,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC,'ERROR: in CHECK_FIT_D')
              GO TO 600
            ENDIF

          ENDIF

          DIST = 'D'
C --
          IDOUBLE = 1
          CALL TRANSFORM_COORD(MDOC,TRMAT,TR
     *   ,KC,COORD2,SURF2,NMAX2,RESULT,IPRROW,IERR)

C --

c         PENEXR = 0.01

          CALL ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     *      ,OPENR,DPEN0,PENEXR
     *      ,ATOM_INDEX,ATOM_NAME     
     *      ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     *      ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
  
          CALL SET_AMATRIX4(MDOC,DIST,AMATRIX,AMAT
     *     ,NC,NSEQ1,ASEQ1,COORD1,SURF1,KC,NSEQ2,ASEQ2,COORD2,SURF2
     *     ,SS_FLAG,SS1,SS2
     *     ,NMAX1,NMAX2,IERR)

          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SET_AMATRIX')
            GO TO 600
          ENDIF

          IF(ADOM.NE.'D') SS_FLAG = 'N'
          D3_FLAG = 'N'

          CALL ALIGNMENT4(MDOC
     *      ,AMATRIX,AMAT,D3_FLAG,SS_FLAG,ADOM
     *      ,OPENR,DPENR,PENEXR,DPEN0P
     *      ,NC,KC
     *      ,ISS1,ISS2,SURF1,SURF2,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *      ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *      ,NPAIR,IPAIR,SCORE(1,1),SCORE(1,2),Q
     *      ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *      ,IPROFILE1,IPROFILE2
     *      ,IDOMAIN1,IDOMAIN2
     *      ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in ALIGNMENT4')
            GO TO 600
          ENDIF
          IF(IPRROW.GE.42) THEN
            RESULT(42) = Q
          ENDIF

          IF(IPRINT.GT.0) THEN 
            CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *      ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *      ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *      ,ICHAIN1,ICHAIN2,D3_FLAG
     *      ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
          ENDIF
          IF(NPAIR.LE.3) THEN
            CALL MSGERR(MDOC,'ERROR: NPAIR < 4')
            IERR = 1
            GO TO 600
          ENDIF

        ENDIF

        IFLAG_COOR = 1

        NPAIR_STOR = NPAIR
        DO IP=1,NPAIR
          IPAIR_STOR(1,IP)= IPAIR(1,IP)
          IPAIR_STOR(2,IP)= IPAIR(2,IP)
        ENDDO

C        NN        = RESULT(3)
C        NGAP      = RESULT(20)
C        SCORE_NEW = RESULT(18)
C        TT = (REAL(NN-NGAP)/REAL(NN))
C        Q = SCORE_NEW*TT*TT*TT*TT

        Q_LIM = 0.01
        IF(DIST.EQ.'D'.OR.DIST.EQ.'P') Q_LIM = 0.0

        WRITE(LINE,
     *  '(''Q :'',F8.3,'' (limit:'',F8.3,'')'')') Q,Q_LIM
        CALL MSGDOC(MDOC,LINE)

        IF(Q.LT.Q_LIM) THEN
          Q_FIN     = 0.0
          DRMS_BEST =-0.1
          NPAIR_BEST= 0
          RESULT(15) = Q_FIN
          RESULT(16) = DRMS_BEST 
          RESULT(17) = NPAIR_BEST 
        ELSE

          DO I=1,NC
            SCORE(I,3) = SCORE(I,1)
          ENDDO
          CALL CHECK_FIT_D(MDOC,COORD1,COORD2
     *     ,NSEQ1,NSEQ2,SURF1,SURF2,IRES1,IRES2,NC,KC,SCORE(1,3)
     *     ,NPAIR,IPAIR,NMAX1,NMAX2,NMAX12,AMAT,IPRINT
     *     ,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in CHECK_FIT_D')
            GO TO 600
          ENDIF
 
          IF(IPRINT.GT.1) THEN 
C           SS: 1 - H, 2 -h, 3 - B, 4 - b
            CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *      ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *      ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *      ,ICHAIN1,ICHAIN2,D3_FLAG
     *      ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT2)
          ENDIF

          IF(IDOUBLE.GT.0) THEN
            CALL DOUBLE_TRANSFORM(MDOC,TRMAT,TR
     *       ,RESULT,IPRROW,IERR)
          ENDIF

        ENDIF

  610   CONTINUE

        NPAIR = NPAIR_STOR
        DO IP=1,NPAIR
          IPAIR(1,IP)= IPAIR_STOR(1,IP)
          IPAIR(2,IP)= IPAIR_STOR(2,IP)
        ENDDO

      ENDIF

      CALL LENSTR_BL(FILE_PAIR,LEN)
      IF(LEN.GT.0) THEN
        ITRANS_P = 1

        CALL WRITE_PAIR_LIST(MDOC,IFLAG_COOR
     *   ,NC,KC,NPAIR,IPAIR,IRES1,IRES2,PNUM1,PNUM2
     *   ,NSEQ1,NSEQ2,COORD1,COORD2,SS1,SS2,NMAX1,NMAX2
     *   ,IDOMAIN1,IDOMAIN2
     *   ,FILE_PAIR,ITRANS_P,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in WRITE_PAIR_LIST')
          GO TO 600
        ENDIF
      ENDIF

      CALL LENSTR_BL(FILE_OUT,LEN)
      IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.LT.0.AND.
     *                                    CORR.NE.'P') THEN
        CALL MSGERR(MDOC,'INFO: output only PAIR fie')
        GO TO 600
      ENDIF

      IF(CORR.EQ.'N') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)
        IF(LEN.GT.4.AND.IPDB2.EQ.1) THEN

C       corr N :  OUT - aligned PDB file_2 (not rotated)

          ITRANS_2 = 0

          CALL ALIGN_3_WRITE_PDB2_ALIGN(MDOC,FILE_2,FILE_OUT
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            RESULT(7)  = NAT
            RESULT(8)  = NRES
            RESULT(9)  = NAT_OCC
            RESULT(10) = NRES_OCC
          ENDIF
        ENDIF

      ELSE IF(CORR.EQ.'2') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.EQ.1.AND.IPDB2.EQ.1) THEN

C       corr 2 : (OUT name+_1,+_2) -> OUT_1, aligned
c                                     OUT_2, aligned (rotated or not)

          FILE_OUT1 = FILE_OUT(1:LEN-4)//'_1.pdb'

          ITRANS_1 = 0
          CALL ALIGN_3_WRITE_PDB1_ALIGN(MDOC,FILE_1,FILE_OUT1
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_1,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF

          CALL LENSTR_BL(FILE_OUT,LEN)
          FILE_OUT2 = FILE_OUT(1:LEN-4)//'_2.pdb'
          ITRANS_2 = ITRANS
          CALL ALIGN_3_WRITE_PDB2_ALIGN(MDOC,FILE_2,FILE_OUT2
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            RESULT(7)  = NAT
            RESULT(8)  = NRES
            RESULT(9)  = NAT_OCC
            RESULT(10) = NRES_OCC
          ENDIF

        ENDIF

      ELSE IF(CORR.EQ.'P') THEN

C      CORR = P  (FILE_OUT) profile  

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.GE.0) THEN
          
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_2SEQ_TO_PROFILE(MDOC,FILE_OUT
     *    ,CODE8
     *    ,NC,KC,NSEQ1,NSEQ2,PNUM1,PNUM2
     *    ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF

        ELSE IF(LEN.GT.4.AND.IPDB1.LT.0.AND.IPDB2.GE.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_PROF_SEQ_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE1,IPROFILE1,KC
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ELSE IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.LT.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_SEQ_PROF_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE2,IPROFILE2,KC
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ELSE IF(LEN.GT.4.AND.IPDB1.LT.0.AND.IPDB2.LT.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_2PROF_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE1,IPROFILE1,KC,NSEQ_PROFILE2,IPROFILE2
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ENDIF

      ELSE
        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.GT.0.AND.IPDB2.EQ.1) THEN

C         (OUT) rotated FULL/noFULL file_2 (without alignment)
          
          ITRANS_2 = 1
          IF(IPDB1.LT.0) ITRANS_2 = 0

          CALL ALIGN_3_WRITE_PDB2_FULL(MDOC,FILE_2,FILE_OUT
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,FULL
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
        ENDIF
        IF(IERR.EQ.0) THEN
          RESULT(7)  = NAT
          RESULT(8)  = NRES
          RESULT(9)  = NAT_OCC
          RESULT(10) = NRES_OCC
        ENDIF
      ENDIF

 600  CONTINUE

      deallocate(AMATRIX,STAT=ISTAT)
      deallocate(SCORE,STAT=ISTAT)
      deallocate(IPAIR,STAT=ISTAT)
      deallocate(IPAIR_STOR,STAT=ISTAT)

 700  CONTINUE

      deallocate(IPROFILE2,STAT=ISTAT)
      deallocate(COORD2,STAT=ISTAT)
      deallocate(ASEQ2,STAT=ISTAT)
      deallocate(NSEQ2,STAT=ISTAT)
      deallocate(IRES2,STAT=ISTAT)
      deallocate(SURF2,STAT=ISTAT)
      deallocate(ICHAIN2,STAT=ISTAT)
      deallocate(IDOMAIN2,STAT=ISTAT)
      deallocate(SS2,STAT=ISTAT)
      deallocate(ISS2,STAT=ISTAT)
      deallocate(PNUM2,STAT=ISTAT)

 800  CONTINUE

      deallocate(IPROFILE1,STAT=ISTAT)
      deallocate(COORD1,STAT=ISTAT)
      deallocate(ASEQ1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

 900  CONTINUE

      FILE_SCR = 'align_1_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'align_2_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)

      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      RETURN
 915  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      GO TO 800
 920  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin2)')
      IERR = 1
      GO TO 800
 925  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      GO TO 700
      END

