C --- alt_sg_list.f ---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80,EXT*3,PATH*1
      CHARACTER SPACE_GROUP*80
      CHARACTER MESSAGE*80,JOB*80
C ----
      PARAMETER (NSG_MAX  = 100)
      CHARACTER SG_LIST(NSG_MAX)*80
      INTEGER   NSG
C =============================================================
c_PATH_OUT /data/alexei/work/molrep_DB/temp/
      PATH_OUT = ' '
      MDOC    = 1
      PROG = 'alt_sg_list'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------------
      IERR = 0
      MD   = 0
      M    = 99
      JOB  = 'alt_sg_list'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(M,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        GO TO 900
      ENDIF
      CLOSE(IOUT)
C -------------------------------------------------------------
      SPACE_GROUP = ' '
      NSG = 0
C ----
      CALL SET_DEFAULT(
     *'SG:          < >  - space group name')
      CALL SET_DEFAULT(
     *'PATH_SCR:    < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(M,' ')
C -----------------------
      LINE='SG'
      CALL ASK(LINE)
      SPACE_GROUP=LINE
      CALL CORR_NAME_BLC(SPACE_GROUP)
c ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C ----
C
c result: PATH_OUT/alt_sg_list.xml

      CALL CLOSE_BATCH(MDOC)
      CALL ALT_SG_LIST(MDOC,SPACE_GROUP
     * ,NSG,SG_LIST,NSG_MAX 
     * ,MESSAGE,PATH_OUT,PATH_SCR,IERR)
C -----------------------
      CALL WRITE_ALT_SG_LIST_XML(MDOC,IERR
     *     ,NSG,SG_LIST,NSG_MAX
     *     ,MESSAGE,JOB,PATH_OUT,JERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE WRITE_ALT_SG_LIST_XML(MDOC,IERR_INPUT
     *     ,NSG,SG_LIST,NSG_MAX
     *     ,MESSAGE,JOB,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR,IERR_INPUT,NSG,NSG_MAX
      CHARACTER MESSAGE*(*),JOB*(*)
      CHARACTER LINE*256,FILE_2*256
      CHARACTER SG_LIST(NSG_MAX)*80
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
 
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'n_sg <n_sg> ',NSG,' </n_sg>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        IF(NSG.GT.0) THEN

          DO I=1,NSG

            CALL LENSTR_BL(SG_LIST(I),L)

            LINE = 'SG_name <SG_name>'//SG_LIST(I)(1:L)//
     *             '</SG_name>'

            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

          ENDDO

        ENDIF

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE ALT_SG_LIST(MDOC,SPACE_GROUP
     * ,NSG,SG_LIST,NSG_MAX 
     * ,MESSAGE,PATH_OUT,PATH_SCR,IERR)
C --------------------------------------------------------------------
C ----
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),MESSAGE*(*)
      CHARACTER SPACE_GROUP*(*),SG_LIST(NSG_MAX)*80
      INTEGER   MDOC,NSG,NSG_MAX,IERR
C ----
      PARAMETER (IPRSYM = 196 )
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER LINE*256,SGNAME*24
C =============================================================
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      MESSAGE = 'normal termination'
C -------------------------
C ---
      CALL LENSTR_BL(SPACE_GROUP,LENS)
      IF(LENS.LT.1.OR.LENS.GT.24) THEN
        GO TO 900
      ENDIF

      NOSPGR = 0
      ISETT  = 1
      NSYM   = 0
      SGNAME = SPACE_GROUP(1:LENS)
      
      CALL GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
      CALL SEARCH_ALT_SYMM_GROUP(MDOC,NSYM,ISYM,IPRSYM
     *  ,SGNAME,NSG,NSG_MAX,SG_LIST,NSG_LIST_1,IERR)
      IF(IERR.NE.0) GO TO 800
      IF(NSG_LIST_1.LE.0) GO TO 700
      IF(NSG.LE.0) GO TO 700
C ---
      RETURN
 900  CONTINUE
      LINE = 'ERROR: wrong input SG name'
      CALL MSGERR(MDOC,LINE)
      MESSAGE = 'ERROR: wrong input SG name'
      IERR = 4
      RETURN
 800  CONTINUE
      LINE = 'ERROR: in symm lib'
      CALL MSGERR(MDOC,LINE)
      MESSAGE = 'ERROR: in symm lib'
      IERR = 5
      RETURN
 700  CONTINUE
      LINE = 'ERROR: in symm lib for initial SG'
      CALL MSGERR(MDOC,LINE)
      MESSAGE = 'ERROR: in symm lib for initial SG'
      IERR = 6
      RETURN
      END

      SUBROUTINE SEARCH_ALT_SYMM_GROUP(MDOC,NSYMR,ISYMR,IPRSYMR
     *  ,SGNAMER,NSG_LIST,NSG_MAX,SG_LIST,NSG_LIST_1,IERR)
C -------------------------------------------------------
      INTEGER    MDOC,IERR
      INTEGER    NSG_LIST,NSG_MAX
      CHARACTER  SGNAMER*24,SG_LIST(NSG_MAX)*80
C --
      INTEGER*2 ISYMR(5,3,IPRSYMR)
      INTEGER   NSYMR
C -----------------------------------
      CHARACTER LINE*80
C -------------------------------------------------------------
      INTEGER   MAXN
      PARAMETER ( MAXN = 196 )
      INTEGER*2 ISYM(5,3,MAXN)
      INTEGER   NOSPGR,ISETT,LEN,IG,NSG,NSS,IFIRST,NOSG,IST
      INTEGER   IS,NO_TAB,NS_TAB,NMAX,NSYM,NNSYM,NSGNSS
      INTEGER   I,J,K,II
      CHARACTER SG_TAB*24,SG_TAB1*24,SG_TAB2*24,OP*80
C -------------------------------------------------------------
      IERR       = 0
      NMAX       = 259
      NSG_LIST   = 1
      NSG_LIST_1 = 0

      DO IG=1,NMAX
        IS = 0
        CALL GET_SPACE_GROUP_INFO(IG,IS,NO_TAB,NS_TAB
     *                          ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
        IF(IERR.GT.0) RETURN
C       space group number
        NSG    = NO_TAB
C       number of symmetry operators
        NSYM   = NS_TAB
        NNSYM  = NSYM
        DO  IS=1,NSYM
          CALL GET_SPACE_GROUP_INFO(IG,IS,NO_TAB,NS_TAB
     *                           ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
          IF(IERR.NE.0) RETURN
          NSS   = IS
          CALL SYMFR2_BL(MDOC,OP,NSS,NNSYM,ISYM,MAXN,IERR)
          IF(IERR.GT.0) RETURN
        ENDDO 

C        CALL NSG_CCP4_TO_STAND(NSG,NOSPGR,ISETT,IERR)


        IF(SGNAMER.EQ.SG_TAB.OR.SGNAMER.EQ.SG_TAB1.OR.
     *                          SGNAMER.EQ.SG_TAB2    ) THEN
          NSG_LIST_1  = 1
          SG_LIST(1) = SG_TAB

          IF(NSG.GT.999) THEN
            IF(NSG.NE.1003.AND.NSG.NE.1004.AND.NSG.NE.1005.AND.
     *         NSG.NE.1017.AND.NSG.NE.2017.AND.NSG.NE.2018.AND.
     *         NSG.NE.3018                                 ) THEN
               NSG_LIST = 1
              GO TO 400
            ENDIF
          ENDIF

          GO TO 300
        ENDIF

        IF(NSG.GT.999) THEN
          IF(NSG.NE.1003.AND.NSG.NE.1004.AND.NSG.NE.1005.AND.
     *       NSG.NE.1017.AND.NSG.NE.2017.AND.NSG.NE.2018.AND.
     *       NSG.NE.3018                                 ) GO TO 300
        ENDIF

c        IF(NOSPGR.EQ.5.AND.ISETT.GT.2) GO TO 300
C        IF(NOSPGR.EQ.18.AND.ISETT.EQ.2) GO TO 300

        IF(NSYM.EQ.NSYMR) THEN        

          DO I=1,NSYMR
            DO II=1,NSYM
              DO J=1,3
              DO K=1,3
                IF(ISYMR(J,K,I).NE.ISYM(J,K,II)) GO TO 100            
              ENDDO            
              ENDDO
              GO TO 200
 100          CONTINUE
            ENDDO
            GO TO 300            
 200        CONTINUE
          ENDDO

          DO I=1,NSYM
            DO II=1,NSYMR
              DO J=1,3
              DO K=1,3
                IF(ISYM(J,K,I).NE.ISYMR(J,K,II)) GO TO 110            
              ENDDO            
              ENDDO
              GO TO 210
 110          CONTINUE
            ENDDO
            GO TO 300            
 210        CONTINUE
          ENDDO

          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.LE.0) LEN = 1
          IF(LEN.GT.4.AND.SG_TAB(LEN-2:LEN).EQ.'(a)') GO TO 300

C          CALL NSG_CCP4_TO_STAND(NSG,NOSPGR,ISETT,IERR)

          NSG_LIST = NSG_LIST + 1
          SG_LIST(NSG_LIST) = SG_TAB

        ENDIF

300     CONTINUE
      ENDDO
400   CONTINUE

      IF(NSG_LIST.GT.1) THEN
        N = NSG_LIST
        NSG_LIST = 1
        DO I=2,N
          IF(SG_LIST(I)(1:1).EQ.SG_LIST(1)(1:1)) THEN
            NSG_LIST = NSG_LIST + 1
            SG_LIST(NSG_LIST) = SG_LIST(I) 
          ENDIF
        ENDDO
      ENDIF

      DO I=1,NSG_LIST
        SG_TAB = SG_LIST(I)
        CALL LENSTR_BL(SG_TAB,LEN)
        IF(LEN.LE.0) LEN = 1
        WRITE(LINE,'(I5,4X,''"'',A,''"'')') 
     *    I,SG_TAB(1:LEN)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ----
      RETURN
      END
