C --- BLANC2MTZ.F ---
C BLANC2MTZ writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C          to new MTZ file. The exit from program suite BLANC.
C -------------
      INCLUDE 'nsym-max.fh'
C     PARAMETER ( IPRSYM = 48 )
      INTEGER*2 ISYM(5,3,IPRSYM)
C -------------
      PARAMETER ( IPRROW = 21 )
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*80,F2_NAME*80,PH_NAME*80,FO_NAME*80
      CHARACTER LINE*80,ITYP*4,CFOM*1,CFREE*1,CSIG*1,ANOM*1
      CHARACTER PATH_OUT*256
C ===========================
C     START - initialization common/COMLIB/,/CRYSTL/,.., open DOC-file.
C
      MDOC = 0
      CALL START(0,MDOC,'blanc2mtz.f',PATH_OUT)
C ---------------------------
C     MSGDOC - writes message to terminal or/and DOC_FILE
C
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '    ---- BLANC to MTZ ----    /V.10.10.99/ ')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
  100 CONTINUE
      MD = 0
      CALL MSGDOC(MD,'Input file Fobs')
      LINE='FILE_F'
      CALL ASK(LINE)
      F_NAME=LINE
      CALL CORR_NAME_BL(F_NAME)
C --
      MT1  = 10
      ITYP = 'FF  '
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
C
C       MSGERR - writes message about error to terminal or/and DOC_FILE
C
        CALL MSGERR(MD,' ERROR: can not open file Fobs')
        GO TO 100
      ENDIF
      CLOSE(MT1)
C -----------------------------------------------------------------
C     list of possible keywords
C
      MD     = 0
      RESMIN = 0.0
      RESMAX = 0.0

      CALL MSGDOC(MDOC,' ')
      CALL SET_DEFAULT(
     *'FILE_C:  < >   - input_file_Fcalc /" " means without file_C/')
      CALL SET_DEFAULT(
     *'FILE_PH: < >   - input_file_phases /" " means without file_PH/')
      CALL SET_DEFAULT(
     *'RESOL: MIN,MAX - resolution <default from files>')
      CALL SET_DEFAULT(
     *'FOM:   <Y>,N   - Y means to write FOM')
      CALL SET_DEFAULT(
     *'FREE:  <N>,Y,I - Y means to write FREE-flag, I new 5%')
      CALL SET_DEFAULT(
     *'SIG:   <Y>,N   - Y means to write sigmas of F')
       CALL SET_DEFAULT(
     *'ANOM:   <N>,Y  - Y means to write Fobs(hkl) and Fobs(-h-k-l)')
      CALL SET_DEFAULT(
     *'FILE_O: <blanc2mtz.mtz> - output_file')
C ---
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------
C
C     read keywords
C 
      LINE='FILE_C'
      CALL ASK(LINE)
      F2_NAME=LINE
      CALL CORR_NAME_BL(F2_NAME)
C ----
      LINE='FILE_O'
      CALL ASK(LINE)
      FO_NAME=LINE
      IF(LINE(1:1).EQ.',') FO_NAME = 'blanc2mtz.mtz'
      CALL CORR_NAME_BL(FO_NAME)
C ----
      LINE='FILE_PH'
      CALL ASK(LINE)
      PH_NAME=LINE
      CALL CORR_NAME_BL(PH_NAME)
C ----
      LINE='RESOL'
      CALL ASK(LINE)
      READ(LINE,*)    RESMIN,RESMAX
C ----
      LINE ='FOM'
      CALL ASK(LINE)
      CFOM = LINE(1:1)
C ----
      LINE ='SIG'
      CALL ASK(LINE)
      CSIG = LINE(1:1)
C ----
      LINE ='ANOM'
      CALL ASK(LINE)
      ANOM = LINE(1:1)
C ----
      LINE ='FREE'
      CALL ASK(LINE)
      CFREE = LINE(1:1)
C ---------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL BLANC2MTZ(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *    ,CFOM,CFREE,CSIG,ANOM
     *    ,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------
C     FINISH - close DOC-file and EXIT.
C
      CALL FINISH
      END

      SUBROUTINE BLANC2MTZ(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *        ,CFOM,CFREE,CSIG,ANOM
     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ----------------------------------------------------
C -P- 
C BLANC2MTZ writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C           to new MTZ file. The exit from program suite BLANC.
C -S-
C          This program reads contents of files: 
C                 Fobs              or  
C                 Fobs and Fcalc    or
C                 Fobs and Phases   or  
C                 Fobs and Fcalc and Phases
C
C   Dialogue and Batch:
C  
C     FILE_F:  - input file_Fobs  of the modules of structure factors.
C     FILE_C:  - input file_Fcalc of the modules of structure factors.
C     FILE_PH: - input file_Phases.
C     RESOL: MIN,MAX - resolution <default from files>
C     FOM:   <Y>,N   - Y means to write FOM'
C     FREE:  <N>,Y,I - Y means to write FREE-flag, I new 5%'
C     SIG:   <Y>,N   - Y means to write sigmas of F'
C     FILE_O: <blanc2mtz.mtz> - output_file 
C
C  Parameters of subroutine BLANC2MTZ: 
C
C      SUBROUTINE BLANC2MTZ(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
C     *        ,CFOM,CFREE,CSIG
C     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    F_NAME:  - input file_Fobs  of the modules of structure factors.
C    F2_NAME: - input file_Fcalc of the modules of structure factors.
C    PH_NAME: - input file_Phases.
C    RESMINR: - resolution <default from files>
C    RESMAXR:  
C    CFOM:  /character*1/ <Y>,N   - Y means to write FOM'
C    CFREE: /character*1/ <N>,Y   - Y means to write FREE-flag'
C    CSIG:  /character*1/ <Y>,N   - Y means to write sigmas of F'
C    FO_NAME: <blanc2mtz.mtz> - output_file 
C    ISYM     - integer*2 array for cryst.symmetry operators.
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM),
C               number of cryst. symm. operators.
C    IERR     - output signal of error / = 1 -error , = 0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C    RESULT(1) - 
C    RESULT(2) - 
C -I-
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),PH_NAME*(*),FO_NAME*(*),CFOM*1
      CHARACTER STAT*1,CFREE*1,CSIG*1,ANOM*1
C ==============================
      INTEGER*4 MTIN,MTNAT,MTOUT
      CHARACTER ITYPE*4,ITYP*4,ITF1*4,ITF2*4,ITF3*4,ITFW*4
      CHARACTER LINE*80,TTT*80,TTT1*80,TITLE*80,PATH*80,EXT*80
      CHARACTER LINE1*80
C --- ccp4  
      integer maxlab, maxtok
C Max number of labels
      parameter (maxlab = 80)
C Max number of tokens for 'parser'
      parameter (maxtok = 2*maxlab+1)
      real adata(maxtok-1)      
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
      PI   = 4.0*ATAN(1.0)
C
C     ITYP  ='FF  '  means 'F   ' or 'FS  '
C     ITYP  ='F   '
C     ITYP  ='FS  '
C     ITYP  ='    '  means ALL  
C     ITYP  ='ABCD'
C     ITYP  ='COEF'
C     ITYP  ='PH  '
C     ITYP  ='RI  '
C
C     Subroutine ORFILE returns actual type by ITYP
C

      MT1 = 20
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      ITYP = 'FF  '
C
C     ORFILE - 1.open file FNAME 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN FILE-F-1')
        RETURN
      ENDIF
C
C     GET_TITLE - gets information from /COMRDF/
C
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ITF1 = ITYP
C
C     for 'COEF':   TITLE(1:4)='FOUR' or 'PATT'
C
C -------------------------------------------------------------
C
C     C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C               also using CELL parameters from common/CRYSTL/ calculates
C               reciprocal cell parameters and volume and put its 
C               to common/CRYSTL/
C               
      CALL C_RD_CR
C -------------------------------------------------------------
      MT2   = 21
      ITYPE = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        MT2=0
      ELSE
        CALL ORFILE(MD,MT2,F2_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A1,B1,C1,AL1,BE1,GA1
     *  ,DM1,DM2,RN1,RX1,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        ITF2=ITYPE
      ENDIF
C ------------------
      MT3   = 22
      ITYPE = 'PH  '
      CALL LENSTR_BL(PH_NAME,LEN)
      IF(LEN.LE.0.OR.PH_NAME(1:1).EQ.' '.OR.PH_NAME(1:1).EQ.',') THEN
        MT3=0
      ELSE
        CALL ORFILE(MD,MT3,PH_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MT1)
          IF(MT2.GT.0) CLOSE(MT2)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,DM1,DM2,RN2,RX2,IDM,IDM,IDM,IDM,IDM,TTT1,IERR)
        ITF3=ITYPE
      ENDIF
C -----------------
      IF(CFOM .EQ.'n') CFOM  = 'N'
      IF(CFOM .NE.'N') CFOM  = 'Y'
      IF(CFREE.EQ.'y') CFREE = 'Y'
      IF(CFREE.EQ.'i') CFREE = 'I'
      IF(CFREE.NE.'Y'.AND.CFREE.NE.'I') CFREE = 'N'
      IF(CSIG .EQ.'n') CSIG  = 'N'
      IF(CSIG .NE.'N') CSIG  = 'Y'
      IF(ANOM .EQ.'y') ANOM  = 'Y'
      IF(ANOM .NE.'Y') ANOM  = 'N'
C ---
      RESMIN = RESMINR
      RESMAX = RESMAXR
      IF(RESMIN.LE.0.0)   RESMIN = RN
      IF(RESMAX.LE.0.0)   RESMAX = RX
      IF(RN .LT.RESMIN)   RESMIN = RN
      IF(RX .GT.RESMAX)   RESMAX = RX
      IF(MT2.GT.0) THEN
        IF(RN1.LT.RESMIN)   RESMIN = RN1
        IF(RX1.GT.RESMAX)   RESMAX = RX1
      ENDIF
      IF(MT3.GT.0) THEN
        IF(RN2.LT.RESMIN)   RESMIN = RN2
        IF(RX2.GT.RESMAX)   RESMAX = RX2
      ENDIF
      WRITE(LINE,'(''RESOLUTION MIN,MAX '',2F7.2)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RHMIN = 1.0/(RESMIN)
      RHMAX = 1.0/(RESMAX)
C ---------------
      MTOUT = 0
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',') THEN
      ELSE
        FO_NAME = 'blanc2mtz.mtz'
      ENDIF

C --- ccp4
      call ccpfyp
      call mtzini
C     CALL CCPRCS(-1,'blanc2mtz','$Date: 1999/10/10 13:09:42 $')
C Open mtz file 
      call lwopen(1,FO_NAME)       

      CALL WR_TITLE_MTZ(M,MTOUT,ITYP,TITLE
     *   ,MT2,MT3,CSIG,CFOM,CFREE,ANOM
     *   ,NSYM,ISYM,IPRSYM,IERR)

C --- ccp4

c       MTOUT=30
c
C ---
C       C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C
C        CALL C_CR_WR
C ---
C       SET_TITLE - sets information to  /COMWRF/
C 
C        CALL SET_TITLE(MD,A,B,C,
C     *  AL,BE,GA,COEF1,BET1,RESMIN,RESMAX,
C     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C        ITFW = 'F   '
C
C       OWFILE - 1.open file 
C                2.writes title to file, parameters from common /COMRDF/
C
C        CALL OWFILE(MD,MTOUT,FO_NAME,ITFW,NSYM,ISYM,IPRSYM,IERR)
c
c        PATH  = ' '
c        EXT   = ' '      
c        CALL OPENFW(MTOUT,MD,PATH,FO_NAME,EXT,IERR)
c        IF(IERR.NE.0) THEN
c          CLOSE (MT1)
c          IF(MT2.GT.0) CLOSE (MT2)
c          IF(MT3.GT.0) CLOSE (MT3)
c          CALL MSGERR(MDOC,' ERR: OPEN FILE-OUTPUT')
c          IERR=1
c          RETURN
c        ENDIF
c
c        CALL WR_TITLE_CIF(M,MTOUT,ITYP,TITLE
c     *   ,MT2,MT3,CSIG,CFOM,CFREE
c     *   ,NSYM,ISYM,IPRSYM,IERR)
c
c      ENDIF

C ----------------------------------------------------------
C ---
C 
C     initialization for CENTR_BL and ANOMSC
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL ANOMF(M,NSYM,ISYM)
C
C     calc limits H,k,l and grid for RESMAX
C
      CALL LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)

C ---
      SUMA   = 0.0
      SUMB   = 0.0
      SUMFOM = 0.0
      NTOT   = 0
      NFREE  = 0
C ----
      IEND1 =-1
      IEND2 =-1
      IEND3 =-1
      IENDW =-1
      JH    =-200
      JK    =-200
      JL    =-200
      KH    =-200
      KK    =-200
      KL    =-200
      LH    =-200
      LK    =-200
      LL    =-200
C -----------------------------------------
      DO     IL=0,ILMAX
      DO     IK=-IKMAX,IKMAX
      DO     IH=-IHMAX,IHMAX
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
        IHP = IH
        IKP = IK
        ILP = IL
C
C        ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C        output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                 IANOM    - 0   +h,+k,+l
C                            1   -h,-k,-l
C                 JJSYM    - number operator of symmetry :
C                                 in(h,k,l) -- JJSYM --> out(h,k,l)
C
        CALL ANOMSC(IHP,IKP,ILP,IANOM,JJSYM,NSYM,ISYM)
        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        IF(NSYM.GT.1) THEN
C
C         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
C
C ---   ICND NE 0 systematic absent
C
        IF(ICND.NE.0) GO TO 100
C 
C       DSTAR - gives value of (4pi*sin(theta))/lambda for H,K,L
C
        CALL DSTAR_BL(IH,IK,IL,RSQ)
        RH = SQRT(RSQ)
        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100
C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IH,IK,IL,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection
C ---
C ------
  200   CONTINUE
        IMISS1 = 1

C         You can default data to `missing' with free format.
c         adata(i) = nan
C         before call qnan(nan)

        IF(IEND1.GT.0)                    GO TO 110

C        IF(JL-IL) 240,210,300
C  210   IF(JK-IK) 240,220,300
C  220   IF(JH-IH) 240,230,300

        IF((JL-IL).LT.0) THEN
          GO TO 240
        ELSE IF((JL-IL).EQ.0) THEN
          GO TO 210
        ELSE 
          GO TO 100
        ENDIF

 210    IF((JK-IK).LT.0) THEN
          GO TO 240
        ELSE IF((JK-IK).EQ.0) THEN
          GO TO 220
        ELSE 
          GO TO 100
        ENDIF

 220    IF((JH-IH).LT.0) THEN
          GO TO 240
        ELSE IF((JH-IH).EQ.0) THEN
          GO TO 230
        ELSE 
          GO TO 100
        ENDIF

C ------
  240   CONTINUE
C
C        RD1 - read from MT1 ; type of file :"F   ","PH  ","COEF","ALMN"
C        RRD1- read from MT1 ; type of file :"FS  "
C 
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C
C        IF(ITF2.EQ.'COEF') THEN
C          CALL RD1(MT1,JH,JK,JL,FA,FB,KEY1,IEND1)
C        IF(ITF2.EQ.'ABCD') THEN
c          CALL RABCD(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C        IF(ITF2.EQ.'PH  ') THEN
c          CALL RD1(MT1,JH,JK,JL,COSFOM,SINFOM,KEY1,IEND1)
C
C Possible to use:
C          CALL RD(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD2(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD2(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD3(MT1,JH,JK,JL,FN,FNA,NUMB,IEND)
C          CALL RRD3(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD4(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD4(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RABCD1(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C

C         SIG-DUMMY
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IT1 = KEY1/2        
        IFLAG_FREE = KEY1 - IT1*2 
        IT3  = IT1/2
        IT3  = IT3-IT1*2
C       if IFLAG_FREE = 1 - free reflection
C       use program COPYFL to set "free flag".

        STAT = 'o'
        IF(IFLAG_FREE.EQ.1) STAT = 'f'
        IF(IT3       .EQ.1) STAT = 'r'
c ---
        IF(CFREE.EQ.'I') THEN
          STAT  = 'o'
          IPERC = 5
          CALL HSRD(RAND)
          IRAND = (RAND + 0.5)*100.0
          IF(IRAND.LE.IPERC) THEN
            STAT = 'f'
          ENDIF
        ENDIF

c ---
        IF(MT1.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_1')
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND1.GT.0)                   GO TO 110
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100

        IF(ANOM.NE.'Y') THEN
          IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
            WT1 = 1./(SN*SN)
            WT2 = 1./(SNA*SNA)
            WT  = WT1+WT2
            FN  = FN*WT1+FNA*WT2
            FN  = FN/WT
            SN  = 1./SQRT(WT)
          ELSE IF(FNA.GT.1.E-6) THEN
            FN = FNA
            SN = SNA
          ENDIF
        ENDIF

        GO TO 200

  230   IMISS1 = 0
C ------
  300   CONTINUE
        IMISS2=1
        IF(IEND2.LT.0.AND.MT2.LE.0)                   GO TO 400
        IF(IEND2.GT.0.OR.MT2.LE.0)                    GO TO 110

C        IF(KL-IL) 340,310,400
C  310   IF(KK-IK) 340,320,400
C  320   IF(KH-IH) 340,330,400

        IF((KL-IL).LT.0) THEN
          GO TO 340
        ELSE IF((KL-IL).EQ.0) THEN
          GO TO 310
        ELSE 
          GO TO 100
        ENDIF

 310    IF((KK-IK).LT.0) THEN
          GO TO 340
        ELSE IF((KK-IK).EQ.0) THEN
          GO TO 320
        ELSE 
          GO TO 100
        ENDIF

 320    IF((KH-IH).LT.0) THEN
          GO TO 340
        ELSE IF((KH-IH).EQ.0) THEN
          GO TO 330
        ELSE 
          GO TO 100
        ENDIF

C ------
  340   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,KH,KK,KL,FD,FDA,SF,SFA,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,KH,KK,KL,FD,FDA,KEY2,IEND2)
C         SIG-DUMMY
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_2')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)                   GO TO 110
        IF(FD.LE.1.E-6.AND.FDA.LE.1.E-6) GO TO 100
        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD = FDA
          SF = SFA
        ENDIF
        GO TO 300

  330   IMISS2 = 0
C --------------------------------------------
  400   CONTINUE

        IMISS3 = 1
        IF(IEND3.LT.0.AND.MT3.LE.0)                   GO TO 500
        IF(IEND3.GT.0.OR.MT3.LE.0)                    GO TO 110

        IF((LL-IL).LT.0) THEN
          GO TO 440
        ELSE IF((LL-IL).EQ.0) THEN
          GO TO 410
        ELSE 
          GO TO 100
        ENDIF

 410    IF((LK-IK).LT.0) THEN
          GO TO 440
        ELSE IF((LK-IK).EQ.0) THEN
          GO TO 420
        ELSE 
          GO TO 100
        ENDIF

 420    IF((LH-IH).LT.0) THEN
          GO TO 440
        ELSE IF((LH-IH).EQ.0) THEN
          GO TO 430
        ELSE 
          GO TO 100
        ENDIF
C ------
  440   CONTINUE
        CALL RD3(MT3,LH,LK,LL,COSFOM,SINFOM,KEY3,IEND3)
        IF(MT3.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_PH')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND3.GT.0)                   GO TO 110

        TEMP = (COSFOM*COSFOM+SINFOM*SINFOM)
        FOM  = SQRT(TEMP)
C       WRITE(*,*) FOM,TEMP
        IF(FOM.LE.0.00001) GO TO 440
        COPH = COSFOM/FOM
        SIPH = SINFOM/FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI = 90.
          IF(SIPH.LT.0.) PHI = PHI+180.
        ELSE
          PHI = (ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI = PHI + 360.
            ELSE
              PHI = PHI + 180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI = PHI + 180.
          ELSE
            IF(SIPH.LE.0.) PHI = PHI + 180.
          ENDIF
        ENDIF

C       SUMFOM = SUMFOM+FOM

        GO TO 400

  430   IMISS3 = 0
C --------------------------------------------
  500   CONTINUE
C -----------------------------------------------------
C       SUMFOM = SUMFOM+FOM

        NTOT = NTOT+1

C ---
C        IF(MTOUT.GT.0) THEN

           
          IF(CSIG.EQ.'Y') THEN
C            WRITE(LINE1,
C     *      '(3I4,1X,F12.4,1X,F10.4)') 
C     *      IH,IK,IL,FN,SN
            adata(1) = IH
            adata(2) = IK
            adata(3) = IL
            adata(4) = FN
            adata(5) = SN
            IP       = 6
          ELSE
C            WRITE(LINE1,
C     *      '(3I4,1X,F12.4,1)') 
C     *      IH,IK,IL,FN
            adata(1) = IH
            adata(2) = IK
            adata(3) = IL
            adata(4) = FN
            IP       = 5
          ENDIF

          IF(ANOM.EQ.'Y') THEN
            IF(CSIG.EQ.'Y') THEN
              adata(IP  ) = FNA
              adata(IP+1) = SNA
              IP          = IP + 2
            ELSE
              adata(IP) = FNA
              IP        = IP + 1
            ENDIF
          ENDIF
 
C         LINE = LINE1
          IF(MT2.GT.0) THEN
C            IF(CSIG.EQ.'Y') THEN
C              WRITE(LINE,
C     *        '(F12.4,1X,F10.4)') 
C     *        FD,SF
C              adata(IP  ) = FD
C              adata(IP+1) = SF
C              IP        = IP + 2
C            ELSE
C              WRITE(LINE,
C     *        '(F12.4)') 
C     *        FD
              adata(IP) = FD
              IP        = IP + 1
C            ENDIF
C            CALL LENSTR_BL(LINE ,LEN)
C            CALL LENSTR_BL(LINE1,LEN1)
C            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(MT3.GT.0) THEN
            IF(CFOM.EQ.'Y') THEN
C              WRITE(LINE1,
C     *        '(F8.3,1X,F6.3)') 
C     *        PHI,FOM
              adata(IP  ) = PHI
              adata(IP+1) = FOM
              IP          = IP + 2
            ELSE
C              WRITE(LINE1,
C     *        '(F8.3)') 
C     *        PHI
              adata(IP) = PHI
              IP        = IP + 1
            ENDIF
C            CALL LENSTR_BL(LINE ,LEN)
C            CALL LENSTR_BL(LINE1,LEN1)
C            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF

          IF(CFREE.EQ.'Y'.OR.CFREE.EQ.'I') THEN
C           CALL LENSTR_BL(LINE ,LEN)
C           LINE = LINE(1:LEN)//' '//STAT
            IF(STAT.EQ.'o') THEN
C             include
              adata(IP) = 1.0
              IP        = IP + 1
            ELSE
C             exclude
              adata(IP) = 0.0
              IP        = IP + 1
              NFREE  = NFREE + 1
            ENDIF
          ENDIF

C          CALL WRTSTR(MTOUT,M,LINE,IERR)
C        ENDIF

         call lwrefl (1, adata)

C ----
 100  CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---------------------------------------
  110 CONTINUE

      CLOSE (MT1)
      IF(MT2.GT.0) CLOSE (MT2)
      IF(MT3.GT.0) CLOSE (MT3)

c      IF(MTOUT.GT.0) THEN

      IF(NTOT.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
c       CLOSE(MTOUT)
        close(unit=1,status='keep')
        IERR=1
        RETURN
      ENDIF
C ---
 50   call lwclos (1, 3)
      close(unit=1,status='keep')

c      write (*,'(i7, '' input reflections processed'')') NTOT
c      call ccperr(0,'Normal termination')

C        END FILE MTOUT
C        CLOSE(MTOUT)
c      ENDIF

C ----------------------------------------------
      RESULT(1) = NTOT
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
C -----------------------------------------------------------
      WRITE(LINE,1000) NTOT
 1000 FORMAT('Number of reflections = ',I8)
      CALL MSGDOC(MDOC,LINE)

      IF(NTOT.GT.0.AND.CFREE.NE.'N') THEN
        T = FLOAT(NFREE)/FLOAT(NTOT)
        WRITE(LINE,*) 'Nfree:',NFREE,T
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      RETURN
      END

      SUBROUTINE WR_TITLE_MTZ(MDOC,IOUT,TYPE,TTT
     * ,MT2,MT3,CSIG,CFOM,CFREE,ANOM
     * ,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,TTT*(*)
C ------------------------------------------------------------
C ----------------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------------------------------------------------------------
C -------
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80,CSIG*1,CFOM*1,CFREE*1,ANOM*1
C --- ccp4
      real      cell(6)
      integer   maxlab
C Max number of labels
      parameter (maxlab = 80)
C Max number of tokens for 'parser'
      parameter (maxtok = 2*maxlab+1)

      integer   ntok
      integer   nlprgo
      integer   ibeg(maxtok), iend(maxtok), ityp(maxtok)
      integer   nsymx, nsympx, nspgrx
      real      fvalue(maxtok)
      real      rsymx(4,4,192)
      real      nan
      character spgrnx*10, pgnamx*10
      character lsprgo(maxlab)*30, ctprgo(maxlab)
      character str*500
C -------------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
C --------------------------------

C cell parameters

      cell(1) = A_CELL
      cell(2) = B_CELL
      cell(3) = C_CELL
      cell(4) = (AL_CELL*180.0)/PI
      cell(5) = (BE_CELL*180.0)/PI
      cell(6) = (GA_CELL*180.0)/PI

      call lwcell(1, cell)

C  SYMMETRY 

c      WRITE(str,'(I6)') NSP_GROUP
C      str       = 'SYMM 19'

      NOSG = NSP_GROUP
      ISTT = N_SETT
      IF(NOSG.EQ.  3.OR.NOSG.EQ.  4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
        ELSE IF(ISTT.EQ.3) THEN  
          ISTT = 4
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
        ELSE IF(ISTT.EQ.3) THEN  
          ISTT = 4
        ELSE IF(ISTT.EQ.4) THEN  
          ISTT = 3
        ENDIF
      ENDIF
C ---
      IF(ISTT.GT.1) NOSG = (ISTT-1)*1000 + NOSG
      NO_CCP4 = NOSG
      str       = ' '
      ibeg(1)   = 1
      iend(1)   = 4
      ityp(1)   = 1
      fvalue(1) = 0
      ibeg(2)   = 6
      iend(2)   = 7
      ityp(2)   = 2
      fvalue(2) = 0
      fvalue(2) = NO_CCP4
C      fvalue(2) = 19
      ntok      = 2
      nsymx     = 0
c      spgrnx    = 'C 1 21 1'
      spgrnx    = ' '
      pgnamx    = ' '
      nspgrx  = 0
      nsympx  = 0

c       write(*,*) '<',str(1:10),'>'
c       write(*,*) '-->',ntok, ibeg(1), iend(1), ityp(1), fvalue(1)
c       write(*,*) '-->',ntok, ibeg(2), iend(2), ityp(2), fvalue(2)
c
c       write(*,*) '<',spgrnx,'>'
c       write(*,*) '<', pgnamx,'>'
c       write(*,*) '<<<',nspgrx, nsymx, nsympx


      call rdsymm (2, str, ibeg, iend, ityp, fvalue, ntok,
     $        spgrnx, nspgrx, pgnamx, nsymx, nsympx, rsymx)

c       write(*,*) '<',spgrnx,'>'
c       write(*,*) '<', pgnamx,'>'
c       write(*,*) '<<<',nspgrx, nsymx, nsympx

C -------------------------
c      WRITE(LINE,'(''loop_'')')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_h'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_k'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      LINE='_refln.index_l'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
C     LABOUT 
c      lsprgo(k) = str(ibeg(i):iend(i))
c      nlprgo = (ntok-1)
C    CTYPOUT 
c      ctprgo(k) = str(ibeg(i):iend(i))

 
c      LINE='_refln.F_meas_au'
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      nlprgo         = 1
      lsprgo(nlprgo) = 'H'
      ctprgo(nlprgo) = 'H'

      nlprgo         = 2
      lsprgo(nlprgo) = 'K'
      ctprgo(nlprgo) = 'H'

      nlprgo         = 3
      lsprgo(nlprgo) = 'L'
      ctprgo(nlprgo) = 'H'

      nlprgo         = nlprgo + 1
      lsprgo(nlprgo) = 'FP'
      ctprgo(nlprgo) = 'F'

      IF(CSIG.EQ.'Y') THEN
c        LINE='_refln.F_meas_au_sigma'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'SIGFP'
        ctprgo(nlprgo) = 'Q'
      ENDIF

      IF(ANOM.EQ.'Y') THEN
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FPM'
        ctprgo(nlprgo) = 'F'
        IF(CSIG.EQ.'Y') THEN
          nlprgo         = nlprgo + 1
          lsprgo(nlprgo) = 'SIGFPM'
          ctprgo(nlprgo) = 'Q'
        ENDIF
      ENDIF

      IF(MT2.GT.0) THEN
c        LINE='_refln.F_calc'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FC'
        ctprgo(nlprgo) = 'F'
C        IF(CSIG.EQ.'Y') THEN
c          LINE='_refln.F_sigma'
c          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C          nlprgo         = nlprgo + 1
C          lsprgo(nlprgo) = 'SIGFC'
C          ctprgo(nlprgo) = 'Q'
C        ENDIF
      ENDIF
      IF(MT3.GT.0) THEN
c        LINE='_refln.phase_calc'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'PH'
        ctprgo(nlprgo) = 'P'
        IF(CFOM.EQ.'Y') THEN
c          LINE='_refln.fom'
c          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          nlprgo         = nlprgo + 1
          lsprgo(nlprgo) = 'FOM'
          ctprgo(nlprgo) = 'W'
        ENDIF
      ENDIF
      IF(CFREE.EQ.'Y'.OR.CFREE.EQ.'I') THEN
c        LINE='_refln.status'
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        nlprgo         = nlprgo + 1
        lsprgo(nlprgo) = 'FreeR_flag'
        ctprgo(nlprgo) = 'I'
      ENDIF
C     H-L:
C     HLA   A
C     HLB   A
C     HLC   A
C     HLD   A
C ----------------------------------------
C Store the column labels in the mtz header:
      call lwclab(1, lsprgo, nlprgo, ctprgo, 0)
C Store the symmetry in the mtz header:
      call lwsymm (1, nsymx, nsympx, rsymx, spgrnx(1:1), nspgrx,
     $     spgrnx, pgnamx)
C Store a history header:
      call lwhstl (1, ' ')
C -----------------------------------------
      RETURN
      END
C ******

      SUBROUTINE DSTAR_BL(IH,IK,IL,RSQ)
C
C -P- DSTAR - give value of (4pi*sin(theta))/lambda for H,K,L
C             using information calculated by DSTARF or REPCELL.
C
C     input : IH,IK,IL - indeces h,k,l
C     output: RSQ      - in 1/Angstrom  (4pi*sin(theta))/lambda
C -------------------------------------------------------------------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
C ******
C---------------------------------------------------------------------
      AH  = IH
      AK  = IK
      AL  = IL
      RSQ=AH*(QQ_1*AH+QQ_4*AK+QQ_5*AL)+QQ_2*AK*AK+(QQ_3*AL+QQ_6*AK)*AL
      RETURN
      END
