C --- check_cell_sg.f ---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80
      CHARACTER SPACE_GROUP*80
      REAL      CELL(6)
      CHARACTER MESSAGE*80,JOB*80
C ----
      PARAMETER (NCH_MAX  = 6000)
      CHARACTER CHAIN(NCH_MAX)*5
      CHARACTER CODE_PDB(NCH_MAX)*4
      INTEGER   NCH_PDB(NCH_MAX)
      REAL      DIFF(NCH_MAX)
      REAL      CELL_FD(NCH_MAX,6)
C ----
      CHARACTER PATH*80,EXT*3
C =============================================================
c_PATH_OUT /data/alexei/work/molrep_DB/temp/
      PATH_OUT = ' '
      MDOC    = 1
      PROG = 'check_cell_sg'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------------
      IERR = 0
      MD   = 0
      M    = 99
      JOB  = 'check_cell_sg'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(M,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        GO TO 900
      ENDIF
      CLOSE(IOUT)
C -------------------------------------------------------------
      DO I=1,6
        CELL(I) = 0.0
      ENDDO
      SPACE_GROUP = ' '
      NPDB = 0
      FLIM = 0.0
C ----
      CALL SET_DEFAULT(
     *'SG:          < >  - space group name or " "')
      CALL SET_DEFAULT(
     *'CELL:        < >  - unit cell parameters')
      CALL SET_DEFAULT(
     *'LIM:     <0.05 >  - similarity (fractional) limit')
      CALL SET_DEFAULT(
     *'PATH_SCR:    < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(M,' ')
C -----------------------
      LINE='SG'
      CALL ASK(LINE)
      SPACE_GROUP=LINE
      CALL CORR_NAME_BLC(SPACE_GROUP)
c ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C ----
      LINE='CELL'
      CALL ASK(LINE)
      READ(LINE,*) CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
C ----
      LINE='LIM'
      CALL ASK(LINE)
      READ(LINE,*) FLIM
C -----------------------
C
c result: PATH_OUT/check_cell_sg.xml

      CALL CLOSE_BATCH(MDOC)
      CALL CHECK_CELL_SG(MDOC
     * ,CELL,SPACE_GROUP,FLIM,DIFF,CODE_PDB
     * ,CELL_FD,CHAIN,NCH_PDB,NCH_MAX,NPDB 
     * ,MESSAGE,PATH_OUT,PATH_SCR,IERR)
C -----------------------
      CALL WRITE_CHECK_CELL_SG_XML(MDOC,IERR
     *     ,NPDB,CODE_PDB,CELL_FD,NCH_MAX,DIFF
     *     ,MESSAGE,JOB,PATH_OUT,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE WRITE_CHECK_CELL_SG_XML(MDOC,IERR_INPUT
     *     ,NPDB,CODE_PDB,CELL_FD, NCH_MAX,DIFF
     *     ,MESSAGE,JOB,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR,IERR_INPUT
      CHARACTER MESSAGE*(*),JOB*(*)
      CHARACTER LINE*256,FILE_2*256
      CHARACTER CODE_PDB(NCH_MAX)*4
      REAL      DIFF(NCH_MAX)
      REAL      CELL_FD(NCH_MAX,6)
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
 
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'n_structure <n_structure> ',NPDB,' </n_structure>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        IF(NPDB.GT.0) THEN

          DO I=1,NPDB

            CALL LENSTR_BL(CODE_PDB(I),L)

            LINE = 'PDB_code <PDB_code>'//CODE_PDB(I)(1:L)//
     *             '</PDB_code>'

            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

            WRITE(LINE,'(A,F8.3,A)',ERR=510) 
     *      'diff <diff> ',DIFF(I),' </diff>'
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
            
            WRITE(LINE,'(A,F8.3,2X,F8.3,2X,F8.3,2X,F6.2,2X,
     *      F6.2,2X,F6.2,A)',ERR=510)
     *      'cell <cell> ',CELL_FD(I,1),CELL_FD(I,2),CELL_FD(I,3)
     *      , CELL_FD(I,4),CELL_FD(I,5),CELL_FD(I,6), ' </cell>' 
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
          ENDDO

        ENDIF

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_CELL_SG(MDOC
     * ,CELL,SPACE_GROUP,FLIM,DIFF, CODE_PDB
     * ,CELL_FD,CHAIN,NCH_PDB,NCH_MAX,NPDB 
     * ,MESSAGE,PATH_OUT,PATH_SCR,IERR)
C --------------------------------------------------------------------
C ----
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),MESSAGE*(*)
      CHARACTER SPACE_GROUP*(*)
      REAL      CELL(6)
      REAL      CELL_FD(NCH_MAX,6)
C ----
      CHARACTER CHAIN(NCH_MAX)*5
      CHARACTER CODE_PDB(NCH_MAX)*4
      INTEGER   NCH_PDB(NCH_MAX)
      REAL      DIFF(NCH_MAX)
C ----
      REAL      CP_CELL(6)
      CHARACTER NAME_CELL_LIST*256
      CHARACTER LINE*256
      CHARACTER CODE*5,CHAR11*11
C =============================================================
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      IF(FLIM.LE.0.0001) FLIM = 0.05
      ANG_LIM  = FLIM
      DIST_LIM = FLIM
      MESSAGE = 'normal termination'
C -------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: problem with setenv MOLREP_DB')
        LINE = '        Example:"setenv MOLREP_DB'//
     *         ' /data/alexei/work/molrep_DB"'
        CALL MSGERR(MDOC,LINE)
        MESSAGE = 'problem with setenv MOLREP_DB'
        IERR = 3
        GO TO 500
      ENDIF
C     Example: "setenv MOLREP_DB ~alexei/molrep_DB"
      CALL LENSTR_BL(LINE,LEN)
      NAME_CELL_LIST = LINE(1:LEN)//'/list/cell_list.txt'
      MT   = 10
      OPEN(MT,FILE=NAME_CELL_LIST,ACCESS='SEQUENTIAL',ERR=900,
     *    FORM='FORMATTED',STATUS='OLD')
C ---
      CALL LENSTR_BL(SPACE_GROUP,LS)
      NCH  = 0
      NPDB = 0
C ---
      DO I=1,1000000
        READ(MT,'(A)',ERR=800,END=100) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.74) GO TO 200
        IF(LINE(1:1).EQ.'#') GO TO 200

C123456711234512123456789 1
c      1 11bgA <P 2 21 21  >    36.400   66.700  107.700  90.00  90.00  90.00
C      1 11bgA <P 2 21 21  >    36.400   66.700  107.700  90.00  90.00  90.00
C123456789 123456789 123456789 123456789 123456789N 123456789 123456789 12345

        READ(LINE,'(7X,A5,2X,A11,2X,3F9.3,3F7.2)') 
     *      CODE,CHAR11
     *     ,CP_CELL(1),CP_CELL(2),CP_CELL(3)
     *     ,CP_CELL(4),CP_CELL(5),CP_CELL(6)

        IF(LS.GT.0) THEN
          CALL LENSTR_BL(CHAR11,L1)
          IF(L1.NE.LS) GO TO 200
          IF(CHAR11(1:L1).NE.SPACE_GROUP(1:LS)) GO TO 200
        ENDIF

        IF(CELL(1).GT.0.01) THEN
          D1 = ABS(CELL(1)-CP_CELL(1))/CP_CELL(1)
          D2 = ABS(CELL(2)-CP_CELL(2))/CP_CELL(2)
          D3 = ABS(CELL(3)-CP_CELL(3))/CP_CELL(3)
          D4 = ABS(CELL(4)-CP_CELL(4))/CP_CELL(4)
          D5 = ABS(CELL(5)-CP_CELL(5))/CP_CELL(5)
          D6 = ABS(CELL(6)-CP_CELL(6))/CP_CELL(6)

          DMAX = D1
          IF(DMAX.LT.D2) DMAX = D2
          IF(DMAX.LT.D3) DMAX = D3
          IF(DMAX.LT.D4) DMAX = D4
          IF(DMAX.LT.D5) DMAX = D5
          IF(DMAX.LT.D6) DMAX = D6

          IF(D1.GT.DIST_LIM.OR.D2.GT.DIST_LIM.OR.
     *       D3.GT.DIST_LIM.OR.D4.GT.ANG_LIM .OR.
     *       D5.GT.ANG_LIM .OR.D6.GT.ANG_LIM     ) GO TO 200

        ENDIF

        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))

        NCH = NCH + 1
        CHAIN(NCH) = CODE
        DIFF(NCH)  = DMAX
        DO J= 1, 6
          CELL_FD(NCH,J) = CP_CELL(J)
        ENDDO

        IF(NCH.GE.NCH_MAX) GO TO 100        

 200    CONTINUE   
      ENDDO
 100  CONTINUE
      CLOSE(MT)

      IMIN = 0
      IF(NCH.GT.0) THEN
        DIFF_MIN = 10000.0
        DO I=1,NCH
          IF(NPDB.GT.0) THEN
            DO J=1,NPDB
              IF(CODE_PDB(J).EQ.CHAIN(I)(1:4)) THEN
                NCH_PDB(J) = NCH_PDB(J) + 1
                GO TO 300 
              ENDIF
            ENDDO
          ENDIF
          NPDB = NPDB + 1
          CODE_PDB(NPDB) = CHAIN(I)(1:4)
          DIFF(NPDB)     = DIFF(I)
          DO K = 1, 6
            CELL_FD(NPDB,K) = CELL_FD(I,K)
          ENDDO
          IF(DIFF(NPDB).LT.DIFF_MIN) THEN
            IMIN = NPDB
            DIFF_MIN = DIFF(NPDB)
          ENDIF
          NCH_PDB(NPDB)  = 1

 300      CONTINUE   
        ENDDO

        WRITE(LINE,'(''N_pdb :'',I5)') NPDB
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))
        DO I=1,NPDB
          WRITE(LINE,'(I5,'')  '',A4,''    Nch '',I4,F8.3)') 
     *                  I,CODE_PDB(I),NCH_PDB(I),DIFF(I)
          CALL LENSTR_BL(LINE,LEN)
          CALL MSGDOC(MDOC,LINE(1:LEN))
        ENDDO

      ELSE
        WRITE(LINE,'(''N_pdb :'',I5)') NPDB
        CALL LENSTR_BL(LINE,LEN)
        CALL MSGDOC(MDOC,LINE(1:LEN))
      ENDIF   

      IF(IMIN.GT.1) THEN
        CODE_PDB(1) = CODE_PDB(IMIN)
        DIFF(1)     = DIFF(IMIN)
        DO K = 1, 6
          CELL_FD(1,K) = CELL_FD(IMIN,K)
        ENDDO
      ENDIF
      IF(NPDB.GT.1) NPDB = 1
C ---
 500  CONTINUE
      RETURN
 900  CONTINUE
      LINE = 'ERROR: can not open "cell_list.txt"'
      CALL MSGERR(MDOC,LINE)
      MESSAGE = 'can not open "cell_list.txt"'
      IERR = 4
      RETURN
 800  CONTINUE
      LINE = 'ERROR: read file "cell_list.txt"'
      CALL MSGERR(MDOC,LINE)
      MESSAGE = 'read file "cell_list.txt'
      IERR = 5
      RETURN
      END
