C --- check_file_DB.f ---
C -------------
      INCLUDE 'nsym-max.fh'
C     PARAMETER ( IPRSYM = 48 )
      INTEGER*2 ISYM(5,3,IPRSYM)
C -------------
      PARAMETER ( IPRROW = 21 )
      REAL      RESULT(IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER F_NAME*256,S_NAME*256,C_NAME*256,O_NAME*256
      CHARACTER LINE*256
      CHARACTER MESSAGE1*80,MESSAGE2*80,MESSAGE3*80
      CHARACTER PATH_OUT*256,PATH_SCR*256
C ===========================
C     START - initialization common/COMLIB/,/CRYSTL/,.., open DOC-file.
C
      MDOC = 0
      CALL START(0,MDOC,'check_file_DB',PATH_OUT)
C ---------------------------
C     MSGDOC - writes message to terminal or/and DOC_FILE
C
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '    ---- CHECK_FILE_DB ----    /V.05.07.2005/ ')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
C     list of possible keywords
C
      CALL MSGDOC(MDOC,' ')
      CALL SET_DEFAULT(
     *'FILE_F:  < >   - input_file_SF ')
      CALL SET_DEFAULT(
     *'FILE_S:  < >   - input_file_sequence')
      CALL SET_DEFAULT(
     *'FILE_C:  < >   - input_file_coordinate')
c      CALL SET_DEFAULT(
c     *'FILE_O:  < >   - output_file_name /without extension/')
c      CALL SET_DEFAULT(
c     *'PATH_SCR:   < >   - path to scratch file directory')
C ---
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------
C
C     read keywords
C 
      LINE='FILE_F'
      CALL ASK(LINE)
      F_NAME=LINE
      CALL CORR_NAME_ALL(F_NAME)
C ---
      LINE='FILE_S'
      CALL ASK(LINE)
      S_NAME=LINE
      CALL CORR_NAME_ALL(S_NAME)
C ---
      LINE='FILE_C'
      CALL ASK(LINE)
      C_NAME=LINE
      CALL CORR_NAME_ALL(C_NAME)
C ---
c      LINE='FILE_O'
c      CALL ASK(LINE)
c      O_NAME=LINE
c      CALL CORR_NAME_ALL(O_NAME)
c ----
c      LINE='PATH_SCR'
c      CALL ASK(LINE)
c      PATH_SCR=LINE
c      CALL CORR_NAME_BLC(PATH_SCR)

       PATH_SCR=' '
       O_NAME  =' '
C ----
C ---------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL CHECK_FILE_DB(MDOC,F_NAME,S_NAME,C_NAME,O_NAME
     *    ,PATH_OUT,PATH_SCR,ISYM,IPRSYM,RESULT,IPRROW
     *    ,MESSAGE1,MESSAGE2,MESSAGE3,IERR1,IERR2,IERR3)
C ---------------------------
C     FINISH - close DOC-file and EXIT.
C

      CALL WRITE_CHECK_FILE_DB_XML(MDOC
     *  ,IERR1,IERR2,IERR3,MESSAGE1,MESSAGE2,MESSAGE3
     *                                 ,PATH_OUT,JERR)
c
      CALL FINISH
      END

      SUBROUTINE WRITE_CHECK_FILE_DB_XML(MDOC
     *  ,IERR1,IERR2,IERR3,MESSAGE1,MESSAGE2,MESSAGE3
     *             ,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,JOB*80
      CHARACTER MESSAGE1*(*),MESSAGE2*(*),MESSAGE3*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      JOB = 'check_file_DB'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR1.GT.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_sf <err_level>',IERR1,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(MESSAGE1,LM)
        IF(LM.LE.0) MESSAGE1 = 'null'
        CALL LENSTR_BL(MESSAGE1,LM)
        LINE = 
     *  'message_sf <err_message>'//
     *   MESSAGE1(1:LM)//'</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      IF(IERR2.GT.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_seq <err_level>',IERR2,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(MESSAGE2,LM)
        IF(LM.LE.0) MESSAGE2 = 'null'
        CALL LENSTR_BL(MESSAGE2,LM)
        LINE = 
     *  'message_seq <err_message>'//
     *   MESSAGE2(1:LM)//'</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      IF(IERR3.GT.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_coord <err_level>',IERR3,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(MESSAGE3,LM)
        IF(LM.LE.0) MESSAGE3 = 'null'
        CALL LENSTR_BL(MESSAGE3,LM)
        LINE = 
     *  'message_coord <err_message>'//
     *   MESSAGE3(1:LM)//'</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF

      IF(IERR1.LT.0.AND.IERR2.LT.0.AND.IERR3.LT.0) THEN
        IERR1 = 1
        MESSAGE1 = 'no file was difined'
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level>',IERR1,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      IF(IERR1.EQ.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_sf <err_level>',IERR1,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
        CALL LENSTR_BL(MESSAGE1,LM)
        IF(LM.LE.0) MESSAGE1 = 'null'
        CALL LENSTR_BL(MESSAGE1,LM)
        LINE = 
     *  'message_sf <err_message>'//MESSAGE1(1:LM)//
     *  '</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      IF(IERR2.EQ.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_seq <err_level>',IERR2,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
        CALL LENSTR_BL(MESSAGE2,LM)
        IF(LM.LE.0) MESSAGE2 = 'null'
        CALL LENSTR_BL(MESSAGE2,LM)
        LINE = 
     *  'message_seq <err_message>'//MESSAGE2(1:LM)//
     *  '</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      IF(IERR3.EQ.0) THEN
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error_coord <err_level>',IERR3,'</err_level>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
        CALL LENSTR_BL(MESSAGE3,LM)
        IF(LM.LE.0) MESSAGE3 = 'null'
        CALL LENSTR_BL(MESSAGE3,LM)
        LINE = 
     *  'message_coord <err_message>'//MESSAGE3(1:LM)//
     *  '</err_message>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
      
      WRITE(IOUT,'(A)',ERR=510) '</'//JOB(1:LJ)//'>' 
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_FILE_DB(MDOC,F_NAME,S_NAME,C_NAME,O_NAME
     *    ,PATH_OUT,PATH_SCR,ISYM,IPRSYM,RESULT,IPRROW
     *    ,MESSAGE1,MESSAGE2,MESSAGE3,IERR1,IERR2,IERR3)
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER F_NAME*(*),S_NAME*(*),C_NAME*(*),O_NAME*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
C ------------------------------
      CHARACTER LINE*256
      CHARACTER MESSAGE1*(*),MESSAGE2*(*),MESSAGE3*(*)
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR1 =-1
      IERR2 =-1
      IERR3 =-1
      MESSAGE1 = 'normal termination'
      MESSAGE2 = 'normal termination'
      MESSAGE3 = 'normal termination'
C ---
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.GT.0) THEN
        CALL CHECK_SF_FILE(MDOC,F_NAME,MESSAGE1,IERR1)
      ENDIF
C ---
      CALL LENSTR_BL(S_NAME,LEN)
      IF(LEN.GT.0) THEN
        CALL CHECK_SEQ_FILE(MDOC,S_NAME,MESSAGE2,IERR2)
      ENDIF
C ---
      CALL LENSTR_BL(C_NAME,LEN)
      IF(LEN.GT.0) THEN
        CALL CHECK_COORD_FILE(MDOC,C_NAME,MESSAGE3,IERR3)
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE CHECK_SF_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER LINE*256
      CHARACTER MESSAGE*(*),CIF*1,SPGR*11,MAP*1,MTZ*1,BLANC*1
      INTEGER   ID(10)
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      CIF  = 'N'
      MAP  = 'N'
      MTZ  = 'N'
      BLANC = 'N'
      IFIRST = 0
      ISCIP  = 0
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL LENSTR_BL(FILE,IFLEN)
      IF(IFLEN.LT.5) THEN 
        LINE = ' ERROR: wrong file name'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'wrong file name'
        IERR = 1
        RETURN
      ENDIF
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input file SF'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input file SF'
        IERR = 1
        RETURN
      ENDIF

      DO I=1,100

        LINE = ' '

        READ(IN,'(A)',END=100,ERR=200) LINE(1:10)
    
        IMODE = 0
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)

        IF(I.EQ.1) THEN
          IF(LINE(1:3).EQ.'MTZ') THEN
            MESSAGE = 'MTZ file'
            MTZ = 'Y'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.mtz') THEN
              LINE = 'ERROR: MTZ_file must has extension ".mtz"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF(LINE(6:9).EQ.'F   ') THEN
            MESSAGE = 'BLANC F_file'
            BLANC = 'F'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF(LINE(6:9).EQ.'FS  ') THEN
            MESSAGE = 'BLANC FS_file'
            BLANC = 'F'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ELSE IF(LINE(6:9).EQ.'RI  ') THEN
            MESSAGE = 'MAP BLANC file'
            BLANC = 'D'
            CLOSE(IN)
            IF(FILE(IFLEN-3:IFLEN).NE.'.dat') THEN
              LINE = 'ERROR: BLANC_file must has extension ".dat"'
              CALL MSGERR(MD,LINE)
              IERR = 1
            ENDIF
            GO TO 300
          ENDIF

        ENDIF
        ISCIP = ISCIP + 1
        IF(LINE(1:1).EQ.'#') GO TO 400
        CALL REMOVE_FIRST_BLANC(LINE)
        IF(IFIRST.EQ.0.AND.LINE(1:5).EQ.'data_') CIF = 'I'
        IFIRST = IFIRST + 1
        IF(CIF.EQ.'I'.AND.LINE(1:7).EQ.'_refln.') THEN
          MESSAGE = 'CIF SF File'
          CIF = 'Y'
          CLOSE(IN)
          IF(FILE(IFLEN-3:IFLEN).NE.'.cif'.AND.
     *       FILE(IFLEN-3:IFLEN).NE.'.ent') THEN
         LINE = 'ERROR: CIF_file must has extension ".cif" or ".ent"'
            CALL MSGERR(MD,LINE)
            IERR = 1
          ENDIF
          GO TO 300
        ENDIF

 400    CONTINUE

      ENDDO
C ---
      CLOSE(IN)
      CALL OPENUR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input file SF'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input file SF'
        IERR = 1
        RETURN
      ENDIF

      READ(IN,END=100,ERR=200) (ID(J),J=1,9)
      
C      WRITE(*,*) '>>>I:',(ID(J),J=1,9)

      MAP = 'Y'
      MESSAGE = 'MAP CCP4 file'
      IF(FILE(IFLEN-3:IFLEN).NE.'.map'.AND.
     *   FILE(IFLEN-4:IFLEN).NE.'.ccp4') THEN
        LINE = 'ERROR: MAP_file must has extension ".map" or ".ccp4"'
        CALL MSGERR(MD,LINE)
        IERR = 1
      ENDIF
      CLOSE(IN)
      GO TO 300
C ---
 500  CIF = 'N'
      IERR = 1
      MESSAGE = 'unknown file'
      CLOSE(IN)
      RETURN
C ---
 300  CONTINUE
      RETURN
C ---
 100  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: end of input file SF'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'end of input file SF'
      IERR = 1
      RETURN
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input file SF'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input file SF'
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_SEQ_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER LINE*4096
      CHARACTER MESSAGE*(*)
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input sequence file'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input sequence file'
        IERR = 1
        RETURN
      ENDIF

      IEND   = 0
      IFIRST = 0
      NBAD   = 0
      NAA    = 0

      DO I=1,1000

        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IN,'(A)',END=620,ERR=200) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE

        IMODE = 1
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          IFIRST = IFIRST + 1
c          IF(IFIRST.GE.2) THEN
c            LINE = ' ERROR: more then one sequence'
c            CALL MSGERR(MD,LINE)
c            MESSAGE = 'more then one sequence'
c            IERR = 1
c          ENDIF
          GO TO 630
        ENDIF
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 630        

        DO K=1,LEN
          CH1 = LINE(K:K)
          IF(CH1.EQ.' '.OR.CH1.EQ.'-') GO TO 700

          DO  J=1,25
            IF(CH1.EQ.AMIN(J)) THEN
              GO TO 710
            ENDIF
          ENDDO
          J   = 26
 710      CONTINUE

          IF(J.EQ.22) J = 7
          IF(J.EQ.23) J = 8

          IF(J.GE.1.AND.J.LE.21) THEN
            NAA = NAA + 1
          ELSE
            NBAD = NBAD + 1
          ENDIF

 700      CONTINUE
        ENDDO

 630    CONTINUE
      ENDDO

 600  CONTINUE
      CLOSE(IN)
      IF(NBAD.GT.10) THEN
        LINE = ' ERROR: number of bad symbols more then 10'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'number of bad symbols more then 10'
        IERR = 1
      ENDIF
      IF(NAA.LE.5) THEN
        LINE = ' ERROR: number of amino acids less 5'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'number of amino acids less 5'
        IERR = 1
      ENDIF
C ---
      RETURN
C ---
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input sequence file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input sequence file'
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_COORD_FILE(MDOC,FILE,MESSAGE,IERR)
C ------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE*(*)
      CHARACTER PATH*1,EXT*1
C ------------------------------
      CHARACTER LINE*256,PDB*1,CIF*1
      CHARACTER MESSAGE*(*)
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C ---
      MESSAGE = ' '
      EXT  = ' '
      PATH = ' '
      IN   = 10
      CALL CORR_NAME_ALL(FILE)
      CALL LENSTR_BL(FILE,IFLEN)
      IF(IFLEN.LT.5) THEN 
        LINE = ' ERROR: wrong file name'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'wrong file name'
        IERR = 1
        RETURN
      ENDIF
      IF(FILE(IFLEN-3:IFLEN).EQ.'.map'.OR.
     *   FILE(IFLEN-4:IFLEN).EQ.'.ccp4'.OR.
     *   FILE(IFLEN-3:IFLEN).EQ.'.dat') THEN
        MESSAGE = 'MAP File'
        RETURN
      ENDIF
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input coord file'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open input coord file'
        IERR = 1
        RETURN
      ENDIF

      IFIRST = 0
      IEND = 0
      PDB  = 'N'
      CIF  = 'N'

      DO I=1,10000

        LINE = ' '

        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IN,'(A)',END=620,ERR=200) LINE(1:12)
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE

        IMODE = 0
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
        CALL CHECK_LINE(IMODE,LINE)
 
        IF(LINE(1:1).EQ.'#') GO TO 700
        IF(LINE(1:6).EQ.'ATOM  '.OR.LINE(1:6).EQ.'HETATM') THEN
          PDB = 'Y'
          GO TO 600
        ENDIF
        CALL REMOVE_FIRST_BLANC(LINE)
        IF(IFIRST.EQ.0.AND.LINE(1:5).EQ.'data_') CIF = 'I'
        IFIRST = IFIRST + 1     
        IF(CIF.EQ.'I'.AND.LINE(1:11).EQ.'_atom_site.') THEN
          CIF = 'Y'
          GO TO 600
        ENDIF

 700    CONTINUE
      ENDDO

 600  CONTINUE

c      WRITE(*,*) '==',PDB,CIF

      CLOSE(IN)
      IF(CIF.EQ.'Y'.AND.PDB.EQ.'N') THEN
        MESSAGE = 'CIF COORD File'
        IF(FILE(IFLEN-3:IFLEN).NE.'.crd') THEN
          LINE = 'ERROR: CIF_file must has extension ".crd"'
          CALL MSGERR(MD,LINE)
          IERR = 1
        ENDIF
        RETURN
      ELSE IF(CIF.NE.'Y'.AND.PDB.EQ.'Y') THEN
        MESSAGE = 'PDB COORD File'
        IF(FILE(IFLEN-3:IFLEN).NE.'.pdb') THEN
          LINE = 'ERROR: PDB_file must has extension ".pdb"'
          CALL MSGERR(MD,LINE)
          IERR = 1
        ENDIF
        RETURN
      ENDIF
      LINE = ' ERROR: unknown coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'unknown coord file'
      IERR = 1
      RETURN
C ---
 100  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: end of input coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'end of input coord file'
      IERR = 1
      RETURN
 200  CONTINUE
      CLOSE(IN)
      LINE = ' ERROR: read error of input coord file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'read error of input coord file'
      IERR = 1
      RETURN
      END
