C --- create_binaries.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80,MODE*1
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'create_binaries'
      CALL START(0,MDOC,PROG,PATH_OUT)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  CREATE_BINARIES ---  /V.12.06.2007/')
      CALL MSGDOC(MDOC,' ')
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'MODE: <C>,D  - C - create ca_DB, D - create ca_DOM')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT(
     *'         directory ca_DB or ca_DOM must be created')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BL(PATH_SCR)
C ----
      LINE='MODE'
      CALL ASK(LINE)
      MODE=LINE(1:1)
C ----
      CALL CLOSE_BATCH(MDOC)
C ---------------------------------
      CALL CREATE_BINARIES(MDOC,MODE
     *   ,PATH_OUT,PATH_SCR,IERR)
      IF(IERR.NE.0) GO TO 900
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE CREATE_BINARIES(MDOC,MODE
     *   ,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,MODE*1
      CHARACTER FILE_XML*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*256,EXT*1
      CHARACTER MESSAGE*80,JOB*80
      CHARACTER PATH_DB*256,CODE*8
      CHARACTER FILE_1*256

      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)

      integer,      allocatable :: NAA_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
C      JOB  = 'get_chain'
C      MESSAGE = 'normal termination'
c ---
C      CALL LENSTR_BL(JOB,LJ)
C      CALL LENSTR_BL(PATH_OUT,L)
C      IF(L.GT.0) THEN
C        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
C      ELSE
C        LINE = JOB(1:LJ)//'.xml'
C      ENDIF
C      EXT  = ' '
C      PATH = ' '
C      IOUT = 21
C      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
C      IF(IERR.NE.0) THEN
C        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
C        CALL MSGERR(MD,LINE)
C        MESSAGE = 'cannot open output XML file'
C        IERR = 9
C        RETURN
C      ENDIF
C      CLOSE(IOUT)
C ---------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERR: setenv MOLREP_DB'      
        CALL MSGERR(MD,LINE)
        LINE = '     Example: "setenv MOLREP_DB ~alexei/molrep_DB"'      
        CALL MSGERR(MD,LINE)
        GO TO 900
      ENDIF
c ----
      IF(MODE.EQ.'c') MODE='C'
      IF(MODE.EQ.'d') MODE='D'
      IF(MODE.NE.'D'.AND.MODE.NE.'C')  MODE='C'

      CALL LENSTR_BL(PATH_DB,LEN)
      IF(MODE.EQ.'C') THEN
        FILE_1 = PATH_DB(1:LEN)//'/list/chain_list.txt'
      ELSE
        FILE_1 = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'
      ENDIF
C     check memory NDOM

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_1,NDOM,IERR)
      IF(IERR.NE.0) GO TO 900
      
      IF(MODE.EQ.'C') THEN
        WRITE(LINE,*) 'N_chains in chain_list:',NDOM
        CALL MSGDOC(MDOC,LINE)
      ELSE
        WRITE(LINE,*) 'N_domains in domain_descr_list:',NDOM
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NDOM.LE.1) THEN
        IERR = 1
        GO TO 900
      ENDIF

C       
      IF(MODE.EQ.'C') THEN
        NSEQMAX = NDOM
        allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)
        I_MIN = 0
        I_MAX = 0
        CALL READ_CHAIN_LIST(MDOC,FILE_1,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
        IF(IERR.NE.0) GO TO 910
        NDOM = NSEQ
        WRITE(LINE,*) 'read N_chains from chain_list:',NDOM
        CALL MSGDOC(MDOC,LINE)
        LEN_CODE = 5
      ELSE

        allocate(CODE_DOM(1:NDOM),STAT=ISTAT)
        allocate(NAA_DOM(1:NDOM),STAT=ISTAT)

c       read  CODE_DOM,NAA_DOM
        CALL READ_DOM_DESCR_CODE_NAA(MDOC
     *           ,FILE_1,NDOM,CODE_DOM,NAA_DOM,IERR)
        IF(IERR.NE.0) GO TO 910
        WRITE(LINE,*) 'read N_domains from domain_descr_list:',NDOM
        CALL MSGDOC(MDOC,LINE)
        LEN_CODE = 7
      ENDIF

      N_NEW = 0

      DO IDOM=1,NDOM

        IF(MODE.EQ.'C') THEN
          IF(COMPLEX_DB(IDOM)(1:1).EQ.'X') GO TO 100
          CODE = CODE_DB(IDOM)
        ELSE
          CODE = CODE_DOM(IDOM)
        ENDIF
C ---
        CALL PREPARE_BIN_FILE(M,MODE,LEN_CODE,IDOM,CODE
     *            ,PATH_DB,PATH_OUT,PATH_SCR,IERR)
        IF(IERR.EQ.999) THEN
          IERR = 0
        ELSE IF(IERR.NE.0) THEN
          LINE = ' ERROR: in PREPARE_BIN_FILE: '//CODE
          CALL MSGERR(MDOC,LINE)
          IERR = 0
c          GO TO 910
        ELSE
          WRITE(LINE,'(I6,A,A)') IDOM,'  ',CODE 
          CALL MSGDOC(MDOC,LINE)
          N_NEW = N_NEW + 1
        ENDIF
C ---
  100   CONTINUE
      ENDDO

      IF(N_NEW.GT.0) THEN
        IF(MODE.EQ.'C') THEN
          CALL MSGDOC(MDOC,'  copy ca_DB/*  --> ../home/ca_DB/')
        ELSE
          CALL MSGDOC(MDOC,'  copy ca_DOM/* --> ../home/ca_DOM/')
        ENDIF
      ELSE
        CALL MSGDOC(MDOC,' no NEW files')
      ENDIF

910   CONTINUE

      IF(MODE.EQ.'C') THEN
        deallocate(ID_DB,STAT=ISTAT)
        deallocate(NAA_DB,STAT=ISTAT)
        deallocate(NAT_DB,STAT=ISTAT)
        deallocate(NRES_DB,STAT=ISTAT)
        deallocate(IBACK_DB,STAT=ISTAT)
        deallocate(ILEVEL_DB,STAT=ISTAT)
        deallocate(IHIER_DB,STAT=ISTAT)
        deallocate(ICLASS_DB,STAT=ISTAT)
        deallocate(FBACK_DB,STAT=ISTAT)
        deallocate(RESOL_DB,STAT=ISTAT)
        deallocate(FIDENT_DB,STAT=ISTAT)
        deallocate(SCR_DB,STAT=ISTAT)
        deallocate(CODE_DB,STAT=ISTAT)
        deallocate(HIER_DB,STAT=ISTAT)
        deallocate(COMPLEX_DB,STAT=ISTAT)
      ELSE
        deallocate(CODE_DOM,STAT=ISTAT)
        deallocate(NAA_DOM,STAT=ISTAT)
      ENDIF
C ----------------------------------
900   CONTINUE

      RETURN
      END

      SUBROUTINE PREPARE_BIN_FILE(MDOC,MODE,LEN_CODE,IDOM,CODE
     *            ,PATH_DB,PATH_OUT,PATH_SCR,IERR)
C ------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER CODE*8,MODE*1
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
      CHARACTER FILE_XYZ*256,FILE_PDB*256,FILE_SCR*256
      CHARACTER FILE_1*256,FILE_OUT*256
      CHARACTER PATH*1,EXT*1
      CHARACTER LINE*256
      CHARACTER NAM1*4

      real,      allocatable :: COORD1(:,:)
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)
C ---
      logical ex
      integer nfile
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      IF(MODE.EQ.'C') THEN
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_SCR = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *             CODE(1:LEN_CODE)//'.dat'
      ELSE
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_SCR = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *             CODE(1:LEN_CODE)//'.dat'
      ENDIF

      inquire(file=FILE_SCR,exist=ex,number=nfile)
      if(ex) then
        IERR = 999
        RETURN
      endif

      IF(MODE.EQ.'C') THEN
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_XYZ = PATH_DB(1:LEN)//'/pdb_DB/'//CODE(1:LEN_CODE)//'.xyz'
        FILE_PDB = 'pdb_DOM.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_PDB,LT )
        IF(LEN.GT.0) THEN
          FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
        ENDIF
        CALL PDB_UNPACK(M,FILE_XYZ,FILE_PDB,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: unpack XYZ file'
          CALL MSGERR(MDOC,LINE)
          GO TO 900
        ENDIF
      ELSE
        FILE_PDB = 'pdb_DOM.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_PDB,LT )
        IF(LEN.GT.0) THEN
          FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
        ENDIF
        FILE_SCR = ' '
        CALL CREATE_DOM_SEQ_AND_PDB(MDOC
     *           ,CODE,FILE_SCR,FILE_PDB
     *         ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: in CREATE_DOM_SEQ_FROM_PDB'
          CALL MSGERR(MDOC,LINE)
          GO TO 900
        ENDIF
      ENDIF

      FILE_1 = 'align.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_1,LT )
      IF(LEN.GT.0) THEN
        FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
      ENDIF
      CALL SURFACE_DB_ALLOC(M,FILE_PDB,FILE_1
     *                     ,RESULT,IPRROW,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SURFACE PDB')
        GO TO 900
      ENDIF

      ITEST = 1
      NMAX1 = 100

      allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,NAM1,NCHAIN1,ITEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
        GO TO 800
      ENDIF
      IF(NC.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
        IERR = 1
        GO TO 800
      ENDIF

      deallocate(COORD1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

      NMAX1 = NC
      ITEST = 0

      allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,NAM1,NCHAIN1,ITEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
        GO TO 800
      ENDIF
      IF(NC.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
        IERR = 1
        GO TO 800
      ENDIF

      CALL ALIGN_SS_DEFINITION_ALLOC(M,NC
     *     ,COORD1(1,1),COORD1(1,2),COORD1(1,3),SS1,SURF1
     *     ,PSS,PH,PB,NMAX1,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-1(pdb)')
        GO TO 800
      ENDIF
      WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
      CALL MSGDOC(MDOC,LINE)

      IF(MODE.EQ.'C') THEN
        FILE_OUT = 'ca_DB/'//CODE(1:LEN_CODE)//'.dat'
      ELSE
        FILE_OUT = 'ca_DOM/'//CODE(1:LEN_CODE)//'.dat'
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENUW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        GO TO 800
      ENDIF

      WRITE(IOUT,ERR=910) NMAX1,NC,CODE
      WRITE(IOUT,ERR=910) (IRES1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (NSEQ1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SS1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SURF1(I),I=1,NC)
      WRITE(IOUT,ERR=910) ((COORD1(J,I),J=1,NC),I=1,3)

      END FILE IOUT
      CLOSE(IOUT)     

C ----
 800  CONTINUE

      deallocate(COORD1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)
C ----
 900  CONTINUE
      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,' ERROR: writting output file')
      IERR = 1
      GO TO 800
      END

      SUBROUTINE READ_DOM_DESCR_CODE_NAA(MDOC
     *           ,FILE,NDOM,CODE_DOM,NAA_DOM,IERR)
C -------------------------------------------------
      CHARACTER FILE*256,CODE_DOM(NDOM)*8
      INTEGER   NAA_DOM(NDOM)
      CHARACTER LINE*256
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C -----
      MT   = 10
      OPEN(MT,FILE=FILE,ACCESS='SEQUENTIAL',ERR=900,
     *    FORM='FORMATTED',STATUS='OLD')
C ---
      I = 0
 100  CONTINUE
      READ(MT,'(A)',ERR=800,END=200) LINE
      IF(LINE(1:1).EQ.'#') GO TO 100
      I = I + 1
C      FRMT = '(I7,1X,A8,1X,I5,1X,I2,1X,I2,1X,I2,1X,I5,1X,I5,1X,'//
      CODE_DOM(I) =LINE(9:16)
      READ(LINE(18:22),'(I5)') NAA_DOM(I) 
      GO TO 100  
 200  CONTINUE
      CLOSE(MT)
C ---
      RETURN
 900  IERR=1
      CALL LENSTR_BL(FILE,LLL)
      LINE = 'ERR: can not open:'//FILE(1:LLL)       
      CALL MSGERR(MDOC,LINE)
      RETURN
 800  IERR=1
      CALL LENSTR_BL(FILE,LLL)
      LINE = 'ERR: reading :'//FILE(1:LLL)       
      CALL MSGERR(MDOC,LINE)
      CLOSE(MT)
      RETURN
      END
