C---------------------------------------------------------------
C --- create_cell_list.f ---
C -----------------------------------
      CHARACTER PATH_OUT*256
      INTEGER*4 MDOC,IERR
      PARAMETER ( MEMORY  = 4 000 000 )
      REAL      POOL(MEMORY)
      PARAMETER ( IPRROW = 21      )
      REAL      RESULT (IPRROW)
C==================================================================
      MDOC=1
      CALL START(0,MDOC,'create_cell_list',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  --- CREATE_CELL_LIST ---  V.29.03.2006/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL CREATE_CELL_LIST(MDOC,POOL,MEMORY,RESULT,IPRROW,IERR)
C --------------------------------------------------
  900 CALL FINISH
      END


      SUBROUTINE CREATE_CELL_LIST(MDOC,POOL,MEMORY
     *                               ,RESULT,IPRROW,IERR)
C --------------------------------------------------------
      CHARACTER LIST_IN*256
C ----
      REAL      RESULT (IPRROW)
      REAL      POOL(MEMORY)
C ---
      INCLUDE 'chain_list_DB.fh'
C ---
      CHARACTER   CODE*5,CHAR11*11
      CHARACTER   FILE_1*256,FILE_OUT*256
      CHARACTER   LINE*256
      CHARACTER   EXT*3,PATH*1,PATH_SCR*256
      REAL        CELL(6)
C -----------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
C     read file LIST_IN
      CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERR: setenv MOLREP_DB'      
        CALL MSGERR(MD,LINE)
        GO TO 900
      ENDIF
C     Example: "setenv MOLREP_DB ~alexei/molrep_DB"
      CALL LENSTR_BL(LINE,LEN)
      LIST_IN = LINE(1:LEN)//'/list/chain_list.txt'
C
      II_MIN = 0
      II_MAX = 0
      CALL READ_CHAIN_LIST(MDOC,LIST_IN,II_MIN,II_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0) GO TO 900

      WRITE(LINE,*) 'N_seq in DB:',NSEQ
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQ.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
C ------
      FILE_OUT = 'cell_list.txt'
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *      ' ERROR: cannot open output file: cell_list.txt')
        IERR = 1
        RETURN
      ENDIF

C -----
      DO I=1,NSEQ
        NAA = NAA_DB(I)
        CODE = CODE_DB(I)(1:5)
        IW = 0

        CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: setenv MOLREP_DB'      
          CALL MSGERR(MD,LINE)
          GO TO 900
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        FILE_1 = LINE(1:LEN)//'/pdb_DB/'//CODE(1:5)//'.xyz'
        MT   = 10
        OPEN(MT,FILE=FILE_1,ACCESS='SEQUENTIAL',ERR=1400,
     *      FORM='FORMATTED',STATUS='OLD')

        DO J=1,100
c                                                       123456789 1
cCRYST1   51.203   58.409   62.858  90.00  90.00  90.00 P 21 21 21         

          READ(MT,'(A)',END=1400,ERR=1400 ) LINE

          IF(LINE(1:6).EQ.'CRYST1') THEN
   
            READ(LINE,'(6X,3F9.3,3F7.2,1X,A11)') 
     *                CELL(1),CELL(2),CELL(3)
     *               ,CELL(4),CELL(5),CELL(6)
     *               ,CHAR11
       
            WRITE(LINE,'(I6,A,A5,A,A11,A,3F9.3,3F7.2)') 
     *         I,' ',CODE,' <',CHAR11,'> '
     *              ,CELL(1),CELL(2),CELL(3)
     *              ,CELL(4),CELL(5),CELL(6)
            CALL MSGDOC(Mdoc,LINE)

            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)') LINE(1:LEN)

            IW = 1
            CLOSE(MT)   
            GO TO 100
          ENDIF

        ENDDO


 1400   CONTINUE

        CLOSE(MT) 

        WRITE(LINE,*) '--->',I,' ',CODE,' ?????'
        CALL MSGDOC(Mdoc,LINE)

 100    CONTINUE

      ENDDO

      END FILE IOUT  
      CLOSE(IOUT)   

      RETURN
C ------------
C ------------
 900  CONTINUE
      IERR = 1
      RETURN
      END
