C --- domain2chain.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_PDB*256,FILE_OUT*256
C
      CHARACTER LINE*256,PROG*80
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'domain2chain'
      
      CALL START(0,MDOC,PROG,PATH_OUT)
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NCHAIN     = 0
      NCHAIN_NEW = 0
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'FILE_PDB:        - ')
      CALL SET_DEFAULT(
     *'FILE_OUT:        - ')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_PDB'
      CALL ASK(LINE)
      FILE_PDB=LINE
      CALL CORR_NAME_ALL(FILE_PDB)
C ----
      LINE='FILE_OUT'
      CALL ASK(LINE)
      FILE_OUT=LINE
      CALL CORR_NAME_ALL(FILE_OUT)
C ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C ----

      CALL CLOSE_BATCH(MDOC)

C ---------------------------------
      CALL DOMAIN2CHAIN(MDOC,FILE_PDB,FILE_OUT
     *           ,NCHAIN,NCHAIN_NEW,PATH_SCR,PATH_OUT,IERR)
      CALL WRITE_DOMAIN2CHAIN_XML(MDOC
     *    ,IERR,PROG,NCHAIN,NCHAIN_NEW,PATH_OUT)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE WRITE_DOMAIN2CHAIN_XML(MDOC
     *    ,IERR_INPUT,PROG,NCHAIN,NCHAIN_NEW,PATH_OUT)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,MESSAGE*80,PROG*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(PROG,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//PROG(1:LJ)//'.xml'
      ELSE
        FILE_2 = PROG(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//PROG(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//PROG(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//PROG(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
        MESSAGE = 'normal termination'
      ELSE
        MESSAGE = 'program failed'
      ENDIF

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//PROG(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN


        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_chain <nchain> ',NCHAIN,' </nchain>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_chain_new <nchain_new> ',NCHAIN_NEW,' </nchain_new>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//PROG(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE DOMAIN2CHAIN(MDOC,FILE_PDB,FILE_OUT
     *           ,NCHAIN,NCHAIN_NEW,PATH_SCR,PATH_OUT,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB*(*),FILE_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ----
      real,      allocatable :: XA(:)
      real,      allocatable :: YA(:)
      real,      allocatable :: ZA(:)
      real,      allocatable :: OCC(:)
      real,      allocatable :: BISO(:)
      character(LEN=4), allocatable :: ANAME(:)
      character(LEN=3), allocatable :: RNAME(:)
      character(LEN=1), allocatable :: ALT(:)
      character(LEN=7), allocatable :: PNUM(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)

      integer,   allocatable :: FRAG_NATOM(:)
      integer,   allocatable :: FRAG_INDEX(:)
      integer,   allocatable :: FRAG_IORDER(:)
      integer,   allocatable :: FRAG_ISTART(:)
      integer,   allocatable :: FRAG_IFINISH(:)
      integer,   allocatable :: FRAG_RES_ISTART(:)
      integer,   allocatable :: FRAG_RES_IFINISH(:)
      real,      allocatable :: FRAG_XSTART(:,:)
      real,      allocatable :: FRAG_XFINISH(:,:)
      real,      allocatable :: FRAG_XCENTRE(:,:)
      real,      allocatable :: FRAG_RAD(:)
      character(LEN=4), allocatable :: FRAG_SEG(:)
C -----------------------------------------------------------
C -----------------------------------
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,5X,1X,A4,A1,A3,A7,3X,3F8.3,2F6.2,6X,A4,A4)'/
C --
      CHARACTER LINE*256,STR_HEAD*256,STR_CRYS*256
      CHARACTER CP_PNUM*7,CP_PNUM_OLD*7,CHAIN*1,CP_SEG*4
      CHARACTER CP_SEG_OLD*4
      CHARACTER EXT*3,PATH*1
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      STR_HEAD = ' '
      STR_CRYS = ' '
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open input file')
        RETURN
      ENDIF
C ------------
      NATOM    = 0
      NRESIDUE = 0
      NCHAIN   = 0
      NSEGMENT = 0
      CP_PNUM_OLD = '?'
      CP_SEG_OLD     = '????' 
      IRES_OLD    =-10000 
100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        NATOM = NATOM + 1
        ISEG_NEW = 0
        CP_PNUM = LINE(21:27)
        IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c         new residue
          NRESIDUE = NRESIDUE + 1
          READ(CP_PNUM(3:6),'(I4)') IRES
          IDELT = IRES - IRES_OLD
          IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c           new chain
            NCHAIN   = NCHAIN + 1
            CHAIN    = CP_PNUM(2:2)
            ISEG_NEW = 1
          ENDIF
        ENDIF

        IF(LEN.GE.76) THEN
          CP_SEG = LINE(73:76)
        ELSE IF(LEN.GE.75) THEN
          CP_SEG = LINE(73:75)//' '
        ELSE IF(LEN.GE.74) THEN
          CP_SEG = LINE(73:74)//'  '
        ELSE IF(LEN.GE.73) THEN
          CP_SEG = LINE(73:73)//'   '
        ELSE
          CP_SEG = CHAIN//CHAIN//'  '
        ENDIF
        IF(CP_SEG(1:1).NE.CHAIN) CP_SEG(1:1) = CHAIN
        IF(CP_SEG(2:2).EQ.' ')   CP_SEG(2:2) = CHAIN
        CP_SEG(4:4) = ' '

        IF(CP_SEG(1:3).NE.CP_SEG_OLD(1:3)) ISEG_NEW = 1
        IF(ISEG_NEW.LE.0.AND.IDELT.GT.10) ISEG_NEW = 1
        IDELT = 0
        IF(ISEG_NEW.GT.0) NSEGMENT = NSEGMENT + 1
        CP_SEG_OLD  = CP_SEG
        IRES_OLD    = IRES
        CP_PNUM_OLD = CP_PNUM
      ENDIF
      GO TO 100
110   CONTINUE
      CLOSE(IN)

C ------------
      IF(NATOM.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N atoms = 0')
        IERR = 1
        RETURN
      ENDIF
      WRITE(LINE,'(A,I6)') 'Natom     :',NATOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') 'Nresidue  :',NRESIDUE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') 'Nsegment  :',NSEGMENT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') 'Nchain    :',NCHAIN
      CALL MSGDOC(MDOC,LINE)
C -----------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open input file.')
        RETURN
      ENDIF
C ------------

      allocate(XA(1:NATOM),STAT=ISTAT)
      allocate(YA(1:NATOM),STAT=ISTAT)
      allocate(ZA(1:NATOM),STAT=ISTAT)
      allocate(OCC(1:NATOM),STAT=ISTAT)
      allocate(BISO(1:NATOM),STAT=ISTAT)
      allocate(ANAME(1:NATOM),STAT=ISTAT)
      allocate(RNAME(1:NATOM),STAT=ISTAT)
      allocate(ALT(1:NATOM),STAT=ISTAT)
      allocate(PNUM(1:NATOM),STAT=ISTAT)
      allocate(SEG(1:NATOM),STAT=ISTAT)
      allocate(ACODE(1:NATOM),STAT=ISTAT)

      allocate(FRAG_NATOM(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_INDEX(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_IORDER(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_ISTART(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_IFINISH(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_RES_ISTART(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_RES_IFINISH(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_XSTART(1:3,1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_XFINISH(1:3,1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_XCENTRE(1:3,1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_RAD(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_SEG(1:NSEGMENT),STAT=ISTAT)

      NATOM_MAX    = NATOM
      NSEGMENT_MAX = NSEGMENT       

      DO I=1,NSEGMENT
        FRAG_NATOM(I) = 0
      ENDDO
       
      NATOM    = 0
      NRESIDUE = 0
      NCHAIN   = 0
      NSEGMENT = 0
      CP_PNUM_OLD = '?'
      CP_SEG_OLD  = '????' 
      IRES_OLD    =-10000 

200   CONTINUE

      READ(IN,'(A)',ERR=800,END=210) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 200

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        NATOM = NATOM + 1
        IF(NATOM.GT.NATOM_MAX) THEN
          CALL MSGERR(MDOC,'ERROR: Natom > Na_alloc')
          IERR = 1
          GO TO 700
        ENDIF
        ISEG_NEW = 0
        CP_PNUM = LINE(21:27)
        IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c         new residue
          NRESIDUE = NRESIDUE + 1
          READ(CP_PNUM(3:6),'(I4)') IRES
          IDELT = IRES - IRES_OLD
          IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c           new chain
            NCHAIN   = NCHAIN + 1
            CHAIN    = CP_PNUM(2:2)
            ISEG_NEW = 1
          ENDIF
        ENDIF

        IF(LEN.GE.76) THEN
          CP_SEG = LINE(73:76)
        ELSE IF(LEN.GE.75) THEN
          CP_SEG = LINE(73:75)//' '
        ELSE IF(LEN.GE.74) THEN
          CP_SEG = LINE(73:74)//'  '
        ELSE IF(LEN.GE.73) THEN
          CP_SEG = LINE(73:73)//'   '
        ELSE
          CP_SEG = CHAIN//CHAIN//'  '
        ENDIF
        IF(CP_SEG(1:1).NE.CHAIN) CP_SEG(1:1) = CHAIN
        IF(CP_SEG(2:2).EQ.' ')   CP_SEG(2:2) = CHAIN
        CP_SEG(4:4) = ' '

        IF(CP_SEG(1:3).NE.CP_SEG_OLD(1:3)) ISEG_NEW = 1
        IF(ISEG_NEW.LE.0.AND.IDELT.GT.10)  ISEG_NEW = 1
        IDELT = 0

        READ(LINE,FRMT)
     *    ANAME(NATOM),ALT(NATOM),RNAME(NATOM),PNUM(NATOM)
     *   ,XA(NATOM),YA(NATOM),ZA(NATOM)
     *   ,OCC(NATOM),BISO(NATOM),SEG(NATOM),ACODE(NATOM)
        CALL LENSTR_BL(LINE,LEN)
        SEG(NATOM)  = CP_SEG
        PNUM(NATOM) = CP_PNUM
        IF(LEN.LE.76) THEN
          ACODE(NATOM) = '    '
        ENDIF

        IF(ISEG_NEW.GT.0) THEN
          NSEGMENT = NSEGMENT + 1
          IF(NSEGMENT.GT.NSEGMENT_MAX) THEN
            CALL MSGERR(MDOC,'ERROR: Nsegment > Ns_alloc')
            IERR = 1
            GO TO 700
          ENDIF
          FRAG_INDEX    (NSEGMENT) = NSEGMENT
          FRAG_IORDER   (NSEGMENT) = NSEGMENT        
          FRAG_ISTART   (NSEGMENT) = NATOM 
          FRAG_RES_ISTART(NSEGMENT) = IRES 
          FRAG_XSTART(1, NSEGMENT) = XA(NATOM)
          FRAG_XSTART(2, NSEGMENT) = YA(NATOM)
          FRAG_XSTART(3, NSEGMENT) = ZA(NATOM)
          FRAG_XCENTRE(1,NSEGMENT) = 0.0
          FRAG_XCENTRE(2,NSEGMENT) = 0.0
          FRAG_XCENTRE(3,NSEGMENT) = 0.0
          FRAG_RAD(NSEGMENT) = 0.0
          FRAG_SEG(NSEGMENT) = SEG(NATOM)
        ENDIF

        FRAG_NATOM    (NSEGMENT) = FRAG_NATOM(NSEGMENT) + 1
        FRAG_IFINISH  (NSEGMENT) = NATOM
        FRAG_RES_IFINISH(NSEGMENT) = IRES
        FRAG_XFINISH(1,NSEGMENT) = XA(NATOM)
        FRAG_XFINISH(2,NSEGMENT) = YA(NATOM)
        FRAG_XFINISH(3,NSEGMENT) = ZA(NATOM)

        CP_SEG_OLD  = CP_SEG
        IRES_OLD    = IRES
        CP_PNUM_OLD = CP_PNUM

      ENDIF

      GO TO 200
210   CONTINUE
      CLOSE(IN)
      IF(NATOM.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N atoms =0')
        IERR = 1
        GO TO 700
      ENDIF
C ====================
      DO IF=1,NSEGMENT
        CALL CALC_CENTRE_RAD(MDOC,FRAG_ISTART(IF),FRAG_IFINISH(IF)
     *   ,XA,YA,ZA,NATOM
     *   ,FRAG_XCENTRE(1,IF),FRAG_XCENTRE(2,IF),FRAG_XCENTRE(3,IF)
     *   ,FRAG_RAD(IF),IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in CALC_CENTRE_RAD')
          GO TO 700
        ENDIF
      ENDDO

      CALL CHECK_ALL_CHAIN(MDOC,FILE_PDB,NATOM,NSEGMENT
     *   ,XA,YA,ZA,OCC,BISO,PNUM,SEG
     *   ,FRAG_NATOM,FRAG_INDEX,FRAG_IORDER
     *   ,FRAG_ISTART,FRAG_IFINISH
     *   ,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *   ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD
     *   ,FRAG_SEG
     *   ,PATH_OUT,PATH_SCR,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in CHECK_ALL_CHAIN') 
        GO TO 700
      ENDIF
C ====================
710   CONTINUE

      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output file')
        GO TO 700
      ENDIF
C --------
      CALL LENSTR_BL(STR_HEAD,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)',ERR=810) STR_HEAD(1:LEN)     
      ENDIF
      CALL LENSTR_BL(STR_CRYS,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A),ERR=810') STR_CRYS(1:LEN)     
      ENDIF


      CALL ISORT1(FRAG_INDEX,NSEGMENT,FRAG_IORDER)


      CP_PNUM_OLD = '?'
      NCHAIN_NEW  = 0
      IATM = 0

      DO IF=1,NSEGMENT

        IFF = FRAG_IORDER(IF) 
        IAS = FRAG_ISTART(IFF)
        IAF = FRAG_IFINISH(IFF) 

        DO IA=IAS,IAF
          IF(IATM.GE.9999) IATM = 0
          IATM = IATM + 1
          IF(CP_PNUM_OLD(2:2).NE.PNUM(IA)(2:2)) THEN
            NCHAIN_NEW = NCHAIN_NEW + 1
          ENDIF
          SEG(IA)(4:4) = ' '
          CP_PNUM = PNUM(IA)
          IF(CP_PNUM(2:2).EQ.'_') CP_PNUM(2:2) = ' '
          CP_PNUM(1:1) = ' '
          WRITE(LINE,FRMT,ERR=810)
     *      ANAME(IA),ALT(IA),RNAME(IA),CP_PNUM
     *     ,XA(IA),YA(IA),ZA(IA)
     *     ,OCC(IA),BISO(IA),SEG(IA),ACODE(IA)
          LINE(1:6) = 'ATOM  '
          WRITE(LINE(7:11),'(I5)') IATM
          LINE(7:7) = ' '
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A),ERR=810') LINE(1:LEN)     
          CP_PNUM_OLD = PNUM(IA)
        ENDDO

      ENDDO
      WRITE(LINE,'(A,I6)') 'Nchain_new:',NCHAIN_NEW
      CALL MSGDOC(MDOC,LINE)

C ------------
      END FILE IOUT
      CLOSE(IOUT)
C =====================

700   CONTINUE

      deallocate(XA,STAT=ISTAT)
      deallocate(YA,STAT=ISTAT)
      deallocate(ZA,STAT=ISTAT)
      deallocate(OCC,STAT=ISTAT)
      deallocate(BISO,STAT=ISTAT)
      deallocate(ANAME,STAT=ISTAT)
      deallocate(RNAME,STAT=ISTAT)
      deallocate(ALT,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

      deallocate(FRAG_NATOM,STAT=ISTAT)
      deallocate(FRAG_INDEX,STAT=ISTAT)
      deallocate(FRAG_IORDER,STAT=ISTAT)
      deallocate(FRAG_ISTART,STAT=ISTAT)
      deallocate(FRAG_IFINISH,STAT=ISTAT)
      deallocate(FRAG_RES_ISTART,STAT=ISTAT)
      deallocate(FRAG_RES_IFINISH,STAT=ISTAT)
      deallocate(FRAG_XSTART,STAT=ISTAT)
      deallocate(FRAG_XFINISH,STAT=ISTAT)
      deallocate(FRAG_XCENTRE,STAT=ISTAT)
      deallocate(FRAG_RAD,STAT=ISTAT)
      deallocate(FRAG_SEG,STAT=ISTAT)

      RETURN
C ------------
800   CONTINUE
      CALL MSGERR(MDOC,'ERROR:  read input file')
      CLOSE(IOUT)
      IERR = 1
      GO TO 700
810   CONTINUE
      CALL MSGERR(MDOC,'ERROR: write to output file')
      CLOSE(IOUT)
      IERR = 1
      GO TO 700
C ------------
900   CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file')
      CLOSE(IN)
      IERR = 1
      RETURN
      END

      SUBROUTINE CALC_CENTRE_RAD(MDOC,ISTART,IFINISH
     *   ,XA,YA,ZA,NATOM,XC,YC,ZC,RAD,IERR)
C ---------------------------------------------
      REAL      XA(NATOM),YA(NATOM),ZA(NATOM)
      CHARACTER LINE*256
C ---------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      XC  = 0.0
      YC  = 0.0
      ZC  = 0.0
      RAD = 0.0
C ---
      RI   = 0.0
      NTOT = 0 
      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.
      DO I=ISTART,IFINISH
        XS   = XS+XA(I)
        YS   = YS+YA(I)
        ZS   = ZS+ZA(I)
        XS2  = XS2+XA(I)*XA(I)
        YS2  = YS2+YA(I)*YA(I)
        ZS2  = ZS2+ZA(I)*ZA(I)
        NTOT = NTOT+1
      ENDDO
      XS  = XS/NTOT
      YS  = YS/NTOT
      ZS  = ZS/NTOT
      XS2 = XS2/NTOT
      YS2 = YS2/NTOT
      ZS2 = ZS2/NTOT
      RX  = XS2-XS*XS
      RY  = YS2-YS*YS
      RZ  = ZS2-ZS*ZS
      RAD = SQRT(ABS(RX+RY+RZ))
      IF(RAD.LT.3.0) RAD = 3.0
      XC  = XS
      YC  = YS
      ZC  = ZS
C ---
      RETURN
      END

      SUBROUTINE CHECK_ALL_CHAIN(MDOC,FILE_PDB,NATOM,NSEGMENT
     *   ,XA,YA,ZA,OCC,BISO,PNUM,SEG
     *   ,FRAG_NATOM,FRAG_INDEX,FRAG_IORDER
     *   ,FRAG_ISTART,FRAG_IFINISH
     *   ,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *   ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD
     *   ,FRAG_SEG
     *   ,PATH_OUT,PATH_SCR,IERR)
C ---------------------------------------------
      CHARACTER FILE_PDB*(*),PATH_SCR*(*),PATH_OUT*(*)
C ---
      CHARACTER PNUM(NATOM)*7,SEG(NATOM)*4
      REAL      XA(NATOM),YA(NATOM),ZA(NATOM),OCC(NATOM),BISO(NATOM)
C ---
      INTEGER   FRAG_NATOM(NSEGMENT),FRAG_INDEX(NSEGMENT)
      INTEGER   FRAG_IORDER(NSEGMENT)
      INTEGER   FRAG_ISTART(NSEGMENT),FRAG_IFINISH(NSEGMENT)
      INTEGER   FRAG_RES_ISTART(NSEGMENT),FRAG_RES_IFINISH(NSEGMENT)
      REAL      FRAG_XSTART(3,NSEGMENT),FRAG_XFINISH(3,NSEGMENT)
      REAL      FRAG_XCENTRE(3,NSEGMENT),FRAG_RAD(NSEGMENT)
      CHARACTER FRAG_SEG(NSEGMENT)*4     
C ---
      character(LEN=1), allocatable :: CHAIN_ORIGIN_ID(:)
C ---
      CHARACTER CHAIN_INP*1,PATH*1,FILE_OUT*256
      CHARACTER STR_TITLE*40,STR_DATE*9
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
c ---
      INCLUDE 'nsym-max.fh'
c ---
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER CHAIN_TEST*1
      CHARACTER LINE*256
C -----------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
C     read ISYM
      FILE_OUT = 'temp.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_OUT,LLL)
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_SCR(1:LEN)//FILE_OUT(1:LLL)
      ENDIF
      PATH = ' '
      CHAIN_INP = ' '
      CALL READPDB(M,FILE_PDB,FILE_OUT,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CHAIN_INP,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in READPDB') 
        RETURN
      ENDIF
      IN = 10
      CALL ORCRD(M,IN,FILE_OUT,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: OPEN INPUT_FILE_1')
        RETURN
      ENDIF
      CLOSE(IN) 
      CALL C_AT_CR
      DO I=1,3
      DO J=1,3
        ORT_TO_FRAC(I,J) = CR_ORT_TO_FRAC(I,J)
        FRAC_TO_ORT(I,J) = CR_FRAC_TO_ORT(I,J)
      ENDDO
      ENDDO
C ---
      allocate(CHAIN_ORIGIN_ID(1:NSEGMENT),STAT=ISTAT)
C ---
      N_CHAIN_ORIGIN     = 1
      CHAIN_ORIGIN_ID(1) =  FRAG_SEG(1)(2:2)     
      IF(NSEGMENT.GT.1) THEN
        DO IF=2,NSEGMENT
          DO IC=1,N_CHAIN_ORIGIN
            IF(FRAG_SEG(IF)(2:2).NE.CHAIN_ORIGIN_ID(IC)) THEN
              N_CHAIN_ORIGIN = N_CHAIN_ORIGIN + 1
              IF(N_CHAIN_ORIGIN.GT.NSEGMENT) THEN
                CALL MSGERR(MDOC,'ERROR: N_CHAIN_ORIGIN > Nseg_alloc')
                IERR = 1
                GO TO 900
              ENDIF
              CHAIN_ORIGIN_ID(N_CHAIN_ORIGIN) = FRAG_SEG(IF)(2:2)
              GO TO 100
            ENDIF
          ENDDO
  100     CONTINUE
        ENDDO
      ENDIF
C ---
      DO IC=1,N_CHAIN_ORIGIN
        CHAIN_TEST = CHAIN_ORIGIN_ID(IC)
        CALL CHECK_ONE_CHAIN(MDOC,IC,NATOM,NSEGMENT,CHAIN_TEST
     *   ,XA,YA,ZA,OCC,BISO,PNUM,SEG
     *   ,FRAG_NATOM,FRAG_INDEX,FRAG_IORDER
     *   ,FRAG_ISTART,FRAG_IFINISH
     *   ,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *   ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD
     *   ,FRAG_SEG
     *   ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in CHECK_ONE_CHAIN') 
          GO TO 900
        ENDIF
      ENDDO
C ---
  900 CONTINUE
      deallocate(CHAIN_ORIGIN_ID,STAT=ISTAT)
C ----
      RETURN
      END

      SUBROUTINE CHECK_ONE_CHAIN(MDOC,ICH,NATOM,NSEGMENT,CHAIN_TEST
     *   ,XA,YA,ZA,OCC,BISO,PNUM,SEG
     *   ,FRAG_NATOM,FRAG_INDEX,FRAG_IORDER
     *   ,FRAG_ISTART,FRAG_IFINISH
     *   ,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *   ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD
     *   ,FRAG_SEG
     *   ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------
C ---
      CHARACTER PNUM(NATOM)*7,SEG(NATOM)*4
      REAL      XA(NATOM),YA(NATOM),ZA(NATOM),OCC(NATOM),BISO(NATOM)
C ---
      INTEGER   FRAG_NATOM(NSEGMENT),FRAG_INDEX(NSEGMENT)
      INTEGER   FRAG_IORDER(NSEGMENT)
      INTEGER   FRAG_ISTART(NSEGMENT),FRAG_IFINISH(NSEGMENT)
      INTEGER   FRAG_RES_ISTART(NSEGMENT),FRAG_RES_IFINISH(NSEGMENT)
      REAL      FRAG_XSTART(3,NSEGMENT),FRAG_XFINISH(3,NSEGMENT)
      REAL      FRAG_XCENTRE(3,NSEGMENT),FRAG_RAD(NSEGMENT)
      CHARACTER FRAG_SEG(NSEGMENT)*4     
C ---
      integer,  allocatable :: CHAIN_FINAL_IS(:)
      integer,  allocatable :: CHAIN_FINAL_IF(:)
      character(LEN=2), allocatable :: CHAIN_FINAL_ID(:)
      integer,  allocatable :: FRAG_POINTER(:)
      character(LEN=3), allocatable :: FRAG_LIST_ID(:)
c ---
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER CHAIN_TEST*1
      CHARACTER LINE*256
      REAL      AMAT(3,3),TRANS(3)
      REAL      AMAT_MIN(3,3),TRANS_MIN(3)
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      allocate(CHAIN_FINAL_IS(1:NSEGMENT),STAT=ISTAT)
      allocate(CHAIN_FINAL_IF(1:NSEGMENT),STAT=ISTAT)
      allocate(CHAIN_FINAL_ID(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_POINTER(1:NSEGMENT),STAT=ISTAT)
      allocate(FRAG_LIST_ID(1:NSEGMENT),STAT=ISTAT)
C ---
      ISTEP = 0

  500 CONTINUE

      ISTEP = ISTEP + 1

      N_CHAIN_FINAL = 0
      DO IF=1,NSEGMENT
        IF(FRAG_SEG(IF)(2:2).NE.CHAIN_TEST) GO TO 100
        IF(N_CHAIN_FINAL.GT.0) THEN
          DO IC=1,N_CHAIN_FINAL
            IF(FRAG_SEG(IF)(1:2).EQ.CHAIN_FINAL_ID(IC)) THEN
              GO TO 100
            ENDIF
          ENDDO
        ENDIF
c        GO TO 100
  110   CONTINUE
        N_CHAIN_FINAL = N_CHAIN_FINAL + 1
        IF(N_CHAIN_FINAL.GT.NSEGMENT) THEN
          CALL MSGERR(MDOC,'ERROR: N_CHAIN_FINAL > Nseg_alloc')
          IERR = 1
          GO TO 900
        ENDIF
        
        CHAIN_FINAL_ID(N_CHAIN_FINAL) = FRAG_SEG(IF)(1:2)
        CHAIN_FINAL_IS(N_CHAIN_FINAL) = 0      
        CHAIN_FINAL_IF(N_CHAIN_FINAL) = 0      

  100   CONTINUE
      ENDDO
C ---
      IF(N_CHAIN_FINAL.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N_CHAIN_FINAL = 0') 
        IERR = 1
        GO TO 900
      ENDIF
C ---
      N_FRAG_LIST = 0
  
      DO IC=1,N_CHAIN_FINAL
        IFIRST = 0
        DO IF=1,NSEGMENT
          IF(FRAG_SEG(IF)(1:2).NE.CHAIN_FINAL_ID(IC)) GO TO 200
          N_FRAG_LIST = N_FRAG_LIST + 1
          IF(N_FRAG_LIST.GT.NSEGMENT) THEN
            CALL MSGERR(MDOC,'ERROR: N_FRAG_LIST > Nseg_alloc')
            IERR = 1
            GO TO 900
          ENDIF
          FRAG_LIST_ID(N_FRAG_LIST) = FRAG_SEG(IF)(1:3)
          FRAG_POINTER(N_FRAG_LIST) = IF

          IF(IFIRST.LE.0) THEN
            CHAIN_FINAL_IS(IC) = N_FRAG_LIST      
            IFIRST = 1
          ENDIF
          CHAIN_FINAL_IF(IC) = N_FRAG_LIST      

  200     CONTINUE
        ENDDO
      ENDDO
C ---
      IF(N_FRAG_LIST.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N_FRAG_LIST = 0') 
        IERR = 1
        GO TO 900
      ENDIF

c      WRITE(LINE,*) '--N_C_F:',N_CHAIN_FINAL
c      CALL MSGDOC(MDOC,LINE) 
c      DO I=1,N_CHAIN_FINAL
c        WRITE(LINE,*) '==',I,'<',CHAIN_FINAL_ID(I),'>',
c     *  CHAIN_FINAL_IS(I),CHAIN_FINAL_IF(I)
c        CALL MSGDOC(MDOC,LINE) 
c      ENDDO
c      WRITE(LINE,*) '--N_F_L:',N_FRAG_LIST
c      CALL MSGDOC(MDOC,LINE) 
c      DO I=1,N_FRAG_LIST
c        WRITE(LINE,*) '--',I,'<',FRAG_LIST_ID(I),'>',FRAG_POINTER(I)
c        CALL MSGDOC(MDOC,LINE) 
c      ENDDO
c      WRITE(LINE,*) '--NSEG:',NSEGMENT
c      CALL MSGDOC(MDOC,LINE) 
c      DO I=1,NSEGMENT
c        WRITE(LINE,*) '--',I,'<',FRAG_SEG(I),'>',FRAG_NATOM(I)
c     *  ,FRAG_RES_ISTART(I),FRAG_RES_IFINISH(I),FRAG_RAD(I)
c        CALL MSGDOC(MDOC,LINE) 
c      ENDDO

      IF(N_CHAIN_FINAL.LE.1) GO TO 800
C ---
C     check all pair in CHAIN_FINAL (IFOUND = 1 there was some change)      
      IFOUND_MIN = 0
      I1_MIN = 0
      I2_MIN = 0
      DIST_MIN = 1.0E30
      DO I1=1,N_CHAIN_FINAL-1
        DO I2=I1+1,N_CHAIN_FINAL
          IFOUND = 0
          CALL CHECK_PAIR(MDOC,NSEGMENT,IFOUND
     *     ,CHAIN_FINAL_IS(I1),CHAIN_FINAL_IF(I1)     
     *     ,CHAIN_FINAL_IS(I2),CHAIN_FINAL_IF(I2)     
     *     ,FRAG_LIST_ID,FRAG_POINTER
     *     ,FRAG_NATOM,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *     ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD,FRAG_SEG
     *     ,DIST,AMAT,TRANS
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in CHECK_PAIR') 
            GO TO 900
          ENDIF
          IF(IFOUND.GT.0) THEN
            IFOUND_MIN = 1
            IF(DIST.LT.DIST_MIN) THEN
              DIST_MIN = DIST
              I1_MIN = I1
              I2_MIN = I2
              DO II=1,3
                TRANS_MIN(II) = TRANS(II)
                DO JJ=1,3
                  AMAT_MIN(II,JJ) = AMAT(II,JJ)
                ENDDO
              ENDDO
            ENDIF
          ENDIF
        ENDDO
      ENDDO

      IF(IFOUND_MIN.GT.0) THEN

        WRITE(LINE,'(I5,A,A,A,A,A,F8.2)') 
     *    ISTEP,' change:>',CHAIN_FINAL_ID(I2_MIN),'> -->'
     *    ,CHAIN_FINAL_ID(I1_MIN),'<',DIST_MIN
        CALL MSGDOC(MDOC,LINE) 

        CALL CHANGE_CHAIN_FINAL(MDOC,NSEGMENT,NATOM
     *     ,CHAIN_FINAL_ID(I1_MIN)
     *     ,CHAIN_FINAL_IS(I2_MIN),CHAIN_FINAL_IF(I2_MIN)     
     *     ,FRAG_LIST_ID,FRAG_POINTER
     *     ,XA,YA,ZA,PNUM,SEG
     *     ,FRAG_NATOM,FRAG_ISTART,FRAG_IFINISH
     *     ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD,FRAG_SEG
     *     ,AMAT_MIN,TRANS_MIN,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in CHANGE_CHAIN_FINAL') 
          GO TO 900
        ENDIF
        GO TO 500
      ENDIF
C ---
  800 CONTINUE

C     iorder for these final chains

      DO ICHF=1,N_CHAIN_FINAL
        CALL DEFINE_ORDER(MDOC,NSEGMENT
     *     ,ICH,ICHF
     *     ,CHAIN_FINAL_IS(ICHF),CHAIN_FINAL_IF(ICHF) 
     *     ,FRAG_POINTER,FRAG_INDEX
     *     ,FRAG_RES_ISTART,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in DEFINE_ORDER') 
          GO TO 900
        ENDIF
      ENDDO

  900 CONTINUE
      deallocate(CHAIN_FINAL_IS,STAT=ISTAT)
      deallocate(CHAIN_FINAL_IF,STAT=ISTAT)
      deallocate(CHAIN_FINAL_ID,STAT=ISTAT)
      deallocate(FRAG_POINTER,STAT=ISTAT)
      deallocate(FRAG_LIST_ID,STAT=ISTAT)
C ----
      RETURN
      END

      SUBROUTINE DEFINE_ORDER(MDOC,NSEGMENT
     *     ,ICH,ICHF
     *     ,IS,IF
     *     ,FRAG_POINTER,FRAG_INDEX
     *     ,FRAG_RES_ISTART,IERR)
C -----------------------------------------------
      INTEGER   FRAG_POINTER(NSEGMENT)
      INTEGER   FRAG_INDEX(NSEGMENT)
      INTEGER   FRAG_RES_ISTART(NSEGMENT)
C ----
      CHARACTER LINE*256
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      DO IC=IS,IF
        I  = FRAG_POINTER(IC)
        IR = FRAG_RES_ISTART(I) 
        FRAG_INDEX(I) = (ICH*500 +ICHF)*10000 + (IR + 100)
      ENDDO

      RETURN
      END

      SUBROUTINE CHANGE_CHAIN_FINAL(MDOC,NSEGMENT,NATOM
     *     ,CHAIN_ID,IS,IF
     *     ,FRAG_LIST_ID,FRAG_POINTER
     *     ,XA,YA,ZA,PNUM,SEG
     *     ,FRAG_NATOM,FRAG_ISTART,FRAG_IFINISH
     *     ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD,FRAG_SEG
     *     ,AMAT,TRANS,IERR)
C -----------------------------------------------
      INTEGER   FRAG_POINTER(NSEGMENT)
      CHARACTER FRAG_LIST_ID(NSEGMENT)*3    
      CHARACTER PNUM(NATOM)*7,SEG(NATOM)*4
      REAL      XA(NATOM),YA(NATOM),ZA(NATOM),OCC(NATOM),BISO(NATOM)
      INTEGER   FRAG_NATOM(NSEGMENT)
      INTEGER   FRAG_ISTART(NSEGMENT),FRAG_IFINISH(NSEGMENT)
      REAL      FRAG_XSTART(3,NSEGMENT),FRAG_XFINISH(3,NSEGMENT)
      REAL      FRAG_XCENTRE(3,NSEGMENT),FRAG_RAD(NSEGMENT)
      CHARACTER FRAG_SEG(NSEGMENT)*4
      CHARACTER CHAIN_ID*2    
C ---
      REAL      AMAT(3,3),TRANS(3),X(3),Y(3)
C ---
      CHARACTER LINE*256
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      DO IC=IS,IF
        I    = FRAG_POINTER(IC) 
        FRAG_SEG(I)(1:1) = CHAIN_ID(1:1)
        X(1) = FRAG_XSTART(1,I)
        X(2) = FRAG_XSTART(2,I)
        X(3) = FRAG_XSTART(3,I)
        CALL MVMULT(AMAT,X,Y)
        Y(1) = Y(1) + TRANS(1)
        Y(2) = Y(2) + TRANS(2)
        Y(3) = Y(3) + TRANS(3)
        FRAG_XSTART(1,I) = Y(1)
        FRAG_XSTART(2,I) = Y(2) 
        FRAG_XSTART(3,I) = Y(3)
        X(1) = FRAG_XFINISH(1,I)
        X(2) = FRAG_XFINISH(2,I)
        X(3) = FRAG_XFINISH(3,I)
        CALL MVMULT(AMAT,X,Y)
        Y(1) = Y(1) + TRANS(1)
        Y(2) = Y(2) + TRANS(2)
        Y(3) = Y(3) + TRANS(3)
        FRAG_XFINISH(1,I) = Y(1)
        FRAG_XFINISH(2,I) = Y(2) 
        FRAG_XFINISH(3,I) = Y(3)
        X(1) = FRAG_XCENTRE(1,I)
        X(2) = FRAG_XCENTRE(2,I)
        X(3) = FRAG_XCENTRE(3,I)
        CALL MVMULT(AMAT,X,Y)
        Y(1) = Y(1) + TRANS(1)
        Y(2) = Y(2) + TRANS(2)
        Y(3) = Y(3) + TRANS(3)
        FRAG_XCENTRE(1,I) = Y(1)
        FRAG_XCENTRE(2,I) = Y(2) 
        FRAG_XCENTRE(3,I) = Y(3)
        IAS = FRAG_ISTART(I)
        IAF = FRAG_IFINISH(I)
        DO IA=IAS,IAF
          PNUM(IA)(2:2) = CHAIN_ID(1:1)
          SEG(IA)(1:1)  = CHAIN_ID(1:1)
          X(1) = XA(IA)
          X(2) = YA(IA)
          X(3) = ZA(IA)
          CALL MVMULT(AMAT,X,Y)
          Y(1) = Y(1) + TRANS(1)
          Y(2) = Y(2) + TRANS(2)
          Y(3) = Y(3) + TRANS(3)
          XA(IA) = Y(1)
          YA(IA) = Y(2) 
          ZA(IA) = Y(3)
        ENDDO
      ENDDO
C ---
  900 CONTINUE
C ----
      RETURN
      END

      SUBROUTINE CHECK_PAIR(MDOC,NSEGMENT,IFOUND_MIN
     *     ,IS1,IF1,IS2,IF2     
     *     ,FRAG_LIST_ID,FRAG_POINTER
     *     ,FRAG_NATOM,FRAG_RES_ISTART,FRAG_RES_IFINISH
     *     ,FRAG_XSTART,FRAG_XFINISH,FRAG_XCENTRE,FRAG_RAD,FRAG_SEG
     *     ,DIST_MIN,AMAT_MIN,TRANS_MIN
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------
      INTEGER   FRAG_NATOM(NSEGMENT)
      INTEGER   FRAG_RES_ISTART(NSEGMENT),FRAG_RES_IFINISH(NSEGMENT)
      REAL      FRAG_XSTART(3,NSEGMENT),FRAG_XFINISH(3,NSEGMENT)
      REAL      FRAG_XCENTRE(3,NSEGMENT),FRAG_RAD(NSEGMENT)
      CHARACTER FRAG_SEG(NSEGMENT)*4     
      INTEGER   FRAG_POINTER(NSEGMENT)
      CHARACTER FRAG_LIST_ID(NSEGMENT)*3    
C ---
      REAL      AMAT(3,3),TRANS(3)
      REAL      AMAT_MIN(3,3),TRANS_MIN(3)
      REAL      XS1(3),XF1(3),XC1(3),XS2(3),XF2(3),XC2(3)
C ---
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER LINE*256
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      IFOUND_MIN = 0
      DIST_MIN   = 1.0E30
      DO I=1,3
        TRANS_MIN(I) = 0.0
        DO J=1,3
          AMAT_MIN(I,J) = 0.0
          IF(I.EQ.J) AMAT_MIN(I,J) = 1.0
        ENDDO
      ENDDO
C ---
C     check overlap
      DO IC1=IS1,IF1
        I1   = FRAG_POINTER(IC1) 
        IRS1 = FRAG_RES_ISTART(I1)
        IRF1 = FRAG_RES_IFINISH(I1)
        DO IC2=IS2,IF2
          I2   = FRAG_POINTER(IC2) 
          IRS2 = FRAG_RES_ISTART(I2)
          IRF2 = FRAG_RES_IFINISH(I2)
          IF((IRS1.LT.IRS2.AND.IRS1.LT.IRF2.AND. 
     *        IRF1.LT.IRS2.AND.IRF1.LT.IRF2     ).OR. 
     *       (IRS1.GT.IRS2.AND.IRS1.GT.IRF2.AND. 
     *        IRF1.GT.IRS2.AND.IRF1.GT.IRF2     )    ) THEN
          ELSE
C           overlap
            GO TO 900
          ENDIF 
        ENDDO
      ENDDO
C ---
C     check distance
      DO IC1=IS1,IF1
        I1 = FRAG_POINTER(IC1) 
        DO IC2=IS2,IF2
          I2   = FRAG_POINTER(IC2) 
          IFOUND = 0
          XS1(1) = FRAG_XSTART(1,I1)
          XS1(2) = FRAG_XSTART(2,I1)
          XS1(3) = FRAG_XSTART(3,I1)
          XF1(1) = FRAG_XFINISH(1,I1)
          XF1(2) = FRAG_XFINISH(2,I1)
          XF1(3) = FRAG_XFINISH(3,I1)
          XC1(1) = FRAG_XCENTRE(1,I1)
          XC1(2) = FRAG_XCENTRE(3,I1)
          XC1(3) = FRAG_XCENTRE(3,I1)
          XS2(1) = FRAG_XSTART(1,I2)
          XS2(2) = FRAG_XSTART(2,I2)
          XS2(3) = FRAG_XSTART(3,I2)
          XF2(1) = FRAG_XFINISH(1,I2)
          XF2(2) = FRAG_XFINISH(2,I2)
          XF2(3) = FRAG_XFINISH(3,I2)
          XC2(1) = FRAG_XCENTRE(1,I2)
          XC2(2) = FRAG_XCENTRE(3,I2)
          XC2(3) = FRAG_XCENTRE(3,I2)
   
          CALL CHECK_DISTANCE(MDOC,IFOUND
     *     ,FRAG_NATOM(I1),XS1,XF1,XC1,FRAG_RAD(I1)
     *     ,FRAG_NATOM(I2),XS2,XF2,XC2,FRAG_RAD(I2)
     *     ,DIST,AMAT,TRANS
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in CHECK_DISTANCE') 
            GO TO 900
          ENDIF
          IF(DIST.LT.DIST_MIN) THEN
            IFOUND_MIN = 1
            DIST_MIN = DIST
            DO II=1,3
              TRANS_MIN(II) = TRANS(II)
              DO JJ=1,3
                AMAT_MIN(II,JJ) = AMAT(II,JJ)
              ENDDO
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C ---
  900 CONTINUE
C ----
      RETURN
      END

      SUBROUTINE CHECK_DISTANCE(MDOC,IFOUND
     *     ,NATOM1,XS1,XF1,XC1,RAD1
     *     ,NATOM2,XS2,XF2,XC2,RAD2
     *     ,DIST_MIN,AMAT,TRANS
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------
      INTEGER   NATOM1,NATOM2
      REAL      RAD1,RAD2     
C ---
      REAL      AMAT(3,3),TRANS(3)
      REAL      AM1(3,3),TR1(3),AM2(3,3),TR2(3),AM3(3,3),TR3(3)
      REAL      XS1(3),XF1(3),XC1(3),XS2(3),XF2(3),XC2(3)
C ---
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER LINE*256
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      IFOUND   = 0
      DIST_MIN = 1.0E30

c      DIST_LIM = 8.0
      DIST_LIM = 12.0
      DIST_LIM_CENTRE = (RAD1 + RAD2)*1.1
C ---
C     check ifinish1 = istart2
      CALL CHECK_COORD(MDOC
     *     ,XF1,XS2,DIST1,AM1,TR1
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
      IF(DIST1.LT.DIST_LIM) THEN
        IFOUND = 1
        DIST_MIN = DIST1
        DO II=1,3
          TRANS(II) = TR1(II)
          DO JJ=1,3
            AMAT(II,JJ) = AM1(II,JJ)
          ENDDO
       ENDDO
      ENDIF
C     check ifinish2 = istart1 
      CALL CHECK_COORD(MDOC
     *     ,XS1,XF2,DIST2,AM2,TR2
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
      IF(DIST2.LT.DIST_MIN.AND.DIST2.LT.DIST_LIM) THEN
        IFOUND = 1
        DIST_MIN = DIST2
        DO II=1,3
          TRANS(II) = TR2(II)
          DO JJ=1,3
            AMAT(II,JJ) = AM2(II,JJ)
          ENDDO
       ENDDO
      ENDIF
C     check icentre
      CALL CHECK_COORD(MDOC
     *     ,XC1,XC2,DIST3,AM3,TR3
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
      IF(IFOUND.LE.0.AND.DIST3.LT.DIST_LIM_CENTRE) THEN
        IFOUND = 1
        DIST_MIN = DIST3
        DO II=1,3
          TRANS(II) = TR3(II)
          DO JJ=1,3
            AMAT(II,JJ) = AM3(II,JJ)
          ENDDO
       ENDDO
      ENDIF
C ---
  900 CONTINUE
C ----
      RETURN
      END

      SUBROUTINE CHECK_COORD(MDOC
     *     ,X1,X2,DIST_MIN,AMAT,TRANS
     *     ,ORT_TO_FRAC,FRAC_TO_ORT,NSYM,ISYM,IPRSYM,IERR)
C -----------------------------------------------
      INTEGER   NATOM1,NATOM3
      REAL      RAD1,RAD2     
C ---
      REAL      AMAT(3,3),TRANS(3)
      REAL      X1(3),X2(3),Y1(3),Y2(3),Z2(3),TS_MIN(3)
      REAL      AM(3,3),SM(3,3),TS(3),T(3),S(3),TT(3)
      REAL      CM(3,3)
C ---
      REAL      ORT_TO_FRAC(3,3),FRAC_TO_ORT(3,3)
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER LINE*256
C -----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      IS_MIN   = 0
      DIST_MIN = 1.0E30
C ---
      CALL MVMULT(ORT_TO_FRAC,X1,Y1)
      CALL MVMULT(ORT_TO_FRAC,X2,Y2)

      DO IS=1,NSYM
        SM(1,1) = REAL(ISYM(1,1,IS))
        SM(2,1) = REAL(ISYM(2,1,IS))
        SM(3,1) = REAL(ISYM(3,1,IS))
        SM(1,2) = REAL(ISYM(1,2,IS))
        SM(2,2) = REAL(ISYM(2,2,IS))
        SM(3,2) = REAL(ISYM(3,2,IS))
        SM(1,3) = REAL(ISYM(1,3,IS))
        SM(2,3) = REAL(ISYM(2,3,IS))
        SM(3,3) = REAL(ISYM(3,3,IS))
        TS(1) = REAL(ISYM(4,1,IS))/REAL(ISYM(5,1,IS)) 
        TS(2) = REAL(ISYM(4,2,IS))/REAL(ISYM(5,2,IS)) 
        TS(3) = REAL(ISYM(4,3,IS))/REAL(ISYM(5,3,IS))

        CALL MVMULT(SM,Y2,Z2)

        Z2(1) = Z2(1) + TS(1)
        Z2(2) = Z2(2) + TS(2)
        Z2(3) = Z2(3) + TS(3)
        T(1) = Z2(1) - Y1(1)
        T(2) = Z2(2) - Y1(2)
        T(3) = Z2(3) - Y1(3)
        CALL DEF_CRYST_TRANS(T,S)
        CALL MVMULT(FRAC_TO_ORT,T,TT)
        DIST = TT(1)*TT(1)+TT(2)*TT(2)+TT(3)*TT(3)
        DIST = SQRT(DIST)
        IF(DIST.LT.DIST_MIN) THEN
          IS_MIN   = IS
          DIST_MIN = DIST
          TS_MIN(1) = TS(1) + S(1)
          TS_MIN(2) = TS(2) + S(2)
          TS_MIN(3) = TS(3) + S(3)
        ENDIF
      ENDDO
      SM(1,1) = REAL(ISYM(1,1,IS_MIN))
      SM(2,1) = REAL(ISYM(2,1,IS_MIN))
      SM(3,1) = REAL(ISYM(3,1,IS_MIN))
      SM(1,2) = REAL(ISYM(1,2,IS_MIN))
      SM(2,2) = REAL(ISYM(2,2,IS_MIN))
      SM(3,2) = REAL(ISYM(3,2,IS_MIN))
      SM(1,3) = REAL(ISYM(1,3,IS_MIN))
      SM(2,3) = REAL(ISYM(2,3,IS_MIN))
      SM(3,3) = REAL(ISYM(3,3,IS_MIN))
      CALL MATMLT(SM,ORT_TO_FRAC,AM)
      CALL MATMLT(FRAC_TO_ORT,AM,AMAT)
      CALL MVMULT(FRAC_TO_ORT,TS_MIN,TRANS)
C ---
  900 CONTINUE
C ----
      RETURN
      END

      SUBROUTINE DEF_CRYST_TRANS(XX,S)
C ----------------------------------------
      REAL  XX(3),S(3)
C ----------------------------------------
      S(1) = 0.0
      S(2) = 0.0
      S(3) = 0.0
 10   CONTINUE
      IF(XX(1).GT.0.5)THEN
        XX(1)=XX(1)-1.0
        S(1) = S(1) - 1.0
        GO TO 10
      ENDIF
 20   CONTINUE
      IF(XX(1).LE.-0.5)THEN
        XX(1)=XX(1)+1.0
        S(1) = S(1) + 1.0
        GO TO 20
      ENDIF
 30   CONTINUE
      IF(XX(2).GT.0.5)THEN
        XX(2)=XX(2)-1.0
        S(2) = S(2) - 1.0
        GO TO 30
      ENDIF
 40   CONTINUE
      IF(XX(2).LE.-0.5)THEN
        XX(2)=XX(2)+1.0
        S(2) = S(2) + 1.0
        GO TO 40
      ENDIF
 50   CONTINUE
      IF(XX(3).GT.0.5)THEN
        XX(3)=XX(3)-1.0
        S(3) = S(3) - 1.0
        GO TO 50
      ENDIF
 60   CONTINUE
      IF(XX(3).LE.-0.5)THEN
        XX(3)=XX(3)+1.0
        S(3) = S(3) + 1.0
        GO TO 60
      ENDIF
C ---
      RETURN
      END
