C --- F2CIF.F ---
C F2CIF    writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C          to one output formatted CIFile. The exit from program suite BLANC.
C -------------
      INCLUDE 'nsym-max.fh'
C     PARAMETER ( IPRSYM = 48 )
      INTEGER*2 ISYM(5,3,IPRSYM)
C -------------
      PARAMETER ( IPRROW = 21 )
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*256,F2_NAME*256,PH_NAME*256,FO_NAME*256
      CHARACTER LINE*256,ITYP*4,CFOM*1,CFREE*1,CSIG*1
      CHARACTER PATH_OUT*256
C ===========================
C     START - initialization common/COMLIB/,/CRYSTL/,.., open DOC-file.
C
      MDOC = 1
      CALL START(0,MDOC,'f2cif',PATH_OUT)
C ---------------------------
C     MSGDOC - writes message to terminal or/and DOC_FILE
C
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '    ---- F to CIF ----    /V.22.05.99/ ')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
  100 CONTINUE
      MD = 0
      CALL MSGDOC(MD,'Input file Fobs')
      LINE='FILE_F'
      CALL ASK(LINE)
      F_NAME=LINE
      CALL CORR_NAME_BL(F_NAME)
C --
      MT1  = 10
      ITYP = 'FF  '
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
C
C       MSGERR - writes message about error to terminal or/and DOC_FILE
C
        CALL MSGERR(MD,' ERROR: can not open file Fobs')
        GO TO 100
      ENDIF
      CLOSE(MT1)
C -----------------------------------------------------------------
C     list of possible keywords
C
      MD     = 0
      RESMIN = 0.0
      RESMAX = 0.0

      CALL MSGDOC(MDOC,' ')
      CALL SET_DEFAULT(
     *'FILE_C:  < >   - input_file_Fcalc /" " means without file_C/')
      CALL SET_DEFAULT(
     *'FILE_PH: < >   - input_file_phases /" " means without file_PH/')
      CALL SET_DEFAULT(
     *'RESOL: MIN,MAX - resolution <default from files>')
      CALL SET_DEFAULT(
     *'FOM:   <Y>,N   - Y means to write FOM')
      CALL SET_DEFAULT(
     *'FREE:  <N>,Y,I - Y means to write FREE-flag, I new 5%')
      CALL SET_DEFAULT(
     *'SIG:   <Y>,N   - Y means to write sigmas of F')
      CALL SET_DEFAULT(
     *'FILE_O: <f2cif.cif> - output_file')
C ---
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------
C
C     read keywords
C 
      LINE='FILE_C'
      CALL ASK(LINE)
      F2_NAME=LINE
      CALL CORR_NAME_BL(F2_NAME)
C ----
      LINE='FILE_O'
      CALL ASK(LINE)
      FO_NAME=LINE
      IF(LINE(1:1).EQ.',') FO_NAME = 'f2cif.cif'
      CALL CORR_NAME_BL(FO_NAME)
C ----
      LINE='FILE_PH'
      CALL ASK(LINE)
      PH_NAME=LINE
      CALL CORR_NAME_BL(PH_NAME)
C ----
      LINE='RESOL'
      CALL ASK(LINE)
      READ(LINE,*)    RESMIN,RESMAX
C ----
      LINE ='FOM'
      CALL ASK(LINE)
      CFOM = LINE(1:1)
      LINE ='SIG'
      CALL ASK(LINE)
      CSIG = LINE(1:1)
      LINE ='FREE'
      CALL ASK(LINE)
      CFREE = LINE(1:1)
C ---------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *    ,CFOM,CFREE,CSIG
     *    ,RESMIN,RESMAX,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ---------------------------
C     FINISH - close DOC-file and EXIT.
C
      CALL FINISH
      END

      SUBROUTINE F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
     *        ,CFOM,CFREE,CSIG
     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C ----------------------------------------------------
C -P- 
C F2CIF    writes a contents of internal BLANC files: Fobs, Fcalc, Phases 
C          to one output formatted CIFile. The exit from program suite BLANC.
C -S-
C          This program reads contents of files: 
C                 Fobs              or  
C                 Fobs and Fcalc    or
C                 Fobs and Phases   or  
C                 Fobs and Fcalc and Phases
C          and writes to one formatted output file ( format CIF). 
C
C   Dialogue and Batch:
C  
C     FILE_F:  - input file_Fobs  of the modules of structure factors.
C     FILE_C:  - input file_Fcalc of the modules of structure factors.
C     FILE_PH: - input file_Phases.
C     RESOL: MIN,MAX - resolution <default from files>
C     FOM:   <Y>,N   - Y means to write FOM'
C     FREE:  <Y>,N   - Y means to write FREE-flag'
C     SIG:   <Y>,N   - Y means to write sigmas of F'
C     FILE_O: <f2cif.cif> - output_file 
C
C  Parameters of subroutine F2CIF: 
C
C      SUBROUTINE F2CIF(MDOC,F_NAME,F2_NAME,PH_NAME,FO_NAME
C     *        ,CFOM,CFREE,CSIG
C     *        ,RESMINR,RESMAXR,ISYM,IPRSYM,RESULT,IPRROW,IERR)
C
C    MDOC   - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    F_NAME:  - input file_Fobs  of the modules of structure factors.
C    F2_NAME: - input file_Fcalc of the modules of structure factors.
C    PH_NAME: - input file_Phases.
C    RESMINR: - resolution <default from files>
C    RESMAXR:  
C    CFOM:  /character*1/ <Y>,N   - Y means to write FOM'
C    CFREE: /character*1/ <Y>,N   - Y means to write FREE-flag'
C    CSIG:  /character*1/ <Y>,N   - Y means to write sigmas of F'
C    FO_NAME:        - output_file /" " means without output/
C    ISYM     - integer*2 array for cryst.symmetry operators.
C    IPRSYM   - dimension of integer*2 array ISYM(5,3,IPRSYM),
C               number of cryst. symm. operators.
C    IERR     - output signal of error / = 1 -error , = 0 - OK / 
C
C    RESULT /real RESULT(IPRROW)/ - array for output information:
C
C    RESULT(1) - 
C    RESULT(2) - 
C -I-
C ------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
      INTEGER*4 MDOC,IERR
      CHARACTER F_NAME*(*),F2_NAME*(*),PH_NAME*(*),FO_NAME*(*),CFOM*1
      CHARACTER STAT*1,CFREE*1,CSIG*1
C ==============================
      REAL      RLATT(6)
      INTEGER*4 MTIN,MTNAT,MTOUT
      CHARACTER ITYPE*4,ITYP*4,ITF1*4,ITF2*4,ITF3*4,ITFW*4
      CHARACTER LINE*80,TTT*80,TTT1*80,TITLE*80,PATH*256,EXT*80
      CHARACTER LINE1*80
C -----------------------------------------------------------
      M    = 99
      MD   =-ABS(MDOC)-1
      IERR = 0
C
C     ITYP  ='FF  '  means 'F   ' or 'FS  '
C     ITYP  ='F   '
C     ITYP  ='FS  '
C     ITYP  ='    '  means ALL  
C     ITYP  ='ABCD'
C     ITYP  ='COEF'
C     ITYP  ='PH  '
C     ITYP  ='RI  '
C
C     Subroutine ORFILE returns actual type by ITYP
C

      MT1 = 20
      CALL LENSTR_BL(F_NAME,LEN)
      IF(LEN.LE.0.OR.F_NAME(1:1).EQ.' '.OR.F_NAME(1:1).EQ.',') THEN
        IERR=1
        RETURN
      ENDIF
      ITYP = 'FF  '
C
C     ORFILE - 1.open file FNAME 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C                copy file_parameters to /COMRDF/.
C
      CALL ORFILE(MD,MT1,F_NAME,ITYP,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERR: OPEN FILE-F-1')
        RETURN
      ENDIF
C
C     GET_TITLE - gets information from /COMRDF/
C
      CALL GET_TITLE(MD,A,B,C,AL,BE,GA
     *  ,COEF1,BET1,RN,RX,IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
      ITF1 = ITYP
C
C     for 'COEF':   TITLE(1:4)='FOUR' or 'PATT'
C
C -------------------------------------------------------------
C
C     C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C               also using CELL parameters from common/CRYSTL/ calculates
C               reciprocal cell parameters and volume and put its 
C               to common/CRYSTL/
C               
      CALL C_RD_CR
C -------------------------------------------------------------
      MT2   = 21
      ITYPE = 'FF  '
      CALL LENSTR_BL(F2_NAME,LEN)
      IF(LEN.LE.0.OR.F2_NAME(1:1).EQ.' '.OR.F2_NAME(1:1).EQ.',') THEN
        MT2=0
      ELSE
        CALL ORFILE(MD,MT2,F2_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-2')
          CLOSE(MT1)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A1,B1,C1,AL1,BE1,GA1
     *  ,DM1,DM2,RN1,RX1,IDM,IDM,IDM,IDM,IDM,TTT,IERR)
        ITF2=ITYPE
      ENDIF
C ------------------
      MT3   = 22
      ITYPE = 'PH  '
      CALL LENSTR_BL(PH_NAME,LEN)
      IF(LEN.LE.0.OR.PH_NAME(1:1).EQ.' '.OR.PH_NAME(1:1).EQ.',') THEN
        MT3=0
      ELSE
        CALL ORFILE(MD,MT3,PH_NAME,ITYPE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-PH')
          CLOSE(MT1)
          IF(MT2.GT.0) CLOSE(MT2)
          RETURN
        ENDIF
        CALL GET_TITLE(MD,A2,B2,C2,AL2,BE2,GA2
     *  ,DM1,DM2,RN2,RX2,IDM,IDM,IDM,IDM,IDM,TTT1,IERR)
        ITF3=ITYPE
      ENDIF
C -----------------
      IF(CFOM .EQ.'n') CFOM  = 'N'
      IF(CFOM .NE.'N') CFOM  = 'Y'
      IF(CFREE.EQ.'y') CFREE = 'Y'
      IF(CFREE.EQ.'i') CFREE = 'I'
      IF(CFREE.NE.'Y'.AND.CFREE.NE.'I') CFREE = 'N'
      IF(CSIG .EQ.'n') CSIG  = 'N'
      IF(CSIG .NE.'N') CSIG  = 'Y'
C ---
      RESMIN = RESMINR
      RESMAX = RESMAXR
      IF(RESMIN.LE.0.0)   RESMIN = RN
      IF(RESMAX.LE.0.0)   RESMAX = RX
      IF(RN .LT.RESMIN)   RESMIN = RN
      IF(RX .GT.RESMAX)   RESMAX = RX
      IF(MT2.GT.0) THEN
        IF(RN1.LT.RESMIN)   RESMIN = RN1
        IF(RX1.GT.RESMAX)   RESMAX = RX1
      ENDIF
      IF(MT3.GT.0) THEN
        IF(RN2.LT.RESMIN)   RESMIN = RN2
        IF(RX2.GT.RESMAX)   RESMAX = RX2
      ENDIF
      WRITE(LINE,'(''RESOLUTION MIN,MAX '',2F7.2)') RESMIN,RESMAX
      CALL MSGDOC(MD,LINE)
      RESMIN = RESMIN + 0.0001
      RESMAX = RESMAX - 0.0001
      RHMIN = 1.0/(RESMIN)
      RHMAX = 1.0/(RESMAX)
C ---------------
      MTOUT = 0
      CALL LENSTR_BL(FO_NAME,LEN)
      IF(LEN.GT.0.AND.FO_NAME(1:1).NE.' '.AND.FO_NAME(1:1).NE.',') THEN
        MTOUT=30


C ---
C       C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C
C        CALL C_CR_WR
C ---
C       SET_TITLE - sets information to  /COMWRF/
C 
C        CALL SET_TITLE(MD,A,B,C,
C     *  AL,BE,GA,COEF1,BET1,RESMIN,RESMAX,
C     *  IDM,IDM,IDM,IDM,IDM,TITLE,IERR)
C        ITFW = 'F   '
C
C       OWFILE - 1.open file 
C                2.writes title to file, parameters from common /COMRDF/
C
C        CALL OWFILE(MD,MTOUT,FO_NAME,ITFW,NSYM,ISYM,IPRSYM,IERR)

        PATH  = ' '
        EXT   = ' '      
        CALL OPENFW(MTOUT,MD,PATH,FO_NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CLOSE (MT1)
          IF(MT2.GT.0) CLOSE (MT2)
          IF(MT3.GT.0) CLOSE (MT3)
          CALL MSGERR(MDOC,' ERR: OPEN FILE-OUTPUT')
          IERR=1
          RETURN
        ENDIF

        CALL WR_TITLE_CIF(M,MTOUT,ITYP,TITLE
     *   ,MT2,MT3,CSIG,CFOM,CFREE
     *   ,NSYM,ISYM,IPRSYM,IERR)

      ENDIF
C ----------------------------------------------------------
      RLATT(1) = A
      RLATT(2) = B
      RLATT(3) = C
      RLATT(4) = AL
      RLATT(5) = BE
      RLATT(6) = GA
      CALL DSTARF(RLATT,AS,BS,CS,ALS,BES,GAS,VOL)
C ---
C 
C     initialization for CENTR_BL and ANOMSC
C
      CALL INIT_CENTR(NSYM,ISYM)
      CALL ANOMF(M,NSYM,ISYM)
C
C     calc limits H,k,l and grid for RESMAX
C
      RES = RESMAX

      CALL LIMHKL(RES,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)

      SUMA   = 0.0
      SUMB   = 0.0
      SUMFOM = 0.0
      NTOT   = 0
C ----
      IEND1 =-1
      IEND2 =-1
      IEND3 =-1
      IENDW =-1
      JH    =-200
      JK    =-200
      JL    =-200
      KH    =-200
      KK    =-200
      KL    =-200
      LH    =-200
      LK    =-200
      LL    =-200
C -----------------------------------------
      DO     IL=0,ILMAX
      DO     IK=-IKMAX,IKMAX
      DO     IH=-IHMAX,IHMAX
        IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0) GO TO 100
        IHP = IH
        IKP = IK
        ILP = IL
C
C        ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C        output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                 IANOM    - 0   +h,+k,+l
C                            1   -h,-k,-l
C                 JJSYM    - number operator of symmetry :
C                                 in(h,k,l) -- JJSYM --> out(h,k,l)
C
        CALL ANOMSC(IHP,IKP,ILP,IANOM,JJSYM,NSYM,ISYM)
c        IF(IANOM.NE.1.OR.JJSYM.NE.1) GO TO 100

        IF(NSYM.GT.1) THEN
C
C         SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C
          CALL SYSABS_BL(IH,IK,IL,NSYM,ISYM,ICND)
        ELSE
          ICND = 0
        ENDIF
C
C ---   ICND NE 0 systematic absent
C
        IF(ICND.NE.0) GO TO 100
C 
C       DSTAR - gives value of (4pi*sin(theta))/lambda for H,K,L
C
        CALL DSTAR(IH,IK,IL,RSQ)
        RH = SQRT(RSQ)
c        IF(RH.LT.RHMIN.OR.RH.GT.RHMAX) GO TO 100
C ---
C       CENTR_BL - Determine whether a reflection (IH,IK,IL) is centric or not

        CALL CENTR_BL(IH,IK,IL,JCENT)
C
C ---   JCENT = 1 centric reflection, JCENT = 0 acentric reflection
C ---
C ------
  200   CONTINUE
        IMISS1 = 1
        IF(IEND1.GT.0)                    GO TO 110

C        IF(JL-IL) 240,210,300
C  210   IF(JK-IK) 240,220,300
C  220   IF(JH-IH) 240,230,300

        IF((JL-IL).LT.0) THEN
          GO TO 240
        ELSE IF((JL-IL).EQ.0) THEN
          GO TO 210
        ELSE 
          GO TO 100
        ENDIF

 210    IF((JK-IK).LT.0) THEN
          GO TO 240
        ELSE IF((JK-IK).EQ.0) THEN
          GO TO 220
        ELSE 
          GO TO 100
        ENDIF

 220    IF((JH-IH).LT.0) THEN
          GO TO 240
        ELSE IF((JH-IH).EQ.0) THEN
          GO TO 230
        ELSE 
          GO TO 100
        ENDIF

C ------
  240   CONTINUE
C
C        RD1 - read from MT1 ; type of file :"F   ","PH  ","COEF","ALMN"
C        RRD1- read from MT1 ; type of file :"FS  "
C 
        IF(ITF1.EQ.'FS  ') THEN
          CALL RRD1(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
        ELSE
          CALL RD1(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C
C        IF(ITF2.EQ.'COEF') THEN
C          CALL RD1(MT1,JH,JK,JL,FA,FB,KEY1,IEND1)
C        IF(ITF2.EQ.'ABCD') THEN
c          CALL RABCD(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C        IF(ITF2.EQ.'PH  ') THEN
c          CALL RD1(MT1,JH,JK,JL,COSFOM,SINFOM,KEY1,IEND1)
C
C Possible to use:
C          CALL RD(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD2(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD2(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD3(MT1,JH,JK,JL,FN,FNA,NUMB,IEND)
C          CALL RRD3(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RD4(MT1,JH,JK,JL,FN,FNA,KEY1,IEND1)
C          CALL RRD4(MT1,JH,JK,JL,FN,FNA,SN,SNA,KEY1,IEND1)
C          CALL RABCD1(MT1,JH,JK,JL,AC,BC,CC,DC,KEY1,IEND1)
C

C         SIG-DUMMY
          SN  = 0.04*FN
          SNA = 0.04*FNA
        ENDIF

        IT1 = KEY1/2        
        IFLAG_FREE = KEY1 - IT1*2 
        IT3  = IT1/2
        IT3  = IT3-IT1*2
C       if IFLAG_FREE = 1 - free reflection
C       use program COPYFL to set "free flag".
        STAT = 'o'
        IF(IFLAG_FREE.EQ.1) STAT = 'f'
        IF(IT3       .EQ.1) STAT = 'r'
c ---
        IF(CFREE.EQ.'I') THEN
          STAT  = 'o'
          IPERC = 5
          CALL HSRD(RAND)
          IRAND = (RAND + 0.5)*100.0
          IF(IRAND.LE.IPERC) THEN
            STAT = 'f'
          ENDIF
        ENDIF
c --- 
        IF(MT1.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_1')
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND1.GT.0)                   GO TO 110
        IF(FN.LE.1.E-6.AND.FNA.LE.1.E-6) GO TO 100
        IF(FN.GT.1.E-6.AND.FNA.GT.1.E-6) THEN
          WT1 = 1./(SN*SN)
          WT2 = 1./(SNA*SNA)
          WT  = WT1+WT2
          FN  = FN*WT1+FNA*WT2
          FN  = FN/WT
          SN  = 1./SQRT(WT)
        ELSE IF(FNA.GT.1.E-6) THEN
          FN = FNA
          SN = SNA
        ENDIF
        GO TO 200

  230   IMISS1 = 0
C ------
  300   CONTINUE
        IMISS2=1
        IF(IEND2.LT.0.AND.MT2.LE.0)                   GO TO 400
        IF(IEND2.GT.0.OR.MT2.LE.0)                    GO TO 110

C        IF(KL-IL) 340,310,400
C  310   IF(KK-IK) 340,320,400
C  320   IF(KH-IH) 340,330,400

        IF((KL-IL).LT.0) THEN
          GO TO 340
        ELSE IF((KL-IL).EQ.0) THEN
          GO TO 310
        ELSE 
          GO TO 100
        ENDIF

 310    IF((KK-IK).LT.0) THEN
          GO TO 340
        ELSE IF((KK-IK).EQ.0) THEN
          GO TO 320
        ELSE 
          GO TO 100
        ENDIF

 320    IF((KH-IH).LT.0) THEN
          GO TO 340
        ELSE IF((KH-IH).EQ.0) THEN
          GO TO 330
        ELSE 
          GO TO 100
        ENDIF

C ------
  340   CONTINUE
        IF(ITF2.EQ.'FS  ') THEN
          CALL RRD2(MT2,KH,KK,KL,FD,FDA,SF,SFA,KEY2,IEND2)
        ELSE
          CALL RD2(MT2,KH,KK,KL,FD,FDA,KEY2,IEND2)
C         SIG-DUMMY
          SF  = 0.04*FD
          SFA = 0.04*FDA
        ENDIF
        IF(MT2.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_2')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT3.GT.0)   CLOSE (MT3)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND2.GT.0)                   GO TO 110
        IF(FD.LE.1.E-6.AND.FDA.LE.1.E-6) GO TO 100
        IF(FD.GT.1.E-6.AND.FDA.GT.1.E-6) THEN
          WT1 = 1./(SF*SF)
          WT2 = 1./(SFA*SFA)
          WT  = WT1+WT2
          FD  = FD*WT1+FDA*WT2
          FD  = FD/WT
          SF  = 1./SQRT(WT)
        ELSE IF(FDA.GT.1.E-6) THEN
          FD = FDA
          SF = SFA
        ENDIF
        GO TO 300

  330   IMISS2 = 0
C --------------------------------------------
  400   CONTINUE

        IMISS3 = 1
        IF(IEND3.LT.0.AND.MT3.LE.0)                   GO TO 500
        IF(IEND3.GT.0.OR.MT3.LE.0)                    GO TO 110

        IF((LL-IL).LT.0) THEN
          GO TO 440
        ELSE IF((LL-IL).EQ.0) THEN
          GO TO 410
        ELSE 
          GO TO 100
        ENDIF

 410    IF((LK-IK).LT.0) THEN
          GO TO 440
        ELSE IF((LK-IK).EQ.0) THEN
          GO TO 420
        ELSE 
          GO TO 100
        ENDIF

 420    IF((LH-IH).LT.0) THEN
          GO TO 440
        ELSE IF((LH-IH).EQ.0) THEN
          GO TO 430
        ELSE 
          GO TO 100
        ENDIF
C ------
  440   CONTINUE
        CALL RD3(MT3,LH,LK,LL,COSFOM,SINFOM,KEY3,IEND3)
        IF(MT3.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE_PH')
          IF(MT1.GT.0)   CLOSE (MT1)
          IF(MT2.GT.0)   CLOSE (MT2)
          IF(MTOUT.GT.0) CLOSE (MTOUT)
          IERR=1
          RETURN
        ENDIF
        IF(IEND3.GT.0)                   GO TO 110

        TEMP = (COSFOM*COSFOM+SINFOM*SINFOM)
        FOM  = SQRT(TEMP)
C       WRITE(*,*) FOM,TEMP
        IF(FOM.LE.0.00001) GO TO 440
        COPH = COSFOM/FOM
        SIPH = SINFOM/FOM
        IF(ABS(COPH).LT.1.E-5) THEN
          PHI = 90.
          IF(SIPH.LT.0.) PHI = PHI+180.
        ELSE
          PHI = (ATAN(SIPH/COPH))*57.29578
          IF(PHI.LT.0.) THEN
            IF(SIPH.LE.0.) THEN
              PHI = PHI + 360.
            ELSE
              PHI = PHI + 180.
            ENDIF
          ELSE IF(PHI.EQ.0.) THEN
            IF(COPH.LT.0.) PHI = PHI + 180.
          ELSE
            IF(SIPH.LE.0.) PHI = PHI + 180.
          ENDIF
        ENDIF
        IF(ABS(PHI-360.0).LT.0.0001) PHI = 0.0

C       SUMFOM = SUMFOM+FOM

        GO TO 400


  430   IMISS3 = 0
C --------------------------------------------
  500   CONTINUE
C -----------------------------------------------------
C       SUMFOM = SUMFOM+FOM

        NTOT = NTOT+1

C ---
        IF(MTOUT.GT.0) THEN
          IF(CSIG.EQ.'Y') THEN
            WRITE(LINE1,
     *      '(3I4,1X,F12.4,1X,F10.4)') 
     *      IH,IK,IL,FN,SN
          ELSE
            WRITE(LINE1,
     *      '(3I4,1X,F12.4)') 
     *      IH,IK,IL,FN
          ENDIF
          LINE = LINE1
          IF(MT2.GT.0) THEN
            IF(CSIG.EQ.'Y') THEN
              WRITE(LINE1,
     *        '(F12.4,1X,F10.4)') 
     *        FD,SF
            ELSE
              WRITE(LINE1,
     *        '(F12.4)') 
     *        FD
            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(MT3.GT.0) THEN
            IF(CFOM.EQ.'Y') THEN
              WRITE(LINE1,
     *        '(F8.3,1X,F6.3)') 
     *        PHI,FOM
            ELSE
              WRITE(LINE1,
     *        '(F8.3)') 
     *        PHI
            ENDIF
            CALL LENSTR_BL(LINE ,LEN)
            CALL LENSTR_BL(LINE1,LEN1)
            LINE = LINE(1:LEN)//' '//LINE1(1:LEN1)
          ENDIF
          IF(CFREE.EQ.'Y'.OR.CFREE.EQ.'I') THEN
            CALL LENSTR_BL(LINE ,LEN)
            LINE = LINE(1:LEN)//' '//STAT
          ENDIF
          CALL WRTSTR(MTOUT,M,LINE,IERR)
        ENDIF
C ----
 100  CONTINUE
      ENDDO
      ENDDO
      ENDDO
C ---------------------------------------
  110 CONTINUE
      CLOSE (MT1)
      IF(MT2.GT.0) CLOSE (MT2)
      IF(MT3.GT.0) CLOSE (MT3)

      IF(MTOUT.GT.0) THEN
        IF(NTOT.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: number of reflections = 0')
          CLOSE(MTOUT)
          IERR=1
          RETURN
        ENDIF
C ---
        END FILE MTOUT
        CLOSE(MTOUT)
      ENDIF
C ----------------------------------------------
      RESULT(1) = NTOT
      RESULT(2) = RESMIN
      RESULT(3) = RESMAX
C -----------------------------------------------------------
      WRITE(LINE,1000) NTOT
 1000 FORMAT('Number or reflextions = ',I8)
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

      SUBROUTINE WR_TITLE_CIF(MDOC,IOUT,TYPE,STR
     * ,MT2,MT3,CSIG,CFOM,CFREE
     * ,NSYM,ISYM,NSMAX,IERR)
C ----------------------------------------------------------
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER TYPE*4,STR*(*)
C ------------------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C -------
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      CHARACTER SYMOP*24,CH10*10,CODE*8,TEMPER*5,WAVE*5,CODE_NDB*8
      CHARACTER TITLE*80,CSIG*1,CFOM*1,CFREE*1
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(USER_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = USER_TITLE(9:68)
        WAVE  = USER_TITLE(69:73)
        TEMPER= USER_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(PDB_NAME,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=PDB_NAME(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.PDB_CODE.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = PDB_CODE//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)

      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        CALL LENSTR_BL(ICS_CATEGORY,LENC)
C ---
c      WRITE(LINE,
c     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(PDB_CODE,LEN)
c      WRITE(LINE,
c     *'(''_database_2.code_PDB   '',2X,A)') PDB_CODE(1:LEN)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      IF(CODE_NDB(1:1).NE.'?') THEN
c        WRITE(LINE,
c     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
c      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(PDB_NAME,LEN)
c      IF(LEN.LE.12) THEN
c        PDB_NAME(13:13)='?'
c        LEN=13
c      ENDIF
c      IF(LEN.GT.32) LEN=32
c      WRITE(LINE,110) PDB_NAME(13:LEN)
c  110 FORMAT(       
c     * '_struct_keywords.text  ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      CALL LENSTR_BL(TITLE,LEN)
c      IF(LEN.GT.60) LEN=60
c      WRITE(LINE,200) TITLE(1:LEN)
c  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c
c      CALL CHNG_DATE(PDB_DATE,CH10)
c
c      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
c     * CH10(1:10)
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL CHCLOCK(CHAR20)
c      WRITE(LINE,210) CHAR20
c  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
c      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
c      CALL LENSTR_BL(TEMPER,LEN)
c      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
c     *   TEMPER(1:1).NE.'?') THEN
c        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
c     *  CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        IF(LEN.GT.5) LEN=5
c        WRITE(LINE,340) TEMPER(1:LEN)
c  340   FORMAT('_diffrn.ambient_temperature    ',A)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
c      CALL LENSTR_BL(WAVE,LEN)
c      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
c     *   WAVE(1:1).NE.'?') THEN
c        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
c     *  CODE(1:LENCD)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c        IF(LEN.GT.5) LEN=5
c        WRITE(LINE,350) WAVE(1:LEN)
c  350   FORMAT('_diffrn_radiation.wavelength  ',A)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
c      ENDIF
C ---
        AL_CELL=AL_CELL/PI180
        BE_CELL=BE_CELL/PI180
        GA_CELL=GA_CELL/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') A_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_b   '',2X,F8.3)') B_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') C_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') AL_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') BE_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') GA_CELL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
C  SYMMETRY 
      NOSG = NSP_GROUP
      ISTT = N_SETT
      IF(NOSG.EQ.  3.OR.NOSG.EQ.  4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
        ELSE IF(ISTT.EQ.3) THEN  
          ISTT = 4
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
        ELSE IF(ISTT.EQ.3) THEN  
          ISTT = 4
        ELSE IF(ISTT.EQ.4) THEN  
          ISTT = 3
        ENDIF
      ENDIF
C ---
      IF(ISTT.GT.1) NOSG = (ISTT-1)*1000 + NOSG
      NO_CCP4 = NOSG

        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(SP_GROUP,LEN)
        WRITE(LINE,100)  SP_GROUP(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

c        WRITE(LINE,400)  NSP_GROUP

        WRITE(LINE,400)  NO_CCP4
  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

c        WRITE(LINE,500)  N_SETT
c  500   FORMAT('_symmetry.cell_setting_number ',2X,I5)
c        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------------------------
      WRITE(LINE,'(''loop_'')')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_h'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_k'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      LINE='_refln.index_l'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C -------------------------
      LINE='_refln.F_meas_au'
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CSIG.EQ.'Y') THEN
        LINE='_refln.F_meas_sigma_au'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
      IF(MT2.GT.0) THEN
        LINE='_refln.F_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CSIG.EQ.'Y') THEN
          LINE='_refln.F_sigma'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(MT3.GT.0) THEN
        LINE='_refln.phase_calc'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CFOM.EQ.'Y') THEN
          LINE='_refln.fom'
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
      ENDIF
      IF(CFREE.EQ.'Y'.OR.CFREE.EQ.'I') THEN
        LINE='_refln.status'
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C -----------------------------------------
      RETURN
      END
