C --- get_chain.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80,CHAIN*1,FILE_PDB*256,FILE_OUT*256
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'get_chain'
      CALL START(0,MDOC,PROG,PATH_OUT)
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  GET_CHAIN ---  /V.02.04.2007/')
      CALL MSGDOC(MDOC,' ')
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      CHAIN = '?'
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'CHAIN:      < >  - ')
      CALL SET_DEFAULT(
     *'FILE_P:      < >  - input pdb file')
      CALL SET_DEFAULT(
     *'FILE_O:      < >  - output pdb file')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='CHAIN'
      CALL ASK(LINE)
      CHAIN=LINE(1:1)
      IF(CHAIN.EQ.',') CHAIN = ' '
C -----------------------
      LINE='FILE_P'
      CALL ASK(LINE)
      FILE_PDB=LINE
      CALL CORR_NAME_BL(FILE_PDB)
C ----
      LINE='FILE_O'
      CALL ASK(LINE)
      FILE_OUT=LINE
      CALL CORR_NAME_BL(FILE_OUT)
C ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BL(PATH_SCR)
C ----

      CALL CLOSE_BATCH(MDOC)

C ---------------------------------
      CALL GET_CHAIN(MDOC,CHAIN
     *   ,FILE_PDB,FILE_OUT
     *   ,PATH_OUT,PATH_SCR,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE GET_CHAIN(MDOC,CHAIN_INP
     *   ,FILE_PDB,FILE_OUT
     *   ,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER LINE*256
      CHARACTER FILE_PDB*(*),FILE_OUT*(*),FILE_XML*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*256,EXT*1
      CHARACTER CHAIN_INP*1
      CHARACTER CODE_PDB*4,DATE_PDB*9
      REAL      CELL(6)
      CHARACTER   MESSAGE*80,JOB*80
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      NRES = 0
      JOB  = 'get_chain'
      MESSAGE = 'normal termination'
c ---
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C -----
      LINE = 'chain <'//CHAIN_INP//'>'
      CALL MSGDOC(MDOC,LINE)
      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.LE.0) THEN
        LINE = ' ERROR: wrong input file name'
        MESSAGE = 'wrong input file name'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
C ----------------------------------
      CALL CLEAN_PDB(MDOC,CHAIN_INP,FILE_PDB,FILE_OUT,NRES
     * ,MESSAGE,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in CLEAN_PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      IF(NRES.LE.0) THEN
        MESSAGE = 'number of residues = 0'
        LINE = ' ERROR: number of residues = 0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      WRITE(LINE,'(A,I6)') 'Number of residues =',NRES
      CALL MSGDOC(MDOC,LINE)
C ----------------------------------
900   CONTINUE

      CALL WRITE_GET_CHAIN_XML(MDOC,IERR,MESSAGE,JOB,PATH_OUT
     *                        ,NRES,CHAIN_INP)

      RETURN
      END


      SUBROUTINE WRITE_GET_CHAIN_XML(MDOC
     *            ,IERR_INPUT,MESSAGE,JOB,PATH_OUT
     *            ,NRES,CHAIN_INP)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*)
      CHARACTER FILE_XML*256
      CHARACTER CHAIN_INP*1
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_XML = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_XML = JOB(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_XML,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_residue <nres> ',NRES,' </nres>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
        LINE = 'chain_id <ch_id> '//CHAIN_INP//' </ch_id>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1

      write(*,*) '--error: write xml file'      

      RETURN
      END
