C --- get_model.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_PDB*256,FILE_OUT*256
C
      CHARACTER LINE*256,PROG*80
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'get_model'
      
      CALL START(0,MDOC,PROG,PATH_OUT)
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NMODEL  = 0
      MODEL  = 0
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'FILE_PDB:        - ')
      CALL SET_DEFAULT(
     *'FILE_OUT:        - ')
      CALL SET_DEFAULT(
     *'MODEL:           - ')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_PDB'
      CALL ASK(LINE)
      FILE_PDB=LINE
      CALL CORR_NAME_ALL(FILE_PDB)
C ----
      LINE='FILE_OUT'
      CALL ASK(LINE)
      FILE_OUT=LINE
      CALL CORR_NAME_ALL(FILE_OUT)
C ----
      LINE='MODEL'
      CALL ASK(LINE)
      READ(LINE,*) MODEL
      IF(MODEL.LT.0) MODEL = 0 
C ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C ----

      CALL CLOSE_BATCH(MDOC)

C ---------------------------------
      CALL GET_MODEL(MDOC,FILE_PDB,FILE_OUT
     *           ,MODEL,NMODEL,PATH_SCR,PATH_OUT,IERR)
      CALL WRITE_GET_MODEL_XML(MDOC
     *    ,IERR,PROG,MODEL,NMODEL,FILE_OUT,PATH_OUT)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE WRITE_GET_MODEL_XML(MDOC
     *    ,IERR_INPUT,PROG,MODEL,NMODEL,FILE_OUT,PATH_OUT)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,MESSAGE*80,PROG*(*),FILE_OUT*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(PROG,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//PROG(1:LJ)//'.xml'
      ELSE
        FILE_2 = PROG(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//PROG(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//PROG(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//PROG(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
        MESSAGE = 'normal termination'
      ELSE
        MESSAGE = 'program failed'
        IF(IERR_INPUT.EQ.9) THEN
          MESSAGE = 'program failed: N_atom = 0'
        ELSE IF(IERR_INPUT.EQ.8) THEN
          MESSAGE = 'program failed: model > N_model'
        ELSE IF(IERR_INPUT.EQ.7) THEN
          MESSAGE = 'program failed: N_model = 1'
        ENDIF
      ENDIF

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//PROG(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_model <nmodel> ',NMODEL,' </nmodel>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'model <model> ',MODEL,' </model>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(FILE_OUT,LEN)
        IF(LEN.LE.0) FILE_OUT = 'null'
        CALL LENSTR_BL(FILE_OUT,LEN)

        WRITE(LINE,'(A,A,A)',ERR=510) 
     *    'file <file> ',FILE_OUT(1:LEN),' </file>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//PROG(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE GET_MODEL(MDOC,FILE_PDB,FILE_OUT
     *      ,IMODEL,NMODEL,PATH_SCR,PATH_OUT,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB*(*),PATH_SCR*(*)
      CHARACTER FILE_OUT*(*),PATH_OUT*(*)
      CHARACTER FILES*256,FILET*256
C -----------------------------------------------------------
      PARAMETER (NCHAIN_MAX = 400 )
      CHARACTER SEG_ID(NCHAIN_MAX)*2,NEW_SEG_ID(NCHAIN_MAX)*2  
      CHARACTER CHAIN(NCHAIN_MAX)*2 
      CHARACTER LINE*256,REC*256,SEG*4,CH1*1,CH_OLD*1,SEG_OLD*4
      CHARACTER EXT*3,PATH*1,TYPE*1
      CHARACTER LETT*61
C --------------------------------------------------
      NLETT = 61
C              123456789 123456789 123456789 12345
      LETT  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789'//
     *        'abcdefghijklmnopqrstuvwxyz'
C              6789 123456789 123456789 1
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
C      CALL LENSTR_BL(FILE_PDB,LEN)
C      FILET = FILE_PDB(1:LEN)//'.pdb'  

      FILET = FILE_PDB
      CALL OPENFR(IN,M,PATH,FILET,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open intput file') 
        RETURN
      ENDIF
C ---
      FILES  = 'molrep_nmr_tmp.pdb'
      CALL LENSTR_BL(FILES,LEN)
      CALL LENSTR_BL(PATH_SCR,LT)
      IF(LT.GT.0) THEN
        FILES  = PATH_SCR(1:LT)//FILES(1:LEN)
      ENDIF      
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILES,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open output file') 
        CLOSE(IN)
        RETURN
      ENDIF
C ------------
      NMODEL  = 0
      IMDL    = 1
      NCHAIN  = 0
      CH_OLD  = '?'
      SEG_OLD = '?'
      NBAD    = 0

100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:4).EQ.'CRYS') THEN

      ELSE IF(LINE(1:6).EQ.'HEADER') THEN

      ELSE IF(LINE(1:9).EQ.'#MOLECULE') THEN

      ELSE IF(LINE(1:7).EQ.'#DOMAIN') THEN

      ELSE IF(LINE(1:5).EQ.'MODEL') THEN
        CH_OLD  = '?'
        READ(LINE,'(10X,I4)') IMDL
        NMODEL = NMODEL + 1
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN

        CH1 = LINE(22:22)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'?') THEN
          IL   = NLETT - NBAD
          CH1  = LETT(IL:IL)
          NBAD = NBAD + 1
        ENDIF 

        SEG = '    '
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.74) THEN
          SEG(1:2) = LINE(73:74)
        ENDIF
        IF(LEN.GE.75) THEN
          SEG(1:3) = LINE(73:75)
        ENDIF
        IF(LEN.GE.76) THEN
          SEG = LINE(73:76)
        ENDIF

        CALL CHKSMB(SEG(1:1),TYPE)
        IF(TYPE.EQ.'?') SEG(1:1) = CH1
        CALL CHKSMB(SEG(2:2),TYPE)
        IF(TYPE.EQ.'?') SEG(2:2) = CH1
        CALL CHKSMB(SEG(3:3),TYPE)
        IF(TYPE.EQ.'?') SEG(3:3) = '0'
        CALL CHKSMB(SEG(4:4),TYPE)
        IF(TYPE.EQ.'?') SEG(4:4) = '0'

        IF(SEG(1:1).EQ.' ') THEN
          SEG(1:1) = CH1
        ENDIF
        IF(SEG(2:2).EQ.' ') THEN
          SEG(2:2) = SEG(1:1)
        ENDIF
        IF(SEG(3:3).EQ.' ') SEG(3:3) = '-'
        IF(SEG(4:4).EQ.' ') SEG(4:4) = '-'

        LINE(22:22) = CH1
        LINE(73:76)=  SEG

        IF((IMODEL.GT.0.AND.IMDL.EQ.IMODEL).OR.
     *      IMODEL.EQ.0                        ) THEN
          IF(CH1.NE.CH_OLD) THEN
            NCHAIN = NCHAIN + 1
            IF(NCHAIN.GT.NCHAIN_MAX) NCHAIN = NCHAIN_MAX
            SEG_ID(NCHAIN) = SEG(1:2) 
            CHAIN(NCHAIN)(1:1) = ' ' 
            CHAIN(NCHAIN)(2:2) = CH1 
            CH_OLD = CH1
          ENDIF          
        ENDIF

      ENDIF
           
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)     

      GO TO 100
110   CONTINUE
      CLOSE(IN)
      END FILE IOUT
      CLOSE(IOUT)
c ---
      IF(IMODEL.LE.0) THEN
        WRITE(LINE,*) 'N_model:',NMODEL
        CALL MSGDOC(MDOC,LINE)
        FILE_OUT = ' '
        GO TO 800
      ENDIF
      IF(NMODEL.LE.1) THEN
        CALL MSGERR(MDOC,'ERROR: N_model =< 1') 
        FILE_OUT = ' '
        IERR = 7
        GO TO 800
      ENDIF
      IF(IMODEL.GT.NMODEL) THEN
        CALL MSGERR(MDOC,'ERROR: model > N_model') 
        FILE_OUT = ' '
        IERR = 8
        GO TO 800
      ENDIF
C ------------
      WRITE(LINE,*) 'N_model:',NMODEL,IMODEL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'N_chain:',NCHAIN
      CALL MSGDOC(MDOC,LINE)

      DO I=1,NCHAIN
        WRITE(LINE,*) I,'<',CHAIN(I),'>','<',SEG_ID(I),'>'
        CALL MSGDOC(MDOC,LINE)
      ENDDO

      NCHAIN_IN = NCHAIN
C      IF(IMODEL.GT.0.AND.NCHAIN.GT.1) THEN
      IF(NCHAIN.GT.1) THEN
        IC = 1
        DO I=1,NCHAIN
          NEW_SEG_ID(I) = SEG_ID(I)
          IF(I.EQ.1) THEN
            NEW_SEG_ID(I)(2:2) = LETT(IC:IC)
          ELSE IF(I.GT.1) THEN
            CH1 = SEG_ID(I)(2:2)
            DO J=1,I-1
              IF(CH1.EQ.SEG_ID(J)(2:2)) GO TO 300
            ENDDO
            IC = IC + 1
            IF(IC.GT.NLETT) THEN
              IT = IC/NLETT
              IC = IC - IT*NLETT
            ENDIF
            NEW_SEG_ID(I)(2:2) = LETT(IC:IC)
            GO TO 310
  300       CONTINUE
            NEW_SEG_ID(I)(2:2) = NEW_SEG_ID(J)(2:2)
  310       CONTINUE
          ENDIF
        ENDDO


c        DO I=1,NCHAIN
c          IF(SEG_ID(I)(1:1).EQ.SEG_ID(I)(2:2)) THEN
c            NEW_SEG_ID(I)(1:1) = NEW_SEG_ID(I)(2:2)
c          ELSE 
c            IC = IC + 1
c            IF(IC.GT.NLETT) IC = NLETT
c            NEW_SEG_ID(I)(1:1) = LETT(IC:IC)
c          ENDIF
c        ENDDO

        INEW = 0
        DO I=1,NCHAIN
          IC = I 
          IF(IC.GT.NLETT) THEN
            IT = IC/NLETT
            IC = IC - IT*NLETT
            INEW = IT
            IF(INEW.GT.NLETT) INEW = NLETT
          ENDIF
          NEW_SEG_ID(I)(1:1) = LETT(IC:IC)
          CHAIN(I)(1:1) = ' ' 
          CHAIN(I)(2:2) = LETT(IC:IC)
          IF(INEW.GT.0) THEN
            CHAIN(I)(1:1) = LETT(INEW:INEW)
          ENDIF 
        ENDDO

        DO I=1,NCHAIN
          SEG_ID(I) = NEW_SEG_ID(I)
        ENDDO

      ENDIF

      DO I=1,NCHAIN
        WRITE(LINE,*) '==',I,'<',CHAIN(I),'>','<',SEG_ID(I),'>'
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ------------
      CALL LENSTR_BL(FILE_OUT,LEN)
      CALL LENSTR_BL(PATH_OUT,LT)
      IF(LT.GT.0) THEN
        FILE_OUT = PATH_OUT(1:LT)//FILE_OUT(1:LEN)
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: open output file') 
        GO TO 800
      ENDIF
C ------------
      NATOM = 0
      ISTART = 1
      IFNISH = NMODEL
      IF(IMODEL.GT.0) THEN
        ISTART = IMODEL
        IFNISH = IMODEL
      ENDIF
      IC = 0
      DO IMOD=ISTART,IFNISH
        IN   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IN,M,PATH,FILES,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: open intput file.') 
          CLOSE(IOUT)
          GO TO 800
        ENDIF
        IFIRST  = 0 
        REC     = '      '
        IWRT    = 1
        ICHAIN  = 0
        CH_OLD  = '?'
        SEG_OLD = '?'
C --
200     CONTINUE

        READ(IN,'(A)',ERR=900,END=210) LINE

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.6) GO TO 200

        IF(LINE(1:4).EQ.'CRYS') THEN
          IF(IMOD.GT.ISTART) GO TO 220
        ELSE IF(LINE(1:6).EQ.'HEADER') THEN
          IF(IMOD.GT.ISTART) GO TO 220
        ELSE IF(LINE(1:9).EQ.'#MOLECULE') THEN
          GO TO 220
        ELSE IF(LINE(1:7).EQ.'#DOMAIN') THEN

        ELSE IF(LINE(1:6).EQ.'COMPND') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'SCALE') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
          GO TO 220
        ELSE IF(LINE(1:5).EQ.'MODEL') THEN
          CH_OLD  = '?'
          IWRT = 0
          READ(LINE,'(10X,I4)') IM
          IF(IMOD.EQ.IM) THEN
            IWRT = 1
            IF(REC(1:9).EQ.'#MOLECULE') THEN
              CALL LENSTR_BL(REC,LEN)
              WRITE(IOUT,'(A)',ERR=910) REC(1:LEN)     
            ENDIF
            IF(IMODEL.GT.0.OR.IFIRST.NE.0) THEN
              GO TO 220
            ENDIF
            IFIRST = 1 
          ELSE
            GO TO 220
          ENDIF
        ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN

          IF((IMODEL.GT.0.AND.IM.EQ.IMODEL).OR.
     *        IMODEL.EQ.0                      ) THEN

            CH1 = LINE(22:22)

            IF(CH1.NE.CH_OLD) THEN
              ICHAIN = ICHAIN + 1
              IF(ICHAIN.GT.NCHAIN_IN) THEN
                ICHAIN = NCHAIN_IN
                CALL MSGERR(MDOC,
     *    'WARNING: WRITE_NMR_PDB problem with chain_ID') 
              ENDIF
              CH_OLD = CH1
            ENDIF

            LINE(73:74) = SEG_ID(ICHAIN)  
C           LINE(22:22) = SEG_ID(ICHAIN)(1:1)
            LINE(21:21) = CHAIN(ICHAIN)(1:1)
            LINE(22:22) = CHAIN(ICHAIN)(2:2)

            
            OCC = 1.0
            WRITE(LINE(55:60),'(F6.2)') OCC

            IF(IWRT.GT.0) NATOM = NATOM + 1

          ENDIF
          
        ENDIF
        
        IF(IWRT.GT.0) THEN   
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)     
        ENDIF

220     CONTINUE
        REC = LINE
        GO TO 200
210     CONTINUE
C --
        CLOSE(IN)
      ENDDO
C ------------
      END FILE IOUT
      CLOSE(IOUT)

      IF(NATOM.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N_atom = 0') 
        FILE_OUT = ' '
        IERR = 9
      ENDIF
C ---
800   CONTINUE

      FILES  = 'molrep_nmr_tmp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)

      RETURN
C ------------
900   CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file') 
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 800
C ------------
910   CONTINUE
      CALL MSGERR(MDOC,'ERROR: write output file') 
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 800
      END



