C --- GET_NMR.f---
C --------------------------------------------------------------------
      CHARACTER MODE*1,CODE*8
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_SEQ*256,FILE_LIST*256,LIST*1,WFLAG*1,FULL*1
C
      CHARACTER LINE*256,PROG*80
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'get_nmr'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  GET_NMR ---  V.27.06.2009/')
      CALL MSGDOC(MDOC,' ')
C ---------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NMAX  = 0
      Q_LIM = 0
      CODE = '     '
      LIST = ' '
      FULL = ' '
      FILE_SEQ  = ' '
      FILE_LIST = ' '
      WFLAG    = ' '
      CALL SET_DEFAULT(' ')
C ---
      CALL SET_DEFAULT(
     *'MODE: <D>,P,S,M  D - create domain/chain file')
      CALL SET_DEFAULT(
     *'                 P - create NMR and seq profile')
      CALL SET_DEFAULT(
     *'                 C - create NMR by chain DB(no SEQ,FILE_L')
      CALL SET_DEFAULT(
     *'                 S - create prf_DOM,')
      CALL SET_DEFAULT(
     *'                          before create empty dir: prf_DOM')
      CALL SET_DEFAULT(
     *'                 M - create multimer files')
      CALL SET_DEFAULT('CODE:  < >     - domain/chain code')
      CALL SET_DEFAULT('SEQ:   < >     - domain/chain sequence file')
      CALL SET_DEFAULT('QLIM:  <0.3>   - Alignment Quality limit')
      CALL SET_DEFAULT('NMAX:  <8>     - ')
      CALL SET_DEFAULT('W:     <Y>,N   - use Q as weight(OCC), mode P')
      CALL SET_DEFAULT('FULL:  <N>,Y   - full output file, mode P')
      CALL SET_DEFAULT('FILE_L:  < >   - file with domain/chain list')
      CALL SET_DEFAULT('LIST:  <S>,L   - Short, Long ')
      CALL SET_DEFAULT(
     *  'PATH_SCR: < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BL(PATH_SCR)
C ----
      LINE='MODE'
      CALL ASK(LINE)
      MODE = LINE(1:1)
      IF(MODE.EQ.'p') MODE = 'P'
      IF(MODE.EQ.'s') MODE = 'S'
      IF(MODE.EQ.'d') MODE = 'D'
      IF(MODE.EQ.'m') MODE = 'M'
      IF(MODE.EQ.'c') MODE = 'C'
      IF(MODE.NE.'P'.AND.MODE.NE.'M'.AND.MODE.NE.'S'.AND.
     *                   MODE.NE.'C') MODE = 'D'
C ----
      LINE='LIST'
      CALL ASK(LINE)
      LIST = LINE(1:1)
      IF(LIST.EQ.'s') LIST = 'S'
      IF(LIST.EQ.'l') LIST = 'L'
      IF(LIST.NE.'L') LIST = 'S'
C ----
      LINE='FULL'
      CALL ASK(LINE)
      FULL = LINE(1:1)
      IF(FULL.EQ.'y') FULL = 'Y'
      IF(FULL.EQ.'n') FULL = 'N'
      IF(FULL.NE.'Y') FULL = 'N'
C ----
      LINE='W'
      CALL ASK(LINE)
      WFLAG = LINE(1:1)
      IF(WFLAG.EQ.'n') WFLAG = 'N'
      IF(WFLAG.EQ.'y') WFLAG = 'Y'
      IF(WFLAG.NE.'N') WFLAG = 'Y'
C ----
      LINE='CODE'
      CALL ASK(LINE)
      CODE = LINE(1:7)         
      IF(CODE(1:1).EQ.',') CODE = '        '
      CALL CORR_NAME_BL(CODE)
C ----
      LINE='SEQ'
      CALL ASK(LINE)
      FILE_SEQ = LINE
      CALL CORR_NAME_BL(FILE_SEQ)
C ----
      LINE='FILE_L'
      CALL ASK(LINE)
      FILE_LIST = LINE
      CALL CORR_NAME_BL(FILE_LIST)
C ----
      LINE='QLIM'
      CALL ASK(LINE)
      READ(LINE,*) Q_LIM
      IF(LINE(1:1).EQ.',') Q_LIM = 0.3
      IF(Q_LIM.LT.0.0001) Q_LIM = 0.3
C ----
      LINE='NMAX'
      CALL ASK(LINE)
      READ(LINE,*) NMAX
      IF(NMAX.LE.0) NMAX = 8
C ---
      CALL CLOSE_BATCH(MDOC)
C ---------------------------------
      CALL GET_NMR(MDOC,MODE
     *   ,CODE,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_OUT,PATH_SCR,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE GET_NMR(MDOC,MODE
     *   ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512
      CHARACTER FILE_TEMP*256,FILE_CRD*256,FILE_PDB*256
      CHARACTER FILE_SEQ*(*),FILE_LIST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*256
C ---
      CHARACTER MODE*1,LIST*1,WFLAG*1,FULL*1
      CHARACTER CODE8*8,PATH*1,EXT*1,ALIGN_CORR*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERR: setenv MOLREP_DB'      
        CALL MSGERR(MD,LINE)
        LINE = '     Example: "setenv MOLREP_DB ~alexei/molrep_DB" '      
        CALL MSGERR(MD,LINE)
        GO TO 900
      ENDIF
      FILE_CRD = ' '
c      IF(NMAX.LE.0) NMAX = 10
c      IF(Q_LIM.LT.0.0001) Q_LIM = 0.3
C ---
      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        IU   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IU,M,PATH,FILE_SEQ,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: SEQ file: no such file')
          RETURN
        ENDIF
        CLOSE(IU)
      ENDIF

      IF(MODE.EQ.'P') THEN
        CALL LENSTR_BL(FILE_LIST,LEN)
        IF(LEN.GT.0) THEN
          IU   = 10
          EXT  = ' '
          PATH = ' '
          CALL OPENFR(IU,M,PATH,FILE_LIST,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: file_l : no such file')
            RETURN
          ENDIF
          CLOSE(IU)
c         CODE8 = ' ' 
        ELSE
          CALL LENSTR_BL(CODE8,LEN)
          IF(LEN.LT.5) THEN
            CALL MSGERR(MDOC,'ERROR: wrong code')
            IERR = 1
            RETURN
          ENDIF
          FILE_LIST = ' '
        ENDIF
      ELSE
        IF(MODE.NE.'S') THEN
          CALL LENSTR_BL(CODE8,LEN)
          IF(LEN.LT.5) THEN
            CALL MSGERR(MDOC,'ERROR: wrong code')
            IERR = 1
            RETURN
          ENDIF
          FILE_LIST = ' '
        ENDIF
      ENDIF

      IF(MODE.EQ.'P') THEN

        IF(MODE.EQ.'P') THEN
          CALL MSGDOC(MDOC,'------ create NMR and seq profile ------')
        ELSE
          CALL MSGDOC(MDOC,'------ create seq profile ------')
        ENDIF

        CALL LENSTR_BL(FILE_LIST,LL)
        CALL LENSTR_BL(CODE8,LEN)

        IF(LL.GT.0.OR.LEN.GT.5) THEN
          CALL CREATE_PRF_FILE(MDOC,MODE
     *       ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *       ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        ELSE
          CALL LENSTR_BL(FILE_SEQ,LL)
          CALL LENSTR_BL(CODE8,LEN)
          IF(LEN.EQ.5.AND.LL.LE.0) THEN
            CALL LENSTR_BL(PATH_DB,LEN_DB)
            FILE_SEQ = PATH_DB(1:LEN_DB)//'/seq_DB/'//CODE8(1:5)//'.seq'
          ENDIF
          CALL CREATE_PRF_FILE_CHAIN(MDOC
     *       ,CODE8,FILE_SEQ,Q_LIM,NMAX,WFLAG,FULL
     *       ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        ENDIF
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN
            LINE = ' ERROR: in CREATE_PRF_FILE'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          GO TO 900
        ENDIF

      ELSE IF(MODE.EQ.'C') THEN

        CALL LENSTR_BL(CODE8,LEN)
        IF(LEN.NE.5) THEN
          CALL MSGERR(MDOC,'ERROR: wrong code')
          IERR = 1
          RETURN
        ENDIF
        FILE_LIST = ' '
        FILE_SEQ  = ' '

        CALL MSGDOC(MDOC,'------ create NMR by chain DB ------')

        MODE = 'P'
        CALL CREATE_PRF_FILE(MDOC,MODE
     *       ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *       ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN
            LINE = ' ERROR: in CREATE_PRF_FILE'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          GO TO 900
        ENDIF

      ELSE IF(MODE.EQ.'S') THEN

        CALL MSGDOC(MDOC,'------ create prf_DOM ------')

c        CALL CREATE_PRF_DB_CLASS(MDOC,MODE
c        CALL CREATE_PRF_DB(MDOC,MODE
        CALL CREATE_PRF_DB_CLASS(MDOC,MODE
     *    ,Q_LIM,NMAX,WFLAG,FULL
     *    ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in CREATE_PRF_DB'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

      ELSE IF(MODE.EQ.'M') THEN
        CALL MSGDOC(MDOC,'------ create multimer files ------')

        CALL CREATE_MULTIMER_FILES(MDOC,PATH_DB
     *     ,FILE_TEMP,FILE_SEQ
     *     ,FILE_CRD
     *     ,CODE8
     *     ,LIST,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN
            LINE = ' ERROR: in CREATE_MULTIMER_FILES'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          GO TO 900
        ENDIF

      ELSE
        CALL MSGDOC(MDOC,'------ get domain/chain ------')

        CALL LENSTR_BL(CODE8,LEN)
        IF(LEN.GT.7) LEN = 7
        FILE_TEMP = CODE8(1:LEN)//'.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        ENDIF

C       FILE_TEMP output one domain file
C       FILE_CRD  output all domains file
        ALIGN_CORR = 'Y'
        CALL GET_DOMAIN_ONE(MDOC,PATH_DB
     *   ,FILE_TEMP,FILE_SEQ
     *   ,FILE_CRD
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOMAIN_ONE'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

        FILE_PDB = 'domains_coot.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_PDB = PATH_OUT(1:LEN)//FILE_PDB(1:LT) 
        ENDIF

        CALL DOMAIN2CHAIN_FOR_COOT(MDOC,FILE_CRD,FILE_PDB,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in DOMAIN2CHAIN_FOR_COOT'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

        CALL LENSTR_BL(FILE_CRD,LT )
        LINE = 'File all domains : '//FILE_CRD(1:LT)
        CALL MSGDOC(MDOC,LINE)
        CALL LENSTR_BL(FILE_PDB,LT )
        LINE = 'File for coot    : '//FILE_PDB(1:LT)
        CALL MSGDOC(MDOC,LINE)

      ENDIF
C ---

      RETURN
  900 CONTINUE
      RETURN
      END

      SUBROUTINE CREATE_PRF_DB(MDOC,MODE
     *   ,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*256,FILE_LIST*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256,FILE_NMR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256,FILE_PRF*256
      CHARACTER FILE_OUT*256
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ---
      CHARACTER LINE*512,PATH*1,EXT*1,PATH_PRF*256
      logical ex
      integer nfile
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
C ------
      FILE_LIST  = ' '
      FILE_PRF   = ' '
      FILE_NMR   = ' '
      FILE_SEQ   = ' '
      FILE_CORR  = ' '
      FILE_FIRST_CORR  = ' '

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

C
c     list/domain_descr_list.txt
C    

C     allocation        

      allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

C ---
      NDOMAIN  = NSEQMAX

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0) GO TO 600

      LEN_CODE = 7
      NSEQ     = NDOM
      WRITE(LINE,*) 'N_dom_db:',NDOM
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF

      PATH_PRF = 'prf_DOM/'
      II = 0
      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC

      NTOT  = 0
      NTOT2 = 0
      NTOT3 = 0
      NTOT4 = 0
      NTOT5 = 0
      NTOT6 = 0
      NTOT7 = 0
      NTOT8 = 0
      NTOT9 = 0
      NTOT10 = 0
      NTOT0 = 0
      NTOTT = 0
      NTOT13= 0
      NTOT_1= 0

      nw = 0
      nww = 0
      
      DO ID=1,NDOMAIN

        CODE8     = CODE_DOM(ID)

c ////
        IF(CODE8(6:7).NE.'_0') THEN
c        IF(CODE8(6:7).Eq.'_0') THEN
C NRES_DOM          
C RCBYR_DOM
C RINBYR_DOM
C PH_DOM
C PB_DOM
C RSBYR_DOM

c        IF(NRES_DOM(ID).ge.25.and.NRES_DOM(ID).le.50) THEN

c         IF(RSBYR_DOM(ID).Gt.1.53.or.
c     *      RSBYR_DOM(ID).lt.1.2.or.
c     *      RINBYR_DOM(ID).Gt.1.06.or.
c     *      RINBYR_DOM(ID).lt.0.74.or.
c     *      RCBYR_DOM(ID).gt.0.76.or.
c     *      RCBYR_DOM(ID).lt.0.57) THEN

          if(RCBYR_DOM(ID).lt.0.58) THEN

        WRITE(*,'(I6,'' '',A,I5,3F8.3,'' '',2F8.2)') 
     *  ID,CODE8,NRES_DOM(ID)
     *  ,RCBYR_DOM(ID),RINBYR_DOM(ID),RSBYR_DOM(ID)
     *  ,PH_DOM(ID),PB_DOM(ID)
          
         ENDIF
c        ENDIF

        ENDIF
        GO TO 200
c ////

c        ICLASS = ICLASS_DOM(ID)/100000
c        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*100000

        ICLASS = ICLASS_DOM(ID)/10000
        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*10000

        FILE_PRF =  CODE8(1:7)//'.prf'
        CALL LENSTR_BL(PATH_DB,LEN)
        CALL LENSTR_BL(FILE_PRF,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF = PATH_DB(1:LEN)//'/prf_DOM/'//FILE_PRF(1:LT) 
        ENDIF

        CALL LENSTR_BL(FILE_PRF,LEN )
        inquire(file=FILE_PRF(1:LEN),exist=ex,number=nfile)

        IF(ex) THEN

c          ITYPE_DOM(ID) = 2

          if(ISUB_CLASS.gt.0) then 
            write(*,*) '--warning:',id,code8,ICLASS_DOM(ID)
c            ITYPE_DOM(ID) =-1
            nw = nw + 1
          endif

        ELSE

c          if(ISUB_CLASS.eq.0) then 
c            write(*,*) '==warning:',id,code8,ICLASS_DOM(ID)
c            ITYPE_DOM(ID) =-1
c            nww = nww + 1
c          endif
          
          IF(ISUB_CLASS.EQ.0) THEN
c            ITYPE_DOM(ID) =-1
          ELSE
c            ITYPE_DOM(ID) = 0
          ENDIF
        ENDIF


        IF(ITYPE_DOM(ID).GT.0) THEN

c          IF(ISUB_CLASS.GT.0) THEN
c            ITYPE_DOM(ID) = 0
c            NTOT0 = NTOT0 + 1
c            GO TO 200
c          ENDIF

          II = II + 1

C         NSEG_DOM(ID) = 0

          FILE_PRF =  CODE8(1:7)//'.prf'
          CALL LENSTR_BL(PATH_DB,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_DB(1:LEN)//'/prf_DOM/'//FILE_PRF(1:LT) 
          ENDIF

          FILE_SCR = ' '

          CALL COPY_PROFILE(MDOC,CODE8
     *       ,NMODEL,FILE_PRF,FILE_SCR,IERR)
          IF(IERR.NE.0) THEN
            NTOT13 = NTOT13 + 1
            LINE = 'ERROR: code:'//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF

          NTOT  = NTOT + 1

C         NSEG_DOM(ID) = NMODEL

          NMD = NMODEL
          IF(NMD.GT.99) NMD = 99

c          ITYPE_DOM(ID) = NMD

          WRITE(LINE,'(3I6,A,A,2I5)') 
     *           II,NTOT,ID,' ',CODE8,NMODEL,NRES_DOM(ID)
          CALL MSGDOC(MDOC,LINE)

          IF(NMODEL.EQ.2) THEN
            NTOT2 = NTOT2 + 1
          ELSE IF(NMODEL.EQ.3) THEN
            NTOT3 = NTOT3 + 1
          ELSE IF(NMODEL.EQ.4) THEN
            NTOT4 = NTOT4 + 1
          ELSE IF(NMODEL.EQ.5) THEN
            NTOT5 = NTOT5 + 1
          ELSE IF(NMODEL.EQ.6) THEN
            NTOT6 = NTOT6 + 1
          ELSE IF(NMODEL.EQ.7) THEN
            NTOT7 = NTOT7 + 1
          ELSE IF(NMODEL.EQ.8) THEN
            NTOT8 = NTOT8 + 1
          ELSE IF(NMODEL.EQ.9) THEN
            NTOT9 = NTOT9 + 1
          ELSE IF(NMODEL.EQ.10) THEN
            NTOT10 = NTOT10 + 1
          ELSE
            NTOTT = NTOTT + 1
          ENDIF

        ELSE IF(ITYPE_DOM(ID).LT.0) THEN

          NTOT_1 = NTOT_1 + 1

        ELSE 

          NTOT0 = NTOT0 + 1

        ENDIF

  200   CONTINUE

      ENDDO

      WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT10
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot = 0:',NTOT0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
      CALL MSGDOC(MDOC,LINE)

      WRITE(*,'(A,I8)') 'Nw:',Nw
      WRITE(*,'(A,I8)') 'Nww:',Nww


        FILE_OUT = 'domain_descr_list.txt'
c       CALL WRITE_DOM_DESCR_LIST(MDOC,FILE_OUT
c     *    ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
c     *    ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
c     *    ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
c     *    ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
c     *    ,LINE_DOM,NDOMAIN,IERR)
c       IF(IERR.NE.0) GO TO 600

        WRITE(*,*) 
     *    '--OK : domain_descr_list.txt --> ../molrep/list/'


600   CONTINUE
      
C     deallocation

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

C ------
  800 CONTINUE
      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_PRF_DB_CLASS(MDOC,MODE
     *   ,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*256,FILE_LIST*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256,FILE_NMR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256,FILE_PRF*256
      CHARACTER FILE_OUT*256
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ---
      CHARACTER LINE*512,PATH*1,EXT*1,PATH_PRF*256
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
C ------
      FILE_LIST  = ' '
      FILE_PRF   = ' '
      FILE_NMR   = ' '
      FILE_SEQ   = ' '
      FILE_CORR  = ' '
      FILE_FIRST_CORR  = ' '

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

C
c     list/domain_descr_list.txt
C    

C     allocation        

      allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

C ---
      NDOMAIN  = NSEQMAX

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0) GO TO 600

      LEN_CODE = 7
      NSEQ     = NDOM
      WRITE(LINE,*) 'N_dom_db:',NDOM
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF

      PATH_PRF = 'prf_DOM/'
      II = 0
      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC

      NTOT  = 0
      NTOT2 = 0
      NTOT3 = 0
      NTOT4 = 0
      NTOT5 = 0
      NTOT6 = 0
      NTOT7 = 0
      NTOT8 = 0
      NTOT9 = 0
      NTOT0 = 0
      NTOT00= 0
      NTOTT = 0
      NTOT13= 0
      NTOT_1= 0
      
      DO ID=1,NDOMAIN
        CODE8     = CODE_DOM(ID)

c        ICLASS = ICLASS_DOM(ID)/100000
c        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*100000

        ICLASS = ICLASS_DOM(ID)/10000
        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*10000

C        IF(ITYPE_DOM(ID).GT.0) THEN

        ITYPE_DOM(ID) = 0

        IF(ISUB_CLASS.EQ.0) THEN

          II = II + 1

          ITYPE_DOM(ID) =-1

          FILE_SCR = ' '

          CALL CREATE_PRF_LIST(MMM
     *     ,CODE8,LEN_CODE
     *     ,ID_DOM,CODE_DOM,ICLASS_DOM,IBACK_DOM,NRES_DOM
     *     ,NDOMAIN
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *     ,ICLASS_LIST
     *     ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

          IF(IERR.NE.0) THEN
            IF(IERR.EQ.13) NTOT13 = NTOT13 + 1
            IF(IERR.NE.13) THEN
              LINE = 'ERROR: code:'//CODE8
              CALL MSGERR(MDOC,LINE)
            ENDIF
            IERR = 0
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          IF(NPRF.LE.1) THEN
            NTOT13 = NTOT13 + 1
            LINE = 'INFO: NPRF < 2 code:'//CODE8
C            CALL MSGERR(MDOC,LINE)
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          FILE_NMR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL LENSTR_BL(PATH_PRF,LEN)
          CALL LENSTR_BL(FILE_NMR,LT )
          IF(LEN.GT.0) THEN
            FILE_NMR = PATH_PRF(1:LEN)//FILE_NMR(1:LT) 
          ENDIF
          FILE_PRF = CODE8(1:LEN_CODE)//'.prf'
          CALL LENSTR_BL(PATH_PRF,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_PRF(1:LEN)//FILE_PRF(1:LT) 
          ENDIF
C         ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
          ICFLAG = 0
          CALL CREATE_PRF_NMR_FILES(MMM
     *     ,FILE_SEQ,FILE_FIRST_CORR,FILE_CORR,LEN_CODE
     *     ,NMODEL,FILE_NMR,FILE_PRF
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            IF(IERR.EQ.13) NTOT13 = NTOT13 + 1
            IF(IERR.NE.13) THEN 
              LINE = 'ERROR: code:'//CODE8
              CALL MSGERR(MDOC,LINE)
            ENDIF
            IERR = 0
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          NTOT  = NTOT + 1


          ITYPE_DOM(ID) = NMODEL

          WRITE(LINE,'(3I6,A,A,2I5,I12)') 
     *  II,NTOT,ID,' ',CODE8,NMODEL,NRES_DOM(ID),ICLASS_DOM(ID)
          CALL MSGDOC(MDOC,LINE)

          IF(NMODEL.EQ.2) THEN
            NTOT2 = NTOT2 + 1
          ELSE IF(NMODEL.EQ.3) THEN
            NTOT3 = NTOT3 + 1
          ELSE IF(NMODEL.EQ.4) THEN
            NTOT4 = NTOT4 + 1
          ELSE IF(NMODEL.EQ.5) THEN
            NTOT5 = NTOT5 + 1
          ELSE IF(NMODEL.EQ.6) THEN
            NTOT6 = NTOT6 + 1
          ELSE IF(NMODEL.EQ.7) THEN
            NTOT7 = NTOT7 + 1
          ELSE IF(NMODEL.EQ.8) THEN
            NTOT8 = NTOT8 + 1
          ELSE IF(NMODEL.EQ.9) THEN
            NTOT9 = NTOT9 + 1
          ELSE IF(NMODEL.EQ.10) THEN
            NTOT0 = NTOT0 + 1
          ELSE IF(NMODEL.EQ.0) THEN
            NTOT00 = NTOT00 + 1
          ELSE
            NTOTT = NTOTT + 1
          ENDIF

          FILE_SCR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL DELETE_FILE(PATH_PRF,FILE_SCR)

        ELSE
          NTOT00 = NTOT00 + 1
        ENDIF

  200   CONTINUE

      ENDDO


      WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot = 0:',NTOT00
      CALL MSGDOC(MDOC,LINE)



        FILE_OUT = 'domain_descr_list.txt'
        CALL WRITE_DOM_DESCR_LIST(MDOC,FILE_OUT
     *    ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *    ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *    ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *    ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *    ,LINE_DOM,NDOMAIN,IERR)
        IF(IERR.NE.0) GO TO 600

        WRITE(*,*) 
     *    '--OK : domain_descr_list.txt --> ../molrep/list/'

        FILE_PRF = 'prf_info.txt'
        CALL LENSTR_BL(PATH_PRF,LEN)
        CALL LENSTR_BL(FILE_PRF,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF = PATH_PRF(1:LEN)//FILE_PRF(1:LT) 
        ENDIF

        EXT  = ' '
        PATH = ' '
        IOUT = 17
        CALL OPENFW(IOUT,M,PATH,FILE_PRF,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,
     *         ' ERROR: cannot open output pdb file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF


        WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT0
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)


        END FILE IOUT
        CLOSE(IOUT)


600   CONTINUE
      
C     deallocation

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

C ------
  800 CONTINUE
      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_PRF_FILE(MDOC,MODE
     *   ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*(*),FILE_LIST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_NMR*256,FILE_PRF*256
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8,COMPLEX_LIST(NPRF_LIST)*10
C ---
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
C ---
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)
C ---
      CHARACTER LINE*512,PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
      FILE_CORR = ' '
      FILE_FIRST_CORR = ' '
      FILE_NMR = ' '
      FILE_PRF = ' '
C ------
      CALL LENSTR_BL(FILE_LIST,LEN)
      IF(LEN.GT.0) THEN
        IU   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IU,M,PATH,FILE_LIST,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: file_l : no such file')
          RETURN
        ENDIF
        NPRF = 0
        DO I=1,NPRF_LIST
          READ(IU,'(A)',ERR=910,END=110) LINE
          LINE = LINE(1:8)
          CALL LENSTR_BL(LINE,LEN)
          IF(LEN.LE.0) GO TO 100 
          IF(LINE(1:1).EQ.'#') GO TO 100
          IF(NPRF.LT.NMAX) THEN
            NPRF = NPRF + 1
            NRES_LIST(NPRF)  = 0
            INDEX_LIST(NPRF) = NPRF
            ICLASS_LIST(NPRF) = 0
            SCORE_LIST(NPRF) = 1.0
            Q_LIST(NPRF)     = 1.0
            SML_LIST(NPRF)   = 0.0
            IF(LEN.EQ.5) THEN
              IF(NPRF.EQ.1) LEN_CODE = 5
              LC = 5
            ELSE IF(LEN.GE.7) THEN
              IF(NPRF.EQ.1) LEN_CODE = 7
              LC = 7
            ELSE
              CALL MSGERR(MDOC,'ERROR: wrong CODE in file_l')
              IERR = 1
              CLOSE(IU)
              RETURN
            ENDIF
            IF(LC.NE.LEN_CODE) THEN
              CALL MSGERR(MDOC,'ERROR: wrong CODE in file_l')
              IERR = 1
              CLOSE(IU)
              RETURN
            ENDIF
            PRF_LIST(NPRF) = LINE(1:LEN)     
          ENDIF
  100     CONTINUE
        ENDDO
  110   CONTINUE
        CLOSE(IU)
        IF(NPRF.LE.1) THEN        
          CALL MSGERR(MDOC,'ERROR: file_l : N_code <2')
          IERR = 1
          RETURN
        ENDIF
        CLOSE(IU)
        GO TO 200
      ELSE
        CALL LENSTR_BL(CODE8,LEN)
        IF(LEN.EQ.5) THEN
          LEN_CODE = 5
        ELSE IF(LEN.GE.7) THEN
          LEN_CODE = 7
        ELSE
          CALL MSGERR(MDOC,'ERROR: wrong CODE')
          GO TO 900
        ENDIF
      ENDIF

      IF(LEN_CODE.EQ.7) THEN

        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF

        WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
        CALL MSGDOC(MDOC,LINE)
        IF(NSEQMAX.LE.0) THEN
          IERR = 1
          GO TO 900
        ENDIF

C
c       list/domain_descr_list.txt
C    

C       allocation        

        allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(LINE_DOM(1:3),STAT=ISTAT)

      
C ---
        NDOMAIN  = NSEQMAX

        CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
        IF(IERR.NE.0.OR.NDOM.LE.0) THEN
          IF(NDOM.LE.0) THEN
            WRITE(LINE,*) 'ERROR: N_dom_db:',NDOM
            CALL MSGERR(MDOC,LINE)
            IERR = 1
          ENDIF
          deallocate(ID_DOM,STAT=ISTAT)
          deallocate(NRES_DOM,STAT=ISTAT)
          deallocate(ITYPE_DOM,STAT=ISTAT)
          deallocate(NSEG_DOM,STAT=ISTAT)
          deallocate(ILEVEL_DOM,STAT=ISTAT)
          deallocate(IFORW_DOM,STAT=ISTAT)
          deallocate(IBACK_DOM,STAT=ISTAT)
          deallocate(ICLASS_DOM,STAT=ISTAT)
          deallocate(FBACK_DOM,STAT=ISTAT)
          deallocate(SCORE_DOM,STAT=ISTAT)
          deallocate(RAD_DOM,STAT=ISTAT)
          deallocate(RCBYR_DOM,STAT=ISTAT)
          deallocate(RINBYR_DOM,STAT=ISTAT)
          deallocate(PH_DOM,STAT=ISTAT)
          deallocate(PB_DOM,STAT=ISTAT)
          deallocate(RSBYR_DOM,STAT=ISTAT)
          deallocate(CODE_DOM,STAT=ISTAT)
          deallocate(LINE_DOM,STAT=ISTAT)
          GO TO 900
        ENDIF
        NSEQ     = NDOM
        WRITE(LINE,*) 'N_dom_db:',NDOM
        CALL MSGDOC(MDOC,LINE)

      ELSE
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_LIST_DB = PATH_DB(1:LEN)//'/list/chain_list.txt'

        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF
        WRITE(LINE,*) 'Memory for chain_list:',NSEQMAX
        CALL MSGDOC(MDOC,LINE)
        IF(NSEQMAX.LE.1) THEN
          IERR = 1
          GO TO 900
        ENDIF

        allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)

        I_MIN = 0
        I_MAX = 0
        CALL READ_CHAIN_LIST(MDOC,FILE_LIST_DB,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
        IF(IERR.NE.0.OR.NSEQ.LE.1) THEN
          IF(NSEQ.LE.1) THEN
            WRITE(LINE,*) 'ERROR: N_chain in chain_list:',NSEQ
            CALL MSGERR(MDOC,LINE)
            IERR = 1
          ENDIF
          deallocate(ID_DB,STAT=ISTAT)
          deallocate(NAA_DB,STAT=ISTAT)
          deallocate(NAT_DB,STAT=ISTAT)
          deallocate(NRES_DB,STAT=ISTAT)
          deallocate(IBACK_DB,STAT=ISTAT)
          deallocate(ILEVEL_DB,STAT=ISTAT)
          deallocate(IHIER_DB,STAT=ISTAT)
          deallocate(ICLASS_DB,STAT=ISTAT)
          deallocate(FBACK_DB,STAT=ISTAT)
          deallocate(RESOL_DB,STAT=ISTAT)
          deallocate(FIDENT_DB,STAT=ISTAT)
          deallocate(SCR_DB,STAT=ISTAT)
          deallocate(CODE_DB,STAT=ISTAT)
          deallocate(HIER_DB,STAT=ISTAT)
          deallocate(COMPLEX_DB,STAT=ISTAT)
          GO TO 900
        ENDIF

        WRITE(LINE,*) 'N_chain in chain_list:',NSEQ
        CALL MSGDOC(MDOC,LINE)

      ENDIF

      IF(LEN_CODE.EQ.7) THEN

        CALL CREATE_PRF_LIST(MDOC
     *   ,CODE8,LEN_CODE
     *   ,ID_DOM,CODE_DOM,ICLASS_DOM,IBACK_DOM,NRES_DOM
     *   ,NDOMAIN
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *   ,ICLASS_LIST
     *   ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

      ELSE

        CALL CREATE_PRF_LIST(MDOC
     *   ,CODE8,LEN_CODE
     *   ,ID_DB,CODE_DB,ICLASS_DB,IBACK_DB,NRES_DB
     *   ,NSEQ
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *   ,ICLASS_LIST
     *   ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
      ENDIF
      IF(LEN_CODE.EQ.7) THEN
        deallocate(ID_DOM,STAT=ISTAT)
        deallocate(NRES_DOM,STAT=ISTAT)
        deallocate(ITYPE_DOM,STAT=ISTAT)
        deallocate(NSEG_DOM,STAT=ISTAT)
        deallocate(ILEVEL_DOM,STAT=ISTAT)
        deallocate(IFORW_DOM,STAT=ISTAT)
        deallocate(IBACK_DOM,STAT=ISTAT)
        deallocate(ICLASS_DOM,STAT=ISTAT)
        deallocate(FBACK_DOM,STAT=ISTAT)
        deallocate(SCORE_DOM,STAT=ISTAT)
        deallocate(RAD_DOM,STAT=ISTAT)
        deallocate(RCBYR_DOM,STAT=ISTAT)
        deallocate(RINBYR_DOM,STAT=ISTAT)
        deallocate(PH_DOM,STAT=ISTAT)
        deallocate(PB_DOM,STAT=ISTAT)
        deallocate(RSBYR_DOM,STAT=ISTAT)
        deallocate(CODE_DOM,STAT=ISTAT)
        deallocate(LINE_DOM,STAT=ISTAT)
      ELSE
        deallocate(ID_DB,STAT=ISTAT)
        deallocate(NAA_DB,STAT=ISTAT)
        deallocate(NAT_DB,STAT=ISTAT)
        deallocate(NRES_DB,STAT=ISTAT)
        deallocate(IBACK_DB,STAT=ISTAT)
        deallocate(ILEVEL_DB,STAT=ISTAT)
        deallocate(IHIER_DB,STAT=ISTAT)
        deallocate(ICLASS_DB,STAT=ISTAT)
        deallocate(FBACK_DB,STAT=ISTAT)
        deallocate(RESOL_DB,STAT=ISTAT)
        deallocate(FIDENT_DB,STAT=ISTAT)
        deallocate(SCR_DB,STAT=ISTAT)
        deallocate(CODE_DB,STAT=ISTAT)
        deallocate(HIER_DB,STAT=ISTAT)
        deallocate(COMPLEX_DB,STAT=ISTAT)
      ENDIF

      IF(IERR.NE.0) THEN
        IF(IERR.NE.13) 
     *    CALL MSGERR(MDOC,'ERROR: in CREATE_PRF_LIST ')
        RETURN
      ENDIF

  200 CONTINUE

        IF(NPRF.LE.1) GO TO 800  
      
        FILE_CORR = CODE8(1:LEN_CODE)//'_corr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_CORR,LT )
        IF(LEN.GT.0) THEN
          FILE_CORR = PATH_SCR(1:LEN)//FILE_CORR(1:LT) 
        ENDIF

        IF(MODE.EQ.'P') THEN 
          FILE_NMR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL LENSTR_BL(PATH_OUT,LEN)
          CALL LENSTR_BL(FILE_NMR,LT )
          IF(LEN.GT.0) THEN
            FILE_NMR = PATH_OUT(1:LEN)//FILE_NMR(1:LT) 
          ENDIF
          FILE_PRF = CODE8(1:LEN_CODE)//'.prf'
          CALL LENSTR_BL(PATH_OUT,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_OUT(1:LEN)//FILE_PRF(1:LT) 
          ENDIF
C         ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
          ICFLAG = 0
          CALL CREATE_PRF_NMR_FILES(MDOC
     *     ,FILE_SEQ,FILE_FIRST_CORR,FILE_CORR,LEN_CODE
     *     ,NMODEL,FILE_NMR,FILE_PRF
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,'ERROR: in CREATE_PRF_NMR_FILES')
            GO TO 800
          ENDIF
          CALL LENSTR_BL(FILE_NMR,LT )
          LINE = 'NMR_file: '//FILE_NMR(1:LT)
          CALL MSGDOC(MDOC,LINE)
          CALL LENSTR_BL(FILE_PRF,LT )
          LINE = 'Prf_file: '//FILE_PRF(1:LT)
          CALL MSGDOC(MDOC,LINE)

        ELSE
          CALL CREATE_PROFILE_SEQ(MDOC,LIST
     *     ,PATH_DB,PATH_SCR,LEN_CODE
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,INDEX_LIST
     *     ,IERR)
          IF(IERR.NE.0) GO TO 800
        ENDIF 

C ------
  800 CONTINUE

      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
  910 CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input list file')
      CLOSE(IU)
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_PRF_FILE_CHAIN(MDOC
     *   ,CODE8,FILE_SEQ,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
C     CHARACTER COMPLEX*10
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)
C ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
C ---
      CHARACTER FILE_CRD*256,FILE_TEMP*256,FILE_XYZ*256,FILE_NMR*256
      CHARACTER FILE_LIST_DB*256
      CHARACTER COMPLEX*10
      CHARACTER LINE*512,PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      CALL LENSTR_BL(PATH_DB,LEN_DB)
C --
      FILE_LIST_DB = PATH_DB(1:LEN_DB)//'/list/chain_list.txt'
      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        RETURN
      ENDIF
      WRITE(LINE,*) 'Memory for chain_list:',NSEQMAX
c      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.1) THEN
        IERR = 1
        RETURN
      ENDIF

      allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)

      I_MIN = 0
      I_MAX = 0
      CALL READ_CHAIN_LIST(MDOC,FILE_LIST_DB,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0.OR.NSEQ.LE.1) THEN
        IF(NSEQ.LE.1) THEN
          WRITE(LINE,*) 'ERROR: N_chain in chain_list:',NSEQ
          CALL MSGERR(MDOC,LINE)
          IERR = 1
        ENDIF
        deallocate(ID_DB,STAT=ISTAT)
        deallocate(NAA_DB,STAT=ISTAT)
        deallocate(NAT_DB,STAT=ISTAT)
        deallocate(NRES_DB,STAT=ISTAT)
        deallocate(IBACK_DB,STAT=ISTAT)
        deallocate(ILEVEL_DB,STAT=ISTAT)
        deallocate(IHIER_DB,STAT=ISTAT)
        deallocate(ICLASS_DB,STAT=ISTAT)
        deallocate(FBACK_DB,STAT=ISTAT)
        deallocate(RESOL_DB,STAT=ISTAT)
        deallocate(FIDENT_DB,STAT=ISTAT)
        deallocate(SCR_DB,STAT=ISTAT)
        deallocate(CODE_DB,STAT=ISTAT)
        deallocate(HIER_DB,STAT=ISTAT)
        deallocate(COMPLEX_DB,STAT=ISTAT)
        RETURN
      ENDIF
      WRITE(LINE,*) 'N_chain in chain_list:',NSEQ
      CALL MSGDOC(MDOC,LINE)
      ICODE8 = 0
      DO I=1,NSEQ
        IF(CODE8(1:5).EQ.CODE_DB(I)(1:5)) THEN
          ICODE8 = I
          GO TO 100
        ENDIF
      ENDDO
  100 CONTINUE

      IF(ICODE8.GT.0) COMPLEX = COMPLEX_DB(ICODE8)

      deallocate(ID_DB,STAT=ISTAT)
      deallocate(NAA_DB,STAT=ISTAT)
      deallocate(NAT_DB,STAT=ISTAT)
      deallocate(NRES_DB,STAT=ISTAT)
      deallocate(IBACK_DB,STAT=ISTAT)
      deallocate(ILEVEL_DB,STAT=ISTAT)
      deallocate(IHIER_DB,STAT=ISTAT)
      deallocate(ICLASS_DB,STAT=ISTAT)
      deallocate(FBACK_DB,STAT=ISTAT)
      deallocate(RESOL_DB,STAT=ISTAT)
      deallocate(FIDENT_DB,STAT=ISTAT)
      deallocate(SCR_DB,STAT=ISTAT)
      deallocate(CODE_DB,STAT=ISTAT)
      deallocate(HIER_DB,STAT=ISTAT)
      deallocate(COMPLEX_DB,STAT=ISTAT)

      IF(ICODE8.LE.0) THEN

        RETURN
      ENDIF
C ----
      FILE_LIST_DB = PATH_DB(1:LEN_DB)//'/list/domain_descr_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NDOMAIN,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        RETURN
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_domain_db:',NDOMAIN
c     CALL MSGDOC(MDOC,LINE)
      IF(NDOMAIN.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      allocate(ID_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(NRES_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(NSEG_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(IFORW_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(IBACK_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(FBACK_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(SCORE_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(RAD_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(PH_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(PB_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(CODE_DOM(1:NDOMAIN),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)
C ---
      CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0.OR.NDOM.LE.0) THEN
        IF(NDOM.LE.0) THEN
          WRITE(LINE,*) 'ERROR: N_dom_db:',NDOM
          CALL MSGERR(MDOC,LINE)
          IERR = 1
        ENDIF
        deallocate(ID_DOM,STAT=ISTAT)
        deallocate(NRES_DOM,STAT=ISTAT)
        deallocate(ITYPE_DOM,STAT=ISTAT)
        deallocate(NSEG_DOM,STAT=ISTAT)
        deallocate(ILEVEL_DOM,STAT=ISTAT)
        deallocate(IFORW_DOM,STAT=ISTAT)
        deallocate(IBACK_DOM,STAT=ISTAT)
        deallocate(ICLASS_DOM,STAT=ISTAT)
        deallocate(FBACK_DOM,STAT=ISTAT)
        deallocate(SCORE_DOM,STAT=ISTAT)
        deallocate(RAD_DOM,STAT=ISTAT)
        deallocate(RCBYR_DOM,STAT=ISTAT)
        deallocate(RINBYR_DOM,STAT=ISTAT)
        deallocate(PH_DOM,STAT=ISTAT)
        deallocate(PB_DOM,STAT=ISTAT)
        deallocate(RSBYR_DOM,STAT=ISTAT)
        deallocate(CODE_DOM,STAT=ISTAT)
        deallocate(LINE_DOM,STAT=ISTAT)
        RETURN
      ENDIF
      WRITE(LINE,*) 'N_dom_db:',NDOMAIN
      CALL MSGDOC(MDOC,LINE)
C ----
      FILE_XYZ = PATH_DB(1:LEN_DB)//'/pdb_DB/'//CODE8(1:5)//'.xyz'
      FILE_CRD = CODE8(1:5)//'.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_CRD,LT )
      IF(LEN.GT.0) THEN
        FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
      ENDIF

      CALL PDB_UNPACK(MDOC,FILE_XYZ,FILE_CRD,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        GO TO 900
      ENDIF

      FILE_TEMP = 'mod_'//CODE8(1:5)//'_mono.pdb'
      CALL LENSTR_BL(PATH_OUT ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF
C     ierr=-1    set '-' in seg_id(76:76) (domains border)
      IERR = 0
      CALL SET_DOMAIN_INFO_TO_PDB(M,FILE_CRD,FILE_TEMP
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,CODE8,COMPLEX,IERR)
      IF(IERR.NE.0.OR.NDOM.LT.0) THEN
        NDOM = 0
        IERR = 0
      ELSE
        FILE_CRD = FILE_TEMP
      ENDIF
C ----
      FILE_NMR = CODE8(1:5)//'_nmr.pdb'
      CALL LENSTR_BL(PATH_OUT,LEN)
      CALL LENSTR_BL(FILE_NMR,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_OUT(1:LEN)//FILE_NMR(1:LT) 
      ENDIF

      CALL CREATE_NMR_FOR_CHAIN_V22(MDOC
     *   ,CODE8,NMODEL_MAX,FILE_NMR,FILE_CRD
     *   ,FILE_SEQ,NDOM
     *   ,NMAX,Q_LIM,WFLAG,FULL,LIST
     *   ,ID_DOM,CODE_DOM,ICLASS_DOM
     *   ,IBACK_DOM,NRES_DOM
     *   ,NDOMAIN
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0.OR.NMODEL_MAX.LE.1) THEN
        IF(IERR.NE.13) THEN
          LINE = ' ERROR: CREATE_NMR_FOR_CHAIN'
          CALL MSGERR(MDOC,LINE)
        ELSE
          LINE = ' INFO: no NMR file'
          CALL MSGERR(MDOC,LINE)
        ENDIF
      ELSE
        CALL MSGDOC(MDOC,' --  NMR file was created')
      ENDIF
C ----
  900 CONTINUE
      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)
C ------
      RETURN
      END

      SUBROUTINE CREATE_NMR_FOR_CHAIN_V22(MDOC
     *   ,CODE8,NMODEL_MAX,FILE_NMR,FILE_CORR
     *   ,FILE_SEQ,NDOM
     *   ,NMAX,Q_LIM,WFLAG,FULL,LIST
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR,NPRF
      CHARACTER CODE8*8
      CHARACTER FILE_NMR*(*),FILE_CORR*(*)
      CHARACTER FILE_SEQ*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
c ---
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C ---
      CHARACTER FILE_FIRST*256
      CHARACTER FILES*256,FILET*256
      CHARACTER FILE_PRF*256,FILE_SUM*256
      CHARACTER FILE_PRF_D*256

      CHARACTER LIST*1,WFLAG*1,FULL*1
      CHARACTER CODED*8,CODEC*8

      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8,COMPLEX_LIST(NPRF_LIST)*10
C ---
      PARAMETER ( NDOM_MAX = 20 )
      INTEGER   NMODEL_DOM(NDOM_MAX)
      CHARACTER FILE_NMR_D(NDOM_MAX)*256
C ---
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER LINE*512,CH1*1,CH2*2,ALIGN_CORR*1
      CHARACTER PAIR*1,DIST*1
      CHARACTER LETT*36
c                 123456789012345678901234567890123456
      DATA LETT /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/36/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------

C      Q_LIM = 0.3
C      NMAX  = 8
C      WFLAG = 'Y'
C      FULL  = 'N'
C      LIST  = 'S'
CCC    LIST  = 'L'

      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
      NPRF = 0
      NMODEL_MAX = 0

      DO ID=1,NDOM_MAX
        NMODEL_DOM(ID) = 0
        WRITE(CH2,'(I2)') ID
        IF(CH2(1:1).EQ.' ') CH2(1:1) = '_'
        LINE = 'nmr_domain_tmp'//CH2//'.pdb'
        CALL LENSTR_BL(LINE,LEN)
        FILE_NMR_D(ID) = LINE(1:LEN)
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_NMR_D(ID),LT )
        IF(LEN.GT.0) THEN
          FILE_NMR_D(ID) = PATH_SCR(1:LEN)//FILE_NMR_D(ID)(1:LT) 
        ENDIF
      ENDDO

      LEN_CODE_C = 5

      NNDOM = NDOM
      IF(NDOM.LE.0) NNDOM = 1
      NMR_DOM    = 0 
      NMODEL_MAX = 0      

      IF(NNDOM.GT.NDOM_MAX) THEN
        IERR = 0
        RETURN
      ENDIF      

      ALIGN_CORR = 'N'
      CODEC      = CODE8(1:5)//'   '
      FILES = ' '
      FILET = 'domain_scr.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILET,LT )
      IF(LEN.GT.0) THEN
        FILET = PATH_SCR(1:LEN)//FILET(1:LT) 
      ENDIF

      FILE_FIRST = 'pdb_first.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_FIRST,LT)
      IF(LEN.GT.0) THEN
        FILE_FIRST = PATH_SCR(1:LEN)//FILE_FIRST(1:LT) 
      ENDIF

      CALL GET_DOMAIN_ONE(M,PATH_DB
     *   ,FILE_FIRST,FILES,FILET
     *   ,CODEC,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in GET_DOMAIN_ONE'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        RETURN
      ENDIF
      
      FILE_PRF = 'prf_domain_sum.prf'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PRF,LT )
      IF(LEN.GT.0) THEN
        FILE_PRF = PATH_SCR(1:LEN)//FILE_PRF(1:LT) 
      ENDIF

c      write(*,*) '--nndom,codec:',nndom,':',codec,';'
c      write(*,*) '--ff',FILE_FIRST,':',code8,';'

      DO ID=1,NNDOM

        WRITE(LINE,'(A,I5,A,I5,A)') '------ Idom:',ID,'(',NNDOM,')'
        CALL MSGDOC(MDOC,LINE)

        IDD = ID
        IF(NDOM.LE.0) IDD = 0             

        CODED = CODE8
        WRITE(CODED(6:7),'(I2)') IDD
        IF(CODED(6:6).EQ.' ') CODED(6:6) = '_' 
        CODED(8:8) = '_'

        LEN_CODE_D = 7
        FILES = ' '

        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC

        CALL CREATE_PRF_LIST(MMM
     *     ,CODED,LEN_CODE_D
     *     ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *     ,IBACK_DOM_BASE,NRES_DOM_BASE
     *     ,NDOMAIN_BASE
     *     ,NMAX,NPRF_LIST,NPRFD,NRES_LIST,PRF_LIST
     *     ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *     ,ICLASS_LIST
     *     ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN 
            CALL MSGERR(MDOC,'ERROR: in CREATE_PRF_LIST. ')
          ENDIF
          IERR = 0
          GO TO 200
        ENDIF

        IF(NPRFD.LE.1) THEN
          CALL MSGERR(MDOC,'INFO: NPRFD < 2')
          IERR = 0
          GO TO 200   
        ENDIF

        INMR = NMR_DOM + 1

        FILE_PRF_D = 'prf_domain_temp.prf'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_PRF_D,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF_D = PATH_SCR(1:LEN)//FILE_PRF_D(1:LT) 
        ENDIF

        FILES = ' '
C       ICFLAG > 0 all models chain_ID = (ICFLAG), =0 A,B,C,D ....
        ICFLAG = ID

        write(*,*) '///1///'


        CALL CREATE_PRF_NMR_FILES(MDOC
     *     ,FILES,FILES,FILES,LEN_CODE_D
     *     ,NMODELD,FILE_NMR_D(INMR),FILE_PRF_D
     *     ,NMAX,NPRF_LIST,NPRFD,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

        write(*,*) '///2///'

        IF(IERR.NE.0.OR.NMODELD.LE.1) THEN
          IF(IERR.NE.13) THEN
            CALL MSGERR(MDOC,'ERROR: in CREATE_NMR_FILES.')
          ENDIF
          IERR = 0
          GO TO 200 
        ENDIF
        NMODEL_DOM(INMR) = NMODELD

c       FILE_PRF + FILE_PRF_D = FILES ('prf_temp.prf')

        FILES = 'prf_temp.prf'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILES,LT )
        IF(LEN.GT.0) THEN
          FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
        ENDIF

        IF(INMR.EQ.1) THEN
          FILET = FILE_FIRST
c        ELSE
c          FILET = FILE_PRF
c        ENDIF

        IPRINT = 0
        PO = 0.0
        PE = 0.01
        PAIR = 'N'
        DIST = 'N'
        IERR = 3

        IPRINT = 1

        CALL MAKE_ALIGN5D(Mdoc,IPRINT
     *        ,FILET,FILE_PRF_D,FILES
     *        ,PAIR,DIST,PO,PE
     *        ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 200 
        ENDIF

        ELSE
          FILET = FILE_PRF
          CALL JOIN_2PROFILES(MDOC,FILET,FILE_PRF_D,FILES,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in JOIN_2PROFILES: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200 
          ENDIF

        ENDIF


c        write(*,*) '-f:',FILE_PRF_D
c        write(*,*) '-f:',FILES
c        if(id.eq.3) stop

        NMR_DOM = NMR_DOM + 1

c       FILES --> FILE_PRF

        CALL COPY_PROFILE(MDOC,CODE8
     *     ,NSEQ_PROFILE,FILES,FILE_PRF,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in : COPY_PROFILE.'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          NMR_DOM = NMR_DOM - 1
          GO TO 200 
        ENDIF


        IF(NMODELD.GT.NMODEL_MAX) NMODEL_MAX = NMODELD


C        write(*,*) '--inmr,NMR_DOM:',INMR,NMR_DOM        
C        write(*,*) '--fn:',FILE_NMR_D(INMR)
C        write(*,*) '--fp:',FILE_PRF
C        write(*,*) '--fT:',FILET
C        write(*,*) '--fPD:',FILE_PRF_D
C        write(*,*) '--fs:',FILES

  200   CONTINUE

      ENDDO

      IF(NMODEL_MAX.LE.1.OR.NMR_DOM.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Nmodel_max < 2')
        IERR = 13
        GO TO 800   
      ENDIF

c      write(*,*) '--NMODEL_MAX,NMR_DOM:',NMODEL_MAX,NMR_DOM
c      write(*,*) '--NNDOM:',NNDOM

      IF(NNDOM.LE.1) THEN
        NM = 0
        CALL COPY_PDB_FILE(MDOC,NM,FILE_NMR_D(1),FILE_NMR,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in : COPY_PDB_FILE .'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 800 
        ENDIF
        GO TO 100
      ENDIF      

      FILE_SUM = 'pdb_sum.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_SUM,LT )
      IF(LEN.GT.0) THEN
        FILE_SUM = PATH_SCR(1:LEN)//FILE_SUM(1:LT) 
      ENDIF

      DO IM=1,NMODEL_MAX 
     
        DO ID=1,NNDOM

          IF(NMODEL_DOM(ID).GE.IM) THEN
            FILES = 'nmr_temp.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILES,LT )
            IF(LEN.GT.0) THEN
              FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
            ENDIF
            NM = IM
            CALL COPY_PDB_FILE(MDOC,NM,FILE_NMR_D(ID),FILES,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: copy file NMR temp -> NMR'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 800
            ENDIF

            IF(ID.GT.1) THEN
C             PDB_SUM + FILES --> FILET
              FILET = 'pdb_temp.pdb'
              CALL LENSTR_BL(PATH_SCR ,LEN)
              CALL LENSTR_BL(FILET,LT )
              IF(LEN.GT.0) THEN
                FILET = PATH_SCR(1:LEN)//FILET(1:LT) 
              ENDIF
              IFT    =-1
              ICFLAG =-1
              NM     = IM
              Q_FIN  = 0.0
              CALL JOIN_PDB_MODEL(MDOC,NM,IFT
     *               ,Q_FIN,ICFLAG,CODE8,CODE8
     *               ,FILE_SUM,FILES,FILET,IERR)
C ----
C     ICFLAG > 0 all ch_ID = (ICFLAG); =0 A,B,C,D ..; <0 save ch_ID
C     IFIRST  1 set MODEL rec for 1st file; 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file (save ch_ID); 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st file (save ch_ID); copy 2nd file: ch_ID see ICFLAG 
C ----
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: JOIN_PDB_MODEL pdb'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
C             copy FILET --> PDB_SUM 
              NM = 0
              CALL COPY_PDB_FILE(MDOC,NM,FILET,FILE_SUM,IERR)
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: copy filet -> SUM'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
            ELSE
C             copy 1st --> PDB_SUM 
              NM = 0
              CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_SUM,IERR)
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: copy 1st file -> SUM'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
            ENDIF
          ENDIF

        ENDDO

        IF(IM.EQ.1) THEN
C         copy FILE_SUM --> FILE_NMR
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILE_SUM,FILE_NMR,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy SUM -> NMR'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
        ELSE
C         FILE_NMR + FILE_SUM --> FILES
          FILES = 'nmr_temp.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILES,LT )
          IF(LEN.GT.0) THEN
            FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
          ENDIF
          IFT    = 1
          ICFLAG =-1
          NM     = IM
          Q_FIN  = 0.0
          CALL JOIN_PDB_MODEL(MDOC,NM,IFT
     *               ,Q_FIN,ICFLAG,CODE8,CODE8
     *               ,FILE_NMR,FILE_SUM,FILES,IERR)
C ----
C     ICFLAG > 0 all ch_ID = (ICFLAG); =0 A,B,C,D ..; <0 save ch_ID
C     IFIRST  1 set MODEL rec for 1st file; 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file (save ch_ID); 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st file (save ch_ID); copy 2nd file: ch_ID see ICFLAG 
C ----
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: JOIN_PDB_MODEL nmr'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
C         copy FILES --> FILE_NMR
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_NMR,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy files -> NMR'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
        ENDIF
 
      ENDDO
C ---

  100 CONTINUE

c      write(*,*) '--fs:',FILE_SEQ
c      write(*,*) '--ff:',FILE_FIRST
c      write(*,*) '--fp:',FILE_PRF
c      write(*,*) '--fc:',FILE_CORR

      CALL LENSTR_BL(FILE_SEQ,LEN)

      IF(LEN.LE.0) GO TO 810

      CALL CORRECTION_PDB_BY_PRF(MDOC
     *  ,FILE_SEQ,FILE_FIRST,FILE_PRF,FILE_CORR
     *  ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in : CORRECTION_PDB_BY_PRF'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

      FILES = 'nmr_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILES,LT )
      IF(LEN.GT.0) THEN
         FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
      ENDIF

      CALL REPLACE_FIRST_MODEL_IN_NMR(MDOC,CODE8
     *    ,FILE_CORR,FILE_NMR,FILES,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in : REPLACE_FIRST_MODEL'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

c      write(*,*) '=ff:',FILE_NMR
c      write(*,*) '=S:',FILES

      NM = 0
      CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_NMR,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: copy file NMR temp -> NMR'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

  810 CONTINUE

      CALL LENSTR_BL(FILE_PRF,LT )
      LINE = 'Prf_file: '//FILE_PRF(1:LT)
      CALL MSGDOC(MDOC,LINE)

      CALL LENSTR_BL(FILE_NMR,LT )
      LINE = 'Result: '//FILE_NMR(1:LT)
      CALL MSGDOC(MDOC,LINE)

C ------
  800 CONTINUE

      DO ID=1,NDOM_MAX
        WRITE(CH2,'(I2)') ID
        IF(CH2(1:1).EQ.' ') CH2(1:1) = '_'
        LINE = 'nmr_domain_tmp'//CH2//'.pdb'
        CALL LENSTR_BL(LINE,LEN)
        FILES = LINE(1:LEN)
        CALL DELETE_FILE(PATH_SCR,FILES)
      ENDDO
      FILES = 'prf_domain_temp.prf'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'prf_temp.prf'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'nmr_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_sum.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_first.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'domain_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
c      FILES = 'prf_domain_sum.prf'
c      CALL DELETE_FILE(PATH_SCR,FILES)
 
      RETURN
      END

      SUBROUTINE JOIN_2PROFILES(MDOC
     *   ,FILE_PRF1,FILE_PRF,FILE_OUT
     *   ,IERR)
C ------------------------------
      CHARACTER FILE_PRF1*(*),FILE_PRF*(*),FILE_OUT*(*)
      CHARACTER PNP*6
      CHARACTER LINE*512
c ---
      character(LEN=77), allocatable :: PRF1(:)
      character(LEN=6), allocatable :: PNUM1(:)
c ---
      CHARACTER PATH*1,EXT*1
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      CALL LENSTR_BL(FILE_PRF1,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MD,' ERROR: wrong PRF1 file name')
        IERR = 1
        RETURN
      ENDIF
      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PRF1,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF1 file')
        IERR = 1
        RETURN
      ENDIF
C ----
      NAA1 = 0
      READ(IN1,'(A)',ERR=900) LINE
      READ(IN1,'(A)',ERR=900) LINE
      READ(IN1,'(A)',ERR=900) LINE
      DO I=1,1000000
        READ(IN1,'(A)',ERR=900,END=1000) LINE
        NAA1 = NAA1 + 1
      ENDDO
 1000 CONTINUE
      CLOSE(IN1) 
      IF(NAA1.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: NAA1 < 1')
        IERR = 1
        RETURN
      ENDIF

      allocate(PNUM1(1:NAA1),STAT=ISTAT)
      allocate(PRF1(1:NAA1),STAT=ISTAT)

      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PRF1,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF1 file')
        IERR = 1
        GO TO 930
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 32
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output PRF file')
        CLOSE(IN1)
        IERR = 1
        GO TO 930
      ENDIF

      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)
      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)
      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)

      DO I=1,NAA1
        READ(IN1,'(A)',ERR=901,END=1010) LINE
        PRF1(I)  = LINE(1:77)
        PNUM1(I) = LINE(63:68)
      ENDDO

 1010 CONTINUE
      CLOSE(IN1) 
C -----------
      CALL LENSTR_BL(FILE_PRF,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MD,' ERROR: wrong PRF file name')
        CLOSE(IOUT)
        IERR = 1
        RETURN
      ENDIF
      EXT  = ' '
      PATH = ' '
      IN2 = 31
      CALL OPENFR(IN2,M,PATH,FILE_PRF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF file')
        IERR = 1
        GO TO 930
      ENDIF
      READ(IN2,'(A)',ERR=910) LINE
      READ(IN2,'(A)',ERR=910) LINE
      READ(IN2,'(A)',ERR=910) LINE
C ---
      DO IP=1,100000
        READ(IN2,'(A)',ERR=910,END=100) LINE
        PNP = LINE(63:68)
        DO IP1=1,NAA1
          IF(PNP.EQ.PNUM1(IP1)) THEN
            PRF1(IP1) = LINE(1:77)
            GO TO 200
          ENDIF
        ENDDO
200     CONTINUE
      ENDDO
100   CONTINUE
      DO IP1=1,NAA1
        WRITE(IOUT,'(A)',ERR=920) PRF1(IP1)
      ENDDO
c ----
      CLOSE(IN2)
      END FILE IOUT
      CLOSE(IOUT)

  930 CONTINUE

      deallocate(PNUM1,STAT=ISTAT)
      deallocate(PRF1,STAT=ISTAT)

      RETURN
C ----
  900 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF1 file')
      CLOSE(IN1)
      IERR =1
      RETURN
  901 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF1 file')
      CLOSE(IOUT)
      CLOSE(IN1)
      IERR =1
      GO TO 930
  910 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF file')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  915 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF from LINE')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  920 CONTINUE
      CALL MSGERR(MD,' ERROR: write output PRF file')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  905 CONTINUE
      CALL MSGERR(MD,' ERROR: write output PRF file')
      CLOSE(IOUT)
      CLOSE(IN1)
      IERR =1
      GO TO 930
      END 

