C --- GET_NMR.f---
C --------------------------------------------------------------------
      CHARACTER MODE*1,CODE*8
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_SEQ*256,FILE_LIST*256,LIST*1,WFLAG*1,FULL*1
C
      CHARACTER LINE*256,PROG*80
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'get_nmr'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  GET_NMR ---  V.03.12.2008/')
      CALL MSGDOC(MDOC,' ')
C ---------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NMAX  = 0
      Q_LIM = 0
      CODE = '     '
      LIST = ' '
      FULL = ' '
      FILE_SEQ  = ' '
      FILE_LIST = ' '
      WFLAG    = ' '
      CALL SET_DEFAULT(' ')
C ---
      CALL SET_DEFAULT(
     *'MODE: <D>,P,S,M  D - create domain/chain file')
      CALL SET_DEFAULT(
     *'                 P - create NMR and seq profile')
      CALL SET_DEFAULT(
     *'                 S - create prf_DOM,')
      CALL SET_DEFAULT(
     *'                          before create empty dir: prf_DOM')
      CALL SET_DEFAULT(
     *'                 M - create multimer files')
      CALL SET_DEFAULT('CODE:  < >     - domain/chain code')
      CALL SET_DEFAULT('SEQ:   < >     - domain/chain sequence file')
      CALL SET_DEFAULT('QLIM:  <0.3>   - Alignment Quality limit')
      CALL SET_DEFAULT('NMAX:  <10>    - ')
      CALL SET_DEFAULT('W:     <Y>,N   - use Q as weight(OCC), mode P')
      CALL SET_DEFAULT('FULL:  <N>,Y   - full output file, mode P')
      CALL SET_DEFAULT('FILE_L:  < >   - file with domain/chain list')
      CALL SET_DEFAULT('LIST:  <S>,L   - Short, Long ')
      CALL SET_DEFAULT(
     *  'PATH_SCR: < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BL(PATH_SCR)
C ----
      LINE='MODE'
      CALL ASK(LINE)
      MODE = LINE(1:1)
      IF(MODE.EQ.'p') MODE = 'P'
      IF(MODE.EQ.'s') MODE = 'S'
      IF(MODE.EQ.'d') MODE = 'D'
      IF(MODE.EQ.'m') MODE = 'M'
      IF(MODE.NE.'P'.AND.MODE.NE.'M'.AND.MODE.NE.'S') MODE = 'D'
C ----
      LINE='LIST'
      CALL ASK(LINE)
      LIST = LINE(1:1)
      IF(LIST.EQ.'s') LIST = 'S'
      IF(LIST.EQ.'l') LIST = 'L'
      IF(LIST.NE.'L') LIST = 'S'
C ----
      LINE='FULL'
      CALL ASK(LINE)
      FULL = LINE(1:1)
      IF(FULL.EQ.'y') FULL = 'Y'
      IF(FULL.EQ.'n') FULL = 'N'
      IF(FULL.NE.'Y') FULL = 'N'
C ----
      LINE='W'
      CALL ASK(LINE)
      WFLAG = LINE(1:1)
      IF(WFLAG.EQ.'n') WFLAG = 'N'
      IF(WFLAG.EQ.'y') WFLAG = 'Y'
      IF(WFLAG.NE.'N') WFLAG = 'Y'
C ----
      LINE='CODE'
      CALL ASK(LINE)
      CODE = LINE(1:7)         
      IF(CODE(1:1).EQ.',') CODE = '        '
      CALL CORR_NAME_BL(CODE)
C ----
      LINE='SEQ'
      CALL ASK(LINE)
      FILE_SEQ = LINE
      CALL CORR_NAME_BL(FILE_SEQ)
C ----
      LINE='FILE_L'
      CALL ASK(LINE)
      FILE_LIST = LINE
      CALL CORR_NAME_BL(FILE_LIST)
C ----
      LINE='QLIM'
      CALL ASK(LINE)
      READ(LINE,*) Q_LIM
      IF(LINE(1:1).EQ.',') Q_LIM = 0.3
C ----
      LINE='NMAX'
      CALL ASK(LINE)
      READ(LINE,*) NMAX
      IF(NMAX.LE.0) NMAX = 10
C ---
      CALL CLOSE_BATCH(MDOC)
C ---------------------------------
      CALL GET_NMR(MDOC,MODE
     *   ,CODE,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_OUT,PATH_SCR,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE GET_NMR(MDOC,MODE
     *   ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512
      CHARACTER FILE_TEMP*256,FILE_CRD*256,FILE_PDB*256
      CHARACTER FILE_SEQ*(*),FILE_LIST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*256
C ---
      CHARACTER MODE*1,LIST*1,WFLAG*1,FULL*1
      CHARACTER CODE8*8,PATH*1,EXT*1,ALIGN_CORR*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERR: setenv MOLREP_DB'      
        CALL MSGERR(MD,LINE)
        LINE = '     Example: "setenv MOLREP_DB ~alexei/molrep_DB" '      
        CALL MSGERR(MD,LINE)
        GO TO 900
      ENDIF
      FILE_CRD = ' '
      IF(NMAX.LE.0) NMAX = 10
      IF(Q_LIM.LT.0.0001) Q_LIM = 0.3
C ---
      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        IU   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IU,M,PATH,FILE_SEQ,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: SEQ file: no such file')
          RETURN
        ENDIF
        CLOSE(IU)
      ENDIF

      IF(MODE.EQ.'P') THEN
        CALL LENSTR_BL(FILE_LIST,LEN)
        IF(LEN.GT.0) THEN
          IU   = 10
          EXT  = ' '
          PATH = ' '
          CALL OPENFR(IU,M,PATH,FILE_LIST,EXT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: file_l : no such file')
            RETURN
          ENDIF
          CLOSE(IU)
c          CODE8 = ' ' 
        ELSE
          CALL LENSTR_BL(CODE8,LEN)
          IF(LEN.LT.5) THEN
            CALL MSGERR(MDOC,'ERROR: wrong code')
            IERR = 1
            RETURN
          ENDIF
          FILE_LIST = ' '
        ENDIF
      ELSE
        IF(MODE.NE.'S') THEN
          CALL LENSTR_BL(CODE8,LEN)
          IF(LEN.LT.5) THEN
            CALL MSGERR(MDOC,'ERROR: wrong code')
            IERR = 1
            RETURN
          ENDIF
          FILE_LIST = ' '
        ENDIF
      ENDIF

      IF(MODE.EQ.'P') THEN

        IF(MODE.EQ.'P') THEN
          CALL MSGDOC(MDOC,'------ create NMR and seq profile ------')
        ELSE
          CALL MSGDOC(MDOC,'------ create seq profile ------')
        ENDIF

        CALL LENSTR_BL(CODE8,LEN)

        CALL CREATE_PRF_FILE(MDOC,MODE
     *     ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN
            LINE = ' ERROR: in CREATE_PRF_FILE'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          GO TO 900
        ENDIF

      ELSE IF(MODE.EQ.'S') THEN

        CALL MSGDOC(MDOC,'------ create prf_DOM ------')

c        CALL CREATE_PRF_DB_CLASS(MDOC,MODE
c        CALL CREATE_PRF_DB(MDOC,MODE
        CALL CREATE_PRF_DB_CLASS(MDOC,MODE
     *    ,Q_LIM,NMAX,WFLAG,FULL
     *    ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in CREATE_PRF_DB'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

      ELSE IF(MODE.EQ.'M') THEN
        CALL MSGDOC(MDOC,'------ create multimer files ------')

        CALL CREATE_MULTIMER_FILES(MDOC,PATH_DB
     *     ,FILE_TEMP,FILE_SEQ
     *     ,FILE_CRD
     *     ,CODE8
     *     ,LIST,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN
            LINE = ' ERROR: in CREATE_MULTIMER_FILES'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          GO TO 900
        ENDIF

      ELSE
        CALL MSGDOC(MDOC,'------ get domain/chain ------')

        CALL LENSTR_BL(CODE8,LEN)
        IF(LEN.GT.7) LEN = 7
        FILE_TEMP = CODE8(1:LEN)//'.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        ENDIF

C       FILE_TEMP output one domain file
C       FILE_CRD  output all domains file
        ALIGN_CORR = 'Y'
        CALL GET_DOMAIN_ONE(MDOC,PATH_DB
     *   ,FILE_TEMP,FILE_SEQ
     *   ,FILE_CRD
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOMAIN_ONE'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

        FILE_PDB = 'domains_coot.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_PDB = PATH_OUT(1:LEN)//FILE_PDB(1:LT) 
        ENDIF

        CALL DOMAIN2CHAIN_FOR_COOT(MDOC,FILE_CRD,FILE_PDB,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in DOMAIN2CHAIN_FOR_COOT'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 900
        ENDIF

        CALL LENSTR_BL(FILE_CRD,LT )
        LINE = 'File all domains : '//FILE_CRD(1:LT)
        CALL MSGDOC(MDOC,LINE)
        CALL LENSTR_BL(FILE_PDB,LT )
        LINE = 'File for coot    : '//FILE_PDB(1:LT)
        CALL MSGDOC(MDOC,LINE)

      ENDIF
C ---

      RETURN
  900 CONTINUE
      RETURN
      END

      SUBROUTINE CREATE_PRF_DB(MDOC,MODE
     *   ,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*256,FILE_LIST*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256,FILE_NMR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256,FILE_PRF*256
      CHARACTER FILE_OUT*256
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ---
      CHARACTER LINE*512,PATH*1,EXT*1,PATH_PRF*256
      logical ex
      integer nfile
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
C ------
      FILE_LIST  = ' '
      FILE_PRF   = ' '
      FILE_NMR   = ' '
      FILE_SEQ   = ' '
      FILE_CORR  = ' '
      FILE_FIRST_CORR  = ' '

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

C
c     list/domain_descr_list.txt
C    

C     allocation        

      allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

C ---
      NDOMAIN  = NSEQMAX

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0) GO TO 600

      LEN_CODE = 7
      NSEQ     = NDOM
      WRITE(LINE,*) 'N_dom_db:',NDOM
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF

      PATH_PRF = 'prf_DOM/'
      II = 0
      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC

      NTOT  = 0
      NTOT2 = 0
      NTOT3 = 0
      NTOT4 = 0
      NTOT5 = 0
      NTOT6 = 0
      NTOT7 = 0
      NTOT8 = 0
      NTOT9 = 0
      NTOT10 = 0
      NTOT0 = 0
      NTOTT = 0
      NTOT13= 0
      NTOT_1= 0

      nw = 0
      nww = 0
      
      DO ID=1,NDOMAIN

        CODE8     = CODE_DOM(ID)

c ////
        IF(CODE8(6:7).NE.'_0') THEN
c        IF(CODE8(6:7).Eq.'_0') THEN
C NRES_DOM          
C RCBYR_DOM
C RINBYR_DOM
C PH_DOM
C PB_DOM
C RSBYR_DOM

c        IF(NRES_DOM(ID).ge.25.and.NRES_DOM(ID).le.50) THEN

c         IF(RSBYR_DOM(ID).Gt.1.53.or.
c     *      RSBYR_DOM(ID).lt.1.2.or.
c     *      RINBYR_DOM(ID).Gt.1.06.or.
c     *      RINBYR_DOM(ID).lt.0.74.or.
c     *      RCBYR_DOM(ID).gt.0.76.or.
c     *      RCBYR_DOM(ID).lt.0.57) THEN

          if(RCBYR_DOM(ID).lt.0.58) THEN

        WRITE(*,'(I6,'' '',A,I5,3F8.3,'' '',2F8.2)') 
     *  ID,CODE8,NRES_DOM(ID)
     *  ,RCBYR_DOM(ID),RINBYR_DOM(ID),RSBYR_DOM(ID)
     *  ,PH_DOM(ID),PB_DOM(ID)
          
         ENDIF
c        ENDIF

        ENDIF
        GO TO 200
c ////

c        ICLASS = ICLASS_DOM(ID)/100000
c        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*100000

        ICLASS = ICLASS_DOM(ID)/10000
        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*10000

        FILE_PRF =  CODE8(1:7)//'.prf'
        CALL LENSTR_BL(PATH_DB,LEN)
        CALL LENSTR_BL(FILE_PRF,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF = PATH_DB(1:LEN)//'/prf_DOM/'//FILE_PRF(1:LT) 
        ENDIF

        CALL LENSTR_BL(FILE_PRF,LEN )
        inquire(file=FILE_PRF(1:LEN),exist=ex,number=nfile)

        IF(ex) THEN

c          ITYPE_DOM(ID) = 2

          if(ISUB_CLASS.gt.0) then 
            write(*,*) '--warning:',id,code8,ICLASS_DOM(ID)
c            ITYPE_DOM(ID) =-1
            nw = nw + 1
          endif

        ELSE

c          if(ISUB_CLASS.eq.0) then 
c            write(*,*) '==warning:',id,code8,ICLASS_DOM(ID)
c            ITYPE_DOM(ID) =-1
c            nww = nww + 1
c          endif
          
          IF(ISUB_CLASS.EQ.0) THEN
c            ITYPE_DOM(ID) =-1
          ELSE
c            ITYPE_DOM(ID) = 0
          ENDIF
        ENDIF


        IF(ITYPE_DOM(ID).GT.0) THEN

c          IF(ISUB_CLASS.GT.0) THEN
c            ITYPE_DOM(ID) = 0
c            NTOT0 = NTOT0 + 1
c            GO TO 200
c          ENDIF

          II = II + 1

C         NSEG_DOM(ID) = 0

          FILE_PRF =  CODE8(1:7)//'.prf'
          CALL LENSTR_BL(PATH_DB,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_DB(1:LEN)//'/prf_DOM/'//FILE_PRF(1:LT) 
          ENDIF

          FILE_SCR = ' '

          CALL COPY_PROFILE(MDOC,CODE8
     *       ,NMODEL,FILE_PRF,FILE_SCR,IERR)
          IF(IERR.NE.0) THEN
            NTOT13 = NTOT13 + 1
            LINE = 'ERROR: code:'//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF

          NTOT  = NTOT + 1

C         NSEG_DOM(ID) = NMODEL

          NMD = NMODEL
          IF(NMD.GT.99) NMD = 99

c          ITYPE_DOM(ID) = NMD

          WRITE(LINE,'(3I6,A,A,2I5)') 
     *           II,NTOT,ID,' ',CODE8,NMODEL,NRES_DOM(ID)
          CALL MSGDOC(MDOC,LINE)

          IF(NMODEL.EQ.2) THEN
            NTOT2 = NTOT2 + 1
          ELSE IF(NMODEL.EQ.3) THEN
            NTOT3 = NTOT3 + 1
          ELSE IF(NMODEL.EQ.4) THEN
            NTOT4 = NTOT4 + 1
          ELSE IF(NMODEL.EQ.5) THEN
            NTOT5 = NTOT5 + 1
          ELSE IF(NMODEL.EQ.6) THEN
            NTOT6 = NTOT6 + 1
          ELSE IF(NMODEL.EQ.7) THEN
            NTOT7 = NTOT7 + 1
          ELSE IF(NMODEL.EQ.8) THEN
            NTOT8 = NTOT8 + 1
          ELSE IF(NMODEL.EQ.9) THEN
            NTOT9 = NTOT9 + 1
          ELSE IF(NMODEL.EQ.10) THEN
            NTOT10 = NTOT10 + 1
          ELSE
            NTOTT = NTOTT + 1
          ENDIF

        ELSE IF(ITYPE_DOM(ID).LT.0) THEN

          NTOT_1 = NTOT_1 + 1

        ELSE 

          NTOT0 = NTOT0 + 1

        ENDIF

  200   CONTINUE

      ENDDO

      WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT10
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot = 0:',NTOT0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
      CALL MSGDOC(MDOC,LINE)

      WRITE(*,'(A,I8)') 'Nw:',Nw
      WRITE(*,'(A,I8)') 'Nww:',Nww


        FILE_OUT = 'domain_descr_list.txt'
c       CALL WRITE_DOM_DESCR_LIST(MDOC,FILE_OUT
c     *    ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
c     *    ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
c     *    ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
c     *    ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
c     *    ,LINE_DOM,NDOMAIN,IERR)
c       IF(IERR.NE.0) GO TO 600

        WRITE(*,*) 
     *    '--OK : domain_descr_list.txt --> ../molrep/list/'


600   CONTINUE
      
C     deallocation

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

C ------
  800 CONTINUE
      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_PRF_DB_CLASS(MDOC,MODE
     *   ,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*256,FILE_LIST*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256,FILE_NMR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256,FILE_PRF*256
      CHARACTER FILE_OUT*256
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ---
      CHARACTER LINE*512,PATH*1,EXT*1,PATH_PRF*256
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
C ------
      FILE_LIST  = ' '
      FILE_PRF   = ' '
      FILE_NMR   = ' '
      FILE_SEQ   = ' '
      FILE_CORR  = ' '
      FILE_FIRST_CORR  = ' '

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

C
c     list/domain_descr_list.txt
C    

C     allocation        

      allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

C ---
      NDOMAIN  = NSEQMAX

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0) GO TO 600

      LEN_CODE = 7
      NSEQ     = NDOM
      WRITE(LINE,*) 'N_dom_db:',NDOM
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF

      PATH_PRF = 'prf_DOM/'
      II = 0
      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC

      NTOT  = 0
      NTOT2 = 0
      NTOT3 = 0
      NTOT4 = 0
      NTOT5 = 0
      NTOT6 = 0
      NTOT7 = 0
      NTOT8 = 0
      NTOT9 = 0
      NTOT0 = 0
      NTOT00= 0
      NTOTT = 0
      NTOT13= 0
      NTOT_1= 0
      
      DO ID=1,NDOMAIN
        CODE8     = CODE_DOM(ID)

c        ICLASS = ICLASS_DOM(ID)/100000
c        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*100000

        ICLASS = ICLASS_DOM(ID)/10000
        ISUB_CLASS = ICLASS_DOM(ID) - ICLASS*10000

C        IF(ITYPE_DOM(ID).GT.0) THEN

        ITYPE_DOM(ID) = 0

        IF(ISUB_CLASS.EQ.0) THEN

          II = II + 1

          ITYPE_DOM(ID) =-1

          FILE_SCR = ' '

          CALL CREATE_PRF_LIST(MMM
     *     ,CODE8,LEN_CODE
     *     ,ID_DOM,CODE_DOM,ICLASS_DOM,IBACK_DOM,NRES_DOM
     *     ,NDOMAIN
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *     ,ICLASS_LIST
     *     ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

          IF(IERR.NE.0) THEN
            IF(IERR.EQ.13) NTOT13 = NTOT13 + 1
            IF(IERR.NE.13) THEN
              LINE = 'ERROR: code:'//CODE8
              CALL MSGERR(MDOC,LINE)
            ENDIF
            IERR = 0
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          IF(NPRF.LE.1) THEN
            NTOT13 = NTOT13 + 1
            LINE = 'INFO: NPRF < 2 code:'//CODE8
C            CALL MSGERR(MDOC,LINE)
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          FILE_NMR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL LENSTR_BL(PATH_PRF,LEN)
          CALL LENSTR_BL(FILE_NMR,LT )
          IF(LEN.GT.0) THEN
            FILE_NMR = PATH_PRF(1:LEN)//FILE_NMR(1:LT) 
          ENDIF
          FILE_PRF = CODE8(1:LEN_CODE)//'.prf'
          CALL LENSTR_BL(PATH_PRF,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_PRF(1:LEN)//FILE_PRF(1:LT) 
          ENDIF
C         ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
          ICFLAG = 0
          CALL CREATE_PRF_NMR_FILES(MMM
     *     ,FILE_SEQ,FILE_FIRST_CORR,FILE_CORR,LEN_CODE
     *     ,NMODEL,FILE_NMR,FILE_PRF
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            IF(IERR.EQ.13) NTOT13 = NTOT13 + 1
            IF(IERR.NE.13) THEN 
              LINE = 'ERROR: code:'//CODE8
              CALL MSGERR(MDOC,LINE)
            ENDIF
            IERR = 0
            ITYPE_DOM(ID) =-1
            NTOT_1 = NTOT_1 + 1
            GO TO 200
          ENDIF

          NTOT  = NTOT + 1


          ITYPE_DOM(ID) = NMODEL

          WRITE(LINE,'(3I6,A,A,2I5,I12)') 
     *  II,NTOT,ID,' ',CODE8,NMODEL,NRES_DOM(ID),ICLASS_DOM(ID)
          CALL MSGDOC(MDOC,LINE)

          IF(NMODEL.EQ.2) THEN
            NTOT2 = NTOT2 + 1
          ELSE IF(NMODEL.EQ.3) THEN
            NTOT3 = NTOT3 + 1
          ELSE IF(NMODEL.EQ.4) THEN
            NTOT4 = NTOT4 + 1
          ELSE IF(NMODEL.EQ.5) THEN
            NTOT5 = NTOT5 + 1
          ELSE IF(NMODEL.EQ.6) THEN
            NTOT6 = NTOT6 + 1
          ELSE IF(NMODEL.EQ.7) THEN
            NTOT7 = NTOT7 + 1
          ELSE IF(NMODEL.EQ.8) THEN
            NTOT8 = NTOT8 + 1
          ELSE IF(NMODEL.EQ.9) THEN
            NTOT9 = NTOT9 + 1
          ELSE IF(NMODEL.EQ.10) THEN
            NTOT0 = NTOT0 + 1
          ELSE IF(NMODEL.EQ.0) THEN
            NTOT00 = NTOT00 + 1
          ELSE
            NTOTT = NTOTT + 1
          ENDIF

          FILE_SCR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL DELETE_FILE(PATH_PRF,FILE_SCR)

        ELSE
          NTOT00 = NTOT00 + 1
        ENDIF

  200   CONTINUE

      ENDDO


      WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT0
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)') 'Ntot = 0:',NTOT00
      CALL MSGDOC(MDOC,LINE)



        FILE_OUT = 'domain_descr_list.txt'
        CALL WRITE_DOM_DESCR_LIST(MDOC,FILE_OUT
     *    ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *    ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *    ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *    ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *    ,LINE_DOM,NDOMAIN,IERR)
        IF(IERR.NE.0) GO TO 600

        WRITE(*,*) 
     *    '--OK : domain_descr_list.txt --> ../molrep/list/'

        FILE_PRF = 'prf_info.txt'
        CALL LENSTR_BL(PATH_PRF,LEN)
        CALL LENSTR_BL(FILE_PRF,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF = PATH_PRF(1:LEN)//FILE_PRF(1:LT) 
        ENDIF

        EXT  = ' '
        PATH = ' '
        IOUT = 17
        CALL OPENFW(IOUT,M,PATH,FILE_PRF,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,
     *         ' ERROR: cannot open output pdb file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF


        WRITE(LINE,'(A,I8)') 'Ntot    :',NTOT
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 2  :',NTOT2
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 3  :',NTOT3
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 4  :',NTOT4
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 5  :',NTOT5
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 6  :',NTOT6
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 7  :',NTOT7
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 8  :',NTOT8
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 9  :',NTOT9
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot 10 :',NTOT0
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot >10:',NTOTT
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot < 2:',NTOT13
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        WRITE(LINE,'(A,I8)') 'Ntot < 0:',NTOT_1
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)


        END FILE IOUT
        CLOSE(IOUT)


600   CONTINUE
      
C     deallocation

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

C ------
  800 CONTINUE
      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_PRF_FILE(MDOC,MODE
     *   ,CODE8,FILE_SEQ,FILE_LIST,Q_LIM,NMAX,WFLAG,FULL
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1,MODE*1,WFLAG*1,FULL*1
      CHARACTER FILE_SEQ*(*),FILE_LIST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      CHARACTER FILE_NMR*256,FILE_PRF*256
      CHARACTER FILE_LIST_DB*256,FILE_SCR*256
      CHARACTER FILE_FIRST_CORR*256,FILE_CORR*256
c ---
      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8,COMPLEX_LIST(NPRF_LIST)*10
C ---
c ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
C ---
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)
C ---
      CHARACTER LINE*512,PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
      FILE_CORR = ' '
      FILE_FIRST_CORR = ' '
      FILE_NMR = ' '
      FILE_PRF = ' '
C ------
      CALL LENSTR_BL(FILE_LIST,LEN)
      IF(LEN.GT.0) THEN
        IU   = 10
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IU,M,PATH,FILE_LIST,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: file_l : no such file')
          RETURN
        ENDIF
        NPRF = 0
        DO I=1,NPRF_LIST
          READ(IU,'(A)',ERR=910,END=110) LINE
          LINE = LINE(1:8)
          CALL LENSTR_BL(LINE,LEN)
          IF(LEN.LE.0) GO TO 100 
          IF(LINE(1:1).EQ.'#') GO TO 100
          IF(NPRF.LT.NMAX) THEN
            NPRF = NPRF + 1
            NRES_LIST(NPRF)  = 0
            INDEX_LIST(NPRF) = NPRF
            ICLASS_LIST(NPRF) = 0
            SCORE_LIST(NPRF) = 1.0
            Q_LIST(NPRF)     = 1.0
            SML_LIST(NPRF)   = 0.0
            IF(LEN.EQ.5) THEN
              IF(NPRF.EQ.1) LEN_CODE = 5
              LC = 5
            ELSE IF(LEN.GE.7) THEN
              IF(NPRF.EQ.1) LEN_CODE = 7
              LC = 7
            ELSE
              CALL MSGERR(MDOC,'ERROR: wrong CODE in file_l')
              IERR = 1
              CLOSE(IU)
              RETURN
            ENDIF
            IF(LC.NE.LEN_CODE) THEN
              CALL MSGERR(MDOC,'ERROR: wrong CODE in file_l')
              IERR = 1
              CLOSE(IU)
              RETURN
            ENDIF
            PRF_LIST(NPRF) = LINE(1:LEN)     
          ENDIF
  100     CONTINUE
        ENDDO
  110   CONTINUE
        CLOSE(IU)
        IF(NPRF.LE.1) THEN        
          CALL MSGERR(MDOC,'ERROR: file_l : N_code <2')
          IERR = 1
          RETURN
        ENDIF
        CLOSE(IU)
        GO TO 200
      ELSE
        CALL LENSTR_BL(CODE8,LEN)
        IF(LEN.EQ.5) THEN
          LEN_CODE = 5
        ELSE IF(LEN.GE.7) THEN
          LEN_CODE = 7
        ELSE
          CALL MSGERR(MDOC,'ERROR: wrong CODE')
          GO TO 900
        ENDIF
      ENDIF

      IF(LEN_CODE.EQ.7) THEN

        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF

        WRITE(LINE,*) 'MEMORY for N_domain_db:',NSEQMAX
        CALL MSGDOC(MDOC,LINE)
        IF(NSEQMAX.LE.0) THEN
          IERR = 1
          GO TO 900
        ENDIF

C
c       list/domain_descr_list.txt
C    

C       allocation        

        allocate(ID_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(NRES_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ITYPE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(NSEG_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ILEVEL_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(IFORW_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(IBACK_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(ICLASS_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(FBACK_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(SCORE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RAD_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RCBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RINBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(PH_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(PB_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(RSBYR_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(CODE_DOM(1:NSEQMAX),STAT=ISTAT)
        allocate(LINE_DOM(1:3),STAT=ISTAT)

      
C ---
        NDOMAIN  = NSEQMAX

        CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOMAIN,IERR)
        IF(IERR.NE.0.OR.NDOM.LE.0) THEN
          IF(NDOM.LE.0) THEN
            WRITE(LINE,*) 'ERROR: N_dom_db:',NDOM
            CALL MSGERR(MDOC,LINE)
            IERR = 1
          ENDIF
          deallocate(ID_DOM,STAT=ISTAT)
          deallocate(NRES_DOM,STAT=ISTAT)
          deallocate(ITYPE_DOM,STAT=ISTAT)
          deallocate(NSEG_DOM,STAT=ISTAT)
          deallocate(ILEVEL_DOM,STAT=ISTAT)
          deallocate(IFORW_DOM,STAT=ISTAT)
          deallocate(IBACK_DOM,STAT=ISTAT)
          deallocate(ICLASS_DOM,STAT=ISTAT)
          deallocate(FBACK_DOM,STAT=ISTAT)
          deallocate(SCORE_DOM,STAT=ISTAT)
          deallocate(RAD_DOM,STAT=ISTAT)
          deallocate(RCBYR_DOM,STAT=ISTAT)
          deallocate(RINBYR_DOM,STAT=ISTAT)
          deallocate(PH_DOM,STAT=ISTAT)
          deallocate(PB_DOM,STAT=ISTAT)
          deallocate(RSBYR_DOM,STAT=ISTAT)
          deallocate(CODE_DOM,STAT=ISTAT)
          deallocate(LINE_DOM,STAT=ISTAT)
          GO TO 900
        ENDIF
        NSEQ     = NDOM
        WRITE(LINE,*) 'N_dom_db:',NDOM
        CALL MSGDOC(MDOC,LINE)

      ELSE
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_LIST_DB = PATH_DB(1:LEN)//'/list/chain_list.txt'

        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NSEQMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF
        WRITE(LINE,*) 'Memory for chain_list:',NSEQMAX
        CALL MSGDOC(MDOC,LINE)
        IF(NSEQMAX.LE.1) THEN
          IERR = 1
          GO TO 900
        ENDIF

        allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
        allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)

        I_MIN = 0
        I_MAX = 0
        CALL READ_CHAIN_LIST(MDOC,FILE_LIST_DB,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
        IF(IERR.NE.0.OR.NSEQ.LE.1) THEN
          IF(NSEQ.LE.1) THEN
            WRITE(LINE,*) 'ERROR: N_chain in chain_list:',NSEQ
            CALL MSGERR(MDOC,LINE)
            IERR = 1
          ENDIF
          deallocate(ID_DB,STAT=ISTAT)
          deallocate(NAA_DB,STAT=ISTAT)
          deallocate(NAT_DB,STAT=ISTAT)
          deallocate(NRES_DB,STAT=ISTAT)
          deallocate(IBACK_DB,STAT=ISTAT)
          deallocate(ILEVEL_DB,STAT=ISTAT)
          deallocate(IHIER_DB,STAT=ISTAT)
          deallocate(ICLASS_DB,STAT=ISTAT)
          deallocate(FBACK_DB,STAT=ISTAT)
          deallocate(RESOL_DB,STAT=ISTAT)
          deallocate(FIDENT_DB,STAT=ISTAT)
          deallocate(SCR_DB,STAT=ISTAT)
          deallocate(CODE_DB,STAT=ISTAT)
          deallocate(HIER_DB,STAT=ISTAT)
          deallocate(COMPLEX_DB,STAT=ISTAT)
          GO TO 900
        ENDIF

        WRITE(LINE,*) 'N_chain in chain_list:',NSEQ
        CALL MSGDOC(MDOC,LINE)

      ENDIF

      IF(LEN_CODE.EQ.7) THEN

        CALL CREATE_PRF_LIST(MDOC
     *   ,CODE8,LEN_CODE
     *   ,ID_DOM,CODE_DOM,ICLASS_DOM,IBACK_DOM,NRES_DOM
     *   ,NDOMAIN
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *   ,ICLASS_LIST
     *   ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

      ELSE

        CALL CREATE_PRF_LIST(MDOC
     *   ,CODE8,LEN_CODE
     *   ,ID_DB,CODE_DB,ICLASS_DB,IBACK_DB,NRES_DB
     *   ,NSEQ
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *   ,ICLASS_LIST
     *   ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
      ENDIF
      IF(LEN_CODE.EQ.7) THEN
        deallocate(ID_DOM,STAT=ISTAT)
        deallocate(NRES_DOM,STAT=ISTAT)
        deallocate(ITYPE_DOM,STAT=ISTAT)
        deallocate(NSEG_DOM,STAT=ISTAT)
        deallocate(ILEVEL_DOM,STAT=ISTAT)
        deallocate(IFORW_DOM,STAT=ISTAT)
        deallocate(IBACK_DOM,STAT=ISTAT)
        deallocate(ICLASS_DOM,STAT=ISTAT)
        deallocate(FBACK_DOM,STAT=ISTAT)
        deallocate(SCORE_DOM,STAT=ISTAT)
        deallocate(RAD_DOM,STAT=ISTAT)
        deallocate(RCBYR_DOM,STAT=ISTAT)
        deallocate(RINBYR_DOM,STAT=ISTAT)
        deallocate(PH_DOM,STAT=ISTAT)
        deallocate(PB_DOM,STAT=ISTAT)
        deallocate(RSBYR_DOM,STAT=ISTAT)
        deallocate(CODE_DOM,STAT=ISTAT)
        deallocate(LINE_DOM,STAT=ISTAT)
      ELSE
        deallocate(ID_DB,STAT=ISTAT)
        deallocate(NAA_DB,STAT=ISTAT)
        deallocate(NAT_DB,STAT=ISTAT)
        deallocate(NRES_DB,STAT=ISTAT)
        deallocate(IBACK_DB,STAT=ISTAT)
        deallocate(ILEVEL_DB,STAT=ISTAT)
        deallocate(IHIER_DB,STAT=ISTAT)
        deallocate(ICLASS_DB,STAT=ISTAT)
        deallocate(FBACK_DB,STAT=ISTAT)
        deallocate(RESOL_DB,STAT=ISTAT)
        deallocate(FIDENT_DB,STAT=ISTAT)
        deallocate(SCR_DB,STAT=ISTAT)
        deallocate(CODE_DB,STAT=ISTAT)
        deallocate(HIER_DB,STAT=ISTAT)
        deallocate(COMPLEX_DB,STAT=ISTAT)
      ENDIF

      IF(IERR.NE.0) THEN
        IF(IERR.NE.13) 
     *    CALL MSGERR(MDOC,'ERROR: in CREATE_PRF_LIST ')
        RETURN
      ENDIF

  200 CONTINUE

        IF(NPRF.LE.1) GO TO 800  
      
        FILE_CORR = CODE8(1:LEN_CODE)//'_corr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_CORR,LT )
        IF(LEN.GT.0) THEN
          FILE_CORR = PATH_SCR(1:LEN)//FILE_CORR(1:LT) 
        ENDIF

        IF(MODE.EQ.'P') THEN 
          FILE_NMR = CODE8(1:LEN_CODE)//'_nmr.pdb'
          CALL LENSTR_BL(PATH_OUT,LEN)
          CALL LENSTR_BL(FILE_NMR,LT )
          IF(LEN.GT.0) THEN
            FILE_NMR = PATH_OUT(1:LEN)//FILE_NMR(1:LT) 
          ENDIF
          FILE_PRF = CODE8(1:LEN_CODE)//'.prf'
          CALL LENSTR_BL(PATH_OUT,LEN)
          CALL LENSTR_BL(FILE_PRF,LT )
          IF(LEN.GT.0) THEN
            FILE_PRF = PATH_OUT(1:LEN)//FILE_PRF(1:LT) 
          ENDIF
C         ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
          ICFLAG = 0
          CALL CREATE_PRF_NMR_FILES(MDOC
     *     ,FILE_SEQ,FILE_FIRST_CORR,FILE_CORR,LEN_CODE
     *     ,NMODEL,FILE_NMR,FILE_PRF
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,'ERROR: in CREATE_PRF_NMR_FILES')
            GO TO 800
          ENDIF
        ELSE
          CALL CREATE_PROFILE_SEQ(MDOC,LIST
     *     ,PATH_DB,PATH_SCR,LEN_CODE
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,Q_LIST,INDEX_LIST
     *     ,IERR)
          IF(IERR.NE.0) GO TO 800
        ENDIF 

C ------
  800 CONTINUE

      RETURN
  900 CONTINUE
      IERR = 1
      RETURN
  910 CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input list file')
      CLOSE(IU)
      IERR = 1
      RETURN
      END
