C---------------------------------------------------------------
C --- get_trans.f ---
C -----------------------------------
      PARAMETER ( IPRROW = 100     )
      REAL      RESULT (IPRROW)
C ---
      CHARACTER FILE_TEST*256
      CHARACTER CHAIN_1*1,CHAIN_2*1
      CHARACTER PATH_SCR*256,PATH_OUT*256
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,PATH*1,EXT*3
C==================================================================
      PATH_OUT = ' '
      MDOC=1
      CALL START(0,MDOC,'get_trans',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  GET_TRANS (2-->1) ---  V.25.05.2007/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
  200 LINE = 'PDB file'
      CALL MSGDOC(MD,LINE)
      LINE = 'FILE_PDB:'
      CALL ASK(LINE)
      FILE_TEST = LINE
      CALL CORR_NAME_BLC(FILE_TEST)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,FILE_TEST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input test file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
C ---
  300 LINE = 'chains (2ch)'
      CALL MSGDOC(MD,LINE)
      LINE='CHAINS:'
      CALL ASK(LINE)
      CHAIN_1 = LINE(1:1)
      CHAIN_2 = LINE(2:2)
C ---
      LINE = 'path to scratch file directory'
      CALL MSGDOC(MD,LINE)
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL GET_TRANS(MDOC
     * ,FILE_TEST
     * ,CHAIN_1,CHAIN_2
     * ,PATH_SCR,PATH_OUT
     * ,RESULT,IPRROW,IERR)
C --------------------------------------------------
  900 CALL FINISH
      END

      SUBROUTINE GET_TRANS(MDOC
     * ,FILE_TEST
     * ,CHAIN_1,CHAIN_2
     * ,PATH_SCR,PATH_OUT
     * ,RESULT,IPRROW,IERR)
C --------------------------------------------------------
      REAL      RESULT(IPRROW)
C ----
      CHARACTER FILE_TEST*(*)
      CHARACTER CHAIN_1*1,CHAIN_2*1
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ---
      CHARACTER FILE_1*256,FILE_2*256
      REAL      MTRANS(3,3),VTRANS(3)
C ----
      CHARACTER MESSAGE*80,JOB*80
C ------------------------------------------------------------
      CHARACTER   EXT*3,PATH*1
      CHARACTER   LINE*256
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      MESSAGE = ' '
      JOB  = 'get_trans'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C ------
      DO I=1,3
        VTRANS(I) = 0.0
        DO J=1,3
          MTRANS(I,J) = 0.0
        ENDDO
      ENDDO
C ------
      FILE_1 = 'file_test.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_1,LLL1)
      IF(LEN.GT.0) THEN
        FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LLL1)
      ENDIF

      IF(CHAIN_1.EQ.'_') CHAIN_1 = ' '

      CALL CLEAN_PDB(MDOC,CHAIN_1
     *          ,FILE_TEST,FILE_1,NRES,MESSAGE,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READPDB (ch1)')
        MESSAGE = ' ERROR: READPDB (ch1)'
        GO TO 900
      ENDIF
      IF(NRES.LE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,' ERROR: Nres = 0 (ch1)')
        MESSAGE = ' ERROR: Nres = 0 (ch1)'
        GO TO 900
      ENDIF

      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_2,LLL2)
      IF(LEN.GT.0) THEN
        FILE_2 = PATH_SCR(1:LEN)//FILE_2(1:LLL2)
      ENDIF
      FILE_2 = 'file_sol.pdb'

      IF(CHAIN_2.EQ.'_') CHAIN_2 = ' '

      CALL CLEAN_PDB(MDOC,CHAIN_2
     *          ,FILE_TEST,FILE_2,NRES,MESSAGE,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: READPDB (ch2)')
        MESSAGE = ' ERROR: READPDB (ch2)'
        GO TO 900
      ENDIF
      IF(NRES.LE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,' ERROR: Nres = 0 (ch2)')
        MESSAGE = ' ERROR: Nres = 0 (ch2)'
        GO TO 900
      ENDIF

      CALL TRANS_CHAIN_2_TO_1(MDOC
     *      ,FILE_1,FILE_2,PATH_SCR,PATH_OUT
     *      ,MTRANS,VTRANS,MESSAGE
     *      ,RESULT,IPRROW,IERR)
      IF(IERR.EQ.2) THEN 
        MESSAGE = 'chains are not homologous'
        GO TO 910
      ELSE IF(IERR.NE.0) THEN 
        GO TO 900
      ENDIF
C ------------
      MESSAGE = 'normal termination'
      GO TO 910
C ------------
 900  CONTINUE
      MESSAGE = 'program failed'
      IERR = 1
 910  CONTINUE
      CALL WRITE_CHAIN_TRANS_XML(MDOC
     *   ,IERR,MESSAGE,JOB,PATH_OUT,MTRANS,VTRANS)

      RETURN
      END

      SUBROUTINE WRITE_CHAIN_TRANS_XML(MDOC
     *    ,IERR_INPUT,MESSAGE,JOB,PATH_OUT,MTRANS,VTRANS)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
      REAL      MTRANS(3,3),VTRANS(3)
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

C        DO I=1,NX
C          DO II=1,3
C            X(II,I) = TRMAT(1,II)*V(1)
C     *               +TRMAT(2,II)*V(2)
C     *               +TRMAT(3,II)*V(3)
C          ENDDO
C          DO II=1,3
C            X(II,I) = X(II,I) + TR(II)
C          ENDDO
C        ENDDO

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mxx <mxx> ',MTRANS(1,1),' </mxx>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mxy <mxy> ',MTRANS(2,1),' </mxy>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mxz <mxz> ',MTRANS(3,1),' </mxz>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'myx <myx> ',MTRANS(1,2),' </myx>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'myy <myy> ',MTRANS(2,2),' </myy>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'myz <myz> ',MTRANS(3,2),' </myz>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mzx <mzx> ',MTRANS(1,3),' </mzx>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mzy <mzy> ',MTRANS(2,3),' </mzy>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'mzz <mzz> ',MTRANS(3,3),' </mzz>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'tx <tx> ',VTRANS(1),' </tx>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'ty <ty> ',VTRANS(2),' </ty>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F16.5,A)',ERR=510) 
     *    'tz <tz> ',VTRANS(3),' </tz>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE TRANS_CHAIN_2_TO_1(MDOC
     *      ,FILE_1,FILE_2,PATH_SCR,PATH_OUT
     *      ,MTRANS,VTRANS,MESSAGE
     *      ,RESULT,IPRROW,IERR)
C --------------------------------------------------------
      REAL      RESULT(IPRROW)
      REAL      MTRANS(3,3),VTRANS(3)
C ----
      CHARACTER FILE_1*(*),FILE_2*(*),MESSAGE*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ---
      CHARACTER   FILE_OUT*256
      CHARACTER   LINE*256
C ------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----- 
      FIDENT_MIN = 80.0
      F_LEVEL    = 0.75
c----
      IPRINT = 0
      FILE_OUT = ' '
      IERR = 0
      CALL MAKE_ALIGN(M,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                    ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in MAKE_ALIGN')
        MESSAGE = ' ERROR: in MAKE_ALIGN'
        GO TO 900
      ENDIF
      N1  = RESULT(1) 
      N2  = RESULT(2) 
      NN  = RESULT(3) 
      NI  = RESULT(4) 
      HID = RESULT(5) 

      F_MIN = FLOAT(N1)*F_LEVEL
      F_MAX = FLOAT(N1)/F_LEVEL
      II_MIN = F_MIN+1
      II_MAX = F_MAX+1

      IF(II_MIN.GT.0.AND.II_MAX.GT.0) THEN
        IF(N2.LT.II_MIN.OR.N2.GT.II_MAX.OR.
     *                     HID.LT.FIDENT_MIN) THEN
          IERR = 2
          RETURN
        ENDIF
      ENDIF
C ------
      DLIM      = 5.0
      ANG_LIM   = 10.0
      DIST_LIM  = 3.0
      NPAIR_INI = NN
      NPAIR     = RESULT(17) 
      DRMS      = RESULT(16)
      CHI       = RESULT(24)
      DIST      = RESULT(25)

      WRITE(LINE,'(A,2I5,3F10.3)') 
     *   '-FIT:NPAIR_INI,NPAIR,CHI,DIST,DRMS'
     *   ,NPAIR_INI,NPAIR,CHI,DIST,DRMS
      CALL MSGDOC(MDOC,LINE)

c ========================
      MTRANS(1,1) = RESULT(33)
      MTRANS(2,1) = RESULT(36)
      MTRANS(3,1) = RESULT(39)
      MTRANS(1,2) = RESULT(34)
      MTRANS(2,2) = RESULT(37)
      MTRANS(3,2) = RESULT(40)
      MTRANS(1,3) = RESULT(35)        
      MTRANS(2,3) = RESULT(38)      
      MTRANS(3,3) = RESULT(41)        
      VTRANS(1) =  RESULT(30)         
      VTRANS(2) =  RESULT(31)        
      VTRANS(3) =  RESULT(32)         
C ------
      RETURN
C ------------
 900  CONTINUE
      IERR = 1
      RETURN
      END
