C --- get_structure_DB.f ---
C --------------------------------------------------------------------
C --- MEMORY - 
C --------------------------------------------------------------------      
      PARAMETER ( IPRROW = 200 ) 
      REAL      RESULT (IPRROW)
C ----
      CHARACTER NAME_SEQ*256,NAME_PDB*256,NAME_TEMP_LIST*256
      CHARACTER NAME_DIR*256,NAME_LIST*256 
      CHARACTER NAME_MX*256
      CHARACTER PATH_SCR*256,PATH_OUT*256
C
      CHARACTER LINE*256,PROG*80
      CHARACTER SPACE_GROUP*80
      REAL      CELL(6)
C ---
      INCLUDE 'get_structure_DB_version.fh'
C --------------------------------------------------------------------
C =============================================================
c_PATH_OUT /data/alexei/work/molrep_DB/temp/
      M = 0
      PATH_OUT = ' '
      MDOC    = 1
      PROG = 'get_structure_DB'
      CALL START(0,MDOC,PROG,PATH_OUT)
C ---------------------------
      CALL MSGDOC(M,'Sol_ ')
      LINE = VERSION
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.75) LEN = 75
      LINE = 'Sol_'//LINE(1:LEN)
      CALL MSGDOC(M,LINE)
      CALL MSGDOC(M,'Sol_ ')
C -------------------------------------------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      NSEQ_MAX  = 0
      NSYM      = 0
      VOLUME    = 0.0
      RESMAX    = 0.0        
      RESMIN    = 0.0        
      OPT_RESOL = 0.0       
      BOVERALL  = 0.0      
      DO I=1,6
        CELL(I) = 0.0
      ENDDO
      SPACE_GROUP = ' '
C ----
      CALL SET_DEFAULT(
     *'FILE_L:  filename - file of sequence_list')
      CALL SET_DEFAULT(
     *'FILE_S:  filename - file of sequence')
      CALL SET_DEFAULT(
     *'FILE_MX:  filename - file of fixed model')
      CALL SET_DEFAULT(
     *'FILE_PDB:   < >   - file of coordinates')
      CALL SET_DEFAULT(
     *'USER_D:  name - directory with user"s pdb files (last ch "/")')
      CALL SET_DEFAULT(
     *'USER_L:  name - list file (list of pdb files in USER_D)')
      CALL SET_DEFAULT(
     *'SPACE_GR:    < >  - space group name')
      CALL SET_DEFAULT(
     *'NSEQ_MAX:  < >  - max number of homologous from DB for one seq')
      CALL SET_DEFAULT(
     *'NSYM:        < >  - number of cryst. symm. operators')
      CALL SET_DEFAULT(
     *'VOLUME:      < >  - volume of cell')
      CALL SET_DEFAULT(
     *'OPT_RESOL:   < >  - optical resolution')
      CALL SET_DEFAULT(
     *'RESMAX:      < >  - X-ray data max resolution')
      CALL SET_DEFAULT(
     *'RESMIN:      < >  - X-ray data min resolution')
      CALL SET_DEFAULT(
     *'BOVERALL:    < >  - Boverall')
      CALL SET_DEFAULT(
     *'CELL:        < >  - unit cell parameters')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >   - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_L'
      CALL ASK(LINE)
      NAME_TEMP_LIST=LINE
      CALL CORR_NAME_BLC(NAME_TEMP_LIST)
C -----------------------
      LINE='FILE_S'
      CALL ASK(LINE)
      NAME_SEQ=LINE
      CALL CORR_NAME_BLC(NAME_SEQ)
c ----
      LINE='FILE_MX'
      CALL ASK(LINE)
      NAME_MX=LINE
      CALL CORR_NAME_BLC(NAME_MX)
c ----
      LINE='FILE_PDB'
      CALL ASK(LINE)
      NAME_PDB=LINE
      CALL CORR_NAME_BLC(NAME_PDB)
c ----
      LINE='USER_D'
      CALL ASK(LINE)
      NAME_DIR=LINE
      CALL CORR_NAME_BLC(NAME_DIR)
c ----
      LINE='USER_L'
      CALL ASK(LINE)
      NAME_LIST=LINE
      CALL CORR_NAME_BLC(NAME_LIST)
C ---
      LINE='SPACE_GR'
      CALL ASK(LINE)
      SPACE_GROUP=LINE
      CALL CORR_NAME_BLC(SPACE_GROUP)
c ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C ----
      LINE='NSEQ_MAX'
      CALL ASK(LINE)
      READ(LINE,*) NSEQ_MAX
C ----
      LINE='NSYM'
      CALL ASK(LINE)
      READ(LINE,*) NSYM
C ----
      LINE='VOLUME'
      CALL ASK(LINE)
      READ(LINE,*) VOLUME 
C ----
      LINE='OPT_RESOL'
      CALL ASK(LINE)
      READ(LINE,*) OPT_RESOL
C ----
      LINE='BOVERALL'
      CALL ASK(LINE)
      READ(LINE,*) BOVERALL 
C ----
      LINE='SIM_LIM'
      CALL ASK(LINE)
      READ(LINE,*) SIM_LIM 
C ----
      LINE='RESMAX'
      CALL ASK(LINE)
      READ(LINE,*) RESMAX 
C ----
      LINE='RESMIN'
      CALL ASK(LINE)
      READ(LINE,*) RESMIN 
C ----
      LINE='CELL'
      CALL ASK(LINE)
      READ(LINE,*) CELL(1),CELL(2),CELL(3),CELL(4),CELL(5),CELL(6)
C -----------------------
c_PATH_SCR /data/alexei/work/molrep_DB/temp/
c_FILE_L /data/alexei/work/molrep_DB/temp/s100_temp_seq_list.txt
c_FILE_S /data/alexei/work/molrep_DB/data/s100.seq
c_FILE_S2
C .............
c_FILE_S8 
c_FILE_PDB 
c_CELL        99.660  99.660  64.330  90.000  90.000 120.000
c_SPACE_GR        H 3
c_NSEQ_MAX         10 
C_NSYM             9
c_VOLUME      553332.2
c_RESMAX           2.5011
c_OPT_RESOL        1.8185
c_BOVERALL        33.7190
c ------------------------
C
c result: PATH_OUT/get_structure_DB.xml

      CALL CLOSE_BATCH(MDOC)
      CALL GET_STRUCTURE_DB(MDOC,VERSION
     * ,NAME_SEQ,NAME_TEMP_LIST,NAME_PDB,NAME_MX
     * ,NAME_DIR,NAME_LIST
     * ,NSEQ_MAX,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL
     * ,CELL,SPACE_GROUP 
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END
