C---------------------------------------------------------------
C --- pdb2s.f ---
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------------------------------
      PARAMETER ( MEMORY = 4000000 )
      REAL      POOL(MEMORY)
      PARAMETER ( IPRROW = 121     )
      REAL      RESULT (IPRROW)
C ---
      CHARACTER FILE_TEST*256,FILE_OUT*256
      CHARACTER PATH_SCR*256,PATH_OUT*256
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,PATH*1,EXT*3,CHAIN_IN*1
C==================================================================
      PATH_OUT = ' '
      MDOC=1
      CALL START(0,MDOC,'pdb2s',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  PDB_2_SEQ ---  V.13.11.2008/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
  200 LINE = 'PDB file'
      CALL MSGDOC(MD,LINE)
      LINE = 'FILE_IN:'
      CALL ASK(LINE)
      FILE_TEST = LINE
      CALL CORR_NAME_BLC(FILE_TEST)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,FILE_TEST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input test file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
c ----
  300 LINE = 'SEQ file'
      CALL MSGDOC(MD,LINE)
      LINE = 'FILE_SEQ:'
      CALL ASK(LINE)
      FILE_OUT = LINE
      CALL CORR_NAME_BLC(FILE_OUT)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFW(MT,M,PATH,FILE_TEST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open output file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
C ---
      LINE = 'Chain_id or "?" (max chain) or " "'
      CALL MSGDOC(MD,LINE)
      LINE='CHAIN'
      CALL ASK(LINE)
      CHAIN_IN=LINE(1:1)
      CALL CORR_NAME_BLC(CHAIN_IN)
C ---
      LINE = 'path to scratch file directory'
      CALL MSGDOC(MD,LINE)
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL PDB2S(MDOC
     * ,FILE_TEST,FILE_OUT,CHAIN_IN,PATH_SCR,PATH_OUT
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------
  900 CALL FINISH
      END

      SUBROUTINE PDB2S(MDOC
     * ,FILE_TEST,FILE_OUT,CHAIN_IN,PATH_SCR,PATH_OUT
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
      REAL      POOL(MEMORY)
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
C ----
      CHARACTER FILE_TEST*(*),FILE_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER CHAIN_IN*1
      CHARACTER CHAIN_IN1*1,CHAIN_IN2*1
C ---
      CHARACTER FILES*256
      CHARACTER FILE_1*256,FILE_2*256
C ----
      CHARACTER   ID_PDB*4,DATE_PDB*9,CHAIN_INP*1
      REAL        CELL(6)

      PARAMETER ( NCHAIN_MAX = 30 )
      CHARACTER   CHAIN_LIST_TEST( NCHAIN_MAX)*1
      INTEGER     NAA_CHAIN_TEST( NCHAIN_MAX)

      CHARACTER   CHAIN_TEST*1
      CHARACTER   STR_TITLE*40,STR_DATE*9
      CHARACTER   MESSAGE*80,JOB*80
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---------------------------------------------------------
      CHARACTER   EXT*3,PATH*1
      CHARACTER   LINE*256
      REAL        FCH4      
      CHARACTER   CH4*4
      EQUIVALENCE (FCH4,CH4)
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ------
      JOB  = 'pdb2s'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C -----
      NAA_MAX = 0
      CHAIN_INP = ' '
C ------
      FILES = 'temp.seq'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILES,LLL)
      IF(LEN.GT.0) THEN
        FILES = PATH_SCR(1:LEN)//FILES(1:LLL)
      ENDIF
      CHAIN_INP = ' '
      IMODEL = 0
      CALL PDB2SEQ(Mdoc,FILE_TEST,FILES
     * ,ID_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        IF(IERR.EQ.9) THEN 
          MESSAGE = 'Number of chains = 0'
          IERR = 1
          GO TO 910
        ENDIF
        GO TO 900
      ENDIF

      NCHAIN_TEST = RESULT(1)

      CALL MSGDOC(MDOC,'--------')
      WRITE(LINE,*) 'Number of chains (file_test):',NCHAIN_TEST
      CALL MSGDOC(MDOC,LINE)

      IF(NCHAIN_TEST.LE.0) THEN
        MESSAGE = 'Number of chains = 0'
        IERR = 1
        GO TO 910
      ENDIF

      IF(NCHAIN_TEST.GT.NCHAIN_MAX) NCHAIN_TEST = NCHAIN_MAX
      
      IFOUND    = 0
      NAA_FOUND = 0
      NAA_MAX   = 0
      II = 1      
      DO I=1,NCHAIN_TEST
        II=II+1
        FCH4 = RESULT(II)
        CHAIN_LIST_TEST(I) = CH4(1:1)
        II=II+1
        NAA_CHAIN_TEST(I) = RESULT(II)
        WRITE(LINE,'(A,3X,I6)') CHAIN_LIST_TEST(I),NAA_CHAIN_TEST(I)
        CALL MSGDOC(MDOC,LINE)

        NAA_TEST   = NAA_CHAIN_TEST(I)
        CHAIN_TEST = CHAIN_LIST_TEST(I)

        IF(NAA_TEST.GT.NAA_MAX) THEN
          NAA_MAX = NAA_TEST
          IF(CHAIN_IN.EQ.'?') CHAIN_INP = CHAIN_TEST
        ENDIF

        IF(CHAIN_IN.NE.' '.AND.CHAIN_IN.NE.'?') THEN
          IF(CHAIN_TEST.EQ.CHAIN_IN) THEN
            IF(I.GT.1) THEN
              JJ = 1      
              DO J=1,I-1
                JJ=JJ+1
                FCH4 = RESULT(JJ)
                IF(CHAIN_IN.EQ.CH4(1:1)) GO TO 111
              ENDDO
            ENDIF
            IFOUND    = 1
            NAA_FOUND = NAA_TEST
            CHAIN_INP = CHAIN_TEST
          ENDIF
        ENDIF
  111   CONTINUE
      ENDDO
      CALL LENSTR_BL(CHAIN_IN,LEN)
      IF((LEN.LE.0.OR.CHAIN_IN.EQ.' ').AND.NCHAIN_TEST.GT.1) GO TO 1000
C ------
      IF(CHAIN_IN.NE.' '.AND.CHAIN_IN.NE.'?'.AND.
     *                                IFOUND.EQ.0) THEN
        MESSAGE = 'Can not find chain '//CHAIN_IN
        IERR = 1
        GO TO 910        
      ENDIF

C      CHAIN_INP = CHAIN_IN
C      NAA_MAX   = NAA_TEST

      IF(CHAIN_IN.EQ.' ') THEN
        CHAIN_INP = ' '
        NAA_MAX = 0
      ELSE IF(CHAIN_IN.EQ.'?') THEN

        NAA_MAX = 0
        DO ITEST=1,NCHAIN_TEST
          CHAIN_TEST = CHAIN_LIST_TEST(ITEST)
          NAA_TEST   = NAA_CHAIN_TEST(ITEST)
          IF(NAA_TEST.GT.NAA_MAX) THEN
            NAA_MAX   = NAA_TEST
            CHAIN_INP = CHAIN_TEST
          ENDIF
        ENDDO

        IF(NAA_MAX.LE.0) THEN
          MESSAGE = 'Can not get chain '
          IERR = 1
          GO TO 910        
        ENDIF
      ELSE
        NAA_MAX = NAA_FOUND
      ENDIF

      CALL LENSTR_BL(PATH_OUT,LEN)
      CALL LENSTR_BL(FILE_OUT,LLL)
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_OUT(1:LEN)//FILE_OUT(1:LLL)
      ENDIF

      IMODEL = 0
      CALL PDB2SEQ(M,FILE_TEST,FILE_OUT
     * ,ID_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        GO TO 900
      ENDIF

      NOUT = 1
      WRITE(LINE,*) 'N_output_chains :',NOUT
      CALL MSGDOC(MDOC,LINE)

C ------------
      MESSAGE = 'normal termination'
      GO TO 910
C ===================
 1000 CONTINUE
      CALL CORR_NAME_BL(FILE_TEST)
      CALL LENSTR_BL(FILE_TEST,LEN)
      IF(LEN.GT.4.AND.FILE_TEST(LEN-3:LEN).EQ.'.pdb') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,L)
        IF(L.LE.0) THEN
          FILE_OUT = FILE_TEST(1:LEN-4)//'.seq'
          CALL REMOVE_PATH(FILE_OUT)
          CALL LENSTR_BL(PATH_OUT,LEN)
          CALL LENSTR_BL(FILE_OUT,LLL)
          IF(LEN.GT.0) THEN
            FILE_OUT = PATH_OUT(1:LEN)//FILE_OUT(1:LLL)
          ENDIF
        ENDIF
      ELSE
        IERR = 1
        GO TO 900
      ENDIF
      IOUT   = 71
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF

      NOUT = 0
      NRES = 0
      DO I=1,NCHAIN_TEST

        CHAIN_INP = CHAIN_LIST_TEST(I)
        CHAIN_IN1 = CHAIN_INP
        NAA1      = NAA_CHAIN_TEST(I)
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_1 = PATH_SCR(1:LEN)//'temp1.seq'
        ELSE
          FILE_1 = 'temp1.seq'
        ENDIF
        IMODEL = 0
        CALL PDB2SEQ(M,FILE_TEST,FILE_1
     *   ,ID_PDB,DATE_PDB
     *   ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *   ,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN 
          CLOSE(IOUT)
          GO TO 900
        ENDIF
        IF(I.GT.1) THEN
C         compare chains
          DO J=1,I-1
            CHAIN_INP = CHAIN_LIST_TEST(J)
            CHAIN_IN2 = CHAIN_INP
            NAA2      = NAA_CHAIN_TEST(J)
            IF(CHAIN_IN1.EQ.CHAIN_IN2) GO TO 1010
            T = REAL(NAA2)/REAL(NAA1)
            IF(T.GT.1.2.OR.T.LT.0.8) GO TO 1030

            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_2 = PATH_SCR(1:LEN)//'temp2.seq'
            ELSE
              FILE_2 = 'temp2.seq'
            ENDIF
            IMODEL = 0
            CALL PDB2SEQ(M,FILE_TEST,FILE_2
     *       ,ID_PDB,DATE_PDB
     *       ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *       ,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN 
              CLOSE(IOUT)
              GO TO 900
            ENDIF
            IPRINT = 0
            FILES  = ' '
            CALL MAKE_ALIGN(M,IPRINT,FILE_1,FILE_2,FILES
     *                    ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN 
              CLOSE(IOUT)
              GO TO 900
            ENDIF
            FIDENT = RESULT(5)
            NAA    = RESULT(3)
            T = REAL(NAA)/REAL(NAA1)
            IF(T.LT.1.2.AND.T.GE.0.8.AND.FIDENT.GE.90.0) GO TO 1010
 1030       CONTINUE
          ENDDO
        ENDIF
C ---
C       copy chain to output
        IN   = 70
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(IN,M,PATH,FILE_1,EXT,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IOUT)
          GO TO 900
        ENDIF
        DO II=1,100000
          READ(IN,'(A)',END=1020,ERR=920) LINE          
          CALL LENSTR_BL(LINE,LEN)
          IF(LEN.GT.0) THEN
            WRITE(IOUT,'(A)') LINE(1:LEN)
          ENDIF
        ENDDO
 1020   CONTINUE
        NOUT = NOUT + 1
        NRES = NRES + NAA1
        CLOSE(IN)
C ---
 1010   CONTINUE
      ENDDO

      END FILE IOUT
      CLOSE(IOUT)
      CHAIN_INP = '-'
      NAA_MAX = NRES
      WRITE(LINE,*) 'N_output_chains :',NOUT
      CALL MSGDOC(MDOC,LINE)
C ===================
      MESSAGE = 'normal termination'
      GO TO 910
C ------------
 920  CONTINUE
      CLOSE(IOUT)
 900  CONTINUE
      MESSAGE = 'program failed'
      IERR = 1
 910  CONTINUE

      CALL WRITE_PDB2SEQ_XML(MDOC,IERR,MESSAGE,JOB,PATH_OUT
     *                      ,NOUT,NAA_MAX,CHAIN_INP,FILE_OUT)

      RETURN
      END

      SUBROUTINE WRITE_PDB2SEQ_XML(MDOC
     *            ,IERR_INPUT,MESSAGE,JOB,PATH_OUT
     *            ,NOUT,NAA_MAX,CHAIN_INP,FILE_OUT)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*)
      CHARACTER FILE_2*256
      CHARACTER FILE_OUT*(*),CHAIN_INP*1
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_chain <nch> ',NOUT,' </nch>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
        LINE = 'chain_id <ch_id> '//CHAIN_INP//' </ch_id>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'N_aa <naa> ',NAA_MAX,' </naa>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(FILE_OUT,L)
        LINE = ' <sequence file_seq="'//
     *   FILE_OUT(1:L)
     *  //'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1

      write(*,*) '--error: write xml file'      

      RETURN
      END
