C---------------------------------------------------------------
C --- pdb_pack.f ---
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------------------------------
      PARAMETER ( MEMORY = 4000000 )
      REAL      POOL(MEMORY)
      PARAMETER ( IPRROW = 121     )
      REAL      RESULT (IPRROW)
C ---
      CHARACTER FILE_TEST*256,FILE_OUT*256
      CHARACTER PATH_SCR*256,PATH_OUT*256
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,PATH*1,EXT*3
C==================================================================
      PATH_OUT = ' '
      PATH_SCR = ' '
      MDOC=1
      CALL START(0,MDOC,'pdb_pack',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  PDB_PACK---  V.14.06.2005/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
  200 LINE = 'IN file'
      CALL MSGDOC(MD,LINE)
      LINE = 'FILE_IN:'
      CALL ASK(LINE)
      FILE_TEST = LINE
      CALL CORR_NAME_BLC(FILE_TEST)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,FILE_TEST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input pdb file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
c ----
  300 LINE = 'OUT file'
      CALL MSGDOC(MD,LINE)
      LINE = 'FILE_OUT:'
      CALL ASK(LINE)
      FILE_OUT = LINE
      CALL CORR_NAME_BLC(FILE_OUT)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFW(MT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open output file')
        IERR=0
        GO TO 300
      ENDIF
      CLOSE(MT)
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL LENSTR_BL(FILE_TEST,LEN)
      IF(FILE_TEST(LEN-3:LEN).EQ.'.pdb') THEN
        CALL PDB_PACK(MDOC,FILE_TEST,FILE_OUT,IERR)
      ELSE
        CALL PDB_UNPACK(MDOC,FILE_TEST,FILE_OUT,IERR)
      ENDIF
C --------------------------------------------------
  900 CALL FINISH
      END

      SUBROUTINE PDB_PACK(MDOC,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*256

      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ATOM*4,RES*3
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER ACODE*4,CP_PNUM_OLD*7,CP_PNUM_WRT*7
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      CP_PNUM_OLD  = '???????'
      IRES_OLD     = 0
      IRES_NEW_OLD = 0
      IEND    = 0
      IADD    = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ENDIF

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CSURF,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
      IF(CP_OCC.LE.0.0001) GO TO 400

C     IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
      IF(CP_PNUM(7:7).EQ.' ') CP_PNUM(7:7) = '_'

      ATOM  = ANAME
      RES   = RNAME 
      ASYMB = '    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF
      IF(ASYMB(2:2).EQ.' ') THEN
        ASYMB(2:2) = ASYMB(1:1)
        ASYMB(1:1) = ' '
      ENDIF
c ----
      IF(CP_PNUM.NE.CP_PNUM_OLD) THEN
c ---
c       new residue
        READ(CP_PNUM(3:6),'(I4)') IRES
        CP_PNUM_WRT = CP_PNUM
        IF(CP_PNUM_OLD(1:1).NE.'?') THEN
          READ(CP_PNUM_OLD(3:6),'(I4)') IRES_OLD
          IF(IRES.LT.IRES_OLD.AND.
     *       CP_PNUM_OLD(7:7).EQ.CP_PNUM(7:7).AND.
     *       CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
            IT = IRES_OLD/100
            IADD = (IT + 1)*100 + 100 - IRES 
          ENDIF
        ENDIF

cc        IF(CP_PNUM(7:7).NE.'_') THEN
cc          CP_PNUM_WRT(7:7) = '_'
cc          IF(CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
cc            IADD = IADD + 1
cc          ENDIF
cc        ENDIF

        IRES = IRES + IADD 

cc        IF(CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
cc          IF(IRES.EQ.IRES_NEW_OLD) THEN
cc            IADD = IADD + 1
cc            IRES = IRES + 1
cc          ENDIF
cc        ENDIF

        IRES_NEW_OLD = IRES
        CP_PNUM_OLD  = CP_PNUM 
        WRITE(CP_PNUM_WRT(3:6),'(I4)') IRES
C ---
        WRITE(STR,'(A4,A3,A6)')
     *   'RES:',RES,CP_PNUM_WRT(2:7)
        CALL LENSTR_BL(STR,LEN)
        WRITE(IOUT,'(A)') STR(1:LEN)
      ENDIF

      WRITE(STR,'(A4,A2,3F8.3,F6.2)')
     *   ATOM,ASYMB(1:2)
     *  ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_BISO

      CALL LENSTR_BL(STR,LEN)
      WRITE(IOUT,'(A)') STR(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE PDB_UNPACK(MDOC,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*256

      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER CP_PNUM_OLD*7          

      CHARACTER ASYMB*4
      CHARACTER FRMT*80
      DATA FRMT
     * /'(A6,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A2)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      CP_PNUM_OLD = '?'
      IA      = 0
      IEND    = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
      IF(IEND.GT.0) GO TO 600
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ENDIF

      IF(LINE(1:4).EQ.'RES:') THEN
        READ(LINE,'(4X,A3,A6)') RNAME,CP_PNUM(2:7)
        CP_PNUM(1:1) = ' ' 
        IF(CP_PNUM(7:7).EQ.'_') CP_PNUM(7:7) = ' '
        GO TO 400
      ENDIF

      IA = IA + 1
      IF(IA.GT.99999) IA = 1

      READ(LINE,'(A4,A2,3F8.3,F6.2)')
     *   ANAME,ASYMB(1:2)
     *  ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_BISO
      CP_OCC  = 1.0
      CP_ALT  = ' '
      CP_CORR = ' '

      WRITE(STR,FRMT)
     * 'ATOM  ',IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,ASYMB(1:2)

      CALL LENSTR_BL(STR,LEN)
      WRITE(IOUT,'(A)') STR(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END
