C --- save_seg_id.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_I*256,FILE_R*256,FILE_OUT*256
C
      CHARACTER LINE*256,PROG*80
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'save_seg_id'
      
      CALL START(0,MDOC,PROG,PATH_OUT)
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NCHAIN     = 0
      NCHAIN_NEW = 0
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'FILE_I:          - input PDB file (before refmac)')
      CALL SET_DEFAULT(
     *'FILE_R:          - input PDB file (after refmac)')
      CALL SET_DEFAULT(
     *'FILE_OUT:        - output PDB file')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_I'
      CALL ASK(LINE)
      FILE_I=LINE
      CALL CORR_NAME_ALL(FILE_I)
C ----
      LINE='FILE_R'
      CALL ASK(LINE)
      FILE_R=LINE
      CALL CORR_NAME_ALL(FILE_R)
C ----
      LINE='FILE_OUT'
      CALL ASK(LINE)
      FILE_OUT=LINE
      CALL CORR_NAME_ALL(FILE_OUT)
C ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C ----

      CALL CLOSE_BATCH(MDOC)

C ---------------------------------
      CALL SAVE_SEG_ID(MDOC,FILE_I,FILE_R,FILE_OUT
     *               ,NRESIDUE,PATH_SCR,PATH_OUT,IERR)
      CALL WRITE_SAVE_SEG_ID_XML(MDOC
     *    ,NRESIDUE,IERR,PROG,PATH_OUT)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE WRITE_SAVE_SEG_ID_XML(MDOC
     *              ,NRESIDUE,IERR_INPUT,PROG,PATH_OUT)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,MESSAGE*80,PROG*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(PROG,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//PROG(1:LJ)//'.xml'
      ELSE
        FILE_2 = PROG(1:LJ)//'.xml'
      ENDIF
      IERR = 0
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//PROG(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//PROG(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//PROG(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
        MESSAGE = 'normal termination'
      ELSE
        MESSAGE = 'program failed'
      ENDIF

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//PROG(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN

        WRITE(LINE,'(A,I10,A)',ERR=510)
     *     '   N_residues <nres> ',NRESIDUE,' </nres>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//PROG(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE SAVE_SEG_ID(MDOC,FILE_I,FILE_R,FILE_OUT
     *                     ,NRESIDUE,PATH_SCR,PATH_OUT,IERR)
C --------------------------------------------------------
      CHARACTER FILE_I*(*),FILE_R*(*),FILE_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ----
      real,      allocatable :: XA(:)
      real,      allocatable :: YA(:)
      real,      allocatable :: ZA(:)
      real,      allocatable :: OCC(:)
      real,      allocatable :: BISO(:)
      character(LEN=4), allocatable :: ANAME(:)
      character(LEN=3), allocatable :: RNAME(:)
      character(LEN=1), allocatable :: ALT(:)
      character(LEN=7), allocatable :: PNUM(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)

      integer,   allocatable :: FRAG_NATOM(:)
      integer,   allocatable :: FRAG_INDEX(:)
      integer,   allocatable :: FRAG_IORDER(:)
      integer,   allocatable :: FRAG_ISTART(:)
      integer,   allocatable :: FRAG_IFINISH(:)
      integer,   allocatable :: FRAG_RES_ISTART(:)
      integer,   allocatable :: FRAG_RES_IFINISH(:)
      real,      allocatable :: FRAG_XSTART(:,:)
      real,      allocatable :: FRAG_XFINISH(:,:)
      real,      allocatable :: FRAG_XCENTRE(:,:)
      real,      allocatable :: FRAG_RAD(:)
      character(LEN=4), allocatable :: FRAG_SEG(:)
C -----------------------------------------------------------
C -----------------------------------
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,5X,1X,A4,A1,A3,A7,3X,3F8.3,2F6.2,6X,A4,A4)'/
c     'ATOM  ',IA,
C --
      CHARACTER LINE*256
      CHARACTER CP_PNUM*7,CP_PNUM_OLD*7,CHAIN*1,CP_SEG*4
      CHARACTER CP_SEG_OLD*4
      CHARACTER EXT*3,PATH*1
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_I,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open input file_I')
        RETURN
      ENDIF
C ------------
      CP_PNUM_OLD = '?'
      NRESIDUE    = 0
100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        CP_PNUM = LINE(21:27)
        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c         new residue
          NRESIDUE = NRESIDUE + 1
        ENDIF
        CP_SEG = LINE(73:76)
        CP_PNUM_OLD = CP_PNUM
      ENDIF
      GO TO 100
110   CONTINUE
      CLOSE(IN)
C ------------
      IF(NRESIDUE.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N residues = 0')
        IERR = 1
        RETURN
      ENDIF
      WRITE(LINE,'(A,I6)') 'Nresidue  :',NRESIDUE
      CALL MSGDOC(MDOC,LINE)
C -----------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_I,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open input file_I.')
        RETURN
      ENDIF
C ------------

      allocate(PNUM(1:NRESIDUE),STAT=ISTAT)
      allocate(SEG(1:NRESIDUE),STAT=ISTAT)
       
      NR          = 0
      CP_PNUM_OLD = '?'

200   CONTINUE

      READ(IN,'(A)',ERR=800,END=210) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 200

      IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        CP_PNUM = LINE(21:27)
        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c         new residue
          NR = NR + 1
          CP_SEG = LINE(73:76)
          PNUM(NR) = CP_PNUM
          SEG(NR)  = CP_SEG
        ENDIF
        CP_PNUM_OLD = CP_PNUM
      ENDIF

      GO TO 200
210   CONTINUE
      CLOSE(IN)
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: N residues =0')
        IERR = 1
        GO TO 700
      ENDIF
C ====================
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_R,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open input file_R.')
        GO TO 700
      ENDIF
C ------------
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: can not open output file')
        CLOSE(IN)
        GO TO 700
      ENDIF
C --------
      IRR = 1
300   CONTINUE

      READ(IN,'(A)',ERR=820,END=310) LINE

      IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        CP_PNUM = LINE(21:27)
        CP_SEG  = '    '
        DO IR=1,NRESIDUE
          IF(IRR.GT.NRESIDUE) IRR = IRR - NRESIDUE
          IF(PNUM(IRR).EQ.CP_PNUM) THEN
            CP_SEG = SEG(IRR)
            GO TO 400
          ENDIF
          IRR = IRR + 1
        ENDDO
400     CONTINUE
        LINE(73:76) = CP_SEG
      ENDIF 

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=810) LINE(1:LEN)     

      GO TO 300
310   CONTINUE
      CLOSE(IN)
      END FILE IOUT
      CLOSE(IOUT)
C =====================

700   CONTINUE

      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)

      RETURN
C ------------
800   CONTINUE
      CALL MSGERR(MDOC,'ERROR:  read input file_I')
      CLOSE(IN)
      IERR = 1
      GO TO 700
820   CONTINUE
      CALL MSGERR(MDOC,'ERROR:  read input file_R')
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 700
810   CONTINUE
      CALL MSGERR(MDOC,'ERROR: write to output file')
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      GO TO 700
C ------------
900   CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file_I')
      CLOSE(IN)
      IERR = 1
      RETURN
      END

