      SUBROUTINE SEARCH_DB(MDOC,NAME_SEQ,NAME_PDB,NAME_DIR,NAME_LIST
     * ,NSEQ_MAX,SIM_LIM,SCORE_LIM
     * ,HARD,PRF,PATH_OUT,PATH_SCR,RESULT,IPRROW,VERSION,IERR)
C ------------------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER NAME_SEQ*(*),NAME_DIR*(*),NAME_LIST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),NAME_PDB*(*)
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,NAME_TEMP_LIST*256
      CHARACTER MESSAGE*80,JOB*80,HARD*1,PRF*1
      CHARACTER VERSION*(*)
      CHARACTER PATH*1,EXT*3
C ---
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ---
C==================================================================
      IERR = 0
      JERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C ---------------------------------
      JOB  = 'search_DB'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C ---------------------------------
      SCORE_LIM = 0.0
      IF(NSEQ_MAX.LE.0     )   NSEQ_MAX   = 20
      IF(SIM_LIM .LE.0.0001)   SIM_LIM    = 0.10
      IF(SCORE_LIM .LE.0.0001) SCORE_LIM  = 0.25
      CALL LENSTR_BL(NAME_SEQ,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGDOC(MDOC,' ERROR: wrong name sequence file')
        IERR = 2
        GO TO 510
      ELSE
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)')    '==file_seq:',NAME_SEQ(1:L)
        CALL MSGDOC(MDOC,LINE)
        MT   = 10
        OPEN(MT,FILE=NAME_SEQ(1:LEN),ACCESS='SEQUENTIAL',ERR=510,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
      ENDIF
      CALL LENSTR_BL(NAME_DIR,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)')    '==user_dir:',NAME_DIR(1:L)
        CALL MSGDOC(MDOC,LINE)
        CALL LENSTR_BL(NAME_LIST,LEN)
        IF(LEN.LE.0) THEN
          MESSAGE = 'wrong list file name'
          CALL MSGDOC(MDOC,' ERROR: wrong list file name')
          IERR = 8
          GO TO 600
        ELSE
          L = LEN
          IF(LEN.GT.60) L=60
          WRITE(LINE,'(A,A)')    '==list_file:',NAME_LIST(1:L)
          CALL MSGDOC(MDOC,LINE)
          MT   = 10
          OPEN(MT,FILE=NAME_LIST(1:LEN),ACCESS='SEQUENTIAL',ERR=520,
     *      FORM='FORMATTED',STATUS='OLD')
          CLOSE(MT)   
        ENDIF
      ENDIF

      WRITE(LINE,'(A,I8)')   '==nseq_max  :',NSEQ_MAX 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==sim_lim   :',SIM_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==score_lim :',SCORE_LIM
c      CALL MSGDOC(MDOC,LINE)

C ---------------------------------  
      CALL LENSTR_BL(NAME_DIR,LEN1)
      CALL LENSTR_BL(NAME_LIST,LEN2)

      IF(LEN1.LE.0.OR.LEN2.LE.0) THEN

        ITIME_START =-1
        NRUN_TIME   = 0
        CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
        WRITE(LINE,*) 'Time:',TIME_CURRENT
        CALL MSGDOC(MDOC,LINE)

        CALL MSGDOC(MDOC,' --- ')
        CALL MSGDOC(MDOC,' --- Searching in DB        ---')
        CALL MSGDOC(MDOC,' --- ')
C ---
        CALL SEARCH_ALIGN_DB(Mdoc,HARD,PRF
     *   ,NAME_SEQ,NAME_PDB,NAME_TEMP_LIST
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,N_SEQ,FIDENT_BEST,SCORE_BEST
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 500

      ELSE

        CALL MSGDOC(MDOC,' --- ')
        CALL MSGDOC(MDOC,' --- Searching in User_DIR   ---')
        CALL MSGDOC(MDOC,' --- ')

        CALL SEARCH_ALIGN_USER(Mdoc,HARD,NAME_SEQ,NAME_TEMP_LIST
     *   ,NAME_DIR,NAME_LIST
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,N_SEQ,FIDENT_BEST,SCORE_BEST
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 500

      ENDIF

      ITIME_START = 1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,'  Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)

      MESSAGE = 'normal termination'
C ---------------------------------
      GO TO 600
 520  CONTINUE
      LINE = ' ERROR: cannot open list file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'input list file : open/read'
      IERR = 8
      GO TO 600
 510  CONTINUE
      LINE = ' ERROR: cannot open sequence file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'input sequence file : open/read'
      IERR = 2
      GO TO 600
 500  CONTINUE
      MESSAGE = 'null'
      IF(IERR.EQ.1) THEN
C        MESSAGE = 'no memory for alignement'
      ELSE IF(IERR.EQ.2) THEN
        MESSAGE = 'input sequence file : open/read'
      ELSE IF(IERR.EQ.3) THEN
        MESSAGE = 'chain_list_DB: open/read'
      ELSE IF(IERR.EQ.4) THEN
        MESSAGE = 'wrong setenv MOLREP_DB'
      ELSE IF(IERR.EQ.5) THEN
        MESSAGE = 'no PDB structure was found'
      ELSE IF(IERR.EQ.6) THEN
        MESSAGE = 'output file-temp_chain_list.txt: open/write'
      ELSE IF(IERR.EQ.7) THEN
        MESSAGE = 'input sequence file : no title or no sequence'
      ELSE IF(IERR.EQ.8) THEN
        MESSAGE = ' can not open input list file'
      ENDIF
C --
 600  CONTINUE

      CALL WRITE_SEARCH_DB_XML(MDOC,IERR,MESSAGE,JOB
     *   ,VERSION
     *   ,N_SEQ,FIDENT_BEST,NAME_TEMP_LIST,PATH_OUT,JERR)
C      IERR = JERR
      RETURN
      END

      SUBROUTINE WRITE_SEARCH_DB_XML(MDOC,IERR_INPUT,MESSAGE,JOB
     *            ,VERSION
     *            ,N_SEQ,FIDENT_BEST,NAME_TEMP_LIST,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*),NAME_TEMP_LIST*(*)
      CHARACTER VERSION*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(VERSION,LEN)
      LINE = 'vers <vers>'//VERSION(1:LEN)//'</vers>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
 
        WRITE(LINE,'(A,I6,A)',ERR=510) 
     *    'n_structure <n_structure> ',N_SEQ,' </n_structure>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        WRITE(LINE,'(A,F5.1,A)',ERR=510) 
     *    'identity_best <identity_best> ',FIDENT_BEST
     *    ,'</identity_best>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(NAME_TEMP_LIST,L)
        LINE = 'chain_list <chain_list temp_chain_list="'//
     *          NAME_TEMP_LIST(1:L)//'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE SEARCH_ALIGN_DB(MDOC,HARD,PRF
     *   ,FILE_SEQ,FILE_PDB,FILE_OUT
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM
     *   ,N_SEQ_TOT,FIDENT_BEST_TOT,SCORE_BEST_TOT
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1,PRF*1
      CHARACTER FILE_SEQ*(*),FILE_PDB*(*),FILE_OUT*(*)
      REAL      RESULT (IPRROW)
C ----
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)

      integer,   allocatable :: NDOM_DB(:)
      integer,   allocatable :: IDOMSEG_DB(:)
      character(LEN=8), allocatable :: CODE_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM1_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM2_DOM_DB(:)

      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
C ---
      CHARACTER FILE_TEMP_SEQ*256
      CHARACTER FILE_DOM_DESCR*256
      CHARACTER FILE_LIST*256,FILE_DOM*256
      CHARACTER FILE_LIST_OUT*256,FILE_DOM_OUT*256
      CHARACTER FILE_DOM_DESCR_OUT*256
      CHARACTER PATH_DB*256
      CHARACTER LINE*256
C ---
      INTEGER   MDOC,IERR
      CHARACTER PATH*1,EXT*1
      logical ex
      integer nfile
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ----
      FIDENT_MIN = SIM_LIM*100.0
c     F_LEVEL    = 0.75
      F_LEVEL    = 0.7
      FILE_OUT   = ' '
      N_SEQ      = 0
      FIDENT_BEST_TOT = 0.0
      SCORE_BEST_TOT  = 0.0
      IF(HARD.EQ.'y') HARD = 'Y'
      IF(HARD.NE.'Y') HARD = 'N'
      WRITE(LINE,*) 'HARD :',HARD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'PRF  :',PRF
      CALL MSGDOC(MDOC,LINE)
C ------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: problem with "setenv MOLREP_DB"')
        CALL MSGERR(MDOC
     *  ,'       Example: "setenv MOLREP_DB ~alexei/molrep_DB"')
        IERR = 9
        GO TO 900
      ENDIF
c ---
      IF(PRF.EQ.'Y') THEN
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_DOM = PATH_DB(1:LEN)//'/prf_DOM/prf_info.txt'
        CALL LENSTR_BL(FILE_DOM,LEN)
        inquire(file=FILE_DOM(1:LEN),exist=ex,number=nfile)
        IF(ex) THEN
        ELSE
          LINE = 'WARNING: there is not dir: prf_DOM'
          CALL MSGDOC(MDOC,LINE)
          PRF = 'N'
          WRITE(LINE,*) 'now PRF  :',PRF
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ENDIF
c ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST = PATH_DB(1:LEN)//'/list/chain_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        IERR = 9
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_chain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 9
        GO TO 900
      ENDIF

C
c       list/chain_list.txt
C
      allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)

      I_MIN = 1
      I_MAX = 100000
      CALL READ_CHAIN_LIST(MDOC,FILE_LIST,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0) THEN
        IERR = 9
        GO TO 800
      ENDIF
c ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM = PATH_DB(1:LEN)//'/list/domain_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_DOM,NSEGMAX,IERR)
      IF(IERR.NE.0.OR.NSEGMAX.LE.0) THEN
        IERR = 9
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_LIST')
        GO TO 800
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_segment_info_db:',NSEGMAX
      CALL MSGDOC(MDOC,LINE)

      allocate(NDOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(IDOMSEG_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(CODE_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM1_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM2_DOM_DB(1:NSEGMAX),STAT=ISTAT)

      CALL READ_DOMAIN_LIST(MDOC,FILE_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
      IF(IERR.NE.0) THEN
        IERR = 9
        GO TO 700
      ENDIF
C ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM_DESCR = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'
      CALL CHECK_MEMORY_FOR_LIST(MDOC
     *              ,FILE_DOM_DESCR,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_DESCR')
        IERR = 9
        GO TO 600
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_dom_db:',NDOM_DESCR_MAX
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM_DESCR_MAX.LE.0) THEN
        IERR = 9
        GO TO 600
      ENDIF

C     allocation        

      allocate(ID_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PH_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PB_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_DOM_DESCR,NDOMAIN
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) GO TO 600
      WRITE(LINE,*) 'N_domain_db:',NDOMAIN
      CALL MSGDOC(MDOC,LINE)

      IF(NDOMAIN.LE.0) THEN
        IERR = 9
        GO TO 600
      ENDIF
C --------------
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_SCR(1:LEN)//'temp_chain_list.txt'
      ELSE
        FILE_OUT = 'temp_chain_list.txt'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: cannot open output file-temp_chain_list.txt')
        IERR = 6
        GO TO 600
      ENDIF
C ----------------
      N_SEQ_TOT = 0
      ISEQ = 0
      FILE_TEMP_SEQ = ' '
      CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
        IERR = 9
        GO TO 600
      ENDIF
      NSEQUENCE = ISEQ
      WRITE(LINE,'(A,I5)') 'N_input_sequences :',NSEQUENCE
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQUENCE.LE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: N_input_sequences = 0')
        IERR = 7
        GO TO 600
      ENDIF

      DO ISEQ=1,NSEQUENCE

        WRITE(LINE,'(A,I5,A)') '----- Sequence :',ISEQ,' -----'
        CALL MSGDOC(MDOC,LINE)

        IF(NSEQUENCE.EQ.1) THEN
          FILE_TEMP_SEQ = FILE_SEQ
        ELSE
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_TEMP_SEQ = PATH_SCR(1:LEN)//'temp_sequence.seq'
          ELSE
            FILE_TEMP_SEQ = 'temp_sequence.seq'
          ENDIF
          CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
            IERR = 9
            GO TO 600
          ENDIF
        ENDIF
        CALL SEARCH_ALIGN_SEQ_DB(MDOC,ISEQ,HARD,PRF
     *     ,FILE_TEMP_SEQ,IOUT
     *     ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB,FBACK_DB
     *     ,NAT_DB,NAA_DB,IHIER_DB,RESOL_DB
     *     ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *     ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *     ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *     ,RINBYR_DOM,RSBYR_DOM
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,N_SEQ,NDOM
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN 
c          IERR = 5
          CLOSE(IOUT)
          GO TO 600
        ENDIF

        N_SEQ_TOT = N_SEQ_TOT + N_SEQ
        IF(FIDENT_BEST_TOT.LT.FIDENT_BEST) 
     *             FIDENT_BEST_TOT = FIDENT_BEST
        IF(SCORE_BEST_TOT.LT.SCORE_BEST) 
     *             SCORE_BEST_TOT = SCORE_BEST
      ENDDO
C ----------------

C      LINE = 'END'
C      CALL LENSTR_BL(LINE,LEN)
C      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

      END FILE IOUT
      CLOSE(IOUT)

      IF(N_SEQ_TOT.LE.0) THEN
        LINE = 'ERROR: no homologous was found'
        CALL MSGDOC(MDOC,LINE)
        IERR = 5
      ENDIF

600   CONTINUE

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

700   CONTINUE

      deallocate(NDOM_DB,STAT=ISTAT)
      deallocate(IDOMSEG_DB,STAT=ISTAT)
      deallocate(CODE_DOM_DB,STAT=ISTAT)
      deallocate(PNUM1_DOM_DB,STAT=ISTAT)
      deallocate(PNUM2_DOM_DB,STAT=ISTAT)

800   CONTINUE
      
C     deallocation

      deallocate(ID_DB,STAT=ISTAT)
      deallocate(NAA_DB,STAT=ISTAT)
      deallocate(NAT_DB,STAT=ISTAT)
      deallocate(NRES_DB,STAT=ISTAT)
      deallocate(IBACK_DB,STAT=ISTAT)
      deallocate(ILEVEL_DB,STAT=ISTAT)
      deallocate(IHIER_DB,STAT=ISTAT)
      deallocate(ICLASS_DB,STAT=ISTAT)
      deallocate(FBACK_DB,STAT=ISTAT)
      deallocate(RESOL_DB,STAT=ISTAT)
      deallocate(FIDENT_DB,STAT=ISTAT)
      deallocate(SCR_DB,STAT=ISTAT)
      deallocate(CODE_DB,STAT=ISTAT)
      deallocate(HIER_DB,STAT=ISTAT)
      deallocate(COMPLEX_DB,STAT=ISTAT)

C ------------
 900  CONTINUE
      RETURN
C ---------------------------
  500 IERR = 6
      CALL MSGDOC(MDOC,'ERROR: writing output file')
      CLOSE(IOUT)      
      GO TO 600
      END

      SUBROUTINE SEARCH_ALIGN_USER(MDOC,HARD,FILE_SEQ,FILE_OUT
     *   ,NAME_DIR,NAME_LIST
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM
     *   ,N_SEQ_TOT,FIDENT_BEST_TOT,SCORE_BEST_TOT
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1
      CHARACTER FILE_SEQ*(*),FILE_OUT*(*)
      CHARACTER NAME_DIR*(*),NAME_LIST*(*)
      REAL      RESULT (IPRROW)
C ----
      CHARACTER FILE_TEMP_SEQ*256
      CHARACTER FILE_DOM_DESCR*256
      CHARACTER FILE_LIST*256,FILE_DOM*256
      CHARACTER FILE_LIST_OUT*256,FILE_DOM_OUT*256
      CHARACTER FILE_DOM_DESCR_OUT*256
      CHARACTER PATH_DB*256
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ----
      FIDENT_MIN = SIM_LIM*100.0
c     F_LEVEL    = 0.75
      F_LEVEL    = 0.7
      FILE_OUT   = ' '
      N_SEQ      = 0
      FIDENT_BEST_TOT = 0.0
      SCORE_BEST_TOT  = 0.0
C --------------
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_SCR(1:LEN)//'temp_chain_list.txt'
      ELSE
        FILE_OUT = 'temp_chain_list.txt'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: cannot open output file-temp_chain_list.txt')
        IERR = 6
        GO TO 900
      ENDIF
C ----------------
      N_SEQ_TOT = 0
      ISEQ      = 0
      FILE_TEMP_SEQ = ' '
      CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
        CLOSE(IOUT)
        IERR = 9
        GO TO 900
      ENDIF
      NSEQUENCE = ISEQ
      WRITE(LINE,'(A,I5)') 'N_input_sequences :',NSEQUENCE
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQUENCE.LE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: N_input_sequences = 0')
        IERR = 7
        CLOSE(IOUT)
        GO TO 900
      ENDIF

      DO ISEQ=1,NSEQUENCE

        WRITE(LINE,'(A,I5,A)') '----- Sequence :',ISEQ,' -----'
        CALL MSGDOC(MDOC,LINE)

        IF(NSEQUENCE.EQ.1) THEN
          FILE_TEMP_SEQ = FILE_SEQ
        ELSE
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_TEMP_SEQ = PATH_SCR(1:LEN)//'temp_sequence.seq'
          ELSE
            FILE_TEMP_SEQ = 'temp_sequence.seq'
          ENDIF
          CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
            CLOSE(IOUT)
            IERR = 9
            GO TO 900
          ENDIF
        ENDIF

        CALL SEARCH_ALIGN_USER_PDB(MDOC,ISEQ
     *     ,FILE_TEMP_SEQ,IOUT
     *     ,NAME_LIST,NAME_DIR
     *     ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *     ,N_SEQ
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN 
C          IERR = 5
          CLOSE(IOUT)
          GO TO 900
        ENDIF

        N_SEQ_TOT = N_SEQ_TOT + N_SEQ
        IF(FIDENT_BEST_TOT.LT.FIDENT_BEST) 
     *             FIDENT_BEST_TOT = FIDENT_BEST
        IF(SCORE_BEST_TOT.LT.SCORE_BEST) 
     *             SCORE_BEST_TOT = SCORE_BEST
      ENDDO
      IF(N_SEQ_TOT.LE.0) THEN
        LINE = 'ERROR: no homologous was found'
        CALL MSGDOC(MDOC,LINE)
        IERR = 5
      ENDIF
C ----------------

      END FILE IOUT
      CLOSE(IOUT)

C ------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE SEARCH_ALIGN_SEQ_DB(MDOC,ISEQ,HARD,PRF
     *   ,FILE_SEQ,IOUT
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *   ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB,FBACK_DB
     *   ,NAT_DB,NAA_DB,IHIER_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *   ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *   ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *   ,RINBYR_DOM,RSBYR_DOM
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,N_SEQ,NDOM
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1,PRF*1
      REAL      RESULT (IPRROW)
C ----
      INTEGER   NRES_DB(NSEQMAX),NAT_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX)
      INTEGER   IHIER_DB(NSEQMAX),NAA_DB(NSEQMAX)
      INTEGER   ICLASS_DB(NSEQMAX)
      REAL      FBACK_DB(NSEQMAX),RESOL_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,COMPLEX_DB(NSEQMAX)*10
C --
      INTEGER   NRES_DOM(NDOMAIN),NSEG_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      REAL      RINBYR_DOM(NDOMAIN)
      REAL      RSBYR_DOM(NDOMAIN)
      CHARACTER CODE_DOM(NDOMAIN)*8
C ---
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ---
      PARAMETER ( NLINEMAX = 100 )
      CHARACTER LINE_HOMOLOG_INFO(NLINEMAX)*256
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C --
      PARAMETER ( NSTRMAXC = 100 )
      INTEGER   ND_STRING_CP,IDOMSEG_CP(NSTRMAXC),ND_RES_CP(NSTRMAXC)
      INTEGER   IDOMDOM_CP(NSTRMAXC)
      CHARACTER PNUM1_DM_CP(NSTRMAXC)*6,PNUM2_DM_CP(NSTRMAXC)*6
      CHARACTER CODE_HOMOL_DM_CP(NSTRMAXC)*8
      REAL      FIDENT_DM_CP(NSTRMAXC),SCORE_DM_CP(NSTRMAXC)
     *         ,Q_DM_CP(NSTRMAXC)
C ---
      CHARACTER FILE_SEQ*(*)
      CHARACTER FILE_PDB*256,FILE_OUT*256
      CHARACTER PATH_DB*256,CODE_TARGET*8
      CHARACTER MODE*1,CH10*10,CODE*8
      CHARACTER DIR_FOR_NEW_SEQ*256
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
C ---
      INTEGER   NLETT,NLETTD
      CHARACTER LETT*26,LETTD*10
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA LETTD/'0123456789'/
      DATA NLETT/26/,NLETTD/10/
      CHARACTER FRMT*256,FRMT1*256      
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT  = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,'//
     *        'F6.2,1X,I6,1X,I6,1X,A10,1X,F6.1,1X,F6.3,1X,F6.3)'
      FRMT1 = '(I6,1X,A8,1X,F6.1,1X,F6.3,1X,F6.3'//
     *        ',1X,I6,1X,I6,1X,I6,1X,F6.2,1X,I5,1X,I5)'
C --------------------------------------------------
C#H 0..9:    0.8    0.6    0.5    0.4    0.4    0.3    0.3    0.2    0.2    0.0
C#N 0...9:  3318  1348  1820   792  2873   480   545   562   496  1468


      FIDENT_MIN  = SIM_LIM*100.0
c     F_LEVEL     = 0.75
      F_LEVEL     = 0.7
      N_SEQ       = 0
      NDOM        = 0
      FIDENT_BEST = 0.0
      SCORE_BEST  = 0.0
      ND_STRING   = 0
      ISEG_NEW    = 0
      CODE_TARGET = 'XXXXA   '
      ICODE_TARGET= 0

      CALL CALC_NAA_NATOM_IN_SEQUENCE(M,FILE_SEQ
     *       ,NRES,NATOM,IERR)
      IF(IERR.NE.0.OR.NRES.LE.0.OR.NATOM.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: read sequence file or Naa = 0 or Natom=0')
        IERR = 2
        GO TO 600
      ENDIF
      WRITE(LINE,*) ' Naa in sequence   :',NRES
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' Natom in sequence :',NATOM
      CALL MSGDOC(MDOC,LINE)

      NLINE_WRITE_MAX = NSEQ_MAX
      IF(NSEQ_MAX.GT.NLINEMAX) NLINE_WRITE_MAX = NLINEMAX

      NATOM_TOT   = NATOM
      NRES_TOT    = NRES 
      NRES_ALIGN  = 0
      NRES_DOMAIN = 0 

      FILE_PDB    = ' '
      MODE        = 'S'
      
      NLINE_INFO  = 0
      NDOMAIN_INI = NDOMAIN
      DIR_FOR_NEW_SEQ = ' '
C ---
      CALL SEARCH_HOMOLOG_BY_SEQ_AND_PDB(MDOC,MODE,HARD,PRF
     *     ,ICODE_TARGET,CODE_TARGET,FILE_PDB,FILE_SEQ
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB
     *     ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *     ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *     ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *     ,ND_STRING_CP,IDOMDOM_CP,IDOMSEG_CP,ND_RES_CP
     *     ,PNUM1_DM_CP,PNUM2_DM_CP,CODE_HOMOL_DM_CP,NSTRMAXC
     *     ,FIDENT_DM_CP,SCORE_DM_CP,Q_DM_CP
     *     ,NRES_TOT_CP,NRES_ALIGN_CP,NRES_DOMAIN_CP
     *     ,ISEG_NEW,NLINE_WRITE_MAX
     *     ,FIDENT_BEST,SCORE_BEST,Q_FIN,NPAIR,DRMS
     *     ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,
     *   'ERROR: in SEARCH_HOMOLOG_BY_SEQ_AND_PDB')
        IERR = 9
        GO TO 600
      ENDIF
C ---
c      write(*,*) '==',NLINE_INFO,ND_STRING

      N_LINES = NLINE_INFO

      IF(NLINE_INFO.GT.0.OR.ND_STRING.GT.0) THEN

        WRITE(LINE,'(A10,I5,A10,I6,I8)') 
     *  'Sequence :',ISEQ,' PROTEIN  ',NRES_TOT,NATOM_TOT
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

        CALL MSGDOC(MDOC,LINE)

        IF(NLINE_INFO.GT.0.AND.FIDENT_BEST.GE.FIDENT_MIN) THEN
        
          N_LINES = NLINE_INFO
          N_SEQ   = NLINE_INFO

          WRITE(LINE,'(A10,I5)') 
     *    'N_struct :',N_LINES
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          CALL MSGDOC(MDOC,LINE)

          LINE =  '#   id code      ident  score  Q'//
     *            '        naa    res    nat  resol f_dom f_mult'
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          DO I=1,NLINE_INFO
            LINE = LINE_HOMOLOG_INFO(I)
            READ(LINE,FRMT,ERR=500)
     *         IC,IL,IH,IB,FB,CODE,NAA,RS,NA,NR,CH10,FI,SC,Q
            IH  = IHIER_DB(IC) 
            FB  = FBACK_DB(IC)
            NAA = NAA_DB(IC)
            RS  = RESOL_DB(IC)
            NA  = NAT_DB(IC)
            CODE(6:8) = '   '

            IFLAG_DOM = 0
            IF(CH10(2:2).NE.'0'.AND.CH10(1:1).NE.'.'.AND.
     *                              CH10(2:2).NE.'_'   ) THEN
              DO LL=1,NLETT
                IF(LETT(LL:LL).EQ.CH10(2:2)) THEN
                  IFLAG_DOM = LL + 9
                  GO TO 111
                ENDIF
              ENDDO
              DO LL=1,NLETTD
                IF(LETTD(LL:LL).EQ.CH10(2:2)) THEN
                  READ(CH10(2:2),'(I1)') IFLAG_DOM
                  GO TO 111
                ENDIF
              ENDDO
              IFLAG_DOM = 1
  111         CONTINUE
            ENDIF

            NM   = 0
            IF(CH10(1:1).NE.'.') THEN
              IF(CH10(4:4).NE.'0') THEN
                NM = 2
              ELSE IF(CH10(6:6).NE.'0') THEN
                NM = 3
              ELSE IF(CH10(8:8).NE.'0') THEN
                NM = 4
              ELSE IF(CH10(10:10).NE.'0') THEN
                NM = 5
              ENDIF
            ENDIF
            IFLAG_MULT = NM

            WRITE(LINE,FRMT1,ERR=500)
     *        IC,CODE,FI,SC,Q,NAA,NR,NA,RS,IFLAG_DOM,IFLAG_MULT
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
          ENDDO
        ENDIF

        IF(ND_STRING.GT.0) THEN
          NDOM = IDOMDOM(1)
          FIDENT_BEST = FIDENT_DM(1)
          SCORE_BEST  = SCORE_DM(1)              
          IF(N_LINES.LE.0) THEN
            IDIFF = 0
            IF(ND_STRING.GT.1) THEN
              DO I=2,ND_STRING
              IDOM = IDOMSEG(I)/100
              ISEG = IDOMSEG(I) - IDOM*100
                IF(CODE_HOMOL_DM(I).NE.CODE_HOMOL_DM(I-1)) IDIFF = 1
              ENDDO
            ENDIF
            IF(IDIFF.EQ.0.AND.FIDENT_BEST.LT.FIDENT_MIN) THEN
              DO IC=1,NSEQ
                IF(CODE_DB(IC)(1:5).EQ.CODE_HOMOL_DM(I)(1:5)) GO TO 410
              ENDDO
              GO TO 420
  410         CONTINUE
c              LINE =  '#   id L  ihier  iback fidbk  code5'//
c     *                '       naa    res    nat'//
c     *                '   nres D0203040C0  ident  score'

              LINE =  '#   id code ident  score naa res'//
     *            '  nat resol f_dom f_mult'
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
              IH   = IHIER_DB(IC) 
              FB   = FBACK_DB(IC)
              NAA  = NAA_DB(IC)
              RS   = RESOL_DB(IC)
              NA   = NAT_DB(IC)
              CODE = CODE_HOMOL_DM(1)
              IL   = 0
              IB   = 0
              CH10 = COMPLEX_DB(IC)
              NR   = NRES_DB(IC)
              FI   = FIDENT_BEST
              SC   = SCORE_BEST 
              Q    = Q_DM(1)

              IFLAG_DOM = 0
              IF(CH10(2:2).NE.'0'.AND.CH10(1:1).NE.'.'.AND.
     *                              CH10(2:2).NE.'_'   ) THEN
                DO LL=1,NLETT
                  IF(LETT(LL:LL).EQ.CH10(2:2)) THEN
                    IFLAG_DOM = LL + 9
                    GO TO 112
                  ENDIF
                ENDDO
                DO LL=1,NLETTD
                  IF(LETTD(LL:LL).EQ.CH10(2:2)) THEN
                    READ(CH10(2:2),'(I1)') IFLAG_DOM
                    GO TO 112
                  ENDIF
                ENDDO
                IFLAG_DOM = 1
  112           CONTINUE
              ENDIF

              NM   = 0
              IF(CH10(1:1).NE.'.') THEN
                IF(CH10(4:4).NE.'0') THEN
                  NM = 2
                ELSE IF(CH10(6:6).NE.'0') THEN
                  NM = 3
                ELSE IF(CH10(8:8).NE.'0') THEN
                  NM = 4
                ELSE IF(CH10(10:10).NE.'0') THEN
                  NM = 5
                ENDIF
              ENDIF
              IFLAG_MULT = NM

              WRITE(LINE,FRMT1,ERR=500)
     *        IC,CODE,FI,SC,Q,NAA,NR,NA,RS,IFLAG_DOM,IFLAG_MULT
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

              N_SEQ     = 1
              N_LINES   = 1
              ND_STRING = 0
              N_STRING  = 0
              GO TO 400
            ENDIF
          ENDIF
        ENDIF

  420   CONTINUE

        IF(N_LINES.LE.0) THEN
          WRITE(LINE,'(A,I5)') 
     *    'N_struct: ',N_LINES
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          CALL MSGDOC(MDOC,LINE)

        ENDIF

        IF(ND_STRING.GT.0) THEN
          NDOM = IDOMDOM(1)
          N_STRING = ND_STRING
 
          WRITE(LINE,'(A10,2I5)',ERR=500) 
     *    'N_domain :',NDOM,ND_STRING
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          CALL MSGDOC(MDOC,LINE)

          DO I=1,ND_STRING
            IDOM = IDOMSEG(I)/100
            ISEG = IDOMSEG(I) - IDOM*100

            WRITE(LINE,
     * '(I5,1X,I5,2X,A6,1X,A6,2X,A8,1X,F5.1,1X,F5.3,1X,F6.3)')
     *       IDOMDOM(I),IDOMSEG(I)
     *       ,PNUM1_DM(I),PNUM2_DM(I),CODE_HOMOL_DM(I)
     *       ,FIDENT_DM(I),SCORE_DM(I),Q_DM(I)
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          ENDDO
          N_SEQ = N_SEQ + 1
        ENDIF

  400   CONTINUE

        IF(ND_STRING.LE.0) THEN
          NDOM = 0
          WRITE(LINE,'(A,2I5)',ERR=500) 
     *    'N_domain: ',NDOM,ND_STRING
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          CALL MSGDOC(MDOC,LINE)

        ENDIF

        IF(N_LINES.LE.0.AND.N_STRING.LE.0) THEN 
          IERR = 5
          GO TO 600
        ENDIF

        LINE = 'END'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

      ENDIF

600   CONTINUE
      
C ------------
 900  CONTINUE
      RETURN
C ---------------------------
  500 IERR = 6
      CALL MSGDOC(MDOC,'ERROR: writing output file')
      RETURN
      END

      SUBROUTINE SEARCH_ALIGN_USER_PDB(MDOC,ISEQ
     *     ,FILE_SEQ,IOUT
     *     ,NAME_LIST,NAME_DIR
     *     ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *     ,N_SEQ
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
      REAL      RESULT (IPRROW)
      CHARACTER NAME_LIST*(*),NAME_DIR*(*)
      CHARACTER FILE_SEQ*(*)
C ----
      integer,   allocatable :: ID_USER(:)
      integer,   allocatable :: NRES_USER(:)
      integer,   allocatable :: NAT_USER(:)
      real,      allocatable :: FID_USER(:)
      real,      allocatable :: SC_USER(:)
      real,      allocatable :: Q_USER(:)
      character(LEN=8), allocatable :: CODE_USER(:)
C ----
      CHARACTER CODE*8
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
C ---
      CHARACTER FRMT1*256      
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT1 = '(I6,1X,A8,1X,F6.1,1X,F6.3,1X,F6.3'//
     *        ',1X,I6,1X,I6,1X,I6,1X,F6.2,1X,I5,1X,I5)'
C --------------------------------------------------
      FIDENT_MIN  = SIM_LIM*100.0
      F_LEVEL     = 0.7
      N_SEQ       = 0
      FIDENT_BEST = 0.0
      SCORE_BEST  = 0.0
      Q_LIM       = 0.2
C ---
      CALL CALC_NAA_NATOM_IN_SEQUENCE(M,FILE_SEQ
     *       ,NRES_SEQ,NATOM_SEQ,IERR)
      IF(IERR.NE.0.OR.NRES_SEQ.LE.0.OR.NATOM_SEQ.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: read sequence file or Naa = 0 or Natom=0')
        IERR = 2
        GO TO 600
      ENDIF
      WRITE(LINE,*) ' Naa in sequence :',NRES_SEQ
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' Natom in sequence :',NATOM_SEQ
      CALL MSGDOC(MDOC,LINE)
C ---
      CALL CHECK_MEMORY_FOR_LIST(MDOC,NAME_LIST,NUSER,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        IERR = 9
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'N_user_pdb:',NUSER
      CALL MSGDOC(MDOC,LINE)
      IF(NUSER.LE.0) THEN
        IERR = 9
        GO TO 900
      ENDIF

      NUSER = NUSER*10
C
      allocate(ID_USER(1:NUSER),STAT=ISTAT)
      allocate(NRES_USER(1:NUSER),STAT=ISTAT)
      allocate(NAT_USER(1:NUSER),STAT=ISTAT)
      allocate(FID_USER(1:NUSER),STAT=ISTAT)
      allocate(SC_USER(1:NUSER),STAT=ISTAT)
      allocate(Q_USER(1:NUSER),STAT=ISTAT)
      allocate(CODE_USER(1:NUSER),STAT=ISTAT)
C ---
      CALL SEARCH_HOMOLOG_BY_USER_PDB(MDOC
     *     ,FILE_SEQ
     *     ,NAME_LIST,NAME_DIR
     *     ,NUSER,ID_USER,NRES_USER,NAT_USER
     *     ,FID_USER,SC_USER,Q_USER,CODE_USER
     *     ,N_SEQ,NRES,Q_LIM
     *     ,FIDENT_BEST,SCORE_BEST,Q_FIN,NPAIR,DRMS
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,
     *   'ERROR: in SEARCH_HOMOLOG_BY_USER_PDB')
        GO TO 600
      ENDIF
C ---

      IF(N_SEQ.GT.0) THEN

        WRITE(LINE,'(A,I5,A,I5,A)') 
     *  'Sequence :',ISEQ,' - ',N_SEQ,'  homologous found'
        CALL MSGDOC(MDOC,LINE)

        WRITE(LINE,'(A10,I5,A10,I6,I8)') 
     *  'Sequence :',ISEQ,' PROTEIN  ',NRES_SEQ,NATOM_SEQ
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

        NS = N_SEQ
        NF = N_SEQ - NSEQ_MAX + 1
        IF(NF.LE.0) NF = 1
        
        N_SEQ_WRITE = NS - NF + 1 

        WRITE(LINE,'(A10,I5)') 
     *    'N_struct :',N_SEQ_WRITE
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

        LINE =  '#   id code      ident  score  Q'//
     *            '        naa    res    nat  resol f_dom f_mult'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

        DO IC=NS,NF,-1
          IH  = 0 
          FB  = 0
          RS  = 0
          ICC = ID_USER(IC)
          NAA = NRES_USER(ICC)
          NR  = NRES_USER(ICC)
          FI  = FID_USER(ICC)
          SC  = SC_USER(ICC)
          Q   = Q_USER(IC)
          NA  = NAT_USER(ICC)
          CODE = CODE_USER(ICC)
          IFLAG_DOM  = 0
          IFLAG_MULT = 0

          WRITE(LINE,FRMT1,ERR=500)
     *        ICC,CODE,FI,SC,Q,NAA,NR,NA,RS,IFLAG_DOM,IFLAG_MULT
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

        ENDDO

        NDOM = 0
        ND_STRING = 0
        WRITE(LINE,'(A,2I5)',ERR=500) 
     *    'N_domain :',NDOM,ND_STRING
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
        LINE = 'END'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

      ELSE

        WRITE(LINE,'(A,I5,A)') 
     *  'Sequence :',ISEQ,' - no homologous was found'
        CALL MSGDOC(MDOC,LINE)
c        IERR = 5
        GO TO 600

      ENDIF

600   CONTINUE

      deallocate(ID_USER,STAT=ISTAT)
      deallocate(NRES_USER,STAT=ISTAT)
      deallocate(NAT_USER,STAT=ISTAT)
      deallocate(FID_USER,STAT=ISTAT)
      deallocate(SC_USER,STAT=ISTAT)
      deallocate(Q_USER,STAT=ISTAT)
      deallocate(CODE_USER,STAT=ISTAT)
C ------------
 900  CONTINUE
      RETURN
C ---------------------------
  500 IERR = 6
      CALL MSGDOC(MDOC,'ERROR: writing output file')
      GO TO 600
      END

      SUBROUTINE SEARCH_HOMOLOG_BY_USER_PDB(MDOC
     *     ,FILE_SEQ
     *     ,NAME_LIST,NAME_DIR
     *     ,NUSER,ID_USER,NRES_USER,NAT_USER
     *     ,FID_USER,SC_USER,Q_USER,CODE_USER
     *     ,N_SEQ,NRES,Q_LIM
     *     ,FIDENT_BEST,SCORE_BEST,Q_FIN_BEST,NPAIR_BEST,DRMS_BEST
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*)
      REAL      RESULT (IPRROW)
      CHARACTER NAME_LIST*(*),NAME_DIR*(*)
      CHARACTER FILE_SEQ*(*)
C ----
      INTEGER   ID_USER(NUSER),NRES_USER(NUSER),NAT_USER(NUSER)
      REAL      FID_USER(NUSER),SC_USER(NUSER),Q_USER(NUSER)
      CHARACTER CODE_USER(NUSER)*8
C ----
      CHARACTER FILE_1*256,FILE_SCR*256
      CHARACTER FILE_PDB*256,FILE_CRD*256
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------
C ---
      CHARACTER CHAIN_INP*1,CODE*8
      CHARACTER CODE_PDB*4,DATE_PDB*9
      REAL      CELL(6)
      CHARACTER STR_TITLE*40,STR_DATE*9
      REAL      FCH4      
      CHARACTER CH4*4
      EQUIVALENCE (FCH4,CH4)
      PARAMETER ( IPRROW2 = 200 )
      REAL      RESULT2 (IPRROW2)
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      N_SEQ       = 0
      FIDENT_BEST = 0.0
      SCORE_BEST  = 0.0
      Q_FIN_BEST  = 0.0
      NPAIR_BEST  = 0
      DRMS_BEST   = 0.0
C ---------------------------
      MT   = 30
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(MT,M,PATH,NAME_LIST,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open input list file')
        IERR = 8
        GO TO 900
      ENDIF

      IPDB = 0
 100  CONTINUE

      READ(MT,'(A)',ERR=300,END=200) FILE_1
      CALL LENSTR_BL(FILE_1,LEN)
      IF(LEN.LE.1.OR.FILE_1(1:1).EQ.'#') GO TO 100
      IPDB = IPDB + 1
      CALL LENSTR_BL(NAME_DIR,LEN_DIR)
      FILE_1 = NAME_DIR(1:LEN_DIR)//FILE_1(1:LEN)
      FILE_SCR = 'sequence_input.seq'
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_SCR = PATH_SCR(1:LEN)//'sequence_input.seq'
      ENDIF
      CHAIN_INP = ' '
      CALL PDB2SEQ(M,FILE_1,FILE_SCR
     *   ,CODE_PDB,DATE_PDB
     *   ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *   ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERROR: read user pdb file'
        CALL MSGERR(MDOC,LINE)
        IERR = 0
        GO TO 100
      ENDIF
      NCHAIN = RESULT(1)
      IF(NCHAIN.LE.0) THEN
        GO TO 100
      ENDIF
      IICH = 0
      DO ICH=1,NCHAIN
        IICH   = IICH + 2
        FCH4 = RESULT(IICH)
        NRES = RESULT(IICH+1)
        IF(NRES.GE.25) THEN
          CHAIN_INP = CH4(1:1)
          WRITE(CODE(1:4),'(I4)') IPDB

          IF(CODE(1:1).EQ.' ') CODE(1:1) = 'U'
          IF(CODE(2:2).EQ.' ') CODE(2:2) = '_'
          IF(CODE(3:3).EQ.' ') CODE(3:3) = '_'
          CODE = CODE(1:4)//CHAIN_INP//'__u'
          IF(CHAIN_INP.EQ.'_') CHAIN_INP = ' '
          FILE_PDB = 'coordinate_input.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_PDB = PATH_SCR(1:LEN)//'coordinate_input.pdb'
          ENDIF
          FILE_CRD = 'coordinate_input.crd'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_CRD = PATH_SCR(1:LEN)//'coordinate_input.crd'
          ENDIF
          PATH = ' '
          CALL READPDB(M,FILE_1,FILE_CRD,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT2,IPRROW2,CHAIN_INP,IERR)   
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: in READPDB read user pdb file'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 100
          ENDIF
          NA_CHAIN = RESULT2(2)
          IERR = 0
          CALL WRITEPDB(M,FILE_CRD,FILE_PDB,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: in WRITEPDB write user pdb file'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 110
          ENDIF
          IPRINT = 0
          FILE_SCR = ' '
          CALL MAKE_ALIGN(M,IPRINT,FILE_SEQ,FILE_PDB,FILE_SCR
     *               ,RESULT2,IPRROW2,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: MAKE_ALIGN for user"s pdb'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 110
          ENDIF
          N1  = RESULT2(1) 
          N2  = RESULT2(2) 
          NN  = RESULT2(3) 
          NI  = RESULT2(4) 
          HID = RESULT2(5) 
          SUM_SCORE  = RESULT2(6)
          SCORE1_MAX = RESULT2(13)
          SCORE1_MIN = RESULT2(14)
          Q_FIN      = RESULT2(15)
          DRMS       = RESULT2(16)
          NPAIR      = RESULT2(17)
          SCORE_NEW  = RESULT2(18)
          FID_NEW    = RESULT2(19)
          NGAP       = RESULT2(20)
          NRES = N1
          T = 1.0 - REAL(NN)/REAL(N1)
          T = EXP(-T)
          TT = (REAL(NN-NGAP)/REAL(NN))
          Q = SCORE_NEW*TT*TT*TT*TT
          Q = Q*T
c          IF(HID.GE.FIDENT_LIM.OR.
c     *        SCORE_NEW.GE.SCORE_LIM) THEN

          WRITE(LINE,'(A,2I6,5X,2F6.3)') 
     *           'Ipdb,Ichain,Q,Q_lim:',IPDB,ICH,Q,Q_LIM
          CALL MSGDOC(MDOC,LINE)

          IF(Q.GE.Q_LIM) THEN
            IF(N_SEQ.GE.NUSER) THEN
              CALL MSGERR(MDOC,
     *       'WARNING: number of homologous structures > limit')
              GO TO 200
            ENDIF
            N_SEQ = N_SEQ + 1        
            ID_USER(N_SEQ)   = N_SEQ
            NRES_USER(N_SEQ) = N2
            NAT_USER(N_SEQ)  = NA_CHAIN
            FID_USER(N_SEQ)  = HID
            SC_USER(N_SEQ)   = SCORE_NEW
            Q_USER(N_SEQ)    = Q 
            CODE_USER(N_SEQ) = CODE
            IF(Q.GT.Q_FIN_BEST) THEN
              FIDENT_BEST = HID
              SCORE_BEST  = SCORE_NEW
              Q_FIN_BEST  = Q
              NPAIR_BEST  = NN
            ENDIF
          
          ENDIF
        ELSE
          CALL MSGDOC(MDOC,'Number of AA < limit (25)')
        ENDIF 
     
  110   CONTINUE
      ENDDO
      GO TO 100
  200 CONTINUE
      CLOSE(MT)
      IF(N_SEQ.LE.0) GO TO 900

      CALL SORT1(Q_USER,N_SEQ,ID_USER)

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id code       n1  n2  Idnt score   Q'
      CALL MSGDOC(MDOC,LINE)
      II = 0
      DO ID=N_SEQ,1,-1
        II   = II + 1

        if(ii.gt.50) go to 900

        IDD  = ID_USER(ID)
        WRITE(LINE,'(I5,1X,A,1X,2I4,1X,F5.1,2F6.3)')
     *    IDD,CODE_USER(IDD),NRES,NRES_USER(IDD)
     *    ,FID_USER(IDD),SC_USER(IDD),Q_USER(ID)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

C ---------------------------
 900  CONTINUE
      RETURN
 300  CONTINUE
      CLOSE(MT)
      LINE = 'ERROR: read list file'
      CALL MSGERR(MDOC,LINE)
      GO TO 100
      END

