      SUBROUTINE SEARCH_DOM(MDOC,NAME_SEQ,NAME_PDB
     * ,NSEQ_MAX,SIM_LIM,SCORE_LIM
     * ,HARD,PRF,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C ------------------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER NAME_SEQ*(*),NAME_PDB*(*),PATH_SCR*(*),PATH_OUT*(*)
C ---
      CHARACTER FINAL_MODEL*256,FINAL_MODEL_COOT*256
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,NAME_TEMP_LIST*256
      CHARACTER MESSAGE*80,JOB*80,HARD*1,PRF*1
      CHARACTER PATH*1,EXT*3
C==================================================================
      IERR = 0
      JERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C ---------------------------------
      JOB  = 'search_DOM'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C ---------------------------------
      NSEQUENCE = 0
      SCORE_LIM = 0.0
      IF(NSEQ_MAX.LE.0     )   NSEQ_MAX   = 1
      IF(SIM_LIM .LE.0.0001)   SIM_LIM    = 0.15
      IF(SCORE_LIM .LE.0.0001) SCORE_LIM  = 0.30
      CALL LENSTR_BL(NAME_SEQ,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)')    '==file_seq:',NAME_SEQ(1:L)
        CALL MSGDOC(MDOC,LINE)
        IF(LEN.LE.0) THEN
          CALL MSGDOC(MDOC,' ERROR: wrong name sequence file')
          IERR = 2
          GO TO 510
        ENDIF
        MT   = 10
        OPEN(MT,FILE=NAME_SEQ(1:LEN),ACCESS='SEQUENTIAL',ERR=510,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
      ENDIF

C      WRITE(LINE,'(A,I8)')   '==nseq_max  :',NSEQ_MAX 
C      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==sim_lim   :',SIM_LIM
c      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==score_lim :',SCORE_LIM
c      CALL MSGDOC(MDOC,LINE)

C ---------------------------------  
      CALL MSGDOC(MDOC,' --- ')
      CALL MSGDOC(MDOC,' --- Searching in DB        ---')
      CALL MSGDOC(MDOC,' --- ')
C ---
      CALL SEARCH_ALIGN_DOM(Mdoc,HARD,PRF,NAME_SEQ,NAME_PDB
     *   ,NAME_TEMP_LIST
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,NSEQUENCE
     *   ,N_SEQ,FIDENT_BEST,SCORE_BEST
     *   ,FINAL_MODEL,FINAL_MODEL_COOT
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 500

      MESSAGE = 'normal termination'
C ---------------------------------
      GO TO 600
 510  CONTINUE
      LINE = ' ERROR: cannot open sequence file output file'
      CALL MSGERR(MD,LINE)
      MESSAGE = 'input sequence file : open/read'
      IERR = 2
      GO TO 600
 500  CONTINUE
      MESSAGE = 'null'
      IF(IERR.EQ.1) THEN
C        MESSAGE = 'no memory for alignement'
      ELSE IF(IERR.EQ.2) THEN
        MESSAGE = 'input sequence file : open/read'
      ELSE IF(IERR.EQ.3) THEN
        MESSAGE = 'chain_list_DB: open/read'
      ELSE IF(IERR.EQ.4) THEN
        MESSAGE = 'wrong setenv MOLREP_DB'
      ELSE IF(IERR.EQ.5) THEN
        MESSAGE = 'no PDB structure was found'
      ELSE IF(IERR.EQ.6) THEN
        MESSAGE = 'output file - search_DOM.txt: open/write'
      ELSE IF(IERR.EQ.7) THEN
        MESSAGE = 'input sequence file : no title or no sequence'
      ENDIF
C --
 600  CONTINUE

      CALL WRITE_SEARCH_DOM_XML(MDOC,IERR,MESSAGE,JOB
     *   ,NSEQUENCE,N_SEQ,FIDENT_BEST,NAME_TEMP_LIST
     *   ,FINAL_MODEL,FINAL_MODEL_COOT
     *   ,PATH_OUT,JERR)
C      IERR = JERR
      RETURN
      END

      SUBROUTINE WRITE_SEARCH_DOM_XML(MDOC,IERR_INPUT,MESSAGE,JOB
     *            ,NSEQUENCE,N_SEQ,FIDENT_BEST,NAME_TEMP_LIST
     *            ,FINAL_MODEL,FINAL_MODEL_COOT
     *            ,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER FINAL_MODEL*(*),FINAL_MODEL_COOT*(*)
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*),NAME_TEMP_LIST*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'N_input_chain <N_chain> ',NSEQUENCE,' </N_chain>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(IERR_INPUT.EQ.0) THEN
 
        CALL LENSTR_BL(NAME_TEMP_LIST,L)
        LINE = 'info_list <info_list info_list="'//
     *          NAME_TEMP_LIST(1:L)//'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

        CALL LENSTR_BL(FINAL_MODEL,L)
        LINE = 'model <model model="'//
     *          FINAL_MODEL(1:L)//'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
 
        CALL LENSTR_BL(FINAL_MODEL_COOT,L)
        LINE = 'model_coot <model_coot model_coot="'//
     *          FINAL_MODEL_COOT(1:L)//'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      ENDIF

      LINE = '</'//JOB(1:LJ)//'>' 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE SEARCH_ALIGN_DOM(MDOC,HARD,PRF
     *   ,FILE_SEQ,FILE_PDB_INPUT,FILE_OUT
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,NSEQUENCE
     *   ,N_SEQ_TOT,FIDENT_BEST_TOT,SCORE_BEST_TOT
     *   ,FINAL_MODEL,FINAL_MODEL_COOT
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1,PRF*1
      CHARACTER FILE_SEQ*(*),FILE_PDB_INPUT*(*),FILE_OUT*(*)
      CHARACTER FINAL_MODEL*(*),FINAL_MODEL_COOT*(*)
      REAL      RESULT (IPRROW)
C ----
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)

      integer,   allocatable :: NDOM_DB(:)
      integer,   allocatable :: IDOMSEG_DB(:)
      character(LEN=8), allocatable :: CODE_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM1_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM2_DOM_DB(:)

      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)
C ---
      CHARACTER FILE_TEMP_SEQ*256
      CHARACTER FILE_DOM_DESCR*256
      CHARACTER FILE_LIST*256,FILE_DOM*256
      CHARACTER FILE_LIST_OUT*256,FILE_DOM_OUT*256
      CHARACTER FILE_DOM_DESCR_OUT*256
      CHARACTER PATH_DB*256
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
c ----
      FIDENT_MIN = SIM_LIM*100.0
c     F_LEVEL    = 0.75
      F_LEVEL    = 0.7
      FILE_OUT   = ' '
      N_SEQ      = 0
      FIDENT_BEST_TOT = 0.0
      SCORE_BEST_TOT  = 0.0
      IF(HARD.EQ.'y') HARD = 'Y'
      IF(HARD.NE.'Y') HARD = 'N'
      WRITE(LINE,*) 'HARD :',HARD
      CALL MSGDOC(MDOC,LINE)
      IF(PRF.EQ.'y') PRF = 'Y'
      IF(PRF.NE.'Y') PRF = 'N'
      WRITE(LINE,*) 'PRF :',PRF
      CALL MSGDOC(MDOC,LINE)
C ------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: problem with "setenv MOLREP_DB"')
        CALL MSGERR(MDOC
     *  ,'       Example: "setenv MOLREP_DB ~alexei/molrep_DB"')
        GO TO 900
      ENDIF

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_LIST = PATH_DB(1:LEN)//'/list/chain_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 900
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_chain_db:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

C
c       list/chain_list.txt
C
      allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)

      I_MIN = 1
      I_MAX = 100000
      CALL READ_CHAIN_LIST(MDOC,FILE_LIST,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0) GO TO 800
c ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM = PATH_DB(1:LEN)//'/list/domain_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_DOM,NSEGMAX,IERR)
      IF(IERR.NE.0.OR.NSEGMAX.LE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_LIST')
        GO TO 800
      ENDIF

      WRITE(LINE,*) 'MEMORY for N_segment_info_db:',NSEGMAX
      CALL MSGDOC(MDOC,LINE)

      allocate(NDOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(IDOMSEG_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(CODE_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM1_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM2_DOM_DB(1:NSEGMAX),STAT=ISTAT)

      CALL READ_DOMAIN_LIST(MDOC,FILE_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
      IF(IERR.NE.0) GO TO 700
C ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM_DESCR = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'
      CALL CHECK_MEMORY_FOR_LIST(MDOC
     *              ,FILE_DOM_DESCR,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_DESCR')
        GO TO 600
      ENDIF

      NDOM_DESCR_MAX = NDOM_DESCR_MAX + 20

      WRITE(LINE,*) 'MEMORY for N_dom_db:',NDOM_DESCR_MAX
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM_DESCR_MAX.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF

C     allocation        

      allocate(ID_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PH_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PB_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_DOM_DESCR,NDOMAIN
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) GO TO 600
      WRITE(LINE,*) 'N_domain_db:',NDOMAIN
      CALL MSGDOC(MDOC,LINE)
      IF(NDOMAIN.LE.0) THEN
        IERR = 1
        GO TO 600
      ENDIF
C --------------
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_SCR(1:LEN)//'search_DOM.txt'
      ELSE
        FILE_OUT = 'search_DOM.txt'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 21
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,
     *  ' ERROR: cannot open output file - search_DOM.txt')
        IERR = 6
        GO TO 600
      ENDIF
C ----------------
      N_SEQ_TOT = 0
      ISEQ      = 1
       CALL SEARCH_ALIGN_SEQ_DOM(MDOC,ISEQ,HARD,PRF
     *     ,FILE_SEQ,FILE_PDB_INPUT,IOUT
     *     ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB,FBACK_DB
     *     ,NAT_DB,NAA_DB,IHIER_DB,RESOL_DB
     *     ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *     ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *     ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *     ,RINBYR_DOM,RSBYR_DOM
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,N_SEQ,NDOM,NSEQUENCE
     *     ,FINAL_MODEL,FINAL_MODEL_COOT
     *     ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        IERR = 5
        CLOSE(IOUT)
        GO TO 600
      ENDIF

      N_SEQ_TOT = N_SEQ_TOT + N_SEQ
      IF(FIDENT_BEST_TOT.LT.FIDENT_BEST) 
     *           FIDENT_BEST_TOT = FIDENT_BEST
      IF(SCORE_BEST_TOT.LT.SCORE_BEST) 
     *          SCORE_BEST_TOT = SCORE_BEST
C ----------------

C      LINE = 'END'
C      CALL LENSTR_BL(LINE,LEN)
C      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

      END FILE IOUT
      CLOSE(IOUT)

600   CONTINUE

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

700   CONTINUE

      deallocate(NDOM_DB,STAT=ISTAT)
      deallocate(IDOMSEG_DB,STAT=ISTAT)
      deallocate(CODE_DOM_DB,STAT=ISTAT)
      deallocate(PNUM1_DOM_DB,STAT=ISTAT)
      deallocate(PNUM2_DOM_DB,STAT=ISTAT)

800   CONTINUE
      
C     deallocation

      deallocate(ID_DB,STAT=ISTAT)
      deallocate(NAA_DB,STAT=ISTAT)
      deallocate(NAT_DB,STAT=ISTAT)
      deallocate(NRES_DB,STAT=ISTAT)
      deallocate(IBACK_DB,STAT=ISTAT)
      deallocate(ILEVEL_DB,STAT=ISTAT)
      deallocate(IHIER_DB,STAT=ISTAT)
      deallocate(ICLASS_DB,STAT=ISTAT)
      deallocate(FBACK_DB,STAT=ISTAT)
      deallocate(RESOL_DB,STAT=ISTAT)
      deallocate(FIDENT_DB,STAT=ISTAT)
      deallocate(SCR_DB,STAT=ISTAT)
      deallocate(CODE_DB,STAT=ISTAT)
      deallocate(HIER_DB,STAT=ISTAT)
      deallocate(COMPLEX_DB,STAT=ISTAT)

C ------------
 900  CONTINUE
      RETURN
C ---------------------------
  500 IERR = 6
      CALL MSGDOC(MDOC,'ERROR: writing output file')
      CLOSE(IOUT)      
      GO TO 600
      END

      SUBROUTINE SEARCH_ALIGN_SEQ_DOM(MDOC,ISEQ,HARD,PRF
     *   ,FILE_SEQ,FILE_PDB_INPUT,IOUT
     *   ,NSEQ_MAX,SIM_LIM,SCORE_LIM,FIDENT_BEST,SCORE_BEST
     *   ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB,FBACK_DB
     *   ,NAT_DB,NAA_DB,IHIER_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *   ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *   ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *   ,RINBYR_DOM,RSBYR_DOM
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,N_SEQ,NDOM,NSEQUENCE
     *   ,FINAL_MODEL,FINAL_MODEL_COOT
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1,PRF*1
      CHARACTER FINAL_MODEL*(*),FINAL_MODEL_COOT*(*)
      REAL      RESULT (IPRROW)
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------
C ----
      INTEGER   NRES_DB(NSEQMAX),NAT_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX)
      INTEGER   ICLASS_DB(NSEQMAX)
      INTEGER   IHIER_DB(NSEQMAX),NAA_DB(NSEQMAX)
      REAL      FBACK_DB(NSEQMAX),RESOL_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,COMPLEX_DB(NSEQMAX)*10
C --
      INTEGER   NRES_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN),NSEG_DOM(NDOMAIN)
      REAL      RINBYR_DOM(NDOMAIN)
      REAL      RSBYR_DOM(NDOMAIN)
      CHARACTER CODE_DOM(NDOMAIN)*8
C ---
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ---
      PARAMETER ( NLINEMAX = 100 )
      CHARACTER LINE_HOMOLOG_INFO(NLINEMAX)*256
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C --
      PARAMETER ( NSTRMAXC = 100 )
      INTEGER   ND_STRING_CP,IDOMSEG_CP(NSTRMAXC),ND_RES_CP(NSTRMAXC)
      INTEGER   IDOMDOM_CP(NSTRMAXC)
      CHARACTER PNUM1_DM_CP(NSTRMAXC)*6,PNUM2_DM_CP(NSTRMAXC)*6
      CHARACTER CODE_HOMOL_DM_CP(NSTRMAXC)*8
      REAL      FIDENT_DM_CP(NSTRMAXC),SCORE_DM_CP(NSTRMAXC)
     *         ,Q_DM_CP(NSTRMAXC)
C ---
      CHARACTER FILE_SEQ*(*),FILE_PDB_INPUT*(*),FILE_TEMP*256
      CHARACTER FILE_PDB*256,FILE_OUT*256,FILE_CRD*256
      CHARACTER FILE_TEMP_SEQ*256
      CHARACTER PATH_DB*256,CODE_TARGET*8
      CHARACTER MODE*1,CH10*10,CODE*8
      CHARACTER DIR_FOR_NEW_SEQ*256
      CHARACTER LINE*256
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER PATH*1,EXT*1
      CHARACTER CHAIN_INP*1
      CHARACTER CODE_PDB*4,DATE_PDB*9
      REAL      CELL(6)
      CHARACTER STR_TITLE*40,STR_DATE*9
C ---
      INTEGER   NLETT,NLETTD
      CHARACTER LETT*26,LETTD*10
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA LETTD/'0123456789'/
      DATA NLETT/26/,NLETTD/10/
      CHARACTER FRMT*256,FRMT1*256      
      REAL      FCH4      
      CHARACTER CH4*4
      EQUIVALENCE (FCH4,CH4)
C ---
      CHARACTER TIME_CURRENT*15,TIME_ELAPSED*15,TIME_EXPECTED*15
C ---
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT  = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,'//
     *        'F6.2,1X,I6,1X,I6,1X,A10,1X,F6.1,1X,F6.3,1X,F6.3)'
      FRMT1 = '(I6,1X,A8,1X,F6.1,1X,F6.3,1X,F6.3'//
     *        ',1X,I6,1X,I6,1X,I6,1X,F6.2,1X,I5,1X,I5)'
C --------------------------------------------------
C#H 0..9:    0.8    0.6    0.5    0.4    0.4    0.3    0.3    0.2    0.2    0.0
C#N 0...9:  3318  1348  1820   792  2873   480   545   562   496  1468

      ITIME_START =-1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT
      CALL MSGDOC(MDOC,LINE)

      FIDENT_MIN  = SIM_LIM*100.0
c     F_LEVEL     = 0.75
      F_LEVEL     = 0.7
      N_SEQ       = 0
      NDOM        = 0
      FIDENT_BEST = 0.0
      SCORE_BEST  = 0.0
      ND_STRING   = 0
      ISEG_NEW    = 0
      CODE_TARGET = 'XXXXA   '
      ICODE_TARGET= 0
      FILE_OUT    = ' '
      NSEQUENCE   = 0

      CALL LENSTR_BL(FILE_PDB_INPUT,LEN)
      IF(LEN.LE.0) THEN

        ISEQ = 0
        FILE_TEMP_SEQ = ' '
        CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
          GO TO 600
        ENDIF
        NSEQUENCE = ISEQ
        WRITE(LINE,'(A,I5)') 'N_input_sequences :',NSEQUENCE
        CALL MSGDOC(MDOC,LINE)
        IF(NSEQUENCE.LE.0) THEN
          CALL MSGDOC(MDOC,'ERROR: N_input_sequences = 0')
          IERR = 7
          GO TO 600
        ENDIF
        IF(NSEQUENCE.GT.1) THEN
          CALL MSGERR(MDOC,
     *    ' WARNING: N_sequence > 1, only first will be used ')
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_TEMP_SEQ = PATH_SCR(1:LEN)//'temp_sequence.seq'
          ELSE
            FILE_TEMP_SEQ = 'temp_sequence.seq'
          ENDIF
          ISEQ = 1
          CALL GET_SEQUENCE(MDOC,ISEQ,FILE_SEQ,FILE_TEMP_SEQ,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
            GO TO 600
          ENDIF
        ELSE
          FILE_TEMP_SEQ = FILE_SEQ
        ENDIF
        CALL REMOVE_DOMAINS_FROM_SEQ(M,FILE_TEMP_SEQ,FILE_OUT
     *    ,NRES,NAA_MAX
     *    ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *    ,IERR)
        IF(IERR.NE.0.OR.NRES.LE.0) THEN
          CALL MSGERR(MDOC,' ERROR: read sequence file or Naa = 0')
          IERR = 2
          GO TO 600
        ENDIF
        WRITE(LINE,*) ' Naa in sequence :',NRES
        CALL MSGDOC(MDOC,LINE)
        FILE_PDB    = ' '
        MODE        = 'S'
      ELSE
        FILE_PDB    = FILE_PDB_INPUT
        MODE        = 'U'
        FILE_TEMP_SEQ = 'sequence_input.seq'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_TEMP_SEQ = PATH_SCR(1:LEN)//'sequence_input.seq'
        ENDIF
        CHAIN_INP = ' '
        CALL PDB2SEQ(M,FILE_PDB,FILE_TEMP_SEQ
     *   ,CODE_PDB,DATE_PDB
     *   ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *   ,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 600
        NSEQUENCE = RESULT(1)
        NRES = RESULT(3)
        FCH4 = RESULT(2)
        WRITE(LINE,'(A,I5)') 'N_input_chain :',NSEQUENCE
        CALL MSGDOC(MDOC,LINE)
        
        CODE_TARGET = 'XXXX'//CH4(1:1)//'   '

        IF(NSEQUENCE.GT.1) THEN
          CHAIN_INP = CH4(1:1)
          CALL PDB2SEQ(M,FILE_PDB,FILE_TEMP_SEQ
     *     ,CODE_PDB,DATE_PDB
     *     ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *     ,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) GO TO 600
          NRES = RESULT(3)
          CALL MSGERR(MDOC,
     *    ' WARNING: N_chain > 1, only first will be used ')
          LINE = '          chain: '//CHAIN_INP
          CALL MSGERR(MDOC,LINE)

          IF(CHAIN_INP.EQ.'_') CHAIN_INP = ' '
          PATH = ' '

          FILE_PDB = 'coordinate_input.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_PDB = PATH_SCR(1:LEN)//'coordinate_input.pdb'
          ENDIF
          FILE_CRD = 'coordinate_input.crd'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_CRD = PATH_SCR(1:LEN)//'coordinate_input.crd'
          ENDIF

          CALL READPDB(M,FILE_PDB_INPUT,FILE_CRD,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CHAIN_INP,IERR)   
          IF(IERR.NE.0) GO TO 600

          IERR = 0
          CALL WRITEPDB(M,FILE_CRD,FILE_PDB,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) GO TO 600

        ENDIF

        IF(NRES.LT.10) THEN
          IERR = 1
          GO TO 600
        ENDIF

        CALL PREPARE_SEQUENCE_WITH_SURF_SS(MDOC,CODE_TARGET,NAA
     *   ,FILE_PDB,FILE_TEMP_SEQ,PATH_SCR,IERR)
        IF(IERR.NE.0) GO TO 600

      ENDIF

      NLINE_WRITE_MAX = NSEQ_MAX
      IF(NSEQ_MAX.GT.NLINEMAX) NLINE_WRITE_MAX = NLINEMAX
      NRES_TOT    = NRES 
      NRES_ALIGN  = 0
      NRES_DOMAIN = 0 
      NLINE_INFO  = 0
      NDOMAIN_INI = NDOMAIN
      DIR_FOR_NEW_SEQ = ' '
C ---
      CALL SEARCH_HOMOLOG_BY_SEQ_AND_PDB(MDOC,MODE,HARD,PRF
     *     ,ICODE_TARGET,CODE_TARGET,FILE_PDB,FILE_TEMP_SEQ
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB
     *     ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *     ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *     ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *     ,ND_STRING_CP,IDOMDOM_CP,IDOMSEG_CP,ND_RES_CP
     *     ,PNUM1_DM_CP,PNUM2_DM_CP,CODE_HOMOL_DM_CP,NSTRMAXC
     *     ,FIDENT_DM_CP,SCORE_DM_CP,Q_DM_CP
     *     ,NRES_TOT_CP,NRES_ALIGN_CP,NRES_DOMAIN_CP
     *     ,ISEG_NEW,NLINE_WRITE_MAX
     *     ,FIDENT_BEST,SCORE_BEST,Q_FIN,NPAIR,DRMS
     *     ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,
     *   'ERROR: in SEARCH_HOMOLOG_BY_SEQ_AND_PDB')
        IERR = 1
        GO TO 600
      ENDIF
C ---
      FINAL_MODEL      ='NULL'
      FINAL_MODEL_COOT ='NULL'

      CALL LENSTR_BL(FILE_PDB_INPUT,LEN)
      IF(LEN.LE.0) THEN

        IF(NLINE_INFO.GT.0.OR.ND_STRING.GT.0) THEN

          IF(NLINE_INFO.GT.0.AND.FIDENT_BEST.GE.FIDENT_MIN) THEN
        
            N_LINES = NLINE_INFO
            N_SEQ   = NLINE_INFO

            CALL MSGDOC(MDOC,
     *  'INFO: output PDB (with dom_info in seg_ID): model_DB.pdb')

            FILE_CRD = 'model_DB.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_CRD,LT )
            IF(LEN.GT.0) THEN
              FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
            ENDIF
            FILE_TEMP = 'model_DB_coot.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_TEMP,LT )
            IF(LEN.GT.0) THEN
              FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
            ENDIF

            FINAL_MODEL      = FILE_CRD
            FINAL_MODEL_COOT = FILE_TEMP

            CALL DOMAIN2CHAIN_FOR_COOT(MDOC,FILE_CRD,FILE_TEMP,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in DOMAIN2CHAIN_FOR_COOT'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 600
            ENDIF

            LINE = 'INFO: output PDB (seg_ID --> chain_ID)'//
     *             '    : model_DB_coot.pdb'
            CALL MSGDOC(MDOC,LINE)

            WRITE(IOUT,'(A)',ERR=500) '# --- search by chains ---'
            WRITE(LINE,'(A,I5,A,I5),ERR=500') 
     *      'N_residues_input :',NRES_TOT_CP
     *     ,'  N_residues_align:',NRES_ALIGN_CP
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

            CALL WRITE_DOMAIN_INFO_TO_OUTPUT(MDOC,IOUT,NDOM
     *       ,ND_STRING_CP,IDOMDOM_CP,IDOMSEG_CP,ND_RES_CP
     *       ,PNUM1_DM_CP,PNUM2_DM_CP,CODE_HOMOL_DM_CP,NSTRMAXC
     *       ,FIDENT_DM_CP,SCORE_DM_CP,Q_DM_CP,IERR)
            IF(IERR.NE.0) GO TO 500

            IF(ND_STRING.GT.0) THEN
              NDOM = IDOMDOM(1)
              FIDENT_BEST = FIDENT_DM(1)
              SCORE_BEST  = SCORE_DM(1)              
              IF(N_LINES.LE.0) THEN
                IDIFF = 0
                IF(ND_STRING.GT.1) THEN
                  DO I=2,ND_STRING
                    IDOM = IDOMSEG(I)/100
                    ISEG = IDOMSEG(I) - IDOM*100
                    IF(CODE_HOMOL_DM(I).NE.CODE_HOMOL_DM(I-1))IDIFF=1
                  ENDDO
                ENDIF
                IF(IDIFF.EQ.0.AND.FIDENT_BEST.LT.FIDENT_MIN) THEN
                  DO IC=1,NSEQ
                    IF(CODE_DB(IC)(1:5).EQ.CODE_HOMOL_DM(I)(1:5)) 
     *              GO TO 410
                  ENDDO
                  GO TO 420
  410             CONTINUE
                  N_SEQ     = 1
                  N_LINES   = 1
                  ND_STRING = 0
                  N_STRING  = 0
                ENDIF
              ENDIF
            ENDIF
  420       CONTINUE
          ENDIF

          IF(ND_STRING.GT.0) THEN

            WRITE(IOUT,'(A)',ERR=500) '# --- search by domains ---'
            WRITE(LINE,'(A,I5,A,I5),ERR=500') 
     *      'N_residues_input :',NRES_TOT
     *     ,'  N_residues_align:',NRES_ALIGN
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

            CALL WRITE_DOMAIN_INFO_TO_OUTPUT(MDOC,IOUT,NDOM
     *       ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *       ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *       ,FIDENT_DM,SCORE_DM,Q_DM,IERR)
            IF(IERR.NE.0) GO TO 500
          ENDIF

          IF(N_LINES.LE.0.AND.N_STRING.LE.0) THEN 
            CALL MSGDOC(MDOC,' final: No homologous was found')
            IERR = 5
            GO TO 600
          ENDIF

        ELSE

          CALL MSGDOC(MDOC,' final: No homologous was found')
          IERR = 5
          GO TO 600

        ENDIF

      ELSE

        IF(ISEG_NEW.GT.0) THEN
          NDOM = 0
          IF(ND_STRING.GT.0) NDOM = IDOMDOM(1)
          IT = NRES_TOT - NRES_DOMAIN 
          IF(IT.LE.5.AND.NDOM.EQ.1) NDOM = 0
          IF(ND_STRING.GT.0.AND.NDOM.GT.0) THEN
            NDOM = IDOMDOM(1)
          ELSE
            NDOM = 0
          ENDIF 

          WRITE(LINE,'(A,I5)') 'N_domain :',NDOM
          CALL MSGDOC(MDOC,LINE)
            
          IF(ND_STRING.GT.0) THEN
            DO I=1,ND_STRING
              IDOM = IDOMSEG(I)/100
              ISEG = IDOMSEG(I) - IDOM*100
              WRITE(LINE,
     *        '(I5,1X,A5,2I3,1X,A6,1X,A6,1X,F5.1,1X,F5.3,1X,F6.3)')
     *        IDOMDOM(I),CODE_TARGET(1:5),IDOM,ISEG
     *        ,PNUM1_DM(I),PNUM2_DM(I)
     *        ,FIDENT_DM(I),SCORE_DM(I),Q_DM(I)
              CALL MSGDOC(MDOC,LINE)
              READ(PNUM1_DM(I)(2:5),'(I4)') IR1
              READ(PNUM2_DM(I)(2:5),'(I4)') IR2
              ND_RES(I) = IR2 - IR1 + 1
            ENDDO
          ENDIF

          T  = REAL(NRES_DOMAIN)/REAL(NRES_TOT)
          IT = NRES_TOT - NRES_DOMAIN 
          IF(T.LT.0.75.AND.IT.GE.30) THEN
            WRITE(LINE,'(A,I6,A,A,A,2I6)') 
     *        ' -final: WARNING: chain :',ICODE,' ',CODE_TARGET
     *        ,'  Nres,Nres_found:',NRES_TOT,NRES_DOMAIN
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          WRITE(LINE,'(A,I5,A,I5),ERR=500') 
     *      'N_residues_input :',NRES_TOT
     *     ,'  N_residues_align:',NRES_ALIGN
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 

          WRITE(LINE,'(A,I5)') 'N_domain :',NDOM
          CALL MSGDOC(MDOC,LINE)

          IF(ND_STRING.GT.0.AND.NDOM.GT.0) THEN

            CALL WRITE_DOMAIN_INFO_TO_OUTPUT(MDOC,IOUT,NDOM
     *       ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *       ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *       ,FIDENT_DM,SCORE_DM,Q_DM,IERR)
            IF(IERR.NE.0) GO TO 500

            FILE_CRD = 'model_DB.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_CRD,LT )
            IF(LEN.GT.0) THEN
              FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
            ENDIF

C           ierr=-1    set '-' in seg_id(76:76) (domains border)
c            IERR =-1
            IERR = 0

            CALL SET_DOMAIN_INFO_TO_PDB_MEM(MDOC
     *        ,FILE_PDB,FILE_CRD
     *        ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *        ,NDOM,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: set dom_info to PDB'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 600
            ENDIF

            CALL MSGDOC(MDOC,
     *  'INFO: output PDB (with dom_info in seg_ID): model_DB.pdb')

            FILE_TEMP = 'model_DB_coot.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_TEMP,LT )
            IF(LEN.GT.0) THEN
              FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
            ENDIF

            FINAL_MODEL      = FILE_CRD
            FINAL_MODEL_COOT = FILE_TEMP

            CALL DOMAIN2CHAIN_FOR_COOT(MDOC,FILE_CRD,FILE_TEMP,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in DOMAIN2CHAIN_FOR_COOT'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 600
            ENDIF

            CALL MSGDOC(MDOC,
     *'INFO: output PDB (seg_ID --> chain_ID)    : model_DB_coot.pdb')

          ELSE

            CALL MSGDOC(MDOC,'INFO: no output PDB file')

          ENDIF

        ELSE

          CALL MSGDOC(MDOC,' final: No homologous was found')
          IERR = 5
          GO TO 600

        ENDIF

      ENDIF

600   CONTINUE

      ITIME_START = 1
      NRUN_TIME   = 0
      CALL EXPECTED_TIME(ITIME_START,NRUN_TIME
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
      WRITE(LINE,*) 'Time:',TIME_CURRENT,'  Elapsed:',TIME_ELAPSED
      CALL MSGDOC(MDOC,LINE)
      
C ------------
 900  CONTINUE
      RETURN
C ---------------------------
  500 IERR = 6
      CALL MSGDOC(MDOC,'ERROR: writing output file')
      RETURN
      END

      SUBROUTINE WRITE_DOMAIN_INFO_TO_OUTPUT(MDOC,IOUT,NDOM
     *       ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *       ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *       ,FIDENT_DM,SCORE_DM,Q_DM,IERR)
C ------------------------
C ---
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C --
      CHARACTER LINE*256
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      IF(ND_STRING.GT.0) THEN
        NDOM = IDOMDOM(1)
        N_STRING = ND_STRING
 
        WRITE(LINE,'(A,I5),ERR=500') 
     *      'N_domain :',NDOM
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
        LINE = ' Nd  Id  Is  c  res     c  res'//
     *         '  code_hom  Idnt score   Q'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
        DO I=1,ND_STRING
          IDOM = IDOMSEG(I)/100
          ISEG = IDOMSEG(I) - IDOM*100
          WRITE(LINE,
     * '(I3,1X,I3,1X,I3,2X,A6,A,A6,2X,A8,1X,F5.1,1X,F5.3,1X,F6.3)')
     *         IDOMDOM(I),IDOM,ISEG
     *         ,PNUM1_DM(I),' <-> ',PNUM2_DM(I),CODE_HOMOL_DM(I)
     *         ,FIDENT_DM(I),SCORE_DM(I),Q_DM(I)
              CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
        ENDDO
      ELSE
        NDOM = 0
        WRITE(LINE,'(A,I5),ERR=500') 
     *      'N_domain :',NDOM
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN) 
      ENDIF

      RETURN
  500 CONTINUE
      IERR = 1
      RETURN
      END

