C --- set_domain.f---
C --------------------------------------------------------------------
      CHARACTER PATH_SCR*256,PATH_OUT*256
      CHARACTER FILE_PDB*256,FILE_OUT*256
C
      CHARACTER LINE*256,PROG*80
C ---
C =============================================================
      PATH_OUT = ' '
      M = 0
      MDOC = 1
      PROG = 'set_domain'
      
      CALL START(0,MDOC,PROG,PATH_OUT)
C -------------------------
 100  IERR = 0
      MD   = 0
      M    = 99
C -----------------------
      NRES       = 0
      CALL SET_DEFAULT(' ')
      CALL MSGDOC(MD,' ')
C ---
      CALL SET_DEFAULT(
     *'FILE_PDB:        - ')
      CALL SET_DEFAULT(
     *'FILE_OUT:        - ')
      CALL SET_DEFAULT(
     *'NRES:            - ')
      CALL SET_DEFAULT(
     *'PATH_SCR:   < >  - path to scratch file directory')
      CALL SET_DEFAULT('?')
      CALL MSGDOC(MD,' ')
C -----------------------
      LINE='FILE_PDB'
      CALL ASK(LINE)
      FILE_PDB=LINE
      CALL CORR_NAME_ALL(FILE_PDB)
C ----
      LINE='FILE_OUT'
      CALL ASK(LINE)
      FILE_OUT=LINE
      CALL CORR_NAME_ALL(FILE_OUT)
C ----
      LINE='NRES'
      CALL ASK(LINE)
      READ(LINE,*) NRES
      IF(NRES.LE.0) NRES = 1
C ----
      LINE='PATH_SCR'
      CALL ASK(LINE)
      PATH_SCR=LINE
      CALL CORR_NAME_ALL(PATH_SCR)
C ----

      CALL CLOSE_BATCH(MDOC)

C ---------------------------------
      CALL SET_DOMAIN(MDOC,NRES,FILE_PDB,FILE_OUT,IERR)
C     *           ,NRES,PATH_SCR,PATH_OUT,IERR)
C -----------------------
  900 CONTINUE
      CALL FINISH
      END

      SUBROUTINE SET_DOMAIN(MDOC,NRES,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,STR*256,PATH*256,EXT*256
      CHARACTER CP_PNUM*7,CP_PNUM_OLD*7,CP_SEG*4
      CHARACTER CP_SEG_OLD*4,CHAIN*1
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      NATOM    = 0
      NRESIDUE = 0
      NCHAIN   = 0
      NSEGMENT = 0
      NR_SEG   = 0
      NDOM     = 0
      STR = ' '

      CP_PNUM_OLD = '?'
      CP_SEG_OLD  = '????' 
      IRES_OLD    =-10000 
 
 400  CONTINUE

      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        IF(LINE(1:6).EQ.'REMARK') GO TO 400
        IF(LINE(1:1).EQ.'#') GO TO 400

        IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *     (LINE(1:6).EQ.'HETATM')) THEN
          NATOM = NATOM + 1
          ISEG_NEW = 0
          CP_PNUM = LINE(21:27)
          IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
          IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c           new residue
            NRESIDUE = NRESIDUE + 1
            READ(CP_PNUM(3:6),'(I4)') IRES
            IDELT = IRES - IRES_OLD
            IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c             new chain
              NCHAIN   = NCHAIN + 1
              CHAIN    = CP_PNUM(2:2)
              ISEG_NEW = 1
            ENDIF
          ENDIF
          IF(LEN.GE.76) THEN
            CP_SEG = LINE(73:76)
          ELSE IF(LEN.GE.75) THEN
            CP_SEG = LINE(73:75)//' '
          ELSE IF(LEN.GE.74) THEN
            CP_SEG = LINE(73:74)//'  '
          ELSE IF(LEN.GE.73) THEN
            CP_SEG = LINE(73:73)//'   '
          ELSE
            CP_SEG = CHAIN//CHAIN//'  '
          ENDIF
          IF(CP_SEG(1:1).NE.CHAIN) CP_SEG(1:1) = CHAIN
          IF(CP_SEG(2:2).EQ.' ')   CP_SEG(2:2) = CHAIN
          CP_SEG(4:4) = ' '

          IF(CP_SEG(1:3).NE.CP_SEG_OLD(1:3)) ISEG_NEW = 1
          IF(ISEG_NEW.LE.0.AND.IDELT.GT.10)  ISEG_NEW = 1
          IDELT = 0
          IF(ISEG_NEW.GT.0) THEN
            NSEGMENT = NSEGMENT + 1
            NR_SEG   = 0
            NDOM = NDOM + 1
            IF(NDOM.GT.1) THEN
c#MOLECULE     2
c#DOMAIN       2
c123456789 12345
              WRITE(STR(11:15),'(I5)') NDOM 
              STR(1:10) = '#DOMAIN   '
              CALL LENSTR_BL(STR,LEN)
              WRITE(IOUT,'(A)') STR(1:LEN)
            ENDIF
          ENDIF

          IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c           new residue
            IF(NR_SEG.GE.NRES) THEN
              NR_SEG   = 0
              NDOM = NDOM + 1
              WRITE(STR(11:15),'(I5)') NDOM 
              STR(1:10) = '#DOMAIN   '
              CALL LENSTR_BL(STR,LEN)
              WRITE(IOUT,'(A)') STR(1:LEN)
            ENDIF
            NR_SEG   = NR_SEG + 1
          ENDIF

          CP_SEG_OLD  = CP_SEG
          IRES_OLD    = IRES
          CP_PNUM_OLD = CP_PNUM

        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
      ENDIF    
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      WRITE(LINE,'(A,I6)') 'Ndomain   :',NDOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') 'Nsegment  :',NSEGMENT
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') 'Nchain    :',NCHAIN
      CALL MSGDOC(MDOC,LINE)

      RETURN
C ----------------
 200  CONTINUE
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END
