C---------------------------------------------------------------
C --- update_DB.f ---
C -----------------------------------
      PARAMETER ( IPRROW = 51      )
      REAL      RESULT (IPRROW)
C ---
      CHARACTER DIR_PDB*256,DIR_OUT*256,LIST_DOM*256
      CHARACTER LIST_IN*256,LIST_PDB*256,LIST_OUT*256
      CHARACTER PATH_SCR*256,DIR_SEQ_OUT*256
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,PATH*1,EXT*3
      CHARACTER PATH_OUT*256
C==================================================================
      MDOC=1
      CALL START(0,MDOC,'update_DB',PATH_OUT)
C ---------------------------
      CALL MSGDOC(MDOC,' ')
      CALL MSGDOC(MDOC,
     * '  ---  UPDATE_DB ---  V.13.12.2009/')
      CALL MSGDOC(MDOC,' ')
C -------------------------------------------------------------
      IERR = 0
      MD   = 0
      M    = 99
c ----
  100 LINE = 'input chain_list_DB file'
      CALL MSGDOC(MD,LINE)
      LINE = 'LIST_IN:'
      CALL ASK(LINE)
      LIST_IN = LINE
      CALL CORR_NAME_BLC(LIST_IN)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,LIST_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input file')
        IERR=0
        GO TO 100
      ENDIF
      CLOSE(MT)
c ---
  200 LINE = 'input PDB_code_list file'
      CALL MSGDOC(MD,LINE)
      LINE = 'LIST_PDB:'
      CALL ASK(LINE)
      LIST_PDB = LINE
      CALL CORR_NAME_BLC(LIST_PDB)
      MT    = 10
      PATH  = ' '
      EXT   = ' '
      CALL OPENFR(MT,M,PATH,LIST_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open input file')
        IERR=0
        GO TO 200
      ENDIF
      CLOSE(MT)
C ---
 300  LINE = 'Output new_chain_list_DB file'
      CALL MSGDOC(MD,LINE)
      LINE='LIST_OUT:'
      CALL ASK(LINE)
      LIST_OUT = LINE
      CALL CORR_NAME_BLC(LIST_OUT)
      PATH  = ' '
      EXT   = ' '
      MT = 10
      CALL OPENFW(MT,M,PATH,LIST_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open output file')
        IERR=0
        GO TO 300
      ENDIF
      CLOSE(MT)
C ---
 700  LINE = 'Output new_domain file'
      CALL MSGDOC(MD,LINE)
      LINE='NEW_DOM:'
      CALL ASK(LINE)
      LIST_DOM = LINE
      CALL CORR_NAME_BLC(LIST_DOM)
      PATH  = ' '
      EXT   = ' '
      MT = 10
      CALL OPENFW(MT,M,PATH,LIST_DOM,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open output domain file')
        IERR=0
        GO TO 700
      ENDIF
      CLOSE(MT)
C ---
 400  LINE = 'directory with input PDB files (last ch:/)'
      CALL MSGDOC(MD,LINE)
      LINE='DIR_PDB:'
      CALL ASK(LINE)
      DIR_PDB = LINE
      CALL CORR_NAME_BLC(DIR_PDB)
      CALL LENSTR_BL(DIR_PDB,LEN)
      IF(LEN.LE.0) THEN 
        GO TO 400
      ENDIF
C ---
 500  LINE = 'directory for output PDB files (last ch:/)'
      CALL MSGDOC(MD,LINE)
      LINE='DIR_OUT:'
      CALL ASK(LINE)
      DIR_OUT = LINE
      CALL CORR_NAME_BLC(DIR_OUT)
      CALL LENSTR_BL(DIR_OUT,LEN)
      IF(LEN.LE.0) THEN 
        GO TO 500
      ENDIF
C ---
 600  LINE = 'directory for output sequence files (last ch:/)'
      CALL MSGDOC(MD,LINE)
      LINE='DIR_SOUT:'
      CALL ASK(LINE)
      DIR_SEQ_OUT = LINE
      CALL CORR_NAME_BLC(DIR_SEQ_OUT)
      CALL LENSTR_BL(DIR_SEQ_OUT,LEN)
      IF(LEN.LE.0) THEN 
        GO TO 600
      ENDIF
C ---
      PATH_SCR = ' '
      LINE = 'Scratch directory'
      CALL MSGDOC(MD,LINE)
      LINE='PATH_SCR:'
      CALL ASK(LINE)
      PATH_SCR = LINE
      CALL CORR_NAME_BLC(PATH_SCR)
C -------------------------------------------
      CALL CLOSE_BATCH(MDOC)
      CALL UPDATE_DB(MDOC
     * ,LIST_IN,LIST_PDB,LIST_OUT,LIST_DOM
     * ,DIR_PDB,DIR_OUT,DIR_SEQ_OUT
     * ,PATH_OUT,PATH_SCR
     * ,RESULT,IPRROW,IERR)
C --------------------------------------------------
  900 CALL FINISH
      END

      SUBROUTINE UPDATE_DB(MDOC
     * ,LIST_IN,LIST_PDB,LIST_OUT,LIST_DOM
     * ,DIR_PDB,DIR_OUT,DIR_SEQ_OUT
     * ,PATH_OUT,PATH_SCR
     * ,RESULT,IPRROW,IERR)
C --------------------------------------------------------
      PARAMETER ( IPRSYM = 196  )
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(IPRROW)
C ----
      CHARACTER DIR_PDB*(*),DIR_OUT*(*),DIR_SEQ_OUT*(*)
      CHARACTER LIST_IN*(*),LIST_OUT*(*),LIST_PDB*(*)
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),LIST_DOM*(*)
C ----
C ---
C      INCLUDE 'chain_list_DB.fh'
C ---
      integer,   allocatable :: ID_DB(:)
      integer,   allocatable :: NAA_DB(:)
      integer,   allocatable :: NAT_DB(:)
      integer,   allocatable :: NRES_DB(:)
      integer,   allocatable :: IBACK_DB(:)
      integer,   allocatable :: ILEVEL_DB(:)
      integer,   allocatable :: IORDER_DB(:)
      integer,   allocatable :: IHIER_DB(:)
      integer,   allocatable :: ICLASS_DB(:)
      real,      allocatable :: FBACK_DB(:)
      real,      allocatable :: FIDENT_DB(:)
      real,      allocatable :: SCR_DB(:)
      real,      allocatable :: RESOL_DB(:)
      character(LEN=8), allocatable :: CODE_DB(:)
      character(LEN=8), allocatable :: HIER_DB(:)
      character(LEN=10), allocatable :: COMPLEX_DB(:)
C ---
      integer,   allocatable :: ID_DOM(:)
      integer,   allocatable :: NRES_DOM(:)
      integer,   allocatable :: ITYPE_DOM(:)
      integer,   allocatable :: NSEG_DOM(:)
      integer,   allocatable :: ILEVEL_DOM(:)
      integer,   allocatable :: IBACK_DOM(:)
      integer,   allocatable :: IFORW_DOM(:)
      integer,   allocatable :: ICLASS_DOM(:)
      real,      allocatable :: FBACK_DOM(:)
      real,      allocatable :: SCORE_DOM(:) 
      real,      allocatable :: RAD_DOM(:)
      real,      allocatable :: RCBYR_DOM(:)
      real,      allocatable :: RINBYR_DOM(:)
      real,      allocatable :: PH_DOM(:)
      real,      allocatable :: PB_DOM(:)
      real,      allocatable :: RSBYR_DOM(:)
      character(LEN=8), allocatable :: CODE_DOM(:)
      character(LEN=512), allocatable :: LINE_DOM(:)

      integer,   allocatable :: NDOM_DB(:)
      integer,   allocatable :: IDOMSEG_DB(:)
      character(LEN=8), allocatable :: CODE_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM1_DOM_DB(:)
      character(LEN=6), allocatable :: PNUM2_DOM_DB(:)

C ----
      CHARACTER FILE_PDB*256,FILES*256,FILEC*256,FILEP*256
      CHARACTER FILE_CRD_NEW*256,FILE_SEQ_NEW*256,FILE_DOM*256
      CHARACTER FILET*256,FILE_XYZ*256,FILE_XYZ_OUT*256
      CHARACTER FILE_OUT*256
      CHARACTER STR_TITLE*40,STR_DATE*9,CHAIN_INP*1
      PARAMETER ( NCHAINMAX = 100    )
      CHARACTER CHAIN_LIST(NCHAINMAX)*1
      INTEGER   NAA_CHAIN (NCHAINMAX)
      CHARACTER ID_PDB*4,CHAINI*1
      REAL      CELL(6)

      CHARACTER   FILE_DOM_DESCR*256,MESSAGE*256
      CHARACTER   CODE_PDB*4,DATE_PDB*9
      CHARACTER   CODE5*5,CHAIN_PDB*1,CODE*5,CH1*1,CH2*2,CH10*10
      CHARACTER   LINE*256,STR*256,STR2*256
      CHARACTER   EXT*3,PATH*1,PATH_DB*256
      REAL        FCH4      
      CHARACTER   CH4*4
      EQUIVALENCE (FCH4,CH4)
      INTEGER   NLETT
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      RESOL_LIM  = 3.5
      NCHAIN_LIM = 20
      NAA_LIM    = 15
      FIDENT_LIM = 80.0
      RMS_LIM    = 1.0

      CALL MSGDOC(MDOC,' ')
C ------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: problem with setenv MOLREP_DB')
        LINE = '        Example:"setenv MOLREP_DB'//
     *         ' /data/alexei/work/molrep_DB"'
        CALL MSGERR(MDOC,LINE)
        RETURN
      ENDIF
C ------
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM_DESCR = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'
      CALL CHECK_MEMORY_FOR_LIST(MDOC
     *              ,FILE_DOM_DESCR,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_DESCR')
        RETURN
      ENDIF

      WRITE(LINE,*) 'N_dom_db:',NDOM_DESCR_MAX
      CALL MSGDOC(MDOC,LINE)
      IF(NDOM_DESCR_MAX.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF

      NDOM_DESCR_MAX = NDOM_DESCR_MAX + 100

C     allocation        

      allocate(ID_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NRES_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ITYPE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(NSEG_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ILEVEL_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IFORW_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(IBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(ICLASS_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(FBACK_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(SCORE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RAD_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RCBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RINBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PH_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(PB_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(RSBYR_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(CODE_DOM(1:NDOM_DESCR_MAX),STAT=ISTAT)
      allocate(LINE_DOM(1:3),STAT=ISTAT)

      CALL READ_DOM_DESCR_LIST(MDOC,FILE_DOM_DESCR,NDOMAIN
     *   ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *   ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *   ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *   ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *   ,LINE_DOM,NDOM_DESCR_MAX,IERR)
      IF(IERR.NE.0) GO TO 710
      WRITE(LINE,*) 'N_domain_db:',NDOMAIN
      CALL MSGDOC(MDOC,LINE)
      IF(NDOMAIN.LE.0) THEN
        IERR = 1
        GO TO 710
      ENDIF
C ------
C     open file: LIST_IN 
      IN = 30
      PATH = ' '
      EXT  = ' '
      CALL OPENFR(IN,M,PATH,LIST_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: cannot OPEN INPUT_LIST_DB_FILE')
        IERR = 1
        GO TO 710
      ENDIF
      CLOSE(IN)

      CALL CHECK_MEMORY_FOR_LIST(MDOC,LIST_IN,NSEQMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_LIST')
        GO TO 710
      ENDIF
      WRITE(LINE,*) 'N_chain_DB:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQMAX.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: NSEQMAX =0')
        IERR = 1
        GO TO 710
      ENDIF
      NSEQMAX = NSEQMAX + 10000
      WRITE(LINE,*) 'Memory for N_chain:',NSEQMAX
      CALL MSGDOC(MDOC,LINE)

C     allocation
      allocate(ILEVEL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IORDER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IHIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ICLASS_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(FIDENT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(CODE_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(ID_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAA_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NAT_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(NRES_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IBACK_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(RESOL_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(HIER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(SCR_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(COMPLEX_DB(1:NSEQMAX),STAT=ISTAT)
C ------
C     open file: LIST_PDB 
      INPDB = 32
      PATH = ' '
      EXT  = ' '
      CALL OPENFR(INPDB,M,PATH,LIST_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: cannot OPEN INPUT_LIST_PDB_FILE')
        IERR = 1
        GO TO 700
      ENDIF
c ---
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_DOM = PATH_DB(1:LEN)//'/list/domain_list.txt'

      CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_DOM,NSEGMAX,IERR)
      IF(IERR.NE.0.OR.NSEGMAX.LE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC
     *  ,'ERROR: in CHECK_MEMORY_FOR_DOM_LIST')
        GO TO 700
      ENDIF

      NSEG_INI = NSEGMAX
      NSEGMAX  = NSEGMAX + 10000
      WRITE(LINE,*) 'MEMORY for N_segment_info_db:',NSEGMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'N_segment_info_db:',NSEG_INI
      CALL MSGDOC(MDOC,LINE)

      allocate(NDOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(IDOMSEG_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(CODE_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM1_DOM_DB(1:NSEGMAX),STAT=ISTAT)
      allocate(PNUM2_DOM_DB(1:NSEGMAX),STAT=ISTAT)

      CALL READ_DOMAIN_LIST(MDOC,FILE_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
      IF(IERR.NE.0.OR.NSEG_DB.LE.0) GO TO 900
C ------
C     read file LIST_IN
C
      II_MIN = 0
      II_MAX = 0
      CALL READ_CHAIN_LIST(MDOC,LIST_IN,II_MIN,II_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0) GO TO 900

      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,*) 'N_seq in DB:',NSEQ
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQ.LE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

      NSEQ_INIT = NSEQ
C -----
C     NEW DOMAINS
C      FILE_DOM = LIST_DOM
C      EXT  = ' '
C      PATH = ' '
C      MT_DOM   = 39
C      CALL OPENFW(MT_DOM,M,PATH,FILE_DOM,EXT,IERR)
C      IF(IERR.NE.0) THEN
C        CALL MSGERR(MD,
C     *  ' ERROR: cannot open output file: new_domain.txt')
C        IERR = 1
C        GO TO 700
C      ENDIF
C -----
C     read file LIST_PDB
      N_REPL    = 0
      N_NEW_PDB = 0
      N_NEW_DOM = 0
 200  CONTINUE

      READ(INPDB,'(A)',ERR=800,END=100) STR
      CALL LENSTR_BL(STR,LEN)
      IF(LEN.LE.0) GO TO 200
      IF(STR(1:1).EQ.'#') THEN
        GO TO 200
      ENDIF
C ---
c      READ(STR,'(I8,2X,A4,4X,A9,4X,F4.2,4X,F6.3)',ERR=200) 
c     *  IPDB,CODE_PDB,DATE_PDB,RESOL,RFAC

      READ(STR,'(A4)',ERR=200) CODE_PDB

      DO I=1,NSEQ
        IF(CODE_DB(I)(1:4).EQ.CODE_PDB) THEN
          CH10 = '-----> :'
          WRITE(LINE,'(A,A,A,A)') 
     *       CH10,STR(1:4),' = db:',CODE_DB(I)(1:4)
          CALL MSGDOC(MDOC,LINE)
          GO TO 200
C         IF(CODE_DB(I)(2:4).EQ.CODE_PDB(2:4)) THEN
c         WRITE(*,*) 'pdb:',CODE_PDB,' ==> ',' db:',CODE_DB(I)
        ENDIF
      ENDDO

C --- add pdb one

      CALL LENSTR_BL(DIR_PDB,LEN)
      IF(LEN.GT.0) THEN 
        FILE_PDB = DIR_PDB(1:LEN)//CODE_PDB//'.pdb'
      ELSE
        FILE_PDB = CODE_PDB//'.pdb'
      ENDIF

      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN 
        FILES = PATH_SCR(1:LEN)//'temp_add.seq'
      ELSE
        FILES = 'temp_add.seq'
      ENDIF

      CHAIN_INP = ' '

      CALL PDB2SEQ(M,FILE_PDB,FILES
     * ,ID_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN 
        CH10 = '-----> :'
        WRITE(LINE,'(A,A,A)') 
     *       CH10,STR(1:4),' --> error in pdb2seq'
        CALL MSGDOC(MDOC,LINE)
        IERR = 0
        GO TO 200
      ENDIF

      IF(RESOL.GT.RESOL_LIM) THEN
        CH10 = '----->no :'
        WRITE(LINE,'(A,A,A,F6.2)') 
     *       CH10,STR(1:4),' --> resolution >',RESOL_LIM
        CALL MSGDOC(MDOC,LINE)
        GO TO 200
      ENDIF

      IF(CELL(1).LT.2.0) THEN
        CH10 = '----->no :'
        WRITE(LINE,'(A,A,A,6F6.2)') 
     *       CH10,STR(1:4),' --> cell:',(CELL(K),K=1,6)
        CALL MSGDOC(MDOC,LINE)
        GO TO 200
      ENDIF

      IMODE =-1
      CALL CHECK_LINE(IMODE,ID_PDB)
c     DATE_PDB = '18-SEP-00'

      NCHAIN = RESULT(1)

c      write(LINE,*) 'Number of chains:',NCHAIN
c      CALL MSGDOC(MDOC,LINE)

      IF(NCHAIN.LE.0) THEN
        CH10 = '----->no :'
        WRITE(LINE,'(A,A,A)') 
     *       CH10,STR(1:4),' --> N_chains =0'
        CALL MSGDOC(MDOC,LINE)
        GO TO 200
      ENDIF
      IF(NCHAIN.GT.NCHAIN_LIM) NCHAIN = NCHAIN_LIM

      II = 1
      DO I=1,NCHAIN
        II=II+1
        FCH4 = RESULT(II)
        CHAIN_LIST(I) = CH4(1:1)
        II=II+1
        NAA_CHAIN(I) = RESULT(II)

c        write(LINE,*) I,CHAIN_LIST(I),NAA_CHAIN(I)
c        CALL MSGDOC(MDOC,LINE)

      ENDDO

C      write(LINE,*) '-0--'
C      CALL MSGDOC(MDOC,LINE)

C -------------------
      DO I=1,NCHAIN

        CHAINI = CHAIN_LIST(I)
        NAAI   = NAA_CHAIN(I)
        IF(NAAI.LT.NAA_LIM) GO TO 300
        CODE5 = STR(1:4)//CHAINI
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN 
          FILEC = PATH_SCR(1:LEN)//'temp_add.crd'
        ELSE
          FILEC = 'temp_add.crd'
        ENDIF

        CH1 = CHAINI
        IF(CH1.EQ.'_') CH1 = ' '
        PATH = ' '

c       write(LINE,*) '---READPDB:'// CHAINI
c       CALL MSGDOC(MDOC,LINE)

        CALL READPDB(M,FILE_PDB,FILEC,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CH1,IERR)   
        IF(IERR.NE.0) THEN
          CH10 = '----->no :'
          WRITE(LINE,'(A,A,A,A,A)') 
     *       CH10,STR(1:4),' ch:'//CHAINI//' --> error in READPDB'
          CALL MSGDOC(MDOC,LINE)
          IERR = 0
          GO TO 200
        ENDIF

        NATOM = RESULT(2)
C       RESULT(4) - reported resolution
        NMODEL = RESULT(20)
        IF(NMODEL.GT.1) THEN
          CH10 = '----->no :'
          WRITE(LINE,'(A,A,A,A,A)') 
     *       CH10,STR(1:4),' ch:'//CHAINI//' --> Nmodel > 1'
          CALL MSGDOC(MDOC,LINE)
          GO TO 200
        ENDIF

        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN 
          FILES = PATH_SCR(1:LEN)//'temp_add.seq'
        ELSE
          FILES = 'temp_add.seq'
        ENDIF

        CALL PDB2SEQ(M,FILE_PDB,FILES
     *   ,ID_PDB,DATE_PDB
     *   ,RESOL,RFAC,IMODEL,CELL,CHAINI
     *   ,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          CH10 = '----->no :'
          WRITE(LINE,'(A,A,A,A,A)') 
     *       CH10,STR(1:4),' ch:'//CHAINI//' --> error in pdb2seq'
          CALL MSGDOC(MDOC,LINE)
          IERR = 0 
          GO TO 200
        ENDIF
c ---
C        CALL MSGDOC(MDOC,' --- ')
C        CALL MSGDOC(MDOC,' --- check sequence  ---')
C        CALL MSGDOC(MDOC,' --- ')

        IF(NSEQ.GE.NSEQMAX) THEN
          CALL MSGERR(MDOC,'ERROR: NSEQ > NSEQMAX')
          IERR = 1
          GO TO 800
        ENDIF

        CALL ADD_ALIGN_DB(M,FILES,IADD,ID_PDB,CHAINI,NAAI
     *   ,NSEQ_INIT,DIR_SEQ_OUT
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB,IORDER_DB,ICLASS_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          CH10 = '----->no :'
          WRITE(LINE,'(A,A,A,A,A)') 
     *       CH10,STR(1:4),' ch:'//CHAINI//' --> error in ADD_ALIGN_DB'
          CALL MSGDOC(MDOC,LINE)
          IERR = 0
          GO TO 200
        ENDIF
c ---
        IF(IADD.NE.0) THEN

          RMS = -1.0
          IBACK = IBACK_DB(NSEQ) 
          FBACK = FBACK_DB(NSEQ) 
          RESOL_DB(NSEQ)  = RESOL
          NAT_DB(NSEQ)    = NATOM

          CODE = '     '
          CH2  = '  '
          IF(IBACK.GT.0) THEN
            CODE = CODE_DB(IBACK)(1:5)
            CH2  = COMPLEX_DB(IBACK)(1:2)
          ENDIF


          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN 
            FILET = PATH_SCR(1:LEN)//ID_PDB//CHAINI//'.pdb'
          ELSE
            FILET = ID_PDB//CHAINI//'.pdb'
          ENDIF

          CALL CLEAN_PDB(MDOC,CHAINI
     *          ,FILE_PDB,FILET,NRES,MESSAGE,IERR)
          IF(IERR.NE.0) THEN
            CH10 = '----->no :'
            WRITE(LINE,'(A,A,A,A,A)') 
     *       CH10,STR(1:4),' ch:'//CHAINI//' --> error in CLEAN_PDB'
            CALL MSGDOC(MDOC,LINE)
            IERR = 0
            GO TO 300
          ENDIF

          IF(FBACK.GE.50.0) THEN

            CODE = CODE_DB(IBACK)(1:5)

            IF(IBACK.LE.NSEQ_INIT.AND.
     *         COMPLEX_DB(IBACK)(1:1).NE.'-') THEN
              CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
              IF(IERR.NE.0) GO TO 300
C             Example: "setenv MOLREP_DB ~alexei/molrep_DB"
              CALL LENSTR_BL(LINE,LEN)
              FILE_XYZ = LINE(1:LEN)//'/pdb_DB/'//CODE(1:5)//'.xyz'

            ELSE
              CALL LENSTR_BL(DIR_OUT,LEN)
              IF(LEN.GT.0) THEN 
                FILE_XYZ = DIR_OUT(1:LEN)//CODE(1:5)//'.xyz'
              ELSE
                FILE_XYZ = CODE(1:5)//'.xyz'
              ENDIF
            ENDIF
c ---
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN 
              FILEP = PATH_SCR(1:LEN)//CODE(1:5)//'.pdb'
            ELSE
              FILEP = CODE(1:5)//'.pdb'
            ENDIF
            CALL PDB_UNPACK(M,FILE_XYZ,FILEP,IERR)
            IF(IERR.NE.0) THEN
              CH10 = '----->no :'
              WRITE(LINE,'(A,A,A,A,A)') 
     *        CH10,STR(1:4),' ch:'//CHAINI//' --> error in PDB_UNPACK'
              CALL MSGDOC(MDOC,LINE)
              IERR = 0
              GO TO 300
              RETURN
            ENDIF

            CALL CHECK_RMS(M,CODE5,FILET,FILEP,PATH_SCR,RMS
     *              ,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              CH10 = '----->no :'
              WRITE(LINE,'(A,A,A,A,A)') 
     *        CH10,STR(1:4),' ch:'//CHAINI//' --> error in CHECK_RMS'
              CALL MSGDOC(MDOC,LINE)
              IERR = 0
              GO TO 300
            ENDIF       

          ENDIF

          IREPLACE = 0
          IF(FBACK.GE.FIDENT_LIM.AND.(RMS.LT.RMS_LIM.AND.
     *                                RMS.GE.0.0         )) THEN
            IF(RESOL_DB(NSEQ).LT.RESOL_DB(IBACK).AND.
     *                             IBACK.LE.NSEQ_INIT) THEN
              IREPLACE = 1
              WRITE(STR2,'(A,F6.2,A,F6.2)') 
     *        ' Resol:',RESOL_DB(NSEQ),' -->',RESOL_DB(IBACK)  
            ENDIF
          ENDIF

          IF(FBACK.LT.FIDENT_LIM.OR.IREPLACE.GT.0.OR.
     *                 (RMS.GE.RMS_LIM.OR.RMS.LT.0.0)) THEN
            CALL LENSTR_BL(DIR_OUT,LEN)
            IF(LEN.GT.0) THEN 
              FILE_XYZ_OUT = DIR_OUT(1:LEN)//ID_PDB//CHAINI//'.xyz'
            ELSE
              FILE_XYZ_OUT = ID_PDB//CHAINI//'.xyz'
            ENDIF

            CALL PDB_PACK(MDOC,FILET,FILE_XYZ_OUT,IERR)
            IF(IERR.NE.0) THEN
              NSEQ = NSEQ - 1
              CH10 = '----->no :'
              WRITE(LINE,'(A,A,A,A,A)') 
     *        CH10,STR(1:4),' ch:'//CHAINI//' --> error in PDB_PACK'
              CALL MSGDOC(MDOC,LINE)
              IERR = 0
              GO TO 200
            ENDIF

            CALL PDB_UNPACK(M,FILE_XYZ_OUT,FILET,IERR)
            IF(IERR.NE.0) THEN
              NSEQ = NSEQ - 1
              CH10 = '----->no :'
              WRITE(LINE,'(A,A,A,A,A)') 
     *        CH10,STR(1:4),' ch:'//CHAINI//' --> error in PDB_UNPACK'
              CALL MSGDOC(MDOC,LINE)
              IERR = 0
              GO TO 200
            ENDIF

            FILE_CRD_NEW = FILET 

c --
            CALL LENSTR_BL(DIR_SEQ_OUT,LEN)
            IF(LEN.GT.0) THEN 
              FILE_SEQ_NEW = DIR_SEQ_OUT(1:LEN)//CODE5//'.seq'
            ELSE
              FILE_SEQ_NEW = CODE5//'.seq'
            ENDIF
            CALL PREPARE_SEQ(M,CODE_PDB,CHAINI,FILE_PDB
     *            ,FILET,FILE_SEQ_NEW,NRES_OCC,NAT_OCC
     *            ,PATH_OUT,PATH_SCR
     *            ,RESULT,IPRROW,IERR)
            IF(IERR.EQ.0) THEN
C             poly ALA 
              IT = NRES_OCC*5 + 5
C             Naa >> Nres
              T = REAL(NAA_DB(NSEQ))/REAL(NRES_OCC)  
              IF(T.GT.4.0.AND.NRES_OCC.LT.30) THEN
                IERR = 10
              ELSE IF(NRES_OCC.LT.NAA_LIM) THEN
C               Naa limit  
                IERR = 11
              ELSE IF(NAT_OCC.LT.IT) THEN
                IERR = 12
              ENDIF
            ENDIF
            IF(IERR.NE.0) THEN
              IREPLACE = 0
              NSEQ = NSEQ - 1
              CH10 = '----->no :'
              IF(IERR.LE.9) THEN
                WRITE(LINE,'(A,A,A,A,A)') 
     *          CH10,STR(1:4),' ch:'//CHAINI//
     *          ' --> error in PREPARE_SEQ'
              ELSE IF(IERR.LE.11) THEN
                WRITE(LINE,'(A,A,A,A,A)') 
     *          CH10,STR(1:4),' ch:'//CHAINI//' --> Naa >> Nres'
              ELSE
                WRITE(LINE,'(A,A,A,A,A)') 
     *          CH10,STR(1:4),' ch:'//CHAINI//' --> Poly ALA'
              ENDIF
              CALL MSGDOC(MDOC,LINE)
              IERR = 0
              GO TO 200
            ENDIF
            IF(IREPLACE.GT.0) THEN
C             --- REPLACE ---
              CH10 = '----->rep:'
C              COMPLEX_DB(IBACK)(1:1) = '-'
C              CH2(1:1) = '-' 
              NDOM_FINAL = 0
              IF(CH2(2:2).NE.'.'.AND.CH2(2:2).NE.'_') THEN
                CALL CREATE_DOM_INFO_FOR_NEW(M
     *            ,NSEQ,CODE5,IBACK,CODE,CH2
     *            ,CODE_DOM,ITYPE_DOM,NDOMAIN
     *            ,FILEP,FILE_CRD_NEW,FILE_SEQ_NEW
     *            ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *            ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *            ,NDOM_FINAL,NDOM_INI
     *            ,PATH_SCR,PATH_OUT
     *            ,RESULT,IPRROW,IERR)
                IF(IERR.NE.0) THEN
                  IERR = 0
                  CALL MSGERR(MDOC,'ERROR: in CREATE_DOM_INFO')
                  CH10 = '----->no :'
                  GO TO 400
                ELSE IF(NDOM_FINAL.NE.NDOM_INI) THEN
                  LINE = 'ERROR: replace : NDOM # NDOM_ini'
                  CALL MSGERR(MDOC,LINE)
                  CH10 = '----->no :'
                  GO TO 400
                ELSE IF(NDOM_FINAL.GT.0) THEN
                  IF(NDOM_FINAL.LE.9) THEN
                    WRITE(COMPLEX_DB(NSEQ)(2:2),'(I1)') NDOM_FINAL
                  ELSE
                    ILETT = NDOM_FINAL - 9 
                    IF(ILETT.LE.NLETT) THEN
                      COMPLEX_DB(NSEQ)(2:2) = LETT(ILETT:ILETT)
                    ELSE
                      COMPLEX_DB(NSEQ)(2:2) = '*'
                    ENDIF
                  ENDIF
                  N_NEW_DOM = N_NEW_DOM + NDOM_FINAL
                ELSE
                  COMPLEX_DB(NSEQ)(2:2) = '0'
                ENDIF
              ENDIF

c              write(*,*) 'ndom:',ch2,NDOM_FINAL,IBACK,NSEQ
c              write(*,*) 'cmplx:',COMPLEX_DB(IBACK)
c              WRITE(*,*) 'OLD:',CODE_DB(IBACK),' ',code
c              WRITE(*,*) 'NEW:',CODE_DB(NSEQ)
c              WRITE(*,*) 'nr:',NRES_DB(IBACK),'<--',NRES_OCC
c              WRITE(*,*) 'na:',Nat_DB(IBACK),'<--',Nat_OCC

              IF(COMPLEX_DB(IBACK)(1:1).NE.'-') N_REPL = N_REPL + 1
              WRITE(CH10(1:5),'(I5)') N_REPL

              CODE_DB(IBACK)   = CODE_DB(NSEQ)
              NRES_DB(IBACK)   = NRES_OCC
              NAT_DB(IBACK)    = NAT_OCC
              RESOL_DB(IBACK)  = RESOL_DB(NSEQ)
              COMPLEX_DB(IBACK)= COMPLEX_DB(NSEQ)
              COMPLEX_DB(IBACK)(1:1) = '-'

  400         CONTINUE
              NSEQ = NSEQ - 1
  
            ELSE
C             --- ADD ---
              CH10 = '----->add:'
C???          IF(CH2(2:2).EQ.'0'.AND.NRES_OCC.LE.NRES_DB(IBACK)) THEN
C                COMPLEX_DB(NSEQ)(2:2) = '0'
C              ENDIF
              N_NEW_PDB = N_NEW_PDB + 1
              WRITE(CH10(1:5),'(I5)') N_NEW_PDB
              NRES_DB(NSEQ) = NRES_OCC
              NAT_DB(NSEQ)  = NAT_OCC
              IBACK = IBACK_DB(NSEQ)
              IF(IBACK.GT.0.AND.IHIER_DB(IBACK).EQ.0) THEN
                IHIER_DB(IBACK) = NSEQ
              ENDIF
C???          ICLASS_DB(NSEQ) = 0      
            ENDIF

          ELSE

            CH10 = '----->no :'
            NSEQ = NSEQ - 1

          ENDIF

          CALL LENSTR_BL(STR,LEN)
          IF(LEN.GT.26) LEN = 26

c123456789 123456789 123456789 123456789 123456789 123456789 123456789 12
c-->add:       1  2bf1  02-DEC-04 2bf1A -->1g9mG Iden,RMS:  36.9 10.69 D0

c123456789 123456789 12345
c       1  2bf1  02-DEC-04 GG  4.00     0.385  REFM Iden,RMS:  36.9  0.00

          WRITE(LINE,'(A,A,A,A,A,A,A5,A,F6.1,F6.2,A,A)') 
     *       CH10,STR(1:4),' ',ID_PDB,CHAINI,' -->',CODE,
     *       ' Iden,RMS:',FBACK,RMS,' ',CH2
          IF(IREPLACE.GT.0) THEN
            CALL LENSTR_BL(LINE,LEN)
            CALL LENSTR_BL(STR2,L)
            LINE = LINE(1:LEN)//STR2(1:L)
          ENDIF
          CALL MSGDOC(MDOC,LINE)

        ENDIF

 300    CONTINUE

      ENDDO


c --- end add pdb one

      GO TO 200
C ---
 100  CONTINUE

c      END FILE MT_DOM
c      CLOSE(MT)
      CLOSE(INPDB)

      WRITE(LINE,*) 'N_new_pdb :',N_NEW_PDB
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'N_replace :',N_REPL
      CALL MSGDOC(MDOC,LINE)
c 
      DO ISEQ=1,NSEQ
        IF(COMPLEX_DB(ISEQ)(1:1).NE.'X') COMPLEX_DB(ISEQ)(1:1) = 'D'
      ENDDO

c ---  clean
C      ISEQ_NEW = 0
C      DO ISEQ=1,NSEQ
C        IF(COMPLEX_DB(ISEQ)(1:1).NE.'-') THEN
C          ISEQ_NEW = ISEQ_NEW + 1
C          ID_DB     (ISEQ_NEW) = ISEQ_NEW
C          NAA_DB    (ISEQ_NEW) = NAA_DB    (ISEQ)
C          NAT_DB    (ISEQ_NEW) = NAT_DB    (ISEQ)
C          NRES_DB   (ISEQ_NEW) = NRES_DB   (ISEQ)
C          RESOL_DB  (ISEQ_NEW) = RESOL_DB  (ISEQ)
C          IBACK_DB  (ISEQ_NEW) = IBACK_DB  (ISEQ)
C          ILEVEL_DB (ISEQ_NEW) = ILEVEL_DB (ISEQ)
C          IHIER_DB  (ISEQ_NEW) = IHIER_DB  (ISEQ)
C          FBACK_DB  (ISEQ_NEW) = FBACK_DB  (ISEQ)
C          FIDENT_DB (ISEQ_NEW) = FIDENT_DB (ISEQ)
C          SCR_DB    (ISEQ_NEW) = SCR_DB    (ISEQ)
C          CODE_DB   (ISEQ_NEW) = CODE_DB   (ISEQ)
C          HIER_DB   (ISEQ_NEW) = HIER_DB   (ISEQ)
C          ICLASS_DB (ISEQ_NEW) = ICLASS_DB (ISEQ)
C          COMPLEX_DB(ISEQ_NEW) = COMPLEX_DB(ISEQ)
C        ENDIF
C      ENDDO
C      WRITE(LINE,'(''N_seq_final     :'',I6)') ISEQ_NEW
C      CALL MSGDOC(MDOC,LINE)
C      NSEQ = ISEQ_NEW 
c ---

      WRITE(LINE,*) 'N_new_dom :',N_NEW_DOM
      CALL MSGDOC(MDOC,LINE)

C
      CALL WRITE_CHAIN_LIST(MDOC,LIST_OUT
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: cannot OPEN OUTPUT_LIST_FILE')
        IERR = 1
        GO TO 900
      ENDIF

      FILE_OUT = 'domain_descr_list.txt'
      CALL WRITE_DOM_DESCR_LIST(MDOC,FILE_OUT
     *    ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     *    ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     *    ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     *    ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     *    ,LINE_DOM,NDOMAIN,IERR)
      IF(IERR.NE.0) GO TO 900

      IF(NSEG_INI.LT.NSEG_DB) THEN
        CALL WRITE_DOMAIN_LIST(MDOC,LIST_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,'ERROR: in WRITE_DOMAIN_LIST')
            GO TO 900
        ENDIF
      ENDIF

      CALL LENSTR_BL(LIST_OUT,LEN)
      LINE = 'new chain list: '//LIST_OUT(1:LEN)
      CALL MSGDOC(MDOC,LINE)
      CALL LENSTR_BL(DIR_OUT,LEN)
      LINE = 'DIR with new PDB: '//DIR_OUT(1:LEN)
      CALL MSGDOC(MDOC,LINE)
      CALL LENSTR_BL(DIR_SEQ_OUT,LEN)
      LINE = 'DIR with new SEQ: '//DIR_SEQ_OUT(1:LEN)
      CALL MSGDOC(MDOC,LINE)
      IF(N_REPL.GT.0) THEN
        CALL LENSTR_BL(FILE_OUT,LEN)
        LINE = 'DOM description new: '//FILE_OUT(1:LEN)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(N_NEW_DOM.GT.0) THEN
        CALL LENSTR_BL(LIST_DOM,LEN)
        LINE = 'new domain.txt: '//LIST_DOM(1:LEN)
        CALL MSGDOC(MDOC,LINE)
        LINE = 'DIR with new domain sequences: seq_DOM'
        CALL MSGDOC(MDOC,LINE)
      ENDIF

  720 CONTINUE

      deallocate(NDOM_DB,STAT=ISTAT)
      deallocate(IDOMSEG_DB,STAT=ISTAT)
      deallocate(CODE_DOM_DB,STAT=ISTAT)
      deallocate(PNUM1_DOM_DB,STAT=ISTAT)
      deallocate(PNUM2_DOM_DB,STAT=ISTAT)

  700 CONTINUE

      deallocate(ID_DB,STAT=ISTAT)
      deallocate(NAA_DB,STAT=ISTAT)
      deallocate(NAT_DB,STAT=ISTAT)
      deallocate(NRES_DB,STAT=ISTAT)
      deallocate(IBACK_DB,STAT=ISTAT)
      deallocate(ILEVEL_DB,STAT=ISTAT)
      deallocate(IORDER_DB,STAT=ISTAT)
      deallocate(IHIER_DB,STAT=ISTAT)
      deallocate(ICLASS_DB,STAT=ISTAT)
      deallocate(FBACK_DB,STAT=ISTAT)
      deallocate(RESOL_DB,STAT=ISTAT)
      deallocate(FIDENT_DB,STAT=ISTAT)
      deallocate(SCR_DB,STAT=ISTAT)
      deallocate(CODE_DB,STAT=ISTAT)
      deallocate(HIER_DB,STAT=ISTAT)
      deallocate(COMPLEX_DB,STAT=ISTAT)

 710  CONTINUE

      deallocate(ID_DOM,STAT=ISTAT)
      deallocate(NRES_DOM,STAT=ISTAT)
      deallocate(ITYPE_DOM,STAT=ISTAT)
      deallocate(NSEG_DOM,STAT=ISTAT)
      deallocate(ILEVEL_DOM,STAT=ISTAT)
      deallocate(IFORW_DOM,STAT=ISTAT)
      deallocate(IBACK_DOM,STAT=ISTAT)
      deallocate(ICLASS_DOM,STAT=ISTAT)
      deallocate(FBACK_DOM,STAT=ISTAT)
      deallocate(SCORE_DOM,STAT=ISTAT)
      deallocate(RAD_DOM,STAT=ISTAT)
      deallocate(RCBYR_DOM,STAT=ISTAT)
      deallocate(RINBYR_DOM,STAT=ISTAT)
      deallocate(PH_DOM,STAT=ISTAT)
      deallocate(PB_DOM,STAT=ISTAT)
      deallocate(RSBYR_DOM,STAT=ISTAT)
      deallocate(CODE_DOM,STAT=ISTAT)
      deallocate(LINE_DOM,STAT=ISTAT)

      RETURN
C ------------
 800  CONTINUE
      CLOSE(INPDB)
      IERR = 1
      GO TO 720
C ------------
 900  CONTINUE
      IERR = 1
      GO TO 720
      END

      SUBROUTINE ADD_ALIGN_DB(MDOC,FILE_1,IADD,ID_PDB,CHAINI,N1_SEQ
     *   ,NSEQ_INIT,DIR_SEQ_OUT
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB,IORDER_DB,ICLASS_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER FILE_1*(*),FILE_2*256,FILE_OUT*256
      CHARACTER DIR_SEQ_OUT*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1
C ---
      INTEGER   ID_DB(NSEQMAX),NAA_DB(NSEQMAX),NAT_DB(NSEQMAX)
     *         ,NRES_DB(NSEQMAX),IORDER_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),IHIER_DB(NSEQMAX)
      INTEGER   ICLASS_DB(NSEQMAX)
      REAL      FBACK_DB(NSEQMAX)
      REAL      RESOL_DB(NSEQMAX),FIDENT_DB(NSEQMAX),SCR_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,HIER_DB(NSEQMAX)*8
     *         ,COMPLEX_DB(NSEQMAX)*10
C ---
C ---
      CHARACTER CODE*5,CODE1*5,CODE4*4,CODE10*10,CHAIN*1
      CHARACTER ID_PDB*4,CHAINI*1
      CHARACTER FRMT*256      
C ----
      REAL      DT(10)
      REAL      DTQ(10)
      DATA  DT/80.0,65.0,50.0,45.0,40.0,35.0,30.0,25.0,20.0,0.0/
      DATA  DTQ/0.80,0.65,0.50,0.45,0.40,0.35,0.30,0.25,0.20,0.0/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,'//
     *       'F6.2,1X,I6,1X,I6,1X,A10,1X,F6.1,1X,F6.4)'
C --------------------------------------------------
      IADD    = 0
      SIM_LIM = 0.2
      FIDENT_MIN = SIM_LIM*100.0
      SCORE_LIM  = 0.200
      Q_LIM      = 0.200
      F_LEVEL = 0.8
      FILE_OUT = ' '
C ------------------------------

      CODE1 = ID_PDB//CHAINI

      WRITE(LINE,*) 'N1_seq,F_LEVEL:',N1_SEQ,F_LEVEL
      CALL MSGDOC(MDOC,LINE)
      IF(N1_SEQ.LE.0) THEN
        IERR = 1
        GO TO 500
      ENDIF

      F_MIN = FLOAT(N1_SEQ)*F_LEVEL
      F_MAX = FLOAT(N1_SEQ)/F_LEVEL
      I_MIN = F_MIN+1
      I_MAX = F_MAX+1

C ----------------------------------

      NSEQ_MAX = NSEQ

      IBEST    = 0
      HID_BEST = 0.0
      SCR_BEST = 0.0
      Q_BEST   = 0.0
      N2_BEST  = 0
      NI_BEST  = 0
      NN_BEST  = 0

c             
c             0     1     2     3     4     5      6     7    6     9
c#H 0..9:       80.0  65.0  50.0  45.0  40.0  35.0  30.0  25.0  20.0  0.0
c#N 0...9:   418   301   385   187   242   238   303   583  2762   717

      IHIER_LEV = 5
      IHIER_LEV_MAX = 0

      DO J=1,NSEQ
        IF(ILEVEL_DB(J).GT.IHIER_LEV_MAX) IHIER_LEV_MAX=ILEVEL_DB(J)
        IORDER_DB(J) = 0
      ENDDO

      IF(IHIER_LEV.GT.IHIER_LEV_MAX) IHIER_LEV=IHIER_LEV_MAX

      WRITE(LINE,*) 'H_lev,max:',IHIER_LEV,IHIER_LEV_MAX
      CALL MSGDOC(MDOC,LINE)


      LINE = '            code   Nr_seq    '//
     *       '  Nr_pdb    Nr_al Nr_id Iden   Q    Id' 
      CALL MSGDOC(MDOC,LINE)

      NS1 = 0
c      DO J=1,NSEQ
      DO J=NSEQ,1,-1

        IF(ILEVEL_DB(J).LT.IHIER_LEV) GO TO 320

        NAA = NAA_DB(J)

        F_MIN = FLOAT(NAA)*F_LEVEL
        F_MAX = FLOAT(NAA)/F_LEVEL
        II_MIN = F_MIN+1
        II_MAX = F_MAX+1

        IF(II_MIN.GT.0.AND.II_MAX.GT.0) THEN
          IF(N1_SEQ.LT.II_MIN.OR.N1_SEQ.GT.II_MAX) GO TO 320
        ENDIF

        IF(I_MIN.GT.0.AND.I_MAX.GT.0) THEN
          IF(NAA.LT.I_MIN.OR.NAA.GT.I_MAX) GO TO 320
        ENDIF
C
        CODE = CODE_DB(J)(1:5)
C        IF(COMPLEX_DB(J)(1:1).EQ.'-') GO TO 320 

        IF(J.LE.NSEQ_INIT.AND.COMPLEX_DB(J)(1:1).NE.'-') THEN
          CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
          IF(IERR.NE.0) GO TO 500
C         Example: "setenv MOLREP_DB ~alexei/molrep_DB"
          CALL LENSTR_BL(LINE,LEN)
          FILE_2 = LINE(1:LEN)//'/seq_DB/'//CODE(1:5)//'.seq'
        ELSE
          CALL LENSTR_BL(DIR_SEQ_OUT,LEN)
          IF(LEN.GT.0) THEN 
            FILE_2 = DIR_SEQ_OUT(1:LEN)//CODE(1:5)//'.seq'
          ELSE
            FILE_2 = CODE(1:5)//'.seq'
          ENDIF
        ENDIF

        MT   = 10
        OPEN(MT,FILE=FILE_2,ACCESS='SEQUENTIAL',ERR=1410,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
        GO TO 1420
 1410   IERR=1
        CALL LENSTR_BL(FILE_2,LLL)
        LINE = 'ERR: can not open:'//FILE_2(1:LLL)       
        CALL MSGDOC(MDOC,LINE)
        GO TO 1400
 1420   CONTINUE
c --
        IPRINT = 0
        IERR = 0
        CALL MAKE_ALIGN(M,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
c -------------------------------------------------
 1400   CONTINUE

        IF(IERR.NE.0) THEN
          WRITE(LINE,
     *    '(I5,1X,A5,1X,A5,'' --- ERROR---'')') 
     *    J,CODE1,CODE_DB(J)(1:5)
          CALL MSGDOC(MDOC,LINE)
          IERR = 0
          GO TO 320
        ENDIF
C ---
        N1  = RESULT(1) 
        N2  = RESULT(2) 
        NN  = RESULT(3) 
        NI  = RESULT(4) 
        HID = RESULT(5) 
        SCR = RESULT(6)  
        SCORE1_MAX = RESULT(13)
        SCORE1_MIN = RESULT(14)
        Q_FIN      = RESULT(15)
        DRMS       = RESULT(16)
        NPAIR      = RESULT(17)
        SCORE_NEW  = RESULT(18)
        FID_NEW    = RESULT(19)
        NGAP       = RESULT(20)
        T = 1.0 - REAL(NN)/REAL(N1)
        T = EXP(-T*T)
        TT = (REAL(NN-NGAP)/REAL(NN))
        Q = SCORE_NEW*TT*TT*TT*TT
        Q = Q*T

c       IF(HID.LT.FIDENT_MIN) GO TO 320
        IF(Q.LT.Q_LIM) GO TO 320 

C        IF(ID_PDB.EQ.CODE(1:4).AND.HID.GT.99.999) HID = 100.0001

C        FIDENT_DB(J) = HID
C        SCR_DB(J)    = SCR
        IORDER_DB(J) = 1

        IF(COMPLEX_DB(J)(1:1).EQ.'X') GO TO 320 

        NS1          = NS1 + 1

        WRITE(LINE,
     *'(I5,1X,A5,1X,A5,I5,A1,I5,A1,I5,A1,I5,A1,2I5,F6.1,1X,F6.4,2I5)') 
     *  NS1,CODE1,CODE_DB(J)(1:5)
     *  ,N1,'(',N1_SEQ,')',N2,'(',NAA_DB(J),')'
     *  ,NN,NI,HID,Q,ID_DB(J),ILEVEL_DB(J)
        CALL MSGDOC(Mdoc,LINE)
        
c        write(*,*) '--q:',q,q_lim

C       IF(HID.GT.HID_BEST) THEN
        IF(Q.GT.Q_BEST) THEN
          IBEST = J
          HID_BEST = HID
          SCR_BEST = SCORE_NEW
          Q_BEST   = Q
          N2_BEST  = N2
          NI_BEST  = NI
          NN_BEST  = NN
        ENDIF
 320    CONTINUE
      ENDDO

      WRITE(LINE,*) 'NS1_seq:',NS1
      CALL MSGDOC(MDOC,LINE)

      NS2 = 0
c      DO J=1,NSEQ
      DO J=NSEQ,1,-1

        IF(ILEVEL_DB(J).GE.IHIER_LEV) GO TO 300
       
        JJ = J
 330    CONTINUE
        IBCK = IBACK_DB(JJ)
        IF(IBCK.GT.0) THEN
          IF(ILEVEL_DB(JJ).GE.IHIER_LEV) THEN
            IF(IORDER_DB(JJ).EQ.1) GO TO 340
          ENDIF
          JJ = IBCK 
          GO TO 330
        ELSE
          IF(IORDER_DB(JJ).EQ.0) GO TO 300
        ENDIF

 340    CONTINUE

c        write(*,*) j,jj,CODE_DB(j),CODE_DB(jj)

        NAA = NAA_DB(J)

        F_MIN = FLOAT(NAA)*F_LEVEL
        F_MAX = FLOAT(NAA)/F_LEVEL
        II_MIN = F_MIN+1
        II_MAX = F_MAX+1

        IF(II_MIN.GT.0.AND.II_MAX.GT.0) THEN
          IF(N1_SEQ.LT.II_MIN.OR.N1_SEQ.GT.II_MAX) GO TO 300
        ENDIF

        IF(I_MIN.GT.0.AND.I_MAX.GT.0) THEN
          IF(NAA.LT.I_MIN.OR.NAA.GT.I_MAX) GO TO 300
        ENDIF
C
        CODE = CODE_DB(J)(1:5)
C        IF(COMPLEX_DB(J)(1:1).EQ.'-') GO TO 300 

        IF(J.LE.NSEQ_INIT.AND.COMPLEX_DB(J)(1:1).NE.'-') THEN
          CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
          IF(IERR.NE.0) GO TO 500
C         Example: "setenv MOLREP_DB ~alexei/molrep_DB"
          CALL LENSTR_BL(LINE,LEN)
          FILE_2 = LINE(1:LEN)//'/seq_DB/'//CODE(1:5)//'.seq'
        ELSE
          CALL LENSTR_BL(DIR_SEQ_OUT,LEN)
          IF(LEN.GT.0) THEN 
            FILE_2 = DIR_SEQ_OUT(1:LEN)//CODE(1:5)//'.seq'
          ELSE
            FILE_2 = CODE(1:5)//'.seq'
          ENDIF
        ENDIF

        MT   = 10
        OPEN(MT,FILE=FILE_2,ACCESS='SEQUENTIAL',ERR=410,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
        GO TO 420
 410    IERR=1
        CALL LENSTR_BL(FILE_2,LLL)
        LINE = 'ERR: can not open:'//FILE_2(1:LLL)       
        CALL MSGDOC(MDOC,LINE)
        GO TO 400
 420    CONTINUE
c --
        IPRINT = 0
        IERR = 0
        CALL MAKE_ALIGN(M,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM
C       RESULT(6) = SUM_SCORE 
C -------------------------------------------------

 400    CONTINUE

        IF(IERR.NE.0) THEN
          WRITE(LINE,
     *    '(I5,1X,A5,1X,A5,'' --- ERROR---'')') 
     *    J,CODE1,CODE_DB(J)(1:5)
          CALL MSGDOC(MDOC,LINE)
          IERR = 0
          GO TO 300
        ENDIF
C ---
        N1  = RESULT(1) 
        N2  = RESULT(2) 
        NN  = RESULT(3) 
        NI  = RESULT(4) 
        HID = RESULT(5) 
        SCR = RESULT(6)  
        SCORE1_MAX = RESULT(13)
        SCORE1_MIN = RESULT(14)
        Q_FIN      = RESULT(15)
        DRMS       = RESULT(16)
        NPAIR      = RESULT(17)
        SCORE_NEW  = RESULT(18)
        FID_NEW    = RESULT(19)
        NGAP       = RESULT(20)
        T = 1.0 - REAL(NN)/REAL(N1)
        T = EXP(-T*T)
        TT = (REAL(NN-NGAP)/REAL(NN))
        Q = SCORE_NEW*TT*TT*TT*TT
        Q = Q*T

C       IF(HID.LT.FIDENT_MIN) GO TO 300
        IF(Q.LT.Q_LIM) GO TO 300

C       IF(ID_PDB.EQ.CODE(1:4).AND.HID.GT.99.999) HID = 100.0001

C        FIDENT_DB(J) = HID
C        SCR_DB(J)    = SCR
        IORDER_DB(J) = 1

        IF(COMPLEX_DB(J)(1:1).EQ.'X') GO TO 300 

        NS2          = NS2 + 1

        WRITE(LINE,
     *'(I5,1X,A5,1X,A5,I5,A1,I5,A1,I5,A1,I5,A1,2I5,F6.1,1X,F6.4,2I5)') 
     *  NS2,CODE1,CODE_DB(J)(1:5)
     *  ,N1,'(',N1_SEQ,')',N2,'(',NAA_DB(J),')'
     *  ,NN,NI,HID,Q,ID_DB(J),ILEVEL_DB(J)
        CALL MSGDOC(Mdoc,LINE)

C        IF(HID.GT.HID_BEST) THEN
        IF(Q.GT.Q_BEST) THEN
          IBEST = J
          HID_BEST = HID
          SCR_BEST = SCORE_NEW
          Q_BEST   = Q
          N2_BEST  = N2
          NI_BEST  = NI
          NN_BEST  = NN
        ENDIF
        
 300    CONTINUE

      ENDDO

      WRITE(LINE,*) 'NS2_seq:',NS2
      CALL MSGDOC(MDOC,LINE)

      IF(IBEST.GT.0) THEN
        IF(HID_BEST.GT.95.0) THEN
c          RETURN
        ENDIF
        CALL MSGDOC(MDOC,' --- BEST ---')
        WRITE(LINE,
     *'(2I6,1X,A5,1X,A5,I5,A1,I5,A1,I5,A1,I5,A1,2I5,F6.1,1X,F6.4)') 
     *  IBEST,IBEST,CODE1,CODE_DB(IBEST)(1:5)
     *  ,N1,'(',N1_SEQ,')',N2_BEST,'(',NAA_DB(IBEST),')'
     *  ,NN_BEST,NI_BEST,HID_BEST,Q_BEST
        CALL MSGDOC(MDOC,LINE)
        CALL MSGDOC(MDOC,' ------')
 
      ENDIF

      IF(NSEQ.LT.NSEQMAX) THEN
        IADD = 1
        NSEQ = NSEQ + 1
        JJ   = NSEQ
        ID_DB(JJ)     = JJ
        CODE_DB(JJ)   = CODE1
        IF(IBEST.LE.0) THEN  
          ILEVEL_DB(JJ) = 9
          IHIER_DB(JJ)  = 0
          IBACK_DB(JJ)  = 0
          ICLASS_DB(JJ) = 0
          FBACK_DB(JJ)  = 0
          SCR_DB(JJ)    = 0
        ELSE

c                  1   2    3    4    5    6    7    8    9
c      DATA  DTQ/0.80,0.65,0.50,0.45,0.40,0.35,0.30,0.25,0.20,0.0/

          ILEV = 0
          DO ILL=1,9
C           IF(HID_BEST.LT.DT(ILL)) THEN
            IF(Q_BEST.GE.DTQ(ILL)) THEN
              GO TO 111
            ELSE
              ILEV = ILL              
            ENDIF
          ENDDO
  111     CONTINUE

          ILEVEL_DB(JJ) = ILEV
          IHIER_DB(JJ)  = 0
          IBACK_DB(JJ)  = ID_DB(IBEST)
          ICLASS_DB(JJ) = ICLASS_DB(IBEST) + 1
          FBACK_DB(JJ)  = HID_BEST
          SCR_DB(JJ)    = SCR_BEST
        ENDIF

        NAA_DB(JJ)    = N1_SEQ
        RESOL_DB(JJ)  = 0.0
        NAT_DB(JJ)    = 0.0
        NRES_DB(JJ)   = N1_SEQ
        COMPLEX_DB(JJ)= 'D_203040C0'

C        FIDENT_DB(JJ) = 0.0
        IORDER_DB(JJ) = 0
C        SCR_DB(JJ)    = 0.0
   
      ENDIF

c      DO J=1,NSEQ
c        FIDENT_DB(J) = 0.0
c        SCR_DB(J)    = 0.0
c        IORDER_DB(J) = 0
c      ENDDO
C ---------------------------
  500 RETURN
  510 IERR = 1
      RETURN
  520 IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_RMS(MDOC,CODE5,FILE_1_CRD,FILE_PDB,PATH_SCR,RMS
     * ,RESULT,IPRROW,IERR)
C ----------------------------------
      REAL      RESULT(IPRROW)
      CHARACTER FILE_1_CRD*(*),FILE_PDB*(*)
      CHARACTER PATH_SCR*(*)
      CHARACTER CODE5*5
C ----
      CHARACTER FILE_OUT*256,PATH*1
      CHARACTER LINE*256
C ----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      RMS = -1.0

      FILE_OUT = ' '
      PATH = ' '
      IPRINT = 0
      IERR   = 0
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_1_CRD,FILE_PDB,FILE_OUT
     *                         ,RESULT,IPRROW,PATH_SCR,PATH,IERR)
      IF(IERR.NE.0) THEN
        CALL LENSTR_BL(FILE_1_CRD,LEN)
        LINE = ' ERROR in MAKE_ALIGN for :'//FILE_1_CRD(1:LEN)
        CALL MSGERR(MDOC,LINE)
        CALL LENSTR_BL(FILE_2,LEN)
        LINE = '                 and for :'//FILE_PDB(1:LEN)
        CALL MSGERR(MDOC,LINE)
        GO TO 500
      ENDIF
C --------------------------------------------------
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity %
C     RESULT(6) = SUM  score
C --------------------------------------------------
      HOM = RESULT(5)
      NN  = RESULT(3)
      N1  = RESULT(1)
      N2  = RESULT(2)

      WRITE(LINE,*) '-align12:',N1,N2,NN,HOM
      CALL MSGDOC(MDOC,LINE)

      F = (FLOAT(NN)*2.0)/FLOAT(N1+N2)
      IF(F.GT.0.9.AND.HOM.GT.50.0) THEN        
C ---
        NPAIR_INI = RESULT(3)
        NPAIR     = RESULT(17) 
        DRMS      = RESULT(16)
        CHI       = RESULT(24)
        DIST      = RESULT(25)
        WRITE(LINE,*)'==BEST NP,RMS:',NPAIR,DRMS
     *      ,NPAIR_INI   
        CALL MSGDOC(MDoc,LINE)
        T = FLOAT(NPAIR)/FLOAT(NPAIR_INI)
        IF(T.GT.0.80) THEN
          RMS = DRMS
        ELSE
          WRITE(LINE,'(A,A,A,I5,A,I5,2F6.2)') 
     *        '- not fit: ',CODE5,
     *        ' NPAIR_INI',NPAIR_INI,' --> NPAIR',NPAIR,T,DRMS
          CALL MSGERR(MDOC,LINE)
        ENDIF
      ELSE
        WRITE(LINE,'(A,A,A,3I5,F7.1)') 
     *      '- not fit: ',CODE5,' N1 N2 NN IDN :',N1,N2,NN,HOM
        CALL MSGERR(MDOC,LINE)
      ENDIF

  500 CONTINUE

      RETURN
      END

      SUBROUTINE PREPARE_SEQ(MDOC,CODE,CHAIN,FILE_PDB
     *          ,FILE_DB,FILE_SEQ_NEW,NRES_OCC,NAT_OCC
     *          ,PATH_OUT,PATH_SCR
     *          ,RESULT,IPRROW,IERR)
C --------------------------------------------------
      CHARACTER CODE*4,CHAIN*1
      CHARACTER FILE_PDB*(*),FILE_SEQ_NEW*(*),FILE_DB*(*)
      REAL      RESULT (IPRROW)
C ----
      REAL        CELL(6)
      CHARACTER   CODE_PDB*4,DATE_PDB*9
      CHARACTER   FILE_1*256,FILE_2*256
      CHARACTER   FILE_TEMP*256,FILE_SURF*256
      CHARACTER   LINE*256
      CHARACTER   EXT*3,PATH*1
      CHARACTER   DOM*2
      CHARACTER   PATH_OUT*(*),PATH_SCR*(*)
C ---
      real,      allocatable :: COORD(:,:)
      integer,   allocatable :: NSEQ(:)
      integer,   allocatable :: IRES(:)
      integer,   allocatable :: SURF(:)
      integer,   allocatable :: ICHAIN(:)
      integer,   allocatable :: IDOMAIN(:)
      integer,   allocatable :: ISS(:)
      real,      allocatable :: ELPOT(:)
      character(LEN=6), allocatable :: PNUM(:)
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN 
        FILE_1 = PATH_SCR(1:LEN)//'temp_add.seq'
      ELSE
        FILE_1 = 'temp_add.seq'
      ENDIF
   
      CALL PDB2SEQ(M,FILE_PDB,FILE_1
     *     ,CODE_PDB,DATE_PDB
     *     ,RESOL,RFAC,IMODEL,CELL,CHAIN
     *     ,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in PDB2SEQ')
        CALL LENSTR_BL(FILE_1,LEN)
        LINE = 'f1:'//FILE_1(1:LEN)//';'
        RETURN
      ENDIF

      FILE_2    = FILE_DB

      FILE_TEMP = 'file_corr.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN 
        FILE_TEMP = PATH_SCR(1:LEN)//'file_corr.pdb'
      ELSE
        FILE_TEMP = 'file_corr.pdb'
      ENDIF

      IPRINT  = 0
      IERR    = 0
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_1,FILE_2,FILE_TEMP
     *                  ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in MAKE_ALIGN')
        RETURN
      ENDIF

      NAT_OCC = RESULT(9) 
      NRES_OCC = RESULT(10) 

      ITEST = 1
      NMAX  = 100

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_TEMP
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE,NCHAIN,ITEST,IERR)
      IF(N.LE.0.OR.IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in READ_PDB_SEQ_AND_COORD_CA')
        IERR = 1
        GO TO 900
      ENDIF

      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      NMAX = N

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)
C ---
      ITEST = 0
      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_TEMP
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE,NCHAIN,ITEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in READ_PDB_SEQ_AND_COORD_CA.')
        GO TO 900
      ENDIF
C ---
      CALL ALIGN_SS_DEFINITION_ALLOC(MDOC,N
     * ,COORD(1,1),COORD(1,2),COORD(1,3),ISS,SURF
     * ,PSS,PH,PB,NMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in ALIGN_SS_DEFINITION')
        GO TO 900
      ENDIF
C ---
C      RESULT(1) = NATOM (Natom Occ > 0)
C      RESULT(2) = SURFA
C      RESULT(3) = SURFC
C      RESULT(8) = NTOT  (Natoms inside)
C      RESULT(9) = NRES
C      RESULT(10)= RAD_INER

C      NATOM    = RESULT(1) 
C      SURFA    = RESULT(2)
C      NACORE   = RESULT(8)
C      NRES     = RESULT(9) 
C      RAD_INER = RESULT(10)
C      CODE_PDB = CODE5(1:4)
C      CHAIN    = CODE5(5:5)

      DOM = '  '
      CALL WRITE_SEQ_WITH_SS_SURF(MDOC,FILE_SEQ_NEW
     *  ,CHAIN,CODE,DOM,NSEQ,ISS,SURF,IDOMAIN
     *  ,NMAX,N,NAA,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in WRITE_SEQ_WITH_SS_SURF')
        CALL LENSTR_BL(FILE_SEQ_NEW,LEN)
        LINE = 'f:'//FILE_SEQ_NEW(1:LEN)//';'
        GO TO 900
      ENDIF

      NAT  = RESULT(7) 
      NRES = RESULT(8) 

C ---
  900 CONTINUE

      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE CREATE_DOM_INFO_FOR_NEW(MDOC
     *      ,IS,CODE_IS,ID,CODE_ID,CH2
     *      ,CODE_DOM,ITYPE_DOM,NDOMAIN
     *      ,FILEP,FILE_CRD_NEW,FILE_SEQ_NEW
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *      ,NDOM_FINAL,NDOM_INI
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
C ---
      INTEGER   MDOC,IERR
      CHARACTER FILE_CRD_NEW*(*),FILE_SEQ_NEW*(*),FILEP*(*)

      CHARACTER CODE_DOM(NDOMAIN)*8
      INTEGER   ITYPE_DOM(NDOMAIN)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER PATH*256,PATH_DB*256,EXT*1
      CHARACTER FILE_CRD*256,FILE_SEQ*256,FILE_XYZ*256
      CHARACTER FILE_1*256,FILE_2*256,FILE_3*256,FILE_4*256
      CHARACTER FILE_5*256
      CHARACTER CODE_IS*5,CODE_ID*5,CODE4*4
      CHARACTER LINE*256
      CHARACTER COMPLEX_ID*8,CODE8*8,CH2*2
      CHARACTER DOM_ID_OLD*8,DOM_ID_NEW*8
C ---
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAX2 = 40  )
      CHARACTER PNUM_START(NSEGMAX2)*7,PNUM_FIN(NSEGMAX2)*7
c -----------------------------------
      CHARACTER CHAIN*1
      INTEGER   NLETT
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
      NDOM = 0
      COMPLEX_ID = ' '
      NDOM_FINAL = 0
      NSEG_FINAL = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
C --------------------------
      CALL MSGDOC(MDOC,'===================================')
      LINE = '==:'//CODE_ID
      CODE8 = CODE_ID//'   '
      CALL MSGDOC(MDOC,LINE)
      IF(CH2(2:2).EQ.'0') THEN
        NDOM_INI = 0
        DOM_ID_OLD = CODE_ID//'_0_'
        DOM_ID_NEW = CODE_IS//'_0_'
        DO IDD=1,NDOMAIN 
          IF(CODE_DOM(IDD).EQ.DOM_ID_OLD) THEN
            CODE_DOM(IDD) = DOM_ID_NEW
            GO TO 200
          ENDIF
        ENDDO
  200   CONTINUE
        IOUT = 0
        ICH  = 0
        NDDD = 0
        IDOM = 0
        FILE_SEQ = 'seq_DOM/'//DOM_ID_NEW(1:7)//'.seq'

        CALL CREATE_AND_WRITE_DOM_DESCR_ALLOC(MDOC,FILE_1,IOUT
     *   ,ICH,NDDD,CODE_IS,IDOM,FILE_SEQ
     *   ,RESULT,IPRROW,IERR)   
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in CREATE_AND_WRITE_DOM_DESCR')
          RETURN
        ENDIF

        RETURN
      ENDIF
C ----
      DO IL=1,NLETT
        IF(CH2(2:2).EQ.LETT(IL:IL)) THEN      
          NDOM_INI = IL + 9
          GO TO 210
        ENDIF
      ENDDO
      READ(CH2(2:2),'(I1)') NDOM_INI
210   CONTINUE

      FILE_CRD = FILEP
C 
      FILE_1 = 'temp1.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_1,LT )
      IF(LEN.GT.0) THEN
        FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
      ENDIF

      DOM_ID_OLD = CODE_ID//'___'
      CALL GET_DOM_INFO_FROM_LIST_MEM(MDOC,DOM_ID_OLD
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,ND_STRING,IDOMDOM,IDOMSEG
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in GET_DOM_INFO_FROM_LIST_MEM')
          RETURN
        ENDIF

C     ierr=-1    set '-' in seg_id(76:76) (domains border)
      IERR =-1
c     IERR = 0

      CALL SET_DOMAIN_INFO_TO_PDB_MEM(MDOC,FILE_CRD,FILE_1
     *      ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX3
     *      ,NDOM,IERR)
      IF(IERR.NE.0.OR.NDOM.LE.0) THEN
        IERR = 1
        RETURN
      ELSE
        FILE_CRD = FILE_1
      ENDIF
C -----------
C     align CODE_IS(seq)/ CODE_ID(corr+dom) --> CODE_IS(dom)  
c       file_seq (new)       file_crd (DB)         file_3
C

      FILE_3   = 'temp3.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_3,LT )
      IF(LEN.GT.0) THEN
        FILE_3 = PATH_SCR(1:LEN)//FILE_3(1:LT) 
      ENDIF

      FILE_SEQ = FILE_SEQ_NEW

      IPRINT  = 0
      IERR    = 0
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_SEQ,FILE_CRD,FILE_3
     *                  ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = 
     *    'ERROR: align CODE_IS(seq)/ CODE_ID(corr+dom) '
        CALL MSGERR(MDOC,LINE)
        LINE = 
     *    'ERROR:           ('//CODE_IS//'<--'//CODE_ID//')'
        CALL MSGERR(MDOC,LINE)
        GO TO 520
      ENDIF
C -------------------------------------------------
C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM
C       RESULT(6) = SUM_SCORE 
C -------------------------------------------------
        NC = RESULT(1)
        NN = RESULT(3) 
        T = FLOAT(NN)/FLOAT(NC)           
        IF(T.LT.0.85) THEN
          IERR = 11
          RETURN
        ENDIF
C ----------------
C     align CODE_IS(pdb)/ CODE_IS(dom) --> 
c       file_crd (new)      file_3          file_4
C

      FILE_CRD = FILE_CRD_NEW

      FILE_4   = 'temp4.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_4,LT )
      IF(LEN.GT.0) THEN
        FILE_4 = PATH_SCR(1:LEN)//FILE_4(1:LT) 
      ENDIF

      IPRINT  = 0
      IERR    = 0
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_CRD,FILE_3,FILE_4
     *                  ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = 
     *    'ERROR:  align CODE_IS(pdb)/ CODE_IS(dom)'
        CALL MSGERR(MDOC,LINE)
        LINE = 
     *    'ERROR:           ('//CODE_IS//'<--'//CODE_ID//')'
        CALL MSGERR(MDOC,LINE)
        GO TO 520
      ENDIF
C ----------------
c     get dom info

      NSEG_TOT = 0
      LEN_LIM = 5
      IF(IS.EQ.ID) LEN_LIM = 0 

c      IF(NDOM.NE.NDOM_INI) THEN
c      ENDIF

      DO IDOM=1,NDOM

        FILE_1 = 'temp5.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_1,LT )
        IF(LEN.GT.0) THEN
          FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
        ENDIF

        CALL GET_DOMAIN_PDB(MDOC,FILE_4,FILE_1
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX2
     *  ,IDOM,NRES,NATOM,IERR)
        IF(IERR.NE.0.OR.NATOM.LE.0.OR.NRES.LT.5.OR.NSEG.LE.0) THEN
          IERR = 0
          GO TO 110
        ENDIF

        IF(NSEG.GT.1) THEN

          ISP = 0
          DO ISS=1,NSEG
            READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
            READ(PNUM_FIN(ISS)(3:6),'(I4)') IS_F
            ISD = IS_F - IS_S + 1
            IF(ISD.GT.1) THEN
              ISP = ISP + 1
              PNUM_START(ISP) = PNUM_START(ISS)
              PNUM_FIN(ISP)   = PNUM_FIN(ISS)
            ENDIF
          ENDDO  
          NSEG = ISP

          ISP = 1
          DO ISS=2,NSEG
            READ(PNUM_START(ISP)(3:6),'(I4)') ISP_S
            READ(PNUM_FIN(ISP)(3:6),'(I4)') ISP_F
            READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
            READ(PNUM_FIN(ISS)(3:6),'(I4)') IS_F
            ISD = IS_S - ISP_F
            IF(ISD.LE.LEN_LIM) THEN
              PNUM_FIN(ISP) = PNUM_FIN(ISS)
            ELSE
              ISP = ISP + 1
              PNUM_START(ISP) = PNUM_START(ISS)
              PNUM_FIN(ISP) = PNUM_FIN(ISS)
            ENDIF
          ENDDO  
          NSEG = ISP

        ENDIF

        NDOM_FINAL = NDOM_FINAL + 1
        DO ISEG=1,NSEG
          NSEG_TOT   = NSEG_TOT + 1
          IDOMDOM(NSEG_TOT)  = NDOM_FINAL
          IDOMSEG(NSEG_TOT)  = ISEG
          PNUM1_DM(NSEG_TOT) = PNUM_START(ISEG)(2:7)  
          PNUM2_DM(NSEG_TOT) = PNUM_FIN(ISEG)(2:7)
          IF(PNUM1_DM(NSEG_TOT)(6:6).EQ.' ') 
     *    PNUM1_DM(NSEG_TOT)(6:6) = '-'
          IF(PNUM2_DM(NSEG_TOT)(6:6).EQ.' ') 
     *    PNUM2_DM(NSEG_TOT)(6:6) = '-'
          PNUM1_DM(NSEG_TOT)(1:1) = CODE_IS(5:5)
          PNUM2_DM(NSEG_TOT)(1:1) = CODE_IS(5:5)
        ENDDO  

c       WRITE(*,*) '---IDOM:',IDOM,IS,CODE_IS,ID,CODE_ID

        DOM_ID_OLD = CODE_ID//'___'
        WRITE(DOM_ID_OLD(6:7),'(I2)') NDOM_FINAL
        IF(DOM_ID_OLD(6:6).EQ.' ') DOM_ID_OLD(6:6) = '_'
        DOM_ID_NEW   = CODE_IS//DOM_ID_OLD(6:8)

        DO IDD=1,NDOMAIN 
          IF(CODE_DOM(IDD).EQ.DOM_ID_OLD) THEN
              CODE_DOM(IDD) = DOM_ID_NEW
C            IF(NDOM.EQ.NDOM_INI) THEN
c             -- profile -- ITYPE_DOM > 0
c             copy with new name and delete
c             ----
C            ENDIF
            GO TO 100
          ENDIF
        ENDDO
 100    CONTINUE

C-       IOUT = 0
C        ICH  = 0
C        NDDD = 0
C        FILE_SEQ = 'seq_DOM/'//DOM_ID_NEW(1:7)//'.seq'
C
C-        CALL CREATE_AND_WRITE_DOM_DESCR_ALLOC(MDOC,FILE_1,IOUT
C     *   ,ICH,NDDD,CODE_IS,IDOM,FILE_SEQ
C     *   ,RESULT,IPRROW,IERR)   
C        IF(IERR.NE.0) THEN
C          CALL MSGERR(MDOC,'ERROR: in CREATE_AND_WRITE_DOM_DESCR')
C          RETURN
C-        ENDIF

 110    CONTINUE

      ENDDO

      IF(NDOM_FINAL.GT.0) THEN
C       NDOM = IDOMDOM(1)
        DO I=1,NSEG_TOT
          NSEG_DB = NSEG_DB + 1
          NDOM_DB(NSEG_DB)      = NDOM_FINAL
          CODE_DOM_DB(NSEG_DB)  = CODE_IS            
          IDOMSEG_DB(NSEG_DB)   = IDOMDOM(I)*100 + IDOMSEG(I)
          PNUM1_DOM_DB(NSEG_DB) = PNUM1_DM(I)
          PNUM2_DOM_DB(NSEG_DB) = PNUM2_DM(I) 
        ENDDO
      ENDIF

C ---
      DOM_ID_NEW = CODE_IS//'___'
      CALL GET_DOM_INFO_FROM_LIST_MEM(MDOC,DOM_ID_NEW
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,ND_STRING,IDOMDOM,IDOMSEG
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in GET_DOM_INFO_FROM_LIST_MEM.')
        RETURN
      ENDIF

      CALL SURFACE_DB_ALLOC(MDOC,FILE_CRD_NEW,FILE_4
     * ,RESULT,IPRROW,IERR)   

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SURFACE_DB_ALLOC.')
        RETURN
      ENDIF
      
      FILE_CRD = FILE_4

C     ierr=-1    set '-' in seg_id(76:76) (domains border)
      IERR =-1
c     IERR = 0
      CALL SET_DOMAIN_INFO_TO_PDB_MEM(MDOC,FILE_CRD,FILE_1
     *      ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX3
     *      ,NDOM,IERR)



      IF(IERR.NE.0.OR.NDOM.LE.0) THEN
        IERR = 1
        RETURN
      ELSE
        FILE_CRD = FILE_1
      ENDIF
C -----------
      DO IDOM=1,NDOM

        FILE_1 = 'temp6.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_1,LT )
        IF(LEN.GT.0) THEN
          FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
        ENDIF

        CALL GET_DOMAIN_PDB(MDOC,FILE_CRD,FILE_1
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX2
     *  ,IDOM,NRES,NATOM,IERR)
        IF(IERR.NE.0.OR.NATOM.LE.0.OR.NRES.LT.5.OR.NSEG.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: in  GET_DOMAIN_PDB.')
          RETURN
        ENDIF

        DOM_ID_NEW = CODE_IS//'___'
        WRITE(DOM_ID_NEW(6:7),'(I2)') IDOM
        IF(DOM_ID_NEW(6:6).EQ.' ') DOM_ID_NEW(6:6) = '_'

        IOUT = 0
        ICH  = 0
        NDDD = 0
        FILE_SEQ = 'seq_DOM/'//DOM_ID_NEW(1:7)//'.seq'

        CALL CREATE_AND_WRITE_DOM_DESCR_ALLOC(MDOC,FILE_1,IOUT
     *   ,ICH,NDDD,CODE_IS,IDOM,FILE_SEQ
     *   ,RESULT,IPRROW,IERR)   
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in CREATE_AND_WRITE_DOM_DESCR')
          RETURN
        ENDIF

      ENDDO
C ---
C ----------------
      RETURN
 520  CONTINUE
      IERR = 2
      RETURN
      END
