      SUBROUTINE PDB2SEQ(MDOC,FILE_1,FILE_OUT
     * ,CODE_PDB,DATE_PDB
     * ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     * ,RESULT,IPRROW,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC,IERR,IPRROW
      CHARACTER FILE_1*(*),FILE_OUT*(*)
      REAL      RESULT(*),CELL(6)
C ----
      INTEGER   NMAX,ICMAX
      PARAMETER (NMAX  = 6000)
      PARAMETER (ICMAX = 200)
      INTEGER   NSEQ(NMAX),ICHAIN(NMAX)
      CHARACTER CHAIN(ICMAX)*1
      CHARACTER CHAIN_INP*1
      CHARACTER CODE_PDB*4,DATE_PDB*9
      CHARACTER LINE*80
C --------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --
      IMODEL = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      DO I=1,NMAX
        NSEQ(I)   = 0
        ICHAIN(I) = 0
      ENDDO
      DO I=1,ICMAX
        CHAIN(I) = ' '
      ENDDO
C---------------------------------------------------------------
      CALL MSGDOC(M,'read file protein-1')
      CALL CORR_NAME_BL(FILE_1)
      CALL LENSTR_BL(FILE_1,LEN)
      IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.pdb') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,L)
        IF(L.LE.0) THEN
          CALL LENSTR_BL(CHAIN_INP,LL)
          IF(LL.LE.0) THEN
            FILE_OUT = FILE_1(1:LEN-4)//'.seq'
          ELSE
            FILE_OUT = FILE_1(1:LEN-4)//CHAIN_INP//'.seq'
          ENDIF
          CALL REMOVE_PATH(FILE_OUT)
        ENDIF

        CALL PDB2SEQ_RUN(MDOC,FILE_1,FILE_OUT
     *         ,CODE_PDB,DATE_PDB
     *         ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
     *         ,NSEQ,CHAIN,ICHAIN,RESULT,IPRROW
     *         ,NMAX,ICMAX,NCHAIN,IERR)
C --------------------------------------------------------
        IF(IERR.NE.0) RETURN
      ELSE
        IERR = 0
      ENDIF
      IF(IERR.NE.0) RETURN

 900  CONTINUE
      RETURN
      END

      SUBROUTINE PDB2SEQ_RUN(MDOC,NAME_IN,NAME_OUT
     *         ,CODE_PDB,DATE_PDB
     *         ,RESOL,RFAC,IMODEL_INP,CELL,CHAIN_INP
     *         ,NSEQ,CHAIN,ICHAIN,RESULT,IPRROW
     *         ,NMAX,ICMAX,NCHAIN,IERR)
C --------------------------------------------------------
      INTEGER   NSEQ(NMAX),ICHAIN(NMAX)
      CHARACTER CHAIN(ICMAX)*1
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
      REAL      RESULT(*),CELL(6)
      CHARACTER CHAIN_INP*1
C --------------------------------------------------------
C ----
      CHARACTER CODE_PDB*4,DATE_PDB*9
      CHARACTER LINE*256,NAME*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      INTEGER   ICH4      
      REAL      FCH4      
      CHARACTER CH1*1,CH3*3,CH4*4
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      PARAMETER ( NRNAMED = 38 )
      CHARACTER RNAMED(38)*3
      PARAMETER ( NRNAMES = 14 )
      CHARACTER RNAMES(14)*3
      CHARACTER CHN*1,CH46*46
      CHARACTER FRMT*80
      EQUIVALENCE (FCH4,CH4)
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
      DATA RNAMED/'A  ','C  ','G  ','T  ','U  ','I  ','+A ','+C ' 
     *           ,'+G ','+T ','+U ','1MA','1MG','2MG','5MC','5MU'
     *           ,'7MG','H2U','M2G','OMC','OMG','OMU','PSU','YG '
     *           ,'Ad ','Ar ','Cd ','Cr ','Gd ','Gr ','Td ','Ur '
     *           ,'Ir ','DA ','DC ','DT ','DG ','DI '/
      DATA RNAMES/'MAN','NAG','FUC','GAL','GLC','GCU','GSA','XYS' 
     *           ,'ARB','RIP','ABE','RAM','MAG','MMA'            /
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: PDB2SEQ wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      N      = 0 
      NRES   = 0
      NDNA   = 0
      NBAD   = 0
      DATE_PDB = '.'
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD = '?'
      ANAME_OLD   = '?'
      IRES_OLD    =-1000000
      IRES    = 0
      IRES_DEL= 0
      ICH     = 0
      NCHAIN  = 0
      IEND    = 0
      RESOL = 0.0
      RFAC  = 0.0
      IMODEL= 0
      DO I=1,6
        CELL(I) = 0.0
      ENDDO
      ISEQRES = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        DATE_PDB = LINE(51:59)
        CODE_PDB = LINE(63:66)
        IMODE =-1
        CALL CHECK_LINE(IMODE,CODE_PDB) 
        GO TO 400
      ENDIF        

      IF(LINE(1:6).EQ.'MODEL ') THEN
        IMODEL= IMODEL + 1
        LINE = ' '
        IF(IMODEL_INP.LE.0.AND.IMODEL.GT.1) GO TO 620
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        READ(LINE,'(6X,3F9.3,3F7.2)',ERR=400) 
     *               CELL(1),CELL(2),CELL(3)
     *              ,CELL(4),CELL(5),CELL(6)
        GO TO 400
      ELSE IF(LINE(1:6).EQ.'REMARK') THEN
        READ(LINE,'(7X,I3,1X,A46)',ERR=400) IREM,CH46
        IF(IREM.EQ.2.AND.CH46(1:10).EQ.'RESOLUTION') THEN

cREMARK   2 RESOLUTION. 2.50 ANGSTROMS.                                          
cREMARK   2 RESOLUTION.    1.93 ANGSTROMS. 
c                       1234567  
c123456789 123456789 123456789 123456                                               
c1234567123 123456789 123456789 123456789 123456789 1
cREMARK   3   R VALUE            (WORKING SET) : 0.186                           
cREMARK   3   R VALUE            (WORKING SET) : 0.205  
                         
          IF(CH46(18:21).EQ.'ANGS') THEN
            READ(CH46(13:16),'(F4.2)',ERR=400) RESOL
          ELSE
            READ(CH46(13:19),'(F7.2)',ERR=400) RESOL
          ENDIF
        ELSE IF(IREM.EQ.3.AND.CH46(1:10).EQ.'  R VALUE ') THEN
          READ(CH46(39:44),'(F6.3)',ERR=400) RFAC
        ENDIF
        GO TO 400
      ENDIF

c      IF(LINE(1:6).EQ.'SEQRES') THEN
c        CALL SEQRES2S(MDOC,IU,IOUT,LINE,CHAIN_INP,CODE_PDB
c     *         ,NSEQ,CHAIN,ICHAIN
c     *         ,NMAX,ICMAX,NCHAIN,IERR)
c        IF(IERR.GT.0) RETURN
c        IF(NCHAIN.GT.0) THEN
c          ISEQRES = 1
c          GO TO 400
c        ENDIF
c      ENDIF

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       IF(ISEQRES.GT.0) GO TO 630

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CSURF,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400

      IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
 
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF

c ----
      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
C      IF(RNAME.EQ.'MSE') RNAME = 'MET'
C      IF(RNAME.EQ.'HYP') RNAME = 'PRO'
C      IF(RNAME.EQ.'CSH') RNAME = 'CYS'
c ----
      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO

      DO  J=1,NRNAMED
        IF(CH3.EQ.RNAMED(J)) THEN
          NDNA = NDNA + 1
          GO TO 400
        ENDIF
      ENDDO
      DO  J=1,NRNAMES
        IF(CH3.EQ.RNAMES(J)) THEN
          GO TO 400
        ENDIF
      ENDDO
      NBAD = NBAD + 1
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
      IF(J.GT.20) J = 21      

      IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c       new residue

        IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c         new chain

C         IF((ICH.GT.0.OR.IEND.GT.0).AND.N.GT.4) THEN
          IF((ICH.GT.0.OR.IEND.GT.0).AND.NRES.GT.4) THEN
            CALL LENSTR_BL(CHAIN_INP,LCH)
            IF(LCH.LE.0.OR.CHAIN_INP.EQ.CHAIN(ICH)) THEN
              LINE = '>'//CODE_PDB//'_'//CHAIN(ICH)
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)') LINE(1:LEN)
              II   = 0
              LINE = ' '
              DO I=1,N
                JJ  = NSEQ(I)
                CH1 = AMIN(JJ)
                II  = II +1
                LINE(II:II) = CH1
                IF(II.EQ.50) THEN
                  CALL LENSTR_BL(LINE,LEN)
                  WRITE(IOUT,'(A)') LINE(1:LEN)
                  II = 0
                  LINE = ' '
                ENDIF
              ENDDO
              IF(II.GT.0) THEN
                CALL LENSTR_BL(LINE,LEN)
                WRITE(IOUT,'(A)') LINE(1:LEN)
              ENDIF
            ENDIF
          ENDIF

C         IF((N.GT.4).OR.ICH.LE.0) ICH = ICH + 1
          IF((NRES.GT.4).OR.ICH.LE.0) ICH = ICH + 1

          IF(ICH.GE.ICMAX) THEN
            WRITE(LINE,'('' ERR: NUMBER OF CHAINS >'',I8)')ICMAX
            CALL MSGERR(MDOC,LINE) 
            CALL MSGERR(MDOC,
     *      '        change parameter MEMORY in main')
            IERR=1
            CLOSE(IOUT)
            CLOSE(IU)
            RETURN
          ENDIF
          N    = 0
          NRES = 0
          NBAD = 0
          NDNA = 0
          CHN = CP_PNUM(2:2)
          CALL LENSTR_BL(CHN,LEN)
          IF(LEN.LE.0) CHN = '_'
          IRES_OLD =-1000000
        ENDIF

      ENDIF

      IF(J.GE.1.AND.J.LE.20) THEN

        IF(ANAME.NE.'CA  ') GO TO 400
        IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD) GO TO 400
        ANAME_OLD = ANAME
 
        READ(CP_PNUM(3:6),'(I4)') IRES

        IF(IRES_OLD.EQ.-1000000) THEN
          IRES_DEL = 0
        ELSE
          IRES_DEL = IRES - IRES_OLD
        ENDIF
        
        IF(IRES_DEL.NE.0.AND.IRES_DEL.NE.1) THEN
          N = N + 1
          IF(N.GE.NMAX) THEN
            WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
            CALL MSGERR(MDOC,LINE) 
            CALL MSGERR(MDOC,
     *      '        change parameter MEMORY in main')
            IERR=1
            CLOSE(IU)
            CLOSE(IOUT)
            RETURN
          ENDIF

          NSEQ(N)    = 25
          CHAIN(ICH) = CHN
          ICHAIN(ICH)= N

        ENDIF

        NRES = NRES + 1
        N = N + 1
        IF(N.GE.NMAX) THEN
          WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
          CALL MSGERR(MDOC,LINE) 
          CALL MSGERR(MDOC,
     *      '        change parameter MEMORY in main')
          IERR=1
          CLOSE(IU)
          CLOSE(IOUT)
          RETURN
        ENDIF

        NSEQ(N)    = J
        CHAIN(ICH) = CHN
        ICHAIN(ICH)= NRES

        IRES_OLD     = IRES

      ENDIF
      CP_PNUM_OLD  = CP_PNUM
      GO TO 400
C --------------
 600  CONTINUE

      CALL LENSTR_BL(CHAIN_INP,LCH)
      IF(LCH.LE.0.OR.CHAIN_INP.EQ.CHAIN(ICH)) THEN 

C       IF(N.GT.4) THEN
        IF(NRES.GT.4) THEN
          LINE = '>'//CODE_PDB//'_'//CHAIN(ICH)
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)') LINE(1:LEN)
          II   = 0
          LINE = ' '
          DO I=1,N
            JJ  = NSEQ(I)
            CH1 = AMIN(JJ)
            II  = II +1
            LINE(II:II) = CH1
            IF(II.EQ.50) THEN
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)') LINE(1:LEN)
              II = 0
              LINE = ' '
            ENDIF
          ENDDO
          IF(II.GT.0) THEN
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)') LINE(1:LEN)
          ENDIF
        ENDIF
      ENDIF

      NCHAIN = ICH
      IF(NCHAIN.GT.0) THEN
        IF(ICHAIN(NCHAIN).LE.4) NCHAIN = NCHAIN -1
      ENDIF

 630  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      WRITE(LINE,'('' Number of chains  :'',I8)') NCHAIN
      CALL MSGDOC(MDOC,LINE)
      IF(NCHAIN.LE.0) THEN
        CALL MSGERR(MDOC,' Number of chains = 0')
        IERR = 9
      ENDIF

      NC = NCHAIN
      NC_LIM = (IPRROW-1)/2

      IF(NC.GT.NC_LIM) NC = NC_LIM
      II = 1
      RESULT(II) = NC

      IF(NC.GT.0) THEN
        DO I=1,NC
          WRITE(LINE,'(I5,1X,A,1X,I5)') I,CHAIN(I),ICHAIN(I)
          CALL MSGDOC(MDOC,LINE)
          II = II + 1
          CH4 = CHAIN(I)//'   '
          RESULT(II) =  FCH4
          II = II + 1
          RESULT(II) =  ICHAIN(I)
        ENDDO
      ENDIF

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE SEQRES2S(MDOC,IU,IOUT,STR,CHAIN_INP,CODE_PDB
     *         ,NSEQ,CHAIN,ICHAIN
     *         ,NMAX,ICMAX,NCHAIN,IERR)
C ----
      CHARACTER STR*256,CHAIN_INP*1
      INTEGER   NSEQ(NMAX),ICHAIN(NMAX)
      CHARACTER CHAIN(ICMAX)*1
      CHARACTER CODE_PDB*4
C ----
      CHARACTER LINE*256,CH1*1,CHAIN_OLD*1,STR1*256
      CHARACTER RNAME*3,CHN*1,CH3*3
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      PARAMETER ( NRNAMED = 38 )
      CHARACTER RNAMED(38)*3
      PARAMETER ( NRNAMES = 14 )
      CHARACTER RNAMES(14)*3
      CHARACTER ANAME*4,ASYMB*4,CTYPE*4
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C ----
      DATA RNAMED/'A  ','C  ','G  ','T  ','U  ','I  ','+A ','+C ' 
     *           ,'+G ','+T ','+U ','1MA','1MG','2MG','5MC','5MU'
     *           ,'7MG','H2U','M2G','OMC','OMG','OMU','PSU','YG '
     *           ,'Ad ','Ar ','Cd ','Cr ','Gd ','Gr ','Td ','Ur '
     *           ,'Ir ','DA ','DC ','DT ','DG ','DI '/
      DATA RNAMES/'MAN','NAG','FUC','GAL','GLC','GCU','GSA','XYS' 
     *           ,'ARB','RIP','ABE','RAM','MAG','MMA'            /
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      ICH     = 0
      NCHAIN  = 0
      IEND    = 0
      N       = 0 
      CHAIN_OLD = '?'
      NDNA    = 0
      NBAD    = 0

C      IF(STR(1:6).EQ.'SEQRES') THEN

 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      STR1 = STR
      STR  = ' '
      READ(IU,'(A)',ERR=500,END=620) STR
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      IF(STR(1:6).NE.'SEQRES') THEN
        IEND = 1
      ELSE
        CALL LENSTR_BL(STR,LEN)
        IF(LEN.GT.72) THEN
          DO L=73,LEN
            STR(L:L) = ' '
          ENDDO
        ENDIF
      ENDIF

      IF(STR1(12:12).EQ.' ') STR1(12:12) = '_'
      IF(STR1(12:12).NE.CHAIN_OLD) THEN
c ---       new chain
        IF((ICH.GT.0.OR.IEND.GT.0).AND.N.GT.4.AND.N.GT.NBAD) THEN
          CALL LENSTR_BL(CHAIN_INP,LCH)
          IF(LCH.LE.0.OR.CHAIN_INP.EQ.CHAIN(ICH)) THEN
            LINE = '>'//CODE_PDB//'_'//CHAIN(ICH)
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)') LINE(1:LEN)
            II   = 0
            LINE = ' '
            DO I=1,N
              JJ  = NSEQ(I)
              CH1 = AMIN(JJ)
              II  = II +1
              LINE(II:II) = CH1
              IF(II.EQ.50) THEN
                CALL LENSTR_BL(LINE,LEN)
                WRITE(IOUT,'(A)') LINE(1:LEN)
                II = 0
                LINE = ' '
              ENDIF
            ENDDO
            IF(II.GT.0) THEN
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)') LINE(1:LEN)
            ENDIF
          ENDIF
        ENDIF
        IF((N.GT.4.AND.N.GT.NBAD).OR.ICH.LE.0) ICH = ICH + 1
        IF(ICH.GE.ICMAX) THEN
          WRITE(LINE,'('' ERR: NUMBER OF CHAINS >'',I8)')ICMAX
          CALL MSGERR(MDOC,LINE) 
          CALL MSGERR(MDOC,
     *      '        change parameter MEMORY in main')
          IERR=1
          CLOSE(IOUT)
          CLOSE(IU)
          RETURN
        ENDIF

        N    = 0
        NDNA = 0
        NBAD = 0
        CHN = STR1(12:12)
        CALL LENSTR_BL(CHN,LEN)
        IF(LEN.LE.0) CHN = '_'
      ENDIF
C ---
cSEQRES   1     93  ALA GLU LYS CYS PHE ASP HIS ALA ALA GLY THR SER TYR  1FBR  50
C123456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
cSEQRES   1 A  207  MET ALA HIS HIS HIS HIS HIS HIS SER LEU SER SER PRO        
cSEQRES   2 A  207  TYR ILE LEU VAL LEU TYR TYR SER ARG HIS GLY ALA THR      
cSEQRES   3 A  207  ALA GLU MET ALA ARG GLN ILE ALA ARG GLY VAL GLU GLN        
cSEQRES   4 A  207  GLY GLY PHE GLU ALA ARG VAL ARG THR VAL PRO ALA VAL        
cSEQRES   5 A  207  SER THR GLU CYS GLU ALA VAL ALA PRO ASP ILE PRO ALA        

      CALL LENSTR_BL(STR1,LEN)
      IF(LEN.GT.70) THEN
        DO L=71,LEN
          STR1(L:L) = ' '
        ENDDO
      ENDIF
      CALL LENSTR_BL(STR1,LEN)
      L1 = 20
      DO K=1,13
        L2 = L1 + 2
        IF(L2.GT.LEN) GO TO 100

        RNAME = STR1(L1:L2)

        CALL CORR_RESNAME_BY_SYNONYM(RNAME)
C        IF(RNAME.EQ.'MSE') RNAME = 'MET'
C        IF(RNAME.EQ.'HYP') RNAME = 'PRO'
C        IF(RNAME.EQ.'CSH') RNAME = 'CYS'

        ANAME = ' C  '
        CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)

        CH3 = RNAME
        DO  J=1,23
          IF(CH3.EQ.ACODE3(J)) THEN
            GO TO 700
          ENDIF
        ENDDO

        DO  J=1,NRNAMED
          IF(CH3.EQ.RNAMED(J)) THEN
            NDNA = NDNA + 1
            GO TO 400
          ENDIF
        ENDDO
        DO  J=1,NRNAMES
          IF(CH3.EQ.RNAMES(J)) THEN
            GO TO 400
          ENDIF
        ENDDO

        NBAD = NBAD + 1
        J   = 26
 700    CONTINUE
        IF(J.EQ.22) J = 7
        IF(J.EQ.23) J = 8
        IF(J.GT.20) J = 21

        N = N + 1
        IF(N.GE.NMAX) THEN
          WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
          CALL MSGERR(MDOC,LINE) 
          CALL MSGERR(MDOC,
     *      '        change parameter MEMORY in main')
          IERR=1
          CLOSE(IU)
          CLOSE(IOUT)
          RETURN
        ENDIF

        NSEQ(N)    = J
        CHAIN(ICH) = CHN
        ICHAIN(ICH)= N

        L1 = L1 + 4
      ENDDO
100   CONTINUE

      CHAIN_OLD = CHN
      GO TO 400
C --------------
 600  CONTINUE

      CALL LENSTR_BL(CHAIN_INP,LCH)
      IF(LCH.LE.0.OR.CHAIN_INP.EQ.CHAIN(ICH)) THEN 
      IF(N.GT.4.AND.N.GT.NBAD) THEN
        LINE = '>'//CODE_PDB//'_'//CHAIN(ICH)
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        II   = 0
        LINE = ' '
        DO I=1,N
          JJ  = NSEQ(I)
          CH1 = AMIN(JJ)
          II  = II +1
          LINE(II:II) = CH1
          IF(II.EQ.50) THEN
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)') LINE(1:LEN)
            II = 0
            LINE = ' '
          ENDIF
        ENDDO
        IF(II.GT.0) THEN
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)') LINE(1:LEN)
        ENDIF
      ENDIF
      ENDIF

      NCHAIN = ICH
      IF(NCHAIN.GT.0) THEN
      IF(ICHAIN(NCHAIN).LE.0) NCHAIN = NCHAIN -1
      ENDIF

      RETURN
C ----------------
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE READ_FASTA_SEQ(MDOC,NAME_IN,NSEQ,IRES,NMAX
     *       ,ISS,ISSN,SURF,ICHAIN,N,ICH,CODE,IERR)
C --------------------------------------------------------
      CHARACTER CODE*4
      INTEGER*2 NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX)
      INTEGER*2 ISS(NMAX),ISSN(NMAX),SURF(NMAX)
C  
C READ_FASTA_SEQ   read sequence which can be used for ALIGN.
C 
C      File with sequence is ASCII file:
C
C      !>prot_id
C      !# sequence 
C      !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C      !# this is comment
C      !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C      !NRGTRITKEVFDNLTNWKNSAQ
C
C      If first symbol in the line is "#" it means the line is comments
C
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
      CHARACTER SS_FLAG*1,D3_FLAG*1 
c ----
      CHARACTER NAME*256,PATH*80,EXT*80,STR*256
      CHARACTER LINE*256,LINE_SS*256,LINE_SR*256
      CHARACTER STR_IN*256
      CHARACTER DB_FLAG*1,SS*1,SS_OLD*1
C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      DB_FLAG = 'N'
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) STR_IN
        CALL LENSTR_BL(STR_IN,LENS)
        IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SS:') THEN
          DB_FLAG = 'Y'
          GO TO 800
        ELSE IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SR:') THEN
          DB_FLAG = 'y'
          GO TO 800
        ENDIF
      ENDDO
 800  CONTINUE
      CLOSE(IU)
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      ICH= 0
      IC = 0
      NC =-1
      N  = 0 
      NR = 0 
      NBAD = 0
      NX   = 0
      CODE = 'XXXX'
      IEND = 0
      LINE_SS = ' '
      LINE_SR = ' '
      SS_OLD = ' '
      NSS    = 0
C ----------------
 400  CONTINUE
      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          ICH = ICH + 1
          NR  = 0
          IF(ICH.EQ.1) THEN
            CODE = '?   '
            IF(LEN.GT.1) THEN
              DO L=2,LEN
                CODE(L-1:L-1) = LINE(L:L)
                IF(L.GE.5) GO TO 400
              ENDDO
            ENDIF
          ENDIF
          GO TO 400
        ENDIF        
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
        IF(DB_FLAG.EQ.'Y') THEN
          LINE_SS = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SS
          LINE_SR = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SR
          IC = 5
        ENDIF
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
C      ELSE IF(CH1.EQ.'-') THEN
C        IC = IC + 1
C        GO TO 400
      ENDIF

      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
C     IF(J.EQ.24) J = 21
      IF(J.GE.1.AND.J.LE.20) THEN
        IF(N.GE.NMAX) THEN
          WRITE(STR,'('' ERR: NUMBER OF RESIDUES >'',I8)') NMAX
          CALL MSGDOC(MDOC,STR) 
          IERR=1
          CLOSE(IU)
          RETURN
        ENDIF
        N  = N + 1
        NR = NR + 1
        NSEQ(N) = J
        IRES(N) = NR
        IF(ICH.LE.0) ICH = 1
        ICHAIN(N) = ICH
      ELSE IF(J.LE.25) THEN
        IF(J.NE.25) THEN
          WRITE(STR,
     *    '('' WARNING: nonstandard residue:'',A,I4)') CH1,J
          CALL MSGDOC(MDOC,STR)
          N       = N + 1 
          NR      = NR + 1 
          NX      = NX + 1
          NSEQ(N) = 21
          IRES(N) = N
          IF(ICH.LE.0) ICH = 1
          ICHAIN(N) = ICH
        ENDIF
      ELSE
        NBAD = NBAD + 1
        WRITE(STR,
     *  '('' WARNING: bad residue:'',A,I4)') CH1,J
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(DB_FLAG.EQ.'Y') THEN
        IF(J.GE.1.AND.J.LE.25) THEN

          SS  = LINE_SS(IC:IC) 
          CH1 = LINE_SR(IC:IC)
          READ(CH1,'(I1)') SURF(N)
          IF(SS.NE.' '.AND.SS.NE.SS_OLD) NSS = NSS + 1
          IF(SS.NE.' ') THEN 
            ISSN(N) = NSS
            ISS (N) = 0
            IF(SS.EQ.'H') THEN
              ISS (N) = 1
            ELSE IF(SS.EQ.'h') THEN
              ISS (N) = 2
            ELSE IF(SS.EQ.'B') THEN
              ISS (N) = 3
            ELSE IF(SS.EQ.'b') THEN
              ISS (N) = 4
            ENDIF
          ELSE
            ISS (N) = 0
            ISSN(N) = 0
          ENDIF
          SS_OLD = SS
        ENDIF
      ENDIF
      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      WRITE(LINE,'('' Number of residues     :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of bad residues :'',I8)') NBAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of X residues   :'',I8)') NX
      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE COPY_SEQUENCE_FASTA(MDOC,NM,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      INTEGER   MDOC,NM,IERR
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C ----
      CHARACTER LINE*256,PATH*1,EXT*1,CH4*4
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      IF(NM.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: in COPY_SEQUENCE_FASTA : NM=0')
        IERR = 1
        RETURN
      ENDIF
      WRITE(CH4,'(I4)') NM
C -----
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: CP_SEQ wrong input file name')
        IERR = 1
        RETURN
      ENDIF
C -----
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: CP_SEQ wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 210
      ENDIF
C --------------------------------

      DO I=1,NM

      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IOUT)
        GO TO 200
c        RETURN
      ENDIF
      IFIRST = 0
      IEND   = 0
 400  CONTINUE
      LINE = ' '
      READ(IN,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
        IF(I.EQ.1) THEN
          IF(LEN.GT.10) LEN = 10 
          LINE = LINE(1:LEN)//' Nseq '//CH4
        ELSE
          WRITE(CH4,'(I4)') I
          LINE = '> iseq '//CH4 
        ENDIF
      ENDIF

      IF(IFIRST.EQ.0) THEN
        IF(LINE(1:1).NE.'>')  WRITE(IOUT,'(A)',ERR = 510) '> '
        IFIRST = 1 
      ENDIF

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) WRITE(IOUT,'(A)',ERR = 510) LINE(1:LEN)

      IF(IEND.GT.0) GO TO 600
      GO TO 400

 600  CONTINUE
      CLOSE(IN)
 
      ENDDO

      END FILE(IOUT)
      CLOSE(IOUT)
      RETURN 
C ----------------
 200  CONTINUE
      LINE = ' ERROR: CP_SEQ cannot open input file'
      CALL MSGERR(MDOC,LINE)
      RETURN
 210  CONTINUE
      LINE = ' ERROR: CP_SEQ cannot output open file'
      CALL MSGERR(MDOC,LINE)
      RETURN
 500  CONTINUE
      LINE = ' ERROR: CP_SEQ reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      LINE = ' ERROR: CP_SEQ write output file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IN)
      CLOSE(IOUT)
      IERR = 1
      RETURN
      END

      SUBROUTINE WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *  ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
C -------------------------------------------------------- 
      CHARACTER NAM1*4,NAM2*4,LINE*50,LINE1*50,LINE2*50,LINE3*50
      CHARACTER DLINE*80,LINE_SS1*50,LINE_SS2*50
      CHARACTER LINE_SURF1*50,LINE_SURF2*50
      CHARACTER LINE_1N1*50,LINE_1N2*50,LINE_1N3*50,LINE_1N4*50
      CHARACTER LINE_2N1*50,LINE_2N2*50,LINE_2N3*50,LINE_2N4*50
      CHARACTER LS1*50,LS2*50,LS3*50,LS4*50,LS5*50
C =========================================================
      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL LENSTR_BL(DLINE,LEN)
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_1N4
      CALL MSGDOC(MDOC,DLINE)

C      chain
C      WRITE(DLINE,2) LINE1
C      CALL MSGDOC(MDOC,DLINE)

      WRITE(DLINE,3) LINE_SS1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,4) LINE_SURF1
      CALL MSGDOC(MDOC,DLINE)
      CALL MSGDOC(MDOC,' ')
      WRITE(DLINE,1) NAM1,LINE
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,1) NAM2,LINE2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,3) LINE_SS2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,4) LINE_SURF2
      CALL MSGDOC(MDOC,DLINE)
    1 FORMAT(1X,A4,':',A)
    2 FORMAT(6X,A)
    3 FORMAT('ss',4X,A)
    4 FORMAT('surf',2X,A)

      WRITE(DLINE,2) LINE_2N1
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N3
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LINE_2N4
      CALL MSGDOC(MDOC,DLINE)

c --
      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS5
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS4
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,44) LS3
   44 FORMAT('score',1X,A)
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS2
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,2) LS1
      CALL MSGDOC(MDOC,DLINE)
C --

      WRITE(DLINE,'(1X,55A)') ('-',I=1,54)
      CALL MSGDOC(MDOC,DLINE)
      LINE     = ' '
      LINE1    = ' '
      LINE2    = ' '
      LINE3    = ' '
      LINE_1N1 = ' '
      LINE_1N2 = ' '
      LINE_1N3 = ' '
      LINE_1N4 = ' '
      LINE_2N1 = ' '
      LINE_2N2 = ' '
      LINE_2N3 = ' '
      LINE_2N4 = ' '
      LINE_SS1 = ' '
      LINE_SS2 = ' '
      LINE_SURF1 = ' '
      LINE_SURF2 = ' '
      LS1=      ' '
      LS2=      ' '
      LS3=      ' '
      LS4=      ' '
      LS5=      ' '
      CALL MSGDOC(MDOC,' ')
      RETURN

      END

      SUBROUTINE ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
C -------------------------------------------------------------
C ---
      CHARACTER ACODE3(25)*3
      CHARACTER CH1*1
      CHARACTER CH3*3
      CHARACTER ANAME*4,RNAME*3,LINE*80
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
C -------------------------------------------------------------
      IERR  = 0
      RNAME = ACODE3(ISEQ1_C)
      ANAME = ' CA '
      OCC   = 0.0
      BISO  = 20.0
      X     = 0.0
      Y     = 0.0
      Z     = 0.0

C12345612345 1234 1231234567123123456781234567812345678123456123456
CATOM   1492  CA  ALA A 202      -4.193  81.551  25.660  1.00 35.67169.60
C           FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
      WRITE(LINE,
     *  '(A6,I5,1X,A4,1X,A3,1X,A1,I4,4X,3F8.3,2F6.2)',ERR=500) 
     *  'ATOM  ',NAT,ANAME,RNAME,CH1,IRES_C,X,Y,Z,OCC,BISO

      IF(CH1.EQ.' '.OR.CH1.EQ.'_') THEN
        LINE(73:76) = '--- '
      ELSE
        LINE(73:76) = CH1//CH1//'. '
      ENDIF

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

c      write(*,*) '>>wrt:',line(1:20)

      RETURN
 500  IERR = 1
      RETURN
      END

      SUBROUTINE CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)
C -----------------------------------------------------
      CHARACTER ANAME*4,ASYMB*4,RNAME*3
C -----------------------------------------------------
      IF(ANAME.EQ.'CA  '.AND.ASYMB.NE.'C   ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(ASYMB.EQ.'SE  ') ASYMB = 'S   '

      IF(ASYMB.NE.'C   '.AND.ASYMB.NE.'N   '.AND.
     *   ASYMB.NE.'O   '.AND.ASYMB.NE.'S   ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(ANAME.EQ.'N   '.OR.ANAME.EQ.'C   '.OR.ANAME.EQ.'O   '.OR.
     *   ANAME.EQ.'CA  '.OR.ANAME.EQ.'CB  '.OR.ANAME.EQ.'OXT ')THEN
        IF(RNAME.EQ.'GLY'.AND.ANAME.EQ.'CB  ') IWRT = 0 
        RETURN
      ENDIF

      IF(RNAME.EQ.'UNK') THEN 
        IWRT = 0 
        RETURN
      ENDIF       

      IF(RNAME.EQ.'CYS'.AND.ANAME.EQ.'SE  ') ANAME = 'SG  '
      IF(RNAME.EQ.'MET'.AND.ANAME.EQ.'SE  ') ANAME = 'SD  '
      IF(RNAME.EQ.'MET'.AND.ANAME.EQ.'S   ') ANAME = 'SD  '

      IF(RNAME.EQ.'ALA') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ARG'.AND.ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'CG  '.AND.ANAME.NE.'NE  '.AND.
     *  ANAME.NE.'NH2 '.AND.
     *  ANAME.NE.'CZ  '.AND.ANAME.NE.'NH1 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ASN'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'OD1 '.AND.ANAME.NE.'ND2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ASP'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'OD1 '.AND.ANAME.NE.'OD2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'CYS'.AND.ANAME.NE.'SG  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLN'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'OE1 '.AND.ANAME.NE.'NE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLU'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.
     *  ANAME.NE.'OE1 '.AND.ANAME.NE.'OE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'GLY') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'HIS'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'ND1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'NE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'ILE'.AND.ANAME.NE.'CG1 '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'LEU'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'LYS'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD  '.AND.ANAME.NE.'CE  '.AND.
     *  ANAME.NE.'NZ  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'MET'.AND.ANAME.NE.'SD  '.AND.
     *  ANAME.NE.'CG  '.AND.ANAME.NE.'CE  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'PHE'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CZ  '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'CE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'PRO'.AND.ANAME.NE.'CG  '.AND.
     *                      ANAME.NE.'CD  '     ) THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'SER'.AND.ANAME.NE.'OG  ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'THR'.AND.ANAME.NE.'OG1 '.AND.
     *  ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'TRP'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'NE1 '.AND.ANAME.NE.'CE2 '.AND.
     *  ANAME.NE.'CH2 '.AND.ANAME.NE.'CZ2 '.AND.
     *  ANAME.NE.'CE3 '.AND.ANAME.NE.'CZ3 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'TYR'.AND.ANAME.NE.'CG  '.AND.
     *  ANAME.NE.'CD1 '.AND.ANAME.NE.'CD2 '.AND.
     *  ANAME.NE.'CZ  '.AND.ANAME.NE.'OH  '.AND.
     *  ANAME.NE.'CE1 '.AND.ANAME.NE.'CE2 ') THEN
        IWRT = 0
        RETURN
      ENDIF

      IF(RNAME.EQ.'VAL'.AND.ANAME.NE.'CG1 '.AND.
     *  ANAME.NE.'CG2 ') THEN
        IWRT = 0
        RETURN
      ENDIF
C ----
      RETURN
      END

      SUBROUTINE CHAINGE_ATOME_ALIGN2(ANAME,IR1,IR2
     *  ,RNAME1,IWRT,ATOM_INDEX,ATOM_NAME)     
C -----------------------------------------------------
C -----
C     N CA CB CG CD CE CZ C O
      CHARACTER ATOM_NAME(9)*2
C                      g d e z
      INTEGER   ATOM_INDEX(4,25)
C ---
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER CH3*3,RNAME1_OLD*3
      CHARACTER ANAME*4,RNAME1*3,RNAME2*3,ATOM1*4
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
C---------------------------------------------------------------
      RNAME1_OLD = RNAME1
C-------
      IWRT = 0
      RNAME1 = ACODE3(IR1)
      RNAME2 = ACODE3(IR2)
      IF(IR1.EQ.IR2) THEN
        IF(RNAME1.EQ.'CYS'.AND.ANAME.EQ.'SE  ') ANAME = 'SG  '
        IF(RNAME1.EQ.'MET'.AND.ANAME.EQ.'SE  ') ANAME = 'SD  '
        IF(RNAME1.EQ.'MET'.AND.ANAME.EQ.'S   ') ANAME = 'SD  '
        IWRT = 1
        IF(RNAME1.EQ.'CYS'.AND.ANAME.EQ.'SD  ') IWRT = 0
        RETURN
      ELSE IF(ANAME.EQ.'N   '.OR.ANAME.EQ.'N   '.OR.ANAME.EQ.'O   '
     *    .OR.ANAME.EQ.'CA  '.OR.ANAME.EQ.'C   '.OR.ANAME.EQ.'OXT '
     *                         ) THEN
        IWRT = 1
        RETURN
      ENDIF

      IF(IR1.NE.IR2) THEN
        IF(RNAME1_OLD.EQ.'MET'.AND.ANAME.EQ.'CE  ') THEN
          IWRT = 0
          RETURN
        ENDIF
      ENDIF

      IF(RNAME1.EQ.'GLY'.OR.RNAME2.EQ.'GLY') RETURN
      IF(ANAME.EQ.'CB  ') THEN
C     -- CB --
        IWRT = 1
        RETURN
      ENDIF

      IA = 0
      IF(ANAME(2:2).EQ.'G') IA=1
      IF(ANAME(2:2).EQ.'D') IA=2
      IF(ANAME(2:2).EQ.'E') IA=3
      IF(ANAME(2:2).EQ.'Z') IA=4
C                      g d e z
C     INTEGER   ATOM_INDEX(4,25)

      IND1 = ATOM_INDEX(1,IR1)
      IND2 = ATOM_INDEX(2,IR1)
      JND1 = ATOM_INDEX(1,IR2)
      JND2 = ATOM_INDEX(2,IR2)

      IF(IND1.GT.0.AND.JND1.GT.0) THEN
        IF(IA.EQ.1) THEN
          ATOM1 = 'CG  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

          IF(IR1 .EQ.1) ATOM1 = 'SG  '
          IF(IR1 .EQ.2) ATOM1 = 'OG  '
          IF(IR1 .EQ.3) ATOM1 = 'OG  '
          IF(IND1.EQ.2) ATOM1(3:3) = '1'
          IF(IND1.EQ.2.AND.ANAME(3:3).EQ.'2') ATOM1 = 'CG2 '
          IWRT = 1
          IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
          ANAME = ATOM1
          RETURN
        ELSE IF(IA.EQ.2.AND.IND2.GT.0) THEN
C       -- CD --
          ATOM1 = 'CD  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

          IF(IR1 .EQ. 7) ATOM1 = 'OD  '
          IF(IR1 .EQ. 8) ATOM1 = 'OD  '
          IF(IR1 .EQ.14) ATOM1 = 'SD  '
          IF(IR1 .EQ.11) ATOM1 = 'ND  '
          IF(IR1 .EQ.15) ATOM1 = 'CD1 '
          IF(IR1 .EQ.16) ATOM1 = 'CD1 '
          IF(IND2.EQ.2) ATOM1(3:3) = '1'
C         -- CD2 --
          IF(IND2.EQ.2.AND.ANAME(3:3).EQ.'2') THEN
            ATOM1 = 'CD2 '
            IF(IR1 .EQ.7) ATOM1 = 'ND2 '
            IF(IR1 .EQ.8) ATOM1 = 'OD2 '
          ENDIF
          IWRT = 1
          IF(IND2.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
          IF(IR1 .EQ. 4) IWRT = 0
          IF(IR2.EQ.14) THEN
            IF(ANAME(1:3).NE.'CG '.AND.ANAME(1:3).NE.'SD '.AND.
     *         ANAME(1:3).NE.'CE ') IWRT = 0
          ENDIF
          ANAME = ATOM1
          RETURN
        ELSE IF(IA.EQ.3) THEN           
          IND1 = ATOM_INDEX(3,IR1)
          JND1 = ATOM_INDEX(3,IR2)
C         -- CE --
          IF(IND1.GT.0.AND.JND1.GT.0) THEN
            IF((IR1.EQ.IR2)             .OR.
     *        (IR1.EQ. 9.AND.IR2.EQ.10).OR.
     *        (IR1.EQ.10.AND.IR2.EQ. 9).OR.
     *        (IR1.EQ.20.AND.IR2.EQ.11).OR.
     *        (IR1.EQ.11.AND.IR2.EQ.20).OR.
     *        (IR1.EQ.12.AND.IR2.EQ.13).OR.
     *        (IR1.EQ.13.AND.IR2.EQ.12).OR.
     *        (IR1.EQ.18.AND.IR2.EQ.19).OR.
     *        (IR1.EQ.19.AND.IR2.EQ.18)    )THEN
              ATOM1 = 'CE  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

              IF(IR1 .EQ. 9) ATOM1 = 'OE  '
              IF(IR1 .EQ.10) ATOM1 = 'OE  '
              IF(IR1 .EQ.12) ATOM1 = 'NE  '
              IF(IR1 .EQ.20) ATOM1 = 'NE  '
              IF(IND1.EQ.2) ATOM1(3:3) = '1'
              IF(IND1.EQ.2.AND.ANAME(3:3).EQ.'2') THEN
                ATOM1 = 'CE2 '
                IF(IR1 .EQ.10) ATOM1 = 'NE2 '
                IF(IR1 .EQ.11) ATOM1 = 'NE2 '
                IF(IR1 .EQ. 9) ATOM1 = 'OE2 '
              ENDIF
              IWRT = 1
              IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
              IF(ANAME(3:3).EQ.'3') IWRT = 0
              ANAME = ATOM1
              RETURN
            ENDIF
          ENDIF
        ELSE IF(IA.EQ.4) THEN           
          IND1 = ATOM_INDEX(4,IR1)
          JND1 = ATOM_INDEX(4,IR2)
C     -- CZ --
          IF(IND1.GT.0.AND.JND1.GT.0) THEN
            IF((IR1.EQ.IR2)             .OR.
     *        (IR1.EQ.12.AND.IR2.EQ.13).OR.
     *        (IR1.EQ.13.AND.IR2.EQ.12).OR.
     *        (IR1.EQ.18.AND.IR2.EQ.19).OR.
     *        (IR1.EQ.19.AND.IR2.EQ.18)    )THEN
              ATOM1 = 'CZ  '
C                 1   2   3   4   5   6   7   8   9   10  11  12  13
C      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
C     *         ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C                 14  15  16  17  18  19  20

              IF(IR1 .EQ.13) ATOM1 = 'NZ  '
              IF(IND1.EQ.2) ATOM1(3:3) = '1'
              IWRT  = 1
              IF(IND1.EQ.1.AND.ANAME(3:3).EQ.'2') IWRT = 0
              ANAME = ATOM1
              RETURN
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C ---------------------------
      RETURN
      END

      SUBROUTINE TRANS(MDOC,NAME1,NAME2,SH1,SH2
     *    ,MOD_IN,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
C --------------------------------------
C -P- 
C TRANS    ortogonal transformation of atomic coordinates.
C            X"-new = [R] * ( X-old + sh1 ) + sh2 
C              [R]      - rotation matrix
C              sh1, sh2 - vectors of shift  
C          Gives also information about position of molecule and radius
C          of inertia.
C -S-
C           Rotation corresponds to solution RFRES and RFROT-program
C           i.e.:   RFRES: (a,b,g) peak for file_1: model1 
C                                           file_2: model2
C             TRANS: model2 --> model1: angle: a,b,g
C             RFROT: model2 --> model1: angle: a,b,g 
C
C   Dialogue and Batch:
C  
C    FILE_IN:       - name input_file  / without extention "crd"/
C    FILE_O: <" ">  - name output_file / without extention "crd"/
C            Translation:
C    SMODE:  <O>/F  -  O - shifts in orthogonal system
C                      F - shifts in fractional
C    SH1:   <0,0,0> -  vector of shift /before rotation/
C    SH2:   <0,0,0> -  vector of shift /after rotation/
C            Rotation:
C    MODE:  <E>/P/R -  E - for input Eiler angles
C                      P - for input polar angles
C                      R - for input rotation matrix
C    ANGLE: <0,0,0> -  angles of rotation
C            [R]    -  rotation matrix
C    R1:    <1,0,0> -  R(1,1),R(2,1),R(3,1)
C    R2:    <0,1,0> -  R(1,2),R(2,2),R(3,2)
C    R3:    <0,0,1> -  R(1,3),R(2,3),R(3,3)
C
C  Parameters of subroutine TRANS: 
C
C      SUBROUTINE TRANS(MDOC,NAME1,NAME2,SH1,SH2
C     *     ,MOD,AM,ALPHA,BETA,GAMMA,RESULT,ISYM,IPRSYM,IERR)
C
C    MDOC  - mode of writing messages to DOC-file
C            0 - only terminal , < - 0 only file, 0 < < 99 - both
C            >= 99 - don't write  
C    NAME1             - input file name, without extention.
C    NAME2             - output file name, without extention.
C    IERR /input/      - if IERR = abs(999) shifts in frational
C    SH1 /real(3)/     -  vector of shift /before rotation/
C    SH2 /real(3)/     -  vector of shift /after rotation/
C    MOD /character*1/   <E>/P/R -  E - for Eiler angles
C                                   P - for polar angles
C                                   R - for rotation matrix 
C    AM  /real(3,3)/   - rotation matrix
C    ALPHA,BETA,GAMMA  - angles of rotation
C    ISYM              - integer*2 array for cryst.symmetry operators 
C    IPRSYM            - dimension of integer*2 array ISYM(5,3,IPRSYM)
C                        You need not to define contents of arrays ISYM
C                        Here is only reservation of memory.
C    IERR              - output signal of error / =1 -error , =o - OK / 
C
C    real RESULT(11) - array for output information:
C
C      RESULT(1) = NTOT
C      RESULT(2) = XMIN
C      RESULT(3) = XMAX
C      RESULT(4) = YMIN
C      RESULT(5) = YMAX
C      RESULT(6) = ZMIN
C      RESULT(7) = ZMAX
C      RESULT(8) = XS
C      RESULT(9) = YS
C      RESULT(10)= ZS
C      RESULT(11)= RI
C      RESULT(12)= MODEL
C      RESULT(13)= NMODEL
C
C        NTOT       - number of atoms
C        XMIN,XMAX  - MIN and MAX value of X,Y,Z
C        YMIN,YMAX
C        ZMIN,ZMAX
C        XS,YS,ZS   - center of atoms: XS = Sum(X)/N
C        RI         - Radius of inertia
C -I-
C --------------------------------------
      INTEGER   MDOC,IERR
      REAL      RESULT(*)
      CHARACTER NAME1*(*),NAME2*(*),MOD_IN*(*),SMOD*1,MOD*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL             AM(3,3),SH1(3),SH2(3)
      REAL             ALPHA,BETA,GAMMA
C ---
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL        FRTOCR(3,3),CRTOFR(3,3)
C ----
      INTEGER   MODE,NSYM
      REAL      X(3),Y(3),Z(3),TRNCS(3),U(3),V(3)
      REAL      AMNCS(3,3),AMAT(3,3),TMAT(3,3),AMNEW(3,3)
      REAL      SH1F(3),SH2F(3),RLATT(6),UA(6),UR(6)
      CHARACTER LINE*80
C=====================================================================
      MODEL = ABS(IERR)
      SMOD  = 'C'
      MOD   = MOD_IN(1:1)
      CALL LENSTR_BL(MOD_IN,LEN)
      IF(LEN.GT.1.AND.(MOD_IN(2:2).EQ.'f'.OR.MOD_IN(2:2).EQ.'F')) THEN
        SMOD = 'F'
      ENDIF
      ISURF = 0
      IF(LEN.GT.2.AND.MOD_IN(3:3).EQ.'S') THEN
        ISURF = 1
      ENDIF
      IFLAG = 0
C     IF(IERR.LT.0) IFLAG=1
C ---
      IERR = 0
      PI   = 4.0*ATAN(1.0)
C ---
      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.
      XMAX =-1.E 30
      YMAX =-1.E 30
      ZMAX =-1.E 30
      XMIN = 1.E 30
      YMIN = 1.E 30
      ZMIN = 1.E 30
      NMODEL = 0
      NANISO = 0
      NINSIDE= 0
C -----------------------------------------------------------------
      MD =-ABS(MDOC)-1
      M  = 99
      IN = 10
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN INPUT_FILE')
        CLOSE(IN) 
        RETURN
      ENDIF
      CALL C_AT_CR
      ACELL = CR_CELL(1)
      BCELL = CR_CELL(2)
      CCELL = CR_CELL(3)
      AANGL = CR_CELL(4)
      BANGL = CR_CELL(5)
      GANGL = CR_CELL(6)
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
      RLATT(1) = ACELL
      RLATT(2) = BCELL
      RLATT(3) = CCELL
      RLATT(4) = AANGL
      RLATT(5) = BANGL
      RLATT(6) = GANGL
      CALL DSTARF(RLATT,AST,BST,CST,COALST,COBEST,COGAST,VOL)
C -------------------------------------------
      IF(MOD.EQ.'r') MOD='R'
      IF(MOD.EQ.'p') MOD='P'
      IF(MOD.NE.'P'.AND.MOD.NE.'R') MOD='E'

      IF(MOD.EQ.'R') THEN

      ELSE IF(MOD.EQ.'P') THEN
        RALD = ALPHA*PI/180.
        RBED = BETA *PI/180.
        RGAD = GAMMA*PI/180.
        CALL POLTOM(RALD,RBED,RGAD,AM)
      ELSE
        ALPHA = ALPHA*PI/180.
        BETA  = BETA *PI/180.
        GAMMA = GAMMA*PI/180.
        CALL EULERM(ALPHA,BETA,GAMMA,AM)
      ENDIF

      IF(SMOD.EQ.'F') THEN
        CALL VCOPY(SH1,SH1F)
        CALL VCOPY(SH2,SH2F)
        CALL FTOO(SH1F,SH1,IERR)
        CALL FTOO(SH2F,SH2,IERR)
      ELSE
        CALL OTOF(SH1,SH1F,IERR)
        CALL OTOF(SH2,SH2F,IERR)
      ENDIF



      WRITE(LINE,'('' SHIFT-1:'',3F8.3)') SH1(1),SH1(2),SH1(3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  /frac/:'',3F8.3)') SH1F(1),SH1F(2),SH1F(3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' SHIFT-2:'',3F8.3)') SH2(1),SH2(2),SH2(3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  /frac/:'',3F8.3)') SH2F(1),SH2F(2),SH2F(3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' MATRIX : '',3F12.4)') (AM(L,1),L=1,3)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''          '',3F12.4)') (AM(L,2),L=1,3)
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,'(''          '',3F12.4)') (AM(L,3),L=1,3)
      CALL MSGDOC(MD,LINE)
      CALL MTOANG(AM,ALPHA,BETA,GAMMA)
      WRITE(LINE,100) ALPHA,BETA,GAMMA
  100 FORMAT('EILER ANGLES : ALPHA BETA GAMMA :',3F10.5)
      CALL MSGDOC(MDOC,LINE)
      CALL MTOPOL(AM,THETA,PHI,CHI)
      WRITE(LINE,102) THETA,PHI,CHI
  102 FORMAT('SPHERICAL POLARS : THETA PHI CHI    :',3F10.5)
      CALL MSGDOC(MDOC,LINE)
C -------------------------------------------
      IF(IFLAG.EQ.1) GO TO 400
      NCSOP=0
      CALL GET_NCS(MDOC,NCMAX,NCSOP,AMNCS,TRNCS,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC
     * ,' WARNING: subroutine TRANS : wrong NCS description.')
        CALL MSGERR(MDOC,'          NCS description will be ignored.')
        IERR=0
      ENDIF      
      IF(NCSOP.GT.0) THEN
          DO I=1,NCSOP

            CALL GET_NCS(MDOC,NCMAX,I,AMNCS,TRNCS,IERR)
            IF(IERR.NE.0) RETURN      
C                                -1
C     [Mncs]_new = [M]*[Mncs]*[M]    
C
C     Tncs_new=-[Mncs]_new*T2-[M]*[Mncs]*T1+[M]*T1+[M]*Tncs+T2 
C
            CALL MTRANS(AM,TMAT)
            CALL MATMLT(AM,AMNCS,AMAT)
            CALL MATMLT(AMAT,TMAT,AMNEW)

            CALL MVMULT(AMNEW,SH2  ,X)
            CALL MVMULT(AMAT ,SH1  ,Y)
            CALL MVMULT(AM   ,SH1  ,Z)
            CALL MVMULT(AM   ,TRNCS,U)
            CALL VADD(SH2,U,V)
            CALL VADD(X,Y,U)
            CALL VSUB(V,U,X)
            CALL VADD(X,Z,V)
        
            CALL SET_NCS(MDOC,NCMAX,I,AMNEW,V,IERR)
            IF(IERR.NE.0) RETURN      

          ENDDO

      ENDIF
 400  CONTINUE
C -------------------------------------------------
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.' '.AND.NAME2(1:1).NE.',') THEN
        IOUT=11
        CALL OWCRD(MD,IOUT,NAME2,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUTPUT_FILE')
          CLOSE(IN) 
          CLOSE(IOUT) 
          RETURN
        ENDIF
      ELSE
        IOUT=0
      ENDIF
C -----------------------------------------------------------
      NA    = 0
      NTOT  = 0
      IEND  =-1
      IENDW =-1
C ----------------------
 200  CONTINUE
        CALL RDCRD(M,IN,MODE,IEND,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
          CLOSE(IN)
          CLOSE(IOUT)
          RETURN
        ENDIF
        IF(IEND.NE.0) GO TO 300
        IF(MODE.EQ.0) THEN
          IF(MODEL.GT.0.AND.CR_MODEL.NE.MODEL) GO TO 200
          X(1) = CR_XYZ(1) + SH1(1)
          X(2) = CR_XYZ(2) + SH1(2)
          X(3) = CR_XYZ(3) + SH1(3)
          NA   = NA + 1
          CALL MVMULT(AM,X,Y)
          X(1) = Y(1) + SH2(1)
          X(2) = Y(2) + SH2(2)
          X(3) = Y(3) + SH2(3)

          IF(CR_BTYPE.EQ.'A') THEN
            UA(1)=CR_ANIS(1)
            UA(2)=CR_ANIS(2)
            UA(3)=CR_ANIS(3)
            UA(4)=CR_ANIS(4)
            UA(5)=CR_ANIS(5)
            UA(6)=CR_ANIS(6)

            CALL MDET2(UA,DET)
     
            IF(DET.LT.0.0000001) THEN

              WRITE(LINE,*) 
     *        ' WARNING: TRANS: Determinant(U) =< 0 :',DET
              CALL MSGERR(MDOC,LINE)
              WRITE(LINE,*) 
     *        '          for atom: ',CR_ANAME,', res:'
     *        ,CR_IRES,', CHAIN:',CR_IGROUP
              CALL MSGERR(MDOC,LINE)
              WRITE(LINE,'(''          U:'',6F9.5)')
     *         CR_ANIS(1),CR_ANIS(2),CR_ANIS(3)
     *        ,CR_ANIS(4),CR_ANIS(5),CR_ANIS(6)
              CALL MSGERR(MDOC,LINE)

              CR_BTYPE='I'

            ELSE

            NANISO=NANISO+1

            CALL UO_TO_B(UA,UA)
            CALL B_SYM(UA,UR,AM)
            CALL B_TO_UO(UR,CR_ANIS)

            ENDIF

          ENDIF 



          IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *        CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *        CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *        CR_OCC .GT.0.0001                        ) THEN

            IF(X(1).GT.XMAX) XMAX=X(1)
            IF(X(2).GT.YMAX) YMAX=X(2)
            IF(X(3).GT.ZMAX) ZMAX=X(3)
            IF(X(1).LT.XMIN) XMIN=X(1)
            IF(X(2).LT.YMIN) YMIN=X(2)
            IF(X(3).LT.ZMIN) ZMIN=X(3)
            XS   = XS+X(1)
            YS   = YS+X(2)
            ZS   = ZS+X(3)
            XS2  = XS2+X(1)*X(1)
            YS2  = YS2+X(2)*X(2)
            ZS2  = ZS2+X(3)*X(3)
            NTOT = NTOT+1

            IF(CR_SURF.LE.15.001) NINSIDE = NINSIDE + 1

          ENDIF

          CR_XYZ(1) = X(1)
          CR_XYZ(2) = X(2)
          CR_XYZ(3) = X(3)
      
          IF(ISURF.EQ.1) CR_BISO = CR_SURF

          IF(IOUT.GT.0) THEN
            CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC,' ERR: WRITE OUTPUT_FILE')
              CLOSE(IN) 
              CLOSE(IOUT) 
              RETURN
            ENDIF
          ENDIF

        ELSE

          IF(MODEL.GT.0.AND.CR_MODEL.NE.MODEL) GO TO 200
          IF(IOUT.GT.0) THEN
            CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC,' ERR: WRITE OUTPUT_FILE')
              CLOSE(IN) 
              CLOSE(IOUT) 
              RETURN
            ENDIF
          ENDIF

        ENDIF

      GO TO 200
C ---------------------------------------------------------
  300 CONTINUE
      CLOSE(IN)
      WRITE(LINE,'('' NUMBER OF COORDS :'',I6)') NA
      CALL MSGDOC(MDOC,LINE)
      IF(NANISO.GT.0) THEN
        WRITE(LINE,'('' Naniso           :'',I6)') NANISO
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      NMODEL = CR_MODEL
      IF(IOUT.GT.0) THEN
        IENDW=1
        MODE=0     
        CALL WRCRD(MDOC,IOUT,MODE,IENDW,IERR)
      ENDIF
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: TRANS: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF
      IF(NTOT.GT.0) THEN
        XS  = XS/NTOT
        YS  = YS/NTOT
        ZS  = ZS/NTOT
        XS2 = XS2/NTOT
        YS2 = YS2/NTOT
        ZS2 = ZS2/NTOT
        WRITE(LINE,'('' X :'',2F10.3)') XMIN,XMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Y :'',2F10.3)') YMIN,YMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Z :'',2F10.3)') ZMIN,ZMAX
        CALL MSGDOC(MDOC,LINE)
        RAD = (XMAX-XMIN)
        RT  = (YMAX-YMIN)
        IF(RAD.LT.RT) RAD=RT
        RT  = (ZMAX-ZMIN)
        IF(RAD.LT.RT) RAD=RT
        WRITE(LINE,'('' SIZE_max         :'',F10.3)') RAD
        CALL MSGDOC(MDOC,LINE)
C --
        WRITE(LINE,'('' Centre of coords :'',3F10.3)') XS,YS,ZS
        CALL MSGDOC(MDOC,LINE)
C --
        X(1) = XS
        X(2) = YS
        X(3) = ZS
        CALL OTOF(X,Y,IERR)
        WRITE(LINE,'('' Centre of coords /fract/ :'',3F10.3)') 
     *  Y(1),Y(2),Y(3)
        CALL MSGDOC(MDOC,LINE)
C -------       
        RX = XS2-XS*XS
        RY = YS2-YS*YS
        RZ = ZS2-ZS*ZS
        RI = SQRT(ABS(RX+RY+RZ))
        WRITE(LINE,'('' Radius of inertia :'',F10.3)') RI
        CALL MSGDOC(MDOC,LINE)
C ---
      ENDIF

      RESULT(1) = NTOT
      RESULT(2) = XMIN
      RESULT(3) = XMAX
      RESULT(4) = YMIN
      RESULT(5) = YMAX
      RESULT(6) = ZMIN
      RESULT(7) = ZMAX
      RESULT(8) = XS
      RESULT(9) = YS
      RESULT(10)= ZS
      RESULT(11)= RI
      RESULT(12)= MODEL
      RESULT(13)= NMODEL
      RESULT(14)= NINSIDE

      WRITE(LINE,'('' Model, Number of models :'',2I5)') MODEL,NMODEL
      CALL MSGDOC(MDOC,LINE)

C -------------------------------------------
      RETURN
      END

      SUBROUTINE UO_TO_B(UO_ANIS,B_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL FRTOCRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=UO_ANIS(1)
      A(2,2)=UO_ANIS(2)
      A(3,3)=UO_ANIS(3)
      A(1,2)=UO_ANIS(4)
      A(1,3)=UO_ANIS(5)
      A(2,3)=UO_ANIS(6)
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
      CALL  MTRANS(FRTOCR,FRTOCRT)

      CALL  MATMLT(A,FRTOCR,S)
      CALL  MATMLT(FRTOCRT,S,R)
C ---
C     U* = G* U G*
C     B  = 2PI^2 U*    
C --
      CALL MATMLT(R,GS,S)
      CALL MATMLT(GS,S,R)


C -----
      B_ANIS(1)=R(1,1)*CONST
      B_ANIS(2)=R(2,2)*CONST
      B_ANIS(3)=R(3,3)*CONST
      B_ANIS(4)=R(1,2)*CONST
      B_ANIS(5)=R(1,3)*CONST
      B_ANIS(6)=R(2,3)*CONST
C ---
      RETURN
      END

      SUBROUTINE B_TO_UO(B_ANIS,UO_ANIS)
C --------------------------------------------
      COMMON/COM_MAT/  ACELL,BCELL,CCELL,AANGL,BANGL,GANGL
     *                ,AST,BST,CST,COALST,COBEST,COGAST
     *                ,FRTOCR,CRTOFR
      REAL FRTOCR(3,3),CRTOFR(3,3)
C ----------------------------
      REAL UO_ANIS(6),B_ANIS(6)
      REAL A(3,3),R(3,3),S(3,3),G(3,3),GS(3,3)
      REAL CRTOFRT(3,3)
C --------------------------------------------
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      CONST=TWOPI*PI
C -----------------------------------
      G(1,1)=ACELL*ACELL
      G(2,2)=BCELL*BCELL
      G(3,3)=CCELL*CCELL
      G(1,2)=ACELL*BCELL*COS(GANGL)
      G(2,1)=G(1,2)
      G(1,3)=ACELL*CCELL*COS(BANGL)
      G(3,1)=G(1,3)
      G(2,3)=BCELL*CCELL*COS(AANGL)
      G(3,2)=G(2,3)
C ---
      GS(1,1)=AST*AST
      GS(2,2)=BST*BST
      GS(3,3)=CST*CST
      GS(1,2)=AST*BST*COGAST
      GS(2,1)=GS(1,2)
      GS(1,3)=AST*CST*COBEST
      GS(3,1)=GS(1,3)
      GS(2,3)=BST*CST*COALST
      GS(3,2)=GS(2,3)
C ---
      A(1,1)=B_ANIS(1)/CONST
      A(2,2)=B_ANIS(2)/CONST
      A(3,3)=B_ANIS(3)/CONST
      A(1,2)=B_ANIS(4)/CONST
      A(1,3)=B_ANIS(5)/CONST
      A(2,3)=B_ANIS(6)/CONST
      A(2,1)=A(1,2)
      A(3,1)=A(1,3)
      A(3,2)=A(2,3)

C ---
C     U* = B/2PI^2    
C     U  = G  U* G
C --
      CALL MATMLT(A,G,S)
      CALL MATMLT(G,S,R)

      CALL  MTRANS(CRTOFR,CRTOFRT)

      CALL  MATMLT(R,CRTOFR,S)
      CALL  MATMLT(CRTOFRT,S,R)
C ---
      UO_ANIS(1)=R(1,1)
      UO_ANIS(2)=R(2,2)
      UO_ANIS(3)=R(3,3)
      UO_ANIS(4)=R(1,2)
      UO_ANIS(5)=R(1,3)
      UO_ANIS(6)=R(2,3)
C ---
      RETURN
      END
      SUBROUTINE B_SYM(B,BR,ROT)
      REAL B(6),BR(6),ROT(3,3)
      REAL S(3,3),R(3,3),RT(3,3)
C ---------------------
      S(1,1)=B(1)
      S(2,2)=B(2)
      S(3,3)=B(3)
      S(1,2)=B(4)
      S(1,3)=B(5)
      S(2,3)=B(6)
      S(2,1)=S(1,2)
      S(3,1)=S(1,3)
      S(3,2)=S(2,3)
C -----------------
      CALL  MTRANS(ROT,RT)

      CALL  MATMLT(S,RT,R)
      CALL  MATMLT(ROT,R,S)
C -----------------------------------------
      BR(1)=S(1,1)
      BR(2)=S(2,2)
      BR(3)=S(3,3)
      BR(4)=S(1,2)
      BR(5)=S(1,3)
      BR(6)=S(2,3)
C ------------------
      RETURN
      END

      SUBROUTINE MDET2(A,DET)
C ------------------------------
      REAL A(6)
C ------------------------------
      DET  =  A(1)*(A(2)*A(3) - A(6)*A(6))
     *      - A(4)*(A(4)*A(3) - A(6)*A(5))
     *      + A(5)*(A(4)*A(6) - A(2)*A(5))
C ---
      RETURN
      END
C -I-
      SUBROUTINE WRITEPDB(MDOC,NAME1,NAME2,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
C -P- writePDB - converts cooordinate's file from "BLANC"-system to "PDB"; 
C -S-
C
C  Dialog and Batch: 
C
C    FILE_IN  - input file of coordinates.
C    FILE_OUT - output file.
C      
C    IF(ABS(IERR).NE.0.AND.IERR.GT.-1000) set  B_OVER = ABS(IERR)
C    IF(IERR.LE.0) keep surf info
C
C  Parameters of subroutine WRITEPDB: 
C
C      SUBROUTINE WRITEPDB(MDOC,NAME1,NAME2,ISYM,IPRSYM,IERR)
C
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    NAME1  - name of input file without extention.
C    NAME2  - name of output file without extention.
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C -I-
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAME1*(*),NAME2*(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
      INTEGER     MODE,IANIS(6)
      REAL        FRTOCR(3,3),CRTOFR(3,3),XA(3),B_OVER
      CHARACTER   ATOM*4,RES*3,ALT*1,CHAIN*2,SEG*4,CSURF*6
      CHARACTER   EXT*3,PATH*1,LINE*80,STR*80,ASYMB*4
      CHARACTER   NCSF*1,GID*4,NAME*256
C --------------------------------------------------------------
      B_OVER = 0.0
      ISURF  = 0
      IF(IERR.NE.0.AND.IERR.GT.-1000) B_OVER = ABS(FLOAT(IERR))
      IF(IERR.LT.0) ISURF = 1
      IERR   = 0
C-----
      IN  = 10
      IOUT=  0
      MD  = 99
      PATH=' '
C --------
      CALL ORCRD(MD,IN,NAME1,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN IN_FILE')
        CLOSE(IN)
        RETURN
      ENDIF
C ---
      IGR=0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
C ---
      CALL LENSTR_BL(NAME2,LEN)
      IF(LEN.GT.0.AND.NAME2(1:1).NE.','.AND.NAME2(1:1).NE.' ') THEN 
        NAME = NAME2
        IF(LEN.GT.4.AND.NAME(LEN-3:LEN).EQ.'.pdb') THEN 
          NAME = NAME2(1:LEN-4)
        ENDIF
        EXT ='pdb'
        IOUT=11
        CALL OPENFW(IOUT,MD,PATH,NAME,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUT_FILE')
          CLOSE(IN)
          RETURN
        ENDIF
      ENDIF
C -------------------
      CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                            ,FRTOCR,CRTOFR,IERR)
C
C                                 ! 11 21 31 !
C            Xo=[FRTOCR] Xf    RO=! 12 22 32 !
C                                 ! 13 23 33 !
C
C ---- PDB-TITLE ----
      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.GE.13) THEN
        LN=LEN-12
        STR(1:LN)=CR_NAME_PDB(13:LEN)
      ELSE
        STR(1:1)='?'
        LN=1      
      ENDIF
      IF(LN.LT.40) THEN
        DO II=LN+1,40
          STR(II:II)=' '
        ENDDO
      ENDIF
      WRITE(LINE,140) STR(1:40),CR_DATE_PDB,CR_CD_PDB
  140 FORMAT ('HEADER',4X,A40,A9,3X,A4)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
      WRITE(LINE,150) CR_TITLE(9:68)
  150 FORMAT ('COMPND',4X,A60)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
      NCODE = 1
      ZERO  = 0.0
      CR_CELL(4)=(CR_CELL(4)*180.0)/3.1415926
      CR_CELL(5)=(CR_CELL(5)*180.0)/3.1415926
      CR_CELL(6)=(CR_CELL(6)*180.0)/3.1415926
      WRITE(LINE,100) CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6),CR_SPGR
  100 FORMAT ('CRYST1',3F9.3,3F7.2,1X,A11)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
      WRITE(LINE,110) CRTOFR(1,1),CRTOFR(2,1),CRTOFR(3,1),ZERO
  110 FORMAT ('SCALE1',4X,3F10.6,5X,F10.6)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
      WRITE(LINE,120) CRTOFR(1,2),CRTOFR(2,2),CRTOFR(3,2),ZERO
  120 FORMAT ('SCALE2',4X,3F10.6,5X,F10.6)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
      WRITE(LINE,130) CRTOFR(1,3),CRTOFR(2,3),CRTOFR(3,3),ZERO
  130 FORMAT ('SCALE3',4X,3F10.6,5X,F10.6)
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT ,'(A)') LINE(1:LEN)
C -------------------
      NA     = 0
      IEND   =-1
      MD     = 99
      IMODEL = 0
  200 CONTINUE
C --------------------------------
      CALL RDCRD(MD,IN,MODE,IEND,IERR)
      IF(IERR.EQ.1) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300

      IF(MODE.GT.0) THEN
        IF(CR_LINE(1:6).EQ.'#MODEL'.OR.CR_LINE(1:7).EQ.'#DOMAIN'.OR.
     *     CR_LINE(1:9).EQ.'#MOLECULE') THEN
          IF(CR_LINE(1:6).EQ.'#MODEL') THEN
            IMODEL = IMODEL + 1
            WRITE(LINE,'(''MODEL'',5X,I4)') IMODEL
          ELSE
            LINE = CR_LINE
          ENDIF
          CALL LENSTR_BL(LINE,LN)
          IF(LN.GT.0) THEN
            WRITE(IOUT,'(A)') LINE(1:LN)
          ENDIF
        ENDIF
        GO TO 200    
      ENDIF

      IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.CR_ATYPE.NE.'y'.AND.
     *   CR_ATYPE.NE.'Y'.AND.CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
     *   GO TO 200

      CALL PDB_ANAME(CR_ANAME,CR_ASYMB,CR_RNAME,ATOM)

      RES   = CR_RNAME
      IRES  = CR_IRES
      ALT   = CR_ALT 
      CHAIN = CR_CHAIN
      XA(1) = CR_XYZ(1)
      XA(2) = CR_XYZ(2)
      XA(3) = CR_XYZ(3)
      OCC   = CR_OCC
      B     = CR_BISO
      SEG   = CR_SEG
      IF(SEG.EQ.'.') SEG = '    '
      SURF  = CR_SURF
      CSURF ='      '
      IF(ISURF.EQ.1) THEN
        IF(SURF.GT.999.99) SURF = 999.99
        WRITE(CSURF,'(F6.2)') SURF
      ENDIF
      ASYMB = CR_ASYMB
      CALL LENSTR_BL(ASYMB,LN)
      IF(LN.LE.0) THEN
        ASYMB = '    '
      ELSE IF(LN.EQ.1) THEN
        ASYMB = ' '//ASYMB(1:1)//'  '
      ENDIF
C ----
      NA=NA+1
      IF(ALT.EQ.'.') ALT=' '
      IF(CHAIN(1:1).EQ.'.') CHAIN(1:1)=' '
      IF(CHAIN(2:2).EQ.'.') CHAIN(2:2)=' '
      WRITE(CHAIN,'(I2)') CR_IGROUP
      CHAIN(1:1)=' '
      IF(NGR.GT.0) THEN
        IGR=CR_IGROUP
        IF(IGR.GT.0.AND.IGR.LE.NGR) THEN
          CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN
          CHAIN(2:2)=GID(1:1)
        ENDIF
      ENDIF
      IF(CHAIN(1:1).EQ.'.') CHAIN(1:1)=' ' 
      IF(CHAIN(2:2).EQ.'.') CHAIN(2:2)=' ' 

      IF(B_OVER.GT.0.0001) B = B_OVER      

      WRITE(LINE,400) NA,ATOM,ALT,RES,CHAIN,IRES
     *               ,XA(1),XA(2),XA(3),OCC,B,CSURF,SEG,ASYMB
 400  FORMAT ('ATOM',1X,I6,1X,A4,A1,A3,A2,I4,4X,3F8.3,2F6.2,A6,A4,A4)
      CALL LENSTR_BL(LINE,LN)
      IF(LN.GT.0) THEN
        WRITE(IOUT,'(A)') LINE(1:LN)
      ENDIF

      IF(CR_BTYPE.EQ.'A') THEN

        DO I=1,6
          IANIS(I) = CR_ANIS(I)*10000.0
        ENDDO 

        WRITE(LINE,410) NA,ATOM,ALT,RES,CHAIN,IRES
     *                  ,(IANIS(L),L=1,6)
 410    FORMAT ('ANISOU',I5,1X,A4,A1,A3,A2,I4,2X,6I7)
        CALL LENSTR_BL(LINE,LN)
        IF(LN.GT.0) THEN
          WRITE(IOUT,'(A)') LINE(1:LN)
        ENDIF
      ENDIF

      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      WRITE(LINE,500) NA
  500 FORMAT(' NUMBER OF ATOMS   :',I6)
      CALL MSGDOC(MDOC,LINE)
      END FILE IOUT
      CLOSE(IOUT)
C --------------------------------------
      RETURN
      END


      SUBROUTINE PDB_ANAME(ANAME,ASYMB,RNAME,ATOM)
C -----------------------------------------------
      CHARACTER ANAME*4,ASYMB*4,ATOM*4,RNAME*3
C ----------------------------------------------
      PARAMETER (N_NAME = 33)
C -----------------------------------------------
      CHARACTER CH2*2
      CHARACTER NAME(N_NAME)*2
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','AS'/
c      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
c     *          'HG','AL','GD','NA','CD','NI','SR'/
C ??? more
C ---------------------------------------------
      ATOM= '    '
      CH2=ASYMB(1:2)
      DO  I=1,N_NAME
        IF(NAME(I).EQ.CH2) THEN
          ATOM=ANAME
          RETURN
        ENDIF
      ENDDO
      IF(ASYMB.EQ.'H   '.OR.ASYMB.EQ.'D   ') THEN
        ATOM(2:4) = ANAME(1:3)
        IF(ANAME(4:4).NE.' ') ATOM(1:1)=ANAME(4:4)
      ELSE
        IF(ANAME(4:4).NE.' ') THEN
          IF(ANAME(1:1).EQ.ASYMB(1:1)) THEN
            ATOM(2:4)=ANAME(1:3)
            ATOM(1:1)=ANAME(4:4)
          ELSE
            ATOM(1:4)=ANAME(1:4)
          ENDIF
        ELSE
          IF(ANAME(1:1).EQ.ASYMB(1:1)) THEN
            IF(ANAME(2:2).EQ.ASYMB(1:1)) THEN
              ATOM(1:3)=ANAME(1:3)
            ELSE
              ATOM(2:4)=ANAME(1:3)
            ENDIF
          ELSE
            ATOM(1:4)=ANAME(1:3)
          ENDIF
        ENDIF
      ENDIF
C --- special cases --

      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NA  ') ATOM=' N A'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NB  ') ATOM=' N B'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'NC  ') ATOM=' N C'
      IF(RNAME.EQ.'HEM'.AND.ANAME.EQ.'ND  ') ATOM=' N D'

      RETURN
      END

C -I-
      SUBROUTINE READPDB(MDOC,FILE_IN,FILE_OUT_INI
     *  ,PATH_SCR,ISYM,IPRSYM
     *  ,STR_TITLE,STR_DATE,RESULT,IPRROW,PDB,IERR)
C --------------------------------------------------------------
C -P- readPDB - convert of cooordinates with PDB-format to BLANC-system format.
C -S-
C
C  Dialog and Batch: 
C
C    FILE_I  - input PDB file of coordinates, without extention "pdb".
C              output file will have the same name with extention "crd".
C
C      SUBROUTINE READPDB(MDOC,FILE,ISYM,IPRSYM
C     *  ,STR_TITLE,STR_DATE,RESULT,IPRROW,PDB,IERR)
C
C  Parameters of subroutine READPDB: 
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    FILE   - name of input file without extention "pdb".
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C
C    output information:  RESULT(IPRROW)
C
C      PDB   /character*1/ "Y".  
C      RESULT(1) - PDB_code
C      RESULT(2) - number of atoms
C      RESULT(3) - number of water molecules
C      RESULT(4) - reported resolution
C      RESULT(5) - reported R-FAC
C      RESULT(6)-(11) - CELL parameters
C
C      RESULT(12)   
C      RESULT(13)  Space group
C      RESULT(14)
C
C      RESULT(15) - number of H-atoms
C      RESULT(16) - number of chains
C      RESULT(17) - NCS , number of NCS  operators.
C      RESULT(18) - IGIVEN
C      RESULT(19) = NRES_TOT
C      RESULT(20) = N_model
C -I-
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_IN*(*),FILE_OUT_INI*(*),PATH_SCR*(*),PDB*1
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RESULT(*)
C ----------------------
      CHARACTER   EXT*80,PATH*1,LINE*256,FILE*256,FILE_OUT*256
      CHARACTER   STR_TITLE*40,STR_DATE*9,CHAIN*1
C ---
      REAL      R4
      INTEGER*4 IEND
      CHARACTER REC*6,CH7*7,NCSF*1,GID*4,NAME*256
      CHARACTER MODE*4,CH1*1,CHAR1*1,CH2*2,CH4*4
      EQUIVALENCE (R4,CH4)
C -----------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
C ===
      MODEL = IERR
      CHAIN = PDB
      FILE  = FILE_IN
      FILE_OUT = FILE_OUT_INI
      CALL CORR_NAME_BLC(FILE_OUT)
C ===
      IERR = 0
      M    = 99
      MD   =-ABS(MDOC)-1
      CALL LENSTR_BL(FILE,LEN)
      IF(LEN.LT.1.OR.FILE(1:1).EQ.','.OR.FILE(1:1).EQ.' ') THEN
        CALL MSGERR(MD,' ERROR: readPDB: WRONG NAME OF INPUT_FILE')
        IERR=1
        RETURN
      ENDIF
      LN = LEN
      DO I=LEN,1,-1
        IF(FILE(I:I).EQ.','.OR.FILE(I:I).EQ.' ') THEN
          LN = LN-1
        ENDIF
      ENDDO
      NAME = FILE(1:LN)
      FILE = NAME
      LEN  = LN
C --
      EXT = ' '
      LN  = 0
      DO I=LEN,1,-1
        IF(FILE(I:I).EQ.'.') GO TO 300
        LN = LN + 1
      ENDDO
      LN = 0
 300  CONTINUE
      IF(LN.GT.0) THEN
        L1   = LEN-LN+1
        L2   = LEN-LN-1
        EXT  = FILE(L1:LEN)
        NAME = FILE(1:L2)
        FILE = NAME
      ENDIF
c      PDB = 'Y'

      CALL LENSTR_BL(FILE_OUT,LEN)
      IF(LEN.LT.1.OR.FILE_OUT(1:1).EQ.','.OR.
     *               FILE_OUT(1:1).EQ.' ') THEN
        FILE_OUT = FILE//'.crd'
        CALL REMOVE_PATH(FILE_OUT)
        CALL ADD_PATH(PATH_SCR,FILE_OUT)
      ELSE
        CALL ADD_PATH(PATH_SCR,FILE_OUT)
      ENDIF
C --------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)
      IN   = 10
c     IOUT = 11
      IOUT = 0
      PATH = ' '
C --------
      CP_PASS = 0
      NCS     = 0
      CALL SET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
      IF(IERR.NE.0) RETURN
      IGR  = 0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      NCHAIN  =0
      CP_NAN  =0
C --------------------------------------------------------------
C     IFIRST      = 0
 400  CONTINUE
      CP_PASS = CP_PASS+1

C     EXT ='pdb'
      CALL OPENFR(IN,M,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: readPDB: cannot OPEN INPUT_FILE')
        RETURN
      ENDIF
C ---
C -------------------
      IFIRST      = 0
      IERR        = 0
      JERR        = 0
      KERR        = 0
      REC         = 'START '
      IR          = 0
      IADD        = 0
      CP_IRES     = 0
      CH7         = '???????'
      CP_PNUM_OLD = '???????'
      CH1         = 'N'
      CH2         = '??'
      NA          = 0
      NRES_TOT    = 0
      NHATOM      = 0
      NAHOH       = 0
C ===
      MODEL_R     = 0
C ===
      FLAG_CR     = 'N'
      FLAG_SC     = 'N'
      FLAG_MT     = 'N'
      CP_BTYPE    = 'I'
C -------------------
  100 CONTINUE
      CALL GETREC(MDOC,IN,IOUT,REC,MODEL,MODEL_R,CHAIN,IERR,IEND)
      IF(IERR.NE.0) GO TO 600

      IF(IEND.NE.0) GO TO 200

      IF(REC.EQ.'ATOM  ') THEN
        IF(CP_PNUM.NE.CH7) THEN
          IF(CP_PNUM(1:2).NE.CH2) THEN
c           new chain
            IR   = 0
CV--  09.07.05
            IADD = 0
            CH7  = '???????'
C^--  09.07.05
c            READ(CP_PNUM(3:6),'(I4)') IR
c            IR=IR-1
            IF(CP_ICH.LT.NMAX) CP_ICH=CP_ICH+1
            CH2=CP_PNUM(1:2)
C --
            IF(CP_PASS.EQ.1) THEN
              IF(NCHAIN.LE.NMAX) THEN
                NCHAIN = NCHAIN+1
                IGR    = NCHAIN
                ICH    = IGR
                IGOLD  = IGR
                ICHOLD = IGR
                INC    = 0
                MLT    = 0
                IATM   = 0
                NCSF   = 'Y'
                GID    = '    '
                GID(1:2)=CH2
                CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
                IF(IERR.NE.0) GO TO 600
              ENDIF
            ENDIF
C --
          ENDIF
c         new residue
c         IR =IR+1
          READ(CP_PNUM(3:6),'(I4)') IR
          NRES_TOT = NRES_TOT+1
c-- 25.06.00 IF(IR.GT.0.AND.IR.LE.CP_IRES) IR = CP_IRES + 1
CV--  09.07.05
          IF(CP_PNUM(7:7).NE.CH7(7:7).AND.CH7(7:7).NE.'?') 
     *    IADD = IADD + 1
          IR   = IR + IADD
C^--  09.07.05
        ENDIF
        CP_IRES  = IR
        NA=NA+1

        CALL CP_CRD(MDOC,IOUT,IFIRST,FILE_OUT,NAHOH,NHATOM,NA
     *  ,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) GO TO 600

        CH7=CP_PNUM
        CP_PNUM_OLD=CP_PNUM
      ENDIF
      KERR=JERR
      GO TO 100
C --------------------
  200 CONTINUE
      CLOSE(IN)
      IEND=1
      IMODE=0     
      IF(CP_PASS.EQ.2) THEN
        CALL WRCRD(M,IOUT,IMODE,IEND,IERR)
      ENDIF
C ---
      IF(CP_PASS.EQ.1) THEN
        NCS=0
        CALL GET_NCS(MDOC,NCMAX,NCS,CP_NSCALE,CP_NV,IERR)
        IF(IERR.NE.0) GO TO 600
        IGR=0
        CALL GET_ASYMM(MDOC,NMAX,NGRT,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 600
        IF(NCS.GT.0.AND.CP_IGIVEN.EQ.0) THEN
          JGR=NGRT
          DO I=1,NGRT
            IGR=I
            CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) GO TO 600
            DO J=1,NCS
              INC=J
              NCSF='N'               
              JGR   =JGR+1
              ICHOLD=ICH
              IGOLD =JGR
              CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,JGR,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
              IF(IERR.NE.0) GO TO 600
            ENDDO
          ENDDO
        ENDIF
      ENDIF
C ----
      IF(CP_PASS.EQ.1) GO TO 400
C --------------------------------------------------------
C
C     check and correct chain id
C
c      CALL CHECK_CHAIN_ID(INEW)
c      IF(INEW.GT.0) THEN
c        LINE = ' WARNING: readPBD: Chain_list is not correct.'//
c     *         ' Program changed it.'
c        CALL MSGERR(MDOC,LINE)
c      ENDIF
C --------------------------------------------------------
      WRITE(LINE,'('' PDB_code : '',A4)') CP_CODE
      CALL MSGDOC(MDOC,LINE)
      CH4=CP_CODE
      RESULT(1)  = R4
      RESULT(2)  = NA
      RESULT(3)  = NAHOH
      RESULT(6)  = CP_CELL(1)
      RESULT(7)  = CP_CELL(2)
      RESULT(8)  = CP_CELL(3)
      CP_CELL(4) = (CP_CELL(4)*180.0)/PI
      CP_CELL(5) = (CP_CELL(5)*180.0)/PI
      CP_CELL(6) = (CP_CELL(6)*180.0)/PI
      RESULT(9)  = CP_CELL(4)
      RESULT(10) = CP_CELL(5)
      RESULT(11) = CP_CELL(6)
      IF(IPRROW.GE.20) THEN
        CH4=CP_SPGR(1:4)
        RESULT(12)=R4
        CH4=CP_SPGR(5:8)
        RESULT(13)=R4
        CH4=CP_SPGR(9:11)//' '
        RESULT(14) = R4
        RESULT(15) = NHATOM
        RESULT(16) = NCHAIN
        RESULT(17) = NCS
        RESULT(18) = CP_IGIVEN
        RESULT(19) = NRES_TOT
        RESULT(20) = MODEL_R
      ENDIF
      WRITE(LINE,'('' Cell: '',6F7.2)') 
     *  RESULT(6),RESULT(7),RESULT(8),RESULT(9)
     * ,RESULT(10),RESULT(11) 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Space group : '',A)') CP_SPGR 
      CALL MSGDOC(MDOC,LINE)
      IF(CP_RESL(1:1).NE.'.') THEN
        READ(CP_RESL(13:16),'(F4.2)',ERR=700) RESULT(4)
        GO TO 710
  700   CONTINUE
        RESULT(4)=0.0
        CP_RESL(13:16)=' 0.0'
  710   CONTINUE
        WRITE(LINE,'('' Resolution: '',A4)') CP_RESL(13:16) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(4)=0.0
      ENDIF
      IF(CP_RFAC(1:1).NE.'.') THEN
        READ(CP_RFAC(30:34),'(F4.2)',ERR=720) RESULT(5)
        GO TO 730
  720   CONTINUE
        RESULT(5)=0.0
        CP_RFAC(30:34)=' 0.0'
  730   CONTINUE
        WRITE(LINE,'('' R_factor  : '',A4)') CP_RFAC(30:34) 
        CALL MSGDOC(MDOC,LINE)
      ELSE
        RESULT(5)=0.0
      ENDIF

      WRITE(LINE,500) NA,NAHOH
  500 FORMAT(' Number of atoms:',I6,' ( ',I6,' water molecules)')
      CALL MSGDOC(MDOC,LINE)
      IF(MODEL_R.GT.0) THEN
        WRITE(LINE,522) MODEL_R
        CALL MSGDOC(MDOC,LINE)
  522   FORMAT(' Number of models:',I6)
      ENDIF
      WRITE(LINE,520) NCHAIN
  520 FORMAT(' Number of chains:',I6)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,521) NRES_TOT
  521 FORMAT(' Number of residues:',I6)
      CALL MSGDOC(MDOC,LINE)
      IF(NHATOM.GT.0) THEN
        WRITE(LINE,510) NHATOM
  510   FORMAT(' Number of H-atoms:',I6)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NCS.GT.0) THEN
        WRITE(LINE,530) NCS
  530   FORMAT(' Number of NCS-operators:',I6)
        CALL MSGDOC(MDOC,LINE)
        IF(CP_IGIVEN.EQ.0) THEN
          CALL MSGDOC(MDOC,
     * '   use NCS-operators for to restore asymm. part of unit cell')
        ELSE
          CALL MSGDOC(MDOC,
     * '   PDB_file contents asymm. part of unit cell')
          CALL MSGDOC(MDOC,
     * '   NC-symmetry only for information')
        ENDIF
      ENDIF
      IF(NA.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: Number of atoms = 0')
        IERR=1
      ENDIF
      STR_DATE  = CP_DATE
      STR_TITLE = CP_TITLE
c     FILE      = FILE_OUT
      CLOSE(IN)
      RETURN
C --------------------
  600 CONTINUE
      IERR=1
      CLOSE(IN)
      IF(CP_PASS.EQ.2) CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE GETREC(MDOC,IN,IOUT
     *    ,REC,MODEL_I,MODEL_R,CHAIN,IERR,IEND)
C -----------------------------------------------
      INTEGER*4 MDOC,IERR,IEND
      CHARACTER REC*6
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------
      COMMON/STTCREC/ ICEND,JEND,KEND,ICH0,STR
      INTEGER   ICEND,JEND,KEND,ICH0
      CHARACTER STR*80,CHAIN*1
C ---
      REAL      PI,CELL(6)
      INTEGER*4 M,IN
      CHARACTER LINE*80
C -----------------------------------
      PI   = 4.0*ATAN(1.0)
      IERR = 0
      IEND = 0
      IF(REC.EQ.'START ') THEN
C ---
        CP_CELL(1) = 1.0
        CP_CELL(2) = 1.0
        CP_CELL(3) = 1.0
        CP_CELL(4) = PI/2.0
        CP_CELL(5) = PI/2.0
        CP_CELL(6) = PI/2.0
        CP_IA      = 0
        CP_IRES    = 0
        CP_ICH     = 0
        ICEND      = 0
        JEND       = 0
        KEND       = 0
        ICH0       =-1
        ICOMPND    = 0
        CP_OXT     = 'N'
        CP_MODEL   = 0
        CP_MOLECULE= 0
        CP_LINE    = ' '
C ===
        MODEL_R    = 0
C ===
        CP_NAME  = '----'
        CP_DATE  = 'XX-XXX-XX'
        CP_CODE  = 'XXXX'
        CP_TITLE = '---'
        CP_RESL  = '.'
        CP_RFAC  = '.'
        IF(CP_PASS.EQ.1) THEN
          CP_NCS  = 0
          CP_IGIVEN=1
        ENDIF

        STR = ' '
        CALL GETLINE(IN,MDOC,STR,IERR,JEND)
        IMODE = 0
        CALL CHECK_LINE(IMODE,STR)
        CALL LENSTR_BL(STR,LEN)
        ICEND = JEND
        IF(IERR.NE.0.OR.JEND.NE.0) THEN
          IEND=JEND
          RETURN
        ENDIF
        REC         = ' '
        
      ENDIF
C -----
  100 CONTINUE
      LINE=STR   
      IEND=ICEND
      IF(IEND.NE.0) THEN
        CLOSE(IN)
        RETURN
      ENDIF

      IF(KEND.NE.0) THEN
        JEND = KEND
        STR=' '
      ELSE
        STR = ' '
        CALL GETLINE(IN,MDOC,STR,IERR,KEND)
        IF(IERR.NE.0) THEN
          CLOSE(IN)
          RETURN
        ENDIF
        IMODE = 0
        CALL CHECK_LINE(IMODE,STR)
        CALL LENSTR_BL(STR,LEN)
        IF(KEND.NE.0.AND.LEN.LE.0) THEN
          JEND = KEND
          STR=' '
        ELSE IF(KEND.NE.0) THEN

        ENDIF
      ENDIF
      ICEND= JEND
C ===
      IF(LINE(1:5).EQ.'MODEL') THEN
C       CALL RDMODEL(LINE,MODEL)
        MODEL_R  = MODEL_R + 1
        CP_MODEL = MODEL_R
        CP_ICH   = 0
        CP_PNUM_OLD = '???????'
        GO TO 100
      ENDIF
      IF(LINE(1:9).EQ.'#MOLECULE'.OR.LINE(1:7).EQ.'#DOMAIN') THEN

C        WRITE(*,*) '-1:',LINE(1:20)
C        WRITE(*,*) '-2:',STR(1:20),IOUT,MODEL_I 

        IF((STR(1:9).EQ.'#MOLECULE'.OR.STR(1:1).EQ.' ').AND.
     *                             IOUT.GT.0.AND.MODEL_I.LE.0) THEN
          M       = 99
          MODE    = 1
          IENDW   = 0
          CR_LINE2 = ' '
          CR_LINE = LINE
          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        ENDIF 

        CP_MOLECULE = 1
        CP_LINE     = LINE
        GO TO 100
      ENDIF

      IF(MODEL_I.GT.0.AND.MODEL_R.GT.MODEL_I) ICEND=1

      IF(MODEL_I.GT.0.AND.MODEL_R.GT.0.AND.MODEL_R.NE.MODEL_I) 
     *  GO TO 100
C ===

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL RDHEAD(LINE)
        GO TO 100        
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        ICOMPND = ICOMPND + 1
        IF(ICOMPND.EQ.1) CALL RDCOMPND(LINE)
        GO TO 100
      ELSE IF(LINE(1:5).EQ.'TITLE') THEN
        ICOMPND = ICOMPND + 1
        CALL RDTITLE_PDB(LINE)
        GO TO 100
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL RDCRYST1(LINE)
        FLAG_CR='Y'
        GO TO 100
c      ELSE IF(LINE(1:6).EQ.'MODEL ') THEN
c        CALL RDMODEL(LINE,MODEL)
cC       IF(MODEL.GT.1) ICEND=1
c        GO TO 100
      ELSE IF(LINE(1:6).EQ.'HET   ') THEN
        CALL RDHET(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'FORMUL') THEN
        CALL RDFORMUL(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'REMARK') THEN
        CALL RDREMARK(LINE)
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'SCALE1'.OR.
     *        LINE(1:6).EQ.'SCALE2'.OR.
     *        LINE(1:6).EQ.'SCALE3') THEN
C        CALL RDSCALE(LINE)
C        FLAG_SC='Y'
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'MTRIX1'.OR.
     *        LINE(1:6).EQ.'MTRIX2'.OR.
     *        LINE(1:6).EQ.'MTRIX3') THEN
C        CALL RDMTRIX(MDOC,LINE,IERR)
C        IF(IERR.NE.0) RETURN
        GO TO 100
      ELSE IF(LINE(1:6).EQ.'TER   ') THEN
        REC='TER   '
      ELSE IF(LINE(1:6).EQ.'CONECT') THEN
        CALL RDCONECT(MDOC,LINE,IERR)
        REC='CONECT'
      ELSE IF(LINE(1:6).EQ.'SSBOND') THEN
        CALL RDSSBOND(MDOC,LINE,IERR)
        REC='USER_L'
      ELSE IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *        (LINE(1:6).EQ.'HETATM')) THEN
        CALL RDATOM(MDOC,LINE,REC,ICH0)
        REC='ATOM  '
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'ANISOU').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
      ELSE IF(LINE(1:6).EQ.'ANISOU') THEN
        CALL RDANISO(LINE)
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
        REC='ATOM  '
      ELSE IF(LINE(1:6).EQ.'SIGATM') THEN
        CALL RDSIGAT(LINE)
        IF((STR(1:6).EQ.'ANISOU').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'SIGUIJ')) GO TO 100
        REC='ATOM  '
      ELSE IF(LINE(1:6).EQ.'SIGUIJ') THEN
        CALL RDSIGUIJ(LINE)
        IF((STR(1:6).EQ.'SIGATM').OR.          
     *     (STR(1:6).EQ.'USER_G').OR.          
     *     (STR(1:6).EQ.'ANISOU')) GO TO 100          
        REC='ATOM  '
      ELSE
        GO TO 100
      ENDIF
C ===
      IF(CHAIN.NE.' '.AND.CHAIN.NE.',') THEN
        IF(CP_PNUM(1:1).NE.CHAIN) THEN 
          GO TO 100
        ELSE
          CP_PNUM(2:2) = ' ' 
          ICH0=0
        ENDIF
      ENDIF
C ===
      RETURN
C -----------------------------------
      END    

      SUBROUTINE RDATOM(MDOC,LINE,REC,ICH0)
C -------------------------------------------------------
C     RDATOM - reads record ATOM/HETATOM from PDB_file.
C 
C -------------------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      CHARACTER LINE*(*),REC*(*)
      INTEGER*4 ICH0
C -----------------------------------
      INTEGER*4 IA
      CHARACTER PNUM*7,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER FRMT*80,ANAME*4,RNAME*3,ASYMB*4,CTYPE*4,ACODE*4
      DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,A4,A4)'/
C ------------------------------------
      ASYMB='    '
      CALL LENSTR_BL(LINE,LEN_IN)
      READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO
     * ,CSURF,CP_SEG,ACODE
      IF(LEN_IN.GE.80) THEN 
        CALL CHKSMB(LINE(80:80),TYPE1)
        IF(TYPE1.EQ.'D'.AND.
     *     LINE(79:79).NE.'+'.AND.LINE(79:79).NE.'-') THEN
          CP_SEG = '    '
          ACODE  = '    '
        ENDIF
      ENDIF

      IF(RNAME.EQ.'   ') THEN
        CALL MSGERR(MDOC,
     * ' WARNING: residue name is empty, default is "HOH"')
        RNAME='HOH'
      ENDIF

      IF(RNAME.EQ.'MSE') THEN
        LINE(1:6) = 'ATOM  '
      ENDIF

      CP_IA=IA
      IF(CP_CORR.EQ.' ') CP_CORR='.'
      IF(CP_ALT .EQ.' ') CP_ALT ='.'

      IF(CP_OCC.GT.1.0) THEN
        IF(FLAG_MT.EQ.'N') THEN
          IF(CP_PASS.EQ.1) THEN
            CALL MSGERR(MDOC,' WARNING: occupancy > 1.0')
          ENDIF
          FLAG_MT='Y'
        ENDIF 
        CP_OCC=1.0
      ENDIF

      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)

      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)

      READ(CSURF,'(F6.2)') CP_SURF


      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN_IN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF

      CP_ANAME=ANAME
      CP_ASYMB=ASYMB
      CP_ATYPE=CTYPE
      CP_BTYPE='I'
      PNUM(1:1)=PNUM(2:2)
      PNUM(2:2)= ' '

      IF(REC(1:6).NE.LINE(1:6).AND.REC(1:6).NE.'ATOM  ') THEN

        ICH0=ICH0+1
        IF(ICH0.GT.9) ICH0=0
        CP_OXT='N'

      ELSE IF(LINE(1:6).EQ.'HETATM'.AND.
     *     CP_PNUM(3:7).NE.PNUM(3:7))THEN
  
        IF(RNAME.NE.'HOH'.OR.CP_RNAME.NE.RNAME) THEN
          ICH0=ICH0+1
          IF(ICH0.GT.9) ICH0=0
        ENDIF
        CP_OXT='N'

      ELSE IF(LINE(1:6).EQ.'ATOM  '.AND.REC(1:6).EQ.'ATOM  '.AND.
     *     CP_PNUM(3:7).NE.PNUM(3:7).AND.CP_OXT.EQ.'Y')THEN
        ICH0=ICH0+1
        IF(ICH0.GT.9) ICH0=0
        CP_OXT='N'
      ELSE

        IF(RNAME.EQ.'HOH'.AND.CP_RNAME.NE.RNAME) THEN
          ICH0=ICH0+1
          IF(ICH0.GT.9) ICH0=0
          CP_OXT='N'
        ENDIF

      ENDIF

      CP_RNAME=RNAME
      
      WRITE(PNUM(2:2),'(I1)') ICH0
      IF(PNUM(2:2).EQ.'0'.AND.PNUM(1:1).NE.' ') PNUM(2:2)=' '
      CP_PNUM=PNUM
      IF(ANAME.EQ.'OXT ') CP_OXT='Y'
      RETURN
      END

      SUBROUTINE RDHEAD(LINE)
C -------------------------------------------------------
C     RDHEAD - reads record HEADER from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      CHARACTER FRMT*80,NAME_PDB*40,DATE_PDB*9,CD_PDB*4
      DATA FRMT/'(10X,A40,A9,3X,A4)'/
C ------------------------------------
      READ(LINE,FRMT) NAME_PDB,DATE_PDB,CD_PDB

      CALL LENSTR_BL(NAME_PDB,LEN)
      IF(LEN.LE.0) NAME_PDB='----'
      CALL LENSTR_BL(DATE_PDB,LEN)
      IF(LEN.LE.0) DATE_PDB='XX-XXX-XX'
      CALL LENSTR_BL(CD_PDB,LEN)
      IF(LEN.LE.0) CD_PDB='XXXX'

      CP_DATE = DATE_PDB
      CP_NAME = NAME_PDB
      CP_CODE = CD_PDB

      RETURN
      END

      SUBROUTINE RDCOMPND(LINE)
C -------------------------------------------------------
C     RDCOMPND - reads record COMPND from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      CHARACTER FRMT*80,TITLE*68
      DATA FRMT/'(10X,A68)'/
C ------------------------------------
      READ(LINE,FRMT) TITLE

      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) TITLE='---'

      CP_TITLE = TITLE(1:40)

      RETURN
      END

      SUBROUTINE RDTITLE_PDB(LINE)
C -------------------------------------------------------
C     RDTITLE_PDB - reads record TITLE from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      CHARACTER FRMT*80,TITLE*68
      DATA FRMT/'(10X,A68)'/
C ------------------------------------
      READ(LINE,FRMT) TITLE

      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) TITLE='---'

      CP_TITLE = TITLE(1:40)

      RETURN
      END

      SUBROUTINE RDMODEL(LINE,MODEL)
C -------------------------------------------------------
C     RDMODEL - reads record MODEL from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ------------------------------------------------------
      CHARACTER FRMT*80
      DATA FRMT/'(10X,I4)'/
C ------------------------------------
      READ(LINE,FRMT) MODEL

      RETURN
      END

      SUBROUTINE RDREMARK(LINE)
C -------------------------------------------------------
C     RDREMARK - reads record REMARK from PDB_file.
C   
C 123456789 123456789 123456789 123456789 123456789 12
C            123456789 123456789 123456789 123456789 1 
C REMARK   4   WAVELENGTH OR WAVELENGTH RANGE : 1.54 A   
C REMARK  18  WAVELENGTH OR RANGE (A)        : 1.54
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
C -----------------------------------
      CHARACTER FRMT*80,CH36*36,CHAR*1,TYPE*1
      DATA FRMT/'(7X,I3,1X,A36)'/
C ------------------------------------
      CHAR=LINE(8:8)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100
      CHAR=LINE(9:9)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100
      CHAR=LINE(10:10)
      CALL CHKSMB(CHAR,TYPE)
      IF(TYPE.NE.'B'.AND.TYPE.NE.'D') GO TO 100

      READ(LINE,FRMT,ERR=100) I,CH36

      IF(I.EQ.2     .AND.CH36(1:10).EQ.'RESOLUTION') THEN
        CP_RESL    = CH36
      ELSE IF(I.EQ.3.AND.CH36(1:10).EQ.'  R VALUE ') THEN
        CP_RFAC    = CH36
      ENDIF

  100 CONTINUE
      RETURN
      END

      SUBROUTINE RDHET(LINE)
C -------------------------------------------------------
C     RDHET - reads record HET from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
      CHARACTER FRMT*80,MON*3,NAME*40
      DATA FRMT/'(7X,A3,10X,I5,5X,A40)'/
C ------------------------------------
      READ(LINE,FRMT) MON,NA,NAME

      IF(MON(1:1).EQ.' ') THEN
        MON=MON(2:3)//' '
        IF(MON(1:1).EQ.' ') MON=MON(2:3)//' '
      ENDIF

      CALL LENSTR_BL(NAME,LEN)
     
      IF(LEN.GT.0) THEN
        DO I=1,LEN
          IF(NAME(I:I).EQ.' ')  NAME(I:I)='_'
          IF(NAME(I:I).EQ.'''') NAME(I:I)='*'
        ENDDO 
      ELSE
        NAME='.'
      ENDIF

      RETURN
      END

      SUBROUTINE RDFORMUL(LINE)
C -------------------------------------------------------
C     RDFORMUL - reads record FORMUL from PDB_file.
C  
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
      CHARACTER FRMT*80,MON*3,FORMUL*40
      DATA FRMT/'(12X,A3,4X,A40)'/
C ------------------------------------
      READ(LINE,FRMT) MON,FORMUL

      IF(MON(1:1).EQ.' ') THEN
        MON=MON(2:3)//' '
        IF(MON(1:1).EQ.' ') MON=MON(2:3)//' '
      ENDIF

      RETURN
      END

      SUBROUTINE RDCRYST1(LINE)
C -------------------------------------------------------
C     RDCRYST1 - reads record CRYST1 from PDB_file.
C 
C -------------------------------------------------------
      CHARACTER LINE*(*)
C ---
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7,CHAR11*11,CHAR1*1
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      REAL CELL(6)
      CHARACTER FRMT*80
      CHARACTER SPGR*24
      DATA FRMT/'(6X,3F9.3,3F7.2,1X,A11)'/
C ------------------------------------
      PI    = 4.0*ATAN(1.0)
      TWOPI = 2.0*PI
      PI180 = PI/180.0
C
      READ(LINE,FRMT) CELL(1),CELL(2),CELL(3)
     *               ,CELL(4),CELL(5),CELL(6)
     *               ,CHAR11
      IMODE = 0
      CALL CHECK_LINE(IMODE,CHAR11)
      SPGR = CHAR11
C ---
      CP_CELL(1) =CELL(1)
      CP_CELL(2) =CELL(2)
      CP_CELL(3) =CELL(3)
      CP_CELL(4) =CELL(4)*PI180
      CP_CELL(5) =CELL(5)*PI180
      CP_CELL(6) =CELL(6)*PI180
C ---
      CALL LENSTR_BL(SPGR,LENS)
      IF(LENS.LE.0) THEN
        SPGR = ' '
        LENS = 1
      ELSE
        J  = 0
        NB =-11
        DO I=1,LENS
          IF(SPGR(I:I).EQ.' ') THEN
            NB = NB+1
            IF(NB.EQ.1) THEN
              J = J + 1
              SPGR(J:J) = SPGR(I:I)
            ENDIF
          ELSE
            NB = 0
            J  = J + 1
            SPGR(J:J) = SPGR(I:I)
          ENDIF
        ENDDO
        LENS = J
      ENDIF

      CP_SPGR = SPGR(1:LENS)

      RETURN
      END

      SUBROUTINE RDSCALE(LINE)
C -------------------------------------------------------
C     RDSCALE - reads record SCALE1 from PDB_file.
C
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      CHARACTER FRMT*80,CH1*1
      DATA FRMT/'(5X,A1,4X,3F10.6,5X,F10.5)'/
C ------------------------------------
      READ(LINE,FRMT) CH1,S1,S2,S3,U

      I=1
      IF(CH1.EQ.'2') I=2
      IF(CH1.EQ.'3') I=3
      IF(I.EQ.1) THEN
        CP_SCALE(1,1)=S1
        CP_SCALE(2,1)=S2
        CP_SCALE(3,1)=S3
        CP_U(1)      =U  
      ELSE IF(I.EQ.2) THEN
        CP_SCALE(1,2)=S1
        CP_SCALE(2,2)=S2
        CP_SCALE(3,2)=S3
        CP_U(2)      =U  
      ELSE IF(I.EQ.3) THEN
        CP_SCALE(1,3)=S1
        CP_SCALE(2,3)=S2
        CP_SCALE(3,3)=S3
        CP_U(3)      =U  
      ENDIF
      RETURN
      END

      SUBROUTINE RDMTRIX(MDOC,LINE,IERR)
C -------------------------------------------------------
C     RDMTRIX - reads record MTRIX1 from PDB_file.
C   
C -------------------------------------------------------
      CHARACTER LINE*(*)
C -----------------------------------------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      REAL FRTOCR(3,3),CRTOFR(3,3),V1(3),U(3),V2(3)
      REAL AM(3,3),BM(3,3),SI(3,3),S(3,3)
      CHARACTER FRMT*80,CH1*1,STR*80
      DATA FRMT/'(5X,A1,1X,I3,3F10.6,5X,F10.5,4X,I1)'/
C ------------------------------------
      PI=4.0*ATAN(1.0)
      READ(LINE,FRMT) CH1,ICS,S1,S2,S3,V,IGIVEN

      IF(CP_PASS.EQ.1) THEN
        I=1
        IF(CH1.EQ.'2') I=2
        IF(CH1.EQ.'3') I=3
        IF(I.EQ.1) THEN
          CP_NSCALE(1,1)=S1
          CP_NSCALE(2,1)=S2
          CP_NSCALE(3,1)=S3
          CP_NV(1)      =V  
        ELSE IF(I.EQ.2) THEN
          CP_NSCALE(1,2)=S1
          CP_NSCALE(2,2)=S2
          CP_NSCALE(3,2)=S3
          CP_NV(2)      =V  
        ELSE IF(I.EQ.3) THEN
          CP_NSCALE(1,3)=S1
          CP_NSCALE(2,3)=S2
          CP_NSCALE(3,3)=S3
          CP_NV(3)      =V  
          CP_NCS=CP_NCS+1                     
          CP_IGIVEN=IGIVEN


          CALL INVERT(CP_SCALE,SI,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' WARNING: problem with SCALE matrix')             
            IERR=0
            GO TO 200
          ENDIF

c          WRITE(STR,'('' MATRIX : '',3F12.4)') (CP_NSCALE(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)
c
c          CALL MTOANG(CP_NSCALE,ALPHA,BETA,GAMMA)
c          WRITE(STR,100) ALPHA,BETA,GAMMA
c  100     FORMAT('EILER ANGLES : ALPHA BETA GAMMA :',3F10.4)
c          CALL MSGDOC(MD,STR)
c
c          ALPHA=ALPHA*PI/180.
c          BETA =BETA *PI/180.
c          GAMMA=GAMMA*PI/180.c
c
c          CALL EULERM(ALPHA,BETA,GAMMA,AM)
c
c          WRITE(STR,'('' MATRIX : '',3F12.4)') (AM(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)


          CALL FRORTH(CP_CELL(1),CP_CELL(2),CP_CELL(3)
     *           ,CP_CELL(4),CP_CELL(5),CP_CELL(6)
     *                         ,FRTOCR,CRTOFR,IERR)
          CALL  MATMLT(SI,CRTOFR,AM)
          CALL  MATMLT(FRTOCR,CP_SCALE,BM)
          CALL  MATMLT(CP_NSCALE,AM,S)
          CALL  MATMLT(BM,S,CP_NSCALE)

          CALL  MVMULT(FRTOCR,CP_U,U)
          CALL  MVMULT(CP_NSCALE,U,V1)
          CALL  VADD(U,V1,V2)
          CALL  MVMULT(BM,CP_NV,V1)
          CALL  VADD(V1,V2,CP_NV)


c          WRITE(STR,'('' MATRIX : '',3F12.4)') (CP_NSCALE(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (CP_NSCALE(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)
c
c          CALL MTOANG(CP_NSCALE,ALPHA,BETA,GAMMA)
c          WRITE(STR,100) ALPHA,BETA,GAMMA
c          CALL MSGDOC(MD,STR)
c
c          ALPHA=ALPHA*PI/180.
c          BETA =BETA *PI/180.
c          GAMMA=GAMMA*PI/180.
c
c          CALL EULERM(ALPHA,BETA,GAMMA,AM)
c
c          WRITE(STR,'('' MATRIX : '',3F12.4)') (AM(L,1),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,2),L=1,3)
c          CALL MSGDOC(MD,STR)
c          WRITE(STR,'(''          '',3F12.4)') (AM(L,3),L=1,3)
c          CALL MSGDOC(MD,STR)

          CALL SET_NCS(MDOC,NMAX,CP_NCS,CP_NSCALE,CP_NV,IERR)
          IF(IERR.NE.0) RETURN
 200      CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE RDSSBOND(MDOC,LINE,IERR)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*(*)
C ----------------------------------
      CHARACTER STR*80,CH1*1,CH2*1,CR1*5,CR2*5
      CHARACTER FRMT*80
      DATA FRMT/'(15X,A1,1X,A5,7X,A1,1X,A5)'/
C ------------------------------------
      READ(LINE,FRMT) CH1,CR1,CH2,CR2
C
      RETURN
      END

      SUBROUTINE RDCONECT(MDOC,LINE,IERR)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*(*)
      RETURN
      END


      SUBROUTINE RDANISO(LINE)
      CHARACTER LINE*(*)
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
C ******
C ------------------------------------------------------
      INTEGER*4 IANISO(6)
      CHARACTER FRMT*80
      DATA FRMT/'(28X,6I7)'/
C ------------------------------------

      READ(LINE,FRMT) (IANISO(I),I=1,6)

      DO I=1,6
        CP_ANIS(I) = IANISO(I)/10000.0
      ENDDO 

      CP_NAN    = 1
      CP_BTYPE  = 'A'

      RETURN
      END

      SUBROUTINE RDSIGAT(LINE)
      CHARACTER LINE*(*)
      RETURN
      END

      SUBROUTINE RDSIGUIJ(LINE)
      CHARACTER LINE*(*)
      RETURN
      END

      SUBROUTINE CHECK_ANAME(MON,ANAME)
C -----------------------------------------
C     CHECK_NAME - ATOM'S NAME
C 
C -----------------------------------------
      CHARACTER MON*3,ANAME*4
C ---
C --------------------------------
      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
      ENDIF
      RETURN
      END     

      SUBROUTINE CP_CRD(MDOC,IOUT,IFIRST,FNAME,NAHOH,NHATOM,NA
     * ,ISYM,IPRSYM,IERR)
C -------------------------------------------------------
      INTEGER MDOC,IOUT,IERR,IFIRST
      CHARACTER FNAME*(*)
      INTEGER   IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C -------------
C -----------------------------------------------
      COMMON/COM_PDB/ CP_CELL,CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN
     *               ,CP_XYZ,CP_OCC,CP_BISO,CP_SCALE,CP_U,CP_ANIS
     *               ,CP_IGIVEN,CP_NCS,CP_PASS,CP_NSCALE,CP_NV
     *               ,CP_MOLECULE,CP_SURF,CP_SEG,CP_LINE
     *               ,CP_ANAME,CP_RNAME,CP_ASYMB,CP_ATYPE
     *               ,CP_PNUM,CP_CORR,CP_ALT,FLAG_CR,FLAG_SC
     *               ,CP_SPGR,FLAG_MT,CP_NAME,CP_DATE,CP_CODE
     *               ,CP_TITLE,CP_RESL,CP_RFAC,CP_BTYPE,CP_OXT
     *               ,CP_PNUM_OLD
      INTEGER   CP_IA,CP_IRES,CP_ICH,CP_MODEL,CP_NAN,CP_NCS,CP_PASS
      INTEGER   CP_IGIVEN
      REAL      CP_CELL(6),CP_XYZ(3),CP_OCC,CP_BISO,CP_SCALE(3,3)
      REAL      CP_U(3),CP_ANIS(6)
      REAL      CP_NSCALE(3,3),CP_NV(3)
      CHARACTER CP_PNUM*7,CP_ANAME*4,CP_RNAME*3,CP_ASYMB*4
      CHARACTER CP_ATYPE*4,CP_CORR*1,CP_ALT*1,FLAG_CR*1,FLAG_SC*1
      CHARACTER CP_SPGR*24,FLAG_MT*1,CP_NAME*40,CP_DATE*9,CP_CODE*4
      CHARACTER CP_TITLE*40,CP_RESL*36,CP_RFAC*36,CP_BTYPE*1,CP_OXT*1
      CHARACTER CP_PNUM_OLD*7
      INTEGER   CP_MOLECULE
      REAL      CP_SURF
      CHARACTER CP_SEG*4
      CHARACTER CP_LINE*80 
C --------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
      REAL      FRTOCR(3,3),CRTOFR(3,3),Y(3)
      CHARACTER CH4*4
      INTEGER   NOSPGR,ISETT,NSYM,NS
      CHARACTER SGNAME*24,SYMOP*26,LINE*80
      CHARACTER CHAR*1,TYPE*1,FNAME_OUT*256
C -------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
      M     = 99
      ISETT = 0
      IENDW = 0
      IF(IFIRST.EQ.0) THEN
        IF(FLAG_CR.NE.'Y') THEN
          IF(CP_PASS.LE.1) THEN
            CALL MSGERR(MDOC,
     *      ' INFO: card "CRYST1" is missing in PDB_file')
            CALL MSGERR(MDOC,
     *      '       default space group "P 1"')
            CALL MSGERR(MDOC,
     *      '       Default CELL: 100,100,100,90,90,90')
          ENDIF
          CP_CELL(1) = 100.0
          CP_CELL(2) = 100.0
          CP_CELL(3) = 100.0
          CP_CELL(4) = PI/2.0
          CP_CELL(5) = PI/2.0
          CP_CELL(6) = PI/2.0
          CP_SPGR    = 'P 1'
          LENS       = 3
          FLAG_SC    = 'N'          
        ENDIF

        IF(CP_CELL(1).LE.0.5.OR.CP_CELL(2).LE.0.5.OR.
     *     CP_CELL(3).LE.0.5.OR.CP_CELL(4).LE.0.001.OR.
     *     CP_CELL(5).LE.0.001.OR.CP_CELL(6).LE.0.001) THEN
          IF(CP_PASS.LE.1) THEN
            CALL MSGERR(MDOC,' WARNING: wrong CELL parameters')
            CALL MSGERR(MDOC,'          Default: 100,100,100,90,90,90')
          ENDIF
          CP_CELL(1) = 100.0
          CP_CELL(2) = 100.0
          CP_CELL(3) = 100.0
          CP_CELL(4) = PI/2.0
          CP_CELL(5) = PI/2.0
          CP_CELL(6) = PI/2.0
          FLAG_SC    = 'N'          
        ENDIF

        CALL LENSTR_BL(CP_SPGR,LENS)
        IF(LENS.LT.1.OR.LENS.GT.24) THEN
          IF(CP_PASS.LE.1) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: wrong card "CRYST1" of PDB_file..')
            CALL MSGERR(MDOC
     *      ,'          default space group "P 1"')
            CALL MSGERR(MDOC,
     *       '          default CELL: 100,100,100,90,90,90')
          ENDIF 
          CP_CELL(1) = 100.0
          CP_CELL(2) = 100.0
          CP_CELL(3) = 100.0
          CP_CELL(4) = PI/2.0
          CP_CELL(5) = PI/2.0
          CP_CELL(6) = PI/2.0
          CP_SPGR    = 'P 1'
          LENS       = 3
          FLAG_SC    = 'N'          
        ENDIF

        N = 0
        DO I=1,LENS
          IF(CP_SPGR(I:I).EQ.' ') N = N + 1
          IF(CP_SPGR(I:I).NE.' ') GO TO 600
        ENDDO

  600   CONTINUE

        IF(N.GT.0) THEN
          DO I=1,LENS-N
            CP_SPGR(I:I)=CP_SPGR(I+N:I+N)
          ENDDO
          DO I=1,N
            CP_SPGR(I+LENS-N:I+LENS-N)=' '
          ENDDO
        ENDIF

        IND=0
        DO I=1,LENS
          CHAR=CP_SPGR(I:I)
          CALL CHKSMB(CHAR,TYPE)
          IF(TYPE.NE.'B'.AND.TYPE.NE.'D') IND=1
        ENDDO

        IF(IND.EQ.0) THEN

          READ(CP_SPGR(1:LENS),*) NOSPGR

          ISETT  = 0
          IF(NOSPGR.GT.1000) THEN

            ISETT  = NOSPGR/1000
            NOSPGR = NOSPGR - ISETT*1000
            ISETT  = ISETT + 1
            NOSG   = NOSPGR

            IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.
     *         NOSG.EQ.155) THEN
              IF(ISETT.EQ.1) THEN
                ISETT = 2
              ELSE IF(ISETT.EQ.2) THEN  
                ISETT = 1
              ENDIF
            ELSE IF(NOSG.EQ.  5) THEN
              IF(ISETT.EQ.1) THEN
                ISETT = 2
              ELSE IF(ISETT.EQ.2) THEN  
                ISETT = 3
c              ELSE IF(ISETT.EQ.3) THEN  
c                ISETT = 4
c              ELSE IF(ISETT.EQ.4) THEN  
c                ISETT = 1
              ENDIF
            ENDIF
          ENDIF

          IF(NOSPGR.LT.1.OR.NOSPGR.GT.230) THEN
            IF(CP_PASS.LE.1) THEN
              CALL MSGERR(MDOC
     *        ,' WARNING: wrong card "CRYST1" of PDB_file')
              CALL MSGERR(MDOC
     *        ,'          default space group: "P 1"')
            ENDIF
            NOSPGR = 1
            ISETT  = 1
          ENDIF
          IF(NOSPGR.EQ.146.OR.NOSPGR.EQ.155) THEN
            ISETT=1
            T= (PI*2.0)/3.0
            IF(ABS(CP_CELL(6)-T).LE.0.0001) ISETT=2
          ENDIF
          IF(NOSPGR.GE.3.AND.NOSPGR.LE.15) THEN
            IF(ISETT.LE.0) ISETT  = 2
            IF(ISETT.EQ.2) THEN
              T = PI/2.0
              IF(ABS(CP_CELL(6)-T).GT.0.0001) ISETT=1
            ELSE IF(ISETT.EQ.1) THEN
              T = PI/2.0
              IF(ABS(CP_CELL(5)-T).GT.0.0001) ISETT=2
            ENDIF
          ENDIF
          IF(ISETT.LE.0) ISETT  = 1
          NSYM   = 0
          SGNAME = ' '

        ELSE

          NOSPGR = 0
          ISETT  = 1
          NSYM   = 0
          SGNAME = CP_SPGR(1:LENS)
          IF((LENS.GE.3.AND.SGNAME(1:3).EQ.'R 3').OR.
     *       (LENS.GE.2.AND.SGNAME(1:2).EQ.'R3')) THEN
            T= (PI*2.0)/3.0
            IF(ABS(CP_CELL(6)-T).LE.0.0001) THEN
              ISETT       = 2
              SGNAME(1:1) = 'H'
            ENDIF
          ENDIF

C                sett 2     sett 1
C
C 3  P 2 P2      P 1 2 1   P 1 1 2
C 4  P21 P 21    P 1 21 1  P 1 1 21
C
C 5  B2  B 2               B 1 1 2
C 5  C2  C 2     C 1 2 1
C
C 
          IF(SGNAME.EQ.'P2' .OR.SGNAME.EQ.'P 2' .OR.
     *       SGNAME.EQ.'P21'.OR.SGNAME.EQ.'P 21'.OR.
     *       SGNAME.EQ.'B2' .OR.SGNAME.EQ.'B 2' .OR.
     *       SGNAME.EQ.'C2' .OR.SGNAME.EQ.'C 2'     ) THEN
            T  = PI/2.0
            ISETT = 2
            IF(ABS(CP_CELL(6)-T).GT.0.001.AND.
     *         ABS(CP_CELL(5)-T).LE.0.001     ) ISETT = 1
            IF(SGNAME.EQ.'P2'.OR.SGNAME.EQ.'P 2') THEN
              IF(ISETT.EQ.1) THEN
                SGNAME = 'P 1 1 2'
              ELSE
                SGNAME = 'P 1 2 1'
              ENDIF
            ELSE IF(SGNAME.EQ.'P21'.OR.SGNAME.EQ.'P 21') THEN
              IF(ISETT.EQ.1) THEN
                SGNAME = 'P 1 1 21'
              ELSE
                SGNAME = 'P 1 21 1'
              ENDIF
            ELSE IF(SGNAME.EQ.'B2'.OR.SGNAME.EQ.'B 2'.OR.
     *              SGNAME.EQ.'C2'.OR.SGNAME.EQ.'C 2'    ) THEN
              IF(ISETT.EQ.1) THEN
                SGNAME = 'B 1 1 2'
              ELSE
                SGNAME = 'C 1 2 1'
              ENDIF
            ENDIF
          ENDIF

        ENDIF

        CALL GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM,IPRSYM,IERR)

        IF(IERR.GT.0) RETURN
        IF(IERR.LT.0) RETURN

        CP_SPGR = SGNAME
        DO I=1,6
          CR_CELL(I)=CP_CELL(I)
        ENDDO 


        CALL FRORTH(CR_CELL(1),CR_CELL(2),CR_CELL(3)
     *           ,CR_CELL(4),CR_CELL(5),CR_CELL(6)
     *                         ,FRTOCR,CRTOFR,IERR)

        IF(FLAG_SC.EQ.'Y') THEN
          DO I=1,3
            DO J=1,3
              CR_SCALE(I,J)=CP_SCALE(I,J)
            ENDDO
            CR_U(I)=CP_U(I)
          ENDDO
        ELSE
          DO I=1,3
            DO J=1,3
              CR_SCALE(I,J)=CRTOFR(I,J)
            ENDDO
          ENDDO
        ENDIF

        DO I=1,3
          DO J=1,3
            CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
            CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          ENDDO
        ENDDO

C        CR_ORT_TO_FRAC(3,3)
C        CR_FRAC_TO_ORT(3,3)
C        CR_M_NCS(3,3)
C        CR_V_NCS(3)
C        CR_NCS

        CR_NSPGR    =NOSPGR
        CR_SETT     =ISETT
        CR_MULT_FLAG=0
        CR_MODEL    =CP_MODEL
        CR_CD_PDB   =CP_CODE
        CR_NAME_PDB =CP_CODE//CP_CODE//'    '//CP_NAME(1:28)
        CR_DATE_PDB =CP_DATE
        CR_TITLE    ='?   ?   '//CP_TITLE
        CR_RESL_PDB =CP_RESL
        CR_RFAC_PDB =CP_RFAC
        CR_SPGR     =SGNAME

        CALL C_AT_CR

        MD=-ABS(MDOC)-1

        IF(CP_PASS.EQ.2) THEN
          FNAME_OUT = FNAME
C         CALL REMOVE_PATH(FNAME_OUT)
          CALL LENSTR_BL(FNAME_OUT,LEN)
          IF(LEN.LE.0) THEN
            LINE = 'ERROR: readPDB: wrong output file name'
            IERR =1
            CALL MSGERR(MDOC,LINE)
            RETURN
          ENDIF
          IOUT = 11 
          CALL OWCRD(MD,IOUT,FNAME_OUT,NSYM,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,
     *      ' ERROR: readPDB: cannot open output file')
            CLOSE(IOUT) 
            RETURN
          ENDIF
          FNAME = FNAME_OUT        
        ENDIF
        IENDW=-1
        IFIRST=1
      ENDIF

      IF(CP_PASS.EQ.2) THEN
        IF(CP_MODEL.GT.0) THEN
          MODE = 1
          CR_LINE2 = ' '
          WRITE(CR_LINE,'(A,I4)') '#MODEL ',CP_MODEL
          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
          CP_MODEL = 0
        ENDIF
        IF(CP_MOLECULE.GT.0) THEN
          MODE = 1
          CR_LINE2 = ' '
          CR_LINE = CP_LINE
          CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
          CP_MOLECULE = 0
        ENDIF
      ENDIF

      MODE = 0
      IF(CP_NAN.EQ.1) CR_FLAG_USER='A'
      CR_PNUM  = CP_PNUM
      CR_IATOM = CP_IA
      CR_IRES  = CP_IRES
      CR_IATOLD= NA
      CR_IGROUP= CP_ICH
      WRITE(CH4,'(I4)') CP_ICH
      CR_CHAIN = CP_PNUM(1:2)
      CR_GROUP = CR_CHAIN//'  '
      CR_ALT   = CP_ALT
      CR_CORR  = '.'
      CR_ATYPE = '.'

      CALL MVMULT(CR_SCALE,CP_XYZ,Y)
      Y(1)=Y(1)+CR_U(1)
      Y(2)=Y(2)+CR_U(2)
      Y(3)=Y(3)+CR_U(3)
      CALL MVMULT(CR_FRAC_TO_ORT,Y,CP_XYZ)


      CR_XYZ(1)= CP_XYZ(1)
      CR_XYZ(2)= CP_XYZ(2)
      CR_XYZ(3)= CP_XYZ(3)
      CR_OCC   = CP_OCC
      CR_BISO  = CP_BISO
      IF(CR_BISO.LT.2.0) THEN
        CP_BTYPE = 'I'       
        CR_BISO  = 2.0
      ENDIF
      CR_ANAME = CP_ANAME
      CR_RNAME = CP_RNAME
      CR_ASYMB = CP_ASYMB

      CR_SURF  = CP_SURF
      CALL LENSTR_BL(CP_SEG,LG)
      IF(LG.LE.0) CP_SEG = '.'
      CR_SEG = CP_SEG
      IF(CP_ASYMB.EQ.'H   '.OR.CP_ASYMB.EQ.'D   ') NHATOM=NHATOM+1

      CR_BTYPE = CP_BTYPE 
      DO IAN=1,6
        CR_ANIS(IAN) = 0.0
      ENDDO
      IF(CP_BTYPE.EQ.'A') THEN
        DO IAN=1,6
          CR_ANIS(IAN) = CP_ANIS(IAN)
        ENDDO
      ENDIF

      CR_MULT_FACTOR =  1
C     IF(CR_ANAME.EQ.'O   '.AND.CR_RNAME.EQ.'HOH') NAHOH=NAHOH+1
      IF(CR_RNAME.EQ.'HOH'.OR.CR_RNAME.EQ.'DOD') THEN
        CR_ANAME='O   '
        NAHOH=NAHOH+1
      ENDIF
      IF(CP_PASS.EQ.2) THEN
        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: writePDB: WRITE OUTPUT_FILE')
          CLOSE(IOUT) 
          RETURN
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE JOINCRD(MDOC,NAMEC,NAMEC2,NAMEO
     * ,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------
C -P- JOINCRD - join two files of coordinates. 
C -S-
C
C  Dialog and Batch: 
C
C    FILE_C  - input file-1 of coordinates.
C    FILE_2  - input file-2 of coordinates.
C    FILE_O  - output file.
C
C  Parameters of subroutine JOINCRD: 
C
C      SUBROUTINE JOINCRD(MDOC,NAMEC,NAMEC2,NAMEO
C     * ,ISYM,IPRSYM,IERR)
C
C    MDOC   - mode of writting messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C    NAMEC  - name of input file-1 without extention.
C    NAMEC2 - name of input file-2 without extention.
C    NAMEO  - name of output file without extention.
C    ISYM   - integer*2 array for cryst.symmetry operators.
C    IPRSYM - dimension of integer*2 array ISYM(5,3,IPRSYM),
C             number of cryst. symm. operators.
C    IERR   - output signal of error / = 1 -error , = 0 - OK / 
C -I-
C ----------------------------------------------------------
      INTEGER     MDOC,IPRSYM,IERR
      INTEGER*2   ISYM(5,3,IPRSYM)
      CHARACTER   NAMEC*(*),NAMEC2*(*),NAMEO*(*)
C ----------------------------------------------------------------
C ---
      INCLUDE 'mr_crd_com.fh'
C ========================================================================
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
      CHARACTER LINE*80,CH5*5,CH2*2
C==================================================================
      NUM_MOL=IERR
      IF(NUM_MOL.LE.0) NUM_MOL=2 
      IERR= 0
C -------
      PI  = 4.0*ATAN(1.0)
      MD  = -ABS(MDOC)-1
      M   = 99
C --------
      IN  = 10
      CALL ORCRD(MD,IN,NAMEC,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: JOINCRD: cannot open input file_1')
        RETURN
      ENDIF
C --------
      IN2  = 11
      CALL ORCRD2(MD,IN2,NAMEC2,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: JOINCRD: cannot open input file_2')
        RETURN
      ENDIF
      CLOSE(IN2)
      CALL JOIN_LIST_CHAIN(NGR1,NGR2,NGR_SUM)
C
C      write(*,*)' --joincrd:',NGR1,NGR2,NGR_SUM
C
C --------
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.','.AND.NAMEO(1:1).NE.' ') THEN 
        IOUT=11
        CALL OWCRD(MD,IOUT,NAMEO,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: JOINCRD: cannot open output file')
          CLOSE(IN) 
          RETURN
        ENDIF
      ELSE
        IOUT=0
      ENDIF
C -------------------------------------------------
      NATOM = 0
      IEND  =-1
      IENDW =-1
C     WRITE(*,*) ' READ CRD'
C --------------------------------
 200  CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: JOINCRD: reading input file_1')
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN

C        IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
C     *     CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
C     *     CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
C     *    GO TO 1000

        NATOM=NATOM+1

      ENDIF      
C ----

      IF(IOUT.GT.0) THEN
        CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IN) 
          RETURN
        ENDIF
      ENDIF
      GO TO 200
C ------------------------------------------------------
 300  CONTINUE
      CLOSE(IN) 
C --------
      CALL ORCRD(MD,IN,NAMEC2,NSYM,ISYM,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: JOINCRD: cannot open input file_2.')
        RETURN
      ENDIF
C --------
      CR_LINE2 = ' '
      WRITE(CH5,'(I5)') NUM_MOL
      CR_LINE='#MOLECULE '//CH5
      MODE=1
      IF(IOUT.GT.0) THEN
        CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IN) 
          RETURN
        ENDIF
      ENDIF
      IEND  =-1
C --------------------------------
C
C
C      write(*,*)' --joincrd:',NGR1
C

 400  CONTINUE

      CALL RDCRD(M,IN,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IOUT)
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 500
      IF(MODE.EQ.0) THEN

C        IF(CR_ATYPE.NE.'.'.AND.CR_ATYPE.NE.' '.AND.
C     *     CR_ATYPE.NE.'y'.AND.CR_ATYPE.NE.'Y'.AND.
C     *     CR_ATYPE.NE.'r'.AND.CR_ATYPE.NE.'R')
C     *    GO TO 1000

        CR_IGROUP = CR_IGROUP + NGR1

        NATOM = NATOM+1
C
C      write(*,*)'  -----j:',NGR1, CR_IGROUP, NATOM
C
      ENDIF      
C ----

      IF(IOUT.GT.0) THEN
        CALL WRCRD(MD,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IN) 
          RETURN
        ENDIF
      ENDIF
      GO TO 400
C ------------------------------------------------------
 500  CONTINUE
      CLOSE(IN) 

      WRITE(LINE,'('' Number of atoms :'',I8)') NATOM
      CALL MSGDOC(MDOC,LINE)

      IENDW=1
      MODE=0     
      CALL WRCRD(MDOC,IOUT,MODE,IENDW,IERR)
C --------------------------------------
      RETURN
      END

      SUBROUTINE JOIN_LIST_CHAIN(NGR1,NGR2,NGR_SUM)
C ----------------------------------------
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      INTEGER   NMAX2,NGR2,NCH2,IGR2,ICH2,INC2,MLT2,IATM2
      CHARACTER NCSF*1,GID*4,NCSF2*1,GID2*4
C ----------------------------------------
      MDOC    = 0
      IERR    = 0
      NGR1    = 0
      NGR2    = 0
      NGR_SUM = 0
C ---
c      CALL CHECK_CHAIN_ID(INEW)
c      CALL CHECK_CHAIN_ID2(INEW)

      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) GO TO 900
      NGR1 = NGR
       
      IGR2  = 0
      CALL GET_ASYM2(MDOC,NMAX2,NGR2,NCH2,IGR2,ICH2,INC2,MLT2,IATM2
     *               ,NCSF2,GID2,IERR)
      IF(IERR.NE.0.OR.NGR2.LE.0) GO TO 900

C ---
      IGR = NGR
      DO IGR2=1,NGR2
        I2 = IGR2
        CALL GET_ASYM2(MDOC,NMAX2,NGR2,ICHOLD2,I2,ICH2,INC2
     *    ,MLT2,IGOLD2,NCSF2,GID2,IERR)

        IF(IERR.NE.0) GO TO 900
        IGR = IGR + 1
        IF(IGR.GT.NMAX) GO TO 900
        ICHOLD = IGR 
        ICH    = IGR
        INC    = INC2
        MLT    = MLT2
        IGOLD  = IGR  
        NCSF   = NCSF2 
        GID    = GID2
        CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
        I  = 0
        CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,I,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)

        IF(IERR.NE.0) GO TO 900
      ENDDO
      NGR_SUM = IGR

c      CALL CHECK_CHAIN_ID(INEW)

      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)

C ---
  900 CONTINUE
      IERR = 0
      RETURN
      END

      SUBROUTINE CHECK_CHAIN_ID_from_libutils(INEW)
C -----------------------------------------------
C  
C 
C -----------------------------------------------
      INTEGER*4 IERR,MDOC
      CHARACTER LINE*80
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -----------------------------------
C ---
      CHARACTER CH1*1,CH2*2
      INTEGER   NLETT
      CHARACTER LETT*66,GROUP_ID(66)*4
C     DATA NLETT /66/
C     DATA LETT/
C     *'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'/
C     *'qrstuvwxyz<>{}[]'/
C       123456789 123456789 123456789 123456789 123456789       
C ------------------------------------
C     PARAMETER (MAXCHAIN=50)
C     NLETT = 66
      NLETT = 50
      LETT  = 'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'//
     *        'qrstuvwxyz<>{}[]RSTUVWXYZ'
      MDOC = 0
      IERR = 0
      INEW = 0
      LNEW = 0
      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NGR.EQ.1) THEN
        IGR = 1
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(GID(1:1).EQ.' '.OR.GID(1:1).EQ.'.') THEN
          GID(1:1) = 'A'
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        RETURN
      ENDIF

      IF(NGR.GT.NLETT) GO TO 900

      DO IGR=1,NGR
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        GROUP_ID(IGR) = GID
      ENDDO

      DO I=2,NGR
        CH2 = GROUP_ID(I)(1:2) 
        DO J=1,I-1
          IF(CH2.EQ.GROUP_ID(J)(1:2)) GO TO 500
        ENDDO
      ENDDO
      RETURN

 500  CONTINUE

      DO I=1,NGR
        IF(GROUP_ID(I)(1:1).EQ.' ') GROUP_ID(I)(1:1) = '.' 
        GROUP_ID(I)(3:3) = GROUP_ID(I)(1:1) 
      ENDDO

      DO I=1,NGR

        CH1 = GROUP_ID(I)(1:1) 
         
        IF(NGR.LE.1) THEN
          IF(CH1.EQ.'.') CH1='A'
          GO TO 400
        ENDIF
        
        IF(I.EQ.1.AND.CH1.NE.'.') GO TO 200
        IF(I.GT.1.AND.CH1.NE.'.') THEN
          DO J=1,I-1
            IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 100
          ENDDO
          GO TO 200
        ENDIF

 100    CONTINUE

        DO K=1,NLETT
          CH1 = LETT(K:K)
          DO J=1,NGR
            IF(J.NE.I) THEN
              IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 300
            ENDIF
          ENDDO
          GO TO 400
 300      CONTINUE
        ENDDO

        LNEW = LNEW + 1
        IF(LNEW.GT.NLETT) LNEW = LNEW - NLETT
        CH1 =  LETT(LNEW:LNEW)        

 400    CONTINUE

        GROUP_ID(I)(1:1) = CH1

 200    CONTINUE

      ENDDO

      DO I=1,NGR
        CH1 = GROUP_ID(I)(3:3)
        IF(CH1.NE.GROUP_ID(I)(1:1)) INEW = 1

c        GROUP_ID(I)(2:2) = GROUP_ID(I)(1:1) 
c        GROUP_ID(I)(1:1) = CH1 

        GROUP_ID(I)(3:3) = ' '
        GROUP_ID(I)(4:4) = ' ' 
      ENDDO
C ----------------------
      IF(INEW.EQ.1) THEN
        DO IGR=1,NGR
          CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                      ,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
          GID = GROUP_ID(IGR)
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDDO
      ENDIF
      RETURN
C ----------------------
900   CONTINUE
      NCHAIN = 1
      IGR    = NCHAIN
      ICH    = IGR
      IGOLD  = IGR
      ICHOLD = IGR
      INC    = 0
      MLT    = 0
      IATM   = 0
      NCSF   = '.'
      GID    = 'AA  '
      INEW   = 1
      CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
      RETURN
      END

      SUBROUTINE CHECK_CHAIN_ID2(INEW)
C -----------------------------------------------
C  
C 
C -----------------------------------------------
      INTEGER*4 IERR,MDOC
      CHARACTER LINE*80
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -----------------------------------
C ---
      CHARACTER CH1*1,CH2*2
      INTEGER   NLETT
      CHARACTER LETT*66,GROUP_ID(66)*4
C     DATA NLETT /66/
C     DATA LETT/
C     *'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'/
C     *'qrstuvwxyz<>{}[]'/
C       123456789 123456789 123456789 123456789 123456789       
C ------------------------------------
C     PARAMETER (MAXCHAIN=50)
C     NLETT = 66
      NLETT = 50
      LETT  = 'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'//
     *        'qrstuvwxyz<>{}[]RSTUVWXYZ'
      MDOC = 0
      IERR = 0
      INEW = 0
      LNEW = 0
      IGR  = 0
      CALL GET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NGR.EQ.1) THEN
        IGR = 1
        CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(GID(1:1).EQ.' '.OR.GID(1:1).EQ.'.') THEN
          GID(1:1) = 'A'
          CALL SET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        RETURN
      ENDIF

      IF(NGR.GT.NLETT) GO TO 900

      DO IGR=1,NGR
        CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        GROUP_ID(IGR) = GID
      ENDDO

      DO I=2,NGR
        CH2 = GROUP_ID(I)(1:2) 
        DO J=1,I-1
          IF(CH2.EQ.GROUP_ID(J)(1:2)) GO TO 500
        ENDDO
      ENDDO
      RETURN

 500  CONTINUE

      DO I=1,NGR
        IF(GROUP_ID(I)(1:1).EQ.' ') GROUP_ID(I)(1:1) = '.' 
        GROUP_ID(I)(3:3) = GROUP_ID(I)(1:1) 
      ENDDO

      DO I=1,NGR

        CH1 = GROUP_ID(I)(1:1) 
         
        IF(NGR.LE.1) THEN
          IF(CH1.EQ.'.') CH1='A'
          GO TO 400
        ENDIF
        
        IF(I.EQ.1.AND.CH1.NE.'.') GO TO 200
        IF(I.GT.1.AND.CH1.NE.'.') THEN
          DO J=1,I-1
            IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 100
          ENDDO
          GO TO 200
        ENDIF

 100    CONTINUE

        DO K=1,NLETT
          CH1 = LETT(K:K)
          DO J=1,NGR
            IF(J.NE.I) THEN
              IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 300
            ENDIF
          ENDDO
          GO TO 400
 300      CONTINUE
        ENDDO

        LNEW = LNEW + 1
        IF(LNEW.GT.NLETT) LNEW = LNEW - NLETT
        CH1 =  LETT(LNEW:LNEW)        

 400    CONTINUE

        GROUP_ID(I)(1:1) = CH1

 200    CONTINUE

      ENDDO

      DO I=1,NGR
        CH1 = GROUP_ID(I)(3:3)
        IF(CH1.NE.GROUP_ID(I)(1:1)) INEW = 1

C        GROUP_ID(I)(2:2) = GROUP_ID(I)(1:1) 
C        GROUP_ID(I)(1:1) = CH1 

        GROUP_ID(I)(3:3) = ' '
        GROUP_ID(I)(4:4) = ' ' 
      ENDDO
C ----------------------
      IF(INEW.EQ.1) THEN
        DO IGR=1,NGR
          CALL GET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                      ,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
          GID = GROUP_ID(IGR)
          CALL SET_ASYM2(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDDO
      ENDIF
      RETURN
C ----------------------
900   CONTINUE
      NCHAIN = 1
      IGR    = NCHAIN
      ICH    = IGR
      IGOLD  = IGR
      ICHOLD = IGR
      INC    = 0
      MLT    = 0
      IATM   = 0
      NCSF   = '.'
      GID    = 'AA  '
      INEW   = 1
      CALL SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
      RETURN
      END

      SUBROUTINE FIT(MDOC,MODE,NAMEW,NAMER,NAMEO,WEIGHT
     *   ,POOL,MEMORY,DLIM,RESULT,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
C -P- 
C FIT      fits 2 sets of coordinates using least squares.
C          See also program 'ALIGN' which output files are
C          suitable for this program too.
C -S-   
C      Dialogue and batch:
C
C    FILE_W: - input file /WORKING MOLECULE,without extention "crd"/
C    FILE_R: - input file /REFERENCE MOLECULE,without extention "crd"/
C    FILE_O: - output file name /without extention "crd"/
C                            " " - means without output file
C                  Matching atoms:
C    MODE:   <Y>  - all
C             A   - only CA
C             O   - only O
C             B   - only back bond"s atoms
C             P   - only P
C    DLIM:   <0.0>  write information to DOC_file about
C                   atoms with deviation > DLIM (and if DLIM > 0)
C
C      It possible to use subroutine FIT by program:
C
C      SUBROUTINE FIT(MDOC,MODE,NAMEW,NAMER,NAMEO
C     *   ,POOL,MEMORY,DLIM,RESULT,ISYM,IPRSYM,IERR)
C
C  Parameters: 
C
C    MDOC  - mode of writing messages to DOC-file
C            0 - only terminal , < - 0 only file, 0 < < 99 - both
C            >= 99 - don't write  
C    MODE   - kind of matching atoms, see above.
C    NAMEW  - input file /WORKING MOLECULE,without extention "crd"/
C    NAMER  - input file /REFERENCE MOLECULE,without extention "crd"/
C    NAMEO  - output file name /without extention "crd"/
C    DLIM   <0.0>  write information to DOC_file about
C                   atoms with deviation > DLIM (and if DLIM > 0)
C    POOL    - real array POOL(MEMORY)
C    MEMORY  - dimension of array POOL, maximal number of atoms = MEMORY/12
C    ISYM    - integer*2 array for cryst.symmetry operators.
C    IPRSYM  - dimension of integer*2 array ISYM(5,3,IPRSYM),
C              number of cryst. symm. operators.
C    IERR    - output signal of error / =1 -error , =0 - OK / 
C
C    RESULT /real RESULT(11)/ - array for output information:
C
C      RESULT(1) = NUMBER OF ATOMS FOR MATCHING
C      RESULT(2) = RMS DISPLACEMENT
C      RESULT(3) = MAXIMUM DISPLACEMENT
C      RESULT(4) = ALPHA         ROTATION:
C      RESULT(5) = BETA        EILER ANGLES /DEGREES/  
C      RESULT(6) = GAMMA
C      RESULT(7) = TR(1)
C      RESULT(8) = TR(2) TRANSLATION VECTOR
C      RESULT(9) = TR(3)
C      RESULT(10)= THETA
C      RESULT(11)= PHI
C      RESULT(12)= CHI
C      RESULT(13)= DIST
C      RESULT(14)= DORT
C      RESULT(15)= DPAR 
C      RESULT(16)= IDIMER
C      RESULT(17)= RAD
C -I-
C --------------------------------------------------------
      REAL      POOL(MEMORY)
      REAL      DLIM
      REAL      RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NATMX,IPRSYM,MDOC,IERR
      CHARACTER NAMEW*(*),NAMER*(*),NAMEO*(*)
      CHARACTER MODE*1,WEIGHT*1
C ---------------------------------------
      NATMX  = (MEMORY*2)/28
      NATMX2 = NATMX/2

      I1  = 1
      I2  = NATMX2*6  +1
      I3  = NATMX2*12 +1
      I4  = NATMX2*14 +1
      I5  = NATMX2*16 +1
      I6  = NATMX2*17 +1
      I7  = NATMX2*18 +1
      I8  = NATMX2*20 +1
      I9  = NATMX2*22 +1
      I10 = NATMX2*24 +1
      I11 = NATMX2*26 +1
      I12 = NATMX2*27 +1

      CALL SFIT(MDOC,MODE,NAMEW,NAMER,NAMEO,WEIGHT
     *   ,POOL(I1),POOL(I2) ,POOL(I3) ,POOL(I4)
     *   ,POOL(I5),POOL(I6) ,POOL(I7) ,POOL(I8)
     *   ,POOL(I9),POOL(I10),POOL(I11),POOL(I12)
     *   ,NATMX,DLIM,RESULT,ISYM,IPRSYM,IERR)

      RETURN
      END

      SUBROUTINE SFIT(MDOC,MODE,NAMEW,NAMER,NAMEO,WEIGHT
     *   ,W,R,BW,BR
     *   ,IRESW,IRESR,ATOMW,ATOMR,RES3W,RES3R,CHAINW,CHAINR
     *   ,NATMX,DLIMR,RESULT,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
      REAL      DLIM
      REAL      RESULT(*)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NATMX,IPRSYM,MDOC,IERR
      CHARACTER NAMEW*(*),NAMER*(*),NAMEO*(*)
      CHARACTER MODE*1,WEIGHT*1
C ---------------------------------------
C ---
      INTEGER*2 IRESW(NATMX)
      REAL      W(3,NATMX),BW(NATMX)
      CHARACTER ATOMW(NATMX)*4,RES3W(NATMX)*3
      CHARACTER CHAINW(NATMX)*2
C ---
      INTEGER*2 IRESR(NATMX)
      REAL      R(3,NATMX),BR(NATMX)
      CHARACTER ATOMR(NATMX)*4,RES3R(NATMX)*3
      CHARACTER CHAINR(NATMX)*2
C ---------------------------------------
      INTEGER   NSYM
      REAL      TRMAT (3,3),TR (3),TRF(3),SCN(3),SCNF(3)
      REAL      CNTRX(3),CNTRY(3)
      REAL      TRMAT1(3,3),TR1(3)
      REAL      TRMAT2(3,3),TR2(3)
      CHARACTER LINE*80
      CHARACTER ACODE3(25)*3,CH3*3,CHW*1,CHR*1
      CHARACTER AMIN(25)
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','ASX','GLX','ACD','   ' 
     *           ,'   '/
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','B','Z','X','-',' '/
C======================================================================
      INCW = 21
      INCR = 22
      IOUT = 24
      IERR = 0
      MD   =-ABS(MDOC)-1
C ---
      DLIM   = DLIMR
      NCYCLE = 1
      IF(ABS(DLIM).LT.0.0001) THEN
        DLIM = 0.0
      ELSE IF(DLIM.LT.0.0) THEN
        DLIM   = ABS(DLIM)
        NCYCLE = 2
      ENDIF
C--------------------------------------
      IF(WEIGHT.EQ.'y') WEIGHT='Y'
      IF(WEIGHT.EQ.'c') WEIGHT='C'
      IF(WEIGHT.NE.'Y'.AND.WEIGHT.NE.'C') WEIGHT='N'
      IF(MODE.EQ.'a') MODE='A'
      IF(MODE.EQ.'o') MODE='O'
      IF(MODE.EQ.'b') MODE='B'
      IF(MODE.EQ.'p') MODE='P'
C--------------------------------------
      CALL ORCRD(MD,INCW,NAMEW,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE_W')
        RETURN
      ENDIF
      CALL C_AT_CR
C -----------
      CALL RDCOOR_FIT(MDOC,MODE,INCW,II,NW,W,BW,WEIGHT
     *        ,IRESW,CHAINW,ATOMW,RES3W,NATMX,RADW,IERR)
C ---------------------------------------
      IF(IERR.NE.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF WORKING MOLECULE = 0')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF WORKING MOLECULE                :'',I6)') 
     * NW
      CALL MSGDOC(MDOC,LINE)
      IF(II.LE.2) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF WORKING MOLECULE FOR MATCHING < 3')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF WORKING MOLECULE FOR MATCHING   :'',I6)')
     * II
      CALL MSGDOC(MDOC,LINE)
      NSW = II
C--------------------------------------
      CALL ORCRD(MD,INCR,NAMER,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE_R')
        RETURN
      ENDIF
C ---------------------------------------
      CALL RDCOOR_FIT(MDOC,MODE,INCR,II,NR,R,BR,WEIGHT
     *        ,IRESR,CHAINR,ATOMR,RES3R,NATMX,RADR,IERR)
C -----------
      IF(IERR.NE.0) RETURN
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF REFERENCE MOLECULE = 0')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF REFERENCE MOLECULE              :'',I6)')
     *  NR
      CALL MSGDOC(MDOC,LINE)
      IF(II.LE.2) THEN
        CALL MSGDOC(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF REFERENCE MOLECULE FOR MATCHING < 3')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF REFERENCE MOLECULE FOR MATCHING :'',I6)')
     * II 
      CALL MSGDOC(MDOC,LINE)
      NSR = II
C--------------------------------------
C -------------------------------------------------------------------
      IF(NSR.NE.NSW) THEN
        CALL MSGERR(MDOC,' ')
        CALL MSGERR(MDOC,
     *  ' ERR: ATOMS NUMBER OF REFERENCE MOLECULE FOR MATCHING')
        CALL MSGERR(MDOC,
     *'      NOT EQUAL ATOMS NUMBER OF WORKING MOLECULE FOR MATCHING')
        IERR=9
        RETURN
      ENDIF
C -------------------------------------------------------------------
      MD =-ABS(MDOC)-1
      IF(MODE.EQ.'A') THEN
        CALL MSGDOC(MD,' MATCHING ATOMS: ONLY CA')
      ELSE IF(MODE.EQ.'O') THEN
        CALL MSGDOC(MD,' MATCHING ATOMS: ONLY O')
      ELSE IF(MODE.EQ.'B') THEN
        CALL MSGDOC(MD,' MATCHING ATOMS: ONLY BACK BOND"S ATOMS')
      ELSE IF(MODE.EQ.'P') THEN
        CALL MSGDOC(MD,' MATCHING ATOMS: ONLY P')
      ELSE
        CALL MSGDOC(MD,' MATCHING ATOMS: ALL ')
      ENDIF
      WRITE(LINE,
     *'('' WRITE TO DOC-FILE ATOMS WITH DEVIATION < D-LIMIT ='',F8.3)'
     *) DLIM
      CALL MSGDOC(MD,LINE)
C ------------------------------------------------------------------
      NC = 0
 100  CONTINUE
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,'('' N_pairs ='',I8)') NSW
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      CALL LSKAB_FIT(MDOC,WEIGHT
     *  ,W,R,BW,BR,NSW,TRMAT,TR,SCN,CNTRX,CNTRY,DRMS,DISMAX,IERR)
      IF(IERR.GT.0) RETURN
      CALL ANGFIX(MDOC,TRMAT,ALPHA,BETA,GAMMA)
      NC = NC + 1
C ------------------------------------------------------------------
      WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     * (TR(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL OTOF(TR,TRF,IERR)
      WRITE(LINE,'('' TRANSLATION VECTOR/frac/ '',3(1X,F10.5))')
     *    (TRF(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' VECTOR W --> R           '',3(1X,F10.5))')
     * (SCN(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL OTOF(SCN,SCNF,IERR)
      WRITE(LINE,'('' VECTOR W --> R/frac/     '',3(1X,F10.5))')
     *    (SCNF(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)

      RAD = RADW
      IF(RADR.GT.RAD) RAD = RADR
      CALL CHECK_TRANS(ALPHA,BETA,GAMMA,SCN,RAD
     *                ,THETA,PHI,CHI,DIST,DORT,DPAR,IDIMER)
      WRITE(LINE,*) ' TFC(1->2):',THETA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) '  -d,ort,par:',DIST,DORT,DPAR
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) '  -d,ort,par:',DIST,DORT,DPAR
      CALL MSGDOC(MDOC,LINE)
      IF(IDIMER.GT.0) THEN
        WRITE(LINE,*) '  ---dimer'
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(DLIM.GE.0.0) THEN
        IFIRST  = 0
        NSW_NEW = 0
        MM      =-ABS(MDOC)-1
        ND      = 0
        DAVER   = 0.0
        D2AVER  = 0.0
        DO  I=1,NSW
          D = 0.0
          IF(BW(I).GT.0.01.AND.BR(I).GT.0.01.AND.WEIGHT.EQ.'C') THEN
            DO  J=1,3
              D = D + (W(J,I)-R(J,I))*(W(J,I)-R(J,I))
            ENDDO
          ELSE           
          ENDIF
          D = SQRT(ABS(D))
          IF(D.GE.DLIM) THEN
            IF(ABS(MDOC).GT.0.AND.ABS(MDOC).LT.99) THEN
              IF(IFIRST.EQ.0) THEN
                CALL MSGDOC(MM,' ')
                WRITE(LINE,20)
  20            FORMAT(11X,'WORKING MOLECULE',23X
     *          ,'REFERENCE MOLECULE  DEVIATION')
                CALL MSGDOC(MM,LINE)
                CALL MSGDOC(MM,' ')
                IFIRST=1
              ENDIF

              CH3 = RES3W(I)
              JJ  = 25
              DO     IJ=1,25
                IF(CH3.EQ.ACODE3(IJ)) JJ = IJ
              ENDDO
              CHW = AMIN(JJ)
              CH3 = RES3R(I)
              JJ  = 25
              DO     IJ=1,25
                IF(CH3.EQ.ACODE3(IJ)) JJ = IJ
              ENDDO
              CHR = AMIN(JJ)

              WRITE(LINE,'('' '',2(A4,1X,I4,A1,3F8.3,1X),F6.2)')
     *           ATOMW(I),IRESW(I),CHW,W(1,I),W(2,I),W(3,I)
     *          ,ATOMR(I),IRESR(I),CHR,R(1,I),R(2,I),R(3,I),D
            CALL MSGDOC(MM,LINE)
            ENDIF
          ELSE
            DAVER  = DAVER  + D
            D2AVER = D2AVER + D*D
          IF(BW(I).GT.0.01.AND.BR(I).GT.0.01.AND.WEIGHT.EQ.'C') THEN
            ND     = ND + 1
          ENDIF
            IF(NCYCLE.EQ.2.AND.NC.LT.NCYCLE) THEN
              NSW_NEW         = NSW_NEW + 1
              ATOMW(NSW_NEW)  = ATOMW(I)
              ATOMR(NSW_NEW)  = ATOMR(I)
              IRESW(NSW_NEW)  = IRESW (I)
              IRESR(NSW_NEW)  = IRESR (I)
              RES3W(NSW_NEW)  = RES3W(I)
              RES3R(NSW_NEW)  = RES3R(I)
              W(1,NSW_NEW)    = W(1,I)
              W(2,NSW_NEW)    = W(2,I)
              W(3,NSW_NEW)    = W(3,I)
              R(1,NSW_NEW)    = R(1,I)
              R(2,NSW_NEW)    = R(2,I)
              R(3,NSW_NEW)    = R(3,I)
              BW(NSW_NEW)     = BW(I)
              BR(NSW_NEW)     = BR(I)
              CHAINW(NSW_NEW) = CHAINW(I)
              CHAINR(NSW_NEW) = CHAINR(I)
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      IF(DLIM.GE.0.0.AND.ND.GT.0) THEN
        DAVER  = DAVER/ND
        D2AVER = D2AVER/ND
C        RMS    = SQRT(ABS(D2AVER - DAVER*DAVER))
        RMS    = SQRT(ABS(D2AVER))
        WRITE(LINE,'('' D_rms for atoms with D < DLIM ='',F10.3)') DLIM
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' N,D_rms,<D> :'',I6,2F10.3)') ND,RMS,DAVER
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      IF(NCYCLE.EQ.2.AND.NSW_NEW.GT.3) THEN
        IF(NC.LT.NCYCLE) THEN
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' --- Cycle 2 ----')
          NSW = NSW_NEW
          CALL MCOPY(TRMAT,TRMAT1)        
          CALL VCOPY(TR,TR1)        
          GO TO 100
        ELSE IF(NC.EQ.2) THEN
          CALL MCOPY(TRMAT,TRMAT2)        
          CALL VCOPY(TR,TR2)        
          CALL MVMULT(TRMAT2,TR1,TR)
          CALL VADD(TR,TR2,TR)
          CALL MATMLT(TRMAT2,TRMAT1,TRMAT)
          CALL MSGDOC(MDOC,' ')
          CALL MSGDOC(MDOC,' --- Final transformation ----')
          CALL MSGDOC(MDOC,' ')
          CALL ANGFIX(MDOC,TRMAT,ALPHA,BETA,GAMMA)
          WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     *    (TR(J),J=1,3)
          CALL MSGDOC(MDOC,LINE)
        ENDIF
      ENDIF
C ---------
      RESULT(1) = NSW
      RESULT(2) = DRMS
      RESULT(3) = DISMAX
      RESULT(4) = ALPHA
      RESULT(5) = BETA
      RESULT(6) = GAMMA
      RESULT(7) = TR(1)
      RESULT(8) = TR(2)
      RESULT(9) = TR(3)
      RESULT(10)= THETA
      RESULT(11)= PHI
      RESULT(12)= CHI
      RESULT(13)= DIST
      RESULT(14)= DORT
      RESULT(15)= DPAR 
      RESULT(16)= IDIMER
      RESULT(17)= RAD
      RESULT(18)= SCN(1)
      RESULT(19)= SCN(2)
      RESULT(20)= SCN(3)
C -----------------------------------------------------------
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.GT.0.AND.NAMEO(1:1).NE.' '.AND.NAMEO(1:1).NE.',') THEN
        MD =-ABS(MDOC)-1
        CALL OWCRD(MD,IOUT,NAMEO,NSYM,ISYM
     *             ,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN OUTPUT_FILE')
          RETURN
        ENDIF
      ELSE
        IOUT = 0
      ENDIF
      IF(IOUT.LE.0) RETURN
C--------------------------------------
      MD =-ABS(MDOC)-1
      CALL ORCRD(MD,INCW,NAMEW,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE_W')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C ---------
      CALL WRCOOR_FIT(MDOC,INCW,IOUT,TRMAT,TR,IERR)
C ---------
      RETURN
      END
      
      SUBROUTINE WRCOOR_FIT(MDOC,INC,IOUT,TRMAT,TR,IERR)
C ----------------------------------------------------------
      INTEGER MDOC,INC,IOUT,IERR
      REAL TRMAT(3,3),TR(3)
C ----------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      REAL XII(3)
C -----------------------------------------------------------
      MODE  = 0
      IEND  =-1
      IENDW =-1
      M     = 99
C -------------------------------------------------------------------
 200  CONTINUE

      CALL RDCRD(M,INC,MODE,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
          CLOSE(INC) 
          CLOSE(IOUT) 
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MODE.EQ.0) THEN

        IF((CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *      CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *      CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R').AND.
     *      CR_OCC .GT.0.0001                        ) THEN
          DO     II=1,3
            XII(II) = TRMAT(1,II)*CR_XYZ(1)
     *               +TRMAT(2,II)*CR_XYZ(2)
     *               +TRMAT(3,II)*CR_XYZ(3)
          ENDDO
          DO     J=1,3
            XII(J) = XII(J)+TR(J)
          ENDDO

          CR_XYZ(1) = XII(1)
          CR_XYZ(2) = XII(2)
          CR_XYZ(3) = XII(3)

        ELSE

          CR_XYZ(1) = 0.0
          CR_XYZ(2) = 0.0
          CR_XYZ(3) = 0.0
          CR_BISO   = 0.0
   
        ENDIF

        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(INC) 
          RETURN
        ENDIF


      ELSE

        CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(INC) 
          RETURN
        ENDIF

      ENDIF



      GO TO 200
 300  CONTINUE
      CLOSE(INC) 
      IENDW = 1
      MODE  = 0
      CALL WRCRD(M,IOUT,MODE,IENDW,IERR)
      RETURN
      END

      SUBROUTINE RDCOOR_FIT(MDOC,MODE,INC,NCRDR,N,X,BX,WEIGHT
     *        ,IRES,CHAIN,ATOM,RES3,NATMX,RI,IERR)
C ---------------------------------------
      INTEGER   MDOC,INC,NCRDR,N,NATMX,IERR
      INTEGER*2 IRES(NATMX)
      REAL      X(3,NATMX),BX(NATMX)
      CHARACTER ATOM(NATMX)*4,RES3(NATMX)*3
      CHARACTER CHAIN(NATMX)*2
      CHARACTER MODE*1,WEIGHT*1
C ---------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      CHARACTER LINE*80
C -------------------------------------------------------------------
      N    = 0
      NA   = 0
      IEND =-1
      IERR = 0
      M    = 99
      MOD  = 0
      II   = 0
      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.
      RI   = 0.0
C -------------------------------------------------------------------
 200  CONTINUE

      CALL RDCRD(M,INC,MOD,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MOD.EQ.0) THEN

        IF(CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *      CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *      CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R') THEN
             
          IF(CR_ALT.NE.'.'.AND.CR_ALT.NE.' '.AND.
     *       CR_ALT.NE.'A'.AND.CR_ALT.NE.'1'     ) GO TO 200

          N = N+1
          IF(MODE.EQ.'A'.OR.MODE.EQ.'P'.OR.MODE.EQ.'O'.OR
     *      .MODE.EQ.'B') THEN
            IF( CR_ANAME.EQ.'CA  '.AND.MODE.EQ.'A')          GO TO 500
            IF( CR_ANAME.EQ.'P   '.AND.MODE.EQ.'P')          GO TO 500
            IF( CR_ANAME.EQ.'O   '.AND.MODE.EQ.'O')          GO TO 500
            IF((CR_ANAME.EQ.'CA  '.OR.CR_ANAME.EQ.'N   '.OR.
     *          CR_ANAME.EQ.'C   '.OR.CR_ANAME.EQ.'O   ').AND.
     *                                         MODE.EQ.'B')  GO TO 500
            GO TO 530
          ENDIF
  500     CONTINUE

          IF(CR_OCC.GT.0.0001.OR.WEIGHT.EQ.'C') THEN

            II = II+1
            IF(II.GT.NATMX) THEN
              WRITE(LINE,*) ' ERR: TOO MANY ATOMS > ',NATMX
              CALL MSGERR(MDOC,LINE)
              IERR=1
              RETURN
            ENDIF
            ATOM(II)  = CR_ANAME
            RES3(II)  = CR_RNAME
            CHAIN(II) = CR_CHAIN
            IRES(II)  = CR_IRES
c           X(1,II)   = CR_XYZ(1)/CR_BISO
c           X(2,II)   = CR_XYZ(2)/CR_BISO
c           X(3,II)   = CR_XYZ(3)/CR_BISO
            X(1,II)   = CR_XYZ(1)
            X(2,II)   = CR_XYZ(2)
            X(3,II)   = CR_XYZ(3)
            BX(II)    = CR_BISO

            IF(CR_OCC.LE.0.0001.AND.WEIGHT.EQ.'C') THEN
              BX(II)    = 0.0
            ENDIF

            IF(CR_OCC.GT.0.0001) THEN
              NA = NA + 1
              XS=XS+X(1,II)
              YS=YS+X(2,II)
              ZS=ZS+X(3,II)
              XS2=XS2+X(1,II)*X(1,II)
              YS2=YS2+X(2,II)*X(2,II)
              ZS2=ZS2+X(3,II)*X(3,II)
            ENDIF
          ENDIF

 530      CONTINUE
        ENDIF
      ENDIF
      GO TO 200
C ---------------------------------
  300 CONTINUE
      IF(NA.GT.0) THEN
        XS  = XS/NA
        YS  = YS/NA
        ZS  = ZS/NA
        XS2 = XS2/NA
        YS2 = YS2/NA
        ZS2 = ZS2/NA
        RX  = XS2-XS*XS
        RY  = YS2-YS*YS
        RZ  = ZS2-ZS*ZS
        RI  = SQRT(ABS(RX+RY+RZ))
      ENDIF
      NCRDR = II
      CLOSE (INC)
      RETURN
      END

      SUBROUTINE LSKAB_FIT(MDOC,WEIGHT
     *  ,X,Y,BX,BY,NX,TRMAT,TR,SCN,CNTRX,CNTRY,DRMS,DISMAX,IERR)
C ---------------------------------------------------------
C
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     Y      CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NX     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION
C            MATRIX
C --------------------------------------------------------
      REAL X(3,*),Y(3,*),BX(*),BY(*),CNTRX(3),CNTRY(3),SCN(3)
      REAL TR(3),TRMAT(3,3),RK(3,3),RKTRK(3,3),R(3),VP(3,3)
      REAL RA(3,3),RANR(3,3),E(3),XT(3),XNORM(3)
      CHARACTER LINE*80,WEIGHT*1
C ----------------------------------------------------------------
      IERR=0
C
C     CALCULATE CENTROIDS
C
      DO     I=1,3
        SCN(I)   = 0.0
        CNTRY(I) = 0.0
        CNTRX(I) = 0.0
      ENDDO
      WSY = 0.0
      WSX = 0.0
      DO     I=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(I)
          WX = 1.0/BX(I)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     J=1,3
          CNTRY(J) = CNTRY(J) + Y(J,I) * WY
          CNTRX(J) = CNTRX(J) + X(J,I) * WX
C          CNTRY(J) = CNTRY(J) + Y(J,I)
C          CNTRX(J) = CNTRX(J) + X(J,I) 
        ENDDO
        WSY = WSY +  WY
        WSX = WSX +  WX
C        WEIGHTY = WEIGHTY +  1.0
C        WEIGHTY = WEIGHTY +  1.0
      ENDDO
      DO     J=1,3
        CNTRX(J) = CNTRX(J)/WSX
        CNTRY(J) = CNTRY(J)/WSY
      ENDDO
C
C     TRANSLATE WORKING AND REFERENCE MOLECULES TO ORIGIN
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I) - CNTRX(J)
        Y(J,I) = Y(J,I) - CNTRY(J)
      ENDDO
      ENDDO
C
      DISMAX = 0.0
      SUMD2  = 0.0
      SUMDIS = 0.0
C
C    GET MATRIX R = SUM(Y.X)
C
      DO     I=1,3
      DO     J=1,3
        RK(I,J) = 0.0
      ENDDO
      ENDDO
      DO     IA=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(IA)
          WX = 1.0/BX(IA)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     I=1,3
        DO     J=1,3
          RK(I,J) = RK(I,J)+Y(I,IA)*X(J,IA)*WY*WX
C          RK(I,J)=RK(I,J)+Y(I,IA)*X(J,IA)
        ENDDO
        ENDDO
      ENDDO
C
C      EZERO VALUE
C
      EZERO = 0.0
      DO     IA=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(IA)
          WX = 1.0/BX(IA)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     I=1,3
          EZERO = EZERO+(X(I,IA)*X(I,IA)*WX*WX+Y(I,IA)*Y(I,IA)*WY*WY)
C          EZERO=EZERO+(X(I,IA)*X(I,IA)+Y(I,IA)*Y(I,IA))
        ENDDO
      ENDDO
      EZERO = EZERO*0.5
C
C      GET RKTRK  =  RKTRANSPSED  *  RK
C
      DO     I=1,3
      DO     J=1,3
        RKTRK(I,J) = 0.0
        DO     K=1,3
          RKTRK(I,J) = RKTRK(I,J)+RK(K,I)*RK(K,J)
        ENDDO
      ENDDO
      ENDDO
C
C      CALL NAG ROUTINE :  EIGENVALUES IN  R
C                       :  EIGENVECTORS NORMALIZED IN VP
C                           (SORTED IN ASCENDING ORDER)
C                           (E   WORKING ARRAY)
C
      IFAIL = 0
      CALL F02ABF(RKTRK,3,3,R,VP,3,E,IFAIL)
      IF (IFAIL.NE.0) THEN
        IERR = 1
        WRITE(MDOC,10) IFAIL
   10   FORMAT
     *  (' ERR: ERROR DETECTED BY NAG LIBRARY ROUTINE - IFAIL=',I5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,11) IFAIL
   11   FORMAT ('     ',I5,5X,' DIAGONALISATION FAILED')
        CALL MSGDOC(MDOC,LINE)
        RETURN
      ENDIF
C
C      SET VP(.1)=VP(.,3) X VP(.,2)
C
      VP(1,1) = VP(2,3)*VP(3,2)-VP(3,3)*VP(2,2)
      VP(2,1) = VP(3,3)*VP(1,2)-VP(1,3)*VP(3,2)
      VP(3,1) = VP(1,3)*VP(2,2)-VP(2,3)*VP(1,2)
C
C     GET  RA = R . V
C
      DO     K=1,3
      DO     I=1,3
        RA(I,K) = 0.0
        DO     J=1,3
          RA(I,K) = RA(I,K)+RK(I,J)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO
C
C      NORM.   RA(.,2) & RA(.3)
C
      DO     J=2,3
        XNORM(J) = 0.0
        DO     I=1,3
          XNORM(J) = XNORM(J)+RA(I,J)*RA(I,J)
        ENDDO
        XNORM(J) = 1./SQRT(ABS(XNORM(J)))
      ENDDO
      DO     J=2,3
      DO     I=1,3
        RANR(I,J) = RA(I,J)*XNORM(J)
      ENDDO
      ENDDO
C
C      SET RANR(.,1) = RANR(.,3) X RANR(.,2)
C
      RANR(1,1) = RANR(2,3)*RANR(3,2) - RANR(3,3)*RANR(2,2)
      RANR(2,1) = RANR(3,3)*RANR(1,2) - RANR(1,3)*RANR(3,2)
      RANR(3,1) = RANR(1,3)*RANR(2,2) - RANR(2,3)*RANR(1,2)
C
C   GET SCALAR PRODUCT  RANR(.,1) . RA(.,1)     & SIGMA VALUE
C
C     SCPD=0.0
C     DO     I=1,3
C       SCPD=RANR(I,1)*RA(I,1)
C     ENDDO
C     SIGMA = 1.
C     IF (SCPD.LT.0) SIGMA=-1.
C     RES = EZERO -SQRT(ABS(R(2)))-SQRT(ABS(R(3)))-SIGMA*SQRT(ABS(R(1)))
C
C      TRANSFORMATION MATRIX
C
      DO     I=1,3
      DO     J=1,3
        TRMAT(I,J) = 0.0
        DO     K=1,3
          TRMAT(I,J) = TRMAT(I,J)+RANR(I,K)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO
C
C
C      CALCULATE RESIDUALS & FIGURES OF MERIT
C
      DO     IA=1,NX
        DO     I=1,3
          XT(I) = 0.0
          DO     J=1,3
            XT(I) = XT(I) + TRMAT(I,J)*X(J,IA)
          ENDDO
        ENDDO
        DO     I=1,3
          X(I,IA) = XT(I)
        ENDDO
        D = 0.0
        DO     J=1,3
          D = D +(X(J,IA)-Y(J,IA))*(X(J,IA)-Y(J,IA))
        ENDDO
        SUMD2  = SUMD2 + D
        D      = SQRT(ABS(D))
        SUMDIS = SUMDIS +D
        DISMAX = AMAX1(DISMAX,D)
      ENDDO
      DRMS   = SQRT(ABS(SUMD2/NX))
      SUMDIS = SUMDIS/NX
C
      WRITE(LINE,40) SUMD2
 40   FORMAT('SUM DISPLACEMENTS**2      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,41) DRMS
 41   FORMAT('RMS DISPLACEMENT          =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,42) SUMDIS
 42   FORMAT('AVERAGE DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,43) DISMAX
 43   FORMAT('MAXIMUM DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
C
C
C     ADD REFERENCE MOLECULE CENTROID TO WORKING MOLECULE COORDS.
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I)+CNTRY(J)
      ENDDO
      ENDDO
C
C     SHIFT REFERENCE MOLECULE TO ORIGINAL POSITION
C
      DO     II=1,NX
      DO     J=1,3
        Y(J,II) = Y(J,II)+CNTRY(J)
      ENDDO
      ENDDO
C
C  FIND TRANSLATION  T = -TRMAT * CTRX   +CNTRY
C
      TR(1)=
     *  -TRMAT(1,1)*CNTRX(1)-TRMAT(1,2)*CNTRX(2)-TRMAT(1,3)*CNTRX(3)
      TR(2)=
     *  -TRMAT(2,1)*CNTRX(1)-TRMAT(2,2)*CNTRX(2)-TRMAT(2,3)*CNTRX(3)
      TR(3)=
     *  -TRMAT(3,1)*CNTRX(1)-TRMAT(3,2)*CNTRX(2)-TRMAT(3,3)*CNTRX(3)

      SCN(1)= CNTRY(1) - CNTRX(1)
      SCN(2)= CNTRY(2) - CNTRX(2)
      SCN(3)= CNTRY(3) - CNTRX(3)

      TR(1) = TR(1) + CNTRY(1)
      TR(2) = TR(2) + CNTRY(2)
      TR(3) = TR(3) + CNTRY(3)
      TEMP       = TRMAT(1,2)
      TRMAT(1,2) = TRMAT(2,1)
      TRMAT(2,1) = TEMP
      TEMP       = TRMAT(1,3)
      TRMAT(1,3) = TRMAT(3,1)
      TRMAT(3,1) = TEMP
      TEMP       = TRMAT(2,3)
      TRMAT(2,3) = TRMAT(3,2)
      TRMAT(3,2) = TEMP

      RETURN
      END

      SUBROUTINE F02ABF(A, IA, N, R, V, IV, E, IFAIL)
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C
C     EIGENVALUES AND EIGENVECTORS OF A REAL SYMMETRIX MATRIX
C     1ST AUGUST 1971
C
      INTEGER  ISAVE, IFAIL, N, IA, IV
      REAL     A(IA,N), R(N), V(IV,N), E(N)
      REAL     X02AAF,TOL
C ----------------------------
      X02AAF = 2.380 E-7
C -----------
      ISAVE = IFAIL
      IFAIL = 1
      TOL   = X02AAF
      CALL F01AJF(N, TOL, A, IA, R, E, V, IV)
      TOL = X02AAF
      CALL F02AMF(N, TOL, R, E, V, IV, IFAIL)
      IF (IFAIL.NE.0) THEN
        ISAVE = IFAIL
      ENDIF
      RETURN
      END

C      FUNCTION X02AAF
C      DOUBLE PRECISION FUNCTION X02AAF
C      X02AAF = 2.380 E-7
C      RETURN
C      END

      SUBROUTINE F02AMF(N, ACHEPS, D, E, Z, IZ, IFAIL)
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 9 REVISED. IER-326 (SEP 1981).
C
C     TQL2
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS OF A
C     TRIDIAGONAL MATRIX, T, GIVEN WITH ITS DIAGONAL ELEMENTS IN
C     THE ARRAY D(N) AND ITS SUB-DIAGONAL ELEMENTS IN THE LAST N
C     - 1 STORES OF THE ARRAY E(N), USING QL TRANSFORMATIONS. THE
C     EIGENVALUES ARE OVERWRITTEN ON THE DIAGONAL ELEMENTS IN THE
C     ARRAY D IN ASCENDING ORDER. THE EIGENVECTORS ARE FORMED IN
C     THE ARRAY Z(N,N), OVERWRITING THE ACCUMULATED
C     TRANSFORMATIONS AS SUPPLIED BY THE SUBROUTINE F01AJF. THE
C     SUBROUTINE WILL FAIL IF ALL EIGENVALUES TAKE MORE THAN 30*N
C     ITERATIONS.
C     1ST APRIL 1972
C
      INTEGER ISAVE, IFAIL, N, I, L, J, M, I1, M1, II, K, IZ
      REAL    B, F, H, G, P, R, C, S, D(N), E(N), Z(IZ,N)
      REAL    ACHEPS
C -----------------------------------
      ISAVE = IFAIL
      IF(N.NE.1) THEN
        DO     I=2,N
           E(I-1) = E(I)
        ENDDO
      ENDIF
      E(N) = 0.0
      B    = 0.0
      F    = 0.0
      J    = 30*N
      DO     L=1,N
         H = ACHEPS*(ABS(D(L))+ABS(E(L)))
         IF(B.LT.H) B = H
C        LOOK FOR SMALL SUB-DIAG ELEMENT
         DO     M=L,N
            IF (ABS(E(M)).LE.B) GO TO 80
         ENDDO
   80    IF(M.EQ.L) GO TO 280
  100    IF(J.LE.0) THEN
           IFAIL = 1
           RETURN
         ENDIF
         J = J - 1
C        FORM SHIFT
         G = D(L)
         H = D(L+1) - G
         IF(ABS(H).LT.ABS(E(L))) THEN
           P = H*0.5/E(L)
           R = SQRT(ABS(P*P+1.0))
           H = P + R
           IF (P.LT.0.0) H = P - R
           D(L) = E(L)/H
         ELSE
           P = 2.0*E(L)/H
           R = SQRT(ABS(P*P+1.0))
           D(L) = E(L)*P/(1.0+R)
         ENDIF
         H  = G - D(L)
         I1 = L + 1
         IF(I1.LE.N) THEN
           DO     I=I1,N
             D(I) = D(I) - H
           ENDDO
         ENDIF
         F = F + H
C     QL TRANSFORMATION
         P = D(M)
         C = 1.0
         S = 0.0
         M1 = M - 1
         DO     II=L,M1
            I = M1 - II + L
            G = C*E(I)
            H = C*P
            IF(ABS(P).GE.ABS(E(I))) THEN
              C      = E(I)/P
              R      = SQRT(ABS(C*C+1.0))
              E(I+1) = S*P*R
              S      = C/R
              C      = 1.0/R
            ELSE
              C      = P/E(I)
              R      = SQRT(ABS(C*C+1.0))
              E(I+1) = S*E(I)*R
              S      = 1.0/R
              C      = C/R
            ENDIF
            P      = C*D(I) - S*G
            D(I+1) = H + S*(C*G+S*D(I))
C           FORM VECTOR
            DO     K=1,N
               H        = Z(K,I+1)
               Z(K,I+1) = S*Z(K,I) + C*H
               Z(K,I)   = C*Z(K,I) - S*H
            ENDDO
         ENDDO
         E(L) = S*P
         D(L) = C*P
         IF(ABS(E(L)).GT.B) GO TO 100
  280    D(L) = D(L) + F
      ENDDO
C     ORDER EIGENVALUES AND EIGENVECTORS
      DO     I=1,N
         K  = I
         P  = D(I)
         I1 = I + 1
         IF(I1.LE.N) THEN
           DO     J=I1,N
              IF(D(J).LT.P) THEN
                K = J
                P = D(J)
              ENDIF
           ENDDO
         ENDIF
         IF(K.NE.I) THEN
           D(K) = D(I)
           D(I) = P
           DO     J=1,N
              P = Z(J,I)
              Z(J,I) = Z(J,K)
              Z(J,K) = P
           ENDDO
         ENDIF
      ENDDO
      IFAIL = 0
      END

      SUBROUTINE F01AJF(N, ATOL, A, IA, D, E, Z, IZ)
C
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C
C     TRED2
C     THIS SUBROUTINE REDUCES THE GIVEN LOWER TRIANGLE OF A
C     SYMMETRIC MATRIX, A, STORED IN THE ARRAY A(N,N), TO
C     TRIDIAGONAL FORM USING HOUSEHOLDERS REDUCTION. THE DIAGONAL
C     OF THE RESULT IS STORED IN THE ARRAY D(N) AND THE
C     SUB-DIAGONAL IN THE LAST N - 1 STORES OF THE ARRAY E(N)
C     (WITH THE ADDITIONAL ELEMENT E(1) = 0). THE TRANSFORMATION
C     MATRICES ARE ACCUMULATED IN THE ARRAY Z(N,N). THE ARRAY
C     A IS LEFT UNALTERED UNLESS THE ACTUAL PARAMETERS
C     CORRESPONDING TO A AND Z ARE IDENTICAL.
C     1ST AUGUST 1971
C
      INTEGER I, IA, II, IZ, J1, J, K, L, N
      REAL F, G, H, HH, A(IA,N), D(N), E(N), Z(IZ,N)
      REAL*4 ATOL
      DO     I=1,N
        DO     J=1,I
          Z(I,J) = A(I,J)
        ENDDO
      ENDDO
      IF(N.NE.1) THEN
        DO     II=2,N
          I = N - II + 2
          L = I - 2
          F = Z(I,I-1)
          G = 0.0
          IF(L.GT.0) THEN
            DO     K=1,L
              G = G + Z(I,K)*Z(I,K)
            ENDDO
          ENDIF
          H = G + F*F
C         IF G IS TOO SMALL FOR ORTHOGONALITY TO BE
C         GUARANTEED THE TRANSFORMATION IS SKIPPED
          IF(G.LE.ATOL) THEN
            E(I) = F
            H    = 0.0
            GO TO 240
          ENDIF
  100     L = L + 1
          G = SQRT(ABS(H))
          IF(F.GE.0.0) G = -G
          E(I) = G
          H    = H - F*G
          Z(I,I-1) = F - G
          F = 0.0
          DO     J=1,L
            Z(J,I) = Z(I,J)/H
            G      = 0.0
C           FORM ELEMENT OF A*U
            DO     K=1,J
              G = G + Z(J,K)*Z(I,K)
            ENDDO
            J1 = J + 1
            IF(J1.LE.L) THEN
              DO     K=J1,L
                G = G + Z(K,J)*Z(I,K)
              ENDDO
            ENDIF
C           FORM ELEMENT OF P
            E(J) = G/H
            F    = F + G*Z(J,I)
          ENDDO
C         FORM K
          HH = F/(H+H)
C         FORM REDUCED A
          DO     J=1,L
            F = Z(I,J)
            G = E(J) - HH*F
            E(J) = G
            DO     K=1,J
              Z(J,K) = Z(J,K) - F*E(K) - G*Z(I,K)
            ENDDO
          ENDDO
  240     D(I) = H
        ENDDO
      ENDIF
      E(1) = 0.0
      D(1) = 0.0
C     ACCUMULATION OF TRANSFORMATION MATRICES
      DO     I=1,N
        L = I - 1
        IF(D(I).NE.0.0) THEN
          DO     J=1,L
            G = 0.0
            DO     K=1,L
              G = G + Z(I,K)*Z(K,J)
            ENDDO
            DO     K=1,L
              Z(K,J) = Z(K,J) - G*Z(K,I)
            ENDDO
          ENDDO
        ENDIF
        D(I)   = Z(I,I)
        Z(I,I) = 1.0
        IF(L.NE.0) THEN
          DO     J=1,L
            Z(I,J) = 0.0
            Z(J,I) = 0.0
          ENDDO
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE CHECK_TRANS(A2,B2,G2,W,RAD
     *         ,THETA,PHI,CHI,DIST,DORT,DPAR,IDIMER)
C -------------------------------------------------------------
      REAL W(3),X(3),XX(3),Z(3)
      REAL CM(3,3)
C -------------------------------------------------------------
      PI   = 4.0*ATAN(1.0)

      IDIMER = 0
      A  = (A2*PI)/180.0
      B  = (B2*PI)/180.0
      G  = (G2*PI)/180.0
      CALL EULERM(A,B,G,CM)                                   
C       rot 1-->2: 
      CALL MTOPOL(CM,THETA,PHI,CHI)

      TH  = (THETA*PI)/180.0
      PH  = (PHI  *PI)/180.0
      CH  = PI
      CALL POLTOM(TH,PH,CH,CM)

      CALL MVMULT(CM,W,XX)
      CALL VSUB(XX,W,X)
      S = 0.5
      CALL VSCAL(X,S,Z)
      CALL VMOD(Z,DORT)

      CALL VADD(W,Z,XX)
      CALL VMOD(XX,DPAR)

      CALL VMOD(W,DIST)

      IF(RAD.GT.0.001) THEN
        RAD_MOD_LIM = 3.0*RAD
        IF(DORT.LE.RAD_MOD_LIM.AND.DPAR.LE.2.5.AND.
     *     ABS(ABS(CHI)-180.0).LE.2.5) THEN
          IDIMER = 1
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE CHECK_FIT(MDOC,NAMEW,NAMER
     *   ,NAMEO1,NAMEO2,ANG_LIM,DIST_LIM
     *   ,POOL,MEMORY,DLIM,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
C      RESULT(1) = NPAIR_INI
C      RESULT(3) = DRMS_INI
C      RESULT(4) = DMAX_INI
C      RESULT(5) = CHI_INI
C      RESULT(6) = DIST_INI
C      RESULT(7) = NPAIR_BEST
C      RESULT(8) = DRMS_BEST
C      RESULT(9) = DMAX_BEST
C      RESULT(10)= CHI_BEST
C      RESULT(11)= DIST_BEST
C      RESULT(1) = NPAIR
C --------------------------------------------------------
      REAL      POOL(MEMORY)
      REAL      DLIM
      REAL      RESULT(IPRROW)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NATMX,IPRSYM,MDOC,IERR
      CHARACTER NAMEW*(*),NAMER*(*),NAMEO1*(*),NAMEO2*(*)
C ---------------------------------------
      NATMX  = (MEMORY*2)/28
      NATMX2 = NATMX/2

      I1  = 1
      I2  = NATMX2*6  +1
      I3  = NATMX2*12 +1
      I4  = NATMX2*14 +1
      I5  = NATMX2*16 +1
      I6  = NATMX2*17 +1
      I7  = NATMX2*18 +1
      I8  = NATMX2*20 +1
      I9  = NATMX2*22 +1
      I10 = NATMX2*24 +1
      I11 = NATMX2*26 +1
      I12 = NATMX2*27 +1

      CALL SCHECK_FIT(MDOC,NAMEW,NAMER
     *   ,NAMEO1,NAMEO2,ANG_LIM,DIST_LIM
     *   ,POOL(I1),POOL(I2) ,POOL(I3) ,POOL(I4)
     *   ,POOL(I5),POOL(I6) ,POOL(I7) ,POOL(I8)
     *   ,POOL(I9),POOL(I10),POOL(I11),POOL(I12)
     *   ,NATMX,DLIM,RESULT,IPRROW,ISYM,IPRSYM,IERR)

      RETURN
      END

      SUBROUTINE SCHECK_FIT(MDOC,NAMEW,NAMER
     *   ,NAMEO1,NAMEO2,ANG_LIM,DIST_LIM
     *   ,W,R,BW,BR
     *   ,IRESW,IRESR,ATOMW,ATOMR,RES3W,RES3R,CHAINW,CHAINR
     *   ,NATMX,DLIMR,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C --------------------------------------------------------
      REAL      DLIM
      REAL      RESULT(IPRROW)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NATMX,IPRSYM,MDOC,IERR
      CHARACTER NAMEW*(*),NAMER*(*),NAMEO1*(*),NAMEO2*(*)
C ---------------------------------------
C ---
      INTEGER*2 IRESW(NATMX)
      REAL      W(3,NATMX),BW(NATMX)
      CHARACTER ATOMW(NATMX)*4,RES3W(NATMX)*3
      CHARACTER CHAINW(NATMX)*2
C ---
      INTEGER*2 IRESR(NATMX)
      REAL      R(3,NATMX),BR(NATMX)
      CHARACTER ATOMR(NATMX)*4,RES3R(NATMX)*3
      CHARACTER CHAINR(NATMX)*2
C ---------------------------------------
      CHARACTER MODE*1,WEIGHT*1
      INTEGER   NSYM
      CHARACTER LINE*80
      REAL      TR(3),TRMAT(3,3)
      REAL      CNTRX_INI(3),CNTRX_BEST(3)
      REAL      CNTRY_INI(3),CNTRY_BEST(3)
      CHARACTER CH3*3,CHW*1,CHR*1
C======================================================================
      INCW = 21
      INCR = 22
      IOUT = 24
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      DLIM   = DLIMR
      WEIGHT = 'N'
      MODE   = 'A' 

      IF(DLIM.LE.0.0001) DLIM = 5.0

C--------------------------------------
      CALL ORCRD(M,INCW,NAMEW,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE_W')
        RETURN
      ENDIF
      CALL C_AT_CR
C -----------
      CALL RDCOOR_CHECK_FIT(M,MODE,INCW,II,NW,W,BW,WEIGHT
     *        ,IRESW,CHAINW,ATOMW,RES3W,NATMX,IERR)
C ---------------------------------------
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR:  RDCOOR_CHECK_FIT (W)')
        RETURN
      ENDIF
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF WORKING MOLECULE = 0')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF WORKING MOLECULE                :'',I6)') 
     * NW
      CALL MSGDOC(MDOC,LINE)
      IF(II.LE.2) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF WORKING MOLECULE FOR MATCHING < 3')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF WORKING MOLECULE FOR MATCHING   :'',I6)')
     * II
      CALL MSGDOC(MDOC,LINE)
      NSW = II
C--------------------------------------
      CALL ORCRD(M,INCR,NAMER,NSYM,ISYM
     *           ,IPRSYM,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE_R')
        RETURN
      ENDIF
C ---------------------------------------
      CALL RDCOOR_CHECK_FIT(M,MODE,INCR,II,NR,R,BR,WEIGHT
     *        ,IRESR,CHAINR,ATOMR,RES3R,NATMX,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR:  RDCOOR_CHECK_FIT (R)')
        RETURN
      ENDIF
C -----------
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF REFERENCE MOLECULE = 0')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF REFERENCE MOLECULE              :'',I6)')
     *  NR
      CALL MSGDOC(MDOC,LINE)
      IF(II.LE.2) THEN
        CALL MSGDOC(MDOC,
     *  ' ERR: NUMBER OF ATOMS OF REFERENCE MOLECULE FOR MATCHING < 3')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,
     *'(''NUMBER OF ATOMS OF REFERENCE MOLECULE FOR MATCHING :'',I6)')
     * II 
      CALL MSGDOC(MDOC,LINE)
      NSR = II
C --------------------------------------
      WRITE(LINE,'('' D-LIMIT ='',F8.3)') DLIM
      CALL MSGDOC(MDOC,LINE)
C ------------------------------------------------------------------
 100  CONTINUE
      CALL MSGDOC(MDOC,' ')
      WRITE(LINE,'('' N_pairs ='',I8)') NSW
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' ')
      CALL ALIGN_FIT(Mdoc,DLIM,W,R,BW,BR,NSW,NSR,IRESW,IRESR
     * ,TR,TRMAT
     * ,CNTRX_INI,CNTRX_BEST
     * ,CNTRY_INI,CNTRY_BEST,ANG_LIM,DIST_LIM
     * ,NPAIR_INI,DRMS_INI,DMAX_INI,CHI_INI,DIST_INI
     * ,NPAIR_BEST,DRMS_BEST,DMAX_BEST,CHI_BEST,DIST_BEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: ALIGN_FIT ')
        RETURN
      ENDIF
C      WRITE(LINE,*)'==BEST NP,RMS:',NPAIR_BEST,DRMS_BEST,DMAX_BEST
C     * ,NSW    
C      CALL MSGDOC(MDoc,LINE)

      CALL MSGDOC(MDOC,' ----- initial -----')
      WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR_INI,DRMS_INI,DMAX_INI      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_INI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  DIST         '',1X,F10.5)')
     *   DIST_INI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_INI(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')
      CALL MSGDOC(MDOC,' ----- best    -----')
      WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR_BEST,DRMS_BEST,DMAX_BEST      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  DIST         '',1X,F10.5)')
     *   DIST_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_BEST(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')

      RESULT(1) = NPAIR_INI
      RESULT(3) = DRMS_INI
      RESULT(4) = DMAX_INI
      RESULT(5) = CHI_INI
      RESULT(6) = DIST_INI
      RESULT(7) = NPAIR_BEST
      RESULT(8) = DRMS_BEST
      RESULT(9) = DMAX_BEST
      RESULT(10)= CHI_BEST
      RESULT(11)= DIST_BEST
      RESULT(15)= CNTRY_BEST(1)
      RESULT(16)= CNTRY_BEST(2)
      RESULT(17)= CNTRY_BEST(3)
      RESULT(18)= CNTRX_BEST(1)
      RESULT(19)= CNTRX_BEST(2)
      RESULT(20)= CNTRX_BEST(3)
      IF(IPRROW.GE.32) THEN
        RESULT(21) = TRMAT(1,1)        
        RESULT(22) = TRMAT(2,1)        
        RESULT(23) = TRMAT(3,1)        
        RESULT(24) = TRMAT(1,2)        
        RESULT(25) = TRMAT(2,2)        
        RESULT(26) = TRMAT(3,2)        
        RESULT(27) = TRMAT(1,3)        
        RESULT(28) = TRMAT(2,3)        
        RESULT(29) = TRMAT(3,3)        
        RESULT(30) = TR(1)        
        RESULT(31) = TR(2)        
        RESULT(32) = TR(3)        
      ENDIF
      IF(IPRROW.GE.35) THEN
        RESULT(33) = CNTRX_INI(1)        
        RESULT(34) = CNTRX_INI(2)        
        RESULT(35) = CNTRX_INI(3)        
      ENDIF
C ------------------------------------------------------------------
      RETURN
      END
      

      SUBROUTINE RDCOOR_CHECK_FIT(MDOC,MODE,INC,NCRDR,N,X,BX,WEIGHT
     *        ,IRES,CHAIN,ATOM,RES3,NATMX,IERR)
C ---------------------------------------
      INTEGER   MDOC,INC,NCRDR,N,NATMX,IERR
      INTEGER*2 IRES(NATMX)
      REAL      X(3,NATMX),BX(NATMX)
      CHARACTER ATOM(NATMX)*4,RES3(NATMX)*3
      CHARACTER CHAIN(NATMX)*2
      CHARACTER MODE*1,WEIGHT*1
C ---------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      CHARACTER LINE*80
C -------------------------------------------------------------------
      N    = 0
      IEND =-1
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      MOD  = 0
      II   = 0
C -------------------------------------------------------------------
 200  CONTINUE

      CALL RDCRD(M,INC,MOD,IEND,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ INPUT_FILE')
        RETURN
      ENDIF
      IF(IEND.NE.0) GO TO 300
      IF(MOD.EQ.0) THEN

        IF(CR_ATYPE .EQ.' '.OR.CR_ATYPE .EQ.'.'.OR.
     *      CR_ATYPE .EQ.'y'.OR.CR_ATYPE .EQ.'Y'.OR.
     *      CR_ATYPE .EQ.'r'.OR.CR_ATYPE .EQ.'R') THEN
             
          IF(CR_ALT.NE.'.'.AND.CR_ALT.NE.' '.AND.
     *       CR_ALT.NE.'A'.AND.CR_ALT.NE.'1'     ) GO TO 200

          N = N+1
          IF(MODE.EQ.'A'.OR.MODE.EQ.'P'.OR.MODE.EQ.'O'.OR
     *      .MODE.EQ.'B') THEN
            IF( CR_ANAME.EQ.'CA  '.AND.MODE.EQ.'A')          GO TO 500
            IF( CR_ANAME.EQ.'P   '.AND.MODE.EQ.'P')          GO TO 500
            IF( CR_ANAME.EQ.'O   '.AND.MODE.EQ.'O')          GO TO 500
            IF((CR_ANAME.EQ.'CA  '.OR.CR_ANAME.EQ.'N   '.OR.
     *          CR_ANAME.EQ.'C   '.OR.CR_ANAME.EQ.'O   ').AND.
     *                                         MODE.EQ.'B')  GO TO 500
            GO TO 530
          ENDIF
  500     CONTINUE

          IF(CR_OCC.GT.0.0001.OR.WEIGHT.EQ.'C') THEN

          II = II+1
          IF(II.GT.NATMX) THEN
            WRITE(LINE,*) ' ERR: TOO MANY ATOMS > ',NATMX
            CALL MSGERR(MDOC,LINE)
            IERR=1
            RETURN
          ENDIF
          ATOM(II)  = CR_ANAME
          RES3(II)  = CR_RNAME
          CHAIN(II) = CR_CHAIN
          IRES(II)  = CR_IRES
c          X(1,II)   = CR_XYZ(1)/CR_BISO
c          X(2,II)   = CR_XYZ(2)/CR_BISO
c          X(3,II)   = CR_XYZ(3)/CR_BISO
          X(1,II)   = CR_XYZ(1)
          X(2,II)   = CR_XYZ(2)
          X(3,II)   = CR_XYZ(3)
          BX(II)    = CR_BISO

          BX(II)    = 0.0

c          IF(CR_OCC.LE.0.0001.AND.WEIGHT.EQ.'C') THEN
c            BX(II)    = 0.0
c          ENDIF

          ENDIF

 530      CONTINUE
        ENDIF
      ENDIF
      GO TO 200
C ---------------------------------
  300 CONTINUE
      NCRDR = II
      CLOSE (INC)
      RETURN
      END

      SUBROUTINE ALIGN_FIT(MDOC,DLIM,X,Y,BX,BY,NX,NY,IRX,IRY
     * ,TR,TRMAT
     * ,CNTRX_INI,CNTRX_BEST
     * ,CNTRY_INI,CNTRY_BEST,ANG_LIM,DIST_LIM
     * ,NPAIR_INI,DRMS_INI,DMAX_INI,CHI_INI,DIST_INI
     * ,NPAIR_BEST,DRMS_BEST,DMAX_BEST,CHI_BEST,DIST_BEST,IERR)
C ---------------------------------------------------------
C
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     Y      CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NX     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION
C            MATRIX
C --------------------------------------------------------
      REAL X(3,*),Y(3,*),BX(*),BY(*)
      REAL TR(3),TRMAT(3,3),V(3)

      PARAMETER ( IPRCHK = 3000 )

      REAL X0(3,IPRCHK)
      REAL XX(3,IPRCHK),YY(3,IPRCHK)
      REAL CNTRX_INI(3),CNTRX_BEST(3),CNTRX(3)
      REAL CNTRY_INI(3),CNTRY_BEST(3),CNTRY(3)
      REAL SCORE_OLD(IPRCHK),SCORE_MAX(IPRCHK),TEMP(IPRCHK)
     *    ,TEMP1(IPRCHK)
      REAL SCORE_OLD_N(IPRCHK),SCORE_MAX_N(IPRCHK),ITEMP(IPRCHK)
      INTEGER IPAIR(2,IPRCHK,IPRCHK),ISC_MAX(IPRCHK)
     *       ,ISC_MAX_N(IPRCHK)
      INTEGER*2 IRX(*),IRY(*)
      CHARACTER LINE*80,WEIGHT*1
C ----------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      IF(IPRCHK.LT.NX.OR.IPRCHK.LT.NY) THEN
        WRITE(LINE,*) ' ERROR: in ALIGN_FIT not memory'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        RETURN
      ENDIF
c ---
      CALL MSGDOC(MDOC,' ----- initial -----')
      DO IA=1,NX
        X0(1,IA) = X(1,IA)
        X0(2,IA) = X(2,IA)
        X0(3,IA) = X(3,IA)
      ENDDO
      WEIGHT = 'N'
      CALL LSKAB_CHECK_FIT(M,WEIGHT
     * ,X,Y,BX,BY,NX,TRMAT,TR,DRMS,DISMAX,DCENTRE
     * ,CNTRX,CNTRY,IERR)
      IF(IERR.NE.0) RETURN
      CALL ANGFIX(M,TRMAT,ALPHA,BETA,GAMMA)
      CALL MTOPOL(TRMAT,THETA,PHI,CHI)
      WRITE(LINE,*) ' Npair,RMS,MAX:',NX,DRMS,DISMAX      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' TFC(1->2):',THETA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     *   (TR(J),J=1,3)
      CALL MSGDOC(M,LINE)
      WRITE(LINE,'('' DIST_CENTRE              '',1X,F10.5)')
     *    DCENTRE
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')
      NPAIR_INI = NX
      DRMS_INI  = DRMS
      DMAX_INI  = DISMAX
      CHI_INI   = CHI
      DIST_INI  = DCENTRE
      CNTRX_INI(1) = CNTRX(1)
      CNTRX_INI(2) = CNTRX(2)
      CNTRX_INI(3) = CNTRX(3)
      CNTRY_INI(1) = CNTRY(1)
      CNTRY_INI(2) = CNTRY(2)
      CNTRY_INI(3) = CNTRY(3)
      DO I=1,NX
        DO II=1,3
          V(II) = X0(II,I)
c          V(II) = X(II,I)
        ENDDO
        DO II=1,3
          X(II,I) = TRMAT(1,II)*V(1)
     *             +TRMAT(2,II)*V(2)
     *             +TRMAT(3,II)*V(3)
        ENDDO
        DO II=1,3
          X(II,I) = X(II,I) + TR(II)
        ENDDO
      ENDDO
C -----------------------------------------
c      write(*,*) '--nx,ny:',nx,ny
c      DO I=1,NX
c        write(*,*) 'I:',I,X(1,I),X(2,I),X(3,I)
c      ENDDO
c      DO I=1,NY
c        write(*,*) 'J:',I,Y(1,I),Y(2,I),Y(3,I)
c      ENDDO
      WEIGHT = 'N'
      DLIM2  = 2.0*DLIM*DLIM
c ===
      NPAIR_BEST = 0
      DRMS_BEST  = 10000.0
      DMAX_BEST  = 0.0
      CHI_BEST   = 0.0
      DIST_BEST  = 0.0

      IF(ANG_LIM.GT.0.00001.AND.DIST_LIM.GT.0.00001) THEN
      IF(ABS(CHI_INI).LT.ANG_LIM.AND.DIST_INI.LE.DIST_LIM) THEN
        GO TO 410 
      ENDIF
      ENDIF

C       NPAIR_BEST = NPAIR_INI 
C       DRMS_BEST  = DRMS_INI  
C       DMAX_BEST  = DMAX_INI  
C       CHI_BEST   = CHI_INI  
C       DIST_BEST  = DIST_INI  
C --------------------------
 400  CONTINUE

      DO I=1,NX
      DO J=1,NY
      DO K=1,2
        IPAIR(K,I,J) = 0
      ENDDO
      ENDDO
      ENDDO
      DO K=1,NY
        DX  = X(1,NX) - Y(1,K)  
        DY  = X(2,NX) - Y(2,K)  
        DZ  = X(3,NX) - Y(3,K)  
        D2  = DX*DX + DY*DY + DZ*DZ

        TEMP(K) = SQRT(D2)
        SCORE_OLD_N(K) = 0.0 

        ARG = D2/DLIM2
        S   = EXP(-ARG)
        TEMP1(K)     = S
        SCORE_OLD(K) = S
        SCORE_OLD_N(K) = SCORE_OLD(K)
        SCORE_MAX(K) = SCORE_OLD(K)
        ISC_MAX(K)   = NX
      ENDDO 

c        WRITE(*,'(I3,''o: '',10F6.3)') NX,(SCORE_OLD(J),J=1,ny)
c        WRITE(*,'(I3,''n: '',10F6.3)') NX,(SCORE_OLD_N(J),J=1,ny)
c        WRITE(*,'(I3,''S: '',10F6.2)') NX,(temp1(J),J=1,ny)
c        WRITE(*,'(I3,''d: '',10F6.2)') NX,(temp(J),J=1,ny)
C ---
      IMAX = 0
      JMAX = 0
      SMAX = 0.0
      DO I=NX-1,1,-1
        DO J=NY,1,-1
          S   = 0.0
          DX  = X(1,I) - Y(1,J)  
          DY  = X(2,I) - Y(2,J)  
          DZ  = X(3,I) - Y(3,J)  
          D2  = DX*DX + DY*DY + DZ*DZ
          TEMP(J)  = SQRT(D2)
          ARG      = D2/DLIM2
          SCORE    = EXP(-ARG)
          TEMP1(J) = SCORE
          IF(J.LT.NY) THEN
            DO K=J+1,NY
              IF(SCORE_OLD(K).GE.S) THEN
                S  = SCORE_OLD(K)
                IP = I+1
                JP = K
              ENDIF
            ENDDO     
            IF(I.LT.NX-1) THEN
              IF(SCORE_MAX(J+1).GE.S) THEN
                S  = SCORE_MAX(J+1)
                IP = ISC_MAX(J+1)
                JP = J+1
              ENDIF
            ENDIF
          ENDIF

          SCORE          = SCORE + S
          SCORE_OLD_N(J) = SCORE

          IF(SCORE.GE.SMAX) THEN
            SMAX = SCORE
            IMAX = I
            JMAX = J
          ENDIF
          IF(SCORE.GT.SCORE_MAX(J)) THEN
            SCORE_MAX_N(J) = SCORE
            ISC_MAX_N(J)   = I
          ELSE
            SCORE_MAX_N(J) = SCORE_MAX(J)
            ISC_MAX_N(J)   = ISC_MAX(J)
          ENDIF  
          IPAIR(1,I,J) = IP
          IPAIR(2,I,J) = JP
        ENDDO

c        WRITE(*,*) ' --------------------'
c        WRITE(*,'(I3,''X: '',10F6.3)') I,(SCORE_MAX(J),J=1,ny)
c        WRITE(*,'(I3,''o: '',10F6.3)') I,(SCORE_OLD(J),J=1,ny)
c        WRITE(*,'(I3,''n: '',10F6.3)') I,(SCORE_OLD_N(J),J=1,ny)
c        WRITE(*,'(I3,''S: '',10F6.2)') I,(temp1(J),J=1,ny)
c        WRITE(*,'(I3,''d: '',10F6.2)') I,(temp(J),J=1,ny)

        DO K=1,NY        
          SCORE_OLD(K) = SCORE_OLD_N(K)
          SCORE_MAX(K) = SCORE_MAX_N(K)
          ISC_MAX(K)   = ISC_MAX_N(K)
        ENDDO

      ENDDO
C ---
c      WRITE(*,*) ' --------------------'
c      WRITE(*,*) ' MAX:',IMAX,JMAX,SMAX
c      WRITE(*,*) ' --------------------'
      DMAX  = 0.0
      DRMS  = 0.0
      NPAIR = 0
      ICUR  = IMAX
      JCUR  = JMAX
 100  CONTINUE
      IF(ICUR.GT.0.AND.JCUR.GT.0) THEN
        NPAIR = NPAIR + 1
        DX = X(1,ICUR) - Y(1,JCUR)  
        DY = X(2,ICUR) - Y(2,JCUR)  
        DZ = X(3,ICUR) - Y(3,JCUR)  
        D2 = DX*DX + DY*DY + DZ*DZ
        D  = SQRT(D2)
        DRMS = DRMS + D2
        IF(D.GT.DMAX) DMAX = D  
        SCORE_MAX(NPAIR) = D
        ISC_MAX  (NPAIR) = ICUR
        ISC_MAX_N(NPAIR) = JCUR
        ITEMP    (NPAIR) = NPAIR 

c        WRITE(*,*) '--',NPAIR,ICUR,JCUR,D

        IF(ICUR.GE.NX.OR.JCUR.GE.NY) GO TO 200 
        IC = IPAIR(1,ICUR,JCUR)
        JC = IPAIR(2,ICUR,JCUR)
        ICUR = IC
        JCUR = JC
        GO TO 100
      ENDIF
 200  CONTINUE
      IF(NPAIR.GT.0) THEN
        DRMS = SQRT((DRMS/FLOAT(NPAIR)))
      ENDIF 
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' Npair,RMS,MAX:',NPAIR,DRMS,DMAX      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MDOC,LINE)

C ---
C      SUBROUTINE SORT2(A,N,TAG,TAG1)
C      SUBROUTINE SORT1(A,N,TAG)
C      CALL SORT0(SCORE_MAX,NPAIR)
C      CALL SORT2(SCORE_MAX,NPAIR,ISC_MAX,ISC_MAX_N)
      NPAIR_OLD = NPAIR 
      CALL SORT3(SCORE_MAX,NPAIR,ITEMP,ISC_MAX,ISC_MAX_N)

C      write(*,*) ' min:',SCORE_MAX(1) 
C      write(*,*) ' max:',SCORE_MAX(npair) 
     
C ---
      NMIN = NX
      IF(NY.LT.NMIN) NMIN = NY
      NMIN1 = NMIN + 1
      R0        = 2.0
      Q_FIN     = 0.0
      DMAX_FIN  = 0.0
      DRMS_FIN  = 0.0
      NPAIR_FIN = NPAIR
 300  CONTINUE
      DRMS = 0.0
      DMAX = 0.0
      DO I=1,NPAIR
        DRMS = DRMS + SCORE_MAX(I)*SCORE_MAX(I)
        IF(SCORE_MAX(I).GT.DMAX) DMAX = SCORE_MAX(I)
      ENDDO
      DRMS = SQRT((DRMS/FLOAT(NPAIR)))
      Q = (1.0+FLOAT(NPAIR))/((1.0+DRMS/R0)*FLOAT(NMIN1))

c      WRITE(*,*) '-- Q,N,RMS,MAX:',Q,NPAIR,DRMS,DMAX      

      IF(Q.GT.Q_FIN) THEN
        Q_FIN     = Q
        DRMS_FIN  = DRMS
        NPAIR_FIN = NPAIR
        DMAX_FIN  = DMAX
        NPAIR = NPAIR - 1
        IF(NPAIR.GT.0) THEN
          SCORE_MAX(NPAIR+1) = 99.0
          GO TO 300
        ENDIF
      ENDIF
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,*)'== Q,N,RMS,MAX:'
     *    ,Q_FIN,NPAIR_FIN,DRMS_FIN,DMAX_FIN      
      CALL MSGDOC(MDoc,LINE)
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MD,LINE)

C ---
      IF(NPAIR.GT.NPAIR_BEST) THEN

        IF(NPAIR.LT.3) THEN
          WRITE(LINE,*) ' >>>>>Npair:',NPAIR      
          CALL MSGDOC(MDOC,LINE)
          GO TO 410
C          IERR = 1
C          RETURN
        ENDIF 
        CALL MSGDOC(MDOC,LINE)
        DO I=1,NPAIR
          IA = ISC_MAX(I)
          JA = ISC_MAX_N(I)
          XX(1,I) = X0(1,IA)
          XX(2,I) = X0(2,IA)
          XX(3,I) = X0(3,IA)
C          XX(1,I) = X(1,IA)
C          XX(2,I) = X(2,IA)
C          XX(3,I) = X(3,IA)
          YY(1,I) = Y(1,JA) 
          YY(2,I) = Y(2,JA) 
          YY(3,I) = Y(3,JA) 
        ENDDO
C ---
        CALL LSKAB_CHECK_FIT(M,WEIGHT
     *  ,XX,YY,BX,BY,NPAIR,TRMAT,TR,DRMS,DISMAX,DCENTRE
     *  ,CNTRX,CNTRY,IERR)
        IF(IERR.NE.0) THEN
          IERR = 0
          GO TO 410
        ENDIF
        WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR,DRMS,DISMAX      
        CALL MSGDOC(MDOC,LINE)
        CALL ANGFIX(M,TRMAT,ALPHA,BETA,GAMMA)
        CALL MTOPOL(TRMAT,THETA,PHI,CHI)
        WRITE(LINE,*) ' TFC(1->2):',THETA,PHI,CHI
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     *   (TR(J),J=1,3)
        CALL MSGDOC(Mdoc,LINE)
        WRITE(LINE,'('' DIST_CENTRE              '',1X,F10.5)')
     *    DCENTRE
        CALL MSGDOC(Mdoc,LINE)

        CALL ISORT3(ITEMP,NPAIR_OLD,SCORE_MAX,ISC_MAX,ISC_MAX_N)
C ---
        WRITE(LINE,*) ' --------------------'
        CALL MSGDOC(M,LINE)
        DO I=1,NPAIR_OLD
          IA  = ISC_MAX(I)
          INA = IRX(IA)
          JA  = ISC_MAX_N(I)
          JNA = IRY(JA)
          WRITE(LINE,'(I5,A2,I5,A3,I5,2X,F6.2)') 
     *    I,') ',INA,' - ',JNA,SCORE_MAX(I)
          CALL MSGDOC(M,LINE)
        ENDDO
        WRITE(LINE,*) ' --------------------'
        CALL MSGDOC(M,LINE)
C ---
        NPAIR_BEST = NPAIR
        DRMS_BEST  = DRMS
        DMAX_BEST  = DMAX
        CHI_BEST   = CHI
        DIST_BEST  = DCENTRE
        CNTRX_BEST(1) = CNTRX(1)
        CNTRX_BEST(2) = CNTRX(2)
        CNTRX_BEST(3) = CNTRX(3)
        CNTRY_BEST(1) = CNTRY(1)
        CNTRY_BEST(2) = CNTRY(2)
        CNTRY_BEST(3) = CNTRY(3)
        DO I=1,NX
          DO II=1,3
            V(II) = X0(II,I)
C            V(II) = X(II,I)
          ENDDO
          DO II=1,3
            X(II,I) = TRMAT(1,II)*V(1)
     *               +TRMAT(2,II)*V(2)
     *               +TRMAT(3,II)*V(3)
          ENDDO
          DO II=1,3
            X(II,I) = X(II,I) + TR(II)
          ENDDO
        ENDDO
        GO TO 400

      ENDIF
C ---
 410  CONTINUE

      NBY2 = NPAIR_INI/2 
      IF(NPAIR_BEST.LT.1.OR.NPAIR_BEST.LT.NBY2) THEN
        NPAIR_BEST = NPAIR_INI 
        DRMS_BEST  = DRMS_INI  
        DMAX_BEST  = DMAX_INI  
        CHI_BEST   = CHI_INI  
        DIST_BEST  = DIST_INI  
        CNTRX_BEST(1) = CNTRX_INI(1)
        CNTRX_BEST(2) = CNTRX_INI(2)
        CNTRX_BEST(3) = CNTRX_INI(3)
        CNTRY_BEST(1) = CNTRY_INI(1)
        CNTRY_BEST(2) = CNTRY_INI(2)
        CNTRY_BEST(3) = CNTRY_INI(3)
      ENDIF

      CALL MSGDOC(MDOC,' ----- best    -----')
      WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR_BEST,DRMS_BEST,DMAX_BEST      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' DIST         '',1X,F10.5)')
     *   DIST_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_BEST(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')
C ---
      RETURN
      END


      SUBROUTINE LSKAB_CHECK_FIT(MDOC,WEIGHT
     * ,X,Y,BX,BY,NX,TRMAT,TR,DRMS,DISMAX,DCENTRE
     * ,CNTRX,CNTRY,IERR)
C ---------------------------------------------------------
C
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     Y      CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NX     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION
C            MATRIX
C --------------------------------------------------------
      REAL X(3,*),Y(3,*),BX(*),BY(*),CNTRX(3),CNTRY(3)
      REAL TR(3),TRMAT(3,3),RK(3,3),RKTRK(3,3),R(3),VP(3,3)
      REAL RA(3,3),RANR(3,3),E(3),XT(3),XNORM(3)
      CHARACTER LINE*80,WEIGHT*1
C ----------------------------------------------------------------
      IERR=0
C
C     CALCULATE CENTROIDS
C
      DO     I=1,3
        CNTRY(I) = 0.0
        CNTRX(I) = 0.0
      ENDDO
      WSY = 0.0
      WSX = 0.0
      DO     I=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(I)
          WX = 1.0/BX(I)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     J=1,3
          CNTRY(J) = CNTRY(J) + Y(J,I) * WY
          CNTRX(J) = CNTRX(J) + X(J,I) * WX
C          CNTRY(J) = CNTRY(J) + Y(J,I)
C          CNTRX(J) = CNTRX(J) + X(J,I) 
        ENDDO
        WSY = WSY +  WY
        WSX = WSX +  WX
C        WEIGHTY = WEIGHTY +  1.0
C        WEIGHTY = WEIGHTY +  1.0
      ENDDO
      DO     J=1,3
        CNTRX(J) = CNTRX(J)/WSX
        CNTRY(J) = CNTRY(J)/WSY
      ENDDO
      DX = CNTRX(1) - CNTRY(1) 
      DY = CNTRX(2) - CNTRY(2) 
      DZ = CNTRX(3) - CNTRY(3)
      DCENTRE = SQRT(DX*DX +DY*DY + DZ*DZ) 

c      write(*,*) '---x:',CNTRX(1),CNTRX(2),CNTRX(3)
c      write(*,*) '---y:',CNTRy(1),CNTRy(2),CNTRy(3)

C
C     TRANSLATE WORKING AND REFERENCE MOLECULES TO ORIGIN
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I) - CNTRX(J)
        Y(J,I) = Y(J,I) - CNTRY(J)
      ENDDO
      ENDDO
C
      DISMAX = 0.0
      SUMD2  = 0.0
      SUMDIS = 0.0
C
C    GET MATRIX R = SUM(Y.X)
C
      DO     I=1,3
      DO     J=1,3
        RK(I,J) = 0.0
      ENDDO
      ENDDO
      DO     IA=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(IA)
          WX = 1.0/BX(IA)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     I=1,3
        DO     J=1,3
          RK(I,J) = RK(I,J)+Y(I,IA)*X(J,IA)*WY*WX
C          RK(I,J)=RK(I,J)+Y(I,IA)*X(J,IA)
        ENDDO
        ENDDO
      ENDDO
C
C      EZERO VALUE
C
      EZERO = 0.0
      DO     IA=1,NX
        IF(WEIGHT.EQ.'Y') THEN
          WY = 1.0/BY(IA)
          WX = 1.0/BX(IA)
        ELSE IF(WEIGHT.EQ.'C') THEN
          IF(BX(I).LT.0.01.OR.BY(I).LT.0.01) THEN
            WY = 0.0
            WX = 0.0
          ELSE
            WY = 1.0
            WX = 1.0
          ENDIF
        ELSE
          WY = 1.0
          WX = 1.0
        ENDIF
        DO     I=1,3
          EZERO = EZERO+(X(I,IA)*X(I,IA)*WX*WX+Y(I,IA)*Y(I,IA)*WY*WY)
C          EZERO=EZERO+(X(I,IA)*X(I,IA)+Y(I,IA)*Y(I,IA))
        ENDDO
      ENDDO
      EZERO = EZERO*0.5
C
C      GET RKTRK  =  RKTRANSPSED  *  RK
C
      DO     I=1,3
      DO     J=1,3
        RKTRK(I,J) = 0.0
        DO     K=1,3
          RKTRK(I,J) = RKTRK(I,J)+RK(K,I)*RK(K,J)
        ENDDO
      ENDDO
      ENDDO
C
C      CALL NAG ROUTINE :  EIGENVALUES IN  R
C                       :  EIGENVECTORS NORMALIZED IN VP
C                           (SORTED IN ASCENDING ORDER)
C                           (E   WORKING ARRAY)
C
      IFAIL = 0
      CALL F02ABF(RKTRK,3,3,R,VP,3,E,IFAIL)
      IF (IFAIL.NE.0) THEN
        IERR = 1
        WRITE(MDOC,10) IFAIL
   10   FORMAT
     *  (' ERR: ERROR DETECTED BY NAG LIBRARY ROUTINE - IFAIL=',I5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,11) IFAIL
   11   FORMAT ('     ',I5,5X,' DIAGONALISATION FAILED')
        CALL MSGDOC(MDOC,LINE)
        RETURN
      ENDIF
C
C      SET VP(.1)=VP(.,3) X VP(.,2)
C
      VP(1,1) = VP(2,3)*VP(3,2)-VP(3,3)*VP(2,2)
      VP(2,1) = VP(3,3)*VP(1,2)-VP(1,3)*VP(3,2)
      VP(3,1) = VP(1,3)*VP(2,2)-VP(2,3)*VP(1,2)
C
C     GET  RA = R . V
C
      DO     K=1,3
      DO     I=1,3
        RA(I,K) = 0.0
        DO     J=1,3
          RA(I,K) = RA(I,K)+RK(I,J)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO
C
C      NORM.   RA(.,2) & RA(.3)
C
      DO     J=2,3
        XNORM(J) = 0.0
        DO     I=1,3
          XNORM(J) = XNORM(J)+RA(I,J)*RA(I,J)
        ENDDO
        XNORM(J) = 1./SQRT(ABS(XNORM(J)))
      ENDDO
      DO     J=2,3
      DO     I=1,3
        RANR(I,J) = RA(I,J)*XNORM(J)
      ENDDO
      ENDDO
C
C      SET RANR(.,1) = RANR(.,3) X RANR(.,2)
C
      RANR(1,1) = RANR(2,3)*RANR(3,2) - RANR(3,3)*RANR(2,2)
      RANR(2,1) = RANR(3,3)*RANR(1,2) - RANR(1,3)*RANR(3,2)
      RANR(3,1) = RANR(1,3)*RANR(2,2) - RANR(2,3)*RANR(1,2)
C
C   GET SCALAR PRODUCT  RANR(.,1) . RA(.,1)     & SIGMA VALUE
C
C     SCPD=0.0
C     DO     I=1,3
C       SCPD=RANR(I,1)*RA(I,1)
C     ENDDO
C     SIGMA = 1.
C     IF (SCPD.LT.0) SIGMA=-1.
C     RES = EZERO -SQRT(ABS(R(2)))-SQRT(ABS(R(3)))-SIGMA*SQRT(ABS(R(1)))
C
C      TRANSFORMATION MATRIX
C
      DO     I=1,3
      DO     J=1,3
        TRMAT(I,J) = 0.0
        DO     K=1,3
          TRMAT(I,J) = TRMAT(I,J)+RANR(I,K)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO
C
C
C      CALCULATE RESIDUALS & FIGURES OF MERIT
C
      DO     IA=1,NX
        DO     I=1,3
          XT(I) = 0.0
          DO     J=1,3
            XT(I) = XT(I) + TRMAT(I,J)*X(J,IA)
          ENDDO
        ENDDO
        DO     I=1,3
          X(I,IA) = XT(I)
        ENDDO
        D = 0.0
        DO     J=1,3
          D = D +(X(J,IA)-Y(J,IA))*(X(J,IA)-Y(J,IA))
        ENDDO
        SUMD2  = SUMD2 + D
        D      = SQRT(ABS(D))
        SUMDIS = SUMDIS +D
        DISMAX = AMAX1(DISMAX,D)
      ENDDO
      DRMS   = SQRT(ABS(SUMD2/NX))
      SUMDIS = SUMDIS/NX
C
      WRITE(LINE,40) SUMD2
 40   FORMAT('SUM DISPLACEMENTS**2      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,41) DRMS
 41   FORMAT('RMS DISPLACEMENT          =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,42) SUMDIS
 42   FORMAT('AVERAGE DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,43) DISMAX
 43   FORMAT('MAXIMUM DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
C
C
C     ADD REFERENCE MOLECULE CENTROID TO WORKING MOLECULE COORDS.
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I)+CNTRY(J)
      ENDDO
      ENDDO
C
C     SHIFT REFERENCE MOLECULE TO ORIGINAL POSITION
C
      DO     II=1,NX
      DO     J=1,3
        Y(J,II) = Y(J,II)+CNTRY(J)
      ENDDO
      ENDDO
C
C  FIND TRANSLATION  T = -TRMAT * CTRX   +CNTRY
C
      TR(1)=
     *  -TRMAT(1,1)*CNTRX(1)-TRMAT(1,2)*CNTRX(2)-TRMAT(1,3)*CNTRX(3)
     *  +CNTRY(1)
      TR(2)=
     *  -TRMAT(2,1)*CNTRX(1)-TRMAT(2,2)*CNTRX(2)-TRMAT(2,3)*CNTRX(3)
     *  +CNTRY(2)
      TR(3)=
     *  -TRMAT(3,1)*CNTRX(1)-TRMAT(3,2)*CNTRX(2)-TRMAT(3,3)*CNTRX(3)
     *  +CNTRY(3)
      TEMP       = TRMAT(1,2)
      TRMAT(1,2) = TRMAT(2,1)
      TRMAT(2,1) = TEMP
      TEMP       = TRMAT(1,3)
      TRMAT(1,3) = TRMAT(3,1)
      TRMAT(3,1) = TEMP
      TEMP       = TRMAT(2,3)
      TRMAT(2,3) = TRMAT(3,2)
      TRMAT(3,2) = TEMP

      RETURN
      END

c ================================
      SUBROUTINE SURFACE_RUN_DB(MDOC,NAMER,NAMEO,RH2O,DEL,BLIM
     * ,SURF_KEY,NATMX
     * ,XR,YR,ZR,OCCR,TEMPR,SURFR,RADVDW,ELPOT
     * ,ATOM,PNUM
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)   
C ---------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      REAL      OCCR(NATMX),TEMPR(NATMX),SURFR(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX)
      REAL      RESULT(IPRROW)
C ---------------------------------------
      CHARACTER LINE*80,NAMER*(*),NAMEO*(*),SURF_KEY*1
C ---------------------------------------
      IERR = 0
      RESULT(1) = 0.0
      IF(RH2O.LE.0.0) RH2O = 1.4
      IF(DEL .LE.0.0) DEL  = 0.1
      IF(BLIM.LE.0.000001) BLIM = 15.0
C -----------
      CALL RDCOOR_SR_DB(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NRES,IERR)
      IF(IERR.NE.0) RETURN
C -----------
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: number of atoms = 0')
        IERR=1
        RETURN
      ENDIF
      WRITE(LINE,'('' Number of atoms :'',I6)') NR
      CALL MSGDOC(MDOC,LINE)
C ------------
      CALL AREA_SR_DB(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT,OCCR
     *    ,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C IERR
C  1   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N_atoms = 0')
C  2   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP NZ < 2')
C  3   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP M < 1')
C  4   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: J > NPMAX')
C  5   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N-neighbors > LIMIT') 
      IF(IERR.NE.0) THEN
        IF(IERR.EQ.1) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N_atoms = 0')
        IF(IERR.EQ.2) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP NZ < 2')
        IF(IERR.EQ.3) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP M < 1')
        IF(IERR.EQ.4) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: J > NPMAX')
        IF(IERR.EQ.5) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N-neighbors > LIMIT') 
        RETURN
      ENDIF
      WRITE(LINE,9999) SURFC
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,9997) SURFA
      CALL MSGDOC(MDOC,LINE)
 9999 FORMAT(' Total Contact    Surface Area =',F10.3)
 9997 FORMAT(' Total Accessible Surface Area =',F10.3)
      CALL MSGDOC(MDOC,' ')
C ------------------------------------------------------------------
      CALL WRCOOR_SR_DB(MDOC,NAMER,NAMEO
     *   ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *   ,NTOT,NAT,IERR)
      IF(IERR.NE.0) RETURN
C ---------------------------------------
 100  CONTINUE

      RESULT(1) = NAT
      RESULT(2) = SURFA
      RESULT(3) = SURFC
      RESULT(8) = NTOT
      RESULT(9) = NRES
C --------------------------------
      RETURN
      END

      SUBROUTINE RDCOOR_SR_DB(MDOC,NAME_IN,NCRDR,X,Y,Z,OCC,TEMP
     *     ,SURF,RADVDW,ELPOT,PNUM,ATOM,NATMX,NR,IERR)
C ---------------------------------------
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX),SURF(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX)
C ------------------------------------------------------------
      CHARACTER CHAR2*2
C ----------------------------------------------
      PARAMETER (N_NAME = 9)
      REAL      TAB_RVDW(N_NAME)
      CHARACTER NAME(N_NAME)*2
      DATA NAME    /'C ','O ','N ','S ','P ','H ','FE','CA','ZN'/
      DATA TAB_RVDW/1.8 ,1.7 ,1.6 ,1.9 ,2.1 ,0.8 ,0.65,1.18,0.88/
C B       10.82000  N     0.650      .
C F       19.00000  N     1.330      .
C NA      22.99000  N      .         .
C MG      24.32000  N     0.820      .
C P       30.97380  N     2.100      .
C PS      30.97380  N     2.100      .
C S       32.06400  A     1.900      .
C SH1     32.06400  B     1.900     1.950
C CL      35.45700  N     1.810      .
C CA      40.08000  N     1.180      .
C V       50.95000  N     0.880      .
C MN      54.94000  N     0.800      .
C FE      55.84700  N     0.650      .
C CO      58.94000  N     0.720      .
C CU      63.54600  N     0.740      .
C ZN      65.37000  N     0.880      .
C BR      79.91600  N     1.960      .
C CD     112.40000  N     1.140      .
C I      126.90450  A     2.200      .
C PB     207.21000  N     1.200      .
C HG     200.61000  N     1.270      .
C -------------------------------------------------------------------
      CHARACTER CODE_PDB*4
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER CH3*3
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1
      CHARACTER FRMT*80,ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
c123456123451123411231234567
cATOM      4  O   THR     1      -5.209  15.501  13.516  1.00 32.45      2PIA 
cATOM      6  OG1 THR     1      -2.234  12.957  13.779  1.00 42.29      2PIA
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','ACD' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','X','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL CORR_NAME_BLC(NAME_IN)
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      NCRDR = 0
      N     = 0 
      NR    = 0
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD = '?'
      ANAME_OLD   = '?'
C ----------------
 400  CONTINUE
      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 400
      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        CODE_PDB = LINE(63:66)
        GO TO 400
      ENDIF        

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
 
      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      IF(CP_PNUM.NE.CP_PNUM_OLD) THEN
        IF(CP_OCC.GT.0.001) NR = NR + 1
      ENDIF
      CP_PNUM_OLD  = CP_PNUM

      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
C      IF(RNAME.EQ.'MSE') RNAME = 'MET'
C      IF(RNAME.EQ.'HYP') RNAME = 'PRO'
C      IF(RNAME.EQ.'CSH') RNAME = 'CYS'

      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.GE.1.AND.J.LE.23) THEN
        IF(N.GE.NATMX) THEN
          WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)') NATMX
          CALL MSGDOC(MDOC,LINE) 
          IERR=1
          CLOSE(IN)
          RETURN
        ENDIF

C        IF(CP_OCC.GT.0.001) THEN
          N = N + 1
          IF(J.EQ.22) J = 7
          IF(J.EQ.23) J = 8
          PNUM(N)(1:1) = CP_PNUM(2:2)
          PNUM(N)(2:6) = CP_PNUM(3:7)
          ATOM(N)      = ANAME
          ANAME_OLD    = ANAME

          X     (N) = CP_XYZ(1)
          Y     (N) = CP_XYZ(2)
          Z     (N) = CP_XYZ(3)
          OCC   (N) = CP_OCC
          TEMP  (N) = CP_BISO
          SURF  (N) = 0.0
          ELPOT (N) = 0.0
          CHAR2     = ASYMB(1:2)

          RVDW      = 1.4
          DO I=1,N_NAME
            IF(CHAR2.EQ.NAME(I)) THEN
              RVDW = TAB_RVDW(I)
              GO TO 100
            ENDIF
          ENDDO
 100      CONTINUE
          RADVDW(N) = RVDW

C        ENDIF

      ENDIF
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      NCRDR = N
      IF(N.LE.0) THEN
        CALL MSGDOC(MDOC,' Number of atoms for surface calc = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGDOC(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGDOC(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE AREA_SR_DB(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT
     *       ,OCCR,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C ---------------------------------------
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      REAL      SURFR(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX),OCCR(NATMX)
C ---------------------------------------
      PARAMETER (NSMAX=500)
      PARAMETER (NPMAX=20000)
      PARAMETER (MAXPO=10000)
      REAL XPNT(MAXPO),YPNT(MAXPO),ZPNT(MAXPO)
      REAL XSOSED(NSMAX),YSOSED(NSMAX),ZSOSED(NSMAX),RSOSED(NSMAX)
      REAL XKPOIN(NPMAX),YKPOIN(NPMAX),ZKPOIN(NPMAX)
      REAL XPOINT(NPMAX),YPOINT(NPMAX),ZPOINT(NPMAX),ITYPE(NPMAX)
      CHARACTER LINE*80
C ----------------------------------------------------
      NGLOB = 0
      SURFC = 0.0
      SURFA = 0.0
      RUNIT = 1.0
      CALL TABLE_SR_DB(RUNIT,DEL,NPOINT,XPOINT,YPOINT,ZPOINT,SDELK
     *          ,NPMAX,IERR)
      IF(IERR.NE.0) RETURN

C -------- START OF CYCLE K-ATOM --------------------

      DO     K=1,NR

C        IF( MOD(K,100).EQ.0) THEN
C          WRITE(LINE,'('' I-ATOM,N-POINTS :'',I6,I8)') K,NGLOB
C          CALL MSGDOC(MDOC,LINE)
C        ENDIF

        IF(OCCR(K).LT.0.001) GO TO 100

        XK = XR(K)
        YK = YR(K)
        ZK = ZR(K)
        RK = RADVDW(K)+RH2O
        L  = 0
        DO     I1=1,NPOINT
          XKPOIN(I1) = XK+(XPOINT(I1)*RK)/RUNIT
          YKPOIN(I1) = YK+(YPOINT(I1)*RK)/RUNIT
          ZKPOIN(I1) = ZK+(ZPOINT(I1)*RK)/RUNIT
          ITYPE (I1) = 0
        ENDDO
        SDEL = (SDELK*RK*RK)/(RUNIT*RUNIT)
C ----------- SOSEDI ----------------
        DO     J=1,NR

          IF(OCCR(J).LT.0.001) GO TO 200

          IF(J.NE.K) THEN
            XJ    = XR(J)
            YJ    = YR(J)
            ZJ    = ZR(J)
            RJ    = RADVDW(J)+RH2O
            R1    = RK+RJ
            RLIM2 = R1*R1
            S1    = (XJ-XK)*(XJ-XK)
            S2    = (YJ-YK)*(YJ-YK)
            S3    = (ZJ-ZK)*(ZJ-ZK)
            DIS2  = S1+S2+S3
            IF(DIS2.LE.RLIM2) THEN
              L = L+1
              IF(L.GT.NSMAX) THEN
                WRITE(LINE,'('' ERROR: surface: N-SOSED >'',I8)') NSMAX
                CALL MSGERR(MDOC,LINE)
                IERR=1
                RETURN
              ENDIF
              XSOSED(L) = XJ
              YSOSED(L) = YJ
              ZSOSED(L) = ZJ
              RSOSED(L) = RJ
              NSOSED    = L
            ENDIF
          ENDIF

 200      CONTINUE

        ENDDO
C -------------
        IF(NSOSED.GT.0) THEN
          DO     IP=1,NPOINT
            XP = XKPOIN(IP)
            YP = YKPOIN(IP)
            ZP = ZKPOIN(IP)
            DO     IS=1,NSOSED
              XS = XSOSED(IS)
              YS = YSOSED(IS)
              ZS = ZSOSED(IS)
              RS = RSOSED(IS)
              DX = XS-XP
              IF(ABS(DX).GT.RS) GO TO 350
              DY = YS-YP
              IF(ABS(DY).GT.RS) GO TO 350
              DZ = ZS-ZP
              IF(ABS(DZ).GT.RS) GO TO 350
              D2  = DX*DX+DY*DY+DZ*DZ
              RS2 = RS*RS
              IF(D2.LT.RS2) THEN
                ITYPE(IP) = 1
                GO TO 352
              ENDIF
 350          CONTINUE
            ENDDO
 352        CONTINUE
          ENDDO
        ENDIF
C --------------------------------------
        MS=0
C   ---
        DO     IP=1,NPOINT
          IF(ITYPE(IP).EQ.0) THEN
            MS = MS+1
          ENDIF
        ENDDO
C   ---
        NGLOB = NGLOB+MS
        SUA   = MS*SDEL
C  --   SCALE AREA TO VDW SHELL ---
        SUC      = (SUA*(RK-RH2O)*(RK-RH2O))/(RK*RK)
        SURFR(K) = SUC
        SURFA    = SURFA+SUA
        SURFC    = SURFC+SUC

 100    CONTINUE

      ENDDO
C ---------------- END OF CYCLE K-ATOM -----------------
      RETURN
      END

      SUBROUTINE TABLE_SR_DB(R,DEL,N,XP,YP,ZP,SD,NPMAX,IERR)
C --------------------------------
C IERR
C  2   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP NZ < 2')
C  3   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP M < 1')
C  4   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: J > NPMAX')
C --------------------------------
      REAL XP(NPMAX),YP(NPMAX),ZP(NPMAX)
C --------------------------------
      PI    = 4.0*ATAN(1.0)
      XP(1) = 0.0
      YP(1) = 0.0
      ZP(1) = R
      J     = 1
      NZ    = (PI*R)/DEL
      IF(NZ.LE.2) THEN
        IERR=2
        RETURN
      ENDIF
      ANGLZ = PI/NZ
      DO K=1,NZ-1
        Z1 = K*ANGLZ
        Z  = R*COS(Z1)
        RS = SIN(Z1)*R
        M  = 2*PI*RS/DEL
        IF(M.LE.1) THEN
          IERR=3
          RETURN
        ENDIF
        BANGL = 2*PI/M
        DO I=1,M
          BI = BANGL*I
          X  = RS*COS(BI)
          Y  = RS*SIN(BI)
          J  = J+1
          IF(J.GT.NPMAX) THEN
            IERR=4
            RETURN
          ENDIF
          XP(J) = X
          YP(J) = Y
          ZP(J) = Z
        ENDDO
      ENDDO
      XP(J+1) = 0
      YP(J+1) = 0
      ZP(J+1) =-R
      N       = J+1
      SD      = (4.0*PI*R*R)/FLOAT(N)
      RETURN
      END

      SUBROUTINE WRCOOR_SR_DB(MDOC,NAMER,NAMEO
     *     ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *     ,NTOT,NAT,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      REAL      SURFR(NATMX),OCCR(NATMX)
      CHARACTER ANAME*4,CP_PNUM*6,CP_PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3,CP_ALT*1
      CHARACTER ANAME_OLD*4,CSURF*6,REC*4
      CHARACTER NAMER*(*),NAMEO*(*),SURF_KEY*1
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1 
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LT.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      ANAME_OLD   = '?'
      CP_PNUM_OLD = '?'
      REC         = '?'
      I           = 1
      NTOT        = 0
      NAT         = 0   
 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,'(12X,A4,A1,A3,A7)',ERR=500) ANAME,CP_ALT,RNAME,CH7

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400

      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)

      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      CP_PNUM_OLD  = CP_PNUM
      ANAME_OLD    = ANAME     
      
      IF(ATOM(I).NE.ANAME.OR.CP_PNUM.NE.PNUM(I)) GO TO 210 

      SF = SURFR(I)*20.0 + BLIM
      IF(SF.GT.999.99) SF = 999.99
      IF(OCCR(I).GT.0.001) NAT = NAT + 1
      IF(SF.LE.BLIM) THEN
        IF(OCCR(I).GT.0.001) NTOT = NTOT + 1
      ENDIF
      OCC = 1.0
      IF(OCCR(I).LT.0.001) OCC = 0.0

      I = I + 1     

      WRITE(LINE(55:60),'(F6.2)',ERR=500) OCC

      WRITE(CSURF,'(F6.2)') SF
      LINE(67:72) = CSURF

      LINE(17:17) = ' '

      REC = 'ATOM'

 400  CONTINUE

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      GO TO 200

 210  CONTINUE

      IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *   RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *   RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                  ) THEN
        SF = BLIM
        WRITE(CSURF,'(F6.2)') SF
        LINE(67:72) = CSURF
        LINE(17:17) = ' '
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      ENDIF

      GO TO 200
C -------------------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE WRCOOR_SR_DB_ALLOC(MDOC,NAMER,NAMEO
     *     ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *     ,SEG,ACODEA
     *     ,NTOT,NAT,IERR)
C ----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      CHARACTER SEG(NATMX)*4,ACODEA(NATMX)*4
      REAL      SURFR(NATMX),OCCR(NATMX)
      CHARACTER ANAME*4,CP_PNUM*6,CP_PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3,CP_ALT*1
      CHARACTER ANAME_OLD*4,CSURF*6,REC*4
      CHARACTER NAMER*(*),NAMEO*(*),SURF_KEY*1
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1 
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LT.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      ANAME_OLD   = '?'
      CP_PNUM_OLD = '?'
      REC         = '?'
      I           = 1
      NTOT        = 0
      NAT         = 0   
 200  CONTINUE

      READ(INC,'(A)',ERR=520,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,'(12X,A4,A1,A3,A7)',ERR=530) ANAME,CP_ALT,RNAME,CH7

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400

      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)

      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      CP_PNUM_OLD  = CP_PNUM
      ANAME_OLD    = ANAME     
      
      IF(ATOM(I).NE.ANAME.OR.CP_PNUM.NE.PNUM(I)) GO TO 210 

      SF = SURFR(I)*20.0 + BLIM
      IF(SF.GT.999.99) SF = 999.99
      IF(OCCR(I).GT.0.001) NAT = NAT + 1
      IF(SF.LE.BLIM) THEN
        IF(OCCR(I).GT.0.001) NTOT = NTOT + 1
      ENDIF
      OCC = 1.0
      IF(OCCR(I).LT.0.001) OCC = 0.0

      WRITE(LINE(55:60),'(F6.2)',ERR=500) OCC

      WRITE(CSURF,'(F6.2)') SF
      LINE(67:72) = CSURF

      LINE(17:17) = ' '
      LINE(73:80) = SEG(I)//ACODEA(I)
c     WRITE(LINE(73:80),'(A4,A4)',ERR=540) SEG(I),ACODEA(I)
      REC = 'ATOM'

      I = I + 1     

 400  CONTINUE

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      GO TO 200

 210  CONTINUE

      IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *   RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *   RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                  ) THEN
        SF = BLIM
        WRITE(CSURF,'(F6.2)') SF
        LINE(67:72) = CSURF
        LINE(17:17) = ' '
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=515) LINE(1:LEN)
      ENDIF

      GO TO 200
C -------------------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: write line (occ)')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 540  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: write line')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 530  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: read line')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 510  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: write output')
      CALL LENSTR_BL(LINE,LEN)
      WRITE(*,'(A,A,A)') '<',LINE(1:LEN),'>'
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 515  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: write output 2')
      CALL LENSTR_BL(LINE,LEN)
      WRITE(*,'(A,A,A)') '<',LINE(1:LEN),'>'
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
 520  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRCOOR_SR_DB: read input file')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE SURFACE_DB(MDOC,NAMER,NAMEO,SURF
     * ,POOL,MEMORY,RESULT,IPRROW,ISYM,IPRSYM,IERR)
C ------------------------------------------------------   
C -P- SURFACE - calculates area on Van-der-Waals surface accessible to solvent.
C               write to file B_iso = SURFACE*10.0 + B_constant
C -S-   
C --------------------------------------------------------
      REAL      POOL(MEMORY),RESULT(IPRROW)
      CHARACTER LINE*80,NAMER*(*),NAMEO*(*),SURF*1
      INTEGER*2 ISYM(5,3,IPRSYM)
C ------------------------------------------------------
C
      NATMX  = (MEMORY/11)/8
      NATMX  = NATMX*8
C
      I1  =             1
      I2  = NATMX     + 1
      I3  = NATMX *2  + 1 
      I4  = NATMX *3  + 1 
      I5  = NATMX *4  + 1 
      I6  = NATMX *5  + 1 
      I7  = NATMX *6  + 1 
      I8  = NATMX *7  + 1
C 
      I9  = NATMX *8  + 1
      I10 = NATMX *9  + 1 
C
      BLIM = 15.0
      DEL  = 0.1
      RH2O = 1.4

      CALL SURFACE_RUN_DB(MDOC,NAMER,NAMEO,RH2O,DEL,BLIM
     * ,SURF,NATMX
     * ,POOL(I1),POOL(I2),POOL(I3),POOL(I4),POOL(I5),POOL(I6)
     * ,POOL(I7),POOL(I8)
     * ,POOL(I9),POOL(I10)
     * ,RESULT,IPRROW,ISYM,IPRSYM,IERR)
      RETURN
      END


      SUBROUTINE SMOOTH_SCORE2(MDOC,NR,SCORE,SCORET,IERR) 
C -----------------------------------------------
      INTEGER     MDOC,IERR
      REAL        SCORE(*),SCORET(*)
C ----------------------------------------------------------------
      LENGTH = 3
      IF(NR.LT.LENGTH) RETURN
      LENGTH2 = LENGTH/2
      IST     = LENGTH - LENGTH2
      IFN     = NR     - LENGTH2
      DO I=IST,IFN
        SUM =-1.0
        IF(SCORE(I).GE.0.0) THEN
          S  = SCORE(I)
          N  = 1
          DO J=1,LENGTH2
            JJ = I-J
            IF(SCORE(JJ).LT.0.0) GO TO 100
              S = S+SCORE(JJ)
              N = N + 1
          ENDDO
 100      CONTINUE
          DO J=1,LENGTH2
            JJ = I+J
            IF(SCORE(JJ).LT.0.0) GO TO 200
              S = S+SCORE(JJ)
              N = N + 1
          ENDDO
 200      CONTINUE
          S = S/N
c         IF(N.GE.3) SUM=S
          SUM = (S*LENGTH)/FLOAT(N)
        ELSE
          SUM =-1.0
        ENDIF
        SCORET(I) = SUM
      ENDDO

c      DO I=1,LENGTH2
c        IF(SCORE(I).GE.0.0.AND.SCORET(LENGTH2+1).GE.0.0) THEN
c          SCORET(I)     = SCORET(LENGTH2+1)
c        ELSE
c          SCORET(I)     =-1.0
c        ENDIF
c        IF(SCORE(NR-I+1).GE.0.0.AND.SCORET(NR-LENGTH2).GE.0.0) THEN
c          SCORET(NR-I+1)=SCORET(NR-LENGTH2)
c        ELSE
c          SCORET(NR-I+1)=-1
c        ENDIF
c      ENDDO

      DO I=1,LENGTH2
        IF(SCORE(I).GE.0.0) THEN
          SCORE(I)      = SCORE(I)*(LENGTH2+1-I)
        ENDIF
        IF(SCORE(NR-I+1).GE.0.0) THEN
          SCORE(NR-I+1) = SCORE(NR-I+1)*(LENGTH2+1-I)
        ENDIF
      ENDDO

c      DO I=1,NR
      DO I=IST,IFN
        IF(SCORE(I).GE.0.0) THEN
          SCORE(I) = SCORET(I)
        ELSE
          SCORE(I) =-1.0
        ENDIF
      ENDDO

      RETURN
      END

C ==========================================================

      SUBROUTINE SET_DOMAIN_INFO_TO_PDB(MDOC,FILE_CRD,FILE_TEMP
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,ND,CODE8,COMPLEX_ID,IERR)
C ------------------------------------------------
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C -------------------------------------------------
      INTEGER   MDOC,IERR,NDOM
      CHARACTER COMPLEX_ID*10,CODE8*8,SEG_DOM*3
      CHARACTER FILE_CRD*(*),FILE_TEMP*(*),FILE_1*256
      CHARACTER PATH*1,EXT*1,PN1*6,PN2*6,PN*6,CHAIN*1
      CHARACTER LINE*256,CP_PNUM_OLD*7,CP_PNUM*7,CHAIN_DOM*1
      INTEGER   NLETT
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      CHARACTER LETTS*26
c                 01234567890123456789012345
      DATA LETTS/'abcdefghijklmnopqrstuvwxyz'/
      DATA NLETT/26/
C -------------------------------------------------
C     ierr=-1    set '=' in seg_id(76:76) (domains border) 
C                                  for MANAGE_CREATE_DOM_DESCR_FOR_ONE
      IFLAG_DB = 0
      IF(IERR.LT.0) IFLAG_DB = 1
C ---  
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      NDOM = 0
      ND   =-1
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',LINE,IERR)
      IF(IERR.NE.0) RETURN
C     Example: "setenv MOLREP_DB ~alexei/molrep_DB"
      CALL LENSTR_BL(LINE,LEN)
      FILE_1 = LINE(1:LEN)//'/list/domain_list.txt'
C ---
      IS = 0
      IFIRST   = 1
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_1,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input file-domain_list.txt')
        IERR = 1
        RETURN
      ENDIF

 200  CONTINUE
      READ(MT,'(A)',END=100,ERR=900) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.31.OR.LINE(1:1).EQ.'#') GO TO 200
      IF(LINE(7:11).EQ.CODE8(1:5)) THEN
        IFIRST = 0
        IS = IS + 1
        IF(IS.GE.NSTRMAX) THEN
          CALL MSGERR(MD,' WARNING: number of dom_str > limit')
          GO TO 100
        ENDIF

C123456789 123456789 123456789 1
C12345 12345123123 123456 123456
C    2 1nn6A  1  2 A 123- A 228-

        READ(LINE,'(I5,6X,2I3,1X,A6,1X,A6)',ERR=900)
     *   ND,IDOM,ISEG,PN1,PN2
        IF(PN1(1:1).EQ.'_') PN1(1:1) = ' '
        IF(PN1(2:2).EQ.'_') PN1(2:2) = ' '
        IF(PN1(3:3).EQ.'_') PN1(3:3) = ' '
        IF(PN1(4:4).EQ.'_') PN1(4:4) = ' '
        IF(PN1(6:6).EQ.'-') PN1(6:6) = ' '
        IF(PN2(1:1).EQ.'_') PN2(1:1) = ' '
        IF(PN2(2:2).EQ.'_') PN2(2:2) = ' '
        IF(PN2(3:3).EQ.'_') PN2(3:3) = ' '
        IF(PN2(4:4).EQ.'_') PN2(4:4) = ' '
        IF(PN2(6:6).EQ.'-') PN2(6:6) = ' '
        IDOMSEG(IS)  = IDOM*100 + ISEG
        PNUM1_DM(IS) = PN1
        PNUM2_DM(IS) = PN2
        ND_RES(IS)   = 0

c           123123 123456 12345612345
c    1 155c_  1  1 _   5  _ 119     0

        write(line,'(I5,1X,A5,2I3,1X,A6,1X,A6,I5)')
     *   ND,CODE8(1:5),IDOM
     *  ,ISEG,PNUM1_DM(IS),PNUM2_DM(IS),ND_RES(IS)
        CALL MSGDOC(MDOC,LINE)

      ELSE
        IF(IFIRST.EQ.0) GO TO 100
      ENDIF

c12345 12345123123 123456 12345612345
c    2 1g6sA  1  1 A   1  A  18     0

      GO TO 200
C ---
 100  CONTINUE
      CLOSE(MT)
C --                             
        write(line,*) '--is,nd',is,nd,pn1,pn2,'//'
        CALL MSGDOC(MDOC,LINE)


C      IF(IS.LE.0.OR.ND.LE.0) THEN
C        RETURN
C      ENDIF
      IF(IS.LE.0.AND.ND.GT.0) THEN
        IERR = 1
        RETURN
      ENDIF

      CALL LENSTR_BL(FILE_CRD,LEN)
      IF(LEN.LE.0) RETURN

      ND_STRING = IS
C -----------      
      NDOM = 0
      N    = 0 
      CP_PNUM_OLD = '?'
      IDOM_OLD = 0
      ISEG_OLD = 0
      ILETT    = 0
      SEG_DOM = '   '
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input crd file')
        IERR = 1
        RETURN
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 11
      CALL OPENFW(IOUT,M,PATH,FILE_TEMP,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open output crd file')
        IERR = 1
        CLOSE(MT)
        RETURN
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 410

        CP_PNUM = LINE(21:27)
 
        IF(ND.GT.0) THEN

        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
          READ(CP_PNUM(3:6),'(I4)') IRES
          CHAIN   = CP_PNUM(2:2)
          PN(2:6) = CP_PNUM(3:7)
          CP_PNUM_OLD  = CP_PNUM
          SEG_DOM = '---'
          IDOM_OLD = -1
          DO IS=1,ND_STRING
            IDOM = IDOMSEG(IS)/100
            ISEG = IDOMSEG(IS) - IDOM*100
            IF(IDOM.NE.IDOM_OLD) THEN
              ILETT = 1
            ELSE
              ILETT = ILETT + 1
              IF(ILETT.GT.2) ILETT = 1
            ENDIF
            PN1  = PNUM1_DM(IS) 
            PN2  = PNUM2_DM(IS) 
            READ(PN1(2:5),'(I4)') IRES1
            READ(PN2(2:5),'(I4)') IRES2
            CHAIN_DOM = PN1(1:1)
            IF(CHAIN_DOM.EQ.CHAIN.AND.
     *         IRES.GE.IRES1.AND.IRES.LE.IRES2) THEN
              WRITE(SEG_DOM(1:2),'(I2)') IDOM
              IF(IDOM.GT.9.AND.IDOM.LE.NLETT) THEN
                IT = IDOM -9
                SEG_DOM(1:2) = ' '//LETT(IT:IT)
              ENDIF
              SEG_DOM(3:3) = ' '
              IF(IFLAG_DB.GT.0) THEN
                SEG_DOM(3:3) = LETT(ILETT:ILETT)
              ENDIF

C              IF(IDOM.NE.IDOM_OLD) THEN
C                ILETT = 1
C                SEG_DOM(3:3) = ' '
C                IF(IFLAG_DB.GT.0) THEN
C                  SEG_DOM(3:3) = LETT(ILETT:ILETT)
C                ENDIF
C              ELSE IF(IS.NE.ISEG_OLD) THEN
C                SEG_DOM(3:3) = ' '
C                ILETT = ILETT + 1
C                IF(ILETT.GT.2) ILETT = 1
C                IF(IFLAG_DB.GT.0) THEN
CC                 SEG_DOM(3:3) = '='
C                  SEG_DOM(3:3) = LETT(ILETT:ILETT)
C                ENDIF
C              ELSE IF(IS.EQ.ISEG_OLD) THEN
C                IF(IFLAG_DB.GT.0) THEN
C                  SEG_DOM(3:3) = LETT(ILETT:ILETT)
C                ENDIF
C              ELSE
C                SEG_DOM(3:3) = ' '
C              ENDIF
C              ISEG_OLD = IS

              ND_RES(IS) = ND_RES(IS) + 1
              GO TO 420
            ENDIF
            IDOM_OLD = IDOM
          ENDDO
 420      CONTINUE
        ENDIF

        ELSE
          CHAIN   = CP_PNUM(2:2)
          SEG_DOM(2:3) = '0 '
        ENDIF

c       Columns 73 - 76 identify specific segments of the molecule.
        IF(CHAIN.EQ.' '.OR.CHAIN.EQ.'_') THEN
          LINE(73:76) = '--'//SEG_DOM(2:3)    
        ELSE
          LINE(73:76) = CHAIN//CHAIN//SEG_DOM(2:3)       
        ENDIF
C       SEG_DOM(3:3) = ' '

 410  CONTINUE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(MT)

      IF(ND.GT.0) THEN 
      DO IS=1,ND_STRING
        WRITE(LINE,'('' IDS,NR :'',2I8)') IDOMSEG(IS),ND_RES(IS)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      ENDIF

      RETURN
C -------------
 500  CONTINUE
      CLOSE(MT)
      CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
 900  CONTINUE
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE GET_DOMAIN_PDB(MDOC,FILE_CRD,FILE_TEMP
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,N,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR,IDOM
      CHARACTER FILE_CRD*(*),FILE_TEMP*(*)
      CHARACTER PNUM*7,PNUM_OLD*7
      CHARACTER PATH*1,EXT*1,SEG_DOM*1,RNAME*3,DOM*1
      CHARACTER LINE*256,REC*1,STR*80
c     PARAMETER ( NSEGMAX = 20  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
      INTEGER   NLETT
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input crd file')
        IERR = 1
        RETURN
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 0
      CALL CORR_NAME_BL(FILE_TEMP)
      CALL LENSTR_BL(FILE_TEMP,LEN)
      IF(LEN.GT.0) THEN
        IOUT = 11
        CALL OPENFW(IOUT,M,PATH,FILE_TEMP,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MD,
     *       ' ERROR: cannot open output crd file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF
      ENDIF
c ----------------
      PNUM_OLD = '?'
      NRES = 0
      REC = '?'
      N = 0
      ISEG = 0
      NSEG = 0
      IFIRST = 0

 400  CONTINUE

      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IWRT = 1

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 410
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 400
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 410

      SEG_DOM = LINE(75:75)
      IF(IDOM.LE.9) THEN 
        WRITE(DOM,'(I1)') IDOM
      ELSE IF(IDOM.LE.NLETT) THEN 
        IT = IDOM - 9
        DOM = LETT(IT:IT)
      ELSE
        DOM = '-'
      ENDIF
      IF(SEG_DOM.NE.DOM) THEN
        REC = 'ATOM'
        ISEG = 0      
        IWRT = 0
        RNAME = LINE(18:20)
        IF(NDOM.LE.1) THEN
        IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *     RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *     RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                  ) THEN
          IWRT = 1
        ENDIF
        ENDIF
      ELSE
        REC = 'ATOM'
        N = N + 1
        PNUM = LINE(21:27)
        IF(PNUM.NE.PNUM_OLD) THEN
          READ(PNUM_OLD(3:6),'(I4)') IRES_OLD
          READ(PNUM    (3:6),'(I4)') IRES
          IT = IRES - IRES_OLD
          IF(IT.GT.5) ISEG = 0
          IF(ISEG.EQ.0) THEN
            IF(NSEG.LT.NSEGMAX) THEN
              NSEG = NSEG + 1
              PNUM_START(NSEG) = PNUM
              PNUM_FIN(NSEG)   = PNUM
            ELSE
              WRITE(STR,
     *        '(''ERROR:  Number of segments >'',I6)') NSEGMAX 
              CALL MSGERR(MDOC,STR)
              IERR = 1
            ENDIF
            ISEG = 1
          ELSE
            PNUM_FIN(NSEG) = PNUM
          ENDIF
          NRES = NRES + 1 
          PNUM_OLD = PNUM
        ENDIF
      ENDIF

 410  CONTINUE

      IF(IWRT.EQ.1.AND.IOUT.GT.0) THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      ENDIF

      GO TO 400
C --------------
 600  CONTINUE
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      CLOSE(MT)

      WRITE(LINE,'('' Natoms,Nres :'',2I8)') N,NRES
      CALL MSGDOC(MDOC,LINE)
      IF(NSEG.GT.0) THEN
        WRITE(LINE,'('' ID_dom,Nseg :'',2I8)') IDOM,NSEG
        CALL MSGDOC(MDOC,LINE)

        DO I=1,NSEG
          WRITE(LINE,'('' Iseg:'',I5,3X,A7,'' - '',A7)') 
     *         I,PNUM_START(I),PNUM_FIN(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO

      ENDIF
      RETURN
C -------------
 500  CONTINUE
      CLOSE(MT)
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      IF(IOUT.GT.0) CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE WRITE_CHAIN_LIST(MDOC,FILE_2
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
C =========================================================
c     list/chain_list.txt
C ---------------------------------------------------------
      INTEGER   ID_DB(NSEQMAX),NAA_DB(NSEQMAX),NAT_DB(NSEQMAX)
     *         ,NRES_DB(NSEQMAX),ICLASS_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),IHIER_DB(NSEQMAX)
      REAL      FBACK_DB(NSEQMAX)
      REAL      RESOL_DB(NSEQMAX),FIDENT_DB(NSEQMAX),SCR_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,HIER_DB(NSEQMAX)*8
     *         ,COMPLEX_DB(NSEQMAX)*10
c -----------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER FILE_2*(*)
      CHARACTER PATH*1,EXT*1,CODE10*10
      CHARACTER FRMT*256      
C ----------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,'//
     *       'F6.2,1X,I6,1X,I6,1X,A10,1X,F6.1,1X,F6.4,1X,I10)'
C --------------------------------------------------
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFW(MT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output file-chain_list.txt')
        IERR = 1
        RETURN
      ENDIF

C      LINE = '#hier    code5       naa    res    nat   nres'//
C     *       ' m0d0t0r0c0'

      LINE =  '#   id L  ihier  iback fidbk  code5'//
     *        '       naa    res    nat'//
     *        '   nres D0203040C0  ident  score class'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(MT,'(A)',ERR=900) LINE(1:LEN) 

c#hier code5   naa  res    nat  nres  complex(m0d1t0r0c0)  ident  score   id
c    1 11bgA   124  1.90   941   124  m0d0t0r0c0
C12345 12345678

c     * '(iA,1X,A,1X,I6,1X,F6.2,1X,I6,1X,I6,1X,A,1X,F6.1,1X,F6.4,1X,I6)'
c     *  ,ERR=520)
c#
c#   id L  ihier  iback   fid  code5       naa    res    nat   nres 
CD0203040C0  ident  score
c#  451 2 000045    234   20.1 11bgA       124   1.90    941    124 . 
C           22.1 0.3440
c#23456 1 123456 123456 123456 12345678 123456 123456 123456 123456
C 1234567890 123456 123456
c#23456789 123456789 123456789 123456789 123456789 123456789 123456789 123456789
C 123456789 1
c#        1         2         3         4         5         6         7
C         8
c#       

C      FRMT = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,F6.2,1X,I6,1X,'//
C     *       'I6,1X,A10,1X,F6.1,1X,F6.4)'

      DO I=1,NSEQ
        CODE10 = COMPLEX_DB(I)
        CALL LENSTR_BL(CODE10,LEN)
        IF(LEN.LE.0) CODE10 = '.'
        SCR = SCR_DB(I)
        IF(SCR.GT.9.9) SCR = 9.9
        ID_DB(I) = I
        WRITE(LINE,FRMT,ERR=900)
     *   ID_DB(I),ILEVEL_DB(I),IHIER_DB(I),IBACK_DB(I),FBACK_DB(I)
     *  ,CODE_DB(I),NAA_DB(I),RESOL_DB(I),NAT_DB(I),NRES_DB(I),CODE10
     *  ,FIDENT_DB(I),SCR,ICLASS_DB(I)
        CALL LENSTR_BL(LINE,LEN)
        WRITE(MT,'(A)',ERR=900) LINE(1:LEN) 
      ENDDO
      END FILE MT
      CLOSE(MT)
C ---
 100  CONTINUE
      RETURN
 900  CONTINUE
      CALL MSGERR(MD,' ERROR: write new list')

      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE READ_CHAIN_LIST(MDOC,FILE_2,I_MIN,I_MAX
     *   ,NSEQ,ID_DB,NAA_DB,NAT_DB,NRES_DB,RESOL_DB
     *   ,IBACK_DB,ILEVEL_DB,IHIER_DB,FBACK_DB
     *   ,FIDENT_DB,SCR_DB,CODE_DB,HIER_DB,COMPLEX_DB,NSEQMAX
     *   ,ICLASS_DB,IERR)
C =========================================================
c     list/chain_list.txt
C ---------------------------------------------------------
      INTEGER   ID_DB(NSEQMAX),NAA_DB(NSEQMAX),NAT_DB(NSEQMAX)
     *         ,NRES_DB(NSEQMAX),ICLASS_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),IHIER_DB(NSEQMAX)
      REAL      FBACK_DB(NSEQMAX)
      REAL      RESOL_DB(NSEQMAX),FIDENT_DB(NSEQMAX),SCR_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,HIER_DB(NSEQMAX)*8
     *         ,COMPLEX_DB(NSEQMAX)*10
c -----------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER FILE_2*(*)
      CHARACTER PATH*1,EXT*1
C ---------------------------------------------------------
      PARAMETER ( NWORDSMAX = 200 )
      COMMON /FREAD_CIF_500/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*500
C ----------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      NSEQ = 0
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open input file-chain_list.txt')
        IERR = 1
        RETURN
      ENDIF
C          1         2            3           4           5 
C     *   ID_DB(I),ILEVEL_DB(I),IHIER_DB(I),IBACK_DB(I),FBACK_DB(I)
C          6          7          8          9          10        11
C     *  ,CODE_DB(I),NAA_DB(I),RESOL_DB(I),NAT_DB(I),NRES_DB(I),CODE10
C          12           13
C     *  ,FIDENT_DB(I),SCR_DB(I)

 200  CONTINUE
      READ(MT,'(A)',END=100,ERR=900) IN_STRING
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.GT.0.AND.IN_STRING(1:1).NE.'#') THEN
        CALL FRD_PARM_CIF_500
        IF(NWORDS.LE.5) GO TO 200
        IF(WORDS(1)(1:1).EQ.'#') GO TO 200
C ---
        NAA = IWORDS(7)
        IF(I_MIN.GT.0.AND.I_MAX.GT.0) THEN
          IF(NAA.LT.I_MIN.OR.NAA.GT.I_MAX) GO TO 200
        ENDIF
C ---
        IF(NSEQ.GE.NSEQMAX) THEN
          CALL MSGERR(MD,' WARNING: number of sequence > limit')
          GO TO 100
        ENDIF
        NSEQ = NSEQ + 1
C       ID_DB(NSEQ)     = IWORDS(1)
        ID_DB(NSEQ)     = NSEQ
        ILEVEL_DB(NSEQ) = IWORDS(2)
        IHIER_DB(NSEQ)  = IWORDS(3)
        IBACK_DB(NSEQ)  = IWORDS(4)
        FBACK_DB(NSEQ)  = FWORDS(5)
        CALL LENSTR_BL(WORDS(6),L)
        IF(L.GT.8) L = 8
        CODE_DB(NSEQ)  = WORDS(6)(1:L)
        NAA_DB(NSEQ)   = IWORDS(7)
        RESOL_DB(NSEQ) = FWORDS(8)
        NAT_DB(NSEQ)   = IWORDS(9)
        NRES_DB(NSEQ)  = IWORDS(10)
C --
        COMPLEX_DB(NSEQ) = '.'
        FIDENT_DB(NSEQ)  = 0.0
        SCR_DB(NSEQ)     = 0.0
        ICLASS_DB(NSEQ)  = 0.0
C       ID_DB(NSEQ)      = 0
        IF(NWORDS.GE.11) THEN
          CALL LENSTR_BL(WORDS(11),L)
          IF(L.GT.10) L = 10
          COMPLEX_DB(NSEQ) = WORDS(11)(1:L)
        ENDIF
        IF(NWORDS.GE.12) THEN
          FIDENT_DB(NSEQ)  = FWORDS(12)
        ENDIF
        IF(NWORDS.GE.13) THEN
          SCR_DB(NSEQ)     = FWORDS(13)
        ENDIF
        IF(NWORDS.GE.14) THEN
          ICLASS_DB(NSEQ)     = IWORDS(14)
        ENDIF
      ENDIF
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(MT)
      RETURN
 900  CONTINUE
      CLOSE(MT)
      IERR = 1
      RETURN
      END

C ******
      SUBROUTINE FRD_PARM_CIF_500
C -------------------------------------------------------
C -P- FRD_PARM_CIF - free format reading of the string of characters.
C                See common /FREAD_CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 200 )
      COMMON /FREAD_CIF_500/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*500
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*500
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.500) LEN=500
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.200) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

      SUBROUTINE CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)
C ----------------------------------------------
      PARAMETER (N_NAME = 95)
      CHARACTER ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
C -----------------------------------------------
      CHARACTER TYPE*1,CH1*1,CH2*2,CH4*4
      CHARACTER NAME(N_NAME)*2
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','I ','NE','AR','SC','TI','CR','GA','GE',
     *          'AS','KR','HE','ZR','NB','TC','RU','RH','PD','AG',
     *          'SN','SB','XE','LA','HF','TA','RE','OS','IR','AU',
     *          'BI','PO','AT','RN','FR','RA','AC','CE','PR','ND',
     *          'PM','EU','TB','DY','ER','TM','LU','TH','PA','NP',
     *          'PU','AM','CM','BK','CF','ES','FM','MD','NO','LR',
     *          'K ','V ','Y ','U ','W '                          /
C ---------------------------------------------
      IF(ANAME(1:1).NE.' ') THEN
        CH1=ANAME(1:1)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'D') THEN
          CALL LENSTR_BL(ANAME,LN)
          IF(LN.LE.1) THEN
            LN=2
            ANAME(2:2)='H'
          ENDIF
          ASYMB = ANAME(2:2)//'   '
          CH4='    '
          CH4(1:LN)=ANAME(2:LN)//CH1
          ANAME=CH4
C         CTYPE='H   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ELSE IF(ANAME(4:4).EQ.' ') THEN
          CH2=ANAME(1:2)
          DO  I=1,N_NAME
            IF(NAME(I).EQ.CH2) THEN
              ASYMB=ANAME(1:2)//'  '
              CTYPE='$   '
              GO TO 100
            ENDIF
          ENDDO
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
  100     CONTINUE
        ELSE
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ENDIF  
      ELSE
        ASYMB=ANAME(2:2)//'   '
        IF(ASYMB(1:1).EQ.'M') ASYMB='C   '
        IF(ASYMB(1:1).EQ.'C'.OR.ASYMB(1:1).EQ.'N'.OR.
     *     ASYMB(1:1).EQ.'O'.OR.ASYMB(1:1).EQ.'B'.OR.
     *     ASYMB(1:1).EQ.'F'                         ) THEN
          CTYPE='C   '
        ELSE
          CTYPE='$   '
        ENDIF
        IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
      ENDIF
      
      IF(ANAME(1:1).EQ.' ') THEN
        ANAME=ANAME(2:4)//' '
      ENDIF
      IF(ANAME(2:2).EQ.' ') THEN
        ANAME(2:4)=ANAME(3:4)//' '
        IF(ANAME(2:2).EQ.' ') ANAME(2:4)=ANAME(3:4)//' '
      ENDIF
C ---
      IF(RNAME(1:1).EQ.' ') THEN
        RNAME=RNAME(2:3)//' '
        IF(RNAME(1:1).EQ.' ') RNAME=RNAME(2:3)//' '
      ENDIF
      IF(RNAME.EQ.'WAT') RNAME='HOH'
      IF(RNAME.EQ.'DOD') RNAME='HOH'
      IF(RNAME.EQ.'CYT') RNAME='C'
      IF(RNAME.EQ.'ADE') RNAME='A'
      IF(RNAME.EQ.'THY') RNAME='T'
      IF(RNAME.EQ.'GUA') RNAME='G'
      IF(RNAME.EQ.'URI') RNAME='U'

      IF(RNAME(1:1).EQ.'''') RNAME(1:1)='*'
      IF(RNAME(2:2).EQ.'''') RNAME(2:2)='*'
      IF(RNAME(3:3).EQ.'''') RNAME(3:3)='*'
      IF(ANAME(1:1).EQ.'''') ANAME(1:1)='*'
      IF(ANAME(2:2).EQ.'''') ANAME(2:2)='*'
      IF(ANAME(3:3).EQ.'''') ANAME(3:3)='*'
      IF(ANAME(4:4).EQ.'''') ANAME(4:4)='*'

      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ASYMB.EQ.'D  ') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH11') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH12') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HT1 ') THEN
        ANAME    = 'H1  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT2 ') THEN
        ANAME    = 'H2  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT3 ') THEN
        ANAME    = 'H3  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF

      IF(RNAME.EQ.'HOH') THEN
        IF(ASYMB(1:1).EQ.'O') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ELSE IF(ASYMB(1:1).EQ.'H'.OR.ASYMB(1:1).EQ.'D') THEN
          ASYMB = 'H   '
          CTYPE = 'H   '
        ENDIF
      ENDIF
C ---  special cases ---
      IF(RNAME.EQ.'IUM'.AND.CTYPE.EQ.'$   ') THEN
        RNAME = ANAME(1:2)
      ENDIF

      RETURN
      END

      SUBROUTINE CORR_RESNAME_BY_SYNONYM(CH3)
C --------------------------------------------
      CHARACTER CH3*3
      PARAMETER ( NRNAMEU = 24 )
      CHARACTER RNAMEU(NRNAMEU)*3
      PARAMETER ( NRNAME = 185 )
      CHARACTER RNAME(NRNAME)*7
C --
      DATA RNAMEU/'TPQ','AIB','CRQ','SNN','ACY','CRG','SUI','ALS' 
     *           ,'ABA','SIN','175','TA4','NRQ','MDO','CH6','EXC'
     *           ,'GLQ','   ','   ','   ','   ','   ','   ','   '/
C --
      DATA RNAME /'CYG CYS','DTY TYR','SCY CYS','TRQ TRP','PHL PHE'
     *           ,'       ','NEM HIS','IAS ASP','MSO MET','AYA ALA' 
     *           ,'GL3 GLY','GLH GLU','ASI GLY','PN2 SER','ARO ARG'
     *           ,'CSZ CYS','SEC SER','CMH CYS','FGL SER','BFD ASP'
     *           ,'CZZ CYS','143 CYS','YCM MET','CXM MET','LCX LYS' 
     *           ,'MCL LYS','LEF LEU','CSR CYS','LAL ALA','AR4 GLU' 
     *           ,'CSH CYS','MSE MET','BMT THR','MLE LEU','MVA VAL' 
     *           ,'PTR TYR','HYP PRO','INI LYS','NLE LEU','TYS TYR'
     *           ,'CGU GLU','OCS CYS','KCX LYS','SAH CYS','SAM MET' 
     *           ,'SEP SER','LLP LYS','5HP PRO','CSO CYS','1PA ALA' 
     *           ,'2AS ASP','3GA ALA','AEI THR','AGM ARG','AHB ASN' 
     *           ,'ALO THR','APH ALA','ASL ASP','ASM ASP','BCS CYS'
     *           ,'BHD ASP','BTA LEU','BTC CYS','BTR TRP','BUC CYS'
     *           ,'C5C CYS','C6C CYS','CAS CYS','CAY CYS','CCS CYS'
     *           ,'CEA CYS','CHP GLY','CME CYS','CSB CYS','CSD ALA'
     *           ,'CSE CYS','CSP CYS','CSS CYS','CSW CYS','CSX CYS'
     *           ,'CTH THR','CYM CYS','DBY TYR','DHN VAL','DNP ALA'
     *           ,'DOH ASP','DSE SER','EFC CYS','EHP PHE','FLA ALA'
     *           ,'FME MET','FTR TRP','FTY TYR','GAM GLU','GHP GLY'
     *           ,'GSC GLY','GT9 CYS','H5M PRO','HAR ARG','HIC HIS'
     *           ,'HIP HIS','HTR TRP','HV5 ALA','IIL ILE','IML ILE'
     *           ,'ITR TRP','IYR TYR','LLY LYS','LTR TRP','LYZ LYS'
     *           ,'M3L LYS','MCY CYS','MEN ASN','MGN GLN','MGY GLY'
     *           ,'MHL LEU','MHO MET','MHS HIS','MIS SER','MLY LYS'
     *           ,'MLZ LYS','MTY TYR','NEP HIS','NMC GLY','NPH CYS'
     *           ,'NVA VAL','OCY CYS','OMT MET','ONL LEU','PBB CYS'
     *           ,'PEC CYS','PGY GLY','PHI PHE','POM PRO','PPN PHE'
     *           ,'PRR ALA','PRS PRO','PTH TYR','PYA ALA','PYX CYS'
     *           ,'RON VAL','SCH CYS','SEB SER','SEG ALA','SLZ LYS'
     *           ,'SMC CYS','SME MET','SNC CYS','SOC CYS','STY TYR'
     *           ,'SVA SER','TBG GLY','THC THR','TIH ALA','TNB CYS'
     *           ,'TPO THR','TRF TRP','TRG LYS','TRN TRP','TRO TRP'
     *           ,'TYI TYR','TYN TYR','TYQ TYR','YOF TYR','TRY TRP'
     *           ,'DSN SER','DAL ALA','DVA VAL','DPN PHE','DPR PRO' 
     *           ,'DTR TRP','DTH THR','DLE LEU','DAR ARG','DAS ASP' 
     *           ,'DCY CYS','DGL GLU','DGN GLN','DHI HIS','DTY TYR' 
     *           ,'DLY LYS','DIL ILE','DIV VAL','       ','       '/
C --------------------------------------------
      DO I=1,NRNAMEU
        IF(CH3.EQ.RNAMEU(I)) THEN
          CH3 = 'UNK'
          GO TO 100
        ENDIF
      ENDDO
C --
      DO I=1,NRNAME
        IF(CH3.EQ.RNAME(I)(1:3)) THEN
          CH3 = RNAME(I)(5:7)
          GO TO 100
        ENDIF
      ENDDO
 100  CONTINUE
      RETURN
      END

      SUBROUTINE GET_MULTIMER_INFO(MDOC,PATH_DB,FILE_XML
     *                                         ,PATH_SCR,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_XML*(*),PATH_DB*(*),PATH_SCR*(*)
C
C -----------------------------------------------------------
C ---
      INCLUDE 'multimer_info.fh'
C ---
C -----------------------------------------------------------
      COMMON /FREAD_XML/ FWORD_XML,IWORD_XML,IFRD_XML_ERR
     *                          ,ITEM_XML,WORD_XML,STRING_XML
      REAL      FWORD_XML   
      INTEGER   IWORD_XML   
      INTEGER   IFRD_XML_ERR
      CHARACTER ITEM_XML*256
      CHARACTER WORD_XML*256
      CHARACTER STRING_XML*500
C --------------------------------------------------------------
      CHARACTER FILE_XYZ_1*256,FILE_PDB_1*256
      CHARACTER FILE_XYZ_2*256,FILE_PDB_2*256,FILES*256
      CHARACTER PATH*1,EXT*1
      CHARACTER CHAIN_ID*2,PDB_CODE*5,CHAIN_FLAG*1,CHAIN_FLAG_M*1
      CHARACTER DIST*1,PAIR*1
      CHARACTER LINE*256
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      REAL      TR(3),RMAT(3,3),AT(3),AM(3,3)
C ------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      NMULTIMER = 0
C ---
      MT   = 50
      CALL LENSTR_BL(FILE_XML,NL)
      OPEN(MT,FILE=FILE_XML(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='OLD')
C ---
      EXT  = ' '
      PATH = ' '
c      MT   = 10
c      CALL OPENFR(MT,M,PATH,FILE_XML,EXT,IERR)
c      IF(IERR.NE.0) THEN
c      CALL MSGDOC(MD,
c     *       ' ERROR: cannot open input xml file')
c        IERR = 1
c        RETURN
c      ENDIF
C ---
      NMULTIMER = 0
      NMOL      = 0
      NMULT     = 0
      NR     = 0
      NT     = 0
      ISIZE  = 0
      NMULT_LIM = 0
      NMOL_LIM  = 0

 100  CONTINUE

      READ(MT,'(A)',ERR=300,END=200) STRING_XML
      CALL LENSTR_BL(STRING_XML,LEN)
      IF(LEN.LE.0) GO TO 100
      IF(STRING_XML(1:1).EQ.'#') GO TO 100

      CALL FRD_PARM_XML
 
      IF(IFRD_XML_ERR.GT.0) GO TO 400
C --
      CALL LENSTR_BL(ITEM_XML,LITEM)
      CALL LENSTR_BL(WORD_XML,LWORD)

      IF(LWORD.LE.0) THEN

        IF(ITEM_XML.EQ.'assembly') THEN

          IF(NMULTIMER.GE.NMULTIMERMAX) THEN
            NMULT_LIM = 1
          ENDIF

          IF(NMULT_LIM.LE.0) THEN
            NMULTIMER = NMULTIMER + 1
            NMOLECULE(NMULTIMER) = 0
          ENDIF
          NMULT = NMULT + 1
          NMOL = 0
          NMOL_LIM = 0
          CHAIN_FLAG = 'Y' 

          WRITE(LINE
     *      ,'('' --- Assembly:'',I4,'' ---'')') 
     *    NMULTIMER
          CALL MSGDOC(MDOC,LINE)

        ELSE IF(ITEM_XML.EQ.'/assembly') THEN

          IF(NMULT_LIM.LE.0) THEN

            IF(ISIZE.NE.NMOLECULE(NMULTIMER)) GO TO 400

            IF(NMOL_LIM.GT.0) THEN
              WRITE(LINE,'(A,I5,A,I5,A,I5)')
     *        ' WARNING: too many molecules ',NMOL,' >'
     *        ,NMOLECULEMAX,' for assembly No:',NMULT
              CALL MSGERR(MD,LINE)
              NMULTIMER = NMULTIMER - 1
            ELSE IF(NMOL.LT.2) THEN
              WRITE(LINE,'(A,I5,A,I5)')
     *        ' WARNING: N molecules ',NMOL
     *        ,' < 2 for assembly No:',NMULT
              CALL MSGERR(MD,LINE)
              NMULTIMER = NMULTIMER - 1
            ELSE IF(CHAIN_FLAG.EQ.'N') THEN
              NMULTIMER = NMULTIMER - 1
            ELSE
              CALL CHECK_MULTIMER_INFO(MDOC,IERR)
              IF(IERR.EQ.0) THEN
                WRITE(LINE
     *           ,'('' --- Assembly:'',I4,'' ---   OK'')') 
     *          NMULTIMER
                CALL MSGDOC(MDOC,LINE)
              ELSE
                IERR = 0
              ENDIF


            ENDIF

            ISIZE = 0
          ENDIF

        ELSE IF(ITEM_XML.EQ.'molecule') THEN

          CHAIN_FLAG_M = 'Y' 

          IF(NMULT_LIM.LE.0) THEN

            IF(ISIZE.LE.0) GO TO 400

            IF(NMOLECULE(NMULTIMER).GE.NMOLECULEMAX) THEN
              NMOL_LIM = 1
            ENDIF

            IF(NMOL_LIM.LE.0) THEN
              NMOLECULE(NMULTIMER) = NMOLECULE(NMULTIMER) + 1
            ENDIF
            NMOL = NMOL + 1
            NR   = 0
            NT   = 0
          ENDIF

        ELSE IF(ITEM_XML.EQ.'/molecule') THEN

          CALL MDET(ROT_MOLECULE(1,1,NMOL,NMULTIMER),DET)
          IF(DET.LT.0.95) THEN
            WRITE(LINE
     *      ,'(A,I4,'' ERROR: '',A,'' ---> '',A,''  Det: '',F8.3)') 
     *      ' Molecule:',NMOL,PDB_CODE(1:5),CHAIN_ID,DET
            CALL MSGDOC(MDOC,LINE)
            CHAIN_FLAG_M = 'N'
          ENDIF

          IF(CHAIN_FLAG_M.EQ.'R') THEN

            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_XYZ_1 = PATH_DB(1:LEN)//'/pdb_DB/'//
     *                   PDB_CODE(1:5)//'.xyz'
            FILE_PDB_1 = 'multi_temp1.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_PDB_1,LT )
            IF(LEN.GT.0) THEN
              FILE_PDB_1 = PATH_SCR(1:LEN)//FILE_PDB_1(1:LT) 
            ENDIF

            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_XYZ_2 = PATH_DB(1:LEN)//'/pdb_DB/'//
     *                   PDB_CODE(1:4)//CHAIN_ID(2:2)//'.xyz'
            FILE_PDB_2 = 'multi_temp2.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILE_PDB_2,LT )
            IF(LEN.GT.0) THEN
              FILE_PDB_2 = PATH_SCR(1:LEN)//FILE_PDB_2(1:LT) 
            ENDIF

            CALL PDB_UNPACK(M,FILE_XYZ_1,FILE_PDB_1,IERR)
            IF(IERR.NE.0) THEN
              IERR = 0
              CHAIN_FLAG_M = 'N'
              CALL DELETE_FILE(PATH,FILE_PDB_1)
              GO TO 500
            ENDIF 
            CALL PDB_UNPACK(M,FILE_XYZ_2,FILE_PDB_2,IERR)
            IF(IERR.NE.0) THEN
              IERR = 0
              CHAIN_FLAG_M = 'N'
              CALL DELETE_FILE(PATH,FILE_PDB_1)
              CALL DELETE_FILE(PATH,FILE_PDB_2)
              GO TO 500
            ENDIF 
            IPRINT = 0
            PAIR   = 'N'
            DIST   = 'N'
            PO     = 0.0
            PE     = 0.0
            FILES  = ' '
c            ierr =-2
            CALL MAKE_ALIGN5(M,IPRINT,FILE_PDB_2,FILE_PDB_1,FILES
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_SCR,IERR)
C        RESULT(1) = NC   Naa_1
C        RESULT(2) = KC   Naa_2
C        RESULT(3) = NN   Naa aligned
C        RESULT(4) = NHOM Naa identical
C        RESULT(5) = HOM  identity
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)

            HOM = RESULT(5)
            IF(IERR.NE.0.OR.HOM.LT.75.0) THEN
              IERR = 0
              CHAIN_FLAG_M = 'N'
              CALL DELETE_FILE(PATH,FILE_PDB_1)
              CALL DELETE_FILE(PATH,FILE_PDB_2)
              GO TO 500
            ENDIF

            TR(1)     = RESULT(30)
            TR(2)     = RESULT(31)
            TR(3)     = RESULT(32)
            RMAT(1,1) = RESULT(33)
            RMAT(1,2) = RESULT(34)
            RMAT(1,3) = RESULT(35)
            RMAT(2,1) = RESULT(36)
            RMAT(2,2) = RESULT(37)
            RMAT(2,3) = RESULT(38)
            RMAT(3,1) = RESULT(39)
            RMAT(3,2) = RESULT(40)
            RMAT(3,3) = RESULT(41)

            CALL MATMLT(ROT_MOLECULE(1,1,NMOL,NMULTIMER),RMAT,AM)
            CALL MVMULT(ROT_MOLECULE(1,1,NMOL,NMULTIMER),TR,AT)

            AT(1) = AT(1) + TR_MOLECULE(1,NMOL,NMULTIMER)
            AT(2) = AT(2) + TR_MOLECULE(2,NMOL,NMULTIMER)
            AT(3) = AT(3) + TR_MOLECULE(3,NMOL,NMULTIMER)

            DO I=1,3
              TR_MOLECULE(1,NMOL,NMULTIMER) = AT(1)
              TR_MOLECULE(2,NMOL,NMULTIMER) = AT(2)
              TR_MOLECULE(3,NMOL,NMULTIMER) = AT(3)
              DO J=1,3
                ROT_MOLECULE(I,J,NMOL,NMULTIMER) = AM(I,J) 
              ENDDO
            ENDDO

            PATH = ' '
            CALL DELETE_FILE(PATH,FILE_PDB_1)
            CALL DELETE_FILE(PATH,FILE_PDB_2)
            CHAIN_FLAG_M = 'Y'

          ENDIF

  500     CONTINUE
          IF(CHAIN_FLAG_M.NE.'Y') CHAIN_FLAG = CHAIN_FLAG_M

          IF(CHAIN_FLAG_M.EQ.'Y') THEN
            WRITE(LINE
     *      ,'('' Molecule:'',I4,'' '',A,'' ---> '',A,''  OK'')') 
     *      NMOL,PDB_CODE(1:5),CHAIN_ID
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            IF(NR.NE.9.OR.NT.NE.3) GO TO 400
          ENDIF

        ENDIF

      ELSE

        IF(ITEM_XML.EQ.'pdb_code') THEN
          PDB_CODE = WORD_XML(1:5)
        ELSE IF(ITEM_XML.EQ.'size') THEN
          ISIZE = IWORD_XML
        ELSE IF(ITEM_XML.EQ.'chain_id') THEN
          CHAIN_ID = WORD_XML(1:2)
          IF(CHAIN_ID(2:2).NE.PDB_CODE(5:5)) THEN
            CHAIN_FLAG_M = 'N'
c
c           PDB_CODE(5:5): A  CHAIN_ID: CD ==  A -> D -> C   
c                          A            CC ==  A -> C 
c
            CALL LENSTR_BL(CHAIN_ID,LEN)           
            IF(LEN.GE.2) THEN
              CHAIN_FLAG_M = 'R'
            ENDIF  
          ENDIF 
        ELSE IF(ITEM_XML.EQ.'mxx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mxy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mxz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'tx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(1,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'ty') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(2,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'tz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(3,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ENDIF

      ENDIF

C --
      GO TO 100    
 200  CONTINUE
      CLOSE(MT)

      IF(NMULT_LIM.GT.0) THEN
        WRITE(LINE,'(A,I5,A,I5)')
     *  ' WARNING: too many multimers ',NMULT,' >'
     *  ,NMULTIMERMAX
        CALL MSGERR(MD,LINE)
c       NMULTIMER = NMULTIMERMAX
      ENDIF

C ---
      RETURN
 300  CONTINUE
      CLOSE(MT)
      CALL MSGERR(MD,
     *       ' ERROR: reading input xml file')
      IERR = 1
      RETURN
 400  CONTINUE
      CLOSE(MT)
      CALL MSGERR(MD,
     *       ' ERROR: wrong xml file')
      IERR = 1
      RETURN
9100  CONTINUE
      CALL MSGERR(MD,' ERROR: there is not xml file')
      IERR = 9
      RETURN
      END


      SUBROUTINE CHECK_MULTIMER_INFO(MDOC,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
C
C -----------------------------------------------------------
C ---
      INCLUDE 'multimer_info.fh'
C ---
C -----------------------------------------------------------
      CHARACTER LINE*256
C ------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      NMULTI = 1
      IF(NMULTIMER.LE.1) RETURN
      DO I=2,NMULTIMER 

        IF(NMOLECULE(I).GT.0) THEN
          DO J=1,NMULTI
            IF(NMOLECULE(I).EQ.NMOLECULE(J)) THEN
 
              DO IMI=1,NMOLECULE(I)

                DO IMJ=1,NMOLECULE(J)          

                  ISIM = 0

                  DO K=1,3
                    DO L=1,3

                      R = ABS(ROT_MOLECULE(K,L,IMI,I) 
     *                      - ROT_MOLECULE(K,L,IMJ,J))
                      IF(R.GT.0.001) ISIM = 1

                    ENDDO

                    T = ABS(TR_MOLECULE(K,IMI,I) 
     *                    - TR_MOLECULE(K,IMJ,J))
                    IF(T.GT.0.01) ISIM = 1

                  ENDDO

                  IF(ISIM.LE.0) THEN
                    GO TO 200 
C                   molecule IMI = molecule IMJ go to check next IMI 
                  ENDIF

                ENDDO

                GO TO 300 
C               molecule IMI # any molecules IMJ  go to next  multimer J  
                
 200            CONTINUE

              ENDDO

C             multimer I = multimer J

              WRITE(LINE,'(A,I5,A,I5)')
     *        ' WARNING:  multimer ',I,' = multimer ',J
              CALL MSGDOC(MD,LINE)
              IERR = 1               
              GO TO 100 

            ENDIF

 300        CONTINUE

          ENDDO

          NMULTI = NMULTI + 1
          NMOLECULE(NMULTI) = NMOLECULE(I)
          DO IM=1,NMOLECULE(I)
            DO K=1,3
              DO L=1,3
                ROT_MOLECULE(K,L,IM,NMULTI)= ROT_MOLECULE(K,L,IM,I)
              ENDDO
              TR_MOLECULE(K,IM,NMULTI) = TR_MOLECULE(K,IM,I)
            ENDDO
          ENDDO
 100      CONTINUE
        ENDIF

      ENDDO

      NMULTIMER = NMULTI

C ---
      RETURN
      END

      SUBROUTINE FRD_PARM_XML
C -------------------------------------------------------
C -P- FRD_PARM_XML - free format reading of the string of characters.
C                See common /FREAD_XML/
C
C     input:     STRING_XML    - input string
C     output:    ITEM_XML
C                IWORD_XML    - integer value
C                FWORD_XML    - real value 
C                WORD_XML     - word
C                IFRD_XML_ERR  - signal of error. 
C                            0  means OK.
C -----------------------------------------------------------
      COMMON /FREAD_XML/ FWORD_XML,IWORD_XML,IFRD_XML_ERR
     *                          ,ITEM_XML,WORD_XML,STRING_XML
      REAL      FWORD_XML   
      INTEGER   IWORD_XML   
      INTEGER   IFRD_XML_ERR
      CHARACTER ITEM_XML*256
      CHARACTER WORD_XML*256
      CHARACTER STRING_XML*500
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER   IP,IS_ITEM,IS_WORD,LEN,IPP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_XML_ERR = 0
      FWORD_XML    = 0.0     
      IWORD_XML    = 0
      ITEM_XML     = ' ' 
      WORD_XML     = ' '       
      IS_ITEM = 0
      IS_WORD = 0
C
      CALL LENSTR_BL(STRING_XML,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.500) LEN=500
C -----------------
      DO IP=1,LEN

        CH = STRING_XML(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH = ' '

        IF(CH.EQ.'<') THEN
          IF(IS_ITEM.LE.0) THEN
C           item start
            IS_ITEM = 1
          ELSE IF(IS_WORD.GT.0) THEN
C           word finish
            GO TO 100            
          ENDIF
        ELSE IF(CH.EQ.'>') THEN
          IF(IS_ITEM.GT.0) THEN
C           item finish and word start
            IS_WORD = 1
          ENDIF
        ELSE
          IF(IS_WORD.GT.0) THEN
            WORD_XML(IS_WORD:IS_WORD) = CH
            IS_WORD = IS_WORD + 1          
          ELSE IF(IS_ITEM.GT.0) THEN
            ITEM_XML(IS_ITEM:IS_ITEM) = CH
            IS_ITEM = IS_ITEM + 1          
          ENDIF
        ENDIF
      ENDDO
C ----
      WORD_XML = ' '
      IS_WORD  = 0
 100  CONTINUE
      IF(IS_ITEM.LE.0) THEN
        IFRD_XML_ERR = 1
        RETURN
      ENDIF
C
      CALL LENSTR_BL(ITEM_XML,LEN)

      STR = ' '
      IPP = 0
      DO IP=1,LEN      
        IF(ITEM_XML(IP:IP).NE.' ') THEN
          IPP = IPP + 1
          STR(IPP:IPP) = ITEM_XML(IP:IP)
        ENDIF
      ENDDO
      ITEM_XML = STR
      IF(IS_WORD.LE.0) RETURN
C
      CALL LENSTR_BL(WORD_XML,LEN)
      STR = ' '
      IPP = 0
      DO IP=1,LEN      
        IF(WORD_XML(IP:IP).NE.' ') THEN
          IPP = IPP + 1
          STR(IPP:IPP) = WORD_XML(IP:IP)
        ENDIF
      ENDDO
      IF(IPP.LE.0) RETURN
      CALL WTODIG(STR,IPP,FA,IA)
      IWORD_XML = IA
      FWORD_XML = FA
C -----------------
      RETURN
      END      

      SUBROUTINE PDB_PACK(MDOC,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*256

      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ATOM*4,RES*3
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER ACODE*4,CP_PNUM_OLD*7,CP_PNUM_WRT*7
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      CP_PNUM_OLD  = '???????'
      IRES_OLD     = 0
      IRES_NEW_OLD = 0
      IEND    = 0
      IADD    = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ENDIF

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CSURF,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
      IF(CP_OCC.LE.0.0001) GO TO 400

C     IF(CP_PNUM(2:2).EQ.' ') CP_PNUM(2:2) = '_'
      IF(CP_PNUM(7:7).EQ.' ') CP_PNUM(7:7) = '_'

      ATOM  = ANAME
      RES   = RNAME 
      ASYMB = '    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF
      IF(ASYMB(2:2).EQ.' ') THEN
        ASYMB(2:2) = ASYMB(1:1)
        ASYMB(1:1) = ' '
      ENDIF
c ----
      IF(CP_PNUM.NE.CP_PNUM_OLD) THEN
c ---
c ---
c       new residue
        READ(CP_PNUM(3:6),'(I4)') IRES
        CP_PNUM_WRT = CP_PNUM
        IF(CP_PNUM_OLD(1:1).NE.'?') THEN
          READ(CP_PNUM_OLD(3:6),'(I4)') IRES_OLD
          IF(IRES.LT.IRES_OLD.AND.
     *       CP_PNUM_OLD(7:7).EQ.CP_PNUM(7:7).AND.
     *       CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
            IT = IRES_OLD/100
            IADD = (IT + 1)*100 + 100 - IRES 
          ENDIF
        ENDIF

cc        IF(CP_PNUM(7:7).NE.'_') THEN
cc          CP_PNUM_WRT(7:7) = '_'
cc          IF(CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
cc            IADD = IADD + 1
cc          ENDIF
cc        ENDIF

        IRES = IRES + IADD 

cc        IF(CP_PNUM_OLD(1:2).EQ.CP_PNUM(1:2)) THEN
cc          IF(IRES.EQ.IRES_NEW_OLD) THEN
cc            IADD = IADD + 1
cc            IRES = IRES + 1
cc          ENDIF
cc        ENDIF

        IRES_NEW_OLD = IRES
        CP_PNUM_OLD  = CP_PNUM 
        WRITE(CP_PNUM_WRT(3:6),'(I4)') IRES
C ---
c ---
        WRITE(STR,'(A4,A3,A6)')
     *   'RES:',RES,CP_PNUM_WRT(2:7)
c ---                     
        CALL LENSTR_BL(STR,LEN)
        WRITE(IOUT,'(A)') STR(1:LEN)
      ENDIF

      WRITE(STR,'(A4,A2,3F8.3,F6.2)')
     *   ATOM,ASYMB(1:2)
     *  ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_BISO

      CALL LENSTR_BL(STR,LEN)
      WRITE(IOUT,'(A)') STR(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE PDB_UNPACK(MDOC,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*256

      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1

      CHARACTER ASYMB*4,SEG*4
      CHARACTER FRMT*80
      DATA FRMT
     * /'(A6,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,6X,A4,A2)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      IA      = 0
      IEND    = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
      IF(IEND.GT.0) GO TO 600
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LINE(1:6).EQ.'HEADER') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:6).EQ.'COMPND') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ELSE IF(LINE(1:4).EQ.'CRYS') THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
        GO TO 400
      ENDIF

      IF(LINE(1:4).EQ.'RES:') THEN
        READ(LINE,'(4X,A3,A6)') RNAME,CP_PNUM(2:7)
        CP_PNUM(1:1) = ' ' 
        IF(CP_PNUM(7:7).EQ.'_') CP_PNUM(7:7) = ' '
        GO TO 400
      ENDIF

      IF(RNAME.EQ.'HOH') GO TO 400

      IA = IA + 1
      IF(IA.GT.99999) IA = 1

      READ(LINE,'(A4,A2,3F8.3,F6.2)')
     *   ANAME,ASYMB(1:2)
     *  ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_BISO
      CP_OCC  = 1.0
      CP_ALT  = ' '
      CP_CORR = ' '
      IF(CP_PNUM(2:2).EQ.' '.OR.CP_PNUM(2:2).EQ.'_') THEN
        SEG = '----'
      ELSE
        SEG = CP_PNUM(2:2)//CP_PNUM(2:2)//'--'
      ENDIF

      WRITE(STR,FRMT)
     * 'ATOM  ',IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO
     * ,SEG,ASYMB(1:2)

      CALL LENSTR_BL(STR,LEN)
      WRITE(IOUT,'(A)') STR(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CHECK_MEMORY_FOR_LIST(MDOC,FILE,NDOM,IERR)
C -------------------------------------------------
      CHARACTER FILE*(*)
      CHARACTER LINE*320000
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C -----
      NDOM = 0
      MT   = 10
      OPEN(MT,FILE=FILE,ACCESS='SEQUENTIAL',ERR=900,
     *    FORM='FORMATTED',STATUS='OLD')
C ---
 100  CONTINUE
      READ(MT,'(A)',ERR=800,END=200) LINE
      IF(LINE(1:1).EQ.'#') GO TO 100
      NDOM = NDOM + 1 
      GO TO 100  
 200  CONTINUE
      CLOSE(MT)
C ---
      RETURN
 900  IERR=1
      CALL LENSTR_BL(FILE,LLL)
      LINE = 'ERR: can not open:'//FILE(1:LLL)       
      CALL MSGERR(MDOC,LINE)
      RETURN
 800  IERR=1
      CALL LENSTR_BL(FILE,LLL)
      LINE = 'ERR: reading :'//FILE(1:LLL)       
      CALL MSGERR(MDOC,LINE)
      CLOSE(MT)
      RETURN
      END

      SUBROUTINE ALIGN_SS_DEFINITION_ALLOC(MDOC,NR
     * ,XR,YR,ZR,ISS,SURF
     * ,PSS,PH,PB,NATMX,IERR)
C ---------------------------------
c     SS definition by CA-CA distances
c  input:
c     integer:
c       NATMX max number of atoms (size of arraies)
C       NR    actual number of atoms
c     real: 
c       XR(NATMX),YR(NATMX),ZR(NATMX) coordinates of i_atom
c       SURF(NATMX) :       >=0 means CA atom ; else < 0  OCC=0 or dummy
c     scratch array
c       real      TEMPR(NATMX) 
c       integer   ID_DOM(NATMX)
c     output:
c       PSS    SS percent
c       PH     helix percent   
c       PB     beta  percent
c       integer  ISS(NATMX) 1 or 2  helix
c                            3 or 4  beta sheet
c                           or 0
C ---------------------------------------
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      INTEGER   ISS(NATMX)
      INTEGER   SURF(NATMX)

c allocatable
c      REAL      TEMPR(NATMX)
c      INTEGER   ID_DOM(NATMX)
      real,      allocatable :: TEMPR(:)
      integer,   allocatable :: ID_DOM(:)

C ---------------------------------------
      CHARACTER LINE*80
C ---------------------------------------
      PI    = 4.0*ATAN(1.0)
      IERR  = 0
      M     = 99
      MD    =-ABS(MDOC)-1
C ---------------------------------------
      IFIRST = 1
      IF(SURF(1).LT.0) THEN
        DO I=2,NR
          IF(SURF(I-1).LT.0.AND.SURF(I).GT.0) THEN
            IFIRST = I
            GO TO 100
          ENDIF
        ENDDO
      ENDIF
  100 CONTINUE
      ILAST = NR
      IF(SURF(NR).LT.0) THEN
        DO I=NR-1,1,-1
          IF(SURF(I+1).LT.0.AND.SURF(I).GT.0) THEN
            ILAST = I
            GO TO 200
          ENDIF
        ENDDO
      ENDIF
  200 CONTINUE
      IF(IFIRST.LE.ILAST) THEN
        DO I=IFIRST,ILAST
          IF(SURF(I).LT.0) THEN
C            write(LINE,'(a,3i5)') 
C     *      '-ss_def-:',ifirst,ilast,i
C            CALL MSGDOC(MDOC,LINE)
C            RETURN
          ENDIF
        ENDDO
      ENDIF
C -----
      PSS = 0.0
      PH  = 0.0
      PB  = 0.0
      DO I=1,NR
        ISS(I)    = 0
      ENDDO
C --
      IF(NR.LE.3) RETURN

      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(ID_DOM(1:NATMX),STAT=ISTAT)

      DO I=1,NR
        ID_DOM(I) = 0 
        TEMPR(I)  = 0.0
      ENDDO

      H_MIN  = 5.1
      H_MAX  = 5.75
      HH_MIN  = 4.5
      HH_MAX  = 5.8
C      H_MAX  = 5.9
c      B_MIN  = 6.4
c      B_MAX  = 7.5
c      H_MIN  = 5.1
c      H_MAX  = 5.8
      B_MIN  = 6.2
      B_MAX  = 7.55
      BB_MIN  =  9.0
      BB_MAX  = 10.9
      D1     =-1.0
      D2     =-1.0
      NSS    = 0
      IFLAG  = 0
      NH     = 0
      NB     = 0
      ICA3   = 0
      ICA2   = 0
      ICA1   = 0
      DO IA = 1,NR

        IF(SURF(IA).GE.0) THEN
C//
        ICA = IA
        IF(ICA2.GT.0) THEN
          DX = XR(ICA) - XR(ICA2)
          DY = YR(ICA) - YR(ICA2)
          DZ = ZR(ICA) - ZR(ICA2)
          D  = SQRT(DX*DX+DY*DY+DZ*DZ)
          IF(ICA3.GT.0) THEN
            DX = XR(ICA) - XR(ICA3)
            DY = YR(ICA) - YR(ICA3)
            DZ = ZR(ICA) - ZR(ICA3)
            DD = SQRT(DX*DX+DY*DY+DZ*DZ)
          ELSE
            DD = 0.0
          ENDIF
          IF((ICA+1).LE.NR) THEN
            DX = XR(ICA2) - XR(ICA+1)
            DY = YR(ICA2) - YR(ICA+1)
            DZ = ZR(ICA2) - ZR(ICA+1)
            DDD = SQRT(DX*DX+DY*DY+DZ*DZ)
            DX = XR(ICA1) - XR(ICA+1)
            DY = YR(ICA1) - YR(ICA+1)
            DZ = ZR(ICA1) - ZR(ICA+1)
            D3 = SQRT(DX*DX+DY*DY+DZ*DZ)
          ELSE
            DDD = 0.0
          ENDIF

          IHEL   = 0
          IBET   = 0
          IF(D1.GT.0.0.AND.D.GT.0.0) THEN

          
            IF(D .GE.B_MIN.AND.D .LE.B_MAX.AND.
     *         D1.GE.B_MIN.AND.D1.LE.B_MAX     ) THEN
              IBET     = 1
             
              IF(((DD.LT.BB_MIN.OR.DD.GT.BB_MAX).AND.DD.GT.0.001).OR. 
     *          ((DDD.LT.BB_MIN.OR.DDD.GT.BB_MAX).AND.DDD.GT.0.001)) 
     *          IBET=0
            ENDIF

            IF(D2.GT.0.0) THEN
              IF(D .GE.H_MIN.AND.D .LE.H_MAX.AND.
     *           D1.GE.H_MIN.AND.D1.LE.H_MAX.AND.
     *           D3.GE.H_MIN.AND.D3.LE.H_MAX     ) THEN
                IHEL     = 1
                IF((DD.LT.HH_MIN.OR.DD.GT.HH_MAX).AND.DD.GT.0.001) 
     *          IHEL=0
              ENDIF
            ENDIF


c            write(LINE,'(a,i5,5f8.3,2i5)') 
c     *      '-ss-:',ia,d,d1,d3,DD,ddd,ihel,ibet
c            CALL MSGDOC(MDOC,LINE)
 

            IF(IHEL.NE.0.OR.IBET.NE.0) THEN
              IF(IHEL.NE.0) THEN
                IF(IFLAG.NE.1) THEN
                  NSS      = NSS + 1
                  NH       = NH  + 1
                  IFLAG    = 1
                ENDIF
                ISS(ICA ) = NSS
                ISS(ICA1) = NSS
                ISS(ICA2) = NSS
C                IF(ICA3.GT.0) ISS(ICA3) = NSS
              ELSE
                IF(IFLAG.NE.2) THEN
                  NSS      = NSS + 1
                  NB       = NB  + 1
                  IFLAG    = 2
                ENDIF
                ISS(ICA ) = -NSS
                ISS(ICA1) = -NSS
                ISS(ICA2) = -NSS
c               IF(ICA3.GT.0) ISS(ICA3) = -NSS
              ENDIF
            ELSE
              IFLAG = 0
            ENDIF

          ENDIF
   
          D2 = D1
          D1 = D

        ENDIF

        ICA3 = ICA2
        ICA2 = ICA1
        ICA1 = ICA

C// 
        ENDIF
      ENDDO
C --- beta-sheet
      DIST_LIM = 5.25
      DO IA=1,NR
        IF(SURF(IA).GE.0.AND.IA.LE.NR-2) THEN
C//
          IF(ISS(IA).LT.0.AND.SURF(IA+1).GE.0) THEN
            DO JA=IA+2,NR
              IF(SURF(JA).GE.0) THEN
C//
                IF(ISS(IA).NE.ISS(JA).AND.ISS(JA).LT.0) THEN
                  DX = XR(IA) - XR(JA)
                  DY = YR(IA) - YR(JA)
                  DZ = ZR(IA) - ZR(JA)
                  D  = SQRT(DX*DX+DY*DY+DZ*DZ)

                  IF(D.LT.TEMPR(IA).OR.TEMPR(IA).LT.0.0001) THEN
                    TEMPR(IA) = D
                  ENDIF

                  IF(D.LT.TEMPR(JA).OR.TEMPR(JA).LT.0.0001) THEN
                    TEMPR(JA) = D
                  ENDIF

                  IF(D.LT.DIST_LIM) THEN
                    ID_DOM(IA) = ID_DOM(IA) + 1
                    ID_DOM(JA) = ID_DOM(JA) + 1
                  ENDIF 
                ENDIF
C//
              ENDIF 
            ENDDO
          ENDIF
C//
        ENDIF 
      ENDDO

c      DO IA = 1,NR
c       IF(IRESR(IA).LT.0) THEN         
c          WRITE(line,*) '>beta>:'
c     *   ,ia,ABS(IRESR(IA)),ISS(IA),ID_DOM(IA),TEMPR(IA)
c      CALL MSGDOC(MDOC,LINE)
c        ENDIF
c      ENDDO

      IS   = 0
      IF   = 0
      ISEG = 0
      NSEG = 0
      DO IA=1,NR
        IF(SURF(IA).GE.0) THEN             
C//
          IF(ISS(IA).NE.0) THEN
            IF(ISEG.GT.0.AND.NSEG.EQ.ISS(IA)) THEN
              IF = IA
            ELSE
c             star new segment 
              IF(ISEG.GT.0) THEN
                N     = 0
                IFLAG = 1
                IF(IS+1.LE.IF.AND.NSEG.LT.0) THEN
                IFLAG = 0

                NNN = IF-IS+1
            
                DO JA=IS,IF
                  IF(SURF(JA).GE.0) THEN
C//
                    IF(ID_DOM(JA).GT.0) THEN
C                      IF(N.LE.0) THEN
C                        N = N + 1
C                        IF(N.GE.2) IFLAG = 1
C                      ENDIF
C                    ELSE
C                      N = 0
c                      N = ID_DOM(JA-1)+ID_DOM(JA)
                       N = N + ID_DOM(JA)
c                      IF(N.GE.2) IFLAG = 1
                    ENDIF           
C//
                  ENDIF
                ENDDO
                  IF(N.GE.2.AND.NNN.GT.3) IFLAG = 1
                  IF(N.GE.1.AND.NNN.EQ.3) IFLAG = 1
                ENDIF
                N = IF-IS+1
                IF(N.LE.2.AND.NSEG.LT.0) IFLAG = 0
                IF(N.LE.4.AND.NSEG.GT.0) IFLAG = 0
                IF(IFLAG.EQ.0) THEN
                  DO JA=IS,IF
                    IF(SURF(JA).GE.0) THEN
C//
                      ISS(JA) = 0
C//
                    ENDIF
                  ENDDO            
                ENDIF
              ENDIF
              IS   = IA
              IF   = IA
              NSEG = ISS(IA)
              ISEG = 1 
            ENDIF   
          ELSE
C           end segment
C           ISEG = 0 
          ENDIF
C//
        ENDIF 
      ENDDO
c ---------------- last segment 
              IF(IS.GT.0.AND.IF.GT.IS) THEN
                N     = 0

                NNN = IF-IS+1

                IFLAG = 1
                IF(IS+1.LE.IF.AND.NSEG.LT.0) THEN
                IFLAG = 0
                DO JA=IS,IF
                  IF(SURF(JA).GE.0) THEN
C//
                    IF(ID_DOM(JA).GT.0) THEN
C                      IF(N.LE.0) THEN
C                        N = N + 1
C                        IF(N.GE.2) IFLAG = 1
C                      ENDIF
C                    ELSE
C                      N = 0
C                      N = ID_DOM(JA-1)+ID_DOM(JA)
                       N = N + ID_DOM(JA)
C                      IF(N.GE.2) IFLAG = 1
                    ENDIF           
C//
                  ENDIF
                ENDDO
                  IF(N.GE.2.AND.NNN.GT.3) IFLAG = 1
                  IF(N.GE.1.AND.NNN.EQ.3) IFLAG = 1
               ENDIF
                N = IF-IS+1
                IF(N.LE.3.AND.NSEG.LT.0) IFLAG = 0
                IF(N.LE.4.AND.NSEG.GT.0) IFLAG = 0
                IF(IFLAG.EQ.0) THEN
                  DO JA=IS,IF
                    IF(SURF(JA).GE.0) THEN
C//
                      ISS(JA) = 0
C//
                    ENDIF
                  ENDDO            
                ENDIF
              ENDIF
C  ---------------
      NH = 0
      NB = 0
      ID_H = 1
      ID_B = 3
      DO I=1,NR
        IF(ISS(I).LT.0) THEN
          NB = NB + 1
          ID_DOM(I) = ABS(ISS(I))
          IF(I.GT.1) THEN
            IF(ID_DOM(I).NE.ID_DOM(I-1).AND.
     *         ISS(I-1).EQ.ID_B             ) THEN
              IF(ID_B.EQ.3) THEN
                ID_B = 4
              ELSE
                ID_B = 3
              ENDIF
            ENDIF
          ENDIF
          ISS(I) = ID_B
        ELSE IF(ISS(I).GT.0) THEN
          NH = NH + 1
          ID_DOM(I) = ABS(ISS(I))
          IF(I.GT.1) THEN
            IF(ID_DOM(I).NE.ID_DOM(I-1).AND.
     *         ISS(I-1).EQ.ID_H             ) THEN
              IF(ID_H.EQ.1) THEN
                ID_H = 2
              ELSE
                ID_H = 1
              ENDIF
            ENDIF
          ENDIF
          ISS(I) = ID_H
        ELSE
          ID_DOM(I) = 0
        ENDIF 

C          WRITE(*,*) '>SS>:',i,ISS(I),ID_DOM(I)

      ENDDO
      NHB = NB + NH
      PH  = (FLOAT(NH)/FLOAT(NR))*100.0
      PB  = (FLOAT(NB)/FLOAT(NR))*100.0
      PSS = (FLOAT(NHB)/FLOAT(NR))*100.0
C ---
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(ID_DOM,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE READ_PDB_SEQ_AND_COORD_CA(MDOC,NAME_IN
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE_PDB,NCHAIN,ITEST,IERR)
C --------------------------------------------------------
      CHARACTER CODE_PDB*(*)
      INTEGER   NSEQ(NMAX),IRES(NMAX)
      INTEGER   SURF(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      REAL      COORD(NMAX,3)
      CHARACTER PNUM(NMAX)*6
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
C ----
      CHARACTER LINE*256,NAME*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1,CH3*3,CH4*4,CH6*6
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1,CSURF*6
      CHARACTER FRMT*80,ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      CHARACTER CP_PNUM_CA*7,CP_PNUM_CA_OLD*7
      CHARACTER CP_SEG*4,CP_SEG_OLD*4
      CHARACTER CH_SEG*1,CH_SEG_OLD*1,CHS*1
      PARAMETER ( NRNAMED = 38 )
      CHARACTER RNAMED(38)*3
      PARAMETER ( NRNAMES = 14 )
      CHARACTER RNAMES(14)*3
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','---' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C
      DATA RNAMED/'A  ','C  ','G  ','T  ','U  ','I  ','+A ','+C ' 
     *           ,'+G ','+T ','+U ','1MA','1MG','2MG','5MC','5MU'
     *           ,'7MG','H2U','M2G','OMC','OMG','OMU','PSU','YG '
     *           ,'Ad ','Ar ','Cd ','Cr ','Gd ','Gr ','Td ','Ur '
     *           ,'Ir ','DA ','DC ','DT ','DG ','DI '/
      DATA RNAMES/'MAN','NAG','FUC','GAL','GLC','GCU','GSA','XYS' 
     *           ,'ARB','RIP','ABE','RAM','MAG','MMA'            /
      INTEGER   NLETT,NLETTD
      CHARACTER LETT*26,LETTD*10
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA LETTD/'0123456789'/
      DATA NLETT/26/,NLETTD/10/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
c      OPEN(IU,FILE=NAME_IN(1:LEN),ACCESS='SEQUENTIAL',ERR=200
c     *  ,FORM='FORMATTED',STATUS='OLD')
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      IADD   = 0
      INEW   = 0
      N      = 0 
      NAA    = 0
      N_OLD  = 0 
      N_NEW  = 0 
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD    = '?'
      CP_PNUM_CA_OLD = '?'
      ANAME_OLD      = '?'
      CP_SEG_OLD     = '?'
      CH_SEG_OLD     = '?'
      CH_SEG         = ' '
      ICH      = 0
      ICH_OLD  =-1
      ICH_CA   = 0
      NCHAIN   = 0
      IEND     = 0
      NDNA     = 0
      IDOM     = 0
      ISEG     = 0
      IDOM_OLD = 0
      IDOMS_OLD=-1
      IDOMS    = 0
      ISEG_OLD = 0
      ISG_OLD  = 0
      NSEG     = 0
      IF(ITEST.EQ.0) THEN
        DO I=1,NMAX
          SURF(I) = 0
        ENDDO         
      ENDIF
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      CALL LENSTR_BL(LINE,LEN)

      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        CODE_PDB = LINE(63:66)
        GO TO 400
      ENDIF        

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CSURF,ACODE

      CP_SEG = LINE(73:76)
      
      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
 
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF

      IWD = 6
      II  = 0
      CH6 = '      '
      DO I=1,IWD
        IF(CSURF(I:I).NE.' ') THEN
          II = II + 1
          CH6(II:II) = CSURF(I:I)
        ENDIF
      ENDDO
      IWD = II
      IF(II.GT.0) THEN 
        CALL WTODIG(CH6,IWD,FDIG,IDIG)
        CP_SURF = FDIG 
      ELSE
        CP_SURF = 0
      ENDIF

c ----
      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
c ----
      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO

      DO  J=1,NRNAMED
        IF(CH3.EQ.RNAMED(J)) THEN
          NDNA = NDNA + 1
          GO TO 400
        ENDIF
      ENDDO
      DO  J=1,NRNAMES
        IF(CH3.EQ.RNAMES(J)) THEN
          GO TO 400
        ENDIF
      ENDDO

      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
C     IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.21) THEN
C ===
      IF(ASYMB(1:1).EQ.'H') GO TO 400
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD) GO TO 400
      ANAME_OLD = ANAME 
      IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
c       new residue
        IF(CP_PNUM_OLD(2:2).NE.CP_PNUM(2:2)) THEN
c         new chain
          ICH = ICH + 1
        ENDIF
        N_OLD = N_NEW    
        IF(N_OLD.GT.0) THEN
          ITM  = 0
          IF(NRA.GT.0) THEN
            T = SUM_SURF/FLOAT(NRA) + 10.00001
            ITM = T/20.0
            IF(ITM.GT.8) ITM = 8   
            IF(ITM.LE.0) ITM = 1   
          ENDIF   
          IF(ITEST.EQ.0) THEN  
            IF(SURF(N_OLD).GE.0) SURF(N_OLD) = ITM
          ENDIF
        ENDIF
        INEW     = 0
        SUM_SURF = 0.0
        NRA      = 0

        IF(CP_PNUM_OLD(2:6).EQ.CP_PNUM(2:6)) IADD = IADD + 1

        CP_PNUM_OLD  = CP_PNUM

CCC          IDOM_OLD = IDOM
CCC          IF(CP_SEG_OLD(3:3).NE.CP_SEG(3:3)) IDOM = IDOM + 1
CCC          CP_SEG_OLD = CP_SEG

      ENDIF
      IF(CP_OCC.GT.0.001) THEN
        T        = CP_SURF - 15.1
        IF(T.LT.0.0) T = 0.0
        SUM_SURF = SUM_SURF + T
        NRA      = NRA + 1
      ENDIF
      IF(ANAME.EQ.'CA  ') THEN

        CP_PNUM_CA = CP_PNUM

        IF(CP_PNUM_CA_OLD.EQ.CP_PNUM_CA) THEN
          LINE = ' ERR: CA ?  '// RNAME//'  '//CP_PNUM
     *             //' '//CODE_PDB   
          CALL MSGERR(MDOC,LINE)
        ENDIF
        ID = 0
        IF(CP_PNUM_CA_OLD.NE.'?') THEN
          READ(CP_PNUM_CA_OLD(3:6),'(I4)') IR_OLD
          READ(CP_PNUM(3:6),'(I4)') IR
          ID = IR -IR_OLD
        ENDIF
C ///
        IF(CP_SEG(3:3).EQ.' '.OR.CP_SEG(3:3).EQ.'-'.OR.
     *     CP_SEG(3:3).EQ.'_'.OR.CP_SEG(3:3).EQ.'0'    ) THEN
          IDOM   = 0
          ISEG   = 0
          CH_SEG = ' '
          IDOMS  = 0
        ELSE
          IDOM = 0
          DO LL=1,NLETT
            IF(LETT(LL:LL).EQ.CP_SEG(3:3)) THEN
              IDOM = LL + 9
              GO TO 111
            ENDIF
          ENDDO
          DO LL=1,NLETTD
            IF(LETTD(LL:LL).EQ.CP_SEG(3:3)) THEN
              READ(CP_SEG(3:3),'(I1)') IDOM
              GO TO 111
            ENDIF
          ENDDO
  111     CONTINUE
          CHS = CP_SEG(4:4)
          IF(CHS.EQ.'a'.OR.CHS.EQ.'b') THEN
            ISEG = 1
          ELSE
            ISEG = 0
          ENDIF
          CH_SEG = CHS
          IF(CH_SEG.EQ.'a') CH_SEG = 'A' 
          IF(CH_SEG.EQ.'b') CH_SEG = 'B'
          IF(IDOM.NE.IDOM_OLD.OR.CH_SEG.NE.CH_SEG_OLD) THEN
            NSEG = NSEG + 1
          ENDIF 
          IDOMS = NSEG*10 + ISEG
        ENDIF
C ///
        IF(IDOMS.NE.IDOMS_OLD) THEN
            IF(IDOMS_OLD.GT.0) THEN
              IF(ISEG_OLD.GT.0) THEN
C               --> '+' only for sequence
              ENDIF
C             --> '='
              N = N +  1
              IF(ITEST.EQ.0) THEN
                IF(N.GT.NMAX) GO TO 910
                IRES(N) = 0          
                NSEQ(N) = 24
                IDOMAIN(N) = IDOMS_OLD
                SURF(N)    =-1
C               PNUM(N)(1:1) = CP_PNUM(2:2)
C               PNUM(N)(2:6) = CP_PNUM(3:7)
                PNUM(N)(1:1) = ' '
                PNUM(N)(2:6) = '     '
                ICHAIN(N)  = ICH_CA 
                COORD(N,1) = 1000.0 
                COORD(N,2) = 1000.0 
                COORD(N,3) = 1000.0 
              ENDIF
            ENDIF

            IF(IDOMS.GT.0) THEN
C               --> '='
              N = N +  1
              IF(ITEST.EQ.0) THEN
                IF(N.GT.NMAX) GO TO 910
                IRES(N) = 0          
                NSEQ(N) = 24
                IDOMAIN(N) = IDOMS
                SURF(N)    =-1
C               PNUM(N)(1:1) = CP_PNUM(2:2)
C               PNUM(N)(2:6) = CP_PNUM(3:7)
                PNUM(N)(1:1) = ' '
                PNUM(N)(2:6) = '     '
                ICHAIN(N)  = ICH_CA
                COORD(N,1) = 1000.0 
                COORD(N,2) = 1000.0 
                COORD(N,3) = 1000.0 
              ENDIF
              IF(ISEG.GT.0) THEN
C               --> '+' only for sequence
              ENDIF
            ENDIF
          ELSE IF(ID.LT.0.OR.ID.GT.1) THEN

            N = N +  1
            IF(ITEST.EQ.0) THEN
              IF(N.GT.NMAX) GO TO 910
              IRES(N) = 0          
              NSEQ(N) = 25
              IDOMAIN(N) = IDOMS
              SURF(N)    =-1
C             PNUM(N)(1:1) = CP_PNUM(2:2)
C             PNUM(N)(2:6) = CP_PNUM(3:7)
              PNUM(N)(1:1) = ' '
              PNUM(N)(2:6) = '     '
              ICHAIN(N)  = ICH_CA
              COORD(N,1) = 1000.0 
              COORD(N,2) = 1000.0 
              COORD(N,3) = 1000.0 
            ENDIF
        ENDIF

        CP_PNUM_CA_OLD = CP_PNUM_CA
        SEG_OLD        = SEG

        INEW  = 1
C //    N_OLD = N
        N = N + 1
        N_NEW = N
        NAA = NAA + 1
        READ(CP_PNUM(3:6),'(I4)') IR
C ??? NCHAIN
        IF(ICH_OLD.NE.ICH) THEN
          ICH_CA  = ICH_CA + 1
          ICH_OLD = ICH
        ENDIF          
        IF(ICH_CA.LE.0) ICH_CA = 1

        IF(ITEST.EQ.0) THEN
          IF(N.GT.NMAX) GO TO 910
          IRES(N) = IR          
          NSEQ(N) = J
          PNUM(N)(1:1) = CP_PNUM(2:2)
          PNUM(N)(2:6) = CP_PNUM(3:7)
          ICHAIN(N)  = ICH_CA
          IDOMAIN(N) = IDOMS
          IF(CP_OCC.GT.0.001) THEN
            COORD(N,1) = CP_XYZ(1) 
            COORD(N,2) = CP_XYZ(2) 
            COORD(N,3) = CP_XYZ(3) 
          ELSE
            COORD(N,1) = 1000.0 
            COORD(N,2) = 1000.0 
            COORD(N,3) = 1000.0 
            SURF(N)    =-1
          ENDIF
        ENDIF

        IDOM_OLD   = IDOM
        IDOMS_OLD  = IDOMS
        ISEG_OLD   = ISEG
        CH_SEG_OLD = CH_SEG

      ENDIF

      ENDIF
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)

      IF(IDOMS_OLD.GT.0) THEN
        IF(ISEG_OLD.GT.0) THEN
C         --> '+' only for sequence
        ENDIF
C             --> '='
        N = N +  1
        IF(ITEST.EQ.0) THEN
          IF(N.GT.NMAX) GO TO 910
          IRES(N) = 0          
          NSEQ(N) = 24
          IDOMAIN(N) = IDOMS_OLD
          SURF(N)    =-1
C          PNUM(N)(1:1) = CP_PNUM(2:2)
C          PNUM(N)(2:6) = CP_PNUM(3:7)
          PNUM(N)(1:1) = ' '
          PNUM(N)(2:6) = '     '
          ICHAIN(N)  = ICH_CA
          COORD(N,1) = 1000.0 
          COORD(N,2) = 1000.0 
          COORD(N,3) = 1000.0 
        ENDIF
      ENDIF


C //
      IF(N_OLD.GE.1.AND.N_OLD.LT.N) THEN
        N_OLD = N_NEW
C //
        ITM   = 0
        IF(NRA.GT.0) THEN
          T = SUM_SURF/FLOAT(NRA) + 10.00001
          ITM = T/20.0
          IF(ITM.GT.8) ITM = 8   
          IF(ITM.LE.0) ITM = 1   
        ENDIF 
        IF(ITEST.EQ.0) THEN  
          IF(SURF(N_OLD).GE.0) SURF(N_OLD) = ITM
        ENDIF

      ENDIF

      NCHAIN = ICH_CA

      WRITE(LINE,'('' Number of residues :'',I8)') NAA
      CALL MSGDOC(MDOC,LINE)
      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues for sequence = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
 910  CONTINUE
      WRITE(LINE,'('' ERR: NUMBER OF RESIDUES >'',I8)')NMAX
      CALL MSGERR(MDOC,LINE) 
      IERR=1
      CLOSE(IU)
      RETURN
      END

      SUBROUTINE SURFACE_DB_ALLOC(MDOC,NAMER,NAMEO
     * ,RESULT,IPRROW,IERR)   
C ---------------------------------------
C ---
C      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
C      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
C      REAL      OCCR(NATMX),TEMPR(NATMX),SURFR(NATMX),RADVDW(NATMX)
C      REAL      ELPOT(NATMX)
c--allocatable
      real,      allocatable :: XR(:)
      real,      allocatable :: YR(:)
      real,      allocatable :: ZR(:)
      real,      allocatable :: OCCR(:)
      real,      allocatable :: TEMPR(:)
      real,      allocatable :: SURFR(:)
      real,      allocatable :: RADVDW(:)
      real,      allocatable :: ELPOT(:)
      character(LEN=6), allocatable :: PNUM(:)
      character(LEN=4), allocatable :: ATOM(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)
C ---
      REAL      RESULT(IPRROW)
C ---------------------------------------
      CHARACTER LINE*256,NAMER*(*),NAMEO*(*),SURF_KEY*1
C ---------------------------------------
      IERR = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      BLIM = 15.0
      DEL  = 0.1
      RH2O = 1.4
C -----------
      ITEST = 1
      NATMX = 100
      
      allocate(XR(1:NATMX),STAT=ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      allocate(ATOM(1:NATMX),STAT=ISTAT)
      allocate(PNUM(1:NATMX),STAT=ISTAT)
      allocate(SEG(1:NATMX),STAT=ISTAT)
      allocate(ACODE(1:NATMX),STAT=ISTAT)

      CALL RDCOOR_SR_DB_ALLOC(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,SEG,ACODE
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NRES,ITEST,IERR)
      IF(IERR.NE.0) GO TO 100
C -----------
      IF(NR.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: surface: number of atoms = 0')
        IERR=1
        GO TO 100
      ENDIF
C -----------

      deallocate(XR,STAT=ISTAT)
      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(ATOM,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

      ITEST = 0
      NATMX = NR
      
      allocate(XR(1:NATMX),STAT=ISTAT)
      allocate(YR(1:NATMX),STAT=ISTAT)
      allocate(ZR(1:NATMX),STAT=ISTAT)
      allocate(OCCR(1:NATMX),STAT=ISTAT)
      allocate(TEMPR(1:NATMX),STAT=ISTAT)
      allocate(SURFR(1:NATMX),STAT=ISTAT)
      allocate(RADVDW(1:NATMX),STAT=ISTAT)
      allocate(ELPOT(1:NATMX),STAT=ISTAT)
      allocate(ATOM(1:NATMX),STAT=ISTAT)
      allocate(PNUM(1:NATMX),STAT=ISTAT)
      allocate(SEG(1:NATMX),STAT=ISTAT)
      allocate(ACODE(1:NATMX),STAT=ISTAT)


      CALL RDCOOR_SR_DB_ALLOC(MDOC,NAMER,NR,XR,YR,ZR,OCCR,TEMPR,SURFR
     *     ,SEG,ACODE
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NRES,ITEST,IERR)
      IF(IERR.NE.0) GO TO 100
C -----------
      WRITE(LINE,'('' Number of atoms :'',I6)') NR
      CALL MSGDOC(MDOC,LINE)
C -----------

      CALL CALC_RAD_INERTIA(MDOC,NR,XR,YR,ZR,OCCR,TEMPR
     *    ,NATMX,RAD_INER,IERR)

C ------------
      CALL AREA_SR_DB_ALLOC(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT,OCCR
     *    ,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C IERR
C  1   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N_atoms = 0')
C  2   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP NZ < 2')
C  3   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: STOP M < 1')
C  4   - CALL MSGERR(MDOC,' ERROR: surface: table_sr: J > NPMAX')
C  5   - CALL MSGERR(MDOC,' ERROR: surface: area_sr: N-neighbors > LIMIT') 
      IF(IERR.NE.0) THEN
        IF(IERR.EQ.1) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N_atoms = 0')
        IF(IERR.EQ.2) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP NZ < 2')
        IF(IERR.EQ.3) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: STOP M < 1')
        IF(IERR.EQ.4) CALL MSGERR(MDOC,
     *    ' ERROR: surface: table_sr: J > NPMAX')
        IF(IERR.EQ.5) CALL MSGERR(MDOC,
     *    ' ERROR: surface: area_sr: N-neighbors > LIMIT') 
        GO TO 100
      ENDIF
      WRITE(LINE,9999) SURFC
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,9997) SURFA
      CALL MSGDOC(MDOC,LINE)
 9999 FORMAT(' Total Contact    Surface Area =',F10.3)
 9997 FORMAT(' Total Accessible Surface Area =',F10.3)
      CALL MSGDOC(MDOC,' ')
C ------------------------------------------------------------------

      CALL WRCOOR_SR_DB_ALLOC(MDOC,NAMER,NAMEO
     *   ,OCCR,SURF_KEY,BLIM,SURFR,PNUM,ATOM,NATMX
     *   ,SEG,ACODE
     *   ,NTOT,NAT,IERR)
      IF(IERR.NE.0) GO TO 100

C ---------------------------------------
      RESULT(1) = NAT
      RESULT(2) = SURFA
      RESULT(3) = SURFC
      RESULT(8) = NTOT
      RESULT(9) = NRES
      RESULT(10)= RAD_INER

 100  CONTINUE

      deallocate(XR,STAT=ISTAT)
      deallocate(XR,STAT=ISTAT)
      deallocate(YR,STAT=ISTAT)
      deallocate(ZR,STAT=ISTAT)
      deallocate(OCCR,STAT=ISTAT)
      deallocate(TEMPR,STAT=ISTAT)
      deallocate(SURFR,STAT=ISTAT)
      deallocate(RADVDW,STAT=ISTAT)
      deallocate(ELPOT,STAT=ISTAT)
      deallocate(ATOM,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

 900  CONTINUE

C --------------------------------
      RETURN
      END

      SUBROUTINE CALC_RAD_INERTIA(MDOC,NR,X,Y,Z,OCC,TEMP
     *    ,NATMX,RAD_INER,IERR)
C ---------------------------------------
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX)
C --------------------------------
      RAD_INER = 0.0
      N   = 0
      XS  = 0.0
      YS  = 0.0
      ZS  = 0.0
      XS2 = 0.0
      YS2 = 0.0
      ZS2 = 0.0
      DO I=1,NR
        IF(OCC(I).GT.0.001) THEN
          XS  = XS  + X(I)
          YS  = YS  + Y(I)
          ZS  = ZS  + Z(I)
          XS2 = XS2 + X(I)*X(I)
          YS2 = YS2 + Y(I)*Y(I)
          ZS2 = ZS2 + Z(I)*Z(I)
          N   = N + 1
        ENDIF
      ENDDO
      IF(N.LE.0) RETURN      
      XS  = XS/REAL(N)
      YS  = YS/REAL(N)
      ZS  = ZS/REAL(N)
      XS2 = XS2/REAL(N)
      YS2 = YS2/REAL(N)
      ZS2 = ZS2/REAL(N)
      RX  = XS2-XS*XS
      RY  = YS2-YS*YS
      RZ  = ZS2-ZS*ZS
      RAD_INER = SQRT(ABS(RX+RY+RZ))
C --------------------------------
      RETURN
      END

      SUBROUTINE RDCOOR_SR_DB_ALLOC(MDOC
     *     ,NAME_IN,NCRDR,X,Y,Z,OCC,TEMP,SURF
     *     ,SEG,ACODEA
     *     ,RADVDW,ELPOT,PNUM,ATOM,NATMX,NR
     *     ,ITEST,IERR)
C ---------------------------------------
      CHARACTER PNUM(NATMX)*6,ATOM(NATMX)*4
      REAL      X(NATMX),Y(NATMX),Z(NATMX)
      REAL      OCC(NATMX),TEMP(NATMX),SURF(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX)
      CHARACTER SEG(NATMX)*4,ACODEA(NATMX)*4
C ------------------------------------------------------------
      CHARACTER CHAR2*2
C ----------------------------------------------
      PARAMETER (N_NAME = 9)
      REAL      TAB_RVDW(N_NAME)
      CHARACTER NAME(N_NAME)*2
      DATA NAME    /'C ','O ','N ','S ','P ','H ','FE','CA','ZN'/
      DATA TAB_RVDW/1.8 ,1.7 ,1.6 ,1.9 ,2.1 ,0.8 ,0.65,1.18,0.88/
C B       10.82000  N     0.650      .
C F       19.00000  N     1.330      .
C NA      22.99000  N      .         .
C MG      24.32000  N     0.820      .
C P       30.97380  N     2.100      .
C PS      30.97380  N     2.100      .
C S       32.06400  A     1.900      .
C SH1     32.06400  B     1.900     1.950
C CL      35.45700  N     1.810      .
C CA      40.08000  N     1.180      .
C V       50.95000  N     0.880      .
C MN      54.94000  N     0.800      .
C FE      55.84700  N     0.650      .
C CO      58.94000  N     0.720      .
C CU      63.54600  N     0.740      .
C ZN      65.37000  N     0.880      .
C BR      79.91600  N     1.960      .
C CD     112.40000  N     1.140      .
C I      126.90450  A     2.200      .
C PB     207.21000  N     1.200      .
C HG     200.61000  N     1.270      .
C -------------------------------------------------------------------
      CHARACTER CODE_PDB*4
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
C ----
      CHARACTER LINE*256,PATH*80,EXT*80,STR*80
      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
      CHARACTER CH3*3
      CHARACTER CH4*4
      REAL      CP_XYZ(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER ASYMB*4,CTYPE*4,TYPE1*1,TYPE2*1
      CHARACTER FRMT*80,ACODE*4,CP_PNUM_OLD*7,ANAME_OLD*4
      CHARACTER CP_SEG*4
      DATA FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,6X,A4,A4)'/
c123456123451123411231234567
cATOM      4  O   THR     1      -5.209  15.501  13.516  1.00 32.45      2PIA 
cATOM      6  OG1 THR     1      -2.234  12.957  13.779  1.00 42.29      2PIA
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','---' 
     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL CORR_NAME_BLC(NAME_IN)
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      NCRDR = 0
      N     = 0 
      NR    = 0
      CODE_PDB = 'XXXX'
      CP_PNUM_OLD = '?'
      ANAME_OLD   = '?'
C ----------------
 400  CONTINUE
      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 400
      IF(LEN.GE.66.AND.LINE(1:6).EQ.'HEADER') THEN
        CODE_PDB = LINE(63:66)
        GO TO 400
      ENDIF        

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,CP_XYZ(1),CP_XYZ(2),CP_XYZ(3),CP_OCC,CP_BISO,CP_SEG,ACODE

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 400
 
      ASYMB='    '
      CALL CORR_NAME(ANAME,RNAME,ASYMB,CTYPE)
      CALL CHKSMB(ACODE(1:1),TYPE1)
      CALL CHKSMB(ACODE(2:2),TYPE2)

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.CP_PNUM_OLD)GO TO 400
      IF(CP_PNUM.NE.CP_PNUM_OLD) THEN
        IF(CP_OCC.GT.0.001) THEN
          IF(RNAME.NE.'HOH') NR = NR + 1
        ENDIF
      ENDIF
      CP_PNUM_OLD  = CP_PNUM

      CH4 = ACODE
      IF(TYPE1.NE.'D'.AND.TYPE2.NE.'D'.AND.TYPE2.NE.'B'.AND.
     *  LEN.GE.77) THEN
        IF(ACODE(1:1).EQ.' ') THEN
          ACODE = ACODE(2:4)//' '
        ENDIF
        IF(ACODE(2:2).EQ.' ') THEN
          ACODE(2:4) = ACODE(3:4)//' '
          IF(ACODE(2:2).EQ.' ') ACODE(2:4) = ACODE(3:4)//' '
        ENDIF
        ASYMB = ACODE
      ENDIF
      ACODE = CH4

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)

      CH3 = RNAME
      DO  J=1,23
        IF(CH3.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.GE.1.AND.J.LE.23) THEN
        IF(N.GE.NATMX.AND.ITEST.EQ.0) THEN
          WRITE(LINE,'('' ERR: NUMBER OF ATOMS >'',I8)') NATMX
          CALL MSGDOC(MDOC,LINE) 
          IERR=1
          CLOSE(IN)
          RETURN
        ENDIF

C        IF(CP_OCC.GT.0.001) THEN
          N = N + 1
          IF(J.EQ.22) J = 7
          IF(J.EQ.23) J = 8

          IF(ITEST.EQ.0) THEN
            PNUM(N)(1:1) = CP_PNUM(2:2)
            PNUM(N)(2:6) = CP_PNUM(3:7)
            ATOM(N)      = ANAME
            ANAME_OLD    = ANAME
            X     (N) = CP_XYZ(1)
            Y     (N) = CP_XYZ(2)
            Z     (N) = CP_XYZ(3)
            OCC   (N) = CP_OCC
            TEMP  (N) = CP_BISO
            SURF  (N) = 0.0
            ELPOT (N) = 0.0
            SEG   (N) = CP_SEG
            ACODEA(N) = ACODE
          ENDIF

          CHAR2     = ASYMB(1:2)

          RVDW      = 1.4
          DO I=1,N_NAME
            IF(CHAR2.EQ.NAME(I)) THEN
              RVDW = TAB_RVDW(I)
              GO TO 100
            ENDIF
          ENDDO
 100      CONTINUE
          IF(ITEST.EQ.0) THEN
            RADVDW(N) = RVDW
          ENDIF

C        ENDIF

      ENDIF
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      NCRDR = N
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms for surface calc = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE AREA_SR_DB_ALLOC(MDOC,NR,XR,YR,ZR,RADVDW,SURFR,ELPOT
     *       ,OCCR,NATMX,RH2O,DEL,SURFA,SURFC,IERR)
C ---------------------------------------
      REAL      XR(NATMX),YR(NATMX),ZR(NATMX)
      REAL      SURFR(NATMX),RADVDW(NATMX)
      REAL      ELPOT(NATMX),OCCR(NATMX)
C ---------------------------------------
      PARAMETER (NSMAX=500)
      PARAMETER (NPMAX=20000)
      PARAMETER (MAXPO=10000)
C      REAL XPNT(MAXPO),YPNT(MAXPO),ZPNT(MAXPO)
C      REAL XSOSED(NSMAX),YSOSED(NSMAX),ZSOSED(NSMAX),RSOSED(NSMAX)
C      REAL XKPOIN(NPMAX),YKPOIN(NPMAX),ZKPOIN(NPMAX)
C      REAL XPOINT(NPMAX),YPOINT(NPMAX),ZPOINT(NPMAX),ITYPE(NPMAX)
c--allocatable
      real,      allocatable :: XPNT(:)
      real,      allocatable :: YPNT(:)
      real,      allocatable :: ZPNT(:)
      real,      allocatable :: XSOSED(:)
      real,      allocatable :: YSOSED(:)
      real,      allocatable :: ZSOSED(:)
      real,      allocatable :: RSOSED(:)
      real,      allocatable :: XKPOIN(:)
      real,      allocatable :: YKPOIN(:)
      real,      allocatable :: ZKPOIN(:)
      real,      allocatable :: XPOINT(:)
      real,      allocatable :: YPOINT(:)
      real,      allocatable :: ZPOINT(:)
      real,      allocatable :: ITYPE(:)

      CHARACTER LINE*80
C ----------------------------------------------------
      NGLOB = 0
      SURFC = 0.0
      SURFA = 0.0

      allocate(XPNT(1:MAXPO),STAT=ISTAT)
      allocate(YPNT(1:MAXPO),STAT=ISTAT)
      allocate(ZPNT(1:MAXPO),STAT=ISTAT)
      allocate(XSOSED(1:NSMAX),STAT=ISTAT)
      allocate(YSOSED(1:NSMAX),STAT=ISTAT)
      allocate(ZSOSED(1:NSMAX),STAT=ISTAT)
      allocate(RSOSED(1:NSMAX),STAT=ISTAT)
      allocate(XKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(YKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(ZKPOIN(1:NPMAX),STAT=ISTAT)
      allocate(XPOINT(1:NPMAX),STAT=ISTAT)
      allocate(YPOINT(1:NPMAX),STAT=ISTAT)
      allocate(ZPOINT(1:NPMAX),STAT=ISTAT)
      allocate(ITYPE(1:NPMAX),STAT=ISTAT)

      RUNIT = 1.0
      CALL TABLE_SR_DB(RUNIT,DEL,NPOINT,XPOINT,YPOINT,ZPOINT,SDELK
     *          ,NPMAX,IERR)
      IF(IERR.NE.0) GO TO 900

C -------- START OF CYCLE K-ATOM --------------------

      DO     K=1,NR

C        IF( MOD(K,100).EQ.0) THEN
C          WRITE(LINE,'('' I-ATOM,N-POINTS :'',I6,I8)') K,NGLOB
C          CALL MSGDOC(MDOC,LINE)
C        ENDIF

        IF(OCCR(K).LT.0.001) GO TO 100

        XK = XR(K)
        YK = YR(K)
        ZK = ZR(K)
        RK = RADVDW(K)+RH2O
        L  = 0
        DO     I1=1,NPOINT
          XKPOIN(I1) = XK+(XPOINT(I1)*RK)/RUNIT
          YKPOIN(I1) = YK+(YPOINT(I1)*RK)/RUNIT
          ZKPOIN(I1) = ZK+(ZPOINT(I1)*RK)/RUNIT
          ITYPE (I1) = 0
        ENDDO
        SDEL = (SDELK*RK*RK)/(RUNIT*RUNIT)
C ----------- SOSEDI ----------------
        DO     J=1,NR

          IF(OCCR(J).LT.0.001) GO TO 200

          IF(J.NE.K) THEN
            XJ    = XR(J)
            YJ    = YR(J)
            ZJ    = ZR(J)
            RJ    = RADVDW(J)+RH2O
            R1    = RK+RJ
            RLIM2 = R1*R1
            S1    = (XJ-XK)*(XJ-XK)
            S2    = (YJ-YK)*(YJ-YK)
            S3    = (ZJ-ZK)*(ZJ-ZK)
            DIS2  = S1+S2+S3
            IF(DIS2.LE.RLIM2) THEN
              L = L+1
              IF(L.GT.NSMAX) THEN
                WRITE(LINE,'('' ERROR: surface: N-SOSED >'',I8)') NSMAX
                CALL MSGERR(MDOC,LINE)
                IERR=1
                GO TO 900
              ENDIF
              XSOSED(L) = XJ
              YSOSED(L) = YJ
              ZSOSED(L) = ZJ
              RSOSED(L) = RJ
              NSOSED    = L
            ENDIF
          ENDIF

 200      CONTINUE

        ENDDO
C -------------
        IF(NSOSED.GT.0) THEN
          DO     IP=1,NPOINT
            XP = XKPOIN(IP)
            YP = YKPOIN(IP)
            ZP = ZKPOIN(IP)
            DO     IS=1,NSOSED
              XS = XSOSED(IS)
              YS = YSOSED(IS)
              ZS = ZSOSED(IS)
              RS = RSOSED(IS)
              DX = XS-XP
              IF(ABS(DX).GT.RS) GO TO 350
              DY = YS-YP
              IF(ABS(DY).GT.RS) GO TO 350
              DZ = ZS-ZP
              IF(ABS(DZ).GT.RS) GO TO 350
              D2  = DX*DX+DY*DY+DZ*DZ
              RS2 = RS*RS
              IF(D2.LT.RS2) THEN
                ITYPE(IP) = 1
                GO TO 352
              ENDIF
 350          CONTINUE
            ENDDO
 352        CONTINUE
          ENDDO
        ENDIF
C --------------------------------------
        MS=0
C   ---
        DO     IP=1,NPOINT
          IF(ITYPE(IP).EQ.0) THEN
            MS = MS+1
          ENDIF
        ENDDO
C   ---
        NGLOB = NGLOB+MS
        SUA   = MS*SDEL
C  --   SCALE AREA TO VDW SHELL ---
        SUC      = (SUA*(RK-RH2O)*(RK-RH2O))/(RK*RK)
        SURFR(K) = SUC
        SURFA    = SURFA+SUA
        SURFC    = SURFC+SUC

 100    CONTINUE

      ENDDO
C ---------------- END OF CYCLE K-ATOM -----------------

 900    CONTINUE

      deallocate(XPNT,STAT=ISTAT)
      deallocate(YPNT,STAT=ISTAT)
      deallocate(ZPNT,STAT=ISTAT)
      deallocate(XSOSED,STAT=ISTAT)
      deallocate(YSOSED,STAT=ISTAT)
      deallocate(ZSOSED,STAT=ISTAT)
      deallocate(RSOSED,STAT=ISTAT)
      deallocate(XKPOIN,STAT=ISTAT)
      deallocate(YKPOIN,STAT=ISTAT)
      deallocate(ZKPOIN,STAT=ISTAT)
      deallocate(XPOINT,STAT=ISTAT)
      deallocate(YPOINT,STAT=ISTAT)
      deallocate(ZPOINT,STAT=ISTAT)
      deallocate(ITYPE,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE WRITE_DOM_DESCR_LIST(MDOC,FILE
     * ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     * ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     * ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     * ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     * ,LINE_DOM,NDOMAIN,IERR)
C ----------------
      CHARACTER FILE*(*)
      INTEGER   ID_DOM(NDOMAIN),NRES_DOM(NDOMAIN),ITYPE_DOM(NDOMAIN)    
      INTEGER   NSEG_DOM(NDOMAIN),ILEVEL_DOM(NDOMAIN)
      INTEGER   IFORW_DOM(NDOMAIN),IBACK_DOM(NDOMAIN)
      REAL      FBACK_DOM(NDOMAIN),SCORE_DOM(NDOMAIN),RAD_DOM(NDOMAIN)
      REAL      RCBYR_DOM(NDOMAIN),RINBYR_DOM(NDOMAIN),PH_DOM(NDOMAIN)
      REAL      PB_DOM(NDOMAIN),RSBYR_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      CHARACTER CODE_DOM(NDOMAIN)*8,LINE_DOM(3)*512
      CHARACTER LINE*512,FRMT*512
      CHARACTER PATH*1,EXT*1
C -------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT = '(I7,1X,A8,1X,I5,1X,I2,1X,I2,1X,I2,1X,I5,1X,I5,1X,'//
     *       'F5.1,1X,F5.3,1X,F6.1,1X,F6.2,1X,F6.2,1X,F5.1,1X,F5.1'//
     *       ',1X,F6.2,1X,I10)'  

      EXT  = ' '
      PATH = ' '
      IOUT = 31
      CALL OPENFW(IOUT,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output domain_desrc_list')
        IERR = 1
        RETURN
      ENDIF

      CALL LENSTR_BL(LINE_DOM(1),LEN)
      WRITE(IOUT,'(A)',ERR = 900) LINE_DOM(1)(1:LEN)
      CALL LENSTR_BL(LINE_DOM(2),LEN)
      WRITE(IOUT,'(A)',ERR = 900) LINE_DOM(2)(1:LEN)
      CALL LENSTR_BL(LINE_DOM(3),LEN)
      WRITE(IOUT,'(A)',ERR = 900) LINE_DOM(3)(1:LEN)

      DO I =1,NDOMAIN
        ID_DOM(I) = I
        SCR = SCORE_DOM(I)
        IF(SCR.GT.9.99) SCR = 9.99
        WRITE(LINE,FRMT,ERR = 900)
     *    ID_DOM(I),CODE_DOM(I),NRES_DOM(I),ITYPE_DOM(I),NSEG_DOM(I)
     *    ,ILEVEL_DOM(I),IFORW_DOM(I),IBACK_DOM(I)
     *    ,FBACK_DOM(I),SCR,RAD_DOM(I),RCBYR_DOM(I)
     *    ,RINBYR_DOM(I),PH_DOM(I),PB_DOM(I),RSBYR_DOM(I),ICLASS_DOM(I)  
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR = 900) LINE(1:LEN)

      ENDDO

      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
  900 IERR = 1
      CALL MSGERR(MD,' ERROR: writing domain_descr_list')
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE READ_DOM_DESCR_LIST(MDOC,FILE,NDOM
     * ,ID_DOM,CODE_DOM,NRES_DOM,ITYPE_DOM,NSEG_DOM
     * ,ILEVEL_DOM,IFORW_DOM,IBACK_DOM
     * ,FBACK_DOM,SCORE_DOM,RAD_DOM,RCBYR_DOM
     * ,RINBYR_DOM,PH_DOM,PB_DOM,RSBYR_DOM,ICLASS_DOM  
     * ,LINE_DOM,NDOMAIN,IERR)
C ----------------
      CHARACTER FILE*(*)
      INTEGER   ID_DOM(NDOMAIN),NRES_DOM(NDOMAIN),ITYPE_DOM(NDOMAIN)    
      INTEGER   NSEG_DOM(NDOMAIN),ILEVEL_DOM(NDOMAIN)
      INTEGER   IFORW_DOM(NDOMAIN),IBACK_DOM(NDOMAIN)
      REAL      FBACK_DOM(NDOMAIN),SCORE_DOM(NDOMAIN),RAD_DOM(NDOMAIN)
      REAL      RCBYR_DOM(NDOMAIN),RINBYR_DOM(NDOMAIN),PH_DOM(NDOMAIN)
      REAL      PB_DOM(NDOMAIN),RSBYR_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      CHARACTER CODE_DOM(NDOMAIN)*8,LINE_DOM(3)*512
      CHARACTER LINE*512,FRMT*512
      CHARACTER PATH*1,EXT*1
C -------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99

      FRMT = '(I7,1X,A8,1X,I5,1X,I2,1X,I2,1X,I2,1X,I5,1X,I5,1X,'//
     *       'F5.1,1X,F5.3,1X,F6.1,1X,F6.2,1X,F6.2,1X,F5.1,1X,F5.1'//
     *       ',1X,F6.2,1X,I10)'  

      EXT  = ' '
      PATH = ' '
      IN = 30
      CALL OPENFR(IN,M,PATH,FILE,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open input domain_desrc_list')
        IERR = 1
        RETURN
      ENDIF

      NDOM = 0
      I    = 0
      DO II =1,1000000

        READ(IN,'(A)',ERR = 900,END = 100) LINE

        IF(LINE(1:1).EQ.'#') THEN
          IF(II.LE.3) THEN
            CALL LENSTR_BL(LINE,LEN)
            LINE_DOM(II) = LINE(1:LEN)
          ENDIF
          GO TO 200
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.12) GO TO 200

        I = I + 1
        ID_DOM(I) = I

C      1 11bgA_1_   105  0  1  0     0 13375  98.1 0.803   15.8   0.73   0.93  13.3  45.7   1.47

C        IF(LEN.GE.104) THEN
          READ(LINE,FRMT,ERR = 900)
     *    ID_DOM(I),CODE_DOM(I),NRES_DOM(I),ITYPE_DOM(I),NSEG_DOM(I)
     *    ,ILEVEL_DOM(I),IFORW_DOM(I),IBACK_DOM(I)
     *    ,FBACK_DOM(I),SCORE_DOM(I),RAD_DOM(I),RCBYR_DOM(I)
     *    ,RINBYR_DOM(I),PH_DOM(I),PB_DOM(I),RSBYR_DOM(I),ICLASS_DOM(I)  
C        ELSE
C          READ(LINE,FRMT,ERR = 900)
C     *    ID_DOM(I),CODE_DOM(I),NRES_DOM(I),ITYPE_DOM(I),NSEG_DOM(I)
C     *    ,ILEVEL_DOM(I),IFORW_DOM(I),IBACK_DOM(I)
C     *    ,FBACK_DOM(I),SCORE_DOM(I),RAD_DOM(I),RCBYR_DOM(I)
C     *    ,RINBYR_DOM(I),PH_DOM(I),PB_DOM(I),RSBYR_DOM(I)
C          ICLASS_DOM(I) = 0 
C        ENDIF 

        NDOM = NDOM + 1

  200   CONTINUE

      ENDDO

  100 CONTINUE

      CLOSE(IN)

      RETURN
C ----------------
  900 IERR = 1
      CALL MSGERR(MD,' ERROR: reading domain_descr_list')
      CLOSE(IN)
      RETURN
      END

      SUBROUTINE MAKE_ALIGN5(MDOC,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
C  IERR = 0 CORR = N : OUT - aligned PDB file_2 (not rotated)
C  IERR =-1 CORR = 2 : (OUT name+_1,+_2) -> OUT_1, aligned
C                       PDB                 OUT_2, aligned (not rotated)
C  IERR = 1 CORR = 2 : (OUT name+_1,+_2) -> OUT_1, aligned
C                       PDB                 OUT_2, aligned (rotated)
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P : OUT - profile  
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
      INTEGER   MDOC,IERR
C     PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*),FILE_PAIR*256
C --
c     for alignment
      CHARACTER CHAIN*1,DIST*1,CORR*1,PAIR*1,FULL*1,ADOM*1
      CHARACTER PAR_ALIGN*16 
C -----------------------------------
      FULL   = 'Y'
      CORR   = 'N'

      IF(PAIR.EQ.'y') PAIR = 'Y'
      IF(PAIR.NE.'Y') PAIR = 'N'

      ITRANS = 0
      IF(IERR.EQ.-1) THEN
        CORR = '2'
      ELSE IF(IERR.EQ.1) THEN
        CORR   = '2'
        ITRANS = 1
      ELSE IF(IERR.EQ.2) THEN
        CORR = 'Y'
        FULL = 'N'
      ELSE IF(IERR.EQ.-2) THEN
        CORR = 'Y'
        FULL = 'Y'
      ELSE IF(IERR.EQ.3) THEN
        CORR   = 'P'
      ENDIF 
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c          mode
c          PAR_ALIGN(1:1) = ' '
c ---
C       2: IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C          IERR = -2 CORR --> Y output file(pdb) (FILE_OUT) rotated full file_2 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C          IERR = -1 ,CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'

c molrep   IF(SEQ.EQ.'N') PAR_ALIGN(2:2) = 'N'
c molrep   IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') PAR_ALIGN(2:2) = 'Y'
c ---
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
c          PAR_ALIGN(3:3) = 'N'
c molrep  IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') PAR_ALIGN(3:3) = SURF
c ---
cC       4: SS_FLAG  use SS
c          PAR_ALIGN(4:4) = 'Y'
c ---
cc       5: remove surf from output
c          PAR_ALIGN(5:5) = 'N'
c ---
cc       6: OCC_FLAG
c          PAR_ALIGN(6:6) = 'N'
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B'
C      PAR_ALIGN(2:2) = 'N' 
C      IF(CORR.EQ.'2') PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 

      IF(DIST.EQ.'p') DIST = 'P'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.NE.'D'.AND.DIST.NE.'P') DIST = 'N'
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
c       PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  

c      OPENR   = 0.462
c      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
c     DPENR   = 0.350
      DPENR   = 0.0

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
c        DPENR   = 0.346
      ELSE
c       'B'
c        DPENR   = 0.312
      ENDIF

      IF(PO.GT.0.001)  OPENR  = PO
      IF(PO.LT.-0.001) OPENR  = 0.0
      IF(PE.GT.0.001)  PENEXR = PE
      IF(PE.LT.-0.001) PENEXR = 0.0

       FILE_PAIR = ' '
       IF(PAIR.EQ.'Y') THEN
         FILE_PAIR = 'align_pair.txt'
         CALL LENSTR_BL(PATH_SCR,LEN)
         IF(LEN.GT.0) THEN
           FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
         ENDIF
      ENDIF
      MODEL   = 1
      CHAIN   = ' '
      ADOM    = 'C'
      IERR = 0
      IF(ITRANS.EQ.1) IERR = 1
      CALL ALIGN_4(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c     RESULT(42) = Q
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
      RETURN
      END

      SUBROUTINE MAKE_ALIGN5D(MDOC,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
C  IERR = 0 CORR = N : OUT - aligned PDB file_2 (not rotated)
C  IERR =-1 CORR = 2 : (OUT name+_1,+_2) -> OUT_1, aligned
C                       PDB                 OUT_2, aligned (not rotated)
C  IERR = 1 CORR = 2 : (OUT name+_1,+_2) -> OUT_1, aligned
C                       PDB                 OUT_2, aligned (rotated)
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P : OUT - profile  
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
      INTEGER   MDOC,IERR
C     PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*),FILE_PAIR*256
C --
c     for alignment
      CHARACTER CHAIN*1,DIST*1,CORR*1,PAIR*1,FULL*1,ADOM*1
      CHARACTER PAR_ALIGN*16 
C -----------------------------------
      FULL   = 'Y'
      CORR   = 'N'

      IF(PAIR.EQ.'y') PAIR = 'Y'
      IF(PAIR.NE.'Y') PAIR = 'N'

      ITRANS = 0
      IF(IERR.EQ.-1) THEN
        CORR = '2'
      ELSE IF(IERR.EQ.1) THEN
        CORR   = '2'
        ITRANS = 1
      ELSE IF(IERR.EQ.2) THEN
        CORR = 'Y'
        FULL = 'N'
      ELSE IF(IERR.EQ.-2) THEN
        CORR = 'Y'
        FULL = 'Y'
      ELSE IF(IERR.EQ.3) THEN
        CORR   = 'P'
      ENDIF 
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c          mode
c          PAR_ALIGN(1:1) = ' '
c ---
C       2: IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C          IERR = -2 CORR --> Y output file(pdb) (FILE_OUT) rotated full file_2 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C          IERR = -1 ,CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'

c molrep   IF(SEQ.EQ.'N') PAR_ALIGN(2:2) = 'N'
c molrep   IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') PAR_ALIGN(2:2) = 'Y'
c ---
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
c          PAR_ALIGN(3:3) = 'N'
c molrep  IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') PAR_ALIGN(3:3) = SURF
c ---
cC       4: SS_FLAG  use SS
c          PAR_ALIGN(4:4) = 'Y'
c ---
cc       5: remove surf from output
c          PAR_ALIGN(5:5) = 'N'
c ---
cc       6: OCC_FLAG
c          PAR_ALIGN(6:6) = 'N'
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B'
C      PAR_ALIGN(2:2) = 'N' 
C      IF(CORR.EQ.'2') PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 

      IF(DIST.EQ.'p') DIST = 'P'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.EQ.'w') DIST = 'W'
      IF(DIST.NE.'D'.AND.DIST.NE.'P'.AND.DIST.NE.'W') DIST = 'N'

      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
c       PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  

c      OPENR   = 0.462
c      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
c     DPENR   = 0.350
      DPENR   = 0.0

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
c        DPENR   = 0.346
      ELSE
c       'B'
c        DPENR   = 0.312
      ENDIF

      IF(PO.GT.0.001)  OPENR  = PO
      IF(PO.LT.-0.001) OPENR  = 0.0
      IF(PE.GT.0.001)  PENEXR = PE
      IF(PE.LT.-0.001) PENEXR = 0.0

       FILE_PAIR = ' '
       IF(PAIR.EQ.'Y') THEN
         FILE_PAIR = 'align_pair.txt'
         CALL LENSTR_BL(PATH_SCR,LEN)
         IF(LEN.GT.0) THEN
           FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
         ENDIF
      ENDIF
      MODEL   = 1
      CHAIN   = ' '
      ADOM    = 'D'
      IERR = 0
      IF(ITRANS.EQ.1) IERR = 1
      CALL ALIGN_4(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c     RESULT(42) = Q
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
      RETURN
      END

      SUBROUTINE MAKE_ALIGN(MDOC,IPRINT,FILE_1,FILE_2,FILE_OUT
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C     *                      ,PAIR,DIST,PO,PE
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
      INTEGER   MDOC,IERR
C     PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_1*(*),FILE_2*(*),FILE_OUT*(*)
C --
c     for alignment
      CHARACTER CHAIN*1,DIST*1,CORR*1,ADOM*1
      CHARACTER PAR_ALIGN*16 
      CHARACTER FULL*1,PAIR*1
      CHARACTER FILE_PAIR*256
C -----------------------------------
      FULL   = 'Y'
      CORR   = 'N'
      PAIR   = 'N'
      ITRANS = 0
      IF(IERR.EQ.-1) THEN
        CORR = '2'
      ELSE IF(IERR.EQ.1) THEN
        CORR   = '2'
        ITRANS = 1
      ELSE IF(IERR.EQ.2) THEN
        CORR = 'Y'
        FULL = 'N'
      ELSE IF(IERR.EQ.-2) THEN
        CORR = 'Y'
        FULL = 'Y'
      ELSE IF(IERR.EQ.3) THEN
        CORR   = 'P'
      ENDIF 
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c          mode
c          PAR_ALIGN(1:1) = ' '
c ---
C       2: IERR =  0 CORR = N output file(pdb) 
c                    (FILE_OUT) aligned file_2 (not rotated)
C          IERR = -2 CORR --> Y output file(pdb) (FILE_OUT) rotated full file_2 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C          IERR = -1 ,CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'

c molrep   IF(SEQ.EQ.'N') PAR_ALIGN(2:2) = 'N'
c molrep   IF(FOBS.EQ.'N'.AND.MOD2.EQ.'N') PAR_ALIGN(2:2) = 'Y'
c ---
cC       3: D3_FLAG (n,c,y) --> ALIGN_with SURF
c          PAR_ALIGN(3:3) = 'N'
c molrep  IF(SURF.EQ.'Y'.OR.SURF.EQ.'C') PAR_ALIGN(3:3) = SURF
c ---
cC       4: SS_FLAG  use SS
c          PAR_ALIGN(4:4) = 'Y'
c ---
cc       5: remove surf from output
c          PAR_ALIGN(5:5) = 'N'
c ---
cc       6: OCC_FLAG
c          PAR_ALIGN(6:6) = 'N'
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B'
C      PAR_ALIGN(2:2) = 'N' 
C      IF(CORR.EQ.'2') PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(2:2) = CORR
      PAR_ALIGN(3:3) = 'Y' 
      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(5:5) = 'N' 
      PAR_ALIGN(6:6) = 'N' 

      DIST = 'N'
      IF(DIST.EQ.'d') DIST = 'D'
      IF(DIST.NE.'D') DIST = 'N'
      IF(DIST.EQ.'D') THEN
c        PAR_ALIGN(4:4) = 'N' 
      ENDIF
      PAR_ALIGN(7:7) = DIST  

c      OPENR   = 0.462
c      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
c      DPENR   = 0.350
      DPENR   = 0.0

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
c        DPENR   = 0.346
      ELSE
c       'B'
c        DPENR   = 0.312
      ENDIF

C --
      FILE_PAIR = ' '
      IF(PAIR.EQ.'Y') THEN
        FILE_PAIR = 'align_pair.txt'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
        ENDIF
      ENDIF
      MODEL   = 1
      CHAIN   = ' '
      ADOM    = 'C'
      IERR = 0
      IF(ITRANS.EQ.1) IERR = 1
      CALL ALIGN_4(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c     RESULT(42) = Q
c      IF(IPRROW.GE.41) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c      ENDIF
      RETURN
      END
c ===========

      SUBROUTINE ALIGN_4(MDOC,FILE_11,FILE_22,FILE_OUT,PATH_SCR
     * ,FILE_PAIR,FULL,ADOM
     * ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINTR
     * ,RESULT,IPRROW,IERR)
C ------------------------------------------------------------
C -P- 
C ALIGN   alignes optimally 2 aminoacid sequences. 
C -S-
C         File with sequence is ASCII file:
C
C        !>prot_id
C        !# sequence 
C        !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C        !# this is comment
C        !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C        !NRGTRITKEVFDNLTNWKNSAQ
C
C         If first symbol in the line is "#" it means the line is comments
C         Blancs are ignored.
C         
C      
C      Dialogue and Batch:
C
C   FILE_1:           - Input coordinate file-1 (sequence)
C   FILE_2:           - Input coordinate file-2 (sequence)
C   MODE: <G>,1,H,S,K - matrix of comparison which will be used
C                   G - gomology
C                   1 - unit
C                   H - hydrophobic
C                   S - structure
C                   K - kodon
C   PEN:     <0>      - gap-penalty factor. From 0 to 1
C
C      Parameters of subroutine:
C
C      MDOC  - mode of writing messages to DOC-file
C             0 - only terminal , < - 0 only file, 0 < < 99 - both
C             >= 99 - don't write  
C
C      IERR   - signal of error / =1 -error , =o - OK / 
C      RESULT /real RESULT(21)/ - array for output information:
C     RESULT(1) = NC   Naa_1
C     RESULT(2) = KC   Naa_2
C     RESULT(3) = NN   Naa aligned
C     RESULT(4) = NHOM Naa identical
C     RESULT(5) = HOM  identity
C     RESULT(6) = SUM  score
C     RESULT(7) = NAT  Natom output
C     RESULT(8) = NRES Nres output
C     RESULT(9) = NAT  Natom1 output
C     RESULT(10)= NRES Nres1 output
C     RESULT(11)= NAT  Natom2 output
C     RESULT(12)= NRES Nres2 output
C     RESULT(13) = SCORE1_MAX 
C     RESULT(14) = SCORE_MIN 
C     RESULT(15) = Q_FIN
C     RESULT(16) = DRMS_BEST 
C     RESULT(17) = NPAIR_BEST 
C     RESULT(18) = SCORE_NEW
C     RESULT(19) = FIDENT_NEW
C     RESULT(20) = NGAP
c      IF(IPRROW.GE.42) THEN
C        RESULT(21) = CHI_INI
C        RESULT(22) = DIST_INI
C        RESULT(23) = DRMS_INI
C        RESULT(24) = CHI_BEST
C        RESULT(25) = DIST_BEST
c        RESULT(30) = TR(1)
c        RESULT(31) = TR(2)
c        RESULT(32) = TR(3)
c        RESULT(33) = TRMAT(1,1)
c        RESULT(34) = TRMAT(1,2)
c        RESULT(35) = TRMAT(1,3)
c        RESULT(36) = TRMAT(2,1)
c        RESULT(37) = TRMAT(2,2)
c        RESULT(38) = TRMAT(2,3)
c        RESULT(39) = TRMAT(3,1)
c        RESULT(40) = TRMAT(3,2)
c        RESULT(41) = TRMAT(3,3)
c        RESULT(42) = Q
c      ENDIF
C -I-
C ---------------------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      RESULT2(100)    
      REAL      RESULT3(100)    
      INTEGER   MDOC,IERR
      CHARACTER PAR_ALIGN*16,CHAIN*1

      CHARACTER FULL*1,ADOM*1
      CHARACTER FILE_PAIR*(*)

      REAL      OPENR,DPENR,PENEXR
      CHARACTER PATH_SCR*(*)
      CHARACTER FILE_11*(*),FILE_22*(*),FILE_OUT*(*)
C ---
C      REAL      COORD1(NMAX1,3)
C      REAL      COORD2(NMAX1,3)
C      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX1),ISS1(NMAX1),ISS2(NMAX1)
C      INTEGER   ICHAIN1(NMAX1),ICHAIN2(NMAX1)
C      INTEGER   IRES1(NMAX1),IRES2(NMAX1)

      real,      allocatable :: COORD1(:,:)
      real,      allocatable :: ASEQ1(:)
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: IPROFILE1(:,:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)

      real,      allocatable :: COORD2(:,:)
      real,      allocatable :: ASEQ2(:)
      integer,   allocatable :: NSEQ2(:)
      integer,   allocatable :: IRES2(:)
      integer,   allocatable :: SURF2(:)
      integer,   allocatable :: ICHAIN2(:)
      integer,   allocatable :: IPROFILE2(:,:)
      integer,   allocatable :: IDOMAIN2(:)
      integer,   allocatable :: SS2(:)
      integer,   allocatable :: ISS2(:)
      character(LEN=6), allocatable :: PNUM2(:)

C      REAL      AMATRIX(NMAX1,NMAX2)
c      REAL      SCORE(NMAX12,3)
c      INTEGER   IPAIR(2,NMAX12)

      real,      allocatable :: AMATRIX(:,:)
      real,      allocatable :: SCORE(:,:)
      integer,   allocatable :: IPAIR(:,:)
      integer,   allocatable :: IPAIR_STOR(:,:)

C ---
      CHARACTER MODE*1,CORR*1,PAIR*1
      CHARACTER SS_FLAG*1,D3_FLAG*1,WS_FLAG*1,OCC_FLAG*1,DIST*1
      CHARACTER FILE_OUT1*256,FILE_OUT2*256
      CHARACTER FILE_1*256,FILE_2*256,FILE_SCR*256
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C -----
C ---------------------------------------
      CHARACTER NAM1*4,NAM2*4,CODE8*8
      CHARACTER CODE8_1*8,CODE8_2*8
      CHARACTER PATH*1,EXT*1
C ----
      REAL AMAT(25,25),TRMAT(3,3),TR(3)
C ----
      CHARACTER LINE*256
C --------------------------------------------------------
      ITRANS = 0
      IF(IERR.EQ.1) ITRANS = 1
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --

      IF(CHAIN.EQ.'_') CHAIN = ' ' 

      IPRINT = IPRINTR
      IF(IPRINTR.EQ.3) IPRINT = 1

      NSEQ_PROFILE1 = 0
      NSEQ_PROFILE2 = 0
      DO I=1,IPRROW
        RESULT(I) = 0.0
      ENDDO
      MODE    = PAR_ALIGN(1:1) 
      CORR    = PAR_ALIGN(2:2) 
      D3_FLAG = PAR_ALIGN(3:3)
      SS_FLAG = PAR_ALIGN(4:4)
      WS_FLAG = PAR_ALIGN(5:5)
C     if y remove surf
c ---
      OCC_FLAG = PAR_ALIGN(6:6)
      DIST     = PAR_ALIGN(7:7)
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
c       SS_FLAG = 'N'
        D3_FLAG = 'N'
      ENDIF
      PAIR = 'N'
      CALL LENSTR_BL(FILE_PAIR,LEN)
      IF(LEN.GT.0) PAIR = 'Y'

      WRITE(LINE,'(''Flag D3,SS,OCC,CORR,DIST:'',A,A,A,A,A)') 
     * D3_FLAG,SS_FLAG,OCC_FLAG,CORR,DIST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''PAIR,FULL,ADOM:'',A,A,A)') PAIR,FULL,ADOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''MODE:'',A)') MODE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''ITRANS:'',I5)') ITRANS
      CALL MSGDOC(MDOC,LINE)

      FILE_1 = FILE_11
      CALL CORR_NAME_ALL(FILE_1)
      CALL LENSTR_BL(FILE_1,LEN1)

      FILE_2 = FILE_22
      CALL CORR_NAME_ALL(FILE_2)
      CALL LENSTR_BL(FILE_2,LEN2)

      NO_COORD1=0
      IF(LEN1.GT.4.AND.(FILE_1(LEN1-3:LEN1).EQ.'.seq'.OR.
     *                  FILE_1(LEN1-3:LEN1).EQ.'.sqb'.OR.
     *                  FILE_1(LEN1-3:LEN1).EQ.'.prf'    )) 
     *   NO_COORD1 = 1
 
      NO_COORD2 = 0
      IF(LEN2.GT.4.AND.(FILE_2(LEN2-3:LEN2).EQ.'.seq'.OR.
     *                  FILE_2(LEN2-3:LEN2).EQ.'.prf'.OR.
     *                  FILE_2(LEN2-3:LEN2).EQ.'.sqb'    ))
     *   NO_COORD2 = 1 
c ////////////////
C ---------------------------------------------------------------
      CALL MSGDOC(MDoc,'read file protein-1')

      IPDB1 = 0

      CALL LENSTR_BL(FILE_1,LEN)

      L = LEN
      IF(LEN.GT.72) L = 72
      IF(LEN.LE. 0) L =  1
      LINE = 'File: '//FILE_1(1:L)
      CALL MSGDOC(MDoc,LINE)

      IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_1 = 'align_1_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_1 = PATH_SCR(1:LEN)//'align_1_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_11,FILE_1
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-1')
            GO TO 900
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_1 = FILE_11  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE8_1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(ASEQ1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)
        deallocate(IPROFILE1,STAT=ISTAT)

        NMAX1 = NC
        ITEST = 0

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE8_1,NCHAIN1,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
          IERR = 1
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)

        IPDB1 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,NC
     *     ,COORD1(1,1),COORD1(1,2),COORD1(1,3),SS1,SURF1
     *     ,PSS,PH,PB,NMAX1,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-1(pdb)')
            GO TO 800
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.dat') THEN

        IPDB1 = 2
        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_1,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-1')
          GO TO 900
        ENDIF
        READ(IN,ERR=910) NMAX1,NC,CODE8
        IF(NMAX1.LE.0.OR.NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-1 = 0')
          IERR = 1
          GO TO 900
        ENDIF

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        READ(IN,ERR=915) (IRES1(I),I=1,NC)
        READ(IN,ERR=915) (NSEQ1(I),I=1,NC)
        READ(IN,ERR=915) (SS1(I),I=1,NC)
        READ(IN,ERR=915) (SURF1(I),I=1,NC)
        IF(NO_COORD1.EQ.0) 
     *  READ(IN,ERR=915) ((COORD1(J,I),J=1,NC),I=1,3)

        CLOSE(IN)     
        NAM1 = CODE8(1:4)

        CALL CORR_BINARY_SEQ(MDOC,NC,NMAX1,PNUM1
     *       ,NSEQ1,IRES1,SS1,SURF1,ICHAIN1,IDOMAIN1
     *       ,NO_COORD1,COORD1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ1')
          GO TO 800
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.sqb') THEN

        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_1,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-1')
          GO TO 900
        ENDIF
        READ(IN,ERR=910) NMAX1,NC,CODE8_1
        IF(NMAX1.LE.0.OR.NC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-1 = 0')
          IERR = 1
          GO TO 900
        ENDIF

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)


        READ(IN,ERR=915) (IRES1(I),I=1,NC)
        READ(IN,ERR=915) (NSEQ1(I),I=1,NC)
        READ(IN,ERR=915) (SS1(I),I=1,NC)
        READ(IN,ERR=915) (SURF1(I),I=1,NC)
        CLOSE(IN)     
        NAM1 = CODE8_1(1:4)

        CALL CORR_BINARY_SEQ(MDOC,NC,NMAX1,PNUM1
     *       ,NSEQ1,IRES1,SS1,SURF1,ICHAIN1,IDOMAIN1
     *       ,NO_COORD1,COORD1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ1')
          GO TO 800
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_1(LEN-3:LEN).EQ.'.prf') THEN
        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_1,NMAX1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 900
        ENDIF

        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)
        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)

        CALL READ_SEQ_PROFILE(MDOC,CODE8_1,FILE_1
     *       ,NSEQ_PROFILE1,NC,NMAX1,IPROFILE1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_SEQ_PROFILE-1')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in PROFILE-1 = 0.')
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)
c        D3_FLAG = 'N'
C        SS_FLAG = 'Y'   
        DIST    = 'N' 
        IPDB1   =-1
      ELSE

        ITEST = 1
        NMAX1 = 100

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,CODE8_1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1 test')
          GO TO 800
        ENDIF
        IF(NC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0.')
          GO TO 800
        ENDIF

        deallocate(COORD1,STAT=ISTAT)
        deallocate(ASEQ1,STAT=ISTAT)
        deallocate(NSEQ1,STAT=ISTAT)
        deallocate(IRES1,STAT=ISTAT)
        deallocate(SURF1,STAT=ISTAT)
        deallocate(ICHAIN1,STAT=ISTAT)
        deallocate(IDOMAIN1,STAT=ISTAT)
        deallocate(SS1,STAT=ISTAT)
        deallocate(ISS1,STAT=ISTAT)
        deallocate(PNUM1,STAT=ISTAT)
        deallocate(IPROFILE1,STAT=ISTAT)

        NMAX1 = NC

        allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
        allocate(ASEQ1(1:NMAX1),STAT=ISTAT)
        allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
        allocate(IRES1(1:NMAX1),STAT=ISTAT)
        allocate(SURF1(1:NMAX1),STAT=ISTAT)
        allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
        allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
        allocate(SS1(1:NMAX1),STAT=ISTAT)
        allocate(ISS1(1:NMAX1),STAT=ISTAT)
        allocate(PNUM1(1:NMAX1),STAT=ISTAT)
        allocate(IPROFILE1(1:NMAX1,1:20),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,CODE8_1,FILE_1
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-1')
          GO TO 800
        ENDIF
        NAM1 = CODE8_1(1:4)

      ENDIF
      
      CALL MSGDOC(MDoc,'read file protein-2')

      IPDB2 = 0

      CALL LENSTR_BL(FILE_2,LEN)

      L = LEN
      IF(LEN.GT.72) L = 72
      IF(LEN.LE. 0) L =  1
      LINE = 'File: '//FILE_2(1:L)
      CALL MSGDOC(MDoc,LINE)

      IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.pdb') THEN

        IF(D3_FLAG.EQ.'Y') THEN
          FILE_2 = 'align_2_scr.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_2 = PATH_SCR(1:LEN)//'align_2_scr.pdb' 
          ENDIF
          CALL SURFACE_DB_ALLOC(M,FILE_22,FILE_2
     *       ,RESULT,IPRROW,IERR)   
          NATOM    =  RESULT(1)
          IF(IERR.NE.0.OR.NATOM.LE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SURFACE PDB-2')
            GO TO 800
          ENDIF
          NATOM_IN =  RESULT(8)
          NRES     =  RESULT(9)
          WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *      NATOM,NATOM_IN,NRES
          CALL MSGDOC(MDOC,LINE)
          FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
          IF(FINSIDE.LT.0.10) THEN
            FILE_2 = FILE_22  
            D3_FLAG = 'N'
          ENDIF
        ENDIF

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,CODE8_2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(ASEQ2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)
        deallocate(IPROFILE2,STAT=ISTAT)

        NMAX2 = KC
        ITEST = 0

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_2
     *      ,NSEQ2,IRES2,PNUM2,COORD2,SURF2,ICHAIN2,IDOMAIN2
     *      ,NMAX2,KC,CODE8_2,NCHAIN2,ITEST,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0')
          IERR = 1
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4) 

        IPDB2 = 1
        IF(SS_FLAG.EQ.'Y') THEN    
          CALL ALIGN_SS_DEFINITION_ALLOC(M,KC
     *     ,COORD2(1,1),COORD2(1,2),COORD2(1,3),SS2,SURF2
     *     ,PSS,PH,PB,NMAX2,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-2(pdb)')
            GO TO 700
          ENDIF
          WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
          CALL MSGDOC(MDOC,LINE)
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.dat') THEN

        IPDB2 = 2
        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-2')
          GO TO 800
        ENDIF

        READ(IN,ERR=920) NMAX2,KC,CODE8_2
        IF(NMAX2.LE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-2 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        READ(IN,ERR=925) (IRES2(I),I=1,KC)
        READ(IN,ERR=925) (NSEQ2(I),I=1,KC)
        READ(IN,ERR=925) (SS2(I),I=1,KC)
        READ(IN,ERR=925) (SURF2(I),I=1,KC)
        IF(NO_COORD2.EQ.0) 
     *  READ(IN,ERR=925) ((COORD2(J,I),J=1,KC),I=1,3)

        CLOSE(IN)     

        NAM2 = CODE8_2(1:4)

        CALL CORR_BINARY_SEQ(MDOC,KC,NMAX2,PNUM2
     *       ,NSEQ2,IRES2,SS2,SURF2,ICHAIN2,IDOMAIN2
     *       ,NO_COORD2,COORD2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ2')
          GO TO 700
        ENDIF

 
      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.sqb') THEN

        IN    = 11
        EXT   = ' '
        PATH  = ' '
        CALL OPENUR(IN,M,PATH,FILE_2,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: open input file-2 (.sqb)')
          GO TO 800
        ENDIF

        READ(IN,ERR=920) NMAX2,KC,CODE8_2
        IF(NMAX2.LE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: Nmax in SEQ-2 = 0')
          IERR = 1
          GO TO 800
        ENDIF

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        READ(IN,ERR=925) (IRES2(I),I=1,KC)
        READ(IN,ERR=925) (NSEQ2(I),I=1,KC)
        READ(IN,ERR=925) (SS2(I),I=1,KC)
        READ(IN,ERR=925) (SURF2(I),I=1,KC)

        CLOSE(IN)     
        
        NAM2 = CODE8_2(1:4)
        CALL CORR_BINARY_SEQ(MDOC,KC,NMAX2,PNUM2
     *       ,NSEQ2,IRES2,SS2,SURF2,ICHAIN2,IDOMAIN2
     *       ,NO_COORD2,COORD2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: CORR_BINARY_SEQ2')
          GO TO 700
        ENDIF

      ELSE IF(LEN.GT.4.AND.FILE_2(LEN-3:LEN).EQ.'.prf') THEN
        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_2,NMAX2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          GO TO 800
        ENDIF

        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)
        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)

        CALL READ_SEQ_PROFILE(MDOC,CODE8_2,FILE_2
     *       ,NSEQ_PROFILE2,KC,NMAX2,IPROFILE2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_SEQ_PROFILE-2')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in PROFILE-2 = 0.')
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4)
c        D3_FLAG = 'N'
C        SS_FLAG = 'Y'   
        CORR    = 'P'
        IPDB2   =-1
c        IF(IPDB1.GE.0) THEN
c          CALL MSGERR(MDOC,'ERROR: 1st file must be PROFILE')
c          IERR = 1
c          GO TO 700
c        ENDIF
      ELSE

        ITEST = 1
        NMAX2 = 100

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        CALL READ_FASTA_SEQ_NEW(M,CODE8_2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2_test')
          GO TO 700
        ENDIF
        IF(KC.LE.0) THEN
          IERR = 1
          CALL MSGERR(MDOC,'ERROR: Naa in SEQ-2 = 0.')
          GO TO 700
        ENDIF

        deallocate(COORD2,STAT=ISTAT)
        deallocate(ASEQ2,STAT=ISTAT)
        deallocate(NSEQ2,STAT=ISTAT)
        deallocate(IRES2,STAT=ISTAT)
        deallocate(SURF2,STAT=ISTAT)
        deallocate(ICHAIN2,STAT=ISTAT)
        deallocate(IDOMAIN2,STAT=ISTAT)
        deallocate(SS2,STAT=ISTAT)
        deallocate(ISS2,STAT=ISTAT)
        deallocate(PNUM2,STAT=ISTAT)
        deallocate(IPROFILE2,STAT=ISTAT)

        NMAX2 = KC

        allocate(COORD2(1:NMAX2,1:3),STAT=ISTAT)
        allocate(ASEQ2(1:NMAX2),STAT=ISTAT)
        allocate(NSEQ2(1:NMAX2),STAT=ISTAT)
        allocate(IRES2(1:NMAX2),STAT=ISTAT)
        allocate(SURF2(1:NMAX2),STAT=ISTAT)
        allocate(ICHAIN2(1:NMAX2),STAT=ISTAT)
        allocate(IDOMAIN2(1:NMAX2),STAT=ISTAT)
        allocate(SS2(1:NMAX2),STAT=ISTAT)
        allocate(ISS2(1:NMAX2),STAT=ISTAT)
        allocate(PNUM2(1:NMAX2),STAT=ISTAT)
        allocate(IPROFILE2(1:NMAX2,1:20),STAT=ISTAT)

        ITEST = 0
        CALL READ_FASTA_SEQ_NEW(M,CODE8_2,FILE_2
     *       ,ITEST,KC,NMAX2,NCHAIN2,PNUM2
     *       ,NSEQ2,IRES2,SS2,ISS2,SURF2,ICHAIN2,IDOMAIN2,IERR)
        IF(IERR.NE.0.OR.KC.LE.0) THEN
          CALL MSGERR(MDOC,'ERROR: READ_FASTA_SEQ-2')
          GO TO 700
        ENDIF
        NAM2 = CODE8_2(1:4)

      ENDIF
C ---
      CALL ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     * ,OPENR,DPEN0,PENEXR
     * ,ATOM_INDEX,ATOM_NAME     
     * ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     * ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
  
      NMAX12 = NMAX1
      IF(NMAX2.GT.NMAX1) NMAX12 = NMAX2

      allocate(AMATRIX(1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(SCORE(1:NMAX12,1:3),STAT=ISTAT)
      allocate(IPAIR(1:2,1:NMAX12),STAT=ISTAT)
      allocate(IPAIR_STOR(1:2,1:NMAX12),STAT=ISTAT)

      DPEN0P =-1
      IF(IPDB1.GE.0.AND.IPDB2.GE.0) THEN
        CALL SET_AMATRIX4(MDOC,DIST,AMATRIX,AMAT
     *   ,NC,NSEQ1,ASEQ1,COORD1,SURF1,KC,NSEQ2,ASEQ2,COORD2,SURF2
     *   ,SS_FLAG,SS1,SS2
     *   ,NMAX1,NMAX2,IERR)
      ELSE
        CALL SET_AMATRIX_PROFILE(MDOC,AMATRIX,AMAT,DPEN0P
     *    ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *    ,NC,IPROFILE1,NSEQ1,ASEQ1,KC,NSEQ2,ASEQ2,IPROFILE2
     *    ,NMAX1,NMAX2,IERR)
        CALL SET_SURF_PROFILE(MDOC,AMATRIX,AMAT
     *    ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *    ,NC,IPROFILE1,SURF1,KC,IPROFILE2,SURF2
     *    ,NMAX1,NMAX2,IERR)
      ENDIF

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SET_AMATRIX')
        GO TO 600
      ENDIF

      IF(DPENR.LE.0.0) DPENR = DPEN0

C -----
      IF(DIST.EQ.'D'.OR.DIST.EQ.'P') THEN
        IF(ADOM.NE.'D') SS_FLAG = 'N'
        D3_FLAG = 'N'
      ENDIF

      CALL ALIGNMENT4(MDOC
     *  ,AMATRIX,AMAT,D3_FLAG,SS_FLAG,ADOM
     *  ,OPENR,DPENR,PENEXR,DPEN0P
     *  ,NC,KC
     *  ,ISS1,ISS2,SURF1,SURF2,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *  ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *  ,NPAIR,IPAIR,SCORE(1,1),SCORE(1,2),Q
     *  ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *  ,IPROFILE1,IPROFILE2
     *  ,IDOMAIN1,IDOMAIN2
     *  ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in ALIGNMENT4')
        GO TO 600
      ENDIF
      IF(IPRROW.GE.42) THEN
        RESULT(42) = Q
      ENDIF

      IF(IPRINT.GT.0) THEN 
        CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *  ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *  ,ICHAIN1,ICHAIN2,D3_FLAG
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
      ENDIF
      IF(NPAIR.LE.3) THEN
        CALL MSGERR(MDOC,'ERROR: NPAIR < 4')
        IERR = 1
        GO TO 600
      ENDIF

      IFLAG_COOR = 0
   
      IF(IPDB1.GT.0.AND.IPDB2.GT.0) THEN

        IDOUBLE = 0

        IF(DIST.EQ.'W') THEN

          NPAIR_STOR = NPAIR
          DO IP=1,NPAIR
            IPAIR_STOR(1,IP)= IPAIR(1,IP)
            IPAIR_STOR(2,IP)= IPAIR(2,IP)
          ENDDO

          Q_LIM = 0.01

          WRITE(LINE,
     *    '(''Q :'',F8.3,'' (-limit :'',F8.3,'')'')') Q,Q_LIM
          CALL MSGDOC(MDOC,LINE)

          IF(Q.LT.Q_LIM) THEN
            Q_FIN     = 0.0
            DRMS_BEST =-0.1
            NPAIR_BEST= 0
            RESULT(15) = Q_FIN
            RESULT(16) = DRMS_BEST 
            RESULT(17) = NPAIR_BEST 
            CALL SET_UNIT_TRANSFORM(RESULT,IPRROW)

            GO TO 610

          ELSE

            DO I=1,NC
              SCORE(I,3) = SCORE(I,1)
            ENDDO
            CALL CHECK_FIT_D(MDOC,COORD1,COORD2
     *       ,NSEQ1,NSEQ2,SURF1,SURF2,IRES1,IRES2,NC,KC,SCORE(1,3)
     *       ,NPAIR,IPAIR,NMAX1,NMAX2,NMAX12,AMAT,IPRINT
     *       ,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(MDOC,'ERROR: in CHECK_FIT_D')
              GO TO 600
            ENDIF

            DRMS = RESULT(16) 
            IF(DRMS.GT.10.0.OR.DRMS.LT.0.0) THEN 
              CALL SET_UNIT_TRANSFORM(RESULT,IPRROW)
              GO TO 610
            ENDIF

          ENDIF

          DIST = 'D'
C --
          IDOUBLE = 1
          CALL TRANSFORM_COORD(MDOC,TRMAT,TR
     *   ,KC,COORD2,SURF2,NMAX2,RESULT,IPRROW,IERR)

C --

c         PENEXR = 0.01

          CALL ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     *      ,OPENR,DPEN0,PENEXR
     *      ,ATOM_INDEX,ATOM_NAME     
     *      ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     *      ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
  
          CALL SET_AMATRIX4(MDOC,DIST,AMATRIX,AMAT
     *     ,NC,NSEQ1,ASEQ1,COORD1,SURF1,KC,NSEQ2,ASEQ2,COORD2,SURF2
     *     ,SS_FLAG,SS1,SS2
     *     ,NMAX1,NMAX2,IERR)

          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in SET_AMATRIX')
            GO TO 600
          ENDIF

          IF(ADOM.NE.'D') SS_FLAG = 'N'
          D3_FLAG = 'N'

          CALL ALIGNMENT4(MDOC
     *      ,AMATRIX,AMAT,D3_FLAG,SS_FLAG,ADOM
     *      ,OPENR,DPENR,PENEXR,DPEN0P
     *      ,NC,KC
     *      ,ISS1,ISS2,SURF1,SURF2,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *      ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *      ,NPAIR,IPAIR,SCORE(1,1),SCORE(1,2),Q
     *      ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *      ,IPROFILE1,IPROFILE2
     *      ,IDOMAIN1,IDOMAIN2
     *      ,NMAX1,NMAX2,NMAX12,RESULT3,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in ALIGNMENT4')
            GO TO 600
          ENDIF
c          IF(IPRROW.GE.42) THEN
             RESULT3(42) = Q
c          ENDIF

c///// 
          DO I=1,NC
            SCORE(I,3) = SCORE(I,1)
          ENDDO
c/////


          IF(IPRINT.GT.0) THEN

c           write(*,*)'==d=',dist,DPENR,NPAIR
 
            CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *      ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *      ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *      ,ICHAIN1,ICHAIN2,D3_FLAG
     *      ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT3)
          ENDIF

          IF(NPAIR.LE.3) THEN
            CALL MSGERR(MDOC,'ERROR: NPAIR < 4')
            IERR = 1
            GO TO 600
          ENDIF

c///// 
          IF(IPRINTR.EQ.3) THEN
            DO I=1,NC
              SCORE(I,1) = SCORE(I,3)
            ENDDO
            CALL CORR_PAIR_BY_SCORE(MDOC,NC,KC,NSEQ1,NSEQ2
     *       ,SCORE(1,1),SCORE(1,2)
     *       ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,DPENR)
            IF(NPAIR.LE.3) THEN
              CALL MSGERR(MDOC,'ERROR: NPAIR < 4.')
              IERR = 1
              GO TO 600
            ENDIF

            DO I=1,NC
              SCORE(I,1) = SCORE(I,3)
            ENDDO

c            write(*,*)'==dD=',dist,DPENR,NPAIR
 
            CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *      ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *      ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *      ,ICHAIN1,ICHAIN2,D3_FLAG
     *      ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT3)

          ENDIF
c/////


        ENDIF

        IFLAG_COOR = 1

        NPAIR_STOR = NPAIR
        DO IP=1,NPAIR
          IPAIR_STOR(1,IP)= IPAIR(1,IP)
          IPAIR_STOR(2,IP)= IPAIR(2,IP)
        ENDDO

C        NN        = RESULT(3)
C        NGAP      = RESULT(20)
C        SCORE_NEW = RESULT(18)
C        TT = (REAL(NN-NGAP)/REAL(NN))
C        Q = SCORE_NEW*TT*TT*TT*TT

        Q_LIM = 0.01
c       IF(DIST.EQ.'D'.OR.DIST.EQ.'P') Q_LIM = 0.0

        WRITE(LINE,
     *  '('' Q :'',F8.3,'' (limit:'',F8.3,'')'')') Q,Q_LIM
        CALL MSGDOC(MDOC,LINE)

        IF(Q.LT.Q_LIM) THEN
          Q_FIN     = 0.0
          DRMS_BEST =-0.1
          NPAIR_BEST= 0
          RESULT(15) = Q_FIN
          RESULT(16) = DRMS_BEST 
          RESULT(17) = NPAIR_BEST 
          CALL SET_UNIT_TRANSFORM(RESULT,IPRROW)
        ELSE

          DO I=1,NC
            SCORE(I,3) = SCORE(I,1)
          ENDDO
          CALL CHECK_FIT_D(MDOC,COORD1,COORD2
     *     ,NSEQ1,NSEQ2,SURF1,SURF2,IRES1,IRES2,NC,KC,SCORE(1,3)
     *     ,NPAIR,IPAIR,NMAX1,NMAX2,NMAX12,AMAT,IPRINT
     *     ,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,'ERROR: in CHECK_FIT_D')
            GO TO 600
          ENDIF
 
          IF(IPRINT.GT.1) THEN 
C           SS: 1 - H, 2 -h, 3 - B, 4 - b
            CALL ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *      ,IRES1,IRES2,SCORE(1,1),SCORE(1,2)
     *      ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *      ,ICHAIN1,ICHAIN2,D3_FLAG
     *      ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT2)
          ENDIF

          IF(IDOUBLE.GT.0) THEN
            CALL DOUBLE_TRANSFORM(MDOC,TRMAT,TR
     *       ,RESULT,IPRROW,IERR)
          ENDIF

        ENDIF

  610   CONTINUE

        NPAIR = NPAIR_STOR
        DO IP=1,NPAIR
          IPAIR(1,IP)= IPAIR_STOR(1,IP)
          IPAIR(2,IP)= IPAIR_STOR(2,IP)
        ENDDO

      ENDIF

      CALL LENSTR_BL(FILE_PAIR,LEN)
      IF(LEN.GT.0) THEN
        ITRANS_P = 1

        CALL WRITE_PAIR_LIST(MDOC,IFLAG_COOR
     *   ,NC,KC,NPAIR,IPAIR,IRES1,IRES2,PNUM1,PNUM2
     *   ,NSEQ1,NSEQ2,COORD1,COORD2,SS1,SS2,NMAX1,NMAX2
     *   ,IDOMAIN1,IDOMAIN2
     *   ,FILE_PAIR,ITRANS_P,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,'ERROR: in WRITE_PAIR_LIST')
          GO TO 600
        ENDIF
      ENDIF

      CALL LENSTR_BL(FILE_OUT,LEN)
      IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.LT.0.AND.
     *                                    CORR.NE.'P') THEN
        CALL MSGERR(MDOC,'INFO: output only PAIR fie')
        GO TO 600
      ENDIF

      IF(CORR.EQ.'N') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)
        IF(LEN.GT.4.AND.IPDB2.EQ.1) THEN

C       corr N :  OUT - aligned PDB file_2 (not rotated)

          ITRANS_2 = 0

          CALL ALIGN_3_WRITE_PDB2_ALIGN(MDOC,FILE_2,FILE_OUT
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            RESULT(7)  = NAT
            RESULT(8)  = NRES
            RESULT(9)  = NAT_OCC
            RESULT(10) = NRES_OCC
          ENDIF
        ENDIF

      ELSE IF(CORR.EQ.'2') THEN

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.EQ.1.AND.IPDB2.EQ.1) THEN

C       corr 2 : (OUT name+_1,+_2) -> OUT_1, aligned
c                                     OUT_2, aligned (rotated or not)

          FILE_OUT1 = FILE_OUT(1:LEN-4)//'_1.pdb'

          ITRANS_1 = 0
          CALL ALIGN_3_WRITE_PDB1_ALIGN(MDOC,FILE_1,FILE_OUT1
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_1,RESULT,IPRROW,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF

          CALL LENSTR_BL(FILE_OUT,LEN)
          FILE_OUT2 = FILE_OUT(1:LEN-4)//'_2.pdb'
          ITRANS_2 = ITRANS
          CALL ALIGN_3_WRITE_PDB2_ALIGN(MDOC,FILE_2,FILE_OUT2
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            RESULT(7)  = NAT
            RESULT(8)  = NRES
            RESULT(9)  = NAT_OCC
            RESULT(10) = NRES_OCC
          ENDIF

        ENDIF

      ELSE IF(CORR.EQ.'P') THEN

C      CORR = P  (FILE_OUT) profile  

        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.GE.0) THEN
          
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_2SEQ_TO_PROFILE(MDOC,FILE_OUT
     *    ,CODE8
     *    ,NC,KC,NSEQ1,NSEQ2,PNUM1,PNUM2
     *    ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF

        ELSE IF(LEN.GT.4.AND.IPDB1.LT.0.AND.IPDB2.GE.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_PROF_SEQ_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE1,IPROFILE1,KC
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ELSE IF(LEN.GT.4.AND.IPDB1.GE.0.AND.IPDB2.LT.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_SEQ_PROF_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE2,IPROFILE2,KC
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ELSE IF(LEN.GT.4.AND.IPDB1.LT.0.AND.IPDB2.LT.0) THEN
          CODE8 = CODE8_1
          CALL ALIGN_WRITE_2PROF_TO_PROFILE(MDOC,FILE_OUT
     *     ,CODE8
     *     ,NC,NSEQ_PROFILE1,IPROFILE1,KC,NSEQ_PROFILE2,IPROFILE2
     *     ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *     ,IDOMAIN1,IDOMAIN2,SS1,SS2
     *     ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
          IF(IERR.NE.0) THEN
            GO TO 600
          ENDIF
        ENDIF

      ELSE
        CALL CORR_NAME_BL(FILE_OUT)
        CALL LENSTR_BL(FILE_OUT,LEN)

        IF(LEN.GT.4.AND.IPDB1.GT.0.AND.IPDB2.EQ.1) THEN

C         (OUT) rotated FULL/noFULL file_2 (without alignment)
          
          ITRANS_2 = 1
          IF(IPDB1.LT.0) ITRANS_2 = 0

          CALL ALIGN_3_WRITE_PDB2_FULL(MDOC,FILE_2,FILE_OUT
     *    ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *    ,ATOM_INDEX,ATOM_NAME     
     *    ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,FULL
     *    ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *    ,ITRANS_2,RESULT,IPRROW,IERR)
        ENDIF
        IF(IERR.EQ.0) THEN
          RESULT(7)  = NAT
          RESULT(8)  = NRES
          RESULT(9)  = NAT_OCC
          RESULT(10) = NRES_OCC
        ENDIF
      ENDIF

 600  CONTINUE

      deallocate(AMATRIX,STAT=ISTAT)
      deallocate(SCORE,STAT=ISTAT)
      deallocate(IPAIR,STAT=ISTAT)
      deallocate(IPAIR_STOR,STAT=ISTAT)

 700  CONTINUE

      deallocate(IPROFILE2,STAT=ISTAT)
      deallocate(COORD2,STAT=ISTAT)
      deallocate(ASEQ2,STAT=ISTAT)
      deallocate(NSEQ2,STAT=ISTAT)
      deallocate(IRES2,STAT=ISTAT)
      deallocate(SURF2,STAT=ISTAT)
      deallocate(ICHAIN2,STAT=ISTAT)
      deallocate(IDOMAIN2,STAT=ISTAT)
      deallocate(SS2,STAT=ISTAT)
      deallocate(ISS2,STAT=ISTAT)
      deallocate(PNUM2,STAT=ISTAT)

 800  CONTINUE

      deallocate(IPROFILE1,STAT=ISTAT)
      deallocate(COORD1,STAT=ISTAT)
      deallocate(ASEQ1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

 900  CONTINUE

      FILE_SCR = 'align_1_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'align_2_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)

      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      RETURN
 915  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      GO TO 800
 920  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin2)')
      IERR = 1
      GO TO 800
 925  CONTINUE
      CALL MSGERR(MDOC,'ERROR: read input file (bin1)')
      IERR = 1
      GO TO 700
      END

      SUBROUTINE CORR_PAIR_BY_SCORE(MDOC,NC,KC,NSEQ1,NSEQ2
     *  ,SCORE1,SCORE2
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,DPENR)
C -------------------------------------
      REAL      SCORE1(NMAX12),SCORE2(NMAX12)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
C ================================================================
      IERR = 0
      IF(NPAIR.EQ.0) RETURN

      CALL SMOOTH_SCORE(MDOC,DPENR
     *  ,NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2,NPAIR,IPAIR
     *  ,NMAX1,NMAX2,NMAX12,IERR)

      SMAX = -1.0E30
      SMIN =  1.0E30
      DO I=1,NC
        IF(SCORE1(I).GE.0.0) THEN
          T = SCORE1(I)- DPENR
          IF(T.GT.SMAX) SMAX = T
          IF(T.LT.SMIN) SMIN = T
        ENDIF
      ENDDO
      SLIM = ABS(SMIN)
      IF(ABS(SMAX).GT.SLIM) SLIM = ABS(SMAX)
      SLIM = SLIM/2.0
      NPAIR_NEW = 0 
      DO IPR=1,NPAIR
        I1 = IPAIR(1,IPR)
        J1 = IPAIR(2,IPR)
        SCR = SCORE1(I1) - DPENR
        IF(SCR.GE.0) THEN
          ISC = (SCR/SLIM)*2.0 + 3.0
          IF(ISC.LT.4) THEN
            ISC = 1
          ELSE IF(ISC.GT.5) THEN
            ISC = 5
          ENDIF
        ELSE IF(SCR.LT.0) THEN
          ISC = (ABS(SCR)/SLIM)*2.0 + 1.0
          IF(ISC.LT.2) THEN
            ISC = 6
          ELSE IF(ISC.GT.3) THEN
            ISC = 3
          ENDIF
        ELSE 
          ISC =-1
        ENDIF
        IF(ISC.LT.0) THEN
          ISC =-1
        ENDIF

c        WRITE(*,*) '>>',IPR,I1,ISC,SCR

        IF(ISC.NE.2.AND.ISC.NE.3) THEN
          NPAIR_NEW = NPAIR_NEW + 1 
          IPAIR(1,NPAIR_NEW) = IPAIR(1,IPR)
          IPAIR(2,NPAIR_NEW) = IPAIR(2,IPR)
        ENDIF
      ENDDO         
      NPAIR = NPAIR_NEW  
      RETURN
      END

      SUBROUTINE TRANSFORM_COORD(MDOC,TRMAT,TR
     *   ,KC,COORD2,SURF2,NMAX2,RESULT,IPRROW,IERR)
C ------------------------------
      REAL      COORD2(NMAX2,3)
      INTEGER   SURF2(NMAX2)
      REAL      RESULT(IPRROW)
      REAL      TR(3),TRMAT(3,3),X(3),Y(3),Z(3)
      CHARACTER LINE*512
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      TR(1)      = RESULT(30)
      TR(2)      = RESULT(31) 
      TR(3)      = RESULT(32) 
      TRMAT(1,1) = RESULT(33) 
      TRMAT(1,2) = RESULT(34) 
      TRMAT(1,3) = RESULT(35) 
      TRMAT(2,1) = RESULT(36) 
      TRMAT(2,2) = RESULT(37) 
      TRMAT(2,3) = RESULT(38) 
      TRMAT(3,1) = RESULT(39) 
      TRMAT(3,2) = RESULT(40) 
      TRMAT(3,3) = RESULT(41) 
C ---
      DO IP2=1,KC
        IF(SURF2(IP2).GE.0) THEN

          Y(1) = COORD2(IP2,1)
          Y(2) = COORD2(IP2,2)
          Y(3) = COORD2(IP2,3)

          DO III=1,3
            Z(III) =   TRMAT(1,III)*Y(1)
     *               + TRMAT(2,III)*Y(2)
     *               + TRMAT(3,III)*Y(3)
          ENDDO
          DO III=1,3
            Z(III) = Z(III) +  TR(III)
          ENDDO

          COORD2(IP2,1) = Z(1)
          COORD2(IP2,2) = Z(2)
          COORD2(IP2,3) = Z(3)

        ENDIF
      ENDDO
C ----
      RETURN
      END 

      SUBROUTINE DOUBLE_TRANSFORM(MDOC,TRMAT,TR
     *   ,RESULT,IPRROW,IERR)
C ------------------------------
      REAL      RESULT(IPRROW)
      REAL      TR(3),TRMAT(3,3),AM1(3,3),T1(3),AM2(3,3),T2(3),X(3)
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      T1(1)    = RESULT(30)
      T1(2)    = RESULT(31) 
      T1(3)    = RESULT(32) 
      AM1(1,1) = RESULT(33) 
      AM1(1,2) = RESULT(34) 
      AM1(1,3) = RESULT(35) 
      AM1(2,1) = RESULT(36) 
      AM1(2,2) = RESULT(37) 
      AM1(2,3) = RESULT(38) 
      AM1(3,1) = RESULT(39) 
      AM1(3,2) = RESULT(40) 
      AM1(3,3) = RESULT(41) 
C ---
      CALL MATMLT(AM1,TRMAT,AM2)
      CALL MVMULT(AM1,TR,X)
      CALL VADD(X,T1,T2)
C ---
      RESULT(30) = T2(1)
      RESULT(31) = T2(2)
      RESULT(32) = T2(3)
      RESULT(33) = AM2(1,1)
      RESULT(34) = AM2(1,2) 
      RESULT(35) = AM2(1,3)
      RESULT(36) = AM2(2,1)
      RESULT(37) = AM2(2,2) 
      RESULT(38) = AM2(2,3) 
      RESULT(39) = AM2(3,1)
      RESULT(40) = AM2(3,2)
      RESULT(41) = AM2(3,3)  
C ----
      RETURN
      END 

      SUBROUTINE SET_UNIT_TRANSFORM(RESULT,IPRROW)
C ------------------------------
      REAL      RESULT(IPRROW)
C ------------------------------
      RESULT(30) = 0.0
      RESULT(31) = 0.0 
      RESULT(32) = 0.0 
      RESULT(33) = 1.0
      RESULT(34) = 0.0   
      RESULT(35) = 0.0  
      RESULT(36) = 0.0 
      RESULT(37) = 1.0 
      RESULT(38) = 0.0 
      RESULT(39) = 0.0
      RESULT(40) = 0.0
      RESULT(41) = 1.0  
C ----
      RETURN
      END 

      SUBROUTINE WRITE_PAIR_LIST(MDOC,IFLAG_COOR
     *   ,NC,KC,NPAIR,IPAIR,IRES1,IRES2,PNUM1,PNUM2
     *   ,NSEQ1,NSEQ2,COORD1,COORD2,SS1,SS2,NMAX1,NMAX2
     *   ,IDOMAIN1,IDOMAIN2
     *   ,FILE_PAIR,ITRANS,RESULT,IPRROW,IERR)
C ------------------------------
      REAL      COORD1(NMAX1,3)
      REAL      COORD2(NMAX2,3)
      CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6
      INTEGER   IPAIR(2,*),IRES1(*),IRES2(*)
      INTEGER   NSEQ1(*),NSEQ2(*)
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
      INTEGER   SS1(*),SS2(*)
C     INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      REAL      RESULT(IPRROW)
      REAL      TR(3),TRMAT(3,3),X(3),Y(3),Z(3)
      CHARACTER FILE_PAIR*(*)
      CHARACTER LINE*512
      CHARACTER PATH*1,EXT*1,SS_1*1,SS_2*1
      CHARACTER  AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      IF(NPAIR.LE.0) THEN
        CALL MSGERR(MD,' ERROR: NPAIR =0')
        IERR = 1
        RETURN
      ENDIF

      IF(ITRANS.GT.0.AND.IFLAG_COOR.GT.0.AND.IPRROW.GE.41) THEN
        TR(1)      = RESULT(30)
        TR(2)      = RESULT(31) 
        TR(3)      = RESULT(32) 
        TRMAT(1,1) = RESULT(33) 
        TRMAT(1,2) = RESULT(34) 
        TRMAT(1,3) = RESULT(35) 
        TRMAT(2,1) = RESULT(36) 
        TRMAT(2,2) = RESULT(37) 
        TRMAT(2,3) = RESULT(38) 
        TRMAT(3,1) = RESULT(39) 
        TRMAT(3,2) = RESULT(40) 
        TRMAT(3,3) = RESULT(41) 
        IF(ABS(TRMAT(1,1)).GT.0.0001.OR.
     *     ABS(TRMAT(2,2)).GT.0.0001.OR.
     *     ABS(TRMAT(3,3)).GT.0.0001    ) ITRANS = 1
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 30
      CALL OPENFW(IOUT,M,PATH,FILE_PAIR,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output PAIR file')
        IERR = 1
        RETURN
      ENDIF

      IC1 = 0
      DO I=1,NPAIR
        IC1  = IC1 +  1
        IP1  = IPAIR(1,I)
        IF(IP1.GT.IC1) THEN
          DO J=IC1,IP1-1
            IR1  = IRES1(J)
            I1   = NSEQ1(J)
            ISS_1 = SS1(J)
            IF(ISS_1.EQ.1) THEN
              SS_1 = 'H'
            ELSE IF(ISS_1.EQ.2) THEN
              SS_1 = 'h'
            ELSE IF(ISS_1.EQ.3) THEN
              SS_1 = 'B'
            ELSE IF(ISS_1.EQ.4) THEN
              SS_1 = 'b'
            ELSE
              SS_1 = ' '
            ENDIF

C            READ(PNUM1(J)(2:5),'(I4)') IRR1

            WRITE(LINE,'(I5,A,I5,A,A,A,A,A,I5,A)') I,')'
     *        ,J,' ',PNUM1(J)(2:6),AMIN(I1),' ',SS_1
     *        ,IDOMAIN1(J),' - '

c            WRITE(LINE,'(I5,A ,2I5,A,A,A,A,A)') I,')'
c     *        ,J,IRR1,' ',AMIN(I1),' ',SS_1,' - '

            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)') LINE(1:LEN)
          ENDDO
          IC1 = IP1
        ENDIF
        IR1  = IRES1(IP1)
        I1   = NSEQ1(IP1)
        ISS_1 = SS1(IP1)
        IF(ISS_1.EQ.1) THEN
          SS_1 = 'H'
        ELSE IF(ISS_1.EQ.2) THEN
          SS_1 = 'h'
        ELSE IF(ISS_1.EQ.3) THEN
          SS_1 = 'B'
        ELSE IF(ISS_1.EQ.4) THEN
          SS_1 = 'b'
        ELSE
          SS_1 = ' '
        ENDIF

        IF(IFLAG_COOR.GT.0) THEN 
          X(1) = COORD1(IP1,1)
          X(2) = COORD1(IP1,2)
          X(3) = COORD1(IP1,3)
        ENDIF
        IP2  = IPAIR(2,I)
        IR2  = IRES2(IP2)
        I2   = NSEQ2(IP2)
        ISS_2 = SS2(IP2)
        IF(ISS_2.EQ.1) THEN
          SS_2 = 'H'
        ELSE IF(ISS_2.EQ.2) THEN
          SS_2 = 'h'
        ELSE IF(ISS_2.EQ.3) THEN
          SS_2 = 'B'
        ELSE IF(ISS_2.EQ.4) THEN
          SS_2 = 'b'
        ELSE
          SS_2 = ' '
        ENDIF

        IF(IFLAG_COOR.GT.0) THEN 
          Y(1) = COORD2(IP2,1)
          Y(2) = COORD2(IP2,2)
          Y(3) = COORD2(IP2,3)
        ENDIF

        IF(IFLAG_COOR.GT.0) THEN
          IF(ITRANS.GT.0) THEN
            DO III=1,3
              Z(III) =   TRMAT(1,III)*Y(1)
     *                 + TRMAT(2,III)*Y(2)
     *                 + TRMAT(3,III)*Y(3)
            ENDDO
            DO III=1,3
              Z(III) = Z(III) +  TR(III)
            ENDDO
C            WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)          
          ELSE
            DO III=1,3
              Z(III) = Y(III)
            ENDDO
          ENDIF

          DX = X(1)-Z(1)
          DY = X(2)-Z(2)
          DZ = X(3)-Z(3)
          D = SQRT(DX*DX+DY*DY+DZ*DZ)

C          READ(PNUM1(IP1)(2:5),'(I4)') IRR1
C          READ(PNUM2(IP2)(2:5),'(I4)') IRR2

          WRITE(LINE,
     *'(I5,A ,I5,A,A,A,A,A,I5,A,I5,A,A,A,A,A,I5,A,F8.3)') I,')'
     *    ,IP1,' ',PNUM1(IP1)(2:6),AMIN(I1),' ',SS_1
     *    ,IDOMAIN1(IP1),' - '
     *    ,IP2,' ',PNUM2(IP2)(2:6),AMIN(I2),' ',SS_2
     *    ,IDOMAIN2(IP2),' '
     *    ,D

c          WRITE(LINE,
c     *    '(I5,A ,2I5,A,A,A,A,A ,2I5,A,A,A,A,A ,F8.3)') I,')'
c     *    ,IP1,IRR1,' ',AMIN(I1),' ',SS_1,' - '
c     *    ,IP2,IRR2,' ',AMIN(I2),' ',SS_2,' '
c     *    ,D

        ELSE

C          READ(PNUM1(IP1)(2:5),'(I4)') IRR1
C          READ(PNUM2(IP2)(2:5),'(I4)') IRR2

c          WRITE(LINE,
c     *    '(I5,A ,2I5,A,A,A,A,A ,2I5,A,A,A,A)') I,')'
c     *    ,IP1,IRR1,' ',AMIN(I1),' ',SS_1,' - '
c     *    ,IP2,IRR2,' ',AMIN(I2),' ',SS_2

          WRITE(LINE,
     * '(I5,A ,I5,A,A,A,A,A,I5,A,I5,A,A,A,A,A,I5)') I,')'
     *    ,IP1,' ',PNUM1(IP1)(2:6),AMIN(I1),' ',SS_1
     *    ,IDOMAIN1(IP1),' - '
     *    ,IP2,' ',PNUM2(IP2)(2:6),AMIN(I2),' ',SS_2
     *    ,IDOMAIN2(IP2)

        ENDIF

        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)

      ENDDO
      IF(NC.GT.IC1) THEN
        DO J=IC1+1,NC
          IR1  = IRES1(J)
          I1   = NSEQ1(J)
          ISS_1 = SS1(J)
          IF(ISS_1.EQ.1) THEN
            SS_1 = 'H'
          ELSE IF(ISS_1.EQ.2) THEN
            SS_1 = 'h'
          ELSE IF(ISS_1.EQ.3) THEN
            SS_1 = 'B'
          ELSE IF(ISS_1.EQ.4) THEN
            SS_1 = 'b'
          ELSE
            SS_1 = ' '
          ENDIF

C          READ(PNUM1(J)(2:5),'(I4)') IRR1

c          WRITE(LINE,'(I5,A ,2I5,A,A,A,A,A)') I,')'
c     *        ,J,IRR1,' ',AMIN(I1),' ',SS_1,' - '

          WRITE(LINE,'(I5,A ,I5,A,A,A,A,A,I5,A)') I,')'
     *        ,J,' ',PNUM1(J)(2:6),AMIN(I1),' ',SS_1
     *        ,IDOMAIN1(J),' - '

          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)') LINE(1:LEN)
        ENDDO
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)
C ----
      RETURN
      END 

      SUBROUTINE ALIGNMENT4(MDOC
     *  ,AMATRIX,AMAT,D3_FLAG,SS_FLAG,ADOM
     *  ,OPENI,DPENI,PENEXI,DPEN0P
     *  ,NC,KC
     *  ,ISS1,ISS2,SURF1,SURF2,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *  ,IRES1,IRES2,ICHAIN1,ICHAIN2
     *  ,NPAIR,IPAIR,SCORE1,SCORE2,Q
     *  ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *  ,IPROFILE1,IPROFILE2
     *  ,IDOMAIN1,IDOMAIN2
     *  ,NMAX1,NMAX2,NMAX12,RESULT,IERR)
C -------------------------------------
      REAL      RESULT(*)
      CHARACTER D3_FLAG*1,SS_FLAG*1,ADOM*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      ASEQ1(NMAX1),ASEQ2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12),ICHAIN1(NMAX1),ICHAIN2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      REAL      SCORE1(NMAX12),SCORE2(NMAX12)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   IPROFILE1(NMAX1,20),IPROFILE2(NMAX2,20)
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
C     INTEGER   ITRACE(2,NMAX1,NMAX2)
C     REAL      AMAX_K(NMAX1)
C     INTEGER   KK_MAX(NMAX1)
C     REAL      AMATRIX_S(NMAX1,NMAX2)

      integer,   allocatable :: ITRACE(:,:,:)
      real,      allocatable :: AMATRIX_S(:,:)
      real,      allocatable :: AMAX_K(:)
      integer,   allocatable :: KK_MAX(:)
      real,      allocatable :: WEIGHT_1(:)
      real,      allocatable :: WEIGHT_2(:)

      CHARACTER LINE*256
C ================================================================
      IERR   = 0
      NPAIR  = 0
      Q      = 0.0
      WRITE(LINE,'('' PENALTY O,E :'',2F8.3)') OPENI,PENEXI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' "0"         :'',F8.3)') DPENI
      CALL MSGDOC(MDOC,LINE)
      IF(IPDB1.LT.0.OR.IPDB2.LT.0) THEN
        WRITE(LINE,'('' "0" for prf :'',F8.3)') DPEN0P
        CALL MSGDOC(MDOC,LINE)
      ENDIF

      allocate(ITRACE(1:2,1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(AMATRIX_S(1:NMAX1,1:NMAX2),STAT=ISTAT)
      allocate(AMAX_K(1:NMAX1),STAT=ISTAT)
      allocate(KK_MAX(1:NMAX1),STAT=ISTAT)

      allocate(WEIGHT_1(1:NMAX1),STAT=ISTAT)
      allocate(WEIGHT_2(1:NMAX2),STAT=ISTAT)
C ------------
c     weight by surf 
      DO N=1,NC
        W = 1.0
        IF(D3_FLAG.EQ.'Y') THEN
          SRF1 = SURF1(N)
          IF(SRF1.LT.0) SRF1 = 9
          IF(SRF1.GT.0) THEN
            TT = SQRT(REAL(SRF1))
            W = 1.0/SQRT(TT)
          ENDIF   
        ENDIF  
        WEIGHT_1(N) = W 
      ENDDO
      DO K=1,KC
        W = 1.0
        IF(D3_FLAG.EQ.'Y') THEN
          SRF2 = SURF2(K)
          IF(SRF2.LT.0) SRF2 = 9
          IF(SRF2.GT.0) THEN
            TT = SQRT(REAL(SRF2))
            W = 1.0/SQRT(TT)
          ENDIF   
        ENDIF  
        WEIGHT_2(K) = W 
      ENDDO

      DO N=1,NC
      DO K=1,KC
        T = AMATRIX(N,K)
        W = 1.0
        IF(D3_FLAG.EQ.'Y') THEN
          W = WEIGHT_1(N)*WEIGHT_2(K)        
          T = T*W
        ENDIF   
        AMATRIX_S(N,K) = T

        AMATRIX(N,K) = T

      ENDDO
      ENDDO

C ----
      DPENII = DPENI
      IF(IPDB1.LT.0.OR.IPDB2.LT.0) THEN
        DPENII = DPEN0P
      ENDIF

      IF(ADOM.EQ.'D') THEN

        CALL ALIGN_NW4_DDD(MDOC,AMATRIX_S,SS_FLAG,ADOM
     *    ,OPENI,PENEXI,DPENII
     *    ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *    ,AMAX_K,KK_MAX
     *    ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)

      ELSE

        CALL ALIGN_NW4(MDOC,AMATRIX_S,SS_FLAG,ADOM
     *  ,OPENI,PENEXI,DPENII
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)

      ENDIF

c      CALL ALIGN_SW4(MDOC,AMATRIX,SS_FLAG
c     *  ,OPENI,PENEXI,DPENII
c     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
c     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)

      deallocate(ITRACE,STAT=ISTAT)
      deallocate(AMATRIX_S,STAT=ISTAT)
      deallocate(AMAX_K,STAT=ISTAT)
      deallocate(KK_MAX,STAT=ISTAT)

      IF(NPAIR.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: NPAIR = 0')
        IERR = 1
        GO TO 900
      ENDIF
C ----
      IF(IPDB1.LT.0.OR.IPDB2.LT.0) THEN

        CALL RECALC_MATRIX_PRF(NC,KC,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     *   ,NPAIR,IPAIR
     *   ,NMAX1,NMAX2,NMAX12,AMAT,AMATRIX
     *   ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *   ,IPROFILE1,IPROFILE2)

      ENDIF

      CALL CALC_SCORE_3(NC,KC,NSEQ1,ASEQ1,NSEQ2,ASEQ2,SCORE1,SCORE2
     * ,NPAIR,IPAIR
     * ,NMAX1,NMAX2,NMAX12,AMAT,AMATRIX
     * ,NC1,KC1,NN,NHOM,HOM
     * ,WEIGHT_1,WEIGHT_2
     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
     * ,FIDENT_NEW,DPENI)

      WRITE(LINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF AMINO ACIDS IN 1-ST SEQ='',I5)')NC1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF AMINO ACIDS IN 2-ND SEQ='',I5)')KC1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF ALIGNED AMINO ACIDS    ='',I5)')NN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' NUMBER OF IDENTICAL AMINO ACIDS  ='',I5)')NHOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' IDENTITY                         ='',F8.3)')HOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE>                          ='',F8.3)') 
     * SUM_SCORE
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE_MAX> (for 1-st seq)       ='',F8.3)') 
     * SCORE1_MAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' <SCORE_MIN> (for 1-st seq),sig   ='',2F8.4)') 
     * SCORE_MIN,SCORE_SIGMA
      CALL MSGDOC(MDOC,LINE)

      SCORE1_MIN = SCORE_MIN       
      IF(SUM_SCORE.LT.SCORE1_MIN) SCORE1_MIN = SUM_SCORE 
      D = SCORE1_MAX - SCORE1_MIN
      SCR = 1.0
      IF(D.GT.0.01) THEN
        SCR = (SUM_SCORE-SCORE1_MIN)/(SCORE1_MAX-SCORE1_MIN)
      ENDIF
      WRITE(LINE,'('' <SCORE_NEW>                      ='',F8.3)') 
     * SCR
      CALL MSGDOC(MDOC,LINE)
      SCORE_NEW = SCR
      WRITE(LINE,'('' IDENT_NEW                        ='',F8.3)') 
     * FIDENT_NEW
      CALL MSGDOC(MDOC,LINE)

      NGAP   = 0
      DO IPR=2,NPAIR 
        ISE = IPAIR(1,IPR-1) 
        JSE = IPAIR(2,IPR-1)
        I1  = IPAIR(1,IPR)
        J1  = IPAIR(2,IPR)
        IF(I1-ISE.GT.1.OR.J1-JSE.GT.1)THEN
          IGAP = 1
          IF(I1-ISE.GT.1)THEN
            IGAP = 1
            DO II=ISE+1,I1-1
              IN1 = NSEQ1(II)
C                       '='
              IF(IN1.GE.24) IGAP = 0
            ENDDO
          ENDIF
          IF(J1-JSE.GT.1)THEN
            DO II=JSE+1,J1-1
              IN2 = NSEQ2(II)
C                       '='
              IF(IN2.GE.24) IGAP = 0
            ENDDO
          ENDIF
          IF(IGAP.GT.0) NGAP = NGAP + 1 
        ENDIF
      ENDDO
      WRITE(LINE,'('' N_gap                            ='',I6)') 
     * NGAP
      CALL MSGDOC(MDOC,LINE)

      IF(KC1.LT.NC1) THEN
        T =  1.0 - REAL(NN)/REAL(KC1)
      ELSE 
        T =  1.0 - REAL(NN)/REAL(NC1)
      ENDIF 
      TT = (REAL(NN-NGAP)/REAL(NN))
      Q  = SCORE_NEW*TT*TT*TT*TT
      Q  = Q * EXP(-T)
      WRITE(LINE,'('' Q                                ='',F8.3)') 
     * Q
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,LINE)
C ---
      RESULT(1) = NC1
      RESULT(2) = KC1
      RESULT(3) = NN
      RESULT(4) = NHOM
      RESULT(5) = HOM
      RESULT(6) = SUM_SCORE 
      RESULT(13) = SCORE1_MAX 
      RESULT(14) = SCORE_MIN 
      RESULT(18) = SCORE_NEW
      RESULT(19) = FIDENT_NEW
      RESULT(20) = NGAP
C ---

 900  CONTINUE

      deallocate(WEIGHT_1,STAT=ISTAT)
      deallocate(WEIGHT_2,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE CALC_SCORE_3(NC,KC,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     * ,SCORE1,SCORE2
     * ,NPAIR,IPAIR
     * ,NMAX1,NMAX2,NMAX12,AMAT,AMATRIX
     * ,NC1,KC1,NN,NHOM,HOM
     * ,WEIGHT_1,WEIGHT_2
     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
     * ,FIDENT_NEW,DPENI)
C -------------------------------------------------------------
      REAL      AMAT(25,25)
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      ASEQ1(NMAX1),ASEQ2(NMAX2)  
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      REAL      SCORE1(*),SCORE2(*)
      REAL      WEIGHT_1(*),WEIGHT_2(*)
C ================================================================
      IVAR      = 1
      SUM_SCORE = 0.0
      NHOM      = 0
      NN        = 0
      WNN       = 0.0
      NC1       = 0
      KC1       = 0
      SCORE1_MAX= 0.0
      SCORE_MIN = 0.0
      SUM_F     = 0.0
      SUM_F_MAX = 0.0
      FIDENT_NEW = 0.0 
      DO I=1,NC
c        IF(NSEQ1(I).LT.24) NC1 = NC1 + 1
        IF(NSEQ1(I).LT.21) NC1 = NC1 + 1
        SCORE1(I) = 0.0
      ENDDO             
      DO I=1,KC
c        IF(NSEQ2(I).LT.24) KC1 = KC1 + 1
        IF(NSEQ2(I).LT.21) KC1 = KC1 + 1
        SCORE2(I) = 0.0
      ENDDO             
      DO I=1,NPAIR             
        N = IPAIR(1,I)
        K = IPAIR(2,I)
        NAA1 = NSEQ1(N)
        NAA2 = NSEQ2(K)
c       IF(NAA1.LT.24.AND.NAA2.LT.24) THEN
        IF(NAA1.LT.21.AND.NAA2.LT.21) THEN
          NN  = NN+1
          WNN = WNN + WEIGHT_1(N)*WEIGHT_2(K)
          IF(NAA1.EQ.NAA2)THEN
            NHOM = NHOM + 1
          ENDIF
C         S = AMAT(NAA1,NAA2)
          S = AMATRIX(N,K)

c          S = AMAT(NAA1,NAA2)

          SCORE1(N) = S
          SCORE2(K) = S
          SUM_SCORE = SUM_SCORE + S
          T = S - DPENI
          IF(T.GT.0) THEN
            SUM_F = SUM_F + T
          ENDIF 
          S1 = ASEQ1(N)
          S2 = ASEQ2(K)
          S  = (S1+S2)/2.0
          SCORE1_MAX = SCORE1_MAX + S
          T = S - DPENI
          IF(T.GT.0) THEN
            SUM_F_MAX = SUM_F_MAX + T
          ENDIF 
        ENDIF
      ENDDO
C ----
      HOM = 0.0    
      IF(NN.GT.0) THEN
        IF(IVAR.EQ.0) THEN
          SUM_SCORE  = SUM_SCORE/REAL(NN)
          SCORE1_MAX = SCORE1_MAX/REAL(NN)
          SUM_F      = SUM_F/REAL(NN)
          SUM_F_MAX  = SUM_F_MAX/REAL(NN)
        ELSE
          SUM_SCORE  = SUM_SCORE/WNN
          SCORE1_MAX = SCORE1_MAX/WNN
          SUM_F      = SUM_F/WNN
          SUM_F_MAX  = SUM_F_MAX/WNN
        ENDIF
        HOM        = (REAL(NHOM)/REAL(NN))*100.0
        FIDENT_NEW = (SUM_F/SUM_F_MAX)*100.0
      ENDIF

      CALL DEF_SCORE_MIN_3(NN,NPAIR,NC,KC
     *  ,NSEQ1,NSEQ2,IPAIR,AMAT,AMATRIX
     *  ,NMAX1,NMAX2,NMAX12
     *  ,WEIGHT_1,WEIGHT_2
     *  ,SCORE_MIN,SCORE_SIGMA,IVAR)

      IF(SUM_SCORE.LT.SCORE_MIN) SCORE_MIN = SUM_SCORE 
C ---
      RETURN
      END

      SUBROUTINE DEF_SCORE_MIN_3(NN,NPAIR,NC,KC
     *  ,NSEQ1,NSEQ2,IPAIR,AMAT,AMATRIX
     *  ,NMAX1,NMAX2,NMAX12
     *  ,WEIGHT_1,WEIGHT_2
     *  ,SCORE_MIN,SCORE_SIGMA,IVAR)
C -------------------------------
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      WEIGHT_1(*),WEIGHT_2(*)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      integer,   allocatable :: ICOPY(:)
C -------------------------------

      allocate(ICOPY(1:NMAX12),STAT=ISTAT)

      SCORE_MIN   = 0.0
      SCORE_SIGMA = 0.0
      IF(NN.LE.0) GO TO 900
      NCYCLE    = 15
      S  = 0.0
      S2 = 0.0
      NH = 0
      INIT = 0
C      S_MIN = 0.0
      NP    = 0
      WNP   = 0.0

      DO IC=1,NCYCLE
C        S_MIN = 0.0
C        NP    = 0
        DO I=1,NPAIR 
          ICOPY(I) = IPAIR(2,I) 
        ENDDO
c       N2 = NPAIR           
        N2 = NN
        DO I=1,NPAIR             
          N = IPAIR(1,I)
          NAA1 = NSEQ1(N)
c         IF(NAA1.LT.24) THEN
          IF(NAA1.LT.21) THEN
            III = 0
  100       CONTINUE
c           CALL HSRD(A)
            CALL HSRD_TIME(A,NH,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            III = III + 1
            IF(III.GT.100) GO TO 200
            A = A + 0.5
            AK = A*REAL(NPAIR) + 1.0         
            K  = AK
            IF(K.LT. 1) K = 1
            IF(K.GT.NPAIR) K = NPAIR
            KK = ICOPY(K)
            NAA2 = NSEQ2(KK)
c           IF(NAA2.GE.24) GO TO 100
            IF(NAA2.GE.21) GO TO 100
CC           S_MIN = S_MIN + AMAT(NAA1,NAA2)
C            S_MIN = S_MIN + AMATRIX(N,KK)
            S_MIN = AMATRIX(N,KK)

c            S_MIN = AMAT(NAA1,NAA2)

            S  = S +  S_MIN
            S2 = S2 + S_MIN*S_MIN
            NP = NP + 1
            WNP = WNP + WEIGHT_1(N)*WEIGHT_2(KK)
            IF(K.LT.N2) THEN
              DO J=K,N2-1
                ICOPY(J) = ICOPY(J+1)
              ENDDO
            ENDIF
            N2 = N2 - 1
            IF(N2.LE.0) GO TO 300
  200       CONTINUE
          ENDIF
        ENDDO
  300   CONTINUE
C        IF(NP.GT.0) THEN
C          S_MIN = S_MIN/REAL(NP)
C        ENDIF
C        S  = S +  S_MIN
C        S2 = S2 + S_MIN*S_MIN
      ENDDO

      NH = 0
      INIT = 0

      DO IC=1,NCYCLE
C        S_MIN = 0.0
C        NP    = 0
        DO I=1,NPAIR 
          ICOPY(I) = IPAIR(1,I) 
        ENDDO
c       N2 = NPAIR  
        N2 = NN         
        DO I=1,NPAIR             
          N = IPAIR(2,I)
          NAA2 = NSEQ2(N)
c          IF(NAA2.LT.24) THEN
          IF(NAA2.LT.21) THEN
            III = 0
  110       CONTINUE
c           CALL HSRD(A)
            CALL HSRD_TIME(A,NH,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            III = III + 1
            IF(III.GT.100) GO TO 210
            A = A + 0.5
            AK = A*REAL(NPAIR) + 1.0         
            K  = AK
            IF(K.LT. 1) K = 1
            IF(K.GT.NPAIR) K = NPAIR
            KK = ICOPY(K)
            NAA1 = NSEQ1(KK)
c           IF(NAA1.GE.24) GO TO 110
            IF(NAA1.GE.21) GO TO 110
CC           S_MIN = S_MIN + AMAT(NAA1,NAA2)
C            S_MIN = S_MIN + AMATRIX(N,KK)
            S_MIN = AMATRIX(KK,N)

c            S_MIN = AMAT(NAA1,NAA2)

            S  = S +  S_MIN
            S2 = S2 + S_MIN*S_MIN
            NP = NP + 1
            WNP = WNP + WEIGHT_1(KK)*WEIGHT_2(N)
            IF(K.LT.N2) THEN
              DO J=K,N2-1
                ICOPY(J) = ICOPY(J+1)
              ENDDO
            ENDIF
            N2 = N2 - 1
            IF(N2.LE.0) GO TO 310
  210       CONTINUE
          ENDIF
        ENDDO
  310   CONTINUE
C        IF(NP.GT.0) THEN
C          S_MIN = S_MIN/REAL(NP)
C        ENDIF
C        S  = S +  S_MIN
C        S2 = S2 + S_MIN*S_MIN
      ENDDO

      IF(NP.GT.0) THEN
        IF(IVAR.EQ.0) THEN
          S  = S/REAL(NP)
          S2 = S2/REAL(NP)
        ELSE
          S  = S/WNP
          S2 = S2/WNP
        ENDIF
      ENDIF
      SCORE_SIGMA = SQRT(ABS(S2-S*S))
      SCORE_MIN   = S

  900 CONTINUE

      deallocate(ICOPY,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE ALIGN_NW4(MDOC,AMATRIX,SS_FLAG,ADOM
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1,ADOM*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      REAL      AMAX_K(NMAX1)
      INTEGER   KK_MAX(NMAX1)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)

      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo

      IF(ABS(PENEXI).LT.0.001) THEN
        OPENI = 0.001

        DO I=1,NC
          KK_MAX(I) = 0
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 300  
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          GO TO 300
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = 0
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 400  
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            GO TO 400
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                AMAX_N = -2000.0
                DO NN=N1+1,NC
                  IF(NSEQ1(NN).LT.24) THEN
                    PEN = OPENI_N 
                    A = AMATRIX(NN,K1) - PEN
                    IF(NN_MAX.GT.0) THEN
                      IF(A.GT.AMAX_N) THEN
                        AMAX_N = A
                        NN_MAX = NN
                      ENDIF        
                    ELSE
                      AMAX_N  = A
                      NN_MAX  = NN
                    ENDIF
c                    GO TO 320
                  ENDIF
                ENDDO
  320           CONTINUE
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,KC
                  IF(NSEQ2(KK).LT.24) THEN
                    PEN = OPENI_K 
                    A = AMATRIX(N1,KK) - PEN
                    IF(KK_MAX(N1).GT.0) THEN
                      IF(A.GT.AMAX_K(N1)) THEN
                        AMAX_K(N1) = A
                        KK_MAX(N1) = KK
                      ENDIF        
                    ELSE
                      AMAX_K(N1) = A
                      KK_MAX(N1) = KK
                    ENDIF
c                    GO TO 330 
                  ENDIF
                ENDDO
  330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

  400       CONTINUE
          ENDDO

  300     CONTINUE
        ENDDO

      ELSE

        DO I=1,NC
          KK_MAX(I) = KC
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 1300  
          K1 = K + 1
          NEXTN_K = 0
          DO L=K1,KC
C           IF(NSEQ2(L).EQ.25) NEXTN_K = 1
            IF(NSEQ2(L).EQ.24) NEXTN_K = 1
            IF(NSEQ2(L).LT.24) GO TO 1310            
          ENDDO
          GO TO 1300
 1310     CONTINUE
          NOPEN_K = 1

          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = NC
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 1400  
            N1 = N + 1
            NEXTN_N = 0
            DO L=N1,NC
C                          =
C             IF(NSEQ1(L).EQ.25) NEXTN_N = 1
              IF(NSEQ1(L).EQ.24) NEXTN_N = 1
              IF(NSEQ1(L).LT.24) GO TO 1410            
            ENDDO
            GO TO 1400
 1410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            PENEXI_N = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
c              PENEXI_N = 0.0
              IF(NEXTN_K.GT.0) PENEXI_N = 0.0
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                IDN    = 0
                AMAX_N = -2000.0
                N_MAX  = NN_MAX
                DO NN=N1+1,N_MAX
                  IF(NSEQ1(NN).LT.24) THEN
                    IDN = IDN + 1
                    PEN = OPENI_N + REAL(IDN)*PENEXI_N
                    A   = AMATRIX(NN,K1) - PEN
                    IF(A.GT.AMAX_N) THEN
                      AMAX_N    = A
                      NN_MAX    = NN
                    ENDIF        
                  ENDIF
                ENDDO
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            PENEXI_K = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IF(NEXTN_N.GT.0) PENEXI_K = 0.0
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                IDK   = 0
                K_MAX      = KK_MAX(N1)
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,K_MAX
                  IF(NSEQ2(KK).LT.24) THEN
                    IDK  = IDK + 1
                    PEN = OPENI_K + REAL(IDK)*PENEXI_K
                    A   = AMATRIX(N1,KK) - PEN
                    IF(A.GT.AMAX_K(N1)) THEN
                      AMAX_K(N1)    = A
                      KK_MAX(N1)    = KK
                    ENDIF        
                  ENDIF
                ENDDO
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

 1400       CONTINUE
          ENDDO

 1300     CONTINUE
        ENDDO

      ENDIF
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      NPAIR = NPAIR + 1
      IPAIR(1,NPAIR) = NT
      IPAIR(2,NPAIR) = KT
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE
C ----
      RETURN
      END

      SUBROUTINE ALIGN_NW4_D(MDOC,AMATRIX,SS_FLAG,ADOM
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1,ADOM*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      REAL      AMAX_K(NMAX1)
      INTEGER   KK_MAX(NMAX1)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)
C ================================================================
c      go to 500
      KCBY6 = KC/6
      IF(KCBY6.LE.0) KCBY6 = 1
      ID1 = KCBY6
      DO K=1,KC
        IF(ISS2(K).NE.0) THEN
          ID1 = K-1
          GO TO 510
        ENDIF
      ENDDO
  510 CONTINUE
      ID1 = ID1 + 8
      
      IF(ID1.GT.KCBY6) ID1 = KCBY6

      ID2 = KCBY6
      DO K=1,KC
        KK = KC - K + 1
        IF(ISS2(KK).NE.0) THEN
          ID2 = K-1
          GO TO 520
        ENDIF
      ENDDO
  520 CONTINUE
      ID2 = ID2 + 8
      IF(ID2.GT.KCBY6) ID2 = KCBY6

      ID1 = KCBY6
      ID2 = KCBY6

      NKD1 = KC - ID1
      NKD2 = KC - ID2

      IF(NC.GT.NKD1) THEN 
        NKD = KC - ID1
        DO I=1,NKD
          N = NKD - I + 1
          DO J=1,N
            JJ = KC -J + 1
            AMATRIX(I,JJ)  = 0.0
          ENDDO
        ENDDO
      ENDIF
      IF(NC.GT.NKD2) THEN 
        NKD = KC - ID2
        DO I=1,NKD
          N = NKD - I + 1
          DO J=1,N
            II = NC -I + 1
            AMATRIX(II,J)  = 0.0
          ENDDO
        ENDDO
      ENDIF
  500 CONTINUE
c ---
      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo

      IF(ABS(PENEXI).LT.0.001) THEN
        OPENI = 0.001

        DO I=1,NC
          KK_MAX(I) = 0
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 300  
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          GO TO 300
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = 0
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 400  
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            GO TO 400
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                AMAX_N = -2000.0
                DO NN=N1+1,NC
                  IF(NSEQ1(NN).LT.24) THEN
                    PEN = OPENI_N 
                    A = AMATRIX(NN,K1) - PEN
                    IF(NN_MAX.GT.0) THEN
                      IF(A.GT.AMAX_N) THEN
                        AMAX_N = A
                        NN_MAX = NN
                      ENDIF        
                    ELSE
                      AMAX_N  = A
                      NN_MAX  = NN
                    ENDIF
c                    GO TO 320
                  ENDIF
                ENDDO
  320           CONTINUE
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,KC
                  IF(NSEQ2(KK).LT.24) THEN
                    PEN = OPENI_K 
                    A = AMATRIX(N1,KK) - PEN
                    IF(KK_MAX(N1).GT.0) THEN
                      IF(A.GT.AMAX_K(N1)) THEN
                        AMAX_K(N1) = A
                        KK_MAX(N1) = KK
                      ENDIF        
                    ELSE
                      AMAX_K(N1) = A
                      KK_MAX(N1) = KK
                    ENDIF
c                    GO TO 330 
                  ENDIF
                ENDDO
  330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

  400       CONTINUE
          ENDDO

  300     CONTINUE
        ENDDO

      ELSE

        DO I=1,NC
          KK_MAX(I) = KC
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 1300  
          K1 = K + 1
          NEXTN_K = 0
          DO L=K1,KC
c           IF(NSEQ2(L).EQ.25.AND.ADOM.EQ.'D') NEXTN_K = 1
            IF(NSEQ2(L).EQ.24) NEXTN_K = 1
            IF(NSEQ2(L).LT.24) GO TO 1310            
          ENDDO
          GO TO 1300
 1310     CONTINUE
          NOPEN_K = 1

          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = NC
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 1400  
            N1 = N + 1
            NEXTN_N = 0
            DO L=N1,NC
C                          =
c             IF(NSEQ1(L).EQ.25.AND.ADOM.EQ.'D') NEXTN_N = 1
              IF(NSEQ1(L).EQ.24) NEXTN_N = 1
              IF(NSEQ1(L).LT.24) GO TO 1410            
            ENDDO
            GO TO 1400
 1410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            PENEXI_N = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
c              PENEXI_N = 0.0
              IF(NEXTN_K.GT.0) PENEXI_N = 0.0
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                IDN    = 0
                AMAX_N = -2000.0
                N_MAX  = NN_MAX
                DO NN=N1+1,N_MAX
                  IF(NSEQ1(NN).LT.24) THEN
                    IDN = IDN + 1
                    PEN = OPENI_N + REAL(IDN)*PENEXI_N
                    A   = AMATRIX(NN,K1) - PEN
                    IF(A.GT.AMAX_N) THEN
                      AMAX_N    = A
                      NN_MAX    = NN
                    ENDIF        
                  ENDIF
                ENDDO
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            PENEXI_K = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IF(NEXTN_N.GT.0) PENEXI_K = 0.0
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                IDK   = 0
                K_MAX      = KK_MAX(N1)
                AMAX_K(N1) = -2000.0
C///
                KZERO = 0
                NZERO = 1
                IF(ISS2(K).NE.0) KZERO = 1
                IF(ISS2(K).NE.0) NZERO = 0
                KZEROP = KZERO
C///

                DO KK=K1+1,K_MAX
                  IF(NSEQ2(KK).LT.24) THEN
C///
                    KZERO = 0
                    IF(ISS2(KK).NE.0) KZERO = 1
                    IF(KZERO.NE.KZEROP) NZERO = NZERO + 1  
                    IF(NZERO.GE.3) GO TO 1330   
C///

                    IDK  = IDK + 1
                    PEN = OPENI_K + REAL(IDK)*PENEXI_K
                    A   = AMATRIX(N1,KK) - PEN
                    IF(A.GT.AMAX_K(N1)) THEN
                      AMAX_K(N1)    = A
                      KK_MAX(N1)    = KK
                    ENDIF  
      
C///
                    KZEROP = KZERO
C///
                  ENDIF
                ENDDO
 1330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

 1400       CONTINUE
          ENDDO

 1300     CONTINUE
        ENDDO

      ENDIF
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      NPAIR = NPAIR + 1
      IPAIR(1,NPAIR) = NT
      IPAIR(2,NPAIR) = KT
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE
C ----
      RETURN
      END

      SUBROUTINE ALIGN_NW4_DDD(MDOC,AMATRIX,SS_FLAG,ADOM
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1,ADOM*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      REAL      AMAX_K(NMAX1)
      INTEGER   KK_MAX(NMAX1)
C ================================================================
      go to 500
      NCBY6 = NC/6
      IF(NCBY6.LE.0) NCBY6 = 1
      ID1 = 0       
      DO N=1,NC
        IF(ISS1(N).NE.0) THEN
          ID1 = N-1
          GO TO 510
        ENDIF
      ENDDO
  510 CONTINUE
      IF(ID1.EQ.0) THEN
        ID2 = 0
        GO TO 530
      ENDIF      
      IF(ID1.EQ.0) ID1 = NCBY6
      ID1 = ID1 + 3
      IF(ID1.GT.NCBY6) ID1 = NCBY6

      ID2 = NCBY6
      DO N=1,NC
        NN = NC - N + 1
        IF(ISS1(NN).NE.0) THEN
          ID2 = N-1
          GO TO 520
        ENDIF
      ENDDO
  520 CONTINUE
      ID2 = ID2 + 3
      IF(ID2.GT.NCBY6) ID2 = NCBY6

  530 CONTINUE
      NND = NC - ID1 - ID2

      KCBY6 = KC/6
      IF(KCBY6.LE.0) KCBY6 = 1
      ID1 = KCBY6
      DO K=1,KC
        IF(ISS2(K).NE.0) THEN
          ID1 = K-1
          GO TO 610
        ENDIF
      ENDDO
  610 CONTINUE
      ID1 = ID1 + 3
      IF(ID1.GT.KCBY6) ID1 = KCBY6

      ID2 = KCBY6
      DO K=1,KC
        KK = KC - K + 1
        IF(ISS2(KK).NE.0) THEN
          ID2 = K-1
          GO TO 620
        ENDIF
      ENDDO
  620 CONTINUE
      ID2 = ID2 + 3
      IF(ID2.GT.KCBY6) ID2 = KCBY6

      NKD = KC - ID1 -  ID2

  500 CONTINUE

c      IF(NKD.GT.NND) THEN 
      IF(KC.GT.NC) THEN 
        CALL ALIGN_NW4_DD(MDOC,AMATRIX,SS_FLAG,ADOM
     *    ,OPENI,PENEXI,DPENII
     *    ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *    ,AMAX_K,KK_MAX
     *    ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
      ELSE
        CALL ALIGN_NW4_D(MDOC,AMATRIX,SS_FLAG,ADOM
     *    ,OPENI,PENEXI,DPENII
     *    ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *    ,AMAX_K,KK_MAX
     *    ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
      ENDIF

      RETURN
      END

      SUBROUTINE ALIGN_NW4_DD(MDOC,AMATRIX,SS_FLAG,ADOM
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,AMAX_K,KK_MAX
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1,ADOM*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
      REAL      AMAX_K(NMAX1)
      INTEGER   KK_MAX(NMAX1)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)
C ================================================================
c     go to 500
      NCBY6 = NC/6
      IF(NCBY6.LE.0) NCBY6 = 1
      ID1 = NCBY6
      DO N=1,NC
        IF(ISS1(N).NE.0) THEN
          ID1 = N-1
          GO TO 510
        ENDIF
      ENDDO
  510 CONTINUE
      ID1 = ID1 + 3
      IF(ID1.GT.NCBY6) ID1 = NCBY6

      ID2 = NCBY6
      DO N=1,NC
        NN = NC - N + 1
        IF(ISS1(NN).NE.0) THEN
          ID2 = N-1
          GO TO 520
        ENDIF
      ENDDO
  520 CONTINUE
      ID2 = ID2 + 3
      IF(ID2.GT.NCBY6) ID2 = NCBY6

      ID1 = NCBY6
      ID2 = NCBY6

      NND1 = NC - ID1
      NND2 = NC - ID2
      IF(KC.GT.NND1) THEN 
        NND = NC - ID1
        DO J=1,NND
          N = NND - J + 1
          DO I=1,N
            II = NC -I + 1
            AMATRIX(II,J)  = 0.0
          ENDDO
        ENDDO
      ENDIF
      IF(KC.GT.NND2) THEN 
        NND = NC - ID2
        DO J=1,NND
          N = NND - J + 1
          DO I=1,N
            JJ = KC - I + 1
            AMATRIX(I,JJ)  = 0.0
          ENDDO
        ENDDO
      ENDIF
  500 CONTINUE
c ---
      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo

      IF(ABS(PENEXI).LT.0.001) THEN
        OPENI = 0.001

        DO I=1,NC
          KK_MAX(I) = 0
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 300  
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          GO TO 300
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = 0
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 400  
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            GO TO 400
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                AMAX_N = -2000.0
                DO NN=N1+1,NC
                  IF(NSEQ1(NN).LT.24) THEN
                    PEN = OPENI_N 
                    A = AMATRIX(NN,K1) - PEN
                    IF(NN_MAX.GT.0) THEN
                      IF(A.GT.AMAX_N) THEN
                        AMAX_N = A
                        NN_MAX = NN
                      ENDIF        
                    ELSE
                      AMAX_N  = A
                      NN_MAX  = NN
                    ENDIF
c                    GO TO 320
                  ENDIF
                ENDDO
  320           CONTINUE
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                AMAX_K(N1) = -2000.0
                DO KK=K1+1,KC
                  IF(NSEQ2(KK).LT.24) THEN
                    PEN = OPENI_K 
                    A = AMATRIX(N1,KK) - PEN
                    IF(KK_MAX(N1).GT.0) THEN
                      IF(A.GT.AMAX_K(N1)) THEN
                        AMAX_K(N1) = A
                        KK_MAX(N1) = KK
                      ENDIF        
                    ELSE
                      AMAX_K(N1) = A
                      KK_MAX(N1) = KK
                    ENDIF
c                    GO TO 330 
                  ENDIF
                ENDDO
  330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

  400       CONTINUE
          ENDDO

  300     CONTINUE
        ENDDO

      ELSE

        DO I=1,NC
          KK_MAX(I) = KC
        ENDDO

        DO K=KC-1,1,-1

          IF(NSEQ2(K).GE.24) GO TO 1300  
          K1 = K + 1
          NEXTN_K = 0
          DO L=K1,KC
c           IF(NSEQ2(L).EQ.25.AND.ADOM.EQ.'D') NEXTN_K = 1
            IF(NSEQ2(L).EQ.24) NEXTN_K = 1
            IF(NSEQ2(L).LT.24) GO TO 1310            
          ENDDO
          GO TO 1300
 1310     CONTINUE
          NOPEN_K = 1

          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L

          NN_MAX = NC
          DO N=NC-1,1,-1

            IF(NSEQ1(N).GE.24) GO TO 1400  
            N1 = N + 1
            NEXTN_N = 0
            DO L=N1,NC
C                          =
c             IF(NSEQ1(L).EQ.25.AND.ADOM.EQ.'D') NEXTN_N = 1
              IF(NSEQ1(L).EQ.24) NEXTN_N = 1
              IF(NSEQ1(L).LT.24) GO TO 1410            
            ENDDO
            GO TO 1400
 1410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L

            AMAX = AMATRIX(N1,K1)
            NT   = N1
            KT   = K1

            OPENI_N  = OPENI 
            PENEXI_N = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *          ISS2(K).EQ.ISS2(K1))) IUSE = 0
            IF(NOPEN_K.GT.0) THEN
              OPENI_N  = 0.0 
c              PENEXI_N = 0.0
              IF(NEXTN_K.GT.0) PENEXI_N = 0.0
              IUSE = 1
            ENDIF
            IF(IUSE.GT.0) THEN  
              IF(N1.LT.NC) THEN
                IDN    = 0
                AMAX_N = -2000.0
                N_MAX  = NN_MAX

C///
                KZERO_N = 0
                NZERO_N = 1
                IF(ISS1(N).NE.0) KZERO_N = 1
                IF(ISS1(N).NE.0) NZERO_N = 0
                KZEROP_N = KZERO_N
C///


                DO NN=N1+1,N_MAX
                  IF(NSEQ1(NN).LT.24) THEN

C///
                    KZERO_N = 0
                    IF(ISS1(NN).NE.0) KZERO_N = 1
                    IF(KZERO_N.NE.KZEROP_N) NZERO_N = NZERO_N + 1  
                    IF(NZERO_N.GE.3) GO TO 1340   
C///

                    IDN = IDN + 1
                    PEN = OPENI_N + REAL(IDN)*PENEXI_N
                    A   = AMATRIX(NN,K1) - PEN
                    IF(A.GT.AMAX_N) THEN
                      AMAX_N    = A
                      NN_MAX    = NN
                    ENDIF        
C///
                    KZEROP_N = KZERO_N
C///
                  ENDIF
                ENDDO
 1340           CONTINUE
                IF(AMAX_N.GT.AMAX) THEN
                  AMAX = AMAX_N
                  NT   = NN_MAX
                  KT   = K1
                ENDIF

              ENDIF
            ENDIF

            OPENI_K  = OPENI 
            PENEXI_K = PENEXI
            IUSE = 1
            IF((SS_FLAG.EQ.'Y').AND.
     *         (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *          ISS1(N).EQ.ISS1(N1))) IUSE = 0
            IF(NOPEN_N.GT.0) THEN
              OPENI_K  = 0.0 
              IF(NEXTN_N.GT.0) PENEXI_K = 0.0
              IUSE = 1
            ENDIF

            IF(IUSE.GT.0) THEN  
              IF(K1.LT.KC) THEN
                IDK   = 0
                K_MAX      = KK_MAX(N1)
                AMAX_K(N1) = -2000.0
C///
C                KZERO = 0
C                NZERO = 1
C                IF(ISS2(K).NE.0) KZERO = 1
C                IF(ISS2(K).NE.0) NZERO = 0
C                KZEROP = KZERO
C///

                DO KK=K1+1,K_MAX
                  IF(NSEQ2(KK).LT.24) THEN
C///
C                    KZERO = 0
C                    IF(ISS2(KK).NE.0) KZERO = 1
C                    IF(KZERO.NE.KZEROP) NZERO = NZERO + 1  
C                    IF(NZERO.GE.3) GO TO 1330   
C///

                    IDK  = IDK + 1
                    PEN = OPENI_K + REAL(IDK)*PENEXI_K
                    A   = AMATRIX(N1,KK) - PEN
                    IF(A.GT.AMAX_K(N1)) THEN
                      AMAX_K(N1)    = A
                      KK_MAX(N1)    = KK
                    ENDIF  
      
C///
C                    KZEROP = KZERO
C///
                  ENDIF
                ENDDO
 1330           CONTINUE
                IF(AMAX_K(N1).GT.AMAX) THEN
                  NT   = N1
                  AMAX = AMAX_K(N1)
                  KT   = KK_MAX(N1)
                ENDIF
              ENDIF
            ENDIF

            AMATRIX(N,K)  = AMATRIX(N,K) + AMAX
            ITRACE(1,N,K) = NT
            ITRACE(2,N,K) = KT
            IF(AMATRIX(N,K).GT.AM_MAX) THEN
              AM_MAX = AMATRIX(N,K)
              NMAX = N
              KMAX = K
              NP = NP + 1
            ENDIF

 1400       CONTINUE
          ENDDO

 1300     CONTINUE
        ENDDO

      ENDIF
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      NPAIR = NPAIR + 1
      IPAIR(1,NPAIR) = NT
      IPAIR(2,NPAIR) = KT
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE
C ----
      RETURN
      END

      SUBROUTINE ALIGN_SW4(MDOC,AMATRIX,AMATRIX_S,SS_FLAG
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMATRIX_S(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)
      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo


      DO K=KC,1,-1

        IF(NSEQ2(K).GE.24) GO TO 300  
        IF(K.LT.KC) THEN
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          L  = 0
          K1 = 0
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L
        ELSE
          K1 = 0
          NOPEN_K = 0
        ENDIF

        DO N=NC,1,-1

          IF(NSEQ1(N).GE.24) GO TO 400  
          IF(N.LT.NC) THEN
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            L  = 0
            N1 = 0
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L
          ELSE
            N1 = 0
            NOPEN_N = 0
          ENDIF

          AMAX = 0.0
          NT   = 0
          KT   = 0 

          IF(N1.GT.0.AND.K1.GT.0) THEN
            A = AMATRIX(N,K) - DPENI + AMATRIX(N1,K1)
            IF(A.GT.AMAX) THEN
              AMAX = A
              NT   = N1
              KT   = K1
            ENDIF
          ENDIF

          IF(N1.GT.0) THEN
            ID = 0
            DO NN=N1,NC
              IF(NSEQ1(NN).LT.24) THEN
                ID  = ID + 1
                PEN = OPENI + REAL(ID)*PENEXI
                IUSE = 1
                IF((SS_FLAG.EQ.'Y').AND.
     *             (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *              ISS2(K).EQ.ISS2(K1))) IUSE = 0
                IF(NOPEN_K.GT.0) THEN
                  PEN  = 0.0
                  IUSE = 1
                ENDIF
                IF(IUSE.GT.0) THEN  
                  A = AMATRIX(NN,K) - PEN 
                  IF(A.GT.AMAX) THEN
                    AMAX = A
                    NT   = NN
                    KT   = K
                  ENDIF
                ENDIF
              ENDIF
            ENDDO
          ENDIF

          IF(K1.GT.0) THEN
            ID = 0
            DO KK=K1,KC
              IF(NSEQ2(KK).LT.24) THEN
                ID  = ID + 1
                PEN = OPENI + REAL(ID)*PENEXI
                IUSE = 1
                IF((SS_FLAG.EQ.'Y').AND.
     *             (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *              ISS1(N).EQ.ISS1(N1))) IUSE = 0
                IF(NOPEN_N.GT.0) THEN
                  PEN  = 0.0
                  IUSE = 1
                ENDIF
                IF(IUSE.GT.0) THEN  
                  A = AMATRIX(N,KK) - PEN 
                  IF(A.GT.AMAX) THEN
                    AMAX = A
                    NT   = N
                    KT   = KK
                  ENDIF
                ENDIF
              ENDIF
            ENDDO
          ENDIF

          AMATRIX(N,K)  = AMAX
          ITRACE(1,N,K) = NT
          ITRACE(2,N,K) = KT
          IF(AMATRIX(N,K).GT.AM_MAX) THEN
            AM_MAX = AMATRIX(N,K)
            NMAX = N
            KMAX = K
            NP = NP + 1
          ENDIF

  400     CONTINUE
        ENDDO

  300   CONTINUE
      ENDDO
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      IF(NT.EQ.IPAIR(1,NPAIR)) THEN
C        IPAIR(2,NPAIR) = KT
      ELSE IF(KT.EQ.IPAIR(2,NPAIR)) THEN
C        IPAIR(1,NPAIR) = NT
      ELSE  
        NPAIR = NPAIR + 1
        IPAIR(1,NPAIR) = NT
        IPAIR(2,NPAIR) = KT
      ENDIF
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE

      do i=1,npair
        AMATRIX_S(IPAIR(1,i),IPAIR(2,i)) = 2.0
      enddo
C ----
      RETURN
      END

      SUBROUTINE ALIGN_WRITE_2SEQ_TO_PROFILE(MDOC,NAMEO
     *  ,CODE
     *  ,NC,KC,NSEQ1,NSEQ2,PNUM1,PNUM2
     *  ,IDOMAIN1,IDOMAIN2,ISS1,ISS2
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAMEO*(*)
      CHARACTER CODE*8
      CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6,PNUM*6
C -----
      INTEGER   ISS1(*),ISS2(*)
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
C ---
      INTEGER   IPROFILE(20)
      CHARACTER LINE*256,PATH*1,EXT*1,SS*1
      CHARACTER LINE1*256,LINE2*256,STR*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_ALL(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
C -------------------------------------
      LINE = 'Profile: '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      NSEQ = 2
      WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
      LINE(1:1) = '#'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
c--------------------------------------
      NAA   = 0
      ICURR = 0
      JCURR = 0
      DO IPR=1,NPAIR
        ICURR = ICURR + 1
        JCURR = JCURR + 1
        I = IPAIR(1,IPR) 
        J = IPAIR(2,IPR)
        IF(I.GT.ICURR) THEN
          DO IC=ICURR,I-1
            IN1 = NSEQ1(IC)
            DO IPRF=1,20
              IPROFILE(IPRF) = 0
            ENDDO
            IR  = 0
            PNUM = PNUM1(IC)
            IDOM = IDOMAIN1(IC)
            IRR = 0
            IF(IN1.GT.0.AND.IN1.LE.20) THEN
              IPROFILE(IN1) = 1
              NAA = NAA + 1
            ELSE
              PNUM = '      '
            ENDIF
            IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN

              ISS = ISS1(IC)
              IF(ISS.EQ.1) THEN
                SS = 'H'
              ELSE IF(ISS.EQ.2) THEN
                SS = 'h'
              ELSE IF(ISS.EQ.3) THEN
                SS = 'B'
              ELSE IF(ISS.EQ.4) THEN
                SS = 'b'
              ELSE
                SS = ' '
              ENDIF
              
              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

              WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C              WRITE(STR,'(A,A,A,A)') 
C     *        ' # ',PNUM(2:6),'  ',AMIN(IN1)

              CALL LENSTR_BL(STR,LS)
              CALL LENSTR_BL(LINE,LEN)
              LINE = LINE(1:LEN)//STR(1:LS)         
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        IF(J.GT.JCURR) THEN
          DO JC=JCURR,J-1
            IN2 = NSEQ2(JC)
            DO IPRF=1,20
              IPROFILE(IPRF) = 0
            ENDDO
            IR  = 0
            IRR = 0
            PNUM = '      '
            IF(IN2.GT.0.AND.IN2.LE.20) THEN
C              IPROFILE(IN2) = 1
C              NAA = NAA + 1
C              IR  = NAA
            ENDIF
            IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *          IN2.EQ.24.OR.IN2.EQ.25     ) THEN
 
C             WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C              WRITE(STR,'(A,A,A,A)') 
C     *        ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
C              CALL LENSTR_BL(STR,LS)
C              CALL LENSTR_BL(LINE,LEN)
C              LINE = LINE(1:LEN)//STR(1:LS)         
C              CALL LENSTR_BL(LINE,LEN)
C              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        ICURR = I
        JCURR = J
        IN1 = NSEQ1(ICURR)
        IN2 = NSEQ2(JCURR)
        DO IPRF=1,20
          IPROFILE(IPRF) = 0
        ENDDO
        PNUM = PNUM1(ICURR)
        IDOM = IDOMAIN1(ICURR)
 
        IF(IN2.GT.0.AND.IN2.LE.20) THEN
          IPROFILE(IN2) = IPROFILE(IN2) + 1
        ENDIF
 
       IF(IN1.GT.0.AND.IN1.LE.20) THEN
          IPROFILE(IN1) = IPROFILE(IN1) + 1
          NAA = NAA + 1
        ELSE
          PNUM = '      '
        ENDIF

        IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *      IN1.EQ.24.OR.IN1.EQ.25     ) THEN

          ISS = ISS1(ICURR)
          IF(ISS.EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS.EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS.EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS.EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

          WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C          WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(INN)


          CALL LENSTR_BL(STR,LS)
          CALL LENSTR_BL(LINE,LEN)
          LINE = LINE(1:LEN)//STR(1:LS)         
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
        ENDIF
      ENDDO
      ICURR = ICURR + 1
      JCURR = JCURR + 1
      IF(NC.GE.ICURR) THEN
        DO IC=ICURR,NC
          IN1 = NSEQ1(IC)
          DO IPRF=1,20
            IPROFILE(IPRF) = 0
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = PNUM1(IC)
          IDOM = IDOMAIN1(IC)
          IF(IN1.GT.0.AND.IN1.LE.20) THEN
            IPROFILE(IN1) = 1
            NAA = NAA + 1
            IR  = NAA
          ELSE
            PNUM = '      '
          ENDIF
          IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *        IN1.EQ.24.OR.IN1.EQ.25) THEN

            ISS = ISS1(IC)
            IF(ISS.EQ.1) THEN
              SS = 'H'
            ELSE IF(ISS.EQ.2) THEN
              SS = 'h'
            ELSE IF(ISS.EQ.3) THEN
              SS = 'B'
            ELSE IF(ISS.EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF

            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

            WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

            CALL LENSTR_BL(STR,LS)
            CALL LENSTR_BL(LINE,LEN)
            LINE = LINE(1:LEN)//STR(1:LS)         
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
      IF(KC.GT.JCURR) THEN
        DO JC=JCURR,KC
          IN2 = NSEQ2(JC)
          DO IPRF=1,20
            IPROFILE(IPRF) = 0
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = '      '
          IF(IN2.GT.0.AND.IN2.LE.20) THEN
            IPROFILE(IN2) = 1
C            NAA = NAA + 1
C            IR = NAA
          ENDIF
          IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *        IN2.EQ.24.OR.IN2.EQ.25) THEN
C            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
C            WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C            CALL LENSTR_BL(STR,LS)
C            CALL LENSTR_BL(LINE,LEN)
C            LINE = LINE(1:LEN)//STR(1:LS)         
C            CALL LENSTR_BL(LINE,LEN)
C            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
C -------------------------------------
      END FILE IOUT
      CLOSE(IOUT)

      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of amino acids in sequence = 0')
        IERR = 1
      ENDIF
      WRITE(LINE,'(A,I6)') ' Number of sequences in profile  :',NSEQ
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') ' Number of amino acids in profile:',NAA
      CALL MSGDOC(MDOC,LINE)

      RETURN
C ----
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write output file')
      IERR = 1
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE ALIGN_WRITE_PROF_SEQ_TO_PROFILE(MDOC,NAMEO
     *  ,CODE
     *  ,NC,NSEQ_PROFILE1,IPROFILE1,KC
     *  ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *  ,IDOMAIN1,IDOMAIN2,ISS1,ISS2
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAMEO*(*)
      INTEGER   ISS1(*),ISS2(*)
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
      CHARACTER CODE*8
      CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6,PNUM*6
C -----
      INTEGER   IPROFILE1(NMAX1,20)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
C ---
      INTEGER   IPROFILE(20)
      CHARACTER LINE*256,PATH*1,EXT*1,SS*1
      CHARACTER LINE1*256,LINE2*256,STR*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_ALL(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
C -------------------------------------
      LINE = 'Profile: '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      NSEQ_PROFILE1 = NSEQ_PROFILE1 + 1
      WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ_PROFILE1 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
      LINE(1:1) = '#'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
c--------------------------------------
      NAA   = 0
      ICURR = 0
      JCURR = 0
      DO IPR=1,NPAIR
        ICURR = ICURR + 1
        JCURR = JCURR + 1
        I = IPAIR(1,IPR) 
        J = IPAIR(2,IPR)
        IF(I.GT.ICURR) THEN
          DO IC=ICURR,I-1
            IN1 = NSEQ1(IC)
            DO IPRF=1,20
              IPROFILE(IPRF) = IPROFILE1(IC,IPRF)
            ENDDO
            PNUM = PNUM1(IC)
            IDOM = IDOMAIN1(IC)
            IF(IN1.GT.0.AND.IN1.LE.20) THEN
              NAA = NAA + 1
            ELSE
              PNUM = '      '
            ENDIF
            IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

              ISS = ISS1(IC)
              IF(ISS.EQ.1) THEN
                SS = 'H'
              ELSE IF(ISS.EQ.2) THEN
                SS = 'h'
              ELSE IF(ISS.EQ.3) THEN
                SS = 'B'
              ELSE IF(ISS.EQ.4) THEN
                SS = 'b'
              ELSE
                SS = ' '
              ENDIF

              WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

              CALL LENSTR_BL(STR,LS)
              CALL LENSTR_BL(LINE,LEN)
              LINE = LINE(1:LEN)//STR(1:LS)         
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        IF(J.GT.JCURR) THEN
          DO JC=JCURR,J-1
            IN2 = NSEQ2(JC)
            DO IPRF=1,20
              IPROFILE(IPRF) = 0
            ENDDO
            IR  = 0
            IRR = 0
            PNUM = '      '
            IF(IN2.GT.0.AND.IN2.LE.20) THEN
              IPROFILE(IN2) = 1
C              NAA = NAA + 1
C              IR  = NAA
            ENDIF
            IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *          IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
CC              WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C              CALL LENSTR_BL(STR,LS)
C              CALL LENSTR_BL(LINE,LEN)
C              LINE = LINE(1:LEN)//STR(1:LS)         
C              CALL LENSTR_BL(LINE,LEN)
C              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        ICURR = I
        JCURR = J
        IN1   = NSEQ1(ICURR)
        IN2   = NSEQ2(JCURR)
        DO IPRF=1,20
          IPROFILE(IPRF) = IPROFILE1(ICURR,IPRF)
        ENDDO
        PNUM = PNUM1(ICURR)
        IDOM = IDOMAIN1(ICURR)
        IF(IN1.GT.0.AND.IN1.LE.20) THEN
          NAA = NAA + 1
        ELSE
          PNUM = '      '
        ENDIF
        IF(IN2.GT.0.AND.IN2.LE.20) THEN
          IPROFILE(IN2) = IPROFILE(IN2) + 1
        ENDIF

        IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

          ISS = ISS1(ICURR)
          IF(ISS.EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS.EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS.EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS.EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

           WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C          WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(INN)

          CALL LENSTR_BL(STR,LS)
          CALL LENSTR_BL(LINE,LEN)
          LINE = LINE(1:LEN)//STR(1:LS)         
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
        ENDIF
      ENDDO
      ICURR = ICURR + 1
      JCURR = JCURR + 1
      IF(NC.GE.ICURR) THEN
        DO IC=ICURR,NC
          IN1 = NSEQ1(IC)
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE1(IC,IPRF)
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = PNUM1(IC)
          IDOM = IDOMAIN1(IC)
          IF(IN1.GT.0.AND.IN1.LE.20) THEN
            NAA = NAA + 1
            IR  = NAA
          ELSE
            PNUM = '      '
          ENDIF
          IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *        IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

            ISS = ISS1(IC)
            IF(ISS.EQ.1) THEN
              SS = 'H'
            ELSE IF(ISS.EQ.2) THEN
              SS = 'h'
            ELSE IF(ISS.EQ.3) THEN
              SS = 'B'
            ELSE IF(ISS.EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF

            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

            WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)


            CALL LENSTR_BL(STR,LS)
            CALL LENSTR_BL(LINE,LEN)
            LINE = LINE(1:LEN)//STR(1:LS)         
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
      IF(KC.GT.JCURR) THEN
        DO JC=JCURR,KC
          IN2 = NSEQ2(JC)
          DO IPRF=1,20
            IPROFILE(IPRF) = 0
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = '      '
          IF(IN2.GT.0.AND.IN2.LE.20) THEN
            IPROFILE(IN2) = 1
C            NAA = NAA + 1
C            IR  = NAA
          ENDIF
          IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *        IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
CC            WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C            CALL LENSTR_BL(STR,LS)
C            CALL LENSTR_BL(LINE,LEN)
C            LINE = LINE(1:LEN)//STR(1:LS)         
C            CALL LENSTR_BL(LINE,LEN)
C            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
C -------------------------------------
      END FILE IOUT
      CLOSE(IOUT)

      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of amino acids in sequence = 0')
        IERR = 1
      ENDIF
      WRITE(LINE,'(A,I6)') 
     *  ' Number of sequences in profile  :',NSEQ_PROFILE1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') ' Number of amino acids in profile:',NAA
      CALL MSGDOC(MDOC,LINE)

      RETURN
C ----
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write output file')
      IERR = 1
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE ALIGN_WRITE_SEQ_PROF_TO_PROFILE(MDOC,NAMEO
     *  ,CODE
     *  ,NC,NSEQ_PROFILE2,IPROFILE2,KC
     *  ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *  ,IDOMAIN1,IDOMAIN2,ISS1,ISS2
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAMEO*(*)
      CHARACTER CODE*8
      CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6,PNUM*6
C -----
      INTEGER   IPROFILE2(NMAX2,20)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   ISS1(*),ISS2(*)
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
C ---
      INTEGER   IPROFILE(20)
      CHARACTER LINE*256,PATH*1,EXT*1,SS*1
      CHARACTER LINE1*256,LINE2*256,STR*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_ALL(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
C -------------------------------------
      LINE = 'Profile: '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      NSEQ_PROFILE2 = NSEQ_PROFILE2 + 1
      WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ_PROFILE2 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
      LINE(1:1) = '#'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
c--------------------------------------
      NAA   = 0
      ICURR = 0
      JCURR = 0
      DO IPR=1,NPAIR
        ICURR = ICURR + 1
        JCURR = JCURR + 1
        I = IPAIR(1,IPR) 
        J = IPAIR(2,IPR)
        IF(J.GT.JCURR) THEN
          DO JC=JCURR,J-1
            IN2 = NSEQ2(JC)
            DO IPRF=1,20
              IPROFILE(IPRF) = IPROFILE2(JC,IPRF)
            ENDDO
            IR  = 0
            IRR = 0
            PNUM = '      '
            IF(IN2.GT.0.AND.IN2.LE.20) THEN
C              NAA = NAA + 1
C              IR  = NAA
            ENDIF
            IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *          IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
C              WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C              CALL LENSTR_BL(STR,LS)
C              CALL LENSTR_BL(LINE,LEN)
C              LINE = LINE(1:LEN)//STR(1:LS)         
C              CALL LENSTR_BL(LINE,LEN)
C              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF    
        IF(I.GT.ICURR) THEN
          DO IC=ICURR,I-1
            IN1 = NSEQ1(IC)
            DO IPRF=1,20
              IPROFILE(IPRF) = 0
            ENDDO
            IR  = 0
            IRR = 0
            PNUM = PNUM1(IC)
            IDOM = IDOMAIN1(IC)
            IF(IN1.GT.0.AND.IN1.LE.20) THEN
              IPROFILE(IN1) = 1
              NAA = NAA + 1
              IR  = NAA
            ELSE
              PNUM = '      '
            ENDIF
            IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN 
              ISS = ISS1(IC)
              IF(ISS.EQ.1) THEN
                SS = 'H'
              ELSE IF(ISS.EQ.2) THEN
                SS = 'h'
              ELSE IF(ISS.EQ.3) THEN
                SS = 'B'
              ELSE IF(ISS.EQ.4) THEN
                SS = 'b'
              ELSE
                SS = ' '
              ENDIF
              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

              WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)


C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

              CALL LENSTR_BL(STR,LS)
              CALL LENSTR_BL(LINE,LEN)
              LINE = LINE(1:LEN)//STR(1:LS)         
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        ICURR = I
        JCURR = J
        IN1   = NSEQ1(ICURR)
        IN2   = NSEQ2(JCURR)
        IF(IN2.GT.0.AND.IN2.LE.20) THEN
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE2(JCURR,IPRF)
          ENDDO
        ELSE
          DO IPRF=1,20
            IPROFILE(IPRF) = 0
          ENDDO
        ENDIF
        PNUM = PNUM1(ICURR)
        IDOM = IDOMAIN1(ICURR)
        IF(IN1.GT.0.AND.IN1.LE.20) THEN
          IPROFILE(IN1) = IPROFILE(IN1) + 1
          NAA = NAA + 1
        ELSE
          PNUM = '      '
        ENDIF
        IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

          ISS = ISS1(ICURR)
          IF(ISS.EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS.EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS.EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS.EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

          WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C         WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(INN)

          CALL LENSTR_BL(STR,LS)
          CALL LENSTR_BL(LINE,LEN)
          LINE = LINE(1:LEN)//STR(1:LS)         
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
        ENDIF
      ENDDO
      ICURR = ICURR + 1
      JCURR = JCURR + 1
      IF(KC.GE.JCURR) THEN
        DO JC=JCURR,KC
          IN2 = NSEQ2(JC)
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE2(JC,IPRF)
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = '      '
          IF(IN1.GT.0.AND.IN1.LE.20) THEN
C            NAA = NAA + 1
C            IR  = NAA
          ENDIF
          IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *        IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
CC            WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C            CALL LENSTR_BL(STR,LS)
C            CALL LENSTR_BL(LINE,LEN)
C            LINE = LINE(1:LEN)//STR(1:LS)         
C            CALL LENSTR_BL(LINE,LEN)
C            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
      IF(NC.GT.ICURR) THEN
        DO IC=ICURR,NC
          IN1 = NSEQ1(IC)
          DO IPRF=1,20
            IPROFILE(IPRF) = 0
          ENDDO
          PNUM = PNUM1(IC)
          IDOM = IDOMAIN1(IC)
          IF(IN1.GT.0.AND.IN1.LE.20) THEN
            IPROFILE(IN1) = 1
            NAA = NAA + 1
          ELSE
            PNUM = '      '
          ENDIF
          IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *        IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

            ISS = ISS1(IC)
            IF(ISS.EQ.1) THEN
              SS = 'H'
            ELSE IF(ISS.EQ.2) THEN
              SS = 'h'
            ELSE IF(ISS.EQ.3) THEN
              SS = 'B'
            ELSE IF(ISS.EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF

            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

            WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

            CALL LENSTR_BL(STR,LS)
            CALL LENSTR_BL(LINE,LEN)
            LINE = LINE(1:LEN)//STR(1:LS)         
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
C -------------------------------------
      END FILE IOUT
      CLOSE(IOUT)

      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of amino acids in sequence = 0')
        IERR = 1
      ENDIF
      WRITE(LINE,'(A,I6)') 
     *  ' Number of sequences in profile  :',NSEQ_PROFILE2
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') ' Number of amino acids in profile:',NAA
      CALL MSGDOC(MDOC,LINE)

      RETURN
C ----
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write output file')
      IERR = 1
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE ALIGN_WRITE_2PROF_TO_PROFILE(MDOC,NAMEO
     *  ,CODE
     *  ,NC,NSEQ_PROFILE1,IPROFILE1,KC,NSEQ_PROFILE2,IPROFILE2
     *  ,NSEQ1,NSEQ2,PNUM1,PNUM2
     *  ,IDOMAIN1,IDOMAIN2,ISS1,ISS2
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAMEO*(*)
      CHARACTER CODE*8
      CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6,PNUM*6
      INTEGER   IDOMAIN1(*),IDOMAIN2(*)
      INTEGER   ISS1(*),ISS2(*)
C -----
      INTEGER   IPROFILE1(NMAX1,20)
      INTEGER   IPROFILE2(NMAX2,20)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
C ---
      INTEGER   IPROFILE(20)
      CHARACTER LINE*256,PATH*1,EXT*1,SS*1
      CHARACTER LINE1*256,LINE2*256,STR*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_ALL(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
C -------------------------------------
      LINE = 'Profile: '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      NSEQ_PROFILE1 = NSEQ_PROFILE1 + NSEQ_PROFILE2
      WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ_PROFILE1 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
      WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
      LINE(1:1) = '#'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
c--------------------------------------
      NAA   = 0
      ICURR = 0
      JCURR = 0
      DO IPR=1,NPAIR
        ICURR = ICURR + 1
        JCURR = JCURR + 1
        I = IPAIR(1,IPR) 
        J = IPAIR(2,IPR)
        IF(I.GT.ICURR) THEN
          DO IC=ICURR,I-1
            IN1 = NSEQ1(IC)
            DO IPRF=1,20
              IPROFILE(IPRF) = IPROFILE1(IC,IPRF)
            ENDDO

            PNUM = PNUM1(IC)
            IDOM = IDOMAIN1(IC)

            IF(IN1.GT.0.AND.IN1.LE.20) THEN
              NAA = NAA + 1
            ELSE
              PNUM = '      '
            ENDIF
            IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *          IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

              ISS = ISS1(IC)
              IF(ISS.EQ.1) THEN
                SS = 'H'
              ELSE IF(ISS.EQ.2) THEN
                SS = 'h'
              ELSE IF(ISS.EQ.3) THEN
                SS = 'B'
              ELSE IF(ISS.EQ.4) THEN
                SS = 'b'
              ELSE
                SS = ' '
              ENDIF

              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

              WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

              CALL LENSTR_BL(STR,LS)
              CALL LENSTR_BL(LINE,LEN)
              LINE = LINE(1:LEN)//STR(1:LS)         
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        IF(J.GT.JCURR) THEN
          DO JC=JCURR,J-1
            IN2 = NSEQ2(JC)
            DO IPRF=1,20
              IPROFILE(IPRF) = IPROFILE2(JC,IPRF)
            ENDDO
            IR  = 0
            IRR = 0
            PNUM = '      '
            IF(IN2.GT.0.AND.IN2.LE.20) THEN
C              NAA = NAA + 1
C              IR  = NAA
            ENDIF
            IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *          IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C              WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C 
C              WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
CC              WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C              CALL LENSTR_BL(STR,LS)
C              CALL LENSTR_BL(LINE,LEN)
C              LINE = LINE(1:LEN)//STR(1:LS)         
C              CALL LENSTR_BL(LINE,LEN)
C              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
            ENDIF
          ENDDO
        ENDIF
        ICURR = I
        JCURR = J
        DO IPRF=1,20
          IPROFILE(IPRF) = 0 
        ENDDO
        IN1   = NSEQ1(ICURR)
        IN2   = NSEQ2(JCURR)
        PNUM  = PNUM1(ICURR)
        IDOM  = IDOMAIN1(ICURR)

        IF(IN1.GT.0.AND.IN1.LE.20) THEN
          NAA = NAA + 1
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE1(ICURR,IPRF) 
     *                     + IPROFILE2(JCURR,IPRF)
          ENDDO
        ELSE
          PNUM = '      '
        ENDIF
        IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *      IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

          ISS = ISS1(ICURR)
          IF(ISS.EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS.EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS.EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS.EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

          WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C          WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(INN)

          CALL LENSTR_BL(STR,LS)
          CALL LENSTR_BL(LINE,LEN)
          LINE = LINE(1:LEN)//STR(1:LS)         
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
        ENDIF
      ENDDO
      ICURR = ICURR + 1
      JCURR = JCURR + 1
      IF(NC.GE.ICURR) THEN
        DO IC=ICURR,NC
          IN1 = NSEQ1(IC)
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE1(IC,IPRF)
          ENDDO
          PNUM = PNUM1(IC)
          IDOM = IDOMAIN1(IC)

          IF(IN1.GT.0.AND.IN1.LE.20) THEN
            NAA = NAA + 1
          ELSE
            PNUM = '      '
          ENDIF
          IF((IN1.GT.0.AND.IN1.LE.20).OR.
     *        IN1.EQ.24.OR.IN1.EQ.25     ) THEN 

            ISS = ISS1(IC)
            IF(ISS.EQ.1) THEN
              SS = 'H'
            ELSE IF(ISS.EQ.2) THEN
              SS = 'h'
            ELSE IF(ISS.EQ.3) THEN
              SS = 'B'
            ELSE IF(ISS.EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF

            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 

            WRITE(STR,'(A,A,I5,A,A,A,A)') 
     *        ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN1)

            CALL LENSTR_BL(STR,LS)
            CALL LENSTR_BL(LINE,LEN)
            LINE = LINE(1:LEN)//STR(1:LS)         
            CALL LENSTR_BL(LINE,LEN)
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
      IF(KC.GT.JCURR) THEN
        DO JC=JCURR,KC
          IN2 = NSEQ2(JC)
          DO IPRF=1,20
            IPROFILE(IPRF) = IPROFILE2(JC,IPRF)
          ENDDO
          IR  = 0
          IRR = 0
          PNUM = '      '
          IF(IN2.GT.0.AND.IN2.LE.20) THEN
C            NAA = NAA + 1
C            IR  = NAA
          ENDIF
          IF((IN2.GT.0.AND.IN2.LE.20).OR.
     *        IN2.EQ.24.OR.IN2.EQ.25     ) THEN 
C            WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
C
C            WRITE(STR,'(A,A,A,A)') ' # ',PNUM(2:6),'  ',AMIN(IN2)
C
CC            WRITE(STR,'(A,I5,A,A)') ' #',IRR,'   ',AMIN(IN2)
C
C            CALL LENSTR_BL(STR,LS)
C            CALL LENSTR_BL(LINE,LEN)
C            LINE = LINE(1:LEN)//STR(1:LS)         
C            CALL LENSTR_BL(LINE,LEN)
C            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF
        ENDDO
      ENDIF
C -------------------------------------
      END FILE IOUT
      CLOSE(IOUT)

      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of amino acids in sequence = 0')
        IERR = 1
      ENDIF
      WRITE(LINE,'(A,I6)') 
     *' Number of sequences in profile  :',NSEQ_PROFILE1
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)') ' Number of amino acids in profile:',NAA
      CALL MSGDOC(MDOC,LINE)

      RETURN
C ----
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write output file')
      IERR = 1
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE READ_SEQ_PROFILE(MDOC,CODE8,FILE_P
     *       ,NSEQ_PROFILE,NC,NMAX,IPROFILE,NCHAIN,PNUM
     *       ,NSEQ,IRES,ISS,ISSN,SURF,ICHAIN,IDOMAIN,IERR)
C ------------------------------------------
      CHARACTER FILE_P*(*)
      CHARACTER CODE8*8
      INTEGER   IPROFILE(NMAX,20),IPROFILE_INP(20)
      INTEGER   NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      INTEGER   ISS(NMAX),ISSN(NMAX),SURF(NMAX)
      CHARACTER PNUM(NMAX)*6,PNUMR*5
      CHARACTER PATH*80,EXT*80,AA*1,CH1*1,CH1_OLD*1
      CHARACTER LINE*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(FILE_P,LEN)
      IF(LEN.LE.0.OR.FILE_P(1:1).EQ.' '.OR.FILE_P(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,FILE_P,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 910
      ENDIF
C -------------------------------
      READ(IU,'(A)',ERR=930,END=920) LINE
      CODE8 = LINE(10:17)
      READ(IU,'(A)',ERR=930,END=920) LINE
      READ(LINE,'(5X,I6)',ERR=935) NSEQ_PROFILE 

      NC = 0
      NSS = 0
      CH1_OLD = ' '
      IR = 0
100   CONTINUE
      READ(IU,'(A)',ERR=930,END=200) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 100
      READ(LINE,'(20I3)',ERR=935) (IPROFILE_INP(IPRF),IPRF=1,20) 
      IR = IR + 1
      IF(LEN.GE.77) THEN

c6         7
c 123456789 123456789 
c1 # 2345600000 H SSSSMMDD
c
c0 #    000000    -.....
C           WRITE(STR,'(A,A,I5,A,A,A,A)') 
C     *      ' # ',PNUM(2:6),IDOM,' ',SS,' ',AMIN(IN1)

        AA  = LINE(77:77)
        CH1 = LINE(75:75)
        PNUMR = LINE(63:68)
        READ(LINE(64:67),'(I4)',ERR=935) IRR
        READ(LINE(69:73),'(I5)',ERR=935) IDOM
        IAA = 5
        DO J=1,25
          IF(AMIN(J).EQ.AA) THEN
            IAA = J
            GO TO 300
          ENDIF
        ENDDO
  300   CONTINUE
        IF(J.LE.0.OR.(J.GT.20.AND.J.NE.24.AND.J.NE.25)) THEN
          GO TO 100
        ENDIF
        NC = NC + 1

c       24 25 = -
        DO IPRF=1,20
          IPROFILE(NC,IPRF) = IPROFILE_INP(IPRF)
        ENDDO

        NSEQ(NC) = IAA
        IRES(NC) = IR
        IF(CH1.NE.' '.AND.CH1.NE.CH1_OLD) NSS = NSS + 1
        IF(CH1.NE.' ') THEN 
          ISSN_N = NSS
          ISS_N = 0
          IF(CH1.EQ.'H') THEN
            ISS_N = 1
          ELSE IF(CH1.EQ.'h') THEN
            ISS_N = 2
          ELSE IF(CH1.EQ.'B') THEN
            ISS_N = 3
          ELSE IF(CH1.EQ.'b') THEN
            ISS_N = 4
          ENDIF
        ELSE
          ISS_N  = 0
          ISSN_N = 0
        ENDIF

        ISSN(NC) = ISSN_N
        ISS (NC) = ISS_N
        CH1_OLD  = CH1
  
C        WRITE(PNUM(NC)(2:5),'(I4)') IRR
C        PNUM(NC)(1:1) = 'A'
C        PNUM(NC)(6:6) = ' '

        PNUM(NC) = PNUMR     
        PNUM(NC)(1:1) = 'A'
        IDOMAIN(NC) = IDOM

      ELSE
        IPR_MAX = 0
        JMAX    = 5
        DO J=1,20
          IF(IPROFILE(NC,J).GT.IPR_MAX) THEN
            IPR_MAX = IPROFILE(NC,J)
            JMAX    = J
          ENDIF
        ENDDO
        IF(IPR_MAX.LE.0) GO TO 100
        NC = NC + 1
        NSEQ(NC) = JMAX
        IRES(NC) = NC
        ISSN(NC) = 0
        ISS (NC) = 0
        IRR = IR
        WRITE(PNUM(NC)(2:5),'(I4)') IRR
        PNUM(NC)(1:1) = 'A'
        PNUM(NC)(6:6) = ' '
        IDOMAIN(NC) = 0
      ENDIF
      GO TO 100
200   CONTINUE
      CLOSE(IU) 
      IF(NC.LE.0) THEN
        IERR = 1
        LINE = ' ERROR: Naa in profile file = 0'
        CALL MSGERR(MDOC,LINE)
        RETURN
      ENDIF
      DO I=1,NC
        ICHAIN(I)  = 0
        SURF(I)    = 0
      ENDDO
C -------------------------------
 900  CONTINUE
      RETURN
C -------------------------------
 910  CONTINUE
      LINE = ' ERROR: cannot open profile file'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN
 920  CONTINUE
      LINE = ' ERROR:  end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      RETURN
 930  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      RETURN
 935  CONTINUE
      CALL LENSTR_BL(LINE,LEN)
      LINE = ' ERROR: reading LINE (input file)'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      RETURN
      END

      SUBROUTINE COPY_PROFILE(MDOC,CODE8
     *       ,NSEQ_PROFILE,FILE_P,FILE_O,IERR)
C ------------------------------------------
      CHARACTER FILE_P*(*),FILE_O*(*)
      CHARACTER CODE8*8,CODE8_INPUT*8
      CHARACTER PATH*80,EXT*80
      CHARACTER LINE*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CODE8_INPUT = CODE8

      CALL LENSTR_BL(FILE_P,LEN)
      IF(LEN.LE.0.OR.FILE_P(1:1).EQ.' '.OR.FILE_P(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,FILE_P,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open input profile file'
        CALL MSGERR(MDOC,LINE)
        RETURN
      ENDIF
      IOUT = 0
      CALL LENSTR_BL(FILE_P,LEN)
      IF(LEN.GE.0.AND.FILE_O(1:1).NE.' '.AND.FILE_O(1:1).NE.',') THEN
        IOUT = 11
        EXT  = ' '
        PATH = ' '
        CALL OPENFW(IOUT,M,PATH,FILE_O,EXT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: cannot open output profile file'
          CALL MSGERR(MDOC,LINE)
          CLOSE(IU)
          RETURN
        ENDIF
      ENDIF
C -------------------------------
      READ(IU,'(A)',ERR=930,END=920) LINE
      CODE8 = LINE(10:17)
      READ(IU,'(A)',ERR=930,END=920) LINE
      READ(LINE,'(5X,I6)',ERR=930) NSEQ_PROFILE 
      READ(IU,'(A)',ERR=930,END=920) LINE
      IF(IOUT.GT.0) THEN
        CALL LENSTR_BL(CODE8_INPUT,LEN)
        IF(LEN.GT.0) THEN
          CODE8 = CODE8_INPUT
        ENDIF
        LINE = 'Profile: '//CODE8
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
        WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ_PROFILE 
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
        WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
        LINE(1:1) = '#'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
      ENDIF
      IF(IOUT.LE.0) RETURN
100   CONTINUE
      READ(IU,'(A)',ERR=930,END=200) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.0) GO TO 100
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
      GO TO 100
200   CONTINUE
      CLOSE(IU)
      END FILE IOUT 
      CLOSE(IOUT)
C -------------------------------
 900  CONTINUE
      RETURN
C -------------------------------
 910  CONTINUE
      LINE = ' ERROR: write output profile file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      CLOSE(IOUT)
      IERR = 1
      RETURN
 920  CONTINUE
      LINE = ' ERROR:  end of input profile file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
 930  CONTINUE
      LINE = ' ERROR: reading input profile file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
      END

      SUBROUTINE SET_AMATRIX_PROFILE(MDOC,AMATRIX,AMAT,DPEN0
     *  ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *  ,NC,IPROFILE1,NSEQ1,ASEQ1,KC,NSEQ2,ASEQ2,IPROFILE2
     *  ,NMAX1,NMAX2,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      ASEQ1(NMAX1),ASEQ2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPROFILE1(NMAX1,20),IPROFILE2(NMAX2,20)
      CHARACTER LINE*256
C ---------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
      SUM_TOT = 0.0
      NTOT    = 0
C ----
      DO I=1,NC
        DO J=1,KC
          IF(IPDB2.GE.0.AND.IPDB1.LT.0) THEN
            N2  = NSEQ2(J)
            SUM = 0.0
            DO IP1=1,20
              W1  = REAL(IPROFILE1(I,IP1))/REAL(NSEQ_PROFILE1) 
              SUM = SUM + AMAT(IP1,N2)*W1
            ENDDO   
            AMATRIX(I,J) = SUM
            IF(N2.LE.20) THEN
              SUM_TOT = SUM_TOT + SUM
              NTOT    = NTOT + 1
            ENDIF
          ELSE IF(IPDB1.GE.0.AND.IPDB2.LT.0) THEN
            N1  = NSEQ1(I)
            SUM = 0.0
            DO IP1=1,20
              W1  = REAL(IPROFILE2(J,IP1))/REAL(NSEQ_PROFILE2) 
              SUM = SUM + AMAT(IP1,N1)*W1
            ENDDO   
            AMATRIX(I,J) = SUM
            IF(N1.LE.20) THEN
              SUM_TOT = SUM_TOT + SUM
              NTOT    = NTOT + 1
            ENDIF  
          ELSE
            SUM = 0.0
            DO IP2=1,20
              W2  = REAL(IPROFILE2(J,IP2))/REAL(NSEQ_PROFILE2) 
              DO IP1=1,20
                W1  = REAL(IPROFILE1(I,IP1))/REAL(NSEQ_PROFILE1) 
                SUM = SUM + AMAT(IP1,IP2)*W1*W2
              ENDDO
            ENDDO   
            N1  = NSEQ1(I)
            N2  = NSEQ2(J)
            AMATRIX(I,J) = SUM
            IF(N1.LE.20.AND.N2.LE.20) THEN
              SUM_TOT = SUM_TOT + SUM
              NTOT    = NTOT + 1
            ENDIF  
          ENDIF
        ENDDO
C ---
        IF(IPDB1.GE.0) THEN
          N1  = NSEQ1(I)
          ASEQ1(I) = AMAT(N1,N1)
        ELSE
          SUM = 0.0
          DO IP1=1,20
            W1  = REAL(IPROFILE1(I,IP1))/REAL(NSEQ_PROFILE1) 
            DO IP2=1,20
              W2  = REAL(IPROFILE1(I,IP2))/REAL(NSEQ_PROFILE1) 
              SUM = SUM + AMAT(IP1,IP2)*W1*W2
            ENDDO
          ENDDO  
          ASEQ1(I) = SUM 
        ENDIF
C ---
      ENDDO
      DO J=1,KC
        IF(IPDB2.GE.0) THEN
          N2  = NSEQ2(J)
          ASEQ2(J) = AMAT(N2,N2)
        ELSE
          SUM = 0.0
          DO IP1=1,20
            W1  = REAL(IPROFILE2(J,IP1))/REAL(NSEQ_PROFILE2) 
            DO IP2=1,20
              W2  = REAL(IPROFILE2(J,IP2))/REAL(NSEQ_PROFILE2) 
              SUM = SUM + AMAT(IP1,IP2)*W1*W2
            ENDDO
          ENDDO  
          ASEQ2(J) = SUM
       ENDIF 
      ENDDO

      IF(NTOT.GT.0) SUM_TOT  = SUM_TOT/REAL(NTOT)
c      WRITE(LINE,*) '--SUM  :',SUM_TOT,NTOT
c      CALL MSGDOC(MDOC,LINE)

      DPEN0 = SUM_TOT

      WRITE(LINE,*) ' prf "0":',DPEN0
      CALL MSGDOC(MDOC,LINE)
C ----
      RETURN
      END

      SUBROUTINE SET_SURF_PROFILE(MDOC,AMATRIX,AMAT
     *  ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     *  ,NC,IPROFILE1,SURF1,KC,IPROFILE2,SURF2
     *  ,NMAX1,NMAX2,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   IPROFILE1(NMAX1,20),IPROFILE2(NMAX2,20)
      CHARACTER LINE*256
C ---------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ----
      IF(IPDB1.LT.0) THEN
        N  = NSEQ_PROFILE1
        N2 = (N-1)/2
        DO I=1,NC
          SURF1(I) = 1
          IF(N.GT.2) THEN
            NS = 0
            DO IP=1,20
              IF(IPROFILE1(I,IP).GT.0) NS = NS + IPROFILE1(I,IP)
            ENDDO
            IF(NS.GT.0) THEN
              IS = N - N2 - NS
              IF(IS.LT.0) IS = 0
              IF(IS.GT.7) IS = 7
              SURF1(I) = IS + 1
            ENDIF
          ENDIF   
        ENDDO
      ENDIF

      IF(IPDB2.LT.0) THEN
        N  = NSEQ_PROFILE2
        N2 = (N-1)/2
        DO I=1,KC
          SURF2(I) = 1
          IF(N.GT.2) THEN
            NS = 0
            DO IP=1,20
              IF(IPROFILE2(I,IP).GT.0) NS = NS + IPROFILE2(I,IP)
            ENDDO
            IF(NS.GT.0) THEN
              IS = N - N2 - NS
              IF(IS.LT.0) IS = 0
              IF(IS.GT.7) IS = 7
              SURF2(I) = IS + 1
            ENDIF
          ENDIF   
        ENDDO
      ENDIF
C ----
      RETURN
      END

      SUBROUTINE RECALC_MATRIX_PRF(NC,KC,NSEQ1,ASEQ1,NSEQ2,ASEQ2
     * ,NPAIR,IPAIR
     * ,NMAX1,NMAX2,NMAX12,AMAT,AMATRIX
     * ,IPDB1,IPDB2,NSEQ_PROFILE1,NSEQ_PROFILE2
     * ,IPROFILE1,IPROFILE2)
c ----------------
      REAL      AMAT(25,25)
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      ASEQ1(NMAX1),ASEQ2(NMAX2)  
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)

      INTEGER   IPROFILE1(NMAX1,20),IPROFILE2(NMAX2,20)
c ----------------
      DO I=1,NPAIR             
        N = IPAIR(1,I)
        K = IPAIR(2,I)
        NAA1 = NSEQ1(N)
        NAA2 = NSEQ2(K)
        IF(IPDB1.LT.0.AND.NAA2.LT.24) THEN
          SMAX = 0.0
          JMAX = 0
          IPMAX = 0
          DO J=1,20
            IPRF = IPROFILE1(N,J)
            IF(IPRF.GT.0) THEN
              S = AMAT(J,NAA2)
              IF(S.GT.SMAX) THEN
                SMAX = S
                JMAX = J
                IPMAX = IPRF
              ENDIF
            ENDIF
          ENDDO
          NAA1     = JMAX
          ASEQ1(N) = AMAT(NAA1,NAA1)
          NSEQ1(N) = NAA1
        ENDIF
        IF(IPDB2.LT.0.AND.NAA1.LT.24) THEN
          SMAX = 0.0
          JMAX = 0
          IPMAX = 0
          DO J=1,20
            IPRF = IPROFILE2(K,J)
            IF(IPRF.GT.0) THEN
              S = AMAT(NAA1,J)
              IF(S.GT.SMAX) THEN
                SMAX = S
                JMAX = J
                IPMAX = IPRF
              ENDIF
            ENDIF
          ENDDO
          NAA2     = JMAX
          ASEQ2(K) = AMAT(NAA2,NAA2)
          NSEQ2(K) = NAA2
        ENDIF
      ENDDO
      DO I=1,NC
        N1  = NSEQ1(I)
        DO J=1,KC
          N2  = NSEQ2(J)
          T = AMAT(N1,N2)
          AMATRIX(I,J) = T
        ENDDO
      ENDDO
C ---
      RETURN
      END

      SUBROUTINE SET_AMATRIX4(MDOC,MODE,AMATRIX,AMAT
     *  ,NC,NSEQ1,ASEQ1,COORD1,SURF1,KC,NSEQ2,ASEQ2,COORD2,SURF2
     *  ,SS_FLAG,SS1,SS2
     *  ,NMAX1,NMAX2,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC
      CHARACTER MODE*1,SS_FLAG*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      COORD1(NMAX1,3)
      REAL      COORD2(NMAX2,3)
      REAL      ASEQ1(NMAX1),ASEQ2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   SS1(NMAX1),SS2(NMAX2)
C ---------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ----
      IF(MODE.NE.'D'.AND.MODE.NE.'P') THEN

        DO I=1,NC
          N1  = NSEQ1(I)
          DO J=1,KC
            N2  = NSEQ2(J)
            T = AMAT(N1,N2)
            AMATRIX(I,J) = T
          ENDDO
          ASEQ1(I) = AMAT(N1,N1)
        ENDDO
        DO J=1,KC
          N2  = NSEQ2(J)
          ASEQ2(J) = AMAT(N2,N2)
        ENDDO

      ELSE IF(MODE.NE.'P') THEN

        TMAX = -1.0E30
        TMIN =  1.0E30
        DO I=1,NC
          DO J=1,KC
            IF(SURF1(I).LT.0.OR.SURF2(J).LT.0) THEN
              AMATRIX(I,J) = 0.0
            ELSE
              DX = COORD1(I,1) - COORD2(J,1)
              DY = COORD1(I,2) - COORD2(J,2)
              DZ = COORD1(I,3) - COORD2(J,3)
              D2 = DX*DX + DY*DY + DZ*DZ
              N  = 1
              IF(I.GT.1.AND.J.GT.1) THEN
                II = I - 1
                JJ = J - 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC.AND.J.LT.KC) THEN
                II = I + 1
                JJ = J + 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.GT.2.AND.J.GT.2) THEN
                II = I - 2
                JJ = J - 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC-1.AND.J.LT.KC-1) THEN
                II = I + 2
                JJ = J + 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              D2   = D2/FLOAT(N)
              SIG2 = 25.0
              SIG2 = 9.0
              TT   = D2/(2.0*SIG2)
              T    = EXP(-TT)
              AMATRIX(I,J) = T
              IF(T.GT.TMAX) TMAX = T
              IF(T.LT.TMIN) TMIN = T
              ASEQ1(I) = 1.0
              ASEQ2(J) = 1.0
            ENDIF
          ENDDO
        ENDDO

      ELSE

        TMAX = -1.0E30
        TMIN =  1.0E30
        DO I=1,NC
        DO J=1,KC
          AMATRIX(I,J) = 0.0
        ENDDO
        ENDDO

        DO I=1,NC
          IF(SURF1(I).GE.0) THEN
            IDS = 0
            IF(I-1.GT.0) THEN
            IF(SURF1(I-1).GE.0) THEN
              IDS =-1
              IF(I-2.GT.0) THEN
              IF(SURF1(I-2).GE.0) THEN
                IDS =-2
              ENDIF
              ENDIF
            ENDIF
            ENDIF
            IDF = 0
            IF(I+1.LE.NC) THEN
            IF(SURF1(I+1).GE.0) THEN
              IDF = 1
              IF(I+2.LE.NC) THEN
              IF(SURF1(I+2).GE.0) THEN
                IDF = 2
              ENDIF
              ENDIF
            ENDIF
            ENDIF
            IF(IDF-IDS.GE.2) THEN  
              DO J=1,KC
                IF(SURF2(J).GE.0) THEN
                  JDS = 0
                  IF(J-1.GT.0) THEN
                  IF(SURF2(J-1).GE.0) THEN
                    JDS =-1
                    IF(J-2.GT.0) THEN
                    IF(SURF2(J-2).GE.0) THEN
                      JDS =-2
                    ENDIF
                    ENDIF
                  ENDIF
                  ENDIF
                  JDF = 0
                  IF(J+1.LE.KC) THEN
                  IF(SURF2(J+1).GE.0) THEN
                    JDF = 1
                    IF(J+2.LE.KC) THEN
                    IF(SURF2(J+2).GE.0) THEN
                      JDF = 2
                    ENDIF
                    ENDIF
                  ENDIF
                  ENDIF
                  IJDS = IDS
                  IF(ABS(IDS).GT.ABS(JDS)) IJDS = JDS
                  IJDF = IDF
                  IF(IDF.GT.JDF) IJDF = JDF
                  IF(IJDF-IJDS.GE.2) THEN  
                    N  = 0
                    DD = 0.0
                    DO IJ=IJDS,IJDF-2
                      IF(IJ+2.LE.IJDF) THEN
                        DX = COORD1(I+IJ,1) - COORD1(I+IJ+2,1)
                        DY = COORD1(I+IJ,2) - COORD1(I+IJ+2,2)
                        DZ = COORD1(I+IJ,3) - COORD1(I+IJ+2,3)
                        D1 = SQRT(DX*DX + DY*DY + DZ*DZ)
                        DX = COORD2(J+IJ,1) - COORD2(J+IJ+2,1)
                        DY = COORD2(J+IJ,2) - COORD2(J+IJ+2,2)
                        DZ = COORD2(J+IJ,3) - COORD2(J+IJ+2,3)
                        D2 = SQRT(DX*DX + DY*DY + DZ*DZ)
                        DD = DD + (D1-D2)*(D1-D2)
                        N  = N + 1
                      ENDIF
                      IF(IJ+3.LE.IJDF) THEN
                        DX = COORD1(I+IJ,1) - COORD1(I+IJ+3,1)
                        DY = COORD1(I+IJ,2) - COORD1(I+IJ+3,2)
                        DZ = COORD1(I+IJ,3) - COORD1(I+IJ+3,3)
                        D1 = SQRT(DX*DX + DY*DY + DZ*DZ)
                        DX = COORD2(J+IJ,1) - COORD2(J+IJ+3,1)
                        DY = COORD2(J+IJ,2) - COORD2(J+IJ+3,2)
                        DZ = COORD2(J+IJ,3) - COORD2(J+IJ+3,3)
                        D2 = SQRT(DX*DX + DY*DY + DZ*DZ)
                        DD = DD + (D1-D2)*(D1-D2)
                        N  = N + 1
                      ENDIF
                    ENDDO

c                    write(*,*) i,j,n,dd

                    IF(N.GT.0) THEN
                      DD   = DD/REAL(N)
                      SIG2 = 25.0
                      SIG2 = 9.0
                      SIG2 = 4.0
c                      SIG2 = 1.0
                      TT   = DD/(2.0*SIG2)
                      T    = EXP(-TT)
                      AMATRIX(I,J) = T
                      IF(T.GT.TMAX) TMAX = T
                      IF(T.LT.TMIN) TMIN = T
                      ASEQ1(I) = 1.0
                      ASEQ2(J) = 1.0
                    ENDIF
                  ENDIF
                ENDIF
              ENDDO
            ENDIF
          ENDIF
        ENDDO

c        write(*,*) '==',tmin,tmax

      ENDIF
C ----
      RETURN
      END

      SUBROUTINE ALIGN_INIT_3(MDOC,MODE,SS_FLAG,D3_FLAG
     * ,OPENR,DPEN0,PENEXR
     * ,ATOM_INDEX,ATOM_NAME     
     * ,NC,KC,SS1,ISS1,SS2,ISS2,SURF1,SURF2
     * ,NSEQ1,NSEQ2,NMAX1,NMAX2,AMAT)
C ---------------------------------------------------------------
      INTEGER   MDOC
      CHARACTER MODE*1
C ---------------------------------------
C -----
C     N CA CB CG CD CE CZ C O
      CHARACTER ATOM_NAME(9)*2
C                      g d e z
      INTEGER   ATOM_INDEX(4,25)
C -----
      INTEGER   ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   SS1(NMAX1),SS2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
C     CHARACTER PNUM1(NMAX1)*6,PNUM2(NMAX2)*6
      CHARACTER SS_FLAG*1,D3_FLAG*1
      REAL      AMAT(25,25)
C -----
      INTEGER ITABB(20,20)
      INTEGER ITABB1(200),ITABB2(200)
      EQUIVALENCE (ITABB1(1),ITABB(1,1))
      EQUIVALENCE (ITABB2(1),ITABB(1,11))
      INTEGER ITABG(20,20)
      INTEGER ITABG1(200),ITABG2(200)
      EQUIVALENCE (ITABG1(1),ITABG(1,1))
      EQUIVALENCE (ITABG2(1),ITABG(1,11))
      INTEGER ITABU(20,20),ITABS(20,20),ITABE(20,20),INDD(20)
      INTEGER ITABU1(200),ITABU2(200)
      EQUIVALENCE (ITABU1(1),ITABU(1,1))
      EQUIVALENCE (ITABU2(1),ITABU(1,11))
      INTEGER ITABS1(200),ITABS2(200)
      EQUIVALENCE (ITABS1(1),ITABS(1,1))
      EQUIVALENCE (ITABS2(1),ITABS(1,11))
      REAL ITABH(20,20)
      REAL HYDRO(20)

      CHARACTER LINE*256
C --------------------------------------------------------
C ============================================================
C
C         C    S    T    P    A    G    N    D    E    Q
C         1    2    3    4    5    6    7    8    9   10
C         H    R    K    M    I    L    V    F    Y    W
C        11   12   13   14   15   16   17   18   19   20
      DATA  HYDRO /
     . -0.4,-0.8,-0.7,-1.6, 1.8,-0.4,-3.5,-3.5,-3.5,-3.5,
     . -3.2,-4.5,-3.9, 1.9, 4.5, 3.8, 4.2, 2.5,-1.3,-0.9/
C    . -0.4,-0.8,-0.7,-1.6, 1.8,-0.4,-3.5,-3.5,-3.5,-3.5,
C    . -3.2,-4.5,-3.9, 1.9, 4.5, 3.8, 4.2, 2.5,-1.3,-0.9/
C
C  PAM-250
C      C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C      1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABG1 /
     .12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     . 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-2, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-2, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0,-1, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 1, 0,-1, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1, 0, 1, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1, 0, 0, 1, 3, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5,-1,-1, 0, 0,-1, 1, 2, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABG2 /
     .-3,-1,-1, 0,-1,-2, 2, 1, 1, 3, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 0,-1, 0,-2,-3, 0,-1,-1, 1, 2, 6, 0, 0, 0, 0, 0, 0, 0, 0,
     .-5, 0, 0,-1,-1,-2, 1, 0, 0, 1, 0, 3, 5, 0, 0, 0, 0, 0, 0, 0,
     .-5,-2,-1,-2,-1,-3,-2,-3,-2,-1,-2, 0, 0, 6, 0, 0, 0, 0, 0, 0,
     .-2,-1, 0,-2,-1,-3,-2,-2,-2,-2,-2,-2,-2, 2, 5, 0, 0, 0, 0, 0,
     .-6,-3,-2,-3,-2,-4,-3,-4,-3,-2,-2,-3,-3, 4, 2, 6, 0, 0, 0, 0,
     .-2,-1, 0,-1, 0,-1,-2,-2,-2,-2,-2,-2,-2, 2, 4, 2, 4, 0, 0, 0,
     .-4,-3,-3,-5,-4,-5,-4,-6,-5,-5,-2,-4,-5, 0, 1, 2,-1, 9, 0, 0,
     . 0,-3,-3,-5,-3,-5,-2,-4,-4,-4, 0,-4,-4,-2,-1,-1,-2, 7,10, 0,
     .-8,-2,-5,-6,-6,-7,-4,-7,-7,-5,-3,-2,-3,-4,-5,-2,-6, 0, 0,17
     . /
c    
C  BLOSUM62
C      C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C      1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
c     
      DATA ITABB1 /
     . 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-1, 1, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3,-1,-1, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     . 0, 1, 0,-1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-2,-2, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 1, 0,-2,-2, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-2,-1, 1, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-4, 0,-1,-1,-1,-2, 0, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-1,-2, 0, 0, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABB2 /
     .-3,-1,-2,-2,-2,-2, 1,-1, 0, 0, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3,-1,-1,-2,-1,-2, 0,-2, 0, 1, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .-3, 0,-1,-1,-1,-2, 0,-1, 1, 1,-1, 2, 5, 0, 0, 0, 0, 0, 0, 0,
     .-1,-1,-1,-2,-1,-3,-2,-3,-2, 0,-2,-1,-1, 5, 0, 0, 0, 0, 0, 0,
     .-1,-2,-1,-3,-1,-4,-3,-3,-3,-3,-3,-3,-3, 1, 4, 0, 0, 0, 0, 0,
     .-1,-2,-1,-3,-1,-4,-3,-4,-3,-2,-3,-2,-2, 2, 2, 4, 0, 0, 0, 0,
     .-1,-2, 0,-2, 0,-3,-3,-3,-2,-2,-3,-3,-2, 1, 3, 1, 4, 0, 0, 0,
     .-2,-2,-2,-4,-2,-3,-3,-3,-3,-3,-1,-3,-3, 0, 0, 0,-1, 6, 0, 0,
     .-2,-2,-2,-3,-2,-3,-2,-3,-2,-1, 2,-2,-2,-1,-1,-1,-1, 3, 7, 0,
     .-2,-3,-2,-4,-3,-2,-4,-4,-3,-2,-2,-3,-3,-1,-3,-2,-3, 1, 2,11
     . /
C
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABU1/
     .  5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABU2/
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0,
     .  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/
C
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA ITABS1/
     .  5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 1, 1, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 2, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 3, 3, 3, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
     . /
      DATA ITABS2/
     .  0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 5, 0, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 4, 5, 0, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 5, 0, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 5, 0, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 4, 5, 0, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1, 0, 0, 4, 4, 4, 5, 0, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 0, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 5, 0,
     .  0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 2, 0, 0, 4, 4, 4, 4, 5, 5, 5/
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
C
C -------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
C---------------------------------------------------------------
      CALL SET_ATOM_INDEX(MDOC,ATOM_INDEX,ATOM_NAME)     
C-------
      DO I=1,25
      DO J=1,25
        AMAT(I,J) = 0.0
      ENDDO
      ENDDO
C-------
      CALL ALIGN_INIT_PREP_SS(MDOC,SS_FLAG
     *  ,NC,KC,SS1,ISS1,SS2,ISS2,NMAX1,NMAX2)
C ---
C      IF(SS_FLAG.EQ.'Y') THEN
C        NSS = 0
C        DO L=1,NC
C          IF(SS1(L).EQ.0) THEN
C            ISS1(L) = 0
C          ELSE
C            IF(L.LE.1) THEN
C              IF(SS1(L).NE.0) NSS = 1
C              ISS1(L) = NSS
C            ELSE
C              IF(SS1(L).NE.SS1(L-1)) NSS = NSS + 1 
C            ENDIF
C            ISS1(L) = NSS
C          ENDIF
C        ENDDO
C        NSS = 0
C        DO L=1,KC
C          IF(SS2(L).EQ.0) THEN
C            ISS2(L) = 0
C          ELSE
C            IF(L.LE.1) THEN
C              IF(SS2(L).NE.0) NSS = 1
C              ISS2(L) = NSS
C            ELSE
C              IF(SS2(L).NE.SS2(L-1)) NSS = NSS + 1 
C            ENDIF
C            ISS2(L) = NSS
C          ENDIF
C        ENDDO
C      ELSE
C        DO L=1,NC
C          SS1(L)  = 0
C          ISS1(L) = 0
C        ENDDO
C        DO L=1,KC
C          SS2(L)  = 0
C          ISS2(L) = 0
C        ENDDO
C      ENDIF

      IF(D3_FLAG.EQ.'N') THEN
        DO L=1,NC
          IF(SURF1(L).GE.0) SURF1(L) = 1 
        ENDDO
        DO L=1,KC
          IF(SURF2(L).GE.0) SURF2(L) = 1 
        ENDDO
      ENDIF
C---------------READING AND PREPARETION OF SEQUENCES------------
C      PREPARETION OTHER FACTORS; F.E. PENALTY FACTORS
C----------------------------------------------------------------
      IF(MODE.EQ.'h') MODE='H'
      IF(MODE.EQ.'s') MODE='S'
      IF(MODE.EQ.'k') MODE='K'
      IF(MODE.NE.'1'.AND.MODE.NE.'H'.AND.MODE.NE.'B'.AND.
     *   MODE.NE.'S'.AND.MODE.NE.'K') MODE='G'
      WRITE(LINE,'('' MATRIX (UNIT-1,GOMOLOGY-<G>,HYDROPHOB-H '')')
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''         STRUCTURE-S,KODON-K          ) :'',A)')
     * MODE
      CALL MSGDOC(MDOC,LINE)
C ----
      IF(MODE.EQ.'H') THEN
        DO     I=1,20
        DO     J=1,20
          ITABH(I,J) = 4.-ABS(HYDRO(I)-HYDRO(J))
     .                   +   (HYDRO(I)+HYDRO(J))/2.
        ENDDO
        ENDDO
      ENDIF  
C -----------------------
      TMXN = 1.E 30
      DO     I=1,20
      DO     J=1,20
        IF(MODE.EQ.'1') THEN
          AMAT(I,J)=FLOAT(ITABU(I,J))
        ELSE IF(MODE.EQ.'H') THEN
          AMAT(I,J)=ITABH(I,J)
        ELSE IF(MODE.EQ.'S') THEN
          AMAT(I,J)=FLOAT(ITABS(I,J))
        ELSE IF(MODE.EQ.'B') THEN
          AMAT(I,J)=FLOAT(ITABB(I,J)) + 0.01
        ELSE
          AMAT(I,J)=FLOAT(ITABG(I,J)) + 0.01
        ENDIF
        IF(TMXN.GT.AMAT(I,J))TMXN=AMAT(I,J)
      ENDDO
      ENDDO
C ----------
      TMAX =-1.E 30
      TMIN = 1.E 30
      DO      I=1,20
      DO      J=1,I
        IF(I.NE.J)            AMAT(I,J) = AMAT(J,I)
        IF(AMAT(I,J).GT.TMAX) TMAX      = AMAT(I,J)
        IF(AMAT(I,J).LT.TMIN) TMIN      = AMAT(I,J)
      ENDDO
      ENDDO
      TX =-1.E 30
      TN = 1.E 30
      DO      I=1,20
      DO      J=1,20
C       AMAT(I,J) = (AMAT(I,J)- TMIN)/TMN + 0.0001
        AMAT(I,J) = (AMAT(I,J) - TMIN + 1.0)/(TMAX - TMIN + 1.0)
        IF(AMAT(I,J).GT.TX) TX = AMAT(I,J)
        IF(AMAT(I,J).LT.TN) TN = AMAT(I,J)
      ENDDO
      ENDDO
      WRITE(LINE,'('' MATCH MAX,MIN :'',2F8.3)') TX,TN
      CALL MSGDOC(MDOC,LINE)
      AMAT0 = (1.0 - TMIN)/(TMAX - TMIN + 1.0)
      WRITE(LINE,'('' "0" :'',F8.3)') AMAT0
      CALL MSGDOC(MDOC,LINE)

      DPEN0 = AMAT0

      AMAT12 = (12.0 + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
      AMAT2  = (2.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
      WRITE(LINE,'('' "12,2" :'',2F8.3)') AMAT12,AMAT2
      CALL MSGDOC(MDOC,LINE)

c      AMAT_1  = (-1.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      AMAT_2  = (-2.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      WRITE(LINE,'('' "-1,-2" :'',2F8.3)') AMAT_1,AMAT_2
c      CALL MSGDOC(MDOC,LINE)
c      AMAT_3  = (-3.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      AMAT_4  = (-4.0  + 1.0 - TMIN)/(TMAX - TMIN + 1.0)
c      WRITE(LINE,'('' "-3,-4" :'',2F8.3)') AMAT_3,AMAT_4
c      CALL MSGDOC(MDOC,LINE)
c      DO      I=1,20
c      DO      J=1,20
c        IF(AMAT(I,J).LT.AMAT_1) AMAT(I,J) = 0.0
c      ENDDO
c      write(*,'(20(f4.3,1x))') (AMAT(I,J),j=1,20)
c      ENDDO

C--------------------------------------------------------------
      RETURN
      END

      SUBROUTINE ALIGN_INIT_PREP_SS(MDOC,SS_FLAG
     * ,NC,KC,SS1,ISS1,SS2,ISS2,NMAX1,NMAX2)
C ---------------------------------------------------------------
      INTEGER   MDOC
C ---------------------------------------
      INTEGER   ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   SS1(NMAX1),SS2(NMAX2)
      CHARACTER SS_FLAG*1
      CHARACTER LINE*256
C --------------------------------------------------------
C            IF(SS2(II).EQ.1) THEN
C              SS = 'H'
C            ELSE IF(SS2(II).EQ.2) THEN
C              SS = 'h'
C            ELSE IF(SS2(II).EQ.3) THEN
C              SS = 'B'
C            ELSE IF(SS2(II).EQ.4) THEN
C              SS = 'b'
C            ELSE
C              SS = ' '
C            ENDIF
C -------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
C-------
      IF(SS_FLAG.EQ.'Y') THEN
        ISS_OLD = -1
        IST     = 0
        IFN     = 0
        DO L=1,NC
          ISS = SS1(L)           
          IF(ISS.NE.ISS_OLD) THEN
            IF(IST.NE.0) THEN
C             finish SS            
              IF(ISS_OLD.EQ.3.OR.ISS_OLD.EQ.4) THEN
C               beta
                LEN = IFN -IST + 1
                IF(LEN.LE.3.AND.LEN.GT.0) THEN
                  DO LL=IST,IFN
                    SS1(LL) = 0
                  ENDDO
                ENDIF
              ENDIF
            ENDIF
            IST = 0
            IFN = 0
            IF(ISS.GT.0) THEN
C             start SS            
              IST = L
              IFN = L
            ENDIF
          ENDIF
          IF(IST.NE.0) IFN = L
          ISS_OLD = ISS
        ENDDO
        ISS_OLD = -1
        IST     = 0
        IFN     = 0
        DO L=1,KC
          ISS = SS2(L)           
          IF(ISS.NE.ISS_OLD) THEN
            IF(IST.NE.0) THEN
C             finish SS            
              IF(ISS_OLD.EQ.3.OR.ISS_OLD.EQ.4) THEN
C               beta
                LEN = IFN -IST + 1
                IF(LEN.LE.3.AND.LEN.GT.0) THEN
                  DO LL=IST,IFN
                    SS2(LL) = 0
                  ENDDO
                ENDIF
              ENDIF
            ENDIF
            IST = 0
            IFN = 0
            IF(ISS.GT.0) THEN
C             start SS            
              IST = L
              IFN = L
            ENDIF
          ENDIF
          IF(IST.NE.0) IFN = L
          ISS_OLD = ISS
        ENDDO
C ---
        NSS = 0
        DO L=1,NC
          IF(SS1(L).EQ.0) THEN
            ISS1(L) = 0
          ELSE
            IF(L.LE.1) THEN
              IF(SS1(L).NE.0) NSS = 1
              ISS1(L) = NSS
            ELSE
              IF(SS1(L).NE.SS1(L-1)) NSS = NSS + 1 
            ENDIF
            ISS1(L) = NSS
          ENDIF
        ENDDO
        NSS = 0
        DO L=1,KC
          IF(SS2(L).EQ.0) THEN
            ISS2(L) = 0
          ELSE
            IF(L.LE.1) THEN
              IF(SS2(L).NE.0) NSS = 1
              ISS2(L) = NSS
            ELSE
              IF(SS2(L).NE.SS2(L-1)) NSS = NSS + 1 
            ENDIF
            ISS2(L) = NSS
          ENDIF
        ENDDO
      ELSE
        DO L=1,NC
          SS1(L)  = 0
          ISS1(L) = 0
        ENDDO
        DO L=1,KC
          SS2(L)  = 0
          ISS2(L) = 0
        ENDDO
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE SET_ATOM_INDEX(MDOC,ATOM_INDEX,ATOM_NAME)     
C ---------------------------------------------------------------
      INTEGER   MDOC
C ---------------------------------------
C -----
C     N CA CB CG CD CE CZ C O
      CHARACTER ATOM_NAME(9)*2
C                      g d e z
      INTEGER   ATOM_INDEX(4,25)
C -----

      CHARACTER LINE*256
C --------------------------------------------------------
C -------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
C---------------------------------------------------------------
C -----
      ATOM_NAME(1) = 'N '
      ATOM_NAME(2) = 'CA'
      ATOM_NAME(3) = 'CB'
      ATOM_NAME(4) = 'CG'
      ATOM_NAME(5) = 'CD'
      ATOM_NAME(6) = 'CE'
      ATOM_NAME(7) = 'CZ'
      ATOM_NAME(8) = 'C '
      ATOM_NAME(9) = 'O '
      DO I=1,4
      DO J=1,25
        ATOM_INDEX(I,J) = 0
      ENDDO
      ENDDO
      ATOM_INDEX( 1, 1) = 1
      ATOM_INDEX( 2, 1) = 0 
      ATOM_INDEX( 1, 2) = 1
      ATOM_INDEX( 2, 2) = 0 
      ATOM_INDEX( 1, 3) = 2
      ATOM_INDEX( 2, 3) = 0 
      ATOM_INDEX( 1, 4) = 1
      ATOM_INDEX( 2, 4) = 1 
      ATOM_INDEX( 1, 7) = 1
      ATOM_INDEX( 2, 7) = 2
      ATOM_INDEX( 1, 8) = 1
      ATOM_INDEX( 2, 8) = 2
      ATOM_INDEX( 1, 9) = 1
      ATOM_INDEX( 2, 9) = 1
      ATOM_INDEX( 3, 9) = 2
      ATOM_INDEX( 1,10) = 1
      ATOM_INDEX( 2,10) = 1
      ATOM_INDEX( 3,10) = 2
      ATOM_INDEX( 1,11) = 1
      ATOM_INDEX( 2,11) = 2
      ATOM_INDEX( 3,11) = 2
      ATOM_INDEX( 1,12) = 1
      ATOM_INDEX( 2,12) = 1
      ATOM_INDEX( 3,12) = 1
      ATOM_INDEX( 4,12) = 1
      ATOM_INDEX( 1,13) = 1
      ATOM_INDEX( 2,13) = 1
      ATOM_INDEX( 3,13) = 1
      ATOM_INDEX( 4,13) = 1
      ATOM_INDEX( 1,14) = 1
      ATOM_INDEX( 2,14) = 1
      ATOM_INDEX( 1,15) = 2
      ATOM_INDEX( 2,15) = 1
      ATOM_INDEX( 1,16) = 1
      ATOM_INDEX( 2,16) = 2
      ATOM_INDEX( 1,17) = 2
      ATOM_INDEX( 2,17) = 0
      ATOM_INDEX( 1,18) = 1
      ATOM_INDEX( 2,18) = 2
      ATOM_INDEX( 3,18) = 2
      ATOM_INDEX( 4,18) = 1
      ATOM_INDEX( 1,19) = 1
      ATOM_INDEX( 2,19) = 2
      ATOM_INDEX( 3,19) = 2
      ATOM_INDEX( 4,19) = 1
      ATOM_INDEX( 1,20) = 1
      ATOM_INDEX( 2,20) = 2
      ATOM_INDEX( 3,20) = 2
C-------
      RETURN
      END

      SUBROUTINE SET_AMATRIX(MDOC,MODE,AMATRIX,AMAT
     *  ,NC,NSEQ1,COORD1,SURF1,KC,NSEQ2,COORD2,SURF2
     *  ,NMAX1,NMAX2,IERR)
C ---------------------------------------------------------------
      INTEGER   MDOC
      CHARACTER MODE*1
      REAL      AMATRIX(NMAX1,NMAX2)
      REAL      AMAT(25,25)
      REAL      COORD1(NMAX1,3)
      REAL      COORD2(NMAX2,3)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
C ---------------------------------------
      MD   =-ABS(MDOC)-1
      M    = 99
      IERR = 0
C ----
      IF(MODE.NE.'D') THEN

        DO I=1,NC
          N1  = NSEQ1(I)
          DO J=1,KC
            N2  = NSEQ2(J)
            T = AMAT(N1,N2)
            AMATRIX(I,J) = T
          ENDDO
        ENDDO

      ELSE
        TMAX = -1.0E30
        TMIN =  1.0E30
        DO I=1,NC
          DO J=1,KC
            IF(SURF1(I).LT.0.OR.SURF2(J).LT.0) THEN
              AMATRIX(I,J) = 0.0
            ELSE
              DX = COORD1(I,1) - COORD2(J,1)
              DY = COORD1(I,2) - COORD2(J,2)
              DZ = COORD1(I,3) - COORD2(J,3)
              D2 = DX*DX + DY*DY + DZ*DZ
              N  = 1
              IF(I.GT.1.AND.J.GT.1) THEN
                II = I - 1
                JJ = J - 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC.AND.J.LT.KC) THEN
                II = I + 1
                JJ = J + 1
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.GT.2.AND.J.GT.2) THEN
                II = I - 2
                JJ = J - 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              IF(I.LT.NC-1.AND.J.LT.KC-1) THEN
                II = I + 2
                JJ = J + 2
                IF(SURF1(II).GE.0.AND.SURF2(JJ).GE.0) THEN
                  DX = COORD1(II,1) - COORD2(JJ,1)
                  DY = COORD1(II,2) - COORD2(JJ,2)
                  DZ = COORD1(II,3) - COORD2(JJ,3)
                  D = DX*DX + DY*DY + DZ*DZ
                  D2 = D2 + D
                  N  = N + 1
                ENDIF
              ENDIF
              D2   = D2/FLOAT(N)
              SIG2 = 25.0
              SIG2 = 9.0
              TT   = D2/(2.0*SIG2)
              T    = EXP(-TT)
              AMATRIX(I,J) = T
              IF(T.GT.TMAX) TMAX = T
              IF(T.LT.TMIN) TMIN = T
            ENDIF
          ENDDO
        ENDDO

      ENDIF
C ----
      RETURN
      END

      SUBROUTINE ALIGN_PRINT3(MDOC,NSEQ1,NSEQ2
     *  ,IRES1,IRES2,SCORE1,SCORE2
     *  ,SS1,SS2,SURF1,SURF2,NAM1,NAM2,NC,KC
     *  ,ICHAIN1,ICHAIN2,D3_FLAG
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,AMAT,DPENR,RESULT)
C -------------------------------------
      CHARACTER  AMIN(25)*1,LINE*50,LINE2*50,NAM1*4,NAM2*4,LINE3*50
      CHARACTER  LINE1*50,LINE_SS1*50,LINE_SS2*50,LINE_SURF1*50
      CHARACTER  LINE_1N1*50,LINE_1N2*50,LINE_1N3*50,LINE_1N4*50
      CHARACTER  LINE_2N1*50,LINE_2N2*50,LINE_2N3*50,LINE_2N4*50
      CHARACTER  LS1*50,LS2*50,LS3*50,LS4*50,LS5*50,LINE_SURF2*50
C ----
      REAL      SCORE1(NMAX12), SCORE2(NMAX12),RESULT(*)
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12),ICHAIN1(NMAX1),ICHAIN2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)

      INTEGER   SS1(NMAX1),SS2(NMAX2)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)

C      alloc
C      INTEGER   STR1(NMAX1),STR2(NMAX2)

      CHARACTER DLINE*256,CHAR*4,SS*1,D3_FLAG*1

      INTEGER*2 ICHS
      CHARACTER CHS*2
      EQUIVALENCE (ICHS,CHS)

      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ================================================================
      IERR = 0
      IF(NPAIR.EQ.0) RETURN

C      CALL CALC_SCORE(NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2
C     * ,NPAIR,IPAIR
C     * ,NMAX1,NMAX2,NMAX12,AMAT
C     * ,NC1,KC1,NN,NHOM,HOM
C     * ,SUM_SCORE,SCORE1_MAX,SCORE_MIN,SCORE_SIGMA
C     * ,FIDENT_NEW,DPENR)

      CALL SMOOTH_SCORE(MDOC,DPENR
     *  ,NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2,NPAIR,IPAIR
     *  ,NMAX1,NMAX2,NMAX12,IERR)

      SMAX = -1.0E30
      SMIN =  1.0E30
      DO I=1,NC
        IF(SCORE1(I).GE.0.0) THEN
          T = SCORE1(I)- DPENR
          IF(T.GT.SMAX) SMAX = T
          IF(T.LT.SMIN) SMIN = T
        ENDIF
      ENDDO

      SLIM = ABS(SMIN)
      IF(ABS(SMAX).GT.SLIM) SLIM = ABS(SMAX)
      SLIM = SLIM/2.0


      IPR   = 0
      IC    = 0
      ICC   = 0

      IPR = IPR+1

      ISE = IPAIR(1,IPR) 
      JSE = IPAIR(2,IPR)
      
      LINE     = ' '
      LINE1    = ' '
      LINE2    = ' '
      LINE3    = ' '
      LINE_1N1 = ' '
      LINE_1N2 = ' '
      LINE_1N3 = ' '
      LINE_1N4 = ' '
      LINE_SS1 = ' '
      LINE_2N1 = ' '
      LINE_2N2 = ' '
      LINE_2N3 = ' '
      LINE_2N4 = ' '
      LINE_SS2 = ' '
      LINE_SURF1= ' '
      LINE_SURF2= ' '
      LS1=      ' '
      LS2=      ' '
      LS3=      ' '
      LS4=      ' '
      LS5=      ' '

      CALL MSGDOC(MDOC,' ')
      IF(ISE.EQ.1)THEN
        IF(JSE.GT.1)THEN
          DO     II=1,JSE-1
            IF(ICC.GE.50)THEN
              CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC              = ICC+1
            IC               = IC+1

            LINE(ICC:ICC)    =' '
            LINE1(ICC:ICC)   =' '
            LINE_1N1(ICC:ICC)=' '
            LINE_1N2(ICC:ICC)=' '
            LINE_1N3(ICC:ICC)=' '
            LINE_1N4(ICC:ICC)=' '
            LINE_SS1(ICC:ICC)=' '
            LINE_SURF1(ICC:ICC)=' '
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

            N2               = NSEQ2(II)
            LINE_2N1(ICC:ICC)=' '
            LINE_2N2(ICC:ICC)=' '
            LINE_2N3(ICC:ICC)=' '
            LINE_2N4(ICC:ICC)=' '
            LINE2(ICC:ICC)   = AMIN(N2)
            IF(N2.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES2(II)
              LINE_2N1(ICC:ICC)= CHAR(1:1)
              LINE_2N2(ICC:ICC)= CHAR(2:2)
              LINE_2N3(ICC:ICC)= CHAR(3:3)
              LINE_2N4(ICC:ICC)= CHAR(4:4)
            ENDIF

C           LINE_SS2(ICC:ICC)= SS2(II)
            IF(SS2(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS2(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS2(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS2(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS2(ICC:ICC)= SS

            SS = ' '
            IF(SURF2(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF2(II)
            ENDIF
            LINE_SURF2(ICC:ICC)= SS


          ENDDO
        ENDIF
c     ELSE IF(JSE.EQ.1) THEN
      ELSE 
        IF(ISE.GT.1)THEN
          DO     II=1,ISE-1
            IF(ICC.GE.50)THEN
              CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC              = ICC+1
            IC               = IC+1

            LINE2(ICC:ICC)    =' '
            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            LINE_SS2(ICC:ICC) =' '
            LINE_SURF2(ICC:ICC)= ' '

            N1               = NSEQ1(II)
            LINE(ICC:ICC)    = AMIN(N1)

C            ICHS             = STR1(II)
C            LINE1(ICC:ICC)   = CHS(2:2)
             LINE1(ICC:ICC)   = ' '
            LINE_1N1(ICC:ICC) =' '
            LINE_1N2(ICC:ICC) =' '
            LINE_1N3(ICC:ICC) =' '
            LINE_1N4(ICC:ICC) =' '
            IF(N1.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES1(II)
              LINE_1N1(ICC:ICC)= CHAR(1:1)
              LINE_1N2(ICC:ICC)= CHAR(2:2)
              LINE_1N3(ICC:ICC)= CHAR(3:3)
              LINE_1N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS1(ICC:ICC)= SS1(II)
            IF(SS1(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS1(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS1(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS1(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS1(ICC:ICC)= SS
            SS = ' '
            IF(SURF1(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF1(II)
            ENDIF
            LINE_SURF1(ICC:ICC)= SS
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

          ENDDO
        ENDIF
c      ELSE

      ENDIF

      IF(ICC.GE.50)THEN
        CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
        ICC = 0
      ENDIF
      ICC = ICC + 1
      IC  = IC  + 1

      N1               = NSEQ1(ISE)
      LINE(ICC:ICC)    = AMIN(N1)

C      ICHS             = STR1(ISE)
C      LINE1(ICC:ICC)   = CHS(2:2)
      LINE1(ICC:ICC)   = ' '

      LINE_1N1(ICC:ICC) =' '
      LINE_1N2(ICC:ICC) =' '
      LINE_1N3(ICC:ICC) =' '
      LINE_1N4(ICC:ICC) =' '
      IF(N1.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES1(ISE)
        LINE_1N1(ICC:ICC)= CHAR(1:1)
        LINE_1N2(ICC:ICC)= CHAR(2:2)
        LINE_1N3(ICC:ICC)= CHAR(3:3)
        LINE_1N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS1(ICC:ICC)= SS1(ISE)
      IF(SS1(ISE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS1(ISE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS1(ISE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS1(ISE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS1(ICC:ICC)= SS
      SS = ' '
      IF(SURF1(ISE).GT.0) THEN
        WRITE(SS,'(I1)') SURF1(ISE)
      ENDIF
      LINE_SURF1(ICC:ICC)= SS

      SCR = SCORE1(ISE) - DPENR
      IF(SCR.GE.0) THEN
        ISC = (SCR/SLIM)*2.0 + 3.0
        IF(ISC.LT.4) THEN
          ISC = 1
        ELSE IF(ISC.GT.5) THEN
          ISC = 5
        ENDIF
      ELSE IF(SCR.LT.0) THEN
        ISC = (ABS(SCR)/SLIM)*2.0 + 1.0
        IF(ISC.LT.2) THEN
          ISC = 6
        ELSE IF(ISC.GT.3) THEN
          ISC = 3
        ENDIF
      ELSE 
        ISC =-1
      ENDIF
      IF(ISC.LT.0) THEN
        ISC =-1
      ENDIF
      IF(ISC.LT.0) LS3(ICC:ICC) = '.'
      IF(ISC.EQ.0) LS3(ICC:ICC) = '0'
      IF(ISC.EQ.1) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.6) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS1(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.4) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.4) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS5(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS3(ICC:ICC) = '+'

      N2               = NSEQ2(JSE)
      LINE2(ICC:ICC)   = AMIN(N2)

      LINE_2N1(ICC:ICC) =' '
      LINE_2N2(ICC:ICC) =' '
      LINE_2N3(ICC:ICC) =' '
      LINE_2N4(ICC:ICC) =' '
      IF(N2.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES2(JSE)
        LINE_2N1(ICC:ICC)= CHAR(1:1)
        LINE_2N2(ICC:ICC)= CHAR(2:2)
        LINE_2N3(ICC:ICC)= CHAR(3:3)
        LINE_2N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS2(ICC:ICC)= SS2(JSE)
      IF(SS2(JSE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS2(JSE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS2(JSE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS2(JSE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS2(ICC:ICC)= SS

      SS = ' '
      IF(SURF2(JSE).GT.0) THEN
        WRITE(SS,'(I1)') SURF2(JSE)
      ENDIF
      LINE_SURF2(ICC:ICC)= SS


      IF(N1.EQ.N2.AND.N1.LT.24)THEN
        LINE3(ICC:ICC) = '*'
      ENDIF

C ---
 20   IPR = IPR + 1

      I1 = IPAIR(1,IPR)
      J1 = IPAIR(2,IPR)

      IF(I1-ISE.GT.1)THEN

        DO     II=ISE+1,I1-1
         IF(ICC.GE.50)THEN
            CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *      ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *      ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
            ICC = 0
          ENDIF
          ICC = ICC + 1
          IC  = IC + 1
          N1  = NSEQ1(II)

          LINE(ICC:ICC)     = AMIN(N1)

C          ICHS             = STR1(II)
C          LINE1(ICC:ICC)   = CHS(2:2)
          LINE1(ICC:ICC)   = ' '

          LINE_1N1(ICC:ICC) =' '
          LINE_1N2(ICC:ICC) =' '
          LINE_1N3(ICC:ICC) =' '
          LINE_1N4(ICC:ICC) =' '
          IF(N1.LT.24) THEN
            WRITE(CHAR,'(I4)') IRES1(II)
            LINE_1N1(ICC:ICC) = CHAR(1:1)
            LINE_1N2(ICC:ICC) = CHAR(2:2)
            LINE_1N3(ICC:ICC) = CHAR(3:3)
            LINE_1N4(ICC:ICC) = CHAR(4:4)
          ENDIF
C          LINE_SS1(ICC:ICC) = SS1(II)
          IF(SS1(II).EQ.1) THEN
            SS = 'H'
          ELSE IF(SS1(II).EQ.2) THEN
            SS = 'h'
          ELSE IF(SS1(II).EQ.3) THEN
            SS = 'B'
          ELSE IF(SS1(II).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF
          LINE_SS1(ICC:ICC)= SS
          SS = ' '
          IF(SURF1(II).GT.0) THEN
            WRITE(SS,'(I1)') SURF1(II)
          ENDIF
          LINE_SURF1(ICC:ICC)= SS
          LS1(ICC:ICC)=      ' '
          LS2(ICC:ICC)=      ' '
          LS3(ICC:ICC)=      ' '
          LS4(ICC:ICC)=      ' '
          LS5(ICC:ICC)=      ' '

          LINE2(ICC:ICC)    = '_'
          IF(J1-JSE.GT.1)THEN
            DO III=JSE+1,J1-1
              N2 = NSEQ2(III)
              IF(N2.GE.24) THEN
                LINE2(ICC:ICC) = AMIN(N2)
              ENDIF
            ENDDO
          ENDIF
          LINE_2N1(ICC:ICC) = ' '
          LINE_2N2(ICC:ICC) = ' '
          LINE_2N3(ICC:ICC) = ' '
          LINE_2N4(ICC:ICC) = ' '
          LINE_SS2(ICC:ICC) = ' ' 
          LINE_SURF2(ICC:ICC)= ' '
        ENDDO

      ELSE IF(J1-JSE.GT.1)THEN

        DO     II=JSE+1,J1-1
          IF(ICC.GE.50)THEN
            CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *      ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *      ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
            ICC = 0
          ENDIF
          ICC = ICC + 1
          IC = IC + 1
          N2               = NSEQ2(II)
          LINE2(ICC:ICC)   = AMIN(N2)

          LINE_2N1(ICC:ICC) =' '
          LINE_2N2(ICC:ICC) =' '
          LINE_2N3(ICC:ICC) =' '
          LINE_2N4(ICC:ICC) =' '
          IF(N2.LT.24) THEN
            WRITE(CHAR,'(I4)') IRES2(II)
            LINE_2N1(ICC:ICC)= CHAR(1:1)
            LINE_2N2(ICC:ICC)= CHAR(2:2)
            LINE_2N3(ICC:ICC)= CHAR(3:3)
            LINE_2N4(ICC:ICC)= CHAR(4:4)
          ENDIF
C          LINE_SS2(ICC:ICC)= SS2(II)
          IF(SS2(II).EQ.1) THEN
            SS = 'H'
          ELSE IF(SS2(II).EQ.2) THEN
            SS = 'h'
          ELSE IF(SS2(II).EQ.3) THEN
            SS = 'B'
          ELSE IF(SS2(II).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF
          LINE_SS2(ICC:ICC)= SS

          SS = ' '
          IF(SURF2(II).GT.0) THEN
            WRITE(SS,'(I1)') SURF2(II)
          ENDIF
          LINE_SURF2(ICC:ICC)= SS

          LINE(ICC:ICC)    ='_'
          IF(I1-ISE.GT.1)THEN
            DO III=ISE+1,I1-1
              N1 = NSEQ1(III)
              IF(N1.GE.24) THEN
                LINE(ICC:ICC) = AMIN(N1)
              ENDIF
            ENDDO
          ENDIF
          LINE1(ICC:ICC)   =' '
          LINE_1N1(ICC:ICC)=' '
          LINE_1N2(ICC:ICC)=' '
          LINE_1N3(ICC:ICC)=' '
          LINE_1N4(ICC:ICC)=' '
          LINE_SS1(ICC:ICC)=' '
          LINE_SURF1(ICC:ICC)=' '
          LS1(ICC:ICC)=      ' '
          LS2(ICC:ICC)=      ' '
          LS3(ICC:ICC)=      ' '
          LS4(ICC:ICC)=      ' '
          LS5(ICC:ICC)=      ' '
        ENDDO
      ENDIF

      JSE = J1
      ISE = I1
C----
      IF(ICC.GE.50)THEN
        CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
        ICC=0
      ENDIF
      ICC = ICC + 1
      IC  = IC  + 1

      N1               = NSEQ1(ISE)
      LINE(ICC:ICC)    = AMIN(N1)

C      ICHS             = STR1(ISE)
C      LINE1(ICC:ICC)   = CHS(2:2)
      LINE1(ICC:ICC)   = ' '

      LINE_1N1(ICC:ICC) =' '
      LINE_1N2(ICC:ICC) =' '
      LINE_1N3(ICC:ICC) =' '
      LINE_1N4(ICC:ICC) =' '
      IF(N1.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES1(ISE)
        LINE_1N1(ICC:ICC)= CHAR(1:1)
        LINE_1N2(ICC:ICC)= CHAR(2:2)
        LINE_1N3(ICC:ICC)= CHAR(3:3)
        LINE_1N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS1(ICC:ICC)= SS1(ISE)
      IF(SS1(ISE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS1(ISE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS1(ISE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS1(ISE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS1(ICC:ICC)= SS
      SS = ' '
      IF(SURF1(ISE).GT.0) THEN
        WRITE(SS,'(I1)') SURF1(ISE)
      ENDIF
      LINE_SURF1(ICC:ICC)= SS

      SCR = SCORE1(ISE) - DPENR
      IF(SCR.GE.0) THEN
        ISC = (SCR/SLIM)*2.0 + 3.0
        IF(ISC.LT.4) THEN
          ISC = 1
        ELSE IF(ISC.GT.5) THEN
          ISC = 5
        ENDIF
      ELSE IF(SCR.LT.0) THEN
        ISC = (ABS(SCR)/SLIM)*2.0 + 1.0
        IF(ISC.LT.2) THEN
          ISC = 6
        ELSE IF(ISC.GT.3) THEN
          ISC = 3
        ENDIF
      ELSE 
        ISC =-1
      ENDIF
      IF(ISC.LT.0) THEN
        ISC =-1
      ENDIF
      IF(ISC.LT.0) LS3(ICC:ICC) = '.'
      IF(ISC.EQ.0) LS3(ICC:ICC) = '0'
      IF(ISC.EQ.1) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.6) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.2) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS1(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS2(ICC:ICC) = '-'
      IF(ISC.EQ.3) LS3(ICC:ICC) = '-'
      IF(ISC.EQ.4) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.4) LS3(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS5(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS4(ICC:ICC) = '+'
      IF(ISC.EQ.5) LS3(ICC:ICC) = '+'

      N2               = NSEQ2(JSE)
      LINE2(ICC:ICC)   = AMIN(N2)

      LINE_2N1(ICC:ICC) =' '
      LINE_2N2(ICC:ICC) =' '
      LINE_2N3(ICC:ICC) =' '
      LINE_2N4(ICC:ICC) =' '
      IF(N2.LT.24) THEN
        WRITE(CHAR,'(I4)') IRES2(JSE)
        LINE_2N1(ICC:ICC)= CHAR(1:1)
        LINE_2N2(ICC:ICC)= CHAR(2:2)
        LINE_2N3(ICC:ICC)= CHAR(3:3)
        LINE_2N4(ICC:ICC)= CHAR(4:4)
      ENDIF
C      LINE_SS2(ICC:ICC)= SS2(JSE)
      IF(SS2(JSE).EQ.1) THEN
        SS = 'H'
      ELSE IF(SS2(JSE).EQ.2) THEN
        SS = 'h'
      ELSE IF(SS2(JSE).EQ.3) THEN
        SS = 'B'
      ELSE IF(SS2(JSE).EQ.4) THEN
        SS = 'b'
      ELSE
        SS = ' '
      ENDIF
      LINE_SS2(ICC:ICC)= SS

      SS = ' '
      IF(SURF2(JSE).GT.0) THEN
        WRITE(SS,'(I1)') SURF2(JSE)
      ENDIF
      LINE_SURF2(ICC:ICC)= SS

      IF(N1.EQ.N2.AND.N1.LT.24)THEN
        LINE3(ICC:ICC) = '*'
      ENDIF

      IF(IPR.LT.NPAIR) GO TO 20
C ------------------------
100   IF(ISE.EQ.NC)THEN
        IF(JSE.LT.KC)THEN
          DO     II=JSE+1,KC
            IF(ICC.GE.50)THEN
              CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
             ICC = 0
            ENDIF
            ICC = ICC + 1
            IC  = IC  + 1

            LINE(ICC:ICC)    =' '
            LINE1(ICC:ICC)   =' '
            LINE_1N1(ICC:ICC)=' '
            LINE_1N2(ICC:ICC)=' '
            LINE_1N3(ICC:ICC)=' '
            LINE_1N4(ICC:ICC)=' '
            LINE_SS1(ICC:ICC)=' '
            LINE_SURF1(ICC:ICC)=' '
            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

            N2               = NSEQ2(II)
            LINE2(ICC:ICC)   = AMIN(N2)

            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            IF(N2.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES2(II)
              LINE_2N1(ICC:ICC)= CHAR(1:1)
              LINE_2N2(ICC:ICC)= CHAR(2:2)
              LINE_2N3(ICC:ICC)= CHAR(3:3)
              LINE_2N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS2(ICC:ICC)= SS2(II)
            IF(SS2(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS2(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS2(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS2(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS2(ICC:ICC)= SS

            SS = ' '
            IF(SURF2(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF2(II)
            ENDIF
            LINE_SURF2(ICC:ICC)= SS

          ENDDO
        ENDIF
c      ELSE IF(JSE.EQ.KC) THEN
      ELSE 
        IF(ISE.LT.NC)THEN
            DO     II=ISE+1,NC
            IF(ICC.GE.50)THEN
              CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *        ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *        ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)
              ICC=0
            ENDIF
            ICC = ICC + 1
            IC  = IC  + 1

            LINE2(ICC:ICC)    =' '
            LINE_2N1(ICC:ICC) =' '
            LINE_2N2(ICC:ICC) =' '
            LINE_2N3(ICC:ICC) =' '
            LINE_2N4(ICC:ICC) =' '
            LINE_SS2(ICC:ICC) =' '
            LINE_SURF2(ICC:ICC)= ' '

            N1               = NSEQ1(II)
            LINE(ICC:ICC)    = AMIN(N1)

C            ICHS             = STR1(II)
C            LINE1(ICC:ICC)   = CHS(2:2)
            LINE1(ICC:ICC)   = ' '

            LINE_1N1(ICC:ICC) =' '
            LINE_1N2(ICC:ICC) =' '
            LINE_1N3(ICC:ICC) =' '
            LINE_1N4(ICC:ICC) =' '
            IF(N1.LT.24) THEN
              WRITE(CHAR,'(I4)') IRES1(II)
              LINE_1N1(ICC:ICC)= CHAR(1:1)
              LINE_1N2(ICC:ICC)= CHAR(2:2)
              LINE_1N3(ICC:ICC)= CHAR(3:3)
              LINE_1N4(ICC:ICC)= CHAR(4:4)
            ENDIF
C            LINE_SS1(ICC:ICC)= SS1(II)
            IF(SS1(II).EQ.1) THEN
              SS = 'H'
            ELSE IF(SS1(II).EQ.2) THEN
              SS = 'h'
            ELSE IF(SS1(II).EQ.3) THEN
              SS = 'B'
            ELSE IF(SS1(II).EQ.4) THEN
              SS = 'b'
            ELSE
              SS = ' '
            ENDIF
            LINE_SS1(ICC:ICC)= SS
            SS = ' '
            IF(SURF1(II).GT.0) THEN
              WRITE(SS,'(I1)') SURF1(II)
            ENDIF
            LINE_SURF1(ICC:ICC)= SS

            LS1(ICC:ICC)=      ' '
            LS2(ICC:ICC)=      ' '
            LS3(ICC:ICC)=      ' '
            LS4(ICC:ICC)=      ' '
            LS5(ICC:ICC)=      ' '

          ENDDO
        ENDIF
c     ELSE
      ENDIF

      CALL WRIT2(MDOC,LINE,NAM1,NAM2,LINE1,LINE2,LINE3
     *  ,LINE_1N1,LINE_1N2,LINE_1N3,LINE_1N4,LINE_SS1,LINE_SURF1
     *        ,LS1,LS2,LS3,LS4,LS5
     *  ,LINE_2N1,LINE_2N2,LINE_2N3,LINE_2N4,LINE_SS2,LINE_SURF2)

      WRITE(DLINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,DLINE)
      NC1 = RESULT(1)
      WRITE(DLINE,'('' NUMBER OF AMINO ACIDS IN 1-ST SEQ='',I5)')NC1
      CALL MSGDOC(MDOC,DLINE)
      KC1 = RESULT(2)
      WRITE(DLINE,'('' NUMBER OF AMINO ACIDS IN 2-ND SEQ='',I5)')KC1
      CALL MSGDOC(MDOC,DLINE)
      NN = RESULT(3)
      WRITE(DLINE,'('' NUMBER OF ALIGNED AMINO ACIDS    ='',I5)')NN
      CALL MSGDOC(MDOC,DLINE)
      NHOM = RESULT(4)
      WRITE(DLINE,'('' NUMBER OF IDENTICAL AMINO ACIDS  ='',I5)')NHOM
      CALL MSGDOC(MDOC,DLINE)
      HOM = RESULT(5)
      WRITE(DLINE,'('' IDENTITY                         ='',F8.3)')HOM
      CALL MSGDOC(MDOC,DLINE)
      SUM_SCORE = RESULT(6)
      WRITE(DLINE,'('' <SCORE>                          ='',F8.3)') 
     * SUM_SCORE 
      CALL MSGDOC(MDOC,DLINE)
      SCORE1_MAX = RESULT(13)
      WRITE(DLINE,'('' <SCORE_MAX> (for 1-st seq)       ='',F8.3)') 
     * SCORE1_MAX
      CALL MSGDOC(MDOC,DLINE)
      SCORE_MIN   = RESULT(14)
      WRITE(DLINE,'('' <SCORE_MIN> (for 1-st seq)       ='',F8.4)') 
     * SCORE_MIN
      CALL MSGDOC(MDOC,DLINE)
      SCORE_NEW = RESULT(18)
      WRITE(DLINE,'('' <SCORE_NEW>                      ='',F8.3)') 
     * SCORE_NEW
      CALL MSGDOC(MDOC,DLINE)
      FIDENT_NEW = RESULT(19)
      WRITE(DLINE,'('' IDENT_NEW                        ='',F8.3)') 
     * FIDENT_NEW
      CALL MSGDOC(MDOC,DLINE)
      NGAP = RESULT(20) 
      WRITE(DLINE,'('' N_gap                            ='',I6)') 
     * NGAP
      CALL MSGDOC(MDOC,DLINE)
      WRITE(DLINE,
     *'('' ------------------------------------------------'')')
      CALL MSGDOC(MDOC,DLINE)
C
      RETURN
      END

      SUBROUTINE CHECK_FIT_D(MDOC,COORD1,COORD2
     * ,NSEQ1,NSEQ2,SURF1,SURF2,IRES1,IRES2,N1,N2,SCORE1
     * ,NPAIR,IPAIR,NMAX1,NMAX2,NMAX12,AMAT,IPRINT
     * ,RESULT,IPRROW,IERR)
C ---------------------------------------------------------
      REAL      AMAT(25,25),RESULT(IPRROW)
      REAL      SCORE1(NMAX12)
      REAL      COORD1(NMAX1,3)
      REAL      COORD2(NMAX2,3)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   SURF1(NMAX1),SURF2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
C ---
      REAL      TR(3),TRMAT(3,3),V(3)
      REAL      CNTRX_INI(3),CNTRX_BEST(3)
      REAL      CNTRY_INI(3),CNTRY_BEST(3)
C ---
c      PARAMETER ( IPRCHK = 3000 )
c      REAL      X(3,IPRCHK),Y(3,IPRCHK)
c      INTEGER   IPAIR_FIN(2,IPRCHK)
c      INTEGER   IPAIR_INI(2,IPRCHK)
c      INTEGER   ITEMP1(IPRCHK)
c      INTEGER   ITEMP2(IPRCHK)
      real,      allocatable :: X(:,:)
      real,      allocatable :: Y(:,:)
      integer,   allocatable :: IPAIR_FIN(:,:)
      integer,   allocatable :: IPAIR_INI(:,:)
      integer,   allocatable :: ITEMP1(:)
      integer,   allocatable :: ITEMP2(:)
c  ---
      CHARACTER LINE*256
C ----------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      SMAX = -1.0E30
      DO I=1,N1
        IF(SCORE1(I).GE.0.0.AND.SCORE1(I).GT.SMAX) SMAX = SCORE1(I)
      ENDDO
      DO I=1,N1
        IF(SURF1(I).GE.0) THEN
          SCORE1(I) = SCORE1(I)/SMAX
        ELSE
          SCORE1(I) =-2
        ENDIF
      ENDDO 

      DLIM      = 1.0
      SCORE_LIM = 0.0
      Q_FIN     = 0.0
      DRMS_BEST =-0.1
      NPAIR_BEST= 0

      RESULT(15) = Q_FIN
      RESULT(16) = DRMS_BEST 
      RESULT(17) = NPAIR_BEST 

      IF(NPAIR.LE.3) THEN
        RETURN
      ENDIF

      allocate(X(1:3,1:NMAX12),STAT=ISTAT)
      allocate(Y(1:3,1:NMAX12),STAT=ISTAT)
      allocate(ITEMP1(1:NMAX12),STAT=ISTAT)
      allocate(ITEMP2(1:NMAX12),STAT=ISTAT)
      allocate(IPAIR_FIN(1:2,1:NMAX12),STAT=ISTAT)
      allocate(IPAIR_INI(1:2,1:NMAX12),STAT=ISTAT)

      II = 0
      DO I=1,NPAIR
        I1 = IPAIR(1,I)
        I2 = IPAIR(2,I)

        IF((SCORE1(I1).GE.SCORE_LIM).AND.SURF2(I2).GE.0.AND.
     *     (NSEQ1(I1).LT.24.AND.NSEQ2(I2).LT.24)) THEN

        II = II + 1
        X(1,II) = COORD1(I1,1) 
        X(2,II) = COORD1(I1,2) 
        X(3,II) = COORD1(I1,3) 
        Y(1,II) = COORD2(I2,1) 
        Y(2,II) = COORD2(I2,2) 
        Y(3,II) = COORD2(I2,3) 

        DX  = X(1,II) - Y(1,II)  
        DY  = X(2,II) - Y(2,II)  
        DZ  = X(3,II) - Y(3,II)  
        D   = SQRT(DX*DX + DY*DY + DZ*DZ)

        IPAIR_FIN(1,II) = II
        IPAIR_FIN(2,II) = II
        IPAIR_INI(1,II) = I1
        IPAIR_INI(2,II) = I2

C        WRITE(*,*) II,i1,i2,NSEQ1(I1),NSEQ2(I2),D

          SCORE1(I1) = 1.0

        ELSE

C          WRITE(*,*) II,i1,i2,IRES1(I1),IRES2(I2)

          SCORE1(I1) = 0.0
       
        ENDIF

      ENDDO

C      RETURN

      NP = II
      IF(NP.LE.3) THEN
        CALL MSGDOC(MDoc,'ERROR: in CHECK_FIT_D: NP < 4')
        GO TO 900
      ENDIF

      CALL ALIGN_FIT_D(M,DLIM,Y,X,NP,NP,IPAIR_FIN
     * ,TR,TRMAT
     * ,CNTRX_INI,CNTRX_BEST
     * ,CNTRY_INI,CNTRY_BEST
     * ,NPAIR_INI,DRMS_INI,DMAX_INI,CHI_INI,DIST_INI
     * ,NPAIR_BEST,DRMS_BEST,DMAX_BEST,CHI_BEST,DIST_BEST
     * ,Q_FIN,NMAX12,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: ALIGN_FIT_D')
        GO TO 900
      ENDIF
C      WRITE(LINE,*)'==BEST NP,RMS:',NPAIR_BEST,DRMS_BEST,DMAX_BEST
C     * ,NSW    
C      CALL MSGDOC(MDoc,LINE)

      CALL MSGDOC(MDOC,' ----- initial -----')
      WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR_INI,DRMS_INI,DMAX_INI      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_INI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  DIST         '',1X,F10.5)')
     *   DIST_INI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_INI(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')
      CALL MSGDOC(MDOC,' ----- best    -----')
      WRITE(LINE,*) ' Q,Npair,RMS,MAX:'
     *  ,Q_FIN,NPAIR_BEST,DRMS_BEST,DMAX_BEST      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(''  DIST         '',1X,F10.5)')
     *   DIST_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_BEST(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')

      IF(IPRINT.GT.1) THEN

        DO I=1,NPAIR_BEST
          ITEMP1(I) = IPAIR_FIN(1,I) 
          ITEMP2(I) = IPAIR_FIN(2,I) 
        ENDDO

        CALL ISORT1(ITEMP1,NPAIR_BEST,ITEMP2)

        DO I=1,NPAIR_BEST
          IPAIR_FIN(1,I) = ITEMP1(I)
          IPAIR_FIN(2,I) = ITEMP2(I)
        ENDDO

        DO I=1,N1
          SCORE1(I) = 0.0
        ENDDO 

        DO I=1,NPAIR_BEST

          II1  = IPAIR_FIN(1,I)
          II2  = IPAIR_FIN(2,I)

          I1 = IPAIR_INI(1,II1)
          I2 = IPAIR_INI(2,II2)

          SCORE1(I1) = 1.0

          DX = COORD1(I1,1)- COORD2(I2,1)
          DY = COORD1(I1,2)- COORD2(I2,2)
          DZ = COORD1(I1,3)- COORD2(I2,3)
          D1 = SQRT(DX*DX + DY*DY + DZ*DZ)

          DX  = X(1,Ii1) - Y(1,Ii2)  
          DY  = X(2,Ii1) - Y(2,Ii2)  
          DZ  = X(3,Ii1) - Y(3,Ii2)  
          D2  = SQRT(DX*DX + DY*DY + DZ*DZ)

C        WRITE(*,*) I,II1,II2,I1,I2,IRES1(I1),IRES2(I2),D1,D2

        ENDDO

        DO I=1,NPAIR_BEST
          II1  = IPAIR_FIN(1,I)
          II2  = IPAIR_FIN(2,I)
          I1 = IPAIR_INI(1,II1)
          I2 = IPAIR_INI(2,II2)
          IPAIR(1,I) = I1
          IPAIR(2,I) = I2
        ENDDO 
        NPAIR = NPAIR_BEST

      ENDIF

      RESULT(15) = Q_FIN
      RESULT(16) = DRMS_BEST 
      RESULT(17) = NPAIR_BEST 
      IF(IPRROW.GE.41) THEN
        RESULT(21) = CHI_INI
        RESULT(22) = DIST_INI
        RESULT(23) = DRMS_INI
        RESULT(24) = CHI_BEST
        RESULT(25) = DIST_BEST
        RESULT(30) = TR(1)
        RESULT(31) = TR(2)
        RESULT(32) = TR(3)
        RESULT(33) = TRMAT(1,1)
        RESULT(34) = TRMAT(1,2)
        RESULT(35) = TRMAT(1,3)
        RESULT(36) = TRMAT(2,1)
        RESULT(37) = TRMAT(2,2)
        RESULT(38) = TRMAT(2,3)
        RESULT(39) = TRMAT(3,1)
        RESULT(40) = TRMAT(3,2)
        RESULT(41) = TRMAT(3,3)
      ENDIF
  900 CONTINUE

      deallocate(X,STAT=ISTAT)
      deallocate(Y,STAT=ISTAT)
      deallocate(ITEMP1,STAT=ISTAT)
      deallocate(ITEMP2,STAT=ISTAT)
      deallocate(IPAIR_FIN,STAT=ISTAT)
      deallocate(IPAIR_INI,STAT=ISTAT)

C ---
      RETURN
      END

      SUBROUTINE ALIGN_FIT_D(MDOC,DLIM,X,Y,NX,NY,IPAIR_FIN
     * ,TR_BEST,TRMAT_BEST
     * ,CNTRX_INI,CNTRX_BEST
     * ,CNTRY_INI,CNTRY_BEST
     * ,NPAIR_INI,DRMS_INI,DMAX_INI,CHI_INI,DIST_INI
     * ,NPAIR_BEST,DRMS_BEST,DMAX_BEST,CHI_BEST,DIST_BEST
     * ,Q_FIN,NMAX12,IERR)
C ---------------------------------------------------------
C
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     Y      CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NX     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION
C            MATRIX
C --------------------------------------------------------
      REAL      TR_BEST(3),TRMAT_BEST(3,3)
      REAL      TR_INI(3),TRMAT_INI(3,3)
      REAL      TR(3),TRMAT(3,3),V(3)
      INTEGER   IPAIR_FIN(2,*)
C ---
      REAL      X(3,*),Y(3,*)
      REAL      CNTRX_INI(3),CNTRX_BEST(3),CNTRX(3)
      REAL      CNTRY_INI(3),CNTRY_BEST(3),CNTRY(3)

C      PARAMETER ( IPRCHK = 3000 )
C      REAL      X0(3,IPRCHK)
C      REAL      XX(3,IPRCHK),YY(3,IPRCHK)
C      REAL      SCORE_OLD(IPRCHK),SCORE_MAX(IPRCHK),TEMP(IPRCHK)
C     *         ,TEMP1(IPRCHK)
C      REAL      SCORE_OLD_N(IPRCHK),SCORE_MAX_N(IPRCHK)
C      INTEGER   ITEMP(IPRCHK)
C      INTEGER   IPAIR(2,IPRCHK,IPRCHK),ISC_MAX(IPRCHK)
C     *         ,ISC_MAX_N(IPRCHK)


      integer,   allocatable :: ITEMP(:)
      integer,   allocatable :: ISC_MAX_N(:)
      integer,   allocatable :: ISC_MAX(:)
      integer,   allocatable :: IPAIR(:,:,:)
      real,      allocatable :: X0(:,:)
      real,      allocatable :: XX(:,:)
      real,      allocatable :: YY(:,:)
      real,      allocatable :: SCORE_OLD(:)
      real,      allocatable :: SCORE_MAX(:)
      real,      allocatable :: TEMP(:)
      real,      allocatable :: TEMP1(:)
      real,      allocatable :: SCORE_OLD_N(:)
      real,      allocatable :: SCORE_MAX_N(:)

      CHARACTER LINE*256
C ----------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      allocate(X0(1:3,1:NMAX12),STAT=ISTAT)
      allocate(XX(1:3,1:NMAX12),STAT=ISTAT)
      allocate(YY(1:3,1:NMAX12),STAT=ISTAT)
      allocate(SCORE_OLD(1:NMAX12),STAT=ISTAT)
      allocate(SCORE_MAX(1:NMAX12),STAT=ISTAT)
      allocate(TEMP(1:NMAX12),STAT=ISTAT)
      allocate(TEMP1(1:NMAX12),STAT=ISTAT)
      allocate(SCORE_OLD_N(1:NMAX12),STAT=ISTAT)
      allocate(SCORE_MAX_N(1:NMAX12),STAT=ISTAT)
      allocate(ITEMP(1:NMAX12),STAT=ISTAT)
      allocate(IPAIR(1:2,1:NMAX12,1:NMAX12),STAT=ISTAT)
      allocate(ISC_MAX(1:NMAX12),STAT=ISTAT)
      allocate(ISC_MAX_N(1:NMAX12),STAT=ISTAT)

      Q_FIN     = 0.0
      NPAIR_INI = NX
      CALL MSGDOC(MDOC,' ----- initial ----.')

      DO I=1,3
        TR_BEST(I) = 0.0
        DO J=1,3
          TRMAT_BEST(I,J) = 0.0
          IF(I.EQ.J) TRMAT_BEST(I,J) = 1.0 
        ENDDO
      ENDDO

      DO IA=1,NX
        X0(1,IA) = X(1,IA)
        X0(2,IA) = X(2,IA)
        X0(3,IA) = X(3,IA)
      ENDDO

      CALL LSKAB_CHECK_FIT_D(M
     * ,X,Y,NX,TRMAT,TR,DRMS,DISMAX,DCENTRE
     * ,CNTRX,CNTRY,IERR)
      IF(IERR.NE.0) GO TO 900

      CALL ANGFIX(M,TRMAT,ALPHA,BETA,GAMMA)
      CALL MTOPOL(TRMAT,THETA,PHI,CHI)
      WRITE(LINE,*) ' Npair,RMS,MAX:',NX,DRMS,DISMAX      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' TFC(1->2):',THETA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     *   (TR(J),J=1,3)
      CALL MSGDOC(M,LINE)
      WRITE(LINE,'('' DIST_CENTRE              '',1X,F10.5)')
     *    DCENTRE
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')
      NPAIR_INI = NX
      DRMS_INI  = DRMS
      DMAX_INI  = DISMAX
      CHI_INI   = CHI
      DIST_INI  = DCENTRE
      CNTRX_INI(1) = CNTRX(1)
      CNTRX_INI(2) = CNTRX(2)
      CNTRX_INI(3) = CNTRX(3)
      CNTRY_INI(1) = CNTRY(1)
      CNTRY_INI(2) = CNTRY(2)
      CNTRY_INI(3) = CNTRY(3)
      DO I=1,3
        TR_INI(I) = TR(I)
        DO J=1,3
          TRMAT_INI(I,J) = TRMAT(I,J)
        ENDDO
      ENDDO
      DO I=1,NX
        DO II=1,3
          V(II) = X0(II,I)
c          V(II) = X(II,I)
        ENDDO
        DO II=1,3
          X(II,I) = TRMAT(1,II)*V(1)
     *             +TRMAT(2,II)*V(2)
     *             +TRMAT(3,II)*V(3)
        ENDDO
        DO II=1,3
          X(II,I) = X(II,I) + TR(II)
        ENDDO
      ENDDO
C -----------------------------------------
c      write(*,*) '--nx,ny:',nx,ny
c      DO I=1,NX
c        write(*,*) 'I:',I,X(1,I),X(2,I),X(3,I)
c      ENDDO
c      DO I=1,NY
c        write(*,*) 'J:',I,Y(1,I),Y(2,I),Y(3,I)
c      ENDDO
c      WEIGHT = 'N'
      DLIM2  = 2.0*DLIM*DLIM
c ===
      NPAIR_BEST = 0
      DRMS_BEST  = 10000.0
      DMAX_BEST  = 0.0
      CHI_BEST   = 0.0
      DIST_BEST  = 0.0

C       NPAIR_BEST = NPAIR_INI 
C       DRMS_BEST  = DRMS_INI  
C       DMAX_BEST  = DMAX_INI  
C       CHI_BEST   = CHI_INI  
C       DIST_BEST  = DIST_INI  

C --------------------------
      IFIRST = 0

 400  CONTINUE

      DO I=1,NX
      DO J=1,NY
      DO K=1,2
        IPAIR(K,I,J) = 0
      ENDDO
      ENDDO
      ENDDO
      DO K=1,NY
        DX  = X(1,NX) - Y(1,K)  
        DY  = X(2,NX) - Y(2,K)  
        DZ  = X(3,NX) - Y(3,K)  
        D2  = DX*DX + DY*DY + DZ*DZ

        TEMP(K) = SQRT(D2)
        SCORE_OLD_N(K) = 0.0 

        ARG = D2/DLIM2
        S   = EXP(-ARG)
        TEMP1(K)     = S
        SCORE_OLD(K) = S
        SCORE_OLD_N(K) = SCORE_OLD(K)
        SCORE_MAX(K) = SCORE_OLD(K)
        ISC_MAX(K)   = NX
      ENDDO 

c        WRITE(*,'(I3,''o: '',10F6.3)') NX,(SCORE_OLD(J),J=1,ny)
c        WRITE(*,'(I3,''n: '',10F6.3)') NX,(SCORE_OLD_N(J),J=1,ny)
c        WRITE(*,'(I3,''S: '',10F6.2)') NX,(temp1(J),J=1,ny)
c        WRITE(*,'(I3,''d: '',10F6.2)') NX,(temp(J),J=1,ny)
C ---
      IMAX = 0
      JMAX = 0
      SMAX = 0.0
      DO I=NX-1,1,-1
        DO J=NY,1,-1
          S   = 0.0
          DX  = X(1,I) - Y(1,J)  
          DY  = X(2,I) - Y(2,J)  
          DZ  = X(3,I) - Y(3,J)  
          D2  = DX*DX + DY*DY + DZ*DZ
          TEMP(J)  = SQRT(D2)
          ARG      = D2/DLIM2
          SCORE    = EXP(-ARG)
          TEMP1(J) = SCORE
          IF(J.LT.NY) THEN
            DO K=J+1,NY
              IF(SCORE_OLD(K).GE.S) THEN
                S  = SCORE_OLD(K)
                IP = I+1
                JP = K
              ENDIF
            ENDDO     
            IF(I.LT.NX-1) THEN
              IF(SCORE_MAX(J+1).GE.S) THEN
                S  = SCORE_MAX(J+1)
                IP = ISC_MAX(J+1)
                JP = J+1
              ENDIF
            ENDIF
          ENDIF

          SCORE          = SCORE + S
          SCORE_OLD_N(J) = SCORE

          IF(SCORE.GE.SMAX) THEN
            SMAX = SCORE
            IMAX = I
            JMAX = J
          ENDIF
          IF(SCORE.GT.SCORE_MAX(J)) THEN
            SCORE_MAX_N(J) = SCORE
            ISC_MAX_N(J)   = I
          ELSE
            SCORE_MAX_N(J) = SCORE_MAX(J)
            ISC_MAX_N(J)   = ISC_MAX(J)
          ENDIF  
          IPAIR(1,I,J) = IP
          IPAIR(2,I,J) = JP
        ENDDO

c        WRITE(*,*) ' --------------------'
c        WRITE(*,'(I3,''X: '',10F6.3)') I,(SCORE_MAX(J),J=1,ny)
c        WRITE(*,'(I3,''o: '',10F6.3)') I,(SCORE_OLD(J),J=1,ny)
c        WRITE(*,'(I3,''n: '',10F6.3)') I,(SCORE_OLD_N(J),J=1,ny)
c        WRITE(*,'(I3,''S: '',10F6.2)') I,(temp1(J),J=1,ny)
c        WRITE(*,'(I3,''d: '',10F6.2)') I,(temp(J),J=1,ny)

        DO K=1,NY        
          SCORE_OLD(K) = SCORE_OLD_N(K)
          SCORE_MAX(K) = SCORE_MAX_N(K)
          ISC_MAX(K)   = ISC_MAX_N(K)
        ENDDO

      ENDDO
C ---
c      WRITE(*,*) ' --------------------'
c      WRITE(*,*) ' MAX:',IMAX,JMAX,SMAX
c      WRITE(*,*) ' --------------------'
      DMAX  = 0.0
      DRMS  = 0.0
      NPAIR = 0
      ICUR  = IMAX
      JCUR  = JMAX
 100  CONTINUE
      IF(ICUR.GT.0.AND.JCUR.GT.0) THEN
        NPAIR = NPAIR + 1
        DX = X(1,ICUR) - Y(1,JCUR)  
        DY = X(2,ICUR) - Y(2,JCUR)  
        DZ = X(3,ICUR) - Y(3,JCUR)  
        D2 = DX*DX + DY*DY + DZ*DZ
        D  = SQRT(D2)
        DRMS = DRMS + D2
        IF(D.GT.DMAX) DMAX = D  
        SCORE_MAX(NPAIR) = D
        ISC_MAX  (NPAIR) = ICUR
        ISC_MAX_N(NPAIR) = JCUR
        ITEMP    (NPAIR) = NPAIR 

c        WRITE(*,*) '--',NPAIR,ICUR,JCUR,D

        IF(ICUR.GE.NX.OR.JCUR.GE.NY) GO TO 200 
        IC = IPAIR(1,ICUR,JCUR)
        JC = IPAIR(2,ICUR,JCUR)
        ICUR = IC
        JCUR = JC
        GO TO 100
      ENDIF
 200  CONTINUE
      IF(NPAIR.GT.0) THEN
        DRMS = SQRT((DRMS/FLOAT(NPAIR)))
      ENDIF 
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' Npair,RMS,MAX:',NPAIR,DRMS,DMAX      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MDOC,LINE)

C ---
      NPAIR_OLD = NPAIR 
      CALL SORT3(SCORE_MAX,NPAIR,ITEMP,ISC_MAX,ISC_MAX_N)

C      write(*,*) ' min:',SCORE_MAX(1) 
C      write(*,*) ' max:',SCORE_MAX(npair) 
     
C ---
      NMIN = NX
      IF(NY.LT.NMIN) NMIN = NY
      NMIN1 = NMIN + 1
      R0        = 2.0
      Q_FIN     = 0.0

      DRMS = 0.0
      DMAX = 0.0
      DO I=1,NPAIR
        DRMS = DRMS + SCORE_MAX(I)*SCORE_MAX(I)
        IF(SCORE_MAX(I).GT.DMAX) DMAX = SCORE_MAX(I)
      ENDDO
      DRMS = SQRT((DRMS/FLOAT(NPAIR)))

C     Qqq_FIN = (1.0+FLOAT(NPAIR))/((1.0+DRMS/R0)*FLOAT(NMIN1))
C     WRITE(LINE,*)'=I= Q,N,RMS:'
C    *    ,Qqq_FIN,NPAIR,DRMS      
C     CALL MSGDOC(MDOC,LINE)

      DMAX_FIN  = 0.0
      DRMS_FIN  = 0.0
      NPAIR_FIN = NPAIR

 300  CONTINUE
      DRMS = 0.0
      DMAX = 0.0
      DO I=1,NPAIR
        DRMS = DRMS + SCORE_MAX(I)*SCORE_MAX(I)
        IF(SCORE_MAX(I).GT.DMAX) DMAX = SCORE_MAX(I)
      ENDDO

      DRMS = SQRT((DRMS/FLOAT(NPAIR)))
      Q = (1.0+FLOAT(NPAIR))/((1.0+DRMS/R0)*FLOAT(NMIN1))

c      WRITE(*,*) '-- Q,N,RMS,MAX:',Q,NPAIR,DRMS,DMAX      

C      WRITE(LINE,*)'>>> Q,N,RMS:'
C     *    ,Q,NPAIR,DRMS,nmin1,r0
C      CALL MSGDOC(MDoc,LINE)

cccc   NPAIR_FIN = NPAIR

      IF(Q.GT.Q_FIN) THEN
        Q_FIN     = Q
        DRMS_FIN  = DRMS
        NPAIR_FIN = NPAIR
        DMAX_FIN  = DMAX
        NPAIR = NPAIR - 1
        IF(NPAIR.GT.0) THEN
          SCORE_MAX(NPAIR+1) = 99.0
          GO TO 300
        ENDIF
      ENDIF

      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MD,LINE)
      WRITE(LINE,*)'== Q,N,RMS,MAX:'
     *    ,Q_FIN,NPAIR_FIN,DRMS_FIN,DMAX_FIN      
      CALL MSGDOC(MDoc,LINE)
      WRITE(LINE,*) ' --------------------'
      CALL MSGDOC(MD,LINE)

c//   
      NPAIR = NPAIR_FIN 
c//
      DO I=1,NPAIR
        IA  = ISC_MAX(I)
        JA  = ISC_MAX_N(I)
        IPAIR_FIN(1,I) = IA
        IPAIR_FIN(2,I) = JA
c        WRITE(*,*) I,IA,JA,SCORE_MAX(I)
      ENDDO

C ---
C       WRITE(LINE,*) ' >>>>>Npair,best:',NPAIR,NPAIR_BEST 
C     *  , NPAIR_FIN,ifirst 
C       CALL MSGDOC(MDOC,LINE)

      IF(NPAIR.GT.NPAIR_BEST.OR.
     *   (NPAIR.EQ.NPAIR_BEST.AND.IFIRST.EQ.0)) THEN

        IF(NPAIR.EQ.NPAIR_BEST) IFIRST=1        

        IF(NPAIR.LT.4) THEN
          WRITE(LINE,*) ' >>>>>Npair:',NPAIR      
          CALL MSGDOC(MDOC,LINE)
          GO TO 410
C          IERR = 1
C          RETURN
        ENDIF 
        DO I=1,NPAIR
          IA = ISC_MAX(I)
          JA = ISC_MAX_N(I)
          XX(1,I) = X0(1,IA)
          XX(2,I) = X0(2,IA)
          XX(3,I) = X0(3,IA)
C          XX(1,I) = X(1,IA)
C          XX(2,I) = X(2,IA)
C          XX(3,I) = X(3,IA)
          YY(1,I) = Y(1,JA) 
          YY(2,I) = Y(2,JA) 
          YY(3,I) = Y(3,JA) 
        ENDDO
C ---
        CALL LSKAB_CHECK_FIT_D(M
     *  ,XX,YY,NPAIR,TRMAT,TR,DRMS,DISMAX,DCENTRE
     *  ,CNTRX,CNTRY,IERR)
        IF(IERR.NE.0) THEN
          IERR = 0
          GO TO 410
        ENDIF

        WRITE(LINE,*) '-Npair,RMS,MAX:'
     *  ,NPAIR,DRMS,DISMAX      
        CALL MSGDOC(MDOC,LINE)
        CALL ANGFIX(M,TRMAT,ALPHA,BETA,GAMMA)
        CALL MTOPOL(TRMAT,THETA,PHI,CHI)
        WRITE(LINE,*) ' TFC(1->2):',THETA,PHI,CHI
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' TRANSLATION VECTOR IN AS '',3(1X,F10.5))')
     *   (TR(J),J=1,3)
        CALL MSGDOC(Mdoc,LINE)
        WRITE(LINE,'('' DIST_CENTRE              '',1X,F10.5)')
     *    DCENTRE
        CALL MSGDOC(Mdoc,LINE)

        CALL ISORT3(ITEMP,NPAIR_OLD,SCORE_MAX,ISC_MAX,ISC_MAX_N)
C ---
        WRITE(LINE,*) ' --------------------'
        CALL MSGDOC(M,LINE)
        DO I=1,NPAIR_OLD
          IA  = ISC_MAX(I)
C          INA = IRX(IA)
          JA  = ISC_MAX_N(I)
C          JNA = IRY(JA)
C          WRITE(LINE,'(I5,A,I5,A3,I5,2X,F6.2)') 
C     *    I,') ',INA,' - ',JNA,SCORE_MAX(I)
          WRITE(LINE,'(I5,A,I5,A3,I5,2X,F6.2)') 
     *    I,') ',IA,' - ',JA,SCORE_MAX(I)
          CALL MSGDOC(M,LINE)
        ENDDO
        WRITE(LINE,*) ' --------------------'
        CALL MSGDOC(M,LINE)
C ---
        NPAIR_BEST = NPAIR
        DRMS_BEST  = DRMS
        DMAX_BEST  = DMAX
        CHI_BEST   = CHI
        DIST_BEST  = DCENTRE
        CNTRX_BEST(1) = CNTRX(1)
        CNTRX_BEST(2) = CNTRX(2)
        CNTRX_BEST(3) = CNTRX(3)
        CNTRY_BEST(1) = CNTRY(1)
        CNTRY_BEST(2) = CNTRY(2)
        CNTRY_BEST(3) = CNTRY(3)
        DO I=1,3
          TR_BEST(I) = TR(I)
          DO J=1,3
            TRMAT_BEST(I,J) = TRMAT(I,J)
          ENDDO
        ENDDO
        DO I=1,NX
          DO II=1,3
            V(II) = X0(II,I)
C            V(II) = X(II,I)
          ENDDO
          DO II=1,3
            X(II,I) = TRMAT(1,II)*V(1)
     *               +TRMAT(2,II)*V(2)
     *               +TRMAT(3,II)*V(3)
          ENDDO
          DO II=1,3
            X(II,I) = X(II,I) + TR(II)
          ENDDO
        ENDDO
        GO TO 400

      ENDIF
C ---
 410  CONTINUE

      NBY2 = NPAIR_INI/2 
      IF(NPAIR_BEST.LT.1.OR.NPAIR_BEST.LT.NBY2) THEN
        NPAIR_BEST = NPAIR_INI 
        DRMS_BEST  = DRMS_INI  
        DMAX_BEST  = DMAX_INI  
        CHI_BEST   = CHI_INI  
        DIST_BEST  = DIST_INI  
        CNTRX_BEST(1) = CNTRX_INI(1)
        CNTRX_BEST(2) = CNTRX_INI(2)
        CNTRX_BEST(3) = CNTRX_INI(3)
        CNTRY_BEST(1) = CNTRY_INI(1)
        CNTRY_BEST(2) = CNTRY_INI(2)
        CNTRY_BEST(3) = CNTRY_INI(3)
        DO I=1,3
          TR_BEST(I) = TR_INI(I)
          DO J=1,3
            TRMAT_BEST(I,J) = TRMAT_INI(I,J)
          ENDDO
        ENDDO
      ENDIF

      CALL MSGDOC(MDOC,' ----- best    =----')
      WRITE(LINE,*) ' Npair,RMS,MAX:'
     *  ,NPAIR_BEST,DRMS_BEST,DMAX_BEST      
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) ' PHI(1->2):',CHI_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' DIST         '',1X,F10.5)')
     *   DIST_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' CENTRX                   '',3(1X,F10.5))')
     *   (CNTRX_BEST(J),J=1,3)
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,' -------------------')

  900 CONTINUE

      deallocate(X0,STAT=ISTAT)
      deallocate(XX,STAT=ISTAT)
      deallocate(YY,STAT=ISTAT)
      deallocate(SCORE_OLD,STAT=ISTAT)
      deallocate(SCORE_MAX,STAT=ISTAT)
      deallocate(TEMP,STAT=ISTAT)
      deallocate(TEMP1,STAT=ISTAT)
      deallocate(SCORE_OLD_N,STAT=ISTAT)
      deallocate(SCORE_MAX_N,STAT=ISTAT)
      deallocate(ITEMP,STAT=ISTAT)
      deallocate(IPAIR,STAT=ISTAT)
      deallocate(ISC_MAX,STAT=ISTAT)
      deallocate(ISC_MAX_N,STAT=ISTAT)
C ---
      RETURN
      END

      SUBROUTINE LSKAB_CHECK_FIT_D(MDOC
     * ,X,Y,NX,TRMAT,TR,DRMS,DISMAX,DCENTRE
     * ,CNTRX,CNTRY,IERR)
C ---------------------------------------------------------
C
C     X      CONTAINS THE NX COORD. OF THE WORKING MOLECULE.
C     Y      CONTAINS THE NY COORD. OF THE REFERENCE MOLECULE.
C     NX     THE NUMBER OF CRESTS TO BE USED TO GENERATE THE ROTATION
C            MATRIX
C --------------------------------------------------------
      REAL X(3,*),Y(3,*),CNTRX(3),CNTRY(3)
      REAL TR(3),TRMAT(3,3)
c ---
      REAL RK(3,3),RKTRK(3,3),R(3),VP(3,3)
      REAL RA(3,3),RANR(3,3),E(3),XT(3),XNORM(3)
      CHARACTER LINE*80
C ----------------------------------------------------------------
      IERR=0
C
C     CALCULATE CENTROIDS
C
      DO     I=1,3
        CNTRY(I) = 0.0
        CNTRX(I) = 0.0
      ENDDO
      WSY = 0.0
      WSX = 0.0
      DO     I=1,NX
        DO     J=1,3
          CNTRY(J) = CNTRY(J) + Y(J,I)
          CNTRX(J) = CNTRX(J) + X(J,I) 
        ENDDO
        WSY = WSY +  1.0
        WSX = WSX +  1.0
      ENDDO
      DO     J=1,3
        CNTRX(J) = CNTRX(J)/WSX
        CNTRY(J) = CNTRY(J)/WSY
      ENDDO

      DX = CNTRX(1) - CNTRY(1) 
      DY = CNTRX(2) - CNTRY(2) 
      DZ = CNTRX(3) - CNTRY(3)

      DCENTRE = SQRT(DX*DX + DY*DY + DZ*DZ) 

C      write(*,*) '---x:',CNTRX(1),CNTRX(2),CNTRX(3)
C      write(*,*) '---y:',CNTRy(1),CNTRy(2),CNTRy(3)

C
C     TRANSLATE WORKING AND REFERENCE MOLECULES TO ORIGIN
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I) - CNTRX(J)
        Y(J,I) = Y(J,I) - CNTRY(J)
      ENDDO
      ENDDO
C
      DISMAX = 0.0
      SUMD2  = 0.0
      SUMDIS = 0.0
C
C    GET MATRIX R = SUM(Y.X)
C
      DO     I=1,3
      DO     J=1,3
        RK(I,J) = 0.0
      ENDDO
      ENDDO
      DO     IA=1,NX
        DO     I=1,3
        DO     J=1,3
          RK(I,J) = RK(I,J)+Y(I,IA)*X(J,IA)
        ENDDO
        ENDDO
      ENDDO
C
C      EZERO VALUE
C
      EZERO = 0.0
      DO     IA=1,NX
        DO     I=1,3
          EZERO = EZERO+(X(I,IA)*X(I,IA)+Y(I,IA)*Y(I,IA))
        ENDDO
      ENDDO
      EZERO = EZERO*0.5
C
C      GET RKTRK  =  RKTRANSPSED  *  RK
C
      DO     I=1,3
      DO     J=1,3
        RKTRK(I,J) = 0.0
        DO     K=1,3
          RKTRK(I,J) = RKTRK(I,J)+RK(K,I)*RK(K,J)
        ENDDO
      ENDDO
      ENDDO
C
C      CALL NAG ROUTINE :  EIGENVALUES IN  R
C                       :  EIGENVECTORS NORMALIZED IN VP
C                           (SORTED IN ASCENDING ORDER)
C                           (E   WORKING ARRAY)
C
      IFAIL = 0
      CALL F02ABF(RKTRK,3,3,R,VP,3,E,IFAIL)
      IF (IFAIL.NE.0) THEN
        IERR = 1
        WRITE(MDOC,10) IFAIL
   10   FORMAT
     *  (' ERR: ERROR DETECTED BY NAG LIBRARY ROUTINE - IFAIL=',I5)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,11) IFAIL
   11   FORMAT ('     ',I5,5X,' DIAGONALISATION FAILED')
        CALL MSGDOC(MDOC,LINE)
        RETURN
      ENDIF
C
C      SET VP(.1)=VP(.,3) X VP(.,2)
C
      VP(1,1) = VP(2,3)*VP(3,2)-VP(3,3)*VP(2,2)
      VP(2,1) = VP(3,3)*VP(1,2)-VP(1,3)*VP(3,2)
      VP(3,1) = VP(1,3)*VP(2,2)-VP(2,3)*VP(1,2)
C
C     GET  RA = R . V
C
      DO     K=1,3
      DO     I=1,3
        RA(I,K) = 0.0
        DO     J=1,3
          RA(I,K) = RA(I,K)+RK(I,J)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO
C
C      NORM.   RA(.,2) & RA(.3)
C
      DO     J=2,3
        XNORM(J) = 0.0
        DO     I=1,3
          XNORM(J) = XNORM(J)+RA(I,J)*RA(I,J)
        ENDDO
        XNORM(J) = 1./SQRT(ABS(XNORM(J)))
      ENDDO
      DO     J=2,3
      DO     I=1,3
        RANR(I,J) = RA(I,J)*XNORM(J)
      ENDDO
      ENDDO
C
C      SET RANR(.,1) = RANR(.,3) X RANR(.,2)
C
      RANR(1,1) = RANR(2,3)*RANR(3,2) - RANR(3,3)*RANR(2,2)
      RANR(2,1) = RANR(3,3)*RANR(1,2) - RANR(1,3)*RANR(3,2)
      RANR(3,1) = RANR(1,3)*RANR(2,2) - RANR(2,3)*RANR(1,2)
C
C   GET SCALAR PRODUCT  RANR(.,1) . RA(.,1)     & SIGMA VALUE
C
C     SCPD=0.0
C     DO     I=1,3
C       SCPD=RANR(I,1)*RA(I,1)
C     ENDDO
C     SIGMA = 1.
C     IF (SCPD.LT.0) SIGMA=-1.
C     RES = EZERO -SQRT(ABS(R(2)))-SQRT(ABS(R(3)))-SIGMA*SQRT(ABS(R(1)))
C
C      TRANSFORMATION MATRIX
C
      DO     I=1,3
      DO     J=1,3
        TRMAT(I,J) = 0.0
        DO     K=1,3
          TRMAT(I,J) = TRMAT(I,J)+RANR(I,K)*VP(J,K)
        ENDDO
      ENDDO
      ENDDO

C      write(*,*) '==',(TRMAT(1,J),j=1,3)
C      write(*,*) '==',(TRMAT(2,J),j=1,3)
C      write(*,*) '==',(TRMAT(3,J),j=1,3)

C
C
C      CALCULATE RESIDUALS & FIGURES OF MERIT
C
      DO     IA=1,NX
        DO     I=1,3
          XT(I) = 0.0
          DO     J=1,3
            XT(I) = XT(I) + TRMAT(I,J)*X(J,IA)
          ENDDO
        ENDDO
        DO     I=1,3
          X(I,IA) = XT(I)
        ENDDO
        D = 0.0
        DO     J=1,3
          D = D +(X(J,IA)-Y(J,IA))*(X(J,IA)-Y(J,IA))
        ENDDO
        SUMD2  = SUMD2 + D
        D      = SQRT(ABS(D))
        SUMDIS = SUMDIS +D
        DISMAX = AMAX1(DISMAX,D)
      ENDDO
      DRMS   = SQRT(ABS(SUMD2/NX))
      SUMDIS = SUMDIS/NX
C
      WRITE(LINE,40) SUMD2
 40   FORMAT('SUM DISPLACEMENTS**2      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,41) DRMS
 41   FORMAT('RMS DISPLACEMENT          =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,42) SUMDIS
 42   FORMAT('AVERAGE DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,43) DISMAX
 43   FORMAT('MAXIMUM DISPLACEMENT      =',F8.3)
      CALL MSGDOC(MDOC,LINE)
C
C
C     ADD REFERENCE MOLECULE CENTROID TO WORKING MOLECULE COORDS.
C
      DO     I=1,NX
      DO     J=1,3
        X(J,I) = X(J,I)+CNTRY(J)
      ENDDO
      ENDDO
C
C     SHIFT REFERENCE MOLECULE TO ORIGINAL POSITION
C
      DO     II=1,NX
      DO     J=1,3
        Y(J,II) = Y(J,II)+CNTRY(J)
      ENDDO
      ENDDO
C
C  FIND TRANSLATION  T = -TRMAT * CTRX   +CNTRY
C
      TR(1)=
     *  -TRMAT(1,1)*CNTRX(1)-TRMAT(1,2)*CNTRX(2)-TRMAT(1,3)*CNTRX(3)
     *  +CNTRY(1)
      TR(2)=
     *  -TRMAT(2,1)*CNTRX(1)-TRMAT(2,2)*CNTRX(2)-TRMAT(2,3)*CNTRX(3)
     *  +CNTRY(2)
      TR(3)=
     *  -TRMAT(3,1)*CNTRX(1)-TRMAT(3,2)*CNTRX(2)-TRMAT(3,3)*CNTRX(3)
     *  +CNTRY(3)
      TEMP       = TRMAT(1,2)
      TRMAT(1,2) = TRMAT(2,1)
      TRMAT(2,1) = TEMP
      TEMP       = TRMAT(1,3)
      TRMAT(1,3) = TRMAT(3,1)
      TRMAT(3,1) = TEMP
      TEMP       = TRMAT(2,3)
      TRMAT(2,3) = TRMAT(3,2)
      TRMAT(3,2) = TEMP

      RETURN
      END

      SUBROUTINE READ_FASTA_SEQ_NEW(MDOC,CODE,NAME_IN
     *       ,ITEST,N,NMAX,ICH,PNUM
     *       ,NSEQ,IRES,ISS,ISSN,SURF,ICHAIN,IDOMAIN,IERR)
C --------------------------------------------------------
      CHARACTER CODE*(*)
      INTEGER NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      INTEGER ISS(NMAX),ISSN(NMAX),SURF(NMAX)
      CHARACTER PNUM(NMAX)*6
C  
C READ_FASTA_SEQ   read sequence which can be used for ALIGN.
C 
C      File with sequence is ASCII file:
C
C      !>prot_id
C      !# sequence 
C      !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C      !# this is comment
C      !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C      !NRGTRITKEVFDNLTNWKNSAQ
C
C      If first symbol in the line is "#" it means the line is comments
C
C --------------------------------------------------------
      CHARACTER NAME_IN*(*)
      CHARACTER SS_FLAG*1,D3_FLAG*1 
c ----
      CHARACTER NAME*256,PATH*80,EXT*80,STR*256
      CHARACTER LINE*2048,LINE_SS*2048,LINE_SR*2048
      CHARACTER STR_IN*2048
      CHARACTER DB_FLAG*1,SS*1,SS_OLD*1,CHAIN*1
C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      DB_FLAG = 'N'
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) STR_IN
        CALL LENSTR_BL(STR_IN,LENS)
        IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SS:') THEN
          DB_FLAG = 'Y'
          GO TO 800
        ELSE IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SR:') THEN
          DB_FLAG = 'y'
          GO TO 800
        ENDIF
      ENDDO
 800  CONTINUE
      CLOSE(IU)
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C --------------------------------
      ICH= 0
      IC = 0
      NC =-1
      N  = 0 
      NR = 0 
      N21 = 0 
      NBAD = 0
      NX   = 0
      CODE = 'XXXX'
      CHAIN= 'A'
      IEND = 0
      LINE_SS = ' '
      LINE_SR = ' '
      SS_OLD  = ' '
      NSS     = 0
      IDOM_OLD = 0
      ISEG_OLD = 0
      J_OLD    =-1
      NDOM     = 0
      IDOM     = 0
      ISEG     = 0
      CALL GIVE_STRING_LENGTH(CODE,LEN_CODE)
C ----------------
 400  CONTINUE

      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          ICH = ICH + 1
          NR  = 0
          IF(ICH.EQ.1) THEN
            CODE = '?   '
            CHAIN = 'A'
            IF(LEN.GT.1) THEN
              DO L=2,LEN
                CODE(L-1:L-1) = LINE(L:L)
                IF(L.EQ.5) CHAIN = LINE(L:L)
                IF(L.GT.7.OR.L.GT.LEN_CODE) GO TO 400
              ENDDO
            ENDIF
          ENDIF
          GO TO 400
        ENDIF        
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
        IF(DB_FLAG.EQ.'Y') THEN
          LINE_SS = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SS
          LINE_SR = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SR
          IC = 5
        ENDIF
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
      ENDIF

      IF(CH1.EQ.'+') THEN
        J = 0
        GO TO 700
      ENDIF
      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
C     IF(J.EQ.21) J = 25
      IF(J.GE.0.AND.J.LE.25) THEN
 
        IF(J.EQ.21) THEN
          NR  = NR + 1
          N21 = N21 + 1 
          J = 25          
          IF(J_OLD.NE.25) THEN

            N  = N  + 1
            IF(ITEST.LE.0) THEN
              IF(N.GT.NMAX) THEN
                WRITE(STR
     *          ,'('' ERR: NUMBER OF RESIDUES >'',I8)') NMAX
                CALL MSGDOC(MDOC,STR) 
                IERR=1
                CLOSE(IU)
                RETURN
              ENDIF

              NSEQ(N) = J
              IRES(N) = 0
              PNUM(N)(1:1) = CHAIN
              WRITE(PNUM(N)(2:5),'(I4)') NR
              PNUM(N)(6:6) = ' '
              IRES(N) = 0
              IF(ICH.LE.0) ICH = 1
              ICHAIN(N) = ICH
              SURF(N) = 0
              ISSN(N) = 0
              ISS (N) = 0
              IDOMAIN(N) = IDOM*10 + ISEG 

            ENDIF
          ENDIF
          J_OLD = J
          GO TO 410
        ENDIF

        IF(J.EQ.24) THEN
          IF(IDOM_OLD.GT.0.AND.J_OLD.NE.24) THEN
            ISEG = ISEG_OLD            
          ELSE
            NDOM = NDOM + 1
            IDOM = NDOM
            ISEG = 0
          ENDIF
        ENDIF
        IF(J.EQ.0) THEN
          IF(ISEG_OLD.EQ.0) THEN
            ISEG = 1
C             =+ 
            IF(N.GT.0) IDOMAIN(N) = IDOM*10 + 1  
          ELSE IF(ISEG_OLD.EQ.1) THEN
            ISEG = 0
            
          ENDIF
          GO TO 410
        ENDIF
        N  = N  + 1
        IF(ITEST.LE.0) THEN
          IF(N.GT.NMAX) THEN
            WRITE(STR,'('' ERR: NUMBER OF RESIDUES >'',I8)') NMAX
            CALL MSGDOC(MDOC,STR) 
            IERR=1
            CLOSE(IU)
            RETURN
          ENDIF
C         IF(J.LE.21) NR = NR + 1
          IF(J.NE.24) NR = NR + 1
          NSEQ(N) = J
          IRES(N) = NR
          PNUM(N)(1:1) = CHAIN
          WRITE(PNUM(N)(2:5),'(I4)') NR
          PNUM(N)(6:6) = ' '
          IF(J.GE.24) IRES(N) = 0
          IF(ICH.LE.0) ICH = 1
          ICHAIN(N) = ICH
          SURF(N) = 0
          ISSN(N) = 0
          ISS (N) = 0
          IDOMAIN(N) = IDOM*10 + ISEG 
C          IF(J.EQ.21) THEN
C            NX = NX + 1
C          ENDIF
        ENDIF
      ELSE
        NBAD = NBAD + 1
        WRITE(STR,
     *  '('' WARNING: bad residue <'',A,''>'')') CH1
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(DB_FLAG.EQ.'Y') THEN
        IF(J.GE.1.AND.J.LE.25) THEN
          SS  = LINE_SS(IC:IC) 
          CH1 = LINE_SR(IC:IC)
          READ(CH1,'(I1)') ISURF_N
          IF(SS.NE.' '.AND.SS.NE.SS_OLD) NSS = NSS + 1
          IF(SS.NE.' ') THEN 
            ISSN_N = NSS
            ISS_N = 0
            IF(SS.EQ.'H') THEN
              ISS_N = 1
            ELSE IF(SS.EQ.'h') THEN
              ISS_N = 2
            ELSE IF(SS.EQ.'B') THEN
              ISS_N = 3
            ELSE IF(SS.EQ.'b') THEN
              ISS_N = 4
            ENDIF
          ELSE
            ISS_N  = 0
            ISSN_N = 0
          ENDIF
          IF(ITEST.LE.0) THEN
            SURF(N) = ISURF_N
            ISSN(N) = ISSN_N
            ISS (N) = ISS_N
          ENDIF
          SS_OLD = SS
        ENDIF
      ENDIF

      
      IF(J.EQ.24) THEN
        IF(IDOM_OLD.GT.0.AND.J_OLD.NE.24) THEN
          IDOM = 0
          ISEG = 0
        ENDIF
      ENDIF

      IDOM_OLD = IDOM
      ISEG_OLD = ISEG
      J_OLD = J

 410  CONTINUE

      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)

      IMODE =-1
      CALL CHECK_LINE(IMODE,CODE(1:4))

      NAA = NR - N21

      WRITE(LINE,'('' Number of symbols      :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of AA           :'',I8)') NAA
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of "?"          :'',I8)') N21
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of bad residues :'',I8)') NBAD
      CALL MSGDOC(MDOC,LINE)
C      WRITE(LINE,'('' Number of X residues   :'',I8)') NX
C      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file sequence'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CORR_BINARY_SEQ(MDOC,N,NMAX,PNUM
     *       ,NSEQ,IRES,ISS,SURF,ICHAIN,IDOMAIN
     *       ,NO_COORD,COORD
     *       ,IERR)
C --------------------------------------------------------
      INTEGER   NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
      INTEGER   SURF(NMAX),ISS(NMAX)
      REAL      COORD(NMAX,3)
      CHARACTER PNUM(NMAX)*6
      CHARACTER LINE*256
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      IDOM_OLD = 0
      ISEG_OLD = 0
      J_OLD    =-1
      NDOM     = 0
      IDOM     = 0
      ISEG     = 0
      IC = 0

      DO I=1,N

        J = NSEQ(I)

        IF(J.EQ.24) THEN
          IF(IDOM_OLD.GT.0.AND.J_OLD.NE.24) THEN
            ISEG = ISEG_OLD            
          ELSE
            NDOM = NDOM + 1
            IDOM = NDOM
            ISEG = 0
          ENDIF
        ENDIF
        IF(J.EQ.0) THEN
          IF(ISEG_OLD.EQ.0) THEN
            ISEG = 1
C             =+ 
            IF(IC.GT.0) IDOMAIN(IC) = IDOM*10 + 1  
          ELSE IF(ISEG_OLD.EQ.1) THEN
            ISEG = 0
            
          ENDIF
          GO TO 100
        ENDIF

        IC =IC + 1 

        NR      = IRES(I)
        PNUM(IC)(1:1) = 'A'
        WRITE(PNUM(IC)(2:5),'(I4)') NR
        PNUM(IC)(6:6) = ' '
        ICHAIN(IC)  = 1
        IRES(IC)    = IRES(I)
        NSEQ(IC)    = NSEQ(I)
        ISS(IC)     = ISS(I)
        IDOMAIN(IC) = IDOM*10 + ISEG 
        IF(NO_COORD.EQ.0) THEN
          COORD(IC,1) = COORD(I,1)
          COORD(IC,2) = COORD(I,2)
          COORD(IC,3) = COORD(I,3)
        ENDIF
        IDOM_OLD = IDOM
        ISEG_OLD = ISEG
        J_OLD = J

 100    CONTINUE

      ENDDO

      N = IC
   
      RETURN
      END

      SUBROUTINE CALC_NAA_NATOM_IN_SEQUENCE(MDOC,NAME_IN
     *       ,NAA,NATOM,IERR)
C --------------------------------------------------------
C  
      CHARACTER NAME_IN*(*)
c ----
      CHARACTER LINE*4096
      CHARACTER PATH*80,EXT*80

C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -----
      INTEGER NA_AA_TAB(20)
C       C  S  T  P  A  G  N  D  E  Q  H  R  K  M  I  L  V  F  Y  W
C       1  2  3  4  5  6  7  8  9     1  2  3  4  5  6  7  8  9
      DATA NA_AA_TAB/
     *  6, 6, 7, 7, 5, 4, 8, 8, 9, 9,10,11, 9, 8, 8, 8, 7,11,12,14/
C -----
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      NAA   = 0
      NATOM = 0
      IC = 0
      NC =-1
      IEND = 0
C ----------------
 400  CONTINUE

      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') GO TO 400 
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
      ENDIF

      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
c     IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.20) THEN
        NAA   = NAA  + 1
        NATOM = NATOM + NA_AA_TAB(J)
      ELSE IF(J.GE.21) THEN
        NAA   = NAA  + 1
        NATOM = NATOM + NA_AA_TAB(6)
      ENDIF
      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      WRITE(LINE,'('' Number of atoms       :'',I8)') NATOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of amino acids :'',I8)') NAA
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file sequence'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE ALIGN_SW(MDOC,AMATRIX,SS_FLAG
     *  ,OPENI,PENEXI,DPENI
     *  ,NC,KC,ISS1,ISS2,NSEQ1,NSEQ2
     *  ,NPAIR,IPAIR,ITRACE,NMAX1,NMAX2,NMAX12)
C -------------------------------------
      CHARACTER SS_FLAG*1
      REAL      AMATRIX(NMAX1,NMAX2)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2),ISS1(NMAX1),ISS2(NMAX2)
      INTEGER   ITRACE(2,NMAX1,NMAX2)
C ================================================================

C -------
C  1   -----------
C      !          !
C  K   !     *    !        A_NK
C      !          !             A_K1N1 --> NN (N+2..NC)
C  KC  -----------                 !
C      1     N    NC               V
C                                 KK
C ----------------------       (K+2,KC)
      AM_MAX = -1000.0
      NMAX = 0
      KMAX = 0
      NP   = 0
      DO N=1,NC
      DO K=1,KC
        ITRACE(1,N,K) = 0
        ITRACE(2,N,K) = 0
      ENDDO
      ENDDO
      
C      WRITE(*,*)'SS_FLAG',SS_FLAG
C      write(*,'(''SS1'',100(2x,i2,1x))') (ISS1(i),i=1,nc)
C      write(*,'(''SS2'',100(2x,i2,1x))') (ISS2(i),i=1,KC)
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo


      DO K=KC,1,-1

        IF(NSEQ2(K).GE.24) GO TO 300  
        IF(K.LT.KC) THEN
          K1 = K + 1
          DO L=K1,KC
            IF(NSEQ2(L).LT.24) GO TO 310            
          ENDDO
          L  = 0
          K1 = 0
  310     CONTINUE
          NOPEN_K = 1
          IF(K1.EQ.L) NOPEN_K = 0
          K1 = L
        ELSE
          K1 = 0
          NOPEN_K = 0
        ENDIF

        DO N=NC,1,-1

          IF(NSEQ1(N).GE.24) GO TO 400  
          IF(N.LT.NC) THEN
            N1 = N + 1
            DO L=N1,NC
              IF(NSEQ1(L).LT.24) GO TO 410            
            ENDDO
            L  = 0
            N1 = 0
  410       CONTINUE
            NOPEN_N = 1
            IF(N1.EQ.L) NOPEN_N = 0
            N1 = L
          ELSE
            N1 = 0
            NOPEN_N = 0
          ENDIF

          AMAX = 0.0
          NT   = 0
          KT   = 0 

          IF(N1.GT.0.AND.K1.GT.0) THEN
            A = AMATRIX(N,K) - DPENI + AMATRIX(N1,K1)
            IF(A.GT.AMAX) THEN
              AMAX = A
              NT   = N1
              KT   = K1
            ENDIF
          ENDIF

          IF(N1.GT.0) THEN
            ID = 0
            DO NN=N1,NC
              IF(NSEQ1(NN).LT.24) THEN
                ID  = ID + 1
                PEN = OPENI + REAL(ID)*PENEXI
                IUSE = 1
                IF((SS_FLAG.EQ.'Y').AND.
     *             (ISS2(K).NE.0.AND.ISS2(K1).NE.0.AND.
     *              ISS2(K).EQ.ISS2(K1))) IUSE = 0
                IF(NOPEN_K.GT.0) THEN
                  PEN  = 0.0
                  IUSE = 1
                ENDIF
                IF(IUSE.GT.0) THEN  
                  A = AMATRIX(NN,K) - PEN 
                  IF(A.GT.AMAX) THEN
                    AMAX = A
                    NT   = NN
                    KT   = K
                  ENDIF
                ENDIF
              ENDIF
            ENDDO
          ENDIF

          IF(K1.GT.0) THEN
            ID = 0
            DO KK=K1,KC
              IF(NSEQ2(KK).LT.24) THEN
                ID  = ID + 1
                PEN = OPENI + REAL(ID)*PENEXI
                IUSE = 1
                IF((SS_FLAG.EQ.'Y').AND.
     *             (ISS1(N).NE.0.AND.ISS1(N1).NE.0.AND.
     *              ISS1(N).EQ.ISS1(N1))) IUSE = 0
                IF(NOPEN_N.GT.0) THEN
                  PEN  = 0.0
                  IUSE = 1
                ENDIF
                IF(IUSE.GT.0) THEN  
                  A = AMATRIX(N,KK) - PEN 
                  IF(A.GT.AMAX) THEN
                    AMAX = A
                    NT   = N
                    KT   = KK
                  ENDIF
                ENDIF
              ENDIF
            ENDDO
          ENDIF

          AMATRIX(N,K)  = AMAX
          ITRACE(1,N,K) = NT
          ITRACE(2,N,K) = KT
          IF(AMATRIX(N,K).GT.AM_MAX) THEN
            AM_MAX = AMATRIX(N,K)
            NMAX = N
            KMAX = K
            NP = NP + 1
          ENDIF

  400     CONTINUE
        ENDDO

  300   CONTINUE
      ENDDO
C ----------------------
C     trace back
      NPAIR = 0
      IF(NP.LE.0) RETURN
      NPAIR = 1
      IPAIR(1,NPAIR) = NMAX
      IPAIR(2,NPAIR) = KMAX
      K = KMAX
      N = NMAX

C      write(*,*) '--nmax,kmax:',nmax,kmax
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(f5.2))')
C     *  NSEQ2(i),':',(amatrix(j,i),j=1,nc)
C      enddo
C      write(*,*) '--trace:'
C      write(*,'(3x,100(2x,i2,1x))') (nseq1(i),i=1,nc)
C      do i=1,kc
C        write(*,'(i2,a,100(1X,2I2))')
C     *  NSEQ2(i),':',(ITRACE(1,j,i),ITRACE(2,j,i),j=1,nc)
C      enddo

C ----
 100  CONTINUE
      NT = ITRACE(1,N,K)
      KT = ITRACE(2,N,K) 
      IF(NT.LE.0.OR.KT.LE.0) GO TO 200
      IF(NT.EQ.IPAIR(1,NPAIR)) THEN
C        IPAIR(2,NPAIR) = KT
      ELSE IF(KT.EQ.IPAIR(2,NPAIR)) THEN
C        IPAIR(1,NPAIR) = NT
      ELSE  
        NPAIR = NPAIR + 1
        IPAIR(1,NPAIR) = NT
        IPAIR(2,NPAIR) = KT
      ENDIF
      N = NT
      K = KT
      GO TO 100
C ----
 200  CONTINUE

C      do i=1,npair
C        write(*,*) '--',i,IPAIR(1,i),IPAIR(2,i)
C     *  , AMATRIX(IPAIR(1,i),IPAIR(2,i))
C      enddo
C ----
      RETURN
      END

      SUBROUTINE DEF_SCORE_MIN_old(NN,NPAIR,NC,KC
     *  ,NSEQ1,NSEQ2,IPAIR,AMAT,NMAX1,NMAX2,NMAX12
     *  ,SCORE_MIN,SCORE_SIGMA)
C -------------------------------
      REAL      AMAT(25,25)
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      integer,   allocatable :: ICOPY(:)
C -------------------------------

      allocate(ICOPY(1:NMAX12),STAT=ISTAT)

      SCORE_MIN   = 0.0
      SCORE_SIGMA = 0.0
      IF(NN.LE.0) GO TO 900
      NCYCLE    = 30
      S  = 0.0
      S2 = 0.0
      NH = 0
      INIT = 0
      DO IC=1,NCYCLE
        S_MIN = 0.0
        NP    = 0
        DO I=1,NPAIR 
          ICOPY(I) = IPAIR(2,I) 
        ENDDO
        N2 = NPAIR           
        DO I=1,NPAIR             
          N = IPAIR(1,I)
          NAA1 = NSEQ1(N)
          IF(NAA1.LT.24) THEN
            III = 0
  100       CONTINUE
c           CALL HSRD(A)
            CALL HSRD_TIME(A,NH,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
            III = III + 1
            IF(III.GT.100) GO TO 200
            A = A + 0.5
            AK = A*REAL(NPAIR) + 1.0         
            K  = AK
            IF(K.LT. 1) K = 1
            IF(K.GT.NPAIR) K = NPAIR
            KK = ICOPY(K)
            NAA2 = NSEQ2(KK)
            IF(NAA2.GE.24) GO TO 100
            S_MIN = S_MIN + AMAT(NAA1,NAA2)
            NP = NP + 1
            IF(K.LT.N2) THEN
              DO J=K,N2-1
                ICOPY(J) = ICOPY(J+1)
              ENDDO
            ENDIF
            N2 = N2 - 1
            IF(N2.LE.0) GO TO 300
  200       CONTINUE
          ENDIF
        ENDDO
  300   CONTINUE
        IF(NP.GT.0) THEN
          S_MIN = S_MIN/REAL(NP)
        ENDIF
        S  = S +  S_MIN
        S2 = S2 + S_MIN*S_MIN
      ENDDO
      S  = S/REAL(NCYCLE)
      S2 = S2/REAL(NCYCLE)
      SCORE_SIGMA = SQRT(ABS(S2-S*S))
      SCORE_MIN   = S

  900 CONTINUE

      deallocate(ICOPY,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE SMOOTH_SCORE(MDOC,DPENI
     *  ,NC,KC,NSEQ1,NSEQ2,SCORE1,SCORE2,NPAIR,IPAIR
     *  ,NMAX1,NMAX2,NMAX12,IERR)
C -----------------------------------------------
      INTEGER   MDOC,IERR
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      REAL      SCORE1(NMAX12),SCORE2(NMAX12)
C ----------------------------------------------------------------
      IERR = 0
      DO I=1,NC
        SCORE2(I) = SCORE1(I)
      ENDDO
      DO IPR=1,NPAIR 
        I   = IPAIR(1,IPR) 
        J   = IPAIR(2,IPR)
        IN1 = NSEQ1(I)
        IN2 = NSEQ2(J)
        IF(IN1.LT.24.AND.IN2.LT.24) THEN
          NS  = 1
          SUM = SCORE2(I)
        ELSE
          SUM = 0.0
          NS  = 0
        ENDIF
        IF(IPR.GT.1) THEN
          IM1 = IPAIR(1,IPR-1)
          JM1 = IPAIR(2,IPR-1)
          IF(I-IM1.EQ.1.AND.J-JM1.EQ.1) THEN
            IN1 = NSEQ1(IM1)
            IN2 = NSEQ2(JM1)
            IF(IN1.LT.24.AND.IN2.LT.24) THEN
              NS  = NS + 1
              SUM = SUM + SCORE2(IM1)
            ENDIF
            IF(IPR.GT.2) THEN
              IM2 = IPAIR(1,IPR-2)
              JM2 = IPAIR(2,IPR-2)
              IF(IM1-IM2.EQ.1.AND.JM1-JM2.EQ.1) THEN
                IN1 = NSEQ1(IM2)
                IN2 = NSEQ2(JM2)
                IF(IN1.LT.24.AND.IN2.LT.24) THEN
                  NS  = NS + 1
                  SUM = SUM + SCORE2(IM2)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(IPR.LT.NPAIR) THEN
          IP1 = IPAIR(1,IPR+1)
          JP1 = IPAIR(2,IPR+1)
          IF(IP1-I.EQ.1.AND.JP1-J.EQ.1) THEN
            IN1 = NSEQ1(IP1)
            IN2 = NSEQ2(JP1)
            IF(IN1.LT.24.AND.IN2.LT.24) THEN
              NS  = NS + 1
              SUM = SUM + SCORE2(IP1)
            ENDIF
            IF(IPR.LT.NPAIR-1) THEN
              IP2 = IPAIR(1,IPR+2)
              JP2 = IPAIR(2,IPR+2)
              IF(IP2-IP1.EQ.1.AND.JP2-JP1.EQ.1) THEN
                IN1 = NSEQ1(IP2)
                IN2 = NSEQ2(JP2)
                IF(IN1.LT.24.AND.IN2.LT.24) THEN
                  NS  = NS + 1
                  SUM = SUM + SCORE2(IP2)
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ENDIF
        IF(NS.GT.0) THEN
          SUM = SUM/REAL(NS)
          SCORE1(I) = SUM
        ELSE
          SCORE1(I) = DPENI
        ENDIF
      ENDDO
      RETURN
      END

      SUBROUTINE ALIGN_3_WRITE_PDB1_ALIGN(MDOC,NAMER,NAMEO
     *  ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *  ,ATOM_INDEX,ATOM_NAME     
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *  ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *  ,ITRANS_INP,RESULT,IPRROW,IERR)
C ------------------------------------------------
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      CHARACTER PNUM1(NMAX2)*6,PNUM2(NMAX2)*6,WS_FLAG*1
      REAL      RESULT(IPRROW)
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C ---
      REAL      TR(3),TRMAT(3,3),X(3),Y(3)
      INTEGER   MDOC,IERR
      CHARACTER ANAME*4,CP_PNUM*6,PNUM22*6,PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3,PNUM11*6
      CHARACTER ANAME_OLD*4,CP_ALT*1,CP_SEG*4
      CHARACTER NAMER*(*),NAMEO*(*)
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7,CH4*4,CH1*1
      CHARACTER CNAME*20,REC*4,CHAIN*1
      DATA CNAME/'ABCDEFGHIJKLMNOPRSTU'/
C                 123456789 123456789 
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name1')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file1')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
c      IF(ITRANS.GT.0.AND.IPRROW.GE.41) THEN
c        TR(1)      = RESULT(30)
c        TR(2)      = RESULT(31) 
c        TR(3)      = RESULT(32) 
c        TRMAT(1,1) = RESULT(33) 
c        TRMAT(1,2) = RESULT(34) 
c        TRMAT(1,3) = RESULT(35) 
c        TRMAT(2,1) = RESULT(36) 
c        TRMAT(2,2) = RESULT(37) 
c        TRMAT(2,3) = RESULT(38) 
c        TRMAT(3,1) = RESULT(39) 
c        TRMAT(3,2) = RESULT(40) 
c        TRMAT(3,3) = RESULT(41) 
c        IF(ABS(TRMAT(1,1)).GT.0.0001.OR.
c     *     ABS(TRMAT(2,2)).GT.0.0001.OR.
c     *     ABS(TRMAT(3,3)).GT.0.0001    ) ITRANS = 1
c        ITRANS = 0
c      ENDIF
      ITRANS = 0
C -------------------------------------
      IF(CHAIN.EQ.' ') CHAIN = 'A'
      NCH    = 0
      CH1    = CHAIN
      IRES_OLD   = 100000
      IRES_1_OLD = 100000
      IRES_2_OLD = 100000
      IPR    = 1
      IPR1   = IPAIR(1,IPR)
      IPR2   = IPAIR(2,IPR)
      ISEQ1  = NSEQ1(IPR1)
      IRES   = IRES1(IPR1)
c      CHAIN  = PNUM1(IPR1)(1:1)
      IRES_1 = IRES1(IPR1)
      IRES_2 = IRES2(IPR2)
      ISEQ2  = NSEQ2(IPR2)
      PNUM22 = PNUM2(IPR2)
      PNUM11 = PNUM1(IPR1)
      IPR1_C = 1
      IFIRST = 0
      PNUM_OLD    = '?'
      ANAME_OLD   = '?'
      REC         = '?'
      NAT_OCC     = 0
      NAT         = 0   
      NRES        = 0   
      NRES_OCC    = 0   
      IEND        = 0

 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      CH1 = CHAIN       

 10   CONTINUE
      IF(IPR1_C.LT.IPR1.AND.IFIRST.EQ.0) THEN
        IRES_C   = IRES1(IPR1_C)
        ISEQ1_C  = NSEQ1(IPR1_C)
        IPR1_C = IPR1_C + 1        
        GO TO 10
      ENDIF


C           FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
      READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO
      
      CP_SEG = '    '
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GE.75) THEN
        CP_SEG(1:3) = LINE(73:75)
        CP_SEG(4:4) = ' '
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(LEN.GE.76) THEN
        CP_SEG = LINE(73:76)
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 200
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ASYMB(1:1).EQ.'H') GO TO 200

      IF(CP_OCC.LT.0.001) GO TO 200

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.PNUM_OLD) GO TO 200
      PNUM_OLD  = CP_PNUM
      ANAME_OLD = ANAME     

      IF(CP_PNUM.NE.PNUM11) THEN
        IF(IFIRST.EQ.1) THEN
          IFIRST = 0
          IF(IPR.EQ.NPAIR) THEN
            GO TO 610
          ENDIF
          IPR1_C = IPR1_C + 1        
          IPR   = IPR + 1     
          IPR1  = IPAIR(1,IPR)
          IPR2  = IPAIR(2,IPR)
          ISEQ1 = NSEQ1(IPR1)
          IRES  = IRES1(IPR1)
          CH1   = CHAIN       
          IRES_1= IRES1(IPR1)
          IRES_2= IRES2(IPR2)
          ISEQ2 = NSEQ2(IPR2)
          PNUM22= PNUM2(IPR2)
          PNUM11= PNUM1(IPR1)

 11       CONTINUE
          IF(IPR1_C.LT.IPR1) THEN
            IRES_C   = IRES1(IPR1_C)
            ISEQ1_C  = NSEQ1(IPR1_C)
            IPR1_C = IPR1_C + 1        
            GO TO 11
          ENDIF

        ENDIF
        IF(CP_PNUM.NE.PNUM11) THEN
          GO TO 200
        ENDIF 
      ENDIF

      IFIRST = 1
c      CALL CHAINGE_ATOME_ALIGN2(ANAME,ISEQ1,ISEQ2,RNAME,IWRT
c     * ,ATOM_INDEX,ATOM_NAME)     
c
c      CALL CORR_ATOME_NAME_AFTER_ALIGN(
c     *                         ANAME,RNAME,ASYMB,IWRT)
      IWRT = 1
      IF(RNAME.EQ.'---') IWRT = 0

      IF(IWRT.EQ.1.AND.ANAME(1:3).EQ.'N  ') THEN
        IDRES   = IRES - IRES_OLD
        IDRES_1 = IRES_1 - IRES_1_OLD
c       IDRES_2 = IRES_2 - IRES_2_OLD
        IF(IDRES.EQ.1.AND.IDRES_1.GT.1) IWRT = 0
      ENDIF
      IF(IWRT.EQ.1) THEN
        IF(CP_OCC.GT.0.001) NAT_OCC = NAT_OCC + 1
        NAT = NAT + 1
        IF(IRES.NE.IRES_OLD) 
     *    NRES = NRES + 1
        IF(IRES.NE.IRES_OLD.AND.CP_OCC.GT.0.001) 
     *    NRES_OCC = NRES_OCC + 1
        IRES_OLD   = IRES
        IRES_1_OLD = IRES_1
c       IRES_2_OLD = IRES_2

C       FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.78) LINE(77:78) =' '//ANAME(1:1)      

        WRITE(CH4,'(I4)') IRES
        LINE(13:27) = ' '//ANAME(1:3)//' '//RNAME//' '//CH1//CH4//' '
c -
        IF(WS_FLAG.EQ.'Y') LINE(67:72) = '      '
C       if y remove surf
c -
        LINE(77:80) = '    '
        LINE(73:76) = CP_SEG

        IF(ITRANS.GT.0) THEN
          READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
          DO II=1,3
            Y(II) =   TRMAT(1,II)*X(1)
     *              + TRMAT(2,II)*X(2)
     *              + TRMAT(3,II)*X(3)
          ENDDO
          DO II=1,3
            Y(II) = Y(II) +  TR(II)
          ENDDO
          CALL LENSTR_BL(LINE,LEN)
          WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)          
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

        REC = 'ATOM'

      ENDIF

      GO TO 200

 400  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 200

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200
C -------------------------
 600  CONTINUE
      IEND = 1
 610  CONTINUE

      IF(IPR.EQ.NPAIR) THEN
        IPR1_C = IPR1_C + 1        
 13     CONTINUE
        IF(IPR1_C.LE.NC) THEN
          IRES_C   = IRES1(IPR1_C)
          ISEQ1_C  = NSEQ1(IPR1_C)
          IPR1_C = IPR1_C + 1        
          GO TO 13
        ENDIF
      ENDIF

      IF(IEND.EQ.0) THEN
 210    CONTINUE
        READ(INC,'(A)',ERR=500,END=600) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.54) GO TO 210
        IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ELSE IF(LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ENDIF
        REC = '?'
        IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 210

        READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

        CP_SEG = '    '
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.75) THEN
          CP_SEG(1:3) = LINE(73:75)
          CP_SEG(4:4) = ' '
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF
        IF(LEN.GE.76) THEN
          CP_SEG = LINE(73:76)
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF

      
        IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1')GOTO 210
        ASYMB='    '
        CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
        IF(ASYMB(1:1).EQ.'H') GO TO 210
        IF(CP_OCC.LT.0.001) GO TO 210
        IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *     RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *     RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                      ) THEN
          CALL LENSTR_BL(LINE,LEN)

          LINE(22:22) = CH1
          IF(LEN.GE.74) THEN
            LINE(73:74) = CH1//CH1
          ENDIF

          IF(LINE(1:4).NE.'ANIS') THEN
            IF(ITRANS.GT.0) THEN
              READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
              DO II=1,3
                Y(II) = TRMAT(1,II)*X(1)
     *                + TRMAT(2,II)*X(2)
     *                + TRMAT(3,II)*X(3)
              ENDDO
              DO II=1,3
                Y(II) = Y(II) +  TR(II)
              ENDDO
              WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)
            ENDIF
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF

        ENDIF
        REC = 'ATOM'
        GO TO 210
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      IF(NAT.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms = 0')
        IERR = 1
      ENDIF
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in ALIGN_WRITE_PDB1')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE ALIGN_3_WRITE_PDB2_ALIGN(MDOC,NAMER,NAMEO
     *  ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *  ,ATOM_INDEX,ATOM_NAME     
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR
     *  ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *  ,ITRANS,RESULT,IPRROW,IERR)
C ------------------------------------------------
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      CHARACTER PNUM1(NMAX2)*6,PNUM2(NMAX2)*6,WS_FLAG*1
      REAL      RESULT(IPRROW)
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C ---
      REAL      TR(3),TRMAT(3,3),X(3),Y(3)
      INTEGER   MDOC,IERR
      CHARACTER ANAME*4,CP_PNUM*6,PNUM22*6,PNUM_OLD*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3
      CHARACTER ANAME_OLD*4,CP_ALT*1,CP_SEG*4
      CHARACTER NAMER*(*),NAMEO*(*)
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7,CH4*4,CH1*1
      CHARACTER CNAME*20,REC*4,CHAIN*1
      DATA CNAME/'ABCDEFGHIJKLMNOPRSTU'/
C                 123456789 123456789 
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      IF(ITRANS.GT.0.AND.IPRROW.GE.41) THEN
        TR(1)      = RESULT(30)
        TR(2)      = RESULT(31) 
        TR(3)      = RESULT(32) 
        TRMAT(1,1) = RESULT(33) 
        TRMAT(1,2) = RESULT(34) 
        TRMAT(1,3) = RESULT(35) 
        TRMAT(2,1) = RESULT(36) 
        TRMAT(2,2) = RESULT(37) 
        TRMAT(2,3) = RESULT(38) 
        TRMAT(3,1) = RESULT(39) 
        TRMAT(3,2) = RESULT(40) 
        TRMAT(3,3) = RESULT(41) 
        IF(ABS(TRMAT(1,1)).GT.0.0001.OR.
     *     ABS(TRMAT(2,2)).GT.0.0001.OR.
     *     ABS(TRMAT(3,3)).GT.0.0001    ) ITRANS = 1
      ENDIF
C -------------------------------------
      IF(CHAIN.EQ.' ') CHAIN = 'A'
      NCH    = 0
      CH1    = CHAIN
      IRES_OLD   = 100000
      IRES_2_OLD = 100000
      IPR    = 1
      IPR1   = IPAIR(1,IPR)
      IPR2   = IPAIR(2,IPR)
      ISEQ1  = NSEQ1(IPR1)
      IRES   = IRES1(IPR1)
c      CHAIN  = PNUM1(IPR1)(1:1)
      IRES_2 = IRES2(IPR2)
      ISEQ2  = NSEQ2(IPR2)
      PNUM22 = PNUM2(IPR2)
      IPR1_C = 1
      IFIRST = 0
      PNUM_OLD    = '?'
      ANAME_OLD   = '?'
      REC         = '?'
      NAT_OCC     = 0
      NAT         = 0   
      NRES        = 0   
      NRES_OCC    = 0   
      IEND        = 0

 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

C       CH1 = LINE(22:22)
      CH1 = CHAIN       

 10   CONTINUE
      IF(IPR1_C.LT.IPR1.AND.IFIRST.EQ.0) THEN
        IRES_C   = IRES1(IPR1_C)
        ISEQ1_C  = NSEQ1(IPR1_C)
C        NAT = NAT + 1   
C        NRES = NRES + 1

C        CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
C        IF(IERR.NE.0) GO TO 500

c        IF(IRES_C.LT.IRES_OLD) THEN
c          NCH = NCH + 1
c          IF(NCH.GT.20) NCH = 20
c          CH1 = CNAME(NCH:NCH)
c        ENDIF
c        IRES_OLD = IRES_C
        IPR1_C = IPR1_C + 1        
        GO TO 10
      ENDIF


C           FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/
      READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

      CP_SEG = '    '
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GE.75) THEN
        CP_SEG(1:3) = LINE(73:75)
        CP_SEG(4:4) = ' '
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(LEN.GE.76) THEN
        CP_SEG = LINE(73:76)
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 200
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ASYMB(1:1).EQ.'H') GO TO 200

c      IF(CP_OCC.LT.0.001) GO TO 200

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.PNUM_OLD) GO TO 200
      PNUM_OLD  = CP_PNUM
      ANAME_OLD = ANAME     

      IF(CP_PNUM.NE.PNUM22) THEN
        IF(IFIRST.EQ.1) THEN
          IFIRST = 0
          IF(IPR.EQ.NPAIR) THEN
            GO TO 610
          ENDIF
          IPR1_C = IPR1_C + 1        
          IPR   = IPR + 1     
          IPR1  = IPAIR(1,IPR)
          IPR2  = IPAIR(2,IPR)
          ISEQ1 = NSEQ1(IPR1)
          IRES  = IRES1(IPR1)
c         CHAIN = PNUM1(IPR1)(1:1)

          CH1 = CHAIN       

          IRES_2= IRES2(IPR2)
          ISEQ2 = NSEQ2(IPR2)
          PNUM22= PNUM2(IPR2)

 11       CONTINUE
          IF(IPR1_C.LT.IPR1) THEN
            IRES_C   = IRES1(IPR1_C)
            ISEQ1_C  = NSEQ1(IPR1_C)
C            NAT = NAT + 1   
C             NRES = NRES + 1
        

c      write(*,*) '===',ipr1_c,ipr,NAT,ISEQ1_C,IRES_C
        
CC            CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
CC            IF(IERR.NE.0) GO TO 500

c            IF(IRES_C.LT.IRES_OLD) THEN
c              NCH = NCH + 1
c              IF(NCH.GT.20) NCH = 20
c              CH1 = CNAME(NCH:NCH)
c            ENDIF

c            IRES_OLD = IRES_C
            IPR1_C = IPR1_C + 1        
            GO TO 11
          ENDIF

        ENDIF
        IF(CP_PNUM.NE.PNUM22) THEN
          GO TO 200
        ENDIF 
      ENDIF

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)

      IWRT = 1
      CALL CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)
      IF(IWRT.EQ.0) GO TO 200

      IFIRST = 1
      CALL CHAINGE_ATOME_ALIGN2(ANAME,ISEQ1,ISEQ2,RNAME,IWRT
     * ,ATOM_INDEX,ATOM_NAME)   
  
      CALL CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)

      IF(RNAME.EQ.'---') IWRT = 0
      IF(IWRT.EQ.1.AND.ANAME(1:3).EQ.'N  ') THEN
        IDRES   = IRES - IRES_OLD
        IDRES_2 = IRES_2 - IRES_2_OLD
        IF(IDRES.EQ.1.AND.IDRES_2.GT.1) IWRT = 0
      ENDIF
      IF(IWRT.EQ.1) THEN
        IF(CP_OCC.GT.0.001) NAT_OCC = NAT_OCC + 1
        NAT = NAT + 1

c        IF(IRES.LT.IRES_OLD) THEN
c          NCH = NCH + 1
c          IF(NCH.GT.20) NCH = 20
c          CH1 = CNAME(NCH:NCH)
c        ENDIF

        IF(IRES.NE.IRES_OLD) 
     *    NRES = NRES + 1
        IF(IRES.NE.IRES_OLD.AND.CP_OCC.GT.0.001) 
     *    NRES_OCC = NRES_OCC + 1
        IRES_OLD = IRES
        IRES_2_OLD = IRES_2

C       FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.78) LINE(77:78) =' '//ANAME(1:1)      

        WRITE(CH4,'(I4)') IRES
        LINE(13:27) = ' '//ANAME(1:3)//' '//RNAME//' '//CH1//CH4//' '
c -
        IF(WS_FLAG.EQ.'Y') LINE(67:72) = '      '
C       if y remove surf
c -
        LINE(77:80) = '    '
        LINE(73:76) = CP_SEG

        IF(ITRANS.GT.0) THEN
          READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
          DO II=1,3
            Y(II) =   TRMAT(1,II)*X(1)
     *              + TRMAT(2,II)*X(2)
     *              + TRMAT(3,II)*X(3)
          ENDDO
          DO II=1,3
            Y(II) = Y(II) +  TR(II)
          ENDDO
          CALL LENSTR_BL(LINE,LEN)
          WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)          
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

        REC = 'ATOM'

      ENDIF

      GO TO 200

 400  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 200

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200
C -------------------------
 600  CONTINUE
      IEND = 1
 610  CONTINUE

      IF(IPR.EQ.NPAIR) THEN

c      write(*,*) '>>end==',ipr1_c,nc,ipr

        IPR1_C = IPR1_C + 1        
 13     CONTINUE
        IF(IPR1_C.LE.NC) THEN
          IRES_C   = IRES1(IPR1_C)
          ISEQ1_C  = NSEQ1(IPR1_C)
C         NAT = NAT + 1   
C         NRES = NRES + 1
  
c      write(*,*) '=end==',ipr1_c,nc,NAT,ISEQ1_C,IRES_C
        
C         CALL ADD_ATOM_OCC_0(IOUT,NAT,ISEQ1_C,IRES_C,CH1,IERR)        
C         IF(IERR.NE.0) GO TO 500

c         IF(IRES_C.LT.IRES_OLD) THEN
c           NCH = NCH + 1
c           IF(NCH.GT.20) NCH = 20
c           CH1 = CNAME(NCH:NCH)
c         ENDIF

c         IRES_OLD = IRES_C
          IPR1_C = IPR1_C + 1        
          GO TO 13
        ENDIF
      ENDIF

      IF(IEND.EQ.0) THEN
 210    CONTINUE
        READ(INC,'(A)',ERR=500,END=600) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.54) GO TO 210
        IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ELSE IF(LINE(1:4).EQ.'ANIS') THEN
          GO TO 210
        ENDIF
        REC = '?'
        IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 210

        READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

        CP_SEG = '    '
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.75) THEN
          CP_SEG(1:3) = LINE(73:75)
          CP_SEG(4:4) = ' '
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF
        IF(LEN.GE.76) THEN
          CP_SEG = LINE(73:76)
          CP_SEG(1:2) = CHAIN//CHAIN
        ENDIF

      
        IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1')GOTO 210
        ASYMB='    '
        CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
        IF(ASYMB(1:1).EQ.'H') GO TO 210
        IF(CP_OCC.LT.0.001) GO TO 210
        IF(RNAME.EQ.'HEM'.OR.RNAME.EQ.'HMD'.OR.RNAME.EQ.'HEC'.OR.
     *     RNAME.EQ.'SRM'.OR.RNAME.EQ.'DHE'.OR.RNAME.EQ.'HEA'.OR.
     *     RNAME.EQ.'BCB'.OR.RNAME.EQ.'BPB'                      ) THEN
          CALL LENSTR_BL(LINE,LEN)

          LINE(22:22) = CH1
          IF(LEN.GE.74) THEN
            LINE(73:74) = CH1//CH1
          ENDIF

          IF(LINE(1:4).NE.'ANIS') THEN
            IF(ITRANS.GT.0) THEN
              READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
              DO II=1,3
                Y(II) = TRMAT(1,II)*X(1)
     *                + TRMAT(2,II)*X(2)
     *                + TRMAT(3,II)*X(3)
              ENDDO
              DO II=1,3
                Y(II) = Y(II) +  TR(II)
              ENDDO
              WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)
            ENDIF
            WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          ENDIF

        ENDIF
        REC = 'ATOM'
        GO TO 210
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      IF(NAT.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms = 0')
        IERR = 1
      ENDIF
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in ALIGN_WRITE_PDB2')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE ALIGN_3_WRITE_PDB2_FULL(MDOC,NAMER,NAMEO
     *  ,NSEQ1,IRES1,IRES2,NSEQ2,PNUM1,PNUM2,NC,KC,WS_FLAG
     *  ,ATOM_INDEX,ATOM_NAME     
     *  ,NMAX1,NMAX2,NMAX12,NPAIR,IPAIR,FULL
     *  ,CHAIN,NAT,NRES,NAT_OCC,NRES_OCC
     *  ,ITRANS,RESULT,IPRROW,IERR)
C ------------------------------------------------
      INTEGER   NSEQ1(NMAX1),NSEQ2(NMAX2)
      INTEGER   IRES1(NMAX1),IRES2(NMAX2)
      INTEGER   IPAIR(2,NMAX12)
      CHARACTER PNUM1(NMAX2)*6,PNUM2(NMAX2)*6,WS_FLAG*1
      REAL      RESULT(IPRROW)
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C ---
      REAL      TR(3),TRMAT(3,3),X(3),Y(3)
      INTEGER   MDOC,IERR
      CHARACTER ANAME*4,CP_PNUM*6,PNUM_OLD*6
      CHARACTER PNUM11*6,PNUM22*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3
      CHARACTER ANAME_OLD*4,CP_ALT*1,CP_SEG*4
      CHARACTER NAMER*(*),NAMEO*(*)
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7,CH4*4,CH1*1
      CHARACTER CNAME*20,REC*4,CHAIN*1,FULL*1
      DATA CNAME/'ABCDEFGHIJKLMNOPRSTU'/
C                 123456789 123456789 
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        RETURN
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        CLOSE(IOUT) 
        RETURN
      ENDIF
C -------------------------------------
      IF(ITRANS.GT.0.AND.IPRROW.GE.41) THEN
        TR(1)      = RESULT(30)
        TR(2)      = RESULT(31) 
        TR(3)      = RESULT(32) 
        TRMAT(1,1) = RESULT(33) 
        TRMAT(1,2) = RESULT(34) 
        TRMAT(1,3) = RESULT(35) 
        TRMAT(2,1) = RESULT(36) 
        TRMAT(2,2) = RESULT(37) 
        TRMAT(2,3) = RESULT(38) 
        TRMAT(3,1) = RESULT(39) 
        TRMAT(3,2) = RESULT(40) 
        TRMAT(3,3) = RESULT(41) 
        IF(ABS(TRMAT(1,1)).GT.0.0001.OR.
     *     ABS(TRMAT(2,2)).GT.0.0001.OR.
     *     ABS(TRMAT(3,3)).GT.0.0001    ) ITRANS = 1
      ENDIF
C -------------------------------------
      IF(CHAIN.EQ.' ') CHAIN = 'A'
      NCH    = 0
      CH1    = CHAIN
      IRES_OLD   = 100000
      IRES_2_OLD = 100000
      IPR    = 1
      IPR1   = IPAIR(1,IPR)
      IPR2   = IPAIR(2,IPR)
      ISEQ1  = NSEQ1(IPR1)
      IRES   = IRES1(IPR1)
c      CHAIN  = PNUM1(IPR1)(1:1)
      IRES_2 = IRES2(IPR2)
      ISEQ2  = NSEQ2(IPR2)
      PNUM22 = PNUM2(IPR2)

      IPR1_C = 1
      IFIRST = 0
      PNUM_OLD    = '?'
      ANAME_OLD   = '?'
      REC         = '?'
      NAT_OCC     = 0
      NAT         = 0   
      NRES        = 0   
      NRES_OCC    = 0   
      IEND        = 0

 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 200
      IF(CP_OCC.LT.0.001) GO TO 200
      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.PNUM_OLD) GO TO 200
      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      IF(ASYMB(1:1).EQ.'H') GO TO 200
      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)

      IF(PNUM_OLD.NE.CP_PNUM) THEN
C       new residue
        IRES = IRES + 1
        NRES = NRES + 1
        IF(CP_OCC.GT.0.001) NRES_OCC = NRES_OCC + 1
        IFLAG_USE = 1
        IF(FULL.EQ.'N') THEN

          READ(CH7(3:6),'(I4)') IRNUMBER

          DO III=1,NPAIR

            PNUM22 = PNUM2(IPAIR(2,III))

C            IF(IRNUMBER.EQ.IRES2(IPAIR(2,III))) GO TO 1111

            IF(CH7(3:7).EQ.PNUM22(2:6)) GO TO 1111

          ENDDO

          IFLAG_USE = 0
 1111     CONTINUE
        ENDIF
      ENDIF      

      IRES_OLD  = IRES
      PNUM_OLD  = CP_PNUM
      ANAME_OLD = ANAME     

      IF(IFLAG_USE.LE.0) GO TO 200

      IF(CP_OCC.GT.0.001) NAT_OCC = NAT_OCC + 1

      NAT = NAT + 1
 
      IF(ITRANS.GT.0) THEN
        READ(LINE(31:54),'(3F8.3)') X(1),X(2),X(3)
        DO II=1,3
          Y(II) =   TRMAT(1,II)*X(1)
     *            + TRMAT(2,II)*X(2)
     *            + TRMAT(3,II)*X(3)
        ENDDO
        DO II=1,3
          Y(II) = Y(II) +  TR(II)
        ENDDO
        WRITE(LINE(31:54),'(3F8.3)') Y(1),Y(2),Y(3)          
      ENDIF

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200

 400  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 200

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200
C -------------------------
 600  CONTINUE
      IEND = 1
 610  CONTINUE

      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      IF(NAT.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms = 0')
        IERR = 1
      ENDIF
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in ALIGN_WRITE_PDB2')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      RETURN
      END

      SUBROUTINE CREATE_PRF_LIST(MDOC
     *   ,CODE8,LEN_CODE
     *   ,ID_DOM,CODE_DOM,ICLASS_DOM,IBACK_DOM,NRES_DOM
     *   ,NDOMAIN
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *   ,ICLASS_LIST
     *   ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C ----------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8,LIST*1
      CHARACTER FILE_SEQ*(*)
      CHARACTER FILE_S*256,FILE_1*256,FILE_2*256,FILE_TEMP*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
C ---
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ----------------
      CHARACTER CODE_DOM(NDOMAIN)*8
      INTEGER   ID_DOM(NDOMAIN),ICLASS_DOM(NDOMAIN),IBACK_DOM(NDOMAIN)
      INTEGER   NRES_DOM(NDOMAIN)

      CHARACTER LINE*512
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      NPRF   = 0
      ID_INI = 0
      DO I=1,NDOMAIN
        IF(CODE_DOM(I)(1:LEN_CODE).EQ.CODE8(1:LEN_CODE)) THEN
          ID_INI = ID_DOM(I)
          GO TO 100 
        ENDIF
      ENDDO
  100 CONTINUE
      IF(ID_INI.LE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: wrong domain code')
        IERR = 1
        GO TO 900
      ENDIF

      WRITE(LINE,'(A,A,A,I8,A,I8,I12)') 
     * 'Initial: ',CODE8,' ',ID_INI,' :'
     * ,IBACK_DOM(ID_INI),ICLASS_DOM(ID_INI)
      CALL MSGDOC(MDOC,LINE)
      ID_FIRST = ID_INI

      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        FILE_S = FILE_SEQ
      ELSE
        CALL LENSTR_BL(PATH_DB,LEN_DB)

        IF(LEN_CODE.GT.5) THEN
          FILE_S = PATH_DB(1:LEN_DB)//'/seq_DOM/'//
     *             CODE_DOM(ID_FIRST)(1:LEN_CODE)//'.seq'  
        ELSE
          FILE_S = PATH_DB(1:LEN_DB)//'/seq_DB/'//
     *             CODE_DOM(ID_FIRST)(1:LEN_CODE)//'.seq' 
        ENDIF 
      ENDIF

      NTOTAL_PRF = 0
      NPRF       = 0

      NDEL = 1000
      NSTEP = 2

      DO ISTEP=1,NSTEP

        NDEL = NDEL * 10

        ICLASS_PRF = ICLASS_DOM(ID_INI)/NDEL
        ISUB_CLASS = ICLASS_DOM(ID_INI) - ICLASS_PRF*NDEL

        ID_PRF = ID_INI
        IF(ISUB_CLASS.LE.0) THEN
          ID_PRF = ID_INI
          GO TO 200
        ENDIF
        ICURR = ID_INI

  210   CONTINUE
        IBK  = IBACK_DOM(ICURR)

        IF(IBK.LE.0) GO TO 200

        ICLASS = ICLASS_DOM(IBK)/NDEL
        ISUB   = ICLASS_DOM(IBK) - ICLASS*NDEL
        IF(ISUB.LE.0) THEN
          ID_PRF = IBK
          GO TO 200
        ENDIF
        ICURR = IBK
        GO TO 210

  200   CONTINUE

        IF(ID_PRF.LE.0) THEN
          CALL MSGERR(MDOC
     *    ,'INFO: there is not PRF')
          IERR = 13
          GO TO 900
        ENDIF

        DO ID=1,NDOMAIN

          ICLASS = ICLASS_DOM(ID)/NDEL
          ISUB   = ICLASS_DOM(ID) - ICLASS*NDEL

          IF(ICLASS.NE.ICLASS_PRF) GO TO 300

          IF(ID.EQ.ID_PRF) GO TO 320

          ICURR = ID

  310     CONTINUE

          IBK  = IBACK_DOM(ICURR)

          IF(IBK.LE.0) GO TO 300

          IF(IBK.EQ.ID_PRF) GO TO 320

          ICURR = IBK
          GO TO 310

  320     CONTINUE

          IF(ISTEP.GT.1.AND.NPRF.GT.0) THEN
            DO II=1,NPRF
              IF(PRF_LIST(II).EQ.CODE_DOM(ID)) GO TO 300
            ENDDO
          ENDIF

          NTOTAL_PRF = NTOTAL_PRF + 1

          WRITE(LINE,'(I5,A,I8,A,A,A,I12,I5,I8)') 
     *      NTOTAL_PRF
     *      ,' id:',ID,' ',CODE_DOM(ID),' '
     *      ,ICLASS_DOM(ID),NRES_DOM(ID),IBACK_DOM(ID)
          CALL MSGDOC(MDOC,LINE)

          IF(NPRF.LT.NPRF_LIST) THEN 

            NPRF = NPRF + 1
            NRES_LIST(NPRF)  = NRES_DOM(ID)
            PRF_LIST(NPRF)   = CODE_DOM(ID)       
            ICLASS_LIST(NPRF)= ICLASS_DOM(ID)
            INDEX_LIST(NPRF) = NPRF

            CALL LENSTR_BL(PATH_DB,LEN_DB)
            FILE_1 = FILE_S
            IF(LEN_CODE.GT.5) THEN
              FILE_2 = PATH_DB(1:LEN_DB)//'/seq_DOM/'//
     *                 CODE_DOM(ID)(1:LEN_CODE)//'.seq'  
            ELSE
              FILE_2 = PATH_DB(1:LEN_DB)//'/seq_DB/'//
     *                 CODE_DOM(ID)(1:LEN_CODE)//'.seq'  
            ENDIF
            FILE_TEMP = ' '
            IPRINT = 0
            MMM = M
            IF(LIST.EQ.'L') THEN
              MMM = MDOC
              IPRINT = 1
            ENDIF
            IERR   = 0  
            CALL MAKE_ALIGN(MMM,IPRINT,FILE_1,FILE_2,FILE_TEMP
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in MAKE_ALIGN: '//CODE_DOM(ID)
              CALL MSGERR(MDOC,LINE)
              SCORE_LIST(NPRF) = 10000.2
              SCORE_LIST(NPRF) = SCORE_LIST(NPRF) + REAL(ISUB)
              Q_LIST(NPRF)     = 0.0
              SML_LIST(NPRF)   = 0.0
              IERR = 0
              GO TO 300
            ENDIF

c           RESULT(6)  = SCORE 
c           RESULT(42) = Q
C           RESULT(3)  = NN   Naa aligned
C           RESULT(19) = FIDENT_NEW
C           RESULT(16) = DRMS_BEST 
C           RESULT(17) = NPAIR_BEST 
C           RESULT(15) = Q_FIN

            SCORE = RESULT(42)
            T      = 1.0 -  SCORE
            IF(T.LT.0.0) T = 0.0
            SCORE_LIST(NPRF) = T + 0.1
            SCORE_LIST(NPRF) = SCORE_LIST(NPRF) + REAL(ISUB)
            IF(ID.EQ.ID_FIRST) SCORE_LIST(NPRF) = 0.0
            Q_LIST(NPRF)     = SCORE
            SML_LIST(NPRF)   = RESULT(5)
C -
          ENDIF

  300     CONTINUE

        ENDDO

        IF(NPRF.GE.NMAX) GO TO 400 

      ENDDO

  400 CONTINUE

      IF(NPRF.GT.1) THEN
        CALL SORT1(SCORE_LIST,NPRF,INDEX_LIST)
      ENDIF

C ------
      RETURN
  900 CONTINUE
      RETURN
      END

      SUBROUTINE CREATE_PRF_NMR_FILES(MDOC
     *   ,FILE_SEQ,FILE_FIRST_CORR,FILE_CORR,LEN_CODE
     *   ,NMODEL,FILE_NMR,FILE_PRF_OUT
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL_INP
     *   ,ICLASS_LIST
     *   ,Q_LIM,ICFLAG
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C ----------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_NMR*(*),FILE_PRF_OUT*(*)
      CHARACTER FILE_SEQ*(*),LIST*1,WFLAG*1,FULL_INP*1
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      Q_LIST(NPRF_LIST),SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
C ---
      PARAMETER ( NPRF_LIST2 = 2000  )
      INTEGER   NRES_LIST2(NPRF_LIST2),INDEX_LIST2(NPRF_LIST2)
      INTEGER   ICLASS_LIST2(NPRF_LIST2)

      REAL      SCORE_LIST2(NPRF_LIST2),Q_LIST2(NPRF_LIST2)
     *         ,SML_LIST2(NPRF_LIST2)
      CHARACTER PRF_LIST2(NPRF_LIST2)*8,COMPLEX_LIST2(NPRF_LIST2)*10
C ---
      CHARACTER FILE_CORR*(*),FILE_FIRST_CORR*(*)
C ---
      CHARACTER FILE_OUT(2)*256,FILE_FIRST*256,FILE1_CORR*256
      CHARACTER FILE_TEMP*256,FILE_TEMP1*256,FILE_SCR*256
      CHARACTER FILE_SCR1*256,FILE_PAIR*256,FILE_T*256
      CHARACTER FILE_PRF(2)*256
      CHARACTER LINE*512,PATH*256
      CHARACTER CODEF*8,CODE8*8,ALIGN_CORR*1,DIST*1,PAIR*1,SORT*1
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      SORT = 'Y'
      NMODEL = 0
      NMAX2  = NMAX*3
      NMAX2  = NPRF
C     25.01.2009
      NMAX2  = NMAX*20

      IF(SORT.EQ.'N') THEN
        Q_LIM2 = 0.1 
        IF(NPRF.LE.NMAX2) Q_LIM2 = 0.0
        IF(Q_LIM2.GT.Q_LIM) Q_LIM2 = Q_LIM
        WRITE(LINE,'(A,F8.3)') 'pre_Q_lim:',Q_LIM2
        CALL MSGDOC(MDOC,LINE)
 
        N = 0
        CALL MSGDOC(MDOC,'==============')
        DO II=1,NPRF
          I = INDEX_LIST(II)
          IF(II.EQ.1.OR.Q_LIST(I).GE.Q_LIM2) THEN
            WRITE(LINE,'(I5,A,A,A,I6,F8.2,F8.3,I10)') 
     *      II,' ',PRF_LIST(I),' Nres,Idnt,Q:'
     *      ,NRES_LIST(I),SML_LIST(I),Q_LIST(I),ICLASS_LIST(I)
            CALL MSGDOC(MDOC,LINE)

            N = N + 1
 
            INDEX_LIST(N) = INDEX_LIST(II)
 
            INDEX_LIST2(N)   = N
            NRES_LIST2(N)    = NRES_LIST(I)
            ICLASS_LIST2(N)  = ICLASS_LIST(I)
            SCORE_LIST2(N)   = 0.0
            Q_LIST2(N)       = Q_LIST(N)
            SML_LIST2(N)     = SML_LIST(I)
            PRF_LIST2(N)     = PRF_LIST(I)
            COMPLEX_LIST2(N) = COMPLEX_LIST2(I)
 
          ELSE
            WRITE(LINE,'(A,A,A,I6,F8.2,F8.3,I10,A)') 
     *      '      ',PRF_LIST(I),' Nres,Idnt,Q:'
     *      ,NRES_LIST(I),SML_LIST(I),Q_LIST(I),ICLASS_LIST(I)
     *      ,' < pre_Q_lim'
            CALL MSGDOC(MDOC,LINE)
          ENDIF
          IF(N.GE.NMAX2) GO TO 200
        ENDDO
        CALL MSGDOC(MDOC,'==============')
  200   CONTINUE
        NPRF = N
        NPRF2 = NPRF
      ELSE
        N = 0
        CALL MSGDOC(MDOC,'=============-')
        DO II=1,NPRF
          I = INDEX_LIST(II)
          WRITE(LINE,'(I5,A,A,A,I6,F8.2,F8.3,I10)') 
     *      II,' ',PRF_LIST(I),' Nres,Idnt,Q:'
     *      ,NRES_LIST(I),SML_LIST(I),Q_LIST(I),ICLASS_LIST(I)
          CALL MSGDOC(MDOC,LINE)
          N = N + 1
          INDEX_LIST2(N)   = N
          NRES_LIST2(N)    = NRES_LIST(I)
          ICLASS_LIST2(N)  = ICLASS_LIST(I) 
          SCORE_LIST2(N)   = 0.0
          Q_LIST2(N)       = Q_LIST(N)
          SML_LIST2(N)     = SML_LIST(I)
          PRF_LIST2(N)     = PRF_LIST(I)
          COMPLEX_LIST2(N) = COMPLEX_LIST2(I)
          IF(N.GE.NMAX2) GO TO 230
        ENDDO
        CALL MSGDOC(MDOC,'==============')
  230   CONTINUE
      ENDIF

      NPRF2 = N

      IF(NPRF2.LE.1) THEN
        LINE = ' ERROR: N < 2'
        CALL MSGERR(MDOC,LINE)
        IERR = 13
        RETURN
      ENDIF
 
      WRITE(LINE,'(A,F8.3)') ' Q_lim:',Q_lim
      CALL MSGDOC(MDOC,LINE)
C --------------------------------------------
      FILE_PRF(1) = 'domain_prfs1.prf'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_PRF(1),LT )
      IF(LEN.GT.0) THEN
        FILE_PRF(1) = PATH_SCR(1:LEN)//FILE_PRF(1)(1:LT) 
      ENDIF

      FILE_PRF(2) = 'domain_prfs2.prf'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_PRF(2),LT )
      IF(LEN.GT.0) THEN
        FILE_PRF(2) = PATH_SCR(1:LEN)//FILE_PRF(2)(1:LT) 
      ENDIF
      FILE_OUT(1) = 'domain_prf1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_OUT(1),LT )
      IF(LEN.GT.0) THEN
        FILE_OUT(1) = PATH_SCR(1:LEN)//FILE_OUT(1)(1:LT) 
      ENDIF

      FILE_OUT(2) = 'domain_prf2.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_OUT(2),LT )
      IF(LEN.GT.0) THEN
        FILE_OUT(2) = PATH_SCR(1:LEN)//FILE_OUT(2)(1:LT) 
      ENDIF

      FILE_FIRST = 'domain_first.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_FIRST,LT )
      IF(LEN.GT.0) THEN
        FILE_FIRST = PATH_SCR(1:LEN)//FILE_FIRST(1:LT) 
      ENDIF

      FILE1_CORR = 'domain_first_corr.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE1_CORR,LT )
      IF(LEN.GT.0) THEN
        FILE1_CORR = PATH_SCR(1:LEN)//FILE1_CORR(1:LT) 
      ENDIF

      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF
      FILE_TEMP1 = 'domain_temp1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP1,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
      ENDIF

      FILE_SCR1 = 'domain_scr1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_SCR1,LT )
      IF(LEN.GT.0) THEN
        FILE_SCR1 = PATH_SCR(1:LEN)//FILE_SCR1(1:LT) 
      ENDIF
C ---
      CALL MSGDOC(MDOC,'= First =============')
      I1 = INDEX_LIST2(1)
      CODE8 = PRF_LIST2(I1)
      CODEF = CODE8
      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC

      FILE_SCR = 'domain_scr.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_SCR,LT )
      IF(LEN.GT.0) THEN
        FILE_SCR = PATH_SCR(1:LEN)//FILE_SCR(1:LT) 
      ENDIF
c ---
      ALIGN_CORR = 'N'
      FILE_T     = ' '
C     get first without model correction (surf&align)
c ---
      CALL GET_DOMAIN_ONE(MMM,PATH_DB
     *   ,FILE_FIRST,FILE_T,FILE_SCR
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in GET_DOMAIN_ONE: '//CODE8
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 910
      ENDIF

      SML = 100.0
      CALL LENSTR_BL(FILE_FIRST_CORR,L)
      IF(L.LE.0) THEN
        CALL LENSTR_BL(FILE_SEQ,LEN)
        IF(LEN.GT.0) THEN
c ---
          ALIGN_CORR = 'Y'
C         get first with model correction (surf&align) for output
c ---
          MMM = MD
          IF(LIST.EQ.'L') MMM = MDOC

          CALL GET_DOMAIN_ONE(MMM,PATH_DB
     *     ,FILE1_CORR,FILE_SEQ,FILE_SCR
     *     ,CODE8,ALIGN_CORR
     *     ,NRES,SML,SCR,NALIGN
     *     ,LIST,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in GET_DOMAIN_ONE: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 910
          ENDIF

        ELSE      
          SML = 100.0
        ENDIF
      ENDIF

      I = INDEX_LIST2(1)
      NFIRST = NRES_LIST2(I)
      WRITE(LINE,'(A,A,A,2I5,F7.2,I10)') 
     *   '   1 ',CODE8(1:7),' Nres,Nalign,Idnt:'
     *    ,NFIRST,NALIGN,SML,ICLASS_LIST2(I)
      CALL MSGDOC(MDOC,LINE)
C ----------------------------
      IF(SORT.EQ.'Y') THEN
        CALL SORT2_BY_3D_ALIGN(M
     *   ,NFIRST,FILE_FIRST,LEN_CODE,FULL_INP
     *   ,NPRF2,NPRF_LIST2,NPRF,NRES_LIST2,PRF_LIST2
     *   ,Q_LIST2,SCORE_LIST2,SML_LIST2,INDEX_LIST2
     *   ,ICLASS_LIST2
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in  SORT2_BY_3D_ALIGN: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 910
        ENDIF
 
        CALL MSGDOC(MDOC,'==============')
        LINE = '      code     Nres Nalgn Idnt    Npr    Q       Rms'
        CALL MSGDOC(MDOC,LINE)
        DO II=1,NPRF2
          I = INDEX_LIST2(II)
          WRITE(LINE,'(I5,A,A,A,I6,F8.2,F8.3,I10)') 
     *      II,' ',PRF_LIST2(I),' Nres,Idnt,Q:'
     *      ,NRES_LIST2(I),SML_LIST2(I),Q_LIST2(I),ICLASS_LIST2(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
        CALL MSGDOC(MDOC,'==============')
      ENDIF

      IFIRST = 0
      NMODEL = 1
      IFL1 = 1
      IFL2 = 2
      LINE = '      code     Nres Nalgn Idnt    Npr    Q       Rms'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,'==============')
      DO II=2,NPRF2
        I = INDEX_LIST2(II)
        CODE8 = PRF_LIST2(I)
        NCURR = NRES_LIST2(I)
        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC
        FILE_SCR = 'domain_scr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_SCR,LT )
        IF(LEN.GT.0) THEN
          FILE_SCR = PATH_SCR(1:LEN)//FILE_SCR(1:LT) 
        ENDIF

C       get current with model correction (if there is sequence)
c        ALIGN_CORR = 'Y'
c        CALL GET_DOMAIN_ONE(MMM,PATH_DB
c     *   ,FILE_TEMP,FILE_SEQ,FILE_SCR
c     *   ,CODE8,ALIGN_CORR
c     *   ,NRES,SML,SCR,NALIGN
c     *   ,LIST,PATH_SCR,PATH_OUT,IERR)

C       get current without model correction 
        ALIGN_CORR = 'A'
        FILE_T = ' ' 
        CALL GET_DOMAIN_ONE(MMM,PATH_DB
     *   ,FILE_TEMP,FILE_T,FILE_SCR
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
 
       IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOMAIN_ONE: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 100
        ENDIF
C ---
C
C       3D alignment  FILE_FIRST <-- FILE_TEMP = FILE_TEMP1
C 
C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
C
        FILE_TEMP1 = 'domain_temp1.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_TEMP1,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
        ENDIF

        IPRINT = 0
        MMM = M
        IF(LIST.EQ.'L') THEN
          MMM = MDOC
          IPRINT = 2
        ENDIF

        IVAR  = 2
c       ivar = 0 or 1 or 2
        IF(IVAR.EQ.0) THEN
c         ivar = 0
c         output   aligned (rotated) file
          IERR   = 1  
          FILE_PAIR = 'align_pair.txt'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
          ENDIF
          PAIR = 'Y'           
          PO   = 0.0
          PE   = 0.0
          DIST = ' '          
          CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          IF(NCURR.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

          SML = FIDENT
          CALL LENSTR_BL(FILE_SEQ,LEN)
          IF(LEN.LE.0) THEN
            SML = SML_LIST(II)
          ENDIF
        
          IF(Q_LIM.GT.0.0001.AND.Q_FIN.LT.Q_LIM) THEN
            WRITE(LINE,'(A,A,A,2I5,F8.3,I5,2F8.3,I10,A)') 
     *      '     ',CODE8(1:7),' '
     *      ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
     *      ,' < Q_lim'
            CALL MSGDOC(MDOC,LINE)
            GO TO 100
          ENDIF

          WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *      II,' ',CODE8(1:7),' '
     *      ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
          CALL MSGDOC(MDOC,LINE)

        ELSE IF(IVAR.EQ.1.OR.IVAR.EQ.2) THEN

c         ivar = 1 or 2
c         output full (rotated) file
c         1 or 2 step
          IERR = -2
          PAIR = ' '
          FILE_PAIR = ' '
          PO = 0.0
c -- 30.10.2008
          PE = 0.01
c --
          DIST = ' '
          IF(IVAR.EQ.1) THEN

            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           

c           for 1 step
            IF(FULL_INP.EQ.'N') IERR = 2 
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE IF(IVAR.EQ.2) THEN
c           for 2 step 
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
            IERR = 2
C           CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_SCR1
            CALL MAKE_ALIGN5D(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_SCR1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          NFIRSTBY2 = NFIRST/2
          IF(NPAIR.LT.NFIRSTBY2) THEN
            DRMS   =-1.0
            Q_FIN  = 0.0
          ELSE IF(NN.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NN)
            Q_FIN  = Q_FIN * EXP(-T)
          ELSE IF(NN.LE.NFIRST) THEN
            T =  1.0 - REAL(NN)/REAL(NFIRST)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

C          ELSE IF(NCURR.GT.NFIRST) THEN
C            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
C            Q_FIN  = Q_FIN * EXP(-T)
C          ENDIF 

          SML = FIDENT
          CALL LENSTR_BL(FILE_SEQ,LEN)
          IF(LEN.LE.0) THEN
            SML = SML_LIST2(II)
          ENDIF
        
          IF(Q_LIM.GT.0.0001.AND.Q_FIN.LT.Q_LIM) THEN
            WRITE(LINE,'(A,A,A,2I5,F8.3,I5,2F8.3,I10,A)') 
     *      '     ',CODE8(1:7),' '
     *      ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
     *      ,' < Q_lim'
            CALL MSGDOC(MDOC,LINE)
            GO TO 100
          ENDIF
          IF(IVAR.EQ.1) THEN
            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        II,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          IF(IVAR.EQ.2) THEN
c --        start 2 step
            IERR = -2
            IF(FULL_INP.EQ.'N') IERR = 2 
            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           
            PO = 0.0
            PE = 0.0
            DIST = 'D'
C           CALL MAKE_ALIGN5(MMM,IPRINT
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *                      ,FILE_FIRST,FILE_SCR1,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in MAKE_ALIGN_D: '//CODE8
              CALL MSGERR(MDOC,LINE)
              IERR = 0
              GO TO 100
            ENDIF
            NN     = RESULT(3)
            FIDENT = RESULT(5)
            NPAIR  = RESULT(17)
            DRMS   = RESULT(16)
            Q_FIN  = RESULT(15)

            IF(NCURR.GT.NFIRST) THEN
              T =  1.0 - REAL(NFIRST)/REAL(NCURR)
              Q_FIN  = Q_FIN * EXP(-T)
            ENDIF 

            SML = FIDENT

            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        II,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)

          ENDIF
c --      end 2 step
 
        ENDIF

C ---
        FILE_SCR = FILE_OUT(IFL1)
        FILE_T   = FILE_PRF(IFL1)
        NMOD1    = 0
        IF(IFIRST.EQ.0) THEN
          CALL LENSTR_BL(FILE_FIRST_CORR,L)
          IF(L.GT.0) THEN
            FILE_SCR = FILE_FIRST_CORR
          ELSE
            CALL LENSTR_BL(FILE_SEQ,LEN)
            IF(LEN.GT.0) THEN
              FILE_SCR = FILE1_CORR
            ELSE
              FILE_SCR = FILE_FIRST
            ENDIF
          ENDIF
          FILE_T = ' '
          IFIRST = 1
          NMOD1 = 1
        ENDIF
C
C       join FILE_SCR + FILE_TEMP1 = FILE_OUT(IFL2)
C

        IF(IVAR.EQ.0) THEN
          FILE_TEMP1 = 'domain_temp1_2.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_TEMP1,LT )
          IF(LEN.GT.0) THEN
            FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
          ENDIF
        ENDIF

        NMODEL = NMODEL + 1
        IF(WFLAG.EQ.'N') Q_FIN = 1.0

C       ICFLAG > 0 all models chain_ID = (ICFLAG), =0 A,B,C,D ....

        CALL JOIN_PDB_MODEL(MDOC,NMODEL,NMOD1
     *               ,Q_FIN,ICFLAG,CODEF,CODE8
     *               ,FILE_SCR,FILE_TEMP1,FILE_OUT(IFL2),IERR)
C --------------------------------------------------------
C     ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
C     IFIRST  1 set MODEL rec for 1st file, 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file, 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st and 2nd file 
C ----
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in JOIN_PDB_MODEL: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 910
        ENDIF

        CALL PREPARE_COOR_PRF(MDOC,CODEF
     *   ,FILE_PAIR,FILE_T,FILE_PRF(IFL2)
     *   ,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in PREPARE_COOR_PRF'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 910
        ENDIF
C ---
        IT   = IFL1
        IFL1 = IFL2
        IFL2 = IT
        IF(NMODEL.GE.NMAX) GO TO 110 
  100   CONTINUE
      ENDDO
  110   CONTINUE
C ------
      CALL MSGDOC(MDOC,'==============')
      WRITE(LINE,'(A,I7)') 'Nmodel :',NMODEL
      CALL MSGDOC(MDOC,LINE)
      IF(NMODEL.GT.1) THEN
        NM = 0

C        I1 = INDEX_LIST2(1)
C        CODE8 = PRF_LIST2(I1)

C        FILE_NMR = CODEF(1:LEN_CODE)//'_nmr.pdb'
C        CALL LENSTR_BL(PATH_PRF ,LEN)
C        CALL LENSTR_BL(FILE_NMR,LT )
C        IF(LEN.GT.0) THEN
C          FILE_NMR = PATH_PRF(1:LEN)//FILE_NMR(1:LT) 
C        ENDIF

        CALL COPY_PDB_FILE(MDOC,NM,FILE_OUT(IFL1),FILE_NMR,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: copy result file: '//CODEF
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 910
        ENDIF

        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC

        CALL LENSTR_BL(FILE_NMR,LT)
        LINE = 'Result : '//FILE_NMR(1:LT)
        CALL MSGDOC(MMM,LINE)

C        FILE_PRF_OUT = CODEF(1:LEN_CODE)//'.prf'
C        CALL LENSTR_BL(PATH_PRF ,LEN)
C        CALL LENSTR_BL(FILE_PRF_OUT,LT )
C        IF(LEN.GT.0) THEN
C          FILE_PRF_OUT = PATH_PRF(1:LEN)//FILE_PRF_OUT(1:LT) 
C        ENDIF

        CALL COPY_PROFILE(MDOC,CODEF
     *       ,NSEQ_PROFILE,FILE_PRF(IFL1),FILE_PRF_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: copy seq_prf result: '//CODEF
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 910
        ENDIF
        CALL LENSTR_BL(FILE_PRF_OUT,LT)
        LINE = 'Seq prf: '//FILE_PRF_OUT(1:LT)
        CALL MSGDOC(MMM,LINE)

        CALL LENSTR_BL(FILE_SEQ,LS)
        CALL LENSTR_BL(FILE_FIRST_CORR,LFC)
        CALL LENSTR_BL(FILE_CORR,LC)
        IF(LS.GT.0.AND.LFC.LE.0.AND.LC.GT.0) THEN
          CALL CORRECTION_PDB_BY_PRF(MDOC
     *     ,FILE_SEQ,FILE_FIRST,FILE_PRF_OUT,FILE_CORR
     *     ,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in : CORRECTION_PDB_BY_PRF'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 910
          ENDIF
          FILE_TEMP = 'domain_temp.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_TEMP,LT )
          IF(LEN.GT.0) THEN
            FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
          ENDIF
          CALL REPLACE_FIRST_MODEL_IN_NMR(MDOC,CODEF
     *               ,FILE_CORR,FILE_OUT(IFL1),FILE_NMR,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in : REPLACE_FIRST_MODEL'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 910
          ENDIF
        ENDIF
      ELSE
        LINE = ' INFO: N_model < 2'
        CALL MSGERR(MDOC,LINE)
        IERR = 13
      ENDIF
C ------
  910 CONTINUE

      FILE_SCR = 'domain_first.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_first_corr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_scr1.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_temp1.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_temp1_1.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_temp1_2.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prf1.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prf2.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prfs1.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prfs2.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prfs1.prf'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domain_prfs2.prf'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)

      FILE_SCR = FILE_PAIR
      PATH = ' '
      CALL DELETE_FILE(PATH,FILE_SCR)

      RETURN
      END
      SUBROUTINE SORT2_BY_3D_ALIGN(MDOC
     *   ,NFIRST,FILE_FIRST,LEN_CODE,FULL_INP
     *   ,NPRF2,NPRF_LIST2,NPRF,NRES_LIST2,PRF_LIST2
     *   ,Q_LIST2,SCORE_LIST2,SML_LIST2,INDEX_LIST2
     *   ,ICLASS_LIST2
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C ----------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LIST*1,FULL_INP*1
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
      INTEGER   NRES_LIST2(NPRF_LIST2),INDEX_LIST2(NPRF_LIST2)
      INTEGER   ICLASS_LIST2(NPRF_LIST2)
      REAL      Q_LIST2(NPRF_LIST2),SML_LIST2(NPRF_LIST2)
      REAL      SCORE_LIST2(NPRF_LIST2)
      CHARACTER PRF_LIST2(NPRF_LIST2)*8       
      CHARACTER FILE_FIRST*(*)
C ---
      CHARACTER FILE_TEMP*256,FILE_TEMP1*256,FILE_SCR*256
      CHARACTER FILE_SCR1*256,FILE_PAIR*256,FILE_T*256
      CHARACTER LINE*512,PATH*256
      CHARACTER CODEF*8,CODE8*8,ALIGN_CORR*1,DIST*1,PAIR*1
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF

      FILE_TEMP1 = 'domain_temp1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP1,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
      ENDIF

      FILE_SCR1 = 'domain_scr1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_SCR1,LT )
      IF(LEN.GT.0) THEN
        FILE_SCR1 = PATH_SCR(1:LEN)//FILE_SCR1(1:LT) 
      ENDIF

      LINE = '      code     Nres Nalgn Idnt    Npr    Q       Rms'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,'===== before sort =========')
      DO I=1,NPRF2
        INDEX_LIST2(I) = I

        ICLASS = ICLASS_LIST2(I)/100000
        ISUB_CLASS = ICLASS_LIST2(I) - ICLASS*100000

        ISUB_CLASS = 0

        IF(I.EQ.1) THEN
          SCORE_LIST2(I) = 0.0
          Q_LIST2(I)     = 1.0
          GO TO 100
        ENDIF 
        CODE8 = PRF_LIST2(I)
        NCURR = NRES_LIST2(I)
        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC
        FILE_SCR = 'domain_scr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_SCR,LT )
        IF(LEN.GT.0) THEN
          FILE_SCR = PATH_SCR(1:LEN)//FILE_SCR(1:LT) 
        ENDIF

C       get current without model correction 
        ALIGN_CORR = 'A'
        FILE_T = ' ' 
        CALL GET_DOMAIN_ONE(MMM,PATH_DB
     *   ,FILE_TEMP,FILE_T,FILE_SCR
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
 
       IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOMAIN_ONE: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          SCORE_LIST2(I) = 10000.1
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = 0.0
          GO TO 100
        ENDIF
C ---
C
C       3D alignment  FILE_FIRST <-- FILE_TEMP = FILE_TEMP1
C 
C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
C
        FILE_TEMP1 = 'domain_temp1.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_TEMP1,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
        ENDIF

        IPRINT = 0
        MMM = M
        IF(LIST.EQ.'L') THEN
          MMM = MDOC
          IPRINT = 2
        ENDIF

        IVAR  = 2
c       ivar = 0 or 1 or 2
        IF(IVAR.EQ.0) THEN
c         ivar = 0
c         output   aligned (rotated) file
          IERR   = 1  
          FILE_PAIR = 'align_pair.txt'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
          ENDIF
          PAIR = 'Y'           
          PO   = 0.0
          PE   = 0.0
          DIST = ' '
          
          CALL MAKE_ALIGN5(M,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          IF(NCURR.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

          SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = Q_FIN

          SML = FIDENT
        
          WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *      I,' ',CODE8(1:7),' '
     *      ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
          CALL MSGDOC(MDOC,LINE)

        ELSE IF(IVAR.EQ.1.OR.IVAR.EQ.2) THEN

c         ivar = 1 or 2
c         output full (rotated) file
c         1 or 2 step
          IERR = -2
          PAIR = ' '
          FILE_PAIR = ' '
          PO = 0.0
c -- 30.10.2008
          PE = 0.01
c --
          DIST = ' '
          IF(IVAR.EQ.1) THEN

            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           

c           for 1 step
            IF(FULL_INP.EQ.'N') IERR = 2 
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE IF(IVAR.EQ.2) THEN
c           for 2 step 
            IERR = 2

c           CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_SCR1
            CALL MAKE_ALIGN5D(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_SCR1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)

          ENDIF
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          IF(Q_FIN.LT.0.001) THEN
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

          NFIRSTBY2 = NFIRST/2
          IF(NPAIR.LT.NFIRSTBY2) THEN
            DRMS   =-1.0
            Q_FIN  = 0.0
          ELSE IF(NN.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NN)
            Q_FIN  = Q_FIN * EXP(-T)
          ELSE IF(NN.LE.NFIRST) THEN
            T =  1.0 - REAL(NN)/REAL(NFIRST)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

c          IF(NCURR.GT.NFIRST) THEN
c            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
c            Q_FIN  = Q_FIN * EXP(-T)
c          ENDIF 

          SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = Q_FIN

          SML = FIDENT

          IF(IVAR.EQ.1) THEN
            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        I,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          IF(IVAR.EQ.2) THEN
c --        start 2 step
            IERR = -2
            IF(FULL_INP.EQ.'N') IERR = 2 
            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           
            PO = 0.0
            PE = 0.0
            DIST = 'D'
C           CALL MAKE_ALIGN5(MMM,IPRINT
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *                      ,FILE_FIRST,FILE_SCR1,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in MAKE_ALIGN_D: '//CODE8
              CALL MSGERR(MDOC,LINE)
              SCORE_LIST2(I) = 10000.1
              SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
              Q_LIST2(I)     = 0.0
              IERR = 0
              GO TO 100
            ENDIF
            NN     = RESULT(3)
            FIDENT = RESULT(5)
            NPAIR  = RESULT(17)
            DRMS   = RESULT(16)
            Q_FIN  = RESULT(15)

c            NFIRSTBY2 = NFIRST/2
c            IF(NPAIR.LT.NFIRSTBY2) THEN
c              DRMS   =-1.0
c              Q_FIN  = 0.0
c            ELSE IF(NN.GT.NFIRST) THEN
c              T =  1.0 - REAL(NFIRST)/REAL(NN)
c              Q_FIN  = Q_FIN * EXP(-T)
c            ELSE IF(NN.LE.NFIRST) THEN
c              T =  1.0 - REAL(NN)/REAL(NFIRST)
c              Q_FIN  = Q_FIN * EXP(-T)
c            ENDIF 

            IF(NCURR.GT.NFIRST) THEN
              T =  1.0 - REAL(NFIRST)/REAL(NCURR)
              Q_FIN  = Q_FIN * EXP(-T)
            ENDIF 

            SML = FIDENT

            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        I,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)

            SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)

            Q_LIST2(I)     = Q_FIN

          ENDIF
c --      end 2 step
 
        ENDIF

  100   CONTINUE
      ENDDO
      CALL MSGDOC(MDOC,'==============')

      CALL SORT1(SCORE_LIST2,NPRF2,INDEX_LIST2)

      RETURN
      END


      SUBROUTINE SORT2_BY_3D_ALIGN_old(MDOC
     *   ,NFIRST,FILE_FIRST,LEN_CODE,FULL_INP
     *   ,NPRF2,NPRF_LIST2,NPRF,NRES_LIST2,PRF_LIST2
     *   ,Q_LIST2,SCORE_LIST2,SML_LIST2,INDEX_LIST2
     *   ,ICLASS_LIST2
     *   ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C ----------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LIST*1,FULL_INP*1
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
      INTEGER   NRES_LIST2(NPRF_LIST2),INDEX_LIST2(NPRF_LIST2)
      INTEGER   ICLASS_LIST2(NPRF_LIST2)
      REAL      Q_LIST2(NPRF_LIST2),SML_LIST2(NPRF_LIST2)
      REAL      SCORE_LIST2(NPRF_LIST2)
      CHARACTER PRF_LIST2(NPRF_LIST2)*8       
      CHARACTER FILE_FIRST*(*)
C ---
      CHARACTER FILE_TEMP*256,FILE_TEMP1*256,FILE_SCR*256
      CHARACTER FILE_SCR1*256,FILE_PAIR*256,FILE_T*256
      CHARACTER LINE*512,PATH*256
      CHARACTER CODEF*8,CODE8*8,ALIGN_CORR*1,DIST*1,PAIR*1
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF

      FILE_TEMP1 = 'domain_temp1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP1,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
      ENDIF

      FILE_SCR1 = 'domain_scr1.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_SCR1,LT )
      IF(LEN.GT.0) THEN
        FILE_SCR1 = PATH_SCR(1:LEN)//FILE_SCR1(1:LT) 
      ENDIF

      LINE = '      code     Nres Nalgn Idnt    Npr    Q       Rms'
      CALL MSGDOC(MDOC,LINE)
      CALL MSGDOC(MDOC,'===== before sort =========')
      DO I=1,NPRF2
        INDEX_LIST2(I) = I

        ICLASS = ICLASS_LIST2(I)/100000
        ISUB_CLASS = ICLASS_LIST2(I) - ICLASS*100000

        ISUB_CLASS = 0

        IF(I.EQ.1) THEN
          SCORE_LIST2(I) = 0.0
          Q_LIST2(I)     = 1.0
          GO TO 100
        ENDIF 
        CODE8 = PRF_LIST2(I)
        NCURR = NRES_LIST2(I)
        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC
        FILE_SCR = 'domain_scr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_SCR,LT )
        IF(LEN.GT.0) THEN
          FILE_SCR = PATH_SCR(1:LEN)//FILE_SCR(1:LT) 
        ENDIF

C       get current without model correction 
        ALIGN_CORR = 'A'
        FILE_T = ' ' 
        CALL GET_DOMAIN_ONE(MMM,PATH_DB
     *   ,FILE_TEMP,FILE_T,FILE_SCR
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
 
       IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOMAIN_ONE: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          SCORE_LIST2(I) = 10000.1
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = 0.0
          GO TO 100
        ENDIF
C ---
C
C       3D alignment  FILE_FIRST <-- FILE_TEMP = FILE_TEMP1
C 
C -----------------------------------
C  IERR = 0 CORR = N  (FILE_OUT) aligned file_2 (not rotated)  
C  IERR =-1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (not rotated)  
C  IERR = 1 CORR = 2  (FILE_OUT+_1_2) aligned file1 and file_2 (rotated)  
C  IERR = 2 CORR = Y : OUT - no aligned PDB file_2 rotated noFULL
C  IERR =-2 CORR = Y : OUT - no aligned PDB file_2 rotated FULL
C  IERR = 3 CORR = P  (FILE_OUT) profile  
C  DIST = <N>/D/P ; PAIR = <N>/Y   PATH_SCR//'align_pair.txt'
C -----------------------------------
C
        FILE_TEMP1 = 'domain_temp1.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_TEMP1,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP1 = PATH_SCR(1:LEN)//FILE_TEMP1(1:LT) 
        ENDIF

        IPRINT = 0
        MMM = M
        IF(LIST.EQ.'L') THEN
          MMM = MDOC
          IPRINT = 2
        ENDIF

        IVAR  = 2
c       ivar = 0 or 1 or 2
        IF(IVAR.EQ.0) THEN
c         ivar = 0
c         output   aligned (rotated) file
          IERR   = 1  
          FILE_PAIR = 'align_pair.txt'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
          ENDIF
          PAIR = 'Y'           
          PO   = 0.0
          PE   = 0.0
          DIST = ' '
          
          CALL MAKE_ALIGN5(M,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          IF(NCURR.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

          SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = Q_FIN

          SML = FIDENT
        
          WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *      I,' ',CODE8(1:7),' '
     *      ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
          CALL MSGDOC(MDOC,LINE)

        ELSE IF(IVAR.EQ.1.OR.IVAR.EQ.2) THEN

c         ivar = 1 or 2
c         output full (rotated) file
c         1 or 2 step
          IERR = -2
          PAIR = ' '
          FILE_PAIR = ' '
          PO = 0.0
c -- 30.10.2008
c         PE = 0.01
          PE = 0.0
c --
          DIST = ' '
          IF(IVAR.EQ.1) THEN

            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           

c           for 1 step
            IF(FULL_INP.EQ.'N') IERR = 2 
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE IF(IVAR.EQ.2) THEN
c           for 2 step 
            IERR = 2

            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_FIRST,FILE_TEMP,FILE_SCR1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)

          ENDIF
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

C         RESULT(3) = NN   Naa aligned
C         RESULT(19) = FIDENT_NEW
C         RESULT(16) = DRMS_BEST 
C         RESULT(17) = NPAIR_BEST 
C         RESULT(15) = Q_FIN
          NN     = RESULT(3)
          FIDENT = RESULT(5)
          NPAIR  = RESULT(17)
          DRMS   = RESULT(16)
          Q_FIN  = RESULT(15)

          IF(Q_FIN.LT.0.001) THEN
            IERR = 0
            SCORE_LIST2(I) = 10000.1
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
            Q_LIST2(I)     = 0.0
            GO TO 100
          ENDIF

          IF(NCURR.GT.NFIRST) THEN
            T =  1.0 - REAL(NFIRST)/REAL(NCURR)
            Q_FIN  = Q_FIN * EXP(-T)
          ENDIF 

          SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
          SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
          Q_LIST2(I)     = Q_FIN

          SML = FIDENT

          IF(IVAR.EQ.1) THEN
            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        I,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)
          ENDIF

          IF(IVAR.EQ.2) THEN
c --        start 2 step
            IERR = -2
            IF(FULL_INP.EQ.'N') IERR = 2 
            FILE_PAIR = 'align_pair.txt'
            CALL LENSTR_BL(PATH_SCR,LEN)
            IF(LEN.GT.0) THEN
              FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
            ENDIF
            PAIR = 'Y'           
            PO = 0.0
            PE = 0.0
            DIST = 'D'
            CALL MAKE_ALIGN5(MMM,IPRINT
     *                      ,FILE_FIRST,FILE_SCR1,FILE_TEMP1
     *                      ,PAIR,DIST,PO,PE
     *                      ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: in MAKE_ALIGN_D: '//CODE8
              CALL MSGERR(MDOC,LINE)
              SCORE_LIST2(I) = 10000.1
              SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)
              Q_LIST2(I)     = 0.0
              IERR = 0
              GO TO 100
            ENDIF
            NN     = RESULT(3)
            FIDENT = RESULT(5)
            NPAIR  = RESULT(17)
            DRMS   = RESULT(16)
            Q_FIN  = RESULT(15)
            NFIRSTBY2 = NFIRST/2
            IF(NPAIR.LT.NFIRSTBY2) THEN
              DRMS   =-1.0
              Q_FIN  = 0.0
            ELSE IF(NN.GT.NFIRST) THEN
              T =  1.0 - REAL(NFIRST)/REAL(NN)
              Q_FIN  = Q_FIN * EXP(-T)
            ELSE IF(NN.LE.NFIRST) THEN
              T =  1.0 - REAL(NN)/REAL(NFIRST)
              Q_FIN  = Q_FIN * EXP(-T)
            ENDIF 

            SML = FIDENT

            WRITE(LINE,'(I4,A,A,A,2I5,F8.3,I5,2F8.3,I10)') 
     *        I,' ',CODE8(1:7),' '
     *        ,NCURR,NN,SML,NPAIR,Q_FIN,DRMS,ICLASS_LIST2(I)
            CALL MSGDOC(MDOC,LINE)

            SCORE_LIST2(I) = 1.0 - Q_FIN + 0.05
            SCORE_LIST2(I) = SCORE_LIST2(I) + REAL(ISUB_CLASS)

            Q_LIST2(I)     = Q_FIN

          ENDIF
c --      end 2 step
 
        ENDIF

  100   CONTINUE
      ENDDO
      CALL MSGDOC(MDOC,'==============')

      CALL SORT1(SCORE_LIST2,NPRF2,INDEX_LIST2)

      RETURN
      END

      SUBROUTINE CORRECTION_PDB_BY_PRF(MDOC
     *   ,FILE_SEQ,FILE_FIRST,FILE_PRF,FILE_CORR
     *   ,PATH_SCR,PATH_OUT,IERR)
C ----------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_SEQ*(*),FILE_PRF*(*),FILE_CORR*(*),FILE_FIRST*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_SCR*256
      CHARACTER FILE_PAIR*256
      CHARACTER LINE*256
      CHARACTER DIST*1,PAIR*1,PATH*1
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ----------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      FILE_PAIR = 'align_pair.txt'
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_PAIR = PATH_SCR(1:LEN)//'align_pair.txt' 
      ENDIF
      FILE_SCR = ' '
      IPRINT = 2
      IERR = 0
      PO = 0.0
      PE = 0.0
      PAIR = 'Y'         
      DIST = ' '

      CALL MAKE_ALIGN5(MDOC,IPRINT
     *         ,FILE_PRF,FILE_SEQ,FILE_SCR
     *         ,PAIR,DIST,PO,PE
     *         ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in MAKE_ALIGN5 '
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL CORR_SEQ_PRF(MDOC,FILE_FIRST,FILE_CORR,FILE_PAIR
     *  ,NAT,NRES,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in CORR_SEQ_PRF'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(FILE_CORR,LT)
      LINE = 'Corr_file : '//FILE_CORR(1:LT)
      CALL MSGDOC(MDOC,LINE)

  900 CONTINUE    

      PATH = ' '
      CALL DELETE_FILE(PATH,FILE_PAIR)

      RETURN
      END

      SUBROUTINE CORR_SEQ_PRF(MDOC,NAMER,NAMEO,NAMEP
     *  ,NAT,NRES,IERR)
C ------------------------------------------------
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: NSEQ2(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: IRES2(:)
      integer,   allocatable :: IDOM1(:)
      character(LEN=6), allocatable :: PNUM1(:)
      character(LEN=6), allocatable :: PNUM2(:)
C -----
      CHARACTER ATOM_NAME(9)*2
      INTEGER   ATOM_INDEX(4,25)
C ---
      INTEGER   MDOC,IERR
      CHARACTER ANAME*4,CP_PNUM*6,PNUM_OLD*6,PNUMW*6
      CHARACTER ASYMB*4,CTYPE*4,RNAME*3
      CHARACTER ANAME_OLD*4,CP_ALT*1,CP_SEG*4

      CHARACTER NAMER*(*),NAMEO*(*),NAMEP*(*)
      CHARACTER LINE*256,PATH*1,EXT*1,CH7*7,CH4*4,CH1*1,AA1*1,AA2*1
      CHARACTER REC*4,CHAIN*1,SS1*1,SS2*1
      CHARACTER AMIN(25)*1
C --
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL SET_ATOM_INDEX(MDOC,ATOM_INDEX,ATOM_NAME)     
C ----
      CALL LENSTR_BL(NAMEP,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input pair file name')
        IERR = 1
        RETURN
      ENDIF
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,NAMEP,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open intput pair file')
        RETURN
      ENDIF
      NPAIR = 0
      DO I=1,1000000
        READ(IN,'(A)',ERR=900,END=1000) LINE
        NPAIR = NPAIR + 1
      ENDDO
 1000 CONTINUE
      CLOSE(IN) 
      IF(NPAIR.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Npair < 1')
        IERR = 1
        RETURN
      ENDIF

      allocate(NSEQ1(1:NPAIR),STAT=ISTAT)
      allocate(NSEQ2(1:NPAIR),STAT=ISTAT)
      allocate(IRES1(1:NPAIR),STAT=ISTAT)
      allocate(IRES2(1:NPAIR),STAT=ISTAT)
      allocate(IDOM1(1:NPAIR),STAT=ISTAT)
      allocate(PNUM1(1:NPAIR),STAT=ISTAT)
      allocate(PNUM2(1:NPAIR),STAT=ISTAT)

      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,NAMEP,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open intput pair file')
        GO TO 510
      ENDIF

      DO I=1,1000000
        READ(IN,'(A)',ERR=910,END=1010) LINE

CC123456789 123456789 123456789 12345
CC123456789 112345 1123456789 12345 1
CC  114)  132  128 V   -   114  114 V
Cc   37)   37  127 R   -   119  119 Q
CC    3)    3    0 =   -
CC        READ(LINE,'(11X,I5,1X,A1,10X,I5,1X,A1)',ERR=910) 
CC     *    IRES1(I),AA1,IRES2(I),AA2

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.40) THEN
          READ(LINE,'(11X,A6,A1,1X,A1,I5,8X,A6,A1,1X,A1)',ERR=910) 
     *      PNUM1(I),AA1,SS1,IDOM1(I),PNUM2(I),AA2,SS2
          IF(LEN.LE.41) SS2 = ' '
        ELSE
          READ(LINE,'(11X,A6,A1,1X,A1,I5)',ERR=910) 
     *      PNUM1(I),AA1,SS1,IDOM1(I)
          PNUM2(I) = '      '
          AA2 = ' '
          SS2 = ' '
        ENDIF

        IF(PNUM1(I)(5:5).NE.' ') THEN
          READ(PNUM1(I)(2:5),'(I4)') IRES1(I)
        ELSE
          IRES1(I) = 0
        ENDIF
        IF(PNUM2(I)(5:5).NE.' ') THEN
          READ(PNUM2(I)(2:5),'(I4)') IRES2(I)
        ELSE
          IRES2(I) = 0
        ENDIF

        DO J=1,25
          IF(AMIN(J).EQ.AA1) GO TO 1020
        ENDDO
        J = 0
 1020   CONTINUE

C        IF((J.LE.0.OR.J.GT.20).AND.J.NE.24.AND.J.NE.25) THEN
C          CALL MSGERR(MDOC,'ERROR: wrong AA1 in PAIR file')
C          WRITE(*,*) '--',J
C          IERR = 1
C          GO TO 910
C        ENDIF

        NSEQ1(I) = J

        DO J=1,25
          IF(AMIN(J).EQ.AA2) GO TO 1030
        ENDDO
        J = 0
 1030   CONTINUE

C        IF((J.LE.0.OR.J.GT.20).AND.J.NE.24.AND.J.NE.25) THEN
C          CALL MSGERR(MDOC,'ERROR: wrong AA2 in PAIR file')
C          IERR = 1
C          WRITE(*,*) '--',J
C          GO TO 910
C        ENDIF

        NSEQ2(I) = J

      ENDDO

 1010 CONTINUE
      CLOSE(IN) 

C ----
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        GO TO 510
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        GO TO 510
      ENDIF
c--------------------------------------
      CALL CORR_NAME_BLC(NAMER)
      CALL LENSTR_BL(NAMER,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        CLOSE(IOUT) 
        IERR = 1
        GO TO 510
      ENDIF
      INC  = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(INC,M,PATH,NAMER,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        CLOSE(IOUT) 
        GO TO 510
      ENDIF
C -------------------------------------
      IFLAG_USE  = 0
      IR1_OLD  = 100000
      IR2_OLD  = 100000
      IR1      = 100000
      IR2      = 100000
      PNUM_OLD   = '?'
      ANAME_OLD  = '?'
      REC        = '?'
      NAT        = 0   
      NRES       = 0   
      PNUMW      = ' '

 200  CONTINUE

      READ(INC,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.54) GO TO 200

      IF(REC.EQ.'ATOM'.AND.LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ELSE IF(LINE(1:4).EQ.'ANIS') THEN
        GO TO 200
      ENDIF

      REC = '?'

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

      CH1 = LINE(22:22)
      CHAIN = 'A'
      CH1 = CHAIN

C     FRMT/'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,10X,A4)'/

      READ(LINE,'(12X,A4,A1,A3,A7,27X,2F6.2)',ERR=500) 
     *    ANAME,CP_ALT,RNAME,CH7,CP_OCC,CP_BISO

      CP_SEG = '    '
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GE.75) THEN
        CP_SEG(1:3) = LINE(73:75)
        CP_SEG(4:4) = ' '
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF
      IF(LEN.GE.76) THEN
        CP_SEG = LINE(73:76)
        CP_SEG(1:2) = CHAIN//CHAIN
      ENDIF

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1') GO TO 200

      ASYMB='    '
      CALL CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
      CP_PNUM(1:1) = CH7(2:2)
      CP_PNUM(2:6) = CH7(3:7)
      IF(ASYMB(1:1).EQ.'H') GO TO 200

      IF(CP_OCC.LT.0.001) GO TO 200

      IF(ANAME.EQ.ANAME_OLD.AND.CP_PNUM.EQ.PNUM_OLD) GO TO 200
      IF(PNUM_OLD.NE.CP_PNUM) THEN
C       new residue
        NRES = NRES + 1
        IFLAG_USE = 1

        READ(CH7(3:6),'(I4)') IRNUMBER

        DO III=1,NPAIR

          ISEQ2 = NSEQ1(III)
          ISEQ1 = NSEQ2(III)
             
C          IF(IRNUMBER.EQ.IRES1(III).AND.
C     *       ISEQ1.GE.1.AND.ISEQ1.LE.20.AND.
C     *       ISEQ2.GE.1.AND.ISEQ2.LE.20     ) THEN
C            IR1  = IRES1(III)
C            IR2  = IRES2(III)
C            IRES = IR2
C            GO TO 1111
C          ENDIF

          IF(CP_PNUM(2:6).EQ.PNUM1(III)(2:6).AND.
     *       ISEQ1.GE.1.AND.ISEQ1.LE.20.AND.
     *       ISEQ2.GE.1.AND.ISEQ2.LE.20     ) THEN
            IR1  = IRES1(III)
            IR2  = IRES2(III)
            IRES = IR2
            PNUMW = PNUM2(III)
            GO TO 1111
          ENDIF

        ENDDO

        IFLAG_USE = 0
 1111   CONTINUE
      ENDIF      

      PNUM_OLD  = CP_PNUM
      ANAME_OLD = ANAME     
      IF(IFLAG_USE.LE.0) GO TO 200

      CALL CORR_RESNAME_BY_SYNONYM(RNAME)

      IWRT = 1
      CALL CORR_ATOME_NAME_AFTER_ALIGN(
     *                         ANAME,RNAME,ASYMB,IWRT)
      IF(IWRT.EQ.0) GO TO 200

      CALL CHAINGE_ATOME_ALIGN2(ANAME,ISEQ1,ISEQ2,RNAME,IWRT
     * ,ATOM_INDEX,ATOM_NAME)  
   
      CALL CORR_ATOME_NAME_AFTER_ALIGN(ANAME,RNAME,ASYMB,IWRT)

      IF(RNAME.EQ.'---') IWRT = 0
      IF(IWRT.EQ.1.AND.ANAME(1:3).EQ.'N  ') THEN
        IDRES   = IR1 - IR1_OLD
        IDRES_2 = IR2 - IR2_OLD
        IF(IDRES.GT.1.AND.IDRES_2.EQ.1) IWRT = 0
      ENDIF

      IF(IWRT.EQ.1) THEN
        NAT = NAT + 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.78) LINE(77:78) =' '//ANAME(1:1)      

C        WRITE(CH4,'(I4)') IRES
C        LINE(13:27) = ' '//ANAME(1:3)//' '//RNAME//' '//CH1//CH4//' '

        LINE(13:27) = ' '//ANAME(1:3)//' '//RNAME//' '//CH1//PNUMW(2:6)

        LINE(77:80) = '    '
        LINE(73:76) = CP_SEG

        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

        IR1_OLD = IR1
        IR2_OLD = IR2

      ENDIF

      GO TO 200

C ---
 400  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 200

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      GO TO 200
C -------------------------
 600  CONTINUE

      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(INC) 
      IF(NAT.LE.0) THEN
        CALL MSGERR(MDOC,' Number of atoms = 0')
        IERR = 1
      ENDIF

 510  CONTINUE
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(NSEQ2,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(IRES2,STAT=ISTAT)
      deallocate(IDOM1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)
      deallocate(PNUM2,STAT=ISTAT)
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in ALIGN_WRITE_PDB2')
      IERR = 1
      CLOSE(IOUT)
      CLOSE(INC) 
      GO TO 510
 910  CONTINUE
      CLOSE(IN) 
      CALL MSGERR(MDOC,' ERROR: read PAIR file')
      GO TO 510
 900  CONTINUE
      CLOSE(IN) 
      CALL MSGERR(MDOC,' ERROR: read PAIR file')
      RETURN
      END

      SUBROUTINE CREATE_PROFILE_SEQ(MDOC,LIST
     *   ,PATH_DB,PATH_SCR,LEN_CODE
     *   ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *   ,Q_LIST,INDEX_LIST
     *   ,IERR)
C ----------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PATH_DB*(*),CODE1*8,CODE2*8,PATH_SCR*(*)
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      REAL      Q_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8       
      CHARACTER LINE*256,LIST*1,PATH*256
      CHARACTER FILE_1*256,FILE_2*256,FILE_OUT*256
      PARAMETER ( IPRROW = 100)
      REAL      RESULT(IPRROW)
C ----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL MSGDOC(MDOC,'==============')
      DO II=1,NPRF
        I = INDEX_LIST(II)
        WRITE(LINE,'(I5,A,A,A,I6,F8.3)') 
     *    II,' ',PRF_LIST(I),' Nres:',NRES_LIST(I),Q_LIST(I)
        CALL MSGDOC(MDOC,LINE)
      ENDDO
      CALL MSGDOC(MDOC,'==============')
C ----------------------------
      N      = 1
      IFIRST = 0
      DO II=2,NPRF
        I  = INDEX_LIST(II)
        I1 = INDEX_LIST(1)
        CODE1 = PRF_LIST(I1)
        CODE2 = PRF_LIST(II)

c       FILE_OUT = 'prf_DOM/'//CODE1(1:LEN_CODE)//'.prf'
        FILE_OUT = CODE1(1:LEN_CODE)//'.prf'

        CALL LENSTR_BL(PATH_DB,LEN_DB)
        IF(IFIRST.GT.0) THEN
c         FILE_1 = 'prf_DOM/'//CODE1(1:LEN_CODE)//'.prf'  
          FILE_1 = CODE1(1:LEN_CODE)//'.prf'  
        ELSE
          FILE_1 = PATH_DB(1:LEN_DB)//'/seq_DOM/'//
     *           CODE1(1:LEN_CODE)//'.seq'  
        ENDIF
        FILE_2 = PATH_DB(1:LEN_DB)//'/seq_DOM/'//
     *           CODE2(1:LEN_CODE)//'.seq'  
C ---
        IPRINT = 0
        PATH = ' '
C       IERR = 3 CORR = P (FILE_OUT) profile  
        IERR = 3
        IPRINT = 0
        MMM = M
        IF(LIST.EQ.'L') THEN
          IPRINT = 1
          MMM = MDOC
        ENDIF

        CALL MAKE_ALIGN(MMM,IPRINT,FILE_1,FILE_2,FILE_OUT
     *           ,RESULT,IPRROW,PATH_SCR,PATH,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERROR: in MAKE_ALIGN '//CODE2(1:LEN_CODE)
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 100
        ENDIF
        N = N + 1
        IFIRST = 1
  100   CONTINUE

      ENDDO
      WRITE(LINE,'(A,I6)') 'N_seq in output file',N
      CALL MSGDOC(MDOC,LINE)
      
      IF(N.GT.1) THEN
        CALL LENSTR_BL(FILE_OUT,LT)
        LINE = 'Result : '//FILE_OUT(1:LT)
        CALL MSGDOC(MDOC,LINE)
      ELSE
        IERR = 1
        CALL MSGERR(MDOC,'ERROR: N_seq < 2')
      ENDIF
C ------------
 900  CONTINUE
      RETURN
      END

      SUBROUTINE JOIN_PDB_MODEL(MDOC,NMODEL,IFIRST
     *               ,Q_FIN,ICFLAG,CODEF,CODE8
     *               ,NAME_IN,NAME_IN2,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_IN2*(*),NAME_OUT*(*)
C --------------------------------------------------------
C     ICFLAG > 0 all ch_ID = (ICFLAG); =0 A,B,C,D ..; <0 save ch_ID
C     IFIRST  1 set MODEL rec for 1st file; 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file (save ch_ID); 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st file (save ch_ID); copy 2nd file: ch_ID see ICFLAG 
C ----
      CHARACTER CODEF*8,CODE8*8
      CHARACTER LINE*256,PATH*80,EXT*80

      CHARACTER CHAIN_ID*80,CH1*1
      PARAMETER ( NCHAIN_ID = 26 )
      DATA CHAIN_ID
     * /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
C        123456789 123456789 123456
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      CALL LENSTR_BL(NAME_IN2,LEN)
      IF(LEN.LE.0.OR.NAME_IN2(1:1).EQ.' '.OR.NAME_IN2(1:1).EQ.',')THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file2 name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      IFT = 0
 400  CONTINUE

      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        IF(IFIRST.EQ.1) THEN
          IF(LINE(1:6).EQ.'HEADER') THEN

cHEADER    DNA BINDING PROTEIN                     13-FEB-04   1SD7
c123456789 123456789 123456789 123456789 123456789 123456789 123456789 

            LINE(11:50) = 'BALBES NMR                              '
          ELSE IF(LINE(1:6).EQ.'CRYST1') THEN
C123456789 123456789 123456789 123456789 123456789 123456789 123456789 
CCRYST1  141.866  141.866  120.965  90.00  90.00 120.00 P 63         24 
            LINE(56:70) = 'P 1            '         
          ELSE IF(LINE(1:6).EQ.'COMPND') THEN
            GO TO 400
          ELSE IF(LINE(1:5).EQ.'SCALE') THEN
            GO TO 400
          ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
            GO TO 400
          ELSE IF(LINE(1:5).EQ.'MODEL') THEN
            IF(IFT.LE.0) THEN
              IFT = 1
              GO TO 400  
            ENDIF
          ENDIF
        ENDIF        
        IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *            (LINE(1:6).EQ.'HETATM')    ) THEN

cATOM    193  OH  TYR A  24      44.159  25.727  21.408  1.00 39.33221.85AA1  O
cATOM      9  CA  TYR B   6      21.332  22.955  30.468  1.00 96.63      BB1  C
c123456789 123456789 123456789 123456789 123456789 123456789 123456789 

          CH1 = LINE(22:22)
          IF(IFIRST.EQ.1) THEN
            IF(ICFLAG.LT.0) THEN
              CH1 = LINE(22:22)
            ELSE 
              IF(ICFLAG.EQ.0) THEN
                IT = 1
              ELSE IF(ICFLAG.GT.0) THEN
                IT = ICFLAG
              ENDIF
              IF(IT.GT.NCHAIN_ID) IT = NCHAIN_ID
              CH1 = CHAIN_ID(IT:IT)
            ENDIF
          ENDIF
          
          LINE(22:22) = CH1
          LINE(73:74) = CH1//CH1
          IF(LEN.LE.71) THEN
            LINE(67:72) = '      '
          ENDIF

        ENDIF
        WRITE(IOUT,'(A)') LINE(1:LEN)
        IF(LINE(1:4).EQ.'CRYS'.AND.IFIRST.EQ.1) THEN
          IT = 1
          Q  = 1
          WRITE(LINE,'(A,I5,F10.3,A,A)') 'MODEL    ',IT,Q,'  ',CODEF
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)') LINE(1:LEN)
        ENDIF

      ENDIF

      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
C ----------------
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN2,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ----------------
      IF(IFIRST.GE.0) THEN
        IT = 1
        IF(Q_FIN.GT.0.0001) IT = Q_FIN
        WRITE(LINE,'(A,I5,F10.3,A,A)') 
     *            'MODEL    ',NMODEL,Q_FIN,'  ',CODE8
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)
      ENDIF

 410  CONTINUE
      READ(IU,'(A)',ERR=510,END=610) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN

        IF(LINE(1:6).EQ.'HEADER') THEN
          GO TO 410
        ELSE IF(LINE(1:6).EQ.'COMPND') THEN
          GO TO 410
        ELSE IF(LINE(1:4).EQ.'CRYS') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'MODEL') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'SCALE') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
          GO TO 410
        ENDIF

        IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 410

cATOM    193  OH  TYR A  24      44.159  25.727  21.408  1.00 39.33221.85AA1  O
cATOM      9  CA  TYR B   6      21.332  22.955  30.468  1.00 96.63      BB1  C
c123456789 123456789 123456789 123456789 123456789 123456789 123456789 

        IF(ICFLAG.LT.0) THEN
          CH1 = LINE(22:22)
        ELSE 
          IF(ICFLAG.EQ.0) THEN
            IT = NMODEL
          ELSE IF(ICFLAG.GT.0) THEN
            IT = ICFLAG
          ENDIF
          IF(IT.GT.NCHAIN_ID) IT = NCHAIN_ID
          CH1 = CHAIN_ID(IT:IT)
        ENDIF
          
        LINE(22:22) = CH1
        LINE(73:74) = CH1//CH1
        IF(LEN.LE.71) THEN
          LINE(67:72) = '      '
        ENDIF

        IF(Q_FIN.GT.0.0001) THEN
          T = Q_FIN
          IF(T.GT.1.0) T = 1.0
          IF(T.LT.0.1) T = 0.1
          WRITE(LINE(55:60),'(F6.2)') T
        ENDIF

        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)

      ENDIF

      GO TO 410
C --------------
 610  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 210  CONTINUE
      LINE = ' ERROR: cannot open file2'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
 510  CONTINUE
      LINE = ' ERROR: reading input file2'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE REPLACE_FIRST_MODEL_IN_NMR(MDOC,CODEF
     *               ,NAME_IN,NAME_IN2,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_IN2*(*),NAME_OUT*(*)
C --------------------------------------------------------
      CHARACTER CODEF*8
      CHARACTER LINE*256,PATH*80,EXT*80
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file1 name')
        IERR = 1
        RETURN
      ENDIF
      CALL LENSTR_BL(NAME_IN2,LEN)
      IF(LEN.LE.0.OR.NAME_IN2(1:1).EQ.' '.OR.NAME_IN2(1:1).EQ.',')THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file2 name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
 400  CONTINUE

      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN

        IF(LINE(1:6).EQ.'HEADER') THEN

cHEADER    DNA BINDING PROTEIN                     13-FEB-04   1SD7
c123456789 123456789 123456789 123456789 123456789 123456789 123456789 

          LINE(11:50) = 'BALBES NMR                              '
        ELSE IF(LINE(1:6).EQ.'CRYST1') THEN
C123456789 123456789 123456789 123456789 123456789 123456789 123456789 
CCRYST1  141.866  141.866  120.965  90.00  90.00 120.00 P 63         24 
          LINE(56:70) = 'P 1            '         
        ELSE IF(LINE(1:6).EQ.'COMPND') THEN
          GO TO 400
        ELSE IF(LINE(1:5).EQ.'MODEL') THEN
          GO TO 400
        ELSE IF(LINE(1:5).EQ.'SCALE') THEN
          GO TO 400
        ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
          GO TO 400
        ELSE IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *          (LINE(1:6).EQ.'HETATM')    ) THEN

cATOM    193  OH  TYR A  24      44.159  25.727  21.408  1.00 39.33221.85AA1  O
cATOM      9  CA  TYR B   6      21.332  22.955  30.468  1.00 96.63      BB1  C
c123456789 123456789 123456789 123456789 123456789 123456789 123456789 12 

          LINE(22:22) = 'A'
          LINE(73:74) = 'AA'
          IF(LEN.LE.71) THEN
            LINE(67:72) = '      '
          ENDIF

        ENDIF

        WRITE(IOUT,'(A)') LINE(1:LEN)
        IF(LINE(1:4).EQ.'CRYS') THEN
          IT = 1
          Q  = 1
          WRITE(LINE,'(A,I5,F10.3,A,A)') 'MODEL    ',IT,Q,'  ',CODEF
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)') LINE(1:LEN)
        ENDIF

      ENDIF

      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
C ----------------
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN2,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ----------------
      IWRT = 0
 410  CONTINUE
      READ(IU,'(A)',ERR=510,END=610) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN

        IF(LINE(1:6).EQ.'HEADER') THEN
          GO TO 410
        ELSE IF(LINE(1:6).EQ.'COMPND') THEN
          GO TO 410
        ELSE IF(LINE(1:4).EQ.'CRYS') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'SCALE') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'ORIGX') THEN
          GO TO 410
        ELSE IF(LINE(1:5).EQ.'MODEL') THEN
          READ(LINE,'(9X,I5)') IMODEL
          IWRT = 1
          IF(IMODEL.EQ.1) IWRT = 0
        ENDIF

        IF(IWRT.LE.0) GO TO 410

        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)') LINE(1:LEN)

      ENDIF

      GO TO 410
C --------------
 610  CONTINUE

      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 210  CONTINUE
      LINE = ' ERROR: cannot open file2'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
 510  CONTINUE
      LINE = ' ERROR: reading input file2'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_MULTIMER_FILES(MDOC,PATH_DB
     *   ,FILE_TEMP,FILE_SEQ
     *   ,FILE_CRD
     *   ,CODE8
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512,LIST*1
      CHARACTER FILE_SCR*256
      CHARACTER FILE_CRD*(*)
      CHARACTER FILE_TEMP*(*),FILE_SEQ*(*),PATH_DB*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ---
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAX = 20  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
C ---
      INCLUDE 'multimer_info.fh'
C ---
c -----------------------------------
      PARAMETER ( IPRROW = 200 ) 
      REAL      RESULT (IPRROW)
      CHARACTER SURF_CORR*1,ALIGN_CORR*1
      CHARACTER CHAIN*1
C ---
      CHARACTER FILE_XML*256,FILE_MULT*256,PATH*256
      CHARACTER CODE5*5,CODE10*10,CODE8*8,DOM*2
      CHARACTER CH4*4,CHAIN_ID*8
      CHARACTER TYPE_PDB*8
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      ALIGN_CORR_LIMIT = 10.0
C ------
      CALL LENSTR_BL(CODE8,LEN)
      IF(LEN.GT.7) LEN = 7

      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF

C     FILE_TEMP output one domain file
C     FILE_CRD  output all domains file

      MMM = M
      IF(LIST.EQ.'L') MMM = MDOC
      ALIGN_CORR = 'Y'
      CALL GET_DOMAIN_ONE(MDOC,PATH_DB
     *   ,FILE_TEMP,FILE_SEQ
     *   ,FILE_CRD
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in GET_DOMAIN_ONE'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_XML = PATH_DB(1:LEN)//'/multimer/'//CODE8(1:5)//'.xml'

      CALL GET_MULTIMER_INFO(MDOC,PATH_DB,FILE_XML,PATH_SCR,IERR)
      IF(IERR.EQ.9) THEN
C        LINE = 'WARNING: problem with GET_MULTIMER_INFO: ierr=9'
C        CALL MSGERR(MDOC,LINE)
        LINE = 'INFO:    no file with MULTIMER_INFO'
        CALL MSGERR(MDOC,LINE)
        IERR = 13
        GO TO 900
      ELSE IF(IERR.NE.0) THEN
        LINE = 'WARNING: problem with GET_MULTIMER_INFO'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      NPDB = NMULTIMER 

      CALL MSGDOC(MDOC,'------ multimers ------')
      IF(NPDB.LE.0) THEN
        LINE = 'WARNING: GET_MULTIMER_INFO: NPDB=0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      DO I=1,NPDB
        CHAIN_ID   = 'AB'
        NM = NMOLECULE(I)
        IF(NM.EQ.2) THEN
          TYPE_PDB = '2chains' 
          CHAIN_ID   = 'AB'
        ELSE IF(NM.EQ.3) THEN
          TYPE_PDB = '3chains' 
          CHAIN_ID   = 'ABC'
        ELSE IF(NM.EQ.4) THEN
          TYPE_PDB = '4chains' 
          CHAIN_ID   = 'ABCD'
        ELSE IF(NM.GT.4) THEN
          TYPE_PDB = 'multimer'
          CHAIN_ID   = 'ABCD'
        ELSE
          GO TO 610
        ENDIF

        WRITE(CH4,'(I4)') I
        LCH4 = 4
        IF(CH4(3:3).EQ.' ') THEN
          CH4(1:1) = CH4(4:4)
          CH4(2:4) = '   '
          LCH4 = 1
        ELSE IF(CH4(2:2).EQ.' ') THEN
          CH4(1:1) = CH4(3:3)
          CH4(2:2) = CH4(4:4)
          CH4(3:4) = '  '
          LCH4 = 2
        ELSE IF(CH4(1:1).EQ.' ') THEN
          CH4(1:1) = CH4(2:2)
          CH4(2:2) = CH4(3:3)
          CH4(3:3) = CH4(4:4)
          CH4(4:4) = ' '
          LCH4 = 3
        ENDIF
C--------------------
C       start multimer model
C -------------------
        CALL LENSTR_BL(CODE8,LC)
        IF(LC.GE.8) LC = 7

        LINE = '--> '//CODE8(1:LC)//'   '//TYPE_PDB
        WRITE(LINE(1:3),'(I3)') I
        CALL MSGDOC(MDOC,LINE)
c -----
        FILE_MULT = CODE8(1:LC)//'_multi'//
     *              CH4(1:LCH4)//'.pdb'      
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_MULT,LO )
        IF(LEN.GT.0) THEN
          FILE_MULT = PATH_SCR(1:LEN)//FILE_MULT(1:LO)
        ENDIF

        CALL CREATE_MULT(MDOC,I,FILE_TEMP,FILE_MULT,IERR) 
        IF(IERR.NE.0) THEN
          LINE = 'WARNING: problem with CREATE_MULT'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 610
        ENDIF
        CALL LENSTR_BL(FILE_MULT,LO )
        IF(LO.GT.0) THEN
          LINE = '   file: '//FILE_MULT(1:LO)
          CALL MSGDOC(MDOC,LINE)
        ENDIF

 610    CONTINUE
C
C       end multimer model
c -------------------------------
      ENDDO

C ------
  910 CONTINUE

      FILE_SCR = 'domain_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = FILE_CRD
      PATH = ' '
      CALL DELETE_FILE(PATH,FILE_SCR)

      RETURN
  900 CONTINUE
      GO TO 910 
      END

      SUBROUTINE CREATE_MULT(MDOC,IMULT,FILE_PDB,FILE_OUT,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB*(*)
      CHARACTER FILE_OUT*(*)
C ----
c      REAL      XA(NATOM_MAX),YA(NATOM_MAX),ZA(NATOM_MAX)
c      REAL      RSTR(20,NATOM_MAX)
      real,      allocatable :: XA(:)
      real,      allocatable :: YA(:)
      real,      allocatable :: ZA(:)
      real,      allocatable :: RSTR(:,:)
      real,      allocatable :: OCC(:)
      real,      allocatable :: BISO(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)
      CHARACTER STR*80
C -----------------------------------------------------------
C ---
      INCLUDE 'multimer_info.fh'
C ---
C -----------------------------------------------------------
      REAL      FCH4      
      CHARACTER CH4*4
      REAL      X(3),Y(3)
      CHARACTER LINE*256,STR_HEAD*256,STR_CRYS*256
      CHARACTER EXT*3,PATH*1,CH24*24,TYPE*1,CH1*1
      EQUIVALENCE (FCH4,CH4)
      CHARACTER LETT*61
C --------------------------------------------------
      NLETT = 61
      LETT  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789'//
     *        'abcdefghijklmnopqrstuvwxyz'
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      STR_HEAD = ' '
      STR_CRYS = ' '
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
C ------------
      NA = 0

100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        NA = NA + 1
      ENDIF
      GO TO 100
110   CONTINUE
      CLOSE(IN)

C ------------
      IF(NA.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      IF(IMULT.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      IF(NMOLECULE(IMULT).LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
C -----------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
C ------------
      NATOM_MAX = NA * NMOLECULE(IMULT) + 1000 

      allocate(XA(1:NATOM_MAX),STAT=ISTAT)
      allocate(YA(1:NATOM_MAX),STAT=ISTAT)
      allocate(ZA(1:NATOM_MAX),STAT=ISTAT)
      allocate(RSTR(1:20,1:NATOM_MAX),STAT=ISTAT)
      allocate(OCC(1:NATOM_MAX),STAT=ISTAT)
      allocate(BISO(1:NATOM_MAX),STAT=ISTAT)
      allocate(SEG(1:NATOM_MAX),STAT=ISTAT)
      allocate(ACODE(1:NATOM_MAX),STAT=ISTAT)

      NA = 0

200   CONTINUE

      READ(IN,'(A)',ERR=800,END=210) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 200

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        L = LEN
        IF(L.GT.80) L = 80
        IF(NA.GE.NATOM_MAX) THEN
          IERR = 1
          RETURN
        ENDIF
        NA = NA + 1

        READ(LINE,'(30X,3F8.3,2F6.2,6X,A4,A4)') 
     *    XA(NA),YA(NA),ZA(NA)
     *   ,OCC(NA),BISO(NA),SEG(NA),ACODE(NA)

        DO IS=1,20
          ISS = (IS-1)*4 + 1
          CH4 = LINE(ISS:ISS+3)
          CALL CHKSMB(CH4(1:1),TYPE)
          CALL CHKSMB(CH4(2:2),TYPE)
          CALL CHKSMB(CH4(3:3),TYPE)
          CALL CHKSMB(CH4(4:4),TYPE)
          RSTR(IS,NA) = FCH4
        ENDDO

      ENDIF

      GO TO 200
210   CONTINUE
      CLOSE(IN)
      IF(NA.LE.0) THEN
        IERR = 1
        GO TO 700
      ENDIF
C ---
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IN)
        GO TO 700
      ENDIF
C --------
      CALL LENSTR_BL(STR_HEAD,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_HEAD(1:LEN)     
      ENDIF
      CALL LENSTR_BL(STR_CRYS,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_CRYS(1:LEN)     
      ENDIF

      DO IM=1,NMOLECULE(IMULT)
        DO IA=1,NA
          X(1) = XA(IA)        
          X(2) = YA(IA)        
          X(3) = ZA(IA)        
          CALL MVMULT(ROT_MOLECULE(1,1,IM,IMULT),X,Y)
          Y(1) = Y(1) + TR_MOLECULE(1,IM,IMULT)        
          Y(2) = Y(2) + TR_MOLECULE(2,IM,IMULT)        
          Y(3) = Y(3) + TR_MOLECULE(3,IM,IMULT)

          WRITE(CH24,'(3F8.3)') (Y(K),K=1,3)

          DO IS=1,20
            ISS = (IS-1)*4 + 1
            FCH4 = RSTR(IS,IA)
            STR(ISS:ISS+3) = CH4 
          ENDDO

          STR(31:54) = CH24
          WRITE(STR(55:80),'(2F6.2,6X,A4,A4)') 
     *     OCC(IA),BISO(IA),SEG(IA),ACODE(IA)

          IL = IM
          IF(IL.GT.NLETT) IL = NLETT
          STR(22:22) = LETT(IL:IL)
          STR(73:73) = LETT(IL:IL)
 
          CALL LENSTR_BL(STR,LEN)
          WRITE(IOUT,'(A)') STR(1:LEN)     
 
       ENDDO

      ENDDO
C ------------
      END FILE IOUT
      CLOSE(IOUT)

700   CONTINUE

      deallocate(XA,STAT=ISTAT)
      deallocate(YA,STAT=ISTAT)
      deallocate(ZA,STAT=ISTAT)
      deallocate(RSTR,STAT=ISTAT)
      deallocate(OCC,STAT=ISTAT)
      deallocate(BISO,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)

      RETURN
C ------------
800   CONTINUE
      CLOSE(IN)
      IERR = 1
      GO TO 700
C ------------
900   CONTINUE
      CLOSE(IN)
      IERR = 1
      RETURN
      END

      SUBROUTINE PREPARE_COOR_PRF(MDOC,CODE
     *   ,FILE_PAIR,FILE_PRF,FILE_OUT
     *   ,IERR)
C ------------------------------
      CHARACTER FILE_PAIR*(*),FILE_PRF*(*),FILE_OUT*(*)
      CHARACTER CODE*8,PN1*6,PN2*6,PNP*6
      CHARACTER LINE*512
      CHARACTER STR*512
      INTEGER   IPROFILE(20)
c ---
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: NSEQ2(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: IRES2(:)
      integer,   allocatable :: IDOM1(:)
      character(LEN=1), allocatable :: SS_1(:)
      character(LEN=1), allocatable :: SS_2(:)
      character(LEN=6), allocatable :: PNUM1(:)
      character(LEN=6), allocatable :: PNUM2(:)
c ---
      CHARACTER PATH*1,EXT*1,SS1*1,SS2*1,AA1*1,AA2*1
      CHARACTER  AMIN(26)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-','.'/
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      IN2 = 0
      CALL LENSTR_BL(FILE_PAIR,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MD,' ERROR: wrong PAIR file name')
        IERR = 1
        RETURN
      ENDIF
      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PAIR,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PAIR file')
        IERR = 1
        RETURN
      ENDIF
C ----
      NPAIR = 0
      DO I=1,1000000
        READ(IN1,'(A)',ERR=900,END=1000) LINE
        NPAIR = NPAIR + 1
      ENDDO
 1000 CONTINUE
      CLOSE(IN1) 
      IF(NPAIR.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Npair < 1')
        IERR = 1
        RETURN
      ENDIF

      allocate(NSEQ1(1:NPAIR),STAT=ISTAT)
      allocate(NSEQ2(1:NPAIR),STAT=ISTAT)
      allocate(IRES1(1:NPAIR),STAT=ISTAT)
      allocate(IRES2(1:NPAIR),STAT=ISTAT)
      allocate(IDOM1(1:NPAIR),STAT=ISTAT)
      allocate(PNUM1(1:NPAIR),STAT=ISTAT)
      allocate(PNUM2(1:NPAIR),STAT=ISTAT)
      allocate(SS_1(1:NPAIR),STAT=ISTAT)
      allocate(SS_2(1:NPAIR),STAT=ISTAT)

      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PAIR,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PAIR file')
        IERR = 1
        GO TO 930
      ENDIF

      DO I=1,1000000
        READ(IN1,'(A)',ERR=901,END=1010) LINE

CC123456789 112345 1123456789 12345 1
Cc   37)   37  127 R   -   119  119 Q
CC    3)    3    0 =   -
CC     *    '(I5,A ,2I5,A,A,A,A,A ,2I5,A,A,A,A,A ,F8.3)') I,')'
CC     *    ,IP1,IRR1,' ',AMIN(I1),' ',SS_1,' - '
CC     *    ,IP2,IRR2,' ',AMIN(I2),' ',SS_2,' '
C
CC        READ(LINE
CC     *    ,'(11X,I5,1X,A1,1X,A1,8X,I5,1X,A1,1X,A1)',ERR=905) 
CC     *    IRES1(I),AA1,SS1,IRES2(I),AA2,SS2


C        CALL LENSTR_BL(LINE,LEN)
C        IF(LEN.GE.35) THEN
C          READ(LINE,'(11X,A6,A1,1X,A1,8X,A6,A1,1X,A1)',ERR=905) 
C     *      PNUM1(I),AA1,SS1,PNUM2(I),AA2,SS2
C        ELSE
C          READ(LINE,'(11X,A6,A1,1X,A1)',ERR=910) 
C     *      PNUM1(I),AA1,SS1
C          PNUM2(I) = '      '
C          AA2 = ' '
C          SS2 = ' '
C        ENDIF

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.40) THEN
          READ(LINE,'(11X,A6,A1,1X,A1,I5,8X,A6,A1,1X,A1)',ERR=905) 
     *      PNUM1(I),AA1,SS1,IDOM1(I),PNUM2(I),AA2,SS2
          IF(LEN.LE.41) SS2 = ' '
        ELSE
          READ(LINE,'(11X,A6,A1,1X,A1,I5)',ERR=905) 
     *      PNUM1(I),AA1,SS1,IDOM1(I)
          PNUM2(I) = '      '
          AA2 = ' '
          SS2 = ' '
        ENDIF

        
        IF(PNUM1(I)(5:5).NE.' ') THEN
          READ(PNUM1(I)(2:5),'(I4)') IRES1(I)
        ELSE
          IRES1(I) = 0
        ENDIF
        IF(PNUM2(I)(5:5).NE.' ') THEN
          READ(PNUM2(I)(2:5),'(I4)') IRES2(I)
        ELSE
          IRES2(I) = 0
        ENDIF

        DO J=1,26
          IF(AMIN(J).EQ.AA1) GO TO 1020
        ENDDO
        J = 26
 1020   CONTINUE
        NSEQ1(I) = J
        DO J=1,26
          IF(AMIN(J).EQ.AA2) GO TO 1030
        ENDDO
        J = 26
 1030   CONTINUE
        NSEQ2(I) = J
        SS_1(I) = SS1
        SS_2(I) = SS2
      ENDDO

 1010 CONTINUE
      CLOSE(IN1) 
C -----------
      IN2 = 0
      NSEQ_IN = 0
      CALL LENSTR_BL(FILE_PRF,LEN)
      IF(LEN.GT.0) THEN
        EXT  = ' '
        PATH = ' '
        IN2 = 31
        CALL OPENFR(IN2,M,PATH,FILE_PRF,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: cannot open intput PRF file')
          IERR = 1
          GO TO 930
        ENDIF
        READ(IN2,'(A)',ERR=910) LINE
        READ(IN2,'(A)',ERR=910) LINE
        READ(LINE,'(5X,I6)',ERR=915) NSEQ_IN 
        READ(IN2,'(A)',ERR=910) LINE
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 32
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output PRF file')
        IF(IN2.GT.0) CLOSE(IN2)
        IERR = 1
        GO TO 930
      ENDIF

      LINE = 'Profile: '//CODE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=920) LINE(1:LEN)

      NSEQ = 2
      IF(IN2.GT.0) NSEQ = NSEQ_IN + 1
      WRITE(LINE,'(A,I6)') 'Nseq:',NSEQ 
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=920) LINE(1:LEN)

      WRITE(LINE,'(20(2X,A1))') (AMIN(I),I=1,20)
      LINE(1:1) = '#'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=920) LINE(1:LEN)
C --------
      NRES1 = 0

      DO IP=1,NPAIR

        IR1 = IRES1(IP)
        IR2 = IRES2(IP)
        PN1 = PNUM1(IP)
        PN2 = PNUM2(IP)
        IDM1= IDOM1(IP)

        SS1 = SS_1(IP)
        SS2 = SS_2(IP)
        IAA1= NSEQ1(IP)
        AA1 = AMIN(IAA1)
        IAA2= NSEQ2(IP)
        AA2 = AMIN(IAA2)


        NRES1 = NRES1 + 1

        DO IPRF=1,20
          IPROFILE(IPRF) = 0
        ENDDO

        JR1 = 0
        IF(IN2.GT.0) THEN

  200     CONTINUE
          READ(IN2,'(A)',ERR=910,END=110) LINE  
          READ(LINE,'(20I3)',ERR=915) (IPROFILE(IPRF),IPRF=1,20) 
          CALL LENSTR_BL(LINE,LEN)
          STR = LINE(61:LEN) 
          CALL LENSTR_BL(STR,LS)

C         READ(STR,'(2X,I5)') JR1

          PNP = LINE(63:68)
          IF(LINE(67:67).NE.' ') THEN
            READ(LINE(64:67),'(I4)',ERR=915) JR1
          ELSE
            JR1 = 0
          ENDIF

          GO TO 120
  110     CONTINUE
          CLOSE(IN2)
          IN2 = 0
          JR1 = IR1
          PNP = PN1
  120     CONTINUE

          IF(PNP(5:5).EQ.' '.AND.PN1(5:5).NE.' ') GO TO 200

          IF(PNP(5:5).NE.' '.AND.PN1(5:5).EQ.' ') THEN

            WRITE(STR(61:77),'(A,A,I5,A,A,A,A)') 
     *      ' #',PN1,IDM1,' ',SS1,' ',AA1

c           WRITE(STR(61:71),'(A,A,A,A,A)') 
c     *           ' #',PN1,SS1,' ',AA1

            GO TO 100
          ENDIF

          IF(IR1.GT.JR1) THEN
            GO TO 200
          ELSE IF(IR1.LT.JR1) THEN

            STR(LS+1:LS+1) = AA2

            IF(IAA1.GT.0.AND.IAA1.LE.20) THEN
              IPROFILE(IAA1) = IPROFILE(IAA1) + 1
            ENDIF
            IF(IAA2.GT.0.AND.IAA2.LE.20) THEN
              IPROFILE(IAA2) = IPROFILE(IAA2) + 1
            ENDIF

            WRITE(STR(61:77),'(A,A,I5,A,A,A,A)') 
     *      ' #',PN1,IDM1,' ',SS1,' ',AA1

c            WRITE(STR(61:71),'(A,A,A,A,A)') 
c     *           ' #',PN1,SS1,' ',AA1

            GO TO 100
          ENDIF

        ENDIF

        IF(IAA1.GT.0.AND.IAA1.LE.20) THEN
          IF(IN2.LE.0) THEN
            IPROFILE(IAA1) = IPROFILE(IAA1) + 1
          ENDIF
        ENDIF
        IF(IAA2.GT.0.AND.IAA2.LE.20) THEN
          IPROFILE(IAA2) = IPROFILE(IAA2) + 1
        ENDIF

        IF(IN2.LE.0) THEN

C         WRITE(STR,'(A,I5,A,A,A,A,A)') ' #',IR1,' ',SS1,' ',AA1,AA2
c         WRITE(STR,'(A,A,A,A,A,A)') ' #',PN1,SS1,' ',AA1,AA2

          WRITE(STR,'(A,A,I5,A,A,A,A,A)') 
     *      ' #',PN1,IDM1,' ',SS1,' ',AA1,AA2

        ELSE
          CALL LENSTR_BL(STR,LS)
          STR(LS+1:LS+1) = AA2
        ENDIF

 100    CONTINUE

        WRITE(LINE,'(20I3)') (IPROFILE(IPRF),IPRF=1,20) 
        CALL LENSTR_BL(LINE,LEN)

        CALL LENSTR_BL(STR,LS)
        LINE = LINE(1:LEN)//STR(1:LS)

        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=920) LINE(1:LEN)

      ENDDO
c ----
      IF(IN2.GT.0) CLOSE(IN2)
      END FILE IOUT
      CLOSE(IOUT)

  930 CONTINUE

      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(NSEQ2,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(IRES2,STAT=ISTAT)
      deallocate(IDOM1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)
      deallocate(PNUM2,STAT=ISTAT)
      deallocate(SS_1,STAT=ISTAT)
      deallocate(SS_2,STAT=ISTAT)

      RETURN
C ----
  900 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PAIR file')
      CLOSE(IN1)
      IERR =1
      RETURN
  901 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PAIR file')
      CLOSE(IN1)
      IERR =1
      GO TO 930
  910 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF file')
      IF(IN2.GT.0) CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  905 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PAIR from LINE')
      CLOSE(IN1)
      IERR =1
      GO TO 930
  915 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF from LINE')
      IF(IN2.GT.0) CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  920 CONTINUE
      CALL MSGERR(MD,' ERROR: write outtput PRF file')
      IF(IN2.GT.0) CLOSE(IN2)
      END FILE IOUT
      CLOSE(IOUT)
      IERR =1
      GO TO 930
      END 

      SUBROUTINE GET_DOMAIN_ONE(MDOC,PATH_DB
     *   ,FILE_TEMP,FILE_SEQ
     *   ,FILE_CRD
     *   ,CODE8,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512,LIST*1,ALIGN_CORR*1
      CHARACTER FILE_XYZ*256,FILE_OUT*256,FILE_SCR*256
      CHARACTER FILE_CRD*(*),FILE_PDB*256
      CHARACTER FILE_TEMP*(*),FILE_SEQ*(*),PATH_DB*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
C ---
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAX = 20  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
c -----------------------------------
      PARAMETER ( IPRROW = 200 ) 
      REAL      RESULT (IPRROW)
      CHARACTER SURF_CORR*1
      CHARACTER CHAIN*1
C ---
      CHARACTER CODE5*5,CODE10*10,CODE8*8,DOM*2
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      ALIGN_CORR_LIMIT = 10.0
      SML = 0.0
      SCR = 0.0
      NRES   = 0
      NALIGN = 0
C ------
C     xyz --> pdb
      CODE5 = CODE8(1:5)
      CALL LENSTR_BL(PATH_DB,LEN_DB)
      FILE_XYZ = PATH_DB(1:LEN_DB)//'/pdb_DB/'//CODE5(1:5)//'.xyz'
      FILE_PDB = 'unpack.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PDB,LT )
      IF(LEN.GT.0) THEN
        FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
      ENDIF
      CALL PDB_UNPACK(M,FILE_XYZ,FILE_PDB,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        GO TO 900
      ENDIF
C     dom_info --> pdb (SEG_ID)

C     FILE_CRD = 'domains.pdb'

      CALL LENSTR_BL(FILE_CRD,LEN )
      IF(LEN.LE.0) THEN
        CALL LENSTR_BL(CODE8,L)
        IF(L.LE.5) THEN
          FILE_CRD = CODE8(1:5)//'_dom.pdb'
        ELSE
          FILE_CRD = CODE8(1:5)//'.pdb'
        ENDIF
        CALL LENSTR_BL(PATH_OUT,LEN)
        CALL LENSTR_BL(FILE_CRD,LT )
        IF(LEN.GT.0) THEN
          FILE_CRD = PATH_OUT(1:LEN)//FILE_CRD(1:LT) 
        ENDIF
      ENDIF

C     ierr=-1    set '-' in seg_id(76:76) (domains border)
      IERR =-1
      CALL SET_DOMAIN_INFO_TO_PDB(M,FILE_PDB,FILE_CRD
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,CODE8,CODE10,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: set dom_info to PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
C --
C --
      IF(NDOM.LE.0) THEN
        NDOM = 0
      ENDIF
      WRITE(LINE,'(A,I5)') ' N_domains :',NDOM
      CALL MSGDOC(MDOC,LINE)

      LINE = 'CODE <'//code8//'>'
      CALL MSGDOC(MDOC,LINE)
  
      CALL LENSTR_BL(CODE8,LEN)
      IF(LEN.LE.5) THEN
        CALL LENSTR_BL(FILE_SEQ,LEN)
        IF(LEN.GT.0) THEN
          FILE_OUT = FILE_CRD    
        ELSE
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILE_CRD,FILE_TEMP,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy file: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 900
          ENDIF
        ENDIF
        GO TO 100
      ENDIF

      DOM = CODE8(6:7)
      IF(DOM(1:1).EQ.'_') DOM(1:1) = ' '
      READ(DOM,'(I2)') IDOM

      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        FILE_OUT = 'domains_corr.pdb'      
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_OUT ,LO )
        IF(LEN.GT.0) THEN
          FILE_OUT = PATH_SCR(1:LEN)//FILE_OUT(1:LO)
        ENDIF 
      ELSE
        FILE_OUT  = FILE_TEMP
      ENDIF

      CALL GET_DOMAIN_PDB(M,FILE_CRD,FILE_OUT
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,NATOM,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: get domain PDB'
        CALL MSGERR(MDOC,LINE)
        GO TO 900
      ENDIF

      WRITE(LINE,*) ' NRES    :',NRES
      CALL MSGDOC(MDOC,LINE)
      IF(NRES.LE.0) THEN
        LINE = ' ERROR: Nresidues = 0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

  100 CONTINUE

      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        SURF_CORR  = 'Y'
c        ALIGN_CORR = 'Y'
        CHAIN      = ' '        
        FILE_SCR = 'domains_scr.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_SCR,LT )
        IF(LEN.GT.0) THEN
          FILE_SCR = PATH_SCR(1:LEN)//FILE_SCR(1:LT) 
        ENDIF

        MMM = M
        IF(LIST.EQ.'L') MMM = MDOC

        CALL MODEL_CORR_GD(MMM,FILE_SEQ,FILE_OUT
     *    ,ALIGN_CORR_LIMIT,CHAIN
     *    ,FILE_TEMP,FILE_SCR
     *    ,SURF_CORR,ALIGN_CORR
     *    ,NATOM,NRES,SML,SCR,NRESA
     *    ,CODE8
     *    ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in MODEL_CORR_GD'
          CALL MSGERR(MDOC,LINE)
          GO TO 900
        ENDIF
        WRITE(LINE,'(A,A,A)') 
     *   '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,I8,F7.2,F7.3,I6)') 
     *   '--Nres,Ident,Scr,Nalign:',NRES,SML,SCR,NRESA
        CALL MSGDOC(MDOC,LINE)

c       NALIGN = NRES
        NALIGN = NRESA

      ENDIF

c      CALL LENSTR_BL(CODE8,LEN)
c      IF(LEN.GE.7) THEN
        CALL LENSTR_BL(FILE_TEMP,LT )
        LINE = 'File: '//FILE_TEMP(1:LT)
        CALL MSGDOC(MDOC,LINE)
c      ENDIF
C ------
  900 CONTINUE

      FILE_SCR = 'unpack.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domains_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)
      FILE_SCR = 'domains_corr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_SCR)

      RETURN 
      END

      SUBROUTINE MODEL_CORR_GD(MDOC,NAME_SEQ,FILE_CRD
     *  ,ALIGN_CORR_LIMIT,CHAIN
     *  ,FILE_OUT,FILE_TEMP
     *  ,SURF_CORR,ALIGN_CORR
     *  ,NATOM,NRES,HID,SCR,NRESA
     *  ,CODE_DB      
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER NAME_SEQ*(*),FILE_CRD*(*)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER SURF_CORR*1,ALIGN_CORR*1
      CHARACTER CODE_DB*8
      CHARACTER CHAIN*1
      CHARACTER PAR_ALIGN*16
      CHARACTER FILE_OUT*(*),FILE_TEMP*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1,SURF*1
      CHARACTER FILE_SCR*256
      CHARACTER FULL*1,ADOM*1
      CHARACTER FILE_PAIR*256
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
C ---------------
      HID   = 0.0
      SCR   = 0.0    
      NATOM = 0
      NRES  = 0
      NRESA = 0
C ----
      SURF      = ' '
      CALL SURFACE_DB_ALLOC(M,FILE_CRD,FILE_TEMP
     * ,RESULT,IPRROW,IERR)   
      NATOM    =  RESULT(1)
      IF(IERR.NE.0.OR.NATOM.LE.0) THEN
        LINE = ' ERROR: in SURFACE_DB'
        CALL MSGERR(MDOC,LINE)
        GO TO 510
      ENDIF
      NATOM_IN =  RESULT(8)
      NRES     =  RESULT(9)
      WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *   NATOM,NATOM_IN,NRES
      CALL MSGDOC(MDOC,LINE)
      FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
      IF(FINSIDE.LT.0.10) THEN
        FILE_TEMP = FILE_CRD  
        SURF_CORR = 'N'
        PAR_ALIGN(5:5) = 'Y' 
      ELSE
        SURF_CORR = 'Y'
        PAR_ALIGN(5:5) = 'N' 
      ENDIF

C ---------
      IF(ALIGN_CORR.EQ.'Y'.OR.ALIGN_CORR.EQ.'A') THEN

C       MODE    = PAR_ALIGN(1:1) matrix 
C       CORR    = PAR_ALIGN(2:2) output pdb correction
C       CORR --> N output file(pdb) 
c                  (FILE_OUT) aligned file_1 (not rotated)
c          PAR_ALIGN(2:2) = 'N'
C       CORR --> Y output file(pdb) (FILE_OUT) rotated full file_1 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C       CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'
C       D3_FLAG = PAR_ALIGN(3:3) use surf info
C       SS_FLAG = PAR_ALIGN(4:4) use SS info
C       PAR_ALIGN(5:5) remove surf from output
C       PAR_ALIGN(6:6) OCC_FLAG
C
        PAR_ALIGN(1:1) = 'G' 
        PAR_ALIGN(1:1) = 'B' 

        PAR_ALIGN(2:2) = 'N' 
        PAR_ALIGN(3:3) = 'N' 

        IF(SURF_CORR.EQ.'Y') PAR_ALIGN(3:3) = 'Y' 

        PAR_ALIGN(4:4) = 'Y' 
        PAR_ALIGN(6:6) = 'N' 
        PAR_ALIGN(7:7) = 'N' 

        OPENR   = 0.462
        DPENR   = 0.350
        PENEXR  = 0.077

        IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c         'G'
          DPENR   = 0.346
        ELSE
c         'B'
          DPENR   = 0.312
        ENDIF

        OPENR   = 0.462
        PENEXR  = 0.077
        OPENR   = 0.750
        PENEXR  = 0.125
c --
        MODEL   = 1
C       CHAIN   = ' '
        IPRINT  = 1

        FILE_PAIR = ' '
        FULL      = 'Y'
        ADOM      = 'C'

        CALL ALIGN_4(MDOC,NAME_SEQ,FILE_TEMP,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C --
C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM identity
C       RESULT(6) = SUM_SCORE score

        IF(IERR.NE.0) THEN
          WRITE(LINE,
     *    '(1X,A5,'' --- ERROR (align) ---'')') CODE_DB(1:5)
          CALL MSGDOC(MDOC,LINE)
          GO TO 510
        ENDIF
C ---
        N1     = RESULT(1) 
        N2     = RESULT(2) 
        NRESA  = RESULT(3) 
        NI     = RESULT(4) 
        HID    = RESULT(5) 
        SCR    = RESULT(6)  
        NATOMA = RESULT(7)
        NR_OUT = RESULT(8)
        NAT_OCC  = RESULT(9)
        NRES_OCC = RESULT(10)
c        NRESA  = NR_OUT
        NATOMA = NAT_OCC
        NRESA  = NRES_OCC
        WRITE(LINE,
     *  '('' Number of atoms, N_res,Ident :'',2I6,F7.2,F7.3)') 
     *     NATOMA,NRESA,HID,SCR
        CALL MSGDOC(MDOC,LINE)
        IF(HID.LT.ALIGN_CORR_LIMIT.OR.
     *     NATOMA.LE.0.OR.NRESA.LE.0  ) THEN
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILE_TEMP,FILE_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy file: '//CODE_DB(1:5)
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 510
          ENDIF
          ALIGN_CORR = 'N'
        ELSE
C         ALIGN_CORR = 'Y'
c          NRES  = NRESA
          NATOM = NATOMA

          IF(ALIGN_CORR.EQ.'A') THEN
            NM = 0
            CALL COPY_PDB_FILE(MDOC,NM,FILE_TEMP,FILE_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: copy file: '//CODE_DB(1:5)
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 510
            ENDIF
          ENDIF
        ENDIF
      ELSE
        NM = 0
        CALL COPY_PDB_FILE(MDOC,NM,FILE_TEMP,FILE_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: copy file: '//CODE_DB(1:5)
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 510
        ENDIF
      ENDIF
c ---

      RETURN
C ----
  510 IERR = 1
      RETURN
      END

      SUBROUTINE COPY_PDB_FILE(MDOC,NMODEL,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*256,EXT*256,ALL*1
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2,A6,4X,A4)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
      NL  = 0
      ALL = 'Y'
      IFIRST = 1
      IF(NMODEL.GT.0) THEN
        ALL = 'N'  
        IFIRST = 0
      ENDIF
 
 400  CONTINUE

      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        IF(LINE(1:4).EQ.'MODE'.AND.ALL.EQ.'N') THEN
          READ(LINE,'(9X,I5)') IT
          IFIRST = 0
          IF(IT.EQ.NMODEL) IFIRST = 1
          GO TO 400
        ELSE IF(LINE(1:6).EQ.'HEADER') THEN
          WRITE(IOUT,'(A)') LINE(1:LEN)
          GO TO 400
        ELSE IF(LINE(1:4).EQ.'CRYS') THEN
          WRITE(IOUT,'(A)') LINE(1:LEN)
          GO TO 400
        ELSE
          IF(IFIRST.EQ.1) THEN
            WRITE(IOUT,'(A)') LINE(1:LEN)
            IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *         (LINE(1:6).EQ.'HETATM')) THEN
              NL = NL + 1
            ENDIF    
          ENDIF    
        ENDIF
      ENDIF

      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      IF(NL.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: empty output file')
        IERR = 1
      ENDIF

      RETURN
C ----------------
 200  CONTINUE
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_DOMAIN_DESCRIPTION(MDOC
     *      ,CODE5,ICH,IDOM,NDOMAIN,FILE_TEMP
     *      ,IOUT,FILE_SEQ,FILE_DOM_PDB,PATH_SCR,IERR)     
C -------------------------------------------------
C ---
      PARAMETER ( IPRROW = 21 )
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR,ICH,IDOM,IOUT
      CHARACTER LINE*256
      CHARACTER FILE_TEMP*(*),PATH_SCR*(*)
      CHARACTER FILE_SEQ*(*),FILE_DOM_PDB*(*)
C ---
      CHARACTER CODE5*5
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
C     calc surf and RAD inrtia

      CALL SURFACE_DB_ALLOC(M,FILE_TEMP,FILE_DOM_PDB
     *   ,RESULT,IPRROW,IERR)   
      IF(IERR.NE.0) RETURN

C      RESULT(1) = NATOMS
C      RESULT(2) = SURFA
C      RESULT(3) = SURFC
C      RESULT(8) = NTOT
C      RESULT(9) = NRES
C      RESULT(10)= RAD_INER

      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(LEN.GT.0) THEN
        CALL CREATE_AND_WRITE_DOM_DESCR_ALLOC(MDOC,FILE_DOM_PDB,IOUT
     *   ,ICH,NDOMAIN,CODE5,IDOM,FILE_SEQ
     *   ,RESULT,IPRROW,IERR)   
      ENDIF
C ------
      RETURN 
      END

      SUBROUTINE CREATE_AND_WRITE_DOM_DESCR_ALLOC(MDOC,FILE_CRD,IOUT
     *   ,ICH,NDOMAIN,CODE5,IDOM,FILE_SEQ
     *   ,RESULT,IPRROW,IERR)   
C ---------------------------------------
      REAL      RESULT(IPRROW)
C ---
      CHARACTER CODE_PDB*4,CODE5*5,CHAIN*1,DOM*2
      CHARACTER CODE88*8
C      INTEGER   NSEQ(NMAX),IRES(NMAX)
C      INTEGER   SURF(NMAX),ICHAIN(NMAX),ISS(NATMX)
C      REAL      COORD(NMAX,3)
C      CHARACTER PNUM(NMAX)*6
      real,      allocatable :: COORD(:,:)
      integer,   allocatable :: NSEQ(:)
      integer,   allocatable :: IRES(:)
      integer,   allocatable :: SURF(:)
      integer,   allocatable :: ICHAIN(:)
      integer,   allocatable :: IDOMAIN(:)
      integer,   allocatable :: ISS(:)
      real,      allocatable :: ELPOT(:)
      character(LEN=6), allocatable :: PNUM(:)
C ---------------------------------------
      CHARACTER LINE*256,FILE_CRD*(*),FILE_SEQ*(*)
C ---------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      ITEST = 1
      NMAX  = 100

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_CRD
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE88,NCHAIN,ITEST,IERR)
      IF(N.LE.0.OR.IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      NMAX = N

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)
C ---
      ITEST = 0
      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_CRD
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE88,NCHAIN,ITEST,IERR)
      IF(IERR.NE.0) GO TO 900
      CODE_PDB = CODE88(1:4) 
C ---
      CALL ALIGN_SS_DEFINITION_ALLOC(MDOC,N
     * ,COORD(1,1),COORD(1,2),COORD(1,3),ISS,SURF
     * ,PSS,PH,PB,NMAX,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
C      RESULT(1) = NATOM (Natom Occ > 0)
C      RESULT(2) = SURFA
C      RESULT(3) = SURFC
C      RESULT(8) = NTOT  (Natoms inside)
C      RESULT(9) = NRES
C      RESULT(10)= RAD_INER

      NATOM    = RESULT(1) 
      SURFA    = RESULT(2)
      NACORE   = RESULT(8)
      NRES     = RESULT(9) 
      RAD_INER = RESULT(10)
      CODE_PDB = CODE5(1:4)
      CHAIN    = CODE5(5:5)

      WRITE(DOM,'(I2)') IDOM
      IF(DOM(1:1).EQ.' ') DOM(1:1) = '_'

      CALL CHECK_SEQ_FOR_SEG_NSEG(MDOC
     *  ,ICH,CHAIN,CODE_PDB,DOM,IDOM,NSEQ,ISS,ISURF,PNUM
     *  ,NMAX,N,NSEG,IERR)

      CALL WRITE_SEQ_WITH_SS_SURF(MDOC,FILE_SEQ
     *  ,CHAIN,CODE_PDB,DOM,NSEQ,ISS,SURF,IDOMAIN
     *  ,NMAX,N,NAA,IERR)
      IF(IERR.NE.0) GO TO 900

      IF(IOUT.GT.0) THEN
        CALL WRITE_DOM_INFO_INTO_LIST_FILE(MDOC,IOUT
     *      ,ICH,NDOMAIN,CODE_PDB,CHAIN,DOM,NSEG
     *      ,NAA,NATOM,NACORE,SURFA,RAD_INER,PH,PB,IERR)     
        IF(IERR.NE.0) GO TO 900
      ENDIF
C ---

  900 CONTINUE

      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

C ------
      RETURN 
      END

      SUBROUTINE CHECK_SEQ_FOR_SEG_NSEG(MDOC
     *  ,ICH,CHAIN,CODE,DOM,IDOM,NSEQ,ISS,ISURF,PNUM
     *  ,NMAX,NR,NSEG,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE*4,CHAIN*1,DOM*2
C -----
      INTEGER   NSEQ(NMAX)
      INTEGER   ISS(NMAX),ISURF(NMAX)
      CHARACTER PNUM(NMAX)*6
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
C ---
      CHARACTER LINE*256
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      NSEG  = 1
      NS    = 1
      LSEG  = 0
      IFLAG = 0
      PNUM1_DM(NS) = ' '
      PNUM2_DM(NS) = ' '
      ND_RES(NS)   = 0
      IDOMDOM(NS)  = NSEG
      DO IPR=1,NR

C        IF(ISS(IPR).EQ.1) THEN
C          SS = 'H'
C        ELSE IF(ISS(IPR).EQ.2) THEN
C          SS = 'h'
C        ELSE IF(ISS(IPR).EQ.3) THEN
C          SS = 'B'
C        ELSE IF(ISS(IPR).EQ.4) THEN
C          SS = 'b'
C        ELSE
C          SS = ' '
C        ENDIF
C        SURF = ' '
C        IF(ISURF(IPR).GT.0) THEN
C          WRITE(SURF,'(I1)') ISURF(IPR)
C        ENDIF

        N1     = NSEQ(IPR)
        IF(N1.GE.24) THEN
          IF(N1.EQ.24) NSEG = NSEG + 1
          IF(NSEG.GT.99) NSEG = 99
          NS = NS + 1
          IF(NS.GT.99) NS = 99
          PNUM1_DM(NS) = ' '
          PNUM2_DM(NS) = ' '
          ND_RES(NS) = 0
          IDOMDOM(NS) = NSEG
C          IF(LSEG.LE.3) THEN
C            IFLAG = 1
C            WRITE(LINE,'(A,I6,1X,A,A,A,A,I5,A,I5)')
C     *      'WARNING: ',ICH,CODE,CHAIN,DOM,'  Len_seg =',LSEG          
C     *  ,'  Naa:',IPR
C            CALL MSGDOC(MDOC,LINE)
C          ENDIF
          LSEG = 0
        ELSE
          LSEG = LSEG + 1
          IF(ND_RES(NS).LE.0) PNUM1_DM(NS) = PNUM(IPR)
          PNUM2_DM(NS) = PNUM(IPR)
          ND_RES(NS)   = ND_RES(NS) + 1
          IDOMDOM(NS) = NSEG
        ENDIF

      ENDDO

C      IF(LSEG.LE.3) THEN
C        IFLAG = 1
C        WRITE(LINE,'(A,I6,1X,A,A,A,A,I5,A,I5)')
C     *  'WARNING: ',ICH,CODE,CHAIN,DOM,'  Len_seg =',LSEG          
C     *  ,'  Naa:',NR
C        CALL MSGDOC(MDOC,LINE)
C      ENDIF

C      IF(IFLAG.GT.0.AND.NS.GT.0) THEN
C        DO I=1,NS
C          WRITE(LINE,'(A,2I5,A,A6,A,A6,A,I5,A,I5)')
C     *    '         ',IDOM,I,'  ',PNUM1_DM(I),' - ',PNUM2_DM(I),'  seg'
C     *    ,IDOMDOM(I),'  Nr=',ND_RES(I)          
C          CALL MSGDOC(MDOC,LINE)
C        ENDDO
C      ENDIF

      RETURN
      END

      SUBROUTINE WRITE_DOM_INFO_INTO_LIST_FILE(MDOC,IOUT
     *      ,ICH,NDOMAIN,CODE_PDB,CHAIN,DOM,NSEG
     *      ,NRES,NATOM,NACORE,SURFA,RAD_INER,PH,PB,IERR)     
C ---------------------------------------
      CHARACTER CODE_PDB*4,CHAIN*1,DOM*2,CODE*8
      CHARACTER LINE*512,FRMT*512
C ---------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
C ------
      COEF_NA_TO_VOL = 20.63
      VOL      = FLOAT(NATOM) *COEF_NA_TO_VOL
      VOL_CORE = FLOAT(NACORE)*COEF_NA_TO_VOL 
      T        = LOG((VOL*3.0)/(4.0*PI))
      RAD      = EXP(T/3.0)
      T        = LOG((VOL_CORE*3.0)/(4.0*PI))
      RAD_CORE = EXP(T/3.0)

      CODE = CODE_PDB//CHAIN//DOM//'_'
      ITYPE = 0
C      NSEG  = NSEG
      ILEVEL= 0
      IFORW = 0
      IBACK = 0
      RIDENT= 0.0
      SCORE = 0.0
      RCBYR = RAD_CORE/RAD
      RINBYR= RAD_INER/RAD

      T     = (SURFA*SURFA*SURFA)/PI 
      VOLS  = SQRT(T)/6.0 
      T     = LOG((VOLS*3.0)/(4.0*PI))
      RADS  = EXP(T/3.0)
      RSBYR = RADS/RAD 
     
      IF(NDOMAIN.LE.0) THEN
        LINE = '#  domain_descr_list'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR = 900) LINE(1:LEN)

        LINE = '#    1    2         3  4  5  6    7    8   '//
     *         '   9    10      11     12     13   14    15     16'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR = 900) LINE(1:LEN)

        LINE = '#    No dom_ID    Nres It Ns Il Iforw Iback'//
     *         ' ident scor    Rad    Rc/R   Ri/R  Ph    Pb   Rsur/R'  
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR = 900) LINE(1:LEN)

      ENDIF

C -- 
c 1   2      3    4    5     6    7    8     9    10    11  12  13   14 15 16 
C No dom_ID Nres Ityp Nseg Ilev Iforw Iback ident scor Rad Rc/R Ri/R Ph Pb Rsur/R  

      FRMT = '(I7,1X,A8,1X,I5,1X,I2,1X,I2,1X,I2,1X,I5,1X,I5,1X,'//
     *       'F5.1,1X,F5.3,1X,F6.1,1X,F6.2,1X,F6.2,1X,F5.1,1X,F5.1'//
     *       ',1X,F6.2,1X,I8)'  
      SCR = SCORE
      IF(SCR.GT.9.9) SCR = 9.9
      ICLASS = 0
      NDOMAIN = NDOMAIN + 1

      WRITE(LINE,FRMT,ERR = 900)
     * NDOMAIN,CODE,NRES,ITYPE,NSEG,ILEVEL,IFORW,IBACK,
     * RIDENT,SCR,RAD,RCBYR,RINBYR,PH,PB,RSBYR,ICLASS  

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR = 900) LINE(1:LEN)

      WRITE(LINE,'(I7,1X,A10,1X,I5,'' <-- '',2I6)') 
     *    NDOMAIN,CODE,NRES,ICH,NSEG
      CALL MSGDOC(MDOC,LINE)
C ------
      RETURN 
C ------
  900 CONTINUE
      LINE = ' ERROR: write output list file'
      CALL MSGERR(MDOC,LINE)
      RETURN 
      END

      SUBROUTINE WRITE_SEQ_WITH_SS_SURF(MDOC,NAMEO
     *  ,CHAIN,CODE,DOM,NSEQ,ISS,ISURF,IDOMAIN
     *  ,NMAX,NR,NAA,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER NAMEO*(*)
      CHARACTER CODE*4,CHAIN*1,DOM*2
C -----
      INTEGER   NSEQ(NMAX)
      INTEGER   ISS(NMAX),ISURF(NMAX),IDOMAIN(NMAX)
C ---
      CHARACTER LINE*80,PATH*1,EXT*1
      CHARACTER LINE1*80,LINE2*80
      CHARACTER SS*1,SURF*1,AANAME*1
      CHARACTER AMIN(25)*1
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
C ------------------------------------------------------------
      M     = 99
      MD    =-ABS(MDOC)-1
      IERR  = 0
C -------------------------------------------------------------------
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        IERR = 1
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      LINE = '>'//CODE//CHAIN//DOM
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)

      NAA   = 0
      II    = 4
      IAA   = 0
      LINE  = '    '
      LINE1 = '#SS:'
      LINE2 = '#SR:'
      IDOM_OLD = 0
      ISEG_OLD = 0
      NSEQ_OLD = 0

      DO IPR=1,NR

        IDOM = IDOMAIN(IPR)/10
        ISEG = IDOMAIN(IPR) - IDOM*10

        IF(IDOM.GT.0.AND.IDOM.EQ.IDOM_OLD) THEN
          IF(ISEG.NE.ISEG_OLD.OR.
     *       (ISEG.GT.O.AND.NSEQ_OLD.EQ.24).OR.
     *       (ISEG.GT.O.AND.NSEQ(IPR).EQ.24)   ) THEN
            AANAME = '+'
            SS     = ' '
            SURF   = ' '
            II  = II  +1
            IAA = IAA +1
            LINE(II:II)  = AANAME
            LINE1(II:II) = SS
            LINE2(II:II) = SURF
            IF(IAA.EQ.50) THEN
              CALL LENSTR_BL(LINE,LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE1(1:LEN)
              WRITE(IOUT,'(A)',ERR=500) LINE2(1:LEN)
              II   = 4
              IAA  = 0
              LINE  = '    '
              LINE1 = '#SS:'
              LINE2 = '#SR:'
            ENDIF
          ENDIF
        ENDIF

        IF(ISS(IPR).EQ.1) THEN
          SS = 'H'
        ELSE IF(ISS(IPR).EQ.2) THEN
          SS = 'h'
        ELSE IF(ISS(IPR).EQ.3) THEN
          SS = 'B'
        ELSE IF(ISS(IPR).EQ.4) THEN
          SS = 'b'
        ELSE
          SS = ' '
        ENDIF

        SURF = ' '
        IF(ISURF(IPR).GT.0) THEN
          WRITE(SURF,'(I1)') ISURF(IPR)
        ENDIF

        N1     = NSEQ(IPR)
        IF(N1.GT.25) N1 = 25
        AANAME = AMIN(N1)
        IF(N1.GE.24) THEN
          SS   = ' '
          SURF = ' '
        ELSE
          NAA = NAA +1
        ENDIF

        II  = II  +1
        IAA = IAA +1
        LINE(II:II)  = AANAME
        LINE1(II:II) = SS
        LINE2(II:II) = SURF

        IF(IAA.EQ.50) THEN
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE1(1:LEN)
          WRITE(IOUT,'(A)',ERR=500) LINE2(1:LEN)
          II   = 4
          IAA  = 0
          LINE  = '    '
          LINE1 = '#SS:'
          LINE2 = '#SR:'
        ENDIF

        IDOM_OLD = IDOM
        ISEG_OLD = ISEG
        NSEQ_OLD = N1

      ENDDO

      IF(IAA.GT.0) THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE(1:LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE1(1:LEN)
        WRITE(IOUT,'(A)',ERR=500) LINE2(1:LEN)
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)

      IF(NAA.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      RETURN

 500  CONTINUE
      CALL MSGERR(MDOC,' ERROR: in WRITE_SEQ_WITH_SS_SURF')
      IERR = 1
      CLOSE(IOUT)
      RETURN
      END

      SUBROUTINE CREATE_DOM_SEQ_AND_PDB(MDOC
     *   ,CODE_DOM,FILE_SEQ,FILE_DOM_PDB
     *   ,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512
      CHARACTER FILE_XYZ*256,FILE_CRD*256,FILE_TEMP*256
      CHARACTER FILE_PDB*256,FILE_SEQ*(*),FILE_DOM_PDB*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*256,EXT*1
C ---
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAX = 20  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
c -----------------------------------
C ---
      CHARACTER CODE5*5,CODE10*10,CODE8*8,CODE_DOM*8,DOM*2
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      CODE10 = ' '
      CODE5 = CODE_DOM(1:5)
C     xyz --> pdb
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH,IERR)
      IF(IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
      CALL LENSTR_BL(PATH,LEN)
      FILE_XYZ = PATH(1:LEN)//'/pdb_DB/'//CODE5(1:5)//'.xyz'
      FILE_PDB = 'unpack.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PDB,LT )
      IF(LEN.GT.0) THEN
        FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
      ENDIF
      CALL PDB_UNPACK(M,FILE_XYZ,FILE_PDB,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        GO TO 900
      ENDIF
C     dom_info --> pdb (SEG_ID)
      FILE_CRD = 'domains.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_CRD,LT )
      IF(LEN.GT.0) THEN
        FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
      ENDIF
      CODE8 = CODE5//'   '
C     ierr=-1    set '-' in seg_id(76:76) (domains border)
      IERR =-1
      CALL SET_DOMAIN_INFO_TO_PDB(M,FILE_PDB,FILE_CRD
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,CODE8,CODE10,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: set dom_info to PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      NC = NDOM
      IF(NDOM.LE.0) THEN
        NDOM = 0
        NC   = 1
      ENDIF

      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF

      DOM = CODE_DOM(6:7)
      IF(DOM(1:1).EQ.'_') DOM(1:1) = ' '          
      READ(DOM,'(I2)') IDOM

      CALL GET_DOMAIN_PDB(M,FILE_CRD,FILE_TEMP
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,NATOM,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: get domain PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
      IF(NRES.LE.0) THEN
        LINE = ' ERROR: get domain PDB: Nresidue = 0'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      IOUT    = 0
      ICH     = 0
      NDOMAIN = 0

      CALL CREATE_DOMAIN_DESCRIPTION(MDOC
     *            ,CODE5,ICH,IDOM,NDOMAIN,FILE_TEMP
     *            ,IOUT,FILE_SEQ,FILE_DOM_PDB,PATH_SCR,IERR)     
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: CREATE_DOMAIN_DESCRIPTION'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

C ------
      RETURN
  900 CONTINUE
      RETURN 
      END

      SUBROUTINE SEARCH_HOMOLOG_BY_SEQ_AND_PDB(MDOC,MODE,HARD,PRF
     *     ,ICODE_TARGET,CODE_TARGET,FILE_PDB,FILE_SEQ
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB
     *     ,IBACK_DB,ILEVEL_DB,ICLASS_DB,NSEQMAX
     *     ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM
     *     ,ITYPE_DOM,ICLASS_DOM,NSEG_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *     ,ND_STRING_CP,IDOMDOM_CP,IDOMSEG_CP,ND_RES_CP
     *     ,PNUM1_DM_CP,PNUM2_DM_CP,CODE_HOMOL_DM_CP,NSTRMAXC
     *     ,FIDENT_DM_CP,SCORE_DM_CP,Q_DM_CP
     *     ,NRES_TOT_CP,NRES_ALIGN_CP,NRES_DOMAIN_CP
     *     ,ISEG_NEW,NLINE_WRITE_MAX
     *     ,FIDENT,SCORE,Q_FIN,NPAIR,DRMS
     *     ,PATH_SCR,PATH_OUT,IERR)
C --------------------------------------------------------
      CHARACTER PATH_OUT*(*),PATH_SCR*(*),HARD*1,MODE*1,PRF*1
      CHARACTER DIR_FOR_NEW_SEQ*(*)
C ---
C      PARAMETER ( NLINEMAX = 100 )
      INTEGER   NLINE_INFO
      CHARACTER LINE_HOMOLOG_INFO(NLINEMAX)*256
C ---
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C --
C      PARAMETER ( NSTRMAXC = 100 )
      INTEGER   ND_STRING_CP,IDOMSEG_CP(NSTRMAXC),ND_RES_CP(NSTRMAXC)
      INTEGER   IDOMDOM_CP(NSTRMAXC)
      CHARACTER PNUM1_DM_CP(NSTRMAXC)*6,PNUM2_DM_CP(NSTRMAXC)*6
      CHARACTER CODE_HOMOL_DM_CP(NSTRMAXC)*8
      REAL      FIDENT_DM_CP(NSTRMAXC),SCORE_DM_CP(NSTRMAXC)
     *         ,Q_DM_CP(NSTRMAXC)
C --
      INTEGER   NRES_DOM(NDOMAIN)
      INTEGER   NSEG_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)

c      REAL      RINBYR_DOM(NDOMAIN)
c      REAL      RSBYR_DOM(NDOMAIN)
      REAL      RINBYR_DOM(2)
      REAL      RSBYR_DOM(2)

      CHARACTER CODE_DOM(NDOMAIN)*8
C --
      INTEGER   NRES_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX)
      INTEGER   ICLASS_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,COMPLEX_DB(NSEQMAX)*10
C --
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ---
      CHARACTER FILE_SEQ*(*)
      CHARACTER FILE_PDB*(*)
      CHARACTER CODE_TARGET*8
      CHARACTER LINE*256

      integer,   allocatable :: IUSED_DOM(:)
      integer,   allocatable :: IORDER_DB(:)

C ----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      allocate(IORDER_DB(1:NSEQMAX),STAT=ISTAT)
      allocate(IUSED_DOM(1:NDOMAIN),STAT=ISTAT)

      NLINE_INFO  = 0
      ISEG_STOR   = 0
      ISEG_NEW    = 0
      ND_STRING   = 0
      NRES_ALIGN  = 0
      NRES_DOMAIN = 0
      IT          = 0
      Q_BEST      = 0
C --- domain ----

      ISEG_NEW_DOM = 0

c      WRITE(*,*) '==MODE:',MODE
c      WRITE(*,*) '==p:',file_pdb
c      WRITE(*,*) '==s:',file_seq

      IF(HARD.EQ.'N') THEN
        FIDENT_DOM_LIM = 18.0
        SCORE_DOM_LIM  = 0.16
        Q_DOM_LIM      = 0.13

        Q_DOM_LIM      = 0.10

c  bad      SCORE_DOM_LIM  = 0.19
c  bad      Q_DOM_LIM      = 0.14
        IF(MODE.EQ.'U') Q_DOM_LIM = 0.10
        RMS_DOM_LIM    = 4.0
        IHIER_LEV      = 4
      ELSE
        FIDENT_DOM_LIM = 15.0
        SCORE_DOM_LIM  = 0.10
        Q_DOM_LIM      = 0.10
        RMS_DOM_LIM    = 4.0
        IHIER_LEV      = 1
      ENDIF

      LINE = ' -- search homologous domain  --'
      CALL MSGDOC(MDOC,LINE)

      CALL UPDATE_DOMAIN_DB_BY_DOMAIN(MDOC,MODE,PRF
     *       ,ICODE_TARGET,CODE_TARGET,FILE_PDB,FILE_SEQ
     *       ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *       ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *       ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM,IUSED_DOM
     *       ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *       ,RINBYR_DOM,RSBYR_DOM
     *       ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *       ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *       ,IHIER_LEV
     *       ,ISEG_NEW,FIDENT,SCORE,FNN
     *       ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *       ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *       ,FIDENT_DM,SCORE_DM,Q_DM
     *       ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *       ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in UPDATE_DOMAIN_DB_BY_DOMAIN')
        GO TO 900
      ENDIF

c        nnn = 0
c        DO ID=1,NDOMAIN
c          IF(IUSED_DOM(ID).GE.1) THEN
c            nnn = nnn + 1
c            write(*,*) nnn,id,' ',CODE_DOM(ID),IUSED_DOM(ID)
c     *                ,NRES_DOM(ID)
c          endif
c        enddo

      NCH = 0
      DO IC=1,NSEQ
        NRES_SUM = 0
        DO ID=1,NDOMAIN
          IF(IUSED_DOM(ID).GE.2) THEN
            IF(CODE_DOM(ID)(1:5).EQ.CODE_DB(IC)(1:5)) THEN
              NRES_SUM = NRES_SUM + NRES_DOM(ID)
            ENDIF
          ENDIF
        ENDDO
        T = REAL(NRES_SUM)/REAL(NRES_DB(IC))
        IF(T.GT.0.5) THEN
          NCH = NCH + 1
          IORDER_DB(IC) = 1
c          WRITE(*,*) NCH,IC,' ',CODE_DB(IC),T
        ELSE
          IORDER_DB(IC) = 0
        ENDIF
        IF(COMPLEX_DB(IC)(2:2).EQ.'_'.OR.
     *       COMPLEX_DB(IC)(2:2).EQ.'.'     ) IORDER_DB(IC) = 1
      ENDDO

      NRES_TOT_DOM    = NRES_TOT
      NRES_ALIGN_DOM  = NRES_ALIGN
      NRES_DOMAIN_DOM = NRES_DOMAIN

      ISEG_NEW_DOM = ISEG_NEW
      Q_BEST_DOM = 0.0

      IF(ISEG_NEW_DOM.GT.0.AND.ND_STRING.GT.0) THEN
        N_TOT = 0
        DO II=1,ND_STRING
          READ(PNUM1_DM(II)(2:5),'(I4)') IRES1
          READ(PNUM2_DM(II)(2:5),'(I4)') IRES2
          N = (IRES2-IRES1) + 1
          Q_BEST_DOM = Q_BEST_DOM + Q_DM(II)*REAL(N)
          N_TOT = N_TOT + N
        ENDDO
        IF(N_TOT.GT.0) Q_BEST_DOM = Q_BEST_DOM/REAL(N_TOT)
      ELSE
        NCH = 0
      ENDIF

      IF(NCH.LE.0) THEN
        DO IC=1,NSEQ
          IORDER_DB(IC) = 1
        ENDDO
      ENDIF   

c      write(*,*) 'ISEG_NEW_DOM:',ISEG_NEW_DOM
c      write(*,*) 'ND_STRING:',ND_STRING
c      write(*,*) 'NRES_TOT_DOM:',NRES_TOT_DOM
c      write(*,*) 'NRES_ALIGN_DOM:',NRES_ALIGN_DOM
c      write(*,*) 'NRES_DOMAIN_DOM:',NRES_DOMAIN_DOM
c      write(*,*) 'NCH:',NCH    
c      write(*,*) 'Q_BEST_DOM:',Q_BEST_DOM
C ---  chain ---

      NLINE_INFO  = 0
      ISEG_STOR   = 0
      ISEG_NEW    = 0
c      ND_STRING   = 0
      ND_STRING_CP = 0
      NRES_ALIGN  = 0
      NRES_DOMAIN = 0
      IT          = 0

c/////
      IF(MODE.EQ.'U') GO TO 100
c/////

      IF(HARD.EQ.'N') THEN
        FIDENT_LIM = 18.0
        SCORE_LIM  = 0.15
        Q_LIM      = 0.13
        IF(MODE.EQ.'U') Q_LIM = 0.13
        RMS_LIM    = 4.0
        IHIER_LEV  = 0
        IF(NCH.LE.0) THEN
          IHIER_LEV = 5
        ENDIF
      ELSE
        FIDENT_LIM = 15.0
        SCORE_LIM  = 0.10
        Q_LIM      = 0.10
        RMS_LIM    = 4.0
        IHIER_LEV  = 0
      ENDIF

      LINE = ' -- search homologous chain  --'
      CALL MSGDOC(MDOC,LINE)
      CALL UPDATE_DOMAIN_DB_BY_CHAIN(MDOC
     *     ,ICODE_TARGET,CODE_TARGET
     *     ,FILE_PDB,FILE_SEQ,MODE
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB
     *     ,IBACK_DB,ILEVEL_DB,IORDER_DB,ICLASS_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM,RMS_LIM,IHIER_LEV
     *     ,ISEG_NEW,ICODE_GOM
     *     ,FIDENT,SCORE,Q_BEST,Q_FIN,NPAIR,DRMS
     *     ,ND_STRING_CP,IDOMDOM_CP,IDOMSEG_CP,ND_RES_CP
     *     ,PNUM1_DM_CP,PNUM2_DM_CP,CODE_HOMOL_DM_CP,NSTRMAX
     *     ,FIDENT_DM_CP,SCORE_DM_CP,Q_DM_CP
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX,NLINE_WRITE_MAX
     *     ,PATH_SCR,PATH_OUT,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in UPDATE_DOMAIN_DB_BY_CHAIN')
        GO TO 900
      ENDIF

c      write(*,*) 'ISEG_NEW:',ISEG_NEW
c      write(*,*) 'ND_STRING_CP:',ND_STRING_CP
c      write(*,*) 'NRES_TOT:',NRES_TOT
c      write(*,*) 'NRES_ALIGN:',NRES_ALIGN
c      write(*,*) 'NRES_DOMAIN:',NRES_DOMAIN
c      write(*,*) 'Q_BEST:',Q_BEST

 100  CONTINUE

      IF(ISEG_NEW.LE.0) THEN
        ICHAIN = 0
        IF(ISEG_NEW_DOM.LE.0) THEN
          ND_STRING = 0
        ELSE 
          ISEG_NEW = 2
          NRES_TOT    = NRES_TOT_DOM 
          NRES_ALIGN  = NRES_ALIGN_DOM
          NRES_DOMAIN = NRES_DOMAIN_DOM
        ENDIF
      ELSE
        ICHAIN = 0
        IT  = NRES_TOT - NRES_ALIGN
        ITT = NRES_TOT_DOM - NRES_ALIGN_DOM - 30
        IF(ISEG_NEW_DOM.LE.0) THEN
          ICHAIN = 1
        ELSE  
          IF(Q_BEST.GE.0.4.AND.IT.LT.25) THEN
            ICHAIN = 1
          ELSE
            IF(IT.LT.ITT) ICHAIN = 1
          ENDIF
        ENDIF

        IF(ICHAIN.GT.0) THEN
C         --- chain ---
          IF(MODE.EQ.'S') THEN
            IF(Q_BEST_DOM.LT.Q_BEST) ND_STRING = 0         
          ELSE
            IF(ND_STRING_CP.GT.0) THEN
              ND_STRING = ND_STRING_CP
              DO I=1,ND_STRING_CP
                IDOMSEG(I)  = IDOMSEG_CP(I)
                IDOMDOM(I)  = IDOMDOM_CP(I)
                PNUM1_DM(I) = PNUM1_DM_CP(I)
                PNUM2_DM(I) = PNUM2_DM_CP(I)
                CODE_HOMOL_DM = CODE_HOMOL_DM_CP(I)
                FIDENT_DM(I) = FIDENT_DM_CP(I)
                SCORE_DM(I)  = SCORE_DM_CP(I)
                Q_DM(I)      = Q_DM_CP(I) 
              ENDDO
              NDOM = IDOMDOM(1)
C 26.09.2008     IF(NDOM.LE.1) ND_STRING = 0
            ENDIF
          ENDIF
        ELSE
C         --- domain ---
          NRES_TOT    = NRES_TOT_DOM
          NRES_ALIGN  = NRES_ALIGN_DOM
          NRES_DOMAIN = NRES_DOMAIN_DOM 
        ENDIF
      ENDIF

c      write(*,*) 'ICHAIN:',ICHAIN
c      write(*,*) 'ND_STRING:',ND_STRING
c      write(*,*) 'NRES_TOT:',NRES_TOT
c      write(*,*) 'NRES_ALIGN:',NRES_ALIGN
c      write(*,*) 'NRES_DOMAIN:',NRES_DOMAIN

C ------------
 900  CONTINUE

      deallocate(IORDER_DB,STAT=ISTAT)
      deallocate(IUSED_DOM,STAT=ISTAT)

      RETURN
      END


      SUBROUTINE READ_DOMAIN_LIST(MDOC,FILE_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
C --------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_DOM*(*)
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
      CHARACTER LINE*256
      CHARACTER PATH*1,EXT*1,PN1*6,PN2*6
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------------
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_DOM,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input file-domain_list.txt')
        IERR = 1
        RETURN
      ENDIF
C ---
      IS = 0
 200  CONTINUE
      READ(MT,'(A)',END=100,ERR=900) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.31.OR.LINE(1:1).EQ.'#') GO TO 200
      IS = IS + 1
      IF(IS.GT.NSEGMAX) THEN
        CALL MSGERR(MD,'ERROR: number of dom_str > limit')
        IERR = 1
        RETURN
      ENDIF
      CODE_DOM_DB(IS) = LINE(7:11)//'   '
      READ(LINE,'(I5,6X,2I3,1X,A6,1X,A6)',ERR=900)
     *   ND,IDOM,ISEG,PN1,PN2
      NDOM_DB(IS)      = ND
      PNUM1_DOM_DB(IS) = PN1
      PNUM2_DOM_DB(IS) = PN2
      IDOMSEG_DB(IS)   = IDOM*100 + ISEG
      GO TO 200
C ---
 100  CONTINUE
      CLOSE(MT)
      NSEG_DB = IS
      IF(IS.LE.0) THEN
        CALL MSGERR(MD,'ERROR: number of dom_str = 0')
        IERR = 1
        RETURN
      ENDIF
C -------------
      RETURN
 900  CONTINUE
      IERR = 1
      CALL MSGDOC(MD,
     * ' ERROR: reading input file-domain_list.txt')
      RETURN
      END

      SUBROUTINE WRITE_DOMAIN_LIST(MDOC,FILE_DOM
     *      ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *      ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX,IERR)
C --------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_DOM*(*)
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
      CHARACTER LINE*256
      CHARACTER PATH*1,EXT*1,PN1*6,PN2*6
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------------
      EXT  = ' '
      PATH = ' '
      MT   = 11
      CALL OPENFW(MT,M,PATH,FILE_DOM,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open output file-domain_list.txt')
        IERR = 1
        RETURN
      ENDIF
C ---
      DO IS=1,NSEG_DB

        ND   = NDOM_DB(IS)
        IDOM = IDOMSEG_DB(IS)/100
        ISEG = IDOMSEG_DB(IS) - IDOM*100  
        WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6)',ERR=900)
     *    ND,CODE_DOM_DB(IS)(1:5),IDOM,ISEG
     *   ,PNUM1_DOM_DB(IS),PNUM2_DOM_DB(IS)

        CALL LENSTR_BL(LINE,LEN)
        WRITE(MT,'(A)',ERR=900) LINE(:LEN)

      ENDDO
      END FILE MT
      CLOSE(MT)
C -------------
      RETURN
 900  CONTINUE
      IERR = 1
      CALL MSGDOC(MD,
     * ' ERROR: riting output file-domain_list.txt')
      CLOSE(MT) 
      RETURN
      END

      SUBROUTINE UPDATE_DOMAIN_DB_BY_CHAIN(MDOC
     *     ,ICODE_TARGET,CODE_TARGET
     *     ,FILE_PDB,FILE_SEQ,MODE
     *     ,NSEQ,CODE_DB,NRES_DB,COMPLEX_DB
     *     ,IBACK_DB,ILEVEL_DB,IORDER_DB,ICLASS_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM,RMS_LIM,IHIER_LEV
     *     ,ISEG_NEW,ICODE_GOM
     *     ,FIDENT,SCORE,Q_BEST,Q_FIN,NPAIR,DRMS
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOM
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX,NLINE_WRITE_MAX
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_SEQ*(*),FILE_PDB*(*)
      CHARACTER CODE_TARGET*8,MODE*1

      INTEGER   NRES_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,COMPLEX_DB(NSEQMAX)*10
      INTEGER   IORDER_DB(NSEQMAX),ICLASS_DB(NSEQMAX)

      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)

      CHARACTER LINE*256
C ----------------------------------
C      PARAMETER ( NLINEMAX = 100 )
      INTEGER   NLINE_INFO
      CHARACTER LINE_HOMOLOG_INFO(NLINEMAX)*256
C ---
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      ISEG_NEW = 0
      FIDENT   = 0.0
      SCORE    = 0.0
      FNN      = 0.0
      ND_STRING = 0
C -------------

      NRES = NRES_TOT

      CALL SEARCH_HOMOLOG_BY_SEQ(MDOC,MODE
     *     ,ICODE_TARGET,CODE_TARGET,FILE_SEQ,FILE_PDB,NRES
     *     ,NSEQ,NRES_DB
     *     ,IBACK_DB,ILEVEL_DB,IORDER_DB,ICLASS_DB
     *     ,CODE_DB,COMPLEX_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM,RMS_LIM,IHIER_LEV
     *     ,ISEG_NEW,ICODE_GOM
     *     ,FIDENT,SCORE,Q_BEST,Q_FIN,NPAIR,DRMS
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOM
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX,NLINE_WRITE_MAX
     *     ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) GO TO 900
C -------------
      RETURN
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE SEARCH_HOMOLOG_BY_SEQ(MDOC,MODE
     *     ,ICODE_TARGET,CODE_TARGET,FILE_SEQ,FILE_PDB,NRES
     *     ,NSEQ,NRES_DB
     *     ,IBACK_DB,ILEVEL_DB,IORDER_DB,ICLASS_DB
     *     ,CODE_DB,COMPLEX_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM,RMS_LIM,IHIER_LEV
     *     ,ISEG_NEW,ICODE_GOM
     *     ,FIDENT,SCORE,Q_BEST,Q_FIN,NPAIR,DRMS
     *     ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *     ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *     ,FIDENT_DM,SCORE_DM,Q_DM
     *     ,NRES_TOT,NRES_ALIGN,NRES_DOM
     *     ,NLINE_INFO,LINE_HOMOLOG_INFO,NLINEMAX,NLINE_WRITE_MAX
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      INTEGER   NRES_DB(NSEQMAX),NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8,COMPLEX_DB(NSEQMAX)*10
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER LINE*256
      CHARACTER PATH_DB*256,FILE_GOM*256
      CHARACTER DIR_FOR_SEQ*256,FILE_SEQ*(*)
      CHARACTER DIR_FOR_PDB*256,FILE_PDB*(*)
      CHARACTER DIR_FOR_NEW_SEQ*256
      CHARACTER FILE_OUT*256,FILE_TEMP*256,FILE_SCR*256
      CHARACTER CODE_LIST*8,CODE_GOM*8,CODE_TARGET*8,MODE*1,DOM*1
      CHARACTER HOME*1
      CHARACTER PATH*1,EXT*1
C ----------------------------------
C      PARAMETER ( NLINEMAX = 100 )
      INTEGER   NLINE_INFO
      CHARACTER LINE_HOMOLOG_INFO(NLINEMAX)*256
C --
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)

      INTEGER   IDUMMY(10)
      INTEGER   IUSED_DOM(10)
      INTEGER   IORDER_DB(NSEQMAX),ICLASS_DB(NSEQMAX)

      integer,   allocatable :: ICODE_STOR(:)
      integer,   allocatable :: N1_STOR(:)
      integer,   allocatable :: N2_STOR(:)
      integer,   allocatable :: NN_STOR(:)
      integer,   allocatable :: NPAIR_STOR(:)
      integer,   allocatable :: NGAP_STOR(:)
      integer,   allocatable :: INDEX_STOR(:)
      real,      allocatable :: HID_STOR(:)
      real,      allocatable :: SCORE_NEW_STOR(:)
      real,      allocatable :: Q_STOR(:)
      real,      allocatable :: Q_FIN_STOR(:)
      real,      allocatable :: DRMS_STOR(:)

      CHARACTER FRMT*256      
      logical ex
      integer nfile
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT = '(I6,1X,I1,1X,I6,1X,I6,1X,F6.2,1X,A8,1X,I6,1X,'//
     *       'F6.2,1X,I6,1X,I6,1X,A10,1X,F6.1,1X,F6.3,1X,F6.3)'
C ---  
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      CALL LENSTR_BL(PATH_DB,LEN)
      IF(IERR.NE.0.OR.LEN.LE.0) THEN
        LINE = 'ERROR: problem with setenv MOLREP_DB'
        CALL MSGERR(MD,LINE)
        LINE = '       Example: "setenv MOLREP_DB ~alexei/molrep_DB"'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF

      HOME = 'N'
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_SCR = PATH_DB(1:LEN)//'/home/home_info.txt'
      CALL LENSTR_BL(FILE_SCR,LEN)
      inquire(file=FILE_SCR(1:LEN),exist=ex,number=nfile)
      IF(ex) THEN
        HOME = 'C'
      ENDIF

      CALL LENSTR_BL(PATH_DB,LEN)
      DIR_FOR_SEQ = PATH_DB(1:LEN)//'/seq_DB/'
      LENCODE = 5
C ---
      allocate(ICODE_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(N1_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(N2_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(NN_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(NPAIR_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(NGAP_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(HID_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(SCORE_NEW_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(Q_FIN_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(Q_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(DRMS_STOR(1:NSEQMAX),STAT=ISTAT)
      allocate(INDEX_STOR(1:NSEQMAX),STAT=ISTAT)

C ---  
      DO ID=1,NSEQ
C        IORDER_DB(ID) = 1
        IF(MODE.EQ.'U') THEN
          IF(COMPLEX_DB(ID)(2:2).EQ.'_'.OR.
     *    COMPLEX_DB(ID)(2:2).EQ.'.'     ) IORDER_DB(ID) = 0
        ENDIF
      ENDDO

      WRITE(LINE,'(A,I6)') ' Nresidue :',NRES
      CALL MSGDOC(MDOC,LINE)

C      NRES_MAX = NRES*1.25
C      NRES_MIN = NRES*0.4
C      NRES_MAX = 10000
C      NRES_MIN = 30
C      IF(NRES.GT.70) NRES_MIN = 50

      NRES_MAX = 10000
      NRES_MIN = NRES/4
      IF(NRES_MIN.LT.25.AND.NRES.GE.25) NRES_MIN = 25

c ////
C      IF(MODE.EQ.'S') NRES_MIN = NRES/4
c ////

      DOM      = 'C'
      NRUN     = 1

      FILE_OUT = ' '
      DIR_FOR_NEW_SEQ = ' '
      NDOMAIN_INI = NSEQ

      FILE_SCR = FILE_SEQ
      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.GT.0.AND.HOME.NE.'N') THEN
        FILE_SCR = FILE_PDB
      ENDIF

c      IF(MODE.EQ.'U') THEN
c        CALL SEARCH_CHAIN_IN_DB_FOR_UPDATE(MDOC,MODE,DOM
c     *     ,ICODE_TARGET
c     *     ,FILE_SEQ,FILE_OUT
c     *     ,LENCODE,NRES,DIR_FOR_SEQ
c     *     ,NSEQ
c     *     ,CODE_DB,NRES_DB,IBACK_DB,ILEVEL_DB,NSEQMAX
c     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
c     *     ,FIDENT_LIM,SCORE_LIM,NRES_MAX,NRES_MIN,IHIER_LEV
c     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
c     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
c     *     ,IORDER_DB
c     *     ,NCH_TOT
c     *     ,PATH_SCR,PATH_OUT,IERR)
c      ELSE
C       ,ICLASS_DB
C        ,IDUMMY,IDUMMY
        CALL SEARCH_CHAIN_IN_DB(MDOC,MODE,DOM,HOME,PATH_DB
     *     ,ICODE_TARGET
     *     ,FILE_SCR,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NSEQ
     *     ,CODE_DB,NRES_DB,IBACK_DB,ILEVEL_DB,NSEQMAX
     *     ,IDUMMY,ICLASS_DB
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM
     *     ,NRES_MAX,NRES_MIN,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,IORDER_DB,IUSED_DOM
     *     ,NCH_TOT,NRUN
     *     ,PATH_SCR,PATH_OUT,IERR)

c      ENDIF
      IF(IERR.NE.0) GO TO 800

      IF(NCH_TOT.LE.0) THEN
        LINE = 'No homologous (search by chain)'
        CALL MSGDOC(MDOC,LINE)
        GO TO 800
      ENDIF

      IDD       = INDEX_STOR(NCH_TOT)
      ICODE_GOM = ICODE_STOR(IDD)
      CODE_GOM  = CODE_DB(ICODE_GOM)
      FIDENT    = HID_STOR(IDD)
C     SCORE     = SCORE_NEW_STOR(NCH_TOT)
      SCORE     = SCORE_NEW_STOR(IDD)
      Q_BEST    = Q_STOR(NCH_TOT)
      NN        = NN_STOR(IDD)

      NLINE_INFO = 0
      IF(MODE.EQ.'S') THEN
        NL = NCH_TOT
        IF(NL.GT.NLINE_WRITE_MAX) NL = NLINE_WRITE_MAX
        IF(NL.GT.NCH_TOT) NL = NCH_TOT
        NFIN = NCH_TOT - NL + 1
        NLINE_INFO = NL
        II = 0
        DO I=NCH_TOT,NFIN,-1
          II = II + 1
          I0 = 0
          F0 = 0.0
          IDD = INDEX_STOR(I)
          IC  = ICODE_STOR(IDD)
          WRITE(LINE,FRMT,ERR=500)
     *     IC,ILEVEL_DB(IC),I0
     *    ,IBACK_DB(IC),F0,CODE_DB(IC),NRES_DB(IC)
     *    ,F0,I0,NRES_DB(IC),COMPLEX_DB(IC)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(I)
          LINE_HOMOLOG_INFO(II) = LINE
        ENDDO
      ENDIF

      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.GT.0) THEN

        LINE = ' -- check by rms --'
        CALL MSGDOC(MDOC,LINE)

        CALL LENSTR_BL(PATH_DB,LEN)
        DIR_FOR_PDB = PATH_DB(1:LEN)//'/pdb_DB/'
        FILE_OUT = ' '
        QQ_LIM   = 0.0
c        DRMS_LIM = 10.0
C       chain - DIR_FOR_PDB(../pdb_DB/)  ; DOM - DIR_FOR_PDB(' ')
C       NDOM_TOT input in _STOR ; NDOM_FINAL output in _STOR
        CALL CHECK_SEARCH_BY_RMS(MDOC,DOM,HOME
     *     ,FILE_PDB,FILE_OUT,DIR_FOR_PDB
     *     ,CODE_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,NCH_TOT
     *     ,FIDENT_LIM,SCORE_LIM,QQ_LIM,RMS_LIM
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,NDOM_FINAL
     *     ,ICODE_BEST,FIDENT_BEST,SCORE_BEST,Q_BEST,DRMS_BEST
     *     ,N2_BEST,NN_BEST,NPAIR_BEST
     *     ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) GO TO 800

c        write(*,*) '--ICODE_BEST:',ICODE_BEST

        IF(ICODE_BEST.GT.0) THEN
c          T = REAL(NN_BEST)/REAL(NN)
c          IF(T.GT.0.9) THEN
            ICODE_GOM = ICODE_BEST
            CODE_GOM  = CODE_DB(ICODE_GOM)
            FIDENT    = FIDENT_BEST
            SCORE     = SCORE_BEST
c          ENDIF
        ELSE
          LINE = 'No homologous (check by rms)'
          CALL MSGDOC(MDOC,LINE)
          GO TO 800
        ENDIF

      ENDIF

      WRITE(LINE,*) '  <-- CODE_gomol: ',CODE_GOM,FIDENT,SCORE
      CALL MSGDOC(MDOC,LINE)

      IF(COMPLEX_DB(ICODE_GOM)(2:2).NE.'0') THEN
        CALL GET_DOM_INFO_FROM_LIST_MEM(MDOC,CODE_GOM
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,ND_STRING,IDOMDOM,IDOMSEG
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX,IERR)
        IF(IERR.NE.0) GO TO 800
      ELSE
        ND_STRING = 0
      ENDIF

C     create domain_info

      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.GT.0) THEN
        FILE_TEMP = FILE_PDB
      ELSE
        FILE_TEMP = FILE_SEQ
      ENDIF
      
      MMM = M
      IF(MODE.EQ.'S') MMM=MDOC 
      MMM=MDOC 

      CALL UPD_ALIGN_AND_DOM_INFO(MMM,FILE_TEMP
     *   ,CODE_GOM,CODE_TARGET
     *   ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX
     *   ,NRES_TOT,NRES_ALIGN,NRES_DOM
     *   ,FIDENT,SCORE,Q_FIN,NPAIR,DRMS
     *   ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) GO TO 800

      WRITE(LINE,'(A,3I6)') ' Nres tot,align,dom:'
     *             ,NRES_TOT,NRES_ALIGN,NRES_DOM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F5.1,1X,F6.3,1X,F6.3,1X,F6.3,1X,I5,1X,F6.2)') 
     *   ' Ident,Score,Q,Qf,Npair,Rms:'
     *   ,FIDENT,SCORE,Q_BEST,Q_FIN,NPAIR,DRMS
      CALL MSGDOC(MDOC,LINE)


      IF(ND_STRING.GT.0) THEN
        DO I=1,ND_STRING
          FIDENT_DM(I) = FIDENT
          SCORE_DM(I)  = SCORE
          Q_DM(I)      = Q_BEST
          IDOM = IDOMSEG(I)/100
          ISEG = IDOMSEG(I) - IDOM*100
          CODE_HOMOL_DM(I) = CODE_GOM(1:5)
          WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6,2X,A)')
     *      IDOMDOM(I),CODE_TARGET(1:5),IDOM,ISEG
     *     ,PNUM1_DM(I),PNUM2_DM(I),CODE_HOMOL_DM(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ELSE

      ENDIF

      ISEG_NEW = 1

 800  CONTINUE

      deallocate(ICODE_STOR,STAT=ISTAT)
      deallocate(N1_STOR,STAT=ISTAT)
      deallocate(N2_STOR,STAT=ISTAT)
      deallocate(NN_STOR,STAT=ISTAT)
      deallocate(NPAIR_STOR,STAT=ISTAT)
      deallocate(NGAP_STOR,STAT=ISTAT)
      deallocate(HID_STOR,STAT=ISTAT)
      deallocate(SCORE_NEW_STOR,STAT=ISTAT)
      deallocate(Q_FIN_STOR,STAT=ISTAT)
      deallocate(Q_STOR,STAT=ISTAT)
      deallocate(DRMS_STOR,STAT=ISTAT)
      deallocate(INDEX_STOR,STAT=ISTAT)

C -------------
      RETURN
 900  CONTINUE
      IERR = 1
      RETURN
 500  CONTINUE
      CALL MSGERR(MDOC,'ERROR: writing output info_lines')
      IERR = 1
      RETURN
      END

      SUBROUTINE UPD_ALIGN_AND_DOM_INFO(MDOC,FILE_TARGET
     *   ,CODE_GOM,CODE_TARGET
     *   ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX
     *   ,NRES_TOT,NRES_ALIGN,NRES_DOM
     *   ,FIDENT,SCORE_NEW,Q_FIN,NPAIR,DRMS
     *   ,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512
      CHARACTER FILE_XYZ*256,FILE_CRD*256,FILE_TEMP*256
      CHARACTER FILE_PDB*256,FILE_TARGET*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*256
      CHARACTER PATH*1,EXT*1
C ---
c     for alignment
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
C ------------------------------------------------
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAX = 100  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
C ---------------------------------
C ---
      CHARACTER CODE_GOM*8,CODE10*10,CODE_TARGET*8
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C -----------------------
      NRES_TOT   = 0
      NRES_ALIGN = 0
      NRES_DOM   = 0

C     --- CODE_GOM ---
C     xyz --> pdb
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_XYZ = PATH_DB(1:LEN)//'/pdb_DB/'//CODE_GOM(1:5)//'.xyz'
      FILE_PDB = 'unpack.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PDB,LT )
      IF(LEN.GT.0) THEN
        FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
      ENDIF
      CALL PDB_UNPACK(M,FILE_XYZ,FILE_PDB,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        GO TO 900
      ENDIF
C     dom_info --> pdb (SEG_ID)
      FILE_CRD = 'domains.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_CRD,LT )
      IF(LEN.GT.0) THEN
        FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
      ENDIF

C     ierr=-1    set '-' in seg_id(76:76) (domains border)
c      IERR =-1
      IERR = 0
      IERR =-1
      CALL SET_DOMAIN_INFO_TO_PDB_MEM(M,FILE_PDB,FILE_CRD
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,IERR)

      IF(IERR.NE.0) THEN
        LINE = ' ERROR: set dom_info to PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF
C ----
      IF(NDOM.LT.0) NDOM = 0
      WRITE(LINE,'(A,I5)') ' N_domain :',NDOM
      CALL MSGDOC(M,LINE)

C ---- ALIGN ---
C     FILE_TARGET FILE_CRD --> FILE_TEMP
      FILE_TEMP = 'model_DB.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF
      IPRINT  = 1
C ----
      CALL MAKE_ALIGN(MDOC,IPRINT,FILE_TARGET,FILE_CRD,FILE_TEMP
     *                  ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
C ------
      NRES_TOT   = RESULT(1)
      NRES_ALIGN = RESULT(3)
      NRES_DOM   = 0
      Q_FIN      = RESULT(15)
      DRMS       = RESULT(16)
      NPAIR      = RESULT(17)
      SCORE_NEW  = RESULT(18)
      FIDENT     = RESULT(5) 
c     get dom info
      ND_STRING  = 0
      NDOM_FINAL = 0
      NSEG_FINAL = 0
C      IF(NDOM.LE.0) GO TO 200
      NSEG_TOT = 0
      LEN_LIM = 5
      ISTART = 1
      IF(NDOM.LE.0) ISTART = 0
      DO IDOM=ISTART,NDOM

        CALL GET_DOMAIN_PDB(M,FILE_TEMP,FILE_PDB
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,NATOM,IERR)
        IF(IERR.NE.0.OR.NATOM.LE.0.OR.NRES.LT.5.OR.NSEG.LE.0) THEN
          IERR = 0
          GO TO 100
        ENDIF

        ISP = 0
        DO ISS=1,NSEG
          READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
          READ(PNUM_FIN  (ISS)(3:6),'(I4)') IS_F
          ISD = IS_F - IS_S
          IF(ISD.GE.LEN_LIM) THEN
            ISP = ISP + 1
            PNUM_START(ISP) = PNUM_START(ISS)
            PNUM_FIN  (ISP) = PNUM_FIN  (ISS)
          ENDIF
        ENDDO  
        NSEG = ISP
        IF(NSEG.LE.0) GO TO 100


        NRES_DOM = NRES_DOM + NRES 

        IF(NSEG.GT.1) THEN
 
          ISP = 1
          DO ISS=2,NSEG
            READ(PNUM_START(ISP)(3:6),'(I4)') ISP_S
            READ(PNUM_FIN(ISP)(3:6),'(I4)') ISP_F
            READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
            READ(PNUM_FIN(ISS)(3:6),'(I4)') IS_F
            ISD = IS_S - ISP_F
            IF(ISD.LE.LEN_LIM) THEN
              PNUM_FIN(ISP) = PNUM_FIN(ISS)
            ELSE
              ISP = ISP + 1
              PNUM_START(ISP) = PNUM_START(ISS)
              PNUM_FIN(ISP) = PNUM_FIN(ISS)
            ENDIF
          ENDDO  
          NSEG = ISP

        ENDIF

        NDOM_FINAL = NDOM_FINAL + 1
        DO ISEG=1,NSEG
          NSEG_TOT   = NSEG_TOT + 1
          IDOMDOM(NSEG_TOT)  = NDOM_FINAL
          IDOMSEG(NSEG_TOT)  = ISEG
          PNUM1_DM(NSEG_TOT) = PNUM_START(ISEG)(2:7)  
          PNUM2_DM(NSEG_TOT) = PNUM_FIN(ISEG)(2:7)
          IF(PNUM1_DM(NSEG_TOT)(6:6).EQ.' ') 
     *    PNUM1_DM(NSEG_TOT)(6:6) = '-'
          IF(PNUM2_DM(NSEG_TOT)(6:6).EQ.' ') 
     *    PNUM2_DM(NSEG_TOT)(6:6) = '-'
          PNUM1_DM(NSEG_TOT)(1:1) = CODE_TARGET(5:5)
          PNUM2_DM(NSEG_TOT)(1:1) = CODE_TARGET(5:5)
        ENDDO  

 100    CONTINUE
      ENDDO
      
      IF(NDOM_FINAL.GT.0) THEN

        ND_STRING = NSEG_TOT
        DO ISEG=1,NSEG_TOT
          IDOMSEG(ISEG) = IDOMDOM(ISEG)*100 + IDOMSEG(ISEG)
          IDOMDOM(ISEG) = NDOM_FINAL 
        ENDDO

      ENDIF

200   CONTINUE

C ------
      RETURN
  900 CONTINUE
      RETURN 
  910 CONTINUE
      IERR = 1
      RETURN 
      END

      SUBROUTINE SET_DOMAIN_INFO_TO_PDB_MEM(MDOC,FILE_CRD,FILE_TEMP
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,ND,IERR)
C ------------------------------------------------
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C -------------------------------------------------
      INTEGER   MDOC,IERR,NDOM
      CHARACTER SEG_DOM*3
      CHARACTER FILE_CRD*(*),FILE_TEMP*(*)
      CHARACTER PATH*1,EXT*1,PN1*6,PN2*6,PN*6,CHAIN*1
      CHARACTER LINE*256,CP_PNUM_OLD*7,CP_PNUM*7,CHAIN_DOM*1
      INTEGER   NLETT
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      CHARACTER LETTS*26
c                 01234567890123456789012345
      DATA LETTS/'abcdefghijklmnopqrstuvwxyz'/
      DATA NLETT/26/
C -------------------------------------------------
C     ierr=-1    set '-' in seg_id(76:76) (domains border) 
      IFLAG_DB = 0
      IF(IERR.LT.0) IFLAG_DB = 1
C ---  
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      NDOM = 0
C --------------------------------------------------
      IF(ND_STRING.GT.0) THEN
        ND = 0
        DO IS=1,ND_STRING
          IDOM = IDOMSEG(IS)/100 
          IF(IDOM.GT.ND) ND = IDOM
          PN1  = PNUM1_DM(IS) 
          PN2  = PNUM2_DM(IS) 
          IF(PN1(1:1).EQ.'_') PN1(1:1) = ' '
          IF(PN1(2:2).EQ.'_') PN1(2:2) = ' '
          IF(PN1(3:3).EQ.'_') PN1(3:3) = ' '
          IF(PN1(4:4).EQ.'_') PN1(4:4) = ' '
          IF(PN1(6:6).EQ.'-') PN1(6:6) = ' '
          IF(PN2(1:1).EQ.'_') PN2(1:1) = ' '
          IF(PN2(2:2).EQ.'_') PN2(2:2) = ' '
          IF(PN2(3:3).EQ.'_') PN2(3:3) = ' '
          IF(PN2(4:4).EQ.'_') PN2(4:4) = ' '
          IF(PN2(6:6).EQ.'-') PN2(6:6) = ' '
          PNUM1_DM(IS) = PN1
          PNUM2_DM(IS) = PN2
          ND_RES(IS)   = 0
        ENDDO
      ELSE
        ND = 0
      ENDIF
C ---
      CALL LENSTR_BL(FILE_CRD,LEN)
      IF(LEN.LE.0) RETURN
C -----------      
      N    = 0 
      CP_PNUM_OLD = '?'
      IDOM_OLD = 0
      ISEG_OLD = 0
      ILETT    = 0
      SEG_DOM = '   '
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input crd file')
        IERR = 1
        RETURN
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 11
      CALL OPENFW(IOUT,M,PATH,FILE_TEMP,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open output crd file')
        IERR = 1
        CLOSE(MT)
        RETURN
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 410

        CP_PNUM = LINE(21:27)
 
        IF(ND.GT.0) THEN

        IF(CP_PNUM_OLD.NE.CP_PNUM) THEN
          SEG_DOM = '---'
          READ(CP_PNUM(3:6),'(I4)') IRES
          CHAIN   = CP_PNUM(2:2)
          PN(2:6) = CP_PNUM(3:7)
          CP_PNUM_OLD  = CP_PNUM
          IDOM_OLD = -1
          DO IS=1,ND_STRING
            IDOM = IDOMSEG(IS)/100
            ISEG = IDOMSEG(IS) - IDOM*100
            IF(IDOM.NE.IDOM_OLD) THEN
              ILETT = 1
            ELSE
              ILETT = ILETT + 1
              IF(ILETT.GT.2) ILETT = 1
            ENDIF
            PN1  = PNUM1_DM(IS) 
            PN2  = PNUM2_DM(IS) 
            READ(PN1(2:5),'(I4)') IRES1
            READ(PN2(2:5),'(I4)') IRES2
            CHAIN_DOM = PN1(1:1)
            IF(CHAIN_DOM.EQ.CHAIN.AND.
     *         IRES.GE.IRES1.AND.IRES.LE.IRES2) THEN
              WRITE(SEG_DOM(1:2),'(I2)') IDOM
              IF(IDOM.GT.9.AND.IDOM.LE.NLETT) THEN
                IT = IDOM -9
                SEG_DOM(1:2) = ' '//LETT(IT:IT)
              ENDIF

              SEG_DOM(3:3) = ' '
              IF(IFLAG_DB.GT.0) THEN
                SEG_DOM(3:3) = LETT(ILETT:ILETT)
              ENDIF

c              IF(IDOM.NE.IDOM_OLD) THEN
c                ILETT = 1
c                SEG_DOM(3:3) = ' '
c                IF(IFLAG_DB.GT.0) THEN
cC                 SEG_DOM(3:3) = '='
c                  SEG_DOM(3:3) = LETT(ILETT:ILETT)
c                ENDIF
c              ELSE IF(IS.NE.ISEG_OLD) THEN
c                SEG_DOM(3:3) = ' '
c                ILETT = ILETT + 1
c                IF(ILETT.GT.2) ILETT = 1
c                IF(IFLAG_DB.GT.0) THEN
cC                 SEG_DOM(3:3) = '='
c                  SEG_DOM(3:3) = LETT(ILETT:ILETT)
c                ENDIF
c              ELSE
c                SEG_DOM(3:3) = ' '
c              ENDIF
c              IDOM_OLD = IDOM

              ISEG_OLD = IS
              ND_RES(IS) = ND_RES(IS) + 1
              GO TO 420
            ENDIF
            IDOM_OLD = IDOM
          ENDDO
 420      CONTINUE
        ENDIF

        ELSE
          CHAIN   = CP_PNUM(2:2)
          SEG_DOM(2:3) = '0 '
        ENDIF

c       Columns 73 - 76 identify specific segments of the molecule.
        IF(CHAIN.EQ.' '.OR.CHAIN.EQ.'_') THEN
          LINE(73:76) = '--'//SEG_DOM(2:3)    
        ELSE
          LINE(73:76) = CHAIN//CHAIN//SEG_DOM(2:3)       
        ENDIF
c        SEG_DOM(3:3) = ' '

 410  CONTINUE

      IF(LINE(1:4).EQ.'ANIS') GO TO 400 

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(MT)
      RETURN
C -------------
 500  CONTINUE
      CLOSE(MT)
      CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE GET_DOM_INFO_FROM_LIST_MEM(MDOC,CODE_GOM
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,ND_STRING,IDOMDOM,IDOMSEG
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX,IERR)
C ---------------------------------------
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ----------------------------------
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C -----------------------------------
      CHARACTER LINE*256,CODE_GOM*8
C ---------------------------------------
      IERR = 0
      ND_STRING = 0
      IF(NSEG_DB.LE.0) RETURN
      IFIRST = 0
      DO I=1,NSEG_DB
        IF(CODE_DOM_DB(I)(1:5).EQ.CODE_GOM(1:5)) THEN
          IFIRST = 1
          ND_STRING = ND_STRING + 1
          IDOMDOM(ND_STRING)  = NDOM_DB(I) 
          IDOMSEG(ND_STRING)  = IDOMSEG_DB(I)
          PNUM1_DM(ND_STRING) = PNUM1_DOM_DB(I)
          PNUM2_DM(ND_STRING) = PNUM2_DOM_DB(I)
        ELSE
          IF(IFIRST.GT.0) GO TO 100
        ENDIF
      ENDDO
  100 CONTINUE
C -----------
      RETURN
      END

      SUBROUTINE UPDATE_DOMAIN_DB_BY_DOMAIN(MDOC,MODE,PRF
     *   ,ICODE_TARGET,CODE_TARGET,FILE_PDB,FILE_SEQ
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM,IUSED_DOM
     *   ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *   ,RINBYR_DOM,RSBYR_DOM
     *   ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *   ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *   ,IHIER_LEV
     *   ,ISEG_NEW,FIDENT,SCORE,FNN
     *   ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *   ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *   ,FIDENT_DM,SCORE_DM,Q_DM
     *   ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *   ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER MODE*1,PRF*1
C ---
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C ---
      CHARACTER FILE_PDB*(*),FILE_SEQ*(*)
      CHARACTER CODE_TARGET*8
      CHARACTER LINE*256
C ---
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6

      INTEGER   NRES_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   NSEG_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      REAL      RINBYR_DOM(*)
      REAL      RSBYR_DOM(*)
      CHARACTER CODE_DOM(NDOMAIN)*8
      INTEGER   IUSED_DOM(NDOMAIN)

C -----------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------
      CALL SEARCH_HOMOLOG_BY_DOMAIN(MDOC,MODE,PRF
     *   ,ICODE_TARGET,CODE_TARGET,FILE_SEQ,FILE_PDB
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM,IUSED_DOM
     *   ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *   ,RINBYR_DOM,RSBYR_DOM
     *   ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *   ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *   ,IHIER_LEV
     *   ,ISEG_NEW,FIDENT,SCORE,FNN
     *   ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *   ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *   ,FIDENT_DM,SCORE_DM,Q_DM
     *   ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *   ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C ---------------------
900   CONTINUE
      RETURN
      END

      SUBROUTINE SEARCH_HOMOLOG_BY_DOMAIN(MDOC,MODE,PRF
     *   ,ICODE_TARGET,CODE_TARGET,FILE_SEQ,FILE_PDB
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,NDOMAIN,CODE_DOM,NRES_DOM,ILEVEL_DOM,IBACK_DOM,IUSED_DOM
     *   ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *   ,RINBYR_DOM,RSBYR_DOM
     *   ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *   ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *   ,IHIER_LEV
     *   ,ISEG_NEW,FIDENT,SCORE,FNN
     *   ,ND_STRING,IDOMDOM,IDOMSEG,ND_RES
     *   ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM,NSTRMAX
     *   ,FIDENT_DM,SCORE_DM,Q_DM
     *   ,NRES_TOT,NRES_ALIGN,NRES_DOMAIN
     *   ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER MODE*1,PRF*1
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C ---
C      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C ---
      PARAMETER ( NSTRMAX3 = 100 )
      INTEGER   ND_STRING3,IDOMSEG3(NSTRMAX3),ND_RES3(NSTRMAX3)
      INTEGER   IDOMDOM3(NSTRMAX3)
      CHARACTER PNUM1_DM3(NSTRMAX3)*6,PNUM2_DM3(NSTRMAX3)*6
C ---
      PARAMETER ( NSTRMAX2 = 100 )
      INTEGER   ND_STRING2,IDOMSEG2(NSTRMAX2),ND_RES2(NSTRMAX2)
      INTEGER   IDOMDOM2(NSTRMAX2)
      CHARACTER PNUM1_DM2(NSTRMAX2)*6,PNUM2_DM2(NSTRMAX2)*6
      CHARACTER CODE_HOMOL_DM2(NSTRMAX2)*8
      REAL      FIDENT_DM2(NSTRMAX2),SCORE_DM2(NSTRMAX2)
     *         ,Q_DM2(NSTRMAX2)
C ---------------------------------
      PARAMETER ( NSEGMAXX = 100  )
      CHARACTER PNUM_START(NSEGMAXX)*7,PNUM_FIN(NSEGMAXX)*7
C ---
      CHARACTER FILE_PDB*(*),FILE_SEQ*(*),FILE_CRD*256

      CHARACTER FILE_2*256
      CHARACTER FILE_REST*256,FILE_OUT*256,FILE_SCR*256
      CHARACTER PATH_DB*256,CODE_TARGET*8,CODE_BEST*8
      CHARACTER PATH*1,EXT*1,CH2*2
      CHARACTER LINE*256
      CHARACTER DIST*1,PAIR*1
C ---
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ---
      INTEGER   NRES_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   NSEG_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      REAL      RINBYR_DOM(*)
      REAL      RSBYR_DOM(*)
      CHARACTER CODE_DOM(NDOMAIN)*8

      INTEGER   IUSED_DOM(NDOMAIN)
      integer,   allocatable :: IORDER_DOM(:)
C -----------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99     
C -----
      allocate(IORDER_DOM(1:NDOMAIN),STAT=ISTAT)
C -----
      NRUN = 0
      DO ID=1,NDOMAIN
        IORDER_DOM(ID) = 1
        IUSED_DOM(ID)  = 0
      ENDDO
      IRES_FIRST  = 1
      IRES_FINISH = 100000
C --------------

 1000 CONTINUE

      DO ID=1,NDOMAIN
        IF(IORDER_DOM(ID).LT.0) IORDER_DOM(ID) = 1

c///
c     
c        IF(MODE.EQ.'U') THEN
c        IF(NRUN.GE.1) THEN
c
c          IF(RINBYR_DOM(ID).GE.1.1.OR.RSBYR_DOM(ID).GE.1.50) THEN 
c            IORDER_DOM(ID) = 0
c          ENDIF
c
c        ELSE
c
c          NRBY3 = NRES_TOT/3
c          IF(NRES_DOM(ID).LT.NRBY3.AND.
c     *       (RINBYR_DOM(ID).GE.1.1.OR.RSBYR_DOM(ID).GE.1.50)) 
c     *    IORDER_DOM(ID) = 0
c
c        ENDIF
c        ENDIF
c///

      ENDDO

      IF(ND_STRING.GT.0) THEN

        ND_STRING3 = ND_STRING
        IMIN = 1000000
        IMAX =-1000000
        ISTR_MIN = 0
        ISTR_MAX = 0
        DO I=1,ND_STRING
          IDOMDOM3(I)  = IDOMDOM(I)
          IDOMSEG3(I)  = IDOMSEG(I)
          ND_RES3(I)   = ND_RES(I) 
          PNUM1_DM3(I) = PNUM1_DM(I)
          PNUM2_DM3(I) = PNUM2_DM(I)
          READ(PNUM2_DM3(I)(2:5),'(I4)') IF
          READ(PNUM1_DM3(I)(2:5),'(I4)') IS
          IF(IS.LT.IMIN) THEN
            IMIN = IS
            ISTR_MIN = I
          ENDIF
          IF(IF.GT.IMAX) THEN
            IMAX = IF
            ISTR_MAX = I
          ENDIF
c/
C          IDOM = IDOMSEG3(I)/100
C          ISEG = IDOMSEG3(I) - IDOM*100
C          WRITE(LINE,'(A,I5,1X,2I3,1X,A6,1X,A6)')
C     *        '--3--',IDOMDOM3(I),IDOM,ISEG
C     *       ,PNUM1_DM3(I),PNUM2_DM3(I)
C          CALL MSGDOC(MDOC,LINE)
c/

        ENDDO

        FILE_SCR = ' '
        CALL LENSTR_BL(FILE_PDB,LEN)
        IF(LEN.GT.0) THEN
          CALL REMOVE_DOMAINS_FROM_PDB(MDOC
     *           ,IRES_FIRST,IRES_FINISH
     *           ,FILE_PDB,FILE_SCR,NRES,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in REMOVE_DOMAINS_FROM_PDB'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 850
          ENDIF
        ELSE
          CALL REMOVE_DOMAINS_FROM_SEQ(M,FILE_SEQ,FILE_SCR
     *       ,NRES,NAA_MAX
     *       ,ND_STRING3,IDOMSEG3,PNUM1_DM3,PNUM2_DM3,ND_RES3,NSTRMAX3
     *       ,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in REMOVE_DOMAINS_FROM_SEQ.'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 850
          ENDIF
          IRES_FIRST  = 1
          IRES_FINISH = NAA_MAX 
        ENDIF

c       IGAP_LEN_MIN = 35
        IGAP_LEN_MIN = 10

        READ(PNUM1_DM3(ISTR_MIN)(2:5),'(I4)') IS
        IT = IS - IRES_FIRST
        IF(IT.GT.1.AND.IT.LT.IGAP_LEN_MIN) THEN
          WRITE(PNUM1_DM3(ISTR_MIN)(2:5),'(I4)') IRES_FIRST
        ENDIF
        READ(PNUM2_DM3(ISTR_MAX)(2:5),'(I4)') IF
        IT = IRES_FINISH - IF
        IF(IT.GT.1.AND.IT.LT.IGAP_LEN_MIN) THEN
          WRITE(PNUM2_DM3(ISTR_MAX)(2:5),'(I4)') IRES_FINISH
        ENDIF
          
        IF(ND_STRING3.GT.1) THEN
          DO I=2,ND_STRING3
            DO J=1,I-1
              READ(PNUM2_DM3(J)(2:5),'(I4)') IF
              READ(PNUM1_DM3(I)(2:5),'(I4)') IS
              IT = IS - IF
              IF(IT.GT.1.AND.IT.LT.IGAP_LEN_MIN) THEN
                IT = IF + 1
                WRITE(PNUM1_DM3(  I)(2:5),'(I4)') IT
              ENDIF
              READ(PNUM1_DM3(J)(2:5),'(I4)') IS
              READ(PNUM2_DM3(I)(2:5),'(I4)') IF
              IT = IS - IF
              IF(IT.GT.1.AND.IT.LT.IGAP_LEN_MIN) THEN
                IT = IS - 1
                WRITE(PNUM2_DM3(  I)(2:5),'(I4)') IT
              ENDIF
            ENDDO
          ENDDO
        ENDIF

c/
C        DO I=1,ND_STRING3
C          IDOM = IDOMSEG3(I)/100
C          ISEG = IDOMSEG3(I) - IDOM*100
C          WRITE(LINE,'(A,I5,1X,2I3,1X,A6,1X,A6)')
C     *        '==3==',IDOMDOM3(I),IDOM,ISEG
C     *       ,PNUM1_DM3(I),PNUM2_DM3(I)
C          CALL MSGDOC(MDOC,LINE)
C        ENDDO
c/

        CALL LENSTR_BL(FILE_PDB,LEN)
        IF(LEN.GT.0) THEN
C         dom_info --> pdb (SEG_ID)
          FILE_CRD = 'domains.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_CRD,LT )
          IF(LEN.GT.0) THEN
            FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
          ENDIF
C         ierr=-1    set '-' in seg_id(76:76) (domains border)
c          IERR =-1
          IERR = 0
          IERR =-1

          CALL SET_DOMAIN_INFO_TO_PDB_MEM(MDOC,FILE_PDB,FILE_CRD
     *      ,ND_STRING3,IDOMSEG3,PNUM1_DM3,PNUM2_DM3,ND_RES3,NSTRMAX3
     *      ,NDOM,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: set dom_info to PDB'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
C         remove dom_info 
          FILE_REST = 'nodomains.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_REST,LT )
          IF(LEN.GT.0) THEN
            FILE_REST = PATH_SCR(1:LEN)//FILE_REST(1:LT) 
          ENDIF
          IERR = 0
          CALL REMOVE_DOMAINS_FROM_PDB(MDOC
     *           ,IRES_FIRST,IRES_FINISH
     *           ,FILE_CRD,FILE_REST,NRES,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in REMOVE_DOMAINS_FROM_PDB'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 850
          ENDIF
        ELSE
          FILE_REST = 'nodomains.seq'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_REST,LT )
          IF(LEN.GT.0) THEN
            FILE_REST = PATH_SCR(1:LEN)//FILE_REST(1:LT) 
          ENDIF

          CALL REMOVE_DOMAINS_FROM_SEQ(M,FILE_SEQ,FILE_REST
     *       ,NRES,NAA_MAX
     *       ,ND_STRING3,IDOMSEG3,PNUM1_DM3,PNUM2_DM3,ND_RES3,NSTRMAX3
     *       ,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in REMOVE_DOMAINS_FROM_SEQ'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 850
          ENDIF
        ENDIF
      ELSE
        CALL LENSTR_BL(FILE_PDB,LEN)
        IF(LEN.GT.0) THEN
          FILE_REST = FILE_PDB
        ELSE
          FILE_REST = FILE_SEQ
        ENDIF
        NRES      = NRES_TOT
      ENDIF

      WRITE(LINE,*) 'NRES_REST:',NRES
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'NRES_DOMAIN:',NRES_DOMAIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'NRES_ALIGN:',NRES_ALIGN
      CALL MSGDOC(MDOC,LINE)

      IF(NRES.LT.25) GO TO 800

C -----
      FILE_OUT = 'temp.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_OUT,LT )
      IF(LEN.GT.0) THEN
        FILE_OUT = PATH_SCR(1:LEN)//FILE_OUT(1:LT) 
      ENDIF

C      ICODE_TARGET = 0
      QQ_DOM_LIM   = 0.0
      NRUN = NRUN + 1
      CALL SEARCH_DOMAIN_IN_DB(MDOC,MODE,PRF,ICODE_TARGET
     *       ,FILE_REST,FILE_OUT,NRES,NRUN
     *       ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *       ,IHIER_LEV
     *       ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *       ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *       ,NDOMAIN,CODE_DOM,NRES_DOM
     *       ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *       ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *       ,ILEVEL_DOM,IBACK_DOM,IORDER_DOM,IUSED_DOM
     *       ,ICODE_BEST,FIDENT_BEST,SCORE_BEST,NN_BEST
     *       ,Q_BEST,NPAIR_BEST,DRMS_BEST,N2_BEST
     *       ,PATH_SCR,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in SEARCH_DOMAIN'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

      ND_STRING2 = 0
      IF(ICODE_BEST.LE.0) THEN
        CALL MSGDOC(MDOC,'no homologous domain was found')
        GO TO 800
      ENDIF

      CODE_BEST = CODE_DOM(ICODE_BEST)
      WRITE(LINE,'(A,A,I6)') ' Code best : ',CODE_BEST,ICODE_BEST
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F5.1,1X,F6.3,1X,F6.3,1X,I5,1X,I5,1X,F6.2)') 
     * ' Ident,Score,Q,Nalign,Npair,Rms:'
     * ,FIDENT_BEST,SCORE_BEST,Q_BEST,NN_BEST,NPAIR_BEST,DRMS_BEST
      CALL MSGDOC(MDOC,LINE)

      CALL LENSTR_BL(FILE_PDB,LEN)
      IF(LEN.LE.0) THEN
      
        FILE_2 = 'pdb_DOM.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_2,LT)
        IF(LEN.GT.0) THEN
          FILE_2 = PATH_SCR(1:LEN)//FILE_2(1:LT) 
        ENDIF
        FILE_SCR = ' '
        CALL CREATE_DOM_SEQ_AND_PDB(MDOC
     *       ,CODE_BEST,FILE_SCR,FILE_2
     *       ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: in CREATE_DOM_SEQ_FROM_PDB'
          CALL MSGERR(MDOC,LINE)
          GO TO 800
        ENDIF

        PO = 0.0
        PE = 0.0
        PAIR = 'N'         
        DIST = 'W'

        IPRINT = 0

        CALL MAKE_ALIGN5D(M,IPRINT,FILE_REST,FILE_2,FILE_OUT
     *                   ,PAIR,DIST,PO,PE
     *                   ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in MAKE_ALIGN'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 800
        ENDIF

      ENDIF

      NR   = 0
c     get dom info
      ND_STRING2  = 0
      NDOM_FINAL  = 0
      NSEG_FINAL  = 0
      NSEG_TOT    = 0
      LEN_LIM     = 5
      FILE_SCR    = ' '
      CH2 = CODE_DOM(ICODE_BEST)(6:7)
      IF(CH2(1:1).EQ.'_') CH2(1:1) = ' '
      READ(CH2,'(I2)') IDOM

      CALL GET_DOMAIN_PDB(Mdoc,FILE_OUT,FILE_SCR
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAXX
     *  ,IDOM,NRES,NATOM,IERR)
      IF(IERR.NE.0.OR.NATOM.LE.0.OR.NRES.LT.5.OR.NSEG.LE.0) THEN
         IERR = 0
        GO TO 700
      ENDIF

      IF(NRES.LT.25) GO TO 700

      ISP = 0
      DO ISS=1,NSEG
        READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
        READ(PNUM_FIN  (ISS)(3:6),'(I4)') IS_F
        ISD = IS_F - IS_S
        IF(ISD.GT.LEN_LIM) THEN
          ISP = ISP + 1
          PNUM_START(ISP) = PNUM_START(ISS)
          PNUM_FIN  (ISP) = PNUM_FIN  (ISS)
        ENDIF
      ENDDO  
      NSEG = ISP
      IF(NSEG.LE.0) GO TO 700

      NR = NR + NRES 

      IF(NSEG.GT.1) THEN
 
        ISP = 1
        DO ISS=2,NSEG
          READ(PNUM_START(ISP)(3:6),'(I4)') ISP_S
          READ(PNUM_FIN(ISP)(3:6),'(I4)') ISP_F
          READ(PNUM_START(ISS)(3:6),'(I4)') IS_S
          READ(PNUM_FIN(ISS)(3:6),'(I4)') IS_F

          ISD = IS_S - ISP_F
          IF(ISD.LE.LEN_LIM) THEN
            PNUM_FIN(ISP) = PNUM_FIN(ISS)
          ELSE
            ISP = ISP + 1
            PNUM_START(ISP) = PNUM_START(ISS)
            PNUM_FIN(ISP)   = PNUM_FIN(ISS)
          ENDIF
        ENDDO  
        NSEG = ISP

      ENDIF

      NDOM_FINAL = NDOM_FINAL + 1
      DO ISEG=1,NSEG
        NSEG_TOT   = NSEG_TOT + 1
        IDOMDOM2(NSEG_TOT)  = NDOM_FINAL
        IDOMSEG2(NSEG_TOT)  = ISEG
        PNUM1_DM2(NSEG_TOT) = PNUM_START(ISEG)(2:7)  
        PNUM2_DM2(NSEG_TOT) = PNUM_FIN(ISEG)(2:7)
        IF(PNUM1_DM2(NSEG_TOT)(6:6).EQ.' ') 
     *  PNUM1_DM2(NSEG_TOT)(6:6) = '-'
        IF(PNUM2_DM2(NSEG_TOT)(6:6).EQ.' ') 
     *  PNUM2_DM2(NSEG_TOT)(6:6) = '-'
        PNUM1_DM2(NSEG_TOT)(1:1) = CODE_TARGET(5:5)
        PNUM2_DM2(NSEG_TOT)(1:1) = CODE_TARGET(5:5)
        CODE_HOMOL_DM2(NSEG_TOT) = CODE_BEST
        FIDENT_DM2(NSEG_TOT) = FIDENT_BEST
        SCORE_DM2 (NSEG_TOT) = SCORE_BEST
        Q_DM2     (NSEG_TOT) = Q_BEST
      ENDDO  

 700  CONTINUE
    
      IF(NDOM_FINAL.GT.0) THEN
        ISEG_NEW = 2
        ND_STRING2 = NSEG_TOT
        DO ISEG=1,NSEG_TOT
          IDOMSEG2(ISEG) = IDOMDOM2(ISEG)*100 + IDOMSEG2(ISEG)
          IDOMDOM2(ISEG) = NDOM_FINAL 
        ENDDO

      ENDIF

      IF(ND_STRING2.GT.0) THEN
        DO I=1,ND_STRING2
          IDOM = IDOMSEG2(I)/100
          ISEG = IDOMSEG2(I) - IDOM*100
          WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6,2X,A)')
     *      IDOMDOM2(I),CODE_TARGET(1:5),IDOM,ISEG
     *     ,PNUM1_DM2(I),PNUM2_DM2(I),CODE_HOMOL_DM2(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ENDIF

      IF(ND_STRING2.LE.0) GO TO 800

      IF(ND_STRING.LE.0) THEN
        ND_STRING = ND_STRING2
        DO I=1,ND_STRING2
          IDOMSEG(I)  = IDOMSEG2(I)
          ND_RES(I)   = 0
          IDOMDOM(I)  = IDOMDOM2(I)
          PNUM1_DM(I) = PNUM1_DM2(I)
          PNUM2_DM(I) = PNUM2_DM2(I)
          CODE_HOMOL_DM(I) = CODE_HOMOL_DM2(I)
          FIDENT_DM(I) = FIDENT_DM2(I)
          SCORE_DM (I) = SCORE_DM2(I)
          Q_DM     (I) = Q_DM2(I)
        ENDDO
      ELSE
        NDOM_FINAL = IDOMDOM(1) + IDOMDOM2(1)
        NDOM_OLD   = IDOMDOM(1)
        DO I=1,ND_STRING
          IDOMDOM(I)  = NDOM_FINAL
        ENDDO
        II = ND_STRING
        DO I=1,ND_STRING2
          II = II + 1
          IDOMDOM(II)  = NDOM_FINAL
          IDOM = IDOMSEG2(I)/100
          ISEG = IDOMSEG2(I) - IDOM*100
          IDOMSEG(II) = (IDOM + NDOM_OLD)*100 + ISEG
          PNUM1_DM(II) = PNUM1_DM2(I)
          PNUM2_DM(II) = PNUM2_DM2(I)
          CODE_HOMOL_DM(II) = CODE_HOMOL_DM2(I)
          FIDENT_DM(II) = FIDENT_DM2(I)
          SCORE_DM (II) = SCORE_DM2(I)
          Q_DM     (II) = Q_DM2(I)
        ENDDO
        ND_STRING = ND_STRING + ND_STRING2
      ENDIF

      NRES_DOMAIN = NRES_DOMAIN + NR
      NRES_ALIGN  = NRES_ALIGN  + NN_BEST

      GO TO 1000

C -----
800   CONTINUE

      IF(ND_STRING.GT.0) THEN
        DO I=1,ND_STRING
          IDOM = IDOMSEG(I)/100
          ISEG = IDOMSEG(I) - IDOM*100
          IF(PNUM1_DM(I)(6:6).EQ.' ') PNUM1_DM(I)(6:6) = '-'
          IF(PNUM2_DM(I)(6:6).EQ.' ') PNUM2_DM(I)(6:6) = '-'
          WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6,2X,A)')
     *      IDOMDOM(I),CODE_TARGET(1:5),IDOM,ISEG
     *     ,PNUM1_DM(I),PNUM2_DM(I),CODE_HOMOL_DM(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ENDIF

850   CONTINUE
      
C      nnn = 0
C      do iii=1,ndomain
C        if(ILEVEL_DOM(iii).gt.0) then
C          nnn = nnn + 1
C          write(*,*) nnn,iii,' ',code_dom(iii),NRES_DOM(iii)
C        endif
C      enddo

CC     deallocation

      deallocate(IORDER_DOM,STAT=ISTAT)
C ---------------------
900   CONTINUE
      RETURN
      END

      SUBROUTINE REMOVE_DOMAINS_FROM_SEQ(MDOC,NAME_IN,NAMEO
     *       ,NRES,NAA_MAX
     *       ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *       ,IERR)
C --------------------------------------------------------
      CHARACTER CODE*4
C      INTEGER NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
C      INTEGER ISS(NMAX),ISSN(NMAX),ISURF(NMAX)
C      CHARACTER PNUM(NMAX)*6

      integer,   allocatable :: NSEQ(:)
      integer,   allocatable :: IRES(:)
      integer,   allocatable :: ISURF(:)
      integer,   allocatable :: ICHAIN(:)
      integer,   allocatable :: IDOMAIN(:)
      integer,   allocatable :: ISS(:)
      integer,   allocatable :: ISSN(:)
      character(LEN=6), allocatable :: PNUM(:)


C ---
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---
      CHARACTER PN1*6,PN2*6,PN*6,CHAIN_DOM*1

C  
C READ_FASTA_SEQ   read sequence which can be used for ALIGN.
C 
C      File with sequence is ASCII file:
C
C      !>prot_id
C      !# sequence 
C      !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C      !# this is comment
C      !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C      !NRGTRITKEVFDNLTNWKNSAQ
C
C      If first symbol in the line is "#" it means the line is comments
C
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAMEO*(*)
      CHARACTER SS_FLAG*1,D3_FLAG*1 
c ----
      CHARACTER NAME*256,PATH*80,EXT*80,STR*256
      CHARACTER LINE*2048,LINE_SS*2048,LINE_SR*2048
      CHARACTER LINE1*2048,LINE2*2048
      CHARACTER STR_IN*2048,TITLE*256
      CHARACTER DB_FLAG*1,SS*1,SS_OLD*1,CHAIN*1
C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1,AANAME*1,SURF*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      ITEST   = 1
      NAA_MAX = 100
1000  CONTINUE

      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      allocate(NSEQ(1:NAA_MAX),STAT=ISTAT)
      allocate(IRES(1:NAA_MAX),STAT=ISTAT)
      allocate(ISURF(1:NAA_MAX),STAT=ISTAT)
      allocate(ICHAIN(1:NAA_MAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NAA_MAX),STAT=ISTAT)
      allocate(ISS(1:NAA_MAX),STAT=ISTAT)
      allocate(ISSN(1:NAA_MAX),STAT=ISTAT)
      allocate(PNUM(1:NAA_MAX),STAT=ISTAT)


      NRES  = 0
      DB_FLAG = 'N'
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) STR_IN
        CALL LENSTR_BL(STR_IN,LENS)
        IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SS:') THEN
          DB_FLAG = 'Y'
          GO TO 800
        ELSE IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SR:') THEN
          DB_FLAG = 'y'
          GO TO 800
        ENDIF
      ENDDO
 800  CONTINUE
      CLOSE(IU)
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C --------------------------------
      ICH= 0
      IC = 0
      NC =-1
      N  = 0 
      NR = 0 
      NRES = 0
      NBAD = 0
      NX   = 0
      CODE = 'XXXX'
      CHAIN= 'A'
      IEND = 0
      LINE_SS = ' '
      LINE_SR = ' '
      SS_OLD  = ' '
      NSS     = 0
C ----------------
 400  CONTINUE

      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          TITLE = LINE
          ICH = ICH + 1
          NR  = 0
          IF(ICH.EQ.1) THEN
            CODE = '?   '
            CHAIN = 'A'
            IF(LEN.GT.1) THEN
              DO L=2,LEN
                CODE(L-1:L-1) = LINE(L:L)
                IF(L.EQ.5) CHAIN = LINE(L:L)
                IF(L.GE.5) GO TO 400
              ENDDO
            ENDIF
          ENDIF
          GO TO 400
        ENDIF        
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
        IF(DB_FLAG.EQ.'Y') THEN
          LINE_SS = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SS
          LINE_SR = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SR
          IC = 5
        ENDIF
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
      ENDIF

      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
C      IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.25) THEN
        N  = N  + 1
        IF(ITEST.LE.0) THEN
          IF(N.GT.NAA_MAX) THEN
            WRITE(STR,'('' ERR: NUMBER OF RESIDUES >'',I8)') NAA_MAX
            CALL MSGDOC(MDOC,STR) 
            IERR=1
            CLOSE(IU)
            RETURN
          ENDIF
          IF(J.LT.21) NRES = NRES + 1
          NR = NR + 1
          NSEQ(N) = J
          IRES(N) = NR
          PNUM(N)(1:1) = CHAIN
          WRITE(PNUM(N)(2:5),'(I4)') NR
          PNUM(N)(6:6) = ' '
          IF(J.GE.24) IRES(N) = 0
          IF(ICH.LE.0) ICH = 1
          ICHAIN(N)  = ICH
          ISURF(N)   = 0
          ISSN(N)    = 0
          ISS (N)    = 0
          IDOMAIN(N) = 0
          IF(J.EQ.21) THEN
            NX = NX + 1
          ENDIF
        ENDIF
      ELSE
        NBAD = NBAD + 1
        WRITE(STR,
     *  '('' WARNING: bad residue <'',A,''>'')') CH1
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(DB_FLAG.EQ.'Y') THEN
        IF(J.GE.1.AND.J.LE.25) THEN
          SS  = LINE_SS(IC:IC) 
          CH1 = LINE_SR(IC:IC)
          READ(CH1,'(I1)') ISURF_N
          IF(SS.NE.' '.AND.SS.NE.SS_OLD) NSS = NSS + 1
          IF(SS.NE.' ') THEN 
            ISSN_N = NSS
            ISS_N = 0
            IF(SS.EQ.'H') THEN
              ISS_N = 1
            ELSE IF(SS.EQ.'h') THEN
              ISS_N = 2
            ELSE IF(SS.EQ.'B') THEN
              ISS_N = 3
            ELSE IF(SS.EQ.'b') THEN
              ISS_N = 4
            ENDIF
          ELSE
            ISS_N  = 0
            ISSN_N = 0
          ENDIF
          IF(ITEST.LE.0) THEN
            ISURF(N) = ISURF_N
            ISSN(N)  = ISSN_N
            ISS (N)  = ISS_N
          ENDIF
          SS_OLD = SS
        ENDIF
      ENDIF
      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)

      WRITE(LINE,'('' Number of residues     :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of bad residues :'',I8)') NBAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of X residues   :'',I8)') NX
      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      IF(ITEST.GT.0) THEN
        NAA_MAX = N
        ITEST   = 0

        deallocate(NSEQ,STAT=ISTAT)
        deallocate(IRES,STAT=ISTAT)
        deallocate(ISURF,STAT=ISTAT)
        deallocate(ICHAIN,STAT=ISTAT)
        deallocate(IDOMAIN,STAT=ISTAT)
        deallocate(ISS,STAT=ISTAT)
        deallocate(ISSN,STAT=ISTAT)
        deallocate(PNUM,STAT=ISTAT)

        GO TO 1000

      ENDIF

C     set domain      
      IF(ND_STRING.GT.0) THEN
        DO I=1,ND_STRING
          IDOM = IDOMSEG(I)/100
          ISEG = IDOMSEG(I) - IDOM*100
          WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6)')
     *      I,'   ',IDOM,ISEG
     *     ,PNUM1_DM(I),PNUM2_DM(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ENDIF

      NDOM = 0
      ISTART  = 0
      IFINISH = 0
      IF(ND_STRING.GT.0) THEN
        DO IR=1,N
          READ(PNUM(IR)(2:5),'(I4)') IRESN
          DO IS=1,ND_STRING
            IDOM = IDOMSEG(IS)/100
            ISEG = IDOMSEG(IS) - IDOM*100
            PN1  = PNUM1_DM(IS) 
            PN2  = PNUM2_DM(IS) 
            READ(PN1(2:5),'(I4)') IRES1
            READ(PN2(2:5),'(I4)') IRES2
            IF(IRESN.GE.IRES1.AND.IRESN.LE.IRES2) THEN
              IDOMAIN(IR) = IDOM
              IF(ISTART.LE.0) ISTART = IR
              IFINISH = IR
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C     write
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGDOC(MDOC,' WARNING: no output file name')
        IERR = 0
        RETURN
      ENDIF
      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) THEN
        TITLE = '>XXXX A'
        CALL LENSTR_BL(TITLE,LEN)
      ENDIF
      WRITE(IOUT,'(A)',ERR=910) TITLE(1:LEN)

      NAA   = 0
      NRES  = 0
      II    = 0
      IF(DB_FLAG.EQ.'Y') II = 4
      IAA   = 0
      LINE  = '    '
      LINE1 = '#SS:'
      LINE2 = '#SR:'

      DO IPR=1,N
C     DO IPR=1,IFINISH

        IF(DB_FLAG.EQ.'Y') THEN
          IF(ISS(IPR).EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS(IPR).EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS(IPR).EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS(IPR).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          SURF = ' '
          IF(ISURF(IPR).GT.0) THEN
            WRITE(SURF,'(I1)') ISURF(IPR)
          ENDIF
        ENDIF

        N1     = NSEQ(IPR)
        IF(N1.GT.25) N1 = 25
        AANAME = AMIN(N1)
        IF(IDOMAIN(IPR).GT.0) THEN
          N1 = 21
        ENDIF
        AANAME = AMIN(N1)
        IF(N1.GE.24) THEN
          SS   = ' '
          SURF = ' '
        ENDIF

        NAA = NAA +1
        IF(N1.LT.21) NRES = NRES + 1
        II  = II  +1
        IAA = IAA +1
        LINE(II:II)  = AANAME
        IF(DB_FLAG.EQ.'Y') THEN
          LINE1(II:II) = SS
          LINE2(II:II) = SURF
        ENDIF

        IF(IAA.EQ.50) THEN
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
          IF(DB_FLAG.EQ.'Y') THEN
            WRITE(IOUT,'(A)',ERR=910) LINE1(1:LEN)
            WRITE(IOUT,'(A)',ERR=910) LINE2(1:LEN)
          ENDIF
          II   = 0
          IF(DB_FLAG.EQ.'Y') II = 4
          IAA  = 0
          LINE  = '    '
          LINE1 = '#SS:'
          LINE2 = '#SR:'
        ENDIF
 
      ENDDO

      IF(IAA.GT.0) THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
        IF(DB_FLAG.EQ.'Y') THEN
          WRITE(IOUT,'(A)',ERR=910) LINE1(1:LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE2(1:LEN)
        ENDIF
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)

      WRITE(LINE,'('' Number of residues to write :'',I8)') NRES
      CALL MSGDOC(MDOC,LINE)

      IF(NRES.LE.0) THEN
        CALL MSGDOC(MDOC,' Number of residues in sequence = 0')
        IERR = 0
      ENDIF

 900  CONTINUE

      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(ISURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(ISSN,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file sequence'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      GO TO 900
 910  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write sequence')
      IERR = 1
      CLOSE(IOUT)
      GO TO 900
      END

      SUBROUTINE REMOVE_DOMAINS_FROM_PDB(MDOC
     *             ,IRES_FIRST,IRES_FINISH
     *             ,FILE_CRD,FILE_REST,NRES,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_CRD*(*),FILE_REST*(*)
      CHARACTER PATH*1,EXT*1
      CHARACTER CP_PNUM_OLD*7,CP_PNUM*7
      CHARACTER SEG_DOM*4,CHAIN*1,RNAME*3
      CHARACTER LINE*256
      CHARACTER ACODE3(25)*3
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
     *           ,'---'/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
c      SEG_OLD  = '?'
      IDOM_OLD = 0
      NRES     = 0
      IFIRST   = 0
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open input crd file')
        IERR = 1
        RETURN
      ENDIF
C ---
      IOUT = 0
      CALL CORR_NAME_BLC(FILE_REST)
      CALL LENSTR_BL(FILE_REST,LEN)
      IF(LEN.GT.0) THEN
        EXT  = ' '
        PATH = ' '
        IOUT = 11
        CALL OPENFW(IOUT,M,PATH,FILE_REST,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MD,
     *         ' ERROR: cannot open output crd file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
        GO TO 400
      ENDIF

      CP_PNUM = LINE(21:27)
      SEG_DOM = LINE(73:76)
      CHAIN   = CP_PNUM(2:2)
      RNAME   = LINE(18:20)
      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
      DO  J=1,20
        IF(RNAME.EQ.ACODE3(J)) THEN
          READ(CP_PNUM(3:6),'(I4)') IRES_FINISH 
          IF(IFIRST.LE.0) IRES_FIRST = IRES_FINISH
          IFIRST = 1
          GO TO 700
        ENDIF
      ENDDO
      J = 21
  700 CONTINUE

      IF(SEG_DOM(3:3).EQ.'-'.OR.SEG_DOM(3:3).EQ.'_'.OR.
     *   SEG_DOM(3:3).EQ.' '                           ) THEN
        IDOM = 0
      ELSE
        IDOM = 1
      ENDIF

      IF(IDOM.LE.0) THEN
        SEG_DOM(4:4) = ' '
        IF(IDOM.NE.IDOM_OLD.AND.IDOM_OLD.GT.0) SEG_DOM(4:4) = '-'
        IF(CP_PNUM_OLD(3:6).NE.CP_PNUM(3:6)) THEN
          IF(J.LE.20) NRES = NRES + 1
        ENDIF
c       Columns 73 - 76 identify specific segments of the molecule.
        IF(CHAIN.EQ.' '.OR.CHAIN.EQ.'_') THEN
          LINE(73:76) = '--'//SEG_DOM(3:4)    
        ELSE
          LINE(73:76) = CHAIN//CHAIN//SEG_DOM(3:4)       
        ENDIF

        CALL LENSTR_BL(LINE,LEN)
        IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)

      ENDIF
      IDOM_OLD    = IDOM
      CP_PNUM_OLD = CP_PNUM
      GO TO 400
C --------------
 600  CONTINUE
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      CLOSE(MT)
      RETURN
C -------------
 500  CONTINUE
      CALL MSGDOC(MD,
     *       ' ERROR: reading input crd file')
      CLOSE(MT)
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      CALL MSGDOC(MD,
     *       ' ERROR: writting output crd file')
      IF(IOUT.GT.0) CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE SEARCH_DOMAIN_IN_DB(MDOC,MODE,PRF,ICODE_TARGET
     *       ,FILE_REST,FILE_OUT,NRES,NRUN
     *       ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *       ,IHIER_LEV
     *       ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *       ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *       ,NDOMAIN,CODE_DOM,NRES_DOM
     *       ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *       ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *       ,ILEVEL_DOM,IBACK_DOM,IORDER_DOM,IUSED_DOM
     *       ,ICODE_BEST,FIDENT_BEST,SCORE_BEST,NN_BEST
     *       ,Q_BEST,NPAIR_BEST,DRMS_BEST,N2_BEST
     *       ,PATH_SCR,IERR)
C -------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
C ---
      INTEGER   MDOC,IERR
      CHARACTER MODE*1,PRF*1
      CHARACTER PATH_SCR*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER FILE_REST*(*),FILE_OUT*(*)
      INTEGER   NRES_DOM(NDOMAIN)
      INTEGER   ILEVEL_DOM(NDOMAIN)
      INTEGER   IBACK_DOM(NDOMAIN)
      INTEGER   ITYPE_DOM(NDOMAIN)
      INTEGER   NSEG_DOM(NDOMAIN)
      INTEGER   ICLASS_DOM(NDOMAIN)
      CHARACTER CODE_DOM(NDOMAIN)*8
      INTEGER   IORDER_DOM(NDOMAIN)
      INTEGER   IUSED_DOM(NDOMAIN)
      CHARACTER PATH_DB*256,PATH_OUT*256
      CHARACTER FILE_1*256,FILE_SCR*256,FILE_SEQ*256
      CHARACTER DIR_FOR_SEQ*256,DIR_FOR_PDB*256

      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6

      CHARACTER CODE*8,CODE_BEST*8,DOM*1
      CHARACTER LINE*256
      CHARACTER CHAIN_INP*1,HOME*1
      CHARACTER CODE_PDB*4,DATE_PDB*9
      REAL      CELL(6)
C ---
      integer,   allocatable :: ICODE_STOR(:)
      integer,   allocatable :: N2_STOR(:)
      integer,   allocatable :: NN_STOR(:)
      integer,   allocatable :: NPAIR_STOR(:)
      integer,   allocatable :: NGAP_STOR(:)
      integer,   allocatable :: INDEX_STOR(:)
      real,      allocatable :: HID_STOR(:)
      real,      allocatable :: SCORE_NEW_STOR(:)
      real,      allocatable :: Q_FIN_STOR(:)
      real,      allocatable :: Q_STOR(:)
      real,      allocatable :: DRMS_STOR(:)
C ----
      logical ex
      integer nfile
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      ICODE_BEST = 0
C ----
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) THEN
        LINE = 'ERR: setenv MOLREP_DB'      
        CALL MSGERR(MD,LINE)
        LINE = '     Example: "setenv MOLREP_DB ~alexei/molrep_DB"'      
        CALL MSGERR(MD,LINE)
        RETURN
      ENDIF

      HOME = 'N'
      CALL LENSTR_BL(PATH_DB,LEN)
      FILE_SCR = PATH_DB(1:LEN)//'/home/home_info.txt'
      CALL LENSTR_BL(FILE_SCR,LEN)
      inquire(file=FILE_SCR(1:LEN),exist=ex,number=nfile)
      IF(ex) THEN
        HOME = 'D'
      ENDIF

      CALL LENSTR_BL(PATH_DB,LEN)
      DIR_FOR_SEQ = PATH_DB(1:LEN)//'/seq_DOM/'
      LENCODE = 7

      allocate(ICODE_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(N2_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(NN_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(NPAIR_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(NGAP_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(HID_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(SCORE_NEW_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(Q_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(Q_FIN_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(DRMS_STOR(1:NDOMAIN),STAT=ISTAT)
      allocate(INDEX_STOR(1:NDOMAIN),STAT=ISTAT)
      
      CALL LENSTR_BL(FILE_REST,LEN)
      IF(FILE_REST(LEN-3:LEN).EQ.'.seq'.OR.
     *   FILE_REST(LEN-3:LEN).EQ.'.pir'    ) THEN
        FILE_SEQ = FILE_REST
      ELSE
        FILE_SEQ = 'rest.seq'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ = PATH_SCR(1:LEN)//'rest.seq'
        ENDIF

        CODE = 'XXXXA   '
        CALL PREPARE_SEQUENCE_WITH_SURF_SS(M,CODE,NAA
     *   ,FILE_REST,FILE_SEQ,PATH_SCR,IERR)

C        CHAIN_INP = ' '
C        CALL PDB2SEQ(M,FILE_REST,FILE_SEQ
C     *   ,CODE_PDB,DATE_PDB
C     *   ,RESOL,RFAC,IMODEL,CELL,CHAIN_INP
C     *   ,RESULT,IPRROW,IERR)
C        NAA = RESULT(3)

        IF(IERR.NE.0) GO TO 900
        IF(NAA.LT.25) GO TO 900
      ENDIF

      PATH_OUT   = ' '

      NRES_MAX   = NRES*1.25
      NRES_MIN   = NRES/4
      IF(NRES_MIN.GT.90) NRES_MIN   = 90
      IF(NRES_MIN.LT.25.AND.NRES.GE.25) NRES_MIN   = 25

c      NRES_MAX   = 10000
c      NRES_MIN   = 30
c      IF(NRES.GT.70) NRES_MIN = 50

      DOM        = 'D'
      ICODE_BEST = 0

C      IF(MODE.EQ.'U') THEN
C        CALL SEARCH_CHAIN_IN_DB_FOR_UPDATE(MDOC,MODE,DOM
C     *     ,ICODE_TARGET
C     *     ,FILE_SEQ,FILE_OUT
C     *     ,LENCODE,NRES,DIR_FOR_SEQ
C     *     ,NDOMAIN
C     *     ,CODE_DOM,NRES_DOM,IBACK_DOM,ILEVEL_DOM,NDOMAIN
C     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
C     *     ,FIDENT_DOM_LIM,SCORE_DOM_LIM,NRES_MAX,NRES_MIN
C     *     ,IHIER_LEV
C     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
C     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
C     *     ,IORDER_DOM
C     *     ,NDOM_TOT
C     *     ,PATH_SCR,PATH_OUT,IERR)
C      ELSE

c     *     ,FILE_SEQ,FILE_OUT

c        CALL SEARCH_CHAIN_IN_DB(MDOC,MODE,DOM,HOME,PATH_DB
c        CALL SEARCH_CHAIN_IN_DB_PRF(MDOC,MODE,DOM,HOME,PATH_DB
c        CALL SEARCH_CHAIN_IN_DB(MDOC,MODE,DOM,HOME,PATH_DB

      IF(PRF.EQ.'Y') THEN
        CALL SEARCH_CHAIN_IN_DB_PRF(MDOC,MODE,DOM,HOME,PATH_DB
     *     ,ICODE_TARGET
     *     ,FILE_REST,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NDOMAIN
     *     ,CODE_DOM,NRES_DOM,IBACK_DOM,ILEVEL_DOM,NDOMAIN
     *     ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM
     *     ,NRES_MAX,NRES_MIN,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,IORDER_DOM,IUSED_DOM
     *     ,NDOM_TOT,NRUN
     *     ,PATH_SCR,PATH_OUT,IERR)
      ELSE
        CALL SEARCH_CHAIN_IN_DB(MDOC,MODE,DOM,HOME,PATH_DB
     *     ,ICODE_TARGET
     *     ,FILE_REST,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NDOMAIN
     *     ,CODE_DOM,NRES_DOM,IBACK_DOM,ILEVEL_DOM,NDOMAIN
     *     ,ITYPE_DOM,ICLASS_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM
     *     ,NRES_MAX,NRES_MIN,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,IORDER_DOM,IUSED_DOM
     *     ,NDOM_TOT,NRUN
     *     ,PATH_SCR,PATH_OUT,IERR)
      ENDIF
      IF(IERR.NE.0) GO TO 900

      IF(NDOM_TOT.LE.0) GO TO 900

      IF(MODE.EQ.'S') THEN
        IF(Q_DOM_LIM.GT.Q_STOR(NDOM_TOT)) THEN
          GO TO 900
        ENDIF
      ENDIF

      IDD         = INDEX_STOR(NDOM_TOT)
      ICODE_BEST  = ICODE_STOR(IDD)
      CODE_BEST   = CODE_DOM(ICODE_GOM)
      FIDENT_BEST = HID_STOR(IDD)
      SCORE_BEST  = SCORE_NEW_STOR(IDD)
      Q_BEST      = Q_STOR(NDOM_TOT)
      DRMS_BEST   = DRMS_STOR(IDD)
      NN_BEST     = NN_STOR(IDD)
      N2_BEST     = N2_STOR(IDD)
      NPAIR_BEST  = NPAIR_STOR(IDD)

      CALL LENSTR_BL(FILE_REST,LEN)
      IF(FILE_REST(LEN-3:LEN).NE.'.seq'.AND.
     *   FILE_REST(LEN-3:LEN).NE.'.pir'     ) THEN
        DIR_FOR_PDB = ' '
C       chain - DIR_FOR_PDB(../pdb_DB/)  ; DOM - DIR_FOR_PDB(' ')
C       NDOM_TOT input in _STOR ; NDOM_FINAL output in _STOR

        LINE = ' -- check by rms --'
        CALL MSGDOC(MDOC,LINE)
        QQ_DOM_LIM = 0.0
        CALL CHECK_SEARCH_BY_RMS(MDOC,DOM,HOME
     *     ,FILE_REST,FILE_OUT,DIR_FOR_PDB
     *     ,CODE_DOM,NDOMAIN
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,NDOM_TOT
     *     ,FIDENT_DOM_LIM,SCORE_DOM_LIM,Q_DOM_LIM,RMS_DOM_LIM
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,NDOM_FINAL
     *     ,ICODE_BEST,FIDENT_BEST,SCORE_BEST,Q_BEST,DRMS_BEST
     *     ,N2_BEST,NN_BEST,NPAIR_BEST
     *     ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,
     *   'ERROR: in CHECK_SEARCH_BY_RMS')
          GO TO 900
        ENDIF
        
      ELSE
      ENDIF
C ----
  900 CONTINUE

      deallocate(ICODE_STOR,STAT=ISTAT)
      deallocate(N2_STOR,STAT=ISTAT)
      deallocate(NN_STOR,STAT=ISTAT)
      deallocate(NPAIR_STOR,STAT=ISTAT)
      deallocate(NGAP_STOR,STAT=ISTAT)
      deallocate(HID_STOR,STAT=ISTAT)
      deallocate(SCORE_NEW_STOR,STAT=ISTAT)
      deallocate(Q_FIN_STOR,STAT=ISTAT)
      deallocate(Q_STOR,STAT=ISTAT)
      deallocate(DRMS_STOR,STAT=ISTAT)
      deallocate(INDEX_STOR,STAT=ISTAT)

      RETURN
      END

      SUBROUTINE SEARCH_CHAIN_IN_DB(MDOC,MODE,DOM,HOME,PATH_DB
     *     ,ICODE_TARGET
     *     ,FILE_SEQ,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NSEQ
     *     ,CODE_DB,NRES_DB,IBACK_DB,ILEVEL_DB,NSEQMAX
     *     ,ITYPE_DOM,ICLASS_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_LIM_INPUT,SCORE_LIM_INPUT,Q_LIM_INPUT
     *     ,NRES_MAX_INPUT,NRES_MIN_INPUT,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,IORDER_DB,IUSED_DOM
     *     ,NCH_TOT,NRUN
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C --
      INTEGER   NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),NRES_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8
      INTEGER   ITYPE_DOM(NSEQMAX)
      INTEGER   ICLASS_DOM(NSEQMAX)
C --
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_SEQ*(*),FILE_OUT*(*)
      CHARACTER DIR_FOR_SEQ*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER LINE*256
      CHARACTER FILE_SCR*256,FILE_1*256,FILE_SEQ_TEMP*256
      CHARACTER CODE_GOM*8,CODE*8,DOM*1,MODE*1,HOME*1,PATH_DB*256
      CHARACTER PATH*1,EXT*1,CODE8*8
      CHARACTER DIST*1,PAIR*1
C --
      INTEGER   ICODE_STOR(NSEQMAX),N2_STOR(NSEQMAX),NN_STOR(NSEQMAX)
      INTEGER   NPAIR_STOR(NSEQMAX),INDEX_STOR(NSEQMAX)
      INTEGER   IORDER_DB(NSEQMAX),NGAP_STOR(NSEQMAX)
      INTEGER   IUSED_DOM(*)
      REAL      HID_STOR(NSEQMAX),SCORE_NEW_STOR(NSEQMAX)
      REAL      Q_STOR(NSEQMAX),Q_FIN_STOR(NSEQMAX),DRMS_STOR(NSEQMAX)
C ----
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---

      Icheck =-1

      PO = 0.0
      PE = 0.0
      PAIR = 'N'         
      DIST = 'N'
      ISTEP     = 0
      NSTEP     = 2
      NSTEP     = 1
      ICRD_FLAG = 0

      FILE_SEQ_TEMP = FILE_SEQ
      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(FILE_SEQ(LEN-3:LEN).EQ.'.seq'.OR.
     *   FILE_SEQ(LEN-3:LEN).EQ.'.pir'    ) THEN
        FILE_SEQ_TEMP = 'sequence_for_align.sqb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ_TEMP = PATH_SCR(1:LEN)//'sequence_for_align.sqb' 
        ENDIF
        CODE8 = 'XXXX    '
        CALL PREPARE_BIN_FILE_FROM_SEQ(M,CODE8
     *           ,FILE_SEQ,FILE_SEQ_TEMP
     *           ,PATH_OUT,PATH_SCR,IERR)
        IF(IERR.NE.0) THEN
            LINE = 'ERR: in PREPARE_BIN_FILE_FROM_SEQ'
            CALL MSGERR(MDOC,LINE)
          IERR = 0
          FILE_SEQ_TEMP = FILE_SEQ
        ENDIF  
      ELSE IF(FILE_SEQ(LEN-3:LEN).EQ.'.pdb') THEN
        ICRD_FLAG = 1
        FILE_SEQ_TEMP = 'sequence_for_align.dat'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ_TEMP = PATH_SCR(1:LEN)//'sequence_for_align.dat' 
        ENDIF
        CODE8 = 'XXXX    '
        CALL PREPARE_BIN_FILE_FROM_PDB(M,CODE8
     *           ,FILE_SEQ,FILE_SEQ_TEMP
     *           ,PATH_OUT,PATH_SCR,IERR)
        IF(IERR.NE.0) THEN
            LINE = 'ERR: in PREPARE_BIN_FILE_FROM_PDB'
            CALL MSGERR(MDOC,LINE)
          IERR = 0
          FILE_SEQ_TEMP = FILE_SEQ
        ENDIF  
      ENDIF  
      N2_MAX  = 0
      NN_MAX  = 0

  800 CONTINUE
      ISTEP = ISTEP + 1

      DRMS_LIM  = 10.0
      Q_BEST    = 0.0
      NCH_TOT   = 0
      NCH_1     = 0
      NCH_1_BAD = 0
      NLEV      = 0
      NORD      = 0
      NSIZE_BAD = 0
      NALIGN_BAD = 0
      N2_MAX     = 0

      WRITE(LINE,'(A,I4,A,I4,A)') '--- step :',ISTEP,'  (',NSTEP,' )'
      CALL MSGDOC(MDOC,LINE)

      IF(ISTEP.EQ.NSTEP) THEN
        NRES_MAX   = NRES_MAX_INPUT
        NRES_MIN   = NRES_MIN_INPUT
        FIDENT_LIM = FIDENT_LIM_INPUT
        SCORE_LIM  = SCORE_LIM_INPUT
        Q_LIM      = Q_LIM_INPUT
      ELSE
        IF(DOM.EQ.'D') THEN
          NRES_MAX   = NRES*1.2
          NRES_MIN   = NRES*0.4
          FIDENT_LIM = 30.0
          SCORE_LIM  = 0.200
          Q_LIM      = 0.400
        ELSE 
          NRES_MAX   = NRES*1.2
          NRES_MIN   = NRES*0.8
          FIDENT_LIM = 60.0
          SCORE_LIM  = 0.6
          Q_LIM      = 0.6
        ENDIF
      ENDIF

      IF(DOM.EQ.'C') THEN
        if(nres_max.lt.100) nres_max = 100
      ENDIF

      WRITE(LINE,*) 'H_lev:',IHIER_LEV
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Nres max,min:',NRES_MAX,NRES_MIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Ident_lim:',FIDENT_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Score_lim:',SCORE_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Q_lim:',Q_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'home:',HOME
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'icode_target:',ICODE_TARGET
      CALL MSGDOC(MDOC,LINE)

      DO ID=1,NSEQ

c         if(id.ge.32239) go to 100

        IF(ILEVEL_DB(ID).LT.IHIER_LEV) GO TO 100
        NLEV  = NLEV + 1
        IF(IORDER_DB(ID).LE.0)         GO TO 100
        NORD  = NORD + 1

        NR   = NRES_DB(ID)
        CODE = CODE_DB(ID)
        IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN
          
          CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
          FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'

          IF(HOME.EQ.'D') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *               CODE(1:LENCODE)//'.dat'
          ELSE IF(HOME.EQ.'C') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *               CODE(1:LENCODE)//'.dat'
          ENDIF

          IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
            CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
C           FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.dat'
          ENDIF

          FILE_SCR = ' '
          IPRINT   = 0
          MMM      = M

          if(id.eq.icheck) then
            IPRINT   = 1
            mmm = mdoc
          endif

          IF(DOM.EQ.'D') THEN
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *               ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF

          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 100
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)

          IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
            IF(NN.GT.NRES_MAX_INPUT.OR.NN.LT.NRES_MIN_INPUT) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
              ENDIF
              IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(ISTEP.EQ.NSTEP) THEN
                IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                  IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
                ENDIF
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
              ELSE
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) =-9
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-9
              ENDIF
            ENDIF
            NALIGN_BAD = NALIGN_BAD + 1
            GO TO 100
          ENDIF

          IF(DOM.EQ.'D') THEN
            T = 1.0 - REAL(NN)/REAL(N2)
            T = EXP(-T*T)
          ELSE 
            T = 1.0 - REAL(NN)/REAL(N1)
            T = EXP(-T*T)
          ENDIF 

          TT = (REAL(NN-NGAP)/REAL(NN))
          Q = SCORE_NEW*TT*TT*TT*TT

          Q = Q*T

          if(id.eq.icheck) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
            CALL MSGDOC(MDOC,LINE)
          endif

          IDRMS = 1
          IF(ICRD_FLAG.GT.0) THEN
            IF(DRMS.GT.DRMS_LIM) IDRMS = 0
          ENDIF

          QQQ = Q
          IF(MODE.EQ.'U') QQQ = Q_FIN

          IF(QQQ.GE.Q_LIM.AND.IDRMS.GT.0) THEN

            IORDER_DB(ID) = 1
            IF(DOM.EQ.'D') IUSED_DOM(ID) = Q * 1000.0

          if(id.eq.icheck) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q_FIN,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
            CALL MSGDOC(MDOC,LINE)
          endif

            NCH_1   = NCH_1 + 1
            NCH_TOT = NCH_TOT + 1
            ICODE_STOR(NCH_TOT)     = ID
            N2_STOR(NCH_TOT)        = N2
            NN_STOR(NCH_TOT)        = NN
            NPAIR_STOR(NCH_TOT)     = NPAIR
            NGAP_STOR(NCH_TOT)      = NGAP
            HID_STOR(NCH_TOT)       = HID
            SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
            Q_FIN_STOR(NCH_TOT)     = Q_FIN

            IF(N2_MAX.LT.N2) N2_MAX = N2

            IF(SCORE_NEW.GE.SCORE_LIM) THEN
              IF(NN_MAX.LT.NN) NN_MAX = NN
            ENDIF

            Q_STOR(NCH_TOT)        = Q
            IF(Q.GT.Q_BEST) Q_BEST = Q

            DRMS_STOR(NCH_TOT)      = DRMS
            INDEX_STOR(NCH_TOT)     = NCH_TOT
          ELSE
            NCH_1_BAD = NCH_1_BAD + 1
            IF(ISTEP.EQ.NSTEP) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IORDER_DB(ID) = 0
c uuu
                IF(MODE.EQ.'U') THEN
                  IORDER_DB(ID) =-9
                  IF(Q.GE.Q_LIM) THEN
                    IORDER_DB(ID) =-9
                  ELSE
                    IORDER_DB(ID) = 0
                  ENDIF
                ENDIF
c uuu
              ENDIF
            ELSE
              IORDER_DB(ID) =-9
            ENDIF
          ENDIF

        ELSE
          NSIZE_BAD = NSIZE_BAD + 1

          IF(NR.GT.NRES_MAX_INPUT.OR.NR.LT.NRES_MIN_INPUT) THEN
C            IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C            ENDIF
            IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
          ELSE
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C              ENDIF
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) =-9
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-9
            ENDIF
          ENDIF
          
        ENDIF

  100   CONTINUE

      ENDDO

      WRITE(LINE,'(A,3I6)') 
     *   'N,Nlev,Nord:',NCH_1,NLEV,NORD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,3I6)') 
     *   'Nbad,Nsize_bad,Nalign_bad:',NCH_1_BAD,NSIZE_BAD,NALIGN_BAD
      CALL MSGDOC(MDOC,LINE)

      NCH_2     = 0
      NCH_2_BAD = 0
      NCH_2_ALIGN_BAD = 0

      IF(NCH_1.LE.0) GO TO 400

      DO ID=1,NSEQ

c         if(id.ge.32239) go to 200

c         if(id.eq.31786) go to 200
c         if(id.eq.31787) go to 200
c         if(id.eq.31788) go to 200

        IF(IORDER_DB(ID).LE.0)         GO TO 200
        IF(ILEVEL_DB(ID).GE.IHIER_LEV) GO TO 200

        JJ = ID
 310    CONTINUE
        IBCK = IBACK_DB(JJ)

        IF(MODE.EQ.'U'.AND.IBCK.EQ.ICODE_TARGET.AND.
     *       ICODE_TARGET.GT.0 ) GO TO 300

C        IF(IBCK.GT.0) THEN

        IF(ILEVEL_DB(JJ).GE.IHIER_LEV) THEN
          IF(IORDER_DB(JJ).GT.0) GO TO 300
          GO TO 200
        ENDIF

        IF(IBCK.GT.0) THEN
          JJ = IBCK 
          GO TO 310
        ELSE
          GO TO 200
        ENDIF

 300    CONTINUE

        NR   = NRES_DB(ID)
        CODE = CODE_DB(ID)
        IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN

          CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
          FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'

          IF(HOME.EQ.'D') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *               CODE(1:LENCODE)//'.dat'
          ELSE IF(HOME.EQ.'C') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *               CODE(1:LENCODE)//'.dat'
          ENDIF

          IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
            IF(CODE(6:7).NE.'_0') THEN
              CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
c              FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
              FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.dat'
            ENDIF
          ENDIF

          FILE_SCR = ' '
          IPRINT   = 0
          MMM      = M

          if(id.eq.icheck) then
            IPRINT   = 1
            mmm = mdoc
          endif

          IF(DOM.EQ.'D') THEN
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *          ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *          ,PAIR,DIST,PO,PE
     *          ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(MMM,IPRINT
     *          ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *          ,PAIR,DIST,PO,PE
     *          ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF

          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)

          IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
C              ENDIF
            ELSE
              IF(NN.GT.NRES_MAX) IORDER_DB(ID) =-9
            ENDIF
            NCH_2_ALIGN_BAD = NCH_2_ALIGN_BAD + 1
            GO TO 200
          ENDIF

          IF(DOM.EQ.'D') THEN
            T = 1.0 - REAL(NN)/REAL(N2)
            T = EXP(-T*T)
          ELSE 
            T = 1.0 - REAL(NN)/REAL(N1)
            T = EXP(-T*T)
          ENDIF 

          TT = (REAL(NN-NGAP)/REAL(NN))
          Q  = SCORE_NEW*TT*TT*TT*TT

          Q  = Q*T

          if(id.eq.icheck) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
            CALL MSGDOC(MDOC,LINE)
          endif

          IDRMS = 1
          IF(ICRD_FLAG.GT.0) THEN
            IF(DRMS.GT.DRMS_LIM) IDRMS = 0
          ENDIF

          QQQ = Q
          IF(MODE.EQ.'U') QQQ = Q_FIN

          IF(QQQ.GE.Q_LIM.AND.IDRMS.GT.0) THEN

            IORDER_DB(ID) = 1
            IF(DOM.EQ.'D') IUSED_DOM(ID) = Q * 1000.0
            IF(JJ.GT.0) THEN
              IORDER_DB(ID) = JJ  
            ENDIF

c            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
c     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q_FIN,DRMS
c     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
c            CALL MSGDOC(MDOC,LINE)

            NCH_TOT = NCH_TOT + 1
            NCH_2 = NCH_2 + 1
            ICODE_STOR(NCH_TOT)     = ID
            N2_STOR(NCH_TOT)        = N2
            NN_STOR(NCH_TOT)        = NN
            NPAIR_STOR(NCH_TOT)     = NPAIR
            NGAP_STOR(NCH_TOT)      = NGAP
            HID_STOR(NCH_TOT)       = HID
            SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
            Q_FIN_STOR(NCH_TOT)     = Q_FIN
            IF(N2_MAX.LT.N2) N2_MAX = N2
            IF(SCORE_NEW.GE.SCORE_LIM) THEN
              IF(NN_MAX.LT.NN) NN_MAX = NN
            ENDIF
            Q_STOR(NCH_TOT)         = Q
            IF(Q.GT.Q_BEST)  Q_BEST = Q
            DRMS_STOR(NCH_TOT)      = DRMS
            INDEX_STOR(NCH_TOT)     = NCH_TOT
          ELSE
            NCH_2_BAD = NCH_2_BAD + 1
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                 IORDER_DB(ID) = 0
c uuu
                 IF(MODE.EQ.'U') THEN
                   IORDER_DB(ID) =-9
                   IF(Q.GE.Q_LIM) THEN
                     IORDER_DB(ID) =-9
                   ELSE
                     IORDER_DB(ID) = 0
                   ENDIF
                 ENDIF
c uuu
C              ENDIF   
            ELSE
              IORDER_DB(ID) =-9
            ENDIF
          ENDIF
        ELSE
          IF(ISTEP.EQ.NSTEP) THEN
C            IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C            ENDIF
          ELSE
            IF(NR.GT.NRES_MAX) IORDER_DB(ID) =-9
          ENDIF
        ENDIF

  200   CONTINUE

      ENDDO

      WRITE(LINE,'(A,3I6)') 
     *   'N2,N2_bad,N2_align_bad:',NCH_2,NCH_2_BAD,NCH_2_ALIGN_BAD
      CALL MSGDOC(MDOC,LINE)

  400 CONTINUE

      WRITE(LINE,*) 'N_TOT :',NCH_TOT
      CALL MSGDOC(MDOC,LINE)

      IF(ISTEP.NE.NSTEP) THEN
        DO ID=1,NSEQ
          IF(IORDER_DB(ID).EQ.-9) IORDER_DB(ID) = 1
        ENDDO
        IF(NCH_TOT.GT.0.AND.Q_BEST.GE.Q_LIM) GO TO 810
        GO TO 800
      ENDIF

  810 CONTINUE

      IF(NCH_TOT.LE.0) GO TO 900

      IF(DOM.EQ.'D') THEN

        NNN_MAX = N2_MAX
        IF(NN_MAX.LT.NNN_MAX.AND.NN_MAX.GT.0) NNN_MAX = NN_MAX
        IF(N1.LT.NNN_MAX.AND.N1.GT.0) NNN_MAX = N1
        WRITE(LINE,'(A,4I6)') 
     *   'N1,N2_max,NN_max,NNN_max:',N1,N2_MAX,NN_MAX,NNN_MAX
        CALL MSGDOC(MDOC,LINE)

        DO ID=1,NCH_TOT
          NNN = N2_STOR(ID)
          IF(NNN.GT.NNN_MAX) NNN = NNN_MAX
          T = 1.0 - REAL(NNN)/REAL(NNN_MAX)
          IF(T.LT.0.0) T = 0.0
          T = EXP(-T*T)
          Q_STOR(ID) = Q_STOR(ID)*T
        ENDDO
      ENDIF

      CALL SORT1(Q_STOR,NCH_TOT,INDEX_STOR)

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id  code     n2  nn ngap Idnt score   Q   Drms'
      CALL MSGDOC(MDOC,LINE)

      II = 0
      DO ID=NCH_TOT,1,-1
        II   = II + 1

        if(ii.gt.50) go to 900

        IDD  = INDEX_STOR(ID)
        ICL = 1
C        IF(DOM.EQ.'D') THEN
          ICL = ICLASS_DOM(ICODE_STOR(IDD))
C        ENDIF
        CODE = CODE_DB(ICODE_STOR(IDD))  
        WRITE(LINE,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F6.3,1X,2I10)')
     *    ICODE_STOR(IDD)
     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NGAP_STOR(IDD)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(ID)
     *    ,DRMS_STOR(IDD),ICL,IORDER_DB(IDD)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

  900 CONTINUE

      RETURN
      END

C     chain - DIR_FOR_PDB(../pdb_DB/)  ; DOM - DIR_FOR_PDB(' ')
C     NCH_TOT input in _STOR ; ND output in _STOR

      SUBROUTINE CHECK_SEARCH_BY_RMS(MDOC,DOM,HOME
     *     ,FILE_PDB,FILE_OUT,DIR_FOR_PDB
     *     ,CODE_DB,NSEQMAX
     *     ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *     ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *     ,NCH_TOT
     *     ,FIDENT_LIM,SCORE_LIM,Q_LIM,RMS_LIM
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,ND
     *     ,ICODE_BEST,FIDENT_BEST,SCORE_BEST,Q_BEST,DRMS_BEST
     *     ,N2_BEST,NN_BEST,NPAIR_BEST
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C --
      INTEGER   NSEQ
      CHARACTER CODE_DB(NSEQMAX)*8,DOM*1,HOME*1
C --
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C --
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_PDB*(*),FILE_OUT*(*)
      CHARACTER DIR_FOR_PDB*(*)
      CHARACTER LINE*256
      CHARACTER FILE_SCR*256,FILE_1*256,FILE_XYZ*256,FILE_TEMP*256
      CHARACTER CODE*8
      CHARACTER PATH*1,EXT*1
      CHARACTER DIST*1,PAIR*1
C --
      INTEGER   ICODE_STOR(NSEQMAX),N2_STOR(NSEQMAX),NN_STOR(NSEQMAX)
      INTEGER   NPAIR_STOR(NSEQMAX),INDEX_STOR(NSEQMAX)
      INTEGER   IORDER_DB(NSEQMAX),NGAP_STOR(NSEQMAX)
      REAL      HID_STOR(NSEQMAX),SCORE_NEW_STOR(NSEQMAX)
      REAL      Q_STOR(NSEQMAX),Q_FIN_STOR(NSEQMAX),DRMS_STOR(NSEQMAX)
C ----
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
c             0     1     2     3     4     5      6     7    8     9
c#H 0..9:       80.0  65.0  50.0  45.0  40.0  35.0  30.0  25.0  20.0  0.0
C#H 0..9:       0.8   0.6   0.5   0.45  0.4   0.35  0.3   0.25  0.2    0.0
C#N 0...9:   6616  1932  2777  2027  4495   754   897   927   568   576

      WRITE(LINE,*) 'Ident_lim:',FIDENT_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Score_lim:',SCORE_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Q_lim    :',Q_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'RMS_lim  :',RMS_LIM
      CALL MSGDOC(MDOC,LINE)

      PO = 0.0
      PE = 0.0
      PAIR = 'N'         
      DIST = 'N'
      ND     = 0
      NND    = 0
      ND_BAD = 0
      NP_NN_BAD = 0
      ICODE_BEST  = 0
      SCORE_BEST  = -1.0
      Q_BEST      = -1.0
      FIDENT_BEST = 0.0
      DRMS_BEST   = 0.0
      N2_BEST     = 0
      NN_BEST     = 0
      NPAIR_BEST  = 0
      N2_MAX      = 0
      NN_MAX      = 0

c      N2_MAX     = 0
C      DO III=NCH_TOT,1,-1
C        IDD  = INDEX_STOR(III)
C        IF(N2_MAX.LT.N2_STOR(IDD)) N2_MAX = N2_STOR(IDD)  
C      ENDDO

      LINE = 
     * '   Id  code     n2  nn  np  Idnt score   Q   Qf     rms  Ngap'
      CALL MSGDOC(MDOC,LINE)

      DO III=NCH_TOT,1,-1

        IDD  = INDEX_STOR(III)
        ID   = ICODE_STOR(IDD)

        CODE = CODE_DB(ID)

        IF(HOME.EQ.'N') THEN
          CALL LENSTR_BL(DIR_FOR_PDB,LEN)
          IF(LEN.LE.0) THEN
            FILE_1 = 'pdb_DOM_tmp.pdb'
            CALL LENSTR_BL(PATH_SCR,LEN)
            CALL LENSTR_BL(FILE_1,LT)
            IF(LEN.GT.0) THEN
              FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
            ENDIF
            FILE_SCR = ' '
            CALL CREATE_DOMAIN_PDB_MEM(MDOC
     *       ,CODE,FILE_1
     *       ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *       ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *       ,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = 'ERR: in CREATE_DOMAIN_PDB_MEM :'//CODE
              CALL MSGERR(MDOC,LINE)
              IERR = 0
c //
              Q_STOR(III) = 0.0
c //
              GO TO 100
            ENDIF
          ELSE
            LENCODE = 5
            CALL LENSTR_BL(DIR_FOR_PDB,LEN)
            FILE_XYZ = DIR_FOR_PDB(1:LEN)//CODE(1:LENCODE)//'.xyz'
            FILE_1   = 'unpack_tmp.pdb'
            CALL LENSTR_BL(PATH_SCR,LEN)
            CALL LENSTR_BL(FILE_1,LT )
            IF(LEN.GT.0) THEN
              FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
            ENDIF
            CALL PDB_UNPACK(M,FILE_XYZ,FILE_1,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: unpack XYZ file'
              CALL MSGERR(MDOC,LINE)
              IERR = 11
              GO TO 900
            ENDIF
          ENDIF
          FILE_SCR= ' '
          IPRINT  = 0
          IF(DOM.EQ.'D') THEN
            DIST = 'W'
            CALL MAKE_ALIGN5D(M,IPRINT
     *              ,FILE_PDB,FILE_1,FILE_SCR
     *              ,PAIR,DIST,PO,PE
     *              ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(M,IPRINT
     *              ,FILE_PDB,FILE_1,FILE_SCR
     *              ,PAIR,DIST,PO,PE
     *              ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF
          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.xyz'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
c //
            Q_STOR(III) = 0.0
c //
            GO TO 100
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)
          IF(DOM.EQ.'D') THEN
            T =  1.0 - REAL(NN)/REAL(N2)
            T =  EXP(-T*T)
          ELSE 
            T =  1.0 - REAL(NN)/REAL(N1)
            T =  EXP(-T*T)
          ENDIF 
          TT = (REAL(NN-NGAP)/REAL(NN))
          Q = SCORE_NEW*TT*TT*TT*TT
          Q = Q * T
        ELSE
          N2        = N2_STOR(IDD)        
          NN        = NN_STOR(IDD)       
          NPAIR     = NPAIR_STOR(IDD)     
          NGAP      = NGAP_STOR(IDD)      
          HID       = HID_STOR(IDD)       
          SCORE_NEW = SCORE_NEW_STOR(IDD) 
          Q_FIN     = Q_FIN_STOR(IDD)     
          Q         = Q_STOR(III)        
          DRMS      = DRMS_STOR(IDD)     
        ENDIF          

        IF(DRMS.GT.9.9) DRMS = 9.9
        IF(Q_FIN.GE.Q_LIM.AND.DRMS.LE.RMS_LIM) THEN

          WRITE(LINE,'(I5,1X,A8,3I4,1X,F5.1,3F6.3,F6.2,I5)')
     *    ID,CODE,N2,NN,NPAIR,HID,SCORE_NEW,Q,Q_FIN,DRMS
     *    ,NGAP

          CALL MSGDOC(MDOC,LINE)

          ND = ND + 1

          NND = IDD
C          ICODE_STOR(NND)    = ICODE_STOR(III)
C          INDEX_STOR(NND)    = NND
          N2_STOR   (NND)     = N2
          NN_STOR   (NND)     = NN
          NPAIR_STOR(NND)     = NPAIR
          NGAP_STOR(NND)      = NGAP
          HID_STOR  (NND)     = HID
          SCORE_NEW_STOR(NND) = SCORE_NEW
          Q_FIN_STOR(NND)     = Q_FIN
          Q_STOR(III)         = Q
        
c uuu
          Q_STOR(III) = Q_FIN
c uuu

          DRMS_STOR (NND)     = DRMS
          T = REAL(NPAIR)/REAL(NN)


c          IF(Q.GT.Q_BEST.AND.T.GT.0.6) THEN

c uuu
          IF(Q_FIN.GT.Q_BEST.AND.T.GT.0.6) THEN
c uuu
            SCORE_BEST  = SCORE_NEW 
            ICODE_BEST  = ID
c uuu
            Q_BEST      = Q_FIN
c uuu
c            Q_BEST      = Q

            FIDENT_BEST = HID
            DRMS_BEST   = DRMS
            N2_BEST     = N2
            NN_BEST     = NN
            NPAIR_BEST  = NPAIR
          ELSE
            NP_NN_BAD   = NP_NN_BAD + 1
          ENDIF
        ELSE
c //
          Q_STOR(III) = 0.0
c //
          ND_BAD = ND_BAD + 1
        ENDIF

100     CONTINUE

      ENDDO

      WRITE(LINE,'(A,2I6)') 'N,Nbad (Qf or rms) :',ND,ND_BAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I6)')  'Np/Nn or Q bad :',NP_NN_BAD
      CALL MSGDOC(MDOC,LINE)

      IF(ICODE_BEST.LE.0) GO TO 900
      IF(ND.LE.0) GO TO 900

      WRITE(LINE,*) 'BEST :',ICODE_BEST,' ',CODE_DB(ICODE_BEST)
      CALL MSGDOC(MDOC,LINE)

c /////
      N2_MAX = 0
      NN_MAX = 0
      DO III=NCH_TOT,1,-1
        IF(Q_STOR(III).GT.0.001) THEN
          IDD  = INDEX_STOR(III)
          IF(N2_MAX.LT.N2_STOR(IDD)) N2_MAX = N2_STOR(IDD)
          IF(NN_MAX.LT.NN_STOR(IDD)) NN_MAX = NN_STOR(IDD) 
        ENDIF  
      ENDDO

      NNN_MAX = N2_MAX
      IF(NN_MAX.LT.NNN_MAX.AND.NN_MAX.GT.0) NNN_MAX = NN_MAX
      WRITE(LINE,'(A,3I6)') 
     *   'N2_max,NN_max,NNN_max:',N2_MAX,NN_MAX,NNN_MAX
      CALL MSGDOC(MDOC,LINE)

      QQ_BEST = 0.0
      DO III=NCH_TOT,1,-1
        IF(Q_STOR(III).GT.0.001) THEN
          IDD  = INDEX_STOR(III)
          CODE = CODE_DB(ICODE_STOR(IDD))

          NNN = N2_STOR(IDD)
          Q   = Q_STOR(III)
          IF(NNN.GT.NNN_MAX) NNN = NNN_MAX
          T = 1.0 - REAL(NNN)/REAL(NNN_MAX)
          IF(T.LT.0.0) T = 0.0
          T = EXP(-T*T)
          QQ = Q*T
          T = REAL(NPAIR_STOR(IDD))/REAL(NN_STOR(IDD))

          CODE = CODE_DB(ICODE_STOR(IDD))
          N2        = N2_STOR(IDD)        
          NN        = NN_STOR(IDD)       
          NPAIR     = NPAIR_STOR(IDD)     
          NGAP      = NGAP_STOR(IDD)      
          HID       = HID_STOR(IDD)       
          SCORE_NEW = SCORE_NEW_STOR(IDD) 
          Q_FIN     = Q_FIN_STOR(IDD)     
          DRMS      = DRMS_STOR(IDD)     
          WRITE(LINE,'(I5,1X,A8,3I4,1X,F5.1,3F6.3,F6.2,I4,F6.3)')
     *    ICODE_STOR(IDD),CODE,N2,NN,NPAIR,HID,SCORE_NEW,Q,QQ,DRMS
     *    ,NNN,T
          CALL MSGDOC(MDOC,LINE)

          IF(QQ.GT.QQ_BEST.AND.T.GT.0.6) THEN
            QQ_BEST     = QQ
            SCORE_BEST  = SCORE_NEW_STOR(IDD)
            ICODE_BEST  = ICODE_STOR(IDD)
            Q_BEST      = Q_STOR    (III)
            FIDENT_BEST = HID_STOR  (IDD)
            DRMS_BEST   = DRMS_STOR (IDD)
            N2_BEST     = N2_STOR   (IDD)
            NN_BEST     = NN_STOR   (IDD)
            NPAIR_BEST  = NPAIR_STOR(IDD)
          ENDIF  
        ENDIF  
      ENDDO

      IF(ICODE_BEST.LE.0) GO TO 900

      WRITE(LINE,*) '--BEST :',ICODE_BEST,' ',CODE_DB(ICODE_BEST)
      CALL MSGDOC(MDOC,LINE)


c /////

      CALL LENSTR_BL(FILE_OUT,LEN)
      IF(LEN.GT.0) THEN

        ID   = ICODE_BEST
        CODE = CODE_DB(ID)

        CALL LENSTR_BL(DIR_FOR_PDB,LEN)
        IF(LEN.LE.0) THEN
          FILE_1 = 'pdb_DOM_tmp.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          CALL LENSTR_BL(FILE_1,LT)
          IF(LEN.GT.0) THEN
            FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
          ENDIF
          FILE_SCR = ' '
c          CALL CREATE_DOM_SEQ_AND_PDB(MDOC
c     *       ,CODE,FILE_SCR,FILE_1
c     *       ,PATH_SCR,PATH_OUT,IERR)
c          IF(IERR.NE.0) THEN
c            LINE = 'ERR: in CREATE_DOM_SEQ_FROM_PDB'
c            CALL MSGERR(MDOC,LINE)
c            GO TO 900
c          ENDIF
          CALL CREATE_DOMAIN_PDB_MEM(MDOC
     *       ,CODE,FILE_1
     *       ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *       ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *       ,PATH_SCR,PATH_OUT,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERR: in CREATE_DOMAIN_PDB_MEM :'//CODE
            CALL MSGERR(MDOC,LINE)
C            GO TO 900
            ICODE_BEST = 0
            IERR = 0
            GO TO 900
          ENDIF
        ELSE
          LENCODE = 5
          CALL LENSTR_BL(DIR_FOR_PDB,LEN)
          FILE_XYZ = DIR_FOR_PDB(1:LEN)//CODE(1:LENCODE)//'.xyz'
          FILE_1   = 'unpack_tmp.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          CALL LENSTR_BL(FILE_1,LT )
          IF(LEN.GT.0) THEN
            FILE_1 = PATH_SCR(1:LEN)//FILE_1(1:LT) 
          ENDIF
          CALL PDB_UNPACK(M,FILE_XYZ,FILE_1,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: unpack XYZ file'
            CALL MSGERR(MDOC,LINE)
            IERR = 11
            GO TO 900
          ENDIF
        ENDIF

        IPRINT  = 1
        IF(DOM.EQ.'D') THEN
          DIST = 'W'
          CALL MAKE_ALIGN5D(MDOC,IPRINT
     *              ,FILE_PDB,FILE_1,FILE_OUT
     *              ,PAIR,DIST,PO,PE
     *              ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
        ELSE
          CALL MAKE_ALIGN5(MDOC,IPRINT
     *              ,FILE_PDB,FILE_1,FILE_OUT
     *              ,PAIR,DIST,PO,PE
     *              ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
        ENDIF
        IF(IERR.NE.0) THEN
          GO TO 900
        ENDIF
        N1  = RESULT(1) 
        N2  = RESULT(2) 
        NN  = RESULT(3) 
        NI  = RESULT(4) 
        HID = RESULT(5) 
        SUM_SCORE  = RESULT(6)
        SCORE1_MAX = RESULT(13)
        SCORE1_MIN = RESULT(14)
        Q_FIN      = RESULT(15)
        DRMS       = RESULT(16)
        NPAIR      = RESULT(17)
        SCORE_NEW  = RESULT(18)
        FID_NEW    = RESULT(19)
        NGAP       = RESULT(20)

C        WRITE(LINE,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,F6.2)')
C     *      ID,CODE,N2,NN,NPAIR,HID,SCORE_NEW,Q_FIN,DRMS
C        CALL MSGDOC(MDOC,LINE)

        NN_BEST     = NN
        N2_BEST     = N2
        FIDENT_BEST = HID 
        SCORE_BEST  = SCORE_NEW
        Q_BEST      = Q_FIN
        NPAIR_BEST  = NPAIR
        DRMS_BEST   = DRMS

      ENDIF

  900 CONTINUE
      RETURN
      END
C =========
      SUBROUTINE CREATE_DOMAIN_PDB_MEM(MDOC
     *   ,CODE_DOM,FILE_DOM_PDB
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*512
      CHARACTER FILE_XYZ*256,FILE_CRD*256,FILE_TEMP*256
      CHARACTER FILE_PDB*256,FILE_SEQ*256,FILE_DOM_PDB*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*256,EXT*1
C ---
      INTEGER   NSEG_DB
      INTEGER   NDOM_DB(NSEGMAX)
      INTEGER   IDOMSEG_DB(NSEGMAX)
      CHARACTER CODE_DOM_DB(NSEGMAX)*8
      CHARACTER PNUM1_DOM_DB(NSEGMAX)*6
      CHARACTER PNUM2_DOM_DB(NSEGMAX)*6
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      PARAMETER ( NSEGMAXX = 100  )
      CHARACTER PNUM_START(NSEGMAXX)*7,PNUM_FIN(NSEGMAXX)*7
c -----------------------------------
C ---
      CHARACTER CODE5*5,CODE10*10,CODE8*8,CODE_DOM*8,DOM*2
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      CODE10 = ' '
      CODE5 = CODE_DOM(1:5)

C     xyz --> pdb
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH,IERR)
      IF(IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF
      CALL LENSTR_BL(PATH,LEN)
      FILE_XYZ = PATH(1:LEN)//'/pdb_DB/'//CODE5(1:5)//'.xyz'
      FILE_PDB = 'unpack_tmp.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PDB,LT )
      IF(LEN.GT.0) THEN
        FILE_PDB = PATH_SCR(1:LEN)//FILE_PDB(1:LT) 
      ENDIF
      CALL PDB_UNPACK(M,FILE_XYZ,FILE_PDB,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        GO TO 900
      ENDIF

      IF(CODE_DOM(6:7).NE.'_0') THEN
        CALL GET_DOM_INFO_FROM_LIST_MEM(MDOC,CODE_DOM
     *   ,NSEG_DB,NDOM_DB,IDOMSEG_DB,CODE_DOM_DB
     *   ,PNUM1_DOM_DB,PNUM2_DOM_DB,NSEGMAX
     *   ,ND_STRING,IDOMDOM,IDOMSEG
     *   ,PNUM1_DM,PNUM2_DM,NSTRMAX,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in GET_DOM_INFO_FROM_LIST_MEM'
          CALL MSGERR(MDOC,LINE)
          IERR = 11
          GO TO 900
        ENDIF
      ELSE
        ND_STRING = 0
      ENDIF

C     dom_info --> pdb (SEG_ID)
      FILE_CRD = 'domains_tmp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_CRD,LT )
      IF(LEN.GT.0) THEN
        FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
      ENDIF
      CODE8 = CODE5//'   '

      IERR =-1
      CALL SET_DOMAIN_INFO_TO_PDB_MEM(M,FILE_PDB,FILE_CRD
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: set dom_info to PDB mem'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      NC = NDOM
      IF(NDOM.LE.0) THEN
        NDOM = 0
        NC   = 1
      ENDIF

      FILE_TEMP = 'domain_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
      ENDIF

      DOM = CODE_DOM(6:7)
      IF(DOM(1:1).EQ.'_') DOM(1:1) = ' '          
      READ(DOM,'(I2)') IDOM

      CALL GET_DOMAIN_PDB(M,FILE_CRD,FILE_TEMP
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAXX
     *  ,IDOM,NRES,NATOM,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in get domain PDB'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

      IOUT     = 0
      ICH      = 0
      NDOMAIN  = 0
      FILE_SEQ = ' '
      CALL CREATE_DOMAIN_DESCRIPTION(MDOC
     *            ,CODE5,ICH,IDOM,NDOMAIN,FILE_TEMP
     *            ,IOUT,FILE_SEQ,FILE_DOM_PDB,PATH_SCR,IERR)     
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: CREATE_DOMAIN_DESCRIPTION'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 900
      ENDIF

C ------
      RETURN
  900 CONTINUE
      RETURN 
      END

      SUBROUTINE SEARCH_CHAIN_IN_DB_FOR_UPDATE(MDOC,MODE,DOM
     *     ,ICODE_TARGET
     *     ,FILE_SEQ,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NSEQ
     *     ,CODE_DB,NRES_DB,IBACK_DB,ILEVEL_DB,NSEQMAX
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_LIM,SCORE_LIM,NRES_MAX,NRES_MIN,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,IORDER_DB
     *     ,NCH_TOT
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C --
      INTEGER   NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),NRES_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8
C --
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_SEQ*(*),FILE_OUT*(*)
      CHARACTER DIR_FOR_SEQ*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER LINE*256
      CHARACTER FILE_SCR*256,FILE_1*256
      CHARACTER CODE_GOM*8,CODE*8,DOM*1,MODE*1
      CHARACTER PATH*1,EXT*1
C --
      INTEGER   ICODE_STOR(NSEQMAX),N2_STOR(NSEQMAX),NN_STOR(NSEQMAX)
      INTEGER   NPAIR_STOR(NSEQMAX),INDEX_STOR(NSEQMAX)
      INTEGER   IORDER_DB(NSEQMAX)
      REAL      HID_STOR(NSEQMAX),SCORE_NEW_STOR(NSEQMAX)
      REAL      Q_FIN_STOR(NSEQMAX),DRMS_STOR(NSEQMAX)
C ----
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      NCH_TOT   = 0
      NCH_1     = 0
      NCH_1_BAD = 0
      NLEV      = 0
      NORD      = 0

      WRITE(LINE,*) 'H_lev:',IHIER_LEV
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Nres max,min:',NRES_MAX,NRES_MIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Ident_lim:',FIDENT_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Score_lim:',SCORE_LIM
      CALL MSGDOC(MDOC,LINE)

      IC_CURR = ICODE_TARGET
      IC_OLD  = 0

  110 CONTINUE

c      WRITE(*,*) '---check back- for:',IC_CURR,ILEVEL_DB(IC_CURR)

C --  check back      
      DO ID=1,NSEQ

        IF(DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
c         write(*,*) '  --ini',NDOMAIN_INI
          GO TO 150
        ENDIF

        IF(ID.EQ.IC_CURR)      GO TO 130
        IF(ID.EQ.ICODE_TARGET) GO TO 130
        IF(ID.EQ.IC_OLD)       GO TO 130

        JJ = ID
 140    CONTINUE
        IBCK = IBACK_DB(JJ)

c        WRITE(*,*)  '  JJ,IBK,ILV:',JJ,IBCK,ILEVEL_DB(JJ)
       
        IF(ILEVEL_DB(JJ).GT.IHIER_LEV) GO TO 130        
        IF(IBCK.EQ.ICODE_TARGET.AND.IC_CURR.NE.ICODE_TARGET) GO TO 130
        IF(IBCK.EQ.IC_OLD) GO TO 130
        IF(IBCK.NE.IC_CURR) THEN
          IF(IBCK.LE.0) GO TO 130 
          JJ = IBCK 
          GO TO 140
        ENDIF
 150    CONTINUE

c        WRITE(*,*) '   OK====:',ID

C       -- OK --
C         ID
        NLEV  = NLEV + 1
        IF(IORDER_DB(ID).GT.0) THEN
          NORD  = NORD + 1
          NR   = NRES_DB(ID)
          CODE = CODE_DB(ID)
          IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN
 
            CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
            FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
              CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
              FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            ENDIF

            FILE_SCR = ' '
            IPRINT   = 0

            CALL MAKE_ALIGN(M,IPRINT,FILE_SEQ,FILE_1,FILE_SCR
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
            IF(IERR.NE.0) THEN
              LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
              CALL MSGERR(MDOC,LINE)
              IERR = 0
              GO TO 130
            ENDIF
            N1  = RESULT(1) 
            N2  = RESULT(2) 
            NN  = RESULT(3) 
            NI  = RESULT(4) 
            HID = RESULT(5) 
            SUM_SCORE  = RESULT(6)
            SCORE1_MAX = RESULT(13)
            SCORE1_MIN = RESULT(14)
            Q_FIN      = RESULT(15)
            DRMS       = RESULT(16)
            NPAIR      = RESULT(17)
            SCORE_NEW  = RESULT(18)
            FID_NEW    = RESULT(19)
            NGAP       = RESULT(20)

C          IF(Q_FIN.GE.Q_LIM) THEN
C          IF(DRMS.LE.4.0) THEN
C          IF(SCORE_NEW.GE.SCORE_LIM) THEN

            IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
              IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
              IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
              GO TO 130
            ENDIF
            IF(HID.GE.FIDENT_LIM.OR.
     *          SCORE_NEW.GE.SCORE_LIM) THEN

              WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
     *          ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q_FIN,DRMS
     *          ,ILEVEL_DB(ID),IORDER_DB(ID)
c             CALL MSGDOC(MDOC,LINE)

              NCH_1   = NCH_1 + 1
              NCH_TOT = NCH_TOT + 1
              ICODE_STOR(NCH_TOT)     = ID
              N2_STOR(NCH_TOT)        = N2
              NN_STOR(NCH_TOT)        = NN
              NPAIR_STOR(NCH_TOT)     = NPAIR
              HID_STOR(NCH_TOT)       = HID
              SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
              Q_FIN_STOR(NCH_TOT)     = Q_FIN

              IF(DOM.EQ.'D') THEN
                T =  1.0 - REAL(NN)/REAL(N2)
                T =  1.0 - REAL(NN)/REAL(N1)
c                T =  REAL(NN)/REAL(N1)
                T = EXP(-T)
              ELSE 
                T = 1.0 - REAL(NN)/REAL(N1)
                T = EXP(-T)
              ENDIF 
c              Q = SCORE_NEW*(HID/10.0)
              TT = (REAL(NN-NGAP)/REAL(NN))
              Q  = SCORE_NEW*TT*TT*TT*TT*(FID_NEW*0.08)
              Q_FIN_STOR(NCH_TOT) = Q * T
  
C             DRMS_STOR(NCH_TOT)      = DRMS
              DRMS_STOR(NCH_TOT)      = FID_NEW
              INDEX_STOR(NCH_TOT)     = NCH_TOT
            ELSE
              NCH_1_BAD = NCH_1_BAD + 1
              IORDER_DB(ID) = 0
            ENDIF
            IF(DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) IORDER_DB(ID) =-1
          ELSE
            IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
            IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
          ENDIF
        ENDIF
C       --------

 130    CONTINUE
      ENDDO
c --
      IBCK = IBACK_DB(IC_CURR)
c      write(*,*) '-- next:',IBCK,ILEVEL_DB(IC_CURR)
      IF(IBCK.LE.0.OR.ILEVEL_DB(IC_CURR).GT.IHIER_LEV) GO TO 120 
      IC_OLD  = IC_CURR
      IC_CURR = IBCK
      GO TO 110

  120 CONTINUE

      WRITE(LINE,'(A,4I6)') 
     *   'N,Nbad,Nlev,Nord:',NCH_1,NCH_1_BAD,NLEV,NORD
      CALL MSGDOC(MDOC,LINE)

      WRITE(LINE,'(A,I6)') 'N_tot :',NCH_TOT
      CALL MSGDOC(MDOC,LINE)

      IF(NCH_TOT.LE.0) GO TO 900

C      CALL SORT1(SCORE_NEW_STOR,NCH_TOT,INDEX_STOR)
      CALL SORT1(Q_FIN_STOR,NCH_TOT,INDEX_STOR)

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id  code     n2  nn  np  Idnt score   Q   I_new'
      CALL MSGDOC(MDOC,LINE)

      II = 0
      DO ID=NCH_TOT,1,-1
        II   = II + 1

        if(ii.gt.50) go to 900

        IDD  = INDEX_STOR(ID)
        CODE = CODE_DB(ICODE_STOR(IDD))  
        WRITE(LINE,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F5.1)')
     *    ICODE_STOR(IDD)
     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NPAIR_STOR(IDD)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_FIN_STOR(ID)
     *    ,DRMS_STOR(IDD)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

  900 CONTINUE

      RETURN
      END

      SUBROUTINE GET_SEQUENCE(MDOC,ISEQ,FILE_IN,FILE_OUT,IERR)
C --------------
      CHARACTER FILE_IN*(*),FILE_OUT*(*)
      CHARACTER LINE*2048,PATH*1,EXT*1
C --------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
      CALL LENSTR_BL(FILE_IN,LEN)
      IF(LEN.LE.0.OR.FILE_IN(1:1).EQ.' '.OR.FILE_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,FILE_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: can not open input file')
        RETURN
      ENDIF
      IOUT = 0
      IF(ISEQ.GT.0) THEN
        CALL LENSTR_BL(FILE_OUT,LEN)
        IF(LEN.LE.0.OR.FILE_OUT(1:1).EQ.' '.OR.
     *                 FILE_OUT(1:1).EQ.','    ) THEN
          CALL MSGERR(MDOC,' ERROR: wrong output file name')
          IERR = 1
          CLOSE(IU)
          RETURN
        ENDIF
        IOUT   = 11
        EXT  = ' '
        PATH = ' '
        CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: can not open output file')
          CLOSE(IU)
          RETURN
        ENDIF
      ENDIF
C ---
      IFIRST = 0
      NSEQ = 0
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IF(LINE(1:1).EQ.'>') THEN
          IFIRST = 1
          NSEQ = NSEQ + 1 
        ELSE IF(IFIRST.EQ.0) THEN
          IFIRST = 1
          NSEQ = NSEQ + 1 
          IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=600) '>XXXX'
        ENDIF
        IF(ISEQ.EQ.NSEQ.AND.IOUT.GT.0) THEN
          WRITE(IOUT,'(A)',ERR=600) LINE(1:LEN)
        ENDIF
 400    CONTINUE
      ENDDO
 800  CONTINUE
      IF(ISEQ.EQ.0) ISEQ = NSEQ 
      CLOSE(IU)
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT) 
      ENDIF
C ---
      RETURN
  500 CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IF(IOUT.GT.0) CLOSE(IOUT) 
      RETURN
  600 CONTINUE
      LINE = ' ERROR: writting output file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      CLOSE(IOUT) 
      RETURN
      END

      SUBROUTINE DOMAIN2CHAIN_FOR_COOT(MDOC,FILE_CRD,FILE_TEMP,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR,NDOM
      CHARACTER DOM_ID*1
      CHARACTER FILE_CRD*(*),FILE_TEMP*(*)
      CHARACTER PATH*1,EXT*1
      CHARACTER LINE*256
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 10
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
      CALL MSGDOC(MD,
     *       ' ERROR: cannot open input crd file')
        IERR = 1
        RETURN
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 11
      CALL OPENFW(IOUT,M,PATH,FILE_TEMP,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open output crd file')
        IERR = 1
        CLOSE(MT)
        RETURN
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 410

        DOM_ID = LINE(75:75)
        LINE(22:22) = DOM_ID

 410  CONTINUE

      IF(LINE(1:6).EQ.'ANISOU') GO TO 400 

      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)

      GO TO 400
C --------------
 600  CONTINUE
      END FILE IOUT
      CLOSE(IOUT)
      CLOSE(MT)

      RETURN
C -------------
 500  CONTINUE
      CLOSE(MT)
      CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
 900  CONTINUE
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE PREPARE_SEQUENCE_WITH_SURF_SS(MDOC,CODE8,NAA
     *   ,FILE_CRD,FILE_SEQ,PATH_SCR,IERR)
C ---------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER PATH_SCR*(*)
C ---
      CHARACTER CODE_PDB*4,CODE8*8,CHAIN*1,DOM*2
      CHARACTER CODE88*8
C      INTEGER   NSEQ(NMAX),IRES(NMAX)
C      INTEGER   SURF(NMAX),ICHAIN(NMAX),ISS(NATMX)
C      REAL      COORD(NMAX,3)
C      CHARACTER PNUM(NMAX)*6
      real,      allocatable :: COORD(:,:)
      integer,   allocatable :: NSEQ(:)
      integer,   allocatable :: IRES(:)
      integer,   allocatable :: SURF(:)
      integer,   allocatable :: ICHAIN(:)
      integer,   allocatable :: IDOMAIN(:)
      integer,   allocatable :: ISS(:)
c      real,      allocatable :: ELPOT(:)
      character(LEN=6), allocatable :: PNUM(:)
C ---------------------------------------
      CHARACTER LINE*256,FILE_CRD*(*),FILE_SEQ*(*),FILE_TEMP*256
C ---------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      FILE_TEMP = 'temp_scr.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_SCR(1:LEN)//'temp_scr.pdb' 
      ENDIF
      CALL SURFACE_DB_ALLOC(M,FILE_CRD,FILE_TEMP
     *       ,RESULT,IPRROW,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SURFACE for input PDB')
        GO TO 900
      ENDIF

      ITEST = 1
      NMAX  = 100

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_TEMP
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE88,NCHAIN,ITEST,IERR)
      IF(N.LE.0.OR.IERR.NE.0) THEN
        IERR = 1
        GO TO 900
      ENDIF

      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      NMAX = N

      allocate(COORD(1:NMAX,1:3),STAT=ISTAT)
      allocate(NSEQ(1:NMAX),STAT=ISTAT)
      allocate(IRES(1:NMAX),STAT=ISTAT)
      allocate(SURF(1:NMAX),STAT=ISTAT)
      allocate(ICHAIN(1:NMAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NMAX),STAT=ISTAT)
      allocate(ISS(1:NMAX),STAT=ISTAT)
      allocate(PNUM(1:NMAX),STAT=ISTAT)
C ---
      ITEST = 0
      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_TEMP
     *         ,NSEQ,IRES,PNUM,COORD,SURF,ICHAIN,IDOMAIN
     *         ,NMAX,N,CODE88,NCHAIN,ITEST,IERR)
      IF(IERR.NE.0) GO TO 900
      CODE_PDB = CODE88(1:4) 
      
C ---
      CALL ALIGN_SS_DEFINITION_ALLOC(MDOC,N
     * ,COORD(1,1),COORD(1,2),COORD(1,3),ISS,SURF
     * ,PSS,PH,PB,NMAX,IERR)
      IF(IERR.NE.0) GO TO 900
C ---
C      RESULT(1) = NATOM (Natom Occ > 0)
C      RESULT(2) = SURFA
C      RESULT(3) = SURFC
C      RESULT(8) = NTOT  (Natoms inside)
C      RESULT(9) = NRES
C      RESULT(10)= RAD_INER

      NATOM    = RESULT(1) 
      SURFA    = RESULT(2)
      NACORE   = RESULT(8)
      NRES     = RESULT(9) 
      RAD_INER = RESULT(10)
      CODE_PDB = CODE8(1:4)
      CHAIN    = CODE8(5:5)

      DOM = '  '

      CALL WRITE_SEQ_WITH_SS_SURF(MDOC,FILE_SEQ
     *  ,CHAIN,CODE_PDB,DOM,NSEQ,ISS,SURF,IDOMAIN
     *  ,NMAX,N,NAA,IERR)
      IF(IERR.NE.0) GO TO 900
C ---

  900 CONTINUE

      deallocate(COORD,STAT=ISTAT)
      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(SURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

C ------
      RETURN 
      END

      SUBROUTINE PREPARE_BIN_FILE_FROM_PDB(MDOC,CODE
     *           ,FILE_PDB,FILE_OUT
     *           ,PATH_OUT,PATH_SCR,IERR)
C ------------------------------------------------
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT (IPRROW)
      INTEGER   MDOC,IERR
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_PDB*(*),FILE_OUT*(*)
      CHARACTER FILE_XYZ*256,FILE_SCR*256
      CHARACTER FILE_1*256
      CHARACTER PATH*1,EXT*1
      CHARACTER LINE*256
      CHARACTER NAM1*4,CODE*8,CODE88*8

      real,      allocatable :: COORD1(:,:)
      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      IF(CODE(1:4).NE.'XXXX') THEN
        FILE_SCR = ' '
        CALL CREATE_DOM_SEQ_AND_PDB(MDOC
     *           ,CODE,FILE_SCR,FILE_PDB
     *         ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: in CREATE_DOM_SEQ_FROM_PDB'
          CALL MSGERR(MDOC,LINE)
          GO TO 900
        ENDIF
      ENDIF
      FILE_1 = 'align.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      IF(LEN.GT.0) THEN
        FILE_1 = PATH_SCR(1:LEN)//'align.pdb' 
      ENDIF
      CALL SURFACE_DB_ALLOC(M,FILE_PDB,FILE_1
     *                     ,RESULT,IPRROW,IERR)   
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: in SURFACE PDB')
        GO TO 900
      ENDIF

      ITEST = 1
      NMAX1 = 100

      allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE88,NCHAIN1,ITEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
        GO TO 800
      ENDIF
      IF(NC.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
        IERR = 1
        GO TO 800
      ENDIF

      deallocate(COORD1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

      NMAX1 = NC
      ITEST = 0

      allocate(COORD1(1:NMAX1,1:3),STAT=ISTAT)
      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      CALL READ_PDB_SEQ_AND_COORD_CA(M,FILE_1
     *      ,NSEQ1,IRES1,PNUM1,COORD1,SURF1,ICHAIN1,IDOMAIN1
     *      ,NMAX1,NC,CODE88,NCHAIN1,ITEST,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: READ_PDB_SEQ-1')
        GO TO 800
      ENDIF
      NAM1 = CODE88(1:4)
      IF(NC.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Naa in SEQ-1 = 0')
        IERR = 1
        GO TO 800
      ENDIF

      CALL ALIGN_SS_DEFINITION_ALLOC(M,NC
     *     ,COORD1(1,1),COORD1(1,2),COORD1(1,3),SS1,SURF1
     *     ,PSS,PH,PB,NMAX1,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR:  ALIGN_SS_DEFINITION-1(pdb)')
        GO TO 800
      ENDIF
      WRITE(LINE,'(''Percent SS,H,B :'',3F6.1)') PSS,PH,PB
      CALL MSGDOC(MDOC,LINE)

      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENUW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        GO TO 800
      ENDIF

      WRITE(IOUT,ERR=910) NMAX1,NC,CODE
      WRITE(IOUT,ERR=910) (IRES1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (NSEQ1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SS1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SURF1(I),I=1,NC)
      WRITE(IOUT,ERR=910) ((COORD1(J,I),J=1,NC),I=1,3)

      END FILE IOUT
      CLOSE(IOUT)     

C ----
 800  CONTINUE

      deallocate(COORD1,STAT=ISTAT)
      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)
C ----
 900  CONTINUE
      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,' ERROR: writting output file')
      IERR = 1
      GO TO 800
      END

      SUBROUTINE PREPARE_BIN_FILE_FROM_SEQ(MDOC,CODE
     *           ,FILE_SEQ,FILE_OUT
     *           ,PATH_OUT,PATH_SCR,IERR)
C ------------------------------------------------
C  sequence.sqb
c
      INTEGER   MDOC,IERR
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_SEQ*(*),FILE_OUT*(*)
      CHARACTER PATH*1,EXT*1
      CHARACTER LINE*256
      CHARACTER NAM1*4,CODE*8

      integer,   allocatable :: NSEQ1(:)
      integer,   allocatable :: IRES1(:)
      integer,   allocatable :: SURF1(:)
      integer,   allocatable :: ICHAIN1(:)
      integer,   allocatable :: IDOMAIN1(:)
      integer,   allocatable :: SS1(:)
      integer,   allocatable :: ISS1(:)
      character(LEN=6), allocatable :: PNUM1(:)
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      ITEST = 1
      NMAX1 = 100
      NAM1  = 'XXXX'

      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      CALL READ_FASTA_SEQ_NEW(M,NAM1,FILE_SEQ
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: PREPARE_BIN_FILE_FROM_SEQ test')
        GO TO 800
      ENDIF
      IF(NC.LE.0) THEN
        IERR = 1
        CALL MSGERR(MDOC,
     *  'ERROR: PREPARE_BIN_FILE_FROM_SEQ Naa in SEQ-1 = 0.')
        GO TO 800
      ENDIF

      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)

      NMAX1 = NC

      allocate(NSEQ1(1:NMAX1),STAT=ISTAT)
      allocate(IRES1(1:NMAX1),STAT=ISTAT)
      allocate(SURF1(1:NMAX1),STAT=ISTAT)
      allocate(ICHAIN1(1:NMAX1),STAT=ISTAT)
      allocate(IDOMAIN1(1:NMAX1),STAT=ISTAT)
      allocate(SS1(1:NMAX1),STAT=ISTAT)
      allocate(ISS1(1:NMAX1),STAT=ISTAT)
      allocate(PNUM1(1:NMAX1),STAT=ISTAT)

      ITEST = 0
      CALL READ_FASTA_SEQ_NEW(M,NAM1,FILE_SEQ
     *       ,ITEST,NC,NMAX1,NCHAIN1,PNUM1
     *       ,NSEQ1,IRES1,SS1,ISS1,SURF1,ICHAIN1,IDOMAIN1,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,'ERROR: PREPARE_BIN_FILE_FROM_SEQ')
        GO TO 800
      ENDIF

      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENUW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        GO TO 800
      ENDIF

      WRITE(IOUT,ERR=910) NMAX1,NC,CODE
      WRITE(IOUT,ERR=910) (IRES1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (NSEQ1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SS1(I),I=1,NC)
      WRITE(IOUT,ERR=910) (SURF1(I),I=1,NC)

      END FILE IOUT
      CLOSE(IOUT)     

C ----
 800  CONTINUE

      deallocate(NSEQ1,STAT=ISTAT)
      deallocate(IRES1,STAT=ISTAT)
      deallocate(SURF1,STAT=ISTAT)
      deallocate(ICHAIN1,STAT=ISTAT)
      deallocate(IDOMAIN1,STAT=ISTAT)
      deallocate(SS1,STAT=ISTAT)
      deallocate(ISS1,STAT=ISTAT)
      deallocate(PNUM1,STAT=ISTAT)
C ----
 900  CONTINUE
      RETURN
 910  CONTINUE
      CALL MSGERR(MDOC,' ERROR: writting output file')
      IERR = 1
      GO TO 800
      END

      SUBROUTINE CLEAN_PDB(MDOC,CHAIN_INP
     *          ,FILE_CRD,FILE_REST,NRES,MESSAGE,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_CRD*(*),FILE_REST*(*),MESSAGE*(*)
      CHARACTER PATH*1,EXT*1,CHAIN_INP*1,CHAIN_I*1
      CHARACTER CP_PNUM_OLD*7,CP_PNUM*7
      CHARACTER CHAIN*1,RNAME*3
      CHARACTER LINE*256
      CHARACTER ACODE3(25)*3
C --
      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
     *           ,'---'/
C -------------------------------------------------
C      set '-' in seg_id(76:76) (domains border) 
C ---  
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CP_PNUM_OLD = '???????'
      NRES     = 0
      CHAIN_I  = CHAIN_INP 
      IF(CHAIN_I.EQ.'_') CHAIN_I = ' '
C ----
      EXT  = ' '
      PATH = ' '
      MT   = 16
      CALL OPENFR(MT,M,PATH,FILE_CRD,EXT,IERR)
      IF(IERR.NE.0) THEN
        MESSAGE = 'cannot open input pdb file'
        CALL MSGDOC(MD,
     *       ' ERROR: cannot open input pdb file')
        IERR = 1
        RETURN
      ENDIF
C ---
      IOUT = 0
      CALL CORR_NAME_BLC(FILE_REST)
      CALL LENSTR_BL(FILE_REST,LEN)
      IF(LEN.GT.0) THEN
        EXT  = ' '
        PATH = ' '
        IOUT = 17
        CALL OPENFW(IOUT,M,PATH,FILE_REST,EXT,IERR)
        IF(IERR.NE.0) THEN
          MESSAGE = 'cannot open output pdb file'
          CALL MSGDOC(MD,
     *         ' ERROR: cannot open output pdb file')
          IERR = 1
          CLOSE(MT)
          RETURN
        ENDIF
      ENDIF
C ----------------
 400  CONTINUE
      READ(MT,'(A)',ERR=500,END=600) LINE
      CALL LENSTR_BL(LINE,LEN)

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) THEN

        IF(LINE(1:6).EQ.'HEADER'.OR.LINE(1:6).EQ.'COMPND'.OR.
     *     LINE(1:6).EQ.'CRYST1') THEN 
          CALL LENSTR_BL(LINE,LEN)
          IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
        ENDIF
        GO TO 400
      ENDIF

      CP_PNUM = LINE(21:27)
      CHAIN   = CP_PNUM(2:2)
      RNAME   = LINE(18:20)
      CALL CORR_RESNAME_BY_SYNONYM(RNAME)
      DO  J=1,23
        IF(RNAME.EQ.ACODE3(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J = 25
  700 CONTINUE
      IF(RNAME.EQ.'HOH') J = 25 
      IF(J.LE.23.AND.CHAIN.EQ.CHAIN_I) THEN
        IF(CP_PNUM_OLD(3:6).NE.CP_PNUM(3:6)) THEN
          NRES = NRES + 1
        ENDIF
        CALL LENSTR_BL(LINE,LEN)
        IF(IOUT.GT.0) WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      ENDIF

      CP_PNUM_OLD = CP_PNUM
      GO TO 400
C --------------
 600  CONTINUE
      IF(IOUT.GT.0) THEN
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      CLOSE(MT)
      RETURN
C -------------
 500  CONTINUE
      MESSAGE = 'reading input pdb file'
      CALL MSGDOC(MD,
     *       ' ERROR: reading input pdb file')
      CLOSE(MT)
      IF(IOUT.GT.0) CLOSE(IOUT)
      IERR = 1
      RETURN
 510  CONTINUE
      MESSAGE = 'writting open input pdb file'
      CALL MSGDOC(MD,
     *       ' ERROR: writting output pdb file')
      IF(IOUT.GT.0) CLOSE(IOUT)
      CLOSE(MT)
      IERR = 1
      RETURN
      END

      SUBROUTINE EXPECTED_TIME(ISTART,NRUN
     *  ,ITIME_CURR,TIME_CURRENT,TIME_ELAPSED,TIME_EXPECTED)
c ---------------------------------------------
      INTEGER   IHR(7)
      CHARACTER TIME_EXPECTED*(*),TIME_ELAPSED*(*)
      CHARACTER TIME_CURRENT*(*)
      COMMON/COM_EXP_TIME/ ITIME_INIT,ITIME_START,ITIME_PREVIOUS
     *              ,NDELTA,IHR_PREVIOUS,IHR_ADD,SUM_DELTA
      INTEGER ITIME_INIT,ITIME_START,ITIME_PREVIOUS,NDELTA
      INTEGER IHR_PREVIOUS,IHR_ADD
      REAL    SUM_DELTA
c ---------------------------------------------
      M      = 99
      IERR   = 0
C ---
C ========
      CALL CLOCK(IHR)
C     IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
      IF(ISTART.LT.0) THEN
        IHR_PREVIOUS = IHR(4) 
        IHR_ADD      = 0
      ENDIF
      IHR4 = IHR(4)
      IF(IHR4.LT.IHR_PREVIOUS)  IHR_ADD = IHR_ADD + 24
      ICLOCK_CURR  = IHR(2)+(IHR(3)+IHR(4)*60)*60 
      IHR_PREVIOUS = IHR(4) 
      IHR4 = IHR4 + IHR_ADD   
      ITIME_CURR = IHR(2)+(IHR(3)+IHR4*60)*60 
      IHR_PREVIOUS = IHR(4) 
C --
      ITM = ICLOCK_CURR/60
      ITIME_S = ICLOCK_CURR - ITM*60
      ITIME_H = ITM/60
      ITIME_M = ITM -ITIME_H*60
      WRITE(TIME_CURRENT,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
      IF(ISTART.GE.0) THEN
        ITELAP = ITIME_CURR - ITIME_INIT
        ITM = ITELAP/60
        ITIME_S = ITELAP - ITM*60
        ITIME_H = ITM/60
        ITIME_M = ITM -ITIME_H*60
        WRITE(TIME_ELAPSED,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
      ENDIF
C ========
      IF(ISTART.LT.0) THEN
        ITIME_INIT     = ITIME_CURR
        ITIME_START    = ITIME_CURR
        ITIME_PREVIOUS = ITIME_CURR
        NDELTA    = 0
        SUM_DELTA = 0.0
        DELTA     = 0.0
        TIME_ELAPSED   = '.'
        TIME_EXPECTED  = '.'
      ELSE IF(ISTART.GT.0) THEN
        ITIME_START    = ITIME_CURR
        ITIME_PREVIOUS = ITIME_CURR
        NDELTA    = 0
        SUM_DELTA = 0.0
        DELTA     = 0.0
        TIME_EXPECTED  = '.'
      ELSE
        D = FLOAT(ITIME_CURR) - FLOAT(ITIME_PREVIOUS)
        IF(D.GT.0.01) THEN
          SUM_DELTA = SUM_DELTA + D
          NDELTA    = NDELTA    + 1
          ITIME_PREVIOUS = ITIME_CURR
        ENDIF
        TIME_EXPECTED  = '.'
        ITIME_EXPECTED = 0
        DELTA = 0.0
        IF(NDELTA.GT.0) THEN
          DELTA     = SUM_DELTA/FLOAT(NDELTA)
          ITIME_EXPECTED = DELTA*FLOAT(NRUN)
          ITM = ITIME_EXPECTED/60
          ITIME_S = ITIME_EXPECTED -ITM*60
          ITIME_H = ITM/60
          ITIME_M = ITM -ITIME_H*60
          WRITE(TIME_EXPECTED,'(I6,''h '',I2,''m '',I2,''s'')')
     *          ITIME_H,ITIME_M,ITIME_S    
        ENDIF
 
C       write(*,*) '--t:',nrun,d,delta,ndelta,ITIME_CURR,ITIME_PREVIOUS
C     *   ,ITIME_EXPECTED

C       123456h 12m 13s   
C       123456789 12345

      ENDIF     
C ---
      RETURN
      END
C
      SUBROUTINE SEARCH_CHAIN_IN_DB_PRF(MDOC,MODE,DOM,HOME,PATH_DB
     *     ,ICODE_TARGET
     *     ,FILE_SEQ,FILE_OUT
     *     ,LENCODE,NRES,DIR_FOR_SEQ
     *     ,NSEQ
     *     ,CODE_DB,NRES_DB,IBACK_DB,ILEVEL_DB,NSEQMAX
     *     ,ITYPE_DOM,NSEG_DOM,ICLASS_DOM
     *     ,NDOMAIN_INI,DIR_FOR_NEW_SEQ
     *     ,FIDENT_LIM_INPUT,SCORE_LIM_INPUT,Q_LIM_INPUT
     *     ,NRES_MAX_INPUT,NRES_MIN_INPUT,IHIER_LEV
     *     ,ICODE_STOR,N2_STOR,NN_STOR,NPAIR_STOR,INDEX_STOR
     *     ,HID_STOR,SCORE_NEW_STOR,Q_FIN_STOR,DRMS_STOR
     *     ,NGAP_STOR,Q_STOR
     *     ,IORDER_DB,IUSED_DOM
     *     ,NCH_TOT,NRUN
     *     ,PATH_SCR,PATH_OUT,IERR)
C -----------------------------------
      INTEGER   MDOC,IERR
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
C --
      INTEGER   NSEQ
      INTEGER   IBACK_DB(NSEQMAX),ILEVEL_DB(NSEQMAX),NRES_DB(NSEQMAX)
      CHARACTER CODE_DB(NSEQMAX)*8
      INTEGER   ITYPE_DOM(NSEQMAX)
      INTEGER   NSEG_DOM(NSEQMAX)
      INTEGER   ICLASS_DOM(NSEQMAX)
C --
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER FILE_SEQ*(*),FILE_OUT*(*)
      CHARACTER DIR_FOR_SEQ*(*),DIR_FOR_NEW_SEQ*(*)
      CHARACTER LINE*256
      CHARACTER FILE_SCR*256,FILE_1*256,FILE_SEQ_TEMP*256
      CHARACTER CODE_GOM*8,CODE*8,DOM*1,MODE*1,HOME*1,PATH_DB*256
      CHARACTER PATH*1,EXT*1,CODE8*8
      CHARACTER DIST*1,PAIR*1
C --
      INTEGER   ICODE_STOR(NSEQMAX),N2_STOR(NSEQMAX),NN_STOR(NSEQMAX)
      INTEGER   NPAIR_STOR(NSEQMAX),INDEX_STOR(NSEQMAX)
      INTEGER   IORDER_DB(NSEQMAX),NGAP_STOR(NSEQMAX)
      INTEGER   IUSED_DOM(*)
      REAL      HID_STOR(NSEQMAX),SCORE_NEW_STOR(NSEQMAX)
      REAL      Q_STOR(NSEQMAX),Q_FIN_STOR(NSEQMAX),DRMS_STOR(NSEQMAX)
C ----
C -----------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---
C      ICHECK  = 10924
C      ICHECK1 = 3365
      ICHECK  =-1 
      ICHECK1 =-1

      PO = 0.0
      PE = 0.0
      PAIR = 'N'         
      DIST = 'N'
      ISTEP     = 0
      NSTEP     = 2
      NSTEP     = 1
      ICRD_FLAG = 0
      ICRD_FLAG1= 0

      FILE_SEQ_TEMP = FILE_SEQ
      CALL LENSTR_BL(FILE_SEQ,LEN)
      IF(FILE_SEQ(LEN-3:LEN).EQ.'.seq'.OR.
     *   FILE_SEQ(LEN-3:LEN).EQ.'.pir'    ) THEN
        FILE_SEQ_TEMP = 'sequence_for_align.sqb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ_TEMP = PATH_SCR(1:LEN)//'sequence_for_align.sqb' 
        ENDIF
        CODE8 = 'XXXX    '
        CALL PREPARE_BIN_FILE_FROM_SEQ(M,CODE8
     *           ,FILE_SEQ,FILE_SEQ_TEMP
     *           ,PATH_OUT,PATH_SCR,IERR)
        IF(IERR.NE.0) THEN
            LINE = 'ERR: in PREPARE_BIN_FILE_FROM_SEQ'
            CALL MSGERR(MDOC,LINE)
          IERR = 0
          FILE_SEQ_TEMP = FILE_SEQ
        ENDIF  
      ELSE IF(FILE_SEQ(LEN-3:LEN).EQ.'.pdb') THEN
        ICRD_FLAG = 1
        FILE_SEQ_TEMP = 'sequence_for_align.dat'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ_TEMP = PATH_SCR(1:LEN)//'sequence_for_align.dat' 
        ENDIF
        CODE8 = 'XXXX    '
        CALL PREPARE_BIN_FILE_FROM_PDB(M,CODE8
     *           ,FILE_SEQ,FILE_SEQ_TEMP
     *           ,PATH_OUT,PATH_SCR,IERR)
        IF(IERR.NE.0) THEN
            LINE = 'ERR: in PREPARE_BIN_FILE_FROM_PDB'
            CALL MSGERR(MDOC,LINE)
          IERR = 0
          FILE_SEQ_TEMP = FILE_SEQ
        ENDIF  
      ENDIF  
      N2_MAX  = 0
      NN_MAX  = 0

      Q_LIM_PRF     = 0.40
      SCORE_LIM_PRF = 0.40

  800 CONTINUE
      ISTEP = ISTEP + 1

      DRMS_LIM  = 10.0
      Q_BEST    = 0.0
      NCH_TOT   = 0
      NCH_1     = 0
      NCH_1_BAD = 0
      NLEV      = 0
      NORD      = 0
      NSIZE_BAD = 0
      NALIGN_BAD = 0
      N1_PRF     = 0
      N2_PRF     = 0

      WRITE(LINE,'(A,I4,A,I4,A)') '--- step :',ISTEP,'  (',NSTEP,' )'
      CALL MSGDOC(MDOC,LINE)

      IF(ISTEP.EQ.NSTEP) THEN
        NRES_MAX   = NRES_MAX_INPUT
        NRES_MIN   = NRES_MIN_INPUT
        FIDENT_LIM = FIDENT_LIM_INPUT
        SCORE_LIM  = SCORE_LIM_INPUT
        Q_LIM      = Q_LIM_INPUT
      ELSE
        IF(DOM.EQ.'D') THEN
          NRES_MAX   = NRES*1.2
          NRES_MIN   = NRES*0.4
          FIDENT_LIM = 30.0
          SCORE_LIM  = 0.200
          Q_LIM      = 0.400
        ELSE 
          NRES_MAX   = NRES*1.2
          NRES_MIN   = NRES*0.8
          FIDENT_LIM = 60.0
          SCORE_LIM  = 0.6
          Q_LIM      = 0.6
        ENDIF
      ENDIF

c     if(nres_max.lt.100) nres_max = 100

C      Q_LIM      = 0.130
C      SCORE_LIM  = 0.190

      WRITE(LINE,*) 'H_lev:',IHIER_LEV
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Nres max,min:',NRES_MAX,NRES_MIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Ident_lim:',FIDENT_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Score_lim:',SCORE_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Q_lim:',Q_LIM
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Score_lim_prf:',SCORE_LIM_PRF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'Q_lim_prf:',Q_LIM_PRF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'home:',HOME
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,*) 'icode_target:',ICODE_TARGET
      CALL MSGDOC(MDOC,LINE)

      SCORE_LIM  = 0.190
      WRITE(LINE,*) 'Score_lim:',SCORE_LIM
      CALL MSGDOC(MDOC,LINE)

c -- prf --

      IF(DOM.NE.'D') GO TO 610

      DO ID=1,NSEQ

c         if(id.ge.32239) go to 600

c         if(id.eq.31795) go to 600
c         if(id.eq.31796) go to 600
c         if(id.eq.31797) go to 600

        NSEG_DOM(ID) = 0

        IF(DOM.EQ.'D') THEN
          IF(ID.LE.NDOMAIN_INI) THEN
            IPRF = ITYPE_DOM(ID)
          ELSE
            IPRF =-1 
          ENDIF
        ELSE
          IPRF =-1 
        ENDIF

        if(id.eq.ICHECK.or.id.eq.ICHECK1) then
          write(*,*) '-',id,CODE_DB(ID),iprf,IORDER_DB(ID)
        endif



c        IF(ILEVEL_DB(ID).LT.IHIER_LEV.AND.IPRF.le.0) GO TO 600

c????
        IF(DOM.EQ.'D'.AND.IPRF.Le.0) GO TO 600
c?????

        NLEV  = NLEV + 1
        IF(IORDER_DB(ID).LE.0)         GO TO 600
        NORD  = NORD + 1

        NR   = NRES_DB(ID)
        CODE = CODE_DB(ID)
        IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN
          IF(IPRF.GT.0) THEN
            CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/prf_DOM/'//
     *                 CODE(1:LENCODE)//'.prf'
          ELSE
            CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
            FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            IF(HOME.EQ.'D') THEN
              CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *                 CODE(1:LENCODE)//'.dat'
            ELSE IF(HOME.EQ.'C') THEN
              CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *               CODE(1:LENCODE)//'.dat'
            ENDIF
          ENDIF

          IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
            CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
C           FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.dat'
          ENDIF

          FILE_SCR = ' '
          IPRINT   = 0
          MMM = M

         if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            mmm = mdoc
            iprint =1
          endif

          IF(DOM.EQ.'D') THEN
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *               ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF

c          CALL MAKE_ALIGN(Mmm,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
c     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)

          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            NSEG_DOM(ID)  =-1
            GO TO 600
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)

          IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
            IF(NN.GT.NRES_MAX_INPUT.OR.NN.LT.NRES_MIN_INPUT) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
              ENDIF
              IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(ISTEP.EQ.NSTEP) THEN
                IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                  IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
                ENDIF
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
              ELSE
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) =-9
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-9
              ENDIF
            ENDIF
            NALIGN_BAD = NALIGN_BAD + 1
            NSEG_DOM(ID)  =-1
            GO TO 600
          ENDIF

          IF(DOM.EQ.'D') THEN
            T = 1.0 - REAL(NN)/REAL(N2)
            T = EXP(-T*T)
          ELSE 
            T = 1.0 - REAL(NN)/REAL(N1)
            T = EXP(-T*T)
          ENDIF 

          TT = (REAL(NN-NGAP)/REAL(NN))
          Q = SCORE_NEW*TT*TT*TT*TT
          Q = Q*T

        
          if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,3I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID),iprf
            CALL MSGDOC(MDOC,LINE)
          endif

          IDRMS = 1
          IF(ICRD_FLAG1.GT.0) THEN
            IF(DRMS.GT.DRMS_LIM) IDRMS = 0
          ENDIF

c          IF(Q.GE.Q_LIM.AND.IDRMS.GT.0) THEN
          IF(Q.GE.Q_LIM_PRF.AND.IDRMS.GT.0) THEN

            NSEG_DOM(ID)  = 2
            IORDER_DB(ID) = 1
            IF(DOM.EQ.'D') IUSED_DOM(ID) = Q * 1000.0

c???
c            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
c     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
c     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
c            CALL MSGDOC(MDOC,LINE)
c???
            IF(IPRF.GT.0) THEN
              N1_PRF = N1_PRF + 1
c              Q = 0.0
            ENDIF
            NCH_1   = NCH_1 + 1
            NCH_TOT = NCH_TOT + 1
            ICODE_STOR(NCH_TOT)     = ID
            N2_STOR(NCH_TOT)        = N2
            NN_STOR(NCH_TOT)        = NN
            NPAIR_STOR(NCH_TOT)     = NPAIR
            NGAP_STOR(NCH_TOT)      = NGAP
            HID_STOR(NCH_TOT)       = HID
            SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
            Q_FIN_STOR(NCH_TOT)     = Q_FIN

            IF(N2_MAX.LT.N2) N2_MAX = N2
            IF(SCORE_NEW.GT.SCORE_LIM_PRF) THEN
              IF(NN_MAX.LT.NN) NN_MAX = NN
            ENDIF

            Q_STOR(NCH_TOT)        = Q
            IF(Q.GT.Q_BEST) Q_BEST = Q

            DRMS_STOR(NCH_TOT)      = DRMS
            INDEX_STOR(NCH_TOT)     = NCH_TOT
          ELSE
            NSEG_DOM(ID)  =-1
            NCH_1_BAD = NCH_1_BAD + 1
            IF(ISTEP.EQ.NSTEP) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IORDER_DB(ID) = 0
              ENDIF
            ELSE
              IORDER_DB(ID) =-9
            ENDIF
          ENDIF

        ELSE
          NSIZE_BAD = NSIZE_BAD + 1
          NSEG_DOM(ID)  =-1
          IF(NR.GT.NRES_MAX_INPUT.OR.NR.LT.NRES_MIN_INPUT) THEN
C            IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C            ENDIF
            IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
          ELSE
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C              ENDIF
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) =-9
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-9
            ENDIF
          ENDIF
          
        ENDIF

  600   CONTINUE

      ENDDO

      WRITE(LINE,'(A,4I6)') 
     *   'N,Nlev,Nord,Nprf:',NCH_1,NLEV,NORD,N1_PRF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,3I6)') 
     *   'Nbad,Nsize_bad,Nalign_bad:',NCH_1_BAD,NSIZE_BAD,NALIGN_BAD
      CALL MSGDOC(MDOC,LINE)

      NCH_1     = 0
      NCH_1_BAD = 0
      NLEV      = 0
      NORD      = 0
      NSIZE_BAD = 0
      NALIGN_BAD = 0
      NCH_2     = 0
      NCH_2_BAD = 0
      NCH_2_ALIGN_BAD = 0

      IF(NCH_TOT.LE.0) GO TO 610
c ////
C     IF(NCH_TOT.LE.0) GO TO 400
C ////

      GO TO 610

      IF(DOM.EQ.'D') THEN

        NNN_MAX = N2_MAX
        IF(NN_MAX.LT.NNN_MAX.AND.NN_MAX.GT.0) NNN_MAX = NN_MAX
        IF(N1.LT.NNN_MAX.AND.N1.GT.0) NNN_MAX = N1
        WRITE(LINE,'(A,4I6)') 
     *   'N1,N2_max,NN_max,NNN_max:',N1,N2_MAX,NN_MAX,NNN_MAX
        CALL MSGDOC(MDOC,LINE)

        DO ID=1,NCH_TOT
          NNN = N2_STOR(ID)
          IF(NNN.GT.NNN_MAX) NNN = NNN_MAX
          T = 1.0 - REAL(NNN)/REAL(NNN_MAX)
          IF(T.LT.0.0) T = 0.0
          T = EXP(-T*T)
          Q_STOR(ID) = Q_STOR(ID)*T
        ENDDO
      ENDIF

      CALL SORT1(Q_STOR,NCH_TOT,INDEX_STOR)

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id  code     n2  nn ngap Idnt score   Q   Drms'
      CALL MSGDOC(MDOC,LINE)

      II = 0
      DO ID=NCH_TOT,1,-1
        II   = II + 1
        IDD  = INDEX_STOR(ID)


C          if(ICODE_STOR(IDD).eq.5030) then
C        CODE = CODE_DB(ICODE_STOR(IDD))  
C          ICL = ICLASS_DOM(ICODE_STOR(IDD))
C        IPRF = ITYPE_DOM(ICODE_STOR(IDD))
C        WRITE(LINE
C     * ,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F6.3,i3,I12)')
C     *    ICODE_STOR(IDD)
C     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NGAP_STOR(IDD)
C     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(ID)
C     *    ,DRMS_STOR(IDD),iprf,ICL
C        CALL MSGDOC(MDOC,LINE)
C          endif

        NSEG_DOM(ICODE_STOR(IDD)) =-1

        if(ii.LE.50000) then

        if(ii.LE.50000) NSEG_DOM(ICODE_STOR(IDD)) = 2

        ICL = 1
        IF(DOM.EQ.'D') THEN
          ICL = ICLASS_DOM(ICODE_STOR(IDD))
        ENDIF
        CODE = CODE_DB(ICODE_STOR(IDD))  

        IPRF = ITYPE_DOM(ICODE_STOR(IDD))

        WRITE(LINE
     * ,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F6.3,i3,I12)')
     *    ICODE_STOR(IDD)
     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NGAP_STOR(IDD)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(ID)
     *    ,DRMS_STOR(IDD),iprf,ICL
        CALL MSGDOC(MDOC,LINE)

        endif

      ENDDO

  610 CONTINUE

      NCH_TOT = 0
      N2_MAX  = 0
      NN_MAX  = 0
      Q_BEST  = 0.0

c --- prf --


c ---
      DO ID=1,NSEQ

c         if(id.ge.32239) go to 100


c         if(id.eq.31795) go to 100
c         if(id.eq.31796) go to 100
c         if(id.eq.31797) go to 100

C       NSEG_DOM(ID) = 0

        IF(DOM.EQ.'D') THEN
          IF(ID.LE.NDOMAIN_INI) THEN
            IPRF = ITYPE_DOM(ID)
          ELSE
            IPRF =-1 
          ENDIF
        ELSE
          IPRF =-1 
        ENDIF

        if(id.eq.ICHECK.or.id.eq.ICHECK1) then
          write(*,*) '-',id,CODE_DB(ID),iprf,IORDER_DB(ID)
        endif



c        IF(ILEVEL_DB(ID).LT.IHIER_LEV.AND.IPRF.le.0) GO TO 100

c????
        IF(DOM.EQ.'D'.AND.IPRF.GE.0) GO TO 100
c?????

        NLEV  = NLEV + 1
        IF(IORDER_DB(ID).LE.0)         GO TO 100
        NORD  = NORD + 1

        NR   = NRES_DB(ID)
        CODE = CODE_DB(ID)
        IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN
          IF(IPRF.GT.0) THEN
            CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/prf_DOM/'//
     *                 CODE(1:LENCODE)//'.prf'
          ELSE
            CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
            FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            IF(HOME.EQ.'D') THEN
              CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *                 CODE(1:LENCODE)//'.dat'
            ELSE IF(HOME.EQ.'C') THEN
              CALL LENSTR_BL(PATH_DB,LEN)
              FILE_1 = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *               CODE(1:LENCODE)//'.dat'
            ENDIF
          ENDIF

          IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
            CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
C           FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.dat'
          ENDIF

          FILE_SCR = ' '
          IPRINT   = 0
          MMM = M

         if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            mmm = mdoc
            iprint =1
          endif

          IF(DOM.EQ.'D') THEN
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *               ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *               ,PAIR,DIST,PO,PE
     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF

c          CALL MAKE_ALIGN(Mmm,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
c     *               ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)

          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            NSEG_DOM(ID)  =-1
            GO TO 100
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)

          IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
            IF(NN.GT.NRES_MAX_INPUT.OR.NN.LT.NRES_MIN_INPUT) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
              ENDIF
              IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(ISTEP.EQ.NSTEP) THEN
                IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                  IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
                ENDIF
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-1
              ELSE
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) =-9
                IF(NN.LT.NRES_MIN) IORDER_DB(ID) =-9
              ENDIF
            ENDIF
            NALIGN_BAD = NALIGN_BAD + 1
            NSEG_DOM(ID)  =-1
            GO TO 100
          ENDIF

          IF(DOM.EQ.'D') THEN
            T = 1.0 - REAL(NN)/REAL(N2)
            T = EXP(-T*T)
          ELSE 
            T = 1.0 - REAL(NN)/REAL(N1)
            T = EXP(-T*T)
          ENDIF 

          TT = (REAL(NN-NGAP)/REAL(NN))
          Q = SCORE_NEW*TT*TT*TT*TT
          Q = Q*T

        
          if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,3I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID),iprf
            CALL MSGDOC(MDOC,LINE)
          endif

          IDRMS = 1
          IF(ICRD_FLAG.GT.0) THEN
            IF(DRMS.GT.DRMS_LIM) IDRMS = 0
          ENDIF

c          IF(Q.GE.Q_LIM.AND.IDRMS.GT.0) THEN
          IF(Q.GE.Q_LIM_PRF.AND.IDRMS.GT.0) THEN

            NSEG_DOM(ID)  = 2
            IORDER_DB(ID) = 1
            IF(DOM.EQ.'D') IUSED_DOM(ID) = Q * 1000.0

c???
c            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
c     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
c     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
c            CALL MSGDOC(MDOC,LINE)
c???
C            IF(IPRF.GT.0) THEN
C              N1_PRF = N1_PRF + 1
c              Q = 0.0
C            ENDIF

            NCH_1   = NCH_1 + 1
            NCH_TOT = NCH_TOT + 1
            ICODE_STOR(NCH_TOT)     = ID
            N2_STOR(NCH_TOT)        = N2
            NN_STOR(NCH_TOT)        = NN
            NPAIR_STOR(NCH_TOT)     = NPAIR
            NGAP_STOR(NCH_TOT)      = NGAP
            HID_STOR(NCH_TOT)       = HID
            SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
            Q_FIN_STOR(NCH_TOT)     = Q_FIN

            IF(N2_MAX.LT.N2) N2_MAX = N2
            IF(SCORE_NEW.GT.SCORE_LIM_PRF) THEN
              IF(NN_MAX.LT.NN) NN_MAX = NN
            ENDIF

            Q_STOR(NCH_TOT)        = Q
            IF(Q.GT.Q_BEST) Q_BEST = Q

            DRMS_STOR(NCH_TOT)      = DRMS
            INDEX_STOR(NCH_TOT)     = NCH_TOT
          ELSE
            NSEG_DOM(ID)  =-1
            NCH_1_BAD = NCH_1_BAD + 1
            IF(ISTEP.EQ.NSTEP) THEN
              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IORDER_DB(ID) = 0
              ENDIF
            ELSE
              IORDER_DB(ID) =-9
            ENDIF
          ENDIF

        ELSE
          NSIZE_BAD = NSIZE_BAD + 1
          NSEG_DOM(ID)  =-1
          IF(NR.GT.NRES_MAX_INPUT.OR.NR.LT.NRES_MIN_INPUT) THEN
C            IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C            ENDIF
            IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
          ELSE
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C              ENDIF
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-1
            ELSE
              IF(NR.GT.NRES_MAX) IORDER_DB(ID) =-9
              IF(NR.LT.NRES_MIN) IORDER_DB(ID) =-9
            ENDIF
          ENDIF
          
        ENDIF

  100   CONTINUE

      ENDDO

      WRITE(LINE,'(A,4I6)') 
     *   'N,Nlev,Nord,Nprf:',NCH_1,NLEV,NORD,N1_PRF
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,3I6)') 
     *   'Nbad,Nsize_bad,Nalign_bad:',NCH_1_BAD,NSIZE_BAD,NALIGN_BAD
      CALL MSGDOC(MDOC,LINE)

      NCH_2     = 0
      NCH_2_BAD = 0
      NCH_2_ALIGN_BAD = 0

      IF(NCH_1.LE.0.AND.N1_PRF.LE.0) GO TO 400
      IF(NCH_TOT.LE.0) GO TO 620

      GO TO 620

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id  code     n2  nn ngap Idnt score   Q   Drms'
      CALL MSGDOC(MDOC,LINE)

      II = 0
      DO ID=1,NCH_TOT
        II   = II + 1
        IDD  = INDEX_STOR(ID)

C        NSEG_DOM(ICODE_STOR(IDD)) =-1
C        if(ii.LE.5000) then
C        if(ii.LE.5000) NSEG_DOM(ICODE_STOR(IDD)) = 2

        ICL = 1
        IF(DOM.EQ.'D') THEN
          ICL = ICLASS_DOM(ICODE_STOR(IDD))
        ENDIF
        CODE = CODE_DB(ICODE_STOR(IDD))  

        IPRF = ITYPE_DOM(ICODE_STOR(IDD))

        WRITE(LINE
     * ,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F6.3,i3,I12)')
     *    ICODE_STOR(IDD)
     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NGAP_STOR(IDD)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(ID)
     *    ,DRMS_STOR(IDD),iprf,ICL
        CALL MSGDOC(MDOC,LINE)

C        endif

      ENDDO

  620 CONTINUE

      IF(NCH_1.LE.0.AND.N1_PRF.LE.0) GO TO 400

      N2_MAX  = 0
      NN_MAX  = 0
      Q_BEST  = 0.0

      DO ID=1,NSEQ

c         if(id.ge.32239) go to 200

c         if(id.eq.31795) go to 200
c         if(id.eq.31796) go to 200
c         if(id.eq.31797) go to 200

        IF(DOM.EQ.'D') THEN
          IF(ID.LE.NDOMAIN_INI) THEN
            IPRF = ITYPE_DOM(ID)
          ELSE
            IPRF =-1 
          ENDIF
        ELSE
          IPRF =-1 
        ENDIF

       
        if(id.eq.ICHECK.or.id.eq.ICHECK1) then
         write(*,*) '-',id,CODE_DB(ID),iprf,IORDER_DB(ID)
     *    ,NSEG_DOM(Id)
        endif

        IF(IORDER_DB(ID).LE.0)         GO TO 200
        IF(NSEG_DOM(ID).LT.0)          GO TO 200

C        IF(ILEVEL_DB(ID).GE.IHIER_LEV.AND.IPRF.LE.0) GO TO 200
C        IF(ILEVEL_DB(ID).GE.IHIER_LEV) GO TO 200
C        JPRF = 0

        JJ = ID

        IF(NSEG_DOM(JJ).eq.2) THEN
          IF(IORDER_DB(ID).GT.0) GO TO 300
          GO TO 200
        ENDIF

        IF(DOM.EQ.'D'.AND.IPRF.ne.0) GO TO 200


 310    CONTINUE
        IBCK = IBACK_DB(JJ)

        IF(MODE.EQ.'U'.AND.IBCK.EQ.ICODE_TARGET.AND.
     *       ICODE_TARGET.GT.0 ) GO TO 300

         JPRF = 0
         IF(DOM.EQ.'D') THEN
           IF(JJ.LE.NDOMAIN_INI) THEN
             JPRF = ITYPE_DOM(JJ)
           ENDIF
         ENDIF

        if(id.eq.ICHECK) then
          write(*,*) '>>',id,jj,jprf,NSEG_DOM(JJ),IORDER_DB(JJ)
        endif

        IF(NSEG_DOM(JJ).eq.2) THEN

c            write(*,*) '>>',id,jj,jprf,NSEG_DOM(JJ),IORDER_DB(JJ)
c             IF(IORDER_DB(JJ).LE.0) GO TO 200

          GO TO 300
        ENDIF
        IF(JPRF.NE.0)  GO TO 200

        IF(IBCK.GT.0) THEN
          JJ = IBCK 
          GO TO 310
        ELSE
C         IF(IORDER_DB(JJ).LE.0) GO TO 200
          GO TO 200
        ENDIF

 300    CONTINUE

       
        if(id.eq.ICHECK.or.id.eq.ICHECK1) then
          write(*,*) '=',id,CODE_DB(ID),iprf,IORDER_DB(ID)
     *    ,NSEG_DOM(Id)
        endif


        NR   = NRES_DB(ID)
        CODE = CODE_DB(ID)
        IF(NR.LE.NRES_MAX.AND.NR.GE.NRES_MIN) THEN

          CALL LENSTR_BL(DIR_FOR_SEQ,LEN)
          FILE_1 = DIR_FOR_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'

          IF(HOME.EQ.'D') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DOM/'//
     *               CODE(1:LENCODE)//'.dat'
          ELSE IF(HOME.EQ.'C') THEN
            CALL LENSTR_BL(PATH_DB,LEN)
            FILE_1 = PATH_DB(1:LEN)//'/home/ca_DB/'//
     *               CODE(1:LENCODE)//'.dat'
          ENDIF

          IF(MODE.EQ.'U'.AND.DOM.EQ.'D'.AND.ID.GT.NDOMAIN_INI) THEN
            CALL LENSTR_BL(DIR_FOR_NEW_SEQ,LEN)
c           FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.seq'
            FILE_1 = DIR_FOR_NEW_SEQ(1:LEN)//CODE(1:LENCODE)//'.dat'
          ENDIF

          FILE_SCR = ' '
          IPRINT   = 0
          MMM      = M

         
         if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            mmm = mdoc
            iprint =1
          endif

          IF(DOM.EQ.'D') THEN
            CALL MAKE_ALIGN5D(MMM,IPRINT
     *          ,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *          ,PAIR,DIST,PO,PE
     *          ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ELSE
            CALL MAKE_ALIGN5(MMM,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
     *          ,PAIR,DIST,PO,PE
     *          ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
          ENDIF
 
c          CALL MAKE_ALIGN(M,IPRINT,FILE_SEQ_TEMP,FILE_1,FILE_SCR
c     *          ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)

          IF(IERR.NE.0) THEN
            LINE = 'ERR: MAKE_ALIGN :'//CODE(1:LENCODE)//'.seq'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF
          N1  = RESULT(1) 
          N2  = RESULT(2) 
          NN  = RESULT(3) 
          NI  = RESULT(4) 
          HID = RESULT(5) 
          SUM_SCORE  = RESULT(6)
          SCORE1_MAX = RESULT(13)
          SCORE1_MIN = RESULT(14)
          Q_FIN      = RESULT(15)
          DRMS       = RESULT(16)
          NPAIR      = RESULT(17)
          SCORE_NEW  = RESULT(18)
          FID_NEW    = RESULT(19)
          NGAP       = RESULT(20)

          IF(NN.GT.NRES_MAX.OR.NN.LT.NRES_MIN) THEN
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
                IF(NN.GT.NRES_MAX) IORDER_DB(ID) = 0
C              ENDIF
            ELSE
              IF(NN.GT.NRES_MAX) IORDER_DB(ID) =-9
            ENDIF
            NCH_2_ALIGN_BAD = NCH_2_ALIGN_BAD + 1
            GO TO 200
          ENDIF

          IF(DOM.EQ.'D') THEN
            T = 1.0 - REAL(NN)/REAL(N2)
            T = EXP(-T*T)
          ELSE 
            T = 1.0 - REAL(NN)/REAL(N1)
            T = EXP(-T*T)
          ENDIF 
          TT = (REAL(NN-NGAP)/REAL(NN))
          Q  = SCORE_NEW*TT*TT*TT*TT
          Q  = Q*T

         
          if(id.eq.ICHECK.or.id.eq.ICHECK1) then
            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q,DRMS
     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
            CALL MSGDOC(MDOC,LINE)
          endif

          IDRMS = 1
          IF(ICRD_FLAG.GT.0) THEN
            IF(DRMS.GT.DRMS_LIM) IDRMS = 0
          ENDIF

          IF(Q.GE.Q_LIM.AND.IDRMS.GT.0) THEN
            IORDER_DB(ID) = 1
            IF(DOM.EQ.'D') IUSED_DOM(ID) = Q * 1000.0
            IF(JJ.GT.0) THEN
              IORDER_DB(ID) = JJ  
            ENDIF

c            WRITE(LINE,'(I5,1X,A8,4I4,1X,F5.1,2F6.3,F6.2,2I6)')
c     *      ID,CODE,N1,N2,NN,NPAIR,HID,SCORE_NEW,Q_FIN,DRMS
c     *      ,ILEVEL_DB(ID),IORDER_DB(ID)
c            CALL MSGDOC(MDOC,LINE)

            IF(JPRF.GT.0) N2_PRF = N2_PRF + 1
            NCH_TOT = NCH_TOT + 1
            NCH_2 = NCH_2 + 1
            ICODE_STOR(NCH_TOT)     = ID
            N2_STOR(NCH_TOT)        = N2
            NN_STOR(NCH_TOT)        = NN
            NPAIR_STOR(NCH_TOT)     = NPAIR
            NGAP_STOR(NCH_TOT)      = NGAP
            HID_STOR(NCH_TOT)       = HID
            SCORE_NEW_STOR(NCH_TOT) = SCORE_NEW
            Q_FIN_STOR(NCH_TOT)     = Q_FIN
            IF(N2_MAX.LT.N2) N2_MAX = N2
            Q_STOR(NCH_TOT)         = Q
            IF(Q.GT.Q_BEST)  Q_BEST = Q
            DRMS_STOR(NCH_TOT)      = DRMS
            INDEX_STOR(NCH_TOT)     = NCH_TOT

            IF(N2_MAX.LT.N2) N2_MAX = N2
            IF(SCORE_NEW.GT.SCORE_LIM) THEN
              IF(NN_MAX.LT.NN) NN_MAX = NN
            ENDIF

          ELSE
            NCH_2_BAD = NCH_2_BAD + 1
            IF(ISTEP.EQ.NSTEP) THEN
C              IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
              IORDER_DB(ID) = 0
C              ENDIF   
            ELSE
              IORDER_DB(ID) =-9
            ENDIF
          ENDIF
        ELSE
          IF(ISTEP.EQ.NSTEP) THEN
C            IF(DOM.NE.'D'.OR.NRUN.EQ.1) THEN
            IF(NR.GT.NRES_MAX) IORDER_DB(ID) = 0
C            ENDIF
          ELSE
            IF(NR.GT.NRES_MAX) IORDER_DB(ID) =-9
          ENDIF
        ENDIF

  200   CONTINUE

      ENDDO

      WRITE(LINE,'(A,4I6)') 
     *   'N2,N2_bad,N2_align_bad,N2prf:'
     *   ,NCH_2,NCH_2_BAD,NCH_2_ALIGN_BAD,N2_PRF
      CALL MSGDOC(MDOC,LINE)

  400 CONTINUE

      WRITE(LINE,*) 'N_TOT :',NCH_TOT
      CALL MSGDOC(MDOC,LINE)

      IF(ISTEP.NE.NSTEP) THEN
        DO ID=1,NSEQ
          IF(IORDER_DB(ID).EQ.-9) IORDER_DB(ID) = 1
        ENDDO
        IF(NCH_TOT.GT.0.AND.Q_BEST.GE.Q_LIM) GO TO 810
        GO TO 800
      ENDIF

  810 CONTINUE

      IF(NCH_TOT.LE.0) GO TO 900

      IF(DOM.EQ.'D') THEN

        NNN_MAX = N2_MAX
        IF(NN_MAX.LT.NNN_MAX.AND.NN_MAX.GT.0) NNN_MAX = NN_MAX
        IF(N1.LT.NNN_MAX.AND.N1.GT.0) NNN_MAX = N1
        WRITE(LINE,'(A,4I6)') 
     *   'N1,N2_max,NN_max,NNN_max:',N1,N2_MAX,NN_MAX,NNN_MAX
        CALL MSGDOC(MDOC,LINE)

        DO ID=1,NCH_TOT
          NNN = N2_STOR(ID)
          IF(NNN.GT.NNN_MAX) NNN = NNN_MAX
          T = 1.0 - REAL(NNN)/REAL(NNN_MAX)
          IF(T.LT.0.0) T = 0.0
          T = EXP(-T*T)
          Q_STOR(ID) = Q_STOR(ID)*T
        ENDDO
      ENDIF

      CALL SORT1(Q_STOR,NCH_TOT,INDEX_STOR)

      CALL MSGDOC(MDOC,' ')
      LINE = '   Id  code     n2  nn ngap Idnt score   Q   Drms'
      CALL MSGDOC(MDOC,LINE)

      II = 0
      DO ID=NCH_TOT,1,-1
        II   = II + 1

        if(ii.gt.100) go to 900

        IDD  = INDEX_STOR(ID)
        ICL = 1
        IF(DOM.EQ.'D') THEN
          ICL = ICLASS_DOM(ICODE_STOR(IDD))
        ENDIF
        CODE = CODE_DB(ICODE_STOR(IDD))  

        IPRF = ITYPE_DOM(ICODE_STOR(IDD))

        WRITE(LINE
     * ,'(I5,1X,A8,3I4,1X,F5.1,2F6.3,1X,F6.3,I3,i12,I10)')
     *    ICODE_STOR(IDD)
     *    ,CODE,N2_STOR(IDD),NN_STOR(IDD),NGAP_STOR(IDD)
     *    ,HID_STOR(IDD),SCORE_NEW_STOR(IDD),Q_STOR(ID)
     *    ,DRMS_STOR(IDD),IPRF,icl,IORDER_DB(IDD)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

  900 CONTINUE

      RETURN
      END

