      SUBROUTINE GET_STRUCTURE_DB(MDOC,VERSION
     * ,NAME_SEQ,NAME_TEMP_LIST,NAME_PDB,NAME_MX
     * ,NAME_DIR,NAME_LIST
     * ,NSEQ_MAX,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL
     * ,CELL,SPACE_GROUP 
     * ,PATH_OUT,PATH_SCR,RESULT,IPRROW,IERR)
C ------------------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      CELL(*)
      CHARACTER NAME_PDB*(*),PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER NAME_TEMP_LIST*(*),NAME_SEQ*(*),NAME_MX*(*)
      CHARACTER SPACE_GROUP*(*),VERSION*(*)
      CHARACTER NAME_DIR*(*),NAME_LIST*(*)
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
      CHARACTER CHAIN_INP*1
      CHARACTER CODE_PDB*4,DATE_PDB*9
      REAL      CELL_PDB(6)
c ----
      integer,   allocatable :: ID_DOM_BASE(:)
      integer,   allocatable :: NRES_DOM_BASE(:)
      integer,   allocatable :: ITYPE_DOM_BASE(:)
      integer,   allocatable :: NSEG_DOM_BASE(:)
      integer,   allocatable :: ILEVEL_DOM_BASE(:)
      integer,   allocatable :: IBACK_DOM_BASE(:)
      integer,   allocatable :: IFORW_DOM_BASE(:)
      integer,   allocatable :: ICLASS_DOM_BASE(:)
      real,      allocatable :: FBACK_DOM_BASE(:)
      real,      allocatable :: SCORE_DOM_BASE(:) 
      real,      allocatable :: RAD_DOM_BASE(:)
      real,      allocatable :: RCBYR_DOM_BASE(:)
      real,      allocatable :: RINBYR_DOM_BASE(:)
      real,      allocatable :: PH_DOM_BASE(:)
      real,      allocatable :: PB_DOM_BASE(:)
      real,      allocatable :: RSBYR_DOM_BASE(:)
      character(LEN=8), allocatable :: CODE_DOM_BASE(:)
      character(LEN=512), allocatable :: LINE_DOM_BASE(:)
c ----
      INTEGER*4 MDOC,IERR
      CHARACTER MESSAGE*80,JOB*80
      CHARACTER CODE4*4,FILE_OUT*256,FILE_SCR*256 
      CHARACTER LINE*256,FILE_LIST_DB*256,PATH_DB*256
      CHARACTER PATH*1,EXT*3,PDB*1,SEQ*1,LIST*1
C==================================================================
      IERR = 0
      MD   = -ABS(MDOC)-1
      M    = 99
C ---------------------------------
      JOB  = 'get_structure_DB'
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        LINE = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        LINE = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 71
      CALL OPENFW(IOUT,M,PATH,LINE,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        MESSAGE = 'cannot open output XML file'
        IERR = 9
        RETURN
      ENDIF
      CLOSE(IOUT)
C ---------------------------------
      N_STR     = 0
      N1_SEQ    = 0
      NA1_SEQ   = 0
      NRES_SUM  = 0
      NATOM_SUM = 0
      CALL CORR_NAME_BL(NAME_MX)
      CALL LENSTR_BL(NAME_MX,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)') 
     *  '==file_fixed_model:',NAME_MX(1:L)
        CALL MSGDOC(MDOC,LINE)
        CHAIN_INP = ' '
        FILE_SCR = 'sequence_input.seq'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SCR = PATH_SCR(1:LEN)//'sequence_input.seq'
        ENDIF
        CALL PDB2SEQ(M,NAME_MX,FILE_SCR
     *   ,CODE_PDB,DATE_PDB
     *   ,RESOL,RFAC,IMODEL,CELL_PDB,CHAIN_INP
     *   ,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERROR: problem to read fixed model'
          CALL MSGERR(MDOC,LINE)
          MESSAGE = 'problem to read fixed model'
          GO TO 600
        ENDIF
        CALL CALC_NAA_NATOM_IN_SEQUENCE(M,FILE_SCR
     *       ,NRES_SUM,NATOM_SUM,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERROR: problem to read fixed model seq'
          CALL MSGERR(MDOC,LINE)
          MESSAGE = 'problem to read fixed model seq'
          GO TO 600
        ENDIF
      ENDIF
C ----
      SEQ  = 'N'
      LIST = 'N'
      CALL CORR_NAME_BL(NAME_TEMP_LIST)
      CALL LENSTR_BL(NAME_TEMP_LIST,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)') '==file_seq_list:',NAME_TEMP_LIST(1:L)
        CALL MSGDOC(MDOC,LINE)
        MT   = 10
        OPEN(MT,FILE=NAME_TEMP_LIST(1:LEN)
     *    ,ACCESS='SEQUENTIAL',ERR=520,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
        LIST = 'Y'
      ENDIF
      CALL CORR_NAME_BL(NAME_SEQ)
      CALL LENSTR_BL(NAME_SEQ,LEN)
      IF(LEN.GT.0) THEN
        MT   = 10
        OPEN(MT,FILE=NAME_SEQ(1:LEN),ACCESS='SEQUENTIAL',ERR=510,
     *    FORM='FORMATTED',STATUS='OLD')
        CLOSE(MT)   
        IF(LEN.GT.60) LEN=60
        WRITE(LINE,'(A,A)')    '==file_seq:',NAME_SEQ(1:LEN)
        CALL MSGDOC(MDOC,LINE)
        SEQ = 'Y'
      ENDIF
      CALL CORR_NAME_BL(NAME_LIST)
      CALL LENSTR_BL(NAME_LIST,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)') '==file_user_list:',NAME_LIST(1:L)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      CALL CORR_NAME_BL(NAME_DIR)
      CALL LENSTR_BL(NAME_DIR,LEN)
      IF(LEN.GT.0) THEN
        L = LEN
        IF(LEN.GT.60) L=60
        WRITE(LINE,'(A,A)') '==file_user_dir:',NAME_DIR(1:L)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C       read seq
      IF(SEQ.EQ.'Y') THEN       
        ND_STRING   = 0
        CALL CALC_NAA_NATOM_IN_SEQUENCE(M,NAME_SEQ
     *       ,N1_SEQ,NA1_SEQ,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERROR: read sequence file')
          IERR = 2
          GO TO 500
        ENDIF
        WRITE(LINE,*) 'N1_seq,NA1_SEQ:',N1_SEQ,NA1_SEQ
        CALL MSGDOC(MDOC,LINE)
        IF(N1_SEQ.LE.0.OR.NA1_SEQ.LE.0) THEN
          IERR = 2
          GO TO 500
        ENDIF

      ENDIF
C ---
      PDB = 'N'
      CALL CORR_NAME_BL(NAME_PDB)
      CALL LENSTR_BL(NAME_PDB,LEN)
      IF(LEN.GT.0) THEN
        IF(LEN.GT.60) LEN=60
        WRITE(LINE,'(A,A)') '==file_PDB:',NAME_PDB(1:LEN)
        CALL MSGDOC(MDOC,LINE)
        PDB = 'Y'
      ENDIF
C ---
      IF(PDB.EQ.'N'.AND.(SEQ.EQ.'N'.OR.LIST.EQ.'N')) THEN
        CALL MSGDOC(MDOC,
     *  ' ERROR: there is not sequence or_chain_list file')
        IERR = 7
        GO TO 500
      ENDIF
      IF(PDB.EQ.'Y'.AND.LIST.EQ.'Y') THEN
        CALL MSGDOC(MDOC,
     *  ' ERROR: there are pdb_file and chain_list ?')
        IERR = 9
        GO TO 500
      ENDIF

      WRITE(LINE,'(A,I8)')   '==nseq_max:',NSEQ_MAX 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I8)')   '==nsym    :',NSYM 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==volume  :',VOLUME
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==resmax  :',RESMAX
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==resmin  :',RESMIN
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==opt_res :',OPT_RESOL
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,F10.2)')'==boverall:',BOVERALL
      CALL MSGDOC(MDOC,LINE)
      IF(CELL(1).GT.0.0001) THEN
        WRITE(LINE,'(A,6F8.2)')'==cell    :',(CELL(I),I=1,6)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      CALL LENSTR_BL(SPACE_GROUP,LEN)
      IF(LEN.GT.0) THEN
        WRITE(LINE,'(A,A)')    '==sp_gr   :',SPACE_GROUP(1:LEN)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
c      N1_SEQ = 0
C ---------------------------------  
      IF(PDB.EQ.'N') THEN
        CALL MSGDOC(MDOC,' --- ')
        CALL MSGDOC(MDOC,' --- Get structures from DB ---')
        CALL MSGDOC(MDOC,' --- ')      
C --    alloc
        CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: setenv MOLREP_DB'      
          CALL MSGERR(MD,LINE)
          LINE = '     Example: "setenv MOLREP_DB ~alexei/molrep_DB" '      
          CALL MSGERR(MD,LINE)
          MESSAGE = 'problem with DB'
          GO TO 600
        ENDIF

        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_LIST_DB = PATH_DB(1:LEN)//'/list/domain_descr_list.txt'

        CALL CHECK_MEMORY_FOR_LIST(MDOC,FILE_LIST_DB,NDOMMAX,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC
     *    ,'ERROR: in CHECK_MEMORY_FOR_LIST')
          MESSAGE = 'problem with DB'
          GO TO 600
        ENDIF

        WRITE(LINE,*) 'MEMORY for N_domain_db:',NDOMMAX
        CALL MSGDOC(MDOC,LINE)
        IF(NDOMMAX.LE.0) THEN
          IERR = 1
          MESSAGE = 'problem with DB'
          GO TO 600
        ENDIF

C
c       list/domain_descr_list.txt
C    

C       allocation        

        allocate(ID_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(NRES_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(ITYPE_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(NSEG_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(ILEVEL_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(IFORW_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(IBACK_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(ICLASS_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(FBACK_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(SCORE_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(RAD_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(RCBYR_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(RINBYR_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(PH_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(PB_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(RSBYR_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(CODE_DOM_BASE(1:NDOMMAX),STAT=ISTAT)
        allocate(LINE_DOM_BASE(1:3),STAT=ISTAT)
        NDOMAIN_BASE  = NDOMMAX

        CALL READ_DOM_DESCR_LIST(MDOC,FILE_LIST_DB,NDOM_BASE
     *   ,ID_DOM_BASE,CODE_DOM_BASE,NRES_DOM_BASE
     *   ,ITYPE_DOM_BASE,NSEG_DOM_BASE
     *   ,ILEVEL_DOM_BASE,IFORW_DOM_BASE,IBACK_DOM_BASE
     *   ,FBACK_DOM_BASE,SCORE_DOM_BASE
     *   ,RAD_DOM_BASE,RCBYR_DOM_BASE
     *   ,RINBYR_DOM_BASE,PH_DOM_BASE,PB_DOM_BASE
     *   ,RSBYR_DOM_BASE,ICLASS_DOM_BASE  
     *   ,LINE_DOM_BASE,NDOMAIN_BASE,IERR)
        IF(IERR.NE.0) THEN
          deallocate(ID_DOM_BASE,STAT=ISTAT)
          deallocate(NRES_DOM_BASE,STAT=ISTAT)
          deallocate(ITYPE_DOM_BASE,STAT=ISTAT)
          deallocate(NSEG_DOM_BASE,STAT=ISTAT)
          deallocate(ILEVEL_DOM_BASE,STAT=ISTAT)
          deallocate(IFORW_DOM_BASE,STAT=ISTAT)
          deallocate(IBACK_DOM_BASE,STAT=ISTAT)
          deallocate(ICLASS_DOM_BASE,STAT=ISTAT)
          deallocate(FBACK_DOM_BASE,STAT=ISTAT)
          deallocate(SCORE_DOM_BASE,STAT=ISTAT)
          deallocate(RAD_DOM_BASE,STAT=ISTAT)
          deallocate(RCBYR_DOM_BASE,STAT=ISTAT)
          deallocate(RINBYR_DOM_BASE,STAT=ISTAT)
          deallocate(PH_DOM_BASE,STAT=ISTAT)
          deallocate(PB_DOM_BASE,STAT=ISTAT)
          deallocate(RSBYR_DOM_BASE,STAT=ISTAT)
          deallocate(CODE_DOM_BASE,STAT=ISTAT)
          deallocate(LINE_DOM_BASE,STAT=ISTAT)
          MESSAGE = 'problem with DB'
          CALL MSGERR(MDOC,'ERROR: problem with DB')
          GO TO 600
        ENDIF
C -- 
        CALL GET_STRUCTURE_DB_RUN(MDOC,NAME_SEQ,NAME_TEMP_LIST
     *   ,NAME_PDB,PDB,SEQ,LIST,JOB,NRES_SUM,NATOM_SUM
     *   ,NAME_DIR,NAME_LIST
     *   ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *   ,SPACE_GROUP,NSEQ_MAX,N1_SEQ,NA1_SEQ,N_STR
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,VERSION,IERR)

        CALL MSGDOC(MDOC,' -- OK --')

c -- dealloc
        deallocate(ID_DOM_BASE,STAT=ISTAT)
        deallocate(NRES_DOM_BASE,STAT=ISTAT)
        deallocate(ITYPE_DOM_BASE,STAT=ISTAT)
        deallocate(NSEG_DOM_BASE,STAT=ISTAT)
        deallocate(ILEVEL_DOM_BASE,STAT=ISTAT)
        deallocate(IFORW_DOM_BASE,STAT=ISTAT)
        deallocate(IBACK_DOM_BASE,STAT=ISTAT)
        deallocate(ICLASS_DOM_BASE,STAT=ISTAT)
        deallocate(FBACK_DOM_BASE,STAT=ISTAT)
        deallocate(SCORE_DOM_BASE,STAT=ISTAT)
        deallocate(RAD_DOM_BASE,STAT=ISTAT)
        deallocate(RCBYR_DOM_BASE,STAT=ISTAT)
        deallocate(RINBYR_DOM_BASE,STAT=ISTAT)
        deallocate(PH_DOM_BASE,STAT=ISTAT)
        deallocate(PB_DOM_BASE,STAT=ISTAT)
        deallocate(RSBYR_DOM_BASE,STAT=ISTAT)
        deallocate(CODE_DOM_BASE,STAT=ISTAT)
        deallocate(LINE_DOM_BASE,STAT=ISTAT)
c --
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,' =-=-=-= ')
          CLOSE(IOUT)
        ENDIF
      ELSE
        CALL MSGDOC(MDOC,' --- ')
        CALL MSGDOC(MDOC,' --- Get structures from PDB ---')
        CALL MSGDOC(MDOC,' --- ')      
        CALL GET_STRUCTURE_DB_PDB_RUN(MDOC,NAME_SEQ,NAME_TEMP_LIST
     *   ,NAME_PDB,PDB,SEQ,LIST,JOB,NRES_SUM,NATOM_SUM
     *   ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *   ,SPACE_GROUP,NSEQ_MAX,N1_SEQ,NA1_SEQ,N_STR
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,VERSION,IERR)
        IF(IERR.NE.0) THEN
          CLOSE(IOUT)
          GO TO 500
        ENDIF
      ENDIF
      IF(N_STR.LE.0) THEN
        IERR = 8
        GO TO 500
      ENDIF
      IF(IERR.NE.0) GO TO 500
C ---------------------------------
      RETURN
 510  CONTINUE
      CALL MSGDOC(MDOC,' ERROR: open intput sequence file')
      IERR = 2
      GO TO 500
 520  CONTINUE
      CALL MSGDOC(MDOC,' ERROR: open intput temp_chain_list')
      IERR = 6
 500  CONTINUE
      MESSAGE = 'null'
      IF(IERR.EQ.1) THEN
c        MESSAGE = 'no memory for alignement'
      ELSE IF(IERR.EQ.2) THEN
        MESSAGE = 'input sequence file : open/read'
      ELSE IF(IERR.EQ.3) THEN
        MESSAGE = 'chain_list_DB: open/read'
      ELSE IF(IERR.EQ.4) THEN
        MESSAGE = 'wrong setenv MOLREP_DB'
      ELSE IF(IERR.EQ.5) THEN
        MESSAGE = 'no PDB structure was found'
      ELSE IF(IERR.EQ.6) THEN
        MESSAGE = 'intput file-temp_chain_list.txt: open/read'
      ELSE IF(IERR.EQ.7) THEN
        MESSAGE = 'there is not sequence or_chain_list file'
      ELSE IF(IERR.EQ.8) THEN
        MESSAGE = 'no structure was found'
      ELSE IF(IERR.EQ.9) THEN
        MESSAGE = 'there are pdb_file and chain_list ?'
      ELSE IF(IERR.EQ.11) THEN
        MESSAGE = 'can not unpack XYZ file'
      ELSE IF(IERR.EQ.21) THEN
        MESSAGE = 'users PDB structure is big for this cell'
      ENDIF
C --
 600  CONTINUE
      CALL WRITE_ERROR_XML(MDOC,IERR,MESSAGE,JOB,VERSION,PATH_OUT,JERR)
C      IERR = JERR
      RETURN
      END

      SUBROUTINE GET_STRUCTURE_DB_RUN(MDOC,NAME_SEQ,FILE_1
     *   ,NAME_PDB,PDB,SEQ,LIST,JOB,NRES_SUM,NATOM_SUM
     *   ,NAME_DIR,NAME_LIST
     *   ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *   ,SPACE_GROUP,NSEQ_MAX,N1_SEQ,NA1_SEQ,N_STR
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,VERSION,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*),PDB*1,SEQ*1,LIST*1,JOB*(*)
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,VERSION*(*)
      CHARACTER FILE_1*(*),NAME_PDB*(*),NAME_SEQ*(*),FILE_2*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1
      CHARACTER NAME_DIR*(*),NAME_LIST*(*)
C ---
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C ---
      PARAMETER ( NSEQ_MAX_PARAM = 100 )
      INTEGER   IORDER(NSEQ_MAX_PARAM)
      INTEGER   NAA_DB(NSEQ_MAX_PARAM),NAT_DB(NSEQ_MAX_PARAM)
      INTEGER   NRES_DB(NSEQ_MAX_PARAM),ID_DB(NSEQ_MAX_PARAM)
      INTEGER   IFLAG_MULT(NSEQ_MAX_PARAM),IFLAG_DOM(NSEQ_MAX_PARAM)
      REAL      SCORE(NSEQ_MAX_PARAM),FIDENT_DB(NSEQ_MAX_PARAM)
      REAL      RESOL_DB(NSEQ_MAX_PARAM),SCR_DB(NSEQ_MAX_PARAM)
      REAL      Q_DB(NSEQ_MAX_PARAM)
      CHARACTER CODE_DB(NSEQ_MAX_PARAM)*8
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C ---
      CHARACTER CODE_RES*8,FILE_RES*256         
      PARAMETER ( NCHAINMAX = 100 )
      CHARACTER CODE_CHAIN(NCHAINMAX)*8
      CHARACTER FILE_CHAIN(NCHAINMAX)*256
      INTEGER   NRES_CHAIN(NCHAINMAX)
      INTEGER   NATOM_CHAIN(NCHAINMAX)
      INTEGER   ISEQUENCE_CHAIN(NCHAINMAX)
      REAL      FIDENT_CHAIN(NCHAINMAX)
C ---
      CHARACTER CODE*5,CODE1*5,CODE4*4,CHAIN*1
      CHARACTER FILE_TEMP_SEQ*256
      CHARACTER FRMT1*256,FRMT2*256      
      CHARACTER LETT*50
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT1 = '(I6,1X,A8,1X,F6.1,1X,F6.3,1X,F6.3'//
     *        ',1X,I6,1X,I6,1X,I6,1X,F6.2,1X,I5,1X,I5)'
      COEF_NR_TO_VOL   = 166.2
      COEF_NA_TO_VOL   = 20.63
C --------------------------------------------------
      NLETT = 50
      LETT  = 'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'
C -------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
C ---
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 71
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file:'//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD, LINE)
        IERR = 10
        GO TO 900
      ENDIF
C ---
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'error <err_level>         0 </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'message <err_message> normal termination </err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      CALL LENSTR_BL(VERSION,LEN)
      LINE = 'vers <vers>'//VERSION(1:LEN)//'</vers>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 
C ------------------------
      ISEQ = 0
      FILE_TEMP_SEQ = ' '
      CALL GET_SEQUENCE(MDOC,ISEQ,NAME_SEQ,FILE_TEMP_SEQ,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
        GO TO 900
      ENDIF
      NSEQUENCE = ISEQ
      WRITE(LINE,'(A,I5)') 'N_input_sequences :',NSEQUENCE
      CALL MSGDOC(MDOC,LINE)
      IF(NSEQUENCE.LE.0) THEN
        CALL MSGDOC(MDOC,'ERROR: N_input_sequences = 0')
        GO TO 900
      ENDIF
C ------
c     read temp_chain_list.txt
C
      CALL LENSTR_BL(FILE_1,LEN)
      IF(LEN.LE.0) GO TO 930
      MT   = 72
      OPEN(MT,FILE=FILE_1(1:LEN)
     *    ,ACCESS='SEQUENTIAL',ERR=930,
     *    FORM='FORMATTED',STATUS='OLD')
c ------
      NSEQ_READ = 0        
c
c    read Nsequence,type,nres
c
      FIDENT_COMPLEX = 100.0
      NCHAIN   = 0
      NDOM     = 0
      NDSTRING = 0
  160 CONTINUE
      READ(MT,'(A)',ERR=920,END=170) LINE
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.0)           GO TO 160
      IF(LINE(1:1).EQ.'#')   GO TO 160 
      IF(LINE(1:8).EQ.'Sequence') THEN
CSequence :    1 PROTEIN     317
C123456789 12345123456789 123456
        READ(LINE,'(10X,I5,10X,I6,I8)') ISEQUENCE,NRES_TOT,NATOM_TOT
        NRES_SUM  = NRES_SUM + NRES_TOT
        NATOM_SUM = NATOM_SUM + NATOM_TOT
        NSEQ_READ = NSEQ_READ + 1     
      ENDIF
      GO TO 160
  170 CONTINUE
      CLOSE(MT)
      CALL LENSTR_BL(FILE_1,LEN)
      IF(LEN.LE.0) GO TO 930
      MT   = 72
      OPEN(MT,FILE=FILE_1(1:LEN)
     *    ,ACCESS='SEQUENTIAL',ERR=930,
     *    FORM='FORMATTED',STATUS='OLD')
C ==============================================
  150 CONTINUE
      NSEQ = 0
  100 CONTINUE
      READ(MT,'(A)',ERR=920,END=140) LINE
      IF(LINE(1:1).EQ.'#')   GO TO 100 
      IF(LINE(1:3).EQ.'END') THEN
        GO TO 110 
      ENDIF
      IF(LINE(1:8).EQ.'Sequence') THEN

CSequence :    1 PROTEIN     317
C123456789 12345123456789 123456

        READ(LINE,'(10X,I5,10X,I6,I8)') ISEQUENCE,NRES_TOT,NATOM_TOT
        GO TO 100 
      ELSE IF(LINE(1:8).EQ.'N_struct') THEN
        READ(LINE,'(10X,I5)') N_LINES
        IF(N_LINES.GT.0) THEN
          DO NSEQ=1,N_LINES
  130       CONTINUE
            READ(MT,'(A)',ERR=920,END=110) LINE
            IF(LINE(1:1).EQ.'#') GO TO 130 
            READ(LINE,FRMT1,ERR=920)
     *         ID_DB(NSEQ),CODE_DB(NSEQ),FIDENT_DB(NSEQ),SCR_DB(NSEQ)
     *        ,Q_DB(NSEQ),NAA_DB(NSEQ),NRES_DB(NSEQ),NAT_DB(NSEQ)
     *        ,RESOL_DB(NSEQ),IFLAG_DOM(NSEQ),IFLAG_MULT(NSEQ)
          ENDDO
          NSEQ = N_LINES
        ENDIF
      ELSE IF(LINE(1:8).EQ.'N_domain') THEN
        READ(LINE,'(10X,2I5)') NDOM,ND_STRING
        IF(ND_STRING.GT.0) THEN
          DO I=1,ND_STRING
  120       CONTINUE
            READ(MT,'(A)',ERR=920,END=110) LINE
            IF(LINE(1:1).EQ.'#') GO TO 120 
            READ(LINE,
     * '(I5,1X,I5,2X,A6,1X,A6,2X,A8,1X,F5.1,1X,F5.3,1X,F6.3)')
     *         IDOMDOM(I),IDOMSEG(I)
     *         ,PNUM1_DM(I),PNUM2_DM(I),CODE_HOMOL_DM(I)
     *         ,FIDENT_DM(I),SCORE_DM(I),Q_DM(I)
          ENDDO
        ENDIF
      ENDIF
      GO TO 100
  110 CONTINUE

      IF(NSEQ.LE.0.AND.ND_STRING.LE.0) THEN
        IERR = 6
        GO TO 900
      ENDIF
C ---
      IF(NSEQ.GT.0) THEN        
        CALL MSGDOC(MDOC,' ------')
        DO I=1,NSEQ
          WRITE(LINE,
     *'(I6,1X,A,1X,I6,1X,F6.2,1X,I6,1X,I6,1X,F6.1,1X,F6.3,1X,F6.3,2I5)'
     *    ,ERR=910) 
     *     ID_DB(I),CODE_DB(I),NAA_DB(I),RESOL_DB(I),NAT_DB(I)
     *     ,NRES_DB(I),FIDENT_DB(I),SCR_DB(I),Q_DB(I)
     *     ,IFLAG_DOM(I),IFLAG_MULT(I)          
          CALL MSGDOC(MDOC,LINE)
          IORDER(I) = I
        ENDDO
        CALL MSGDOC(MDOC,' ------')
      ENDIF
C ---
      NSEQ_LIST = NSEQ 
      IF(NSEQ_MAX.GT.0.AND.NSEQ.GT.NSEQ_MAX) NSEQ = NSEQ_MAX
C ---
      IF(NSEQUENCE.EQ.1) THEN
        FILE_TEMP_SEQ = NAME_SEQ
      ELSE
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_TEMP_SEQ = PATH_SCR(1:LEN)//'temp_sequence.seq'
        ELSE
          FILE_TEMP_SEQ = 'temp_sequence.seq'
        ENDIF
        CALL GET_SEQUENCE(MDOC,ISEQUENCE,NAME_SEQ,FILE_TEMP_SEQ,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
          GO TO 900
        ENDIF
      ENDIF

      WRITE(IOUT,'(A)',ERR=910) '<sequence>' 
      WRITE(LINE,'(A,I6,A)',ERR=910) 
     * 'nres_seq <nres_seq> ',NRES_TOT,' </nres_seq>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 
    
      CHAIN = 'A'
      IF(ISEQUENCE.GT.0.AND.ISEQUENCE.LE.NLETT) THEN
        CHAIN = LETT(ISEQUENCE:ISEQUENCE)
      ENDIF

      N = NSEQ 

      IF(ND_STRING.GT.0) THEN
        Q_LIM   = 0.14
        NDOM    = IDOMDOM(1)
        ND      = 0
        ND_DIFF = 0
        ID_DOM  = 0
        DO IDOM=1,NDOM
          DO II=1,ND_STRING
            IT = IDOMSEG(II)/100
            IF(IT.EQ.IDOM) THEN
              IF(Q_DM(II).GE.Q_LIM) THEN
                ND = ND + 1
                IF(ID_DOM.LE.0) THEN
                  ID_DOM = II
                ELSE
                  IF(CODE_HOMOL_DM(II)(1:5).NE.
     *               CODE_HOMOL_DM(ID_DOM)(1:5)) ND_DIFF = 1 
                ENDIF
              ELSE
                WRITE(LINE,'(A,A,A,F6.3,A)') 
     *           'WARNING: MULTI-DOMAINS: domains ',CODE_HOMOL_DM(II),
     *           ' will not be used (Q <',Q_LIM,')'
                CALL MSGDOC(MDOC,LINE)
              ENDIF
              GO TO 111
            ENDIF
          ENDDO      
  111     CONTINUE
        ENDDO

        IF(ND.GT.0.AND.ND_DIFF.EQ.0) THEN
          IF(NSEQ.GT.0) THEN
            DO J=1,NSEQ
              I = IORDER(J)
              IF(CODE_DB(I)(1:5).EQ.CODE_HOMOL_DM(ID_DOM)(1:5)) THEN
                ND_STRING = 0
                WRITE(LINE,'(A,A)') 
     *  'WARNING: MULTI-DOMAINS: this domain will be used before: '
     *          ,CODE_HOMOL_DM(ID_DOM)
                CALL MSGDOC(MDOC,LINE)
                GO TO 112
              ENDIF
            ENDDO
          ENDIF
        ELSE IF(ND.LE.0) THEN
          ND_STRING = 0
        ENDIF
  112   CONTINUE

        IF(ND_STRING.GT.0) THEN
          NRES_DOM = 0
          DO II=1,ND_STRING
            IF(Q_DM(II).GE.Q_LIM) THEN
              READ(PNUM1_DM(II)(2:5),'(I4)') IRES1
              READ(PNUM2_DM(II)(2:5),'(I4)') IRES2
              NRES_DOM = NRES_DOM + (IRES2-IRES1) + 1
            ENDIF
          ENDDO
          NATOM_DOM = (REAL(NRES_DOM)*COEF_NR_TO_VOL)/COEF_NA_TO_VOL
          T = REAL(NATOM_DOM)/REAL(NATOM_TOT)
          IF(T.LT.0.33) THEN
            LINE = 'WARNING: MULTI-DOMAINS is small, will not be used'
            CALL MSGDOC(MDOC,LINE)
            ND_STRING = 0
          ENDIF
        ENDIF
 
      ENDIF

      IF(ND_STRING.GT.0) N = N + 1

      WRITE(LINE,'(A,I6,A)',ERR=910) 
     * 'n_structure <n_structure> ',N,' </n_structure>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      N_STR = 0
      IF(NSEQ.GT.0) THEN
        CALL MSGDOC(MDOC,' -- monomers start ----')
        DO J=1,NSEQ
          I = IORDER(J) 
          IF(J.EQ.1) FIDENT_FIRST = FIDENT_DB(I) 
          IF(FIDENT_COMPLEX.GT.FIDENT_DB(I)) 
     *      FIDENT_COMPLEX = FIDENT_DB(I)
          CALL WRITE_STRUCTURE_XML(MDOC,J,I,IOUT
     *      ,FILE_TEMP_SEQ,NRES_SUM,NATOM_SUM,NRES_TOT,NATOM_TOT,CHAIN
     *      ,NAME_PDB,PDB,SEQ
     *      ,NAME_DIR,NAME_LIST
     *      ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *      ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *      ,CODE_DB(I),NAA_DB(I),RESOL_DB(I),NAT_DB(I)
     *      ,NRES_DB(I),FIDENT_DB(I),SCR_DB(I),ID_DB(I)
     *      ,IFLAG_DOM(I),IFLAG_MULT(I) 
     *      ,CODE_RES,FILE_RES         
     *      ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *      ,IBACK_DOM_BASE,NRES_DOM_BASE
     *      ,NDOMAIN_BASE
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            N_STR =  N_STR + 1
            IF(NCHAIN.LT.NCHAINMAX) THEN
              NCHAIN = NCHAIN + 1
              NCH    = NCH    + 1
              CODE_CHAIN(NCHAIN)  = CODE_RES
              FILE_CHAIN(NCHAIN)  = FILE_RES
              NRES_CHAIN(NCHAIN)  = NRES_TOT
              NATOM_CHAIN(NCHAIN) = NATOM_TOT
              ISEQUENCE_CHAIN(NCHAIN) = ISEQUENCE
              FIDENT_CHAIN(NCHAIN) = FIDENT_DB(I)
            ENDIF
          ELSE
            IERR = 0
          ENDIF
        ENDDO
        CALL MSGDOC(MDOC,' -- monomers finish ----')
         
        IF(NSEQ.LT.NSEQ_LIST) THEN
          NCH  = 0
          NADD = 10
          T = FIDENT_FIRST*0.80
          DO J=NSEQ+1,NSEQ_LIST
            I   = IORDER(J) 
            IF(NCHAIN.LT.NCHAINMAX.AND.NCH.LT.NADD.AND.
     *         FIDENT_DB(I).GT.T) THEN
              NCHAIN = NCHAIN + 1
              NCH    = NCH    + 1
              CODE_CHAIN(NCHAIN)  = CODE_DB(I)
              FILE_CHAIN(NCHAIN)  = ' '
              NRES_CHAIN(NCHAIN)  = NRES_TOT
              NATOM_CHAIN(NCHAIN) = NATOM_TOT
              ISEQUENCE_CHAIN(NCHAIN) = ISEQUENCE
              FIDENT_CHAIN(NCHAIN) = FIDENT_DB(I)
            ENDIF
          ENDDO
        ENDIF

      ENDIF
    
      IF(ND_STRING.GT.0) THEN
        I = N_STR + 1 
        CALL WRITE_STRUCTURE_DOM_XML(MDOC,I,IOUT
     *      ,FILE_TEMP_SEQ,NRES_SUM,NATOM_SUM,NRES_TOT,NATOM_TOT,CHAIN
     *      ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *      ,SPACE_GROUP,N1_SEQ,NA1_SEQ,Q_LIM
     *      ,ND_STRING,IDOMDOM,IDOMSEG
     *      ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM
     *      ,FIDENT_DM,SCORE_DM,Q_DM
     *      ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *      ,IBACK_DOM_BASE,NRES_DOM_BASE
     *      ,NDOMAIN_BASE
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.EQ.0) THEN
          N_STR =  N_STR + 1
        ELSE
          IERR = 0
        ENDIF
      ENDIF
C ---------------------------
      WRITE(IOUT,'(A)',ERR=910) '</sequence>' 
      GO TO 150
  140 CONTINUE

      
C     IF(ISEQUENCE.GT.1.AND.NCHAIN.GT.1) THEN
      IF(NSEQ_READ.GT.1.AND.NCHAIN.GT.1) THEN

        CALL WRITE_STRUCTURE_COMPLEX_XML(MDOC,IOUT,NAME_SEQ
     *      ,NRES_SUM,NATOM_SUM,CHAIN,FIDENT_COMPLEX
     *      ,NCHAIN,NSEQUENCE
     *      ,CODE_CHAIN,FILE_CHAIN,NRES_CHAIN,NATOM_CHAIN
     *      ,ISEQUENCE_CHAIN
     *      ,FIDENT_CHAIN
     *      ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *      ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          IERR = 0
        ENDIF

      ENDIF

      CLOSE(MT)

c      WRITE(IOUT,'(A)',ERR=910) '<sequence>'  ?
c     complex  [iseq code? model_file]
c      WRITE(IOUT,'(A)',ERR=910) '</sequence>' ?

C ==============================================
      LINE = '</'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN

  910 IERR = 10

  900 CONTINUE
      RETURN

  920 CONTINUE
      CALL MSGERR(MD,
     *    ' ERROR: read file-temp_chain_list.txt')
      CLOSE(MT)
      IERR = 6
      RETURN
  930 CONTINUE
      CALL MSGERR(MD,
     *    ' ERROR: open file-temp_chain_list.txt')
       IERR = 6
      RETURN
      END

      SUBROUTINE GET_STRUCTURE_DB_PDB_RUN(MDOC,NAME_SEQ,FILE_1
     *   ,NAME_PDB,PDB,SEQ,LIST,JOB,NRES_SUM,NATOM_SUM
     *   ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *   ,SPACE_GROUP,NSEQ_MAX,N1_SEQ,NA1_SEQ,N_STR
     *   ,PATH_SCR,PATH_OUT,RESULT,IPRROW,VERSION,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*),PDB*1,SEQ*1,LIST*1,JOB*(*)
C ---
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,VERSION*(*)
      CHARACTER FILE_1*(*),NAME_PDB*(*),NAME_SEQ*(*),FILE_2*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1
C ---
      PARAMETER ( NSEQ_MAX_PARAM = 100 )
      INTEGER   IORDER(NSEQ_MAX_PARAM)
      INTEGER   NAA_DB(NSEQ_MAX_PARAM),NAT_DB(NSEQ_MAX_PARAM)
      INTEGER   NRES_DB(NSEQ_MAX_PARAM),ID_DB(NSEQ_MAX_PARAM)
      INTEGER   IFLAG_MULT(NSEQ_MAX_PARAM),IFLAG_DOM(NSEQ_MAX_PARAM)
      REAL      SCORE(NSEQ_MAX_PARAM),FIDENT_DB(NSEQ_MAX_PARAM)
      REAL      RESOL_DB(NSEQ_MAX_PARAM),SCR_DB(NSEQ_MAX_PARAM)
      REAL      Q_DB(NSEQ_MAX_PARAM)
      CHARACTER CODE_DB(NSEQ_MAX_PARAM)*8
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C ---
      CHARACTER CODE*5,CODE1*5,CODE4*4,CHAIN*1
      CHARACTER FRMT1*256,FRMT2*256      
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      FRMT1 = '(I6,1X,A8,1X,F6.1,1X,F6.3,1X,F6.3'//
     *        ',1X,I6,1X,I6,1X,I6,1X,F6.2,1X,I5,1X,I5)'
      N_STR= 0
C --------------------------------------------------
C
c     read temp_chain_list.txt
C
      CALL LENSTR_BL(JOB,LJ)

      NSEQMAX = 10

      NSEQ = 1
      ND_STRING    = 0
      IORDER(1)    = 1 
      CODE_DB(1)   = 'XXXXX'
      NAA_DB(1)    = 0
      RESOL_DB(1)  = 0.0
      NAT_DB(1)    = 0
      NRES_DB(1)   = 0 
      FIDENT_DB(1) = 0.0
      SCR_DB(1)    = 0.0
      ID_DB(1)     = 0
      IFLAG_DOM(1) = 0
      IFLAG_MULT(1)= 0
C --------------------------------------------------
      IF(NSEQ_MAX.GT.0.AND.NSEQ.GT.NSEQ_MAX) NSEQ = NSEQ_MAX
C --------------------------
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 71
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file:'//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD, LINE)
        IERR = 10
        GO TO 900
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'error <err_level>         0 </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'message <err_message> normal termination </err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      LINE =
     * 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      CALL LENSTR_BL(VERSION,LEN)
      LINE = 'vers <vers>'//VERSION(1:LEN)//'</vers>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      WRITE(IOUT,'(A)',ERR=910) '<sequence>' 
    
      N = NSEQ 
      IF(ND_STRING.GT.0) N = N + 1

      WRITE(LINE,'(A,I6,A)',ERR=910) 
     * 'n_structure <n_structure> ',N,' </n_structure>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN) 

      N_STR = 0
      IF(NSEQ.GT.0) THEN
        DO J=1,NSEQ

          I = IORDER(J) 
          CALL WRITE_STRUCTURE_PDB_XML(MDOC,J,I,IOUT,NAME_SEQ
     *      ,NAME_PDB,PDB,SEQ,NRES_SUM,NATOM_SUM
     *      ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *      ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *      ,CODE_DB(I),NAA_DB(I),RESOL_DB(I),NAT_DB(I)
     *      ,NRES_DB(I),FIDENT_DB(I),SCR_DB(I),ID_DB(I)
     *      ,IFLAG_DOM(I),IFLAG_MULT(I)          
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
          IF(IERR.EQ.0) THEN
            N_STR =  N_STR + 1
          ELSE
          ENDIF
        ENDDO
      ENDIF
    
C ---------------------------
      WRITE(IOUT,'(A)',ERR=910) '</sequence>' 

      LINE = '</'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN

  910 IERR = 10

  900 CONTINUE
      RETURN

  930 CONTINUE
      CALL MSGERR(MD,
     *    ' ERROR: open file-temp_chain_list.txt')
       IERR = 6
      RETURN
      END

      SUBROUTINE WRITE_ERROR_XML(MDOC,IERR_INPUT,MESSAGE,JOB,VERSION
     *                            ,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,MESSAGE*(*),JOB*(*),VERSION*(*)
      CHARACTER FILE_2*256
      CHARACTER PATH_OUT*(*),PATH*1,EXT*1
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      CALL LENSTR_BL(JOB,LJ)
      CALL LENSTR_BL(PATH_OUT,L)
      IF(L.GT.0) THEN
        FILE_2 = PATH_OUT(1:L)//JOB(1:LJ)//'.xml'
      ELSE
        FILE_2 = JOB(1:LJ)//'.xml'
      ENDIF
      EXT  = ' '
      PATH = ' '
      IOUT = 71
      CALL OPENFW(IOUT,M,PATH,FILE_2,EXT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: cannot open output file: '//JOB(1:LJ)//'.xml'
        CALL MSGERR(MD,LINE)
        IERR = 1
        RETURN
      ENDIF
C ---------------------------
      LINE =
     * '<?xml version="1.0" encoding="ASCII" standalone="yes"?>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<!--     '//JOB(1:LJ)//' output   -->'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '<'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I6,A)',ERR=510) 
     * 'error <err_level> ',IERR_INPUT,' </err_level>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(MESSAGE,LM)
      IF(LM.LE.0) MESSAGE = 'null'
      CALL LENSTR_BL(MESSAGE,LM)
      LINE = 'message <err_message> '//MESSAGE(1:LM)//'</err_message>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 


      LINE = 'job <job>'//JOB(1:LJ)//'</job>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(VERSION,LEN)
      LINE = 'vers <vers>'//VERSION(1:LEN)//'</vers>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      LINE = '</'//JOB(1:LJ)//'>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      END FILE IOUT
      CLOSE(IOUT)

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE WRITE_STRUCTURE_XML(MDOC,ISQ,ISEQ,IOUT
     *  ,NAME_SEQ,NRES_SUM,NATOM_SUM,NRES_TOT,NATOM_TOT,CHAIN_IN
     *  ,NAME_PDB,PDB,SEQ
     *  ,NAME_DIR,NAME_LIST
     *  ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *  ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *  ,CODE_DB,NAA_DB,RESOL_DB,NAT_DB
     *  ,NRES_DB,FIDENT_DB,SCR_DB,ID_DB
     *  ,IFLAG_DOM,IFLAG_MULT          
     *  ,CODE_RES,FILE_RES         
     *  ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *  ,IBACK_DOM_BASE,NRES_DOM_BASE
     *  ,NDOMAIN_BASE
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*),NAME_SEQ*(*),NAME_PDB*(*)
      CHARACTER NAME_DIR*(*),NAME_LIST*(*)
      CHARACTER PDB*1,SEQ*1,CHAIN_IN*1
      CHARACTER CODE_RES*8,FILE_RES*(*)         
C ---
      INTEGER   ID_DB,NAA_DB,NAT_DB
     *         ,NRES_DB,ISEQ
      REAL      RESOL_DB,FIDENT_DB,SCR_DB
      CHARACTER CODE_DB*8
C --
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C --
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
C ---
      INCLUDE 'multimer_info.fh'
C ---
      CHARACTER TYPE_PDB*8
c ---
      PARAMETER ( NLISTMAX = 100 )
      CHARACTER CODE_LIST(NLISTMAX)*8
      INTEGER   ISEQUENCE_LIST(NLISTMAX)
C ---------------------------------
      PARAMETER ( NSEGMAX = 100  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
c -----------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,FILE_CRD*256,FILE_SEQ*256,PATH*256
      CHARACTER PATH_DB*256
      CHARACTER SURF*1,SURF_CORR*1,ALIGN_CORR*1,CODE8*8
      CHARACTER FILE_OUT*256,FILE_TEMP*256,CODE5*5
      CHARACTER FILE_TEMP1*256,FILE_TEMP2*256
      CHARACTER FILE_NMR*256,FILE_NMR_C*256,FILE_CORR*256
      CHARACTER FILE_XML*256,FILE_XYZ*256
      CHARACTER CH4*4,CH1*1,CH8*8,CH2*2
      CHARACTER COMPLEX_ID*8,CHAIN_ID*8,DOM_ID*8,CHAIN*1
      CHARACTER DOMAIN_CODE*8 
      CHARACTER COMPLEX_DB*10
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C -----------------------------------
      INCLUDE 'nsym-max.fh'
C -----------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
c------------------------------------
      CHARACTER CHAIN_INP*1
      CHARACTER STR_TITLE*40,STR_DATE*9
      CHARACTER EXT*1
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
CC --------------------------------------------------
      COEF_NR_TO_VOL   = 166.2
      COEF_NA_TO_VOL   = 20.63
      ALIGN_CORR_LIMIT = 10.0
      VOLUME_LIMIT     = 0.80
      CHAIN = CODE_DB(5:5)
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) GO TO 520
C       Example: "setenv MOLREP_DB ~alexei/molrep_DB"

      CALL MSGDOC(MDOC,'===================================')
      WRITE(LINE,'(A,I5,A)') 
     *  '======  structure ',ISQ,'  ========'
      CALL MSGDOC(MDOC,LINE)

c     calc SIM,VOL_MON,NMON for model_DB_info

      IF(FIDENT_DB.LE.1.0) FIDENT_DB = 1.0
      SIM     = FIDENT_DB/100.0

      NRES_REST  = NRES_SUM - NRES_TOT
      NATOM_REST = NATOM_SUM - NATOM_TOT

      IF(NATOM_TOT.LE.0) THEN

        VOL_MON = FLOAT(NAT_DB)*COEF_NA_TO_VOL

        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
        IF(NA1_SEQ.GT.0) VOL_MON = FLOAT(NA1_SEQ)*COEF_NA_TO_VOL
      ELSE
        VOL_MON = FLOAT(NATOM_TOT)*COEF_NA_TO_VOL
        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
      ENDIF
      VOL_REST = FLOAT(NATOM_REST)*COEF_NA_TO_VOL
      VOL_SUM  = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL

      NS = NSYM
      IF(NSYM.LE.0) NS = 1
      IF(VOLUME.LE.0.01) THEN
        IF(CELL(1).GT.0.01) THEN
          C4 = (CELL(4)*PI)/180.0
          C5 = (CELL(5)*PI)/180.0
          C6 = (CELL(6)*PI)/180.0
          COAL=COS(C4)
          COBE=COS(C5)
          COGA=COS(C6)
          VOLUME=CELL(1)*CELL(2)*CELL(3)*
     *           SQRT(1.-COAL**2-COBE**2-COGA**2+2.*COAL*COBE*COGA)
        ELSE
          VOLUME = VOL_MON*1.3*FLOAT(NS)
        ENDIF
      ENDIF 


CCC     VM = VOL_MON
      VM = VOL_SUM

CCC      VOL_EMPTY = VOLUME/REAL(NS) - VOL_REST 
      VOL_EMPTY = VOLUME/REAL(NS)  
      VPERC = (VM/VOL_EMPTY)*100.0

      NMON1 = (VOL_EMPTY*VOLUME_LIMIT)/VM
      VOL_MONOMER = VM

      IF(VOL_EMPTY.LE.VM) THEN
        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                               VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)
        GO TO 520
      ENDIF
      IF(NMON1.LE.0) THEN
        NMON1 = 1
      ENDIF
      WRITE(LINE,
     *    '(''INFO: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
      CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                               VOLUME_LIMIT
      CALL MSGDOC(MDOC,LINE)

c       resolution
      RESMAX_USED = 3.0
      IF(RESMAX.GT.0.0001.AND.BOVERALL.GT.0.0001.AND.
     *                        OPT_RESOL.GT.0.0001) THEN
        CALL NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)              
        IF(RESMAX.LE.RESMAX_NEW) THEN
          RESMAX_USED = RESMAX_NEW
        ELSE
          RESMAX_USED = RESMAX
        ENDIF
      ENDIF
C --------------------------------------------------
C    titles
C ---
      WRITE(IOUT,'(A)',ERR=510) '<structure>' 
      LINE =
     * '  PDB_code <PDB_code> '//CODE_DB(1:5)//' </PDB_code>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=520) LINE(1:LEN) 
      WRITE(IOUT,'(A)',ERR=520) 
     *'  user_flag  <user_flag> '//PDB//' </user_flag>'
C--------------------
C     start model
C -------------------
      CALL MSGDOC(MDOC,'===================================')
      CALL MSGDOC(MDOC,'------ monomers ------')
      CODE8 = CODE_DB
      LINE = '==:'//CODE8
      CALL MSGDOC(MDOC,LINE)

      IF(CODE8(8:8).EQ.'u') THEN

        CH8 = CODE8(1:8) 
        IF(CH8(1:1).EQ.'U') CH8(1:1) = ' '       
        IF(CH8(2:2).EQ.'_') CH8(2:2) = ' '       
        IF(CH8(3:3).EQ.'_') CH8(3:3) = ' ' 
        READ(CH8(1:4),'(I4)',ERR=1300) NPDB      
        MT   = 73
        EXT  = ' '
        PATH = ' '
        CALL OPENFR(MT,M,PATH,NAME_LIST,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,
     *    ' ERROR: can not open input user list file')
          IERR = 9
          GO TO 530
        ENDIF
        IPDB = 0
 1100   CONTINUE

        READ(MT,'(A)',ERR=1300,END=1200) FILE_XYZ
        CALL LENSTR_BL(FILE_XYZ,LEN)
        IF(LEN.LE.1.OR.FILE_XYZ(1:1).EQ.'#') GO TO 1100
        IPDB = IPDB + 1
        IF(NPDB.EQ.IPDB) THEN
          CLOSE(MT)
          CALL LENSTR_BL(NAME_DIR,LEN_DIR)
          CALL LENSTR_BL(FILE_XYZ,LEN)
          FILE_XYZ = NAME_DIR(1:LEN_DIR)//FILE_XYZ(1:LEN)
          CHAIN_INP = CODE8(5:5)
          FILE_TEMP = 'coordinate_input.crd'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_TEMP,LT )
          IF(LEN.GT.0) THEN
            FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
          ENDIF
          FILE_CRD = 'coordinate_input.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILE_CRD,LT )
          IF(LEN.GT.0) THEN
            FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
          ENDIF
          PATH = ' '
          CALL READPDB(M,FILE_XYZ,FILE_TEMP,PATH,ISYM,IPRSYM
     *            ,STR_TITLE,STR_DATE
     *            ,RESULT,IPRROW,CHAIN_INP,IERR)   
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: in READPDB read user pdb file'
            CALL MSGERR(MDOC,LINE)
            IERR = 9
            GO TO 530
          ENDIF
          IERR = 0
          CALL WRITEPDB(M,FILE_TEMP,FILE_CRD,ISYM,IPRSYM,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: in WRITEPDB write user pdb file'
            CALL MSGERR(MDOC,LINE)
            IERR = 9
            GO TO 530
          ENDIF
          GO TO 1400
        ENDIF
        GO TO 1100
1200    CONTINUE
        CLOSE(MT)
        CALL MSGERR(MDOC,
     *    ' ERROR: problem with user"s pdb file')
        IERR = 9
        GO TO 530
1400    CONTINUE

      ELSE
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_XYZ = PATH_DB(1:LEN)//'/pdb_DB/'//CODE8(1:5)//'.xyz'
        FILE_CRD = CODE8(1:5)//'.pdb'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_CRD,LT )
        IF(LEN.GT.0) THEN
          FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
        ENDIF

        CALL PDB_UNPACK(MDOC,FILE_XYZ,FILE_CRD,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: unpack XYZ file'
          CALL MSGERR(MDOC,LINE)
          IERR = 11
          GO TO 530
          RETURN
        ENDIF
      ENDIF
C ---
C     domains ?
      NDOM = 0
      IF(IFLAG_DOM.GT.0) THEN
C       set domain info into pdb file
        FILE_TEMP = 'mod_'//CODE8(1:5)//'_mono.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        ENDIF
C       ierr=-1    set '-' in seg_id(76:76) (domains border)
        IERR = 0
        CALL SET_DOMAIN_INFO_TO_PDB(M,FILE_CRD,FILE_TEMP
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,CODE8,COMPLEX_DB,IERR)
c        IF(IERR.NE.0.OR.NDOM.LE.0) THEN
        IF(IERR.NE.0.OR.NDOM.LT.0) THEN
          NDOM = 0
          IERR = 0
        ELSE
          FILE_CRD = FILE_TEMP
        ENDIF
      ENDIF
c ---
      FILE_SEQ = NAME_SEQ
      SURF_CORR  = 'Y'
      ALIGN_CORR = 'Y'
      ALIGN_CORR_LIM = 10.0
      IF(FIDENT_DB.LT.ALIGN_CORR_LIM.AND.PDB.EQ.'N') 
     *   ALIGN_CORR = 'N'
      IF(SEQ.EQ.'N') ALIGN_CORR = 'N'
      VOL  = VOL_MON
      RAD  = RAD_MON
      NMON = NMON1      
c -----
      FILE_TEMP = 'mod_'//CODE8(1:5)//'_mono1.pdb'
      FILE_OUT  = 'mod_'//CODE8(1:5)//'_mono2.pdb'      
      CALL LENSTR_BL(PATH_OUT ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      CALL LENSTR_BL(FILE_OUT ,LO )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        FILE_OUT  = PATH_OUT(1:LEN)//FILE_OUT(1:LO)
      ENDIF

      CALL MODEL_CORRECTION(MDOC,FILE_SEQ,FILE_CRD
     *  ,ALIGN_CORR_LIMIT,CHAIN
     *  ,FILE_OUT,FILE_TEMP
     *  ,SURF_CORR,ALIGN_CORR,NATOM,NRES,SML,CODE8
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 520

      WRITE(LINE,'(A,A,A)') 
     * '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,2I8,F7.2)') '--Natom,Nres,Ident:',NATOM,NRES,SML 
      CALL MSGDOC(MDOC,LINE)
      NRES_MON = NRES

      IF(SURF_CORR.EQ.'Y'.OR.ALIGN_CORR.EQ.'Y') THEN
C        VOL = FLOAT(NRES)*COEF_NR_TO_VOL
C        V   = FLOAT(NATOM)*COEF_NA_TO_VOL
C        IF(V.GT.VOL) VOL = V

        VOL = FLOAT(NATOM)*COEF_NA_TO_VOL

      ENDIF

      NS = NSYM
      IF(NSYM.LE.0) NS = 1
c      COMPL = (VOL*FLOAT(NS))/(VOLUME*VOLUME_LIMIT)
      COMPL = (VOL*FLOAT(NS))/VOLUME
      IF(COMPL.GT.1.0  )  COMPL = 1.0
      IF(COMPL.LT.0.001)  COMPL = 0.001
C ----
      T   = LOG((VOL*3.0)/(4.0*PI))
      RAD = EXP(T/3.0)
      RAD_MON = RAD
c ----
C     surf keyword
      IF(SURF_CORR.EQ.'Y') THEN
        SURF   = 'Y'
      ELSE
        SURF   = '2'
      ENDIF
c -----
C     files
      FILE_CORR = ' '
      FILE_CRD  = FILE_OUT
      IF(ALIGN_CORR.EQ.'Y') THEN
        FILE_SEQ = 'null'
      ENDIF
      FILE_SEQ = 'null'
c ------
      COMPLEX_ID = '100'
      CHAIN_ID   = CHAIN
      DOM_ID     = '0'
c ------
      RAD_M = RAD
      CALL CALC_PDB_RADIUS_INERTIA(M,FILE_CRD,NTOT,RINER,IERR)
      IF(IERR.EQ.0) THEN
        t = riner/rad
        WRITE(line,'(A,3F8.3)') '--Riner,Radius,ratio:',riner,rad,t
        CALL MSGDOC(MDOC,LINE)
        RAD = RINER
        IF(RINER.LT.RAD_M) RAD_M = RINER
        RINER_MON = RINER
      ELSE
        IERR = 0
      ENDIF

      NRES_MONO = NRES
      VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
      COMPL = (VOL*FLOAT(NS))/VOLUME
      IF(COMPL.GT.1.0  )  COMPL = 1.0
      IF(COMPL.LT.0.001)  COMPL = 0.001

      LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *   CHAIN_ID//' '//DOM_ID//' ===='
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I5)')    '==Nmonomers  :',NMON
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM,COMPL
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
      CALL MSGDOC(MDOC,LINE)     
      SIM_NMR = 0.5
      IF(SIM.GT.0.5) SIM_NMR = SIM 
c ------
c     NMR model CODE8 NDOM

      T = REAL(NRES_DB)/REAL(NRES_MON)
      IF(T.LE.1.15) THEN

        ND = NDOM
        IF(NDOM.GT.9) ND = 9
        CALL LENSTR_BL(FILE_CRD,LEN)
        FILE_NMR_C= FILE_CRD(1:LEN-4)//'_ens.pdb'
        FILE_CORR = 'model_corr_temp.pdb'
        CALL LENSTR_BL(PATH_SCR  ,LEN)
        CALL LENSTR_BL(FILE_CORR ,LC)
        IF(LEN.GT.0) THEN
          FILE_CORR  = PATH_SCR(1:LEN)//FILE_CORR(1:LC)
        ENDIF

        CALL CREATE_NMR_FOR_CHAIN_V2(Mdoc
     *   ,CODE8,NMODEL_MAX,NMODEL_MIN,FILE_NMR_C,FILE_CORR
     *   ,NAME_SEQ,ND
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)

        IF(NMODEL_MIN.GT.NMODEL_MAX) NMODEL_MIN = NMODEL_MAX

        WRITE(LINE,'(A,2I6)') 
     *    'INFO: Nmodel_ens_MIN,MAX :',NMODEL_MIN,NMODEL_MAX
        CALL MSGDOC(MDOC,LINE)     

        IF(IERR.NE.0.OR.NMODEL_MIN.LE.3) THEN
          IF(IERR.NE.13.AND.NMODEL_MIN.GT.3) THEN
            LINE = ' ERROR: CREATE_NMR_FOR_CHAIN'
            CALL MSGERR(MDOC,LINE)
          ELSE
            LINE = ' INFO: no NMR file'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          IERR = 0      
          FILE_NMR_C  = 'null'
          FILE_CORR   = ' '
        ELSE
          CALL MSGDOC(MDOC,' --  NMR file was created')
        ENDIF
      ELSE
        WRITE(LINE,'('' Nres_DB > Nres_MON:'',2I8)') NRES_DB,NRES_MON
        CALL MSGERR(MDOC,LINE)
        LINE = ' INFO: no NMR file'
        CALL MSGERR(MDOC,LINE)
        FILE_NMR_C  = 'null'
        FILE_CORR   = ' '
      ENDIF
c ------
c     write XML
      DOMAIN_CODE = ' '
      NSLIST = 0   
      CALL WRITE_MODEL_XML(MDOC,IOUT
     * ,DOMAIN_CODE
     * ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     * ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     * ,SIM,COMPL,NMON,SURF,SIM_NMR
     * ,FILE_NMR_C,FILE_CRD,FILE_SEQ,IERR)
      IF(IERR.NE.0) GO TO 530     

      CODE_RES = CODE8
      FILE_RES = FILE_CRD

C
C     end model
c -------------------------------
C
c     domain models
C
      IF(NDOM.LE.0.OR.NDOM.GT.9) GO TO 700

      CALL MSGDOC(MDOC,'------ domains. ------')

      NUM_DOM = 1
      DO IDOM=1,NDOM
        CODE8    = CODE_DB
        CHAIN_ID = CHAIN
        WRITE(LINE,'(A,I8)') '--domain:',IDOM 
        CALL MSGDOC(MDOC,LINE)
c--------------------
C     start domain model
C -------------------
        IF(NUM_DOM.LE.9) THEN
          WRITE(CH1,'(I1)') NUM_DOM
        ELSE IF(NUM_DOM.LE.NLETT) THEN
          I = NUM_DOM - 9 
          CH1 = LETT(I:I)
        ELSE
          CH1 = 'X'
        ENDIF

        IF(CH1.EQ.' ') CH1='0'
 
        FILE_TEMP = 'mod_'//CODE8(1:5)//'_'//CH1//'dom'//'.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        ENDIF

        CALL GET_DOMAIN_PDB(MDOC,FILE_CRD,FILE_TEMP
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,NATOM,IERR)
        IF(IERR.NE.0.OR.NATOM.LE.0) THEN
          IERR = 0
          GO TO 710
        ENDIF

C -----
C       VOL,COMPL,RAD from pdb_model
        VOL   = FLOAT(NATOM)*COEF_NA_TO_VOL
        NS = NSYM
        IF(NSYM.LE.0) NS = 1
c        COMPL = (VOL*FLOAT(NS))/(VOLUME*VOLUME_LIMIT)
        COMPL = (VOL*FLOAT(NS))/VOLUME
        IF(COMPL.GT.1.0  )  COMPL = 1.0
        IF(COMPL.LT.0.001)  COMPL = 0.001
C ----
        T   = LOG((VOL*3.0)/(4.0*PI))
        RAD = EXP(T/3.0)
C ----
        WRITE(LINE,'(A,A,A)') 
     *   '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2I8,F7.2)') 
     *  '--Natom,Nres,Ident:',NATOM,NRES,SML 
        CALL MSGDOC(MDOC,LINE)
c ----
C       surf keyword
        IF(SURF_CORR.EQ.'Y') THEN
          SURF   = 'Y'
        ELSE
          SURF   = '2'
        ENDIF
c -----
C       files
        FILE_SEQ = 'null'
c ------
        COMPLEX_ID = '100'
        WRITE(CH2,'(I2)') IDOM
        DOM_ID     = CH2
c ------
c ------
        RAD_M = RAD
        CALL CALC_PDB_RADIUS_INERTIA(M,FILE_TEMP,NTOT,RINER,IERR)
        IF(IERR.EQ.0) THEN
          t = riner/rad
          WRITE(line,'(A,3F8.3)') '--Riner,Radius,ratio:',riner,rad,t
          CALL MSGDOC(MDOC,LINE)
          RAD = RINER
          IF(RINER.LT.RAD_M) RAD_M = RINER
        ELSE
          IERR = 0
        ENDIF

        VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
        COMPL = (VOL*FLOAT(NS))/VOLUME
        IF(COMPL.GT.1.0  )  COMPL = 1.0
        IF(COMPL.LT.0.001)  COMPL = 0.001
        IF(NRES.LT.NRES_MONO-2.AND.NRES.GE.15) THEN    
c ------
          SIM_DOM = SIM

          IF(ALIGN_CORR.EQ.'Y') THEN
C           FILE_TEMP
            FILE_TEMP1 = 'mod_'//CODE8(1:5)//'_mono1.pdb'
            FILE_TEMP2 = 'mod_'//CODE8(1:5)//'_tmp.pdb'
            CALL LENSTR_BL(PATH_OUT ,LEN)
            CALL LENSTR_BL(FILE_TEMP1,LT )
            CALL LENSTR_BL(FILE_TEMP2,LT2)
            IF(LEN.GT.0) THEN
              FILE_TEMP1 = PATH_OUT(1:LEN)//FILE_TEMP1(1:LT) 
              FILE_TEMP2 = PATH_OUT(1:LEN)//FILE_TEMP2(1:LT2) 
            ENDIF

            CALL GET_DOMAIN_PDB(MDOC,FILE_TEMP1,FILE_TEMP2
     *       ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *       ,IDOM,NRES2,NATOM2,IERR)
            IF(IERR.NE.0.OR.NATOM2.LE.0) THEN
              IERR = 0
              GO TO 720
            ENDIF

            CALL SIM_FOR_DOMAIN(M,FILE_TEMP,FILE_TEMP2
     *                 ,ALIGN_CORR_LIMIT,SML2
     *                 ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
            IF(IERR.NE.0) THEN
              IERR = 0
              GO TO 720
            ENDIF

            SIM_DOM = SML2/100.0

          ENDIF

  720     CONTINUE

          LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *     CHAIN_ID//' '//DOM_ID//' ===='
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,I5)')    '==Nmodels    :',NMON
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM_DOM,COMPL
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
          CALL MSGDOC(MDOC,LINE)     
          SIM_NMR = 0.5
          IF(SIM_DOM.GT.0.5) SIM_NMR = SIM_DOM
c ----
C         domain NMR model
C      
          CALL LENSTR_BL(FILE_CORR,LT )
          IF(LT.LE.0) FILE_CORR = FILE_CRD

          CALL LENSTR_BL(FILE_TEMP,LT )
          FILE_NMR = FILE_TEMP(1:LT-4)//'_ens.pdb'

          CALL CREATE_NMR_FOR_DOMAIN(M,NRES,NRES_DOM
     *     ,CODE8,IDOM,NMODEL,FILE_NMR,FILE_CORR,NAME_SEQ
     *     ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *     ,IBACK_DOM_BASE,NRES_DOM_BASE
     *     ,NDOMAIN_BASE
     *     ,PATH_DB,PATH_SCR,PATH_OUT,IERR)

          WRITE(LINE,'(A,I6)') 'INFO: Nmodel_ens :',NMODEL
          CALL MSGDOC(MDOC,LINE)
     
          IF(IERR.NE.0.OR.NMODEL.LE.3) THEN
            IF(IERR.EQ.33) THEN
              WRITE(LINE,'('' Nres_DB > Nres_DOM:'',2I8)')NRES_DOM,NRES
              CALL MSGERR(MDOC,LINE)
              LINE = ' INFO: no NMR file'
              CALL MSGERR(MDOC,LINE)
            ELSE IF(IERR.NE.13.AND.IERR.NE.33.AND.NMODEL.GT.3) THEN
              LINE = ' ERROR: CREATE_NMR_FOR_DOMAIN'
              CALL MSGERR(MDOC,LINE)
            ELSE
              LINE = ' INFO: no NMR file'
              CALL MSGERR(MDOC,LINE)
            ENDIF
            IERR = 0
            FILE_NMR = 'null'
          ELSE
            CALL MSGDOC(MDOC,' --  NMR file was created')
          ENDIF
c ----
c         write XML
          DOMAIN_CODE = ' '
          NSLIST   = 0   
c ----
          CALL WRITE_MODEL_XML(MDOC,IOUT
     *     ,DOMAIN_CODE
     *     ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     *     ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     *     ,SIM_DOM,COMPL,NMON,SURF,SIM_NMR
     *     ,FILE_NMR,FILE_TEMP,FILE_SEQ,IERR)
          IF(IERR.NE.0) GO TO 530     

          NUM_DOM =  NUM_DOM + 1

        ELSE
          CALL MSGDOC(MDOC,' NRES > NRES_MONO-2 or NRES < 15') 
          CALL MSGDOC(MDOC,'INFO: domain will not be used')
        ENDIF

 710    CONTINUE
C
C     end domain model
c -------------------------------
      ENDDO

 700  CONTINUE
c -------------------------------
C     123456789
C     D0213040C0
C     DIMER,TRIMER,....
c
c     FILE_CRD   VOL_MON  NRES_MON
c
      NM   = 0
      NPDB = 0

      IF(IFLAG_MULT.LE.0) GO TO 600

      IF(IFLAG_MULT.GT.0) THEN
        CODE5 = CODE_DB(1:5)
        CALL LENSTR_BL(PATH_DB,LEN)
        FILE_XML = PATH_DB(1:LEN)//'/multimer/'//CODE5//'.xml'
        CALL GET_MULTIMER_INFO(MDOC,PATH_DB,FILE_XML,PATH_SCR,IERR)
        IF(IERR.EQ.9) THEN
          LINE = 'WARNING: problem with GET_MULTIMER_INFO: ierr=9'
          CALL MSGERR(MDOC,LINE)
          LINE = '         no file with MULTIMER_INFO'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 600
        ELSE IF(IERR.NE.0) THEN
          LINE = 'WARNING: problem with GET_MULTIMER_INFO'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 600
        ENDIF
        NPDB = NMULTIMER 
      ENDIF

      CALL MSGDOC(MDOC,'------ multimers ------')
      IF(NPDB.LE.0) THEN
        LINE = 'WARNING: GET_MULTIMER_INFO: NPDB=0'
        CALL MSGERR(MDOC,LINE)
        GO TO 600
      ENDIF
C--------------------
C     multimer models
C -------------------
      DO I=1,NPDB
        CHAIN_ID   = 'AB'
        NM = NMOLECULE(I)
        IF(NM.EQ.2) THEN
          TYPE_PDB = 'dimer' 
          CHAIN_ID   = 'AB'
        ELSE IF(NM.EQ.3) THEN
          TYPE_PDB = 'trimer' 
          CHAIN_ID   = 'ABC'
        ELSE IF(NM.EQ.4) THEN
          TYPE_PDB = 'tetramer' 
          CHAIN_ID   = 'ABCD'
        ELSE IF(NM.GT.4) THEN
          TYPE_PDB = 'multimer'
          CHAIN_ID   = 'ABCD'
        ELSE
          GO TO 610
        ENDIF

        WRITE(CH4,'(I4)') I
        LCH4 = 4
        IF(CH4(3:3).EQ.' ') THEN
          CH4(1:1) = CH4(4:4)
          CH4(2:4) = '   '
          LCH4 = 1
        ELSE IF(CH4(2:2).EQ.' ') THEN
          CH4(1:1) = CH4(3:3)
          CH4(2:2) = CH4(4:4)
          CH4(3:4) = '  '
          LCH4 = 2
        ELSE IF(CH4(1:1).EQ.' ') THEN
          CH4(1:1) = CH4(2:2)
          CH4(2:2) = CH4(3:3)
          CH4(3:3) = CH4(4:4)
          CH4(4:4) = ' '
          LCH4 = 3
        ENDIF
C--------------------
C       start multimer model
C -------------------
        LINE = '    ==:'//CODE5//' '//TYPE_PDB
        WRITE(LINE(1:3),'(I3)') I
        CALL MSGDOC(MDOC,LINE)
        SURF_CORR  = 'Y'
        ALIGN_CORR = 'Y'
        ALIGN_CORR_LIM = 10.0
        IF(FIDENT_DB.LT.ALIGN_CORR_LIM) 
     *     ALIGN_CORR = 'N'
        IF(TYPE_PDB.EQ.'multimer')  ALIGN_CORR = 'N'
        VOL  = VOL_MON*FLOAT(NM)
        RAD  = RAD_MON*1.1
        NMON = NMON1/NM
        NRES = NRES_MON*NM

C        VM    = VOL*FLOAT(NS)
C        VPERC = (VM/VOLUME)*100.0
C        VOLUME_LIMIT_MULTI = 1.0
C        NMON  = (VOLUME*VOLUME_LIMIT_MULTI)/VM



        VOLUME_LIMIT_MULTI = 0.8
        VM = VOL_MONOMER*REAL(NM)
        VPERC = (VM/VOL_EMPTY)*100.0
        NMON = (VOL_EMPTY*VOLUME_LIMIT_MULTI)/VM

C        IF(VOLUME.LE.VM.OR.NMON.LE.0) THEN
        IF(VOL_EMPTY.LE.VM.OR.NMON.LE.0) THEN
          WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON,VPERC
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(''                    Limit:'',F6.2)')
     *                                       VOLUME_LIMIT_MULTI
          CALL MSGDOC(MDOC,LINE)
          GO TO 610
        ENDIF
        WRITE(LINE,
     *    '(''INFO: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                     VOLUME_LIMIT_MULTI
        CALL MSGDOC(MDOC,LINE)
c -----
        FILE_OUT  = 'mod_'//CODE5//'_1multi'//CH4(1:LCH4)//'.pdb'      
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_OUT ,LO )
        IF(LEN.GT.0) THEN
          FILE_OUT  = PATH_OUT(1:LEN)//FILE_OUT(1:LO)
        ENDIF

        CALL CREATE_MULTIMER(MDOC,I,FILE_CRD,FILE_OUT,IERR) 
        IF(IERR.NE.0) THEN
          LINE = 'WARNING: problem with CREATE_MULTIMER'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 610
        ENDIF

        NS = NSYM
        IF(NSYM.LE.0) NS = 1
c        COMPL = (VOL*FLOAT(NS))/(VOLUME*VOLUME_LIMIT)
        COMPL = (VOL*FLOAT(NS))/VOLUME
        IF(COMPL.GT.1.0  )  COMPL = 1.0
        IF(COMPL.LT.0.001)  COMPL = 0.001
C ----
        T   = LOG((VOL*3.0)/(4.0*PI))
        RAD = EXP(T/3.0)
c ----
C       surf keyword
        IF(SURF_CORR.EQ.'Y') THEN
          SURF   = 'Y'
        ELSE
          SURF   = '2'
        ENDIF
c -----
        FILE_SEQ = 'null'
c ------
        COMPLEX_ID = '200'
        IF(TYPE_PDB.EQ.'dimer'   ) COMPLEX_ID = '200'
        IF(TYPE_PDB.EQ.'trimer'  ) COMPLEX_ID = '300'
        IF(TYPE_PDB.EQ.'tetramer') COMPLEX_ID = '222'
        IF(TYPE_PDB.EQ.'multimer') THEN
          WRITE(COMPLEX_ID(1:2),'(I2)') NM
          IF(COMPLEX_ID(1:1).EQ.' ') THEN
            COMPLEX_ID = COMPLEX_ID(2:2)//'00'
          ELSE
            COMPLEX_ID = COMPLEX_ID(1:2)//'00'
          ENDIF
        ENDIF
        DOM_ID     = '0'
c ------
c ------
      RAD_M = RAD
      CALL CALC_PDB_RADIUS_INERTIA(M,FILE_OUT,NTOT,RINER,IERR)
      IF(IERR.EQ.0) THEN
        t = riner/rad
        WRITE(line,'(A,3F8.3)') '--Riner,Radius,ratio:',riner,rad,t
        CALL MSGDOC(MDOC,LINE)
        RAD = RINER
        IF(RINER.LT.RAD_M) RAD_M = RINER
      ELSE
        IERR = 0
      ENDIF

      VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
      COMPL = (VOL*FLOAT(NS))/VOLUME
      IF(COMPL.GT.1.0  )  COMPL = 1.0
      IF(COMPL.LT.0.001)  COMPL = 0.001

c ------
        LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *     CHAIN_ID//' '//DOM_ID//' ===='
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,I5)')    '==Nmodels    :',NMON
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM,COMPL
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
        CALL MSGDOC(MDOC,LINE)     
        SIM_NMR = 0.5
        IF(SIM.GT.0.5) SIM_NMR = SIM 
c       write XML
        DOMAIN_CODE = ' '
        NSLIST = 0   
        FILE_NMR = 'null'
c ------
c -----
        CALL LENSTR_BL(FILE_NMR_C,LEN)
        IF(LEN.GT.0.AND.FILE_NMR_C.NE.'null') THEN

          CALL LENSTR_BL(FILE_OUT ,LO )
          FILE_NMR = FILE_OUT(1:LO-4)//'_ens.pdb'

          CALL CREATE_MULTIMER(MDOC,I,FILE_NMR_C,FILE_NMR,IERR) 
          IF(IERR.NE.0) THEN
            LINE = 'WARNING: problem with CREATE_MULTIMER'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            FILE_NMR = 'null'
            GO TO 610
          ENDIF
        ENDIF
c -----
        CALL WRITE_MODEL_XML(MDOC,IOUT
     *   ,DOMAIN_CODE
     *   ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     *   ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     *   ,SIM,COMPL,NMON,SURF,SIM_NMR
     *   ,FILE_NMR,FILE_OUT,FILE_SEQ,IERR)
        IF(IERR.NE.0) GO TO 530     

 610    CONTINUE
C
C       end multimer model
c -------------------------------
      ENDDO
C -------------------------------
C ---------------
 600  CONTINUE
      WRITE(IOUT,'(A)',ERR=520) '</structure>' 

      FILE_CORR = 'model_corr_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_CORR)

C --------------
 510  CONTINUE
      RETURN
 520  CONTINUE
      IERR = 2
      RETURN
 530  CONTINUE
      WRITE(IOUT,'(A)',ERR=520) '</structure>' 
      RETURN
1300  CONTINUE
      CLOSE(MT)
      LINE = 'ERROR: read user list file'
      CALL MSGERR(MDOC,LINE)
      IERR = 9
      RETURN
      END

      SUBROUTINE PREPARE_MONOMER(MDOC,NL,ISEQUENCE_LIST
     * ,CODE8,CHAIN
     * ,NSEQUENCE,ISEQUENCE,NAME_SEQ,FILE_OUT
     * ,FIDENT,NRES_ALIGN,NATOM_ALIGN
     * ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
c -----------------------------------
      INTEGER   MDOC,IERR
      INTEGER   ISEQUENCE_LIST(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      CHARACTER CODE8*8,CHAIN*1
      CHARACTER NAME_SEQ*(*),FILE_OUT*(*)
C ------------------------------------------------
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---------------------------------
      CHARACTER COMPLEX_DB*10
      CHARACTER COMPLEX_ID*10
      CHARACTER FILE_CRD*256,FILE_SEQ*256
      CHARACTER FILE_TEMP*256,FILE_TEMP2*256,FILE_XYZ*256
      CHARACTER PATH_DB*256,FILE_OUT_BEST*256
      CHARACTER SURF_CORR*1,ALIGN_CORR*1
      CHARACTER LINE*256
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C --------------------------------------------------
      ALIGN_CORR_LIMIT = 10.0
      NRES_ALIGN  = 0
      NATOM_ALIGN = 0
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) GO TO 900
      CALL LENSTR_BL(PATH_DB,LEN)

      IF(FILE_OUT.EQ.'null') THEN
        FILE_XYZ = PATH_DB(1:LEN)//'/pdb_DB/'//CODE8(1:5)//'.xyz'
      ELSE
        FILE_XYZ = PATH_DB(1:LEN)//'/add_DB/'//CODE8(1:5)//'.xyz'
      ENDIF
      FILE_CRD = CODE8(1:5)//'.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_CRD,LT )
      IF(LEN.GT.0) THEN
        FILE_CRD = PATH_SCR(1:LEN)//FILE_CRD(1:LT) 
      ENDIF
      CALL PDB_UNPACK(MDOC,FILE_XYZ,FILE_CRD,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: unpack XYZ file'
        CALL MSGERR(MDOC,LINE)
        IERR = 11
        RETURN
      ENDIF
C ---
      NDOM = 0
      COMPLEX_ID = ' '      
c     not used
c
C     set domain info into pdb file
      FILE_TEMP2 = 'mod_'//CODE8(1:5)//'_cmono.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_TEMP2,LT )
      IF(LEN.GT.0) THEN
        FILE_TEMP2 = PATH_SCR(1:LEN)//FILE_TEMP2(1:LT) 
      ENDIF
C     ierr=-1    set '-' in seg_id(76:76) (domains border)
c      IERR =-1
      IERR = 0
      CALL SET_DOMAIN_INFO_TO_PDB(M,FILE_CRD,FILE_TEMP2
     *  ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *  ,NDOM,CODE8,COMPLEX_DB,IERR)
      IF(IERR.NE.0.OR.NDOM.LE.0) THEN
        NDOM = 0
        IERR = 0
        FILE_TEMP2 = FILE_CRD
      ENDIF
c ---
      IST = 1
      IFN = NSEQUENCE
      IF(ISEQUENCE.GT.0) THEN
        IST = ISEQUENCE
        IFN = ISEQUENCE
      ENDIF

      ISEQUENCE_BEST = 0
      FIDENT_BEST    =-1.0
      FILE_OUT_BEST  = ' '
      NRES_BEST      = 0
      NATOM_BEST     = 0

      DO IS=IST,IFN

        IF(ISEQUENCE.EQ.0) THEN
          DO IL=1,NL
            IF(ISEQUENCE_LIST(IL).EQ.IS) GO TO 100
          ENDDO
        ENDIF

        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ = PATH_SCR(1:LEN)//'temp_sequence.seq'
        ELSE
          FILE_SEQ = 'temp_sequence.seq'
        ENDIF
        CALL GET_SEQUENCE(MDOC,IS,NAME_SEQ,FILE_SEQ,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGDOC(MDOC,'ERROR: in GET_SEQUENCE')
          GO TO 900
        ENDIF
        SURF_CORR  = 'Y'
        ALIGN_CORR = 'Y'
c -----
        FILE_TEMP = 'mod_'//CODE8(1:5)//'_cmono1.pdb'
        FILE_OUT  = 'mod_'//CODE8(1:5)//'_cmono2.pdb'      
        CALL LENSTR_BL(PATH_SCR ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        CALL LENSTR_BL(FILE_OUT ,LO )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_SCR(1:LEN)//FILE_TEMP(1:LT) 
          FILE_OUT  = PATH_SCR(1:LEN)//FILE_OUT(1:LO)
        ENDIF
        CALL MODEL_CORRECTION(MDOC,FILE_SEQ,FILE_TEMP2
     *    ,ALIGN_CORR_LIMIT,CHAIN
     *    ,FILE_OUT,FILE_TEMP
     *    ,SURF_CORR,ALIGN_CORR,NATOM,NRES,SML,CODE8
     *    ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in MODEL_CORRECTION'
          CALL MSGERR(MDOC,LINE)
          GO TO 900
        ENDIF
        WRITE(LINE,'(A,A,A,A)') 
     *   '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR,';'
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2I8,F7.2)') '--Natom,Nres,Ident:',NATOM,NRES,SML 
        CALL MSGDOC(MDOC,LINE)
        IF(SML.GT.FIDENT_BEST) THEN
          ISEQUENCE_BEST = IS
          FIDENT_BEST    = SML
          FILE_OUT_BEST  = FILE_OUT
          NRES_BEST      = NRES
          NATOM_BEST     = NATOM
        ENDIF
  100   CONTINUE
      ENDDO
      ISEQUENCE = ISEQUENCE_BEST
      FIDENT    = FIDENT_BEST
      FILE_OUT  = FILE_OUT_BEST
      NRES_ALIGN  = NRES_BEST
      NATOM_ALIGN = NATOM_BEST
  900 CONTINUE
      RETURN
      END

      SUBROUTINE WRITE_STRUCTURE_COMPLEX_XML(MDOC,IOUT,NAME_SEQ
     *      ,NRES_SUM,NATOM_SUM,CHAIN,FIDENT
     *      ,NCHAIN,NSEQUENCE
     *      ,CODE_CHAIN,FILE_CHAIN,NRES_CHAIN,NATOM_CHAIN
     *      ,ISEQUENCE_CHAIN
     *      ,FIDENT_CHAIN
     *      ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *      ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *      ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),NAME_SEQ*(*)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*)
      CHARACTER CHAIN*1
C ---
      CHARACTER CODE_CHAIN(NCHAIN)*8
      CHARACTER FILE_CHAIN(NCHAIN)*256
      INTEGER   NRES_CHAIN(NCHAIN)
      INTEGER   NATOM_CHAIN(NCHAIN)
      INTEGER   ISEQUENCE_CHAIN(NCHAIN)
      REAL      FIDENT_CHAIN(NCHAIN)
C --
      PARAMETER ( NLISTMAX = 100 )
      CHARACTER CODE_LIST(NLISTMAX)*8
      CHARACTER FILE_LIST(NLISTMAX)*256
      INTEGER   ICODE_LIST(NLISTMAX)
      INTEGER   NATOM_LIST(NLISTMAX)
      INTEGER   NRES_LIST(NLISTMAX)
      INTEGER   ISEQUENCE_LIST(NLISTMAX)
      REAL      FIDENT_LIST(NLISTMAX)
c -----------------------------------
      INTEGER   MDOC,IERR
      CHARACTER LINE*256,FILE_CRD*256,FILE_SEQ*256,PATH*256
      CHARACTER PATH_DB*256
      CHARACTER SURF*1,SURF_CORR*1,ALIGN_CORR*1,CODE8*8
      CHARACTER FILE_OUT*256,FILE_TEMP*256,CODE5*5
      CHARACTER FILE_XML*256,FILE_XYZ*256,FILE_NMR*256
      CHARACTER CH4*4,CH1*1,CH2*2
      CHARACTER COMPLEX_ID*8,CHAIN_ID*8,DOM_ID*8
      CHARACTER DOMAIN_CODE*8,TITLE*8
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
CC --------------------------------------------------
      COEF_NR_TO_VOL   = 166.2
      COEF_NA_TO_VOL   = 20.63
      ALIGN_CORR_LIMIT = 10.0
      VOLUME_LIMIT     = 0.80
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) GO TO 520
C       Example: "setenv MOLREP_DB ~alexei/molrep_DB"

      CALL MSGDOC(MDOC,'===================================')
      CALL MSGDOC(MDOC,'------ assembly ------')


      IF(FIDENT.LE.1.0) FIDENT = 1.0
      SIM = FIDENT/100.0

C     IF(NRES_SUM.LE.0) THEN
      IF(NATOM_SUM.LE.0) THEN
C       VOL_MON = FLOAT(N1_SEQ)*COEF_NR_TO_VOL
        VOL_MON = FLOAT(NA1_SEQ)*COEF_NA_TO_VOL
        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
      ELSE
C       VOL_MON = FLOAT(NRES_SUM)*COEF_NR_TO_VOL
        VOL_MON = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL
        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
      ENDIF

      NS = NSYM
      IF(NSYM.LE.0) NS = 1
      IF(VOLUME.LE.0.01) THEN
        IF(CELL(1).GT.0.01) THEN
          C4 = (CELL(4)*PI)/180.0
          C5 = (CELL(5)*PI)/180.0
          C6 = (CELL(6)*PI)/180.0
          COAL=COS(C4)
          COBE=COS(C5)
          COGA=COS(C6)
          VOLUME=CELL(1)*CELL(2)*CELL(3)*
     *           SQRT(1.-COAL**2-COBE**2-COGA**2+2.*COAL*COBE*COGA)
        ELSE
          VOLUME = VOL_MON*1.3*FLOAT(NS)
        ENDIF
      ENDIF
 
c       resolution
      RESMAX_USED = 3.0
      IF(RESMAX.GT.0.0001.AND.BOVERALL.GT.0.0001.AND.
     *                        OPT_RESOL.GT.0.0001) THEN
        CALL NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)              
        IF(RESMAX.LE.RESMAX_NEW) THEN
          RESMAX_USED = RESMAX_NEW
        ELSE
          RESMAX_USED = RESMAX
        ENDIF
      ENDIF
C --------------------------------------------------
      NASSEMBLY_LIM = 3
      NASSEMBLY     = 0
      DO I=1,NLISTMAX
        ICODE_LIST(I) = 0
        CODE_LIST(I)  = ' '
        FILE_LIST(I)  = ' '
        ISEQUENCE_LIST(I) = 0 
        FIDENT_LIST(I) = 100.0
        NRES_LIST(I)  = 0
        NATOM_LIST(I) = 0
      ENDDO

      DO IC=1,NCHAIN
        CALL LENSTR_BL(FILE_CHAIN(IC),LEN)
        IF(LEN.LE.0) THEN
          LEN = 4
          FILE_CHAIN(IC) = 'null'
        ENDIF
        WRITE(LINE,'(I5,1X,A,1X,2I5,1X,A,F7.1)')
     *    IC,CODE_CHAIN(IC),NRES_CHAIN(IC),ISEQUENCE_CHAIN(IC)
     *    ,FILE_CHAIN(IC)(1:LEN),FIDENT_CHAIN(IC)
        CALL MSGDOC(MDOC,LINE)
      ENDDO

      IF(NCHAIN.LE.1) RETURN

      DO IC=1,NCHAIN-1
        NL    = 0
        NRES  = 0
        NATOM = 0
        IF(IC.GT.1) THEN
          DO JC=1,IC-1
            IF(CODE_CHAIN(JC)(1:4).EQ.CODE_CHAIN(IC)(1:4)) GO TO 200
          ENDDO
        ENDIF
        NL = NL + 1  
        NRES  = NRES + NRES_CHAIN(IC) 
        NATOM = NATOM + NATOM_CHAIN(IC) 
        ICODE_LIST(NL) = IC
        CODE_LIST(NL)  = CODE_CHAIN(IC)
        FILE_LIST(NL)  = FILE_CHAIN(IC)
        NRES_LIST(NL)  = NRES_CHAIN(IC)
        NATOM_LIST(NL) = NATOM_CHAIN(IC)
        ISEQUENCE_LIST(NL) = ISEQUENCE_CHAIN(IC) 
        FIDENT_LIST(NL) = FIDENT_CHAIN(IC)
        DO JC=IC+1,NCHAIN
          IF(CODE_LIST(NL)(1:4).NE.CODE_CHAIN(JC)(1:4)) GO TO 100
          DO K=1,NL
            IF(ISEQUENCE_CHAIN(JC).EQ.
     *      ISEQUENCE_CHAIN(ICODE_LIST(K))) GO TO 100
          ENDDO
          NL = NL + 1
          NRES  = NRES + NRES_CHAIN(JC) 
          NATOM = NATOM + NATOM_CHAIN(JC) 
          ICODE_LIST(NL) = JC
          CODE_LIST(NL)  = CODE_CHAIN(JC)
          FILE_LIST(NL)  = FILE_CHAIN(JC)
          NRES_LIST(NL)  = NRES_CHAIN(JC)
          NATOM_LIST(NL) = NATOM_CHAIN(JC)
          ISEQUENCE_LIST(NL) = ISEQUENCE_CHAIN(JC) 
          FIDENT_LIST(NL) = FIDENT_CHAIN(JC)
  100     CONTINUE
        ENDDO
        IF(NL.GT.0) THEN         

c//
C          WRITE(*,*) '-----'
C          DO IL=1,NL
C            CALL LENSTR_BL(FILE_LIST(IL),LEN )
C            WRITE(*,*) IL,ISEQUENCE_LIST(IL),' ',CODE_LIST(IL) 
C     *      ,' ',FILE_LIST(IL)(1:LEN)
C          ENDDO
C          WRITE(*,*) '-----'
c//

          CALL LENSTR_BL(PATH_DB,LEN)
          FILE_XML = PATH_DB(1:LEN)//'/multimer/'//
     *    CODE_LIST(1)(1:5)//'.xml'

          CALL GET_MULTIMER_INFO2(MDOC,FILE_XML,PATH_DB
     *            ,NL,CODE_LIST,FILE_LIST,NLISTMAX,NMULT,IERR)
          IF(IERR.EQ.9) THEN
            IERR = 0
            GO TO 200
          ELSE IF(IERR.NE.0) THEN
            LINE = 'WARNING: problem with GET_MULTIMER_INFO'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF
          IF(NMULT.LE.0) GO TO 200
          IT = NASSEMBLY + 1
          WRITE(CH2,'(I2)') IT
          IF(CH2(1:1).EQ.' ') THEN
            FILE_OUT  = 'mod_'//CODE_LIST(1)(1:5)//'_'
     *                 //CH2(2:2)//'assembly.pdb'      
          ELSE
            FILE_OUT  = 'mod_'//CODE_LIST(1)(1:5)//'_'
     *                 //CH2//'assembly.pdb'
          ENDIF      
          CALL LENSTR_BL(PATH_OUT ,LEN)
          CALL LENSTR_BL(FILE_OUT ,LO )
          IF(LEN.GT.0) THEN
            FILE_OUT  = PATH_OUT(1:LEN)//FILE_OUT(1:LO)
          ENDIF

c//
C          WRITE(*,*) '====='
C          DO IL=1,NL
C            CALL LENSTR_BL(FILE_LIST(IL),LEN )
C            WRITE(LINE,'(2I5,A,A,F8.2,A,A)') 
C     *      IL,ISEQUENCE_LIST(IL),' '
C     *      ,CODE_LIST(IL),FIDENT_LIST(IL) 
C     *      ,' ',FILE_LIST(IL)(1:LEN)
C            CALL MSGDOC(MDOC,LINE)
C          ENDDO
C          WRITE(*,*) '====='
c//

          IF(NL.LT.2) GO TO 200          

          FSUM  = 0.0
          NRES  = 0
          NATOM = 0
          DO IL=1,NL
            IF(FILE_LIST(IL).EQ.'null'.OR.
     *         FILE_LIST(IL).EQ.'add_DB'  ) THEN
              IF(FILE_LIST(IL).EQ.'add_DB') THEN
                ISEQUENCE_LIST(IL) = 0
                FIDENT_LIST(IL)    = 0.0
              ENDIF
              CH1 = 'A'
              CALL PREPARE_MONOMER(M,NL,ISEQUENCE_LIST
     *          ,CODE_LIST(IL),CH1
     *          ,NSEQUENCE,ISEQUENCE_LIST(IL),NAME_SEQ,FILE_LIST(IL)
     *          ,FIDENT_LIST(IL),NRES_LIST(IL),NATOM_LIST(IL)
     *          ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
              IF(IERR.NE.0) THEN
                IERR = 0
                GO TO 200
              ENDIF
            ENDIF
            FIDENT = FIDENT_LIST(IL)
            FSUM   = FSUM + FIDENT
            NRES   = NRES + NRES_LIST(IL)
            NATOM  = NATOM + NATOM_LIST(IL)
          ENDDO

C          CALL MSGDOC(MDOC,'-------')
          NLL = 0
          DO IL=1,NL
            IF(ISEQUENCE_LIST(IL).GT.0) THEN
              NLL = NLL + 1
              ICODE_LIST(NLL) = ICODE_LIST(IL)
              CODE_LIST(NLL)  = CODE_LIST(IL)
              FILE_LIST(NLL)  = FILE_LIST(IL)
              NRES_LIST(NLL)  = NRES_LIST(IL)
              NATOM_LIST(NLL) = NATOM_LIST(IL)
              ISEQUENCE_LIST(NLL) = ISEQUENCE_LIST(IL) 
              FIDENT_LIST(NLL) = FIDENT_LIST(IL)
              FILE_LIST(NLL)   = FILE_LIST(IL)

C              CALL LENSTR_BL(FILE_LIST(NLL),LEN )
C              WRITE(LINE,'(2I5,A,A,F8.2,A,A)') 
C     *          NLL,ISEQUENCE_LIST(NLL),' '
C     *          ,CODE_LIST(NLL),FIDENT_LIST(NLL) 
C     *          ,' ',FILE_LIST(NLL)(1:LEN)
C              CALL MSGDOC(MDOC,LINE)

            ENDIF
          ENDDO
C          CALL MSGDOC(MDOC,'-------')
          NL = NLL
          IF(NL.LT.2) GO TO 200          


          FIDENT = FSUM/REAL(NL)
          IF(FIDENT.LE.1.0) FIDENT = 1.0
          SIM = FIDENT/100.0

          CALL CREATE_MULTIMER2(MDOC,NMULT
     *       ,NL,CODE_LIST,FILE_LIST,NATOM_LIST
     *       ,NM,FILE_OUT,NLISTMAX,IERR)
          IF(IERR.NE.0) THEN
            LINE = 'ERROR: problem with CREATE_MULTIMER2'
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200
          ENDIF
C ---
          LINE = '  PDB_code :'//CODE_LIST(1)(1:4)
          CALL LENSTR_BL(LINE,LEN)
          CALL MSGDOC(MDOC,LINE)

          CALL MSGDOC(MDOC,' -------')
          DO IL=1,NL
            CALL LENSTR_BL(FILE_LIST(IL),LEN )
            WRITE(LINE,'(2I5,A,A,F8.2,A,A)') 
     *      IL,ISEQUENCE_LIST(IL),' '
     *      ,CODE_LIST(IL),FIDENT_LIST(IL) 
     *      ,' ',FILE_LIST(IL)(1:LEN)
            CALL MSGDOC(MDOC,LINE)
          ENDDO
          CALL MSGDOC(MDOC,' -------')

C         VOL = FLOAT(NRES_SUM)*COEF_NR_TO_VOL
          VOL = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL
          T   = LOG((VOL*3.0)/(4.0*PI))
          RAD = EXP(T/3.0)

          NS = NSYM
          IF(NSYM.LE.0) NS = 1
          VM    = VOL*FLOAT(NS)
          VPERC = (VM/VOLUME)*100.0
          NMON  = (VOLUME*VOLUME_LIMIT)/VM
          IF(VOLUME.LE.VM.OR.NMON.LE.0) THEN
            WRITE(LINE,
     *     '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *      NMON,VPERC
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'(''                    Limit:'',F6.2)')
     *                                       VOLUME_LIMIT
            CALL MSGDOC(MDOC,LINE)
            GO TO 200
          ENDIF

C         VOL = FLOAT(NRES)*COEF_NR_TO_VOL
          VOL = FLOAT(NATOM)*COEF_NA_TO_VOL
          T   = LOG((VOL*3.0)/(4.0*PI))
          RAD = EXP(T/3.0)

          RAD_M = RAD
          CALL CALC_PDB_RADIUS_INERTIA(M,FILE_OUT,NTOT,RINER,IERR)
          IF(IERR.EQ.0) THEN
            t = riner/rad
            WRITE(line,'(A,3F8.3)') 
     *      '--Riner,Radius,ratio:',riner,rad,t
            CALL MSGDOC(MDOC,LINE)
            RAD = RINER
            IF(RINER.LT.RAD_M) RAD_M = RINER
          ELSE
            IERR = 0
          ENDIF
          T   = LOG((VOL*3.0)/(4.0*PI))
          RAD = EXP(T/3.0)
c ----
C         surf keyword
          SURF_CORR  = 'Y'
          ALIGN_CORR = 'Y'
          IF(SURF_CORR.EQ.'Y') THEN
            SURF   = 'Y'
          ELSE
            SURF   = '2'
          ENDIF

          VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
          COMPL = (VOL*FLOAT(NS))/VOLUME
          IF(COMPL.GT.1.0  )  COMPL = 1.0
          IF(COMPL.LT.0.001)  COMPL = 0.001

          WRITE(COMPLEX_ID(1:2),'(I2)') NM
          IF(COMPLEX_ID(1:1).EQ.' ') THEN
            COMPLEX_ID = COMPLEX_ID(2:2)//'00'
          ELSE
            COMPLEX_ID = COMPLEX_ID(1:2)//'00'
          ENDIF

          CHAIN_ID   = 'AB'
          IF(NM.GE.3) CHAIN_ID   = 'ABC'
          IF(NM.GE.4) CHAIN_ID   = 'ABCD'

          DOM_ID     = '0'
          FILE_SEQ = 'null'
c ------
          LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *       CHAIN_ID//' '//DOM_ID//' ===='
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,I5)')    '==Nmodels    :',NMON
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM,COMPL
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
          CALL MSGDOC(MDOC,LINE)     
          WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
          CALL MSGDOC(MDOC,LINE)    
          SIM_NMR = 0.5
          IF(SIM.GT.0.5) SIM_NMR = SIM 
          NASSEMBLY =  NASSEMBLY + 1
          IF(NASSEMBLY.LE.1) THEN
            WRITE(IOUT,'(A)',ERR=510) '<assembly>' 
          ENDIF
          WRITE(IOUT,'(A)',ERR=510) '<structure>' 
          TITLE(1:5) = 'ASSEM'
          WRITE(TITLE(6:8),'(I3)') NASSEMBLY 
          IF(TITLE(6:6).EQ.' ') TITLE(6:6) = '_'
          IF(TITLE(7:7).EQ.' ') TITLE(7:7) = '_'
          LINE =
     *    '  PDB_code <PDB_code> '//TITLE//' </PDB_code>'
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=520) LINE(1:LEN) 
          WRITE(IOUT,'(A)',ERR=520) 
     *    '  user_flag  <user_flag> '//'N'//' </user_flag>'
c         write XML
          DOMAIN_CODE = ' '
          NSLIST = NL
          FILE_NMR = 'null'
          SIM_NMR = 0.5
          IF(SIM.GT.0.5) SIM_NMR = SIM 
          CALL WRITE_MODEL_XML(MDOC,IOUT
     *     ,DOMAIN_CODE
     *     ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     *     ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     *     ,SIM,COMPL,NMON,SURF,SIM_NMR
     *     ,FILE_NMR,FILE_OUT,FILE_SEQ,IERR)
          IF(IERR.NE.0) GO TO 520     

          WRITE(IOUT,'(A)',ERR=520) '</structure>' 

        ENDIF
  200   CONTINUE
        IF(NASSEMBLY.GE.NASSEMBLY_LIM) GO TO 600
      ENDDO
C ---------------
 600  CONTINUE
      IF(NASSEMBLY.GE.1) THEN
        WRITE(IOUT,'(A)',ERR=520) '</assembly>' 
      ENDIF

      IF(NASSEMBLY.LE.0) THEN
        LINE = ' no assemblies found'
        CALL MSGDOC(MDOC,LINE)   
      ELSE  
        WRITE(LINE,'(I5,A)') NASSEMBLY,' assemblies found'
        CALL MSGDOC(MDOC,LINE)   
      ENDIF
C --------------
 510  CONTINUE
      RETURN
 520  CONTINUE
      IERR = 2
      RETURN
      END

      SUBROUTINE WRITE_STRUCTURE_DOM_XML(MDOC,ISQ,IOUT
     *  ,NAME_SEQ,NRES_SUM,NATOM_SUM,NRES_TOT,NATOM_TOT,CHAIN
     *  ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *  ,SPACE_GROUP,N1_SEQ,NA1_SEQ,Q_LIM
     *  ,ND_STRING,IDOMDOM,IDOMSEG
     *  ,PNUM1_DM,PNUM2_DM,CODE_HOMOL_DM
     *  ,FIDENT_DM,SCORE_DM,Q_DM
     *  ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *  ,IBACK_DOM_BASE,NRES_DOM_BASE
     *  ,NDOMAIN_BASE
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*),NAME_SEQ*(*),CHAIN*1
C ------------------------------------------------
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C ---
      PARAMETER ( NSTRMAX = 100 )
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      INTEGER   IDOMDOM(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
      CHARACTER CODE_HOMOL_DM(NSTRMAX)*8
      REAL      FIDENT_DM(NSTRMAX),SCORE_DM(NSTRMAX),Q_DM(NSTRMAX)
C ----
      PARAMETER ( NLISTMAX = 100 )
      CHARACTER CODE_LIST(NLISTMAX)*8
      INTEGER   ISEQUENCE_LIST(NLISTMAX)
c -----------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,FILE_CRD*256,FILE_SEQ*256,PATH*256
      CHARACTER PATH_DB*256,FILE_NMR*256
      CHARACTER FILE_CRD_TMP*256
      CHARACTER SURF*1,SURF_CORR*1,ALIGN_CORR*1,CODE8*8
      CHARACTER FILE_OUT*256,FILE_TEMP*256,CODE5*5
      CHARACTER FILE_XML*256,FILE_XYZ*256,FILE_SCR*256
      CHARACTER CH4*4,CH1*1,CH11*1,CH2*2
      CHARACTER COMPLEX_ID*8,CHAIN_ID*8,DOM_ID*8
      CHARACTER DOMAIN_CODE*8    
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
      CHARACTER LETTD*36
c                 123456789012345678901234567890123456
      DATA LETTD /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETTD/36/
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
CC --------------------------------------------------
      COEF_NR_TO_VOL   = 166.2
      COEF_NA_TO_VOL   = 20.63
      ALIGN_CORR_LIMIT = 10.0
      VOLUME_LIMIT     = 0.80
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) GO TO 520
C       Example: "setenv MOLREP_DB ~alexei/molrep_DB"

      CALL MSGDOC(MDOC,'===================================')
      WRITE(LINE,'(A,I5,A)') 
     *  '======  structure ',ISQ,'  ========'
      CALL MSGDOC(MDOC,LINE)

c     calc SIM,VOL_MON,NMON 
c
      NRES_REST = NRES_SUM - NRES_TOT
      NATOM_REST = NATOM_SUM - NATOM_TOT

      IF(NATOM_TOT.LE.0) THEN
        VOL_MON = FLOAT(NA1_SEQ)*COEF_NA_TO_VOL
        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
      ELSE
        VOL_MON = FLOAT(NATOM_TOT)*COEF_NA_TO_VOL
        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)
      ENDIF
      VOL_REST = FLOAT(NATOM_REST)*COEF_NA_TO_VOL
      VOL_SUM  = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL

      NS = NSYM
      IF(NSYM.LE.0) NS = 1
      IF(VOLUME.LE.0.01) THEN
        IF(CELL(1).GT.0.01) THEN
          C4 = (CELL(4)*PI)/180.0
          C5 = (CELL(5)*PI)/180.0
          C6 = (CELL(6)*PI)/180.0
          COAL=COS(C4)
          COBE=COS(C5)
          COGA=COS(C6)
          VOLUME=CELL(1)*CELL(2)*CELL(3)*
     *           SQRT(1.-COAL**2-COBE**2-COGA**2+2.*COAL*COBE*COGA)
        ELSE
          VOLUME = VOL_MON*1.3*FLOAT(NS)
        ENDIF
      ENDIF 


CCC      VM = VOL_MON
      VM = VOL_SUM

CCC      VOL_EMPTY = VOLUME/REAL(NS) - VOL_REST 
      VOL_EMPTY = VOLUME/REAL(NS) 
      VPERC = (VM/VOL_EMPTY)*100.0
      NMON1 = (VOL_EMPTY*VOLUME_LIMIT)/VM

      IF(VOL_EMPTY.LE.VM) THEN
        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                           VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)
        GO TO 520
      ENDIF
      IF(NMON1.LE.0) THEN
        NMON1 = 1
      ENDIF

        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *  NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                             VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)

c     resolution
      RESMAX_USED = 3.0
      IF(RESMAX.GT.0.0001.AND.BOVERALL.GT.0.0001.AND.
     *                        OPT_RESOL.GT.0.0001) THEN
        CALL NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)              
        IF(RESMAX.LE.RESMAX_NEW) THEN
          RESMAX_USED = RESMAX_NEW
        ELSE
          RESMAX_USED = RESMAX
        ENDIF
      ENDIF

C      Q_LIM = 0.8
C      Q_MAX = 0.0
C      DO II=1,ND_STRING
C        IF(Q_MAX.LT.Q_DM(II)) Q_MAX = Q_DM(II)
C      ENDDO
C      IF(Q_MAX.LT.Q_LIM) THEN
C        WRITE(LINE,'(A,F6.3)') 
C     *  'WARNING: no domains with Q >',Q_LIM
C        CALL MSGDOC(MDOC,LINE)
C        GO TO 510
C      ENDIF

      NDOM  = IDOMDOM(1)
      N     = 0
      DO IDOM=1,NDOM
        DO II=1,ND_STRING
          IT = IDOMSEG(II)/100
          IF(IT.EQ.IDOM) THEN
            IF(Q_DM(II).GE.Q_LIM) N = N + 1
            GO TO 111
          ENDIF
        ENDDO      
  111   CONTINUE
      ENDDO
      IF(N.LT.1) THEN
        WRITE(LINE,'(A,F6.3,A)') 
     *  'WARNING: Ndomains (with Q >',Q_LIM,') = 0'
        CALL MSGDOC(MDOC,LINE)
        GO TO 510
      ENDIF
C --------------------------------------------------
C    titles
C ---
      WRITE(IOUT,'(A)',ERR=510) '<structure>' 
      LINE =
     * '  PDB_code <PDB_code> '//'MDOM'//' </PDB_code>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=520) LINE(1:LEN) 
      WRITE(IOUT,'(A)',ERR=520) 
     *'  user_flag  <user_flag> '//'N'//' </user_flag>'

C--------------------
C
c     domain models
C

      CALL MSGDOC(MDOC,'------ multi-domains ------')

      NDOM    = IDOMDOM(1)
      NUM_DOM = 0

      DO IDOM=1,NDOM

        DO II=1,ND_STRING
          IT = IDOMSEG(II)/100
          IF(IT.EQ.IDOM) THEN
            CODE8  = CODE_HOMOL_DM(II)
            FIDENT = FIDENT_DM(II)
            Q      = Q_DM(II)
            GO TO 100
          ENDIF
        ENDDO
        GO TO 710
  100   CONTINUE
        
        WRITE(LINE,'(A,I5,A,A,A,F6.1,1X,F6.3)') 
     *  '-------  Domain:',idom,' code: ',CODE8
     *  ,'  Ident,Q:',FIDENT,Q
        CALL MSGDOC(MDOC,LINE)
        IF(Q.LT.Q_LIM) THEN
          WRITE(LINE,'(A,F6.3)') 
     *    'WARNING: this domain will not be used, Q <',Q_LIM
          CALL MSGDOC(MDOC,LINE)
          GO TO 710
        ENDIF

        FILE_SEQ = 'target.seq'
        CALL LENSTR_BL(PATH_SCR ,LEN)
        IF(LEN.GT.0) THEN
          FILE_SEQ = PATH_SCR(1:LEN)//'target.seq' 
        ENDIF 

        CALL CREATE_DOMAIN_SEQUENCE(M,NAME_SEQ,FILE_SEQ
     *    ,IDOM,NRES,NAA_MAX
     *    ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *    ,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERROR: in CREATE_DOMAIN_SEQUENCE'
          CALL MSGDOC(MDOC,LINE)
          IERR = 0
          GO TO 710
        ENDIF

        NUM_DOM = NUM_DOM + 1
        IF(NUM_DOM.LE.9) THEN
          WRITE(CH1,'(I1)') NUM_DOM
        ELSE IF(NUM_DOM.LE.NLETT) THEN
          I = NUM_DOM - 9 
          CH1 = LETT(I:I)
        ELSE
          CH1 = 'X'
        ENDIF

        FILE_SCR = ' '
        FILE_CRD = 'mod_'//CODE8(1:7)//'_'//CH1//'dom.pdb'
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_CRD,LT )
        IF(LEN.GT.0) THEN
          FILE_CRD = PATH_OUT(1:LEN)//FILE_CRD(1:LT) 
        ENDIF

        CALL CREATE_DOM_SEQ_AND_PDB(MDOC
     *       ,CODE8,FILE_SCR,FILE_CRD
     *       ,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: in CREATE_DOM_SEQ_FROM_PDB :'//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 710
        ENDIF

        SURF_CORR  = 'Y'
        ALIGN_CORR = 'Y'
        SIM  = FIDENT/100.0
        ALIGN_CORR_LIM = 0.10
        IF(FIDENT.LT.ALIGN_CORR_LIM) ALIGN_CORR = 'N'
        VOL  = VOL_MON
        RAD  = RAD_MON
        NMON = NMON1      
c -----
        FILE_TEMP = 'mod_'//CODE8(1:7)//'_'//CH1//'dom1.pdb'
        FILE_OUT  = 'mod_'//CODE8(1:7)//'_'//CH1//'dom2.pdb'      
        CALL LENSTR_BL(PATH_OUT ,LEN)
        CALL LENSTR_BL(FILE_TEMP,LT )
        CALL LENSTR_BL(FILE_OUT ,LO )
        IF(LEN.GT.0) THEN
          FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
          FILE_OUT  = PATH_OUT(1:LEN)//FILE_OUT(1:LO)
        ENDIF

        CALL MODEL_CORRECTION(MDOC,FILE_SEQ,FILE_CRD
     *    ,ALIGN_CORR_LIMIT,CHAIN
     *    ,FILE_OUT,FILE_TEMP
     *    ,SURF_CORR,ALIGN_CORR,NATOM,NRES,SML,CODE8
     *    ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
        IF(IERR.NE.0) GO TO 530

        WRITE(LINE,'(A,A,A)') 
     *   '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR 
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2I8,F7.2)') '--Natom,Nres,Ident:',NATOM,NRES,SML 
        CALL MSGDOC(MDOC,LINE)
        NRES_MON = NRES
        IF(SURF_CORR.EQ.'Y'.OR.ALIGN_CORR.EQ.'Y') THEN
C         VOL = FLOAT(NRES)*COEF_NR_TO_VOL
C         V   = FLOAT(NATOM)*COEF_NA_TO_VOL
C         IF(V.GT.VOL) VOL = V
          VOL = FLOAT(NATOM)*COEF_NA_TO_VOL
        ENDIF

        NS = NSYM
        IF(NSYM.LE.0) NS = 1
        COMPL = (VOL*FLOAT(NS))/VOLUME
        IF(COMPL.GT.1.0  )  COMPL = 1.0
        IF(COMPL.LT.0.001)  COMPL = 0.001
C ----
        T   = LOG((VOL*3.0)/(4.0*PI))
        RAD = EXP(T/3.0)
        RAD_MON = RAD
c ----
C       surf keyword
        IF(SURF_CORR.EQ.'Y') THEN
          SURF   = 'Y'
        ELSE
          SURF   = '2'
        ENDIF
c -----
C       files
        FILE_CRD = FILE_OUT
C -------
C       set domain ID
        FILE_CRD_TMP = 'temp_gsdb.pdb'
        CALL LENSTR_BL(PATH_SCR,LEN)
        IF(LEN.GT.0) THEN
          FILE_CRD_TMP = PATH_SCR(1:LEN)//'temp_gsdb.pdb' 
        ENDIF 
        NM = 0
        CALL COPY_PDB_FILE(M,NM
     *               ,FILE_CRD,FILE_CRD_TMP,IERR)
        IF(IERR.NE.0) THEN
          LINE = 'ERR: in COPY_PDB_FILE_AND_SET_DOM_ID :'//CODE8
          CALL MSGERR(MDOC,LINE)
          CALL DELETE_FILE(PATH_SCR,FILE_CRD_TMP)
          IERR = 0
          GO TO 710
        ENDIF
        CALL COPY_PDB_FILE_AND_SET_DOM_ID(M,CH1
     *               ,FILE_CRD_TMP,FILE_CRD,IERR)
        IF(IERR.NE.0) THEN
          CALL DELETE_FILE(PATH_SCR,FILE_CRD_TMP)
          LINE = 'ERR: in COPY_PDB_FILE_AND_SET_DOM_ID :'//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 710
        ENDIF
C ------
        IF(ALIGN_CORR.EQ.'Y') THEN
          FILE_SEQ = 'null'
        ENDIF
        FILE_SEQ = 'null'
c ------
        RAD_M = RAD
        CALL CALC_PDB_RADIUS_INERTIA(M,FILE_CRD,NTOT,RINER,IERR)
        IF(IERR.EQ.0) THEN
          t = riner/rad
          WRITE(line,'(A,3F8.3)') '--Riner,Radius,ratio:',riner,rad,t
          CALL MSGDOC(MDOC,LINE)
          RAD = RINER
          IF(RINER.LT.RAD_M) RAD_M = RINER
          RINER_MON = RINER
        ELSE
          IERR = 0
        ENDIF

        VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
        COMPL = (VOL*FLOAT(NS))/VOLUME
        IF(COMPL.GT.1.0  )  COMPL = 1.0
        IF(COMPL.LT.0.001)  COMPL = 0.001

C -----
        COMPLEX_ID = '100'
        CHAIN_ID   = CHAIN
        WRITE(CH2,'(I2)') NUM_DOM
        DOM_ID     = CH2
c ------
        LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *     CHAIN_ID//' '//DOM_ID//' ===='
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,I5)')    '==Nmodels    :',NMON
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM,COMPL
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
        CALL MSGDOC(MDOC,LINE)     
        WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
        CALL MSGDOC(MDOC,LINE)     
        SIM_NMR = 0.5
        IF(SIM.GT.0.5) SIM_NMR = SIM 
c       write XML
        DOMAIN_CODE = CODE8(1:7)
        NSLIST = 0

        CH11 = CODE8(7:7)
        DO I=1,NLETTD
          IF(CH11.EQ.LETTD(I:I)) THEN
            IDM = I-1
            GO TO 200
          ENDIF
        ENDDO
        IDM = 0
  200   CONTINUE

        FILE_NMR = 'null'

        CALL LENSTR_BL(FILE_CRD,LT )
        FILE_NMR = FILE_CRD(1:LT-4)//'_ens.pdb'

        CALL CREATE_NMR_FOR_DOMAIN(M,NRES,NRES_DOM
     *   ,CODE8,IDM,NMODEL,FILE_NMR,FILE_CRD_TMP,NAME_SEQ
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)

        WRITE(LINE,'(A,I6)') 'INFO: Nmodel_ens :',NMODEL
        CALL MSGDOC(MDOC,LINE)

        IF(IERR.NE.0.OR.NMODEL.LE.3) THEN
          IF(IERR.EQ.33) THEN
            WRITE(LINE,'('' Nres_DB Nres:'',2I8)') NRES_DOM,NRES
            CALL MSGERR(MDOC,LINE)
            LINE = ' INFO: no NMR file'
            CALL MSGERR(MDOC,LINE)
          ELSE IF(IERR.NE.13.AND.IERR.NE.33.AND.NMODEL.GT.3) THEN
            LINE = ' ERROR: CREATE_NMR_FOR_DOMAIN'
            CALL MSGERR(MDOC,LINE)
          ELSE
            LINE = ' INFO: no NMR file'
            CALL MSGERR(MDOC,LINE)
          ENDIF
          IERR = 0
          FILE_NMR = 'null'
        ELSE
C -------
C         set domain ID
          FILE_CRD_TMP = 'temp_gsdb.pdb'
          CALL LENSTR_BL(PATH_SCR,LEN)
          IF(LEN.GT.0) THEN
            FILE_CRD_TMP = PATH_SCR(1:LEN)//'temp_gsdb.pdb' 
          ENDIF 
          CALL COPY_PDB_FILE_AND_SET_DOM_ID(M,CH1
     *               ,FILE_NMR,FILE_CRD_TMP,IERR)
          IF(IERR.NE.0) THEN
            CALL DELETE_FILE(PATH_SCR,FILE_CRD_TMP)
            LINE = 'ERR: in COPY_PDB_FILE_AND_SET_DOM_ID :'//CODE8
            CALL MSGERR(MDOC,LINE)
            FILE_NMR = 'null'
            IERR = 0
          ELSE
            CALL COPY_PDB_FILE_AND_SET_DOM_ID(M,CH1
     *               ,FILE_CRD_TMP,FILE_NMR,IERR)
            CALL DELETE_FILE(PATH_SCR,FILE_CRD_TMP)
            IF(IERR.NE.0) THEN
              LINE = 'ERR: in COPY_PDB_FILE_AND_SET_DOM_ID :'//CODE8
              CALL MSGERR(MDOC,LINE)
              FILE_NMR = 'null'
              IERR = 0
            ELSE
              CALL MSGDOC(MDOC,' -- NMR file was created')
            ENDIF
          ENDIF

        ENDIF

        CALL WRITE_MODEL_XML(MDOC,IOUT
     *   ,DOMAIN_CODE
     *   ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     *   ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     *   ,SIM,COMPL,NMON,SURF,SIM_NMR
     *   ,FILE_NMR,FILE_CRD,FILE_SEQ,IERR)
        IF(IERR.NE.0) GO TO 530     

 710    CONTINUE
C
C     end domain model
c -------------------------------
      ENDDO

 700  CONTINUE
C ---------------
 600  CONTINUE
      WRITE(IOUT,'(A)',ERR=520) '</structure>' 

      FILE_CRD_TMP = 'temp_gsdb.pdb'
      CALL DELETE_FILE(PATH_SCR,FILE_CRD_TMP)

C --------------
 510  CONTINUE
      RETURN
 520  CONTINUE
      IERR = 2
      RETURN
 530  CONTINUE
      WRITE(IOUT,'(A)',ERR=520) '</structure>' 
      RETURN
      END

      SUBROUTINE WRITE_STRUCTURE_PDB_XML(MDOC,ISQ,ISEQ,IOUT,NAME_SEQ
     *  ,NAME_PDB,PDB,SEQ,NRES_SUM,NATOM_SUM
     *  ,NSYM,VOLUME,RESMAX,RESMIN,OPT_RESOL,BOVERALL,CELL
     *  ,SPACE_GROUP,N1_SEQ,NA1_SEQ
     *  ,CODE_DB,NAA_DB,RESOL_DB,NAT_DB
     *  ,NRES_DB,FIDENT_DB,SCR_DB,ID_DB
     *  ,IFLAG_DOM,IFLAG_MULT          
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*)
      REAL      CELL(*)
      CHARACTER SPACE_GROUP*(*),NAME_SEQ*(*),NAME_PDB*(*)
      CHARACTER PDB*1,SEQ*1
C ---
      INTEGER   ID_DB,NAA_DB,NAT_DB
     *         ,NRES_DB,ISEQ
      REAL      RESOL_DB,FIDENT_DB,SCR_DB
      CHARACTER CODE_DB*8
C ------------------------------------------------
      CHARACTER TYPE_PDB*8
C ----
      PARAMETER ( NLISTMAX = 100 )
      CHARACTER CODE_LIST(NLISTMAX)*8
      INTEGER   ISEQUENCE_LIST(NLISTMAX)
c -----------------------------------
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256,FILE_CRD*256,FILE_SEQ*256,PATH*256
      CHARACTER PATH_DB*256,FILE_NMR*256
      CHARACTER SURF*1,SURF_CORR*1,ALIGN_CORR*1,CODE8*8
      CHARACTER FILE_OUT*256,FILE_TEMP*256,CODE5*5
      CHARACTER FILE_XML*256,FILE_XYZ*256
      CHARACTER CH4*4,CH1*1,CHAIN*1
      CHARACTER COMPLEX_ID*8,CHAIN_ID*8,DOM_ID*8
      CHARACTER DOMAIN_CODE*8    
      CHARACTER LETT*26
c                 01234567890123456789012345
      DATA LETT /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/26/
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
CC --------------------------------------------------
      COEF_NR_TO_VOL   = 166.2
      COEF_NA_TO_VOL   = 20.63
      ALIGN_CORR_LIMIT = 10.0
      VOLUME_LIMIT     = 0.80
      CHAIN = 'A'
C --------------------------------------------------
      CALL GET_PATH(MDOC,'MOLREP_DB',PATH_DB,IERR)
      IF(IERR.NE.0) GO TO 520
C       Example: "setenv MOLREP_DB ~alexei/molrep_DB"

      CALL MSGDOC(MDOC,'===================================')
      WRITE(LINE,'(A,I5,A)') 
     *  '======  structure ',ISQ,'  ========'
      CALL MSGDOC(MDOC,LINE)

c      write(line,*) '>>seq,vol,nres_sum:',seq,volume,nres_sum
c      CALL MSGDOC(MDOC,LINE)

      IF(SEQ.EQ.'Y') THEN

c      calc SIM,VOL_MON,NMON 
c
C     
C       VOL_MON = FLOAT(N1_SEQ)*COEF_NR_TO_VOL
        VOL_MON = FLOAT(NA1_SEQ)*COEF_NA_TO_VOL

        T       = LOG((VOL_MON*3.0)/(4.0*PI))
        RAD_MON = EXP(T/3.0)

        NS = NSYM
        IF(NSYM.LE.0) NS = 1
        IF(VOLUME.LE.0.01) THEN
          IF(CELL(1).GT.0.01) THEN
            C4 = (CELL(4)*PI)/180.0
            C5 = (CELL(5)*PI)/180.0
            C6 = (CELL(6)*PI)/180.0
            COAL=COS(C4)
            COBE=COS(C5)
            COGA=COS(C6)
            VOLUME=CELL(1)*CELL(2)*CELL(3)*
     *           SQRT(1.-COAL**2-COBE**2-COGA**2+2.*COAL*COBE*COGA)
          ELSE
            VOLUME = VOL_MON*1.3*FLOAT(NS)
          ENDIF
        ENDIF 
        VM = VOL_MON*FLOAT(NS)
C ---
        IF(NRES_SUM.GT.0) THEN
C         VM_FIXED = FLOAT(NRES_SUM)*COEF_NR_TO_VOL
          VM_FIXED = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL
          VM = VM + VM_FIXED*FLOAT(NS)
        ENDIF
C ---
        VPERC = (VM/VOLUME)*100.0
        NMON1 = (VOLUME*VOLUME_LIMIT)/VM
        IF(VOLUME.LE.VM) THEN
          WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                           VOLUME_LIMIT
          CALL MSGDOC(MDOC,LINE)
          GO TO 520
        ENDIF
        IF(NMON1.LE.0) THEN
          NMON1 = 1
        ENDIF

        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *  NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                             VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)

c       resolution
        RESMAX_USED = 3.0
        IF(RESMAX.GT.0.0001.AND.BOVERALL.GT.0.0001.AND.
     *                        OPT_RESOL.GT.0.0001) THEN
          CALL NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)              
          IF(RESMAX.LE.RESMAX_NEW) THEN
            RESMAX_USED = RESMAX_NEW
          ELSE
            RESMAX_USED = RESMAX
          ENDIF
        ENDIF

      ENDIF
C --------------------------------------------------
C    titles
C ---
      WRITE(IOUT,'(A)',ERR=510) '<structure>' 
      LINE =
     * '  PDB_code <PDB_code> '//'USER'//' </PDB_code>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=520) LINE(1:LEN) 
      WRITE(IOUT,'(A)',ERR=520) 
     *'  user_flag  <user_flag> '//PDB//' </user_flag>'
C--------------------
C     start model
C -------------------
      CALL MSGDOC(MDOC,'===================================')
      CODE8 = CODE_DB
      LINE = '==:'//CODE8
      CALL MSGDOC(MDOC,LINE)
      FILE_CRD = NAME_PDB
C ---
      FILE_SEQ = NAME_SEQ

      SURF_CORR  = 'Y'
      ALIGN_CORR = 'Y'

      IF(SEQ.EQ.'N') ALIGN_CORR = 'N'

C      VOL  = VOL_MON
C      RAD  = RAD_MON
C      NMON = NMON1      
c -----
      FILE_TEMP = 'mod_'//CODE8(1:5)//'_mono1.pdb'
      FILE_OUT  = 'mod_'//CODE8(1:5)//'_mono2.pdb'      
      CALL LENSTR_BL(PATH_OUT ,LEN)
      CALL LENSTR_BL(FILE_TEMP,LT )
      CALL LENSTR_BL(FILE_OUT ,LO )
      IF(LEN.GT.0) THEN
        FILE_TEMP = PATH_OUT(1:LEN)//FILE_TEMP(1:LT) 
        FILE_OUT  = PATH_OUT(1:LEN)//FILE_OUT(1:LO)
      ENDIF

      CALL MODEL_CORRECTION(MDOC,FILE_SEQ,FILE_CRD
     *  ,ALIGN_CORR_LIMIT,CHAIN
     *  ,FILE_OUT,FILE_TEMP
     *  ,SURF_CORR,ALIGN_CORR,NATOM,NRES,SML,CODE8
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
      IF(IERR.NE.0) GO TO 520

      WRITE(LINE,'(A,A,A)') 
     * '--Correction Surf,Align:',SURF_CORR,ALIGN_CORR 
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,2I8,F7.2)') '--Natom,Nres,Ident:',NATOM,NRES,SML 
      CALL MSGDOC(MDOC,LINE)
      NRES_MON = NRES
C -----
C     VOL,COMPL,RAD from pdb_model
C     
      FIDENT_DB = SML
      IF(FIDENT_DB.LE.0.001) FIDENT_DB = 50.0
      SIM     = FIDENT_DB/100.0

C      VOL_MON = FLOAT(NRES)*COEF_NR_TO_VOL
C      V       = FLOAT(NATOM)*COEF_NA_TO_VOL
C      IF(V.GT.VOL_MON) VOL_MON = V

      VOL_MON = FLOAT(NATOM)*COEF_NA_TO_VOL
      T       = LOG((VOL_MON*3.0)/(4.0*PI))
      RAD_MON = EXP(T/3.0)
      NS = NSYM
      IF(NSYM.LE.0) NS = 1
      IF(VOLUME.LE.0.01) THEN
        IF(CELL(1).GT.0.01) THEN
          C4 = (CELL(4)*PI)/180.0
          C5 = (CELL(5)*PI)/180.0
          C6 = (CELL(6)*PI)/180.0
          COAL=COS(C4)
          COBE=COS(C5)
          COGA=COS(C6)
          VOLUME=CELL(1)*CELL(2)*CELL(3)*
     *           SQRT(1.-COAL**2-COBE**2-COGA**2+2.*COAL*COBE*COGA)
        ELSE
          VOLUME = VOL_MON*1.3*FLOAT(NS)
        ENDIF
      ENDIF 
      VM = VOL_MON*FLOAT(NS)
      VPERC = (VM/VOLUME)*100.0

      IF(SEQ.EQ.'N') THEN

      IF(NRES_SUM.GT.0) THEN
C       VM_FIXED = FLOAT(NRES_SUM)*COEF_NR_TO_VOL
        VM_FIXED = FLOAT(NATOM_SUM)*COEF_NA_TO_VOL
        VM = VM + VM_FIXED*FLOAT(NS)
      ENDIF

      NMON1 = (VOLUME*VOLUME_LIMIT)/VM
      IF(VOLUME.LE.VM) THEN
        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                               VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)
        IERR = 21
        RETURN
      ENDIF
      IF(NMON1.LE.0) THEN
        WRITE(LINE,
     *    '(''WARNING: Nmod='',I4,'' Percent of volume:'',F5.1)') 
     *    NMON1,VPERC
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(''                    Limit:'',F5.2)')
     *                                               VOLUME_LIMIT
        CALL MSGDOC(MDOC,LINE)
        NMON1 = 1
      ENDIF

      ENDIF
c -----
c     resolution
      RESMAX_USED = 3.0
      IF(RESMAX.GT.0.0001.AND.BOVERALL.GT.0.0001.AND.
     *                        OPT_RESOL.GT.0.0001) THEN
        CALL NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)              
        RESMAX_USED = RESMAX_NEW
      ENDIF

      VOL  = VOL_MON
      RAD  = RAD_MON
      NMON = NMON1      

      NS = NSYM
      IF(NSYM.LE.0) NS = 1
c      COMPL = (VOL*FLOAT(NS))/(VOLUME*VOLUME_LIMIT)
      COMPL = (VOL*FLOAT(NS))/VOLUME
      IF(COMPL.GT.1.0  )  COMPL = 1.0
      IF(COMPL.LT.0.001)  COMPL = 0.001
C ----
      T   = LOG((VOL*3.0)/(4.0*PI))
      RAD = EXP(T/3.0)
      RAD_MON = RAD
c ----
C     surf keyword
      IF(SURF_CORR.EQ.'Y') THEN
        SURF   = 'Y'
      ELSE
        SURF   = '2'
      ENDIF
c -----
C     files
      FILE_CRD = FILE_OUT
      IF(ALIGN_CORR.EQ.'Y') THEN
        FILE_SEQ = 'null'
      ENDIF
      FILE_SEQ = 'null'
c ------
      COMPLEX_ID = '100'
      CHAIN_ID = CODE8(5:5)
      CHAIN_ID   = 'A'
      DOM_ID     = '0'
c ------
      RAD_M = RAD
      CALL CALC_PDB_RADIUS_INERTIA(M,FILE_CRD,NTOT,RINER,IERR)
      IF(IERR.EQ.0) THEN
        t = riner/rad
        WRITE(line,'(A,3F8.3)') '--Riner,Radius,ratio:',riner,rad,t
        CALL MSGDOC(MDOC,LINE)
        RAD = RINER
        IF(RINER.LT.RAD_M) RAD_M = RINER
        RINER_MON = RINER
      ELSE
        IERR = 0
      ENDIF

      VOL = (4.0*PI*RAD_M*RAD_M*RAD_M)/3.0
      COMPL = (VOL*FLOAT(NS))/VOLUME
      IF(COMPL.GT.1.0  )  COMPL = 1.0
      IF(COMPL.LT.0.001)  COMPL = 0.001

      LINE = '==== Id Chain Dom : '//COMPLEX_ID//' '//
     *   CHAIN_ID//' '//DOM_ID//' ===='
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,I5)')    '==Nmonomers  :',NMON
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'(A,2F8.3)') '==Sim,Compl  :',SIM,COMPL
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,F8.3)')  '==Resmax_used:',RESMAX_USED
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,F8.3)')  '==Radius     :',RAD
      CALL MSGDOC(MDOC,LINE)     
      WRITE(LINE,'(A,I6)')    '==Nresidues  :',NRES
      CALL MSGDOC(MDOC,LINE)     
      SIM_NMR = 0.5
      IF(SIM.GT.0.5) SIM_NMR = SIM 
c ------
c     write XML
      DOMAIN_CODE = ' '
      NSLIST = 0
      FILE_NMR = 'null' 
      CALL WRITE_MODEL_XML(MDOC,IOUT
     * ,DOMAIN_CODE
     * ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     * ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     * ,SIM,COMPL,NMON,SURF,SIM_NMR
     * ,FILE_NMR,FILE_CRD,FILE_SEQ,IERR)
      IF(IERR.NE.0) GO TO 520     
C
C     end model
c -------------------------------
C ---------------
 600  CONTINUE
      WRITE(IOUT,'(A)',ERR=520) '</structure>' 
C --------------
 510  CONTINUE
      RETURN
 520  CONTINUE
      IERR = 2
      RETURN
      END

      SUBROUTINE WRITE_MODEL_XML(MDOC,IOUT
     * ,DOMAIN_CODE
     * ,NSLIST,ISEQUENCE_LIST,CODE_LIST,NLISTMAX
     * ,COMPLEX_ID,CHAIN_ID,DOM_ID,RAD,VOL,RESMAX_USED,NRES
     * ,SIM,COMPL,NMON,SURF,SIM_NMR
     * ,FILE_NMR,FILE_CRD,FILE_SEQ,IERR)
c -----------------------------------------------
      INTEGER   MDOC,IERR,IOUT
      CHARACTER FILE_CRD*(*),FILE_SEQ*(*),FILE_NMR*(*)
      CHARACTER SURF*1
      CHARACTER COMPLEX_ID*8,CHAIN_ID*8,DOM_ID*8
      CHARACTER DOMAIN_CODE*8    
      CHARACTER LINE*256
      CHARACTER CODE_LIST(NLISTMAX)*8
      INTEGER   ISEQUENCE_LIST(NLISTMAX)
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------------------------------------
      WRITE(IOUT,'(A)',ERR=510) '  <model>'
      CALL LENSTR_BL(COMPLEX_ID,L)
      LINE = '    complex <complex> '//COMPLEX_ID(1:L)//' </complex>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      CALL LENSTR_BL(CHAIN_ID,L)
      LINE = '    chain <chain> '//CHAIN_ID(1:L)//' </chain>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      CALL LENSTR_BL(DOM_ID,L)
      LINE = '    domain <domain> '//DOM_ID(1:L)//' </domain>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      IF(NSLIST.GT.0) THEN
        WRITE(LINE,'(A,I10,A)',ERR=510)
     *   '    N_sequences <Nseq> ',NSLIST,' </Nseq>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
        DO IS=1,NSLIST
          WRITE(LINE,'(A,I10,A)',ERR=510)
     *     '      I_seq <Iseq> ',ISEQUENCE_LIST(IS),' </Iseq>'
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
          CALL LENSTR_BL(CODE_LIST(IS),L)
          LINE = '      str_code <str_code> '//
     *         CODE_LIST(IS)//' </str_code>'
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
        ENDDO
      ENDIF

      CALL LENSTR_BL(DOMAIN_CODE,L)
      IF(L.GT.0) THEN
        LINE = '    domain_code <domain_code> '//
     *         DOMAIN_CODE(1:L)//' </domain_code>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF
 
      WRITE(LINE,'(A,F6.1,A)',ERR=510)
     * '    radius <radius> ',RAD,' </radius>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,F10.1,A)',ERR=510)
     * '    volume <volume> ',VOL,' </volume>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I10,A)',ERR=510)
     * '    n_residues <nres> ',NRES,' </nres>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,F6.2,A)',ERR=510)
     * '    resmax_used <resmax_used> ',RESMAX_USED,' </resmax_used>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,F7.3,A)',ERR=510)
     * '    similarity <similarity> ',SIM,' </similarity>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,F7.3,A)',ERR=510)
     * '    similarity_ens <similarity_ens> ',SIM_NMR
     *                  ,' </similarity_ens>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,F7.3,A)',ERR=510)
     * '    model completeness <mod_compl> ',COMPL,' </mod_compl>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,I5,A)',ERR=510)
     * '    number of monomers <nmon> ',NMON,' </nmon>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(LINE,'(A,A,A)',ERR=510)
     * '    surface keyword <surf> ',SURF,' </surf>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(FILE_CRD,L)
      LINE = '    <coordinates file_crd="'//
     * FILE_CRD(1:L)
     *//'"/>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      CALL LENSTR_BL(FILE_NMR,L)
      IF(L.GT.0) THEN
        LINE = '    <coordinates file_ens="'//
     *   FILE_NMR(1:L)
     *  //'"/>'
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 
      ENDIF

      CALL LENSTR_BL(FILE_SEQ,L)
      LINE = '    <sequence file_seq="'//
     * FILE_SEQ(1:L)
     *//'"/>'
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN) 

      WRITE(IOUT,'(A)',ERR=510)   '  </model>'
C -----------
      RETURN
 510  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE NEW_RESOLUTION_LIMIT(MDOC,RESMAX,BOVERALL
     *                      ,OPT_RESOL,RESMAX_NEW,IERR)      
C --------------------------------------------------
      CHARACTER LINE*80
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
C --------------------------------------------------
      SIGMA_RES2  = (0.356*RESMAX)*(0.356*RESMAX)
      SIGMA_BOV2  = BOVERALL/(8.0*PI*PI)
      SIGMA_OPT2  = (OPT_RESOL*OPT_RESOL)/4.0
      SIGMA_RES   = SQRT(SIGMA_RES2)
      SIGMA_BOV   = SQRT(SIGMA_BOV2)
      SIGMA_OPT   = SQRT(SIGMA_OPT2)

C       sigma_opt^2/2 = sigma_bov^2 + sigma_res^2
      SIGMA_OPT2BY2 = SIGMA_OPT2/2.0
      
c        WRITE(MDOC,'(A,3F8.3)') 'sigma R,B,O:'
c     *   ,SIGMA_RES,SIGMA_BOV,SIGMA_OPT
c        WRITE(MDOC,'(A,4F8.3)') 'sigma2 R,B,O:'
c     *   ,SIGMA_RES2,SIGMA_BOV2,SIGMA_OPT2,SIGMA_OPT2BY2

      SIGB2  = 1.414*SIGMA_OPT2 - SIGMA_RES2
      BOV =  8.0*PI*PI*SIGB2

c        WRITE(MDOC,'(A,3F8.3)') '==BOV:'
c     *   ,BOV, SIGB2

      
      OPT_RES_NEW   = OPT_RESOL*1.1
      SIGMA_OPT2_N  = (OPT_RES_NEW*OPT_RES_NEW)/4.0
      SIGMA_RES2_N  = 1.414*SIGMA_OPT2_N - SIGMA_BOV2
      SIGMA_RES_N   = SQRT(ABS(SIGMA_RES2_N))
      RESMAX_NEW    = SIGMA_RES_N/0.356

c        WRITE(MDOC,'(A,2F8.3)') 'res opt N:'
c     *   ,RESMAX_NEW,OPT_RES_NEW
c        WRITE(*,*) '--------'
C -------------
      RETURN
      END       

      SUBROUTINE MODEL_CORRECTION(MDOC,NAME_SEQ,FILE_CRD
     *  ,ALIGN_CORR_LIMIT,CHAIN
     *  ,FILE_OUT,FILE_TEMP
     *  ,SURF_CORR,ALIGN_CORR,NATOM,NRES,HID,CODE_DB
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER NAME_SEQ*(*),FILE_CRD*(*)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER SURF_CORR*1,ALIGN_CORR*1
      CHARACTER CODE_DB*8
      CHARACTER CHAIN*1,FULL*1,ADOM*1
      CHARACTER PAR_ALIGN*16
      CHARACTER FILE_OUT*(*),FILE_TEMP*(*),FILE_PAIR*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1,SURF*1
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
      HID   = 0.0
      NATOM = 0
      NRES  = 0
C ----------------------------------------------------
      SURF      = ' '
      CALL SURFACE_DB_ALLOC(M,FILE_CRD,FILE_TEMP
     * ,RESULT,IPRROW,IERR)   
      NATOM    =  RESULT(1)
      IF(IERR.NE.0.OR.NATOM.LE.0) THEN
        LINE = ' ERROR: in SURFACE_DB'
        CALL MSGERR(MDOC,LINE)
        GO TO 510
      ENDIF
      NATOM_IN =  RESULT(8)
      NRES     =  RESULT(9)
      WRITE(LINE,'('' Number of atoms, N_inside,Nres :'',3I6)') 
     *   NATOM,NATOM_IN,NRES
      CALL MSGDOC(MDOC,LINE)
      FINSIDE = FLOAT(NATOM_IN)/FLOAT(NATOM)
      IF(FINSIDE.LT.0.10) THEN
        FILE_TEMP = FILE_CRD  
        SURF_CORR = 'N'
        PAR_ALIGN(5:5) = 'Y' 
      ELSE
        SURF_CORR = 'Y'
        PAR_ALIGN(5:5) = 'N' 
      ENDIF
C ---------
      IF(ALIGN_CORR.EQ.'Y') THEN

C       MODE    = PAR_ALIGN(1:1) matrix 
C       CORR    = PAR_ALIGN(2:2) output pdb correction
C       CORR --> N output file(pdb) 
c                  (FILE_OUT) aligned file_1 (not rotated)
c          PAR_ALIGN(2:2) = 'N'
C       CORR --> Y output file(pdb) (FILE_OUT) rotated full file_1 (without alignment)
c          PAR_ALIGN(2:2) = 'Y'
C       CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c          PAR_ALIGN(2:2) = '2'
C       D3_FLAG = PAR_ALIGN(3:3) use surf info
C       SS_FLAG = PAR_ALIGN(4:4) use SS info
C       PAR_ALIGN(5:5) remove surf from output
C       PAR_ALIGN(6:6) OCC_FLAG
C
        PAR_ALIGN(1:1) = 'G' 
        PAR_ALIGN(1:1) = 'B' 

        PAR_ALIGN(2:2) = 'N' 
        PAR_ALIGN(3:3) = 'N' 

        IF(SURF_CORR.EQ.'Y') PAR_ALIGN(3:3) = 'Y' 

        PAR_ALIGN(4:4) = 'Y' 
        PAR_ALIGN(6:6) = 'N' 
        PAR_ALIGN(7:7) = 'N' 

        OPENR   = 0.462
        DPENR   = 0.350
        PENEXR  = 0.077

        IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c         'G'
          DPENR   = 0.346
        ELSE
c         'B'
          DPENR   = 0.312
        ENDIF

        OPENR   = 0.462
        PENEXR  = 0.077
        OPENR   = 0.750
        PENEXR  = 0.125
c --
        MODEL   = 1
C       CHAIN   = ' '
        IPRINT  = 1
        FULL    = 'Y'
        FILE_PAIR = ' '
        ADOM    = 'C'
        CALL ALIGN_4(MDOC,NAME_SEQ,FILE_TEMP,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C --
C       RESULT(1) = NC
C       RESULT(2) = KC
C       RESULT(3) = NN
C       RESULT(4) = NHOM
C       RESULT(5) = HOM
C       RESULT(6) = SUM_SCORE 

        IF(IERR.NE.0) THEN
          WRITE(LINE,
     *    '(1X,A5,'' --- ERROR (align) ---'')') CODE_DB(1:5)
          CALL MSGDOC(MDOC,LINE)
          GO TO 510
        ENDIF
C ---
        N1     = RESULT(1) 
        N2     = RESULT(2) 
        NRESA  = RESULT(3) 
        NI     = RESULT(4) 
        HID    = RESULT(5) 
        SCR    = RESULT(6)  
        NATOMA = RESULT(7)
        NR_OUT = RESULT(8)
        NAT_OCC  = RESULT(9)
        NRES_OCC = RESULT(10)
c        NRESA  = NR_OUT
        NATOMA = NAT_OCC
        NRESA  = NRES_OCC
        WRITE(LINE,'('' Number of atoms, N_res,Ident :'',2I6,F7.2)') 
     *     NATOMA,NRESA,HID
        CALL MSGDOC(MDOC,LINE)
        IF(HID.LT.ALIGN_CORR_LIMIT.OR.
     *     NATOMA.LE.0.OR.NRESA.LE.0  ) THEN
          FILE_OUT = FILE_TEMP  
          ALIGN_CORR = 'N'
        ELSE
          ALIGN_CORR = 'Y'
          NRES  = NRESA
          NATOM = NATOMA
        ENDIF
      ELSE
        FILE_OUT = FILE_TEMP  
      ENDIF
c ---

  500 RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE SIM_FOR_DOMAIN(MDOC,FILE_1,FILE_2
     *  ,ALIGN_CORR_LIMIT,HID
     *  ,PATH_SCR,PATH_OUT,RESULT,IPRROW,IERR)
C -------------------------------------------------
      REAL      RESULT (IPRROW)
      CHARACTER FILE_1*(*),FILE_2*(*)
      INTEGER*4 MDOC,IERR
      CHARACTER LINE*256
      CHARACTER CHAIN*1,FULL*1,ADOM*1
      CHARACTER PAR_ALIGN*16
      CHARACTER FILE_OUT*256,FILE_PAIR*256
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH*1,EXT*1
C --------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      PI   = 4.0*ATAN(1.0)
      HID   = 0.0
C ----------------------------------------------------
C     MODE    = PAR_ALIGN(1:1) matrix 
C     CORR    = PAR_ALIGN(2:2) output pdb correction
C     CORR --> N output file(pdb) 
c                (FILE_OUT) aligned file_1 (not rotated)
c        PAR_ALIGN(2:2) = 'N'
C     CORR --> Y output file(pdb) (FILE_OUT) rotated full file_1 (without alignment)
c        PAR_ALIGN(2:2) = 'Y'
C     CORR --> 2 output fileS(pdb) (FILE_OUT name +_1, +_2)--> FILE_OUT_1, FILE_OUT_2
c        PAR_ALIGN(2:2) = '2'
C     D3_FLAG = PAR_ALIGN(3:3) use surf info
C     SS_FLAG = PAR_ALIGN(4:4) use SS info
C     PAR_ALIGN(5:5) remove surf from output
C     PAR_ALIGN(6:6) OCC_FLAG
C
      PAR_ALIGN(1:1) = 'G' 
      PAR_ALIGN(1:1) = 'B' 

      PAR_ALIGN(2:2) = 'N' 
      PAR_ALIGN(3:3) = 'N' 

      PAR_ALIGN(4:4) = 'Y' 
      PAR_ALIGN(6:6) = 'N' 
      PAR_ALIGN(7:7) = 'N' 

      OPENR   = 0.462
      DPENR   = 0.350
      PENEXR  = 0.077

      IF(PAR_ALIGN(1:1).EQ.'G') THEN 
c       'G'
        DPENR   = 0.346
      ELSE
c       'B'
        DPENR   = 0.312
      ENDIF

      OPENR   = 0.462
      PENEXR  = 0.077
      OPENR   = 0.750
      PENEXR  = 0.125
c --
      MODEL   = 1
      CHAIN   = ' '
      IPRINT  = 1
      FULL    = 'Y'
      FILE_PAIR = ' '
      FILE_OUT  = ' '
      ADOM    = 'C'
      IERR    = 0

      CALL ALIGN_4(MDOC,FILE_1,FILE_2,FILE_OUT,PATH_SCR
     *      ,FILE_PAIR,FULL,ADOM
     *      ,OPENR,DPENR,PENEXR,PAR_ALIGN,MODEL,CHAIN,IPRINT
     *      ,RESULT,IPRROW,IERR)
C --
C     RESULT(1) = NC
C     RESULT(2) = KC
C     RESULT(3) = NN
C     RESULT(4) = NHOM
C     RESULT(5) = HOM
C     RESULT(6) = SUM_SCORE 

      IF(IERR.NE.0) THEN
        WRITE(LINE,
     *  '(1X,'' --- ERROR (align) inSIM_FOR_DOMAIN ---'')') 
        CALL MSGDOC(MDOC,LINE)
        GO TO 510
      ENDIF
C ---
      N1     = RESULT(1) 
      N2     = RESULT(2) 
      NRESA  = RESULT(3) 
      NI     = RESULT(4) 
      HID    = RESULT(5) 
      SCR    = RESULT(6)  
      NATOMA = RESULT(7)
      NR_OUT = RESULT(8)
      NAT_OCC  = RESULT(9)
      NRES_OCC = RESULT(10)
c      NRESA  = NR_OUT
c      NATOMA = NAT_OCC
c      NRESA  = NRES_OCC
      WRITE(LINE,'('' N_res,Ident :'',I6,F7.2)') 
     *     NRESA,HID
      CALL MSGDOC(MDOC,LINE)
      IF(HID.LT.ALIGN_CORR_LIMIT.OR.NRESA.LE.0  ) THEN
        GO TO 510 
      ENDIF
c ---

      RETURN
  510 IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_MULTIMER(MDOC,IMULT,FILE_PDB,FILE_OUT,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB*(*)
      CHARACTER FILE_OUT*(*)
C ----
c      REAL      XA(NATOM_MAX),YA(NATOM_MAX),ZA(NATOM_MAX)
c      REAL      RSTR(20,NATOM_MAX)
      real,      allocatable :: XA(:)
      real,      allocatable :: YA(:)
      real,      allocatable :: ZA(:)
      real,      allocatable :: RSTR(:,:)
      real,      allocatable :: OCC(:)
      real,      allocatable :: BISO(:)
      character(LEN=4), allocatable :: SEG(:)
      character(LEN=4), allocatable :: ACODE(:)
      character(LEN=80), allocatable :: MLINE(:)
      CHARACTER STR*80
C -----------------------------------------------------------
C ---
      INCLUDE 'multimer_info.fh'
C ---
C -----------------------------------------------------------
      REAL      FCH4      
      CHARACTER CH4*4
      REAL      X(3),Y(3)
      CHARACTER LINE*256,STR_HEAD*256,STR_CRYS*256
      CHARACTER EXT*3,PATH*1,CH24*24,TYPE*1,CH1*1
      EQUIVALENCE (FCH4,CH4)
      CHARACTER LETT*61
C --------------------------------------------------
      NLETT = 61
      LETT  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789'//
     *        'abcdefghijklmnopqrstuvwxyz'

cC123456789 123456789 123456789 123456789 123456789 123456789 1
c'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789abcdefghijklmnopqrstuvwxyz'

      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      STR_HEAD = ' '
      STR_CRYS = ' '
C --------------------------------------------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
C ------------
      NA = 0
      NMODEL = 0
100   CONTINUE

      READ(IN,'(A)',ERR=900,END=110) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 100

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:5).EQ.'MODEL') THEN
        NA = NA + 1
        NMODEL = NMODEL + 1
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        NA = NA + 1
      ENDIF
      GO TO 100
110   CONTINUE
      CLOSE(IN)

C ------------
      IF(NA.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      IF(IMULT.LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
      IF(NMOLECULE(IMULT).LE.0) THEN
        IERR = 1
        RETURN
      ENDIF
C -----------------
      IN   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
      IF(IERR.NE.0) THEN
        RETURN
      ENDIF
C ------------
      NATOM_MAX = NA * NMOLECULE(IMULT) + 1000 

      allocate(XA(1:NATOM_MAX),STAT=ISTAT)
      allocate(YA(1:NATOM_MAX),STAT=ISTAT)
      allocate(ZA(1:NATOM_MAX),STAT=ISTAT)
      allocate(RSTR(1:20,1:NATOM_MAX),STAT=ISTAT)
      allocate(OCC(1:NATOM_MAX),STAT=ISTAT)
      allocate(BISO(1:NATOM_MAX),STAT=ISTAT)
      allocate(SEG(1:NATOM_MAX),STAT=ISTAT)
      allocate(ACODE(1:NATOM_MAX),STAT=ISTAT)
      allocate(MLINE(1:NATOM_MAX),STAT=ISTAT)

      NA = 0
      NMODEL = 0

200   CONTINUE

      READ(IN,'(A)',ERR=800,END=210) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.6) GO TO 200

      IF(LINE(1:4).EQ.'CRYS') THEN
        STR_CRYS = LINE
      ELSE IF(LINE(1:6).EQ.'HEADER') THEN
        STR_HEAD = LINE
      ELSE IF(LINE(1:5).EQ.'MODEL') THEN
        NA = NA + 1
        NMODEL = NMODEL + 1
        MLINE(NA) = LINE(1:LEN)
      ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *        LINE(1:6).EQ.'HETATM'    ) THEN
        L = LEN
        IF(L.GT.80) L = 80
        IF(NA.GE.NATOM_MAX) THEN
          IERR = 1
          RETURN
        ENDIF
        NA = NA + 1

        MLINE(NA) = ' '

        READ(LINE,'(30X,3F8.3,2F6.2,6X,A4,A4)') 
     *    XA(NA),YA(NA),ZA(NA)
     *   ,OCC(NA),BISO(NA),SEG(NA),ACODE(NA)

        DO IS=1,20
          ISS = (IS-1)*4 + 1
          CH4 = LINE(ISS:ISS+3)
          CALL CHKSMB(CH4(1:1),TYPE)
          CALL CHKSMB(CH4(2:2),TYPE)
          CALL CHKSMB(CH4(3:3),TYPE)
          CALL CHKSMB(CH4(4:4),TYPE)
          RSTR(IS,NA) = FCH4
        ENDDO

      ENDIF

      GO TO 200
210   CONTINUE
      CLOSE(IN)
      IF(NA.LE.0) THEN
        IERR = 1
        GO TO 700
      ENDIF
C ---
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CLOSE(IN)
        GO TO 700
      ENDIF
C --------
      CALL LENSTR_BL(STR_HEAD,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_HEAD(1:LEN)     
      ENDIF
      CALL LENSTR_BL(STR_CRYS,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_CRYS(1:LEN)     
      ENDIF

      IF(NMODEL.LE.0) NMODEL = 1
      DO IMD=1,NMODEL
        DO IM=1,NMOLECULE(IMULT)
          NMOD = 0
          DO IA=1,NA
            CALL LENSTR_BL(MLINE(IA),LEN)
            IF(LEN.GT.0) THEN
              NMOD = NMOD + 1
              IF(IMD.EQ.NMOD.AND.NMODEL.GT.1.AND.IM.EQ.1) THEN
                WRITE(IOUT,'(A)') MLINE(IA)(1:LEN)  
              ENDIF   
              GO TO 300
            ENDIF
            IF(IMD.NE.NMOD.AND.NMODEL.GT.1) GO TO 300
            X(1) = XA(IA)        
            X(2) = YA(IA)        
            X(3) = ZA(IA)        
            CALL MVMULT(ROT_MOLECULE(1,1,IM,IMULT),X,Y)
            Y(1) = Y(1) + TR_MOLECULE(1,IM,IMULT)        
            Y(2) = Y(2) + TR_MOLECULE(2,IM,IMULT)        
            Y(3) = Y(3) + TR_MOLECULE(3,IM,IMULT)

            WRITE(CH24,'(3F8.3)') (Y(K),K=1,3)

            DO IS=1,20
              ISS = (IS-1)*4 + 1
              FCH4 = RSTR(IS,IA)
              STR(ISS:ISS+3) = CH4 
            ENDDO

            STR(31:54) = CH24
            WRITE(STR(55:80),'(2F6.2,6X,A4,A4)') 
     *       OCC(IA),BISO(IA),SEG(IA),ACODE(IA)

            IL = IM
            IF(IL.GT.NLETT) IL = NLETT
            STR(22:22) = LETT(IL:IL)
            STR(73:73) = LETT(IL:IL)
            STR(74:74) = LETT(1:1)
 
            CALL LENSTR_BL(STR,LEN)
            WRITE(IOUT,'(A)') STR(1:LEN)     

  300       CONTINUE 
          ENDDO

        ENDDO
      ENDDO
C ------------
      END FILE IOUT
      CLOSE(IOUT)

700   CONTINUE

      deallocate(XA,STAT=ISTAT)
      deallocate(YA,STAT=ISTAT)
      deallocate(ZA,STAT=ISTAT)
      deallocate(RSTR,STAT=ISTAT)
      deallocate(OCC,STAT=ISTAT)
      deallocate(BISO,STAT=ISTAT)
      deallocate(SEG,STAT=ISTAT)
      deallocate(ACODE,STAT=ISTAT)
      deallocate(MLINE,STAT=ISTAT)

      RETURN
C ------------
800   CONTINUE
      CLOSE(IN)
      IERR = 1
      GO TO 700
C ------------
900   CONTINUE
      CLOSE(IN)
      IERR = 1
      RETURN
      END

      SUBROUTINE CALC_PDB_RADIUS_INERTIA(MDOC
     *                                  ,NAME_IN,NTOT,RI,IERR)
C --------------------------------------------------------
      CHARACTER LINE*256,NAME_IN*(*),PATH*80,EXT*80,STR*80
      REAL      X(3),CP_OCC,CP_BISO
      CHARACTER ANAME*4,RNAME*3,CP_PNUM*7,CP_CORR*1,CP_ALT*1
      CHARACTER FRMT*80
      DATA FRMT
     * /'(6X,I5,A1,A4,A1,A3,A7,3X,3F8.3,2F6.2)'/
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C ---------------------------
      RI   = 0.0
      NTOT = 0 
      XS   = 0.
      YS   = 0.
      ZS   = 0.
      XS2  = 0.
      YS2  = 0.
      ZS2  = 0.
      XMAX =-1.E 30
      YMAX =-1.E 30
      ZMAX =-1.E 30
      XMIN = 1.E 30
      YMIN = 1.E 30
      ZMIN = 1.E 30
      IEND = 0
C ----------------
 400  CONTINUE
      IF(IEND.GT.0) GO TO 600
      LINE = ' '
      READ(IU,'(A)',ERR=500,END=620) LINE
      GO TO 610
 620  CONTINUE
      IEND = 1
 610  CONTINUE

      IF((LINE(1:6).NE.'ATOM  ').AND. 
     *        (LINE(1:6).NE.'HETATM')) GO TO 400

       READ(LINE,FRMT)
     *  IA,CP_CORR,ANAME,CP_ALT,RNAME,CP_PNUM
     * ,X(1),X(2),X(3),CP_OCC,CP_BISO

      IF(CP_ALT.NE.' '.AND.CP_ALT.NE.'A'.AND.CP_ALT.NE.'1')
     * GO TO 400
      IF(CP_OCC.LT.0.01) GO TO 400

      IF(X(1).GT.XMAX) XMAX=X(1)
      IF(X(2).GT.YMAX) YMAX=X(2)
      IF(X(3).GT.ZMAX) ZMAX=X(3)
      IF(X(1).LT.XMIN) XMIN=X(1)
      IF(X(2).LT.YMIN) YMIN=X(2)
      IF(X(3).LT.ZMIN) ZMIN=X(3)
      XS   = XS+X(1)
      YS   = YS+X(2)
      ZS   = ZS+X(3)
      XS2  = XS2+X(1)*X(1)
      YS2  = YS2+X(2)*X(2)
      ZS2  = ZS2+X(3)*X(3)
      NTOT = NTOT+1

      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      WRITE(LINE,'('' NUMBER OF COORDS :'',I6)') NTOT
      CALL MSGDOC(MDOC,LINE)
      IF(NTOT.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: CALC_PDB_RADIUS_INERTIA: N-ATOMS = 0')
        IERR=1
        RETURN
      ENDIF
      IF(NTOT.GT.0) THEN
        XS  = XS/NTOT
        YS  = YS/NTOT
        ZS  = ZS/NTOT
        XS2 = XS2/NTOT
        YS2 = YS2/NTOT
        ZS2 = ZS2/NTOT
        WRITE(LINE,'('' X :'',2F10.3)') XMIN,XMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Y :'',2F10.3)') YMIN,YMAX
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'('' Z :'',2F10.3)') ZMIN,ZMAX
        CALL MSGDOC(MDOC,LINE)
        RAD = (XMAX-XMIN)
        RT  = (YMAX-YMIN)
        IF(RAD.LT.RT) RAD=RT
        RT  = (ZMAX-ZMIN)
        IF(RAD.LT.RT) RAD=RT
        WRITE(LINE,'('' SIZE_max         :'',F10.3)') RAD
        CALL MSGDOC(MDOC,LINE)
C --
        WRITE(LINE,'('' Centre of coords :'',3F10.3)') XS,YS,ZS
        CALL MSGDOC(MDOC,LINE)
C --
        RX = XS2-XS*XS
        RY = YS2-YS*YS
        RZ = ZS2-ZS*ZS
        RI = SQRT(ABS(RX+RY+RZ))
        WRITE(LINE,'('' Radius of inertia :'',F10.3)') RI
        CALL MSGDOC(MDOC,LINE)
        IF(RI.LE.0.1) IERR = 1
C ---
      ENDIF

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file'
      CALL MSGERR(MDOC,LINE)
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_DOMAIN_SEQUENCE(MDOC,NAME_IN,NAMEO
     *       ,ID_DOMAIN,NRES,NAA_MAX
     *       ,ND_STRING,IDOMSEG,PNUM1_DM,PNUM2_DM,ND_RES,NSTRMAX
     *       ,IERR)
C --------------------------------------------------------
      CHARACTER CODE*4
C      INTEGER NSEQ(NMAX),IRES(NMAX),ICHAIN(NMAX),IDOMAIN(NMAX)
C      INTEGER ISS(NMAX),ISSN(NMAX),ISURF(NMAX)
C      CHARACTER PNUM(NMAX)*6

      integer,   allocatable :: NSEQ(:)
      integer,   allocatable :: IRES(:)
      integer,   allocatable :: ISURF(:)
      integer,   allocatable :: ICHAIN(:)
      integer,   allocatable :: IDOMAIN(:)
      integer,   allocatable :: ISS(:)
      integer,   allocatable :: ISSN(:)
      character(LEN=6), allocatable :: PNUM(:)


C ---
      INTEGER   ND_STRING,IDOMSEG(NSTRMAX),ND_RES(NSTRMAX)
      CHARACTER PNUM1_DM(NSTRMAX)*6,PNUM2_DM(NSTRMAX)*6
C ---
      CHARACTER PN1*6,PN2*6,PN*6,CHAIN_DOM*1

C  
C READ_FASTA_SEQ   read sequence which can be used for ALIGN.
C 
C      File with sequence is ASCII file:
C
C      !>prot_id
C      !# sequence 
C      !SVIGSDDRTRVTNTTAYPYRAIVHISSSIGSCTGWMIGPKTVATAGHCIY
C      !# this is comment
C      !    DTSSG--SFAGTATVSP   GRNGTSYPYG
C      !NRGTRITKEVFDNLTNWKNSAQ
C
C      If first symbol in the line is "#" it means the line is comments
C
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAMEO*(*)
      CHARACTER SS_FLAG*1,D3_FLAG*1 
c ----
      CHARACTER NAME*256,PATH*80,EXT*80,STR*2048
      CHARACTER LINE*2048,LINE_SS*2048,LINE_SR*2048
      CHARACTER LINE1*2048,LINE2*2048
      CHARACTER STR_IN*2048,TITLE*256
      CHARACTER DB_FLAG*1,SS*1,SS_OLD*1,CHAIN*1
C      CHARACTER ACODE3(25)*3
      CHARACTER AMIN(25)*1,AANAME*1,SURF*1
      CHARACTER CH1*1
C      CHARACTER CH3*3
C --
C      DATA ACODE3/'CYS','SER','THR','PRO','ALA','GLY','ASN','ASP' 
C     *           ,'GLU','GLN','HIS','ARG','LYS','MET','ILE','LEU' 
C     *           ,'VAL','PHE','TYR','TRP','UNK','ASX','GLX','===' 
C     *           ,'---'/
C  
c                1   2   3   4   5   6   7   8   9  10  11  12  13
      DATA AMIN/'C','S','T','P','A','G','N','D','E','Q','H','R','K'
     *       ,'M','I','L','V','F','Y','W','?','B','Z','=','-'/
c             14  15  16  17  18  19  20  21  22  23  24  25
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ---------------------------
      ITEST   = 1
      NAA_MAX = 100
1000  CONTINUE

      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 200
      ENDIF
C -------------------------------
      allocate(NSEQ(1:NAA_MAX),STAT=ISTAT)
      allocate(IRES(1:NAA_MAX),STAT=ISTAT)
      allocate(ISURF(1:NAA_MAX),STAT=ISTAT)
      allocate(ICHAIN(1:NAA_MAX),STAT=ISTAT)
      allocate(IDOMAIN(1:NAA_MAX),STAT=ISTAT)
      allocate(ISS(1:NAA_MAX),STAT=ISTAT)
      allocate(ISSN(1:NAA_MAX),STAT=ISTAT)
      allocate(PNUM(1:NAA_MAX),STAT=ISTAT)


      NRES  = 0
      DB_FLAG = 'N'
      DO I=1,10000 
        READ(IU,'(A)',ERR=500,END=800) STR_IN
        CALL LENSTR_BL(STR_IN,LENS)
        IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SS:') THEN
          DB_FLAG = 'Y'
          GO TO 800
        ELSE IF(LENS.GE.4.AND.STR_IN(1:4).EQ.'#SR:') THEN
          DB_FLAG = 'y'
          GO TO 800
        ENDIF
      ENDDO
 800  CONTINUE
      CLOSE(IU)
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 900
      ENDIF
C --------------------------------
      ICH= 0
      IC = 0
      NC =-1
      N  = 0 
      NR = 0 
      NRES = 0
      NBAD = 0
      NX   = 0
      CODE = 'XXXX'
      CHAIN= 'A'
      IEND = 0
      LINE_SS = ' '
      LINE_SR = ' '
      SS_OLD  = ' '
      NSS     = 0
C ----------------
 400  CONTINUE

      IF(IC.GT.NC) THEN
        IF(IEND.GT.0) GO TO 600
        LINE = ' '
        READ(IU,'(A)',ERR=500,END=620) LINE
        GO TO 610
 620    CONTINUE
        IEND = 1
 610    CONTINUE
        IMODE = 1
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0) GO TO 400        
        CALL CHECK_LINE(IMODE,LINE)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0.AND.LINE(1:1).EQ.'>') THEN
          TITLE = LINE
          ICH = ICH + 1
          NR  = 0
          IF(ICH.EQ.1) THEN
            CODE = '?   '
            CHAIN = 'A'
            IF(LEN.GT.1) THEN
              DO L=2,LEN
                CODE(L-1:L-1) = LINE(L:L)
                IF(L.EQ.5) CHAIN = LINE(L:L)
                IF(L.GE.5) GO TO 400
              ENDDO
            ENDIF
          ENDIF
          GO TO 400
        ENDIF        
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#') GO TO 400        
        IC = 1
        NC = LEN
        IF(DB_FLAG.EQ.'Y') THEN
          LINE_SS = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SS
          LINE_SR = ' '
          READ(IU,'(A)',ERR=500,END=620) LINE_SR
          IC = 5
        ENDIF
      ENDIF
      CH1 = LINE(IC:IC)
      IF(CH1.EQ.' ') THEN
        IC = IC + 1
        GO TO 400
      ENDIF


      IF(CH1.EQ.'+') THEN
        J = 0
        GO TO 700
      ENDIF
      DO  J=1,25
        IF(CH1.EQ.AMIN(J)) THEN
          GO TO 700
        ENDIF
      ENDDO
      J   = 26
 700  CONTINUE
      IF(J.EQ.22) J = 7
      IF(J.EQ.23) J = 8
C      IF(J.EQ.21) J = 25
      IF(J.GE.1.AND.J.LE.25) THEN
        N  = N  + 1
        IF(ITEST.LE.0) THEN
          IF(N.GT.NAA_MAX) THEN
            WRITE(STR,'('' ERR: NUMBER OF RESIDUES >'',I8)') NAA_MAX
            CALL MSGDOC(MDOC,STR) 
            IERR=1
            CLOSE(IU)
            RETURN
          ENDIF
          IF(J.LT.21) NRES = NRES + 1
          IF(J.NE.24) NR = NR + 1
          NSEQ(N) = J
          IRES(N) = NR
          PNUM(N)(1:1) = CHAIN
          WRITE(PNUM(N)(2:5),'(I4)') NR
          PNUM(N)(6:6) = ' '
          IF(J.GE.24) IRES(N) = 0
          IF(ICH.LE.0) ICH = 1
          ICHAIN(N)  = ICH
          ISURF(N)   = 0
          ISSN(N)    = 0
          ISS (N)    = 0
          IDOMAIN(N) = 0
          IF(J.EQ.21) THEN
            NX = NX + 1
          ENDIF
        ENDIF
      ELSE
        NBAD = NBAD + 1
        WRITE(STR,
     *  '('' WARNING: bad residue <'',A,''>'')') CH1
        CALL MSGDOC(MDOC,STR)
      ENDIF
      IF(DB_FLAG.EQ.'Y') THEN
        IF(J.GE.1.AND.J.LE.25) THEN
          SS  = LINE_SS(IC:IC) 
          CH1 = LINE_SR(IC:IC)
          READ(CH1,'(I1)') ISURF_N
          IF(SS.NE.' '.AND.SS.NE.SS_OLD) NSS = NSS + 1
          IF(SS.NE.' ') THEN 
            ISSN_N = NSS
            ISS_N = 0
            IF(SS.EQ.'H') THEN
              ISS_N = 1
            ELSE IF(SS.EQ.'h') THEN
              ISS_N = 2
            ELSE IF(SS.EQ.'B') THEN
              ISS_N = 3
            ELSE IF(SS.EQ.'b') THEN
              ISS_N = 4
            ENDIF
          ELSE
            ISS_N  = 0
            ISSN_N = 0
          ENDIF
          IF(ITEST.LE.0) THEN
            ISURF(N) = ISURF_N
            ISSN(N)  = ISSN_N
            ISS (N)  = ISS_N
          ENDIF
          SS_OLD = SS
        ENDIF
      ENDIF
      IC = IC + 1
      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)

      WRITE(LINE,'('' Number of residues     :'',I8)') N
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of bad residues :'',I8)') NBAD
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,'('' Number of X residues   :'',I8)') NX
      CALL MSGDOC(MDOC,LINE)
      IF(N.LE.0) THEN
        CALL MSGERR(MDOC,' Number of residues in sequence = 0')
        IERR = 1
      ENDIF
      IF(ITEST.GT.0) THEN
        NAA_MAX = N
        ITEST   = 0

        deallocate(NSEQ,STAT=ISTAT)
        deallocate(IRES,STAT=ISTAT)
        deallocate(ISURF,STAT=ISTAT)
        deallocate(ICHAIN,STAT=ISTAT)
        deallocate(IDOMAIN,STAT=ISTAT)
        deallocate(ISS,STAT=ISTAT)
        deallocate(ISSN,STAT=ISTAT)
        deallocate(PNUM,STAT=ISTAT)

        GO TO 1000

      ENDIF

C     set domain      
      IF(ND_STRING.GT.0) THEN
        DO I=1,ND_STRING
          IDOM = IDOMSEG(I)/100
          ISEG = IDOMSEG(I) - IDOM*100
          WRITE(LINE,'(I5,1X,A5,2I3,1X,A6,1X,A6)')
     *      I,'   ',IDOM,ISEG
     *     ,PNUM1_DM(I),PNUM2_DM(I)
          CALL MSGDOC(MDOC,LINE)
        ENDDO
      ENDIF

      NDOM = 0
      ISTART  = 0
      IFINISH = 0
      IF(ND_STRING.GT.0) THEN
        DO IR=1,N
          READ(PNUM(IR)(2:5),'(I4)') IRESN
          DO IS=1,ND_STRING
            IDOM = IDOMSEG(IS)/100
            ISEG = IDOMSEG(IS) - IDOM*100
            PN1  = PNUM1_DM(IS) 
            PN2  = PNUM2_DM(IS) 
            READ(PN1(2:5),'(I4)') IRES1
            READ(PN2(2:5),'(I4)') IRES2
            IF(IRESN.GE.IRES1.AND.IRESN.LE.IRES2) THEN
              IDOMAIN(IR) = IDOM
              IF(ISTART.LE.0) ISTART = IR
              IFINISH = IR
            ENDIF
          ENDDO
        ENDDO
      ENDIF
C    
      CALL CORR_NAME_BLC(NAMEO)
      CALL LENSTR_BL(NAMEO,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGDOC(MDOC,' WARNING: no output file name')
        IERR = 0
        RETURN
      ENDIF

      IOUT = 11
      EXT  = ' '
      PATH = ' '
      CALL OPENFW(IOUT,M,PATH,NAMEO,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        RETURN
      ENDIF
c--------------------------------------
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) THEN
        TITLE = '>XXXX A'
        CALL LENSTR_BL(TITLE,LEN)
      ENDIF
      WRITE(IOUT,'(A)',ERR=910) TITLE(1:LEN)

      NAA   = 0
      NRES  = 0
      II    = 0
      IF(DB_FLAG.EQ.'Y') II = 4
      IAA   = 0
      LINE  = '    '
      LINE1 = '#SS:'
      LINE2 = '#SR:'

      DO IPR=1,N
C     DO IPR=1,IFINISH

        IF(DB_FLAG.EQ.'Y') THEN
          IF(ISS(IPR).EQ.1) THEN
            SS = 'H'
          ELSE IF(ISS(IPR).EQ.2) THEN
            SS = 'h'
          ELSE IF(ISS(IPR).EQ.3) THEN
            SS = 'B'
          ELSE IF(ISS(IPR).EQ.4) THEN
            SS = 'b'
          ELSE
            SS = ' '
          ENDIF

          SURF = ' '
          IF(ISURF(IPR).GT.0) THEN
            WRITE(SURF,'(I1)') ISURF(IPR)
          ENDIF
        ENDIF

        N1     = NSEQ(IPR)
        IF(N1.GT.25) N1 = 25
        AANAME = AMIN(N1)

        IF(IDOMAIN(IPR).EQ.ID_DOMAIN) THEN

        ELSE IF(N1.LE.20) THEN
          N1 = 21
        ENDIF

        AANAME = AMIN(N1)
        IF(N1.GE.24) THEN
          SS   = ' '
          SURF = ' '
        ENDIF

        NAA = NAA +1
        IF(N1.LT.21) NRES = NRES + 1
        II  = II  +1
        IAA = IAA +1
        LINE(II:II)  = AANAME
        IF(DB_FLAG.EQ.'Y') THEN
          LINE1(II:II) = SS
          LINE2(II:II) = SURF
        ENDIF

        IF(IAA.EQ.50) THEN
          CALL LENSTR_BL(LINE,LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
          IF(DB_FLAG.EQ.'Y') THEN
            WRITE(IOUT,'(A)',ERR=910) LINE1(1:LEN)
            WRITE(IOUT,'(A)',ERR=910) LINE2(1:LEN)
          ENDIF
          II   = 0
          IF(DB_FLAG.EQ.'Y') II = 4
          IAA  = 0
          LINE  = '    '
          LINE1 = '#SS:'
          LINE2 = '#SR:'
        ENDIF
 
      ENDDO

      IF(IAA.GT.0) THEN
        CALL LENSTR_BL(LINE,LEN)
        WRITE(IOUT,'(A)',ERR=910) LINE(1:LEN)
        IF(DB_FLAG.EQ.'Y') THEN
          WRITE(IOUT,'(A)',ERR=910) LINE1(1:LEN)
          WRITE(IOUT,'(A)',ERR=910) LINE2(1:LEN)
        ENDIF
      ENDIF

      END FILE IOUT
      CLOSE(IOUT)

      WRITE(LINE,'('' Number of residues to write :'',I8)') NRES
      CALL MSGDOC(MDOC,LINE)

      IF(NRES.LE.0) THEN
        CALL MSGDOC(MDOC,' Number of residues in sequence = 0')
        IERR = 0
      ENDIF

 900  CONTINUE

      deallocate(NSEQ,STAT=ISTAT)
      deallocate(IRES,STAT=ISTAT)
      deallocate(ISURF,STAT=ISTAT)
      deallocate(ICHAIN,STAT=ISTAT)
      deallocate(IDOMAIN,STAT=ISTAT)
      deallocate(ISS,STAT=ISTAT)
      deallocate(ISSN,STAT=ISTAT)
      deallocate(PNUM,STAT=ISTAT)

      RETURN
C ----------------
 200  CONTINUE
      LINE = ' ERROR: cannot open file sequence'
      CALL MSGERR(MDOC,LINE)
      IERR = 1
      RETURN
 300  CONTINUE
      LINE = ' ERROR: DB: end of input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU) 
      IERR = 1
      GO TO 900
 910  CONTINUE
      CALL MSGERR(MDOC,' ERROR: write sequence')
      IERR = 1
      CLOSE(IOUT)
      GO TO 900
      END

      SUBROUTINE GET_MULTIMER_INFO2(MDOC,FILE_XML,PATH_DB
     *        ,NFILE,CHAIN_LIST,FILE_LIST,NLISTMAX,NMULT,IERR)
C ------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER FILE_XML*(*),PATH_DB*(*)
      CHARACTER CHAIN_LIST(NLISTMAX)*(*)
      CHARACTER FILE_LIST(NLISTMAX)*(*)
C -----------------------------------------------------------
      PARAMETER ( NMULTIMERMAX = 100 )
      PARAMETER ( NMOLECULEMAX = 200 )

      COMMON /MULTIMER_INFO2/ NMULTIMER,NMOLECULE
     * ,ROT_MOLECULE,TR_MOLECULE,CHAIN_ID_MULT,CODE_PDB_MULT
      INTEGER   NMULTIMER   
      INTEGER   NMOLECULE(NMULTIMERMAX)
      REAL      ROT_MOLECULE(3,3,NMOLECULEMAX,NMULTIMERMAX)
      REAL      TR_MOLECULE(3,NMOLECULEMAX,NMULTIMERMAX)
      REAL      CHAIN_ID_MULT(NMOLECULEMAX,NMULTIMERMAX)
      CHARACTER CODE_PDB_MULT(NMULTIMERMAX)*5
C ----------
c      INCLUDE 'multimer_info2.fh'
C ---
C -----------------------------------------------------------
      COMMON /FREAD_XML/ FWORD_XML,IWORD_XML,IFRD_XML_ERR
     *                          ,ITEM_XML,WORD_XML,STRING_XML
      REAL      FWORD_XML   
      INTEGER   IWORD_XML   
      INTEGER   IFRD_XML_ERR
      CHARACTER ITEM_XML*256
      CHARACTER WORD_XML*256
      CHARACTER STRING_XML*500
C --------------------------------------------------------------
      CHARACTER PATH*1,EXT*1
      CHARACTER CHAIN_ID*2,PDB_CODE*5,CHAIN_FLAG*1
      CHARACTER LINE*256,FILE_TEMP*256
      REAL      FCH4      
      CHARACTER CH4*4
      EQUIVALENCE (FCH4,CH4)
C ------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      NMULTIMER = 0
      NMULT     = 0
      NFILE_INPUT = NFILE
C ---
      MT   = 60
      CALL LENSTR_BL(FILE_XML,NL)
      OPEN(MT,FILE=FILE_XML(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='OLD')
C ---
      EXT  = ' '
      PATH = ' '
c      MT   = 10
c      CALL OPENFR(MT,M,PATH,FILE_XML,EXT,IERR)
c      IF(IERR.NE.0) THEN
c      CALL MSGDOC(MD,
c     *       ' ERROR: cannot open input xml file')
c        IERR = 1
c        RETURN
c      ENDIF
C ---
      NMULTIMER = 0
      NMOL      = 0
      NMULT     = 0
      NR     = 0
      NT     = 0
      ISIZE  = 0
      NMULT_LIM = 0
      NMOL_LIM  = 0

 100  CONTINUE

      READ(MT,'(A)',ERR=300,END=200) STRING_XML
      CALL LENSTR_BL(STRING_XML,LEN)
      IF(LEN.LE.0) GO TO 100
      IF(STRING_XML(1:1).EQ.'#') GO TO 100

      CALL FRD_PARM_XML
 
      IF(IFRD_XML_ERR.GT.0) GO TO 400
C --
      CALL LENSTR_BL(ITEM_XML,LITEM)
      CALL LENSTR_BL(WORD_XML,LWORD)

      IF(LWORD.LE.0) THEN

        IF(ITEM_XML.EQ.'assembly') THEN

          NFILE = NFILE_INPUT

          IF(NMULTIMER.GE.NMULTIMERMAX) THEN
            NMULT_LIM = 1
          ENDIF

          IF(NMULT_LIM.LE.0) THEN
            NMULTIMER = NMULTIMER + 1
            NMOLECULE(NMULTIMER) = 0
          ENDIF
          NMULT = NMULT + 1
          NMOL = 0
          NMOL_LIM = 0
          CHAIN_FLAG = 'Y' 

        ELSE IF(ITEM_XML.EQ.'/assembly') THEN

          IF(NMULT_LIM.LE.0) THEN

            IF(ISIZE.NE.NMOLECULE(NMULTIMER)) GO TO 400

            IF(NMOL_LIM.GT.0) THEN
              WRITE(LINE,'(A,I5,A,I5,A,I5)')
     *        ' WARNING: too many molecules ',NMOL,' >'
     *        ,NMOLECULEMAX,' for assembly No:',NMULT
              CALL MSGERR(MD,LINE)
              NMULTIMER = NMULTIMER - 1
            ELSE IF(NMOL.LT.2) THEN
              WRITE(LINE,'(A,I5,A,I5)')
     *        ' WARNING: N molecules ',NMOL
     *        ,' < 2 for assembly No:',NMULT
              CALL MSGERR(MD,LINE)
              NMULTIMER = NMULTIMER - 1
            ELSE IF(CHAIN_FLAG.EQ.'N') THEN
              NMULTIMER = NMULTIMER - 1
            ELSE
              CALL CHECK_MULTIMER_INFO(MDOC,IERR)
              IERR = 0
            ENDIF
            ISIZE = 0
          ENDIF

        ELSE IF(ITEM_XML.EQ.'molecule') THEN

          IF(NMULT_LIM.LE.0) THEN

            IF(ISIZE.LE.0) GO TO 400

            IF(NMOLECULE(NMULTIMER).GE.NMOLECULEMAX) THEN
              NMOL_LIM = 1
            ENDIF

            IF(NMOL_LIM.LE.0) THEN
              NMOLECULE(NMULTIMER) = NMOLECULE(NMULTIMER) + 1
            ENDIF
            NMOL = NMOL + 1
            NR   = 0
            NT   = 0
          ENDIF

        ELSE IF(ITEM_XML.EQ.'/molecule') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            IF(NR.NE.9.OR.NT.NE.3) GO TO 400
          ENDIF
        ENDIF

      ELSE

        IF(ITEM_XML.EQ.'pdb_code') THEN
          PDB_CODE = WORD_XML(1:5)
        ELSE IF(ITEM_XML.EQ.'size') THEN
          ISIZE = IWORD_XML
        ELSE IF(ITEM_XML.EQ.'chain_id') THEN
          CALL LENSTR_BL(WORD_XML,L)
          IF(L.LE.0) THEN
            CHAIN_ID = '<>'
          ELSE IF(L.EQ.1) THEN
            CHAIN_ID = WORD_XML(1:1)//' '
          ELSE IF(L.EQ.2) THEN
            CHAIN_ID = WORD_XML(1:2)
          ELSE
            CHAIN_ID = '??'
          ENDIF
          IF(NFILE.LE.0) GO TO 500
          DO J=1,NFILE_INPUT
            IF(CHAIN_ID(2:2).EQ.CHAIN_LIST(J)(5:5)) THEN
              GO TO 500
            ENDIF
          ENDDO
 
          IF(CHAIN_ID(2:2).EQ.' ') THEN
            IF(NFILE.LT.NLISTMAX) THEN
              NFILE = NFILE + 1
              CHAIN_LIST(NFILE) = PDB_CODE(1:4)//CHAIN_ID(1:1)
              FILE_LIST(NFILE)  = 'add_DB'
              MT1   = 61
              CALL LENSTR_BL(PATH_DB,LEN)
              FILE_TEMP = PATH_DB(1:LEN)//'/add_DB/'//
     *                    CHAIN_LIST(NFILE)(1:5)//'.xyz'
              CALL LENSTR_BL(FILE_TEMP,LEN)
              OPEN(MT1,FILE=FILE_TEMP(1:LEN),ACCESS='SEQUENTIAL'
     *        ,ERR=510,FORM='FORMATTED',STATUS='OLD')
              CLOSE(MT1)
              GO TO 500
 510          CONTINUE
            ENDIF
          ENDIF

          CHAIN_FLAG = 'N'
  500     CONTINUE
          IF(CHAIN_ID(1:1).EQ.'_'.AND.CHAIN_ID(2:2).NE.'_') 
     *    CHAIN_FLAG = 'N'
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            CH4 = CHAIN_ID//'  '
            CHAIN_ID_MULT(NMOL,NMULTIMER) = FCH4
            CODE_PDB_MULT(NMULTIMER) = PDB_CODE
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mxx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mxy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mxz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,1,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'myz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,2,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(1,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzy') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(2,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'mzz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            ROT_MOLECULE(3,3,NMOL,NMULTIMER) = FWORD_XML
            NR = NR + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'tx') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(1,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'ty') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(2,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ELSE IF(ITEM_XML.EQ.'tz') THEN
          IF(NMULT_LIM.LE.0.AND.NMOL_LIM.LE.0) THEN
            TR_MOLECULE(3,NMOL,NMULTIMER) = FWORD_XML
            NT = NT + 1
          ENDIF
        ENDIF

      ENDIF

C --
      GO TO 100    
 200  CONTINUE
      CLOSE(MT)

      IF(NMULT_LIM.GT.0) THEN
        WRITE(LINE,'(A,I5,A,I5)')
     *  ' WARNING: too many multimers ',NMULT,' >'
     *  ,NMULTIMERMAX
        CALL MSGERR(MD,LINE)
c       NMULTIMER = NMULTIMERMAX
      ENDIF

      NMULT = NMULTIMER
C ---
      RETURN
 300  CONTINUE
      CLOSE(MT)
      CALL MSGERR(MD,
     *       ' ERROR: reading input xml file')
      IERR = 1
      RETURN
 400  CONTINUE
      CLOSE(MT)
      CALL MSGERR(MD,
     *       ' ERROR: wrong xml file')
      IERR = 1
      RETURN
9100  CONTINUE
      IERR = 9
      RETURN
      END

      SUBROUTINE CREATE_MULTIMER2(MDOC,IMULT
     *  ,NFILE,CHAIN_LIST,FILE_PDB_LIST,NATOM_LIST
     *  ,NMOL,FILE_OUT,NLISTMAX,IERR)
C --------------------------------------------------------
      CHARACTER FILE_PDB_LIST(NLISTMAX)*256
      CHARACTER CHAIN_LIST(NLISTMAX)*8
      INTEGER   NATOM_LIST(NLISTMAX)
      CHARACTER FILE_OUT*(*)
C ----
c      REAL      XA(NATOM_MAX),YA(NATOM_MAX),ZA(NATOM_MAX)
c      REAL      RSTR(20,NATOM_MAX)
      real,      allocatable :: XA(:,:)
      real,      allocatable :: YA(:,:)
      real,      allocatable :: ZA(:,:)
      real,      allocatable :: RSTR(:,:,:)
      real,      allocatable :: OCC(:,:)
      real,      allocatable :: BISO(:,:)
      real,      allocatable :: RSEG(:,:)
      real,      allocatable :: RACODE(:,:)
      CHARACTER STR*80
      CHARACTER FILE_PDB*256
C -----------------------------------------------------------
      PARAMETER ( NMULTIMERMAX = 100 )
      PARAMETER ( NMOLECULEMAX = 200 )

      COMMON /MULTIMER_INFO2/ NMULTIMER,NMOLECULE
     * ,ROT_MOLECULE,TR_MOLECULE,CHAIN_ID_MULT,CODE_PDB_MULT
      INTEGER   NMULTIMER   
      INTEGER   NMOLECULE(NMULTIMERMAX)
      REAL      ROT_MOLECULE(3,3,NMOLECULEMAX,NMULTIMERMAX)
      REAL      TR_MOLECULE(3,NMOLECULEMAX,NMULTIMERMAX)
      REAL      CHAIN_ID_MULT(NMOLECULEMAX,NMULTIMERMAX)
      CHARACTER CODE_PDB_MULT(NMULTIMERMAX)*5
C ----------
C ---
C      INCLUDE 'multimer_info2.fh'
C ---
C -----------------------------------------------------------
      REAL      X(3),Y(3)
      CHARACTER LINE*256,STR_HEAD*256,STR_CRYS*256
      CHARACTER EXT*3,PATH*1,CH24*24,TYPE*1,CH1*1,SEG*4,ACODE*4
      REAL      FCH4      
      CHARACTER CH4*4
      EQUIVALENCE (FCH4,CH4)
      CHARACTER LETT*61
C --------------------------------------------------
      NLETT = 61
      LETT  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789'//
     *        'abcdefghijklmnopqrstuvwxyz'
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      STR_HEAD = ' '
      STR_CRYS = ' '
C --------------------------------------------------
      NMOL = 0
      IF(NFILE.LE.0) RETURN
      IF(NMULTIMER.LE.0) THEN
        CALL MSGERR(MD,' ERROR: NMULT =< 0')
        IERR = 1
        RETURN
      ENDIF
      IF(NMOLECULE(IMULT).LE.0) THEN
        CALL MSGERR(MD,' ERROR: NMOLECULE(IMULT) =< 0')
        IERR = 1
        RETURN
      ENDIF
C ------------
      DO IMT=1,NMULTIMER
        IMULT = IMT
        IF(NMOLECULE(IMT).EQ.NFILE) THEN
          DO IM=1,NMOLECULE(IMT)
            FCH4 = CHAIN_ID_MULT(IM,IMT)
            DO J=1,NFILE
              IF(CH4(2:2).EQ.CHAIN_LIST(J)(5:5)) GO TO 310
            ENDDO
            DO J=1,NFILE
              IF(CH4(1:1).EQ.CHAIN_LIST(J)(5:5).AND.
     *           CH4(2:2).EQ.' '                    ) GO TO 310
            ENDDO
            GO TO 320
  310       CONTINUE
          ENDDO
          GO TO 300
        ENDIF
  320   CONTINUE
      ENDDO
      CALL MSGERR(MD,
     *   ' ERROR: in CREATE_MULTIMER no such chain_ID in the list')
      IERR = 1
      GO TO 600
  300 CONTINUE
      NATOM_MAX = 0
      DO I=1,NFILE
        IN   = 10
        EXT  = ' '
        PATH = ' '
        FILE_PDB = FILE_PDB_LIST(I)
        CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open input pdb file')
          RETURN
        ENDIF
C ------------
        NA        = 0
100     CONTINUE

        READ(IN,'(A)',ERR=900,END=110) LINE

        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.6) GO TO 100

        IF(LINE(1:4).EQ.'CRYS') THEN
          IF(I.EQ.1) STR_CRYS = LINE
        ELSE IF(LINE(1:6).EQ.'HEADER') THEN
          IF(I.EQ.1) STR_HEAD = LINE
        ELSE IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *          LINE(1:6).EQ.'HETATM'    ) THEN
          NA = NA + 1
        ENDIF
        GO TO 100
110     CONTINUE
        CLOSE(IN)
        IF(NA.LE.0) THEN
          CALL MSGERR(MD,' ERROR: NA =< 0')
          IERR = 1
          RETURN
        ENDIF
        NATOM_LIST(I) = NA
        IF(NATOM_MAX.LT.NA) NATOM_MAX = NA
      ENDDO
C ------------

      allocate(XA(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(YA(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(ZA(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(RSTR(1:20,1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(OCC(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(BISO(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(RSEG(1:NATOM_MAX,1:NFILE),STAT=ISTAT)
      allocate(RACODE(1:NATOM_MAX,1:NFILE),STAT=ISTAT)

      DO I=1,NFILE
        IN   = 10
        EXT  = ' '
        PATH = ' '
        FILE_PDB = FILE_PDB_LIST(I)
        CALL OPENFR(IN,M,PATH,FILE_PDB,EXT,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MD,' ERROR: can not open input pdb file.')
          GO TO 700
        ENDIF
        NA = 0
200     CONTINUE
        READ(IN,'(A)',ERR=800,END=210) LINE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LT.6) GO TO 200
        IF(LINE(1:6).EQ.'ATOM  '.OR. 
     *     LINE(1:6).EQ.'HETATM'    ) THEN
          L = LEN
          IF(L.GT.80) L = 80
          IF(NA.GE.NATOM_MAX) THEN
            CALL MSGERR(MD,' ERROR: NA.GE.NATOM_MAX')
            IERR = 1
            RETURN
          ENDIF
          NA = NA + 1
          READ(LINE,'(30X,3F8.3,2F6.2,6X,A4,A4)') 
     *    XA(NA,I),YA(NA,I),ZA(NA,I) 
     *   ,OCC(NA,I),BISO(NA,I),SEG,ACODE
          DO IS=1,20
            ISS = (IS-1)*4 + 1
            CH4 = LINE(ISS:ISS+3)
            CALL CHKSMB(CH4(1:1),TYPE)
            CALL CHKSMB(CH4(2:2),TYPE)
            CALL CHKSMB(CH4(3:3),TYPE)
            CALL CHKSMB(CH4(4:4),TYPE)
            RSTR(IS,NA,I) = FCH4
          ENDDO
          CH4          = SEG
          RSEG(NA,I)   = FCH4
          CH4          = ACODE
          RACODE(NA,I) = FCH4
        ENDIF
        GO TO 200
210     CONTINUE
        CLOSE(IN)
        IF(NA.LE.0) THEN
          CALL MSGERR(MD,' ERROR: NA =< 0.')
          IERR = 1
          GO TO 700
        ENDIF
      ENDDO
C ---
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: can not open output pdb file')
        CLOSE(IN)
        GO TO 700
      ENDIF
C --------
      CALL LENSTR_BL(STR_HEAD,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_HEAD(1:LEN)     
      ENDIF
      CALL LENSTR_BL(STR_CRYS,LEN)
      IF(LEN.GT.0) THEN
        WRITE(IOUT,'(A)') STR_CRYS(1:LEN)     
      ENDIF

      DO IM=1,NMOLECULE(IMULT)

        FCH4 = CHAIN_ID_MULT(IM,IMULT)

        DO J=1,NFILE
          IF(CH4(2:2).EQ.CHAIN_LIST(J)(5:5)) GO TO 500
        ENDDO
        DO J=1,NFILE
          IF(CH4(1:1).EQ.CHAIN_LIST(J)(5:5).AND.
     *       CH4(2:2).EQ.' '                    ) GO TO 500
        ENDDO
        CALL MSGERR(MD,
     *   ' ERROR: in CREATE_MULTIMER no such chain_ID in the list')
        IERR = 1
        GO TO 600
  500   CONTINUE

        DO IA=1,NATOM_LIST(J)
          X(1) = XA(IA,J)        
          X(2) = YA(IA,J)        
          X(3) = ZA(IA,J)        
          CALL MVMULT(ROT_MOLECULE(1,1,IM,IMULT),X,Y)
          Y(1) = Y(1) + TR_MOLECULE(1,IM,IMULT)        
          Y(2) = Y(2) + TR_MOLECULE(2,IM,IMULT)        
          Y(3) = Y(3) + TR_MOLECULE(3,IM,IMULT)

          WRITE(CH24,'(3F8.3)') (Y(K),K=1,3)

          DO IS=1,20
            ISS = (IS-1)*4 + 1
            FCH4 = RSTR(IS,IA,J)
            STR(ISS:ISS+3) = CH4 
          ENDDO

          STR(31:54) = CH24
          FCH4 = RSEG(IA,J)
          SEG  = CH4
          FCH4   = RACODE(IA,J)
          ACODE  = CH4
          WRITE(STR(55:80),'(2F6.2,6X,A4,A4)') 
     *     OCC(IA,J),BISO(IA,J),SEG,ACODE

          IL = IM
          IF(IL.GT.NLETT) IL = NLETT
          STR(22:22) = LETT(IL:IL)
          STR(73:73) = LETT(IL:IL)
 
          CALL LENSTR_BL(STR,LEN)
          WRITE(IOUT,'(A)') STR(1:LEN)     
 
       ENDDO

      ENDDO
C ------------
      END FILE IOUT
      CLOSE(IOUT)
      NMOL = NMOLECULE(IMULT)

700   CONTINUE

      deallocate(XA,STAT=ISTAT)
      deallocate(YA,STAT=ISTAT)
      deallocate(ZA,STAT=ISTAT)
      deallocate(RSTR,STAT=ISTAT)
      deallocate(OCC,STAT=ISTAT)
      deallocate(BISO,STAT=ISTAT)
      deallocate(RSEG,STAT=ISTAT)
      deallocate(RACODE,STAT=ISTAT)

      RETURN
C ------------
600   CONTINUE
      CLOSE(IOUT)
      IERR = 1
      GO TO 700
C ------------
800   CONTINUE
      CALL MSGERR(MD,' ERROR: read input pdb file.')
      CLOSE(IN)
      IERR = 1
      GO TO 700
C ------------
900   CONTINUE
      CALL MSGERR(MD,' ERROR: read input pdb file')
      CLOSE(IN)
      IERR = 1
      RETURN
      END

      SUBROUTINE CREATE_NMR_FOR_DOMAIN(MDOC,NRES_IN,NRES_DOM
     *   ,CODE8,IDOM,NMODEL,FILE_NMR,FILE_CORR,FILE_SEQ
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR
      CHARACTER CODE8*8
      CHARACTER FILE_NMR*(*),FILE_CORR*(*),FILE_SEQ*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
c ---
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C ---
      CHARACTER LIST*1,WFLAG*1,FULL*1
      CHARACTER FILES*256,FILE_DOMAIN_CORR*256
      CHARACTER FILE_PRF*256

      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8,COMPLEX_LIST(NPRF_LIST)*10
C ---
      CHARACTER COMPLEX*10,CODED*8
C ------------------------------------------------
      PARAMETER ( NSEGMAX = 100  )
      CHARACTER PNUM_START(NSEGMAX)*7,PNUM_FIN(NSEGMAX)*7
c -----------------------------------
C ---------------------------------
C ---
      CHARACTER LINE*512
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      NMAX  = 8
      Q_LIM = 0.3

C ---

      CODED = CODE8
      WRITE(CODED(6:7),'(I2)') IDOM
      IF(CODED(6:6).EQ.' ') CODED(6:6) = '_' 
      CODED(8:8) = '_'

      LEN_CODE = 7
 
      ID_INI = 0
      NRES_DOM = 0
      DO I=1,NDOMAIN_BASE
        IF(CODE_DOM_BASE(I)(1:LEN_CODE).EQ.CODED(1:LEN_CODE)) THEN
          ID_INI = ID_DOM_BASE(I)
          NRES_DOM =  NRES_DOM_BASE(I)
          GO TO 100 
        ENDIF
      ENDDO
  100 CONTINUE
      IF(ID_INI.LE.0) THEN
        CALL MSGERR(MDOC
     *  ,'ERROR: wrong domain code')
        IERR = 1
        RETURN
      ENDIF

      T = REAL(NRES_DOM)/REAL(NRES_IN)
      IF(T.GT.1.15) THEN
        IERR = 33
        RETURN
      ENDIF
C ---
      WFLAG = 'Y'
      FULL  = 'N'
      LIST  = 'S'
      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIS
      NPRF = 0
      NMODEL = 0

C      IF(IDOM.LE.0.OR.IDOM.GT.99) THEN
C        IERR = 1
C        RETURN
C      ENDIF

C     GET DOMAIN_CORR: FILE_CORR -> FILE_DOMAIN_CORR 

      FILE_DOMAIN_CORR = 'domain_corr.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_DOMAIN_CORR,LT )
      IF(LEN.GT.0) THEN
        FILE_DOMAIN_CORR = PATH_SCR(1:LEN)//FILE_DOMAIN_CORR(1:LT) 
      ENDIF

      FILES = 'corr_temp.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILES,LT )
      IF(LEN.GT.0) THEN
        FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
      ENDIF

      CALL GET_DOMAIN_PDB(M,FILE_CORR,FILE_DOMAIN_CORR
     *  ,NDOM,NSEG,PNUM_START,PNUM_FIN,NSEGMAX
     *  ,IDOM,NRES,NATOM,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: get domain PDB'
        CALL MSGERR(MDOC,LINE)
        GO TO 800
      ENDIF
  
      FILES = ' '
      CALL CREATE_PRF_LIST(MDOC
     *     ,CODED,LEN_CODE
     *     ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *     ,IBACK_DOM_BASE,NRES_DOM_BASE
     *     ,NDOMAIN_BASE
     *     ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *     ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *     ,ICLASS_LIST
     *     ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
C       CALL MSGERR(MDOC,'ERROR: in CREATE_PRF_LIST ')
        IERR = 13
        GO TO 800
      ENDIF

      IF(NPRF.LE.1) THEN
        IERR = 13
        GO TO 800
      ENDIF

      FILE_PRF = 'prf_temp.prf'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PRF,LT )
      IF(LEN.GT.0) THEN
        FILE_PRF = PATH_SCR(1:LEN)//FILE_PRF(1:LT) 
      ENDIF

      FILES = ' '
C     ICFLAG > 0 all chain_ID = (ICFLAG); =0 A,B,C,D ..; <0 save chain_ID
      ICFLAG = IDOM
      IF(ICFLAG.LE.0) ICFLAG = 1

      CALL CREATE_PRF_NMR_FILES(MDOC
     *  ,FILES,FILES,FILES,LEN_CODE
     *  ,NMODEL,FILE_NMR,FILE_PRF
     *  ,NMAX,NPRF_LIST,NPRF,NRES_LIST,PRF_LIST
     *  ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *  ,ICLASS_LIST
     *  ,Q_LIM,ICFLAG
     *  ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        GO TO 800
      ENDIF

      FILES = 'nmr_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILES,LT )
      IF(LEN.GT.0) THEN
         FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
      ENDIF
      CALL REPLACE_FIRST_MODEL_IN_NMR(MDOC,CODE8
     *    ,FILE_DOMAIN_CORR,FILE_NMR,FILES,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in : REPLACE_FIRST_MODEL'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

      NM = 0
      CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_NMR,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: copy file NMR temp -> NMR'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

C ------
  800 CONTINUE

      FILES = 'prf_temp.prf'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'nmr_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'domain_corr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'corr_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
 
      RETURN
      END

      SUBROUTINE CREATE_NMR_FOR_CHAIN_V2(MDOC
     *   ,CODE8,NMODEL_MAX,NMODEL_MIN,FILE_NMR,FILE_CORR
     *   ,FILE_SEQ,NDOM
     *   ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *   ,IBACK_DOM_BASE,NRES_DOM_BASE
     *   ,NDOMAIN_BASE
     *   ,PATH_DB,PATH_SCR,PATH_OUT,IERR)
C -------------------------------------------------
      INTEGER   MDOC,IERR,NPRF
      CHARACTER CODE8*8
      CHARACTER FILE_NMR*(*),FILE_CORR*(*)
      CHARACTER FILE_SEQ*(*)
      CHARACTER PATH_SCR*(*),PATH_OUT*(*),PATH_DB*(*)
c ---
      CHARACTER CODE_DOM_BASE(NDOMAIN_BASE)*8
      INTEGER   ID_DOM_BASE(NDOMAIN_BASE)
      INTEGER   ICLASS_DOM_BASE(NDOMAIN_BASE)      
      INTEGER   IBACK_DOM_BASE(NDOMAIN_BASE)
      INTEGER   NRES_DOM_BASE(NDOMAIN_BASE)
C ---
      CHARACTER FILE_FIRST*256
      CHARACTER FILES*256,FILET*256
      CHARACTER FILE_PRF*256,FILE_SUM*256
      CHARACTER FILE_PRF_D*256

      CHARACTER LIST*1,WFLAG*1,FULL*1
      CHARACTER CODED*8,CODEC*8

      PARAMETER ( NPRF_LIST = 2000  )
      INTEGER   NRES_LIST(NPRF_LIST),INDEX_LIST(NPRF_LIST)
      INTEGER   ICLASS_LIST(NPRF_LIST)
      REAL      SCORE_LIST(NPRF_LIST),Q_LIST(NPRF_LIST)
     *         ,SML_LIST(NPRF_LIST)
      CHARACTER PRF_LIST(NPRF_LIST)*8,COMPLEX_LIST(NPRF_LIST)*10
C ---
      PARAMETER ( NDOM_MAX = 20 )
      INTEGER   NMODEL_DOM(NDOM_MAX)
      CHARACTER FILE_NMR_D(NDOM_MAX)*256
C ---
      PARAMETER ( IPRROW = 51 )
      REAL      RESULT(IPRROW)
      CHARACTER LINE*512,CH1*1,CH2*2,ALIGN_CORR*1
      CHARACTER PAIR*1,DIST*1
      CHARACTER LETT*36
c                 123456789012345678901234567890123456
      DATA LETT /'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA NLETT/36/
C -------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ------
      Q_LIM = 0.3
      NMAX  = 8

      WFLAG = 'Y'
      FULL  = 'N'
      LIST  = 'S'

CCC   LIST  = 'L'

      IF(NMAX.GT.NPRF_LIST) NMAX = NPRF_LIST
      NPRF = 0
      NMODEL_MAX = 0
      NMODEL_MIN = 1000

      DO ID=1,NDOM_MAX
        NMODEL_DOM(ID) = 0
        WRITE(CH2,'(I2)') ID
        IF(CH2(1:1).EQ.' ') CH2(1:1) = '_'
        LINE = 'nmr_domain_tmp'//CH2//'.pdb'
        CALL LENSTR_BL(LINE,LEN)
        FILE_NMR_D(ID) = LINE(1:LEN)
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_NMR_D(ID),LT )
        IF(LEN.GT.0) THEN
          FILE_NMR_D(ID) = PATH_SCR(1:LEN)//FILE_NMR_D(ID)(1:LT) 
        ENDIF
      ENDDO

      LEN_CODE_C = 5

      NNDOM = NDOM
      IF(NDOM.LE.0) NNDOM = 1
      NMR_DOM    = 0 
      NMODEL_MAX = 0      
      NMODEL_MIN = 1000

      IF(NNDOM.GT.NDOM_MAX) THEN
        IERR = 0
        RETURN
      ENDIF      

      ALIGN_CORR = 'N'
      CODEC      = CODE8(1:5)//'   '
      FILES = ' '
      FILET = 'domain_scr.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILET,LT )
      IF(LEN.GT.0) THEN
        FILET = PATH_SCR(1:LEN)//FILET(1:LT) 
      ENDIF

      FILE_FIRST = 'pdb_first.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILE_FIRST,LT)
      IF(LEN.GT.0) THEN
        FILE_FIRST = PATH_SCR(1:LEN)//FILE_FIRST(1:LT) 
      ENDIF

      CALL GET_DOMAIN_ONE(MDOC,PATH_DB
     *   ,FILE_FIRST,FILES,FILET
     *   ,CODEC,ALIGN_CORR
     *   ,NRES,SML,SCR,NALIGN
     *   ,LIST,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in GET_DOMAIN_ONE'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        RETURN
      ENDIF
      
      FILE_PRF = 'prf_domain_sum.prf'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_PRF,LT )
      IF(LEN.GT.0) THEN
        FILE_PRF = PATH_SCR(1:LEN)//FILE_PRF(1:LT) 
      ENDIF

c      write(*,*) '--nndom,codec:',nndom,':',codec,';'
c      write(*,*) '--ff',FILE_FIRST,':',code8,';'

      DO ID=1,NNDOM

        IDD = ID
        IF(NDOM.LE.0) IDD = 0             

        CODED = CODE8
        WRITE(CODED(6:7),'(I2)') IDD
        IF(CODED(6:6).EQ.' ') CODED(6:6) = '_' 
        CODED(8:8) = '_'

        LEN_CODE_D = 7
        FILES = ' '

        CALL CREATE_PRF_LIST(MDOC
     *     ,CODED,LEN_CODE_D
     *     ,ID_DOM_BASE,CODE_DOM_BASE,ICLASS_DOM_BASE
     *     ,IBACK_DOM_BASE,NRES_DOM_BASE
     *     ,NDOMAIN_BASE
     *     ,NMAX,NPRF_LIST,NPRFD,NRES_LIST,PRF_LIST
     *     ,SCORE_LIST,Q_LIST,SML_LIST,INDEX_LIST
     *     ,ICLASS_LIST
     *     ,FILE_SEQ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          IF(IERR.NE.13) THEN 
            CALL MSGERR(MDOC,'ERROR: in CREATE_PRF_LIST. ')
          ENDIF
          IERR = 0
          GO TO 200
        ENDIF

C        IF(NPRFD.LE.1) THEN
C          CALL MSGERR(MDOC,'INFO: NPRFD < 2')
C          IERR = 0
C          GO TO 200   
C        ENDIF

        IF(NPRFD.LE.3) THEN
          CALL MSGERR(MDOC,'INFO: NPRFD < 4')
          IERR = 13
          GO TO 800   
        ENDIF

        INMR = NMR_DOM + 1

        FILE_PRF_D = 'prf_domain_temp.prf'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILE_PRF_D,LT )
        IF(LEN.GT.0) THEN
          FILE_PRF_D = PATH_SCR(1:LEN)//FILE_PRF_D(1:LT) 
        ENDIF

        FILES = ' '
C       ICFLAG > 0 all models chain_ID = (ICFLAG), =0 A,B,C,D ....
        ICFLAG = ID

        CALL CREATE_PRF_NMR_FILES(MDOC
     *     ,FILES,FILES,FILES,LEN_CODE_D
     *     ,NMODELD,FILE_NMR_D(INMR),FILE_PRF_D
     *     ,NMAX,NPRF_LIST,NPRFD,NRES_LIST,PRF_LIST
     *     ,Q_LIST,SML_LIST,INDEX_LIST,WFLAG,FULL
     *     ,ICLASS_LIST
     *     ,Q_LIM,ICFLAG
     *     ,LIST,PATH_DB,PATH_SCR,PATH_OUT,IERR)

C        IF(IERR.NE.0.OR.NMODELD.LE.1) THEN
C          IF(IERR.NE.13) THEN
C            CALL MSGERR(MDOC,'ERROR: in CREATE_NMR_FILES.')
C          ENDIF
C          IERR = 0
C          GO TO 200 
C        ENDIF

        IF(IERR.NE.0.OR.NMODELD.LE.3) THEN
          IF(IERR.NE.13) THEN
            CALL MSGERR(MDOC,'ERROR: in CREATE_NMR_FILES.')
          ENDIF
          IERR = 13
          GO TO 800 
        ENDIF

C        IF(IERR.NE.0.OR.NMODELD.LE.1) THEN
C          IF(IERR.NE.13) THEN
C            CALL MSGERR(MDOC,'ERROR: in CREATE_NMR_FILES.')
C          ENDIF
C          IERR = 0
C          GO TO 200 
C        ENDIF

        NMODEL_DOM(INMR) = NMODELD

c       FILE_PRF + FILE_PRF_D = FILES ('prf_temp.prf')

        FILES = 'prf_temp.prf'
        CALL LENSTR_BL(PATH_SCR,LEN)
        CALL LENSTR_BL(FILES,LT )
        IF(LEN.GT.0) THEN
          FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
        ENDIF

        IF(INMR.EQ.1) THEN
          FILET = FILE_FIRST
c        ELSE
c          FILET = FILE_PRF
c        ENDIF

        IPRINT = 0
        PO = 0.0
        PE = 0.01
        PAIR = 'N'
        DIST = 'N'
        IERR = 3

       IPRINT = 1

        CALL MAKE_ALIGN5D(Mdoc,IPRINT
     *        ,FILET,FILE_PRF_D,FILES
     *        ,PAIR,DIST,PO,PE
     *        ,RESULT,IPRROW,PATH_SCR,PATH_OUT,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in MAKE_ALIGN 1: '//CODE8
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          GO TO 200 
        ENDIF


        ELSE
          FILET = FILE_PRF
          CALL JOIN_2PROFILES(MDOC,FILET,FILE_PRF_D,FILES,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: in JOIN_2PROFILES: '//CODE8
            CALL MSGERR(MDOC,LINE)
            IERR = 0
            GO TO 200 
          ENDIF

        ENDIF

        NMR_DOM = NMR_DOM + 1

c       FILES --> FILE_PRF

        CALL COPY_PROFILE(MDOC,CODE8
     *     ,NSEQ_PROFILE,FILES,FILE_PRF,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in : COPY_PROFILE.'
          CALL MSGERR(MDOC,LINE)
          IERR = 0
          NMR_DOM = NMR_DOM - 1
          GO TO 200 
        ENDIF

        IF(NMODELD.GT.NMODEL_MAX) NMODEL_MAX = NMODELD
        IF(NMODELD.LT.NMODEL_MIN) NMODEL_MIN = NMODELD


C        write(*,*) '--inmr,NMR_DOM:',INMR,NMR_DOM        
C        write(*,*) '--fn:',FILE_NMR_D(INMR)
C        write(*,*) '--fp:',FILE_PRF
C        write(*,*) '--fT:',FILET
C        write(*,*) '--fPD:',FILE_PRF_D
C        write(*,*) '--fs:',FILES

  200   CONTINUE

      ENDDO

C      IF(NMODEL_MAX.LE.1.OR.NMR_DOM.LE.0) THEN
C        CALL MSGERR(MDOC,'ERROR: Nmodel_max < 2')

      IF(NMODEL_MIN.LE.3.OR.NMR_DOM.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: Nmodel_min < 4')
        IERR = 13
        GO TO 800   
      ENDIF

c      write(*,*) '--NMODEL_MAX,NMR_DOM:',NMODEL_MAX,NMR_DOM
c      write(*,*) '--NNDOM:',NNDOM

      IF(NNDOM.LE.1) THEN
        NM = 0
        CALL COPY_PDB_FILE(MDOC,NM,FILE_NMR_D(1),FILE_NMR,IERR)
        IF(IERR.NE.0) THEN
          LINE = ' ERROR: in : COPY_PDB_FILE .'
          CALL MSGERR(MDOC,LINE)
          IERR = 1
          GO TO 800 
        ENDIF
        GO TO 100
      ENDIF      

      FILE_SUM = 'pdb_sum.pdb'
      CALL LENSTR_BL(PATH_SCR,LEN)
      CALL LENSTR_BL(FILE_SUM,LT )
      IF(LEN.GT.0) THEN
        FILE_SUM = PATH_SCR(1:LEN)//FILE_SUM(1:LT) 
      ENDIF

      DO IM=1,NMODEL_MAX 
     
        DO ID=1,NNDOM

          IF(NMODEL_DOM(ID).GE.IM) THEN
            FILES = 'nmr_temp.pdb'
            CALL LENSTR_BL(PATH_SCR ,LEN)
            CALL LENSTR_BL(FILES,LT )
            IF(LEN.GT.0) THEN
              FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
            ENDIF
            NM = IM
            CALL COPY_PDB_FILE(MDOC,NM,FILE_NMR_D(ID),FILES,IERR)
            IF(IERR.NE.0) THEN
              LINE = ' ERROR: copy file NMR temp -> NMR'
              CALL MSGERR(MDOC,LINE)
              IERR = 1
              GO TO 800
            ENDIF

            IF(ID.GT.1) THEN
C             PDB_SUM + FILES --> FILET
              FILET = 'pdb_temp.pdb'
              CALL LENSTR_BL(PATH_SCR ,LEN)
              CALL LENSTR_BL(FILET,LT )
              IF(LEN.GT.0) THEN
                FILET = PATH_SCR(1:LEN)//FILET(1:LT) 
              ENDIF
              IFT    =-1
              ICFLAG =-1
              NM     = IM
              Q_FIN  = 0.0
              CALL JOIN_PDB_MODEL(MDOC,NM,IFT
     *               ,Q_FIN,ICFLAG,CODE8,CODE8
     *               ,FILE_SUM,FILES,FILET,IERR)
C ----
C     ICFLAG > 0 all ch_ID = (ICFLAG); =0 A,B,C,D ..; <0 save ch_ID
C     IFIRST  1 set MODEL rec for 1st file; 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file (save ch_ID); 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st file (save ch_ID); copy 2nd file: ch_ID see ICFLAG 
C ----
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: JOIN_PDB_MODEL pdb'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
C             copy FILET --> PDB_SUM 
              NM = 0
              CALL COPY_PDB_FILE(MDOC,NM,FILET,FILE_SUM,IERR)
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: copy filet -> SUM'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
            ELSE
C             copy 1st --> PDB_SUM 
              NM = 0
              CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_SUM,IERR)
              IF(IERR.NE.0) THEN
                LINE = ' ERROR: copy 1st file -> SUM'
                CALL MSGERR(MDOC,LINE)
                IERR = 1
                GO TO 800
              ENDIF
            ENDIF
          ENDIF

        ENDDO

        IF(IM.EQ.1) THEN
C         copy FILE_SUM --> FILE_NMR
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILE_SUM,FILE_NMR,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy SUM -> NMR'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
        ELSE
C         FILE_NMR + FILE_SUM --> FILES
          FILES = 'nmr_temp.pdb'
          CALL LENSTR_BL(PATH_SCR ,LEN)
          CALL LENSTR_BL(FILES,LT )
          IF(LEN.GT.0) THEN
            FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
          ENDIF
          IFT    = 1
          ICFLAG =-1
          NM     = IM
          Q_FIN  = 0.0
          CALL JOIN_PDB_MODEL(MDOC,NM,IFT
     *               ,Q_FIN,ICFLAG,CODE8,CODE8
     *               ,FILE_NMR,FILE_SUM,FILES,IERR)
C ----
C     ICFLAG > 0 all ch_ID = (ICFLAG); =0 A,B,C,D ..; <0 save ch_ID
C     IFIRST  1 set MODEL rec for 1st file; 2nd file: MODEL rec: NMODEL 
C     IFIRST  0 copy 1st file (save ch_ID); 2nd file: MODEL rec: NMODEL 
C     IFIRST -1 copy 1st file (save ch_ID); copy 2nd file: ch_ID see ICFLAG 
C ----
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: JOIN_PDB_MODEL nmr'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
C         copy FILES --> FILE_NMR
          NM = 0
          CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_NMR,IERR)
          IF(IERR.NE.0) THEN
            LINE = ' ERROR: copy files -> NMR'
            CALL MSGERR(MDOC,LINE)
            IERR = 1
            GO TO 800
          ENDIF
        ENDIF
 
      ENDDO
C ---

  100 CONTINUE

c      write(*,*) '--fs:',FILE_SEQ
c      write(*,*) '--ff:',FILE_FIRST
c      write(*,*) '--fp:',FILE_PRF
c      write(*,*) '--fc:',FILE_CORR

      CALL CORRECTION_PDB_BY_PRF(MDOC
     *  ,FILE_SEQ,FILE_FIRST,FILE_PRF,FILE_CORR
     *  ,PATH_SCR,PATH_OUT,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in : CORRECTION_PDB_BY_PRF'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

      FILES = 'nmr_temp.pdb'
      CALL LENSTR_BL(PATH_SCR ,LEN)
      CALL LENSTR_BL(FILES,LT )
      IF(LEN.GT.0) THEN
         FILES = PATH_SCR(1:LEN)//FILES(1:LT) 
      ENDIF

      CALL REPLACE_FIRST_MODEL_IN_NMR(MDOC,CODE8
     *    ,FILE_CORR,FILE_NMR,FILES,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: in : REPLACE_FIRST_MODEL'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

c      write(*,*) '=ff:',FILE_NMR
c      write(*,*) '=S:',FILES

      NM = 0
      CALL COPY_PDB_FILE(MDOC,NM,FILES,FILE_NMR,IERR)
      IF(IERR.NE.0) THEN
        LINE = ' ERROR: copy file NMR temp -> NMR'
        CALL MSGERR(MDOC,LINE)
        IERR = 1
        GO TO 800
      ENDIF

      CALL LENSTR_BL(FILE_NMR,LT )
      LINE = 'Result: '//FILE_NMR(1:LT)
      CALL MSGDOC(MDOC,LINE)

C ------
  800 CONTINUE

      DO ID=1,NDOM_MAX
        WRITE(CH2,'(I2)') ID
        IF(CH2(1:1).EQ.' ') CH2(1:1) = '_'
        LINE = 'nmr_domain_tmp'//CH2//'.pdb'
        CALL LENSTR_BL(LINE,LEN)
        FILES = LINE(1:LEN)
        CALL DELETE_FILE(PATH_SCR,FILES)
      ENDDO
      FILES = 'prf_domain_temp.prf'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'prf_temp.prf'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'nmr_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_sum.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_temp.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'pdb_first.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'domain_scr.pdb'
      CALL DELETE_FILE(PATH_SCR,FILES)
      FILES = 'prf_domain_sum.prf'
c      CALL DELETE_FILE(PATH_SCR,FILES)
 
      RETURN
      END

      SUBROUTINE COPY_PDB_FILE_AND_SET_DOM_ID(MDOC,DOM
     * ,NAME_IN,NAME_OUT,IERR)
C --------------------------------------------------------
      CHARACTER NAME_IN*(*),NAME_OUT*(*)
C --------------------------------------------------------
C ----
      CHARACTER LINE*256,PATH*256,EXT*256,DOM*1
C -------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
      IFIRST = 0
C ---------------------------
      CALL LENSTR_BL(NAME_IN,LEN)
      IF(LEN.LE.0.OR.NAME_IN(1:1).EQ.' '.OR.NAME_IN(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong input file name')
        IERR = 1
        RETURN
      ENDIF
      IU   = 10
      EXT  = ' '
      PATH = ' '
      CALL OPENFR(IU,M,PATH,NAME_IN,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open input file')
        GO TO 200
      ENDIF
C ---------------------------
      CALL LENSTR_BL(NAME_OUT,LEN)
      IF(LEN.LE.0.OR.NAME_OUT(1:1).EQ.' '
     *           .OR.NAME_OUT(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERROR: wrong output file name')
        CLOSE(IU)
        IERR = 1
        RETURN
      ENDIF
      IOUT   = 11
      EXT    = ' '
      PATH   = ' '
      CALL OPENFW(IOUT,M,PATH,NAME_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERROR: open output file')
        CLOSE(IU)
        GO TO 200
      ENDIF
C --------------------------------
 400  CONTINUE

      READ(IU,'(A)',ERR=500,END=600) LINE

      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN

C        IF(LINE(1:4).EQ.'MODE'.AND.ALL.EQ.'N') THEN
C          READ(LINE,'(9X,I5)') IT
C          IFIRST = IFIRST + 1
C          GO TO 400
C        ENDIF

        IF((LINE(1:6).EQ.'ATOM  ').OR. 
     *     (LINE(1:6).EQ.'HETATM')) THEN
C          IF(IFIRST.LE.1) LINE(75:75) = DOM
          LINE(75:75) = DOM
        ENDIF
        WRITE(IOUT,'(A)',ERR=510) LINE(1:LEN)
      ENDIF

      GO TO 400
C --------------
 600  CONTINUE
      CLOSE(IU)
      END FILE IOUT
      CLOSE(IOUT)

      RETURN
C ----------------
 200  CONTINUE
      GO TO 900
 500  CONTINUE
      LINE = ' ERROR: reading input file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      CLOSE(IOUT)
      GO TO 900
 510  CONTINUE
      LINE = ' ERROR: write output file'
      CALL MSGERR(MDOC,LINE)
      CLOSE(IU)
      CLOSE(IOUT)
      GO TO 900
C ----------------
 900  CONTINUE
      IERR = 1
      RETURN
      END


      SUBROUTINE JOIN_2PROFILES(MDOC
     *   ,FILE_PRF1,FILE_PRF,FILE_OUT
     *   ,IERR)
C ------------------------------
      CHARACTER FILE_PRF1*(*),FILE_PRF*(*),FILE_OUT*(*)
      CHARACTER PNP*6
      CHARACTER LINE*512
c ---
      character(LEN=77), allocatable :: PRF1(:)
      character(LEN=6), allocatable :: PNUM1(:)
c ---
      CHARACTER PATH*1,EXT*1
C ------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      M    = 99
C ----
      CALL LENSTR_BL(FILE_PRF1,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MD,' ERROR: wrong PRF1 file name')
        IERR = 1
        RETURN
      ENDIF
      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PRF1,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF1 file')
        IERR = 1
        RETURN
      ENDIF
C ----
      NAA1 = 0
      READ(IN1,'(A)',ERR=900) LINE
      READ(IN1,'(A)',ERR=900) LINE
      READ(IN1,'(A)',ERR=900) LINE
      DO I=1,1000000
        READ(IN1,'(A)',ERR=900,END=1000) LINE
        NAA1 = NAA1 + 1
      ENDDO
 1000 CONTINUE
      CLOSE(IN1) 
      IF(NAA1.LE.0) THEN
        CALL MSGERR(MDOC,'ERROR: NAA1 < 1')
        IERR = 1
        RETURN
      ENDIF

      allocate(PNUM1(1:NAA1),STAT=ISTAT)
      allocate(PRF1(1:NAA1),STAT=ISTAT)

      EXT  = ' '
      PATH = ' '
      IN1 = 30
      CALL OPENFR(IN1,M,PATH,FILE_PRF1,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF1 file')
        IERR = 1
        GO TO 930
      ENDIF
C ---
      EXT  = ' '
      PATH = ' '
      IOUT = 32
      CALL OPENFW(IOUT,M,PATH,FILE_OUT,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open output PRF file')
        CLOSE(IN1)
        IERR = 1
        GO TO 930
      ENDIF

      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)
      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)
      READ(IN1,'(A)',ERR=901) LINE
      CALL LENSTR_BL(LINE,LEN)
      WRITE(IOUT,'(A)',ERR=905) LINE(1:LEN)

      DO I=1,NAA1
        READ(IN1,'(A)',ERR=901,END=1010) LINE
        PRF1(I)  = LINE(1:77)
        PNUM1(I) = LINE(63:68)
      ENDDO

 1010 CONTINUE
      CLOSE(IN1) 
C -----------
      CALL LENSTR_BL(FILE_PRF,LEN)
      IF(LEN.LE.0) THEN
        CALL MSGERR(MD,' ERROR: wrong PRF file name')
        CLOSE(IOUT)
        IERR = 1
        RETURN
      ENDIF
      EXT  = ' '
      PATH = ' '
      IN2 = 31
      CALL OPENFR(IN2,M,PATH,FILE_PRF,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MD,' ERROR: cannot open intput PRF file')
        IERR = 1
        GO TO 930
      ENDIF
      READ(IN2,'(A)',ERR=910) LINE
      READ(IN2,'(A)',ERR=910) LINE
      READ(IN2,'(A)',ERR=910) LINE
C ---
      DO IP=1,100000
        READ(IN2,'(A)',ERR=910,END=100) LINE
        PNP = LINE(63:68)
        DO IP1=1,NAA1
          IF(PNP.EQ.PNUM1(IP1)) THEN
            PRF1(IP1) = LINE(1:77)
            GO TO 200
          ENDIF
        ENDDO
200     CONTINUE
      ENDDO
100   CONTINUE
      DO IP1=1,NAA1
        WRITE(IOUT,'(A)',ERR=920) PRF1(IP1)
      ENDDO
c ----
      CLOSE(IN2)
      END FILE IOUT
      CLOSE(IOUT)

  930 CONTINUE

      deallocate(PNUM1,STAT=ISTAT)
      deallocate(PRF1,STAT=ISTAT)

      RETURN
C ----
  900 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF1 file')
      CLOSE(IN1)
      IERR =1
      RETURN
  901 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF1 file')
      CLOSE(IOUT)
      CLOSE(IN1)
      IERR =1
      GO TO 930
  910 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF file')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  915 CONTINUE
      CALL MSGERR(MD,' ERROR: read intput PRF from LINE')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  920 CONTINUE
      CALL MSGERR(MD,' ERROR: write output PRF file')
      CLOSE(IN2)
      CLOSE(IOUT)
      IERR =1
      GO TO 930
  905 CONTINUE
      CALL MSGERR(MD,' ERROR: write output PRF file')
      CLOSE(IOUT)
      CLOSE(IN1)
      IERR =1
      GO TO 930
      END 

