C --- LIBUTILS.FTN ---
C ******
C ---------------------------------------------------------------------------
C
C     --- LIBRARY OF KERNEL SUBROUTINES OF "BLANC-SYSTEM" ---
C                                 /V. ??.09.1978 - 29.03.1991   A.A.VAGIN/
C                                   - 21.06.1992 - 29.09.1992
C                                   - 16.12.1994 - 15.07.1995
C                                   - 11.02.1997 - 27.11.1997 ....
c
c                                   - 29.11.2004
C ---------------------------------------------------------------------------
C ******
C -P-
C -P------   SUBROUTINES DEPENDED ON SYSTEM --------------------
C -P-
C      CVX - for VMS VAX 
C      CDP - for unix system
C      CMS - for MS-DOS
C      CLN - for Linux 
C ******

C ******
      SUBROUTINE GET_PATH(MDOC,NAME,PATH,IERR)
C ----------------------------------------
C
C -P- GET_PATH - call getenv / get BLANC - path of blanc directory /
C
      CHARACTER NAME*(*),PATH*(*)
      CHARACTER LINE*256
C ******
C ----------------------------------------
C     / setenv BLANC ~alexei/blanc /
C     CALL GET_PATH('BLANC',LINE)
C     LINE='~alexei/blanc' 
C ----------------------------------------
      IERR=0

CDP   CALL GETENV(NAME,PATH)
CDP   CALL LENSTR_BL(PATH,LEN)
CDP   IF(LEN.LE.0) THEN
CDP     CALL MSGERR(MDOC
CDP  *,' ERR: path of BLANC directory is wrong.')
CDP     CALL MSGERR(MDOC
CDP  *,'      Probably you did not set command: "setenv".')
CDP     CALL MSGERR(MDOC
CDP  *,'      Set command: "setenv BLANC path_name".')
CDP     CALL MSGERR(MDOC
CDP  *,'      Example: "setenv BLANC ~alexei/blanc"')
CDP     IERR=1
CDP   ENDIF

      CALL LENSTR_BL(NAME,LN)

      CALL GETENV(NAME,PATH)
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.LE.0) THEN
        LINE = ' ERR: path of '//NAME(1:LN)//' directory is wrong.'
        CALL MSGERR(MDOC,LINE)
        CALL MSGERR(MDOC
     *,'      Probably you did not set command: "setenv".')
        LINE = '      Set command: "setenv '//NAME(1:LN)//
     *         ' path_name".'
        CALL MSGERR(MDOC,LINE)
        LINE = '      Example: "setenv '//NAME(1:LN)//
     *         ' ~alexei/blanc"'
        CALL MSGERR(MDOC,LINE)
        IERR=1
      ENDIF

CMS   PATH=' '      
CVX   PATH=' '      

      RETURN
      END

      SUBROUTINE GET_PATH_OUT(LINE,PATH)
C -------------------------------------------------------------
      INTEGER   LEN,LLL
      CHARACTER LINE*(*),PATH*(*)
C -------------------------------------------------------------
      LLL = 0
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        DO I=1,LEN
          IF(LINE(I:I).NE.' ') THEN
            LLL = I
            GO TO 10
          ENDIF
        ENDDO
      ENDIF
  10  CONTINUE
      IF(LLL.GT.0) THEN
        LINE = LINE(LLL:LEN)
        LEN  = LEN - LLL + 1
        IF(LEN.LE.1) RETURN
        IF(LINE(1:1).NE.'>') RETURN
        LINE = LINE(2:LEN)
        LEN  = LEN - 1
        PATH = LINE(1:LEN)    
        CALL CORR_NAME_BL(PATH)
        CALL LENSTR_BL(PATH,LEN)
        IF(LEN.LE.0) THEN
          PATH = ' '    
        ENDIF
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE DISPL_BL(LINE)
C
C -P- DISPL - write message to terminal and stop cursor at the end of line.
C
C             NOTE : for Linux ( CLN ) cursor will not stop
C                    at the end of line.
C
      CHARACTER LINE*(*)
      INTEGER   NL
      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.79) NL=79
CVX   WRITE(*,'(''$'',A  )') LINE(1:NL)
CDP   WRITE(*,'('' '',A,$)') LINE(1:NL)
CMS   WRITE(*,'('' '',A,\)') LINE(1:NL)
      WRITE(*,'('' '',A,$)') LINE(1:NL)
      RETURN
      END
C ******
C ******
      SUBROUTINE CLOCK(IH)
C
C -P- CLOCK - get date to --> array IH()
C
C    IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
C
      INTEGER IH(7)
C ******
      CHARACTER  cdate*8,ctime*10,czone*5
      INTEGER    ivalues(8)
CMS   INTEGER*2 IHR,IMN,ISEC,I100H,IYR,IMON,IDAY
CVX   CHARACTER STR*8
      INTEGER*4 ID(3)
CLN   INTEGER*4 ID(3)
c --------------------------------
CVX   CALL IDATE(I1,I2,I3)
CVX   IH(5)=I2
CVX   IH(6)=I1
CVX   IT1  =I3+1900
CVX   IH(7)=IT
CVX   CALL TIME(STR)
CVX   READ(STR,'(I2,1X,I2,1X,I2)') IH(4),IH(3),IH(2)
CVX   IH(1)=0
C
CMS   CALL GETTIM(IHR,IMN,ISEC,I100H)
CMS   CALL GETDAT(IYR,IMON,IDAY)
CMS   IH(4)=IHR
CMS   IH(3)=IMN
CMS   IH(2)=ISEC
CMS   IH(5)=IDAY
CMS   IH(6)=IMON
CMS   IH(7)=IYR
CMS   IH(1)=I100H/2

CDP
c      ID(1) = 0
c      ID(2) = 0
c      ID(3) = 0
c      CALL ITIME(ID)
c      IH(4)=ID(1)
c      IH(3)=ID(2)
c      IH(2)=ID(3)
c      IDAY = 1
c      IMON = 1
c      IYR  = 0
c      CALL IDATE(IMON,IDAY,IYR)
c      IF(IYR.GE.99) THEN
c        IYR=IYR+1900
c      ELSE
c        IYR=IYR+2000
c      ENDIF
c      IH(5)=IDAY
c      IH(6)=IMON
c      IH(7)=IYR
c      IH(1)=0
CDP 
c ===============================================
      CALL Date_and_Time(CDATE,CTIME,CZONE,IVALUES)
      IH(4)=IVALUES(5)
      IH(3)=IVALUES(6)
      IH(2)=IVALUES(7)
      IH(5)=IVALUES(3)
      IH(6)=IVALUES(2)
      IH(7)=IVALUES(1)
      IH(1)=0
c ================================================

C
C  Dummy routine for Linux
C
CLN   IH(4)=0
CLN   IH(3)=0
CLN   IH(2)=0
CLN   IH(5)=01
CLN   IH(6)=01
CLN   IH(7)=1990
CLN   IH(1)=0

      RETURN
      END

C 
C ----  OLD DUMMY SUBROUTINES / not used now/  -----------
C 


      SUBROUTINE GETNOS(CH3)
C
C -P- GETNOS - get name of operating system
C
      CHARACTER CH3*3
C --------------------------------
      CH3='UNX'
CMS   CH3='MSD'      
CVX   CH3='VAX'      
CDP   CH3='UNX'      
CLN   CH3='LIN'      
      RETURN
      END

CMS   SUBROUTINE EXIT
CMS   STOP
CMS   END


C ******
      SUBROUTINE HSRD(A)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
C
C ******
      INTEGER INIT,N,IH(7),I
      DATA INIT/0/,N/0/
C -----------------------------------------
      IF(INIT.EQ.0) THEN
        N    = 1342773
        INIT = 1
        CALL CLOCK(IH)
        N = IH(2)+(IH(3)+IH(4)*60)*60
      ENDIF

      I = 2147483647
CMS   I = 2147483647
CVX   I = 2147483647
CDP   I = 2147483647
CLN   I = 21474836

      N = N*65539+I+1
C     N = N*65539+2147483647+1
      A = ABS(N*.4656613E-9)-.5
      RETURN
      END
C ******
      SUBROUTINE HSRD_TIME(A,N,INIT)
C -P- HSRD - gives A - random variable / -0.5 =< A =< 0.5 /
C
C ******
      INTEGER IH(7)
      INTEGER INIT,N
C      DATA INIT/0/,N/0/
C -----------------------------------------
      IF(INIT.EQ.0) THEN
        N    = 1342773
c        CALL CLOCK(IH)
c        N = IH(2)+(IH(3)+IH(4)*60)*60 
        INIT = 1
      ENDIF

c     N = N*65539 + 2147483647 + 1

      N = N*65539 + 21474836 + 1
      A = ABS(N*.4656613E-9)-.5
      RETURN
      END

c      SUBROUTINE CPU(ICPU,MDOC)
C
C     CPU - write CPU information to DOC_FILE or/and terminal,return CPU time.
C           
C       In the first call ICPU must be = 0.
C       Next call return value of CPU_time by ICPU and write message:
C       ' CPU TIME :XXXXXXXX MIN XXX.XX SEC'
C
C     ICPU  - time from initialization till this call /in seconds*50/ 
C     MDOC  - mode of writting messages to DOC-file
C             0 - only term, < - 0 only file, 0 < < 99 - both
C             =< 99 - not write  
C
c      INTEGER*4 ICPU,MDOC
C MS   INTEGER*2 IH,IM,IS,ID
C DP   INTEGER*4 IH,IM,IS,ID,IYR,IMON,IDAY
c      REAL TARR(2)  
c      CHARACTER LINE*80
C ------------------------------
c      IF(ICPU.EQ.0) THEN
c
C VX     T1=SECNDS(0.0)
c
C MS     CALL GETTIM(IH,IM,IS,ID)
C MS     T1=IH*3600.0+IM*60.0+IS+ID/100.0
c
C DP     CALL timedate(IYR,IMON,IDAY,IH,IM,IS,ID)
C DP     T1=IH*3600.0+IM*60.0+IS+ID/100.0
C DP     T1=0 
c
c      ELSE
c
C VX     DELTA=SECNDS(T1)
C VX     IIDD=DELTA*50.0
c
C MS     CALL GETTIM(IH,IM,IS,ID)
C MS     X1=IH*3600.0+IM*60.0+IS+ID/100.0
C MS     SC=X1-T1
C MS     IIDD=SC*50.0
c
C DP     CALL timedate(IYR,IMON,IDAY,IH,IM,IS,ID)
C DP     X1=IH*3600.0+IM*60.0+IS+ID/100.0
C DP     SC=X1-T1
C DP     IIDD=SC*50.0
C DP     X1=DTIME(TARR)
C DP     T1=T1+X1
C DP     SC=T1
C DP     IIDD=SC*50.0+0.5
c
c        ICPU=IIDD
c        JTDD=IIDD/50
c        ITDD=IIDD-JTDD*50
c        ITM=JTDD/60
c        JTDD=JTDD-ITM*60
c        WRITE(LINE,10) ITM,JTDD,ITDD
c  10    FORMAT(' CPU TIME :',I8,' MIN ',I3,'.',I2,' SEC')
c        CALL MSGDOC(MDOC,LINE)
c      ENDIF
c      RETURN
c      END

C ==========================================

C ******
C -P-
C -P- ----   SUBROUTINES INDEPENDED ON SYSTEM --------------------
C -P-
C -P------ subroutines for all programs  --------------------
C -P-
C ******

      SUBROUTINE SET_DEFAULT(LINE)
C
C -P- SET_DEFAULT - write info about the defaults, get the defaults and go to 
C -P-               batch mode.  
C
      CHARACTER LINE*(*)
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      PARAMETER ( KEY_MAX = 100 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_KEYWORDS/ 
     *                  FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*256
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ---
      INTEGER*4 NL,NLK
      CHARACTER STR*256,KEY*256,K_TEST*11,CHAR1*1,IN_STRING2*256
      CHARACTER STR1*256,S_END*256,FILE_KEY*256
C ---------------------------------------------------------
      IF(IBATCH.NE.0) THEN
C       It is not interactive mode 
        RETURN
      ENDIF

      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.255) NL=255
      IF(NL.LE.0) THEN
        STR(1:1)=' '
        NL      =1
      ELSE
        STR=LINE(1:NL)
      ENDIF

      IWD = 0
      IWB = 0

      IF(STR(1:1).EQ.'?') THEN
C       first call of dialogue
        IF(NL.GT.2) THEN
          S_END=STR(3:NL)
          NL_END=NL-2
        ELSE
          S_END =' '
          NL_END=0
        ENDIF
        NKEY=0
        DO I=1,KEY_MAX
          FLAG(I)=0
        ENDDO

        M=0
        CALL MSGDOC(M,'# ---  type "keyword   parameters" and/or  ---')
        CALL MSGDOC(M,'# ---  press key "CR" to run program       ---')

        KFIRST    = 0
        IUNIT_KEY = 0
        FILE_KEY  = ' '

 200    CONTINUE
C       start loop of dialogue

        IF(BAT_MODE.EQ.0.AND.KFIRST.NE.1) CALL DISPL_BL('-->')

C       read input line

        IF(KFIRST.NE.1) THEN

          READ(*,'(A)',END=1040,ERR=1030) IN_STRING

        ELSE
          IF(IUNIT_KEY.LE.0) GO TO 1020
          READ(IUNIT_KEY,'(A)',END=1010,ERR=1020) IN_STRING
          GO TO 1000
 1010     CONTINUE
          CLOSE(IUNIT_KEY)
          IUNIT_KEY = 0
          KFIRST    = 2
          GO TO 200
        ENDIF
 1000   CONTINUE
        CALL LENSTR_BL(IN_STRING,L)
        IF(L.GT.1) THEN
          IFIRST     = 0
          II         = 0
          IN_STRING2 = ' '
          DO I=1,L
            IF(IFIRST.EQ.0.AND.IN_STRING(I:I).EQ.' ') THEN
            ELSE
              IFIRST=1
              II=II+1
              IN_STRING2(II:II)=IN_STRING(I:I)
            ENDIF
          ENDDO
          IN_STRING=IN_STRING2
          CALL LENSTR_BL(IN_STRING,L)
          IF(L.GT.0.AND.IN_STRING(1:1).EQ.'#') GO TO 200
C         comments
        ELSE
          IF(IBATCH.NE.0) THEN
            IF(L.LE.0.OR.IN_STRING(1:1).EQ.' ') GO TO 200
          ENDIF
C         empty line
        ENDIF
        IF(L.LE.0.OR.IN_STRING(1:1).EQ.' '.OR.
     *  IN_STRING(1:4).EQ.'_END'.OR.IN_STRING(1:4).EQ.'_end') 
     *  GO TO 100
C       finish of dialogue
C ----
        CALL FRD_PARM_KEYWORDS
        IF(NWORDS.LE.0) GO TO 200

C       get key_word:  'word  <...> ' or '_word <...> '    
        KEY = WORDS(1)
        NLK = LEN_WORDS(1)
        IF(NLK.GE.1) THEN
          IF(KEY(1:1).NE.'_') THEN
C           first symbol must be '_' if not add it
            KEY = '_'//KEY(1:NLK)
            NLK = NLK + 1
          ELSE
            KEY = KEY(1:NLK)
          ENDIF
        ELSE
          KEY = ' '
          NLK = 1
        ENDIF
        
        IF(NLK.GT.12) NLK=12
        IF(NLK.LE.1) GO TO 200 
C       check keyword KEY and convert to uppercase
        CALL CHECK_LINE(1,KEY(1:NLK))

C       create string of parameters STR without keyword 
        DO I=1,L
          J = I+LEN_WORDS(1)-1
          IF(IN_STRING(I:J).EQ.WORDS(1)(1:LEN_WORDS(1))) THEN
            JJ = J+1
            IF(JJ.EQ.L) GO TO 200 
            STR = IN_STRING(JJ:L)
            NL  = L-J
            GO TO 300
          ENDIF
        ENDDO
        GO TO 200

 300    CONTINUE
C       remove last symbol ':' from keywords 
        IF(KEY(NLK:NLK).EQ.':') THEN
          KEY(NLK:NLK) = ' '
          NLK          = NLK-1
        ENDIF

C       creat correct string STR : 'keyword <parameters>'
        IF(NL.LE.0) THEN
          STR=KEY(1:NLK)//' ' 
        ELSE
          STR=KEY(1:NLK)//' '//STR(1:NL) 
        ENDIF
        CALL LENSTR_BL(STR,NL)
        IF(NL.GT.256) NL=256
        IF(NLK.GT.1) THEN
          IF(NKEY_TEST.GT.0) THEN
C           check with possible keywords / KEY_TEST(NKEY_TEST) /               
            IMODE  = 1
            K_TEST = KEY(2:NLK)
            NLKK   = NLK-1
            CALL CHECK_LINE(IMODE,K_TEST)
            DO I=1,NKEY_TEST
              CALL LENSTR_BL(KEY_TEST(I),LEN)
              IF(LEN.EQ.NLKK) THEN
                IF(KEY_TEST(I)(1:LEN).EQ.K_TEST(1:LEN)) GO TO 310
              ENDIF
            ENDDO

            L = LEN
            IF(L.GT.11) L = 11
            STR1=' WARNING: no such keyword :'//K_TEST(1:L)
            IF(L.GT.0) THEN
              IF(K_TEST(1:1).NE.'#') THEN
                CALL MSGERR(M,STR1)
              ENDIF
            ELSE
              CALL MSGERR(M,' WARNING: no such keyword')
            ENDIF

            GO TO 200

 310        CONTINUE          
          ENDIF
        ENDIF

        IF(BAT_MODE.EQ.1) THEN
          MM=1
          IF(NL.GT.0) CALL MSGDOC(MM,STR(1:NL))
        ENDIF

        IF(NKEY.GT.0) THEN
C         check with previous keywords 
C         if there is such keywords replace stored string STOR
          DO I=1,NKEY
            CALL LENSTR_BL(STOR_KEY(I),NLSK)
            IF(NLSK.EQ.NLK.AND.KEY(1:NLK).EQ.STOR_KEY(I)(1:NLK))THEN
              STOR(I)     = STR(1:NL)
              STOR_KEY(I) = KEY(1:NLK)
            ENDIF 
          ENDDO
        ENDIF

        IF(NKEY.LT.KEY_MAX) THEN
C         store new keyword in STOR_KEY and string STR in STOR
          NKEY           = NKEY+1
          FLAG(NKEY)     = 1
          STOR(NKEY)     = STR(1:NL)
          STOR_KEY(NKEY) = KEY(1:NLK)
        ENDIF

        IF(KEY(1:NLK).EQ.'_ADD') THEN
          FILE_KEY = WORDS(2)
          CALL CORR_NAME_BL(FILE_KEY)
          CALL LENSTR_BL(FILE_KEY,LEN)
          IF(NWORDS.GT.1.AND.LEN.GT.0.AND.
     *       FILE_KEY(1:1).NE.'.'.AND.FILE_KEY(1:1).NE.' ') THEN
            IUNIT_KEY = 10
            M         = 0
            CALL OPENFR(IUNIT_KEY,M,' ',FILE_KEY,' ',IERR)
            IF(IERR.NE.0) THEN
              CALL MSGERR(M,' ERROR: can not open ADD_KEYWORD_FILE')
              IERR      = 0
              IUNIT_KEY = 0
              KFIRST    = 2             
            ELSE
            KFIRST    = 1
            ENDIF             
          ELSE
            M         = 0
            CALL MSGERR(M,' WARNING: keyword ADD without parameter')
          ENDIF
        ENDIF

        GO TO 200

C       end loop of dialogue
C ----------------------------------
 100    CONTINUE
C       finish of dialogue
        
        IF(BATCH_FILE.GT.0.AND.NKEY.GT.0) THEN
C         write to batch file
          DO I=1,NKEY
            STR=STOR(I)
            CALL LENSTR_BL(STR,NL)
            IF(NL.LE.0) THEN
              NL=1
              STR=' '
            ELSE
              IF(NL.GT.256) NL=256
            ENDIF
            WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
          ENDDO
        ENDIF

        IBATCH = 1
        IEND   = 1
        IWB    = 1
        IWD    = 0

        IF(NL_END.EQ.0) THEN
          STR   = '_END'
          NL    = 4
        ELSE
          STR = '_END'//S_END(1:NL_END)
          NL  = NL_END+4
        ENDIF

      ELSE
C
C       it is possible keyword if string is : 'keyword: <....>'
C         or comment string
C   

        IF(STR(1:1).NE.' ') THEN
          N  = NL
          NK = 0
          IF(NL.GT.12) N = 12
          DO I=1,N
            IF(STR(I:I).EQ.':') THEN
              IF(NK.GT.0.AND.NKEY_TEST.LT.KEY_MAX) THEN
                NKEY_TEST           = NKEY_TEST + 1
                KEY_TEST(NKEY_TEST) = STR(1:NK)
              ENDIF
              GO TO 320 
            ENDIF
            NK=NK+1
          ENDDO
        ENDIF
 320    CONTINUE       

        STR    = '#'//STR(1:NL)
        NL     = NL+1
        IWB    = 1
        IWD    = 1
      ENDIF

      IF(BATCH_FILE.GT.0.AND.IWB.GT.0) THEN
C       write to batch file
        CALL LENSTR_BL(STR,NL)
        IF(NL.LE.0) THEN
          NL  = 1
          STR = '#'
        ELSE
          IF(NL.GT.256) NL = 256
        ENDIF
        WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
      ENDIF

      IF(IWD.GT.0) THEN
        M = 0
        CALL LENSTR_BL(STR,NL)
        IF(NL.LE.0) THEN
          NL  = 1
          STR = ' '
        ELSE
          IF(NL.GT.256) NL = 256
        ENDIF
        CALL MSGDOC(M,STR(1:NL))
      ENDIF
C ---
      RETURN
 10   M = 0
      CALL MSGERR(M,' ERROR: writing to batch file')
C      CALL FINISH
      STOP
 1020 CONTINUE
      CLOSE(IUNIT_KEY) 
      M = 0
      CALL MSGERR(M,' ERROR: reading add_keyword file')
C      CALL FINISH
      STOP
 1030 CONTINUE 
      M = 0
      CALL MSGERR(M,' ERROR: reading input stream')
C      CALL FINISH
      STOP
 1040 CONTINUE 
      M = 0
      CALL MSGERR(M,' ERROR: end of input stream')
C      CALL FINISH
      STOP
      END

C ******
      SUBROUTINE ASK(LINE)
C
C -P- ASK - write key_word (input LINE) and get the default (output LINE).
C
      CHARACTER LINE*(*)
C ******
C ---
      PARAMETER ( KEY_MAX = 100 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      
      INTEGER*4 NL,NLA,NLK
      CHARACTER STR*256,KEYR*12,KEY*12,ANS*256
C ---------------------------------------------------------
      MDOC=0

      CALL LENSTR_BL(LINE,NLK)
      IF(NLK.GT.11) NLK=11
      
C     get keyword from input line
      IF(NLK.GE.1) THEN
        IF(LINE(NLK:NLK).EQ.':') THEN
          LINE(NLK:NLK)=' '
          NLK = NLK-1
        ENDIF
      ENDIF

      IF(NLK.GE.1) THEN
        KEY = '_'//LINE(1:NLK)
        NLK = NLK+1
      ELSE
        KEY = ' '
        NLK = 1
      ENDIF

      CALL CHECK_LINE(1,KEY)
C     now KEY is keyword      
     

      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.254) NL = 254
      IF(NL.LE.0) THEN
        LINE(1:1) = ' '
        NL        = 1
      ENDIF

      NL          = NL + 1
      LINE(NL:NL) = ':'

      IF(IBATCH.EQ.0) THEN
C       display keyword and ask parameters in iteractive mode
        IF(BAT_MODE.EQ.0) CALL DISPL_BL(LINE(1:NL))
      ENDIF
C ---
      IF(NLK.GT.1.AND.IBATCH.GT.0) THEN
C       not iterractive mode
C       search KEY in array of stored kewords STOR_KEY

        DO K=1,KEY_MAX
          IF(FLAG(K).GT.0) THEN
            CALL LENSTR_BL(STOR_KEY(K),NLSK)
            IF(NLSK.EQ.NLK.AND.KEY(1:NLK).EQ.STOR_KEY(K)(1:NLK))THEN
              ANS = STOR(K)
              CALL LENSTR_BL(ANS,NLA)
C             FLAG(K) = 0
              FLAG(K) = -1
              NKEY    = NKEY-1
              GO TO 200
            ENDIF
          ENDIF
        ENDDO

      ENDIF

            
 100  CONTINUE
      IF(IEND.GT.0) THEN
        IT = 2*KEY_MAX 
        IF(IEND.GT.IT) GO TO 20
        ANS(1:12) = ',,,,,,,,,,,,'
        NLA       = 12
        LINE      = ANS(1:NLA)
        IEND      = IEND + 1
        RETURN
      ENDIF

      LINE=' '
      READ(*,'(A)',ERR=10,END=20) LINE
      CALL LENSTR_BL(LINE,NLA)
      IF(NLA.GT.255) NLA = 255
      IF(NLA.LE.0) THEN
        LINE(1:12) = ',,,,,,,,,,,,'
        NLA        = 12
      ENDIF

      ANS=LINE(1:NLA)

      IF(ANS(1:4).EQ.'_END'.OR.ANS(1:4).EQ.'_end') THEN
        IEND = IEND + 1
        GO TO 100
      ENDIF

      IF(BAT_MODE.EQ.1) THEN
        M = 1
        IF(NLA.GT.0) CALL MSGDOC(M,LINE(1:NLA))
      ENDIF

 200  CONTINUE

      IF(ANS(1:1).EQ.'#') THEN
C       write to batch file
        IF(BATCH_FILE.GT.0) THEN
          WRITE(BATCH_FILE,'(A)') ANS(1:NLA)
        ENDIF
        GO TO 100
      ENDIF

      IF(NLK.GT.1.AND.ANS(1:1).EQ.'_') THEN
C       IBATCH = 1
        NLKR   = 0
        IF(NLA.GT.0) THEN
          DO I=1,NLA
            IF(ANS(I:I).NE.' ') THEN
              KEYR(I:I) = ANS(I:I)
              NLKR      = NLKR + 1
            ELSE
              GO TO 300
            ENDIF
          ENDDO
        ENDIF
 300    CONTINUE

C       IF(NLA.GE.NLK) THEN
C       KEYR = ANS(1:NLK)
          CALL CHECK_LINE(1,KEYR)
          IF(KEY(1:NLK).NE.KEYR(1:NLKR)) THEN
            DO K=1,KEY_MAX
              IF(FLAG(K).EQ.0) THEN
                IF(NLA.GT.NLKR) THEN
                  STOR(K)     = KEYR(1:NLKR)//' '//ANS(NLKR+2:NLA)
                  STOR_KEY(K) = KEYR(1:NLKR)
                ELSE
                  STOR(K)     = KEYR(1:NLKR)//'   '
                  STOR_KEY(K) = KEYR(1:NLKR)
                ENDIF
                FLAG(K) = 1
                NKEY    = NKEY + 1
                GO TO 100  
              ENDIF
            ENDDO
            GO TO 100
          ENDIF
C       ENDIF
        N= NLA - (NLKR+1)
        IF(N.LE.0) THEN
          ANS(1:12) = ',,,,,,,,,,'
          N         = 12
        ELSE
          K1       = NLKR+2
          K2       = K1 +N - 1
          ANS(1:N) = ANS(K1:K2)
        ENDIF
        NLA = N
      ENDIF
      
C -----
C     remove first blancs from answer string      
      J   = 0
      IFL = 0
      DO I=1,NLA
        IF(IFL.NE.0.OR.ANS(I:I).NE.' ') THEN
          J        = J+1
          IFL      = 1
          ANS(J:J) = ANS(I:I)
        ENDIF            
      ENDDO
      NLA     = J
      NLA_ANS = NLA
C ---
C     put several symbols ',' in the end of answer string 
      LINE    = ANS(1:NLA)
      IF(NLA.LE.245) THEN
        NLA               = NLA+6
        LINE(NLA+1:NLA+6) = ',,,,,,'
      ENDIF

      IF(BATCH_FILE.GT.0.AND.IEND.EQ.0) THEN
C       write to batch file
        IF(NLK.GT.1) THEN
          WRITE(BATCH_FILE,'(A)',ERR=30)
     *     KEY(1:NLK)//' '//ANS(1:NLA_ANS)
        ELSE
          WRITE(BATCH_FILE,'(A)',ERR=30) ANS(1:NLA_ANS)
        ENDIF
      ENDIF
C ---
      RETURN
C ---------------------------------------------------------
 10   CALL MSGERR(MDOC,' ERROR: read input stream')
      GO TO 1000
 20   CALL MSGERR(MDOC,' ERROR: end of input stream')
      GO TO 1000
 30   CALL MSGERR(MDOC,' ERROR: write to batch file')
 1000 CALL FINISH
      END

C ******
      SUBROUTINE FRD_PARM_KEYWORDS
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_KEYWORDS/ 
     *                  FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*256
      CHARACTER IN_STRING*256
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*256
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS  =0
      NW      =0
      IW      =0
      IS      =0
      IAP     =0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.256) LEN=256
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE START_NEW(IG,MDOC,PROG,PATH_OUT)
C
C -P- START - initialization common/COMLIB/,/CRYSTL/,.., open DOC-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ------
      PARAMETER ( KEY_MAX = 100 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ------
      COMMON/CRYSTL/ A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *              ,A_STAR,B_STAR,C_STAR,COALST,COBEST,COGAST
     *              ,SIALST,SIBEST,SIGAST
     *              ,FRTOCR,CRTOFR,VOLUME
     *              ,PDB_SCALE,PDB_U
     *              ,NSP_GROUP,N_SETT,PDB_MODEL
     *              ,PDB_CODE,PDB_NAME,PDB_DATE
     *              ,PDB_RESL,PDB_RFAC
     *              ,SP_GROUP,USER_TITLE
C -
      REAL      FRTOCR(3,3),CRTOFR(3,3),VOLUME
      REAL      PDB_SCALE(3,3),PDB_U(3) 
      INTEGER*4 NSP_GROUP,N_SETT,PDB_MODEL
      CHARACTER PDB_CODE*4,PDB_NAME*40,PDB_DATE*9 
      CHARACTER PDB_RESL*40,PDB_RFAC*40
      CHARACTER SP_GROUP*24,USER_TITLE*80
C -------
C ------------------------------------------------------------------------
C ------------------------------------------------------------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
C ---
      INCLUDE 'mr_crd_com.fh'
C ---
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      REAL AM(3,3),TRN(3)
      INTEGER NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -------------------------------------------------
C ---
      INTEGER*4  MDOC,IG
      CHARACTER  PROG*(*),PATH_OUT*(*)
C ******
      INTEGER*4  M,IERR
      CHARACTER  LINE*80,PATH*80
C --------------
c     INCLUDE "temp_molrep_path.fh"
C -------------------------------------------
      PI     = 4.0*ATAN(1.0)
      IGRAPH = IG
      IFIRST = 0
C ---
C -----------------------
      CALL SET_BYTE
      IEND      = 0
      IBATCH    = 0
      NKEY      = 0
      NKEY_TEST = 0
      DO I=1,KEY_MAX
        FLAG(I)=0
      ENDDO
C ---
      CALL LENSTR_BL(PROG,LEN_PROG)
      IF(LEN_PROG.LE.0) THEN
        LEN_PROG=1
        PROG(1:1)=' '
      ELSE IF(LEN_PROG.GT.20) THEN
        LEN_PROG=20
      ENDIF
      PROGRAMM=PROG(1:LEN_PROG)
      IF(MDOC.GE.997) THEN
        LINEL  =  PROG(1:LEN_PROG)
C        M      = -ABS(MDOC)
      ENDIF
C -------------------------------
      IF(MDOC.EQ.0) THEN
        M=0
      ELSE IF(MDOC.GE.997) THEN
C       M=999       
        M=MDOC       
      ELSE IF(MDOC.LE.-997) THEN
        M=0
      ELSE IF(MDOC.LT.0) THEN
        M=-48
        IF(MDOC.LE.-99) M=-99
      ELSE IF(MDOC.GT.0) THEN
        M= 48
        IF(MDOC.GE.99) M=99
      ENDIF
      CALL OPENDOC(M,PATH_OUT)

      IF(M.EQ.0) MDOC=0

      MDOC=ABS(MDOC)
      IF(MDOC.GE.997) THEN
        MDOC=1
      ENDIF
C ---
      A_CELL=1.0
      B_CELL=1.0
      C_CELL=1.0
      AL_CELL   = PI/2.0
      BE_CELL   = PI/2.0
      GA_CELL   = PI/2.0
      DO I=1,80
        USER_TITLE(I:I)  = ' '
      ENDDO
      DO I=1,40
        PDB_NAME(I:I)       = ' '
      ENDDO
      PDB_NAME(1:13)  = 'XXXXXXXX    ?'
      PDB_DATE  = 'XX-XXX-XX'
      PDB_CODE  = 'XXXX'
      PDB_RESL  = '.'
      PDB_RFAC  = '.'
      USER_TITLE(1:9)  = '?   ?   ?'
      USER_TITLE(69:78)= '?   ?   '
      NSP_GROUP = 1
      N_SETT   = 1
      SP_GROUP = 'P 1        '
      CR_TITLE    = USER_TITLE
      CR2_TITLE   = USER_TITLE
      CR3_TITLE   = USER_TITLE
      TL_WR       = USER_TITLE
      TL_RD       = USER_TITLE
      CR_NAME_PDB  = PDB_NAME
      CR2_NAME_PDB = PDB_NAME
      CR3_NAME_PDB = PDB_NAME
      PT_WR        = PDB_NAME
      PT_RD        = PDB_NAME
      NCS=0
      CALL SET_NCS(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCS=0
      CALL SET_NCS2(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCS=0
      CALL SET_NCS3(MDOC,NMAX,NCS,AM,TRN,IERR)
      IGR=0
      CALL SET_ASYM3(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      NCSOP    = 0
      N_GROUP  = 0   
      N_CHAIN  = 0
C --- 
      A_WR   = 1.0
      B_WR   = 1.0
      C_WR   = 1.0
      AL_WR  = PI/2.0
      BE_WR  = PI/2.0
      GA_WR  = PI/2.0
      RN_WR  = 0.0
      RX_WR  = 0.0
      CF_WR  = 1.0
      TF_WR  = 0.0
      NX_WR  = 0
      NY_WR  = 0
      NZ_WR  = 0
      IN_WR  = 0
      IM_WR  = 0
      NS_WR  = 1
      IS_WR  = 1
      IER_WR = 0
      IEN_WR = 0
      TP_WR  =' '
      T1_WR  ='?   '
      T2_WR  ='?   '
      NS_WR  = NSP_GROUP
      IS_WR  = N_SETT
      IER_WR = 0
      IEN_WR = 0
      CD_WR  = PDB_CODE
      SG_WR  = SP_GROUP
      PD_WR  = PDB_DATE
C --------------------
C -----------------------------------------------
C ----- PDB --------------------
      CR_TEMPER     = 0.0
      CR_WAVEL      = 0.0
      CR_RES_MIN    = 0.0
      CR_RES_MAX    = 0.0
      CR_RFAC_ALL   = 0.0
      CR_RFAC_OBS   = 0.0
      CR_SIGMA_I    = 0.0
      CR_SIGMA_F    = 0.0
      CR_CD_NDB     = '?'
      CR_CD_CSD     = '?'
      CR_DATE_NDB   = '?'
      CR_DATE_CREAT = '?'
      CR_PROGRAM    = '?'
      CR_METHOD     = '?'
C -----------------------------------------------
C ----- PDB 2 --------------------
      CR_RFAC_CUT     = 0.0
      CR_NMODEL       = 0
      CR_RMEGR_ALL    = 0.0
      CR_RMERG_OBS    = 0.0
      CR_RMERG_IOBS   = 0.0
      CR_RES_RMIN     = 0.0
      CR_RES_RMAX     = 0.0
      CR_SIGMAR_I     = 0.0
      CR_SIGMAR_F     = 0.0
      CR_RFREE_ALL    = 0.0
      CR_RFREE_OBS    = 0.0
      CR_RFREE_CUT    = 0.0
      CR_DPI          = 0.0
      CR_ERR_CRD_MIN  = 0.0
      CR_ERR_CRD_MAX  = 0.0
      CR_NDB_TITLE    = '?'
      CR_NDB_NAME     = '?'
      CR_INFO_FLAG    = '?'
C------------------------------------------
C------------------------------------------
C ---
      CR_CELL(1)=1.0
      CR_CELL(2)=1.0
      CR_CELL(3)=1.0
      CR_CELL(4)=PI/2.0
      CR_CELL(5)=PI/2.0
      CR_CELL(6)=PI/2.0
      CR_SCALE(1,1)=1.0
      CR_SCALE(1,2)=0.0
      CR_SCALE(1,3)=0.0
      CR_SCALE(2,1)=0.0
      CR_SCALE(2,2)=1.0
      CR_SCALE(2,3)=0.0
      CR_SCALE(3,1)=0.0
      CR_SCALE(3,2)=0.0
      CR_SCALE(3,3)=1.0
      CR_U(1)      =0.0
      CR_U(2)      =0.0
      CR_U(3)      =0.0
      CR_CF1 = 0.0
      CR_CF2 = 0.0
      CR_TOV = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_DATE_PDB = PDB_DATE
      CR_CD_PDB   = PDB_CODE
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = ' '
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = SP_GROUP
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG=0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      ='.'
      CR_FSA      ='.'
      CR_SURF     = 0.0
      CR_SEG      = '.'
      CR_LINE     = ' '
      CR_LINE2    = ' '
C -CR2-
C ---
      CR2_CELL(1)=1.0
      CR2_CELL(2)=1.0
      CR2_CELL(3)=1.0
      CR2_CELL(4)=PI/2.0
      CR2_CELL(5)=PI/2.0
      CR2_CELL(6)=PI/2.0
      CR2_SCALE(1,1)=1.0
      CR2_SCALE(1,2)=0.0
      CR2_SCALE(1,3)=0.0
      CR2_SCALE(2,1)=0.0
      CR2_SCALE(2,2)=1.0
      CR2_SCALE(2,3)=0.0
      CR2_SCALE(3,1)=0.0
      CR2_SCALE(3,2)=0.0
      CR2_SCALE(3,3)=1.0
      CR2_U(1)      =0.0
      CR2_U(2)      =0.0
      CR2_U(3)      =0.0
      CR2_CF1 = 0.0
      CR2_CF2 = 0.0
      CR2_TOV = 0.0
      CR2_ORT_TO_FRAC(1,1)=1.0
      CR2_ORT_TO_FRAC(1,2)=0.0
      CR2_ORT_TO_FRAC(1,3)=0.0
      CR2_ORT_TO_FRAC(2,1)=0.0
      CR2_ORT_TO_FRAC(2,2)=1.0
      CR2_ORT_TO_FRAC(2,3)=0.0
      CR2_ORT_TO_FRAC(3,1)=0.0
      CR2_ORT_TO_FRAC(3,2)=0.0
      CR2_ORT_TO_FRAC(3,3)=1.0
      CR2_FRAC_TO_ORT(1,1)=1.0
      CR2_FRAC_TO_ORT(1,2)=0.0
      CR2_FRAC_TO_ORT(1,3)=0.0
      CR2_FRAC_TO_ORT(2,1)=0.0
      CR2_FRAC_TO_ORT(2,2)=1.0
      CR2_FRAC_TO_ORT(2,3)=0.0
      CR2_FRAC_TO_ORT(3,1)=0.0
      CR2_FRAC_TO_ORT(3,2)=0.0
      CR2_FRAC_TO_ORT(3,3)=1.0
      CR2_DATE_PDB = PDB_DATE
      CR2_CD_PDB   = PDB_CODE
      CR2_RFAC_PDB = '.'
      CR2_RESL_PDB = '.'
      CR2_TIME     = ' '
      CR2_FLAG_HA  = 'N'
      CR2_FLAG_USER= 'N'
      CR2_MODEL    = 0
      CR2_NSPGR    = 1
      CR2_SETT     = 1
      CR2_SPGR     = SP_GROUP
      CR2_PDB_REC  ='.'
      CR2_NSYM     = 1
      CR2_NCS      = 0
      CR2_SYMOP    = 'X,Y,Z'
      CR2_IATOM    =0
      CR2_IRES     =0
      CR2_IATOLD   =0
      CR2_IGROUP   =0
      CR2_MULT_FLAG=0
      CR2_MULT_FACTOR=1
      CR2_RTYPE    = '.'
      CR2_ATYPE    = '.'
      CR2_TERM     = '.'
      CR2_RNAME    = '.'
      CR2_ANAME    = '.'
      CR2_CHAIN    = '. '
      CR2_GROUP    = '.   '
      CR2_BTYPE    = 'I'
      CR2_FSC      ='.'
      CR2_FSA      ='.'
      CR2_SURF     = 0.0
      CR2_SEG      = '.'
      CR2_LINE     = ' '
      CR2_LINE2    = ' '
C --------------------------------
C -CR3-
C ---
      CR3_CELL(1)=1.0
      CR3_CELL(2)=1.0
      CR3_CELL(3)=1.0
      CR3_CELL(4)=PI/2.0
      CR3_CELL(5)=PI/2.0
      CR3_CELL(6)=PI/2.0
      CR3_SCALE(1,1)=1.0
      CR3_SCALE(1,2)=0.0
      CR3_SCALE(1,3)=0.0
      CR3_SCALE(2,1)=0.0
      CR3_SCALE(2,2)=1.0
      CR3_SCALE(2,3)=0.0
      CR3_SCALE(3,1)=0.0
      CR3_SCALE(3,2)=0.0
      CR3_SCALE(3,3)=1.0
      CR3_U(1)      =0.0
      CR3_U(2)      =0.0
      CR3_U(3)      =0.0
      CR3_CF1 = 0.0
      CR3_CF2 = 0.0
      CR3_TOV = 0.0
      CR3_ORT_TO_FRAC(1,1)=1.0
      CR3_ORT_TO_FRAC(1,2)=0.0
      CR3_ORT_TO_FRAC(1,3)=0.0
      CR3_ORT_TO_FRAC(2,1)=0.0
      CR3_ORT_TO_FRAC(2,2)=1.0
      CR3_ORT_TO_FRAC(2,3)=0.0
      CR3_ORT_TO_FRAC(3,1)=0.0
      CR3_ORT_TO_FRAC(3,2)=0.0
      CR3_ORT_TO_FRAC(3,3)=1.0
      CR3_FRAC_TO_ORT(1,1)=1.0
      CR3_FRAC_TO_ORT(1,2)=0.0
      CR3_FRAC_TO_ORT(1,3)=0.0
      CR3_FRAC_TO_ORT(2,1)=0.0
      CR3_FRAC_TO_ORT(2,2)=1.0
      CR3_FRAC_TO_ORT(2,3)=0.0
      CR3_FRAC_TO_ORT(3,1)=0.0
      CR3_FRAC_TO_ORT(3,2)=0.0
      CR3_FRAC_TO_ORT(3,3)=1.0
      CR3_DATE_PDB = PDB_DATE
      CR3_CD_PDB   = PDB_CODE
      CR3_RFAC_PDB = '.'
      CR3_RESL_PDB = '.'
      CR3_TIME     = ' '
      CR3_FLAG_HA  = 'N'
      CR3_FLAG_USER= 'N'
      CR3_MODEL    = 0
      CR3_NSPGR    = 1
      CR3_SETT     = 1
      CR3_SPGR     = SP_GROUP
      CR3_PDB_REC  ='.'
      CR3_NSYM     = 1
      CR3_NCS      = 0
      CR3_SYMOP    = 'X,Y,Z'
      CR3_IATOM    =0
      CR3_IRES     =0
      CR3_IATOLD   =0
      CR3_IGROUP   =0
      CR3_MULT_FLAG=0
      CR3_MULT_FACTOR=1
      CR3_RTYPE    = '.'
      CR3_ATYPE    = '.'
      CR3_TERM     = '.'
      CR3_RNAME    = '.'
      CR3_ANAME    = '.'
      CR3_CHAIN    = '. '
      CR3_GROUP    = '.   '
      CR3_BTYPE    = 'I'
      CR3_FSC      ='.'
      CR3_FSA      ='.'
      CR3_SURF     = 0.0
      CR3_SEG      = '.'
      CR3_LINE     = ' '
      CR3_LINE2    = ' '
C --------------------------------
      A_RD   = 1.0
      B_RD   = 1.0
      C_RD   = 1.0
      AL_RD  = PI/2.0
      BE_RD  = PI/2.0
      GA_RD  = PI/2.0
      RN_RD  = 0.0
      RX_RD  = 0.0
      CF_RD  = 1.0
      TF_RD  = 0.0
      NX_RD  = 0
      NY_RD  = 0
      NZ_RD  = 0
      IN_RD  = 0
      IM_RD  = 0
      NS_RD  = 1
      IS_RD  = 1
      IER_RD = 0
      IEN_RD = 0
      TP_RD  =' '
      T1_RD  ='?   '
      T2_RD  ='?   '
      NS_RD  = NSP_GROUP
      IS_RD  = N_SETT
      IER_RD = 0
      IEN_RD = 0
      CD_RD  = PDB_CODE
      SG_RD  = SP_GROUP
      PT_RD  = PDB_NAME
      PD_RD  = PDB_DATE
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
C ================================================================
      CALL WRT_BATCH('# --------------------------------')

c      CALL LENSTR_BL(MOLREPLIB,LEN_P)
c      PATH  = MOLREPLIB
c      PATH  = PATH(1:LEN_P)//'/bin/'
c      LEN_P = LEN_P+5
C      LINE  = PATH(1:LEN_P)//PROGRAMM(1:LEN_PROG)//' <<stop'

      LINE  = PROGRAMM(1:LEN_PROG)//' <<stop'

C
C      LINE='$BLANC/exe/'//PROGRAMM(1:LEN_PROG)//' <<stop'
C
      CALL WRT_BATCH(LINE)
      CALL WRT_BATCH('# --------------------------------')
      CALL WRT_BATCH('# first line :   "_DOC  <N>,Y,A "')
      LINE=
     *'#   N - means without DOC-file: "'//PROGRAMM(1:LEN_PROG)//'.doc"'
      CALL WRT_BATCH(LINE)
      CALL WRT_BATCH(
     *'#   Y - create new file or rewrite if it is old file')
      CALL WRT_BATCH(
     *'#   A - means to keep old contents and add new information')
      CALL WRT_BATCH('#  ')
      CALL WRT_BATCH('_DOC  Y')
      CALL WRT_BATCH('#  ')
C ================================================================
      RETURN
      END          

      SUBROUTINE START(IG,MDOC,PROG,PATH_OUT)
C -------------------------------------------------------
      INTEGER   MDOC,M
      CHARACTER PATH_OUT*(*)
      CHARACTER LINE*256,PROG*(*)
      CHARACTER MSG*1
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ------
      PARAMETER ( KEY_MAX = 100 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ------
C -------------------------------------------------------
      CALL SET_BYTE
      IEND      = 0
      IBATCH    = 0
      NKEY      = 0
      NKEY_TEST = 0
      DO I=1,KEY_MAX
        FLAG(I)=0
      ENDDO

      M    = 0
      MDOC = 0
      PATH_OUT = ' '
      CALL START_NEW(0,MDOC,PROG,PATH_OUT)


      CALL LENSTR_BL(PROG,LP)

      IF(LP.LE.0) THEN
        PROG = 'program'
        CALL LENSTR_BL(PROG,LP)
      ENDIF

      LINE = ' Do you want to have FILE-DOCUMENT /'//
     *         PROG(1:LP)//'.doc/ ? /<N>/Y/A :'
      CALL MSGDOC(M,LINE)
      CALL MSGDOC(M,'   N - means without DOC-file')
      CALL MSGDOC(M,'   Y - with new contents')
      CALL MSGDOC(M,
     *'   A - means to keep old contents and add new information')
      LINE = '       with DOC-file program creates batch file: '//
     *        PROG(1:LP)//'.bat'   
      CALL MSGDOC(M,LINE)

      CALL DISPL_BL('_DOC:')

 1120 CONTINUE
      READ(*,'(A)') LINE
      IF(LINE(1:1).EQ.'#') GO TO 1120

      IBATCH   = 0
      PATH_OUT = ' '
      MSG      = ' '
      LLL      = 0
      IF(LINE(1:4).EQ.'_DOC') THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.6) THEN
          DO I=6,LEN
            IF(LINE(I:I).NE.' ') THEN
              MSG = LINE(I:I)
              LLL = I
              GO TO 10
            ENDIF
          ENDDO
        ENDIF
  10    CONTINUE
        IBATCH = 1
      ELSE
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.0) THEN
          DO I=1,LEN
            IF(LINE(I:I).NE.' ') THEN
              LLL = I
              MSG = LINE(I:I)
              GO TO 20
            ENDIF
          ENDDO
        ENDIF
  20    CONTINUE
      ENDIF

      IF(LLL.GT.0) THEN
        LINE = LINE(LLL:LEN)
        LEN  = LEN - LLL + 1
        IF(LINE(1:1).NE.'>'.AND.LEN.GT.1) THEN
          LINE = LINE(2:LEN)
          LEN  = LEN - 1
        ENDIF
        CALL GET_PATH_OUT(LINE,PATH_OUT)
      ENDIF

      IF(MSG.EQ.'y') MSG = 'Y'
      IF(MSG.EQ.'a') MSG = 'A'
      IF(MSG.NE.'Y'.AND.MSG.NE.'A'.AND.MSG.NE.'#') MSG='N'

      IF(MSG.NE.'N'.OR.MSG.EQ.'#') THEN
        IF(MSG.EQ.'Y') MDOC = 999
        IF(MSG.EQ.'A') MDOC = 998
        IF(MSG.EQ.'#') MDOC = 997
        CALL START_NEW(0,MDOC,PROG,PATH_OUT)
      ELSE
        MDOC=0
      ENDIF
      IF(IBATCH.EQ.1) CALL SET_BATCH(IBATCH)
      CALL MSGDOC(M,' ')

      RETURN
      END          

C ******
      SUBROUTINE OPENDOC(MMDOC,PATH_OUT)
C
C -P- OPENDOC   open file-document iunit=DOC_FILE  =48
C                and file-inbatch  iunit=BATCH_FILE=47
C 
C     input :    MMDOC > 0  open, get name from terminal 
C                MMDOC < 0  open, get name from /COMLIB/..,LINEL,..  
C     output:    MMDOC , =0 don't open
C
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4  MMDOC,MDOC
C ******
      CHARACTER  PATH_OUT*(*)
      CHARACTER  NAME1*256,MSG*1,MSG4*1,FNAME*256,CH1*1,TYPE*1
      CHARACTER  NAMEB*256,NAME*256,PATH*1,EXT*1
      CHARACTER  LINE*256

CMS   LOGICAL*2  EXI

      LOGICAL    EXI
C ---------------------------------------------------------------------
      M          = 99
      IERR       = 0
      PATH       = ' '
      EXT        = ' '
C ---
      DOC_FILE   = 0
      BATCH_FILE = 0
      BAT_MODE   = 0
  10  CONTINUE
      MDOC = MMDOC      
      IF(MDOC.GE.997) THEN
        NAME1 = LINEL
        IF(MDOC.EQ.997) NAME1='#'
      ELSE
        IF(MDOC.EQ.0.OR.ABS(MDOC).GE.99) RETURN
        DOC_FILE=ABS(MDOC)
        NAME1=' '
        IF(MDOC.GT.0) THEN
          WRITE(*,*) 
          CALL DISPL_BL(
     *    'FILE-DOCUMENT / tape name or CR / :')
          READ(*,'(A)')  NAME1
        ELSE
          NAME1=LINEL
        ENDIF
      ENDIF
  11  CH1=NAME1(1:1)

      CALL LENSTR_BL(NAME1,LEN)

      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        NAME1(1:1)=' '
      ENDIF
      CALL LENSTR_BL(NAME1,LEN)
      IF(NAME1(1:1).EQ.'#') THEN
        IF(MDOC.GT.0) THEN
          READ(*,'(A)')  NAME1
          GO TO 11           
        ELSE
          DOC_FILE   = 0
          MDOC       = 0
          BATCH_FILE = 0
          MMDOC      = MDOC
          RETURN
        ENDIF
      ENDIF

      IF(NAME1(1:1).EQ.'_') THEN
        IF(NAME1(1:4).EQ.'_DOC') THEN
C
C         IBATCH  =1
C
          BAT_MODE=1
          CALL LENSTR_BL(NAME1,LEN)

          LLL = 0
          IF(LEN.GE.6) THEN
            J   =0
            LINE=' '
            DO I=6,LEN
              IF(NAME1(I:I).NE.' ') THEN
                LLL = I
                GO TO 40
              ENDIF
            ENDDO
  40        CONTINUE
            IF(LLL.GT.0) THEN
              NAME1 = NAME1(LLL:LEN)
              LEN   = LEN - LLL + 1
              LINE  = NAME1
              IF(LINE(1:1).NE.'>'.AND.LEN.GT.1) THEN
                LINE = LINE(2:LEN)
                LEN  = LEN - 1
              ENDIF
              CALL GET_PATH_OUT(LINE,PATH_OUT)
            ELSE
              NAME1(1:1) = ' '
            ENDIF

            IF(MDOC.EQ.997) THEN
            IF(NAME1(1:1).EQ.'N'.OR.NAME1(1:1).EQ.'n') THEN
              MMDOC=0
              RETURN
            ELSE IF(NAME1(1:1).EQ.'Y'.OR.NAME1(1:1).EQ.'y') THEN
              MDOC =999
              MMDOC=999
              NAME1=PROGRAMM
            ELSE IF(NAME1(1:1).EQ.'A'.OR.NAME1(1:1).EQ.'a') THEN
              MDOC =998
              MMDOC=998
              NAME1=PROGRAMM
            ENDIF
            ENDIF
          ELSE
            NAME1=' '
          ENDIF
        ENDIF
      ENDIF

      IF(NAME1(1:1).NE.' ') THEN
C --
        CALL LENSTR_BL(NAME1,LEN)
        IF(LEN.GT.0.AND.NAME1(1:1).NE.','.AND.NAME1(1:1).NE.' ') THEN
          NAME=NAME1(1:LEN)
          DO I=LEN,1,-1
            IF(NAME(I:I).EQ.',') THEN
              NAME(I:I)=' '
            ELSE
              IF(NAME(I:I).NE.' ') GO TO 800
            ENDIF 
          ENDDO
 800      CONTINUE
          LINE = NAME
          CALL LENSTR_BL(LINE,LEN)
          IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.doc') THEN
            NAME1=LINE(1:LEN-4)
          ENDIF
        ENDIF
C -------

        CALL LENSTR_BL(NAME1,NL)

        FNAME=NAME1(1:NL)//'.doc'
        CALL ADD_PATH(PATH_OUT,FNAME)
        NAMEB=NAME1(1:NL)//'.bat'
        CALL ADD_PATH(PATH_OUT,NAMEB)

        IF(MDOC.GT.0) THEN   

        INQUIRE(FILE=FNAME,EXIST=EXI)
        IF(EXI) THEN
          DOC_FILE=48

C          OPEN(UNIT=DOC_FILE,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='OLD',FORM='FORMATTED') 

          CALL OPENFW(DOC_FILE,M,PATH,FNAME,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

 50       CONTINUE
          IF(MMDOC.GE.998) THEN
C do not keep old contents : LINE(1:1)='N'
            LINE(1:1)='N'
            IF(MMDOC.EQ.998) LINE(1:1)='Y'
          ELSE
            CALL DISPL_BL(
     *      'Do you want to keep old contents (<Y>,N) ? :')
            READ(*,'(A)') LINE
          ENDIF
          IF(LINE(1:1).EQ.'_') THEN
            IF(LINE(1:5).EQ.'_KEEP') THEN
              CALL LENSTR_BL(LINE,LEN)
              IF(LEN.GE.7) THEN
                J=0
                DO I=7,LEN
                 IF(LINE(I:I).NE.' ') THEN
                   J=J+1
                   LINE(J:J)=LINE(I:I)
                   GO TO 100 
                 ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
 100      CONTINUE
          MSG=LINE(1:1)
          IF(MSG.EQ.'#') GO TO 50
          IF(MSG.EQ.'n') MSG='N'
          IF(MSG.EQ.'N') THEN
            REWIND DOC_FILE
          ELSE
C            DO   I=1,32767
            DO   I=1,1000000
              READ(DOC_FILE,'(A)',END=45) LINE
            ENDDO
   45       CONTINUE             
            BACKSPACE DOC_FILE
          ENDIF 
        ELSE
   30     CONTINUE
          IF(MDOC.GE.998) THEN
            LINE(1:1)='Y'
          ELSE
            CALL DISPL_BL(
     *'Do you really want to have DOC-file (<Y>,N) ?:')
            READ(*,'(A)') LINE
          ENDIF
          IF(LINE(1:1).EQ.'_') THEN
            IF(LINE(1:5).EQ.'_KEEP') THEN
              CALL LENSTR_BL(LINE,LEN)
              IF(LEN.GE.7) THEN
                J=0
                DO I=7,LEN
                 IF(LINE(I:I).NE.' ') THEN
                   J=J+1
                   LINE(J:J)=LINE(I:I)
                   GO TO 101 
                 ENDIF
                ENDDO
              ENDIF
            ENDIF
          ENDIF
 101      CONTINUE
          MSG4=LINE(1:1)
          IF(MSG4.EQ.'#') GO TO 30
          IF(MSG4.EQ.'n') MSG4='N'
          IF(MSG4.NE.'N') THEN
            DOC_FILE=48

C            OPEN(UNIT=DOC_FILE,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=20,
C     *          STATUS='UNKNOWN',FORM='FORMATTED')           

            CALL OPENFW(DOC_FILE,M,PATH,FNAME,EXT,IERR)
            IF(IERR.NE.0) GO TO 20

          ELSE 
            DOC_FILE   = 0
            MDOC       = 0
            BATCH_FILE = 0
          ENDIF 
        ENDIF

        ENDIF

      ELSE
        DOC_FILE   = 0
        MDOC       = 0
        BATCH_FILE = 0
      ENDIF

c     IF(DOC_FILE.NE.0.AND.MMDOC.NE.999) THEN

      IF(DOC_FILE.NE.0) THEN
        BATCH_FILE=47
        INQUIRE(FILE=NAMEB,EXIST=EXI)
        IF(EXI) THEN

C          OPEN(UNIT=BATCH_FILE,FILE=NAMEB,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='OLD',FORM='FORMATTED')           

          CALL OPENFW(BATCH_FILE,M,PATH,NAMEB,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

          IF(MSG.EQ.'N') THEN
            REWIND BATCH_FILE
          ELSE  
            DO   I=1,32767
              READ(BATCH_FILE,'(A)',END=46) LINE
            ENDDO
   46       CONTINUE             
            BACKSPACE BATCH_FILE
          ENDIF
        ELSE

C          OPEN(UNIT=BATCH_FILE,FILE=NAMEB,ACCESS='SEQUENTIAL',ERR=20,
C     *         STATUS='UNKNOWN',FORM='FORMATTED')           

          CALL OPENFW(BATCH_FILE,M,PATH,NAMEB,EXT,IERR)
          IF(IERR.NE.0) GO TO 20

        ENDIF 
      ENDIF
      WRITE(*,*)
      MDOC  = ABS(MDOC)
      MMDOC = MDOC
      RETURN

   20 WRITE(*,*) ' ERROR: OPEN DOC_FILE or BATCH_FILE'
      IF(MMDOC.LT.997) GO TO 10
      RETURN
      END

C ******
      SUBROUTINE OPENFR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFR - open formatted file for read /with extention and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF

      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)
   


      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IN,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='OLD')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' INPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENUR(IN,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENUR - open unformatted file for read /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IN,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)
   

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IN,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='UNFORMATTED',STATUS='OLD')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' INPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR READ/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENFW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open formatted file for write /with extentiom and path/
C
C       input:
C               IOUT   - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C                       ( example of PATH='blanc/temp/' )
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IOUT,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='FORMATTED',STATUS='UNKNOWN')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' OUTPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR WRITE/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE OPENUW(IOUT,MDOC,PATH,FNAME,EXT,IERR)
C
C -P- OPENFW - open unformatted file for write /with extentiom and path/
C
C       input:
C               IN    - unit
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C               PATH  - path      / may be = '    ' /
C               FNAME - file name
C               EXT   - extention / may be = '    ' /
C
C        output:
C               IERR = 0 - OK
C                    > 0 - error.
C
      INTEGER*4 IOUT,MDOC,IERR
      CHARACTER PATH*(*),FNAME*(*),EXT*(*)
C ******
      INTEGER*4 NLE,NLN,NLP,NL
      CHARACTER FILE*256,FILE1*256,LINE*256
      CHARACTER CH1*1,TYPE*1
C -------------------------------------------------------------
      IERR=0

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TYPE)
      IF(TYPE.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF


      IF(NLN.GT.1) THEN
        DO I=2,NLN
          IF(FNAME(I:I).EQ.',') FNAME(I:I)=' '
        ENDDO
      ENDIF
      IF(NLP.GT.1) THEN
        DO I=2,NLP
          IF(PATH(I:I).EQ.',') PATH(I:I)=' '
        ENDDO
      ENDIF
      IF(NLE.GT.1) THEN
        DO I=2,NLE
          IF(EXT(I:I).EQ.',') EXT(I:I)=' '
        ENDDO
      ENDIF

      CALL LENSTR_BL(EXT,NLE)
      CALL LENSTR_BL(PATH,NLP)
      CALL LENSTR_BL(FNAME,NLN)

      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) GO TO 9100

      IF(NLE.GT.0) THEN
        FILE1=FNAME(1:NLN)//'.'//EXT(1:NLE)
      ELSE
        FILE1=FNAME(1:NLN)
      ENDIF     
      CALL LENSTR_BL(FILE1,NL)
      IF(NLP.GT.0) THEN
        FILE=PATH(1:NLP)//FILE1(1:NL)
      ELSE
        FILE=FILE1(1:NL)
      ENDIF     
      CALL LENSTR_BL(FILE,NL)

      OPEN(IOUT,FILE=FILE(1:NL),ACCESS='SEQUENTIAL',ERR=9100,
     *  FORM='UNFORMATTED',STATUS='UNKNOWN')

      IF(NL.GT.65) NL=65
      WRITE(LINE,10) FILE(1:NL)
 10   FORMAT(' OUTPUT FILE :',A,';')
      CALL MSGDOC(MDOC,LINE)
      RETURN
C ----
9100  CONTINUE
      IF(NLE.GT.65) NLE=65
      IF(NLP.GT.65) NLP=65
      IF(NLN.GT.65) NLN=65
      CALL MSGERR(MDOC,' ERR: OPEN FILE /FOR WRITE/ ')
      IF(NLP.GT.0) THEN
        WRITE(LINE,20) PATH(1:NLP)
 20     FORMAT('        PATH :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLN.GT.0) THEN
        WRITE(LINE,30) FNAME(1:NLN)
 30     FORMAT('        NAME :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IF(NLE.GT.0) THEN
        WRITE(LINE,40) EXT(1:NLE)
 40     FORMAT('   EXTENTION :',A,';')
        CALL MSGERR(MDOC,LINE)
      ENDIF
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE RD_INF(MDOC,NAME,RLATT,NSYM,ISYM,IPRSYM,IERR)
C
C -P- RD_INF - read information from inform-file ( UNIT=49)
C -P-          and put into common/CRYSTL/
C
C   input  : MDOC  =    0 - write messages only to termimal
C                > 0, < 99  write messages to termimal and to file-document
C                > = 99     don't write any messages 
C                < 0        write messages only to file-document
C
C            NSYM  >= 0  -  input name of inf_file from terminal.
C                 else if  < 0     get from common/COMLIB/...LINEL...      
C
C
C   output : RLATT - unit cell parameters
C            NSYM  - symmetry operators number
C                  = 0 is a signal of error. 
C            ISYM  - symmetry operators
C
C ******
C -----------------------------------------------------------
      CHARACTER NAME*(*)
      INTEGER   MDOC,NSYM,IPRSYM,IERR
      INTEGER*2 ISYM(5,3,IPRSYM)
      REAL      RLATT(6)
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
      REAL      FDATA
      INTEGER*4 IDATA
      CHARACTER DATA*80,ITEM*80
C ---
      CHARACTER   TITLE*80,LINE*256,FNAME*256
      CHARACTER   PATH*1,EXT*3,SGNAME*24
      CHARACTER   CODE_PDB*4,DATE_PDB*9,NAME_PDB*40
C ---
      REAL AMR(3,3),TR(3)
C------------------------------------------------
      IERR=0
      PI   =4.0*ATAN(1.0)
      TWOPI=2.0*PI
      PI180=PI/180.0
C------------------------------
      IS=0
      SGNAME=' '
      NSG=0
      NSETT=0
      ACELL=0.0
      BCELL=0.0
      CCELL=0.0
      ALCELL=0.0
      BECELL=0.0
      GACELL=0.0
      CODE_PDB='XXXX'
      DATE_PDB='XX-XXX-XX'
      NAME_PDB='---'
      TITLE   ='---'
C-------------------------------------
      MTIN=49
      M=99
      PATH=' '
C --
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.0.AND.NAME(1:1).NE.','.AND.NAME(1:1).NE.' ') THEN
        FNAME=NAME(1:LEN)
        DO I=LEN,1,-1
          IF(FNAME(I:I).EQ.',') THEN
            FNAME(I:I)=' '
          ELSE
            IF(FNAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        LINE = FNAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.inf') THEN
          FNAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        FNAME=NAME
      ENDIF
C -------
      EXT='inf'
      CALL OPENFR(MTIN,M,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: can''t open input INF_file')
        RETURN
      ENDIF
      MD=-1
      WRITE(LINE,'('' INPUT-INF_FILE :'',A32)') NAME
      CALL MSGDOC(MD,LINE)
      IEND=-1
 100  CONTINUE
      CALL GETCIF(MTIN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        CLOSE(MTIN)
        RETURN
      ENDIF
      IF(IEND.NE.0) THEN
        GO TO 200
      ENDIF

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.         
     *     (ITEM(1:9).EQ.'_entry.id')) THEN         
          LN=LEND
          IF(LN.GT.4) LN=4
          CODE_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          LN=LEND
          IF(LN.GT.40) LN=40
          NAME_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          DATE_PDB=DATA(1:LEND)
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          TITLE=DATA(1:LEND)
          LN=LEND
          IF(LN.GT.40) LN=40
          NAME_PDB=DATA(1:LN)
        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         

          IF(ITEM(7:14).EQ.'length_a') THEN         
            ACELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN         
            BCELL=FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN         
            CCELL=FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN     
            ALCELL=FDATA
            ALCELL=ALCELL*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN         
            BECELL=FDATA
            BECELL=BECELL*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            GACELL=FDATA
            GACELL=GACELL*PI180
          ENDIF

        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN

          IF     (ITEM(11:21).EQ.'space_group') THEN         
            SGNAME=DATA
          ELSE IF(ITEM(11:21).EQ.'Int_Tables_') THEN         
            NSG=IDATA
          ELSE IF(ITEM(11:21).EQ.'cell_settin') THEN         
            NSETT=IDATA
          ELSE IF(ITEM(11:21).EQ.'equiv_pos_a') THEN     

          ENDIF
C --
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN

          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA=FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF

          IF(I.EQ.N_CIF) THEN     
            IS=IS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS(MDOC,NCMAX,IS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF

        ELSE IF(ITEM(1:5).EQ.'_stop') THEN
          CLOSE(MTIN)
          GO TO 200
        ENDIF
      ENDDO
      GO TO 100
 200  CONTINUE
      RLATT(1)=ACELL
      RLATT(2)=BCELL
      RLATT(3)=CCELL
      RLATT(4)=ALCELL
      RLATT(5)=BECELL
      RLATT(6)=GACELL
      IF(NSG.LT.1.OR.NSG.GT.230) NSG=1
      IF(NSETT.LT.1.OR.NSETT.GT.9) NSETT=1
      IF(ACELL.LE.0.5.OR.BCELL.LE.0.5.OR.CCELL.LE.0.5.OR.
     *     ALCELL.LE.0.001.OR.BECELL.LE.0.001.OR.GACELL.LE.0.001) 
     *THEN
        CALL MSGERR(MDOC,' ERR: there is not CELL parameters')
        IERR=3
        RETURN
      ENDIF
      IF(SGNAME(1:1).EQ.' '.AND.NSG.EQ.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERR: there is not a symmetry information')
        IERR=3
        RETURN
      ENDIF

      CALL GET_SYMM(MDOC,NSG,NSETT,SGNAME,NSYM,ISYM
     *                                            ,IPRSYM,IERR)
      IF(IERR.GT.0) RETURN
      IERR=0
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.LE.0) THEN
        LINE=CODE_PDB//'    '// '---'
        LEN=10
      ELSE
        IF(LEN.GT.60) LEN=60
        LINE=TITLE(1:LEN)             
      ENDIF
      CALL SET_CELL(RLATT,CODE_PDB,NAME_PDB,DATE_PDB,LINE,NSG
     *        ,NSETT,SGNAME,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRONG TITLE')
        RETURN
      ENDIF
C --------------------------------------------------
      RETURN
      END

C ******
      SUBROUTINE INFORM(MDOC,RLATT,NSYM,ISYM,NSMAX)
C
C -P- INFORM - read information from inform-file (old format)( UNIT=49)
C -P-          and put into common/CRYSTL/
C
C   input  : MDOC  =    0 - write messages only to termimal
C                > 0, < 99  write messages to termimal and to file-document
C                > = 99     don't write any messages 
C                < 0        write messages only to file-document
C
C            NSYM  >= 0  -  input name of inf_file from terminal.
C                 else if  < 0     get from common/COMLIB/...LINEL...      
C
C
C   output : RLATT - unit cell parameters
C            NSYM  - symmetry operators number
C                  = 0 is a signal of error. 
C            ISYM  - symmetry operators
C
C                for j-symmetry operators:
C
C             Xnew   ! ISYM(1,1,j) ISYM(2,1,j) ISYM(3,1,j)! X   T(1)
C             Ynew = ! ISYM(1,2,j) ISYM(2,2,j) ISYM(3,2,j)! Y + T(2)
C             Znew   ! ISYM(1,3,j) ISYM(2,3,j) ISYM(3,3,j)! Z   T(3)
C
C             T(i)  / translation vector / = ISYM(4,i,j)/ISYM(5,i,j)
C
C -------------------------------------------------------------------------
C      PARAMETER (NABSMAX=10)
C      COMMON/COMABS/ NABS,JABS
C      INTEGER   NABS
C      INTEGER*2 JABS(13,NABSMAX)
C
C            NABS  - condition of absence number
C            JABS  - conditions of absences
C                    type indices:
C               h**2*JABS(1) + k**2*JABS(2) + l**2*JABS(3) +
C            + (h*JABS(4) + k*ABS(5) + l*JABS(6))**2 + JABS(7)=0
C                    condition   :
C MOD [ h*JABS(8) + k*ABS(9) + l*JABS(10) + JABS(11) , JABS(12) ] = JABS(13)
C
C -------------------------------------------------------------------------
C                 NON-CRYSTALLOGRAFICAL SYMMETRY :
C
C      PARAMETER (NCSMAX=7)
C      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C 
C           NCSOP - NUMBER OF OPERATORS OF NON-CRYST.SYMMETRY / MAX=7/
C
C        
C  X-NEW               X-0      TRNCS(1)                 ! 1,1  2,1  3,1 ! 
C  Y-NEW  = [AMNCS] *  Y-0  +   TRNCS(2)       [AMNCS] = ! 1,2  2,2  3,2 !
C  Z-NEW               Z-0      TRNCS(3)                 ! 1,3  2,3  3,3 !
C        
C                     ORTOGONAL COORDINATE SYSTEM
C                       COORDINATES IN ANGSTROMS
C       
C ----------------------------------------------------------------------------
C inform-file example :
C ----------------------------------------------------------------------------
C
C           1         2         3         4         5         6 
C ----------------------------------------------------------------------------
C !# <--- it means a comment
C !TITLE    :<------   PDB_NAME -------------------->12-FEB-92   CODE 
C !TITLE    :<--------- USER_TITLE----------------- >
C !CELL:         A =144.1  B=   144.1 C=  178.9  AL=90.  BE=  90. GA= 120.
C !SP.GROUP: No, Sett :  152  1 '<- SP.GR ->'
C !NO EQUIV. POSITIONS:5
C !SYM1:  X, Y  , Z,
C !SYM2: -X+1/2, -2Y    , Z+1/2  
C !SYM3:  X + 1/3,-Y+1/2,-Z-1/3 
C !SYM3:  X - 1/2, 0 ,-2.0 Z  ,     
C !SYM4: -X+2Y-2/3, Y+1/2,-Z+1/2                                              
C !NO COND. OF ABSENCE:               7 
C !ABS1:    H,K,L : L=2N-1    
C !ABS2: 0 ,K,L : K=2N+1                                                      
C !# <--- it means a comment
C !ABS3:    0,K ,0: K=2N                                                      
C !ABS4:    H,2H,0  :H+K=4N                                                   
C !ABS5:    H,H,L: -2H + K =4N-1                                              
C !ABS6:   0,K,L:   H + K+L=6N-5                                              
C !ABS7:  H,K, 0 :  - H + K+L=6N-5                                            
C !# <--- it means a comment
C !NO NONCRYST.SYMM OP:              1
C !NCS1:  ALPHA= 30.0 BETA= 60.0 GAMMA=10.0 TX= 20.0 TY=30. TZ=2.5            
C !END                                                                        
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM
      INTEGER*2 ISYM(5,3,NSMAX)
      REAL      RLATT(6)
C ----
      PARAMETER (NABSMAX=10)
      COMMON/COMABS/ NABS,JABS
      INTEGER   NABS
      INTEGER*2 JABS(13,NABSMAX)
C ------
      INCLUDE 'mr_cryst_com.fh'
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*40,DATE*9,SPGR*24
      CHARACTER TITLE*80,MSG*1
      CHARACTER LINE*80,FNAME*80,PATH*1,EXT*3
C -------------------------------------------------------------------
      MSG='Y'
      CALL CLEAR_STR(TITLE)      
      CALL CLEAR_STR(NAME)      
      IF(NSYM.LT.0) THEN
        MSG='N'
        NSYM=0
C       IF(MDOC.GE.0.AND.MDOC.LT.99) THEN
C         LINE=
C    * ' ERR: TRYING READ INF-FILE-NAME FROM TERMINAL AND MDOC >= 0'
C         CALL MSGERR(MDOC,LINE)
C         NSYM=0
C         RETURN 
C       ENDIF
      ENDIF
      PI=4.0*ATAN(1.0)
 1010 CONTINUE
      IERR=0
      IF(MSG.EQ.'Y') THEN
        CALL DISPL_BL('INFORM FILE  /.INF/     :')
        READ(*,'(A)') FNAME
      ELSE
        FNAME=LINEL
      ENDIF
C ---
C     MTINFR = INF_FILE
      MTINFR=49
C ---
      CALL LENSTR_BL(FNAME,NL)
      IF(NL.LE.0.OR.FNAME(1:1).EQ.' ') THEN
        LINE=' ERR: EMPTY FILE-NAME /INF/'
        CALL MSGERR(MDOC,LINE)
        IF(MSG.EQ.'Y') GO TO 1010
        NSYM=0
        RETURN
      ENDIF

      PATH=' '
      EXT='inf'
      CALL OPENFR(MTINFR,MDOC,PATH,FNAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 1000

      CALL MSGDOC(MDOC,'INFORM FILE :')
C --------------------------------
C -- TITLE,CELL,SP.GR,NO EQ ---
      DO     I=1,5
  200   READ(MTINFR,'(A80)') LINE
        IF(LINE(1:1).EQ.'#') GO TO 200
        IF(I.EQ.1) THEN
          IF(LINE(1:5).NE.'TITLE') THEN
            CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE')
            CLOSE (UNIT=MTINFR)
            IF(MSG.EQ.'Y') GO TO 1010
            NSYM=0
            RETURN 
          ENDIF
          NAME=LINE(11:50)
          DATE=LINE(51:59)
          CODE=LINE(63:66)
        ENDIF
        IF(I.EQ.2) THEN
          IF(LINE(1:5).NE.'TITLE') THEN
            CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE')
            CLOSE (UNIT=MTINFR)
            IF(MSG.EQ.'Y') GO TO 1010
            NSYM=0
            RETURN 
          ENDIF
          TITLE=LINE(11:50)
C         SPGR=LINE(51:61)
        ENDIF
        IF(I.EQ.3) THEN
          IF(LINE(1:4).NE.'CELL') THEN
            CALL MSGERR(MDOC,' ERR: NOT FOUND "CELL"-STRING')
            CLOSE(UNIT=MTINFR)
            NSYM=0
            RETURN 
          ENDIF
          CALL FREDA(LINE,6,80,0,KN,KL,FN,FL)
          IF(KN.NE.6) THEN
            CALL MSGERR(MDOC,' ERR: WRONG "CELL"-STRING')
            CLOSE(UNIT=MTINFR)
            NSYM=0
            RETURN 
          ENDIF
          RLATT(1)=FN(1)
          RLATT(2)=FN(2)
          RLATT(3)=FN(3)
          RLATT(4)=FN(4)
          RLATT(5)=FN(5)
          RLATT(6)=FN(6)
        ENDIF
        IF(I.EQ.4) THEN
          IF(LINE(1:4).NE.'SP.G') THEN
            CALL MSGERR(MDOC,' ERR: NOT FOUND "SP.GROUP"-STRING')
            CLOSE(UNIT=MTINFR)
            NSYM=0
            RETURN 
          ENDIF
          IN_STRING = LINE
          CALL FRD_PARM
          NSPGROUP= IWORDS(2)
          NOSETT  = IWORDS(3)
          IF(NSPGROUP.GT.230.OR.NSPGROUP.LE.0) THEN
            CALL MSGERR(MDOC,
     *      ' ERR: SPACE GROUP NUMBER IS WRONG')
            CLOSE(UNIT=MTINFR)
            NSYM=0
            RETURN 
          ENDIF
          IF(NOSETT.LE.0) NOSETT=1
c         IF(NOSETT.GE.3) NOSETT=2
          LEN=LEN_WORDS(4)
          IF(LEN.GT.0) THEN
            SPGR=WORDS(4)(1:LEN)
            IF(LEN.LT.11) THEN
              DO II=LEN+1,11
                SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE
            SPGR='?          '
          ENDIF
        ENDIF
        CALL MSGDOC(MDOC,LINE(1:79))
      ENDDO
      RLATT(4)=(RLATT(4)*PI)/180.
      RLATT(5)=(RLATT(5)*PI)/180.
      RLATT(6)=(RLATT(6)*PI)/180.

      IF(LINE(1:4).NE.'NO E') THEN
        CALL MSGERR(MDOC,' ERR: NOT FOUND "NSYM"-STRING')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
      CALL FREDA(LINE,21,80,0,KN,KL,FN,FL)
      NSYM=FN(1)+0.01
      IF(NSYM.GT.NSMAX.OR.NSYM.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: NUMBER OPERATORS OF SYMMETRY > LIMIT')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
  210   READ(MTINFR,'(A80)') LINE
        IF(LINE(1:1).EQ.'#') GO TO 210
        CALL MSGDOC(MDOC,LINE(1:79))
        IF(LINE(1:3).NE.'SYM') THEN
          CALL MSGERR(MDOC,' ERR: NOT FOUND "SYM "-STRING')
          CLOSE(UNIT=MTINFR)
          NSYM=0
          RETURN 
        ENDIF
        NS=I
        CALL SYMFR2_BL(MDOC,LINE,NS,NSYMR,ISYM,NSMAX,IERR)
      ENDDO
      IF(NSYMR.NE.NSYM) THEN
        CALL MSGERR(MDOC,' ERR: WRONG NUMBER OF "SYM "-STRING')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
C -----------------------------------------
C --- NABS ---
  220 READ(MTINFR,'(A80)') LINE
      IF(LINE(1:1).EQ.'#') GO TO 220
      IF(LINE(1:4).NE.'NO C') THEN
        CALL MSGERR(MDOC,' ERR: NOT FOUND "NABS"-STRING')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
      CALL FREDA(LINE,21,80,0,KN,KL,FN,FL)
      NABS=FN(1)+0.01
C --- ABS ---
      IF(NABS.GT.0) THEN
        CALL MSGDOC(MDOC,LINE(1:79))
        IF(NABS.GT.NABSMAX) THEN
          CALL MSGERR(MDOC
     .    ,' ERR: NUMBER OF CONDITIONS OF ABSENCE > LIMIT')
          CLOSE(UNIT=MTINFR)
          NSYM=0
          RETURN 
        ENDIF
        DO     I=1,NABS
  230     READ(MTINFR,'(A80)') LINE
          IF(LINE(1:1).EQ.'#') GO TO 230
          CALL MSGDOC(MDOC,LINE(1:79))
          NA=I
          CALL ABSFR2(MDOC,LINE,NA,NABSR,JABS,NABSMAX,IERR)
        ENDDO
        IF(NABSR.NE.NABS) THEN
          CALL MSGERR(MDOC,' ERR: WRONG NUMBER OF "ABS "-STRING')
          CLOSE(UNIT=MTINFR)
          NSYM=0
          RETURN 
        ENDIF
      ENDIF
C -----------------------------------------
C --- NCSOP ---
  240 READ(MTINFR,'(A80)') LINE
      IF(LINE(1:1).EQ.'#') GO TO 240
      IF(LINE(1:3).EQ.'END') GO TO 100
      IF(LINE(1:4).NE.'NO N') THEN
        CALL MSGERR(MDOC,' ERR: NOT FOUND "NCS"-STRING')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
      CALL FREDA(LINE,21,80,0,KN,KL,FN,FL)
      NCSOP=FN(1)+0.01
      IF(NCSOP.GT.NCSMAX.OR.NCSOP.LE.0) THEN
        CALL MSGERR(MDOC
     .     ,' ERR: NUMBER OPERATORS OF NC-SYMMETRY IS WRONG')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
C ----------------------------------------
C --- NCS ---
      DO     I=1,NCSOP
  250   READ(MTINFR,'(A80)') LINE
        IF(LINE(1:1).EQ.'#') GO TO 250
        CALL MSGDOC(MDOC,LINE(1:79))
        IF(LINE(1:3).NE.'NCS') THEN
          CALL MSGERR(MDOC,' ERR: NOT FOUND "NCS"-STRING')
          CLOSE(UNIT=MTINFR)
          NSYM=0
          RETURN 
        ENDIF
        NCS=I
        CALL FREDA(LINE,5,80,0,KN,KL,FN,FL)
        IF(KN.NE.6) THEN
          CALL MSGERR(MDOC,' ERR: WRONG "NCS"-STRING')
          CLOSE(UNIT=MTINFR)
          NSYM=0
          RETURN 
        ENDIF
        ALPHA=(FN(1)*PI)/180.0
        BETA =(FN(2)*PI)/180.0
        GAMMA=(FN(3)*PI)/180.0
        TRNCS(1,NCS)=FN(4)
        TRNCS(2,NCS)=FN(5)
        TRNCS(3,NCS)=FN(6)
        CALL EULERM(ALPHA,BETA,GAMMA,AM)
        DO     L1=1,3
        DO     L2=1,3
          AMNCS(L1,L2,NCS)=AM(L1,L2)      
        ENDDO
        ENDDO
      ENDDO
      IF(NCS.NE.NCSOP) THEN
        CALL MSGERR(MDOC,' ERR: WRONG NUMBER OF "NCS"-STRING')
        CLOSE(UNIT=MTINFR)
        NSYM=0
        RETURN 
      ENDIF
C --------------------------
  100 CLOSE(UNIT=MTINFR)
      CALL SET_CELL(RLATT,CODE,NAME,DATE,TITLE,NSPGROUP
     *        ,NOSETT,SPGR,IERR)
      CALL C_CR_WR
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
      RETURN
C --------------------------
 1000 CONTINUE
      LINE=' ERR: OPEN FILE "'//FNAME(1:NL)//'"'
      CALL MSGERR(MDOC,LINE)
      IF(MSG.EQ.'Y') GO TO 1010
      NSYM=0
      RETURN
      END

C ******
      SUBROUTINE CHECK_BATCH(IBAT)
C
C -P- CHECK_BAT - return info about mode / dialogue (0) or batch (1)/.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ******
      INTEGER*4 IBAT
C ------
      IBAT=BAT_MODE
      RETURN
      END


C ******
      SUBROUTINE CLEAR_DEF
C
C -P- CLEAR_DEF - return dialogue mode.  
C
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      PARAMETER ( KEY_MAX = 100 )
      COMMON/COMASK/ IEND,NKEY,FLAG,STOR,STOR_KEY 
      INTEGER*4 FLAG(KEY_MAX),IEND,NKEY
      CHARACTER STOR(KEY_MAX)*256,STOR_KEY(KEY_MAX)*11
      COMMON/COMASK2/ NKEY_TEST,KEY_TEST
      INTEGER*4 NKEY_TEST
      CHARACTER KEY_TEST(KEY_MAX)*11
C ---
C -----------------------------------------------------------
      IF(BAT_MODE.GT.0) RETURN
      IEND      = 0
      IBATCH    = 0
      NKEY      = 0
      NKEY_TEST = 0
      DO I=1,KEY_MAX
        FLAG(I) = 0
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE WRT_BATCH(LINE)
C
C -P- WRT_BATCH - write message to BATCH-FILE.
C
      CHARACTER LINE*(*)
C ******
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 NL
      CHARACTER STR*80
C ---------------------------------------------------------
      IF(BATCH_FILE.GT.0) THEN
        CALL LENSTR_BL(LINE,NL)
        IF(NL.LE.0) THEN
          NL=1
          STR=' '
        ELSE
          IF(NL.GT.79) NL=79
          STR = LINE(1:NL)
        ENDIF
        WRITE(BATCH_FILE,'(A)',ERR=10) STR(1:NL)
      ENDIF
C ---
      RETURN
 10   CALL MSGERR(MDOC,' ERR: WRITTING TO BATCH')
      CALL FINISH
      END

C ******
      SUBROUTINE C_CR_AT
C     
C -P- C_CR_AT - copy parameters from common/CRYSTL/ to common/CRDINF/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        CR_TITLE(I:I)   = ' '
      ENDDO
      CR_CELL(1) = A_CELL    
      CR_CELL(2) = B_CELL    
      CR_CELL(3) = C_CELL    
      CR_CELL(4) = AL_CELL   
      CR_CELL(5) = BE_CELL   
      CR_CELL(6) = GA_CELL
      CR_NAME_PDB= PDB_NAME   
      CR_DATE_PDB= PDB_DATE
      CR_CD_PDB  = PDB_CODE  
      CR_TITLE   = USER_TITLE
      CR_NSPGR   = NSP_GROUP 
      CR_SETT    = N_SETT   
      CR_SPGR    = SP_GROUP 
      CR_RESL_PDB= PDB_RESL
      CR_RFAC_PDB= PDB_RFAC
      CR_MODEL   = PDB_MODEL
      DO I=1,3
        CR_U(I)=PDB_U(I)
        DO J=1,3
          CR_SCALE(I,J)=PDB_SCALE(I,J)
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE C_AT_CR
C     
C -P- C_AT_CR - copy parameters from common/CRDINF/ to common/CRYSTL/
C 
C --------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
      INCLUDE 'mr_cryst_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = CR_CELL(1) 
      B_CELL    = CR_CELL(2)
      C_CELL    = CR_CELL(3)
      AL_CELL   = CR_CELL(4)
      BE_CELL   = CR_CELL(5)
      GA_CELL   = CR_CELL(6)
      PDB_NAME  = CR_NAME_PDB 
      PDB_DATE  = CR_DATE_PDB 
      PDB_CODE  = CR_CD_PDB 
      USER_TITLE= CR_TITLE 
      NSP_GROUP = CR_NSPGR 
      N_SETT    = CR_SETT
      SP_GROUP  = CR_SPGR
      PDB_RESL  = CR_RESL_PDB
      PDB_RFAC  = CR_RFAC_PDB
      PDB_MODEL = CR_MODEL
      DO I=1,3
        PDB_U(I)=CR_U(I)
        DO J=1,3
          PDB_SCALE(I,J)=CR_SCALE(I,J)
        ENDDO
      ENDDO
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      DO I=1,3
        DO J=1,3
          CR_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

c --cr2--

C ******
      SUBROUTINE C_CR2_AT
C     
C -P- C_CR2_AT - copy parameters from common/CRYSTL/ to common/CRD2INF/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        CR2_TITLE(I:I)   = ' '
      ENDDO
      CR2_CELL(1) = A_CELL    
      CR2_CELL(2) = B_CELL    
      CR2_CELL(3) = C_CELL    
      CR2_CELL(4) = AL_CELL   
      CR2_CELL(5) = BE_CELL   
      CR2_CELL(6) = GA_CELL
      CR2_NAME_PDB= PDB_NAME   
      CR2_DATE_PDB= PDB_DATE
      CR2_CD_PDB  = PDB_CODE  
      CR2_TITLE   = USER_TITLE
      CR2_NSPGR   = NSP_GROUP 
      CR2_SETT    = N_SETT   
      CR2_SPGR    = SP_GROUP 
      CR2_RESL_PDB= PDB_RESL
      CR2_RFAC_PDB= PDB_RFAC
      CR2_MODEL   = PDB_MODEL
      DO I=1,3
        CR2_U(I)=PDB_U(I)
        DO J=1,3
          CR2_SCALE(I,J)=PDB_SCALE(I,J)
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          CR2_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR2_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE C_AT_CR2
C     
C -P- C_AT_CR2 - copy parameters from common/CRD2INF/ to common/CRYSTL/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C -------
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = CR2_CELL(1) 
      B_CELL    = CR2_CELL(2)
      C_CELL    = CR2_CELL(3)
      AL_CELL   = CR2_CELL(4)
      BE_CELL   = CR2_CELL(5)
      GA_CELL   = CR2_CELL(6)
      PDB_NAME  = CR2_NAME_PDB 
      PDB_DATE  = CR2_DATE_PDB 
      PDB_CODE  = CR2_CD_PDB 
      USER_TITLE= CR2_TITLE 
      NSP_GROUP = CR2_NSPGR 
      N_SETT    = CR2_SETT
      SP_GROUP  = CR2_SPGR
      PDB_RESL  = CR2_RESL_PDB
      PDB_RFAC  = CR2_RFAC_PDB
      PDB_MODEL = CR2_MODEL
      DO I=1,3
        PDB_U(I)=CR2_U(I)
        DO J=1,3
          PDB_SCALE(I,J)=CR2_SCALE(I,J)
        ENDDO
      ENDDO
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      DO I=1,3
        DO J=1,3
          CR2_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR2_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

c --CR3--

C ******
      SUBROUTINE C_CR3_AT
C     
C -P- C_CR3_AT - copy parameters from common/CRYSTL/ to common/CRD2INF/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
      INCLUDE 'mr_crd2_com.fh'
c ------
C -------------------------------------------------
C ******
C --------------------------------------------------------------------
      DO I=1,80
        CR3_TITLE(I:I)   = ' '
      ENDDO
      CR3_CELL(1) = A_CELL    
      CR3_CELL(2) = B_CELL    
      CR3_CELL(3) = C_CELL    
      CR3_CELL(4) = AL_CELL   
      CR3_CELL(5) = BE_CELL   
      CR3_CELL(6) = GA_CELL
      CR3_NAME_PDB= PDB_NAME   
      CR3_DATE_PDB= PDB_DATE
      CR3_CD_PDB  = PDB_CODE  
      CR3_TITLE   = USER_TITLE
      CR3_NSPGR   = NSP_GROUP 
      CR3_SETT    = N_SETT   
      CR3_SPGR    = SP_GROUP 
      CR3_RESL_PDB= PDB_RESL
      CR3_RFAC_PDB= PDB_RFAC
      CR3_MODEL   = PDB_MODEL
      DO I=1,3
        CR3_U(I)=PDB_U(I)
        DO J=1,3
          CR3_SCALE(I,J)=PDB_SCALE(I,J)
        ENDDO
      ENDDO
      DO I=1,3
        DO J=1,3
          CR3_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR3_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE C_AT_CR3
C     
C -P- C_AT_CR3 - copy parameters from common/CRD2INF/ to common/CRYSTL/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    = CR3_CELL(1) 
      B_CELL    = CR3_CELL(2)
      C_CELL    = CR3_CELL(3)
      AL_CELL   = CR3_CELL(4)
      BE_CELL   = CR3_CELL(5)
      GA_CELL   = CR3_CELL(6)
      PDB_NAME  = CR3_NAME_PDB 
      PDB_DATE  = CR3_DATE_PDB 
      PDB_CODE  = CR3_CD_PDB 
      USER_TITLE= CR3_TITLE 
      NSP_GROUP = CR3_NSPGR 
      N_SETT    = CR3_SETT
      SP_GROUP  = CR3_SPGR
      PDB_RESL  = CR3_RESL_PDB
      PDB_RFAC  = CR3_RFAC_PDB
      PDB_MODEL = CR3_MODEL
      DO I=1,3
        PDB_U(I)=CR3_U(I)
        DO J=1,3
          PDB_SCALE(I,J)=CR3_SCALE(I,J)
        ENDDO
      ENDDO
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      DO I=1,3
        DO J=1,3
          CR3_FRAC_TO_ORT(I,J)=FRTOCR(I,J)
          CR3_ORT_TO_FRAC(I,J)=CRTOFR(I,J)
        ENDDO
      ENDDO
      RETURN
      END


C ******
      SUBROUTINE FINISH
C
C -P- FINISH - close DOC-file and EXIT.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
      CHARACTER LINE*80
C -------------------------
      M=-1
      CALL LENSTR_BL(PROGRAMM,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        PROGRAMM(1:1)=' '
      ELSE IF(LEN.GT.20) THEN
        LEN=20
      ENDIF
      WRITE(LINE,10) PROGRAMM(1:LEN)      
  10  FORMAT(' **** END //////// ',A,' ///////// END ****')
      CALL MSGDOC(M,LINE)
      IF(DOC_FILE.GT.0) THEN
        END FILE DOC_FILE
        CLOSE(DOC_FILE)
      ENDIF

      IF(BATCH_FILE.GT.0) THEN
        WRITE(LINE,20) PROGRAMM(1:LEN)      
  20    FORMAT('_END   ',A)
        CALL WRT_BATCH(LINE)
        LINE='stop'
        CALL WRT_BATCH(LINE)
        END FILE BATCH_FILE
        CLOSE(BATCH_FILE)
      ENDIF

      CALL EXIT
      END          

C ******
      SUBROUTINE CLOSE_DOC(M)
C
C -P- CLOSE_DOC - close DOC-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
C -------------------------
      IF(DOC_FILE.GT.0) THEN
        END FILE DOC_FILE
        CLOSE(DOC_FILE)
      ENDIF
      RETURN
      END          

      SUBROUTINE SET_BATCH(IBAT)
C
C -P- CHECK_BAT - return info about mode / dialogue (0) or batch (1)/.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ******
      INTEGER*4 IBAT
C ------
      BAT_MODE=IBAT
      RETURN
      END

C ******
      SUBROUTINE CLOSE_BATCH(M)
C
C -P- CLOSE_BATCH - close BATCH-file.
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
C ******
      INTEGER*4 M
C -------------------------
      CHARACTER LINE*80
C -------------------------
      CALL LENSTR_BL(PROGRAMM,LEN)
      IF(LEN.LE.0) THEN
        LEN=1
        PROGRAMM(1:1)=' '
      ELSE IF(LEN.GT.20) THEN
        LEN=20
      ENDIF

      IF(BATCH_FILE.GT.0) THEN

        WRITE(LINE,20) PROGRAMM(1:LEN)      
  20    FORMAT('_END   ',A)
        CALL WRT_BATCH(LINE)
        LINE='stop'
        CALL WRT_BATCH(LINE)

        END FILE BATCH_FILE
        CLOSE(BATCH_FILE)
        BATCH_FILE=0
      ENDIF

      RETURN
      END          

C ******
      SUBROUTINE MSGDOC(MDOC,STRING)
C ---
C -P- MSGDOC - writes message to terminal or/and DOC_FILE
C        MDOC   < 0  write to DOC_FILE only ( if DOC_FILE > 0 )
C               = 0  write to terminal only
C      0 < MDOC < 99 write to terminal and to DOC_FILE ( if DOC_FILE > 0 )
C       !MDOC! >= 99 don't write 
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 MDOC
      CHARACTER STRING*(*)
C ******
C -----------------------------------
      IF(IGRAPH.EQ.0) THEN
        IF(ABS(MDOC).GE.99) RETURN
        CALL LENSTR_BL(STRING,NL)
        IF(NL.GE.80) NL=79
        IF(MDOC.GE.0) THEN
          IF(NL.LE.0) THEN
            IF(MDOC.GE.0) WRITE(*,*) 
            IF(MDOC.NE.0.AND.DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
          ELSE
            IF(MDOC.GE.0) WRITE(*,100) STRING(1:NL)
            IF(MDOC.NE.0.AND.DOC_FILE.GT.0) 
     *      WRITE(DOC_FILE,101) STRING(1:NL)
 100        FORMAT(' ',A)
 101        FORMAT(A)
          ENDIF
        ELSE
          IF(NL.LE.0) THEN
            IF(DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
          ELSE
            IF(DOC_FILE.GT.0) WRITE(DOC_FILE,101) STRING(1:NL)
          ENDIF
        ENDIF
      ELSE
        CALL MSGDOG(MDOC,STRING)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE MSGERR(MDOC,STRING)
C ---
C -P- MSGERR - writes message about error to terminal or/and DOC_FILE
C        MDOC   # 0  write to terminal and DOC_FILE only ( if DOC_FILE > 0 )
C               = 0  write to terminal only
C ---
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 MDOC
      CHARACTER STRING*(*)
C ******
C -----------------------------------
      IF(IGRAPH.EQ.0) THEN
C       IF(MDOC.GE.99) RETURN
        CALL LENSTR_BL(STRING,NL)
        IF(NL.GE.80) NL=79
        IF(NL.LE.0) THEN
          WRITE(*,*) 
          IF(MDOC.NE.0.AND.DOC_FILE.GT.0) WRITE(DOC_FILE,*) 
        ELSE
          WRITE(*,100) STRING(1:NL)
          IF(MDOC.NE.0.AND.DOC_FILE.GT.0) 
     *    WRITE(DOC_FILE,101) STRING(1:NL)
 100      FORMAT(' ',A)
 101      FORMAT(A)
        ENDIF
      ELSE
        CALL MSGERG(MDOC,STRING)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE MSGERG(MDOC,STRING)
      CHARACTER STRING*(*)
      RETURN
      END
C ******

C ******
      SUBROUTINE MSGDOG(MDOC,STRING)
      CHARACTER STRING*(*)
      RETURN
      END
C ******

C -P-
C -P------ control information in the internal common blocks  ---
C -P-
C ******
      SUBROUTINE SET_CELL(RLATT,CODE,NAME,DATE,TITLE
     *   ,NSPGROUP,NOSETT,SPGR,IERR)
C     
C -P- SET_CELL - put parameters to common/CRYSTL/
C 
C               calc reciprocal cell parameters and volume
C               and put its to common/CRYSTL/
C               calc matrix FRTOCR and CRTOFR
C
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C -------
C ---
      REAL      RLATT(6)
      INTEGER*4 NSPGROUP,NOSETT,IERR
      CHARACTER CODE*4,NAME*40,DATE*9,SPGR*24 
      CHARACTER TITLE*(*)
C ******
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I)   = ' '
      ENDDO
      A_CELL    =RLATT(1)
      B_CELL    =RLATT(2)
      C_CELL    =RLATT(3)
      AL_CELL   =RLATT(4)
      BE_CELL   =RLATT(5)
      GA_CELL   =RLATT(6)
      PDB_NAME  =NAME
      PDB_DATE  =DATE
      PDB_CODE  =CODE
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.80) LEN=80
      USER_TITLE=TITLE(1:LEN)
      NSP_GROUP =NSPGROUP
      N_SETT    =NOSETT
      SP_GROUP  =SPGR
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
C ---
      RETURN
      END

      SUBROUTINE GET_CELL(RLATT,CODE,NAME,DATE,TITLE
     *   ,NSPGROUP,NOSETT,SPGR,NSM,IERR)
C     
C -P- GET_CELL - get parameters from common/CRYSTL/
C 
C
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
C --------------
C ---
      REAL      RLATT(6)
      INTEGER*4 NSPGROUP,NOSETT,IERR
      CHARACTER CODE*4,NAME*40,DATE*9,SPGR*24 
      CHARACTER TITLE*(*)
C ******
C --------------------------------------------------------------------
      RLATT(1) = A_CELL    
      RLATT(2) = B_CELL    
      RLATT(3) = C_CELL    
      RLATT(4) = AL_CELL    
      RLATT(5) = BE_CELL
      RLATT(6) = GA_CELL    
      NAME     = PDB_NAME
      DATE     = PDB_DATE 
      CODE     = PDB_CODE  
      TITLE    = USER_TITLE
      NSPGROUP = NSP_GROUP
      NOSETT   = N_SETT    
      SPGR     = SP_GROUP  
      NSM      = CR_NSYM
C ---
      RETURN
      END

C ******
      SUBROUTINE SETLNL(NAME)
C ---
C -P- SETLNL - /old, don't use now /put NAME to --> common/COMLIB/..,LINEL,..
C ---
C ******
      COMMON/COMLIB/ IGRAPH,DOC_FILE,INF_FILE,BATCH_FILE,IBATCH
     .              ,BAT_MODE,RVAL_1,RVAL_2
     .              ,IVAL_1,IVAL_2,LINEL,MSGL_1,MSGL_2
     .              ,PROGRAMM
      CHARACTER LINEL*80,MSGL_1*1,MSGL_2*1,PROGRAMM*80
      INTEGER*4 IGRAPH,IVAL_1,IVAL_2,DOC_FILE,INF_FILE 
      INTEGER*4 BAT_MODE,BATCH_FILE,IBATCH
C ---
      INTEGER*4 LEN
      CHARACTER NAME*(*)
C -------------------------------------
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.0.AND.LEN.LE.80) THEN
        LINEL=NAME(1:LEN)
      ELSE
        LINEL=' '
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE C_CR_WR
C     
C -P- C_CR_WR - copy parameters from common/CRYSTL/ to common/COMWRF/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C -------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      A_WR  = A_CELL    
      B_WR  = B_CELL    
      C_WR  = C_CELL    
      AL_WR = AL_CELL   
      BE_WR = BE_CELL   
      GA_WR = GA_CELL   
      PT_WR = PDB_NAME 
      PD_WR = PDB_DATE  
      CD_WR = PDB_CODE  
      TL_WR = USER_TITLE
      T1_WR = USER_TITLE(1:4)
      T2_WR = USER_TITLE(5:8)
      NS_WR = NSP_GROUP 
      IS_WR = N_SETT   
      SG_WR = SP_GROUP 
      RETURN
      END

C ******
      SUBROUTINE SET_WRF(NSPGR,NSETT,CODESG,CODEPDB
     *                  ,NAMEPDB,DATEPDB,TITLE)
C     
C -P- SET_WRF - put N_SpGr, N_SETT, CODE_SpGr, CODE_PDB to common/COMWRF/
C -P-               NAME_PDB, DATE_PDB , TITLE_PDB
C --------------------------------------------------
      INTEGER*4 NSPGR,NSETT
      CHARACTER CODEPDB*4,NAMEPDB*40,TITLE*(*)
      CHARACTER CODESG*24,DATEPDB*9
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      T1_WR = '?   '
      T2_WR = '?   '
      TL_WR(9:9) = '?'
      CD_WR = CODEPDB  
      NS_WR = NSPGR 
      IS_WR = NSETT   
      SG_WR = CODESG 
      PT_WR = NAMEPDB
      PD_WR = DATEPDB
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.80) LEN=80
      IF(LEN.GE.8) THEN
        TL_WR(1:LEN) = TITLE(1:LEN)
        T1_WR = TITLE(1:4)
        T2_WR = TITLE(5:8)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE C_RD_WR
C     
C -P- C_RD_WR - copy parameters from common/COMRDF/ to common/COMWRF/
C 
C --------------------------------------------------
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ******
C --------------------------------------------------------------------
      DO I=1,80
        TL_WR(I:I) = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I) = ' '
      ENDDO
      A_WR  = A_RD    
      B_WR  = B_RD    
      C_WR  = C_RD    
      AL_WR = AL_RD   
      BE_WR = BE_RD   
      GA_WR = GA_RD   
      CD_WR = CD_RD  
      T1_WR = T1_RD
      T2_WR = T2_RD
      TL_WR = TL_RD
      NS_WR = NS_RD 
      IS_WR = IS_RD   
      SG_WR = SG_RD 
      PT_WR = PT_RD
      PD_WR = PD_RD
      RETURN
      END

C ******
      SUBROUTINE C_RD_CR
C     
C -P- C_RD_CR - copy parameters from common/COMRDF/ to common/CRYSTL/
C 
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ******
C --------------------------------------------------------------------
      DO I=1,80
        USER_TITLE(I:I) = ' '
      ENDDO
      DO I=1,40
        PDB_NAME(I:I) = ' '
      ENDDO
      A_CELL    = A_RD    
      B_CELL    = B_RD   
      C_CELL    = C_RD
      AL_CELL   = AL_RD
      BE_CELL   = BE_RD
      GA_CELL   = GA_RD
      PDB_CODE  = CD_RD
      USER_TITLE= TL_RD
      NSP_GROUP = NS_RD
      N_SETT    = IS_RD
      SP_GROUP  = SG_RD
      PDB_NAME  = PT_RD
      PDB_DATE  = PD_RD
      CALL REPCELL(IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,
     * ' WARNING: determinant of matrix "Frac-to-Orth" = 0')
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYMM/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C ******
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,'('' ERR: wrong number of chain > '',I6)')N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

C ******
      SUBROUTINE GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYMM/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP


      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0.) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END

      SUBROUTINE SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYM2/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of chain > '',I6)') N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

      SUBROUTINE GET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYM2/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP


      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0.) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END

      SUBROUTINE SET_ASYM3(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input IGR = 0 - INIT/return NMAX, 1,2,.......  NMAX
C         IGR > 0  input IGR,IGOLD,INC,MLT,NCSF,GID(1:2),ICH,ICHOLD
C                 
C                  use IGOLD /number in the file/, if IGOLD=0 use IGOLD=IGR 
C                     if ( INC = 0) or
C                  1. if ICHOLD and ICH = 0 --> IG_CHAIN  =  IGR 
C                     if ( INC . ne. 0)
C                  2.    ICH    > 0         --> IG_CHAIN  =  ICH
C                  3.    ICHOLD > 0         --> IG_CHAIN  = -ICHOLD
C                      and check ICHOLD: if ICHOLD = IG_OLD(IG) then
C                                             IG_CHAIN  = IG 
C                  return new value NGR
C NGR     - number of groups in the structure. 
C IGR     - No of group.
C ICH     - pointer to initial group.      /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - group number in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + add_chain_number
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYM3/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to chain.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - number of group in the file.
C NCS_FLAG     - 
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER CH4*4,LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN

      IF(IGR.GT.NMAX) THEN
        WRITE(LINE,'('' WARNING: Too many chains > '',I6)') NMAX
        CALL MSGERR(MDOC,LINE)
        IGR=NMAX
      ENDIF
      IF(IGR.LE.0) THEN
        N_GROUP=0
        N_CHAIN=0
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP+1) THEN
        WRITE(LINE,'('' ERR: wrong number of chain > '',I6)')N_GROUP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.GT.N_GROUP) THEN
        N_GROUP=N_GROUP+1
        N_CHAIN=N_GROUP
      ENDIF

      IF(IGOLD.LE.0) IGOLD=IGR

      IF(INC.LE.0) THEN
        INC=0
        IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.LE.0.AND.ICHOLD.LE.0) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
      ELSE IF(ICH.GT.0.AND.ICHOLD.LE.0) THEN
        IF(ICH.EQ.IGR) THEN
          INC=0
        ENDIF
        IG_CHAIN    (IGR) = ICH
      ELSE
        IF(ICHOLD.EQ.IGOLD) THEN
          INC=0
          IG_CHAIN    (IGR) = IGR   
        ELSE
          IG_CHAIN    (IGR) = -ICHOLD   
        ENDIF
      ENDIF

      I_NCS       (IGR) = INC   
      MULT_FLAG   (IGR) = MLT   
      IG_OLD      (IGR) = IGOLD   
      NCS_FLAG    (IGR) = NCSF

      IF(INC.GT.99) THEN
        WRITE(LINE,'('' ERR: wrong number of NCS operator > 99 '')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      WRITE(CH4,'(I2)') INC
      CH4(1:2)=GID(1:2)
      IF(CH4(2:2).EQ.' ') CH4(2:2)='.'
      IF(CH4(3:3).EQ.' ') CH4(3:3)='.'
      GROUP_ID    (IGR) = CH4

      IF(N_GROUP.GT.0) THEN
        DO I=1,N_GROUP
          IF(IG_CHAIN(I).LT.0) THEN
            IGO = -IG_CHAIN(I)
            DO J=1,N_GROUP
              IF(IGO.EQ.IG_OLD(J)) THEN
                IG_CHAIN(I) = IG_CHAIN(J)
                GO TO 100
              ENDIF
            ENDDO
          ENDIF
  100     CONTINUE
        ENDDO
      ENDIF

      NGR=N_GROUP

      RETURN
      END

      SUBROUTINE GET_ASYM3(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                    ,IGOLD,NCSF,GID,IERR)
C -----------------------------------------------
C   input - IGR   0/GET ONLY NMAX,NGR/, 1,2,....NGR
C
C NGR     - number of groups in the structure. 
C IGR     - group number.
C ICH     - pointer to initial group. /for initial = IGR/
C ICHOLD  - pointer/ODL/ to initial group. /for initial = IGROLD/
C INC     - pointer to NCS matrix. 0 - initial group.
C MLT_    - 0,1,2,3,......
C IGOLD   - number of group in the file.
C NCSF    - Y,N,C
C GID     -  "A102" = PDB_chain + + add_chain_number+I_NCS
      INTEGER MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IGOLD,IERR
      CHARACTER NCSF*1,GID*4
C ------------------------------------------------------------------------
      PARAMETER (MAXCHAIN=100)
      COMMON /COM_ASYM3/  N_GROUP,N_CHAIN,IG_CHAIN,I_NCS,IG_OLD
     *                   ,MULT_FLAG,NCS_FLAG,GROUP_ID
      INTEGER*4 N_GROUP,N_CHAIN
      INTEGER*4 IG_CHAIN    (MAXCHAIN)   
      INTEGER*4 I_NCS       (MAXCHAIN)   
      INTEGER*4 MULT_FLAG   (MAXCHAIN)
      INTEGER*4 IG_OLD      (MAXCHAIN)   
      CHARACTER NCS_FLAG    (MAXCHAIN)*1
      CHARACTER GROUP_ID    (MAXCHAIN)*4
C ---
C N_GROUP      - number of groups in the structure. 
C IG_CHAIN     - pointer to initial group.
C I_NCS        - pointer to NCS matrix.
C MULT_FLAG    -
C IG_OLD       - group number in the file.
C NCS_FLAG     - Y,N,C
C GROUP_ID     -  "A102" = PDB_chain + add_chain_number+I_NCS
C --------------------------------------------------------------------------
      CHARACTER LINE*80
C --------------------------------------------------------------------
      IERR=0
      NMAX=MAXCHAIN
      NGR =N_GROUP


      IF(IGR.GT.NGR) THEN
        WRITE(LINE,'('' ERR: number of chain > '',I6)') NGR
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF

      IF(IGR.EQ.0) RETURN

      IF(NGR.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: number of chain = 0 ')
        IERR=1
        RETURN
      ENDIF

      IF(IGR.LT.0.) THEN
        DO I=1,NGR
          IF(IGOLD.EQ.IG_OLD(I)) THEN
            IGR=I
            GO TO 100
          ENDIF 
        ENDDO
        CALL MSGERR(MDOC,' ERR: wrong description of asym. part')
        IERR=1
        RETURN
      ENDIF
 100  CONTINUE
      ICH    = IG_CHAIN    (IGR)   
      INC    = I_NCS       (IGR)   
      MLT    = MULT_FLAG   (IGR)    
      IGOLD  = IG_OLD      (IGR)   
      NCSF   = NCS_FLAG    (IGR)
      GID    = GROUP_ID    (IGR) 

      IF(ICH.LE.0.OR.ICH.GT.NGR) THEN
        WRITE(LINE,'('' WARNING: wrong description asymm. part.'')')
        CALL MSGERR(MDOC,LINE)
        ICH=IGR
      ENDIF

      ICHOLD = IG_OLD      (ICH)   

      RETURN
      END

      
C ******
      SUBROUTINE SET_NCS(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE GET_NCS(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
C ******
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END
      
      SUBROUTINE SET_NCS2(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS2/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE GET_NCS2(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS2/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END
      
      SUBROUTINE SET_NCS3(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS3/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: Too many non_cr_symm. operators > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        NCS=NCSMAX
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCSOP=0
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP+1) THEN
        WRITE(LINE,
     *'('' ERR: wrong number of NCS-operator > '',I6)') NCSOP
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.GT.NCSOP) NCSOP=NCSOP+1
      DO I=1,3
        TRNCS(I,NCS)=TR(I)
        DO J=1,3
          AMNCS(I,J,NCS)=AM(I,J)
        ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE GET_NCS3(MDOC,NMAX,NCS,AM,TR,IERR)
C -----------------------------------------------
      INTEGER NCS,MDOC,IERR
      REAL    AM(3,3),TR(3)
C -------
      PARAMETER (NCSMAX=150)
      COMMON/COMNCS3/ NCSOP,AMNCS(3,3,NCSMAX),TRNCS(3,NCSMAX)
C -------------------------------
      CHARACTER LINE*80
C --------------------------------
      IERR=0
      NMAX=NCSMAX
      IF(NCS.GT.NCSMAX) THEN
        WRITE(LINE,
     *'('' ERR: number of non_cr_symm. operator > '',I6)') NCSMAX
        CALL MSGERR(MDOC,LINE)
        IERR=1
        RETURN
      ENDIF
      IF(NCS.LT.1) THEN
        NCS=NCSOP
        RETURN
      ENDIF
      DO I=1,3
        TR(I)=TRNCS(I,NCS)
        DO J=1,3
          AM(I,J)=AMNCS(I,J,NCS)
        ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE REPCELL(IERR)
C
C -P- REPCELL - using CELL parameters from common/CRYSTL/ calc reciprocal
C -P-           cell parameters and volume and put its to common/CRYSTL/
C -P-           calc matrix FRTOCR and CRTOFR
C
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C ---------------------------------------------------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
      INTEGER IERR
C ******
C---------------------------------------------------------------------
      COAL=COS(AL_CELL)
      COBE=COS(BE_CELL)
      COGA=COS(GA_CELL)

      VOLUME=A_CELL*B_CELL*C_CELL*SQRT(1.-COAL**2-COBE**2-COGA**2
     *    +2.*COAL*COBE*COGA)

      SINAL=SQRT(1.-COAL*COAL)
      SINBE=SQRT(1.-COBE*COBE)
      SINGA=SQRT(1.-COGA*COGA)
      A_STAR=B_CELL*C_CELL*SINAL/VOLUME
      B_STAR=A_CELL*C_CELL*SINBE/VOLUME
      C_STAR=A_CELL*B_CELL*SINGA/VOLUME
      COALST=(COBE*COGA-COAL)/(SINBE*SINGA)
      COBEST=(COAL*COGA-COBE)/(SINAL*SINGA)
      COGAST=(COAL*COBE-COGA)/(SINAL*SINBE)
      SIBEST=SQRT(ABS(1.-COBEST*COBEST))
      SIALST=SQRT(ABS(1.-COALST*COALST))
      SIGAST=SQRT(ABS(1.-COGAST*COGAST))
      QQ_1=A_STAR*A_STAR
      QQ_2=B_STAR*B_STAR
      QQ_3=C_STAR*C_STAR
      QQ_4=2.*A_STAR*B_STAR*COGAST
      QQ_5=2.*A_STAR*C_STAR*COBEST
      QQ_6=2.*B_STAR*C_STAR*COALST
      CALL FRORTH(A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *            ,FRTOCR,CRTOFR,IERR)
      RETURN
      END


C ******
      SUBROUTINE DSTARF(RLATT,AST,BST,CST,COALS,COBES,COGAS,VOL)
C
C -P- DSTARF - calculate reciprocal cell parameters and volume
C -P-          old version, now use REPCELL.
C     input:  RLATT    - unit cell parameters 
C                        angles in radian
C     output:
C             AST,BST,CST   ! recyprocal cell parameters and volume cell
C             COALS,COBES   !  
C             COGAS,VOL     !
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C -------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
C ---------
      REAL RLATT(6),VOL
      REAL AST,BST,CST,COALST,COBEST,COGAST
C ******
C---------------------------------------------------------------------
      A_CELL =RLATT(1)
      B_CELL =RLATT(2)
      C_CELL =RLATT(3)
      AL_CELL=RLATT(4)
      BE_CELL=RLATT(5)
      GA_CELL=RLATT(6)

      COAL=COS(AL_CELL)
      COBE=COS(BE_CELL)
      COGA=COS(GA_CELL)

      VOL=A_CELL*B_CELL*C_CELL*SQRT(1.-COAL**2-COBE**2-COGA**2
     *    +2.*COAL*COBE*COGA)
      VOLUME=VOL

      SINAL=SQRT(ABS(1.-COAL*COAL))
      SINBE=SQRT(ABS(1.-COBE*COBE))
      SINGA=SQRT(ABS(1.-COGA*COGA))

      A_STAR=B_CELL*C_CELL*SINAL/VOLUME
      B_STAR=A_CELL*C_CELL*SINBE/VOLUME
      C_STAR=A_CELL*B_CELL*SINGA/VOLUME
      AST=A_STAR
      BST=B_STAR
      CST=C_STAR
      COALST=(COBE*COGA-COAL)/(SINBE*SINGA)
      COBEST=(COAL*COGA-COBE)/(SINAL*SINGA)
      COGAST=(COAL*COBE-COGA)/(SINAL*SINBE)
      COALS=COALST
      COBES=COBEST
      COGAS=COGAST
      SIBEST=SQRT(ABS(1.-COBEST*COBEST))
      SIALST=SQRT(ABS(1.-COALST*COALST))
      SIGAST=SQRT(ABS(1.-COGAST*COGAST))
      QQ_1=AST*AST
      QQ_2=BST*BST
      QQ_3=CST*CST
      QQ_4=2.*AST*BST*COGAS
      QQ_5=2.*AST*CST*COBES
      QQ_6=2.*BST*CST*COALS
      CALL FRORTH(A_CELL,B_CELL,C_CELL,AL_CELL,BE_CELL,GA_CELL
     *            ,FRTOCR,CRTOFR,IERR)
      RETURN
      END

C ******
      SUBROUTINE FRORTH(A,B,C,ALPHA,BETA,GAMMA,FRTOCR,CRTOFR,IERR)
C
C -P- FRORTH - calc transformation to orthogonal angstroms from fractional
C -P-          cell FRTOCR and back - CRTOFR 
C
C       ALPHA,BETA,GAMMA - in radian
C
C       orthog axes are defined to have 
C       A parallel to XO   Cstar parallel to ZO 
C
C                                 ! 11 21 31 !
C            Xo=[FRTOCR] Xf    RO=! 12 22 32 !
C                                 ! 13 23 33 !
C
C            Xf=[CRTOFR] Xo
C
      REAL FRTOCR(3,3),CRTOFR(3,3)      
      INTEGER IERR
C ******
      IERR=0
      SINA=SIN(ALPHA)
      COSA=COS(ALPHA)
      SINB=SIN(BETA)
      COSB=COS(BETA)
      SING=SIN(GAMMA)
      COSG=COS(GAMMA)
      COSBS=(COSA*COSG-COSB)/(SINA*SING)
      SINBS=SQRT(ABS(1.-COSBS*COSBS))
      COSAS=(COSG*COSB-COSA)/(SINB*SING)
      SINAS=SQRT(ABS(1.-COSAS*COSAS))
      COSGS=(COSA*COSB-COSG)/(SINA*SINB)
      SINGS=SQRT(ABS(1.-COSGS*COSGS))
C
      DO     I=1,3
      DO     J=1,3
        FRTOCR(I,J)=0.
      ENDDO
      ENDDO
C
      FRTOCR(1,1)=A
      FRTOCR(2,1)=B*COSG
      FRTOCR(3,1)=C*COSB
      FRTOCR(1,2)=0.
      FRTOCR(2,2)=B*SING
      FRTOCR(3,2)=-C*SINB*COSAS
      FRTOCR(1,3)=0.
      FRTOCR(2,3)=0.
      FRTOCR(3,3)=C*SINB*SINAS
      CALL INVERT(FRTOCR,CRTOFR,IERR)
      RETURN
      END

C -P-
C -P------  subroutines of rotation matrix  --------------------
C -P-
C ******
      SUBROUTINE EULERM(A,B,G,AM)
C
C -P- EULERM - calc euleran matrix AM[] <-- from euleran angles A,B,G /rad/
C
C     euleran angles : 1. A( Z) - alpha around axis Z
C                      2. B(Y') - beta  around new axis Y
C                      3. G(Z') - gamma around new axis Z
C
C                ! 11 21 31 !      Rotation of coord-system.
C           X' = ! 12 22 32 ! X
C                ! 13 23 33 !
C
      REAL AM(3,3)
C ******
      SINA=SIN(A)
      SINB=SIN(B)
      SING=SIN(G)
      COSA=COS(A)
      COSB=COS(B)
      COSG=COS(G)
      AM(1,1)= COSA*COSB*COSG-SINA*SING
      AM(1,2)= SINA*COSB*COSG+COSA*SING
      AM(1,3)=-SINB*COSG
      AM(2,1)=-COSA*COSB*SING-SINA*COSG
      AM(2,2)=-SINA*COSB*SING+COSA*COSG
      AM(2,3)= SINB*SING
      AM(3,1)= COSA*SINB
      AM(3,2)= SINA*SINB
      AM(3,3)= COSB
      RETURN
      END

C ******
      SUBROUTINE FTPMAT(PHI,THETA,PSI,AM)
C
C -P- FTPMAT - calc transform matrix AM[] <-- from angles PHI,THETA,PSI/rad/
C
C       PHI       -  rotation angle around  axis - X
C       THETA     -  rotation angle around  axis - Y
C       PSI       -  rotation angle around  axis - Z
C
C       PHI,THETA,PSI -in radian
C
C            ! 11 21 31 !
C       X' = ! 12 22 32 ! X
C            ! 13 23 33 !
C
      REAL AM(3,3)
C ******
      COSA=COS(PHI)
      SINA=SIN(PHI)  
      COSB=COS(THETA)
      SINB=SIN(THETA)
      COSG=COS(PSI)
      SING=SIN(PSI)
      AM(1,1)= COSB*COSG
      AM(1,2)= SINA*SINB*COSG-COSA*SING
      AM(1,3)=-COSA*SINB*COSG+SINA*SING
      AM(2,1)=-COSB*SING
      AM(2,2)=-SINA*SINB*SING+COSA*COSG
      AM(2,3)= COSA*SINB*SING+SINA*COSG
      AM(3,1)= SINB
      AM(3,2)=-SINA*COSB
      AM(3,3)= COSA*COSB
      RETURN
      END

C ******
      SUBROUTINE MTOANG(AMAT,ALPHA,BETA,GAMMA)
      REAL AMAT(3,3)
C
C -P- MTOANG - calc from rotation matrix AMAT[] --> Eiler angles /degree/ 
C -P-          ALPHA,BETA,GAMMA 
C
C ******
C ------------------------------------------------
      ALPHA = 0.0
      BETA  = 0.0
      GAMMA = 0.0
      PI    = 4.0*ATAN(1.0)
      CONV  = 180./PI

      TRACE = AMAT(1,1)+AMAT(2,2)+AMAT(3,3)
      IF(TRACE.LT.2.9999999) THEN
        IF(AMAT(3,3).LT. 0.999999.AND.AMAT(3,3).GT.-0.999999) THEN
          BETA = CONV*ACOS(AMAT(3,3))
          TEMP = SQRT(ABS(1-AMAT(3,3)*AMAT(3,3)))
          BETA = CONV*AATAN2(TEMP,AMAT(3,3))
          R13  = AMAT(3,1)
          R23  = AMAT(3,2)
          R31  = AMAT(1,3)
          R32  = AMAT(2,3)
          IF(R23.LT.-0.0000001) THEN
            R13  = -R13
            R23  = -R23
            R31  = -R31
            R32  = -R32
            BETA = -BETA
          ENDIF
          ALPHA = CONV*AATAN2(R23, R13)
          GAMMA = CONV*AATAN2(R32,-R31)
        ELSE
C   ----  BETA = 0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
          BETA = 0.0
          IF(AMAT(3,3).LT.0.0) BETA = 180.
          GAMMA = CONV*AATAN2(AMAT(1,2),AMAT(2,2))
          ALPHA = 0.
        ENDIF
      ENDIF
C -----------------------------------
      RETURN
      END

C ******
      SUBROUTINE POLTOM(THETA,PHI,CHI,AM)
C
C -P- POLTOM - calc transform matrix AM[] <-- from  polars - THETA PHI CHI /rad/
C
C                    polar coordinates of rotate axis 
C       THETA     -  angle between  rotate axis and Z
C       PHI       -  angle in plan XY between X and projection rotate axis
C
C       CHI       -  rotation angle 
C
C       THETA,PHI,CHI -in radian
C
C            ! 11 21 31 !
C       X' = ! 12 22 32 ! X
C            ! 13 23 33 !
C
      REAL AM(3,3)
C ******
      PI=4.0*ATAN(1.0)
      SF= SIN(PHI)
      CF= COS(PHI)  
      CT= COS(THETA)
      ST= SIN(THETA)
      CH= COS(CHI)
      SH= SIN(CHI)

      AM(1,1)=( CH         +(1.0-CH)*ST*ST*CF*CF )
      AM(1,2)=( CT*SH      +(1.0-CH)*ST*ST*SF*CF )
      AM(1,3)=(-ST*SF*SH   +(1.0-CH)*CT*ST*CF    )

      AM(2,1)=(-CT*SH      +(1.0-CH)*ST*ST*CF*SF )
      AM(2,2)=( CH         +(1.0-CH)*ST*ST*SF*SF )
      AM(2,3)=( ST*CF*SH   +(1.0-CH)*CT*ST*SF    )

      AM(3,1)=( ST*SF*SH   +(1.0-CH)*CT*ST*CF    )
      AM(3,2)=(-ST*CF*SH   +(1.0-CH)*CT*ST*SF    )
      AM(3,3)=( CH         +(1.0-CH)*CT*CT       )


      RETURN
      END
C 
      SUBROUTINE MTOPOL(TRMAT,THETA,PHI,CHI)
      REAL TRMAT(3,3)
C
C -P- MTOPOL - from rotation matrix TRMAT[] --> polars - THETA PHI CHI /degree/
C
C ******
C ------------------------------------------------
      REAL DC(3)
C ------------------------------------------------
      PI=4.0*ATAN(1.0)
      CONV=180./PI

      THETA=0.0
      PHI  =0.0
      CHI  =0.0

      TRACE=TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999) GO TO 200

      
      COSCHI = TRACE/2. -0.5
      SINCHI = SQRT(ABS(1.-COSCHI*COSCHI))
      CHI    = CONV*AATAN2(SINCHI,COSCHI)
      CHK = ABS(CHI)

      IF(CHK.LE.179.5.AND.ABS(TRMAT(3,3)).LT.0.99999) THEN

        DC(1) = (TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
        DC(2) = (TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
        DC(3) = (TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)

        CHK = DC(1)**2 +DC(2)**2 +DC(3)**2

        IF(CHK.GT.0.8) THEN
          STHETA = SQRT(ABS(1.-DC(3)*DC(3)))
          THETA  = CONV*AATAN2(STHETA,DC(3))
          PHI = CONV*AATAN2(DC(2),DC(1))
          GO TO 200
        ENDIF

      ENDIF
C
      CTHETA = (TRMAT(3,3)-COSCHI)/(1.0-COSCHI)
      CTHETA = SQRT(ABS(CTHETA))
      STHETA = SQRT(ABS(1.0-CTHETA*CTHETA))
      D = TRMAT(1,2)-TRMAT(2,1)
      CTHETA = CTHETA*SIGN(1.0,D)
      THETA  = CONV*AATAN2(STHETA,CTHETA)

      IF(TRMAT(3,3).GE.TRMAT(2,2).AND.TRMAT(3,3).GE.TRMAT(1,1)) THEN
        DC(1) = TRMAT(3,1)+TRMAT(1,3)
        DC(2) = TRMAT(2,3)+TRMAT(3,2)
        DC(3) = 2.0*(TRMAT(3,3)-COSCHI)

        DC(1) = DC(1)*SIGN(1.0,CTHETA)
        DC(2) = DC(2)*SIGN(1.0,CTHETA)
        PHI   = CONV*AATAN2(DC(2),DC(1))

      ELSE IF(TRMAT(2,2).GE.TRMAT(1,1)) THEN
        DC(1) = TRMAT(1,2)+TRMAT(2,1)
        DC(2) = 2.0*(TRMAT(2,2)-COSCHI)
        DC(3) = TRMAT(2,3)+TRMAT(3,2)

        D = TRMAT(3,1)-TRMAT(1,3)
c           2 st sf sh  --> sign sf
        DC(1) = DC(1)*SIGN(1.0,D)     
        DC(2) = DC(2)*SIGN(1.0,D)     
 
        PHI   = CONV*AATAN2(DC(2),DC(1))

      ELSE 
c         max  cf^2 st^2
c               2 (1-ch) st^2 cf^2
        DC(1) = 2.0*(TRMAT(1,1)-COSCHI)
c               2 (1-ch) st^2 sf cf
        DC(2) = TRMAT(1,2)+TRMAT(2,1)
        DC(3) = TRMAT(3,1)+TRMAT(1,3)

        D = TRMAT(2,3)-TRMAT(3,2)
c           2 st cf sh         --> sign cf
        D3 = TRMAT(3,1)+TRMAT(1,3)
c           2 (1-ch) ct st cf  --> sign cf
        
        IF(ABS(D3).GT.1.0E-3) THEN
          DC(1) = DC(1)*SIGN(1.0,CTHETA)
          DC(2) = DC(2)*SIGN(1.0,CTHETA)
          D = D3
        ENDIF         

        DC(1) = DC(1)*SIGN(1.0,D)     
        DC(2) = DC(2)*SIGN(1.0,D)  
        PHI   = CONV*AATAN2(DC(2),DC(1))

      ENDIF
C
 200  CONTINUE

      RETURN
      END

C ******
      SUBROUTINE MTOPOL_old(TRMAT,THETA,PHI,CHI)
      REAL TRMAT(3,3)
C
C -P- MTOPOL - from rotation matrix TRMAT[] --> polars - THETA PHI CHI /degree/
C
C ******
C ------------------------------------------------
      REAL DC(5)
C ------------------------------------------------
      OMEGA=0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=1.0
      THETA=0.0
      THETA=0.0
      PHI  =0.0
      CHI  =0.0
      PI=4.0*ATAN(1.0)
      CONV=180./PI
      TRACE=TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999)       GO TO 100
      IF(TRMAT(3,3).GE. 0.999999) GO TO 13
      IF(TRMAT(3,3).LE.-0.999999) GO TO 13
      THETA2=CONV*ACOS(TRMAT(3,3))
C
      R13=TRMAT(3,1)
      R23=TRMAT(3,2)
      R31=TRMAT(1,3)
      R32=TRMAT(2,3)
      IF(R23.GE.0.) GO TO 9
      R13=-R13
      R23=-R23
      R31=-R31
      R32=-R32
      THETA2=-THETA2
9     CONTINUE
      THETA3=CONV*AATAN2(R32,-R31)
      THETA1=CONV*AATAN2(R23,R13)
      GO TO 18
C  BETA =0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
13    THETA2=0.
      IF(TRMAT(3,3).LT.0.) THETA2=180.
      THETA3=CONV*AATAN2(TRMAT(1,2),TRMAT(2,2))
      THETA1=0.
      IF(THETA2.EQ.0)    CHI=THETA3
      IF(THETA2.EQ.180.) CHI=180.
      GO TO 10
C   SPHERICAL POLARS REF PATTERSON INT TAB VOL2 P59
18    CHI  =0.0
      DC(1)=0.0
      DC(2)=0.0
      DC(3)=0.0
      OMEGA=0.0
      PHI  =0.0
      COSCHI=TRACE/2. -0.5
      SINCHI=SQRT(ABS(1.-COSCHI*COSCHI))
      CHI=CONV*AATAN2(SINCHI,COSCHI)
      CHK=ABS(CHI)
      IF(CHK.GT.179.5) GO TO 10
      DC(1)=(TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
      DC(2)=(TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
      DC(3)=(TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)
      CHK=DC(1)**2 +DC(2)**2 +DC(3)**2
      IF(CHK.GT.0.8) GO TO 11
C
10    DC(1)=SQRT(ABS(0.5*TRMAT(1,1)+0.5))
      DC(2)=SQRT(ABS(0.5*TRMAT(2,2)+0.5))
      DC(3)=SQRT(ABS(0.5*TRMAT(3,3)+0.5))
C
C   ASSUME DC(1) POSITIVE
      IF(DC(1).EQ.0.0) GO TO 17
      IF(DC(2).NE.0.0)DC(2)=DC(2)*SIGN(1.0,TRMAT(2,1))
      IF(DC(3).NE.0.0)DC(3)=DC(3)*SIGN(1.0,TRMAT(3,1))
      GO TO 11
17    IF(DC(2).EQ.0.0) GO TO 11
      IF(DC(3).EQ.0.0) GO TO 11
      DC(3)=DC(3)*SIGN(1.0,TRMAT(3,2))
11    DC(4)=DC(1)
      DC(5)=DC(2)
C
12    SOMEGA=SQRT(ABS(1.-DC(3)*DC(3)))
      OMEGA=CONV*AATAN2(SOMEGA,DC(3))
      PHI=CONV*AATAN2(DC(2),DC(1))
100   CONTINUE
      THETA=OMEGA
      RETURN
      END

      SUBROUTINE ANGFIX(MDOC,TRMAT,THETA1,THETA2,THETA3)
C
C calc from rotation matrix TRMAT[] --> Eiler angles - THETA1,THETA2,THETA3 
C                                  spherical polars  - OMEGA PHI CHI /degree/
C                                  direction cosinus - DC(1),DC(2),DC(3)
C     
C
      REAL TRMAT(3,3),DC(5)
      CHARACTER LINE*80
C 
C ------------------------------------------------
      OMEGA  = 0.0
      DC(1)  = 0.0
      DC(2)  = 0.0
      DC(3)  = 1.0
      THETA1 = 0.0
      THETA2 = 0.0
      THETA3 = 0.0
      PHI    = 0.0
      CHI    = 0.0
C      IF(ABS(MDOC).LT.99) THEN
        CALL MSGDOC(MDOC,'  ROTATION MATRIX ')
        WRITE(LINE,'(1X,3(1X,F10.3))') (TRMAT(J,1),J=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(1X,3(1X,F10.3))') (TRMAT(J,2),J=1,3)
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,'(1X,3(1X,F10.3))') (TRMAT(J,3),J=1,3)
        CALL MSGDOC(MDOC,LINE)
C      ENDIF
      PI    = 4.0*ATAN(1.0)
      CONV  = 180./PI
      TRACE = TRMAT(1,1)+TRMAT(2,2)+TRMAT(3,3)
      IF(TRACE.GE.2.999999)       GO TO 100
      IF(TRMAT(3,3).GE. 0.999999) GO TO 13
      IF(TRMAT(3,3).LE.-0.999999) GO TO 13
      THETA2 = CONV*ACOS(TRMAT(3,3))
C
      R13 = TRMAT(3,1)
      R23 = TRMAT(3,2)
      R31 = TRMAT(1,3)
      R32 = TRMAT(2,3)
      IF(R23.LT.0.0) THEN 
        R13    =-R13
        R23    =-R23
        R31    =-R31
        R32    =-R32
        THETA2 =-THETA2
      ENDIF
9     CONTINUE

      THETA3 = CONV*AATAN2(R32,-R31)
      THETA1 = CONV*AATAN2(R23,R13)
      GO TO 18
C     BETA =0 OR 180  CAN ONLY FIND ALPHA + OR - GAMMA.
13    THETA2 = 0.0
      IF(TRMAT(3,3).LT.0.) THETA2=180.
      THETA3 = CONV*AATAN2(TRMAT(1,2),TRMAT(2,2))
      THETA1 = 0.0
      IF(THETA2.EQ.0)    CHI = THETA3
      IF(THETA2.EQ.180.) CHI = 180.
      GO TO 10
C     SPHERICAL POLARS REF PATTERSON INT TAB VOL2 P59
18    CHI    = 0.0
      DC(1)  = 0.0
      DC(2)  = 0.0
      DC(3)  = 0.0
      OMEGA  = 0.0
      PHI    = 0.0
      COSCHI = TRACE/2. -0.5
      SINCHI = SQRT(ABS(1.-COSCHI*COSCHI))
      CHI    = CONV*AATAN2(SINCHI,COSCHI)
      CHK    = ABS(CHI)
      IF(CHK.GT.179.5) GO TO 10
      DC(1) = (TRMAT(2,3)-TRMAT(3,2))/(2.*SINCHI)
      DC(2) = (TRMAT(3,1)-TRMAT(1,3))/(2.*SINCHI)
      DC(3) = (TRMAT(1,2)-TRMAT(2,1))/(2.*SINCHI)
      CHK   = DC(1)**2 +DC(2)**2 +DC(3)**2
      IF(CHK.GT.0.8) GO TO 11
C
10    DC(1) = SQRT(ABS(0.5*TRMAT(1,1)+0.5))
      DC(2) = SQRT(ABS(0.5*TRMAT(2,2)+0.5))
      DC(3) = SQRT(ABS(0.5*TRMAT(3,3)+0.5))
C
C     ASSUME DC(1) POSITIVE
      IF(DC(1).EQ.0.0) GO TO 17
      IF(DC(2).NE.0.0)DC(2) = DC(2)*SIGN(1.0,TRMAT(2,1))
      IF(DC(3).NE.0.0)DC(3) = DC(3)*SIGN(1.0,TRMAT(3,1))
      GO TO 11
17    IF(DC(2).EQ.0.0) GO TO 11
      IF(DC(3).EQ.0.0) GO TO 11
      DC(3) = DC(3)*SIGN(1.0,TRMAT(3,2))
11    DC(4) = DC(1)
      DC(5) = DC(2)
C
12    SOMEGA = SQRT(ABS(1.-DC(3)*DC(3)))
      OMEGA  = CONV*AATAN2(SOMEGA,DC(3))
      PHI    = CONV*AATAN2(DC(2),DC(1))
100   CONTINUE

      WRITE(LINE,101) THETA1,THETA2,THETA3
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,102) OMEGA,PHI,CHI
      CALL MSGDOC(MDOC,LINE)
      WRITE(LINE,103) (DC(I),I=1,3)
      CALL MSGDOC(MDOC,LINE)
101   FORMAT(' EILER             - ALPHA BETA GAMMA :',3(1X,F10.5))
102   FORMAT(' SPHERICAL POLARS  - OMEGA PHI CHI    :',3(1X,F10.5))
103   FORMAT(' DIRECTION COSINES OF ROTATION AXIS   :',3(1X,F10.5))
      RETURN
      END

C -P-
C -P------ useful crystallographical subroutines  --------------------
C -P-

C ******
      SUBROUTINE FTOO(X,Y,IERR)
C
C -P- FTOO - transform fractional coords X(3) to orthoganal Y(3).
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C ---------------------------------------------------
      REAL X(3),Y(3)
C ******
C---------------------------------------------------------------------
      CALL MVMULT(FRTOCR,X,Y)
      RETURN
      END

C ******
      SUBROUTINE OTOF(X,Y,IERR)
C
C -P- OTOF - transform orthogonal coords X(3) to fractional Y(3).
C --------------------------------------------------
      INCLUDE 'mr_cryst_com.fh'
C ------
C ---------------------------------------------------
      REAL X(3),Y(3)
C ******
C---------------------------------------------------------------------
      CALL MVMULT(CRTOFR,X,Y)
      RETURN
      END

C ******
      SUBROUTINE DSTAR(IH,IK,IL,RSQ)
C
C -P- DSTAR - give value of (4pi*sin(theta))/lambda for H,K,L
C             using information calculated by DSTARF or REPCELL.
C
C     input : IH,IK,IL - indeces h,k,l
C     output: RSQ      - in 1/Angstrom  (4pi*sin(theta))/lambda
C -------------------------------------------------------------------
      COMMON/DST_SCR/  QQ_1,QQ_2,QQ_3,QQ_4,QQ_5,QQ_6
C ******
C---------------------------------------------------------------------
      AH  = IH
      AK  = IK
      AL  = IL
      RSQ=AH*(QQ_1*AH+QQ_4*AK+QQ_5*AL)+QQ_2*AK*AK+(QQ_3*AL+QQ_6*AK)*AL
      RETURN
      END

C ******
      SUBROUTINE LIMHKL(RESMAX,IHMAX,IKMAX,ILMAX,NXMIN,NYMIN,NZMIN)
C -------------------------------------------------
C -P- LIMHKL - using CELL parameters from common/CRYSTL/
C -P-          and information about resolution RESMAX defines
C -P-          IHMAX,IKMAX,ILMAX - maximal values of indeces and    
C -P-          NXMIN,NYMIN,NZMIN - minimal grid spasing acceptable
C -P-          for calculation structure factors 
C --------------------------------------------------
C ******
      INCLUDE 'mr_cryst_com.fh'
C ------
C ---------------------------------------------------
      INTEGER*2 ID(50)
C              1  2   3   4   5   6   7   8    9  10
c      DATA ID/  4,  6,  8, 10, 12, 16, 20, 24, 30, 32
c     *       , 36, 48, 50, 54, 60, 64, 72, 80, 90, 96
c     *       ,100,108,120,128,132,144,150,160,162,180
c     *       ,192,200,216,240,250,256,264,270,288,300
c     *       ,320,324,360,384,400,432,450,480,500,512/
      DATA ID/  4,  6,  0,  0, 12,  0,  0, 24,  0, 32
     *       , 36, 48,  0,  0, 60,  0, 72,  0,  0, 96
     *       ,  0,108,120,  0,132,144,  0,  0,  0,180
     *       ,192,  0,216,240,  0,  0,264,  0,288,300
     *       ,  0,324,360,384,  0,432,  0,480,  0,600/
      DATA ND/50/
C---------------------------------------------------------------------
      RES = RESMAX*0.85
      IF(RES.LE.0.0) RES = 0.01
      CA = COS(AL_CELL)
      CB = COS(BE_CELL)
      CG = COS(GA_CELL)
      SA = SQRT(ABS(1.-CA*CA))
      SB = SQRT(ABS(1.-CB*CB))
      SG = SQRT(ABS(1.-CG*CG))

      IHMAX = INT(SIALST/(A_STAR*RES*SQRT(SIALST**2+(SIBEST*CG)**2
     .  + (SIGAST*CB)**2 + 2.0*COALST*(2.0*COBEST*COGAST + SIBEST*CB
     .  *SIGAST*CG) - 2.0*(COGAST**2 + COBEST**2))))
      IKMAX = INT(SIBEST/(B_STAR*RES*SQRT(SIBEST**2+(SIALST*CG)**2
     .  + (SIGAST*CA)**2 + 2.0*COBEST*(2.0*COALST*COGAST + SIALST*CA
     .  *SIGAST*CG) - 2.0*(COALST**2 + COGAST**2))))
      ILMAX = INT(SIGAST/(C_STAR*RES*SQRT(SIGAST**2+(SIALST*CB)**2
     .  + (SIBEST*CA)**2 + 2.0*COGAST*(2.0*COALST*COBEST + SIALST*CA
     .  *SIBEST*CB) - 2.0*(COALST**2 + COBEST**2))))
C      IHMAX=(IHMAX+1)/2
C      IKMAX=(IKMAX+1)/2
C      ILMAX=(ILMAX+1)/2
      IH2 = IHMAX*2+1
      IK2 = IKMAX*2+1
      IL2 = ILMAX*2+1

      RES=RES*0.88      

      RH = 1.0/(RES * A_STAR)
      RK = 1.0/(RES * B_STAR)
      RL = 1.0/(RES * C_STAR)
      SH = A_STAR * A_STAR
      SK = B_STAR * B_STAR
      SL = C_STAR * C_STAR
      NX = INT(RH+SQRT(.25/SH+RH**2))+1
      NY = INT(RK+SQRT(.25/SK+RK**2))+1
      NZ = INT(RL+SQRT(.25/SL+RL**2))+1

      IF(MOD(NX,2).NE.0) NX = NX+1
      IF(MOD(NY,2).NE.0) NY = NY+1
      IF(MOD(NZ,2).NE.0) NZ = NZ+1
      DO   I=1,ND
        NXMIN=ID(I)
        IF(NXMIN.GE.NX.AND.NXMIN.GE.IH2) GO TO 100
      ENDDO
  100 CONTINUE
      DO   I=1,ND
        NYMIN=ID(I)
        IF(NYMIN.GE.NY.AND.NYMIN.GE.IK2) GO TO 200
      ENDDO
  200 CONTINUE
      DO   I=1,ND
        NZMIN=ID(I)
        IF(NZMIN.GE.NZ.AND.NZMIN.GE.IL2) GO TO 300
      ENDDO
  300 CONTINUE
      IF(IHMAX.GT.511) IHMAX = 511
      IF(IKMAX.GT.511) IKMAX = 511
      IF(ILMAX.GT.511) ILMAX = 511
      RETURN
      END

C ******
      SUBROUTINE SETBADD(DMAX,BAVE,NX,NY,NZ,BADD)        
C ----------------------------------
C -P- SETBADD - give Badd.
C ------
      INCLUDE 'mr_cryst_com.fh'
C ******
C---------------------------------------------------------------------
      RH   = 1.0/(DMAX * A_STAR)
      RK   = 1.0/(DMAX * B_STAR)
      RL   = 1.0/(DMAX * C_STAR)
      SHH  = A_STAR * A_STAR
      SKK  = B_STAR * B_STAR
      SLL  = C_STAR * C_STAR
      D1   = SHH*NX*(NX-2.0*RH)
      D2   = SKK*NY*(NY-2.0*RK)
      D3   = SLL*NZ*(NZ-2.0*RL)
      D1   = AMIN1(D1,D2,D3)
      D2   = ALOG(0.35*(15.0+10.0*DMAX))
      BTOT = 4.0*D2/D1
c      write(*,*) ' bav,bt:',BAVE,BTOT
      IF(BTOT.GT.35.0) BTOT=35.0
      BADD = BTOT - BAVE
c      write(*,*) ' badd:',BADD
      IF(BADD.LT.0.0) BADD = 0.0
      RETURN
      END

C ******
      SUBROUTINE SET_LIMZ(NSYM,ISYM,NZ,IZMAX)
C --------------------------------------------
C -P- SET_LIMZ - return limit of Z (IZmax) for given NZ. 
C --------------------------------------------
      INTEGER NSYM,NZ,IZMAX
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C ---------------------------------------------
      INEG  = 0
      ITM   = 1
      IZMAX = NZ-1
      IF(NSYM.GT.1) THEN
        DO I=1,NSYM
          IF(ISYM(1,3,I).EQ.0.AND.ISYM(2,3,I).EQ.0) THEN
            IF(ISYM(3,3,I).LT.0) INEG=1
            TR=FLOAT(ISYM(4,3,I))/FLOAT(ISYM(5,3,I))
            IF(ABS(TR-0.5).LT.0.001) THEN
              IT=2 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.25).LT.0.001) THEN
              IT=4 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.3333).LT.0.001) THEN
              IT=3 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.1666).LT.0.001) THEN
              IT=6 
              IF(ITM.LT.IT) ITM=IT
            ELSE IF(ABS(TR-0.125).LT.0.001) THEN
              IT=8 
              IF(ITM.LT.IT) ITM=IT
            ENDIF
          ENDIF
        ENDDO
        IF(INEG.EQ.1) ITM = ITM*2
        IZMAX = FLOAT(NZ)/FLOAT(ITM)+0.001
        IF(IZMAX.GE.NZ) IZMAX = NZ-1
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE SYSABS_BL(IH,IK,IL,NSYM,ISYM,JABS)
C
C -P- SYSABS - check systematic absent for h,k,l: 1 - absent, 0 - no.
C  
C -----------------------------------------------
      INTEGER   IH,IK,IL,NSYM,JABS
      INTEGER*2 ISYM(5,3,NSYM)
C ******
      INTEGER JH,JK,JL
C -----------------------------------------------
      JABS=0
      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
          JH= ISYM(1,1,I)*IH + ISYM(1,2,I)*IK + ISYM(1,3,I)*IL
          IF(IH.EQ.JH) THEN
            JK= ISYM(2,1,I)*IH + ISYM(2,2,I)*IK + ISYM(2,3,I)*IL
            IF(IK.EQ.JK) THEN
              JL= ISYM(3,1,I)*IH + ISYM(3,2,I)*IK + ISYM(3,3,I)*IL
              IF(IL.EQ.JL) THEN
                PH= IH*(FLOAT(ISYM(4,1,I))/FLOAT(ISYM(5,1,I))) + 
     *              IK*(FLOAT(ISYM(4,2,I))/FLOAT(ISYM(5,2,I))) + 
     *              IL*(FLOAT(ISYM(4,3,I))/FLOAT(ISYM(5,3,I)))  
                DEL= ABS(PH-NINT(PH))
                IF(DEL.GT.0.05) JABS=1
              ENDIF
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE SPEC_POS(NSYM,ISYM,XF,YF,ZF
     *  ,DLIMX,DLIMY,DLIMZ,MULT)
C -----------------------
C -P- SPEC_POS - check spec.position. Return MULT = 1 or 2,3,..(i.e 1,1/2,1/3) 
C -----------------------
      REAL      XF,YF,ZF
      REAL      DLIMX,DLIMY,DLIMZ
      INTEGER   NSYM,MULT
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C -----------------------
      MULT  = 1
      NSP   = 1
      IF (NSYM.GT.1) THEN
        DO    I=2,NSYM
          X= ISYM(1,1,I)*XF + ISYM(2,1,I)*YF + ISYM(3,1,I)*ZF +
     *       FLOAT(ISYM(4,1,I))/FLOAT(ISYM(5,1,I))
          DELX = ABS(X-XF)
          DELX = MOD(DELX,1.0)
          IF(DELX.LE.DLIMX) THEN
            Y= ISYM(1,2,I)*XF + ISYM(2,2,I)*YF + ISYM(3,2,I)*ZF +
     *         FLOAT(ISYM(4,2,I))/FLOAT(ISYM(5,2,I))
            DELY = ABS(Y-YF)
            DELY = MOD(DELY,1.0)
            IF(DELY.LE.DLIMY) THEN
              Z= ISYM(1,3,I)*XF + ISYM(2,3,I)*YF + ISYM(3,3,I)*ZF +
     *           FLOAT(ISYM(4,3,I))/FLOAT(ISYM(5,3,I))
              DELZ = ABS(Z-ZF)
              DELZ = MOD(DELZ,1.0)
              IF(DELZ.LE.DLIMZ) NSP=NSP+1
            ENDIF
          ENDIF
        ENDDO
        MULT = FLOAT(NSYM)/FLOAT(NSP)+0.01  
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE INIT_CENTR(NSYM,ISYM)
C -----------------------
C -P- INIT_CENTR - initialization for subroutine CENTR_BL.
C -----------------------
C ******
C ----------------------------------------------------
      INTEGER*4 NSYM
      INTEGER*2 ISYM(5,3,1)
C ---
      COMMON /COM_CENTR/ CPROJ,NCENT
      INTEGER NCENT
      REAL CPROJ(3,20)
C ---
      INTEGER IH,IK,IL,J,NC
      REAL CPRJ(3,12)
      INTEGER IHKL(3,12),IN(3)
C
C---- set up tests for 0kl h0l hk0 hhl hkh hkk h-hl hk-h hk-k
C      -h2hl   2h-hl  hkl
C
      DATA IHKL/0,1,2, 1,0,2, 1,2,0, 1,1,10, 1,10,1, 10,1,1, 1,-1,10,
     +          1,10,-1, 10,1,-1, -1,2,10, 2,-1,10, 1,4,8/
      DATA CPRJ/1.0,0.0, 0.0, 0.0,1.0, 0.0, 0.0,0.0,1.0, 1.0,-1.0,0.0,
     +          1.0,0.0,-1.0, 0.0,1.0,-1.0, 1.0,1.0,0.0, 1.0, 0.0,1.0, 
     +          0.0,1.0, 1.0, 2.0,1.0, 0.0, 1.0,2.0,0.0, 0.0, 0.0,0.0/
C --------------------------------------------------------------
      NCENT = 0
      DO    NC = 1,10
        IN(1) = IHKL(1,NC)
        IN(2) = IHKL(2,NC)
        IN(3) = IHKL(3,NC)
C
C ----  Generate symm equivs
C
C ----  test whether h' k' l' equals -h -k -l
C
        DO   J = 1,NSYM
          IH=IN(1)*ISYM(1,1,J)+IN(2)*ISYM(1,2,J)+IN(3)*ISYM(1,3,J)
          IF(IH.EQ.-IN(1)) THEN
            IK=IN(1)*ISYM(2,1,J)+IN(2)*ISYM(2,2,J)+IN(3)*ISYM(2,3,J)
            IF(IK.EQ.-IN(2)) THEN
              IL=IN(1)*ISYM(3,1,J)+IN(2)*ISYM(3,2,J)+IN(3)*ISYM(3,3,J)
              IF(IL.EQ.-IN(3)) THEN
                NCENT = NCENT + 1
                CPROJ(1,NCENT) = CPRJ(1,NC)
                CPROJ(2,NCENT) = CPRJ(2,NC)
                CPROJ(3,NCENT) = CPRJ(3,NC)
                GO TO 30
              ENDIF
            ENDIF
          ENDIF
        ENDDO
C
C---- next symm opn
C
   30   CONTINUE
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE CENTR_BL(IH,IK,IL,ICENT)
C
C -P- CENTR - Determine whether a reflection (IH,IK,IL) is centric (ICENT=1)
C -P-         or not (ICENT=0)
C ******
C ---
      COMMON /COM_CENTR/ CPROJ,NCENT
      INTEGER NCENT
      REAL CPROJ(3,20)
C ---
C     INTEGER IH,IK,IL
C -----------------------------------------------------
      ICENT = 0
      IF(NCENT.GT.0) THEN
        DO    I = 1,NCENT
          IF((CPROJ(1,I)*IH+CPROJ(2,I)*IK+CPROJ(3,I)*IL).EQ.0.0)
     *    GO TO 10
        ENDDO
        RETURN
C ---
   10   ICENT = 1
      ENDIF
      RETURN
      END

      SUBROUTINE CALC_EPS(N,IH,IK,IL,NSYM,ISYM)
C
C    
C
      INTEGER*2 ISYM(5,3,NSYM)
      INTEGER   IHH(192),IKK(192),ILL(192)
C --------------------------------------------
      N      = 1
      IHH(1) = IH
      IKK(1) = IK
      ILL(1) = IL
      IH1    = IHH(1)
      IK1    = IKK(1)
      IL1    = ILL(1)
      IF(NSYM.LE.1) RETURN

      DO     I=2,NSYM
        JH = ISYM(1,1,I)*IH1 +ISYM(1,2,I)*IK1 +ISYM(1,3,I)*IL1
        JK = ISYM(2,1,I)*IH1 +ISYM(2,2,I)*IK1 +ISYM(2,3,I)*IL1
        JL = ISYM(3,1,I)*IH1 +ISYM(3,2,I)*IK1 +ISYM(3,3,I)*IL1
        IF(JL.LT.0) THEN
          JH=-JH
          JK=-JK
          JL=-JL
        ELSE IF(JL.EQ.0) THEN
          IF(JK.LT.0) THEN
            JH=-JH
            JK=-JK
          ELSE IF(JK.EQ.0) THEN
            IF(JH.LT.0) THEN
              JH=-JH
            ENDIF
          ENDIF
        ENDIF
        IF(N.GT.0) THEN
          DO  L=1,N
            IF(IHH(L).EQ.JH.AND.IKK(L).EQ.JK.AND.ILL(L).EQ.JL)GOTO 10
          ENDDO
        ENDIF
        N = N+1
        IHH(N) = JH
        IKK(N) = JK
        ILL(N) = JL
   10   CONTINUE
      ENDDO
      RETURN
      END

      SUBROUTINE INDMLTT(IHN,IKN,ILN,NGEN,NSYM,ISYM)
C
C -------------------------------------------
      INTEGER*2 ISYM(5,3,1)
      INTEGER   IHH(96),IKK(96),ILL(96)
C -------------------------------------------
      NGEN=0
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
        IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
        ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(IHS.EQ.IHH(J).AND.IKS.EQ.IKK(J).AND.
     *         ILS.EQ.ILL(J)) GO TO 1000
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHH(NGEN)=IHS
        IKK(NGEN)=IKS
        ILL(NGEN)=ILS
 1000   CONTINUE
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE ANOMSC(IH,IK,IL,IANOM,JJSYM,NSYM,ISYM)
C
C     ENTRY ANOMF(MDOC,NSYM,ISYM)
C                 MDOC  - mode of writting messages to DOC-file
C                        0 - only term, < - 0 only file, 0 < < 99 - both
C                        =< 99 - not write
C
C -P- ANOMSC - transforms h,k,l to asymmetrycal part of reciprocal space.
C -P-          before to use ANOMSC - make the firts call :
C -P-          CALL ANOMF(MDOC,NSYM,ISYM)
C
C     input  : IH,IK,IL - indices h,k,l
C              NSYM     - number operators of symmetry
C              ISYM (5,3,NSYM) - array of operators of symmetry
C     output : IH,IK,IL -   indices h,k,l from asymmetrycal part
C                           of reciprocal space
C              IANOM    - 0   +h,+k,+l
C                         1   -h,-k,-l
C              JJSYM    - number operator of symmetry :
C                              in(h,k,l) -- JJSYM --> out(h,k,l)
C ******
      COMMON/COM_ANOM/ NSEL,ICASE,ISEL(96),IHKL(3)
      INTEGER*2   ISYM(5,3,1)
      INTEGER     IHKL,HKLT(3),HKL(3),ISEL
      INTEGER     HH,HK,HL,HHS,HKS,HLS,H
      INTEGER     HKLS(3)
      CHARACTER   SYM(24)*1,LHKL(3)*1,LP*1,LM*1,LK*1,LB*1,LINE*80
      EQUIVALENCE (HKL(1),HH),(HKL(2),HK),(HKL(3),HL)
      EQUIVALENCE (HKLS(1),HHS),(HKLS(2),HKS),(HKLS(3),HLS)
      DATA LHKL/'H','K','L'/,LP/'+'/,LM/'-'/,LK/','/,LB/' '/
C ------------------------------------------------------------------
      IHKL(1)=IH
      IHKL(2)=IK
      IHKL(3)=IL
      MINNEG=4
      HHS=-10000
      DO   K=1,3
        HKLT(K)=IHKL(K)
      ENDDO
      JCASE=ICASE
      DO    I=1,NSEL
        JSYM=ISEL(I)
        NEG=0
        NZERO=0
        DO   J=1,3
          H=0
          DO    K=1,3
            H=H+ISYM(J,K,JSYM)*HKLT(K)
          ENDDO
          IF(H.LT.0) THEN 
            NEG=NEG+1
          ELSE IF(H.EQ.0) THEN
            JCASE=1
            NZERO=NZERO+1
          ENDIF 
          HKL(J)=H
        ENDDO
        IANO=1
        IF(HL.EQ.0) THEN
          IF((NEG-1).EQ.0) THEN 
            IF(HK.LE.0 ) THEN
              IANO=-1
              NEG=3-NEG-NZERO
              DO    K=1,3
                HKL(K)=-HKL(K)
              ENDDO
            ENDIF
          ELSE IF((NEG-1).GT.0) THEN
            IANO=-1
            NEG=3-NEG-NZERO
            DO    K=1,3
              HKL(K)=-HKL(K)
            ENDDO
          ENDIF
        ELSE IF(HL.LT.0) THEN 
          IANO=-1
          NEG=3-NEG-NZERO
          DO    K=1,3
            HKL(K)=-HKL(K)
          ENDDO
        ENDIF
        IF(NEG-MINNEG) 30,40,10
   30   MINNEG=NEG
        IF(NEG.NE.0) GO TO 60
          DO    K=1,3
            HKLS(K)=HKL(K)
          ENDDO
          JJSYM=JSYM
          IANOM=IANO
          IF(JCASE) 100,100,10
   40     IF(HKS.GE.0 .AND.HK.GE.0 ) GO TO 50
          IF(HK-HKS) 10,50,60
   50     IF(HH-HHS) 10,68,60
   68     IF(HL-HLS) 60,67,10
   67     IF(IANOM.GT.0) GO TO 10
   60   CONTINUE
        DO    K=1,3
          HKLS(K)=HKL(K)
        ENDDO
        JJSYM=JSYM
        IANOM=IANO
   10   CONTINUE
      ENDDO
  100 CONTINUE
      DO    K=1,3
        IHKL(K)=HKLS(K)
      ENDDO
      IH=IHKL(1)
      IK=IHKL(2)
      IL=IHKL(3)
      RETURN
C ------------------------------
      ENTRY ANOMF(MDOC,NSYM,ISYM)
C ------------------------------
      IP=0
      CALL MSGDOC(MDOC
     .    ,'     EQUIVALENT REFLEXS (WITHOUT FRIDEL-SYMMETRY)')
      ICASE=0
      NSEL=0
      DO    I=1,NSYM
        IF(I.GT.1) THEN
          DO    J=1,NSEL
            ISL=ISEL(J)
            DO     II=1,3
              DO     KK=1,3
                IF(ISYM(II,KK,ISL).NE.ISYM(II,KK,I)) GO TO 230
              ENDDO
            ENDDO
            GO TO 200
  230       CONTINUE
          ENDDO
        ENDIF
        NSEL=NSEL+1
        ISEL(NSEL)=I
        NEG=0
        IZ=0
        ICL=-4
        DO  K=1,24
          SYM(K)=LB
        ENDDO
        SYM(8)=LK
        SYM(17)=LK
        DO    J=1,3
          ICL=ICL+3
          DO    K=1,3
            ICL=ICL+2
            H=ISYM(J,K,I)
            IF(H.LT.0) THEN  
              NEG=NEG+1
              SYM(ICL)=LM
              SYM(ICL+1)=LHKL(K)
              IZ=IZ+1
            ELSE IF(H.GT.0) THEN
              SYM(ICL)=LP
              SYM(ICL+1)=LHKL(K)
              IZ=IZ+1
            ENDIF
          ENDDO
        ENDDO
        WRITE(LINE,1005) NSEL,SYM
 1005   FORMAT(5X,' ',I2,' ) ',24A1)
        CALL MSGDOC(MDOC,LINE)
        IF(NEG.EQ.IZ.OR.NEG.EQ.0) IP=IP+1
  200   CONTINUE
      ENDDO
      IF(IP.EQ.1) RETURN
      ICASE=1
      RETURN
      END


C ******
      SUBROUTINE ASCELL(ITYPE,XI,YI,ZI,NSYM,ISYM,ZMAX,XO,YO,ZO,
     .                   JSYM,TRANS,IERR)
C                                                                  
C -P- ASCELL - transforms:  XI,YI,ZI  /in frac. units/
C -P-          to asymmetric part of cell -->  XO,YO,ZO,
C
C      ITYPE = 0   0 =< XO  < 1     0 =< YO  < 1     0 =< ZO =< ZMAX
C            = 1   0 =< XO  < 1     0 =< YO =< 1/2   0 =< ZO =< ZMAX
C            = 2   0 =< XO =< 1/2   0 =< YO =< 1/2   0 =< ZO =< ZMAX
C                                                                  
C      NSYM  -  no op. symm.                      
C      ISYM - sym-matrix from space group
C  X'=ISYM(1,1,J)*X+ISYM(2,1,J)*Y+ISYM(3,1,J)*Z+ISYM(4,1,J)/ISYM(5,1,J)
C  Y'=ISYM(1,2,J)*X+ISYM(2,2,J)*Y+ISYM(3,2,J)*Z+ISYM(4,2,J)/ISYM(5,2,J)
C  Z'=ISYM(1,3,J)*X+ISYM(2,3,J)*Y+ISYM(3,3,J)*Z+ISYM(4,3,J)/ISYM(5,3,J)
C
C      JSYM     - number of operator of symmetry
C      TRANS(3) - translations
C
C            XO = [Rjsym]*XI + TRANS(1)
C            YO = [Rjsym]*YI + TRANS(2)
C            ZO = [Rjsym]*ZI + TRANS(3)
C      
C      IERR = 0   OK
C           = 1   NO SUCH POINT
C --------------------------------------------------------------
      INTEGER*2 ISYM(5,3,NSYM)
      REAL      TRANS(3)
C ---------------------------------------
C ******
      IERR=0
      DO     IS=1,NSYM
        JSYM=IS
        XO=ISYM(1,1,IS)*XI + ISYM(2,1,IS)*YI + ISYM(3,1,IS)*ZI
     .     + FLOAT(ISYM(4,1,IS))/FLOAT(ISYM(5,1,IS))
        YO=ISYM(1,2,IS)*XI + ISYM(2,2,IS)*YI + ISYM(3,2,IS)*ZI
     .     + FLOAT(ISYM(4,2,IS))/FLOAT(ISYM(5,2,IS))
        ZO=ISYM(1,3,IS)*XI + ISYM(2,3,IS)*YI + ISYM(3,3,IS)*ZI
     .     + FLOAT(ISYM(4,3,IS))/FLOAT(ISYM(5,3,IS))
        TRANS(3)=0.0
31      IF(ZO.LT.0.0) THEN
          ZO=ZO+1.0
          TRANS(3)=TRANS(3)+1.0
          GO TO 31
        ENDIF
32      IF(ZO.GE.1.0) THEN
          ZO=ZO-1.0                                             
          TRANS(3)=TRANS(3)-1.0
          GO TO 32
        ENDIF

        IF(ZO.GT.ZMAX) GO TO 200

        TRANS(1)=0.0
11      IF(XO.LT.0.0) THEN
          XO=XO+1.0
          TRANS(1)=TRANS(1)+1.0
          GO TO 11
        ENDIF
12      IF(XO.GE.1.0) THEN
          XO=XO-1.0
          TRANS(1)=TRANS(1)-1.0
          GO TO 12
        ENDIF

        TRANS(2)=0.0
21      IF(YO.LT.0.0) THEN
          YO=YO+1.0
          TRANS(2)=TRANS(2)+1.0
          GO TO 21
        ENDIF
22      IF(YO.GE.1.0) THEN
          YO=YO-1.0
          TRANS(2)=TRANS(2)-1.0
          GO TO 22
        ENDIF

        IF(ITYPE.EQ.0)         GO TO 100

        IF(YO.LE.0.5)   THEN
          IF(ITYPE.EQ.1)       GO TO 100
          IF(XO.LE.0.5) THEN
            IF(ITYPE.EQ.2)     GO TO 100
          ENDIF
        ENDIF

  200   CONTINUE
      ENDDO
C -------------------
      IERR=1
  100 CONTINUE
      RETURN
      END

C ******
      SUBROUTINE GENER(ITYPE,NGEN,IH,IK,IL,FA,FB
     *                 ,NSYM,ISYM,IPRSYM)
C
C     This subroutine used only in program "FFT"( calculate El. Dens).
C -------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM)
      REAL      FA(IPRSYM),FB(IPRSYM)
      COMMON/COM_FFT/ COSD,SIND
      REAL      COSD(25),SIND(25)
C ******
      REAL      TWOPI
      INTEGER   IFIRST
      DATA      IFIRST/0/
C     DATA      TWOPI/6.2831852/
C -------------------------------------------
      IF(IFIRST.EQ.0) THEN
        TWOPI   = 8.0*ATAN(1.0)
        AN      = TWOPI/24.
        CS      = COS(AN)
        SS      = SIN(AN)
        COSD(1) = 1.
        SIND(1) = 0.
        DO I=2,25
          COSD(I) = COSD(I-1)*CS-SIND(I-1)*SS
          SIND(I) = SIND(I-1)*CS+COSD(I-1)*SS
        ENDDO
        IFIRST = 1
      ENDIF

      NGEN = 0
      IH1  = IH(1)     
      IK1  = IK(1)     
      IL1  = IL(1)     
      FB1  = FB(1)     
      FAA  = FA(1)     
      IF(ITYPE.EQ.1) FB1 = 0.
      DO  I=1,NSYM
        JH  = ISYM(1,1,I)*IH1 +ISYM(1,2,I)*IK1 +ISYM(1,3,I)*IL1
        JK  = ISYM(2,1,I)*IH1 +ISYM(2,2,I)*IK1 +ISYM(2,3,I)*IL1
        JL  = ISYM(3,1,I)*IH1 +ISYM(3,2,I)*IK1 +ISYM(3,3,I)*IL1
        FBB = FB1      
        IT  = ISYM(4,1,I)*IH1 +ISYM(4,2,I)*IK1 +ISYM(4,3,I)*IL1
        IF(JH.LT.0) THEN              
          JH  =-JH        
          JK  =-JK        
          JL  =-JL        
          IT  =-IT        
          FBB =-FBB      
        ENDIF
        IF(NGEN.GT.0) THEN                   
          DO L=1,NGEN   
            IF(IH(L).EQ.JH.AND.IK(L).EQ.JK.AND.IL(L).EQ.JL) GO TO 100
          ENDDO
        ENDIF
        NGEN     = NGEN+1
        IH(NGEN) = JH
        IK(NGEN) = JK
        IL(NGEN) = JL
        IF(ITYPE.EQ.1.OR.I.EQ.1) THEN
          FA(NGEN) = FAA
          FB(NGEN) = FBB
        ELSE
          IF(IT.LT.0) THEN              
            IT = IABS(IT)   
            IT = 24-MOD(IT,24)                  
          ELSE
            IT = MOD(IT,24) 
          ENDIF
          IT       = IT+1       
          FA(NGEN) = FAA*COSD(IT)+FBB*SIND(IT)
          FB(NGEN) = FBB*COSD(IT)-FAA*SIND(IT)
        ENDIF
        IF(JH.EQ.0) THEN
          IF(NGEN.GT.1) THEN
            DO K=1,NGEN-1
              IF(JH.EQ.IH(K).AND.-JK.EQ.IK(K).AND.-JL.EQ.IL(K))
     .        GO TO 100
            ENDDO
          ENDIF
          NGEN     = NGEN+1
          IH(NGEN) = JH
          IK(NGEN) =-JK
          IL(NGEN) =-JL
          FA(NGEN) = FA(NGEN-1)
          FB(NGEN) =-FB(NGEN-1)
        ENDIF
  100   CONTINUE      
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE ASYM(JS,JH,JK,JL,IS,IH,IK,IL)
C
C -P- ASYM - convert indeces to asymm. part reciprocal space
C     JH,JK,JL --> IH,IK,IL , IL >= 0; if IL=0 - IK>=0; if IL=IK=0 - H > 0
C     IS = -JS if for IH,IK,IL was used  FRIDEL-SYMMETRY-OPERATION 
C
C ******
      IH=JH
      IK=JK
      IL=JL
      IS=JS
      IF(IL.LT.0) THEN
        IH=-IH
        IK=-IK
        IL=-IL
        IS=-IS
      ELSE IF(IL.EQ.0) THEN
        IF(IK.LT.0) THEN
          IH=-IH
          IK=-IK
          IS=-IS
        ELSE IF(IK.EQ.0) THEN
          IF(IH.LT.0) THEN
            IH=-IH
            IS=-IS
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE INDGEN(IHN,IKN,ILN,IHH,IKK,ILL,NGEN,IH,IK,IL,LSYM,
     *                  NSYM,ISYM,IPRSYM)
C
C -P- INDGEN - generates symmetry related indeces: 
C                                               IHH,IKK,ILL and IH,IK,IL 
C       input: IHN,IKN,ILN - index of reflection.
C              NSYM        - number od op. cryst. symmetry.
C              ISYM()      - op. cryst symmetry
C              IPRSYM      - dimension of array ISYM(5,3,.),IHH()..,IH().. 
C   IH(NSYM),IK(NSYM),IL(NSYM) - indeces from IHN,IKN,ILN by matrix ISYM 
C                    converted indeces to asymm. part reciprocal space
C   IL(NSYM) >= 0; if IL=0 - IK>=0; if IL=IK=0 - H > 0
C   LSYM(NSYM) = -1 if for IH,IK,IL was used  FRIDEL-SYMMETRY-OPERATION 
C   NGEN - number of different indeces IH,IK,IL 
C   IHH(NGEN),IKK(NGEN),ILL(NGEN) only different IH,IK,IL indeces.
C
C -------------------------------------------
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   IH(IPRSYM),IK(IPRSYM),IL(IPRSYM),LSYM(IPRSYM)
      INTEGER   IHH(IPRSYM),IKK(IPRSYM),ILL(IPRSYM)
C -------------------------------------------
C ******
      NGEN=0
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHN+ISYM(1,2,I)*IKN+ISYM(1,3,I)*ILN
        IKS=ISYM(2,1,I)*IHN+ISYM(2,2,I)*IKN+ISYM(2,3,I)*ILN
        ILS=ISYM(3,1,I)*IHN+ISYM(3,2,I)*IKN+ISYM(3,3,I)*ILN
        LS =1
        IF(ILS.LT.0) THEN
          IHS=-IHS
          IKS=-IKS
          ILS=-ILS
          LS =-LS
        ELSE IF(ILS.EQ.0) THEN
          IF(IKS.LT.0) THEN
            IHS=-IHS
            IKS=-IKS
            LS =-LS
          ELSE IF(IKS.EQ.0) THEN
            IF(IHS.LT.0) THEN
              IHS=-IHS
              LS =-LS
            ENDIF
          ENDIF
        ENDIF
        IH(I)  =IHS
        IK(I)  =IKS
        IL(I)  =ILS
        LSYM(I)=LS
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(IHS.EQ.IHH(J).AND.IKS.EQ.IKK(J).AND.
     *         ILS.EQ.ILL(J)) GO TO 1000
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHH(NGEN)=IHS
        IKK(NGEN)=IKS
        ILL(NGEN)=ILS
 1000   CONTINUE
      ENDDO
      END


      SUBROUTINE GET_NSYMP(MDOC,NSYM,NSYMP,ISYM,IPRSYM,IERR)
C --------------------------------
      INTEGER   MDOC,IERR
      INTEGER   NSYM,NSYMP,IPRSYM
      INTEGER*2 ISYM(5,3,IPRSYM)
C ---
      CHARACTER LINE*80
C --------------------------------------------
      INTEGER*2 IHT(200),IKT(200),ILT(200)
C ---------------------------------------------
      IERR=0
      NGEN=0
      IHP=1
      IKP=5
      ILP=7
      DO     I=1,NSYM
        IHS=ISYM(1,1,I)*IHP+ISYM(1,2,I)*IKP+ISYM(1,3,I)*ILP
        IKS=ISYM(2,1,I)*IHP+ISYM(2,2,I)*IKP+ISYM(2,3,I)*ILP
        ILS=ISYM(3,1,I)*IHP+ISYM(3,2,I)*IKP+ISYM(3,3,I)*ILP
        ISS=1
        CALL ASYM(ISS,IHS,IKS,ILS,JSS,JHH,JKK,JLL)
        IF(NGEN.GT.0) THEN
          DO     J=1,NGEN
            IF(JHH.EQ.IHT(J).AND.JKK.EQ.IKT(J).AND.
     *         JLL.EQ.ILT(J)) THEN
              GO TO 100
            ENDIF
          ENDDO
        ENDIF
        NGEN=NGEN+1
        IHT(NGEN)=JHH
        IKT(NGEN)=JKK
        ILT(NGEN)=JLL
 100   CONTINUE
      ENDDO
      NSYMP=NGEN
      RETURN
      END

C ******
      SUBROUTINE GET_TWOFOLD_PATT(NSYM,ISYM,ITWOX,ITWOY)
C --------------------------------------------
C --------------------------------------------
      INTEGER   NSYM,NZ,IZMAX
      INTEGER*2 ISYM(5,3,NSYM)
C ******
C ---------------------------------------------
      ITWOX = 0
      ITWOY = 0

      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
          IF(ISYM(2,1,I).EQ.0.AND.
     *       ISYM(3,1,I).EQ.0.AND.ISYM(3,2,I).EQ.0.AND.
     *       ISYM(2,1,I).EQ.0.AND.ISYM(3,1,I).EQ.0.AND.
     *       ISYM(3,1,I).EQ.0                          ) THEN

            IF(ISYM(1,1,I).EQ. 1.AND.ISYM(2,2,I).EQ.-1.AND.
     *         ISYM(3,3,I).EQ.-1) THEN
               ITWOX = 1
            ENDIF

            IF(ISYM(1,1,I).EQ.-1.AND.ISYM(2,2,I).EQ.1.AND.
     *         ISYM(3,3,I).EQ.-1) THEN
               ITWOY = 1
            ENDIF

          ENDIF
        ENDDO
      ENDIF

      RETURN
      END

C ******
      SUBROUTINE GET_NSYMZ(NSYM,ISYM,NSYMZ)
C -P- GET_NSYMZ computes symmetry Z-axis in Patterson 
      INTEGER*2 ISYM(5,3,1)
C ******
C --------------------------
      NSYMZ=1
      IF(NSYM.GT.1) THEN
        DO I=2,NSYM
C         rotation around Z , angle 180
          IF(ISYM(1,1,I).EQ.-1.AND.ISYM(2,1,I).EQ. 0.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 0.AND.ISYM(2,2,I).EQ.-1.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=2
            ELSE IF(NSYMZ.EQ.3) THEN
              NSYMZ=6
            ELSE IF(NSYMZ.EQ.4) THEN

            ENDIF 
          ENDIF 
C         rotation around Z , angle 90
          IF(ISYM(1,1,I).EQ. 0.AND.ISYM(2,1,I).EQ.-1.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 1.AND.ISYM(2,2,I).EQ. 0.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=4
            ELSE IF(NSYMZ.EQ.2) THEN 
              NSYMZ=4
            ELSE IF(NSYMZ.EQ.3) THEN
              NSYMZ=12
            ELSE IF(NSYMZ.EQ.6) THEN
              NSYMZ=12
            ENDIF 
          ENDIF 
C         rotation around Z , angle 120
          IF(ISYM(1,1,I).EQ. 0.AND.ISYM(2,1,I).EQ.-1.AND.
     *       ISYM(3,1,I).EQ. 0.AND.
     *       ISYM(1,2,I).EQ. 1.AND.ISYM(2,2,I).EQ.-1.AND.
     *       ISYM(3,2,I).EQ. 0.AND.
     *       ISYM(1,3,I).EQ. 0.AND.ISYM(2,3,I).EQ. 0.AND.
     *       ISYM(3,3,I).EQ. 1) THEN
            IF(NSYMZ.EQ.1) THEN 
              NSYMZ=3
            ELSE IF(NSYMZ.EQ.2) THEN
              NSYMZ=6
            ELSE IF(NSYMZ.EQ.4) THEN
              NSYMZ=12
            ENDIF 
          ENDIF 
        ENDDO
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE CHECK_REF(NSYM,ISYM,IFX,IFY,IFZ)             
C -P- CHECK_REF check possibility to refine coords: for x IFX = 1 - yes, 0 - no
      INTEGER*2 ISYM(5,3,1)
C ******
C ------------------------------------------------
      IFX=0
      IFY=0
      IFZ=0
      IF(NSYM.LE.1) RETURN
      IX=13
      IY=17
      IZ=19
      DO I=2,NSYM
        IXX=ISYM(1,1,I)*IX+ISYM(2,1,I)*IY+ISYM(3,1,I)*IZ
        IYY=ISYM(1,2,I)*IX+ISYM(2,2,I)*IY+ISYM(3,2,I)*IZ
        IZZ=ISYM(1,3,I)*IX+ISYM(2,3,I)*IY+ISYM(3,3,I)*IZ
        IF((IX-IXX).NE.0) IFX=1
        IF((IY-IYY).NE.0) IFY=1
        IF((IZ-IZZ).NE.0) IFZ=1
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE GEE(RH,RAD,GGG)
C
C -P- GEE - calc structure factor of scattering from Sphere 
C           with radius=RAD
C     RH      - in 1/Angstrom  (4pi*sin(theta))/lambda
C
      REAL RH,RAD,GGG
C ******
      REAL TWOPI
      DATA TWOPI/6.2831832/
C -------------------------------------
C     TWOPI=8.0*ATAN(1.0)
      T=RH*RAD*TWOPI
      COST=COS(T)
      SINT=SIN(T)
      T3=T*T*T
      GGG=(2.0*TWOPI*RAD*RAD*RAD*(SINT-T*COST))/T3
      RETURN
      END

C ******
      SUBROUTINE GAUSS_TRP(RH,RAD,GGG)
C
C -P- GAUSS_TRP - calc structure factor of scattering for Gaussian  
C                 with width = RAD
C     RH      - in 1/Angstrom  (4pi*sin(theta))/lambda
C
      REAL RH,RAD,GGG
C ******
      RSQ= RH*RH
      B  = RAD*RAD
      GGG=EXP(-B*RSQ)*1000.0
      RETURN
      END

C ******
      SUBROUTINE CALC_ORIG_AV(MDOC,NORIG,SOR,IPRORG
     *   ,NSYM,ISYM,IPRSYM,IERR)
C
C -P- CALC_ORIG_PS - creats list of equivalent origins.
C                    NORIG - number of origins. 
C                    SOR(3,i) - vector of origin (for example : 0.5,0.0,0.5)  
C                               only positive components.
C                               include vector: (0,0,0)
C -------------------------------------------------------------
      REAL      SOR(3,IPRORG)
C ******
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   M(3,3),IS(3),JS,ID(6)
      CHARACTER LINE*80
      DATA      ID/0,6,4,8,3,9/
C                   1/2 1/3 2/3 1/4 3/4 
C -------------------------------------------------------------
      NORIG=1
      SOR(1,1)=0.0  
      SOR(2,1)=0.0
      SOR(3,1)=0.0
      CALL CHECK_REF(NSYM,ISYM,IFX,IFY,IFZ)
      IF(NSYM.LE.1) GO TO 100
      DO K1=1,6
      DO K2=1,6
      DO K3=1,6
        IF(K1.NE.1.OR.K2.NE.1.OR.K3.NE.1) THEN
          IS(1)=ID(K1)
          IS(2)=ID(K2)
          IS(3)=ID(K3)

          IF(IFX.EQ.0.AND.IS(1).NE.0) GO TO 200
          IF(IFY.EQ.0.AND.IS(2).NE.0) GO TO 200
          IF(IFZ.EQ.0.AND.IS(3).NE.0) GO TO 200

          DO I=1,NSYM-1
          DO J=I+1,NSYM
            DO K=1,3
            DO L=1,3
              M(K,L)=ISYM(K,L,I)-ISYM(K,L,J)
            ENDDO
            ENDDO
            DO K=1,3
              JS=M(1,K)*IS(1)+M(2,K)*IS(2)+M(3,K)*IS(3)
              IF(MOD(JS,12).NE.0) GO TO 200 
            ENDDO
          ENDDO
          ENDDO
          IF(NORIG.GE.IPRORG) GO TO 100
          NORIG=NORIG+1
          SOR(1,NORIG)=IS(1)/12.0
          SOR(2,NORIG)=IS(2)/12.0
          SOR(3,NORIG)=IS(3)/12.0
 200      CONTINUE
        ENDIF
      ENDDO
      ENDDO
      ENDDO
 100  CONTINUE

c      WRITE(*,*) ' NOR=',NORIG
c      DO I=1,NORIG
c        WRITE(*,*) SOR(1,I),SOR(2,I),SOR(3,I)
c      ENDDO

      RETURN
      END

C ******
      SUBROUTINE PACK(IND,IH,IK,IL)
C
C -P- PACK - pack indices h,k,l --> IND
C
      INTEGER*4 IH,IK,IL,IND

C ******
      IND = ((IL+512)*1024+IK+512)*1024+IH+512
      RETURN
      END  

C ******
      SUBROUTINE UNPACK(IND,IH,IK,IL)
C
C -P- UNPACK - unpack IND --> indices h,k,l 
C
      INTEGER*4 IH,IK,IL,IND
C ******
      ITEMP1 = IND/(1024*1024)                                       
      IL     = ITEMP1-512   
      ITEMP1 = ITEMP1*1024*1024                                  
      ITEMP1 = IND-ITEMP1
      ITEMP2 = ITEMP1/1024                       
      IK     = ITEMP2-512                                                      
      ITEMP2 = ITEMP2*1024                                     
      ITEMP2 = ITEMP1-ITEMP2                     
      IH     = ITEMP2-512              
      RETURN
      END

C -P-
C -P------ others useful subroutines  --------------------
C -P-
      SUBROUTINE SET_BYTE
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C --------------------------
      INTEGER   IN4
      INTEGER*2 IN2(2)
      EQUIVALENCE (IN4,IN2(1))
C -----------------------
      CHARACTER CHAR*1
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----
      IN2(1)=100
      IN2(2)=0
      IF(IN4.EQ.100) THEN
C          IN4
C          2 1
        IBYTE1=1
        IBYTE2=2
      ELSE
C          IN4
C          1 2
        IBYTE1=2
        IBYTE2=1
      ENDIF
C -----------------------------------------
      CHAR='0'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_DIG_0=ICH
      CHAR='A'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_A_CAP=ICH
      CHAR='a'
      ICH=0
      CH2(IBYTE1:IBYTE1)=CHAR
      ISTART_A_LOW=ICH
      RETURN
      END

C ******
      SUBROUTINE CHECK_LINE(IMODE,LINE)
C ------------------------------------------
C -P- CHECK_LINE - check and convert symbols of line.
C               MODE  0  only check
C                    -1  convert symbols to low case.
C                     1  to upper
C ---------------------------------------------
      CHARACTER LINE*(*)
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER   ICH4
      CHARACTER CHAR*1,TYPE*1
C -----------------------------------------
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0) THEN
        DO I=1,LEN       
          ICH4=0
          CHAR=LINE(I:I) 
          CALL CHKSMB(CHAR,TYPE)
          IF(TYPE.EQ.'l'.AND.IMODE.EQ.1) THEN
            CALL CHTOINT(CHAR,ICH4)
C           ICH4=ICH4 - 32
            ICH4=ICH4 - (ISTART_A_LOW - ISTART_A_CAP)
            CALL INTTOCH(CHAR,ICH4)
          ELSE IF(TYPE.EQ.'L'.AND.IMODE.EQ.-1) THEN
            CALL CHTOINT(CHAR,ICH4)
C           ICH4=ICH4 + 32
            ICH4=ICH4 + (ISTART_A_LOW - ISTART_A_CAP)
            CALL INTTOCH(CHAR,ICH4)
          ELSE IF(TYPE.EQ.'?') THEN
            CHAR = ' '
          ENDIF
          LINE(I:I) = CHAR
        ENDDO
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE CHKSMB(CHAR,TYPE)
C ------------------------------------------
C -P- CHKSMB - check symbol.
C
C  input: CHAR - one symbol.   
C  output TYPE - one symbol
C
C  if   CHAR = 'A' -- 'Z'           TYPE = 'L'    
C       CHAR = 'a' -- 'z'           TYPE = 'l'    
C       CHAR = '0' -- '9'           TYPE = 'D'    
C       CHAR = '+' or '-'           TYPE = 'S'
C       CHAR = '*' or '/' or
C              '=' or '.'           TYPE = 'O'
C       CHAR = ' '                  TYPE = 'B'
C       CHAR = any printed symbol   TYPE = 'C'
C  else             Type = '?'
C ---------------------------------------------
      CHARACTER CHAR*1,TYPE*1
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER   ICH
      CHARACTER CH*1,CH1*1
C -----------------------------------------
      TYPE='?'
      ICH=0
      CH=CHAR
      CALL LENSTR_BL(CH,LEN)
      IF(CH.EQ.' '.AND.LEN.LE.0) LEN=1
      IF(LEN.LE.0) THEN
        TYPE='?'
        RETURN
      ENDIF

      CALL CHTOINT(CH,ICH)

C      IF(ICH.GE. 65 .AND.ICH.LE. 90 ) THEN
C        TYPE='L'
C      ELSE IF(ICH.GE. 97 .AND.ICH.LE.122 ) THEN
C        TYPE='l'
C      ELSE IF(ICH.GE. 48 .AND.ICH.LE. 57 ) THEN
C        TYPE='D'

      ISF_CAP=ISTART_A_CAP+25
      ISF_LOW=ISTART_A_LOW+25
      ISF_DIG=ISTART_DIG_0+9
      
      IF(ICH.GE.ISTART_A_CAP.AND.ICH.LE.ISF_CAP ) THEN
        TYPE='L'
      ELSE IF(ICH.GE.ISTART_A_LOW.AND.ICH.LE.ISF_LOW ) THEN
        TYPE='l'
      ELSE IF(ICH.GE.ISTART_DIG_0.AND.ICH.LE.ISF_DIG ) THEN
        TYPE='D'
      ELSE IF(CH.EQ.'+'.OR.CH.EQ.'-') THEN
        TYPE='S'
      ELSE IF(CH.EQ.'*'.OR.CH.EQ.'/'.OR.CH.EQ.'.'.OR.CH.EQ.'=') THEN
        TYPE='O'
      ELSE IF(CH.EQ.' ') THEN
        TYPE='B'
      ELSE IF(CH.EQ.'''') THEN
C             '
        TYPE='C'
      ELSE IF(CH.EQ.'_') THEN
        TYPE='U'
      ELSE IF(CH.EQ.'\\') THEN
C             \
        TYPE='C'
      ELSE 
        IF(CH.EQ.'!'.OR.CH.EQ.'@'.OR.CH.EQ.'#'.OR.CH.EQ.'$'
     * .OR.CH.EQ.'"'.OR.CH.EQ.'>'.OR.CH.EQ.'%'.OR.CH.EQ.'^'
     * .OR.CH.EQ.'`'.OR.CH.EQ.'?'.OR.CH.EQ.'('.OR.CH.EQ.'['
     * .OR.CH.EQ.'&'.OR.CH.EQ.'<'.OR.CH.EQ.')'.OR.CH.EQ.'~'
     * .OR.CH.EQ.']'.OR.CH.EQ.'{'.OR.CH.EQ.'}'.OR.CH.EQ.'|'
     * .OR.CH.EQ.';'.OR.CH.EQ.':'.OR.CH.EQ.',') THEN
          TYPE='C'
        ENDIF
      ENDIF
      RETURN
      END



C ******
      SUBROUTINE CHTOINT(CHAR,ICHAR)
C ------------------------------------------
C -P- CHTOINT - convert a character to integer
C ---------------------------------------------
      CHARACTER CHAR*1
      INTEGER*4 ICHAR
C ----------------------------------------
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----------------------------------------
      ICH = 0
      CH2(IBYTE1:IBYTE1) = CHAR
      ICHAR = ICH
      RETURN
      END

C ******
      SUBROUTINE INTTOCH(CHAR,ICHAR)
C ------------------------------------------
C -P- CHTOINT - convert a character to integer
C ---------------------------------------------
      CHARACTER CHAR*1
      INTEGER*4 ICHAR
C ----------------------------------------
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ******
      INTEGER*2 ICH
      CHARACTER CH2*2
      EQUIVALENCE (CH2,ICH)
C -----------------------------------------
      ICH  = ICHAR
      CHAR = CH2(IBYTE1:IBYTE1)
      RETURN
      END

C ******
      SUBROUTINE CHCLOCK(LINE)
C
C -P- CHCLOCK - converts clock and data to characters string /LINE*20/
C     example out string : 'D: 2.04.05/ 5.03.86 '
C
C ******
      CHARACTER LINE*20
      INTEGER IH(7)
C ----------------------------------------------------------------------
      CALL CLOCK(IH)
      ITEMP = IH(7)/100
      IH(7) = IH(7)-ITEMP*100
      WRITE(LINE,1) IH(4),IH(3),IH(2),IH(5),IH(6),IH(7) 
   1  FORMAT('D:',I2,'.',I2,'.',I2,'/',I2,'.',I2,'.',I2,1X)
      RETURN
      END

C ******
      SUBROUTINE LENSTR_BL(STRING,NL)
C -P- LENSTR - gives length of string.
      INTEGER*4 NL
      CHARACTER STRING*(*)
C -------------------------------------
      N  = LEN(STRING)
      NL = N
      DO 10 I=N,1,-1
        IF(STRING(NL:NL).NE.' ') GO TO 20      
        NL = NL-1
   10 CONTINUE
   20 RETURN
      END

      SUBROUTINE GIVE_STRING_LENGTH(STRING,LENGTH)
C -------------------------------------
      INTEGER LENGTH
      CHARACTER STRING*(*)
C -------------------------------------
      LENGTH = LEN(STRING)
      RETURN
      END

      SUBROUTINE REMOVE_PATH(STRING)
C -------------------------------------
      CHARACTER STRING*(*),TEMP*256
C -------------------------------------
      CALL LENSTR_BL(STRING,LEN)
      IF(LEN.LE.1) RETURN
      NL = LEN
      DO I=LEN,1,-1
        IF(STRING(NL:NL).EQ.'/') GO TO 20      
        NL = NL-1
      ENDDO
   20 CONTINUE
      IF(NL.GE.1.AND.NL.LT.LEN) THEN
        TEMP = STRING(NL+1:LEN)
        STRING = TEMP
      ENDIF
      RETURN
      END

C -P-
C -P------ vector-matrix subroutines --------------------
C -P-

C ******
      SUBROUTINE VMOD(X,D)
C -P- VMOD - D=!X!  X(3) - vector     
      REAL X(3)
C ******
      X2 = X(1)*X(1)
      Y2 = X(2)*X(2)
      Z2 = X(3)*X(3)
      D  = SQRT(X2+Y2+Z2)
      RETURN
      END

C ******
      SUBROUTINE VUNIT(X,Y,IERR)
C -P- VUNIT -  Y=X/!X!    if !X!=0 then Y=(1,0,0) and IERR=1       
      REAL X(3),Y(3)
C ******
      IERR=0
      CALL VMOD(X,D)
      IF(D.GT.0.0) THEN
        D    = 1./D
        Y(1) = X(1)*D
        Y(2) = X(2)*D
        Y(3) = X(3)*D
      ELSE
        IERR = 1
        Y(1) = 1.0
        Y(2) = 0.0
        Y(3) = 0.0
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE VSCAL(X,S,Y)
C -P- VSCALE - Y=S*X  S - coefficient
      REAL X(3),Y(3)
C ******
      Y(1) = X(1)*S
      Y(2) = X(2)*S
      Y(3) = X(3)*S
      RETURN
      END

C ******
      SUBROUTINE VADD(X,Y,Z)
C -P- VADD - Z=X+Y
      REAL X(3),Y(3),Z(3)
C ******
      Z(1) = X(1)+Y(1)
      Z(2) = X(2)+Y(2)
      Z(3) = X(3)+Y(3)
      RETURN
      END

C ******
      SUBROUTINE VSUB(X,Y,Z)
C -P- VSUB - Z=X-Y
      REAL X(3),Y(3),Z(3)
C ******
      Z(1) = X(1)-Y(1)
      Z(2) = X(2)-Y(2)
      Z(3) = X(3)-Y(3)
      RETURN
      END

C ******
      SUBROUTINE VPROD(X,Y,S)
C -P- VPROD - S = (X.Y)  S=X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
      REAL X(3),Y(3)
C ******
      S = X(1)*Y(1)+X(2)*Y(2)+X(3)*Y(3)
      RETURN
      END

C ******
      SUBROUTINE VCOPY(X,Y)
C -P- VCOPY - Y <= X
      REAL X(3),Y(3)
C ******
      Y(1) = X(1)
      Y(2) = X(2)
      Y(3) = X(3)
      RETURN
      END

C ******
      SUBROUTINE VMULT(X,Y,Z)
C -P- VMULT Z = X*Y    
      REAL X(3),Y(3),Z(3)
C ******
      VX   = X(2)*Y(3)-X(3)*Y(2)
      VY   = X(3)*Y(1)-X(1)*Y(3)
      Z(3) = X(1)*Y(2)-X(2)*Y(1)
      Z(1) = VX
      Z(2) = VY
      RETURN
      END

C ******
      SUBROUTINE MCOPY(X,Y)      
      REAL X(9),Y(9)
C -P- MCOPY - [Y] <= [X]
C                             ! 11 21 31 !
C            [Y] =[X]     X = ! 12 22 32 !
C                             ! 13 23 33 !
C ******
      DO     I=1,9    
        Y(I) = X(I) 
      ENDDO
      RETURN        
      END           

C ******
      SUBROUTINE MATMLT(X,Y,Z)
      REAL X(3,3),Y(3,3),Z(3,3)
C -P- MATMLT - [Z] =[X] [Y]
C                               ! 11 21 31 !
C           [Z] =[X] [Y]    X = ! 12 22 32 !
C                               ! 13 23 33 !
C ******
      DO     I=1,3
      DO     J=1,3
        Z(I,J)=0.0
        DO     K=1,3
          Z(I,J) = Z(I,J)+X(K,J)*Y(I,K)
        ENDDO
      ENDDO
      ENDDO
      RETURN
      END

C ******
      SUBROUTINE MVMULT(AM,X,Y)
      REAL X(3),Y(3),AM(3,3)
C -P- MVMULT -  Y =[AM] X
C                             !1!   ! 11 21 31 !    !1!
C           Y =[AM] X       Y !2! = ! 12 22 32 !  X !2!
C                             !3!   ! 13 23 33 !    !3!
C ******
      Y(1) = AM(1,1)*X(1)+AM(2,1)*X(2)+AM(3,1)*X(3)
      Y(2) = AM(1,2)*X(1)+AM(2,2)*X(2)+AM(3,2)*X(3)
      Y(3) = AM(1,3)*X(1)+AM(2,3)*X(2)+AM(3,3)*X(3)
      RETURN
      END

C ******
      SUBROUTINE MTRANS(AM,BM)
      REAL AM(3,3),BM(3,3)
C -P- MTRANS - matrix transposition
C           ! 11 21 31 !            ! 11 12 13 !  
C     AM  = ! 12 22 32 !  --> BM =  ! 21 22 33 !
C           ! 13 23 33 !            ! 31 32 33 !    
C     It is posible to use CALL MTRANS(AM,AM)
C ******
      BM(1,1) = AM(1,1)
      BM(2,2) = AM(2,2)
      BM(3,3) = AM(3,3)
      T       = AM(1,2)
      BM(1,2) = AM(2,1)
      BM(2,1) = T
      T       = AM(1,3)
      BM(1,3) = AM(3,1)
      BM(3,1) = T
      T       = AM(3,2)
      BM(3,2) = AM(2,3)
      BM(2,3) = T
      RETURN
      END

C ******
      SUBROUTINE INVERT(S,SS,IERR)
C
C -P- INVERT - invertion matrix S(3,3) , result marix SS(3,3)
C
C -------------
      REAL S(3,3),SS(3,3)
      INTEGER IERR
C ******
C -------------------------------
      IERR=0
      DO    I=1,3
      DO    J=1,3
        SS(I,J) = 0.0
      ENDDO
      ENDDO
C
      DET = 0.0

      DO    J=1,3
      DO    I=1,3
        IF(I.EQ.1) THEN
          I1=2
          I2=3
        ELSE IF(I.EQ.2) THEN
          I1=1
          I2=3
        ELSE
          I1=1
          I2=2
        ENDIF
        IF(J.EQ.1) THEN
          J1=2
          J2=3
        ELSE IF(J.EQ.2) THEN
          J1=1
          J2=3
        ELSE
          J1=1
          J2=2
        ENDIF
        SS(I,J) = (-1)**(I+J)*(S(J1,I1)*S(J2,I2)-
     *            S(J2,I1)*S(J1,I2))
      ENDDO
      ENDDO

      DET = S(1,1)*SS(1,1)+S(1,2)*SS(2,1)+S(1,3)*SS(3,1)

      IF(ABS(DET).LT.1.0E-8) THEN
        IERR = 1
        DET  = 0.0
      ELSE
        DET = 1./DET
      ENDIF
      DO    I=1,3
      DO    J=1,3
        SS(I,J) = DET*SS(I,J)
      ENDDO
      ENDDO

      RETURN
      END

      SUBROUTINE MDET(A,DET)
C ------------------------------
      REAL A(3,3)
C ------------------------------
      DET  =  A(1,1)*(A(2,2)*A(3,3) - A(3,2)*A(2,3))
     *      - A(2,1)*(A(1,2)*A(3,3) - A(3,2)*A(1,3))
     *      + A(3,1)*(A(1,2)*A(2,3) - A(2,2)*A(1,3))
C ---
      RETURN
      END


C ******
      SUBROUTINE POLTOC(AM,VECT1,VECT2,R)
C     R =[AM}* VECT , where VECT=(VECT1*cos(VECT2),VECT1*sin(VECT2),0)
      REAL AM(3,3),R(3)
C ******
      X    = VECT1*COS(VECT2)
      Y    = VECT1*SIN(VECT2)
      R(1) = AM(1,1)*X+AM(2,1)*Y
      R(2) = AM(1,2)*X+AM(2,2)*Y
      R(3) = AM(1,3)*X+AM(2,3)*Y
      RETURN
      END


C ******
      SUBROUTINE CTOMAT(X,F,T,Z)
C                               ! cosT -sinT*cosF  sinT*sinF !
C           [Z] =[X] [Y]    X = ! sinT  cosT*cosF -cosT*sinF !
C                               !  0       sinF     cosF     !
      REAL X(3,3),Y(3,3),Z(3,3)
C ******
      COST   = COS(T)
      SINT   = SIN(T)
      COSF   = COS(F)
      SINF   = SIN(F)
      Y(1,1) = COST
      Y(2,1) =-SINT*COSF
      Y(3,1) = SINT*SINF
      Y(1,2) = SINT
      Y(2,2) = COST*COSF
      Y(3,2) =-COST*SINF
      Y(1,3) = 0.
      Y(2,3) = SINF
      Y(3,3) = COSF
      CALL MATMLT(X,Y,Z)
      RETURN
      END
C -P-
C -P------ read/write subroutines  --------------------
C -P-
C ******
      SUBROUTINE ORCRD(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.crd') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.64) LEN=64
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE/CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) THEN
        IERR=4
        CLOSE(IN)
      ENDIF
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERR: END OF FILE /.CRD/')
      IERR=2
      RETURN
      END


C ******
      SUBROUTINE OPEN_CRD(MDOC,IN,FNAME,IERR)
C
C -P- ORCRD - OPEN OF FILE-CRD FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.cif') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE-COORDS /CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      RETURN
      END

C ******
      SUBROUTINE OWCRD(MDOC,IOUT,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P-  OWCRD - OPEN OF FILE-CRD FOR WRITE
C
      INTEGER   IOUT,MDOC,ILINE,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.crd') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='crd'
      PATH=' '
      CALL OPENFW(IOUT,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 9100
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.65) LEN=65
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('OUT-FILE/CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL WR_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) GO TO 9000
      RETURN
9100  CONTINUE
      CALL MSGERR(MDOC,' ERR: OPEN OF FILE /.CRD/')
      IERR=1
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.CRD/')
      CLOSE(IOUT)
      IERR=2
      RETURN
      END

C ******
      SUBROUTINE RD_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD_TTL_CRD - reads title of file to common/CRDINF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRDFRM/ NCRD_CSF,CSF_NE,CSF_RAD
     *               ,CSF_A1,CSF_B1,CSF_A2,CSF_B2
     *               ,CSF_A3,CSF_B3,CSF_A4,CSF_B4
     *               ,CSF_C,CSF_FI,CSF_FII,CSF_ATOM
      CHARACTER       CSF_ATOM(IPRAT_SF)*4
      REAL            CSF_A1(IPRAT_SF),CSF_B1(IPRAT_SF)
      REAL            CSF_A2(IPRAT_SF),CSF_B2(IPRAT_SF)
      REAL            CSF_A3(IPRAT_SF),CSF_B3(IPRAT_SF)
      REAL            CSF_A4(IPRAT_SF),CSF_B4(IPRAT_SF)
      REAL            CSF_C (IPRAT_SF),CSF_RAD(IPRAT_SF)
      REAL            CSF_FI(IPRAT_SF),CSF_FII(IPRAT_SF)
      REAL            CSF_NE(IPRAT_SF)
C ---------------------------------------------------------
      COMMON /CRST_PDB/ CS_SCALE,CS_U
     *                 ,CS_TEMPER,CS_WAVEL
     *                 ,CS_RES_MIN,CS_RES_MAX 
     *                 ,CS_RFAC_ALL,CS_RFAC_OBS
     *                 ,CS_SIGMA_I,CS_SIGMA_F 
     *                 ,CS_MODEL_PDB
     *                 ,CS_CD_PDB,CS_CD_NDB,CS_CD_CSD
     *                 ,CS_NAME_PDB
     *                 ,CS_DATE_PDB,CS_DATE_NDB
     *                 ,CS_DATE_CREAT,CS_TITLE
     *                 ,CS_RESL_PDB,CS_RFAC_PDB
     *                 ,CS_PROGRAM,CS_METHOD
      REAL  CS_SCALE(3,3)
      REAL  CS_U(3)
      REAL  CS_TEMPER
      REAL  CS_WAVEL
      REAL  CS_RES_MIN
      REAL  CS_RES_MAX 
      REAL  CS_RFAC_ALL
      REAL  CS_RFAC_OBS
      REAL  CS_SIGMA_I
      REAL  CS_SIGMA_F 
      INTEGER*4 CS_MODEL_PDB
      CHARACTER CS_CD_PDB    *8
      CHARACTER CS_CD_NDB    *8
      CHARACTER CS_CD_CSD    *8
      CHARACTER CS_NAME_PDB  *40
      CHARACTER CS_DATE_PDB  *9
      CHARACTER CS_DATE_NDB  *9
      CHARACTER CS_DATE_CREAT*20
      CHARACTER CS_TITLE     *80
      CHARACTER CS_RESL_PDB  *40
      CHARACTER CS_RFAC_PDB  *40
      CHARACTER CS_PROGRAM   *40
      CHARACTER CS_METHOD    *40
C ---
C       Fractional coord. system.        Ortogonal coord system of data_PDB
C
C        X                     | 11  12  13 |    X                  U(1)
C        Y  (fract)   =  SCALE | 21  22  23 |    Y  (Cartesian)  +  U(2)
C        Z                     | 31  32  33 |    Z                  U(3)
C
C  CS_SCALE 
C  CS_U
C ---
C  CS_MODEL_PDB -
C  CS_CD_PDB    -  PDB code /_database_2.code_PDB/
C  CS_CD_NDB    -  NDB code /_database_2.code_NDB/
C  CS_CD_CSD    -  NDB code /_database_2.code_CSD/
C  CS_NAME_PDB  -  PDB name /_struct_keywords.text/  (PROTEIN,DNA,RNA,...)
C  CS_DATE_PDB  -  PDB creating date /_database_PDB_rev.data_original /
C  CS_DATE_NDB  -  NDB creating date 
C  CS_DATE_CREAT-  file creation date /_audit.creation_date /
C  CS_TITLE     -  title /_struct.title '5"-D(*CP*GP*CP*G)-3",SPERMIN' /
C  CS_RESL_PDB  -  resolution from PDB_remark
C  CS_RFAC_PDB  -  R-factor   from PDB_remark
C  CS_PROGRAM   -  refinement program name / _computing.structure_refinement / 
C  CS_METHOD    -   /_expt.method 'X_RAY DIFFRACTION'/ 
C  CS_TEMPER    -   /_diffrn.ambient_temp 293 /
C  CS_WAVEL     -   /_diffrn_radiation.wavelength  1.5418 /
C  CS_RES_MIN   -   /_refine.ls_d_res_low  /
C  CS_RES_MAX   -   /_refine.ls_d_res_high /
C  CS_RFAC_ALL  -   /_refine.ls_R_factor_all/
C  CS_RFAC_OBS  -  t.e. with cutoff /_refine.ls_R_factor_obs/
C  CS_SIGMA_I   -   / ? _reflns.observed_criterion  '>2sigma(I)' /
C  CS_SIGMA_F   -
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2,TYPE*1
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24

      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*80,CH10*10,CHAR1*1
C -------------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
C -------------------------------------------------------------------
      DO I=1,80
        CR_TITLE(I:I)   = ' '
        TITLE(I:I)   = ' '
      ENDDO
      DO I=1,40
        CR_NAME_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR_CELL(1)=1.0
      CR_CELL(2)=1.0
      CR_CELL(3)=1.0
      CR_CELL(4)=PI/2.0
      CR_CELL(5)=PI/2.0
      CR_CELL(6)=PI/2.0
      CR_SCALE(1,1)=1.0
      CR_SCALE(1,2)=0.0
      CR_SCALE(1,3)=0.0
      CR_SCALE(2,1)=0.0
      CR_SCALE(2,2)=1.0
      CR_SCALE(2,3)=0.0
      CR_SCALE(3,1)=0.0
      CR_SCALE(3,2)=0.0
      CR_SCALE(3,3)=1.0
      CR_U(1)      =0.0
      CR_U(2)      =0.0
      CR_U(3)      =0.0
      CR_FLAG_HA='N'
      CR_CF1 = 0.0
      CR_CF2 = 0.0
      CR_TOV = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR_DATE_PDB   = 'XX-XXX-XX'
      CR_CD_PDB     = 'XXXX'
      CR_TITLE(1:9)   = '?   ?   ?'
      CR_TITLE(69:78) = '?    ?    '
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = '.'
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = 'P 1        '
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG  =0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      = '.'
      CR_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C --------------------
      CS_TEMPER     = 0.0
      CS_WAVEL      = 0.0
      CS_RES_MIN    = 0.0
      CS_RES_MAX    = 0.0
      CS_RFAC_ALL   = 0.0
      CS_RFAC_OBS   = 0.0
      CS_SIGMA_I    = 0.0
      CS_SIGMA_F    = 0.0
      CS_CD_NDB     = '?'
      CS_CD_CSD     = '?'
      CS_DATE_NDB   = '?'
      CS_DATE_CREAT = '?'
      CS_PROGRAM    = '?'
      CS_METHOD     = '?'
C ------------------------------------------
      INCS=0
      CALL SET_NCS(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      IEND = -1
      ISOP =  0
C -------
  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9).EQ.'_entry.id')) THEN
          CR_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR_CD_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB')) THEN
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          CR_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *    (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR_DATE_PDB)         
          ELSE
            CR_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
C          CR_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:27).EQ.'_diffrn.ambient_temperature') THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:28).EQ.'_diffrn_radiation.wavelength') THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF

        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a') THEN
            CR_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN
            CR_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN
            CR_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN
            CR_CELL(4) = FDATA
            CR_CELL(4) = CR_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN
            CR_CELL(5) = FDATA
            CR_CELL(5) = CR_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            CR_CELL(6) = FDATA
            CR_CELL(6) = CR_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:23).EQ.'space_group_n') THEN
            IF(LEND.GT.11) LEND=11
            CR_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE IF(ITEM(11:15).EQ.'Int_T') THEN
            CR_NSPGR = IDATA
          ELSE IF(ITEM(11:19).EQ.'cell_sett') THEN
            CR_SETT = IDATA
          ELSE IF((ITEM(11:19).EQ.'equiv_pos').OR.
     *            (ITEM(11:19).EQ.'equiv.pos')) THEN
c            IF(I.EQ.N_CIF) THEN
              LINE=DATA(1:LEND)
              ISOP=ISOP+1
              CALL SYMFR2_BL(MDOC,LINE,ISOP,NSYMR,ISYM,NSMAX,IERR)
              IF(IERR.GT.0) THEN
                CALL MSGERR(MDOC
     *          ,' ERR: WRONG NUMBER OF "_symmetry_equiv"-STRING')
                IERR=1
                RETURN
              ENDIF
              NSYM   =ISOP
              CR_NSYM=ISOP
c            ENDIF
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN
          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA =FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            INCS=INCS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS(MDOC,NCMAX,INCS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_struct_asym') THEN
          IF(I.EQ.1) THEN
            IGOLD  = 0
            ICHOLD = 0
            INC    = 0
            NCSF   = '.'
            MULT   = 1
            GID    = '.   '            
          ENDIF
          IF(ITEM(14:15).EQ.'id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              IGOLD  = IDATA
            ELSE
              GID = CH2//'  '
            ENDIF
          ELSE IF(ITEM(14:22).EQ.'entity_id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              ICHOLD =IDATA
            ENDIF
          ELSE IF(ITEM(14:27).EQ.'nc_symmetry_id') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              INC=0
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)')INC
            ENDIF
          ELSE IF(ITEM(14:29).EQ.'nc_symmetry_flag') THEN
            NCSF =DATA(1:1)
          ELSE IF(ITEM(14:25).EQ.'multiplicity') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              MLT=1
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)') MLT
            ENDIF
          ELSE IF(ITEM(14:28).EQ.'PDB_chain_label') THEN
            CH2 = DATA(1:2)
            GID = CH2//'  '
          ENDIF

          IF(I.EQ.N_CIF) THEN
            IGRP  = IGRP+1
            NGR   = IGRP
            ICH   = 0
            IF(IGOLD .LE.0) IGOLD =IGRP 
            IF(ICHOLD.LE.0) ICHOLD=IGRP 
            CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGRP,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF

        ELSE IF((ITEM(1:18).EQ.'_derivative_scale1').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale1')) THEN
         CR_FLAG_HA='Y'
         CR_CF1 = FDATA
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale2').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale2')) THEN
         CR_FLAG_HA='Y'
         CR_CF2 = FDATA
        ELSE IF((ITEM(1:20).EQ.'_derivative_Toverall').OR.
     *          (ITEM(1:20).EQ.'_derivative.Toverall')) THEN
         CR_FLAG_HA='Y'
         CR_TOV = FDATA
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF_RAD (NCRD_CSF+1)=0.0
            CSF_NE  (NCRD_CSF+1)=0.0
            CSF_ATOM(NCRD_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF_ATOM(NCRD_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF_A1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF_A2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF_A3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF_A4(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF_B1(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF_B2(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF_B3(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF_C(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF_FI(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF_FII(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF_RAD(NCRD_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF_NE(NCRD_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD_CSF   = NCRD_CSF + 1
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN
          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR_NAME_PDB(5:12)=CR_CD_PDB//'    '
      ENDIF
      CR_NAME_PDB(1:4)   = CR_CD_PDB
      CR_NAME_PDB(13:32) = NAME(1:20)

      CR_TITLE(9:68) = TITLE
      CR_TITLE(69:73)= WAVE
      CR_TITLE(74:78)= TEMPER

      RETURN
      END

      SUBROUTINE OLD_RDTTL(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C    RD_TTL_CRD - reads title of file to common/CRDINF/,/CRDATM/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C 
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ------------------------------------------------------------
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*40,DATE*9,SPGR*24
      CHARACTER TITLE*80,TIME*20
      CHARACTER LINE*80
C -------------------------------------------------------------------
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      IERR  = 0
C ----
      DO I=1,80
        CR_TITLE(I:I)   = ' '
      ENDDO
      CR_CELL(1)   = 1.0
      CR_CELL(2)   = 1.0
      CR_CELL(3)   = 1.0
      CR_CELL(4)   = PI/2.0
      CR_CELL(5)   = PI/2.0
      CR_CELL(6)   = PI/2.0
      CR_SCALE(1,1)= 1.0
      CR_SCALE(1,2)= 0.0
      CR_SCALE(1,3)= 0.0
      CR_SCALE(2,1)= 0.0
      CR_SCALE(2,2)= 1.0
      CR_SCALE(2,3)= 0.0
      CR_SCALE(3,1)= 0.0
      CR_SCALE(3,2)= 0.0
      CR_SCALE(3,3)= 1.0
      CR_U(1)      = 0.0
      CR_U(2)      = 0.0
      CR_U(3)      = 0.0
      CR_FLAG_HA   = 'N'
      CR_CF1       = 0.0
      CR_CF2       = 0.0
      CR_TOV       = 0.0
      CR_ORT_TO_FRAC(1,1)=1.0
      CR_ORT_TO_FRAC(1,2)=0.0
      CR_ORT_TO_FRAC(1,3)=0.0
      CR_ORT_TO_FRAC(2,1)=0.0
      CR_ORT_TO_FRAC(2,2)=1.0
      CR_ORT_TO_FRAC(2,3)=0.0
      CR_ORT_TO_FRAC(3,1)=0.0
      CR_ORT_TO_FRAC(3,2)=0.0
      CR_ORT_TO_FRAC(3,3)=1.0
      CR_FRAC_TO_ORT(1,1)=1.0
      CR_FRAC_TO_ORT(1,2)=0.0
      CR_FRAC_TO_ORT(1,3)=0.0
      CR_FRAC_TO_ORT(2,1)=0.0
      CR_FRAC_TO_ORT(2,2)=1.0
      CR_FRAC_TO_ORT(2,3)=0.0
      CR_FRAC_TO_ORT(3,1)=0.0
      CR_FRAC_TO_ORT(3,2)=0.0
      CR_FRAC_TO_ORT(3,3)=1.0
      CR_NAME_PDB = '----'
      CR_DATE_PDB = 'XX-XXX-XX'
      CR_CD_PDB   = 'xxxx'
      CR_TITLE   = '---'
      CR_RFAC_PDB = '.'
      CR_RESL_PDB = '.'
      CR_TIME     = '.'
      CR_FLAG_HA  = 'N'
      CR_FLAG_USER= 'N'
      CR_MODEL    = 0
      CR_NSPGR    = 1
      CR_SETT     = 1
      CR_SPGR     = 'P 1        '
      CR_PDB_REC  ='.'
      CR_NSYM     = 1
      CR_NCS      = 0
      CR_SYMOP    = 'X,Y,Z'
      CR_IATOM    =0
      CR_IRES     =0
      CR_IATOLD   =0
      CR_IGROUP   =0
      CR_MULT_FLAG  =0
      CR_MULT_FACTOR=1
      CR_RTYPE    = '.'
      CR_ATYPE    = '.'
      CR_TERM     = '.'
      CR_RNAME    = '.'
      CR_ANAME    = '.'
      CR_CHAIN    = '. '
      CR_GROUP    = '.   '
      CR_BTYPE    = 'I'
      CR_FSC      = '.'
      CR_FSA      = '.'
C ------------------------------------------
       ICS_CATEGORY   = '_database_PDB_'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell_length_a'
       ICS_CELL(2)    = '_cell_length_b'
       ICS_CELL(3)    = '_cell_length_c'
       ICS_CELL(4)    = '_cell_angle_alpha'
       ICS_CELL(5)    = '_cell_angle_beta'
       ICS_CELL(6)    = '_cell_angle_gamma'
C
       ICS_SPGR       = '_symmetry_space_group_name_H-M'
       ICS_NSPGR      = '_symmetry_Int_Tables_number'
       ICS_SETT       = '_symmetry_cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv_pos_as_xyz'
C
C      CALL MSGDOC(MDOC,'TITLE OF FILE :')
C --------------------------------
      I = 0
      CALL SET_NCS(MDOC,NCMAX,I,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGR = 0
      CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
  300 CONTINUE
      READ(IN,'(A)',END=1010,ERR=1000) IN_STRING
      CALL LENSTR_BL(IN_STRING,L)
      IF(L.LE.0.OR.IN_STRING(1:1).EQ.'#') GO TO 300
      CALL FRD_PARM
      IF(NWORDS.LE.0) GO TO 300
      LINE = WORDS(1)
      LEN  = LEN_WORDS(1)
C --
      IF(LEN.GE.15.AND.LINE(1:15).EQ.'data_structure_') THEN
c        CR_CD_PDB = '    '
c        L=LEN_WORDS(2)
c        IF(L.GT.4) L=4
c        CR_CD_PDB = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      CALL LENSTR_BL(ICS_CATEGORY,LENC)
      CALL LENSTR_BL(ICS_CD_PDB,LEN)
      L1=LENC+1
      L2=L1+LEN-1
      IF(LINE(1:LENC).EQ.ICS_CATEGORY(1:LENC).AND.
     *   LINE(L1:L2) .EQ.ICS_CD_PDB(1:LEN)  ) THEN
        CR_CD_PDB = '    '
        L=LEN_WORDS(2)
        IF(L.GT.4) L=4
        CR_CD_PDB = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:18).EQ.'_database_PDB_name') THEN
        L=LEN_WORDS(2)
        IF(L.GT.56) L=56
        CR_NAME_PDB = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:18).EQ.'_database_PDB_date') THEN
        L=LEN_WORDS(2)
        IF(L.GT.9) L=9
        CR_DATE_PDB = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:13).EQ.'_struct_title') THEN
        L=LEN_WORDS(2)
        IF(L.GT.54) L=54
        CR_TITLE = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:19).EQ.'_file_creation_date') THEN
        L=LEN_WORDS(2)
        IF(L.GT.20) L=20
        CR_TIME = WORDS(2)(1:L)
        GO TO 300
      ENDIF
C ---
      CALL LENSTR_BL(ICS_MODEL,LEN)
      IF(LINE(1:LEN).EQ.ICS_MODEL(1:LEN)) THEN
C        CR_MODEL = IWORDS(2)
        GO TO 300
      ENDIF
C ----
      CALL LENSTR_BL(ICS_RESL_PDB,LEN)
      L1=LENC+1
      L2=L1+LEN-1
      IF(LINE(1:LENC).EQ.ICS_CATEGORY(1:LENC).AND.
     *   LINE(L1:L2) .EQ.ICS_RESL_PDB(1:LEN)) THEN
        READ(IN,'(A80)',END=1010,ERR=1000) IN_STRING
        CALL LENSTR_BL(IN_STRING,LEN)
        IF(LEN.LE.0.OR.IN_STRING(1:1).EQ.'#'.OR.NWORDS.LE.0) GO TO 300
        CALL FRD_PARM
        CR_RESL_PDB = WORDS(1)(1:LEN_WORDS(1))
        GO TO 300
      ENDIF
      CALL LENSTR_BL(ICS_RFAC_PDB,LEN)
      L1=LENC+1
      L2=L1+LEN-1
      IF(LINE(1:LENC).EQ.ICS_CATEGORY(1:LENC).AND.
     *   LINE(L1:L2) .EQ.ICS_RFAC_PDB(1:LEN)) THEN
        READ(IN,'(A80)',END=1010,ERR=1000) IN_STRING
        CALL LENSTR_BL(IN_STRING,LEN)
        IF(LEN.LE.0.OR.IN_STRING(1:1).EQ.'#'.OR.NWORDS.LE.0) GO TO 300
        CALL FRD_PARM
        CR_RFAC_PDB = WORDS(1)(1:LEN_WORDS(1))
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:14).EQ.'_cell_length_a') THEN
        CR_CELL(1) = FWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:14).EQ.'_cell_length_b') THEN
        CR_CELL(2) = FWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:14).EQ.'_cell_length_c') THEN
        CR_CELL(3) = FWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:17).EQ.'_cell_angle_alpha') THEN
        CR_CELL(4) = FWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:16).EQ.'_cell_angle_beta') THEN
        CR_CELL(5) = FWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:17).EQ.'_cell_angle_gamma') THEN
        CR_CELL(6) = FWORDS(2)
        CR_CELL(4)=CR_CELL(4)*PI180
        CR_CELL(5)=CR_CELL(5)*PI180
        CR_CELL(6)=CR_CELL(6)*PI180
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:23).EQ.'_symmetry_space_group_n') THEN
        L=LEN_WORDS(2)
        IF(L.GT.11) L=11
        CR_SPGR = WORDS(2)(1:L)
        IF(L.LT.11) THEN
          DO II=L+1,11
            CR_SPGR(II:II)=' '
          ENDDO
        ENDIF
        GO TO 300
      ENDIF
      IF(LINE(1:15).EQ.'_symmetry_Int_T') THEN
        CR_NSPGR = IWORDS(2)
        GO TO 300
      ENDIF
      IF(LINE(1:19).EQ.'_symmetry_cell_sett') THEN
        CR_SETT = IWORDS(2)
        GO TO 300
      ENDIF
C ---
      IF(LINE(1:15).EQ.'_symmetry_equiv') THEN
        I=0
  500   CONTINUE
        READ(IN,'(A80)',END=1010,ERR=1000) IN_STRING
        CALL LENSTR_BL(IN_STRING,LEN)
        CALL FRD_PARM
        LINE=WORDS(1)
        LEN =LEN_WORDS(1)
        IF(LEN.LE.0.OR.IN_STRING(1:1).EQ.'#'.OR.NWORDS.LE.0) GO TO 500
        IF(IN_STRING(1:1).EQ.'_'.OR.IN_STRING(1:4).EQ.'loop')GO TO 400
        I=I+1
        LINE=WORDS(1)(1:LEN_WORDS(1))
        NS=I
        CALL SYMFR2_BL(MDOC,LINE,NS,NSYMR,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          CALL MSGERR(MDOC,' ERR: WRONG NUMBER OF "SYM "-STRING')
          CLOSE(UNIT=IN)
          IERR=1
          RETURN
        ENDIF
        GO TO 500
  400   NSYM = I
        LINE=IN_STRING
      ENDIF
C ----------------------------------------------------------
      IF(LINE(1:12).EQ.'_nc_symmetry') THEN
        I=0
  700   CONTINUE
        READ(IN,'(A80)',END=1010,ERR=1000) IN_STRING
        IF(IN_STRING(1:12).EQ.'_nc_symmetry') GO TO 700
        CALL LENSTR_BL(IN_STRING,LEN)
        CALL FRD_PARM
        LINE = WORDS(1)
        LEN  = LEN_WORDS(1)
        IF(LEN.LE.0.OR.IN_STRING(1:1).EQ.'#'.OR.NWORDS.LE.0) GO TO 700
        IF(IN_STRING(1:1).EQ.'_'.OR.IN_STRING(1:4).EQ.'loop')GO TO 710
        I=I+1
        ALPHA = FWORDS(1)
        BETA  = FWORDS(2)
        GAMMA = FWORDS(3)
        ALPHA = ALPHA*PI180
        BETA  = BETA *PI180
        GAMMA = GAMMA*PI180
        CALL EULERM(ALPHA,BETA,GAMMA,AMR)
        TR(1) = FWORDS(4)
        TR(2) = FWORDS(5)
        TR(3) = FWORDS(6)
        CALL SET_NCS(MDOC,NCMAX,I,AMR,TR,IERR)
        IF(IERR.NE.0) RETURN
        II = 0
        CALL GET_NCS(MDOC,NCMAX,II,AMR,TR,IERR)
        IF(IERR.NE.0) RETURN
        GO TO 700
  710   CONTINUE
        LINE=IN_STRING
      ENDIF
C --------------------------------------------------------------
C --- ASYMM. PART ---

      IF(LINE(1:12).EQ.'_struct_asym') THEN
        IGR = 0
  800   CONTINUE
        READ(IN,'(A80)',END=1010,ERR=1000) IN_STRING
        IF(IN_STRING(1:12).EQ.'_struct_asym') GO TO 800
        CALL LENSTR_BL(IN_STRING,LEN)
        CALL FRD_PARM
        LINE = WORDS(1)
        LEN  = LEN_WORDS(1)
        IF(LEN.LE.0.OR.IN_STRING(1:1).EQ.'#'.OR.NWORDS.LE.0) GO TO 800
        IF(IN_STRING(1:1).EQ.'_'.OR.IN_STRING(1:4).EQ.'loop')GO TO 810
        IGR  = IGR+1
        NGR  = IGR
        IATM = 0
        ICH  = IWORDS(2)
        CH2  = WORDS(6)(1:2)
        GID  = CH2//'  '
        CH2  = WORDS(3)(1:2)
        IF(CH2(1:1).EQ.'.') THEN
          INC=0
        ELSE
          READ(CH2,'(I2)')INC
        ENDIF
        NCSF  = WORDS(4)(1:2)
        CH2   = WORDS(5)(1:2)
        CALL LENSTR_BL(CH2,LEN)
        IF(CH2(1:1).EQ.'.') THEN
          MLT=1
        ELSE
          IF(LEN.LE.1) THEN
            CH2(2:2)=CH2(1:1)
            CH2(1:1)=' '
          ENDIF
          READ(CH2,'(I2)')MLT
        ENDIF
        CALL SET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) RETURN
        GO TO 800
  810   CONTINUE
        LINE=IN_STRING
      ENDIF
C -----------------------------------------
C --- DERI ---
      IF(LINE(1:18).EQ.'_derivative_scale1') THEN
         CR_FLAG_HA='Y'
         CR_CF1 = FWORDS(2)
      ELSE IF(LINE(1:18).EQ.'_derivative_scale2') THEN
         CR_FLAG_HA='Y'
         CR_CF2 = FWORDS(2)
      ELSE IF(LINE(1:20).EQ.'_derivative_Toverall') THEN
         CR_FLAG_HA='Y'
         CR_TOV = FWORDS(2)
      ENDIF
C --------------------------------
      IF(LINE(1:11).EQ.'_atom_site_') THEN
        GO TO 600
      ENDIF
      GO TO 300
 600  CONTINUE
      RETURN
C ---------------------
1000  IERR=3
      RETURN
1010  IERR=2
      RETURN
      END


C ******
      SUBROUTINE WR_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
C -P- WR_TTL_CRD - writes title from common/CRDINF/,/CRDATM/ to file
C ---
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ******
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRDFRM/ NCRD_CSF,CSF_NE,CSF_RAD
     *               ,CSF_A1,CSF_B1,CSF_A2,CSF_B2
     *               ,CSF_A3,CSF_B3,CSF_A4,CSF_B4
     *               ,CSF_C,CSF_FI,CSF_FII,CSF_ATOM
      CHARACTER       CSF_ATOM(IPRAT_SF)*4
      REAL            CSF_A1(IPRAT_SF),CSF_B1(IPRAT_SF)
      REAL            CSF_A2(IPRAT_SF),CSF_B2(IPRAT_SF)
      REAL            CSF_A3(IPRAT_SF),CSF_B3(IPRAT_SF)
      REAL            CSF_A4(IPRAT_SF),CSF_B4(IPRAT_SF)
      REAL            CSF_C (IPRAT_SF),CSF_RAD(IPRAT_SF)
      REAL            CSF_FI(IPRAT_SF),CSF_FII(IPRAT_SF)
      REAL            CSF_NE(IPRAT_SF)
C -----------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C -------------------------------------------------
C ---
C      REAL        AM(3,3)
C      CHARACTER   FL(6)*40
C      REAL        FN(40)
C ----
C      REAL      RLATT(6)
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CID*1,CH2M*2,CODE*8,TEMPER*5,WAVE*5
      CHARACTER TITLE*80,CH10*10,CODE_NDB*8
C ------------------------------------------------------------------------
      REAL      AMR(3,3),TRN(3)
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
      IF(IOUT.LE.0) RETURN
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(CR_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = CR_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = CR_TITLE(9:68)
        WAVE  = CR_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = CR_TITLE(9:68)
        WAVE  = CR_TITLE(69:73)
        TEMPER= CR_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=CR_NAME_PDB(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.CR_CD_PDB.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = CR_CD_PDB//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)
      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL LENSTR_BL(ICS_CATEGORY,LENC)

C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR_CD_PDB,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') CR_CD_PDB(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR_NAME_PDB,LEN)
      IF(LEN.LE.12) THEN
        CR_NAME_PDB(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) CR_NAME_PDB(13:LEN)
  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(CR_DATE_PDB,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL CHCLOCK(CHAR20)
      WRITE(LINE,210) CHAR20
  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      IF(CR_MODEL.GT.0) THEN
        CALL LENSTR_BL(ICS_MODEL,LEN)
        WRITE(LINE,'(A,A,2X,I4)')
     *  ICS_CATEGORY(1:LENC),ICS_MODEL(1:LEN),CR_MODEL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR_RESL_PDB(1:1).NE.'.'.AND.CR_RESL_PDB(1:1).NE.' ') THEN
        CALL LENSTR_BL(ICS_RESL_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RESL_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_RESL_PDB,LEN)
        WRITE(LINE,310) CR_RESL_PDB(1:LEN)
  310   FORMAT(2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR_RFAC_PDB(1:1).NE.'.'.AND.CR_RFAC_PDB(1:1).NE.'   ')THEN
        CALL LENSTR_BL(ICS_RFAC_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RFAC_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_RFAC_PDB,LEN)
        WRITE(LINE,330) CR_RFAC_PDB(1:LEN)
  330   FORMAT(2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT(2X,'_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT(2X,'_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        CR_CELL(4)=CR_CELL(4)/PI180
        CR_CELL(5)=CR_CELL(5)/PI180
        CR_CELL(6)=CR_CELL(6)/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') CR_CELL(1)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell_length_b   '',2X,F8.3)') CR_CELL(2)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') CR_CELL(3)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') CR_CELL(4)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') CR_CELL(5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') CR_CELL(6)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR_SPGR,LEN)
        WRITE(LINE,100)  CR_SPGR(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,400)  CR_NSPGR
  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        IF(CR_SETT.EQ.2) THEN
          WRITE(LINE,500)  CR_SETT
  500     FORMAT('_symmetry.cell_setting_number ',2X,I5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        ENDIF
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I))
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        CR_SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,CR_SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------
C --- NCS ---
      NCS=0
      CALL GET_NCS(MDOC,NMAX,NCS,AM,TR,IERR)
      IF(NCS.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.alpha'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.beta'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.gamma'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO I=1,NCS
          CALL GET_NCS(MDOC,NMAX,I,AMR,TRN,IERR)
          IF(IERR.NE.0) RETURN
          CALL MTOANG(AMR,ALPHA,BETA,GAMMA)
          WRITE(LINE,700) ALPHA,BETA,GAMMA,TRN(1),TRN(2),TRN(3)
  700     FORMAT(2X,6F12.5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C --------------------------------------------------------------
C --- ASYMM. PART ---
      IGR=0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      IF(NGR.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.id'')')  
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.entity_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.PDB_chain_label'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        DO IGR=1,NGR

          CALL GET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN

          IF(INC.LE.0) THEN
            CH2='. '
          ELSE
            WRITE(CH2,'(I2)') INC
          ENDIF
          IF(NCSF.EQ.' '.OR.NCSF.EQ.'Y') NCSF='.'
          IF(MLT.LE.1) THEN
            CH2M='. '
          ELSE
            WRITE(CH2M,'(I2)') MLT
          ENDIF
          IF(CH2M(1:1).EQ.' ') THEN
            CH2M(1:1)=CH2M(2:2)
            CH2M(2:2)=' '
          ENDIF
          CID=GID(1:1)
          IF(CID.EQ.' ') CID = '.'
          IF(ICHOLD.LT.0) ICHOLD = ABS(ICHOLD)
          WRITE(LINE,800) IGOLD,ICHOLD,CH2,NCSF,CH2M,CID
  800     FORMAT(2X,I4,2X,I4,2X,A2,2X,A1,2X,A2,2X,A1)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO

      ENDIF
C -----------------------------------------------------------
      IF(NCRD_CSF.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_c'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_real'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_imag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.radius_contact'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.nelec'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO ICSF=1,NCRD_CSF
          WRITE(LINE,900) CSF_ATOM(ICSF)
     *    ,CSF_A1(ICSF),CSF_A2(ICSF),CSF_A3(ICSF),CSF_A4(ICSF)
  900     FORMAT(2X,A4,2X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,910) 
     *    CSF_B1(ICSF),CSF_B2(ICSF),CSF_B3(ICSF),CSF_B4(ICSF)
  910     FORMAT(8X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,920) 
     *    CSF_C(ICSF),CSF_FI(ICSF),CSF_FII(ICSF),CSF_NE(ICSF)
     *    ,CSF_RAD(ICSF)
  920     FORMAT(8X,5(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C -----------------------------------------------------------
C --- DERI ---
      IF(CR_FLAG_HA.EQ.'Y') THEN
        WRITE(LINE,600) CR_CF1
  600   FORMAT('_derivative.scale1',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,610) CR_CF2
  610   FORMAT('_derivative.scale2',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,620) CR_TOV
  620   FORMAT('_derivative.Toverall',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C --------------------------
      RETURN
      END

C ******
      SUBROUTINE RDCRD(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD - reads coordinates to common/CRDATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---
C -------------------------------------------------
      COMMON/COM_CRD_CIF/ IEND_CIF      
C --
      COMMON/COM_CRD_SCR/ ICHAIN_CIF,CHAIN_CIF,CHAIN_CIF_OLD      
      INTEGER   ICHAIN_CIF
      CHARACTER CHAIN_CIF*4,CHAIN_CIF_OLD*4
C --
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*80,BFLAG*1,MULT*2,ASYMB*4,TYPE*1,CH5*5,CHAR1*1
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF       =-1
        CR_IATOM       = 0
        IEND           = 0
        ICHAIN_CIF     = 0
        CHAIN_CIF_OLD  = '????'
      ENDIF

  300 CONTINUE   
      CALL GETCIF_CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF
      CR_LINE2 = ' '
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR_LINE=LINE(1:LEN)
          IF(LINE(1:6).EQ.'#MODEL') CR_MODEL = CR_MODEL + 1
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IF((ITM_CIF(1)(1:11).NE.'_atom_site_').AND.
     *   (ITM_CIF(1)(1:11).NE.'_atom_site.'))  GO TO 300

      CR_ANAME     = '    '
      CR_ASYMB     = '    '
      CR_RNAME     = '   '
      CR_PNUM      = '       '       
      CR_BTYPE     = '.'
      CR_CORR      = '.'
      CR_IATOLD    = 0
      CR_IGROUP    = 0
      CR_GROUP     = '    '
      CR_MULT_FLAG = 1
      CR_IRES      = 0
      IFLAG        = 0
      IFLAG_AUTH   = 0
      IFLAG_ISEQ   = 0
      CR_SURF  = 0.0
      CR_SEG   = '.'

      IF(CR_MODEL.LE.0) CR_MODEL = 1

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_atom_site') THEN

        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN
          CR_IATOLD=IDATA
        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN
          CR_ANAME(1:LEND)=DATA(1:LEND)
        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
          CR_ASYMB(1:LEND) = DATA(1:LEND)
        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
          CR_ATYPE=DATA(1:1)
        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
          CR_ALT=DATA(1:1)
        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
          CR_CORR=DATA(1:1)
        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
          CR_RNAME(1:LEND)=DATA(1:LEND)

        ELSE IF(ITEM(12:23).EQ.'label_seq_id') THEN
          CR_IRES=IDATA
          IFLAG_ISEQ = 1

        ELSE IF(ITEM(12:22).EQ.'auth_seq_id') THEN

          IF(LEND.GT.0) THEN
            CH5 = '     '
            J   = 5
            DO K = 5,1,-1
              IF(DATA(K:K).NE.' ') THEN
                CH5(J:J) = DATA(K:K) 
                J = J -1
              ENDIF
            ENDDO
            CHAR1 = CH5(5:5)              
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              DO K=2,5
                CH5(K-1:K-1) = CH5(K:K)
              ENDDO 
              CH5(5:5) = ' '
            ENDIF
          ENDIF

          CR_PNUM(3:7) = CH5
          IFLAG_AUTH   = 1

        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN

          CHAIN_CIF = DATA(1:4)
          IF(CHAIN_CIF.NE.CHAIN_CIF_OLD) THEN
            ICHAIN_CIF = ICHAIN_CIF + 1
            CHAIN_CIF_OLD = CHAIN_CIF
          ENDIF

          CHAR1 = DATA(1:1)
          CALL CHKSMB(CHAR1,TYPE)              

          IF(TYPE.EQ.'D') THEN
            CR_IGROUP=IDATA
          ELSE
            CR_IGROUP=ICHAIN_CIF
          ENDIF

        ELSE IF(ITEM(13:18).EQ.'artn_x') THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y') THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z') THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x') THEN
          CR_XYZ(1)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y') THEN
          CR_XYZ(2)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z') THEN
          CR_XYZ(3)=FDATA
          CR_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'segment') THEN
          CR_SEG=DATA
        ELSE IF(ITEM(12:18).EQ.'surface') THEN
          CR_SURF=FDATA
        ELSE IF(ITEM(12:20).EQ.'occupancy') THEN
          CR_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv').OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR_BTYPE = '.' 
          IF(DATA(1:4).EQ.'Uani'.OR.DATA(1:1).EQ.'A'
     *                          .OR.DATA(1:1).EQ.'a') CR_BTYPE = 'A'
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
          IF(DATA(1:1).EQ.'.') THEN
            CR_MULT_FACTOR=1
          ELSE
            CR_MULT_FACTOR=IDATA
          ENDIF
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(1)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(2)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(3)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(4)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(5)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
          CR_FLAG_USER='A'
          CR_ANIS(6)=FDATA
        ENDIF

        ENDIF
      ENDDO


      MODE=0
      CR_IATOM =CR_IATOM+1

      IF(IFLAG_AUTH.EQ.0) THEN
        WRITE(CR_PNUM(3:6),'(I4)') CR_IRES       
        CR_PNUM(7:7) = ' '
      ENDIF

      IF(IFLAG_ISEQ.EQ.0) THEN
        READ(CR_PNUM(3:6),'(I4)') CR_IRES       
      ENDIF

      BFLAG='.'
      IF(CR_BTYPE.EQ.'A') BFLAG='A'
      IF(CR_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB      = CR_ASYMB
      ASYMB(3:4) = '  '          
      WRITE(LINE,100)
     *    CR_IATOLD,CR_ANAME,ASYMB,CR_ATYPE
     *   ,CR_ALT,CR_CORR
     *   ,CR_RNAME,CR_IRES,CR_IGROUP
     *   ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *   ,CR_OCC,CR_BISO
c,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)
c     *    ,1X,A1,1X,A2)
      CR_LINE=LINE

          IF(CR_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,400) BFLAG,MULT,CR_SURF,CR_SEG
     *      ,(CR_ANIS(IAN),IAN=1,6)
 400        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,401) BFLAG,MULT,CR_SURF,CR_SEG
 401        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
      CR_LINE2=LINE

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END


C ******
      SUBROUTINE WRCRD(MDOC,IOUT,MODE,IEND,IERR)
C
C -P- WRCRD - writes coordinates from common/CRDATM/ to file.
C
      INTEGER IOUT,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      INCLUDE 'mr_crd_com.fh'
C ---
C -------------------------------------------------
      CHARACTER LINE*80,MULT*2,BFLAG*1,ALT*2,ASYMB*4
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.LE.0) THEN
        IF(IEND.LT.0) THEN
        IF(IOUT.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_atom_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.type_symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.calc_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_alt_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.footnote_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_comp_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_seq_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_asym_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        IF(CR_PDB_REC(1:1).EQ.'F') THEN
          WRITE(LINE,'(''_atom_site.fract_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ELSE
          WRITE(LINE,'(''_atom_site.cartn_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        WRITE(LINE,'(''_atom_site.occupancy'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.B_iso_or_equiv'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.thermal_displace_type'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.symmetry_multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.surface'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.segment'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CR_FLAG_USER.EQ.'A') THEN
          WRITE(LINE,'(''_atom_site.aniso_U[1][1]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[3][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF
        ENDIF
        IEND=0
        ENDIF
C      ELSE IF(IEND.EQ.0) THEN
        IF(MODE.EQ.0) THEN

       
          BFLAG='.'
          IF(CR_BTYPE.EQ.'A') BFLAG='A'

          IF(CR_MULT_FACTOR.GT.1.AND.CR_MULT_FACTOR.LT.100) THEN
            WRITE(MULT,'(I2)') CR_MULT_FACTOR
          ELSE
            MULT='. '
          ENDIF
          ASYMB      = CR_ASYMB
          ASYMB(3:4) = '  '          
          IATOM      = CR_IATOLD
          IF(CR_ATYPE.EQ.' '   ) CR_ATYPE = '.'
          IF(CR_ALT  .EQ.' '   ) CR_ALT   = '.'
          IF(CR_CORR .EQ.' '   ) CR_CORR  = '.'
          IF(CR_BISO .GT.999.99) CR_BISO  = 999.99
          IF(CR_OCC  .GT.999.99) CR_OCC   = 999.99
          IF(CR_BISO .LT.-99.99) CR_BISO  =-99.99
          IF(CR_OCC  .LT.-99.99) CR_OCC   =-99.99
          IF(CR_SURF.GT.999.99) CR_SURF=999.99

        IF(CR_PDB_REC(1:1).EQ.'F') THEN


            WRITE(LINE,110)
     *      IATOM,CR_ANAME,ASYMB,CR_ATYPE
     *     ,CR_ALT,CR_CORR
     *     ,CR_RNAME,CR_IRES,CR_IGROUP
     *     ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *     ,CR_OCC,CR_BISO

  110     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.5,1X,F8.5,1X,F8.5,1X,F6.2,1X,F6.2)

          ELSE 

          WRITE(LINE,100)
     *    IATOM,CR_ANAME,ASYMB,CR_ATYPE
     *   ,CR_ALT,CR_CORR
     *   ,CR_RNAME,CR_IRES,CR_IGROUP
     *   ,CR_XYZ(1),CR_XYZ(2),CR_XYZ(3)
     *   ,CR_OCC,CR_BISO

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)

          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

          IF(CR_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,300) BFLAG,MULT,CR_SURF,CR_SEG
     *     ,(CR_ANIS(IAN),IAN=1,6)
 300        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,301) BFLAG,MULT,CR_SURF,CR_SEG
 301        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

         ELSE
          IF(IOUT.GT.0) THEN
            CALL LENSTR_BL(CR_LINE,LEN)
            LINE = CR_LINE        
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            CALL LENSTR_BL(CR_LINE2,LEN)
            IF(LEN.GT.0) THEN
              LINE = CR_LINE2        
              CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            ENDIF
          ENDIF

        ENDIF

        IF(IERR.GT.0) GO TO 200
C ---
      ELSE
        IF(IOUT.GT.0) THEN
          END FILE IOUT
          CLOSE(IOUT)
        ENDIF
      ENDIF
      RETURN
 200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.CRD/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END

C -------

C ******
      SUBROUTINE ORCRD2(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD2 - OPEN OF FILE-CRD-2 FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
      EXT='crd'
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.crd') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE2/CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD2_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) IERR=4
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ OF FILE-2 /.CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERR: END OF FILE-2 /.CRD/')
      IERR=2
      CLOSE(IN)
      RETURN
      END

C ******
      SUBROUTINE OWCRD2(MDOC,IOUT,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P-  OWCRD2 - OPEN OF FILE-CRD-2 FOR WRITE
C
      INTEGER   IOUT,MDOC,ILINE,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
      EXT='crd'
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.crd') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      PATH=' '
      CALL OPENFW(IOUT,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) GO TO 9100
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('OUT-FILE2/CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL WR2_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.GT.0) GO TO 9000
      RETURN
9100  CONTINUE
      CALL MSGERR(MDOC,' ERR: OPEN OF FILE-2 /.CRD/')
      IERR=1
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE-2 /.CRD/')
      CLOSE(IOUT)
      IERR=2
      RETURN
      END

      SUBROUTINE RD2_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD2_TTL_CRD - reads title of file to common/CRD2INF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRD2FRM/ NCRD2_CSF,CSF2_NE,CSF2_RAD
     *               ,CSF2_A1,CSF2_B1,CSF2_A2,CSF2_B2
     *               ,CSF2_A3,CSF2_B3,CSF2_A4,CSF2_B4
     *               ,CSF2_C,CSF2_FI,CSF2_FII,CSF2_ATOM
      CHARACTER       CSF2_ATOM(IPRAT_SF)*4
      REAL            CSF2_A1(IPRAT_SF),CSF2_B1(IPRAT_SF)
      REAL            CSF2_A2(IPRAT_SF),CSF2_B2(IPRAT_SF)
      REAL            CSF2_A3(IPRAT_SF),CSF2_B3(IPRAT_SF)
      REAL            CSF2_A4(IPRAT_SF),CSF2_B4(IPRAT_SF)
      REAL            CSF2_C (IPRAT_SF),CSF2_RAD(IPRAT_SF)
      REAL            CSF2_FI(IPRAT_SF),CSF2_FII(IPRAT_SF)
      REAL            CSF2_NE(IPRAT_SF)
C -----------------------------------
      INCLUDE 'mr_crd2_com.fh'
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2,TYPE*1
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24


      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*80,CH10*10,CHAR1*1
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C -------------------------------------------------------------------
      DO I=1,80
        CR2_TITLE(I:I)   = ' '
        TITLE(I:I)   = ' '
      ENDDO
      DO I=1,40
        CR2_NAME_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR2_CELL(1)=1.0
      CR2_CELL(2)=1.0
      CR2_CELL(3)=1.0
      CR2_CELL(4)=PI/2.0
      CR2_CELL(5)=PI/2.0
      CR2_CELL(6)=PI/2.0
      CR2_SCALE(1,1)=1.0
      CR2_SCALE(1,2)=0.0
      CR2_SCALE(1,3)=0.0
      CR2_SCALE(2,1)=0.0
      CR2_SCALE(2,2)=1.0
      CR2_SCALE(2,3)=0.0
      CR2_SCALE(3,1)=0.0
      CR2_SCALE(3,2)=0.0
      CR2_SCALE(3,3)=1.0
      CR2_U(1)      =0.0
      CR2_U(2)      =0.0
      CR2_U(3)      =0.0
      CR2_FLAG_HA='N'
      CR2_CF1 = 0.0
      CR2_CF2 = 0.0
      CR2_TOV = 0.0
      CR2_ORT_TO_FRAC(1,1)=1.0
      CR2_ORT_TO_FRAC(1,2)=0.0
      CR2_ORT_TO_FRAC(1,3)=0.0
      CR2_ORT_TO_FRAC(2,1)=0.0
      CR2_ORT_TO_FRAC(2,2)=1.0
      CR2_ORT_TO_FRAC(2,3)=0.0
      CR2_ORT_TO_FRAC(3,1)=0.0
      CR2_ORT_TO_FRAC(3,2)=0.0
      CR2_ORT_TO_FRAC(3,3)=1.0
      CR2_FRAC_TO_ORT(1,1)=1.0
      CR2_FRAC_TO_ORT(1,2)=0.0
      CR2_FRAC_TO_ORT(1,3)=0.0
      CR2_FRAC_TO_ORT(2,1)=0.0
      CR2_FRAC_TO_ORT(2,2)=1.0
      CR2_FRAC_TO_ORT(2,3)=0.0
      CR2_FRAC_TO_ORT(3,1)=0.0
      CR2_FRAC_TO_ORT(3,2)=0.0
      CR2_FRAC_TO_ORT(3,3)=1.0
      CR2_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR2_DATE_PDB   = 'XX-XXX-XX'
      CR2_CD_PDB     = 'XXXX'
      CR2_TITLE(1:9)   = '?   ?   ?'
      CR2_TITLE(69:78) = '?    ?    '
      CR2_RFAC_PDB = '.'
      CR2_RESL_PDB = '.'
      CR2_TIME     = '.'
      CR2_FLAG_HA  = 'N'
      CR2_FLAG_USER= 'N'
      CR2_MODEL    = 0
      CR2_NSPGR    = 1
      CR2_SETT     = 1
      CR2_SPGR     = 'P 1        '
      CR2_PDB_REC  ='.'
      CR2_NSYM     = 1
      CR2_NCS      = 0
      CR2_SYMOP    = 'X,Y,Z'
      CR2_IATOM    =0
      CR2_IRES     =0
      CR2_IATOLD   =0
      CR2_IGROUP   =0
      CR2_MULT_FLAG  =0
      CR2_MULT_FACTOR=1
      CR2_RTYPE    = '.'
      CR2_ATYPE    = '.'
      CR2_TERM     = '.'
      CR2_RNAME    = '.'
      CR2_ANAME    = '.'
      CR2_CHAIN    = '. '
      CR2_GROUP    = '.   '
      CR2_BTYPE    = 'I'
      CR2_FSC      = '.'
      CR2_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C ------------------------------------------
      INCS=0
      CALL SET_NCS2(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYM2(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      IEND = -1
      ISOP =  0
C -------
  300 CONTINUE   
      CALL GETCIF_2CRD(IN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9).EQ.'_entry.id')) THEN
          CR2_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR2_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR2_CD_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB')) THEN
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          CR2_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
       ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *    (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR2_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)

          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR2_DATE_PDB)         
          ENDIF

        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR2_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR2_DATE_PDB)         
          ELSE
            CR2_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR2_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
C          CR2_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR2_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR2_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR2_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR2_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:27).EQ.'_diffrn.ambient_temperature')) THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:28).EQ.'_diffrn_radiation.wavelength')) THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a') THEN
            CR2_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN
            CR2_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN
            CR2_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN
            CR2_CELL(4) = FDATA
            CR2_CELL(4) = CR2_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN
            CR2_CELL(5) = FDATA
            CR2_CELL(5) = CR2_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            CR2_CELL(6) = FDATA
            CR2_CELL(6) = CR2_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:23).EQ.'space_group_n') THEN
            IF(LEND.GT.11) LEND=11
            CR2_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR2_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE IF(ITEM(11:15).EQ.'Int_T') THEN
            CR2_NSPGR = IDATA
          ELSE IF(ITEM(11:19).EQ.'cell_sett') THEN
            CR2_SETT = IDATA
          ELSE IF(ITEM(11:18).EQ.'equiv.id') THEN
          ELSE IF(ITEM(11:15).EQ.'equiv') THEN
c            IF(I.EQ.N_CIF) THEN
              LINE=DATA(1:LEND)
              ISOP=ISOP+1
              CALL SYMFR2_BL(MDOC,LINE,ISOP,NSYMR,ISYM,NSMAX,IERR)
              IF(IERR.GT.0) THEN
                CALL MSGERR(MDOC
     *          ,' ERR: WRONG NUMBER OF "_symmetry_equiv"-STRING')
                IERR=1
                RETURN
              ENDIF
              NSYM   =ISOP
              CR2_NSYM=ISOP
c            ENDIF
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN
          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA =FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            INCS=INCS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS2(MDOC,NCMAX,INCS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS2(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_struct_asym') THEN
          IF(I.EQ.1) THEN
            IGOLD  = 0
            ICHOLD = 0
            INC    = 0
            NCSF   = '.'
            MULT   = 1
            GID    = '.   '            
          ENDIF
          IF(ITEM(14:15).EQ.'id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              IGOLD  = IDATA
            ELSE
              GID = CH2//'  '
            ENDIF
          ELSE IF(ITEM(14:22).EQ.'entity_id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              ICHOLD =IDATA
            ENDIF
          ELSE IF(ITEM(14:27).EQ.'nc_symmetry_id') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              INC=0
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)')INC
            ENDIF
          ELSE IF(ITEM(14:29).EQ.'nc_symmetry_flag') THEN
            NCSF =DATA(1:1)
          ELSE IF(ITEM(14:25).EQ.'multiplicity') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              MLT=1
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)') MLT
            ENDIF
          ELSE IF(ITEM(14:28).EQ.'PDB_chain_label') THEN
            CH2 = DATA(1:2)
            GID = CH2//'  '
          ENDIF
          IF(I.EQ.N_CIF) THEN
            IGRP  = IGRP+1
            NGR   = IGRP
            ICH   = 0
            IF(IGOLD .LE.0) IGOLD =IGRP 
            IF(ICHOLD.LE.0) ICHOLD=IGRP 
            CALL SET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGRP,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale1').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale1')) THEN
         CR2_FLAG_HA='Y'
         CR2_CF1 = FDATA
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale2').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale2')) THEN
         CR2_FLAG_HA='Y'
         CR2_CF2 = FDATA
        ELSE IF((ITEM(1:20).EQ.'_derivative_Toverall').OR.
     *          (ITEM(1:20).EQ.'_derivative.Toverall')) THEN
         CR2_FLAG_HA='Y'
         CR2_TOV = FDATA
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD2_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF2_RAD (NCRD2_CSF+1)=0.0
            CSF2_NE  (NCRD2_CSF+1)=0.0
            CSF2_ATOM(NCRD2_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF2_ATOM(NCRD2_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF2_A1(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF2_A2(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF2_A3(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF2_A4(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF2_B1(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF2_B2(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF2_B3(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF2_C(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF2_FI(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF2_FII(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF2_RAD(NCRD2_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF2_NE(NCRD2_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD2_CSF   = NCRD2_CSF + 1
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN

          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR2_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR2_NAME_PDB(5:12)=CR2_CD_PDB//'    '
      ENDIF
      CR2_NAME_PDB(1:4)   = CR2_CD_PDB
      CR2_NAME_PDB(13:32) = NAME(1:20)

      CR2_TITLE(9:68) = TITLE
      CR2_TITLE(69:73)= WAVE
      CR2_TITLE(74:78)= TEMPER

      RETURN
      END

C ******
      SUBROUTINE WR2_TTL_CRD(MDOC,IOUT,NSYM,ISYM,NSMAX,IERR)
C -P- WR2_TTL_CRD - writes title from common/CRD2INF/,/CRD2ATM/ to file
C ---
      INTEGER   NSYM,MDOC,IOUT,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ******
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRD2FRM/ NCRD2_CSF,CSF2_NE,CSF2_RAD
     *               ,CSF2_A1,CSF2_B1,CSF2_A2,CSF2_B2
     *               ,CSF2_A3,CSF2_B3,CSF2_A4,CSF2_B4
     *               ,CSF2_C,CSF2_FI,CSF2_FII,CSF2_ATOM
      CHARACTER       CSF2_ATOM(IPRAT_SF)*4
      REAL            CSF2_A1(IPRAT_SF),CSF2_B1(IPRAT_SF)
      REAL            CSF2_A2(IPRAT_SF),CSF2_B2(IPRAT_SF)
      REAL            CSF2_A3(IPRAT_SF),CSF2_B3(IPRAT_SF)
      REAL            CSF2_A4(IPRAT_SF),CSF2_B4(IPRAT_SF)
      REAL            CSF2_C (IPRAT_SF),CSF2_RAD(IPRAT_SF)
      REAL            CSF2_FI(IPRAT_SF),CSF2_FII(IPRAT_SF)
      REAL            CSF2_NE(IPRAT_SF)
C -----------------------------------
      INCLUDE 'mr_crd2_com.fh'
C -----------------------------------------------------------
C -------------------------------------------------
C ---
C      REAL        AM(3,3)
C      CHARACTER   FL(6)*40
C      REAL        FN(40)
C ----
C      REAL      RLATT(6)
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CID*1,CH2M*2,CODE*8,TEMPER*5,WAVE*5
      CHARACTER TITLE*80,CH10*10,CODE_NDB*8
C ------------------------------------------------------------------------
      REAL      AMR(3,3),TRN(3)
      CHARACTER LINE*80,CHAR20*20,CH1*1,CH2*2,CH3*3
      CHARACTER ICS_CATEGORY*40,ICS_CELL(6)*40
     *         ,ICS_SCALE(9)*40,ICS_U(3)*40
     *         ,ICS_ORIGX(9)*40,ICS_T(3)*40
     *         ,ICS_A(4)*40,ICS_B(4)*40,ICS_C*40,ICS_FI*40,ICS_FII*40
     *         ,ICS_RADIUS*40,ICS_NSPGR*40,ICS_SETT*40
     *         ,ICS_CD_PDB*40,ICS_NAME_PDB*40,ICS_DATE_PDB*40
     *         ,ICS_TITLE*40,ICS_RESL_PDB*40,ICS_RFAC_PDB*40
     *         ,ICS_MODEL*40,ICS_SPGR*40,ICS_SYMOP*40,ICS_ATYPE*40
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
      IF(IOUT.LE.0) RETURN
C --------------------------------
       ICS_CATEGORY   = '_database_PDB.'
       ICS_CD_PDB     = 'code'
       ICS_NAME_PDB   = 'name'
       ICS_DATE_PDB   = 'date'
       ICS_TITLE      = 'compnd'
       ICS_RESL_PDB   = 'remark_resolution'
       ICS_RFAC_PDB   = 'remark_R_factor'
       ICS_MODEL      = 'model'
C
       ICS_CELL(1)    = '_cell.length_a'
       ICS_CELL(2)    = '_cell.length_b'
       ICS_CELL(3)    = '_cell.length_c'
       ICS_CELL(4)    = '_cell.angle_alpha'
       ICS_CELL(5)    = '_cell.angle_beta'
       ICS_CELL(6)    = '_cell.angle_gamma'
C
       ICS_SPGR       = '_symmetry.space_group_name_H-M'
       ICS_NSPGR      = '_symmetry.Int_Tables_number'
       ICS_SETT       = '_symmetry.cell_setting_number'
       ICS_SYMOP      = '_symmetry_equiv.pos_as_xyz'
C
C --------------------------------
      CALL LENSTR_BL(CR2_TITLE,LEN)
      IF(LEN.LT.9) THEN 
        TITLE = '?'
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.69) THEN 
        TITLE = CR2_TITLE(9:68)
        WAVE  = '?'
        TEMPER= '?'
      ELSE IF(LEN.LT.74) THEN 
        TITLE = CR2_TITLE(9:68)
        WAVE  = CR2_TITLE(69:73)
        TEMPER= '?'
      ELSE
        TITLE = CR2_TITLE(9:68)
        WAVE  = CR2_TITLE(69:73)
        TEMPER= CR2_TITLE(74:78)
      ENDIF

      CALL LENSTR_BL(CR2_NAME_PDB,LEN)
      IF(LEN.LE.4) THEN
        CODE         ='XXXX    '
        CODE_NDB     ='?'
      ELSE
        IF(LEN.GT.12) LEN=12   
        CODE=CR2_NAME_PDB(5:LEN)
        CODE_NDB     = CODE
      ENDIF

      IF(CODE_NDB(1:4).EQ.CR2_CD_PDB.AND.CODE_NDB(5:8).EQ.'    ')
     *  CODE_NDB='?'

      IF(CODE(1:1).EQ.'?'.OR.CODE(1:1).EQ.' '.OR.CODE(1:1).EQ.'.'.OR.
     *   CODE(1:4).EQ.'XXXX') THEN
        CODE    = CR2_CD_PDB//'    '    
        CODE_NDB= '?'
      ENDIF

      CALL LENSTR_BL(CODE,LENCD)
      WRITE(LINE,'(''data_structure_'',A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL LENSTR_BL(ICS_CATEGORY,LENC)

C ---
      WRITE(LINE,
     *'(''_database_2.database_id'',2X,A)') CODE
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR2_CD_PDB,LEN)
      WRITE(LINE,
     *'(''_database_2.code_PDB   '',2X,A)') CR2_CD_PDB(1:LEN)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      IF(CODE_NDB(1:1).NE.'?') THEN
        WRITE(LINE,
     *'(''_database_2.code_NDB   '',2X,A)') CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      WRITE(LINE,'(''_struct_keywords.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(CR2_NAME_PDB,LEN)
      IF(LEN.LE.12) THEN
        CR2_NAME_PDB(13:13)='?'
        LEN=13
      ENDIF
      IF(LEN.GT.32) LEN=32
      WRITE(LINE,110) CR2_NAME_PDB(13:LEN)

  110 FORMAT(       
     * '_struct_keywords.text  ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_struct.entry_id'',2X,A)') CODE(1:LENCD)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      CALL LENSTR_BL(TITLE,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,200) TITLE(1:LEN)
  200 FORMAT(       '_struct.title   ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      WRITE(LINE,'(''_database_PDB_rev.num 1'')') 
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)

      CALL CHNG_DATE(CR2_DATE_PDB,CH10)

      WRITE(LINE,'(''_database_PDB_rev.date_original'',2X,A)') 
     * CH10(1:10)
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      CALL CHCLOCK(CHAR20)
      WRITE(LINE,210) CHAR20
  210 FORMAT(       '_file_creation_date ',2X,'''',A,'''')
      CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
      IF(CR2_MODEL.GT.0) THEN
        CALL LENSTR_BL(ICS_MODEL,LEN)
        WRITE(LINE,'(A,A,2X,I4)')
     *  ICS_CATEGORY(1:LENC),ICS_MODEL(1:LEN),CR2_MODEL
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR2_RESL_PDB(1:1).NE.'.'.AND.CR2_RESL_PDB(1:1).NE.' ')THEN
        CALL LENSTR_BL(ICS_RESL_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RESL_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_RESL_PDB,LEN)
        WRITE(LINE,310) CR2_RESL_PDB(1:LEN)
  310   FORMAT('''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      IF(CR2_RFAC_PDB(1:1).NE.'.'.AND.CR2_RFAC_PDB(1:1).NE.'   ')THEN
        CALL LENSTR_BL(ICS_RFAC_PDB,LEN)
        LINE= ICS_CATEGORY(1:LENC)//ICS_RFAC_PDB(1:LEN)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_RFAC_PDB,LEN)
        WRITE(LINE,330) CR2_RFAC_PDB(1:LEN)
  330   FORMAT('''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(TEMPER,LEN)
      IF(LEN.GT.0.AND.TEMPER(1:1).NE.'.'.AND.TEMPER(1:1).NE.' '.AND.
     *   TEMPER(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn.entry_id             '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,340) TEMPER(1:LEN)
  340   FORMAT('_diffrn.ambient_temperature    ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
      CALL LENSTR_BL(WAVE,LEN)
      IF(LEN.GT.0.AND.WAVE(1:1).NE.'.'.AND.WAVE(1:1).NE.' '.AND.
     *   WAVE(1:1).NE.'?') THEN
        WRITE(LINE,'(''_diffrn_radiation.entry_id  '',2X,A)') 
     *  CODE(1:LENCD)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(LEN.GT.5) LEN=5
        WRITE(LINE,350) WAVE(1:LEN)
  350   FORMAT('_diffrn_radiation.wavelength  ',A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C ---
        CR2_CELL(4)=CR2_CELL(4)/PI180
        CR2_CELL(5)=CR2_CELL(5)/PI180
        CR2_CELL(6)=CR2_CELL(6)/PI180
        WRITE(LINE,'(''_cell.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_a   '',2X,F8.3)') CR2_CELL(1)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell_length_b   '',2X,F8.3)') CR2_CELL(2)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.length_c   '',2X,F8.3)') CR2_CELL(3)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_alpha'',2X,F8.3)') CR2_CELL(4)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_beta '',2X,F8.3)') CR2_CELL(5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.angle_gamma'',2X,F8.3)') CR2_CELL(6)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_cell.formula_units_Z  ?'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ---
        WRITE(LINE,'(''_symmetry.entry_id  '',2X,A)') CODE(1:LENCD) 
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        CALL LENSTR_BL(CR2_SPGR,LEN)
        WRITE(LINE,100)  CR2_SPGR(1:LEN)
  100   FORMAT('_symmetry.space_group_name_H-M',2X,'''',A,'''')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,400)  CR2_NSPGR
  400   FORMAT('_symmetry.Int_Tables_number   ',2X,I5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        IF(CR2_SETT.EQ.2) THEN
          WRITE(LINE,500)  CR2_SETT
  500     FORMAT('_symmetry.cell_setting_number ',2X,I5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C        ENDIF
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_symmetry_equiv.pos_as_xyz'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
C ----------------------------------------
C --- SYM ---
      DO     I=1,NSYM
        LINE=' '
C        LINE(1:3)='SYM'
C        WRITE(CH3,'(I3)') I
C        LINE(4:4)=CH3(3:3)
C        LINE(5:5)=' '
        L=0
        DO J=1,3
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I))
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I))
          TR=ABS(TR)
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'
            L=L+2
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3'
            L=L+2
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'
            L=L+2
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF
          DO  K=1,3
            IDG=ISYM(K,J,I)
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO
          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO
        CALL LENSTR_BL(LINE,LEN)
        JL=0
        DO IL=1,LEN
          IF(LINE(IL:IL).NE.' ') THEN
            JL=JL+1
            LINE(JL:JL)=LINE(IL:IL)
          ENDIF
        ENDDO
        LEN=JL
        CR2_SYMOP = LINE(1:LEN)
        WRITE(LINE,510)  I,CR2_SYMOP(1:LEN)
  510   FORMAT('    ',I3,2X,A)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDDO
C -------
C --- NCS ---
      NCS=0
      CALL GET_NCS2(MDOC,NMAX,NCS,AM,TR,IERR)
      IF(NCS.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.alpha'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.beta'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.gamma'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_nc_symmetry.vector_3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO I=1,NCS
          CALL GET_NCS2(MDOC,NMAX,I,AMR,TRN,IERR)
          IF(IERR.NE.0) RETURN
          CALL MTOANG(AMR,ALPHA,BETA,GAMMA)
          WRITE(LINE,700) ALPHA,BETA,GAMMA,TRN(1),TRN(2),TRN(3)
  700     FORMAT(2X,6F12.5)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C --------------------------------------------------------------
C --- ASYMM. PART ---
      IGR=0
      CALL GET_ASYM2(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
      IF(NGR.GT.0) THEN

        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.id'')')  
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.entity_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.nc_symmetry_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_struct_asym.PDB_chain_label'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)

        DO IGR=1,NGR

          CALL GET_ASYM2(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
          IF(IERR.NE.0) RETURN
          IF(INC.LE.0) THEN
            CH2='. '
          ELSE
            WRITE(CH2,'(I2)') INC
          ENDIF
          IF(NCSF.EQ.' '.OR.NCSF.EQ.'Y') NCSF='.'
          IF(MLT.LE.1) THEN
            CH2M='. '
          ELSE
            WRITE(CH2M,'(I2)') MLT
          ENDIF
          IF(CH2M(1:1).EQ.' ') THEN
            CH2M(1:1)=CH2M(2:2)
            CH2M(2:2)=' '
          ENDIF
          CID=GID(1:1)
          IF(CID.EQ.' ') CID = '.'
          IF(ICHOLD.LT.0) ICHOLD = ABS(ICHOLD)
          WRITE(LINE,800) IGOLD,ICHOLD,CH2,NCSF,CH2M,CID
  800     FORMAT(2X,I4,2X,I4,2X,A2,2X,A1,2X,A2,2X,A1)
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO

      ENDIF
C -----------------------------------------------------------
      IF(NCRD2_CSF.GT.0) THEN
        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_a4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b1'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b2'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b3'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_b4'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_Cromer_Mann_c'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_real'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.scat_dispersion_imag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.radius_contact'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_type.nelec'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        DO ICSF=1,NCRD2_CSF
          WRITE(LINE,900) CSF2_ATOM(ICSF)
     *    ,CSF2_A1(ICSF),CSF2_A2(ICSF),CSF2_A3(ICSF),CSF2_A4(ICSF)
  900     FORMAT(2X,A4,2X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,910) 
     *    CSF2_B1(ICSF),CSF2_B2(ICSF),CSF2_B3(ICSF),CSF2_B4(ICSF)
  910     FORMAT(8X,4(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,920) 
     *    CSF2_C(ICSF),CSF2_FI(ICSF),CSF2_FII(ICSF),CSF2_NE(ICSF)
     *    ,CSF2_RAD(ICSF)
  920     FORMAT(8X,5(1X,F9.5))
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDDO
      ENDIF
C -----------------------------------------------------------
C -----------------------------------------------------------
C --- DERI ---
      IF(CR2_FLAG_HA.EQ.'Y') THEN
        WRITE(LINE,600) CR2_CF1
  600   FORMAT('_derivative.scale1',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,610) CR2_CF2
  610   FORMAT('_derivative.scale2',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,620) CR2_TOV
  620   FORMAT('_derivative.Toverall',2X,F10.5)
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
      ENDIF
C --------------------------
      RETURN
      END


C ******
      SUBROUTINE RDCRD2(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD2 - reads coordinates to common/CRD2ATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
c -------------------------------------------------
      COMMON/COM_2CRD_CIF/ IEND_CIF      
C --
      COMMON/COM_2CRD_SCR/ ICHAIN_CIF,CHAIN_CIF,CHAIN_CIF_OLD      
      INTEGER   ICHAIN_CIF
      CHARACTER CHAIN_CIF*4,CHAIN_CIF_OLD*4
C --
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*80,BFLAG*1,MULT*2,ASYMB*4,TYPE*1,CH5*5,CHAR1*1
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF       =-1
        CR2_IATOM      = 0
        IEND           = 0
        ICHAIN_CIF     = 0
        CHAIN_CIF_OLD  = '????'
      ENDIF

  300 CONTINUE   
      CALL GETCIF_2CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF
      CR2_LINE2 = ' '
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR2_LINE=LINE(1:LEN)
          IF(LINE(1:6).EQ.'#MODEL') CR2_MODEL = CR2_MODEL + 1
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IF((ITM_CIF(1)(1:11).NE.'_atom_site_').AND.
     *   (ITM_CIF(1)(1:11).NE.'_atom_site.'))  GO TO 300

      CR2_ANAME     = '    '
      CR2_ASYMB     = '    '
      CR2_RNAME     = '   '
      CR2_PNUM      = '       '       
      CR2_BTYPE     = '.'
      CR2_CORR      = '.'
      CR2_IATOLD    = 0
      CR2_IGROUP    = 0
      CR2_GROUP     = '    '
      CR2_MULT_FLAG = 1
      CR2_IRES      = 0
      IFLAG         = 0
      IFLAG_AUTH    = 0
      IFLAG_ISEQ    = 0
      CR2_SURF  = 0.0
      CR2_SEG   = '.'

      IF(CR2_MODEL.LE.0) CR2_MODEL = 1

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF(ITEM(1:10).EQ.'_atom_site') THEN

        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN
          CR2_IATOLD=IDATA
        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN
          CR2_ANAME(1:LEND)=DATA(1:LEND)
        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
          CR2_ASYMB(1:LEND) = DATA(1:LEND)
        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
          CR2_ATYPE=DATA(1:1)
        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
          CR2_ALT=DATA(1:1)
        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
          CR2_CORR=DATA(1:1)
        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
          CR2_RNAME(1:LEND)=DATA(1:LEND)

        ELSE IF(ITEM(12:23).EQ.'label_seq_id') THEN
          CR2_IRES=IDATA
          IFLAG_ISEQ = 1

        ELSE IF(ITEM(12:22).EQ.'auth_seq_id') THEN
C
C    _atom_site.auth_seq_id

          IF(LEND.GT.0) THEN
            CH5 = '     '
            J   = 5
            DO K = 5,1,-1
              IF(DATA(K:K).NE.' ') THEN
                CH5(J:J) = DATA(K:K) 
                J = J -1
              ENDIF
            ENDDO
            CHAR1 = CH5(5:5)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              DO K=2,5
                CH5(K-1:K-1) = CH5(K:K)
              ENDDO 
              CH5(5:5) = ' '
            ENDIF
          ENDIF

          CR2_PNUM(3:7) = CH5
          IFLAG_AUTH   = 1

        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN
          CHAIN_CIF = DATA(1:4)
          IF(CHAIN_CIF.NE.CHAIN_CIF_OLD) THEN
            ICHAIN_CIF = ICHAIN_CIF + 1
            CHAIN_CIF_OLD = CHAIN_CIF
          ENDIF

          CHAR1 = DATA(1:1)
          CALL CHKSMB(CHAR1,TYPE)              

          IF(TYPE.EQ.'D') THEN
            CR2_IGROUP=IDATA
          ELSE
            CR2_IGROUP=ICHAIN_CIF
          ENDIF

        ELSE IF(ITEM(13:18).EQ.'artn_x') THEN
          CR2_XYZ(1)=FDATA
          CR2_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y') THEN
          CR2_XYZ(2)=FDATA
          CR2_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z') THEN
          CR2_XYZ(3)=FDATA
          CR2_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x') THEN
          CR2_XYZ(1)=FDATA
          CR2_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y') THEN
          CR2_XYZ(2)=FDATA
          CR2_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z') THEN
          CR2_XYZ(3)=FDATA
          CR2_PDB_REC(1:1)='F'

        ELSE IF(ITEM(12:18).EQ.'surface') THEN
          CR2_SURF=FDATA
        ELSE IF(ITEM(12:18).EQ.'segment') THEN
          CR2_SEG=DATA
        ELSE IF(ITEM(12:20).EQ.'occupancy') THEN
          CR2_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv').OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR2_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR2_BTYPE = '.' 
          IF(DATA(1:4).EQ.'Uani'.OR.DATA(1:1).EQ.'A'
     *                          .OR.DATA(1:1).EQ.'a') CR2_BTYPE = 'A'
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
          IF(DATA(1:1).EQ.'.') THEN
            CR2_MULT_FACTOR=1
          ELSE
            CR2_MULT_FACTOR=IDATA
          ENDIF
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(1)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(2)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(3)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(4)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(5)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
          CR2_FLAG_USER='A'
          CR2_ANIS(6)=FDATA
        ENDIF

        ENDIF

      ENDDO


      MODE=0

      CR2_IATOM =CR2_IATOM+1

      IF(IFLAG_AUTH.EQ.0) THEN
        WRITE(CR2_PNUM(3:6),'(I4)') CR2_IRES       
        CR2_PNUM(7:7) = ' '
      ENDIF

      IF(IFLAG_ISEQ.EQ.0) THEN
        READ(CR2_PNUM(3:6),'(I4)') CR2_IRES       
      ENDIF

C ---
C     print 

      BFLAG='.'
      IF(CR2_BTYPE.EQ.'A') BFLAG='A'
      IF(CR2_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR2_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB=CR2_ASYMB
      ASYMB(3:4)='  '          
      IATOM=CR2_IATOLD
      WRITE(LINE,100)
     *   IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *   ,CR2_ALT,CR2_CORR
     *   ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *   ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *   ,CR2_OCC,CR2_BISO
c,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)
c     *    ,1X,A1,1X,A2)
      CR2_LINE=LINE

          IF(CR2_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,400) BFLAG,MULT,CR2_SURF,CR2_SEG
     *                      ,(CR2_ANIS(IAN),IAN=1,6)
 400        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,401) BFLAG,MULT,CR2_SURF,CR2_SEG
 401        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
      CR2_LINE2=LINE

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD_2/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE WRCRD2(MDOC,IOUT,MODE,IEND,IERR)
C
C -P- WRCRD2 - writes coordinates from common/CRD2ATM/ to file.
C
      INTEGER IOUT,MDOC,IERR,IEND,MODE
C ******
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      CHARACTER LINE*80,MULT*2,BFLAG*1,ALT*2,ASYMB*4
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.LE.0) THEN
        IF(IEND.LT.0) THEN
        IF(IOUT.GT.0) THEN


        WRITE(LINE,'(''loop_'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_atom_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.type_symbol'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.calc_flag'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_alt_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.footnote_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_comp_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_seq_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.label_asym_id'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)


        IF(CR2_PDB_REC(1:1).EQ.'F') THEN
          WRITE(LINE,'(''_atom_site.fract_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.fract_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ELSE
          WRITE(LINE,'(''_atom_site.cartn_x'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_y'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.cartn_z'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        WRITE(LINE,'(''_atom_site.occupancy'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.B_iso_or_equiv'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.thermal_displace_type'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.symmetry_multiplicity'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.surface'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        WRITE(LINE,'(''_atom_site.segment'')')
        CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        IF(CR2_FLAG_USER.EQ.'A') THEN
          WRITE(LINE,'(''_atom_site.aniso_U[1][1]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[3][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][2]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[1][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          WRITE(LINE,'(''_atom_site.aniso_U[2][3]'')')
          CALL WRTSTR(IOUT,MDOC,LINE,IERR)
        ENDIF

        ENDIF
        IEND=0
        ENDIF
C      ELSE IF(IEND.EQ.0) THEN
        IF(MODE.EQ.0) THEN

       
          BFLAG='.'
          IF(CR2_BTYPE.EQ.'A') BFLAG='A'

          IF(CR2_MULT_FACTOR.GT.1) THEN
            WRITE(MULT,'(I2)') CR2_MULT_FACTOR
          ELSE
            MULT='. '
          ENDIF
          ASYMB      = CR2_ASYMB
          ASYMB(3:4) = '  '          
          IATOM      = CR2_IATOLD
      
          IF(CR2_ATYPE.EQ.' ') CR2_ATYPE='.'
          IF(CR2_ALT  .EQ.' ') CR2_ALT  ='.'
          IF(CR2_CORR .EQ.' ') CR2_CORR ='.'
          IF(CR2_BISO.GT.999.99) CR2_BISO=999.99
          IF(CR2_OCC .GT.999.99) CR2_OCC =999.99
          IF(CR2_BISO.LT.-99.99) CR2_BISO=-99.99
          IF(CR2_OCC .LT.-99.99) CR2_OCC =-99.99
          IF(CR2_SURF.GT.999.99) CR2_SURF=999.99



        IF(CR2_PDB_REC(1:1).EQ.'F') THEN

            WRITE(LINE,110)
     *      IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *     ,CR2_ALT,CR2_CORR
     *     ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *     ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *     ,CR2_OCC,CR2_BISO

  110     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.5,1X,F8.5,1X,F8.5,1X,F6.2,1X,F6.2)

          ELSE 

          WRITE(LINE,100)
     *    IATOM,CR2_ANAME,ASYMB,CR2_ATYPE
     *   ,CR2_ALT,CR2_CORR
     *   ,CR2_RNAME,CR2_IRES,CR2_IGROUP
     *   ,CR2_XYZ(1),CR2_XYZ(2),CR2_XYZ(3)
     *   ,CR2_OCC,CR2_BISO

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)

          ENDIF

          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

          IF(CR2_FLAG_USER.EQ.'A') THEN

            WRITE(LINE,300)  BFLAG,MULT,CR2_SURF,CR2_SEG
     *                       ,(CR2_ANIS(IAN),IAN=1,6)
 300        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,301) BFLAG,MULT,CR2_SURF,CR2_SEG
 301        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
          IF(IOUT.GT.0) THEN
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
          ENDIF

        ELSE
          IF(IOUT.GT.0) THEN
            CALL LENSTR_BL(CR2_LINE,LEN)
            LINE = CR2_LINE        
            CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            CALL LENSTR_BL(CR2_LINE2,LEN)
            IF(LEN.GT.0) THEN
              LINE = CR2_LINE2        
              CALL WRTSTR(IOUT,MDOC,LINE,IERR)
            ENDIF
          ENDIF

        ENDIF

        IF(IERR.GT.0) GO TO 200
C ---
      ELSE
        IF(IOUT.GT.0) THEN
          END FILE IOUT
          CLOSE(IOUT)
        ENDIF
      ENDIF
      RETURN
 200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.CRD2/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END

C ----cr3---

C ******
      SUBROUTINE ORCRD3(MDOC,IN,FNAME,NSYM,ISYM,NSMAX,IERR)
C
C -P- ORCRD3 - OPEN OF FILE-CRD-3 FOR READ
C
C
      INTEGER   IN,MDOC,IERR
      INTEGER   NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
C ******
C ----------
      CHARACTER EXT*3,PATH*1,LINE*256,NAME*256
C -------------------------------------------------------------
      IERR=0
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
        LINE = NAME
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GT.4.AND.LINE(LEN-3:LEN).EQ.'.crd') THEN
          NAME=LINE(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      EXT='crd'
      PATH=' '
      CALL OPENFR(IN,MDOC,PATH,NAME,EXT,IERR)
      IF(IERR.NE.0) THEN
        IERR=1
        RETURN
      ENDIF
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.60) LEN=60
      WRITE(LINE,10) FNAME(1:LEN)
 10   FORMAT('INPUT FILE3/CRD/:',A)
      CALL MSGDOC(MDOC,LINE)
      CALL RD3_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
      IF(IERR.EQ.2) GO TO 9200
      IF(IERR.EQ.3) GO TO 9000
      IF(IERR.GT.0) IERR=4
      RETURN
9000  CONTINUE
      CALL MSGERR(MDOC,' ERR: READ OF FILE-3 /.CRD/')
      CLOSE(IN)
      IERR=3
      RETURN
9200  CONTINUE
      CALL MSGERR(MDOC,' ERR: END OF FILE-3 /.CRD/')
      IERR=2
      CLOSE(IN)
      RETURN
      END

      SUBROUTINE RD3_TTL_CRD(MDOC,IN,NSYM,ISYM,NSMAX,IERR)
C
C -P- RD3_TTL_CRD - reads title of file to common/CRD3INF/
C ----------------------------------------------------------------------------
C ---
      INTEGER   NSYM,MDOC,IN,IERR
      INTEGER   NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
C ---
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_3CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
C -------------------------------------------------
      PARAMETER (IPRAT_SF =15)
      COMMON/CRD3FRM/ NCRD3_CSF,CSF3_NE,CSF3_RAD
     *               ,CSF3_A1,CSF3_B1,CSF3_A2,CSF3_B2
     *               ,CSF3_A3,CSF3_B3,CSF3_A4,CSF3_B4
     *               ,CSF3_C,CSF3_FI,CSF3_FII,CSF3_ATOM
      CHARACTER       CSF3_ATOM(IPRAT_SF)*4
      REAL            CSF3_A1(IPRAT_SF),CSF3_B1(IPRAT_SF)
      REAL            CSF3_A2(IPRAT_SF),CSF3_B2(IPRAT_SF)
      REAL            CSF3_A3(IPRAT_SF),CSF3_B3(IPRAT_SF)
      REAL            CSF3_A4(IPRAT_SF),CSF3_B4(IPRAT_SF)
      REAL            CSF3_C (IPRAT_SF),CSF3_RAD(IPRAT_SF)
      REAL            CSF3_FI(IPRAT_SF),CSF3_FII(IPRAT_SF)
      REAL            CSF3_NE(IPRAT_SF)
C -----------------------------------
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C --------------------------------------------------------------
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C ---
      REAL        AM(3,3)
      CHARACTER   FL(6)*40
      REAL        FN(40)
C ----
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4,CH2*2,CH10*10,TYPE*1
      REAL      RLATT(6),AMR(3,3),TR(3)
      INTEGER*4 NSPGROUP,NOSETT
      CHARACTER CODE*4,NAME*20,DATE*9,SPGR*24


      CHARACTER TITLE*80,TIME*20,NAME_NDB*8,TEMPER*5,WAVE*5
      CHARACTER LINE*80,CHAR1*1
C -------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      IERR=0
C -------------------------------------------------------------------
      DO I=1,80
        CR3_TITLE(I:I)   = ' '
        TITLE(I:I)   = ' '
      ENDDO
      DO I=1,40
        CR3_NAME_PDB(I:I) = ' '
      ENDDO
      NCRD_CSF=0
      CR3_CELL(1)=1.0
      CR3_CELL(2)=1.0
      CR3_CELL(3)=1.0
      CR3_CELL(4)=PI/2.0
      CR3_CELL(5)=PI/2.0
      CR3_CELL(6)=PI/2.0
      CR3_SCALE(1,1)=1.0
      CR3_SCALE(1,2)=0.0
      CR3_SCALE(1,3)=0.0
      CR3_SCALE(2,1)=0.0
      CR3_SCALE(2,2)=1.0
      CR3_SCALE(2,3)=0.0
      CR3_SCALE(3,1)=0.0
      CR3_SCALE(3,2)=0.0
      CR3_SCALE(3,3)=1.0
      CR3_U(1)      =0.0
      CR3_U(2)      =0.0
      CR3_U(3)      =0.0
      CR3_FLAG_HA='N'
      CR3_CF1 = 0.0
      CR3_CF2 = 0.0
      CR3_TOV = 0.0
      CR3_ORT_TO_FRAC(1,1)=1.0
      CR3_ORT_TO_FRAC(1,2)=0.0
      CR3_ORT_TO_FRAC(1,3)=0.0
      CR3_ORT_TO_FRAC(2,1)=0.0
      CR3_ORT_TO_FRAC(2,2)=1.0
      CR3_ORT_TO_FRAC(2,3)=0.0
      CR3_ORT_TO_FRAC(3,1)=0.0
      CR3_ORT_TO_FRAC(3,2)=0.0
      CR3_ORT_TO_FRAC(3,3)=1.0
      CR3_FRAC_TO_ORT(1,1)=1.0
      CR3_FRAC_TO_ORT(1,2)=0.0
      CR3_FRAC_TO_ORT(1,3)=0.0
      CR3_FRAC_TO_ORT(2,1)=0.0
      CR3_FRAC_TO_ORT(2,2)=1.0
      CR3_FRAC_TO_ORT(2,3)=0.0
      CR3_FRAC_TO_ORT(3,1)=0.0
      CR3_FRAC_TO_ORT(3,2)=0.0
      CR3_FRAC_TO_ORT(3,3)=1.0
      CR3_NAME_PDB(1:13) = 'XXXXXXXX    ?'
      CR3_DATE_PDB   = 'XX-XXX-XX'
      CR3_CD_PDB     = 'XXXX'
      CR3_TITLE(1:9)   = '?   ?   ?'
      CR3_TITLE(69:78) = '?    ?    '
      CR3_RFAC_PDB = '.'
      CR3_RESL_PDB = '.'
      CR3_TIME     = '.'
      CR3_FLAG_HA  = 'N'
      CR3_FLAG_USER= 'N'
      CR3_MODEL    = 0
      CR3_NSPGR    = 1
      CR3_SETT     = 1
      CR3_SPGR     = 'P 1        '
      CR3_PDB_REC  ='.'
      CR3_NSYM     = 1
      CR3_NCS      = 0
      CR3_SYMOP    = 'X,Y,Z'
      CR3_IATOM    =0
      CR3_IRES     =0
      CR3_IATOLD   =0
      CR3_IGROUP   =0
      CR3_MULT_FLAG  =0
      CR3_MULT_FACTOR=1
      CR3_RTYPE    = '.'
      CR3_ATYPE    = '.'
      CR3_TERM     = '.'
      CR3_RNAME    = '.'
      CR3_ANAME    = '.'
      CR3_CHAIN    = '. '
      CR3_GROUP    = '.   '
      CR3_BTYPE    = 'I'
      CR3_FSC      = '.'
      CR3_FSA      = '.'
      NAME_NDB    = 'XXXX    '
      TITLE(1:1)  = '?'
      TEMPER      = '?    '
      WAVE        = '?    '
      NAME(1:1)   = '?'
C ------------------------------------------
      INCS=0
      CALL SET_NCS3(MDOC,NCMAX,INCS,AMR,TR,IERR)
      IF(IERR.NE.0) RETURN
      IGRP=0
      CALL SET_ASYM3(MDOC,NMAX,NGR,NCH,IGRP,ICH,INC,MLT,IATM
     *                    ,NCSF,GID,IERR)
      IF(IERR.NE.0) RETURN
C --
      IEND = -1
      ISOP =  0
C -------
  300 CONTINUE   
      CALL GETCIF_3CRD(IN,MDOC,IERR,IEND)
      IF(IERR.NE.0) THEN
        IERR=3
        RETURN
      ENDIF
      IF(IEND.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        GO TO 300
      ELSE IF(IEND.NE.0) THEN
        IERR=2
        RETURN
      ENDIF
      IF(N_CIF.LE.0) GO TO 300

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:18).EQ.'_database_PDB_code').OR.
     *     (ITEM(1:18).EQ.'_database_PDB.code').OR.
     *     (ITEM(1:20).EQ.'_database_2.code_PDB').OR.
     *     (ITEM(1:9).EQ.'_entry.id')) THEN
          CR3_CD_PDB = '    '
          IF(LEND.GT.4) LEND=4
          CR3_CD_PDB = DATA(1:LEND)
          IF(LEND.LT.4) THEN
            DO II=LEND+1,4
              CR3_CD_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:20).EQ.'_database_2.code_NDB')) THEN
          NAME_NDB = '?'
          IF(LEND.GT.8) LEND=8
          NAME_NDB = DATA(1:LEND)
          IF(LEND.LT.8) THEN
            DO II=LEND+1,8
              NAME_NDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_name').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.name').OR.
     *          (ITEM(1:21).EQ.'_struct_keywords.text').OR.
     *          (ITEM(1:16).EQ.'_struct.keywords')) THEN
          CR3_NAME_PDB = ' '
          IF(LEND.GT.20) LEND=20
          NAME = DATA(1:LEND)
          IF(LEND.LT.20) THEN
            DO II=LEND+1,20
              NAME(II:II)=' '
            ENDDO
          ENDIF
       ELSE IF((ITEM(1:31).EQ.'_database_PDB_rev.date_original').OR.        
     *   (ITEM(1:31).EQ.'_database_NDB_rev.date_original')) THEN         
          CR3_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR3_DATE_PDB)         
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_database_PDB_date').OR.
     *          (ITEM(1:18).EQ.'_database_PDB.date').OR.
     *          (ITEM(1:20).EQ.'_audit.creation_date')) THEN         
          CR3_DATE_PDB = '         '
          IF(LEND.GT.10) LEND=10
          CH10 = DATA(1:LEND)
          IF(CH10(5:5).EQ.'-') THEN
            CALL CHNG_DATE_BACK(CH10,CR3_DATE_PDB)         
          ELSE
            CR3_DATE_PDB = CH10(1:9)
          ENDIF
        ELSE IF((ITEM(1:13).EQ.'_struct_title').OR.
     *          (ITEM(1:13).EQ.'_struct.title')) THEN     
          IF(LEND.GT.60) LEND=60
          TITLE = DATA(1:LEND)
          IF(LEND.LT.60) THEN
            DO II=LEND+1,60
              TITLE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF(ITEM(1:19).EQ.'_file_creation_date') THEN
          IF(LEND.GT.20) LEND=20
          CR3_TIME = DATA(1:LEND)
        ELSE IF((ITEM(1:19).EQ.'_database_PDB_model').OR.
     *          (ITEM(1:19).EQ.'_database_PDB.model')) THEN
C          CR3_MODEL = IDATA
        ELSE IF((ITEM(1:31).EQ.'_database_PDB_remark_resolution').OR.
     *          (ITEM(1:31).EQ.'_database_PDB.remark_resolution')) 
     *       THEN
          IF(LEND.GT.40) LEND=40
          CR3_RESL_PDB = DATA(1:LEND)              
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR3_RESL_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:29).EQ.'_database_PDB_remark_R_factor').OR.
     *          (ITEM(1:29).EQ.'_database_PDB.remark_R_factor')) THEN
          IF(LEND.GT.40) LEND=40
          CR3_RFAC_PDB = DATA(1:LEND)
          IF(LEND.LT.40) THEN
            DO II=LEND+1,40
              CR3_RFAC_PDB(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:27).EQ.'_diffrn.ambient_temperature')) THEN
          IF(LEND.GT.5) LEND=5
          TEMPER = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              TEMPER(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:28).EQ.'_diffrn_radiation.wavelength')) THEN
          IF(LEND.GT.5) LEND=5
          WAVE = DATA(1:LEND)
          IF(LEND.LT.5) THEN
            DO II=LEND+1,5
              WAVE(II:II)=' '
            ENDDO
          ENDIF
        ELSE IF((ITEM(1:12) .EQ.'_cell_length').OR.         
     *          (ITEM(1:12) .EQ.'_cell_angle_').OR.         
     *          (ITEM(1:12) .EQ.'_cell.length').OR.         
     *          (ITEM(1:12) .EQ.'_cell.angle_')) THEN         
          IF(ITEM(7:14).EQ.'length_a') THEN
            CR3_CELL(1) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_b') THEN
            CR3_CELL(2) = FDATA
          ELSE IF(ITEM(7:14).EQ.'length_c') THEN
            CR3_CELL(3) = FDATA
          ELSE IF(ITEM(7:17).EQ.'angle_alpha') THEN
            CR3_CELL(4) = FDATA
            CR3_CELL(4) = CR3_CELL(4)*PI180
          ELSE IF(ITEM(7:16).EQ.'angle_beta') THEN
            CR3_CELL(5) = FDATA
            CR3_CELL(5) = CR3_CELL(5)*PI180
          ELSE IF(ITEM(7:17).EQ.'angle_gamma') THEN
            CR3_CELL(6) = FDATA
            CR3_CELL(6) = CR3_CELL(6)*PI180
          ENDIF
        ELSE IF(ITEM(1:9).EQ.'_symmetry') THEN
          IF(ITEM(11:23).EQ.'space_group_n') THEN
            IF(LEND.GT.11) LEND=11
            CR3_SPGR = DATA(1:LEND)
            IF(LEND.LT.11) THEN
              DO II=LEND+1,11
                CR3_SPGR(II:II)=' '
              ENDDO
            ENDIF
          ELSE IF(ITEM(11:15).EQ.'Int_T') THEN
            CR3_NSPGR = IDATA
          ELSE IF(ITEM(11:19).EQ.'cell_sett') THEN
            CR3_SETT = IDATA
          ELSE IF(ITEM(11:18).EQ.'equiv.id') THEN
          ELSE IF(ITEM(11:15).EQ.'equiv') THEN
c            IF(I.EQ.N_CIF) THEN
              LINE=DATA(1:LEND)
              ISOP=ISOP+1
              CALL SYMFR3_BL(MDOC,LINE,ISOP,NSYMR,ISYM,NSMAX,IERR)
              IF(IERR.GT.0) THEN
                CALL MSGERR(MDOC
     *          ,' ERR: WRONG NUMBER OF "_symmetry_equiv"-STRING')
                IERR=1
                RETURN
              ENDIF
              NSYM   =ISOP
              CR3_NSYM=ISOP
c            ENDIF
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_nc_symmetry') THEN
          IF(ITEM(14:18).EQ.'alpha') THEN
            ALPHA=FDATA
          ELSE IF(ITEM(14:17).EQ.'beta') THEN
            BETA =FDATA
          ELSE IF(ITEM(14:18).EQ.'gamma') THEN
            GAMMA=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_1') THEN
            TR(1)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_2') THEN
            TR(2)=FDATA
          ELSE IF(ITEM(14:21).EQ.'vector_3') THEN
            TR(3)=FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            INCS=INCS+1
            ALPHA=ALPHA*PI180
            BETA =BETA *PI180
            GAMMA=GAMMA*PI180
            CALL EULERM(ALPHA,BETA,GAMMA,AMR)
            CALL SET_NCS3(MDOC,NCMAX,INCS,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
            II=0
            CALL GET_NCS3(MDOC,NCMAX,II,AMR,TR,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF(ITEM(1:12).EQ.'_struct_asym') THEN
          IF(I.EQ.1) THEN
            IGOLD  = 0
            ICHOLD = 0
            INC    = 0
            NCSF   = '.'
            MULT   = 1
            GID    = '.   '            
          ENDIF
          IF(ITEM(14:15).EQ.'id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              IGOLD  = IDATA
            ELSE
              GID = CH2//'  '
            ENDIF
          ELSE IF(ITEM(14:22).EQ.'entity_id') THEN
            CH2   = DATA(1:2)
            CHAR1 = CH2(1:1)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              ICHOLD =IDATA
            ENDIF
          ELSE IF(ITEM(14:27).EQ.'nc_symmetry_id') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              INC=0
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)')INC
            ENDIF
          ELSE IF(ITEM(14:29).EQ.'nc_symmetry_flag') THEN
            NCSF =DATA(1:1)
          ELSE IF(ITEM(14:25).EQ.'multiplicity') THEN
            CH2 = DATA(1:2)
            CALL LENSTR_BL(CH2,LEN)
            IF(CH2(1:1).EQ.'.') THEN
              MLT=1
            ELSE
              IF(LEN.LE.1) THEN
                CH2(2:2)=CH2(1:1)
                CH2(1:1)=' '
              ENDIF
              READ(CH2,'(I2)') MLT
            ENDIF
          ELSE IF(ITEM(14:28).EQ.'PDB_chain_label') THEN
            CH2 = DATA(1:2)
            GID = CH2//'  '
          ENDIF
          IF(I.EQ.N_CIF) THEN
            IGRP  = IGRP+1
            NGR   = IGRP
            ICH   = 0
            IF(IGOLD .LE.0) IGOLD =IGRP 
            IF(ICHOLD.LE.0) ICHOLD=IGRP 
            CALL SET_ASYM3(MDOC,NMAX,NGR,ICHOLD,IGRP,ICH,INC,MLT
     *                      ,IGOLD,NCSF,GID,IERR)
            IF(IERR.NE.0) RETURN
          ENDIF
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale1').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale1')) THEN
         CR3_FLAG_HA='Y'
         CR3_CF1 = FDATA
        ELSE IF((ITEM(1:18).EQ.'_derivative_scale2').OR.
     *          (ITEM(1:18).EQ.'_derivative.scale2')) THEN
         CR3_FLAG_HA='Y'
         CR3_CF2 = FDATA
        ELSE IF((ITEM(1:20).EQ.'_derivative_Toverall').OR.
     *          (ITEM(1:20).EQ.'_derivative.Toverall')) THEN
         CR3_FLAG_HA='Y'
         CR3_TOV = FDATA
        ELSE IF((ITEM(1:11).EQ.'_atom_type_').OR.
     *          (ITEM(1:11).EQ.'_atom_type.')) THEN
          IF(NCRD3_CSF.GE.IPRAT_SF) THEN
            GO TO 410
          ENDIF
          IF(I.EQ.1) THEN
            CSF3_RAD (NCRD3_CSF+1)=0.0
            CSF3_NE  (NCRD3_CSF+1)=0.0
            CSF3_ATOM(NCRD3_CSF+1)='.   '
          ENDIF
          IF(ITEM(12:17).EQ.'symbol') THEN
            CSF3_ATOM(NCRD3_CSF+1) = DATA(1:4)
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a1') THEN
            CSF3_A1(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a2') THEN
            CSF3_A2(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a3') THEN
            CSF3_A3(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_a4') THEN
            CSF3_A4(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b1') THEN
            CSF3_B1(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b2') THEN
            CSF3_B2(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:30).EQ.'scat_Cromer_Mann_b3') THEN
            CSF3_B3(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:29).EQ.'scat_Cromer_Mann_c') THEN
            CSF3_C(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_real') THEN
            CSF3_FI(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:31).EQ.'scat_dispersion_imag') THEN
            CSF3_FII(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:17).EQ.'radius') THEN
            CSF3_RAD(NCRD3_CSF+1) =FDATA
          ELSE IF(ITEM(12:16).EQ.'nelec') THEN
            CSF3_NE(NCRD3_CSF+1)  =FDATA
          ENDIF
          IF(I.EQ.N_CIF) THEN
            NCRD3_CSF   = NCRD3_CSF + 1
          ENDIF

        ELSE IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *          (ITEM(1:11).EQ.'_atom_site.')) THEN

          GO TO 400
        ENDIF
 410    CONTINUE
      ENDDO
      GO TO 300
 400  CONTINUE

      IF(NAME_NDB(1:1).NE.'?'.AND.NAME_NDB(1:4).NE.'XXXX') THEN
        CR3_NAME_PDB(5:12)=NAME_NDB
      ELSE
        CR3_NAME_PDB(5:12)=CR3_CD_PDB//'    '
      ENDIF
      CR3_NAME_PDB(1:4)   = CR3_CD_PDB
      CR3_NAME_PDB(13:32) = NAME(1:20)

      CR3_TITLE(9:68) = TITLE
      CR3_TITLE(69:73)= WAVE
      CR3_TITLE(74:78)= TEMPER

      RETURN
      END

C ******
      SUBROUTINE RDCRD3(MDOC,IN,MODE,IEND,IERR)
C
C -P- RDCRD3 - reads coordinates to common/CRD3ATM/
C
      INTEGER IN,MDOC,IERR,IEND,MODE
C ******
C ------------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_3CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ------------------------------------------------------------
      INCLUDE 'mr_crd2_com.fh'
C ------------------------------------------------------------
C -------------------------------------------------
      COMMON/COM_3CRD_CIF/ IEND_CIF      
C --
      COMMON/COM_3CRD_SCR/ ICHAIN_CIF,CHAIN_CIF,CHAIN_CIF_OLD      
      INTEGER   ICHAIN_CIF
      CHARACTER CHAIN_CIF*4,CHAIN_CIF_OLD*4
C --
      INTEGER   IDATA
      REAL      FDATA
      CHARACTER DATA*80,ITEM*80
C --
      CHARACTER LINE*80,BFLAG*1,MULT*2,ASYMB*4,TYPE*1,CH5*5,CHAR1*1
C      CHARACTER CODE*4,ALT*2,CH2*2
C --------------------------------------------------------------
      IERR=0
      
      IF(IEND.EQ.-1) THEN
        REWIND IN
        IEND_CIF       =-1
        CR3_IATOM      = 0
        IEND           = 0
        ICHAIN_CIF     = 0
        CHAIN_CIF_OLD  = '????'
      ENDIF

  300 CONTINUE   
      CALL GETCIF_3CRD(IN,MDOC,IERR,IEND_CIF)
      IF(IERR.NE.0) THEN
        GO TO 1200
      ENDIF
      CR3_LINE2 = ' '
      IF(IEND_CIF.EQ.-2) THEN
C
C       This string / DT_CIF (NWORDSMAX) / is a comment
C   
        LINE=DT_CIF (NWORDSMAX)
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.LE.0.OR.LINE(1:1).EQ.'#'.OR.LINE(1:1).EQ.'C'.OR.
     *     LINE(1:1).EQ.'d'.OR.LINE(1:1).EQ.'c'.OR.
     *     LINE(1:1).EQ.'_') THEN
          MODE=1
          IF(LEN.LE.0) THEN
            LEN=1
            LINE(1:1)='#'
          ENDIF
          CR3_LINE=LINE(1:LEN)
          IF(LINE(1:6).EQ.'#MODEL') CR3_MODEL = CR3_MODEL + 1
          GO TO 500
        ENDIF
        GO TO 300 
      ELSE IF(IEND_CIF.NE.0) THEN
        GO TO 1300
      ENDIF

      IF(N_CIF.LE.0) GO TO 300
      IF(ITM_CIF(1)(1:11).NE.'_atom_site_')  GO TO 300

      CR3_ANAME     = '    '
      CR3_ASYMB     = '    '
      CR3_RNAME     = '   '
      CR3_PNUM      = '       '       
      CR3_BTYPE     = '.'
      CR3_CORR      = '.'
      CR3_IATOLD    = 0
      CR3_IGROUP    = 0
      CR3_GROUP     = '    '
      CR3_MULT_FLAG = 1
      CR3_IRES      = 0
      IFLAG         = 0
      IFLAG_AUTH    = 0
      IFLAG_ISEQ    = 0
      CR3_SURF  = 0.0
      CR3_SEG   = '.'

      IF(CR3_MODEL.LE.0) CR3_MODEL = 1

      DO I=1,N_CIF
        CALL LENSTR_BL(ITM_CIF(I),LENI) 
        ITEM = ITM_CIF(I)(1:LENI)
        CALL LENSTR_BL(DT_CIF(I),LEND) 
        DATA = DT_CIF(I)(1:LEND)
        CALL LENSTR_BL(BLK_CIF,LENB) 
        IDATA=IDT_CIF(I)
        FDATA=FDT_CIF(I)

        IF((ITEM(1:11).EQ.'_atom_site_').OR.
     *     (ITEM(1:11).EQ.'_atom_site.')) THEN


        IF((ITEM(12:22).EQ.'atom_number').OR.
     *     (ITEM(12:13).EQ.'id')) THEN
          CR3_IATOLD=IDATA
        ELSE IF(ITEM(12:24).EQ.'label_atom_id') THEN
          CR3_ANAME(1:LEND)=DATA(1:LEND)
        ELSE IF(ITEM(12:22).EQ.'type_symbol') THEN
          CR3_ASYMB(1:LEND) = DATA(1:LEND)
        ELSE IF((ITEM(12:20).EQ.'atom_type').OR.
     *          (ITEM(12:20).EQ.'calc_flag')) THEN
          CR3_ATYPE=DATA(1:1)
        ELSE IF(ITEM(12:23).EQ.'label_alt_id') THEN
          CR3_ALT=DATA(1:1)
        ELSE IF((ITEM(12:24).EQ.'label_corr_id').OR.
     *          (ITEM(12:22).EQ.'footnote_id')) THEN
          CR3_CORR=DATA(1:1)
        ELSE IF((ITEM(12:23).EQ.'label_res_id').OR.
     *          (ITEM(12:24).EQ.'label_comp_id')) THEN
          CR3_RNAME(1:LEND)=DATA(1:LEND)

        ELSE IF(ITEM(12:23).EQ.'label_seq_id') THEN
          CR3_IRES=IDATA
          IFLAG_ISEQ = 1
        ELSE IF(ITEM(12:22).EQ.'auth_seq_id') THEN
          IF(LEND.GT.0) THEN
            CH5 = '     '
            J   = 5
            DO K = 5,1,-1
              IF(DATA(K:K).NE.' ') THEN
                CH5(J:J) = DATA(K:K) 
                J = J -1
              ENDIF
            ENDDO
            CHAR1 = CH5(5:5)
            CALL CHKSMB(CHAR1,TYPE)              
            IF(TYPE.EQ.'D') THEN
              DO K=2,5
                CH5(K-1:K-1) = CH5(K:K)
              ENDDO 
              CH5(5:5) = ' '
            ENDIF
          ENDIF

          CR3_PNUM(3:7) = CH5
          IFLAG_AUTH   = 1

        ELSE IF((ITEM(12:26).EQ.'label_entity_id').OR.
     *          (ITEM(12:24).EQ.'label_asym_id')) THEN

          CHAIN_CIF = DATA(1:4)
          IF(CHAIN_CIF.NE.CHAIN_CIF_OLD) THEN
            ICHAIN_CIF = ICHAIN_CIF + 1
            CHAIN_CIF_OLD = CHAIN_CIF
          ENDIF

          CHAR1 = DATA(1:1)
          CALL CHKSMB(CHAR1,TYPE)              

          IF(TYPE.EQ.'D') THEN
            CR3_IGROUP=IDATA
          ELSE
            CR3_IGROUP=ICHAIN_CIF
          ENDIF
  
        ELSE IF(ITEM(13:18).EQ.'artn_x') THEN
          CR3_XYZ(1)=FDATA
          CR3_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_y') THEN
          CR3_XYZ(2)=FDATA
          CR3_PDB_REC(1:1)='C'
        ELSE IF(ITEM(13:18).EQ.'artn_z') THEN
          CR3_XYZ(3)=FDATA
          CR3_PDB_REC(1:1)='C'

        ELSE IF(ITEM(12:18).EQ.'fract_x') THEN
          CR3_XYZ(1)=FDATA
          CR3_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_y') THEN
          CR3_XYZ(2)=FDATA
          CR3_PDB_REC(1:1)='F'
        ELSE IF(ITEM(12:18).EQ.'fract_z') THEN
          CR3_XYZ(3)=FDATA
          CR3_PDB_REC(1:1)='F'

        ELSE IF(ITEM(12:18).EQ.'surface') THEN
          CR3_SURF=FDATA
        ELSE IF(ITEM(12:18).EQ.'segment') THEN
          CR3_SEG=DATA
        ELSE IF(ITEM(12:20).EQ.'occupancy') THEN
          CR3_OCC=FDATA
        ELSE IF((ITEM(12:25).EQ.'B_iso_or_equiv').OR.
     *          (ITEM(12:25).EQ.'B_isi_or_equiv')) THEN
          CR3_BISO=FDATA
        ELSE IF(ITEM(12:32).EQ.'thermal_displace_type') THEN
          CR3_BTYPE = '.' 
          IF(DATA(1:4).EQ.'Uani'.OR.DATA(1:1).EQ.'A'
     *                          .OR.DATA(1:1).EQ.'a') CR3_BTYPE = 'A'
        ELSE IF(ITEM(12:32).EQ.'symmetry_multiplicity') THEN
          IF(DATA(1:1).EQ.'.') THEN
            CR3_MULT_FACTOR=1
          ELSE
            CR3_MULT_FACTOR=IDATA
          ENDIF
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][1]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(1)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][2]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(2)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[3][3]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(3)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][2]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(4)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[1][3]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(5)=FDATA
        ELSE IF(ITEM(12:24).EQ.'aniso_U[2][3]') THEN
          CR3_FLAG_USER='A'
          CR3_ANIS(6)=FDATA
        ENDIF

        ENDIF

      ENDDO


      MODE=0
      CR3_IATOM =CR3_IATOM+1

      IF(IFLAG_AUTH.EQ.0) THEN
        WRITE(CR3_PNUM(3:6),'(I4)') CR3_IRES       
        CR3_PNUM(7:7) = ' '
      ENDIF

      IF(IFLAG_ISEQ.EQ.0) THEN
        READ(CR3_PNUM(3:6),'(I4)') CR3_IRES       
      ENDIF
C ---
C     print 

      BFLAG='.'
      IF(CR3_BTYPE.EQ.'A') BFLAG='A'
      IF(CR3_MULT_FACTOR.GT.1) THEN
        WRITE(MULT,'(I2)') CR3_MULT_FACTOR
      ELSE
        MULT='. '
      ENDIF
      ASYMB=CR3_ASYMB
      ASYMB(3:4)='  '          
      IATOM=CR3_IATOLD
      WRITE(LINE,100)
     *   IATOM,CR3_ANAME,ASYMB,CR3_ATYPE
     *   ,CR3_ALT,CR3_CORR
     *   ,CR3_RNAME,CR3_IRES,CR3_IGROUP
     *   ,CR3_XYZ(1),CR3_XYZ(2),CR3_XYZ(3)
     *   ,CR3_OCC,CR3_BISO
c,BFLAG,MULT

  100     FORMAT(I5,1X,A4,1X,A4,1X,A1,1X,A1,1X,A1,1X,A3,1X 
     *    ,I4,1X,I2,1X,F8.3,1X,F8.3,1X,F8.3,1X,F6.2,1X,F6.2)
      CR3_LINE=LINE
          IF(CR3_FLAG_USER.EQ.'A') THEN
            WRITE(LINE,400) BFLAG,MULT,CR3_SURF,CR3_SEG
     *                      ,(CR3_ANIS(IAN),IAN=1,6)
 400        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4,1X,6F9.4)
          ELSE
            WRITE(LINE,401) BFLAG,MULT,CR3_SURF,CR3_SEG
 401        FORMAT(1X,A1,1X,A2,1X,F6.2,1X,A4)
          ENDIF
      CR3_LINE2=LINE

 500  CONTINUE
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
1200  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD_3/')
      CLOSE(IN)
      IERR=1
      RETURN
1300  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END


      SUBROUTINE RDCRD_OLD(IN,MDOC
     * ,ATOM,IRES,RES3,ALT,ICHAIN,ITYPE,XA,YA,ZA,OCC,BETA
     * ,IEND,IERR)
C ---
      INTEGER*2 IRES,ICHAIN,ITYPE
      REAL      XA,YA,ZA,OCC,BETA
      CHARACTER ATOM*4,RES3*3,ALT*1
C ---
      INTEGER*2 NA
      REAL      SURF,CTEMP
      CHARACTER RES1*1,LINE*80,CYS*1
C --------------------------------------------------------------
      IERR=0
      IEND=0
      IF(IEND.EQ.-1) THEN
        DO I=1,4
          READ(IN,430,ERR=410,END=420) LINE
  430     FORMAT(A)
        ENDDO
        IEND=0
      ENDIF
      READ(IN,400,ERR=410,END=420)
     *NA,ATOM,IRES,ALT,RES1,CYS,RES3,ICHAIN,ITYPE,XA,YA,ZA,OCC
     * ,BETA,SURF,CTEMP
C
C               I   A IR    R1 CS R3 IC IT  XYZ   OCC  BETA SURF TEMP
 400  FORMAT(I5,1X,A4,I4,A1,A1,A1,A3,I3,I2,3F10.5,F6.3,F6.1,F7.2,F5.2)
C
        WRITE(LINE,400)
     *NA,ATOM,IRES,ALT,RES1,CYS,RES3,ICHAIN,ITYPE,XA,YA,ZA,OCC
     *,BETA,SURF,CTEMP
      CALL MSGDOC(MDOC,LINE)
C ---
      RETURN
 410  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.CRD/')
      CLOSE(IN)
      IERR=1
      RETURN
 420  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END

      SUBROUTINE WRSTR(MDOC,IOUT,IEND,IERR)
C ---
      COMMON/COM_STR/ DIST,THETA,PSI,RVDW,CHARGE,IDUMMY
     *              ,IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP
     *              ,LA,HR
      INTEGER*2 IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP,IDUMMY
      CHARACTER LA*1,HR*1
      REAL      DIST,PSI,THETA,RVDW,CHARGE
C ---
      COMMON/COM_OLD/ NA,IRES,ICHAIN,ITYPE
     *              ,XA,YA,ZA,OCC,BETA,SURF,CTEMP
     *              ,ATOM,ALT,RES1,CYS,RES3
      INTEGER*2 NA,IRES,ICHAIN,ITYPE
      REAL      X,Y,Z,OCC,BETA,SURF,CTEMP
      CHARACTER ATOM*4,RES1*1,RES3*3,CYS*1
C ---
      INTEGER IOUT,MDOC,IERR,IEND
      CHARACTER CLC*1,CLB*1,CLF*1,LINE*80
      DATA PI180/0.0174533/,TWOPI/6.2831852/
C --------------------------------------------------------------
      IERR=0
      WRITE(CLC,10) LC
      WRITE(CLB,10) LB
      WRITE(CLF,10) LFS
 10   FORMAT(I1)
      IF(CLC.EQ.'0') CLC=' '
      IF(CLB.EQ.'0') CLB=' '
      IF(CLF.EQ.'0') CLF=' '
C ---
      IF(IEND.EQ.0) THEN
        IF(THETA.GT.TWOPI) THETA=THETA-TWOPI
        IF(THETA.LT. 0.0 ) THETA=THETA+TWOPI
        THETA=THETA/PI180
        IF(PSI.GT.TWOPI) PSI=PSI-TWOPI
        IF(PSI.LT. 0.0 ) PSI=PSI+TWOPI
        PSI  =PSI/PI180
        WRITE(IOUT,500,ERR=510)
     *  NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
C
C               I     A IR    R1    R3 IG HR ID LC NC NB LB F1 F2 FS
 500    FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,A1,I1,I4,A1,I4,I4,I4
     *        ,A1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
C              LF RT RP LA  D   TET  PSI  RVDW CHARGE
C
C ---
C        IF(MDOC.GT.0.AND.MDOC.LT.99) THEN

          WRITE(LINE,500)
     *    NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
          CALL MSGDOC(MDOC,LINE)
C        ENDIF
      ELSE
        END FILE IOUT
        CLOSE(IOUT)
      ENDIF
      RETURN
 510  CONTINUE 
      CALL MSGERR(MDOC,' ERR: WRITE OF FILE /.STR/')
      CLOSE(IOUT)
      IERR=1
      RETURN
      END


      SUBROUTINE RDSTR(MDOC,IN,IEND,IERR)
C ---
      COMMON/COM_STR/ DIST,THETA,PSI,RVDW,CHARGE,IDUMMY
     *              ,IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP
     *              ,LA,HR
      INTEGER*2 IGRP,LC,NC,LB,NB,NF1,NF2,NFS,LFS,IRT,IRP,IDUMMY
      CHARACTER LA*1,HR*1
      REAL      DIST,PSI,THETA,RVDW,CHARGE
C ---
      COMMON/COM_OLD/ NA,IRES,ICHAIN,ITYPE
     *              ,XA,YA,ZA,OCC,BETA,SURF,CTEMP
     *              ,ATOM,ALT,RES1,CYS,RES3
      INTEGER*2 NA,IRES,ICHAIN,ITYPE
      REAL      X,Y,Z,OCC,BETA,SURF,CTEMP
      CHARACTER ATOM*4,RES1*1,RES3*3,CYS*1
C ---
      INTEGER IN,MDOC,IERR,IEND
C ---
      CHARACTER CLC*1,CLB*1,CLF*1,LINE*80
      DATA PI180/0.0174533/
C --------------------------------------------------------------
      IEND=0
      IERR=0
C ---
      READ(IN,501,ERR=510,END=520)
     *  NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,LC,NC,
     *  NB,LB,NF1,NF2,NFS,LFS,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
C
C             I     A IR    R1    R3 IG HR ID LC NC NB LB F1 F2 FS
 501  FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,I1,I1,I4,I1,I4,I4,I4
     *        ,I1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
C              LF RT RP LA  D   TET  PSI  RVDW CHARGE
C
C ---
      WRITE(CLC,10) LC
      WRITE(CLB,10) LB
      WRITE(CLF,10) LFS
 10   FORMAT(I1)
      IF(CLC.EQ.'0') CLC=' '
      IF(CLB.EQ.'0') CLB=' '
      IF(CLF.EQ.'0') CLF=' '
      WRITE(LINE,500)
     *    NA,ATOM,IRES,RES1,RES3,IGRP,HR,IDUMMY,CLC,NC,
     *  NB,CLB,NF1,NF2,NFS,CLF,IRT,IRP,LA,DIST,THETA,PSI,RVDW,CHARGE
 500  FORMAT(I5,1X,A4,I4,1X,A1,1X,A3,I3,A1,I1,A1,I1,I4,A1,I4,I4,I4
     *        ,A1,I1,I1,A1,F7.3,F7.3,F7.3,F5.2,F5.2)
      CALL MSGDOC(MDOC,LINE)
      THETA=THETA*PI180
      PSI  =PSI  *PI180
      RETURN
 510  CONTINUE 
      CALL MSGERR(MDOC,' ERR: READ OF FILE /.STR/')
      CLOSE(IN)
      IERR=1
      RETURN
 520  CONTINUE 
      CLOSE(IN)
      IEND=1
      RETURN
      END


C ******
      SUBROUTINE WBLOCK(MT,IBLOCK,NW,IERR)
C
C -P- WBLOCK - writes (unformatted) data block to file 
C
C     input : NW - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer array
C     output : IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NWMAX= 512 )
      INTEGER*4 MT,NW,IBLOCK(*),IERR
C ******
C ---------------------------------------------------------------------
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF
      NW0=0
      NW1=1
10    NW2=NW0+NWMAX
      IF(NW2.GT.NW) THEN
        NWW=NW-NW0
      ELSE
        NWW=NWMAX
      ENDIF
      NW0=NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NW1-1
      WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
C
      NW1=NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE TO OUTPUT-FILE')
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE WBLOCK_I2(MT,IBLOCK,NW_R,IERR)
C
C -P- WBLOCK_I2 - writes (unformatted) data block(integer*2) to file 
C
C     input : NW_R - number of wolds(4-bytes) that they will be written to MT
C                  from IBLOCK
C             IBLOCK - integer*2 array
C     output : IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NWMAX_R = 512 )
      INTEGER*4 MT,NW,IERR
      INTEGER*2 IBLOCK(*)
C ******
C ---------------------------------------------------------------------
      MDOC     = 0
      IERR     = 0
      NW       = NW_R   *2
      NWMAX    = NWMAX_R*2
      IF(MT.EQ.0) RETURN
      IF(NW.LE.0) THEN
        CALL MSGERR(MDOC,' ERR IN WBLOCK_I2: WRONG NUMBER WORDS')
        IERR=1
        RETURN
      ENDIF

      NW0 = 0
      NW1 = 1
10    NW2 = NW0 + NWMAX
      IF(NW2.GT.NW) THEN
        NWW = NW-NW0
      ELSE
        NWW = NWMAX
      ENDIF
      NW0 = NW0+NWW
C N    CALL WFILE(MT,0,IBLOCK(NW1),-1,NWW)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0 = NW1-1
      WRITE(MT,ERR=9) (IBLOCK(II0+II),II=1,NWW)
C
      NW1 = NW1+NWW
      IF(NW1.LE.NW) GO TO 10
      RETURN
C -------------------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR: WRITE TO OUTPUT-FILE / in wblock_i2 /')
      IERR=1
      RETURN
      END



C ******
      SUBROUTINE RBLOCK(MT,IBLOCK,NR,IERR)
C
C -P- RBLOCK - reads (unformatted) data block from file  
C
C     input  : NR - number of words(4-bytes) that will be read from MT 
C                   to array IBLOCK
C     output : IBLOCK - integer*4 array
C              IERR - 0  normal end
C                     1  error
CMS      : IBLOCK
      PARAMETER ( NRMAX= 512 )
      INTEGER*4 MT,NR,IBLOCK(*),IERR
C ******
C -------------------------------------------------------------------
      MDOC=0
      IERR=0
      NR0=0
      NR1=1
10    NR2=NR0+NRMAX
      IF(NR2.GT.NR) THEN
        NRR=NR-NR0
      ELSE
        NRR=NRMAX
      ENDIF
      NR0=NR0+NRR
C N    CALL RFILE(MT,0,IBLOCK(NR1),-1,NRR)
C N    IF(ERRCODE.NE.0) GO TO 9
C 
      II0=NR1-1
      READ(MT,ERR=9) (IBLOCK(II0+II),II=1,NRR)
C 
      NR1=NR1+NRR
      IF(NR1.LE.NR) GO TO 10
      RETURN
C ----------------
    9 CONTINUE
      CALL MSGERR(MDOC,' ERR IN RBLOCK: READ INPUT-FILE')
      IERR=1
      RETURN
      END


C ******
      SUBROUTINE ORFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C -P- ORFILE - 1.open file FNAME 
C              2.reads title of file and copy file_parameters to /COMRDF/.
C -P-
C
C     ENTRY OPFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
C
C -P- OPFILE - 1.don't open file, rewind file 
C              2.reads title of file and copy file_parameters to /COMRDF/.
C -P-
C ----------
C     CHARACTER / TTT*80,TYPE*4,FNAME*(*) /
C ----------
C     input :  MT     - unit of file
C              FNAME  - file name or " "./if " " - name will be taken
C                                                  from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C              TYPE   = '    '  don't check type of file
C                     = 'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  ' - check type of file
C                       return if file has different type
C                     = 'FF  ' means both 'F   ' and 'FS  '.  
C     output : MT =0  - signal of error.
C              TYPE   - type of file
C              FNAME  - name of file
C              TTT    - title; for file type 'COEF' :
C                                          TTT(1:4)='PATT'  for Patterson
C                                          TTT(1:4)='FOUR'  for Fourie
C              A,B,C  -                   init cell
C              AL,BE,GA  / in radian /    parameters
C
C              for file type 'RI  ' :
C                NX,NY,NZ  - number point of grid for axis x,y,z
C                IZN,IZM   - numbers of first and last z-section.
C              else
C                F1,F2     - scale,beta
C                F3,F4     - resmin,resmax
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
      INTEGER*4 MT,MDOC,NSYM
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TYPE*4
C ******
C ---
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      CHARACTER LINE2*256
      CHARACTER TTT*80,TTT2*80,NAME*256
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,SYMOP*60,WAVE*5,TEMPER*5,CHAR1*1
      INTEGER*4 NW40,ILINE(20)
      CHARACTER LINE*80,TYP*4,STR*80,PATH*1,EXT*3,CDATE*20,MSG*1
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD  = 'XXXX'
      T1_RD  = '?   '
      T2_RD  = '?   '
      PD_RD  = 'XX-XXX-XX'
      TEMPER = '?    '
      WAVE   = '?    '
C ---
      MSG = 'N'
      CH1 = FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      CALL LENSTR_BL(FNAME,NLN)
      IF(NLN.LE.0.OR.FNAME(1:1).EQ.' '.OR.FNAME(1:1).EQ.',') THEN
        CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME')
        IERR=1
        RETURN
      ENDIF

      IF(MT.LE.0.OR.MT.GT.99) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE: UNIT = 0')
        IERR=1      
        IER_RD=1
        RETURN
      ENDIF
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        LINE2 = NAME
        CALL LENSTR_BL(LINE2,LEN)
        IF(LEN.GT.4.AND.LINE2(LEN-3:LEN).EQ.'.dat') THEN
          NAME=LINE2(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------

      PATH = ' '
C?    EXT  = ' '
      EXT  = 'dat'
      MD   = MDOC

      CALL OPENUR(MT,MD,PATH,NAME,EXT,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        IERR=1      
        IER_RD=1
        RETURN
      ENDIF
      GO TO 1010
C ======================================================================
      ENTRY OPFILE(MDOC,MT,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
C ======================================================================
      IERR  = 0
      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.
C ---
      DO I=1,80
        TL_RD(I:I)= ' '
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TL_RD(1:9) = '?   ?   ?'
      DO I=1,40
        PT_RD(I:I) = ' '
      ENDDO
      PT_RD(1:13) = 'XXXXXXXX    ?'
      CD_RD='XXXX'
      T1_RD='?   '
      T2_RD='?   '
      PD_RD='XX-XXX-XX'
      TEMPER='?    '
      WAVE  ='?    '
C ---
      REWIND MT
      MSG='N'
 1010 CONTINUE
      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE1 OF FILE')
        CLOSE(MT)        
        IERR=2      
        IER_RD=2
        RETURN
      ENDIF
      CDATE=LINE(60:79)
      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)
      READ(LINE,90) TYP,A,B,C,AL,BE,GA
   90 FORMAT(1X,A4,5X,6F8.3)
      IF(TYPE.NE.'    ') THEN
        IF(TYPE.EQ.'FF  ')THEN
          IF(TYP.NE.'F   '.AND.TYP.NE.'FS  ') THEN
            CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
            CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN 
          ENDIF
        ELSE IF(TYPE.NE.TYP) THEN
          CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
          CLOSE(MT)
          IERR=2    
          IER_RD=2
          RETURN
        ENDIF
      ENDIF
      TYPE=TYP
      AL=AL*PI180
      BE=BE*PI180
      GA=GA*PI180
      TP_RD=TYP
      A_RD=A
      B_RD=B
      C_RD=C
      AL_RD=AL
      BE_RD=BE
      GA_RD=GA
      DT_RD=LINE(60:79)

 2000 CONTINUE

      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE2 OF FILE')
        CLOSE(MT)
        IERR=2    
        IER_RD=2
        RETURN
      ENDIF


      IF(LINE(1:4).EQ.'PDB:') THEN
C
C       FORMAT('PDB:',A40,1X,A9)
C       TL_RD(9:48),PD_RD
C              
        READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER
        

        GO TO 2000
      ELSE IF(LINE(1:4).EQ.'NSYM') THEN
C 
C       FORMAT('NSYM',1X,I5) NSYM
C
        READ(LINE,'(4X,1X,I5)') NSYM

        IF(NSYM.LE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ TITLE: NSYM=0')
          CLOSE(MT)
          IERR=2        
          IER_RD=2
          RETURN
        ENDIF
        IF(NSYM.GT.NSMAX) THEN
          WRITE(STR,'('' ERR: READ TITLE: NSYM >'',I5)') NSMAX
          CALL MSGERR(MDOC,STR) 
          CLOSE(MT)
          IERR=2      
          IER_RD=2
          RETURN
        ENDIF
        DO ISS=1,NSYM
          CALL RBLOCK(MT,ILINE,NW40,IERR)
          IF(IERR.NE.0) THEN
            CALL MSGERR(MDOC,' ERR: READ SYM_TITLE OF FILE')
            CLOSE(MT)
            IERR=2        
            IER_RD=2
            RETURN
          ENDIF
          
C
C
          READ(LINE,'(4X,1X,A)') SYMOP
          CALL LENSTR_BL(SYMOP,LEN)
          IF(LEN.LE.4) THEN
            WRITE(STR,'('' ERR: READ TITLE: SYM_OP'')') 
            CALL MSGERR(MDOC,STR) 
            CLOSE(MT)
            IERR=2      
            IER_RD=2
            RETURN
          ENDIF  
          NS=ISS
          CALL SYMFR2_BL(MDOC,SYMOP,NS,NSYMR,ISYM,NSMAX,IERR)
C
        ENDDO
        GO TO 2000    
      ELSE IF(LINE(1:3).EQ.'SYM') THEN
        GO TO 2000
      ENDIF

      IF(TYP.EQ.'RI  ') THEN

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '
        READ(LINE,100,ERR=999) TTT(1:48),NX,NY,NZ,IZN,IZM
        READ(LINE,'(28X,A4,A11,I3,1X,I1)',ERR=999) 
     *  CD_RD,SG_RD,NS_RD,IS_RD
        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9) IS_RD=1

c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  100   FORMAT(A48,12X,5I4)

        WRITE(STR,30) CD_RD,SG_RD,NS_RD,IS_RD,CDATE
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
     *           ,' Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)
C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX,NY,NZ,IZN,IZM
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *    ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)

        F1=0.0
        F2=0.0
        F3=0.0
        F4=0.0
      ELSE

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
        CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            IF(TPSYMB.NE.'D') LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '

        READ(LINE,110,ERR=999) TTT(1:48),F1,F2,F3,F4
        READ(LINE,'(28X,A4,A11,I3,1X,I1)',ERR=999) 
     *  CD_RD,SG_RD,NS_RD,IS_RD
        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9)   IS_RD=1
c        DO I=1,80
c          TTT(I:I)=' '
c        ENDDO
  110   FORMAT(A48,2F8.2,2F8.3)


            WRITE(STR,30) CD_RD,SG_RD,NS_RD,IS_RD,CDATE
            CALL MSGDOC(MDOC,STR)
C            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
            WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
            CALL MSGDOC(MDOC,STR)
            IF(TYP.EQ.'ALMN') THEN
              WRITE(STR,81) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   81         FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ELSE
              WRITE(STR,80) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   80         FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
            ENDIF


        NX=0
        NY=0
        NZ=0
        IZN=0
        IZM=0
      ENDIF


      PT_RD(5:24)=TTT(9:28)
      PT_RD(1:4) =CD_RD
      DO II=25,40
        PT_RD(II:II)=' '
      ENDDO

      T1_RD=TTT(1:4)
      T2_RD=TTT(5:8)

      TL_RD(1:4)  = T1_RD
      TL_RD(5:8)  = T2_RD
      TL_RD(9:48) = TTT2(1:40)
      TL_RD(69:73)= WAVE
      TL_RD(74:78)= TEMPER


      WRITE(STR,700)
     * PT_RD(5:12),PT_RD(13:24),PD_RD,TL_RD(69:73),TL_RD(74:78)
      CALL MSGDOC(MDOC,STR)
 700  FORMAT('DB_code:',A,';key:',A,';Date:',A,';Lambda:',A
     * ,';Temp:',A) 

      RN_RD=F3
      RX_RD=F4
      CF_RD=F1
      TF_RD=F2
      NX_RD=NX
      NY_RD=NY
      NZ_RD=NZ
      IN_RD=IZN
      IM_RD=IZM
      IER_RD=0
      IEN_RD=-1
      RETURN

 999  CONTINUE
      CALL MSGERR(MDOC,' ERR: problem with title2 of input file')
      CLOSE(MT)        
      IERR=3      
      IER_RD=3
      RETURN
      END

C ******
      SUBROUTINE OWFILE(MDOC,MT,FNAME,TYP,NSYM,ISYM,NSMAX,IERR)

C     *          ,A,B,C,AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C
C -P- OWFILE - 1.open file  
C -P-          2.writes title to file from common /COMRDF/
C ---------
C   CHARACTER TYPE*4,FNAME*(*)
C ---------
C     input :  MT     - unit of file. If MT=0 - return without error signal.
C              FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C              IPRINT = 1 print all information
C                     = 0 don't print
C              TYP    = type of file.
C                       'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  '
C
C      output :  FNAME     - name of file
C                MT = 0    - signal of error.
C ---
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      INTEGER*4 MT,MDOC,NSYM,NSMAX
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TTT*80
      CHARACTER TTT2*80
      CHARACTER TYP*4
C ******
C -------
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
      CHARACTER CH1*1,TPSYMB*1,NAME*256
      INTEGER*4 NW40,ILINE(20)
      INTEGER*4 IH(7)
      CHARACTER LINE2*256
      CHARACTER STR*80,CDATE*20,SYMOP*60,WAVE*5,TEMPER*5
      CHARACTER LINE*80,CH2*2,CH3*3,PATH*1,EXT*3
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IF(MT.EQ.0) RETURN
      IERR=0
      CALL LENSTR_BL(FNAME,NLN)
      IF(NLN.LE.0.OR.FNAME(1:1).EQ.','.OR.FNAME(1:1).EQ.' ') THEN
        CALL MSGERR(MDOC,' ERR: WRONG FILE_NAME')
        IERR=1
        IER_WR=1
        RETURN
      ENDIF
C -----------        
      DO I=1,80
        TTT(I:I)  = ' '
        TTT2(I:I) = ' '
      ENDDO
      TEMPER='?    '
      WAVE  ='?    '
C ------------     
C --
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.FNAME(1:1).NE.','.AND.FNAME(1:1).NE.' ') THEN
        NAME=FNAME(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 800
          ENDIF 
        ENDDO
 800    CONTINUE
        LINE2 = NAME
        CALL LENSTR_BL(LINE2,LEN)
        IF(LEN.GT.4.AND.LINE2(LEN-3:LEN).EQ.'.dat') THEN
          NAME=LINE2(1:LEN-4)
        ENDIF
      ELSE
        NAME=FNAME
      ENDIF
C -------
      PATH = ' '
C?    EXT  = ' '
      EXT  = 'dat'
      MD   = MDOC
      CALL OPENUW(MT,MD,PATH,NAME,EXT,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        IERR=1
        IER_WR=1
        RETURN
      ENDIF

      PI    = 4.0*ATAN(1.0)
      PI180 = PI/180.0
      ALW   = AL_WR/PI180
      BEW   = BE_WR/PI180
      GAW   = GA_WR/PI180
      CALL CLOCK(IH)
      TP_WR = TYP      
      IMODE = 0
      CALL CHECK_LINE(IMODE,TP_WR)
      IF(A_WR.LT.-999.999) A_WR=-999.999
      IF(A_WR.GT.9999.999) A_WR=9999.999
      IF(B_WR.LT.-999.999) B_WR=-999.999
      IF(B_WR.GT.9999.999) B_WR=9999.999
      IF(C_WR.LT.-999.999) C_WR=-999.999
      IF(C_WR.GT.9999.999) C_WR=9999.999
      IF(ALW.LT.-999.999) ALW=-999.999
      IF(ALW.GT.9999.999) ALW=9999.999
      IF(BEW.LT.-999.999) BEW=-999.999
      IF(BEW.GT.9999.999) BEW=9999.999
      IF(GAW.LT.-999.999) GAW=-999.999
      IF(GAW.GT.9999.999) GAW=9999.999
      IF(IH(2).LT.0.OR.IH(2).GT.99) IH(2)=0
      IF(IH(3).LT.0.OR.IH(3).GT.99) IH(3)=0
      IF(IH(4).LT.0.OR.IH(4).GT.99) IH(4)=0
      IF(IH(5).LT.0.OR.IH(5).GT.99) IH(5)=0
      IF(IH(6).LT.0.OR.IH(6).GT.99) IH(6)=0
      IF(IH(7).LT.0.OR.IH(7).GT.9999) IH(7)=0
       
      WRITE(LINE,10) TP_WR,A_WR,B_WR,C_WR,ALW,BEW,GAW
     * ,IH(4),IH(3),IH(2),IH(5),IH(6),IH(7)
   10   FORMAT(' ',A4,'     ',6F8.3,';',I2,'.',I2,'.',I2,'/'
     *   ,I2,'.',I2,'.',I4)
      CDATE=LINE(60:79)
      DT_WR=CDATE
      CALL GETNOS(CH3)
      LINE(7:9)=CH3

      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IER_WR=2
        IERR=2
        RETURN
      ENDIF

      WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20 FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
      CALL MSGDOC(MDOC,STR)

C ---------
      IMODE=0
      T1_WR      = TL_WR(1:4)
      T2_WR      = TL_WR(5:8)
      TTT(1:20)  = PT_WR(5:24)

      TTT2(1:40) = TL_WR(9:48)
      WAVE       = TL_WR(69:73)
      TEMPER     = TL_WR(74:78)

C     READ(LINE,'(4X,A40,1X,A9,A5,A5)') TTT2(1:40),PD_RD,WAVE,TEMPER

      CALL CHECK_LINE(IMODE,PT_WR)
      CALL CHECK_LINE(IMODE,PD_WR)
      WRITE(LINE,'(''PDB:'',A40,1X,A9,A5,A5)') 
     *  TTT2(1:40),PD_WR,WAVE,TEMPER
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR=2
        IER_WR=2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C 
C     FORMAT('NSYM',1X,I5) NSYM
C
      IF(NSYM.LE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE: NSYM=0')
        CLOSE(MT)
        IERR=2        
        IER_WR=2
        RETURN
      ENDIF
      IF(NSYM.GT.NSMAX) THEN
        WRITE(STR,'('' ERR: WRITE TITLE: NSYM >'',I5)') NSMAX
        CALL MSGERR(MDOC,STR) 
        CLOSE(MT)
        IERR=2      
        IER_WR=2
        RETURN
      ENDIF

      IF(NSYM.LT.0.OR.NSYM.GT.230) NSYM=1
      WRITE(LINE,'(''NSYM:'',I5)') NSYM
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR=2
        IER_WR=2
        RETURN
      ENDIF
      CALL MSGDOC(MDOC,LINE)

C
C         FORMAT('ISYM',1X,A) SYMOP
C

      DO     I=1,NSYM
        LINE=' ' 
        LINE(1:3)='SYM'
        WRITE(CH3,'(I3)') I
        LINE(4:4)=CH3(3:3)
        LINE(5:5)=' '
        L=5
        DO J=1,3
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I)) 
          IF(TR.LT.0) THEN
            L=L+1
            LINE(L:L)='-'
            NEG=1
          ELSE
            NEG=0
          ENDIF
          IF(ISYM(5,J,I).EQ.0) ISYM(5,J,I)=1.0
          TR=FLOAT(ISYM(4,J,I))/FLOAT(ISYM(5,J,I)) 
          TR=ABS(TR) 
          IF(TR.GT.0.49.AND.TR.LT.0.51) THEN
            L=L+1
            LINE(L:L+2)='1/2'
            L=L+2
          ELSE IF(TR.GT.0.24.AND.TR.LT.0.26) THEN
            L=L+1
            LINE(L:L+2)='1/4'  
            L=L+2 
          ELSE IF(TR.GT.0.32.AND.TR.LT.0.34) THEN
            L=L+1
            LINE(L:L+2)='1/3' 
            L=L+2 
          ELSE IF(TR.GT.0.74.AND.TR.LT.0.76) THEN
            L=L+1
            LINE(L:L+2)='3/4'
            L=L+2 
          ELSE IF(TR.GT.0.165.AND.TR.LT.0.167) THEN
            L=L+1
            LINE(L:L+2)='1/6'  
            L=L+2 
          ELSE IF(TR.GT.0.66.AND.TR.LT.0.67) THEN
            L=L+1
            LINE(L:L+2)='2/3'
            L=L+2 
          ELSE IF(TR.GT.0.833.AND.TR.LT.0.835) THEN
            L=L+1
            LINE(L:L+2)='5/6'
            L=L+2 
          ELSE
            IF(NEG.GT.0) L=L-1
          ENDIF

          DO  K=1,3
            IDG=ISYM(K,J,I) 
            IF(IDG.LT.0) THEN
              L=L+1
              LINE(L:L)='-'
            ELSE IF(IDG.GT.0) THEN
              L=L+1
              LINE(L:L)='+'
            ENDIF  
            IDG=ABS(IDG)
            IF(IDG.GT.1.AND.IDG.LT.10) THEN
              WRITE(CH1,'(I1)') IDG
              L=L+1
              LINE(L:L)=CH1  
            ELSE IF(IDG.GT.9.AND.IDG.LT.100) THEN
              WRITE(CH2,'(I2)') IDG
              L=L+1
              LINE(L:L+1)=CH2  
              L=L+1
            ELSE IF(IDG.GT.99.AND.IDG.LT.1000) THEN
              WRITE(CH3,'(I3)') IDG
              L=L+1
              LINE(L:L+2)=CH3  
              L=L+2
            ENDIF
            IF(IDG.NE.0) THEN
              L=L+1
              IF(K.EQ.1) THEN
                LINE(L:L)='X'
              ELSE IF(K.EQ.2) THEN
                LINE(L:L)='Y'
              ELSE
                LINE(L:L)='Z'
              ENDIF
            ENDIF
          ENDDO

          LINE(L+1:L+3)=' , '
          L=L+3
        ENDDO

        IMODE=0
        CALL CHECK_LINE(IMODE,LINE)
        CALL WBLOCK(MT,ILINE,NW40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
          CLOSE(MT)
          IERR=2
          IER_WR=2
          RETURN
        ENDIF
        CALL MSGDOC(MDOC,LINE)
      ENDDO
C ---------
      DO I=1,80
        LINE(I:I)=' '
      ENDDO
      IMODE=0
      CALL CHECK_LINE(IMODE,T1_WR)
      CALL CHECK_LINE(IMODE,T2_WR)

      CALL CHECK_LINE(IMODE,TL_WR(1:20))
      CALL CHECK_LINE(IMODE,CD_WR)
      CALL CHECK_LINE(IMODE,SG_WR)
      IF(NS_WR.LE.0.OR.NS_WR.GT.230) NS_WR=1
      IF(IS_WR.LE.0.OR.IS_WR.GT.9)   IS_WR=1
      IF(TYP.EQ.'RI  ') THEN
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1
        IF(NY_WR.LE.0.OR.NY_WR.GT.9999) NY_WR=1
        IF(NZ_WR.LE.0.OR.NZ_WR.GT.9999) NZ_WR=1
        IF(IN_WR.LT.-999.OR.IN_WR.GT.9999) IN_WR=0
        IF(IM_WR.LT.-999.OR.IM_WR.GT.9999) IM_WR=0
        IF(NX_WR.LE.0.OR.NX_WR.GT.9999) NX_WR=1
        WRITE(LINE,40,ERR=999) 
     *         T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
     *                ,IS_WR,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   40   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1
     *  ,'            ', 5I4)
        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,DT_WR
   30   FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
     *             ,' Sett:',I1,' Date:',A)
        CALL MSGDOC(MDOC,STR)
C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
   50   FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A40)
        CALL MSGDOC(MDOC,STR)
        WRITE(STR,60) NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
   60   FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *   ' IZmax=',I5)
        CALL MSGDOC(MDOC,STR)
      ELSE
        IF(CF_WR.GT.99999.9) CF_WR=99999.9
        IF(TF_WR.GT.99999.9) TF_WR=99999.9
        IF(CF_WR.LT.-9999.9) CF_WR=-9999.9
        IF(TF_WR.LT.-9999.9) TF_WR=-9999.9
        IF(RN_WR.LE.0.0)     RN_WR=0.01
        IF(RN_WR.GT.9999.9)  RN_WR=9999.9
        IF(RX_WR.LE.0.0)     RX_WR=0.01
        IF(RX_WR.GT.9999.9)  RX_WR=9999.9
        WRITE(LINE,70,ERR=999) 
     *   T1_WR,T2_WR,TTT(1:20),CD_WR,SG_WR,NS_WR
     *                ,IS_WR,CF_WR,TF_WR,RN_WR,RX_WR
   70   FORMAT(A4,A4,A20,A4,A11,I3,' ',I1,2F8.2,2F8.3)

        WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,CDATE
        CALL MSGDOC(MDOC,STR)
C        WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
        WRITE(STR,50) LINE(1:4),LINE(5:8),TTT2(1:40)
        CALL MSGDOC(MDOC,STR)
        IF(TYP.EQ.'ALMN') THEN
          WRITE(STR,81) CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   81     FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ELSE
          WRITE(STR,80)  CF_WR,TF_WR,RN_WR,RX_WR
          CALL MSGDOC(MDOC,STR)
   80     FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.3,
     *               ' RESmax:',F8.3)
        ENDIF
      ENDIF
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IERR=2
        IER_WR=2
        RETURN
      ENDIF
      RETURN
 999  CONTINUE
      CALL MSGERR(MDOC,' ERR: problem to write TITLE2')
      CLOSE(MT)
      IERR=3
      IER_WR=3
      RETURN
      END

C ******
      SUBROUTINE GET_TITLE(MDOC,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT,IERR)
C
C -P-  GET_TITLE - gets information from /CRDINF/
C -P-
C ---------
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
C ******
C -------
      CHARACTER TTT*(*)
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
C -------------------------------------------
      IERR=0
      CALL CLEAR_STR(TTT)
      A   = A_RD 
      B   = B_RD 
      C   = C_RD 
      AL  = AL_RD
      BE  = BE_RD
      GA  = GA_RD
      F1  = CF_RD
      F2  = TF_RD
      F3  = RN_RD
      F4  = RX_RD
      NX  = NX_RD
      NY  = NY_RD
      NZ  = NZ_RD
      IZN = IN_RD
      IZM = IM_RD
      CALL LENSTR_BL(TL_RD,LN)
      IF(LN.GT.78) LN=78
      IF(LN.LT.9) THEN
        TTT(1:4)     = T1_RD
        TTT(5:8)     = T2_RD
        TTT(9:9)     = '?'
        RETURN
      ENDIF
      TTT(1:4)     = T1_RD
      TTT(5:8)     = T2_RD
      TTT(9:LN)    = TL_RD(9:LN)
      N=LEN(TTT)
      IF(N.GE.84) THEN
        TTT(81:84)=CD_RD  
        CALL LENSTR_BL(PT_RD,LN)
        IF(LN.GT.0) THEN
          LLIM=N-80
          IF(LN.GT.LLIM) LN=LLIM
          L1=81
          L2=80+LN
          IF(LN.GE.1) TTT(L1:L2)=PT_RD(1:LN)
        ELSE
          IF(N.GE.85) TTT(85:85)='?'
        ENDIF
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE SET_TITLE(MDOC,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TITLE,IERR)
C
C -P- SET_TITLE - set information to /COMWRF/
C -P- 
C ---------
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
C ******
C -------
      CHARACTER TTT*256,TITLE*(*),CHAR9*9
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 NX,NY,NZ,IZN,IZM
C -------------------------------------------
      TTT = TITLE
      IERR=0
      DO I=1,80
        TL_WR(I:I)   = ' '
      ENDDO
      DO I=1,40
        PT_WR(I:I)   = ' '
      ENDDO
      PT_WR(1:13)   = 'XXXXXXXX    ?'
      T1_WR='?   '
      T2_WR='?   '
      TL_WR(1:9)   = '?   ?   ?'
      CD_WR='XXXX'
      A_WR = A
      B_WR = B
      C_WR = C
      AL_WR= AL
      BE_WR= BE
      GA_WR= GA
      CF_WR= F1
      TF_WR= F2
      RN_WR= F3
      RX_WR= F4
      NX_WR= NX
      NY_WR= NY
      NZ_WR= NZ
      IN_WR= IZN
      IM_WR= IZM

      CALL LENSTR_BL(TTT,LN)

      CHAR9 = '---------'

      IF(LN.LE.0) THEN
        LN = 1
        TTT(1:1) = '-'
      ENDIF
      IF(LN.LT.9) THEN
        TTT(LN+1:9) = CHAR9(LN+1:9)
      ENDIF

      CALL LENSTR_BL(TTT,LN)

      IF(LN.GT.78) LN=78

      T1_WR=TTT(1:4)
      T2_WR=TTT(5:8)
      TL_WR(1:LN)=TTT(1:LN)

      N=LEN(TTT)
      CALL LENSTR_BL(TTT,LN)

      IF(N.GE.84.AND.LN.GE.81) THEN
        CD_WR=TTT(81:84)
        PT_WR=TTT(81:LN)
      ENDIF

      RETURN
      END

C ******
      SUBROUTINE WRT (MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY WWRT (MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- WRT  - write to MT ; file of type:"F   ","PH  ","COEF","ALMN"
C -P- WWRT - write to MT ; file of type:"FS  "
C
C     input  : IHH,IKK,ILL - indices h, k, l
C              for type 'F   ' and 'FS  '
C                FAA         - structure factors F( h, k, l)
C                FBB         -                   F(-h,-k,-l)
C              only for type 'FS  '
C                SD1         - sigma F( h, k, l)
C                SD2                 F(-h,-k,-l)
C              for type 'PH  '
C                FAA         - M*cos(Phi)  M -figure of merit
C                FBB         - M*sin(Phi)
C              for type 'COEF'
C                for Patterson:/TTT(1:4)='PATT',
C                             see subroutine CTITLE or WTITLE/
C                FAA         - (Fmod)**2
C                FBB           sigma (Fmod)**2
C                for Fourie   : / TTT(1:4)='FOUR' /
C                FAA         - Fmod*M*cos(Phi)
C                FBB         - Fmod*M*sin(Phi)
C              for type 'ALMN'
C                FAA         - Almn
C                FBB         - Blmn
C              IEND        = -1  first call, subroutine ser IEND=0, NUMB=0
C                          =  0  normal next indices
C                          =  1  last record;IHH,IKK,ILL,FAA,FBB - don't used
C                          =  2  last record; write indices: 512,512,512,0,0,
C                                and close file
C              NUMB        -  integer*4 key /only two bytes are used/
C                             NUMB = 1 --> "01" free reflection 
C                             NUMB = 2 --> "10" reconctructed reflection 
C      
C              MT = 0      - means the error.
C ******
C  CMS      : FA,FB,IH,IK,IL,IBUF,IBUF4
      PARAMETER ( NWMX2= 512  )
      PARAMETER ( NWMAX=1024  )
      PARAMETER ( IND=146     )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER   NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2,SSD1,SSD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WRT/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C -----------------------------------------------
      ITYP=0
      SD1=0.
      SD2=0.
      GO TO 1000
C ===============================================================
      ENTRY WWRT (MT,IHH,IKK,ILL,FAA,FBB,SSD1,SSD2,NUMB,IEND)
C ===============================================================
      SD1=SSD1
      SD2=SSD2
      ITYP=1
1000  CONTINUE
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        SD1=0.
        SD2=0.
      ENDIF
      JTYP=0
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M   =IND
C     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      IF(ITYP.EQ.0) THEN
        FA(I)=FAA
        FB(I)=FBB
      ELSE
        IF(FAA.GT.1.E-6) THEN
          FA(I)=FAA
          IF(FBB.GT.1.E-6) THEN
            JTYP=1
            FB(I)=-SD1-3.0
          ELSE
            FB(I)= SD1+3.0
          ENDIF
        ELSE
          IF(FBB.GT.1.E-6) THEN
            FA(I)=-FBB
            FB(I)= SD2+3.0
          ELSE
            I=I-1
            GO TO 300
          ENDIF
        ENDIF
      ENDIF
      IF(IEND.GT.0) THEN
        M=I
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  IF(ITYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      IF(JTYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=-FBB
      FB(I)= SD2+3.0
      IF(IEND.GT.0) THEN
        M=I
      ELSE
        IF(I.LT.M) GO TO 300
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
300   IF(IEND.EQ.2) THEN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
C ---------------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WRT')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE WRT1(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY WWRT1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- WRT1  - write to MT ; file of type:"F   ","PH  ","COEF","ALMN"
C -P- WWRT1 - write to MT ; file of type:"FS  "
C ******
      PARAMETER ( NWMX2= 512  )
      PARAMETER ( NWMAX=1024  )
      PARAMETER ( IND=146     )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER   NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2,SSD1,SSD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WRT1/IBUF4(NWMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C -----------------------------------------
      ITYP=0
      SD1=0.
      SD2=0.
      GO TO 1000
C ===============================================================
      ENTRY WWRT1(MT,IHH,IKK,ILL,FAA,FBB,SSD1,SSD2,NUMB,IEND)
C ===============================================================
      SD1=SSD1
      SD2=SSD2
      ITYP=1
1000  CONTINUE
      MDOC=0
      IERR=0
      IF(MT.EQ.0) RETURN
      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777
      IF(IEND.GT.0) THEN
        IHH=512
        IKK=512
        ILL=512
        NUMB=0
        FAA=0.
        FBB=0.
        SD1=0.
        SD2=0.
      ENDIF
      JTYP=0
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=IND
C      NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL=NUMB*1024+ILL
      ELSE
        ILLL=ILL
      ENDIF
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      IF(ITYP.EQ.0) THEN
        FA(I)=FAA
        FB(I)=FBB
      ELSE
        IF(FAA.GT.1.E-6) THEN
          FA(I)=FAA
          IF(FBB.GT.1.E-6) THEN
            JTYP=1
            FB(I)=-SD1-3.0
          ELSE
            FB(I)= SD1+3.0
          ENDIF
        ELSE
          IF(FBB.GT.1.E-6) THEN
            FA(I)=-FBB
            FB(I)= SD2+3.0
          ELSE
            I=I-1
            GO TO 300
          ENDIF
        ENDIF
      ENDIF
      IF(IEND.GT.0) THEN
        M=I
      ELSE
C        NUMB=NUMB+1
        IF(I.LT.M) GO TO 2000
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
2000  IF(ITYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      IF(JTYP.EQ.0) THEN
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ENDIF
      I=I+1
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IH(I)=IHH
      IK(I)=IKK
      IL(I)=ILLL
      FA(I)=-FBB
      FB(I)= SD2+3.0
      IF(IEND.GT.0) THEN
        M=I
      ELSE
        IF(I.LT.M) GO TO 300
      ENDIF
C N    CALL WFILE(MT,0,IBUF4,-1, 512)
C N    IF(ERRCODE.NE.0) THEN
C N      CALL ERMSG(ERRCODE)
C N      GO TO 88888
C N    ENDIF
      WRITE(MT,ERR=88888) IBUF4
      I=0
300   IF(IEND.EQ.2) THEN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
C ---------------------------------------
99999 CONTINUE
88888 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE WRT1')
      CLOSE(MT)
      MT=0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE RD(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD  - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD - read from MT ;file of type:"FS  "
C
C     input    MT          - unit of file
C              IEND        = -1  initialization with first indices,
C                                then subroutine set IEND=0
C     output : IHH,IKK,ILL - indices h, k, l
C              for type 'F   ' and 'FS  '
C                FAA         - structure factors F( h, k, l)
C                FBB         -                   F(-h,-k,-l)
C              only for type 'FS  '
C                SD1         - sigma F( h, k, l)
C                SD2                 F(-h,-k,-l)
C              for type 'PH  '
C                FAA         - M*cos(Phi)  M -figure of merit
C                FBB         - M*sin(Phi)
C              for type 'COEF'
C                for Patterson::
C                FAA         - (Fmod)**2
C                FBB           sigma (Fmod)**2
C                for Fourie
C                FAA         - Fmod*M*cos(Phi)
C                FBB         - Fmod*M*sin(Phi)
C              for type 'ALMN'
C                FAA         - Almn
C                FBB         - Blmn
C              IEND        =  0  normal, next indices
C                          =  1  last record.  
C                             indices IHH,IKK,ILL,FAA,FBB - can not be used.
C              NUMB        -  integer*4 key /only two bytes are used/
C                             NUMB = 1 --> "01" free reflection 
C                             NUMB = 2 --> "10" reconctructed reflection 
C             output MT = 0 - means the error.
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C --------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
c     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN

30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024

      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN

50    CONTINUE
      IKK =IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD1(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD1 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD1- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD1/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD1(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
c     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN

30    IKK =IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN

50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD1')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD2(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD2(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD2 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD2- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD2/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C --------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD2(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
c     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD2')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE RD3(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD3(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD3 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD3- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD3/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL    FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ------------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD3(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
c     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD3')
      CLOSE(MT)
      MT=0

88888 CONTINUE      
      IEND=1
      RETURN
      END
C ******
      SUBROUTINE RD4(MT,IHH,IKK,ILL,FAA,FBB,NUMB,IEND)
C
C     ENTRY RRD4(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C
C -P- RD4 - read from MT ;file of type:"F   ","PH  ","COEF","ALMN"
C -P- RRD4- read from MT ;file of type:"FS  "
C ******
      PARAMETER ( NRMX2=512    )
      PARAMETER ( NRMAX=1024   )
      PARAMETER ( IND=146      )
      PARAMETER ( INDA=      1)
      PARAMETER ( INDB=IND*2+1)
      PARAMETER ( INDH=IND*4+1)
      PARAMETER ( INDK=IND*5+1)
      PARAMETER ( INDL=IND*6+1)
      PARAMETER ( INDM=IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,SD1,SD2
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RD4/IBUF4(NRMX2),I,FIRST
      INTEGER*4 IBUF4
      LOGICAL    FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ------------------------------------------------------------
      ITYP=0
      GO TO 1000
C ====================================================================
      ENTRY RRD4(MT,IHH,IKK,ILL,FAA,FBB,SD1,SD2,NUMB,IEND)
C ====================================================================
      ITYP=1
1000  JTYP=0
      MDOC=0
      IF(IEND.GT.0) RETURN
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M=0
c     NUMB=0
      IEND=0
      I=0
      FIRST=.FALSE.
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
20    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND=1
      RETURN
30    IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      IF(ITYP.EQ.0) THEN
        FAA=FA(I)
        FBB=FB(I)
      ELSE
        IF(FA(I).GT.0.) THEN
          FAA=FA(I)
          IF(FB(I).GT.0.) THEN
            SD1=FB(I)-3.
            FBB=0.
            SD2=0.
          ELSE
            JTYP=1
            SD1=ABS(FB(I))-3.
          ENDIF
        ELSE
          FAA=0.
          SD1=0.
          FBB=ABS(FA(I))
          SD2=ABS(FB(I))-3.
        ENDIF
      ENDIF
C      NUMB=NUMB+1
      IF(JTYP.EQ.0) RETURN
      IF(I.LT.M) GO TO 40

      READ(MT,ERR=99999,END=88888) IBUF4

      I=0
40    I=I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH=IH(I)
      IF(IHH.LT.512) GO TO 50
      IEND=1
      RETURN
50    CONTINUE
      IKK=IK(I)
      ILLL=IL(I)
      NUMB=ILLL/1024
      ILL=ILLL-NUMB*1024
      FBB=ABS(FA(I))
      SD2=ABS(FB(I))-3.
      RETURN
C ---------------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERR: SUBROUTINE RD3')
      CLOSE(MT)
      MT=0
88888 CONTINUE      
      IEND=1
      RETURN
      END

C ******
      SUBROUTINE WABCD(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- WABCD -  writes to MT file of type:"ABCD"
C
C      input : IHH,IKK,ILL - indices h, k, l
C                FAA         -  A  coefficients Hendrickson-Lattman
C                FBB         -  B                             
C                FCC         -  C                             
C                FDD         -  D                             
C              IEND    = -1 first indices, then subroutine set IEND=0
C                      =  0 normal write next indices
C                      =  1 last indices, IHH,IKK,ILL,FAA,FBB,FCC,FDD-not used
C                      =  2 last indices and close file.
C              NUMB        -  integer*4 key /only two bytes are used/
C                             NUMB = 1 --> "01" free reflection 
C                             NUMB = 2 --> "10" reconctructed reflection 
C   output :   MT = 0 - error
C ******
C------------------------------------------------------------------
      PARAMETER ( NWMX2 = 512    )
      PARAMETER ( NWMAX = 1024   )
      PARAMETER ( IND   = 146    )
      PARAMETER ( INDA  =       1)
      PARAMETER ( INDB  = IND*2+1)
      PARAMETER ( INDH  = IND*4+1)
      PARAMETER ( INDK  = IND*5+1)
      PARAMETER ( INDL  = IND*6+1)
      PARAMETER ( INDM  = IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WAB/IBUF4,I,FIRST
      INTEGER*4 IBUF4(NWMX2)
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC = 0
      IF(MT.EQ.0) RETURN

      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777

      IF(IEND.GT.0) THEN
        IHH  = 512
        IKK  = 512
        ILL  = 512
        NUMB = 0
        FAA  = 0.
        FBB  = 0.
        FCC  = 0.
        FDD  = 0.      
      ENDIF
C ---
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M     = IND
      IEND  = 0
      I     = 0
      FIRST = .FALSE.
C ---
10    I = I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL = NUMB*1024+ILL
      ELSE
        ILLL = ILL
      ENDIF
      IH(I) = IHH     
      IK(I) = IKK
      IL(I) = ILLL
      FA(I) = FAA
      FB(I) = FBB
      I     = I + 1
      IH(I) = IHH     
      IK(I) = IKK
      IL(I) = ILLL
      FA(I) = FCC
      FB(I) = FDD

      IF(IEND.GT.0) THEN        
        WRITE(MT,ERR=88888) IBUF4
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ELSE
        IF(I.LT.M) RETURN
      ENDIF

      WRITE(MT,ERR=88888) IBUF4
      I = 0
      RETURN
C -----------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERROR: in SUBROUTINE WABCD')
      CLOSE(MT)
      MT = 0
      RETURN
88888 CONTINUE
      CALL MSGERR(MDOC,' ERROR: writing in subroutine WABCD')
      CLOSE(MT)
      MT = 0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE WABCD1(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- WABCD1 -  writes to MT file of type:"ABCD"
C ******
C------------------------------------------------------------------
      PARAMETER ( NWMX2 = 512    )
      PARAMETER ( NWMAX = 1024   )
      PARAMETER ( IND   = 146    )
      PARAMETER ( INDA  =       1)
      PARAMETER ( INDB  = IND*2+1)
      PARAMETER ( INDH  = IND*4+1)
      PARAMETER ( INDK  = IND*5+1)
      PARAMETER ( INDL  = IND*6+1)
      PARAMETER ( INDM  = IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NWMAX),M
      COMMON/COM_WA1/IBUF4,I,FIRST
      INTEGER*4 IBUF4(NWMX2)
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC = 0
      IF(MT.EQ.0) RETURN

      IF((ABS(IHH).GT.511.OR.ABS(IKK).GT.511.OR.ABS(ILL).GT.511). 
     * AND.IEND.LE.0) GO TO 77777

      IF(IEND.GT.0) THEN
        IHH  = 512
        IKK  = 512
        ILL  = 512
        NUMB = 0
        FAA  = 0.
        FBB  = 0.
        FCC  = 0.
        FDD  = 0.      
      ENDIF
C ---
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M     = IND
      IEND  = 0
      I     = 0
      FIRST = .FALSE.
C ---
10    I = I+1       
      IF(I.GT.M.OR.I.LE.0) GO TO 99999
      IF(NUMB.GE.0.AND.NUMB.LE.31) THEN
        ILLL = NUMB*1024+ILL
      ELSE
        ILLL = ILL
      ENDIF
      IH(I) = IHH     
      IK(I) = IKK
      IL(I) = ILLL
      FA(I) = FAA
      FB(I) = FBB
      I     = I + 1
      IH(I) = IHH     
      IK(I) = IKK
      IL(I) = ILLL
      FA(I) = FCC
      FB(I) = FDD

      IF(IEND.GT.0) THEN        
        WRITE(MT,ERR=88888) IBUF4
        IF(IEND.EQ.2) THEN
          END FILE MT
          CLOSE(MT)
        ENDIF
        RETURN
      ELSE
        IF(I.LT.M) RETURN
      ENDIF

      WRITE(MT,ERR=88888) IBUF4
      I = 0
      RETURN
C -----------------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERROR: in SUBROUTINE WABCD')
      CLOSE(MT)
      MT = 0
      RETURN
88888 CONTINUE
      CALL MSGERR(MDOC,' ERROR: writing in subroutine WABCD')
      CLOSE(MT)
      MT = 0
      RETURN
77777 CONTINUE
      CALL MSGERR(MDOC,' WARNING: indeses > 511, will be ignored')
      RETURN
      END

C ******
      SUBROUTINE RABCD(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- RABCD - reads coef ABCD from MT_file /type:"ABCD"/
C
C     output : IHH,IKK,ILL - indices h, k, l
C                FAA         -  A  coefficients Hendrickson-Lattman
C                FBB         -  B                             
C                FCC         -  C                             
C                FDD         -  D                             
C              IEND  = -1  first read, then subroutine set IEND = 0
C                    =  0  normal read next indices IHH,IKK,ILL 
C                    =  1 last indices, IHH,IKK,ILL,FAA,FBB,FCC,FDD -not used
C              NUMB        -  integer*4 key /only two bytes are used/
C                             NUMB = 1 --> "01" free reflection 
C                             NUMB = 2 --> "10" reconctructed reflection 
C    output :  MT = 0 - error. 
C ******
C------------------------------------------------------------------
      PARAMETER ( NRMX2 = 512    )
      PARAMETER ( NRMAX = 1024   )
      PARAMETER ( IND   = 146    )
      PARAMETER ( INDA  =       1)
      PARAMETER ( INDB  = IND*2+1)
      PARAMETER ( INDH  = IND*4+1)
      PARAMETER ( INDK  = IND*5+1)
      PARAMETER ( INDL  = IND*6+1)
      PARAMETER ( INDM  = IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RAB/IBUF4,I,FIRST
      INTEGER*4 IBUF4(NRMX2)
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC = 0
      IF(IEND.GT.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: reading in subroutine RABCD: read with IEND > 0')
        RETURN
      ENDIF
C ---
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M     = 0
      IEND  = 0
      I     = 0
      FIRST = .FALSE.
C ---
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=77777,END=88888) IBUF4
      I = 0
C ---
20    I = I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH  = IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND = 1
      RETURN
C ---
30    IKK  = IK(I)
      ILLL = IL(I)
      NUMB = ILLL/1024
      ILL  = ILLL-NUMB*1024
      FAA  = FA(I)
      FBB  = FB(I)
      I    = I +1
      FCC  = FA(I)
      FDD  = FB(I)
      RETURN
C ---------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERROR: IN SUBROUTINE RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
C ---
77777 CONTINUE
      CALL MSGERR(MDOC,' ERROR: reading in subroutine RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
C ---
88888 CONTINUE
      CALL MSGERR(MDOC,' ERROR: end of file in subroutine RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
      END

C ******
      SUBROUTINE RABCD1(MT,IHH,IKK,ILL,FAA,FBB,FCC,FDD,NUMB,IEND)
C
C -P- RABCD1 - reads coef ABCD from MT_file /type:"ABCD"/
C ******
C------------------------------------------------------------------
      PARAMETER ( NRMX2 = 512    )
      PARAMETER ( NRMAX = 1024   )
      PARAMETER ( IND   = 146    )
      PARAMETER ( INDA  =       1)
      PARAMETER ( INDB  = IND*2+1)
      PARAMETER ( INDH  = IND*4+1)
      PARAMETER ( INDK  = IND*5+1)
      PARAMETER ( INDL  = IND*6+1)
      PARAMETER ( INDM  = IND*7+1)
      INTEGER*4 NUMB,ILLL
      REAL      FA(IND),FB(IND),FAA,FBB,FCC,FDD
      INTEGER*2 IH(IND),IK(IND),IL(IND)
      INTEGER*2 IBUF(NRMAX),M
      COMMON/COM_RA1/IBUF4,I,FIRST
      INTEGER*4 IBUF4(NRMX2)
      LOGICAL   FIRST
      EQUIVALENCE (IBUF(INDM),M),(IBUF(INDH),IH(1)),(IBUF(INDK),IK(1))
      EQUIVALENCE (IBUF(INDL),IL(1)),(IBUF(INDA),FA(1))
      EQUIVALENCE (IBUF(INDB),FB(1))
      EQUIVALENCE (IBUF(1),IBUF4(1))
C ---------------------------------------------------------------------
      MDOC = 0
      IF(IEND.GT.0) THEN
        CALL MSGERR(MDOC,
     *  ' ERROR: reading in subroutine RABCD: read with IEND > 0')
        RETURN
      ENDIF
C ---
      IF(IEND.LT.0) FIRST=.TRUE.
      IF(.NOT.FIRST) GO TO 10
      M     = 0
      IEND  = 0
      I     = 0
      FIRST = .FALSE.
C ---
10    IF(I.LT.M) GO TO 20

      READ(MT,ERR=77777,END=88888) IBUF4
      I = 0
C ---
20    I = I+1
      IF(I.LE.0.OR.I.GT.IND) GO TO 99999
      IHH  = IH(I)
      IF(IHH.LT.512) GO TO 30
      IEND = 1
      RETURN
C ---
30    IKK  = IK(I)
      ILLL = IL(I)
      NUMB = ILLL/1024
      ILL  = ILLL-NUMB*1024
      FAA  = FA(I)
      FBB  = FB(I)
      I    = I +1
      FCC  = FA(I)
      FDD  = FB(I)
      RETURN
C ---------------------------
99999 CONTINUE
      CALL MSGERR(MDOC,' ERROR: IN SUBROUTINE RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
C ---
77777 CONTINUE
      CALL MSGERR(MDOC,' ERROR: reading in subroutine RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
C ---
88888 CONTINUE
      CALL MSGERR(MDOC,' ERROR: end of file in subroutine RABCD')
      CLOSE(MT)
      MT   = 0
      IEND = 1
      RETURN
      END

      SUBROUTINE RTITLE(MT,FNAME,MDOC,TYPE,IPRINT,A,B,C,
     *             AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C    /for read OLD format/ 
C    RTITLE - 1.open file FNAME/if FNAME=' ', ask name from terminal/ 
C             2.reads title of file,return file parameters,fill /COMRDF/.
C               
C
C     ENTRY PTITLE(MT,FNAME,MDOC,TYPE,IPRINT,A,B,C,
C    *             AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C
C     PTITLE - 1.don't open file, rewind file 
C              2.reads title of file,return file parameters,fill /COMRDF/.
C ----------
C     CHARACTER / TTT*80,TYPE*4,FNAME*(*) /
C ----------
C     input :  MT     - unit of file
C              FNAME  - file name or " "./if " " - name will be taken
C                                                  from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C              IPRINT = 1 print all information
C                     = 0 don't print 
C              TYPE   = '    '  don't check type of file
C                     = 'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  ' - check type of file
C                       return if file has different type
C                     = 'FF  ' means both 'F   ' and 'FS  '.  
C     output : MT =0  - signal of error.
C              TYPE   - type of file
C              FNAME  - name of file
C              TTT    - title; for file type 'COEF' :
C                                          TTT(1:4)='PATT'  for Patterson
C                                          TTT(1:4)='FOUR'  for Fourie
C              A,B,C  -                   init cell
C              AL,BE,GA  / in radian /    parameters
C
C              for file type 'RI  ' :
C                NX,NY,NZ  - number point of grid for axis x,y,z
C                IZN,IZM   - numbers of first and last z-section.
C              else
C                F1,F2     - scale,beta
C                F3,F4     - resmin,resmax
C ---
C ---
      COMMON/COMRDF/ A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
     *              ,RN_RD,RX_RD,CF_RD,TF_RD
     *              ,NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
     *              ,NS_RD,IS_RD,IER_RD,IEN_RD
     *              ,TP_RD,T1_RD,T2_RD,TL_RD,DT_RD
     *              ,CD_RD,SG_RD,PT_RD,PD_RD
      REAL A_RD,B_RD,C_RD,AL_RD,BE_RD,GA_RD
      REAL RN_RD,RX_RD,CF_RD,TF_RD
      INTEGER*4 NX_RD,NY_RD,NZ_RD,IN_RD,IM_RD
      INTEGER*4 NS_RD,IS_RD,IER_RD,IEN_RD
      CHARACTER TP_RD*4,T1_RD*4,T2_RD*4,TL_RD*80,DT_RD*20     
      CHARACTER CD_RD*4,SG_RD*24,PT_RD*40,PD_RD*9
C ---
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 MT,MDOC,IPRINT,NX,NY,NZ,IZN,IZM
      CHARACTER FNAME*(*)
      CHARACTER TTT*80
      CHARACTER TYPE*4
C ---
      CHARACTER CH1*1,TPSYMB*1,ASKL*80,CHAR1*1
      INTEGER*4 NW40,ILINE(20)
      CHARACTER LINE*80,TYP*4,STR*80,PATH*1,EXT*1,CDATE*20,MSG*1
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      PI=4.0*ATAN(1.0)
      PI180=PI/180.
C  ---
      MSG='N'
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      CALL LENSTR_BL(FNAME,NLN)
      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) THEN
        IF(MDOC.GE.0.AND.MDOC.LT.99) THEN
 1000     CONTINUE
          MSG='Y'
C          CALL DISPL_BL('FILE :')
C          READ(*,'(A)') FNAME
          ASKL='IN_FILE:'
          CALL ASK(ASKL)
          READ(ASKL,'(A)') FNAME
          CALL LENSTR_BL(FNAME,NLN)
          IF(NLN.GT.0) THEN
            PATH=' '
            EXT=' '
            CALL OPENUR(MT,MDOC,PATH,FNAME,EXT,IERR)
          ELSE 
            IERR=1
          ENDIF
          IF(IERR.NE.0) GO TO 1000
        ELSE
          IERR=1
        ENDIF
      ELSE
        PATH=' '
        EXT=' '
        MD=MDOC
        IF(IPRINT.EQ.0) MD=99
        CALL OPENUR(MT,MD,PATH,FNAME,EXT,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        MT=0        
        IER_RD=1
        RETURN
      ENDIF
      GO TO 1010
C ======================================================================
      ENTRY PTITLE(MT,FNAME,MDOC,TYPE,IPRINT,A,B,C,
     *                 AL,BE,GA,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C ======================================================================
      REWIND MT
      MSG='N'
 1010 CONTINUE
      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE1 OF FILE')
        CLOSE(MT)        
        MT=0        
        IER_RD=1
        RETURN
      ENDIF
      CDATE=LINE(60:79)
      IF(IPRINT.NE.0) THEN
        IF(MDOC.GE.0.AND.MDOC.LT.99) THEN 
          WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20     FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
          CALL MSGDOC(MDOC,STR)
        ENDIF
      ENDIF
      READ(LINE,90) TYP,A,B,C,AL,BE,GA
   90 FORMAT(1X,A4,5X,6F8.3)
      IF(TYPE.NE.'    ') THEN
        IF(TYPE.EQ.'FF  ')THEN
          IF(TYP.NE.'F   '.AND.TYP.NE.'FS  ') THEN
            CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
            CLOSE(MT)
            IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 1111
            MT=0        
            IER_RD=1
            RETURN 
          ENDIF
        ELSE IF(TYPE.NE.TYP) THEN
          CALL MSGERR(MDOC,' ERR: WRONG FILE TYPE ')
          CLOSE(MT)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 1111
          MT=0        
          IER_RD=1
          RETURN
        ENDIF
      ENDIF
 1111 CONTINUE
      TYPE=TYP
      AL=AL*PI180
      BE=BE*PI180
      GA=GA*PI180
      TP_RD=TYP
      A_RD=A
      B_RD=B
      C_RD=C
      AL_RD=AL
      BE_RD=BE
      GA_RD=GA
      DT_RD=LINE(60:79)

 2000 CONTINUE

      CALL RBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: READ TITLE2 OF FILE')
        CLOSE(MT)
        MT=0        
        IER_RD=1
        RETURN
      ENDIF

      PT_RD='----'
      PD_RD='XX-XXX-XX'

      IF(LINE(1:4).EQ.'PDB ') THEN
C
C       FORMAT('PDB:',A40,1X,A9)
C       PT_RD,PD_RD
C              
        GO TO 2000
      ELSE IF(LINE(1:4).EQ.'NSYM') THEN
C 
C       FORMAT('NSYM',1X,I5) NSYM
C

        GO TO 2000
      ELSE IF(LINE(1:4).EQ.'ISYM') THEN
C
C       FORMAT('ISYM',1X,A16) SYMOP
C
        GO TO 2000
      ENDIF

      IF(TYP.EQ.'RI  ') THEN

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '

        READ(LINE,100) TTT(1:48),NX,NY,NZ,IZN,IZM
        READ(LINE,'(28X,A4,A11,I3,1X,I1)') CD_RD,SG_RD,NS_RD,IS_RD
        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9) IS_RD=1
        TTT(49:80)=' '
  100   FORMAT(A48,12X,5I4)
        IF(IPRINT.NE.0) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN 
            WRITE(STR,30) CD_RD,SG_RD,NS_RD,IS_RD,CDATE
   30       FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
     *             ,' Sett:',I1,' Date:',A)
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
   50       FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A20)
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,60) NX,NY,NZ,IZN,IZM
   60        FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *      ' IZmax=',I5)
            CALL MSGDOC(MDOC,STR)
          ENDIF
        ENDIF
        F1=0.0
        F2=0.0
        F3=0.0
        F4=0.0
      ELSE

        CHAR1 = LINE(46:46)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') THEN
          LINE(44:46)='   '
        ELSE
          CHAR1 = LINE(45:45)
          CALL CHKSMB(CHAR1,TPSYMB)
          IF(TPSYMB.NE.'D') THEN
            LINE(44:45)='  '
          ELSE
            CHAR1 = LINE(44:44)
            CALL CHKSMB(CHAR1,TPSYMB)
            LINE(44:44)=' '
          ENDIF
        ENDIF
        CHAR1 = LINE(48:48)
        CALL CHKSMB(CHAR1,TPSYMB)
        IF(TPSYMB.NE.'D') LINE(48:48)=' '

        READ(LINE,110) TTT(1:48),F1,F2,F3,F4
        READ(LINE,'(28X,A4,A11,I3,1X,I1)') CD_RD,SG_RD,NS_RD,IS_RD
        IF(NS_RD.LE.0.OR.NS_RD.GT.230) NS_RD=1
        IF(IS_RD.LE.0.OR.IS_RD.GT.9) IS_RD=1
        TTT(49:80)=' '
  110   FORMAT(A48,4F8.2)
        IF(IPRINT.NE.0) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN 
            WRITE(STR,30) CD_RD,SG_RD,NS_RD,IS_RD,CDATE
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
            CALL MSGDOC(MDOC,STR)
            IF(TYP.EQ.'ALMN') THEN
              WRITE(STR,81) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   81         FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.2,
     *               ' RESmax:',F8.2)
            ELSE
              WRITE(STR,80) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   80         FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.2,
     *               ' RESmax:',F8.2)
            ENDIF
          ENDIF
        ENDIF
        NX=0
        NY=0
        NZ=0
        IZN=0
        IZM=0
      ENDIF

      T1_RD=TTT(1:4)
      T2_RD=TTT(5:8)
      TL_RD=TTT(9:28)
      RN_RD=F3
      RX_RD=F4
      CF_RD=F1
      TF_RD=F2
      NX_RD=NX
      NY_RD=NY
      NZ_RD=NZ
      IN_RD=IZN
      IM_RD=IZM
      IER_RD=0
      IEN_RD=-1
      RETURN
      END


      SUBROUTINE WTITLE(MT,FNAME,MDOC,TYP,IPRINT,A,B,C,AL,BE,GA
     *                 ,F1,F2,F3,F4,NX,NY,NZ,IZN,IZM,TTT)
C    /for write OLD format/ 
C    WTITLE - 1.open file FNAME /if FNAME=' ', ask name from terminal/ 
C             2.writes title to file, get some parameters from common
C              /COMRDF/: NS_WR - No Space Group, IS_WR - No Setting.
C ---------
C   CHARACTER TTT*80,TYPE*4,FNAME*(*)
C ---------
C     input :  MT     - unit of file. If MT=0 - return without error signal.
C              FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C              MDOC   - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C              IPRINT = 1 print all information
C                     = 0 don't print
C              TYP    = type of file.
C                       'F   ' or 'FS  ' or 'COEF' or 'ABCD'
C                       'ALMN' or 'RI  '
C              TTT    - title of file/ TTT(1:4),TTT(5:8) - subtitles
C                                      TTT(9:37)         - any text  /
C              A,B,C                      init cell
C              AL,BE,GA  / in radian /    parameters
C
C              for file type 'RI  ' :
C                NX,NY,NZ  - number point of grid for axis x,y,z
C                IZN,IZM   - numbers of first and last z-section.
C              else
C                F1,F2     - scale,beta
C                F3,F4     - resmin,resmax
C      output :  FNAME     - name of file
C                MT = 0    - signal of error.
C ---
C ---
      COMMON/COMWRF/ A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
     *              ,RN_WR,RX_WR,CF_WR,TF_WR
     *              ,NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
     *              ,NS_WR,IS_WR,IER_WR,IEN_WR
     *              ,TP_WR,T1_WR,T2_WR,TL_WR,DT_WR
     *              ,CD_WR,SG_WR,PT_WR,PD_WR
      REAL A_WR,B_WR,C_WR,AL_WR,BE_WR,GA_WR
      REAL RN_WR,RX_WR,CF_WR,TF_WR
      INTEGER*4 NX_WR,NY_WR,NZ_WR,IN_WR,IM_WR
      INTEGER*4 NS_WR,IS_WR,IER_WR,IEN_WR
      CHARACTER TP_WR*4,T1_WR*4,T2_WR*4,TL_WR*80,DT_WR*20     
      CHARACTER CD_WR*4,SG_WR*24,PT_WR*40,PD_WR*9
C ---
      REAL A,B,C,AL,BE,GA,F1,F2,F3,F4
      INTEGER*4 MT,MDOC,IPRINT,NX,NY,NZ,IZN,IZM
      CHARACTER FNAME*(*)
      CHARACTER TTT*80
      CHARACTER TYP*4
C -------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 NW40,ILINE(20)
      INTEGER*4 IH(7)
      CHARACTER STR*80,CDATE*20,ASKL*80
      CHARACTER LINE*80,CH3*3,PATH*1,EXT*1
      EQUIVALENCE (ILINE(1),LINE)
      DATA NW40/20/
C ----------------------------------------------------------------------
      IF(MT.EQ.0) RETURN
C  ---
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      CALL LENSTR_BL(FNAME,NLN)
      IF(FNAME(1:1).EQ.' '.OR.NLN.LE.0) THEN
        IF(MDOC.GE.0.AND.MDOC.LT.99) THEN
 1000     CONTINUE
C          CALL DISPL_BL('FILE :')
C          READ(*,'(A)') FNAME
          ASKL='OUT_FILE:'
          CALL ASK(ASKL)
          READ(ASKL,'(A)') FNAME
          CALL LENSTR_BL(FNAME,NLN)
          IF(NLN.GT.0) THEN
            PATH=' '
            EXT=' '
            CALL OPENUW(MT,MDOC,PATH,FNAME,EXT,IERR)
          ENDIF
          IF(IERR.NE.0) GO TO 1000
        ELSE
          IERR=1
        ENDIF
      ELSE
        PATH=' '
        EXT=' '
        MD=MDOC
        IF(IPRINT.EQ.0) MD=99  
        CALL OPENUW(MT,MD,PATH,FNAME,EXT,IERR)
      ENDIF
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: OPEN FILE')
        MT=0
        IER_WR=1
        RETURN
      ENDIF
      PI=4.0*ATAN(1.0)
      PI180=PI/180.0
      ALW=AL/PI180
      BEW=BE/PI180
      GAW=GA/PI180
      CALL CLOCK(IH)
      WRITE(LINE,10) TYP,A,B,C,ALW,BEW,GAW,IH(4),IH(3),IH(2),
     * IH(5),IH(6),IH(7)
   10   FORMAT(' ',A4,'     ',6F8.3,';',I2,'.',I2,'.',I2,'/'
     *   ,I2,'.',I2,'.',I4)
      CDATE=LINE(60:79)
      CALL GETNOS(CH3)
      LINE(7:9)=CH3
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        IER_WR=1
        MT=0
        RETURN
      ENDIF
      IF(IPRINT.NE.0) THEN
        WRITE(STR,20) LINE(2:5),LINE(7:9),LINE(11:58)
   20   FORMAT('Type:',A,'; OS:',A,'; CELL:',A)
        CALL MSGDOC(MDOC,STR)
      ENDIF
C ---------
      IF(NS_WR.LE.0.OR.NS_WR.GT.230) NS_WR=1
      IF(IS_WR.LE.0.OR.IS_WR.GT.9) IS_WR=1
      IF(TYP.EQ.'RI  ') THEN
        WRITE(LINE,40) TTT(1:28),CD_WR,SG_WR,NS_WR,IS_WR
     *                ,NX,NY,NZ,IZN,IZM
   40   FORMAT(A28,A4,A11,I3,' ',I1,12X,5I4)
        IF(IPRINT.NE.0) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN 
            WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,CDATE
   30       FORMAT('CodePDB:',A4,' Sp.Gr:',A11,' No Sp.Gr:',I3
     *             ,' Sett:',I1,' Date:',A)
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
   50       FORMAT('Code1:',A4,'; Code2:',A4,'; Title:',A20)
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,60) NX,NY,NZ,IZN,IZM
   60        FORMAT('Grid:  NX=',I5,' NY=',I5,' NZ=',I5,' IZmin=',I5,
     *      ' IZmax=',I5)
            CALL MSGDOC(MDOC,STR)
          ENDIF
        ENDIF
      ELSE
        WRITE(LINE,70) TTT(1:28),CD_WR,SG_WR,NS_WR,IS_WR,F1,F2,F3,F4
   70   FORMAT(A28,A4,A11,I3,' ',I1,4F8.2)
        IF(IPRINT.NE.0) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN 
            WRITE(STR,30) CD_WR,SG_WR,NS_WR,IS_WR,CDATE
            CALL MSGDOC(MDOC,STR)
            WRITE(STR,50) LINE(1:4),LINE(5:8),LINE(9:28)
            CALL MSGDOC(MDOC,STR)
            IF(TYP.EQ.'ALMN') THEN
              WRITE(STR,81) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   81         FORMAT('Rad:',F8.2,' Zsymm:',F8.2,' RESmin:',F8.2,
     *               ' RESmax:',F8.2)
            ELSE
              WRITE(STR,80) F1,F2,F3,F4
              CALL MSGDOC(MDOC,STR)
   80         FORMAT('Scale:',F8.2,' Bfactor:',F8.2,' RESmin:',F8.2,
     *               ' RESmax:',F8.2)
            ENDIF
          ENDIF
        ENDIF
      ENDIF
      CALL WBLOCK(MT,ILINE,NW40,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE TITLE OF FILE')
        CLOSE(MT)
        MT=0
        IER_WR=1
        RETURN
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE BYTARR(MDOC,IMODE,FNAME,POOL,IPRPLN,IR,IPRMEM,ZMINTS,
     *   KX,KY,KZ,KZMIN,KZMAX,AR,BR,CR,ALR,BER,GAR,RMAX,R000,SCALE,
     *   POSITIV,PERCENT,ISYM,IPRSYM,IERR)
C ----------------------------------------------------------------------
C
C -P- BYTARR - reads electron-dens-file into byte-array IR
C
C input:
C  FNAME - file name. If FNAME = ' ' - FNAME,MSG,PERCENT will be
C                                            taken from terminal.
C  MDOC  - mode of writting messages to DOC-file
C                0 - only term, < - 0 only file, 0 < < 99 - both
C                >= 99 - not write  
C  IMODE=0
C
C         input    JX : from: 0 to: KX-1
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMIN - KZMAX
C         output   ID        byte-array IR 
C                             / dimension KX,KY,KZMAX-KZMIN+1/
C
C  IMODE=1
C
C         KX - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY-1
C                  JZ : from: 0 to: KZMAX-KZMIN
C         output   ID        byte-array IR 
C                             / dimension KX/2+1,KY,KZMAX-KZMIN+1/
C
C  IMODE=2
C
C         KX - EVEN
C         KY - EVEN
C
C         input    JX : from: 0 to: KX/2
C                  JY : from: 0 to: KY/2
C                  JZ : from: 0 to: KZMAX-KZMIN
C
C         output   ID        byte-array IR 
C
C   POSITIV /<'Y'>/ - using positive value only 
C
C   PERCENT        percent of R-MAX, if =0 take value from 
C                       title of file   
C                   RMAX - max value of dens in array IR
C
C      input file-DENS  cell : KX,KY,KZ, KZMIN=0 , KZMAX >= ZMINTS * KZ
C                             AR,BR,CR /angstroms/,ALR,BER,GAR /radians/
C
C ---------
C            DENS(JX,JY,JZ) --> ID/byte/ = (DENS-R000)/SCALE
C
C         output IERR > 0 is signal of error.
C ---------------------------------------------------------------------
CMS      : IR,POOL
      INTEGER*2 IR  (IPRMEM)
      INTEGER*2 POOL(IPRPLN)
      CHARACTER MSG*1,POSITIV*1
C ---
C ******
      CHARACTER TITLE*160,FNAME*(*),LINE*80
C ---------------------------------------------------------------------
      IERR = 0
      MD   =-ABS(MDOC)-1
      MSG  = POSITIV
      MTIN = 31
      CALL LENSTR_BL(FNAME,LEN)
      IF(LEN.GT.0.AND.(FNAME(1:1).NE.','.OR.FNAME(1:1).NE.',')) THEN
        ITYPE  =0
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TITLE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
          RETURN
        ENDIF
        KXY=KX*KY
        IF(KXY.GT.IPRPLN) THEN
        WRITE(LINE,'('' ERR: not memory '',I4,'' x'',I4,'' >'',I8)')
     *             KX,KY,IPRPLN
          CALL MSGERR(MDOC,LINE)
          CLOSE(MTIN)
          RETURN
        ENDIF
      ELSE
        IERR=1
        CALL MSGERR(MDOC,' ERR: OPEN FILE-DENS')
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      ITESTZ=KZ*ZMINTS
      IF(KZMAX.LT.ITESTZ) THEN
        WRITE(TITLE,10) ITESTZ
 10     FORMAT(' ERR:   Z-MAX < ',I6)
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
      IF(KZMIN.NE.0) THEN
        CALL MSGERR(MDOC,' ERR:   Z-MIN NE 0')
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C ---------------------------------------------------------------------
      IF(IMODE.EQ.0) THEN
        KXYZ=(KXY*ITESTZ)/2+1
      ELSE IF(IMODE.EQ.1) THEN
        IT=MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERR:  NX IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KX2=KX/2
        KXYZ=((KX2+1)*KY*ITESTZ)/2+1
      ELSE IF(IMODE.EQ.2) THEN
        IT=MOD(KX,2)
        IF(IT.NE.0) THEN
          CALL MSGERR(MDOC,' ERR:  NX IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        IT=MOD(KY,2)
        IF(IT.NE.0) THEN
C          WRITE(*,*) ' ERR: NY IS NOT EVEN'
          CALL MSGERR(MDOC,' ERR: NY IS NOT EVEN')
          CLOSE (MTIN)
          IERR=1
          RETURN
        ENDIF
        KY2=KY/2
        KX2=KX/2
        KXYZ=((KX2+1)*(KY2+1)*ITESTZ)/2+1
      ENDIF
      IF(KXYZ.GT.IPRMEM) THEN
        WRITE(TITLE,30) IPRMEM
 30     FORMAT(' ERR:   NOT MEMORY FOR BYTE-ARRAY :',I6)
        CALL MSGERR(MDOC,TITLE)
        CLOSE (MTIN)
        IERR=1
        RETURN
      ENDIF
C --------------------------------------------
      R000=-RMIN          
      IF(MSG.EQ.'n') MSG='N'
      IF(MSG.NE.'N') R000=0.0             
C ---------------------------
      RRMAX=0.0
      IF(PERCENT.LE.0.0) PERCENT=100.
      RRMAX=RMAX*(PERCENT/100.)
      WRITE(TITLE,40) PERCENT
 40   FORMAT(' PERCENT OF R-MAX :',F10.5)
      CALL MSGDOC(MDOC,TITLE)
      WRITE(TITLE,50) RRMAX
 50   FORMAT(' R-MAX NOW :',F18.6)
      CALL MSGDOC(MDOC,TITLE)
      SCALE=(RRMAX+R000)/254.9
C --------------------------------------------
      IF(IMODE.EQ.0) THEN
        NX=KX
        NY=KY
      ELSE IF(IMODE.EQ.1) THEN
        NX=KX2+1
        NY=KY
      ELSE IF(IMODE.EQ.2) THEN
        NX=KX2+1
        NY=KY2+1
      ENDIF
C -------------------------------------------
      ITYPE=1
      IM=-1
      CALL SETDEN(IM,IX,IY,IZZ,ID,IR,KX,KY,KZ,KZMIN,KZMAX)
      DO     IZ=KZMIN,ITESTZ
        IZZ=IZ-KZMIN
        CALL IRDENS(MTIN,FNAME,MD,ITYPE,ICNTZ,KX,KY,KZ,KZMAX,
     *  KZMIN,RMAX,RMIN,POOL,SCALER,AR,BR,CR,ALR,BER,GAR,DRMS,
     *  RAVER,RESOL,JX0,JY0,JZ0,JTR,TITLE,NSYM,ISYM,IPRSYM,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-DENS')
          CLOSE(MTIN)
          RETURN
        ENDIF
        DO     IY=0,NY-1
          IND=IY*KX
          DO     IX=0,NX-1
            JND=IND+IX+1
            D =POOL(JND)/SCALER
            ID=(D+R000)/SCALE
            IF(ID.LT.  0) ID=  0
            IF(ID.GT.255) ID=255
            CALL SETDEN(IMODE,IX,IY,IZZ,ID,IR,KX,KY,KZ,KZMIN,KZMAX)
          ENDDO
        ENDDO
      ENDDO            
      CLOSE (MTIN)
      RETURN
      END

C ******
      SUBROUTINE GETDNS(MDOC,IMODE,X,Y,Z,DENS,IR,NX,NY,NZ,NZMIN,NZMAX,
     *                  R000,SCALE,IERR)
C ------------------------------------------------------------------
C
C -P- GETDNS - get DENS from array IR-"byte"
C
C      input : X,Y,Z  -  >= 0  /in unit cell/
C                       NX,NY,NZ NZMIN-NZMAX  NZMIN=0
C
C      output: DENS   = ID/BYTE/ * SCALE - R000
C -------------------------------------------------------------------
C
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   DENS   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C         output IERR > 0 is signal of error.
C ------------------------------------------------------------------
CMS      : IR
      INTEGER*2 IR(*)
C ------------------------------------------------------------------
C ******
      IERR=0
      MD=-ABS(MDOC)-1
      IF(X.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> X < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Y.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> Y < 0')
        IERR=1
        RETURN
      ENDIF
      IF(Z.LT.0.0) THEN
        CALL MSGERR(MDOC,' ERR: IN SUBR "GETDNS" --> Z < 0')
        IERR=1
        RETURN
      ENDIF
      NX2=NX/2
      NY2=NY/2
      IX=X*NX
      IY=Y*NY
      IZ=Z*NZ
      AX=X*NX-IX
      AY=Y*NY-IY
      AZ=Z*NZ-IZ
      IF(IZ .GT.NZMAX) IZ =NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IX .GE.NX ) IX =0
        IF(IY .GE.NY ) IY =0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IX .GT.NX2) IX =NX2
        IF(IY .GE.NY ) IY =0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IX .GT.NX2) IX =NX2
        IF(IY .GE.NY2) IY =NY2
      ENDIF
      IXX=IX+1
      IYY=IY+1
      IZZ=IZ+1
      IF(IZZ.GT.NZMAX) IZZ=NZMAX
      IF(IMODE.EQ.0) THEN
        IF(IXX.GE.NX ) IXX=0
        IF(IYY.GE.NY ) IYY=0
      ELSE IF(IMODE.EQ.1) THEN
        IF(IXX.GT.NX2) IXX=NX2
        IF(IYY.GE.NY ) IYY=0  
      ELSE IF(IMODE.EQ.2) THEN
        IF(IXX.GT.NX2) IXX=NX2
        IF(IYY.GE.NY2) IYY=NY2
      ENDIF
      AAX=1.0-AX
      AAY=1.0-AY
      AAZ=1.0-AZ
      CALL GTDENS(IMODE,IX ,IY ,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R111=IDEN
      CALL GTDENS(IMODE,IX ,IY ,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R112=IDEN
      CALL GTDENS(IMODE,IXX,IYY,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R221=IDEN
      CALL GTDENS(IMODE,IXX,IYY,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R222=IDEN
      CALL GTDENS(IMODE,IXX,IY ,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R211=IDEN
      CALL GTDENS(IMODE,IXX,IY ,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R212=IDEN
      CALL GTDENS(IMODE,IX ,IYY,IZ ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R121=IDEN
      CALL GTDENS(IMODE,IX ,IYY,IZZ,IDEN,IR,NX,NY,NZ,NZMIN,NZMAX)
      R122=IDEN
  
      R1=AAX*R111+AX*R211
      D1=AAX*R112+AX*R212
      R2=AAX*R121+AX*R221
      D2=AAX*R122+AX*R222
      RY=AAY*R1  +AY*R2
      DY=AAY*D1  +AY*D2
      DP=AAZ*RY  +AZ*DY

      DENS=DP*SCALE-R000

      RETURN
      END

C ******
      SUBROUTINE GTDENS(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C -------------------------------------------------------------------
C     ==== GTDENS ======
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMIN - NZMAX
C         output   ID   from byte-array IR 
C                             / dimension NX,NY,NZMAX-NZMIN+1/
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY,NZMAX-NZMIN+1/
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C
C         output   ID   from byte-array IR 
C                             / dimension NX/2+1,NY/2+1,NZMAX-NZMIN+1/
C
C ---------------------------------------------------------------------
C     ==== SETDEN ======
C -----------------------------
C     ENTRY SETDEN(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C    !!!!   FIRST CALL SETDEN WITH IMODE=-1
C -P-        GTDENS
C -P-  ENTRY SETDEN
C -----------------------------
C  IMODE=0
C         input    JX : from: 0 to: NX-1
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=1
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY-1
C                  JZ : from: 0 to: NZMAX-NZMIN
C  IMODE=2
C         input    JX : from: 0 to: NX/2
C                  JY : from: 0 to: NY/2
C                  JZ : from: 0 to: NZMAX-NZMIN
C         ID  dens in point JX,JY,JZ move to array IR
C -----------------------------
C ******
CMS      : IR
      INTEGER*2   IR(*)
      INTEGER*2   IN2(2),JN2(2)
      INTEGER     IN4,JN4,IT
      EQUIVALENCE (IN4,IN2(1)),(JN4,JN2(1))
      COMMON/COM_BYTE/ IBYTE1,IBYTE2
     *,ISTART_A_CAP,ISTART_A_LOW,ISTART_DIG_0
C ----------------------------------------
      ITYPE=0
      GO TO 10
C ----
      ENTRY SETDEN(IMODE,JX,JY,JZ,ID,IR,NX,NY,NZ,NZMIN,NZMAX)
C ----
      ITYPE=1
 10   CONTINUE
      IF(IMODE.EQ.-1) THEN
        IN2(1)=100
        IN2(2)=0
        IF(IN4.EQ.100) THEN
C          IN4
C          2 1
          IBYTE1=1
          IBYTE2=2
        ELSE
C          IN4
C          1 2
          IBYTE1=2
          IBYTE2=1
        ENDIF
        RETURN
      ENDIF
      IX=JX
      IY=JY
      IZ=JZ
      IF(IZ.LT.NZMIN) IZ=NZMIN
      IF(IZ.GT.NZMAX) IZ=NZMAX
      IZ  =IZ-NZMIN
C     IF(IX.LT.0) IX=0
C     IF(IY.LT.0) IY=0
      IF(IMODE.EQ.0) THEN
C       IF(IX.GE.NX) IX=NX-1
C       IF(IY.GE.NY) IY=NY-1
        IND =(NY*IZ+IY)*NX+IX+1
      ELSE IF(IMODE.EQ.1) THEN
        NX2=NX/2
C       IF(IX.GT.NX2) IX=NX2
C       IF(IY.GE.NY ) IY=NY-1
        IND =(NY*IZ+IY)*(NX2+1)+IX+1
      ELSE IF(IMODE.EQ.2) THEN
        NX2=NX/2
        NY2=NY/2
C       IF(IX.GT.NX2) IX=NX2
C       IF(IY.GT.NY2) IY=NY2
        IND =((NY2+1)*IZ+IY)*(NX2+1)+IX+1
      ENDIF
      INDD=(IND+1)/2
      IND =MOD(IND,2)
      JN4 =0
      IN4 =0
      IF(ITYPE.EQ.0) THEN
C     --- GET ---
        IN2(IBYTE1)=IR(INDD)
        IF(IND.EQ.0) THEN
          IT =IN4/256
          ID =IN4-IT*256
        ELSE
         ID =IN4/256
        ENDIF
      ELSE
C     --- SET ---
        IN4 =ID
        IT  =ID/256
        IN4 =ID-IT*256
        IN2(IBYTE2)=0
        JN2(IBYTE1)=IR(INDD)
        IF(IND.EQ.0) THEN
          JN4=JN4/256
          JN4=JN4*256
          IN4=IN4+JN4
        ELSE
          IN4=IN4*256
          IT =JN4/256
          JN4=JN4-IT*256
          IN4=IN4+JN4
        ENDIF
        IR(INDD)=IN2(IBYTE1)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE RDENS(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,POOL,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0,IZ0
     * ,ITR,TITLE,NSYM,ISYM,NSMAX,IERR)
C
C -P- RDENS - reads file-dens to --> array POOL (real)
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - mode of writting messages to DOC-file
C               0 - only term, < - 0 only file, 0 < < 99 - both
C               =< 99 - don't write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( don't close )
C              -1 not open , rewind , read titles ( don't print )
C               1 read next plan(x,y) from file to array POOL(real) 
C   output:
C       MTIN =0       - signal of error.
C       FNAME         - name of file 
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       RMAX,RMIN     - max and min value of density
C       POOL          - real array of density (NX,NY)
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS(!R!) = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may be applied ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C---------------------------------------------------------------------
CMS      : POOL
      COMMON/COM_RDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      REAL POOL(*)
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 IX0,IY0,IZ0,ITR
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ******
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      IPRINT=0
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF

C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN

        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF

        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(ABS(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA)))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            IERR=4  
            MTIN=0
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)


        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2

C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF

        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            POOL(IXY)=IBLCK2(I)/SCALE
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF

        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN

      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE IRDENS(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,IPOOL,SCALE,A,B,C,AL,BE,GA,RMS,AVER,RESOL
     * ,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IERR)
C
C -P- IRDENS - reads of file-dens --> array IPOOL /integer*2/
C       for i-section: RDENSi=IRDENSi/SCALEi
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - unit number file-document , may be =0
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( not close )
C              -1 not open , rewind , read titles ( not print )
C               1 read from file to IPOOL (integer*2) next plan(x,y)
C
C   output:
C       MTIN =0       - error.
C       FNAME         - name of file 
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       RMAX,RMIN     - max and min value of density
C       IPOOL         - integer*2 array of density (NX,NY)
C       SCALE         - scale for this section DENS(i,j)=IPOOL(i,j)/SCALE
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       RESOL
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may by appled ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C ******
C---------------------------------------------------------------------
CMS      : IPOOL
      INTEGER*2 IPOOL(*)
      COMMON/COM_RIDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      INTEGER*4 IX0,IY0,IZ0,ITR
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      IPRINT=0
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF
C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN
        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF
        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(ABS(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA)))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            MTIN=0
            IERR=4
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C         IF(IERR.NE.0) THEN
C           CALL MSGERR(MDOC,' ERR: READ FILE-IN')
C           CLOSE(MTIN)
C           MTIN=0
C           RETURN
C         ENDIF
        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          CLOSE(MTIN)
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF
C 
        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            IPOOL(IXY)=IBLCK2(I)
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF
        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN
      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE IRDNS2(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,IPOOL,SCALE,A,B,C,AL,BE,GA,RMS,AVER,RESOL
     * ,IX0,IY0,IZ0,ITR,TITLE
     * ,NSYM,ISYM,NSMAX,IERR)
C
C -P- IRDENS - reads of file-dens --> array IPOOL /integer*2/
C       for i-section: RDENSi=IRDENSi/SCALEi
C
C   input :
C       MT    - unit number
C       FNAME  - file name or " ".   /if " " - name will be taken
C                                                      from terminal  /
C       MDOC  - unit number file-document , may be =0
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C       ITYPE - 0 open file & read title & read last record (RMAX,RMIN ...)
C                                   & rewind ( not close )
C              -1 not open , rewind , read titles ( not print )
C               1 read from file to IPOOL (integer*2) next plan(x,y)
C
C   output:
C       MTIN =0       - error.
C       FNAME         - name of file 
C       ICNTZ         - number of z-section / for ITYPE = 1/
C       NX,NY,NZ      - number points for axis X,Y,Z
C       IZMIN,IZMAX   - min and max section Z
C       RMAX,RMIN     - max and min value of density
C       IPOOL         - integer*2 array of density (NX,NY)
C       SCALE         - scale for this section DENS(i,j)=IPOOL(i,j)/SCALE
C       A,B,C         -  cell parameters
C       AL,BE,GA      -  / in radian /
C       RMS           -  RMS = SQRT(<R**2>-<ABS(R)>*<ABS(R)>)
C       RESOL
C       IX0,IY0,IZ0   -  origin of coord. system /first point=0/
C       ITR           =  0 translation may by appled ,=1 no.
C       TITLE         -  general title / CHARACTER*80 /
C ******
C---------------------------------------------------------------------
CMS      : IPOOL
      INTEGER*2 IPOOL(*)
      COMMON/COM_2RIDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      INTEGER*4 IX0,IY0,IZ0,ITR
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      IPRINT=0
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF
C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN
        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF
        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(ABS(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA)))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            MTIN=0
            IERR=4
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C         IF(IERR.NE.0) THEN
C           CALL MSGERR(MDOC,' ERR: READ FILE-IN')
C           CLOSE(MTIN)
C           MTIN=0
C           RETURN
C         ENDIF
        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          CLOSE(MTIN)
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2
C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF
C 
        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            IPOOL(IXY)=IBLCK2(I)
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF
        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN
      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE RDENS2(MTIN,FNAME,MDOC,ITYPE,ICNTZ,NX,NY,NZ,IZMAX,
     * IZMIN,RMAX,RMIN,POOL,A,B,C,AL,BE,GA,RMS,AVER,RESOL,IX0,IY0,IZ0
     * ,ITR,TITLE,NSYM,ISYM,NSMAX,IERR)
C
C -P- RDENS2 - reads file-dens to --> array POOL (real)
C
C ******
C---------------------------------------------------------------------
CMS      : POOL
      COMMON/COM_2RDNS/ LZ
      INTEGER*4 ICNTZ,LZ
      REAL RMAX,RMIN,A,B,C,AL,BE,GA,VOL
      REAL POOL(*)
      INTEGER*4 MTIN,MDOC,ITYPE,NX,NY,NZ,IZMAX,IZMIN
      INTEGER*4 IX0,IY0,IZ0,ITR
      INTEGER*4 NSYM,NSMAX,IERR
      INTEGER*2 ISYM(5,3,NSMAX)
      CHARACTER FNAME*(*)
      CHARACTER TITLE*(*)
C ******
C ------------------------------------
      CHARACTER CH1*1,TPSYMB*1
      INTEGER*4 ILINE(20)
      REAL      RLINE(20)
      INTEGER*4 IBLOCK(512)
      INTEGER*2 IBLCK2(1024)
      INTEGER*4 NRMAX,NR8,NR40,NR
      CHARACTER LINE*80,TYPE*4,MSG*1
      EQUIVALENCE (IBLCK2(1),IBLOCK(1))
      EQUIVALENCE (ILINE(1),RLINE(1)),(ILINE(1),LINE)
      DATA NRMAX/1024/
      DATA NR8/4/
      DATA NR40/20/
C ---------------------------------------------------------------------
      IERR=0
      MSG='N'
      IPRINT=0
      CH1=FNAME(1:1)
      CALL CHKSMB(CH1,TPSYMB)
      IF(TPSYMB.EQ.'?'.OR.CH1.EQ.' '.OR.CH1.EQ.',') THEN
        FNAME(1:1)=' '
      ENDIF
      IF(ITYPE.EQ.-2) THEN
        ITYPE=0
        IPRINT=0
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ELSE IF(ITYPE.EQ.0) THEN
        IPRINT=1
        CALL LENSTR_BL(FNAME,LEN)
        IF(LEN.LE.0.OR.FNAME(1:1).EQ.' ') MSG='Y'
      ENDIF
      IF(ITYPE.EQ.-1) THEN
        LZ=IZMIN
        REWIND MTIN
        ICNTZ=IZMIN-1
        ITYPE=1
        IPRINT=0
      ENDIF
      IF(ITYPE.EQ.0) THEN
  10    TYPE='    '
        M=MDOC
        IF(IPRINT.EQ.0) M=99
        CALL ORFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
        IF(IERR.GT.0) THEN
          IERR=1
C         MTIN=0
          RETURN
        ENDIF
        CALL GET_TITLE(M,A,B,C,AL,BE,GA
     *        ,F1,F2,F3,F4,NX,NY,NZ,IZMIN,IZMAX,TITLE,IERR)
        IF(IERR.GT.0) THEN
          IERR=2
          RETURN
        ENDIF

C        CALL RTITLE(MTIN,FNAME,MDOC,TYPE,IPRINT,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)
C        IF(MTIN.LE.0) RETURN

        IF(TYPE.NE.'RI  ') THEN
          CALL MSGERR(MDOC,' ERR: WRONG TYPE FILE ')
          CLOSE(MTIN)
          IF(MDOC.GE.0.AND.MDOC.LT.99.AND.MSG.EQ.'Y') GO TO 10
          MTIN=0
          IERR=3
          RETURN
        ENDIF

        IF(TITLE(1:3).NE.'RF:') THEN
C
C         CELL VOLUME
C
          S=(AL+BE+GA)*0.5
          VOL=2.0*A*B*C*
     *        SQRT(ABS(SIN(S)*SIN(S-AL)*SIN(S-BE)*SIN(S-GA)))
          IF(IPRINT.EQ.1) THEN
            IF(MDOC.GT.0.AND.MDOC.LT.99) THEN
              WRITE(LINE,40) VOL
 40           FORMAT(' VOL :',G12.4)
              CALL MSGDOC(MDOC,LINE)
            ENDIF
          ENDIF
        ELSE
          VOL=1.0
        ENDIF
        NXY=NX*NY
        LZ=IZMIN
      ELSE
        IF(LZ.EQ.IZMIN) THEN

C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)
C          CALL RBLOCK(MTIN,ILINE,NR40,IERR)

          IF(IPRINT.EQ.0) M=99
          TYPE='RI  '
          CALL OPFILE(M,MTIN,FNAME,TYPE,NSYM,ISYM,NSMAX,IERR)
          IF(IERR.GT.0) THEN
            IERR=4  
            MTIN=0
            RETURN
          ENDIF

C        IPR=0
C        CALL PTITLE(MTIN,FNAME,MDOC,TYPE,IPR,
C     *  A,B,C,AL,BE,GA,DDM,DDM,DDM,DDM,NX,NY,NZ,IZMIN,IZMAX,TITLE)


        ENDIF
        NXY=NX*NY
      ENDIF
      IF(ITYPE.EQ.0) THEN
        JZMIN=IZMIN
        JZMAX=IZMAX
        ICNTZ=IZMIN-1
      ELSE
        JZMIN=1
        JZMAX=1
        ICNTZ=ICNTZ+1
      ENDIF
      DO     JZ=JZMIN,JZMAX
        CALL RBLOCK(MTIN,ILINE,NR8,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN')
          MTIN=0
          IERR=5
          RETURN
        ENDIF
        SCALE=RLINE(2)
        IXY=0
        NR0=0
        NR1=1
   20   NR2=NR0+NRMAX
        IF(NR2.GT.NXY) THEN
          NRR=NXY-NR0
        ELSE
          NRR=NRMAX
        ENDIF
        NRR2=NRR/2

C N      CALL RFILE(MTIN,0,IBLOCK(1),-1,NRR2)
C N      IF(ERRCODE.NE.0) THEN
C N        CALL ERMSG(ERRCODE)
C N        CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
C N        CLOSE(MTIN)
C N        MTIN=0
C N        RETURN
C N      ENDIF

        READ(MTIN,ERR=2) (IBLOCK(JR),JR=1,NRR2)
        GO TO 1
    2   CALL MSGERR(MDOC,' ERR:  READ DENS-FILE')
        CLOSE(MTIN)
        MTIN=0
        IERR=6
        RETURN
    1   CONTINUE

        IF(ITYPE.NE.0) THEN
          DO     I=1,NRR
            IXY=IXY+1
            POOL(IXY)=IBLCK2(I)/SCALE
          ENDDO
        ENDIF
        NR0=NR0+NRR
        NR1=NR1+NRR
        IF(NR1.LE.NXY) GO TO 20
      ENDDO
      IF(ITYPE.EQ.0) THEN
        CALL RBLOCK(MTIN,ILINE,NR40,IERR)
        IF(IERR.NE.0) THEN
          CALL MSGERR(MDOC,' ERR: READ FILE-IN.')
          CLOSE(MTIN)
          MTIN=0
          IERR=7
          RETURN
        ENDIF

        READ(LINE,30) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 30     FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
        RMS  =DELX
        RESOL=DELY
        AVER =DELZ
        IF(IPRINT.EQ.1) THEN
          IF(MDOC.GE.0.AND.MDOC.LT.99) THEN   
            WRITE(LINE,25) RMAX,RMIN,RMS,AVER
 25         FORMAT('Rmax:',G12.4,' Rmin:',G12.4,' RMS(R):',G12.4
     *      ,' <R>:',G12.4)
            CALL MSGDOC(MDOC,LINE)
            WRITE(LINE,'('' Resolution :'',F10.3)') RESOL
            CALL MSGDOC(MDOC,LINE)
          ENDIF
        ENDIF
        REWIND MTIN

      ELSE
        LZ=LZ+1
      ENDIF
      RETURN
      END


C ******
      SUBROUTINE WDENS(MTOUT,MDOC,ICNTZ,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,POOL,RESOL,IX0,IY0,IZ0,ITR)
C
C -P- WDENS - writes next plan(x,y) 
C             /z=ICNTZ POOL(real)/ to file MTOUT
C
C     if ICNTZ.eq.-999 then set RMAX=-1.E 30 and RMIN= 1.E 30
C     if ICNTZ.eq.IZMAX then write last record (RMAX,RMIN,IX0,IY0,IZ0,ITR)
C                         and write EOF & close file MTOUT
C     !!!!  subroutine destroyed array POOL
C           ICNTZ = -999 for first call / after call WTITLE /
C    output ICNTZ - z-section number
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C ******
CMS      : POOL
      REAL POOL(*)
      COMMON/COM_WDNS/ AVER,AVER2
C ----------------------------------------------------------------
      MT=ABS(MTOUT)
      CALL WSECT(MTOUT,MDOC,ICNTZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN,POOL
     *          ,POOL,AVER,AVER2)
      IF(MTOUT.EQ.0) RETURN
      IF(ICNTZ.GE.IZMAX) THEN
        CALL WTITL2(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL)
        IF(MTOUT.EQ.0) RETURN
        END FILE MT
        CLOSE(MT)
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE WTITL2(MTOUT,MDOC,NX,NY,NZ,IZMIN,IZMAX,RMAX,RMIN
     .                ,IX0,IY0,IZ0,ITR,AVER,AVER2,RESOL)
C
C    WTITL2 - writes of last record to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C     output: MTOUT = 0 - error.
C ******
      INTEGER*4 NR
      INTEGER*4 ILINE(20)
      CHARACTER LINE*80
      EQUIVALENCE (LINE,ILINE(1))
      DATA NWW/20/
C------------------------------------
      MT=ABS(MTOUT)
      NR=NX*NY
      NR=NR*(IZMAX-IZMIN+1)
C     --------------
      AVER=AVER/NR
      AVER2=AVER2/NR
      RMS=AVER2-AVER*AVER
      IF(RMS.LT.0.0) RMS=0.0
      IF(RMS.GT.0.0) RMS=SQRT(ABS(RMS))
      DELX=RMS
      DELY=RESOL
      DELZ=AVER
      IF(NR.LT.0.OR.NR.GT.999999999) NR=0
      IF(IX0.GT.9999) IX0=9999
      IF(IY0.GT.9999) IY0=9999
      IF(IZ0.GT.9999) IZ0=9999
      IF(IX0.LT.-999) IX0=-999
      IF(IY0.LT.-999) IY0=-999
      IF(IZ0.LT.-999) IZ0=-999
      IF(DELX.GT. 1.0E31)  DELX= 1.0E31
      IF(DELZ.GT. 1.0E31)  DELZ= 1.0E31
      IF(DELZ.LT.-1.0E31)  DELZ=-1.0E31
      IF(RMAX.GT. 1.0E31)  RMAX= 1.0E31
      IF(RMAX.LT.-1.0E31)  RMAX=-1.0E31
      IF(RMIN.GT. 1.0E31)  RMIN= 1.0E31
      IF(RMIN.LT.-1.0E31)  RMIN=-1.0E31
      IF(DELY.GT.99.9999) DELY=99.9999
      IF(DELY.LT.-9.9999) DELY=-9.9999
      IF(ITR.LT.0.OR.ITR.GT.9) ITR=0
      WRITE(LINE,32) NR,RMAX,RMIN,IX0,IY0,IZ0,DELX,DELY,DELZ,ITR
 32   FORMAT(I10,2G12.4,3I4,G12.4,F7.4,G12.4,I1)
      CALL WBLOCK(MT,ILINE,NWW,IERR)
      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,20)
 20     FORMAT(' ------------------------------------')
        CALL MSGDOC(MDOC,LINE)
        WRITE(LINE,10) RMAX,RMIN,RMS,AVER
 10     FORMAT('Rmax:',G12.4,' Rmin:',G12.4
     *  ,' RMS(R):',G12.4,' <R>:',G12.4)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
      RETURN
      END

C ////////////////////////////////////////////////////////////////////
C ******
      SUBROUTINE WSECT(MTOUT,MDOC,IZ,IZMIN,IZMAX,NX,NY,RMAX,RMIN
     *                  ,POOL,IPOOL,AVER,AVER2)
C
C    WSECT writes of next plan(x,y) to file (dens)
C
C               MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       >= 99 - not write  
C     output: MTOUT = 0 - error.
C ******
CMS      : POOL,IPOOL
      REAL POOL(*)
      INTEGER*4 IDATE(7),NW8
      INTEGER*2 IPOOL(*),IDAT(8)
      CHARACTER LINE*80
      EQUIVALENCE (IDAT(1),SCAL1),(IDAT(3),SCAL),(IDAT(5),RM)
      EQUIVALENCE (IDAT(7),RN)
      DATA NW8/4/
C ----------------------------------------
      MT=ABS(MTOUT)
      IF(IZ.EQ.-999) THEN
        IF(MTOUT.GT.0) THEN
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,200)
          CALL MSGDOC(MDOC,LINE)
          WRITE(LINE,201)
          CALL MSGDOC(MDOC,LINE)
 201      FORMAT(' ')
 200      FORMAT('   X',3X,'Y',3X,'Z',6X,'R-MAX',7X,'X',3X,'Y',
     *         3X,'Z',6X,'R-MIN',8X,'TIME')
        ENDIF 
        RMAX=-1.E 30
        RMIN= 1.E 30
        AVER =0.0
        AVER2=0.0
        IZ=IZMIN
      ELSE
        IZ=IZ+1
      ENDIF
      SCAL1=1.
      RN= 1.E 30
      RM=-1.E 30
      NXY=NX*NY
      DO     J=1,NY
        IY=J-1
        IND=IY*NX
        DO     I=1,NX
          IX=I-1
          INDX=IND+I
          R=POOL(INDX)
          AVER =AVER+R
          AVER2=AVER2+R*R
          IF(R.GE.RMAX) RMAX=R
          IF(R.LE.RMIN) RMIN=R
          IF(R.GE.RM) THEN
            RM=R
            IXM=IX
            IYM=IY
          ENDIF
          IF(R.LE.RN) THEN
            RN=R
            IXN=IX
            IYN=IY
          ENDIF
        ENDDO
      ENDDO
      RRMAX=MAX(ABS(RM),ABS(RN))
      IF(ABS(RRMAX).GT.1.E-6) THEN
        SCAL=(32 766.)/RRMAX
      ELSE
        SCAL=1.
      ENDIF
      DO     J=1,NY
        IND=(J-1)*NX
        DO     I=1,NX
          INDX=IND+I
          PL=POOL(INDX)*SCAL
          IF(ABS(PL).GT.32766.) PL=SIGN(32766.,PL)
          IPOOL(INDX)=PL
        ENDDO
      ENDDO

      CALL WBLOCK_I2(MT,IDAT,NW8,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      NXY2=NXY/2

      CALL WBLOCK_I2(MT,IPOOL,NXY2,IERR)

      IF(IERR.NE.0) THEN
        CALL MSGERR(MDOC,' ERR: WRITE DATA TO FILE-OUT')
        CLOSE(MT)
        MTOUT=0
        RETURN
      ENDIF
      CALL CLOCK(IDATE)
C --------
      IF(MTOUT.GT.0) THEN
        WRITE(LINE,1) IXM,IYM,IZ,RM,IXN,IYN,IZ,RN,IDATE(4),IDATE(3)
     *               ,IDATE(2)
        CALL MSGDOC(MDOC,LINE)
      ENDIF
C N 1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',J2,'.',J2)
    1 FORMAT(1X,3I4,1X,G12.4,' , ',3I4,1X,G12.4,' ; ',I2,'.',I2,'.',I2)
      RETURN
      END
C -P-
C -P------ sort subroutines  --------------------
C -P-

C ******
      SUBROUTINE I2SORT1(A,N,TAG)
C
C -P- I2SORT1 - sorts array A(integer*4) with aray TAG(integer*2)
C     N = element number in A 
C ******
CMS      : A,TAG 
      INTEGER*4 N
      INTEGER*2 A(*),T,TT
      INTEGER*2 TAG(*),TG
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END

C ******
      SUBROUTINE ISORT1(A,N,TAG)
C
C -P- ISORT1 - sorts array A(integer*4) with aray TAG(real or integer*4)
C     N = element number in A 
C ******
CMS      : A,TAG 
      INTEGER*4 N
      INTEGER*4 A(*),T,TT
      DIMENSION TAG(*)
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END

C ******
      SUBROUTINE ISORT0(A,N)
C
C -P- ISORT0 - sorts array A (integer*4)
C     N = element number in A
C ******
CMS      : A
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      K=I
  100 A(K+1)=A(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      GO TO 90
      END

C ******
      SUBROUTINE ISORT3(A,N,TAG,TAG1,TAG2)
C
C -P- ISORT3 - sort array A(integer*4) with aray TAG,TAG1,TAG2 
C                                     (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1,TAG2
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*),TAG2(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(J)
      TAG2(J)=TG2

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

      TG2=TAG2(L)
      TAG2(L)=TAG2(K)
      TAG2(K)=TG2

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90

      TG =TAG(I+1)
      TG1=TAG1(I+1)
      TG2=TAG2(I+1)

      K=I
  100 A(K+1)=A(K)

      TAG (K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      TAG2(K+1)=TAG2(K)

      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T

      TAG (K+1)=TG
      TAG1(K+1)=TG1
      TAG2(K+1)=TG2

      GO TO 90
      END

C ******
      SUBROUTINE ISORT2(A,N,TAG,TAG1)
C
C -P- ISORT2 - sort array A (integer*4) with aray TAG,TAG1
C                                     (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1
      INTEGER*4  N
      INTEGER*4  A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90

      TG=TAG(I+1)
      TG1=TAG1(I+1)

      K=I
  100 A(K+1)=A(K)

      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)

      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T

      TAG(K+1)=TG
      TAG1(K+1)=TG1

      GO TO 90
      END

C ******
      SUBROUTINE SORT1(A,N,TAG)
C
C -P- SORT1 - sort array A (real) with aray TAG
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG
      INTEGER*4 N
      REAL      A(*),T,TT
      DIMENSION TAG(*)
      DIMENSION IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
      END
C ******
      SUBROUTINE SORT0(A,N)
C
C -P- SORT0 - sort array A (real)
C     N = element number in A
C ******
CMS      : A
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      K=I
  100 A(K+1)=A(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      GO TO 90
      END

C ******
      SUBROUTINE SORT3(A,N,TAG,TAG1,TAG2)
C
C -P- SORT3 - sort array A (real) with aray TAG,TAG1,TAG2
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1,TAG2
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*),TAG2(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(J)
      TAG2(J)=TG2

      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)

      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG

      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1

      TG2=TAG2(IJ)
      TAG2(IJ)=TAG2(I)
      TAG2(I)=TG2

      GO TO 40
   30 A(L)=A(K)
      A(K)=TT

      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG

      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1

      TG2=TAG2(L)
      TAG2(L)=TAG2(K)
      TAG2(K)=TG2

   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      TG1=TAG1(I+1)
      TG2=TAG2(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      TAG2(K+1)=TAG2(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      TAG1(K+1)=TG1
      TAG2(K+1)=TG2
      GO TO 90
      END

C ******
      SUBROUTINE SORT2(A,N,TAG,TAG1)
C
C -P- SORT2 - sort array A (real) with aray TAG,TAG1
C                              (real or integer*4)
C     N = element number in A
C ******
CMS      : A,TAG,TAG1
      INTEGER*4  N
      REAL       A(*),T,TT
      DIMENSION  IU(24),IL(24),TAG(*),TAG1(*)
C===========================================================
      M=1
      I=1
      J=N
    5 IF(I.GE.J) GO TO 70
   10 K=I
      IJ=(J+I)/2
      T=A(IJ)
      IF(A(I).LE.T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
   20 L=J
      IF(A(J).GE.T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(J)
      TAG1(J)=TG1
      IF(A(I).LE.T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      TG1=TAG1(IJ)
      TAG1(IJ)=TAG1(I)
      TAG1(I)=TG1
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
      TG1=TAG1(L)
      TAG1(L)=TAG1(K)
      TAG1(K)=TG1
   40 L=L-1
      IF(A(L).GT.T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K).LT.T) GO TO 50
      IF(K.LE.L) GO TO 30
      IF((L-I).LE.(J-K)) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M.EQ.0) RETURN
      I=IL(M)
      J=IU(M)
   80 IF((J-I).GE.1) GO TO 10
      IF(I.EQ.1) GO TO 5
      I=I-1
   90 I=I+1
      IF(I.EQ.J) GO TO 70
      T=A(I+1)
      IF(A(I).LE.T) GO TO 90
      TG=TAG(I+1)
      TG1=TAG1(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      TAG1(K+1)=TAG1(K)
      K=K-1
      IF(T.LT.A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      TAG1(K+1)=TG1
      GO TO 90
      END
C -P-
C -P- ------------ FFT ----------------------
C -P-
C ******
      SUBROUTINE MDHFT(X,DD,IERR)
C -P- MDHFT -
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM     
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA      
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.      
C   
C     THIS PROGRAM CALCULATES THE TRANSFORM         
C     (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))     
C   
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS    
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C   
C     I1 = (I0 - 1)*D(2) + 1    
C     DO 100 I2 = I1, D(1), D(3)
C     I3 = I2 + D(4) - 1        
C     DO 100 I = I2, I3, D(5)   
C        .   
C        .   
C 100 CONTINUE         
C   
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS 
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.        
C----------------------------------------------------------
CMS      :X,DD
      REAL    X(*)
      INTEGER*4 DD(*),IERR
C ******
      INTEGER PTS,I,J,K,KK,LL,NT,ND
      REAL    A,B,C,D,E,F,ANGLE,TWOPI,TWON
      INTEGER DIM(10)
C---------------------------------------------------------
      MDOC=0
      IERR=0
      TWOPI=8.0*ATAN(1.0)
      NT=2
      DO     I=1,10
        DIM(I)=DD(I)
        IF(DIM(I).EQ.0) GO TO 200
        NT=NT*DIM(I)
      ENDDO
      GO TO 700
  200 CONTINUE
      ND=I
      NT=IABS(NT)
      DIM(1)=-IABS(DIM(1))

      CALL MDCFT2(X,DIM,IERR)
      IF(IERR.NE.0) RETURN

      PTS=-DIM(1)
      DIM(1)=PTS
      I=2*PTS
      TWON=FLOAT(I)
      DO     J=1,NT,I
        X(J+1)=X(J)
      ENDDO
      PTS=PTS+1
      DO     J=3,PTS,2
        ANGLE=TWOPI*FLOAT(J/2)/TWON
        CO=COS(ANGLE)
        SI=SIN(ANGLE)
        K=2*(PTS-J)
        DO     KK=J,NT,I
          LL=KK+K
          A=X(KK)+X(LL)
          B=X(KK)-X(LL)
          C=X(KK+1)+X(LL+1)
          D=X(KK+1)-X(LL+1)
          E=B*CO+C*SI
          F=B*SI-C*CO
          X(KK)=A+F
          X(LL)=A-F
          X(KK+1)=E+D
          X(LL+1)=E-D
        ENDDO
      ENDDO
      DO     J=2,ND
        DIM(J)=-IABS(DIM(J))
      ENDDO

      CALL MDCFT2(X,DIM,IERR)
      IF(IERR.NE.0) RETURN

      RETURN
  700 CONTINUE 
C
C     CALL MSGERR(???,' ERR: -- MDHFT -- : MORE THAN NINE DIMENSION')
C
      IERR=1
      RETURN
      END

C ******
      SUBROUTINE CMPLFT (X, Y, N, D,IERR)     
      INTEGER N        
      INTEGER D(5)     
CMS      : X,Y
      REAL X(*), Y(*)  
C   
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM     
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA      
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.      
C   
C     THIS PROGRAM CALCULATES THE TRANSFORM         
C     (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))     
C   
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS    
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C   
C     I1 = (I0 - 1)*D(2) + 1    
C     DO 100 I2 = I1, D(1), D(3)
C     I3 = I2 + D(4) - 1        
C     DO 100 I = I2, I3, D(5)   
C        .   
C        .   
C 100 CONTINUE         
C   
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS 
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.        
C   
C ******
C     CHARACTER LINE*80
      LOGICAL ERROR    
      INTEGER P MAX, P SYM, TWO GRP       
      INTEGER FACTOR(15), SYM(15), UN SYM(15)       
C   
C     P MAX IS THE LARGEST PRIME FACTOR THAT WILL BE TOLERATED BY THIS
C     PROGRAM.         
C     TWO GRP IS THE LARGEST POWER OF TWO THAT IS TREATED AS A SPECIAL
C     CASE.  
C   
C -----------------------
      IERR=0
      P MAX = 19       
      TWO GRP = 8      
    
      IF (N .LE. 1) GO TO 100    
      CALL S R FP (N, P MAX, TWO GRP, FACTOR, SYM, P SYM, UN SYM, ERROR)
      IF (ERROR) GO TO 200       
    
      CALL MD FT KD (N, FACTOR, D, X, Y,IERR)  
      IF(IERR.GT.0) GO TO 200
      CALL D IP RP (N, SYM, P SYM, UN SYM, D, X, Y) 
    
  100 CONTINUE         
      RETURN 
    
  200 CONTINUE         
C      WRITE (*, 300) N
C      WRITE (LINE, 300) N
C      CALL MSGERR(MDOC,LINE)
      IERR=1
      CALL EXITB
    
C  300 FORMAT(' ERR: INVALID NUMBER OF POINTS FOR CMPL FT. N =',I10)
    
      END    
      SUBROUTINE DIPRP(PTS,SYM,P SYM,UN SYM,DIM,X,Y)       
C     DOUBLE IN PLACE REORDERING PROGRAMME
C   
      INTEGER PTS,P SYM
CMS      : X,Y
      REAL X (10), Y (10)        
      INTEGER SYM(10), UN SYM(10), DIM(5) 
C   
      REAL T 
      LOGICAL ONE MOD  
      INTEGER MODULO (14)        
      INTEGER DK,JJ,KK,LK,MODS,MULT,NEST,P UN SYM,TEST        
      INTEGER NT, SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE 
C   
      INTEGER S (14), U (14)     
      INTEGER A,B,C,D,E,F,G,H,I,J,K,L,M,N 
      INTEGER BS,CS,DS,ES,FS,GS,HS,IS,JS,KS,LS,MS,NS
      INTEGER AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL       
      EQUIVALENCE (AL,U(1)),(BS,S(2)),(BL,U(2))     
      EQUIVALENCE (CS,S(3)),(CL,U(3)),(DS,S(4)),(DL,U(4))     
      EQUIVALENCE (ES,S(5)),(EL,U(5)),(FS,S(6)),(FL,U(6))     
      EQUIVALENCE (GS,S(7)),(GL,U(7)),(HS,S(8)),(HL,U(8))     
      EQUIVALENCE (IS,S(9)),(IL,U(9)),(JS,S(10)),(JL,U(10))   
      EQUIVALENCE (KS,S(11)),(KL,U(11)),(LS,S(12)),(LL,U(12)) 
      EQUIVALENCE (MS,S(13)),(ML,U(13)),(NS,S(14)),(NL,U(14)) 
C   
      NEST=14
C   
      NT = DIM(1)      
      SEP = DIM(2)     
      P2 = DIM(3)      
      SIZE = DIM(4) - 1
      P4 = DIM(5)      
      IF (SYM(1).EQ.0) GO TO 500 
      DO 100 J=1,NEST  
      U(J)=1 
      S(J)=1 
  100 CONTINUE         
      N=PTS  
      DO 200 J=1,NEST  
      IF (SYM(J).EQ.0) GO TO 300 
      JJ=NEST+1-J      
      U(JJ)=N
      S(JJ)=N/SYM(J)   
      N=N/SYM(J)       
  200 CONTINUE         
  300 CONTINUE         
C   
      JJ=0   
C ======================
      A=0    
  410 A=A+1  
      IF(A.GT.AL) GO TO 420      
C ==========DO 400 A=1,AL
      DO 400 B=A,BL,BS 
      DO 400 C=B,CL,CS 
      DO 400 D=C,DL,DS 
      DO 400 E=D,EL,ES 
      DO 400 F=E,FL,FS 
      DO 400 G=F,GL,GS 
      DO 400 H=G,HL,HS 
      DO 400 I=H,IL,IS 
      DO 400 J=I,JL,JS 
      DO 400 K=J,KL,KS 
      DO 400 L=K,LL,LS 
      DO 400 M=L,ML,MS 
      DO 400 N=M,NL,NS 
      JJ=JJ+1
      IF (JJ.GE.N) GO TO 400     
      DELTA = (N-JJ)*SEP         
      P1 = (JJ-1)*SEP + 1        
      DO 350 P0 = P1, NT, P2     
      P3 = P0 + SIZE   
      DO 350 P = P0, P3, P4      
      P5 = P + DELTA   
      T = X(P)         
      X(P) = X(P5)     
      X(P5) = T        
      T = Y(P)         
      Y(P) = Y(P5)     
      Y(P5) = T        
  350 CONTINUE         
  400 CONTINUE         
      GO TO 410        
  420 CONTINUE         
C   
  500 CONTINUE         
      IF (UN SYM(1).EQ.0) GO TO 1900      
      P UN SYM=PTS/P SYM**2      
      MULT=P UN SYM/UN SYM(1)    
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM       
      LK=MULT
      DK=MULT
      DO 600 K=2,NEST  
      IF (UN SYM(K).EQ.0) GO TO 700       
      LK=LK*UN SYM(K-1)
      DK=DK/UN SYM(K)  
      U(K)=(LK-DK)*P SYM         
      MODS=K 
  600 CONTINUE         
  700 CONTINUE         
      ONE MOD=MODS.LT.3
      IF (ONE MOD) GO TO 900     
      DO 800 J=3,MODS  
      JJ=MODS+3-J      
      MODULO(JJ)=U(J)  
  800 CONTINUE         
  900 CONTINUE         
      MODULO(2)=U(2)   
      JL=(P UN SYM-3)*P SYM      
      MS=P UN SYM*P SYM
C   
    
      DO 1800 J=P SYM,JL,P SYM   
      K=J    
C   
 1000 CONTINUE         
      K=K*MULT         
      IF (ONE MOD) GO TO 1200    
      DO 1100 I=3,MODS 
      K=K-(K/MODULO(I))*MODULO(I)
 1100 CONTINUE         
 1200 CONTINUE         
      IF (K.GE.TEST) GO TO 1300  
      K=K-(K/MODULO(2))*MODULO(2)
      GO TO 1400       
 1300 CONTINUE         
      K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)         
 1400 CONTINUE         
      IF (K.LT.J) GO TO 1000     
C   
      IF (K.EQ.J) GO TO 1700     
      DELTA = (K-J)*SEP
      DO 1600 L=1,P SYM
      DO 1500 M=L,PTS,MS         
      P1 = (M+J-1)*SEP + 1       
      DO 1500 P0 = P1, NT, P2    
      P3 = P0 + SIZE   
      DO 1500 JJ = P0, P3, P4    
      KK = JJ + DELTA  
      T=X(JJ)
      X(JJ)=X(KK)      
      X(KK)=T
      T=Y(JJ)
      Y(JJ)=Y(KK)      
      Y(KK)=T
 1500 CONTINUE         
 1600 CONTINUE         
 1700 CONTINUE         
 1800 CONTINUE         
C   
 1900 CONTINUE         
      RETURN 
      END    
C ******
      SUBROUTINE HERMFT (X, Y, N, DIM,IERR)   
      INTEGER N        
      INTEGER DIM(5)   
CMS      : X,Y
      REAL X(*), Y(*)  
C   
C     HERMITIAN SYMMETRIC FOURIER TRANSFORM         
C   
C     GIVEN THE UNIQUE TERMS OF A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH
C     2N THIS SUBROUTINE CALCULATES THE 2N REAL NUMBERS WHICH ARE ITS 
C     FOURIER TRANSFORM.  THE EVEN NUMBERED ELEMENTS OF THE TRANSFORM 
C     (0, 2, 4, . . ., 2N-2) ARE RETURNED IN X AND THE ODD NUMBERED   
C     ELEMENTS (1, 3, 5, . . ., 2N-1) IN Y.         
C   
C     A FINITE HERMITIAN SEQUENCE OF LENGTH 2N CONTAINS N + 1 UNIQUE  
C     REAL NUMBERS AND N - 1 UNIQUE IMAGINARY NUMBERS.  FOR CONVENIENCE 
C     THE REAL VALUE FOR X(N) IS STORED AT Y(0).    
C   
C ******
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO N, TWO PI     
      INTEGER NT, D2, D3, D4, D5 
      INTEGER I, J, K, N OVER 2, I0, I1, I2         
      INTEGER K1       
C -------------------------    
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)         
      IERR=0
      NT = DIM(1)      
      D2 = DIM(2)      
      D3 = DIM(3)      
      D4 = DIM(4) - 1  
      D5 = DIM(5)      
    
      DO 100 I0 = 1, NT, D3      
      I1 = I0 + D4     
      DO 100 I = I0, I1, D5      
      A = X(I)         
      B = Y(I)         
      X(I) = A + B     
      Y(I) = A - B     
  100 CONTINUE         
    
      N OVER 2 = N/2 + 1         
      IF (N OVER 2 .LT. 2) GO TO 500      
      DO 400 I0 = 2, N OVER 2    
      ANGLE = TWO PI*FLOAT(I0-1)/TWO N    
      CO = COS(ANGLE)  
      SI = SIN(ANGLE)  
      K = (N + 2 - 2*I0)*D2      
      K1 = (I0 - 1)*D2 + 1       
      DO 300 I1 = K1, NT, D3     
      I2 = I1 + D4     
      DO 200 I = I1, I2, D5      
      J = I + K        
      A = X(I) + X(J)  
      B = X(I) - X(J)  
      C = Y(I) + Y(J)  
      D = Y(I) - Y(J)  
      E = B*CO + C*SI  
      F = B*SI - C*CO  
      X(I) = A + F     
      X(J) = A - F     
      Y(I) = E + D     
      Y(J) = E - D     
  200 CONTINUE         
  300 CONTINUE         
  400 CONTINUE         
    
      CALL CMPLFT (X, Y, N, DIM,IERR)
    
  500 CONTINUE         
      RETURN 
    
      END    
      SUBROUTINE MDFTKD(N, FACTOR, DIM, X, Y,IERR)    
C     MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER       
C   
      INTEGER N        
      INTEGER FACTOR (10), DIM(5)
CMS      : X,Y
      REAL X(10), Y(10)
C   
      INTEGER F, M, P, R, S      
C ----------------------------   
      IERR=0
      S = DIM(2)       
      F = 0  
      M = N  
  100 CONTINUE         
      F = F + 1        
      P = FACTOR(F)    
      IF (P.EQ.0) RETURN         
      M = M/P
      R = M*S
      IF (P.GT.8) GO TO 700      
      GO TO (100, 200, 300, 400, 500, 800, 700, 600), P       
      GO TO 800        
C   
  200 CONTINUE         
      CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM)    
      GO TO 100        
C   
  300 CONTINUE         
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., DIM) 
      GO TO 100        
C   
  400 CONTINUE         
      CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), DIM) 
      GO TO 100        
C   
  500 CONTINUE         
      CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM)
      GO TO 100        
C   
  600 CONTINUE         
      CALL R8 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), X(5*R+1), Y(5*R+1),   
     .X(6*R+1), Y(6*R+1), X(7*R+1), Y(7*R+1), DIM)  
      GO TO 100        
C   
  700 CONTINUE         
      CALL RP CFTK (N, M, P, R, X, Y, DIM)
      GO TO 100        
C   
  800 CONTINUE         
C      WRITE(*,900)
C  900 FORMAT (' ERR: TRANSFER ERROR DETECTED IN MDFTKD',//)
C      CALL MSGERR(MDOC,' ERR: TRANSFER ERROR DETECTED IN MDFTKD')
      IERR=1
      RETURN 
      END    
C ******
      SUBROUTINE REALFT (EVEN, ODD, N, DIM,IERR)        
      INTEGER N        
      INTEGER DIM(5)   
CMS      : EVEN,ODD
      REAL EVEN(*), ODD(*)       
C   
C     REAL FOURIER TRANSFORM     
C   
C     GIVEN A REAL SEQUENCE OF LENGTH 2N THIS SUBROUTINE CALCULATES THE 
C     UNIQUE PART OF THE FOURIER TRANSFORM.  THE FOURIER TRANSFORM HAS
C     N + 1 UNIQUE REAL PARTS AND N - 1 UNIQUE IMAGINARY PARTS.  SINCE
C     THE REAL PART AT X(N) IS FREQUENTLY OF INTEREST, THIS SUBROUTINE
C     STORES IT AT X(N) RATHER THAN IN Y(0).  THEREFORE X AND Y MUST BE 
C     OF LENGTH N + 1 INSTEAD OF N.  NOTE THAT THIS STORAGE ARRANGEMENT
C     IS DIFFERENT FROM THAT EMPLOYED BY THE HERMITIAN FOURIER TRANSFORM
C     SUBROUTINE.      
C   
C     FOR CONVENIENCE THE DATA IS PRESENTED IN TWO PARTS, THE FIRST   
C     CONTAINING THE EVEN NUMBERED REAL TERMS AND THE SECOND CONTAINING 
C     THE ODD NUMBERED TERMS (NUMBERING STARTING AT 0).  ON RETURN THE
C     REAL PART OF THE TRANSFORM REPLACES THE EVEN TERMS AND THE      
C     IMAGINARY PART OF THE TRANSFORM REPLACES THE ODD TERMS. 
C   
C ******
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO PI, TWO N     
      INTEGER NT, D2, D3, D4, D5 
      INTEGER I, J, K, L, N OVER 2, I0, I1, I2      
    
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)         
      IERR=0    
      CALL CMPL FT (EVEN, ODD, N, DIM,IERR)    
      IF(IERR.GT.0) GO TO 600   
      NT = DIM(1)      
      D2 = DIM(2)      
      D3 = DIM(3)      
      D4 = DIM(4) - 1  
      D5 = DIM(5)      
      N OVER 2 = N/2 + 1         
    
      IF (N OVER 2 .LT. 2) GO TO 400      
      DO 300 I = 2, N OVER 2     
      ANGLE = TWO PI*FLOAT(I-1)/TWO N     
      CO = COS(ANGLE)  
      SI = SIN(ANGLE)  
      I0 = (I - 1)*D2 + 1        
      J = (N + 2 - 2*I)*D2       
      DO 200 I1 = I0, NT, D3     
      I2 = I1 + D4     
      DO 100 K = I1, I2, D5      
      L = K + J        
      A = (EVEN(L) + EVEN(K))/2.0
      C = (EVEN(L) - EVEN(K))/2.0
      B = (ODD(L) + ODD(K))/2.0  
      D = (ODD(L) - ODD(K))/2.0  
      E = C*SI + B*CO  
      F = C*CO - B*SI  
      EVEN(K) = A + E  
      EVEN(L) = A - E  
      ODD(K) = F - D   
      ODD(L) = F + D   
  100 CONTINUE         
  200 CONTINUE         
  300 CONTINUE         
    
  400 CONTINUE         
      IF (N .LT. 1) GO TO 600    
      J = N*D2         
      DO 500 I1 = 1, NT, D3      
      I2 = I1 + D4     
      DO 500 K = I1, I2, D5      
      L = K + J        
      EVEN(L) = EVEN(K) - ODD(K) 
      ODD(L) = 0.0     
      EVEN(K) = EVEN(K) + ODD(K) 
      ODD(K) = 0.0     
  500 CONTINUE         
    
  600 CONTINUE         
      RETURN 
      END    
      SUBROUTINE RPCFTK (N, M, P, R, X, Y, DIM)    
C     RADIX PRIME MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL  
C   
      INTEGER N, M, P, R, DIM(5) 
CMS      : X,Y
      REAL X(R,P), Y(R,P)        
C   
      LOGICAL FOLD,ZERO
      REAL ANGLE,IS,IU,RS,RU,T,TWOPI,XT,YT
      REAL FU, FP, FJM1, FMP     
      INTEGER J,JJ,K0,K,M OVER 2,MP,PM,PP,U,V       
      INTEGER K1, K2, KK, L, L1, MMP, NT, SIZE, SEP 
      INTEGER NS       
C   
      REAL AA (9,9), BB (9,9)    
      REAL A (18), B (18), C (18), S (18) 
      REAL IA (9), IB (9), RA (9), RB (9) 
      DATA TWO PI/6.283185/      
C   
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M OVER 2=M/2+1   
      MP=M*P 
      FMP = FLOAT(MP)  
      MMP = SEP*MP     
      PP=P/2 
      PM=P-1 
      FP = FLOAT(P)    
      FU = 0.0         
      DO 100 U=1,PP    
      FU = FU + 1.0    
      ANGLE = TWO PI*FU/FP       
      JJ=P-U 
      A(U)=COS(ANGLE)  
      B(U)=SIN(ANGLE)  
      A(JJ)=A(U)       
      B(JJ)=-B(U)      
  100 CONTINUE         
      DO 300 U=1,PP    
      DO 200 V=1,PP    
      JJ=U*V-U*V/P*P   
      AA(V,U)=A(JJ)    
      BB(V,U)=B(JJ)    
  200 CONTINUE         
  300 CONTINUE         
C   
      FJM1 = -1.0      
      DO 1500 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1         
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FMP    
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 700        
      C(1)=COS(ANGLE)  
      S(1)=SIN(ANGLE)  
      DO 400 U=2,PM    
      C(U)=C(U-1)*C(1)-S(U-1)*S(1)        
      S(U)=S(U-1)*C(1)+C(U-1)*S(1)        
  400 CONTINUE         
      GO TO 700        
  500 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1       
      DO 600 U=1,PM    
      T=C(U)*A(U)+S(U)*B(U)      
      S(U)=-S(U)*A(U)+C(U)*B(U)  
      C(U)=T 
  600 CONTINUE         
  700 CONTINUE         
C   
      DO 1400 KK = K0, NS, MMP  
      DO 1340 L = KK, NT, L1    
      K1 = L + SIZE    
      DO 1320 K = L, K1, K2     
      XT=X(K,1)        
      YT=Y(K,1)        
      RS=X(K,2)+X(K,P) 
      IS=Y(K,2)+Y(K,P) 
      RU=X(K,2)-X(K,P) 
      IU=Y(K,2)-Y(K,P) 
      DO 800 U=1,PP    
      RA(U)=XT+RS*AA(U,1)       
      IA(U)=YT+IS*AA(U,1)       
      RB(U)=RU*BB(U,1) 
      IB(U)=IU*BB(U,1) 
  800 CONTINUE         
      XT=XT+RS         
      YT=YT+IS         
      DO 1000 U=2,PP   
      JJ=P-U 
      RS=X(K,U+1)+X(K,JJ+1)     
      IS=Y(K,U+1)+Y(K,JJ+1)     
      RU=X(K,U+1)-X(K,JJ+1)     
      IU=Y(K,U+1)-Y(K,JJ+1)     
      XT=XT+RS         
      YT=YT+IS         
      DO 900 V=1,PP    
      RA(V)=RA(V)+RS*AA(V,U)    
      IA(V)=IA(V)+IS*AA(V,U)    
      RB(V)=RB(V)+RU*BB(V,U)    
      IB(V)=IB(V)+IU*BB(V,U)    
  900 CONTINUE         
 1000 CONTINUE         
      X(K,1)=XT        
      Y(K,1)=YT        
      DO 1300 U=1,PP   
      JJ=P-U 
      IF (ZERO) GO TO 1100      
      XT=RA(U)+IB(U)   
      YT=IA(U)-RB(U)   
      X(K,U+1)=XT*C(U)+YT*S(U)  
      Y(K,U+1)=YT*C(U)-XT*S(U)  
      XT=RA(U)-IB(U)   
      YT=IA(U)+RB(U)   
      X(K,JJ+1)=XT*C(JJ)+YT*S(JJ)         
      Y(K,JJ+1)=YT*C(JJ)-XT*S(JJ)         
      GO TO 1200       
 1100 CONTINUE         
      X(K,U+1)=RA(U)+IB(U)      
      Y(K,U+1)=IA(U)-RB(U)      
      X(K,JJ+1)=RA(U)-IB(U)     
      Y(K,JJ+1)=IA(U)+RB(U)     
 1200 CONTINUE         
 1300 CONTINUE         
 1320 CONTINUE         
 1340 CONTINUE         
 1400 CONTINUE         
      IF (FOLD) GO TO 500       
 1500 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R2CFTK (N, M, X0, Y0, X1, Y1, DIM)
C     RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(5)      
CMS      : X0,Y0,X1,Y1
      REAL X0 (10), Y0 (10), X1 (10), Y1 (10)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M2,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM2, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C,IS,IU,RS,RU,S,TWOPI    
      REAL FJM1, FM2   
      DATA TWO PI/6.283185/     
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M2=M*2 
      FM2 = FLOAT(M2)  
      M OVER 2=M/2+1   
      MM2 = SEP*M2     
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM2   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C=COS(ANGLE)     
      S=SIN(ANGLE)     
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      C=-C   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM2   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS=X0(K)+X1(K)   
      IS=Y0(K)+Y1(K)   
      RU=X0(K)-X1(K)   
      IU=Y0(K)-Y1(K)   
      X0(K)=RS         
      Y0(K)=IS         
      IF (ZERO) GO TO 300       
      X1(K)=RU*C+IU*S  
      Y1(K)=IU*C-RU*S  
      GO TO 400        
  300 CONTINUE         
      X1(K)=RU         
      Y1(K)=IU         
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R3CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM)
C     RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(5)      
CMS      : X0,Y0,X1,Y1,X2,Y2
      REAL X0 (10), Y0 (10), X1 (10), Y1 (10), X2 (10), Y2 (10)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M3,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM3, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,A,B,C1,C2,S1,S2,T,TWOPI  
      REAL I0,I1,I2,IA,IB,IS,R0,R1,R2,RA,RB,RS      
      REAL FJM1, FM3   
      DATA TWO PI/6.283185/, A/-0.5/, B/0.86602540/ 
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M3=M*3 
      FM3 = FLOAT(M3)  
      MM3 = SEP*M3     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM3   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1*A+S1*B      
      S1=C1*B-S1*A     
      C1=T   
      T=C2*A-S2*B      
      S2=-C2*B-S2*A    
      C2=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM3   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      R0=X0(K)         
      I0=Y0(K)         
      RS=X1(K)+X2(K)   
      IS=Y1(K)+Y2(K)   
      X0(K)=R0+RS      
      Y0(K)=I0+IS      
      RA=R0+RS*A       
      IA=I0+IS*A       
      RB=(X1(K)-X2(K))*B        
      IB=(Y1(K)-Y2(K))*B        
      IF (ZERO) GO TO 300       
      R1=RA+IB         
      I1=IA-RB         
      R2=RA-IB         
      I2=IA+RB         
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      GO TO 400        
  300 CONTINUE         
      X1(K)=RA+IB      
      Y1(K)=IA-RB      
      X2(K)=RA-IB      
      Y2(K)=IA+RB      
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R4CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM)  
C     RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(5)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3
      REAL X0 (10), Y0 (10), X1 (10), Y1 (10)       
      REAL X2 (10), Y2 (10), X3 (10), Y3 (10)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M4,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM4, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C1,C2,C3,S1,S2,S3,T,TWOPI
      REAL I1,I2,I3,IS0,IS1,IU0,IU1,R1,R2,R3,RS0,RS1,RU0,RU1
      REAL FJM1, FM4   
      DATA TWO PI/6.283185/     
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M4=M*4 
      FM4 = FLOAT(M4)  
      MM4 = SEP*M4     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM4   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1   
      C1=S1  
      S1=T   
      C2=-C2 
      T=C3   
      C3=-S3 
      S3=-T  
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM4   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS0=X0(K)+X2(K)  
      IS0=Y0(K)+Y2(K)  
      RU0=X0(K)-X2(K)  
      IU0=Y0(K)-Y2(K)  
      RS1=X1(K)+X3(K)  
      IS1=Y1(K)+Y3(K)  
      RU1=X1(K)-X3(K)  
      IU1=Y1(K)-Y3(K)  
      X0(K)=RS0+RS1    
      Y0(K)=IS0+IS1    
      IF (ZERO) GO TO 300       
      R1=RU0+IU1       
      I1=IU0-RU1       
      R2=RS0-RS1       
      I2=IS0-IS1       
      R3=RU0-IU1       
      I3=IU0+RU1       
      X2(K)=R1*C1+I1*S1
      Y2(K)=I1*C1-R1*S1
      X1(K)=R2*C2+I2*S2
      Y1(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      GO TO 400        
  300 CONTINUE         
      X2(K)=RU0+IU1    
      Y2(K)=IU0-RU1    
      X1(K)=RS0-RS1    
      Y1(K)=IS0-IS1    
      X3(K)=RU0-IU1    
      Y3(K)=IU0+RU1    
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R5CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, 
     . DIM)  
C     RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(5)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4
      REAL X0 (10), Y0 (10), X1 (10), Y1 (10), X2 (10), Y2 (10)       
      REAL X3 (10), Y3 (10), X4 (10), Y4 (10)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M5,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM5, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,A1,A2,B1,B2,C1,C2,C3,C4,S1,S2,S3,S4,T,TWOPI
      REAL R0,R1,R2,R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2   
      REAL I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2   
      REAL FJM1, FM5   
      DATA TWO PI/6.283185/, A1/0.30901699/, B1/0.95105652/,
     .      A2/-0.80901699/, B2/0.58778525/         
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M5=M*5 
      FM5 = FLOAT(M5)  
      MM5 = SEP*M5     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM5   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      C4=C2*C2-S2*S2   
      S4=S2*C2+C2*S2   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=C1*A1+S1*B1    
      S1=C1*B1-S1*A1   
      C1=T   
      T=C2*A2+S2*B2    
      S2=C2*B2-S2*A2   
      C2=T   
      T=C3*A2-S3*B2    
      S3=-C3*B2-S3*A2  
      C3=T   
      T=C4*A1-S4*B1    
      S4=-C4*B1-S4*A1  
      C4=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM5   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      R0=X0(K)         
      I0=Y0(K)         
      RS1=X1(K)+X4(K)  
      IS1=Y1(K)+Y4(K)  
      RU1=X1(K)-X4(K)  
      IU1=Y1(K)-Y4(K)  
      RS2=X2(K)+X3(K)  
      IS2=Y2(K)+Y3(K)  
      RU2=X2(K)-X3(K)  
      IU2=Y2(K)-Y3(K)  
      X0(K)=R0+RS1+RS2 
      Y0(K)=I0+IS1+IS2 
      RA1=R0+RS1*A1+RS2*A2      
      IA1=I0+IS1*A1+IS2*A2      
      RA2=R0+RS1*A2+RS2*A1      
      IA2=I0+IS1*A2+IS2*A1      
      RB1=RU1*B1+RU2*B2
      IB1=IU1*B1+IU2*B2
      RB2=RU1*B2-RU2*B1
      IB2=IU1*B2-IU2*B1
      IF (ZERO) GO TO 300       
      R1=RA1+IB1       
      I1=IA1-RB1       
      R2=RA2+IB2       
      I2=IA2-RB2       
      R3=RA2-IB2       
      I3=IA2+RB2       
      R4=RA1-IB1       
      I4=IA1+RB1       
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      X4(K)=R4*C4+I4*S4
      Y4(K)=I4*C4-R4*S4
      GO TO 400        
  300 CONTINUE         
      X1(K)=RA1+IB1    
      Y1(K)=IA1-RB1    
      X2(K)=RA2+IB2    
      Y2(K)=IA2-RB2    
      X3(K)=RA2-IB2    
      Y3(K)=IA2+RB2    
      X4(K)=RA1-IB1    
      Y4(K)=IA1+RB1    
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    
      SUBROUTINE R8CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, 
     . X5, Y5, X6, Y6, X7, Y7, DIM)       
C     RADIX 8 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL      
C  
      INTEGER N, M, DIM(5)      
CMS      : X0,Y0,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,X6,Y6,X7,Y7
      REAL X0 (10), Y0 (10), X1 (10), Y1 (10), X2 (10), Y2 (10)       
      REAL X3 (10), Y3 (10), X4 (10), Y4 (10), X5 (10), Y5 (10)       
      REAL X6 (10), Y6 (10), X7 (10), Y7 (10)       
C  
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M8,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM8, NT, SIZE, SEP 
      INTEGER NS       
      REAL ANGLE,C1,C2,C3,C4,C5,C6,C7,E,S1,S2,S3,S4,S5,S6,S7,T,TWOPI  
      REAL R1,R2,R3,R4,R5,R6,R7,RS0,RS1,RS2,RS3,RU0,RU1,RU2,RU3       
      REAL I1,I2,I3,I4,I5,I6,I7,IS0,IS1,IS2,IS3,IU0,IU1,IU2,IU3       
      REAL RSS0,RSS1,RSU0,RSU1,RUS0,RUS1,RUU0,RUU1  
      REAL ISS0,ISS1,ISU0,ISU1,IUS0,IUS1,IUU0,IUU1  
      REAL FJM1, FM8   
      DATA TWO PI/6.283185/, E/0.70710678/
C  
      NT = DIM(1)      
      SEP = DIM(2)     
      L1 = DIM(3)      
      SIZE = DIM(4) - 1
      K2 = DIM(5)      
      NS = N*SEP       
      M8=M*8 
      FM8 = FLOAT(M8)  
      MM8 = SEP*M8     
      M OVER 2=M/2+1   
C  
      FJM1 = -1.0      
      DO 600 J=1,M OVER 2       
      FOLD=J.GT.1 .AND. 2*J.LT.M+2        
      K0 = (J-1)*SEP + 1        
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM8   
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200       
      C1=COS(ANGLE)    
      S1=SIN(ANGLE)    
      C2=C1*C1-S1*S1   
      S2=S1*C1+C1*S1   
      C3=C2*C1-S2*S1   
      S3=S2*C1+C2*S1   
      C4=C2*C2-S2*S2   
      S4=S2*C2+C2*S2   
      C5=C4*C1-S4*S1   
      S5=S4*C1+C4*S1   
      C6=C4*C2-S4*S2   
      S6=S4*C2+C4*S2   
      C7=C4*C3-S4*S3   
      S7=S4*C3+C4*S3   
      GO TO 200        
  100 CONTINUE         
      FOLD=.FALSE.     
      K0 = (M+1-J)*SEP + 1      
      T=(C1+S1)*E      
      S1=(C1-S1)*E     
      C1=T   
      T=S2   
      S2=C2  
      C2=T   
      T=(-C3+S3)*E     
      S3=(C3+S3)*E     
      C3=T   
      C4=-C4 
      T=-(C5+S5)*E     
      S5=(-C5+S5)*E    
      C5=T   
      T=-S6  
      S6=-C6 
      C6=T   
      T=(C7-S7)*E      
      S7=-(C7+S7)*E    
      C7=T   
  200 CONTINUE         
C  
      DO 500 KK = K0, NS, MM8   
      DO 440 L = KK, NT, L1     
      K1 = L + SIZE    
      DO 420 K = L, K1, K2      
      RS0=X0(K)+X4(K)  
      IS0=Y0(K)+Y4(K)  
      RU0=X0(K)-X4(K)  
      IU0=Y0(K)-Y4(K)  
      RS1=X1(K)+X5(K)  
      IS1=Y1(K)+Y5(K)  
      RU1=X1(K)-X5(K)  
      IU1=Y1(K)-Y5(K)  
      RS2=X2(K)+X6(K)  
      IS2=Y2(K)+Y6(K)  
      RU2=X2(K)-X6(K)  
      IU2=Y2(K)-Y6(K)  
      RS3=X3(K)+X7(K)  
      IS3=Y3(K)+Y7(K)  
      RU3=X3(K)-X7(K)  
      IU3=Y3(K)-Y7(K)  
      RSS0=RS0+RS2     
      ISS0=IS0+IS2     
      RSU0=RS0-RS2     
      ISU0=IS0-IS2     
      RSS1=RS1+RS3     
      ISS1=IS1+IS3     
      RSU1=RS1-RS3     
      ISU1=IS1-IS3     
      RUS0=RU0-IU2     
      IUS0=IU0+RU2     
      RUU0=RU0+IU2     
      IUU0=IU0-RU2     
      RUS1=RU1-IU3     
      IUS1=IU1+RU3     
      RUU1=RU1+IU3     
      IUU1=IU1-RU3     
      T=(RUS1+IUS1)*E  
      IUS1=(IUS1-RUS1)*E        
      RUS1=T 
      T=(RUU1+IUU1)*E  
      IUU1=(IUU1-RUU1)*E        
      RUU1=T 
      X0(K)=RSS0+RSS1  
      Y0(K)=ISS0+ISS1  
      IF (ZERO) GO TO 300       
      R1=RUU0+RUU1     
      I1=IUU0+IUU1     
      R2=RSU0+ISU1     
      I2=ISU0-RSU1     
      R3=RUS0+IUS1     
      I3=IUS0-RUS1     
      R4=RSS0-RSS1     
      I4=ISS0-ISS1     
      R5=RUU0-RUU1     
      I5=IUU0-IUU1     
      R6=RSU0-ISU1     
      I6=ISU0+RSU1     
      R7=RUS0-IUS1     
      I7=IUS0+RUS1     
      X4(K)=R1*C1+I1*S1
      Y4(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X6(K)=R3*C3+I3*S3
      Y6(K)=I3*C3-R3*S3
      X1(K)=R4*C4+I4*S4
      Y1(K)=I4*C4-R4*S4
      X5(K)=R5*C5+I5*S5
      Y5(K)=I5*C5-R5*S5
      X3(K)=R6*C6+I6*S6
      Y3(K)=I6*C6-R6*S6
      X7(K)=R7*C7+I7*S7
      Y7(K)=I7*C7-R7*S7
      GO TO 400        
  300 CONTINUE         
      X4(K)=RUU0+RUU1  
      Y4(K)=IUU0+IUU1  
      X2(K)=RSU0+ISU1  
      Y2(K)=ISU0-RSU1  
      X6(K)=RUS0+IUS1  
      Y6(K)=IUS0-RUS1  
      X1(K)=RSS0-RSS1  
      Y1(K)=ISS0-ISS1  
      X5(K)=RUU0-RUU1  
      Y5(K)=IUU0-IUU1  
      X3(K)=RSU0-ISU1  
      Y3(K)=ISU0+RSU1  
      X7(K)=RUS0-IUS1  
      Y7(K)=IUS0+RUS1  
  400 CONTINUE         
  420 CONTINUE         
  440 CONTINUE         
  500 CONTINUE         
      IF (FOLD) GO TO 100       
  600 CONTINUE         
C  
      RETURN 
      END    

      SUBROUTINE SRFP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM,ERROR)
C     SYMMETRIZED REORDERING FACTORING PROGRAMME    
C  
      LOGICAL ERROR    
      INTEGER PTS,PMAX,TWO GRP,P SYM      
      INTEGER FACTOR (10), SYM (10), UN SYM (10)    
C  
      INTEGER PP(14), QQ (7)    
      INTEGER F,J,JJ,N,NEST,P,P TWO,Q,R   
C     CHARACTER LINE*80
C --------------------------
      MDOC=0
      NEST=14
C  
      N=PTS  
      P SYM=1
      F=2    
      P=0    
      Q=0    
  100 CONTINUE         
      IF (N.LE.1) GO TO 500     
      DO 200 J=F,PMAX  
      IF (N.EQ.(N/J)*J) GO TO 300         
  200 CONTINUE         
      GO TO 1400       
  300 CONTINUE         
      IF (2*P+Q.GE.NEST) GO TO 1600       
      F=J    
      N=N/F  
      IF (N.EQ.(N/F)*F) GO TO 400         
      Q=Q+1  
      QQ(Q)=F
      GO TO 100        
  400 CONTINUE         
      N=N/F  
      P=P+1  
      PP(P)=F
      P SYM=P SYM*F    
      GO TO 100        
C  
  500 CONTINUE         
      R=1    
      IF (Q.EQ.0) R=0  
      IF (P.LT.1) GO TO 700     
      DO 600 J=1,P     
      JJ=P+1-J         
      SYM(J)=PP(JJ)    
      FACTOR(J)=PP(JJ) 
      JJ=P+Q+J         
      FACTOR(JJ)=PP(J) 
      JJ=P+R+J         
      SYM(JJ)=PP(J)    
   
  600 CONTINUE         
  700 CONTINUE         
      IF (Q.LT.1) GO TO 900     
      DO 800 J=1,Q     
      JJ=P+J 
      UN SYM(J)=QQ(J)  
      FACTOR(JJ)=QQ(J) 
  800 CONTINUE         
      SYM(P+1)=PTS/P SYM**2     
  900 CONTINUE         
      JJ=2*P+Q         
      FACTOR(JJ+1)=0   
      P TWO=1
      J=0    
 1000 CONTINUE         
      J=J+1  
      IF (FACTOR(J).EQ.0) GO TO 1200      
      IF (FACTOR(J).NE.2) GO TO 1000      
      P TWO=P TWO*2    
      FACTOR(J)=1      
      IF (P TWO.GE.TWO GRP) GO TO 1100    
      IF (FACTOR(J+1).EQ.2) GO TO 1000    
 1100 CONTINUE         
      FACTOR(J)=P TWO  
      P TWO=1
      GO TO 1000       
 1200 CONTINUE         
      IF (P.EQ.0) R=0  
      JJ=2*P+R         
      SYM(JJ+1)=0      
      IF (Q.LE.1) Q=0  
      UN SYM(Q+1)=0    
      ERROR=.FALSE.    
C  
 1300 CONTINUE         
      RETURN 
C  
 1400 CONTINUE         
C      WRITE(*,1500) PMAX,PTS
C      WRITE(LINE,1500) PMAX,PTS
C      CALL MSGERR(MDOC,LINE)
      ERROR=.TRUE.     
      GO TO 1300       
C 1500 FORMAT (' ERR: LARGEST FACTOR EXCEEDS ',I3,'  N = ',I6)
C  
 1600 CONTINUE         
C      WRITE(*,1700) NEST,PTS
C      WRITE(LINE,1700) NEST,PTS
C      CALL MSGERR(MDOC,LINE)
      ERROR=.TRUE.     
      GO TO 1300       
C 1700 FORMAT (' ERR: FACTOR COUNT EXCEEDS ',I3,'  N = ',I6)
C  
      END    

C ******
      SUBROUTINE MDCFT2(X,D,IERR)
C -P- MDCFT2 -
CMS      : X,D
      REAL X(*)         
      INTEGER*4 D(*),IERR
C ******
      LOGICAL ERROR     
      INTEGERI,INC,NT,SPACE,PTS,PMAX,PSYM,TWOGRP    
      INTEGER DIM(5),FACTOR(15),SYM(15),UNSYM(15)    
C -----------------------------
C     MDOC=0
      IF(D(1).EQ.0) RETURN        
      PMAX=19
      TWOGRP=8         
      I=2    
      NT=D(1)
  100 IF(D(I).EQ.0) GOTO 200       
      NT=NT*D(I)       
      I=I+1  
      GOTO100
  200 CONTINUE         
      NT=IABS(2*NT)    
      DIM(1)=NT        
      SPACE=NT         
      INC=NT/D(I-1)    
  300 CONTINUE         
      I=I-1  
      IF(I.EQ.0) RETURN 
      IF(D(I).LE.1) GOTO 600       
      PTS=D(I)         
      CALL SRFP(PTS,PMAX,TWOGRP,FACTOR,SYM,PSYM,UNSYM,ERROR)   
      IF(ERROR) GOTO 700 
      IF(I.EQ.1) GOTO 400
      DIM(2)=IABS(INC) 
      DIM(3)=IABS(SPACE)         
      DIM(4)=DIM(2)    
      DIM(5)=2         
      GOTO 500
  400 CONTINUE         
      DIM(2)=2         
      DIM(3)=NT        
      DIM(4)=NT        
      DIM(5)=2*PTS     
  500 CONTINUE         
      CALL MDFTKD(PTS,FACTOR,DIM,X(1),X(2),IERR)
      IF(IERR.GT.0) GO TO 700
      CALL DIPRP(PTS,SYM,PSYM,UNSYM,DIM,X(1),X(2))   
  600 CONTINUE         
      IF(I.LE.2) GOTO 300
      INC=INC/D(I-1)   
      SPACE=SPACE/D(I) 
      GOTO 300
  700 CONTINUE         
C      WRITE(*,800)
C  800 FORMAT(' ERR:  FACTORING ERROR IN MDCFT2'//)
C      CALL MSGERR(MDOC,' ERR:  FACTORING ERROR IN MDCFT2')
      IERR=1
      RETURN 
      END    


C -P-
C -P------ others useful subroutines  --------------------
C -P-

      SUBROUTINE CORR_NAME_BL(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.4.AND.NAMEF(LEN-3:LEN).EQ.'.dat') THEN
        NAMEF = NAME(1:LEN-4)
      ELSE
        NAMEF = NAME
      ENDIF
      RETURN 
      END

      SUBROUTINE CORR_NAME_ALL(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      NAMEF = NAME
      RETURN 
      END

      SUBROUTINE CORR_NAME_BLC(NAMEF)
C -------------------------------------------
      CHARACTER NAMEF*(*),NAME*256
C -------------------------------------------
      CALL LENSTR_BL(NAMEF,LEN)
      IF(LEN.GT.0.AND.NAMEF(1:1).NE.','.AND.NAMEF(1:1).NE.' ') THEN
        NAME = NAMEF(1:LEN)
        DO I=LEN,1,-1
          IF(NAME(I:I).EQ.',') THEN
            NAME(I:I)=' '
          ELSE
            IF(NAME(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ELSE
        NAME = ' '
      ENDIF
      CALL LENSTR_BL(NAME,LEN)
      IF(LEN.GT.4.AND.NAMEF(LEN-3:LEN).EQ.'.crd') THEN
        NAMEF = NAME(1:LEN-4)
      ELSE
        NAMEF = NAME
      ENDIF
      RETURN 
      END

      SUBROUTINE REMOVE_FIRST_BLANC(LINE)
C -------------------------------------------
      CHARACTER LINE*(*),STR*512
C -------------------------------------------
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0.AND.LEN.LE.512) THEN
        STR = LINE(1:LEN)
        DO I=1,LEN
          IL = I
          IF(STR(I:I).NE.' ') THEN
            GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
        LINE = STR(IL:LEN)
      ENDIF
      RETURN 
      END

      SUBROUTINE DELETE_FILE(PATH,NAME)
C -------------------------------------------------------------
      INTEGER   MT,LEN
      CHARACTER NAME*(*),PATH*(*),FNAME*256
      logical ex
      integer nfile
C -------------------------------------------------------------
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//NAME
      ELSE
        FNAME = NAME       
      ENDIF
      MT=10
      inquire(file=fname,exist=ex,number=nfile)
      if(nfile.gt.6 .and. nfile.lt.100) close(nfile)
      if(ex) then
        OPEN(UNIT=MT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=10)
        CLOSE(MT,STATUS='DELETE',ERR=10)
      endif
 10   CONTINUE
      RETURN
      END  

      SUBROUTINE CHECK_STOP_SIGNAL(PATH,FILE,ISIGNAL)
C -------------------------------------------------------------
      INTEGER   MT,LEN,ISIGNAL
      CHARACTER FILE*(*),PATH*(*),FNAME*256
C -------------------------------------------------------------
      ISIGNAL = 0
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//FILE
      ELSE
        FNAME = FILE       
      ENDIF
      MT=10
      OPEN(UNIT=MT,FILE=FNAME,ACCESS='SEQUENTIAL',ERR=10
     *  ,FORM='FORMATTED',STATUS='OLD')
      CLOSE(MT,ERR=10)
      ISIGNAL = 1
      RETURN      
 10   CONTINUE
      ISIGNAL = 0
      RETURN
      END  

      SUBROUTINE CORR_ANAME_PDB(ANAME,RNAME,ASYMB,CTYPE)
C ----------------------------------------------
      PARAMETER (N_NAME = 33)
      CHARACTER ANAME*4,RNAME*3,ASYMB*4,CTYPE*4
C -----------------------------------------------
      CHARACTER TYPE*1,CH1*1,CH2*2,CH4*4
      CHARACTER NAME(N_NAME)*2
      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
     *          'HG','AL','GD','NA','CD','NI','SR','IN','HO','YB',
     *          'TE','LI','RB','BA','CS','SM','TL','PT','BE','SE',
     *          'MO','SI','AS'/
c      DATA NAME/'CO','MG','CA','ZN','CU','FE','CL','BR','MN','PB',
c     *          'HG','AL','GD','NA','CD','NI','SR'/
C ??? more
C ---------------------------------------------
      IF(ANAME(1:1).NE.' ') THEN
        CH1=ANAME(1:1)
        CALL CHKSMB(CH1,TYPE)
        IF(TYPE.EQ.'D') THEN
          CALL LENSTR_BL(ANAME,LN)
          IF(LN.LE.1) THEN
            LN=2
            ANAME(2:2)='H'
          ENDIF
          ASYMB = ANAME(2:2)//'   '
          CH4='    '
          CH4(1:LN)=ANAME(2:LN)//CH1
          ANAME=CH4
C         CTYPE='H   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ELSE IF(ANAME(4:4).EQ.' ') THEN
          CH2=ANAME(1:2)
          DO  I=1,N_NAME
            IF(NAME(I).EQ.CH2) THEN
              ASYMB=ANAME(1:2)//'  '
              CTYPE='$   '
              GO TO 100
            ENDIF
          ENDDO
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
  100     CONTINUE
        ELSE
          ASYMB=ANAME(2:2)//'   '
          CTYPE='C   '
          IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
        ENDIF  
      ELSE
        ASYMB=ANAME(2:2)//'   '
        IF(ASYMB(1:1).EQ.'M') ASYMB='C   '
        IF(ASYMB(1:1).EQ.'C'.OR.ASYMB(1:1).EQ.'N'.OR.
     *     ASYMB(1:1).EQ.'O'.OR.ASYMB(1:1).EQ.'B'.OR.
     *     ASYMB(1:1).EQ.'F'                         ) THEN
          CTYPE='C   '
        ELSE
          CTYPE='$   '
        ENDIF
        IF(ASYMB(1:1).EQ.'H') CTYPE='H   '
      ENDIF
      
      IF(ANAME(1:1).EQ.' ') THEN
        ANAME=ANAME(2:4)//' '
      ENDIF
      IF(ANAME(2:2).EQ.' ') THEN
        ANAME(2:4)=ANAME(3:4)//' '
        IF(ANAME(2:2).EQ.' ') ANAME(2:4)=ANAME(3:4)//' '
      ENDIF
C ---
      IF(RNAME(1:1).EQ.' ') THEN
        RNAME=RNAME(2:3)//' '
        IF(RNAME(1:1).EQ.' ') RNAME=RNAME(2:3)//' '
      ENDIF
      IF(RNAME.EQ.'WAT') RNAME='HOH'
      IF(RNAME.EQ.'DOD') RNAME='HOH'
      IF(RNAME.EQ.'CYT') RNAME='C'
      IF(RNAME.EQ.'ADE') RNAME='A'
      IF(RNAME.EQ.'THY') RNAME='T'
      IF(RNAME.EQ.'GUA') RNAME='G'
      IF(RNAME.EQ.'URI') RNAME='U'

      IF(RNAME(1:1).EQ.'''') RNAME(1:1)='*'
      IF(RNAME(2:2).EQ.'''') RNAME(2:2)='*'
      IF(RNAME(3:3).EQ.'''') RNAME(3:3)='*'
      IF(ANAME(1:1).EQ.'''') ANAME(1:1)='*'
      IF(ANAME(2:2).EQ.'''') ANAME(2:2)='*'
      IF(ANAME(3:3).EQ.'''') ANAME(3:3)='*'
      IF(ANAME(4:4).EQ.'''') ANAME(4:4)='*'

      IF(ANAME.EQ.'H0  ') THEN
        ANAME    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ASYMB.EQ.'D  ') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HE22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HD22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH11') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH12') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH21') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HH22') THEN
        ASYMB    = 'H   '
        CTYPE='H   '
      ENDIF
      IF(ANAME.EQ.'HT1 ') THEN
        ANAME    = 'H1  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT2 ') THEN
        ANAME    = 'H2  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF
      IF(ANAME.EQ.'HT3 ') THEN
        ANAME    = 'H3  '
        ASYMB    = 'H   '
        CTYPE    = 'H   '
      ENDIF

      IF(RNAME.EQ.'HOH') THEN
        IF(ASYMB(1:1).EQ.'O') THEN
          ANAME = 'O   '
          ASYMB = 'O   '
          CTYPE = 'C   '
        ELSE IF(ASYMB(1:1).EQ.'H'.OR.ASYMB(1:1).EQ.'D') THEN
          ASYMB = 'H   '
          CTYPE = 'H   '
        ENDIF
      ENDIF
C ---  special cases ---
      IF(RNAME.EQ.'IUM'.AND.CTYPE.EQ.'$   ') THEN
        RNAME = ANAME(1:2)
      ENDIF

      RETURN
      END

      SUBROUTINE ADD_PATH(PATH,NAME)
C -------------------------------------------------------------
      INTEGER   LEN
      CHARACTER NAME*(*),PATH*(*),FNAME*256
C -------------------------------------------------------------
      CALL LENSTR_BL(PATH,LEN)
      IF(LEN.GT.0.AND.PATH(1:1).NE.',') THEN
        FNAME = PATH(1:LEN)//NAME
        NAME  = FNAME
      ENDIF
      RETURN
      END  

      SUBROUTINE CHECK_CHAIN_ID(INEW)
C -----------------------------------------------
C  
C 
C -----------------------------------------------
      INTEGER*4 IERR,MDOC
      CHARACTER LINE*80
      INTEGER   NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
      CHARACTER NCSF*1,GID*4
C -----------------------------------
C ---
      CHARACTER CH1*1,CH2*2
      INTEGER   NLETT
      CHARACTER LETT*66,GROUP_ID(66)*4
C     DATA NLETT /66/
C     DATA LETT/
C     *'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'/
C     *'qrstuvwxyz<>{}[]'/
C       123456789 123456789 123456789 123456789 123456789       
C ------------------------------------
C     PARAMETER (MAXCHAIN=50)
C     NLETT = 66
      NLETT = 50
      LETT  = 'ABCDEFGHIJKLMNOPRSTUVWXYZ123456789abcdefghijklmnop'//
     *        'qrstuvwxyz<>{}[]RSTUVWXYZ'
      MDOC = 0
      IERR = 0
      INEW = 0
      LNEW = 0
      IGR  = 0
      CALL GET_ASYMM(MDOC,NMAX,NGR,NCH,IGR,ICH,INC,MLT,IATM
     *               ,NCSF,GID,IERR)
      IF(IERR.NE.0.OR.NGR.LE.0) THEN
        GO TO 900
      ENDIF
      IF(NGR.EQ.1) THEN
        IGR = 1
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        IF(GID(1:1).EQ.' '.OR.GID(1:1).EQ.'.') THEN
          GID(1:1) = 'A'
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDIF
        RETURN
      ENDIF

      IF(NGR.GT.NLETT) GO TO 900

      DO IGR=1,NGR
        CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                    ,NCSF,GID,IERR)
        IF(IERR.NE.0) GO TO 900
        GROUP_ID(IGR) = GID
      ENDDO

      DO I=2,NGR
        CH2 = GROUP_ID(I)(1:2) 
        DO J=1,I-1
          IF(CH2.EQ.GROUP_ID(J)(1:2)) GO TO 500
        ENDDO
      ENDDO
      RETURN

 500  CONTINUE

      DO I=1,NGR
        IF(GROUP_ID(I)(1:1).EQ.' ') GROUP_ID(I)(1:1) = '.' 
        GROUP_ID(I)(3:3) = GROUP_ID(I)(1:1) 
      ENDDO

      DO I=1,NGR

        CH1 = GROUP_ID(I)(1:1) 
         
        IF(NGR.LE.1) THEN
          IF(CH1.EQ.'.') CH1='A'
          GO TO 400
        ENDIF
        
        IF(I.EQ.1.AND.CH1.NE.'.') GO TO 200
        IF(I.GT.1.AND.CH1.NE.'.') THEN
          DO J=1,I-1
            IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 100
          ENDDO
          GO TO 200
        ENDIF

 100    CONTINUE

        DO K=1,NLETT
          CH1 = LETT(K:K)
          DO J=1,NGR
            IF(J.NE.I) THEN
              IF(CH1.EQ.GROUP_ID(J)(1:1)) GO TO 300
            ENDIF
          ENDDO
          GO TO 400
 300      CONTINUE
        ENDDO

        LNEW = LNEW + 1
        IF(LNEW.GT.NLETT) LNEW = LNEW - NLETT
        CH1 =  LETT(LNEW:LNEW)        

 400    CONTINUE

        GROUP_ID(I)(1:1) = CH1

 200    CONTINUE

      ENDDO

      DO I=1,NGR
        CH1 = GROUP_ID(I)(3:3)
        IF(CH1.NE.GROUP_ID(I)(1:1)) INEW = 1

c        GROUP_ID(I)(2:2) = GROUP_ID(I)(1:1) 
c        GROUP_ID(I)(1:1) = CH1 

        GROUP_ID(I)(3:3) = ' '
        GROUP_ID(I)(4:4) = ' ' 
      ENDDO
C ----------------------
      IF(INEW.EQ.1) THEN
        DO IGR=1,NGR
          CALL GET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT,IGOLD
     *                      ,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
          GID = GROUP_ID(IGR)
          CALL SET_ASYMM(MDOC,NMAX,NG,ICHOLD,IGR,ICH,INC,MLT
     *                     ,IGOLD,NCSF,GID,IERR)
          IF(IERR.NE.0) GO TO 900
        ENDDO
      ENDIF
      RETURN
C ----------------------
900   CONTINUE
      NCHAIN = 1
      IGR    = NCHAIN
      ICH    = IGR
      IGOLD  = IGR
      ICHOLD = IGR
      INC    = 0
      MLT    = 0
      IATM   = 0
      NCSF   = '.'
      GID    = 'AA  '
      INEW   = 1
      CALL SET_ASYMM(MDOC,NMAX,NGR,ICHOLD,IGR,ICH,INC,MLT
     *                   ,IGOLD,NCSF,GID,IERR)
      RETURN
      END

C ******
      SUBROUTINE CHNG_DATE(CH9,CH10)
C -------------------------------------------------------
C -P- CHNG_DATE - 
C -------------------------------------------------------
      CHARACTER CH9*9,CH10*10
C ******
      CHARACTER MONTH(12)*3
      DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP'
     *           ,'OCT','NOV','DEC'/
C ---------------------------------
      IF(CH9(1:1).EQ.'X') THEN
        CH10='XXXX-XX-XX'
        RETURN
      ENDIF
      CH10(1:2) = '19'
      CH10(3:4) = CH9(8:9)
      IF(CH10(3:3).EQ.'0') THEN
        CH10(1:2) = '20'
      ENDIF
      CH10(5:5) = '-'
      CH10(8:8) = '-'
      CH10(9:10)= CH9(1:2)
      IM=0
      DO I=1,12
        IF(CH9(4:6).EQ.MONTH(I)) THEN
          IM=I
          GO TO 100
        ENDIF
      ENDDO
 100  CONTINUE
      IF(IM.LE.0) IM=1
      WRITE(CH10(6:7),'(I2)') IM
      IF(CH10(6:6).EQ.' ') CH10(6:6)='0'
      RETURN
      END

C ******
      SUBROUTINE CHNG_DATE_BACK(CH10,CH9)
C -------------------------------------------------------
C -P- CHNG_DATE_BACK - 
C -------------------------------------------------------
      CHARACTER CH9*9,CH10*10
C ******
      CHARACTER MONTH(12)*3
      DATA MONTH/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP'
     *           ,'OCT','NOV','DEC'/
C ---------------------------------
      IF(CH10(1:1).EQ.'X') THEN
        CH9='XX-XXX-XX'
        RETURN
      ENDIF
      CH9(8:9) =CH10(3:4)
      CH9(3:3) = '-'
      CH9(7:7) = '-'
      CH9(1:2) = CH10(9:10)
      READ(CH10(6:7),'(I2)') IM
      IF(IM.LE.0)  IM=1
      IF(IM.GT.12) IM=12
      CH9(4:6)=MONTH(IM)
      RETURN
      END

C -------------
      SUBROUTINE GET_SYMM(MDOC,NOSPGR,ISETT,SGNAME,NSYM,ISYM
     *                              ,MAXNSO,IERR)
C -------------------------------------------------------
C -P- GET_SYMM - generate cryst.symm. oparators from space group name or space
C -P-            group number.
C -------------------------------------------------------
C --
C           input
C         nsg  sett  --> nsg sett' --> nsg+sett
C          3    1         3   2        1003
C          3    2         3   1           3
C          4    1         4   2        1004
C          4    2         4   1           4
C          5    1         5   4        3005               
C          5    2         5   1           5       
C          5    3         5   2        1005  
C          5    4         5   3        2005  
C        146    1 R     146   2        1146 R
C        146    2 H     146   1         146 H
C        155    1 R     155   2        1155 R
C        155    2 H     155   1         155 H
C --------------------------------------        
C
c      ISTT = NSG/1000
c      NOSG = NSG - ISTT*1000
c      ISTT = ISTT + 1
c
c      IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
c        IF(ISTT.EQ.1) THEN
c          ISTT = 2
c        ELSE IF(ISTT.EQ.2) THEN  
c          ISTT = 1
c        ENDIF
c      ELSE IF(NOSG.EQ.  5) THEN
c        IF(ISTT.EQ.1) THEN
c          ISTT = 2
c        ELSE IF(ISTT.EQ.2) THEN  
c          ISTT = 3
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 1
c        ENDIF
c      ENDIF
c
c      NOSPGR = NOSG
c      ISETT  = ISTT 
C ---
C ---
C -------------------------------------------------------
      INTEGER   MDOC,IERR,MAXNSO
C --
      INTEGER*2 ISYM(5,3,MAXNSO)
      INTEGER   NOSPGR,ISETT,NSYM
      CHARACTER SGNAME*(*)
C -----------------------------------
      CHARACTER LINE*80
C -----------------------------------
      CHARACTER SG_TAB*24,SG_TAB1*24,SG_TAB2*24,OP*80
      INTEGER   III,I,IS,NSS,NSYMR,N,LENS,LEN
      INTEGER   NO_CCP4,NO_TAB,NS_TAB,NSG,L
C -------------------------------------------------------
      IERR = 0
      M    = 99
C ------------------------------------
      NSYM = 0
C ------------------------------------
      CALL LENSTR_BL(SGNAME,LENS)
      IF(LENS.LE.0) THEN
        IF(NOSPGR.LE.0) THEN
C         default P1
          GO TO 100
        ELSE
C         --> use space group number
          GO TO 400
        ENDIF
      ENDIF
C ------------------------------------------
C     use space group name
C
      N = 0
      DO I=1,LENS
        IF(SGNAME(I:I).NE.' ') GO TO 600
        N = N + 1 
      ENDDO
  600 CONTINUE

      IF(N.GT.0) THEN
        DO I=1,LENS-N
          SGNAME(I:I) = SGNAME(I+N:I+N)
        ENDDO
        CALL LENSTR_BL(SGNAME,LENS)
      ENDIF
      IF(LENS.LT.2) GO TO 400
      IF(SGNAME.EQ.'A2')  SGNAME = 'A121'
      IF(SGNAME.EQ.'I2')  SGNAME = 'I121'
      IF(SGNAME.EQ.'P2')  SGNAME = 'P121'
      IF(SGNAME.EQ.'P21') SGNAME = 'P1211'
      IF(SGNAME.EQ.'I21') SGNAME = 'I1211'
      IF(SGNAME.EQ.'C21') SGNAME = 'C1211'
      IF(SGNAME.EQ.'C2')  SGNAME = 'C121'
      IF(SGNAME.EQ.'B2')  SGNAME = 'B112'
      CALL LENSTR_BL(SGNAME,LENS)
C -----------------------------------------
      III = 0
  300 CONTINUE

      III = III + 1
      IS  = 0
      CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
      IF(IERR.NE.0) GO TO 400

C     space group number
      NO_CCP4 = NO_TAB 
C     number of symmetry operators
      NSYM    = NS_TAB
C     space group name

      CALL LENSTR_BL(SG_TAB,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB(1:LENS).EQ.SGNAME(1:LENS)) GO TO 500
      ENDIF
      CALL LENSTR_BL(SG_TAB1,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB1(1:LENS).EQ.SGNAME(1:LENS)) THEN
          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.GT.0) SGNAME = SG_TAB(1:LEN)
          GO TO 500
        ENDIF
      ENDIF
      CALL LENSTR_BL(SG_TAB2,LEN)
      IF(LEN.GT.0) THEN
        IF(LENS.EQ.LEN.AND.SG_TAB2(1:LENS).EQ.SGNAME(1:LENS)) THEN
          CALL LENSTR_BL(SG_TAB,LEN)
          IF(LEN.GT.0) SGNAME = SG_TAB(1:LEN)
          GO TO 500
        ENDIF
      ENDIF
      GO TO 300
C ----------------------------------------------------------
C     use space group number
C
  400 CONTINUE

C ----
      CALL NSG_STAND_TO_CCP4(NOSPGR,ISETT,NO_CCP4,IERR)
      IF(IERR.NE.0) GO TO 100      

      III = 0
  410 CONTINUE

      III = III + 1
      IS  = 0
      CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
      IF(IERR.NE.0) GO TO 100

C     space group number
      NSG    = NO_TAB
C     number of symmetry operators
      NSYM   = NS_TAB

      IF(NSG.EQ.NO_CCP4) THEN
        CALL LENSTR_BL(SG_TAB,LENR)
        SGNAME = SG_TAB(1:LENR)
        GO TO 500
      ENDIF

      GO TO 410
C --------------------------------
 500  CONTINUE
      IF(NSYM.GT.MAXNSO) THEN
        WRITE(LINE,
     *  '('' ERROR: number of cryst. symmetry operators >'',I6)') 
     *  MAXNSO
        CALL MSGERR(MDOC,LINE)
        IERR=1
        GO TO 100
      ELSE IF(NSYM.LE.0) THEN
        WRITE(LINE,
     *  '('' ERROR: number of cryst. symmetry operators =< 0'')')
        CALL MSGERR(MDOC,LINE)
        IERR=1
        GO TO 100
      ENDIF

      NSYMR = NSYM   
      DO  IS=1,NSYM
        CALL GET_SPACE_GROUP_INFO(III,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB,SG_TAB1,SG_TAB2,OP,IERR)
        IF(IERR.NE.0) GO TO 100
        NSS   = IS
        CALL SYMFR2_BL(MDOC,OP,NSS,NSYMR,ISYM,MAXNSO,IERR)
        IF(IERR.GT.0) RETURN
      ENDDO 

c      write(*,*) '--no_ccp4:',NO_CCP4

      CALL NSG_CCP4_TO_STAND(NO_CCP4,NOSPGR,ISETT,IERR)

c      write(*,*) '-- No sg :',NOSPGR,ISETT
c        CALL LENSTR_BL(SGNAME,L)
c      write(*,*) '-sgname  :',SGNAME(1:L),'>'

      RETURN
C -----------------------------
 100  CONTINUE
      NOSPGR      = 1
      ISETT       = 1
      NSYM        = 1
      ISYM(1,1,1) = 1
      ISYM(2,1,1) = 0
      ISYM(3,1,1) = 0
      ISYM(4,1,1) = 0
      ISYM(5,1,1) = 1
      ISYM(1,2,1) = 0
      ISYM(2,2,1) = 1
      ISYM(3,2,1) = 0
      ISYM(4,2,1) = 0
      ISYM(5,2,1) = 1
      ISYM(1,3,1) = 0
      ISYM(2,3,1) = 0
      ISYM(3,3,1) = 1
      ISYM(4,3,1) = 0
      ISYM(5,3,1) = 1

      LINE = ' WARNING: can''t find space group name'
      CALL MSGERR(MDOC,LINE)
      CALL LENSTR_BL(SGNAME,L)
      IF(L.GT.0) THEN
        IF(L.GT.12) L = 12
      ELSE
        L      = 1
        SGNAME = ' '
      ENDIF 
      LINE = '              -->'//SGNAME(1:L)//'<--'
      CALL MSGERR(MDOC,LINE)
      CALL MSGERR(MDOC,'        default space group is "P 1"')

      SGNAME     = 'P 1'
      IERR=-1
      RETURN
      END


      SUBROUTINE NSG_CCP4_TO_STAND(NO_CCP4,NO_STAND,IS_STAND,IERR)
C -----------------------------------------------------------
      INTEGER NO_STAND,IS_STAND,NO_CCP4
C -----------------------------------------------------------
      IERR     = 0
      NO_STAND = 0
      IS_STAND = 0
C ----------------------
      NSG  = NO_CCP4
      ISTT = NSG/1000
      NOSG = NSG - ISTT*1000
      ISTT = ISTT + 1

      IF(NOSG.EQ.3.OR.NOSG.EQ.4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ENDIF
      NO_STAND = NOSG
      IS_STAND = ISTT 
C ---
      RETURN
      END

      SUBROUTINE NSG_STAND_TO_CCP4(NO_STAND,IS_STAND,NO_CCP4,IERR)
C -----------------------------------------------------------
      INTEGER NO_STAND,IS_STAND,NO_CCP4
C -----------------------------------------------------------
      IERR    = 0
      NO_CCP4 = 0
      NOSPGR  = NO_STAND
      IF(NOSPGR.LE.0.OR.NOSPGR.GT.230) THEN
        IERR = 1
        RETURN
      ENDIF      
      ISETT  = IS_STAND      
      IF(ISETT.LE.0.OR.ISETT.GT.9) ISETT = 1
C -------
      NOSG = NOSPGR
      ISTT = ISETT
C ----
      IF(NOSG.EQ.  3.OR.NOSG.EQ.  4.OR.NOSG.EQ.146.OR.NOSG.EQ.155) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
        ENDIF
      ELSE IF(NOSG.EQ.  5) THEN
        IF(ISTT.EQ.1) THEN
          ISTT = 2
        ELSE IF(ISTT.EQ.2) THEN  
          ISTT = 1
c        ELSE IF(ISTT.EQ.3) THEN  
c          ISTT = 4
c        ELSE IF(ISTT.EQ.4) THEN  
c          ISTT = 3
        ENDIF
      ENDIF
C ---
      IF(ISTT.GT.1) NOSG = (ISTT-1)*1000 + NOSG
      NO_CCP4 = NOSG
C ---
      RETURN
      END 

      SUBROUTINE SYMFR2_BL(MDOC,LINE,NS,NSYM,ISYM,IPRSYM,IERR)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NSYM
      CHARACTER LINE*(*),STR*80
C 
      REAL      ROT(3,3),TR(3)
      INTEGER   NUM(10)      
      CHARACTER INUM(10)*1,ICH*1
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR = 0
      I1   = 1
      IF(LINE(1:1).EQ.'S') I1=6
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.4) THEN
        IERR=1
      ENDIF
      IMAX = LEN
      I    = I1-1
      NOP  = 1
      DO     J=1,3
        TR(J) = 0.0
        DO     K=1,3
          ROT(J,K) = 0.0
        ENDDO
      ENDDO
  117 S      = 1.0
      T      = 0.0
      IP     = 0
      J      = 0
      NP     = 0
      ISL    = 0
      IFOUND = 0

  100 I=I+1
      IF(I.GT.IMAX)                 GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')                GO TO 100
      IF(ICH.EQ.','.OR. ICH.EQ.'*') GO TO 110
      IFOUND=1

      IF(ICH.EQ.'X')  GO TO 105
      IF(ICH.EQ.'Y')  GO TO 106
      IF(ICH.EQ.'Z')  GO TO 107

      IF(ICH.EQ.'+')  GO TO 121
      IF(ICH.EQ.'-')  GO TO 122
      IF(ICH.EQ.'/')  GO TO 123
      IF(ICH.EQ.'.')  GO TO 124

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
9101  FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100
C ---- DIGIT
  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 120
  103 T = T/A
      GO TO 120
  104 NP=NP+1
      T = T + A/10**NP
  120 TR(NOP)=T
      GO TO 100
C --- LETTER
  105 J=1
      GO TO 108
  106 J=2
      GO TO 108
 107  J=3
 108  IF(T.NE.0.0) S=T
      ROT(J,NOP)=S
      T   = 0.0
      S   = 1.0
      ISL = 0
      IP  = 0
      NP  = 0
      GO TO 100
C ----------------------
C --- + ---
  121 S=1.0
      GO TO 130
C --- - ---
  122 S=-1.0
  130 IF(T.NE.0.0.AND.J.EQ.0) THEN
        T=0.0
      ENDIF
      GO TO 100
C --- / ---
  123 ISL=1
      GO TO 100
C --- . ---
  124 IP=1
      GO TO 100

  110 CONTINUE
      IF(J.NE.0.AND.T.NE.0.0) TR(NOP) = T
      J=0     
      IF(IFOUND.EQ.0 .AND. I.LE.IMAX) THEN
        CALL MSGERR(MDOC,' ERR: BLANK OPERATOR FIELD')
      ENDIF
      NOP=NOP+1
      IF(NOP.LE.3.AND.I.LE.IMAX) GO TO 117
      IF(NOP.EQ.4 .AND. IFOUND.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: LAST GENERAL POSITION IS INCOMPLETE')
        IERR=1
      ENDIF
      NSYM=NS
      ISYM(1,1,NS)=ROT(1,1)
      ISYM(2,1,NS)=ROT(2,1)
      ISYM(3,1,NS)=ROT(3,1)
      ISYM(1,2,NS)=ROT(1,2)
      ISYM(2,2,NS)=ROT(2,2)
      ISYM(3,2,NS)=ROT(3,2)
      ISYM(1,3,NS)=ROT(1,3)
      ISYM(2,3,NS)=ROT(2,3)
      ISYM(3,3,NS)=ROT(3,3)
      ISYM(4,1,NS)=INT((TR(1)*24.+0.1))
      ISYM(4,2,NS)=INT((TR(2)*24.+0.1))
      ISYM(4,3,NS)=INT((TR(3)*24.+0.1))
      ISYM(5,1,NS)=24
      ISYM(5,2,NS)=24
      ISYM(5,3,NS)=24
      RETURN
      END

      SUBROUTINE SYMFR3_BL(MDOC,LINE,NS,NSYM,ISYM,IPRSYM,IERR)
      INTEGER*2 ISYM(5,3,IPRSYM)
      INTEGER   NSYM
      CHARACTER LINE*(*),STR*80
C 
      REAL      ROT(3,3),TR(3)
      INTEGER   NUM(10)      
      CHARACTER INUM(10)*1,ICH*1
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR=0
      I1=1
      IF(LINE(1:1).EQ.'S') I1=6
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.4) THEN
        IERR=1
      ENDIF
      IMAX=LEN
      I=I1-1
      NOP=1
      DO     J=1,3
        TR(J)=0.
        DO     K=1,3
          ROT(J,K)=0.
        ENDDO
      ENDDO
  117 S=1.0
      T=0.0
      IP=0
      J=0
      NP=0
      ISL=0
      IFOUND=0

  100 I=I+1
      IF(I.GT.IMAX)                 GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')                GO TO 100
      IF(ICH.EQ.','.OR. ICH.EQ.'*') GO TO 110
      IFOUND=1

      IF(ICH.EQ.'X')  GO TO 105
      IF(ICH.EQ.'Y')  GO TO 106
      IF(ICH.EQ.'Z')  GO TO 107

      IF(ICH.EQ.'+')  GO TO 121
      IF(ICH.EQ.'-')  GO TO 122
      IF(ICH.EQ.'/')  GO TO 123
      IF(ICH.EQ.'.')  GO TO 124

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
9101  FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100
C ---- DIGIT
  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 120
  103 T = T/A
      GO TO 120
  104 NP=NP+1
      T = T + A/10**NP
  120 TR(NOP)=T
      GO TO 100
C --- LETTER
  105 J=1
      GO TO 108
  106 J=2
      GO TO 108
 107  J=3
 108  IF(T.NE.0.0) S=T
      ROT(J,NOP)=S
      T  =0.0
      S  =1.0
      ISL=0
      IP =0
      NP =0
      GO TO 100
C ----------------------
C --- + ---
  121 S=1.0
      GO TO 130
C --- - ---
  122 S=-1.0
  130 IF(T.NE.0.0.AND.J.EQ.0) THEN
        T=0.0
      ENDIF
      GO TO 100
C --- / ---
  123 ISL=1
      GO TO 100
C --- . ---
  124 IP=1
      GO TO 100

  110 CONTINUE
      IF(J.NE.0.AND.T.NE.0.0) TR(NOP) = T
      J=0     
      IF(IFOUND.EQ.0 .AND. I.LE.IMAX) THEN
        CALL MSGERR(MDOC,' ERR: BLANK OPERATOR FIELD')
      ENDIF
      NOP=NOP+1
      IF(NOP.LE.3.AND.I.LE.IMAX) GO TO 117
      IF(NOP.EQ.4 .AND. IFOUND.EQ.0) THEN
        CALL MSGERR(MDOC,' ERR: LAST GENERAL POSITION IS INCOMPLETE')
        IERR=1
      ENDIF
      NSYM=NS
      ISYM(1,1,NS)=ROT(1,1)
      ISYM(2,1,NS)=ROT(2,1)
      ISYM(3,1,NS)=ROT(3,1)
      ISYM(1,2,NS)=ROT(1,2)
      ISYM(2,2,NS)=ROT(2,2)
      ISYM(3,2,NS)=ROT(3,2)
      ISYM(1,3,NS)=ROT(1,3)
      ISYM(2,3,NS)=ROT(2,3)
      ISYM(3,3,NS)=ROT(3,3)
      ISYM(4,1,NS)=INT((TR(1)*24.+0.1))
      ISYM(4,2,NS)=INT((TR(2)*24.+0.1))
      ISYM(4,3,NS)=INT((TR(3)*24.+0.1))
      ISYM(5,1,NS)=24
      ISYM(5,2,NS)=24
      ISYM(5,3,NS)=24
      RETURN
      END

C ******
      SUBROUTINE GETLINE(IUN,MDOC,STR,IERR,IEND)
C -----------------------------------------------
C -P- GETLINE - reads one record of file to string STR (80 chars maximum).
C               Checks two last characters of STR and put ' ' if they
C               are not good. 
C               If lenght of STR = 0  set STR(1:1)=' '.
C               Fills to the rest of string by ' '.
C      input:
C         IUN  - logical unit_number.
C         MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                0 - only terminal , < - 0 only file, 0 < < 99 - both
C                >= 99 - don't write  
C      output:
C         STR  - output string
C         IERR - "1" means read_error,  "0" - OK.
C         IEND - "1" means end-of-file, "0" - STR was reading.
C -----------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
      CHARACTER STR*(*)
C ******
C -----------------------------------------------
      INTEGER*4 NL
      CHARACTER CH1*1,CHAR1*1
C -----------------------------------------------
      IERR = 0
      IEND = 0
      READ(IUN,'(A)',ERR=1000,END=1010) STR
      NL = LEN(STR)
      IF(NL.LE.0) THEN
        STR = ' '
        NL  = 1
      ELSE
        IF(NL.GE.1) THEN
          CHAR1 = STR(NL:NL) 
          CALL CHKSMB(CHAR1,CH1)
          IF(CH1.EQ.'?') STR(NL:NL) = ' '
          IF(NL.GT.1) THEN
            CHAR1 = STR(NL-1:NL-1) 
            CALL CHKSMB(CHAR1,CH1)
            IF(CH1.EQ.'?') STR(NL-1:NL-1) = ' '
          ENDIF
        ENDIF       
      ENDIF
c      IF(NL.LT.80) THEN
c        DO I=NL,80
c          STR(I:I) = ' '
c        ENDDO
c      ENDIF
      RETURN
C ----------------------------------
 1000 CALL MSGDOC(MDOC,' ERROR: read error.')     
      IERR=1
      RETURN
 1010 IEND=1
      RETURN
C -----------------------------------
      END     


C ******
      SUBROUTINE GETCIF(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.
C     output:
C           IEND  = 0 - OK, = 1 - end of file.
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        IEND   =0
      ENDIF
      IERR=0
      IEND=0
      LOOP_FLAG='N'
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') GO TO 200    
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END
C ******
      SUBROUTINE GETCIF_INFO(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_INFO - reads the records from file and get information 
C -P-               from records by CIF_style. 
C     Each call of subroutine returns set of loop (or only one) 
C     item_names and corresponding data, also its data_block_name or
C     comment string.
C     Returned information are in common /COMCIF/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writing messages to DOC-file. 
C                   0 - only terminal , < 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0 
C                  ( or -2 come back after getting comment string)
C
C     output:
C           IEND  =  0  - OK 
C                 =  1  - end of file 
C                 = -2  - OK, comment string was reading, puts comment string
C                             into DT_CIF.
C                                                   
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C                  IEND = 0
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C                  IEND = -2
C           DT_CIF(NWORDSMAX) - comment string  
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 60 )
      COMMON /COMCIF_INFO/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /COMFREAD_INFO/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      INTEGER*4 I,II,IFLAG,LEN_IN,LN,LNN
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR = 0
      IF(IEND.EQ.-1) THEN
C       first call
        N_DATA    = 0
        N_CIF     = 0
        N_ITEM    = 0
        I_CIF     = 0
        NWORDS    = 0
        BLK_CIF   = ' '
        BLK_FLAG  = 'N'
        LOOP_FLAG = 'N'
        IEND      = 0
      ELSE IF(IEND.EQ.-2) THEN
C       back after giving comments
        IEND  = 0
        I_CIF = NWORDS
      ELSE
        IEND      = 0
        LOOP_FLAG = 'N'
      ENDIF
C ------------------------------------------------------
  300 CONTINUE

        IF(I_CIF.EQ.NWORDS) THEN

C ===        
C         get one string
C
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
C         end of file or reading error
          IF(IERR.NE.0.OR.IEND.NE.0) RETURN
C ===          
          CALL LENSTR_BL(IN_STRING,LEN_IN)

          IF(LEN_IN.GT.1.AND.IN_STRING(1:1).NE.';'.AND.
     *                       IN_STRING(1:1).NE.'#') THEN
C           remove comments in the line
            IFLAG = 0
            II    = 1
            DO I=1,LEN_IN
              IF(IFLAG.EQ.0) THEN
                IF(IN_STRING(I:I).EQ.'''') II=II*(-1)
                IF(II.GT.0) THEN
                  IF(IN_STRING(I:I).EQ.'#') THEN
                    IFLAG=1
                    IN_STRING(I:I) = ' '
                  ENDIF
                ENDIF
              ELSE
                IN_STRING(I:I) = ' '
              ENDIF
            ENDDO
          ENDIF
C ===        
C         read next line because data block is not open 
          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200
C ===
          IF(IN_STRING(1:1).EQ.';') THEN
C           text variable started with ;
C
C           only first line with information will be accepted
C           set value looks like  '....'
C
            IFLAG=0
            CALL LENSTR_BL(IN_STRING,LEN_IN)
            LN = LEN_IN
            IF(LN.GT.79) LN=79
            LINE(2:LN+1)    = IN_STRING(1:LN)
            LINE(1:1)       = ''''
            LINE(2:2)       = ' '
            LINE(LN+1:LN+1) = ''''
            IF(LEN_IN.GT.1) THEN
C             value (text) is ready
              IFLAG=1
            ENDIF
            DO I=1,32000
C             read next line till second ;
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              CALL LENSTR_BL(IN_STRING,LEN_IN)
              IF(IFLAG.EQ.0) THEN
C               if value is not ready yet
                CALL LENSTR_BL(IN_STRING,LEN_IN)
                IF(LEN_IN.GT.1) THEN
                  LINE = IN_STRING
                  LN   = LEN_IN
                  IF(LN.GT.79) LN=79
                  LINE(2:LN+1) = IN_STRING(1:LN)
                  LINE(1:1)    = ''''
                  IF(LINE(2:2).EQ.';') LINE(2:2) = ' '
                  LINE(LN+1:LN+1) = ''''
                  IFLAG           = 1
C                 value (text) is ready
                ENDIF
              ENDIF
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
            LNN=LN+1
            IF(LNN.GT.2) THEN
              LN    = 0
              IFLAG = 0
              DO I=2,LNN-1
C               replace ' to "
                IF(LINE(I:I).EQ.'''') LINE(I:I)='"'

C               remove forward blancs
                IF(LINE(I:I).EQ.' '.AND.IFLAG.EQ.0) THEN

                ELSE
                  IFLAG       = 1
                  LN          = LN + 1
                  LINE(LN:LN) = LINE(I:I)
                ENDIF

              ENDDO
            ENDIF
            LN          = LN + 1
            LINE(LN:LN) = ''''
            IN_STRING   = LINE(1:LN)
          ENDIF
C ===
          CALL FRD_PARM_INFO
          IF(IFRD_ERR.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' WARNING: CIF_read: number of words > limit')
          ENDIF

          IF(NWORDS.LE.0) GO TO 200
C ==
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX) = IN_STRING
            IEND   = -2
            NWORDS = I_CIF
            RETURN 
C           return comment and come back with IEND=-2
          ENDIF
C ==
          I_CIF = 0
        ENDIF      

        I_CIF = I_CIF + 1

        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
C
C         first or next block data
C
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA    = 0
          N_ITEM    = 0
          LOOP_FLAG = 'N' 
          BLK_FLAG  = 'Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS = 0
            I_CIF  = 0
            N_CIF  = 0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
C
C         block data was started
C       
          IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
C
C         loop
C       
            IF(N_DATA.NE.0) THEN
              CALL MSGERR(MDOC
     *        ,' ERR: CIF_read: number of data > number of items')
              WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *        ITM_CIF(N_DATA)(1:16)
              CALL MSGERR(MDOC,LINE)
            ENDIF
            LOOP_FLAG = 'Y'
            N_DATA    = 0
            N_ITEM    = 0

          ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
C
C           item
C
            IF(LOOP_FLAG.EQ.'N') N_ITEM=0
            IF(N_DATA.NE.0) THEN
              CALL MSGERR(MDOC
     *        ,' ERR: CIF_read: number of data > number of items')
              WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *        ITM_CIF(N_DATA)(1:16)
              CALL MSGERR(MDOC,LINE)
            ENDIF
            N_DATA = 0        
            N_ITEM = N_ITEM+1
            IF(N_ITEM.GT.NWORDSMAX) THEN
              WRITE(LINE,'(
     *        '' ERR: CIF_read: too many items in the loop >'',I5)')
     *        NWORDSMAX
              CALL MSGERR(MDOC,LINE)
            ENDIF
            ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))

          ELSE
C
C           data
C
            IF(N_ITEM.LE.0) THEN
              CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
              CALL MSGERR(MDOC,IN_STRING)
           
            ENDIF
            LOOP_FLAG      = 'N'
            N_DATA         = N_DATA + 1
            N_CIF          = N_DATA
            DT_CIF(N_CIF)  = WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
            IDT_CIF(N_CIF) = IWORDS(I_CIF)
            FDT_CIF(N_CIF) = FWORDS(I_CIF)
            IF(N_DATA.EQ.N_ITEM) THEN
              N_DATA = 0
              RETURN
            ENDIF
          ENDIF

        ELSE
          I_CIF = NWORDS
        ENDIF   

      GO TO 300
C -------------------------
      END

C ******
      SUBROUTINE FRD_PARM_INFO
C -------------------------------------------------------
C -P- FRD_PARM_INFO  - free format reading of the string of characters.
C                      See common /COMFREAD_INFO/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 60
C -S-
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 60 )
      COMMON /COMFREAD_INFO/ 
     *                  FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR = 0
      NWORDS   = 0
      NW       = 0
      IW       = 0
      IS       = 0
      IAP      = 0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS = 1
            NW = NW+1
            IF(NW.GT.NWORDSMAX) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)     = '?'
            LEN_WORDS(NW) = 1
          ELSE
            WORDS(NW)     = STR(1:IW)
            LEN_WORDS(NW) = IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW) = IA
          FWORDS(NW) = FA
          IS         = 0
          IW         = 0
          IAP        = 0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      


C ******
      SUBROUTINE GETCIF_CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_CRD - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA    = 0
        N_CIF     = 0
        N_ITEM    = 0
        I_CIF     = 0
        NWORDS    = 0
        BLK_CIF   = ' '
        BLK_FLAG  = 'N'
        LOOP_FLAG = 'N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_CIF
C -------------------------------------------------------
C -P- FRD_PARM_CIF - free format reading of the string of characters.
C                See common /FREAD_CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE GETCIF_2CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_2CRD - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_2CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF_2CRD/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_2CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_2CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_2CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_2CIF
C -------------------------------------------------------
C -P- FRD_PARM_2CIF - free format reading of the string of characters.
C                     See common /FREAD_2CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_2CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE GETCIF_3CRD(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF_3CRD - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one)
C     item_names and corresponding data, also its data_block_name.
C     Returned information are in common /COMCIF_3CRD/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writting messages to DOC-file /See subr. OPENDOC/
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0.(or -2)
C     output:
C           IEND  = 0 - OK, = 1 - end of file, = -2  commets string
C                                                    DT_CIF (NWORDSMAX)
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF_2CRD/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_3CRD/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /FREAD_3CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF
  300 CONTINUE
        IF(I_CIF.EQ.NWORDS) THEN
  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)

          IF(IERR.NE.0.OR.IEND.NE.0) RETURN

          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200

          IF(IN_STRING(1:1).EQ.';') THEN
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
          ENDIF
          CALL FRD_PARM_3CIF
          IF(NWORDS.LE.0) GO TO 200
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
          I_CIF=0
        ENDIF      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_3CIF
C -------------------------------------------------------
C -P- FRD_PARM_3CIF - free format reading of the string of characters.
C                     See common /FREAD_3CIF/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /FREAD_3CIF/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE FRD_PARM
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

      SUBROUTINE FRD_2PARM
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COM2FREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COM2FREAD/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE GETCIF_C(IUN,MDOC,IERR,IEND)
C -------------------------------------------------------
C -P- GETCIF - reads the records from file and get information from records
C -P-          by CIF_style. 
C     Each call of subroutine returns set of loop (or only one) 
C     item_names and corresponding data, also its data_block_name or
C     comment string.
C     Returned information are in common /COMCIF/
C     
C     input:
C           IUN  - log. unit number.
C           MDOC - mode of writing messages to DOC-file. 
C                   0 - only terminal , < - 0 only file, 0 < < 99 - both
C                   >= 99 - don't write  
C           IEND - for first call must be equal = -1; for others = 0 (or -2)
C
C     output:
C           IEND  = 0  - OK 
C                 = 1  - end of file 
C                 = -2 - OK, comment string was reading, puts comment string
C                            into DT_CIF.
C                                                   
C           IERR  - signal of error. 0 means OK.               
C
C           Returned information are in common /COMCIF/:
C
C           N_CIF     - number of returned data.
C           ITM_CIF() - array of item_name
C           DT_CIF () - array of data as string of characters.
C           FDT_CIF() - array of data as integer.
C           IDT_CIF() - array of data as real.
C           BLK_CIF   - data_block_name.
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMCIF_CRD_C/ N_CIF,I_CIF,FDT_CIF,IDT_CIF
     *               ,N_DATA,N_ITEM
     *               ,DT_CIF,ITM_CIF,BLK_CIF,LOOP_FLAG,BLK_FLAG
      REAL      FDT_CIF(NWORDSMAX)
      INTEGER*4 IDT_CIF(NWORDSMAX)
      INTEGER*4 N_DATA   
      INTEGER*4 N_ITEM  
      INTEGER*4 N_CIF   
      INTEGER*4 I_CIF
      CHARACTER DT_CIF (NWORDSMAX)*80
      CHARACTER ITM_CIF(NWORDSMAX)*80
      CHARACTER BLK_CIF*80
      CHARACTER LOOP_FLAG*1,BLK_FLAG*1
C ---
      COMMON /COMFREAD_C/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR,IEND
C ******
      CHARACTER LINE*80
C --------------------------------------------------------------
      IERR=0
      IF(IEND.EQ.-1) THEN
        N_DATA =0
        N_CIF =0
        N_ITEM =0
        I_CIF  =0
        NWORDS =0
        BLK_CIF=' '
        BLK_FLAG='N'
        LOOP_FLAG='N'
        IEND=0
      ELSE IF(IEND.EQ.-2) THEN
        IEND=0
      ELSE
        IEND=0
        LOOP_FLAG='N'
      ENDIF

  300 CONTINUE

        IF(I_CIF.EQ.NWORDS) THEN

  200     CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)


          IF(IERR.NE.0.OR.IEND.NE.0) RETURN
C ===          
          CALL LENSTR_BL(IN_STRING,LEN_IN)

          IF(LEN_IN.GT.1.AND.IN_STRING(1:1).NE.';'.AND.
     *                       IN_STRING(1:1).NE.'#') THEN
            IFLAG=0
            II=1
            DO I=1,LEN_IN
              IF(IFLAG.EQ.0) THEN
                IF(IN_STRING(I:I).EQ.'''') II=II*(-1)
                IF(II.GT.0) THEN
                  IF(IN_STRING(I:I).EQ.'#') THEN
                    IFLAG=1
                    IN_STRING(I:I)=' '
                  ENDIF
                ENDIF
              ELSE
                IN_STRING(I:I)=' '
              ENDIF
            ENDDO
          ENDIF
C ===        
          IF(IN_STRING(1:5).NE.'data_'.AND.
     *       IN_STRING(1:7).NE.'global_'.AND.BLK_FLAG.EQ.'N') 
     *    GO TO 200
C ===
          IF(IN_STRING(1:1).EQ.';') THEN
            LLN=0
            IFLAG=0
            CALL LENSTR_BL(IN_STRING,LEN_IN)
            LN=LEN_IN
            IF(LN.GT.78) LN=78
            LINE(2:LN+1)=IN_STRING(1:LN)
            LINE(1:1)  =''''
            LINE(2:2)  =' '
            LINE(LN+2:LN+2)=''''
            IF(LEN_IN.GT.1) THEN
              IFLAG=1
              LLN=LN+2
            ENDIF
            DO I=1,32000
              CALL GETLINE(IUN,MDOC,IN_STRING,IERR,IEND)
              IF(IERR.NE.0.OR.IEND.NE.0) RETURN
              CALL LENSTR_BL(IN_STRING,LEN_IN)
              LN=LEN_IN
              IF(LN.GT.78) LN=78
              IF(IFLAG.EQ.0) THEN
                CALL LENSTR_BL(IN_STRING,LEN_IN)
                IF(LEN_IN.GT.1) THEN
c                  LINE=IN_STRING
                  LN=LEN_IN
                  IF(LN.GT.78) LN=78
                  LINE(2:LN+1)=IN_STRING(1:LN)
                  LINE(1:1)  = ''''
                  IF(LINE(2:2).EQ.';') LINE(2:2)  =' '
                  LINE(LN+2:LN+2)= ''''
                  IFLAG=1
                  LLN=LN+2
                ENDIF
              ENDIF
              IF(IN_STRING(1:1).EQ.';') GO TO 100
            ENDDO
  100       CONTINUE
            LNN=LLN
            IF(LNN.GT.2) THEN
              LN=1
              IFLAG=0
              DO I=2,LNN-1
                IF(LINE(I:I).EQ.'''') LINE(I:I)='"'

                IF(LINE(I:I).EQ.' '.AND.IFLAG.EQ.0) THEN

                ELSE
                  IFLAG=1
                  LN=LN+1
                  LINE(LN:LN)=LINE(I:I)
                ENDIF

              ENDDO
              LINE(1:1)    =''''
              LINE(LN+1:LN+1)  =''''
            ELSE
              LN=3
              LINE(1:1)    =''''
              LINE(2:2)    ='.'
              LINE(LN:LN)  =''''
            ENDIF
            IN_STRING=LINE(1:LN)

          ENDIF
C ===
          CALL FRD_PARM_C

          IF(NWORDS.LE.0) GO TO 200
C ==
          IF(WORDS(1) (1:1).EQ.'#') THEN
            DT_CIF(NWORDSMAX)=IN_STRING
            IEND=-2
            NWORDS=I_CIF
            RETURN 
          ENDIF
C ==
          I_CIF=0

        ENDIF
      
        I_CIF=I_CIF+1
        IF((WORDS(I_CIF)(1:5).EQ.'data_'  ).OR. 
     *     (WORDS(I_CIF)(1:7).EQ.'global_')) THEN
          BLK_CIF=WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0
          N_ITEM=0
          LOOP_FLAG='N' 
          BLK_FLAG='Y'
          IF(WORDS(I_CIF)(1:5).EQ.'data_'  ) THEN 
            NWORDS=0
            I_CIF=0
            N_CIF=0
            RETURN
          ENDIF

        ELSE IF(BLK_FLAG.EQ.'Y') THEN
       
        IF(WORDS(I_CIF)(1:5).EQ.'loop_'  ) THEN 
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          LOOP_FLAG='Y'
          N_DATA=0
          N_ITEM=0
        ELSE IF(WORDS(I_CIF)(1:1).EQ.'_'  ) THEN 
          IF(LOOP_FLAG.EQ.'N') N_ITEM=0
          IF(N_DATA.NE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of data > number of items')
            WRITE(LINE,'(''       last items :<'',A,''>'')') 
     *      ITM_CIF(N_DATA)(1:16)
            CALL MSGERR(MDOC,LINE)
          ENDIF
          N_DATA=0        
          N_ITEM=N_ITEM+1
          IF(N_ITEM.GT.NWORDSMAX) THEN
            WRITE(LINE,
     *      '('' ERR: CIF_read: too many items in the loop >'',I5)')
     *      NWORDSMAX
            CALL MSGERR(MDOC,LINE)
          ENDIF
          ITM_CIF(N_ITEM)=WORDS(I_CIF) (1:LEN_WORDS(I_CIF))
        ELSE
          IF(N_ITEM.LE.0) THEN
            CALL MSGERR(MDOC
     *      ,' ERR: CIF_read: number of items =0 / before the data /')
            CALL MSGERR(MDOC,IN_STRING)
           
          ENDIF
          LOOP_FLAG='N'
          N_DATA=N_DATA+1
          N_CIF=N_DATA
          DT_CIF(N_CIF) =WORDS(I_CIF)(1:LEN_WORDS(I_CIF))
          IDT_CIF(N_CIF)=IWORDS(I_CIF)
          FDT_CIF(N_CIF)=FWORDS(I_CIF)
          IF(N_DATA.EQ.N_ITEM) THEN
            N_DATA=0
            RETURN
          ENDIF
        ENDIF

        ELSE
          I_CIF=NWORDS
        ENDIF   

      GO TO 300

      END

C ******
      SUBROUTINE FRD_PARM_C
C -------------------------------------------------------
C -P- FRD_PARM - free format reading of the string of characters.
C                See common /COMFREAD/
C
C     input:     IN_STRING - input string; a word is the part of the string
C                            between two blancs or two "'".
C     output:    NWORDS    - number of words of the string
C                IWORDS    - array of integer value of each word.
C                FWORDS    - array of real value of each word.
C                WORDS     - array of words
C                LEN_WORDS - array of lengths of the words
C                IFRD_ERR  - signal of error. 
C                            0  means OK.
C                            1 - number of words > NWORDSMAX = 40
C -S-
C -----------------------------------------------------------
      PARAMETER ( NWORDSMAX = 40 )
      COMMON /COMFREAD_C/ FWORDS,IFRD_ERR,NWORDS,LEN_WORDS,IWORDS
     *                 ,WORDS,IN_STRING
      REAL      FWORDS   (NWORDSMAX)
      INTEGER*4 LEN_WORDS(NWORDSMAX)
      INTEGER*4 IWORDS   (NWORDSMAX)
      INTEGER*4 NWORDS,IFRD_ERR
      CHARACTER WORDS(NWORDSMAX)*80
      CHARACTER IN_STRING*80
C --------------------------------------------------------------
C ******
      REAL      FA
      INTEGER*4 NW,IS,IW,IAP,LEN,IP,IA
      CHARACTER CH*1,CK*1,STR*80
C --------------------------------------------------------------
      IFRD_ERR=0
      NWORDS=0
      NW=0
      IW=0
      IS=0
      IAP=0
      CALL LENSTR_BL(IN_STRING,LEN)
      IF(LEN.LE.0) RETURN
      IF(LEN.GT.80) LEN=80
C -----------------
      DO   IP=1,LEN
        CH=IN_STRING(IP:IP)
        CALL CHKSMB(CH,CK)
        IF(CK.EQ.'?') CH=' '
        IF(CH.EQ.'''') THEN
          IAP=IAP+1
          IF(IAP.GE.2) IAP=0
        ENDIF
        IF(CH.NE.' '.OR.IAP.EQ.1) THEN
C         start of a word
          IF(IS.EQ.0) THEN
            IS=1
            NW=NW+1
            IF(NW.GT.20) THEN
              IFRD_ERR=1
              RETURN
            ENDIF
          ENDIF
          IF(CH.NE.'''') THEN
            IW=IW+1
            STR(IW:IW)=CH       
          ELSE
            IF(IW.GT.0) THEN
            ENDIF
          ENDIF
        ENDIF
        IF((CH.EQ.' '.AND.IS.EQ.1.AND.IAP.EQ.0).OR.
     *       (IP.EQ.LEN.AND.IW.NE.0)) THEN
          IF(IW.LE.0) THEN
            WORDS(NW)='?'
            LEN_WORDS(NW)=1
          ELSE
            WORDS(NW)=STR(1:IW)
            LEN_WORDS(NW)=IW
          ENDIF
          NWORDS=NW
          CALL WTODIG(STR,IW,FA,IA)
          IWORDS(NW)=IA
          FWORDS(NW)=FA
          IS=0
          IW=0
          IAP=0
        ENDIF
      ENDDO
C -----------------
      RETURN
      END      

C ******
      SUBROUTINE WTODIG(STR,IW,F,I)
C -------------------------------------------------------
C -P- WTODIG - convert string to integer and real.
C              
C              STR  - input string of characters (without blancs).
C              IW   - number of characters in the string.
C              I    - output integer value of string.
C              F    - output real value of string.
C      Subroutine returns I=0 and F=0.0 if it can't convert the string 
C      to the digits.
C      Examples right strings: "+23", "324", "-123", "-1.0", "0.23",
C                              "+2.00", "-1.2E-2", "0.3e+2", "-3E4".
C -------------------------------------------------------
      REAL F
      INTEGER*4 I,IW
      CHARACTER STR*(*)
C ******
C ---
      REAL A,SIGN
      INTEGER*4 IA,INTGR,IPOINT,NP,K,J
      CHARACTER CH*1,NUM(10)*1
      DATA NUM /'0','1','2','3','4','5','6','7','8','9'/
C ---------------------------------
      INTGR=0
      SIGN=1.0
      IPOINT=0
      NP=0
      F=0.0
      I=0
      A=0.0
      IA=0
      IE=0
      IF(IW.GT.16) RETURN
C --------------------------------
      DO   J=1,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 100
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.1) THEN
          IF(CH.EQ.'-') SIGN=-1.0
          GO TO 200
        ENDIF
        IF(CH.EQ.'.'.AND.IPOINT.EQ.0) THEN
          IPOINT=1
          GO TO 200
        ENDIF
        IF(CH.EQ.'e'.OR.CH.EQ.'E') THEN
          IF(A.EQ.0.0) RETURN
          IE=1
          GO TO 300
        ENDIF
        RETURN
  100   CONTINUE
        K=K-1
        IF(IPOINT.EQ.1) NP=NP+1
        A=A*10.0+K
        IF(IPOINT.EQ.0) IA=IA*10+K
 200    CONTINUE
      ENDDO
 300  F=SIGN*A/10.0**NP
      I=IA
      IF(SIGN.LT.0.0) I=-I
C --- 
      J=J+1
      IF(IE.EQ.0.OR.J.GT.IW) RETURN
      I=0
      IA=0
      A=F
      F=0.0
      ISIGN=1
C --------------------------------
      JJ=J
      DO   J=JJ,IW
        CH=STR(J:J)
        DO    K=1,10
          IF(CH.EQ.NUM(K)) GO TO 400
        ENDDO  
        IF((CH.EQ.'-'.OR.CH.EQ.'+').AND.J.EQ.JJ) THEN
          IF(CH.EQ.'-') ISIGN=-1
          GO TO 500
        ENDIF
        RETURN
  400   CONTINUE
        K=K-1
        IA=IA*10+K
  500   CONTINUE
      ENDDO
      IF(IA.GT.31) IA=31
      IF(ISIGN.LT.0) IA=-IA
      F= A * 10.0**IA
C ---------------------------------
      RETURN
      END

C ******
      SUBROUTINE CLEAR_STR(STR)
C
C -P- CLEAR_STR - put blancs to the string.
C ******
C -------
      CHARACTER STR*(*)
      INTEGER*4 NL
C -------------------------------------------
      NL=LEN(STR)
      IF(NL.LE.0) THEN
        STR=' '
        NL=1
      ELSE
        DO I=1,NL
          STR(I:I)=' '
        ENDDO
      ENDIF
      RETURN
      END

      SUBROUTINE CLEAR_LINE(LINE)
C
      CHARACTER LINE*(*)
C ******
      INTEGER*4 L
C -------------------------------------------------------------
      CALL LENSTR_BL(LINE,L)
      IF(L.GT.0) THEN
        DO I=L,1,-1
          IF(LINE(I:I).EQ.',') THEN
            LINE(I:I)=' '
          ELSE
            IF(LINE(I:I).NE.' ') GO TO 100
          ENDIF 
        ENDDO
 100    CONTINUE
      ENDIF
      RETURN
      END

C ******
      SUBROUTINE WRTSTR(IUN,MDOC,LINE,IERR)
C -------------------------------------------------------
C -P- WRTSTR - writes a string to file. /max 80 chars/
C -------------------------------------------------------
      INTEGER*4 MDOC,IUN,IERR
      CHARACTER LINE*(*)
C ******
C ----------------------------------
      IERR=0
      IF(IUN.LE.0) RETURN
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LE.0) RETURN
      WRITE(IUN,'(A)',ERR=100) LINE(1:LEN)
      IF(LEN.GT.80) LEN=80
      CALL MSGDOC(MDOC,LINE(1:LEN))
      RETURN
  100 CONTINUE
      IERR=1
      RETURN
      END      

C 
      SUBROUTINE FREDA(LINE,IMIN,IMAX,NCHAR,KN,KL,FN,FL)
      CHARACTER   LINE*80
C ----
      CHARACTER   FL(6)*40
      REAL        FN(40)
C 
C ----
      INTEGER NUM(10)
      CHARACTER INUM(10)*1,ICH*1
      DATA  NCHLIM/6/
      DATA  NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA  INUM/'1','2','3','4','5','6','7','8','9','0'/
C -----------------------------------------------------------
      IF(NCHAR.GT.NCHLIM) NCHAR=NCHLIM
      DO     KN=1,40
        FN(KN)=0.0
        IF(NCHAR.GT.0) THEN
          DO     KL=1,NCHAR
            FL(KL)=' '
          ENDDO
        ENDIF
      ENDDO
C ------
      KN=0
      KL=0
      I=IMIN-1
C
C ---- START OF A NEW FIELD
C ---- LOOK FOR A NON-BLANK COLUMN
C
  109 A =0.0
      IP=0
      NP=0
      L=0
      S=1.0
  110 I=I+1
      IF(I.GT.IMAX)  GO TO 108
  111   ICH=LINE(I:I)
        IF(L.EQ.0  .AND.  ICH.EQ.' ')  GO TO 110
C ----  START OF A FIELD
        L=L+1
        DO 100 J=1,10
        IF(ICH.EQ.INUM(J)) GO TO 101
  100   CONTINUE
        IF(ICH.EQ.'.')  GO TO 102
        IF(ICH.EQ.'+')  GO TO 103
        IF(ICH.EQ.'-')  GO TO 104
        IF(L.GT.1)  GO TO 105
        GO TO 150
C ---- START OF A LITERAL FIELD BY A CHARACTER WHICH IS OTHER THAN 0-9+-.
C
C ---- NUMERIC FIELD FOUND
C
  101   IF(J.EQ.10)  J=0
        IF(IP.EQ.1)  NP=NP+1
  106   A=10.0*A + J
        GO TO 110
  102   IP=1
        GO TO 110
  103   IF(L.GT.1)  GO TO 105
        S=1.0
        GO TO 110
  104   IF(L.GT.1)  GO TO 105
        S=-1.0
        GO TO 110

  108   IF(L.GT.0)  GO TO 105
        GO TO 120

C ----  END OF NUMERIC FIELD
  105   A = S*A/10.0**NP
        KN=KN+1
        FN(KN)=A
        IF(ICH.EQ.'+' .OR. ICH.EQ.'-')   I=I-1
        GO TO 109
C
C --- LITERAL FIELD
C
  150  KL=KL+1
  151  FL(L)(KL:KL) = ICH
       L=L+1
       IF(L.GT.NCHAR)  GO TO 109
       I=I+1
       IF(I.GT.IMAX)  GO TO 152
       ICH=LINE(I:I)
       IF(ICH.EQ.' ')  GO TO 152
       GO TO 151
C ---- END OF LITERAL FIELD DEFINED BY BLANK
  152  DO 153 J=L,NCHAR
  153  FL(J)(KL:KL) = ' '
       GO TO 109
C
C    FINISHED
C
  120 RETURN
      END

C 
      SUBROUTINE ABSFR2(MDOC,LINE,NA,NABS,JABS,IPRABS,IERR)
C
C            MDOC  - mode of writting messages to DOC-file
C                       0 - only term, < - 0 only file, 0 < < 99 - both
C                       =< 99 - not write  
C            NABS  - condition of absence number
C            JABS  - conditions of absences
C                    type indices:
C     h**2*JABS(1)+k**2*JABS(2)+l**2*JABS(3)+
C      +(h*JABS(4)+k*ABS(5)+l*JABS(6))**2 +JABS(7)=0
C                    condition   :
C    MOD [ h*JABS(8)+k*ABS(9)+l*JABS(10)+JABS(11) , JABS(12) ] = JABS(13)
C
      INTEGER*2 JABS(13,IPRABS)
      INTEGER   NABS,NA
      CHARACTER LINE*80,STR*80
C 
      REAL      RABS(13)
      INTEGER   NUM(10),JIND(13)
      CHARACTER INUM(10)*1,ICH*1
      DATA NUM / 1,  2,  3,  4,  5,  6,  7,  8,  9,  0 /
      DATA INUM/'1','2','3','4','5','6','7','8','9','0'/
C ---------------------------------------------------------------
      IERR=0
      I1=1
      IF(LINE(1:1).EQ.'A') I1=6
      IMAX=80
      I=I1-1
      DO     J=1,13
        JABS(J,NA)=0.
        JIND(J)=0
        RABS(J)=0.0
      ENDDO
      S=1.0
      T=0.0
      IP=0
      NP=0
      ISL=0
      IFOUND=0
      JJ=0
      J=0
  100 I=I+1
      IF(I.GT.IMAX)      GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')  GO TO 100
      IF(IFOUND.GT.0)    GO TO 109
      IF(ICH.EQ.','.OR.ICH.EQ.':') THEN
        JJ=JJ+1
        IF(JJ.GT.3) GO TO 108
        JIND(JJ)=J
        IF(T.NE.0.0) S=T
        RABS(JJ) = S*S
        IF(J.EQ.0) THEN
          JABS(JJ,NA)=1
        ELSE
          JABS(JJ,NA)=0
          IF(JJ.GT.1) THEN
            DO     L=1,JJ-1
              IF(JIND(L).EQ.JIND(JJ)) THEN
                JABS(L ,NA)= 0
                JABS(JJ,NA)= 0
                JABS(L+3 ,NA)= 1
                JABS(JJ+3,NA)=-1
                IF(RABS(L) .NE.0.0) JABS(L +3,NA)= RABS(L)
                IF(RABS(JJ).NE.0.0) JABS(JJ+3,NA)=-RABS(JJ)
              ENDIF
            ENDDO
          ENDIF
        ENDIF
 108    IF(ICH.EQ.':') GO TO 109
        IF(JJ.GT.3)    IFOUND=1
        S=1.0
        T=0.0
        J=0
        IP=0
        NP=0
        ISL=0
        GO TO 100
      ENDIF

      IF(ICH.EQ.'H') THEN
        J  =1
        GO TO 100
      ENDIF
      IF(ICH.EQ.'K') THEN
        J  =2
        GO TO 100
      ENDIF
      IF(ICH.EQ.'L') THEN
        J  =3
        GO TO 100
      ENDIF
      IF(ICH.EQ.'+') THEN
        S  = 1.0
        GO TO 100
      ENDIF
      IF(ICH.EQ.'-') THEN
        S  =-1.0
        GO TO 100
      ENDIF
      IF(ICH.EQ.'/') THEN
        ISL=1
        GO TO 100
      ENDIF
      IF(ICH.EQ.'.') THEN
        IP =1
        GO TO 100
      ENDIF

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 102
      ENDDO

      WRITE(STR,9101) ICH
 9101 FORMAT(' ERR: INVALID CHARACTER...',A1)
      CALL MSGERR(MDOC,STR)
      IERR=1
      GO TO 100

  102 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 103
      IF(IP .EQ.1)  GO TO 104
      T = A*S
      GO TO 100

  103 T = T/A
      GO TO 100
  104 NP=NP+1
      T = T + A/10**NP
      GO TO 100
C -------- AFTER : ------------------------
  109 CONTINUE
      JJ=7
      IF1=0
      S=1.0
      T=0.0
      IP=0
      NP=0
      ISL=0
  200 I=I+1
      J=0
      IF(I.GT.IMAX)      GO TO 110
      ICH =LINE(I:I)
      IF(ICH.EQ.' ')  GO TO 200
      IF(ICH.EQ.'=') THEN
C       IF(T.NE.0) S=T
C       JABS(11,NA)=S
        IF1=IF1+1
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'N') THEN
        IF(T.NE.0) S=T
        JABS(12,NA)=S
        ITEMP=S
        IF1=IF1+1
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF

      IF(ICH.EQ.'H') THEN
        J  =1
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'K') THEN
        J  =2
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'L') THEN
        J  =3
        IF(T.NE.0) S=T
        JABS(JJ+J,NA)=S
        T=0.0
        S=1.0
        IP=0
        NP=0
        ISL=0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'+') THEN
        S  = 1.0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'-') THEN
        S  =-1.0
        GO TO 200
      ENDIF
      IF(ICH.EQ.'/') THEN
        ISL=1
        GO TO 200
      ENDIF
      IF(ICH.EQ.'.') THEN
        IP =1
        GO TO 200
      ENDIF

      DO     K=1,10
        IF(ICH.EQ.INUM(K))  GO TO 202
      ENDDO

      WRITE(STR,9101) ICH
      IERR=1
      CALL MSGERR(MDOC,STR)
      GO TO 200

  202 A = NUM(K)
      IF(ISL.EQ.1)  GO TO 203
      IF(IP .EQ.1)  GO TO 204
      T = A*S
      GO TO 200

  203 T = T/A
      GO TO 200
  204 NP=NP+1
      T = T + A/10**NP
      GO TO 200
C --------------------
  110 IF(T.NE.0) THEN
        IF(T.LT.0.0) T=ITEMP+T
        JABS(13,NA) = T
      ENDIF

      IF(IF1.NE.2) THEN
        CALL MSGERR(MDOC,' ERR: WRONG OPERATOR FIELD')
        IERR=1
      ENDIF
      NABS=NA
      RETURN
      END

      SUBROUTINE EXITB 
C      CALL EXIT
      RETURN
      END


      SUBROUTINE SMI (AM,NV,ISING,MA,IAM)   
CMS      : MA,AM
      DIMENSION MA(*),AM(*)
C     CHARACTER LINE*80
C --------------------------------------------------
      MDOC=0
      NV1=NV+1
      LOE=(NV*(NV+1))/2  
      DO   LO=1,LOE      
        LVE=LOE+1-LO       
        LVR=LVE+NV1        
        AM(LVR)=AM(LVE)    
      ENDDO
      ISING=0 
      JD=NV   
      NN=NV-1 
      IX=2
C---- START LOOP.         
      DO   I=1,NN     
        JJ=IX+JD
        JI=JJ   
C       END LOOP THROUGH NA ATOMS    
        BIG=0.0 
        MA(IX)=I
        JK=JD   
C----   FIND THE PIVOTAL ELEMENT.          
        DO      J=I,NV     
          IF((ABS(AM(JJ))-BIG).GT.0.0) THEN      
C----       A LARGER DIAGONAL ELEMENT HAS BEEN FOUND.         
            BIG=ABS(AM(JJ))    
            MA(IX)=J
          ENDIF
          JJ=JJ+JK
          JK=JK-1
        ENDDO
C----   CHECK FOR A ZERO DIAGONAL ELEMENT. 
        IF(BIG.EQ.0.0) GO TO 9000 
C----   IS AN INTERCHANGE NECESSARY.       
        IF((MA(IX)-I).GT.0.0) THEN           
          JK = MA(IX)        
          CALL SMI053 (JI,JK,JD,I,NV,AM,IAM)
C----     IINVERT THE I-TH DIAGONAL.         
        ENDIF
        AM(JI)=1.0/AM(JI)  
C----   INCREMENT THE IX POINTER FOR THE FIRST ELEMENT OF THE Q-ARRAY.   
        IX=IX+1 
C----   SET UPPER LIMIT FOR THE Q-ARRAY GENERATION LOOP.  
        MQ=JI-1 
C----   KEEP TRACK OF THE PIVOT ELEMENT.   
        JK=JI   
C----   CALCULATE THE UNIQUE ELEMENTS OF THE CONGRUENT MATRIX Q(I).      
        DO     J=IX,MQ    
          JI=JI+1 
          AM(J)=-AM(JK)*AM(JI)   
        ENDDO
C----   SET THE LIMITS FOR THE I-TH ROW (NEGLECTING THE PIVOT).          
        N=JK+1  
        M=JI
C----   MULTIPLY MATRICES A AND Q.         
        DO      J=N,M      
          DO      K=IX,MQ    
C----       STEP THE JI POINTER THROUGH THE REST OF THE MATRIX.   
            JI=JI+1 
            AM(JI)=AM(JI)+AM(K)*AM(J)         
          ENDDO
          IX=IX+1 
        ENDDO
        
C----   THE NEXT ROW WILL BE ONE ELEMENT SHORTER.         
        JD=JD-1 
C----   ADJUST IX SO THAT IT POINTS TO THE ELEMENT RIGHT OF THE I-TH PIVOT
        IX=IX+1 
      ENDDO
C---- END OF THE DIAGONALIZING LOOP.     
C         
C----INVERT THE LAST DIAGONAL ELEMENT, IF NON-ZERO.    
      IF(AM(JI).EQ.0.0) GO TO 9000          
      AM(JI)=1.0/AM(JI)  
C----RESTORE THE MATRIX. 
      N=4 
      M=IX
      JJ=MQ   
      I=NV
      DO   JD=2,NV    
        I=I-1   
C----   ZERO OUT THE UNNEEDED PORTION OF THE Q-ARRAY.     
        DO     J=M,IX     
          AM(J)=0.0          
        ENDDO
C----   POSITION RESTORATION POINTERS.     
        MN=IX   
        JI=M-1  
C----   RESTORATION NEST.   
        DO      K=JJ,MQ    
          JK=MN+1 
          DO      J=K,MQ     
            MN=MN+1 
            AM(M)=AM(M)+AM(J)*AM(MN)          
          ENDDO
          AM(JI)=AM(JI)+AM(K)*AM(M)         
C----     ARE WE AT THE END OF THE ROW...    
          IF((K-MQ).EQ.0) GO TO 250  
C----     NO,CALCULATE THE ADDITIONAL ELEMENTS.  
          M=M+1   
          MN=JK   
          DO      J=M,IX     
            MN=MN+1 
            AM(J) = AM(J)+AM(K)*AM(MN)        
          ENDDO
        ENDDO
C----   SET POINTERS FOR NEXT CYCLE.       
 250    M=JJ-1  
        IX=MQ   
        JJ=JJ-N 
        N=N+1   
        MQ=M-2  
C ----  IS INTERCHANGE NECESSARY...        
        IF((MA(M)-I).GT.0) THEN 
          JK = MA(M)         
          CALL SMI053 (JI,JK,JD,I,NV,AM,IAM)
        ENDIF
      ENDDO
C ----  RUECKSPEICHERN DER MATRIX  
      DO   LO=1,LOE      
        LVE=LO+NV1         
        AM(LO)=AM(LVE)     
      ENDDO
C      WRITE(LINE,271) IX,LOE
C  271 FORMAT(' ERR: K IX,LVER :',2I10)
C      CALL MSGERR(MDOC,LINE)
      RETURN  
 9000 ISING=1 
      RETURN         
      END 

      SUBROUTINE SMI053 (JI,JK,JD,I,NV,AM,IAM)         
C
C      SUBROUTINE INTCH(JI,JK,JD)        
C      120 variables, 45 atoms, 560 parameters version of nov. 1967.   
C ---- a routine interchange 2 matrix columns.        
C ---- first the i row is interchanged with the j column until j elements 
C      have been switched.  then the remainder of the i row is         
C      interchanged with the remainder of the j row.    
C ---- ji represents the index of diagonal i of matrix am.   
C ---- jd is the decrement needed to get from the first to the second   
C      element in column (i+1).          
C ---- matrix inversion block. 
C
CMS      : AM
      DIMENSION AM(*)  
C -----------------------------------------------
      IDEL=JK-I          
      IJ=JI-1 
      JY=JI+IDEL         
      JM=JY-JD
      JS=JD   
      DO   J=I,NV      
        IJ=IJ+1 
        IF((J-JK).LE.0) THEN 
          JM=JM+JS
          JS=JS-1 
        ELSE
          JM=JM+1 
        ENDIF
        HOLD=AM(IJ)        
        AM(IJ)=AM(JM)      
        AM(JM)=HOLD        
      ENDDO
      HOLD=AM(JI)        
      AM(JI)=AM(JY)      
      AM(JY)=HOLD        
      RETURN  
      END 

      SUBROUTINE SBTOP(P,SC,TO,SF,AI,XYZ,BETA,ITF,NA,NQ,NP)
C
C     copy parameters from arrays used by subroutines to array P      
C
      DIMENSION P(168),SC(2),SF(15),AI(15),XYZ(3,15),BETA(6,15)       
C ----------------------------------------
      I=1 
      DO     J=1,NQ       
        P(I)=SC(J)      
        I=I+1
      ENDDO
      P(I)=TO 
      I=I+1   
      DO     J=1,NA      
        P(I)=SF(J)      
        P(I+1)=AI(J)    
        I=I+2
        DO     K=1,3    
          P(I)=XYZ(K,J)
          I=I+1        
        ENDDO
        IF(ITF.LE.1) THEN
          P(I)=BETA(1,J)   
          I=I+1        
        ELSE
          DO     K=1,6 
            P(I)=BETA(K,J)
            I=I+1     
          ENDDO
        ENDIF
      ENDDO
      RETURN
      END  


      SUBROUTINE PTOSB(P,SC,TO,SF,AI,XYZ,BETA,ITF,NA,NQ,NP)
C
C     copy parameters from array P to arrays used by subroutines      
C
      DIMENSION P(168),SC(2),SF(15),AI(15),XYZ(3,15),BETA(6,15)       
C -------------------------------------------------------------
      I=1 
      DO     J=1,NQ       
        SC(J)=P(I)      
        I=I+1
      ENDDO
      TO=P(I) 
      I=I+1   
      DO     J=1,NA      
        SF(J)=P(I)      
        IF(P(I+1).LE.0) P(I+1)=0          
        AI(J)=P(I+1)    
        I=I+2
        DO     K=1,3    
          XYZ(K,J)=P(I)
          I=I+1        
        ENDDO
        IF(ITF.LE.1) THEN
          BETA(1,J)=P(I)   
          I=I+1        
        ELSE
          DO     K=1,6 
            BETA(K,J)=P(I)
            I=I+1     
          ENDDO
        ENDIF
      ENDDO
      RETURN  
      END 


C ******
      SUBROUTINE GET_SFA(ASYMB
     *      ,N,NEL,A1,A2,A3,A4,B1,B2,B3,B4,C,FI,FII,RAD,IERR)
C -----------------------------------------------
C -P- GET_SFA - gets atomic scatt.factor coefficients for atomic type.
C -S-
      REAL      A1,A2,A3,A4,B1,B2,B3,B4,C,FI,FII,RAD
      INTEGER*4 N,NEL,IERR
      CHARACTER ASYMB*4
C ******
C ---
      REAL      TSF_A1(94),TSF_A2(94),TSF_A3 (94),TSF_A4 (94)
      REAL      TSF_B1(94),TSF_B2(94),TSF_B3 (94),TSF_B4 (94)
      REAL      TSF_C (94),TSF_FI(94),TSF_FII(94),TSF_RAD(94)
      INTEGER*4 TSF_N,TSF_NE(94)
      CHARACTER TSF_ATOM(94)*4
C ---
      DATA TSF_N /94/
      DATA TSF_ATOM( 1)/'H   '/,TSF_NE( 1)/ 1/,TSF_RAD( 1)/1.50/
     * ,TSF_A1( 1)/  0.49300/,TSF_B1( 1)/ 10.51091/
     * ,TSF_A2( 1)/  0.32291/,TSF_B2( 1)/ 26.12573/
     * ,TSF_A3( 1)/  0.14019/,TSF_B3( 1)/  3.14236/
     * ,TSF_A4( 1)/  0.04081/,TSF_B4( 1)/ 57.79977/
     * ,TSF_C ( 1)/  0.00304/
     * ,TSF_FI( 1)/  0.00000/,TSF_FII( 1)/  0.00000/
      DATA TSF_ATOM( 2)/'HE  '/,TSF_NE( 2)/ 2/,TSF_RAD( 2)/1.50/
     * ,TSF_A1( 2)/  0.87340/,TSF_B1( 2)/  9.10371/
     * ,TSF_A2( 2)/  0.63090/,TSF_B2( 2)/  3.35680/
     * ,TSF_A3( 2)/  0.31120/,TSF_B3( 2)/ 22.92763/
     * ,TSF_A4( 2)/  0.17800/,TSF_B4( 2)/  0.98210/
     * ,TSF_C ( 2)/  0.00640/
     * ,TSF_FI( 2)/  0.00000/,TSF_FII( 2)/  0.00000/
      DATA TSF_ATOM( 3)/'LI  '/,TSF_NE( 3)/ 3/,TSF_RAD( 3)/1.50/
     * ,TSF_A1( 3)/  1.12820/,TSF_B1( 3)/  3.95460/
     * ,TSF_A2( 3)/  0.75080/,TSF_B2( 3)/  1.05240/
     * ,TSF_A3( 3)/  0.61750/,TSF_B3( 3)/ 85.39058/
     * ,TSF_A4( 3)/  0.46530/,TSF_B4( 3)/168.26120/
     * ,TSF_C ( 3)/  0.03770/
     * ,TSF_FI( 3)/  0.00080/,TSF_FII( 3)/  0.00030/
      DATA TSF_ATOM( 4)/'BE  '/,TSF_NE( 4)/ 4/,TSF_RAD( 4)/1.50/
     * ,TSF_A1( 4)/  1.59190/,TSF_B1( 4)/ 43.64275/
     * ,TSF_A2( 4)/  1.12780/,TSF_B2( 4)/  1.86230/
     * ,TSF_A3( 4)/  0.53910/,TSF_B3( 4)/103.48310/
     * ,TSF_A4( 4)/  0.70290/,TSF_B4( 4)/  0.54200/
     * ,TSF_C ( 4)/  0.03850/
     * ,TSF_FI( 4)/  0.00380/,TSF_FII( 4)/  0.00140/
      DATA TSF_ATOM( 5)/'B   '/,TSF_NE( 5)/ 5/,TSF_RAD( 5)/1.50/
     * ,TSF_A1( 5)/  2.05450/,TSF_B1( 5)/ 23.21852/
     * ,TSF_A2( 5)/  1.33260/,TSF_B2( 5)/  1.02100/
     * ,TSF_A3( 5)/  1.09790/,TSF_B3( 5)/ 60.34987/
     * ,TSF_A4( 5)/  0.70680/,TSF_B4( 5)/  0.14030/
     * ,TSF_C ( 5)/ -0.19320/
     * ,TSF_FI( 5)/  0.00900/,TSF_FII( 5)/  0.00390/
      DATA TSF_ATOM( 6)/'C   '/,TSF_NE( 6)/ 6/,TSF_RAD( 6)/1.90/
     * ,TSF_A1( 6)/  2.31000/,TSF_B1( 6)/ 20.84392/
     * ,TSF_A2( 6)/  1.02000/,TSF_B2( 6)/ 10.20751/
     * ,TSF_A3( 6)/  1.58860/,TSF_B3( 6)/  0.56870/
     * ,TSF_A4( 6)/  0.86500/,TSF_B4( 6)/ 51.65125/
     * ,TSF_C ( 6)/  0.21560/
     * ,TSF_FI( 6)/  0.01810/,TSF_FII( 6)/  0.00910/
      DATA TSF_ATOM( 7)/'N   '/,TSF_NE( 7)/ 7/,TSF_RAD( 7)/1.70/
     * ,TSF_A1( 7)/ 12.21261/,TSF_B1( 7)/  0.00570/
     * ,TSF_A2( 7)/  3.13220/,TSF_B2( 7)/  9.89331/
     * ,TSF_A3( 7)/  2.01250/,TSF_B3( 7)/ 28.99754/
     * ,TSF_A4( 7)/  1.16630/,TSF_B4( 7)/  0.58260/
     * ,TSF_C ( 7)/-11.52901/
     * ,TSF_FI( 7)/  0.03110/,TSF_FII( 7)/  0.01800/
      DATA TSF_ATOM( 8)/'O   '/,TSF_NE( 8)/ 8/,TSF_RAD( 8)/1.40/
     * ,TSF_A1( 8)/  3.04850/,TSF_B1( 8)/ 13.27711/
     * ,TSF_A2( 8)/  2.28680/,TSF_B2( 8)/  5.70111/
     * ,TSF_A3( 8)/  1.54630/,TSF_B3( 8)/  0.32390/
     * ,TSF_A4( 8)/  0.86700/,TSF_B4( 8)/ 32.90894/
     * ,TSF_C ( 8)/  0.25080/
     * ,TSF_FI( 8)/  0.04920/,TSF_FII( 8)/  0.03220/
      DATA TSF_ATOM( 9)/'F   '/,TSF_NE( 9)/ 9/,TSF_RAD( 9)/1.50/
     * ,TSF_A1( 9)/  3.53920/,TSF_B1( 9)/ 10.28251/
     * ,TSF_A2( 9)/  2.64120/,TSF_B2( 9)/  4.29440/
     * ,TSF_A3( 9)/  1.51700/,TSF_B3( 9)/  0.26150/
     * ,TSF_A4( 9)/  1.02430/,TSF_B4( 9)/ 26.14763/
     * ,TSF_C ( 9)/  0.27760/
     * ,TSF_FI( 9)/  0.07270/,TSF_FII( 9)/  0.05340/
      DATA TSF_ATOM(10)/'NE  '/,TSF_NE( 10)/10/,TSF_RAD(10)/1.50/
     * ,TSF_A1(10)/  3.95530/,TSF_B1(10)/  8.40421/
     * ,TSF_A2(10)/  3.11250/,TSF_B2(10)/  3.42620/
     * ,TSF_A3(10)/  1.45460/,TSF_B3(10)/  0.23060/
     * ,TSF_A4(10)/  1.12510/,TSF_B4(10)/ 21.71841/
     * ,TSF_C (10)/  0.35150/
     * ,TSF_FI(10)/  0.10190/,TSF_FII(10)/  0.08330/
      DATA TSF_ATOM(11)/'NA  '/,TSF_NE(11)/11/,TSF_RAD(11)/1.50/
     * ,TSF_A1(11)/  4.76260/,TSF_B1(11)/  3.28500/
     * ,TSF_A2(11)/  3.17360/,TSF_B2(11)/  8.84221/
     * ,TSF_A3(11)/  1.26740/,TSF_B3(11)/  0.31360/
     * ,TSF_A4(11)/  1.11280/,TSF_B4(11)/129.42410/
     * ,TSF_C (11)/  0.67600/
     * ,TSF_FI(11)/  0.13530/,TSF_FII(11)/  0.12390/
      DATA TSF_ATOM(12)/'MG  '/,TSF_NE(12)/12/,TSF_RAD(12)/1.50/
     * ,TSF_A1(12)/  5.42041/,TSF_B1(12)/  2.82750/
     * ,TSF_A2(12)/  2.17350/,TSF_B2(12)/ 79.26118/
     * ,TSF_A3(12)/  1.22690/,TSF_B3(12)/  0.38080/
     * ,TSF_A4(12)/  2.30730/,TSF_B4(12)/  7.19371/
     * ,TSF_C (12)/  0.85840/
     * ,TSF_FI(12)/  0.17190/,TSF_FII(12)/  0.17710/
      DATA TSF_ATOM(13)/'AL  '/,TSF_NE(13)/13/,TSF_RAD(13)/1.50/
     * ,TSF_A1(13)/  6.42021/,TSF_B1(13)/  3.03870/
     * ,TSF_A2(13)/  1.90020/,TSF_B2(13)/  0.74260/
     * ,TSF_A3(13)/  1.59360/,TSF_B3(13)/ 31.54724/
     * ,TSF_A4(13)/  1.96460/,TSF_B4(13)/ 85.08868/
     * ,TSF_C (13)/  1.11510/
     * ,TSF_FI(13)/  0.21300/,TSF_FII(13)/  0.24550/
      DATA TSF_ATOM(14)/'SI  '/,TSF_NE(14)/14/,TSF_RAD(14)/1.50/
     * ,TSF_A1(14)/  6.29151/,TSF_B1(14)/  2.43860/
     * ,TSF_A2(14)/  3.03530/,TSF_B2(14)/ 32.33374/
     * ,TSF_A3(14)/  1.98910/,TSF_B3(14)/  0.67850/
     * ,TSF_A4(14)/  1.54100/,TSF_B4(14)/ 81.69379/
     * ,TSF_C (14)/  1.14070/
     * ,TSF_FI(14)/  0.25410/,TSF_FII(14)/  0.33020/
      DATA TSF_ATOM(15)/'P   '/,TSF_NE(15)/15/,TSF_RAD(15)/1.80/
     * ,TSF_A1(15)/  6.43451/,TSF_B1(15)/  1.90670/
     * ,TSF_A2(15)/  4.17910/,TSF_B2(15)/ 27.15704/
     * ,TSF_A3(15)/  1.78000/,TSF_B3(15)/  0.52600/
     * ,TSF_A4(15)/  1.49080/,TSF_B4(15)/ 68.16457/
     * ,TSF_C (15)/  1.11490/
     * ,TSF_FI(15)/  0.29550/,TSF_FII(15)/  0.43350/
      DATA TSF_ATOM(16)/'S   '/,TSF_NE(16)/16/,TSF_RAD(16)/1.80/
     * ,TSF_A1(16)/  6.90531/,TSF_B1(16)/  1.46790/
     * ,TSF_A2(16)/  5.20341/,TSF_B2(16)/ 22.21512/
     * ,TSF_A3(16)/  1.43790/,TSF_B3(16)/  0.25360/
     * ,TSF_A4(16)/  1.58630/,TSF_B4(16)/ 56.17207/
     * ,TSF_C (16)/  0.86690/
     * ,TSF_FI(16)/  0.33310/,TSF_FII(16)/  0.55670/
      DATA TSF_ATOM(17)/'CL  '/,TSF_NE(17)/17/,TSF_RAD(17)/1.50/
     * ,TSF_A1(17)/ 11.46041/,TSF_B1(17)/  0.01040/
     * ,TSF_A2(17)/  7.19641/,TSF_B2(17)/  1.16620/
     * ,TSF_A3(17)/  6.25561/,TSF_B3(17)/ 18.51942/
     * ,TSF_A4(17)/  1.64550/,TSF_B4(17)/ 47.77846/
     * ,TSF_C (17)/ -9.55741/
     * ,TSF_FI(17)/  0.36390/,TSF_FII(17)/  0.70180/
      DATA TSF_ATOM(18)/'AR  '/,TSF_NE(18)/18/,TSF_RAD(18)/1.50/
     * ,TSF_A1(18)/  7.48451/,TSF_B1(18)/  0.90720/
     * ,TSF_A2(18)/  6.77231/,TSF_B2(18)/ 14.84071/
     * ,TSF_A3(18)/  0.65390/,TSF_B3(18)/ 43.89835/
     * ,TSF_A4(18)/  1.64420/,TSF_B4(18)/ 33.39293/
     * ,TSF_C (18)/  1.44450/
     * ,TSF_FI(18)/  0.38430/,TSF_FII(18)/  0.87170/
      DATA TSF_ATOM(19)/'K   '/,TSF_NE(19)/19/,TSF_RAD(19)/1.50/
     * ,TSF_A1(19)/  8.21861/,TSF_B1(19)/ 12.79491/
     * ,TSF_A2(19)/  7.43981/,TSF_B2(19)/  0.77480/
     * ,TSF_A3(19)/  1.05190/,TSF_B3(19)/213.18719/
     * ,TSF_A4(19)/  0.86590/,TSF_B4(19)/ 41.68416/
     * ,TSF_C (19)/  1.42280/
     * ,TSF_FI(19)/  0.38680/,TSF_FII(19)/  1.06570/
      DATA TSF_ATOM(20)/'CA  '/,TSF_NE(20)/20/,TSF_RAD(20)/1.50/
     * ,TSF_A1(20)/  8.62661/,TSF_B1(20)/ 10.44211/
     * ,TSF_A2(20)/  7.38731/,TSF_B2(20)/  0.65990/
     * ,TSF_A3(20)/  1.58990/,TSF_B3(20)/ 85.74849/
     * ,TSF_A4(20)/  1.02110/,TSF_B4(20)/178.43719/
     * ,TSF_C (20)/  1.37510/
     * ,TSF_FI(20)/  0.36410/,TSF_FII(20)/  1.28550/
      DATA TSF_ATOM(21)/'SC  '/,TSF_NE(21)/21/,TSF_RAD(21)/1.50/
     * ,TSF_A1(21)/  9.18901/,TSF_B1(21)/  9.02131/
     * ,TSF_A2(21)/  7.36791/,TSF_B2(21)/  0.57290/
     * ,TSF_A3(21)/  1.64090/,TSF_B3(21)/136.10809/
     * ,TSF_A4(21)/  1.46800/,TSF_B4(21)/ 51.35315/
     * ,TSF_C (21)/  1.33290/
     * ,TSF_FI(21)/  0.31190/,TSF_FII(21)/  1.53310/
      DATA TSF_ATOM(22)/'TI  '/,TSF_NE(22)/22/,TSF_RAD(22)/1.50/
     * ,TSF_A1(22)/  9.75951/,TSF_B1(22)/  7.85081/
     * ,TSF_A2(22)/  7.35581/,TSF_B2(22)/  0.50000/
     * ,TSF_A3(22)/  1.69910/,TSF_B3(22)/ 35.63383/
     * ,TSF_A4(22)/  1.90210/,TSF_B4(22)/116.10510/
     * ,TSF_C (22)/  1.28070/
     * ,TSF_FI(22)/  0.21910/,TSF_FII(22)/  1.80690/
      DATA TSF_ATOM(23)/'V   '/,TSF_NE(23)/23/,TSF_RAD(23)/1.50/
     * ,TSF_A1(23)/ 10.29711/,TSF_B1(23)/  6.86571/
     * ,TSF_A2(23)/  7.35111/,TSF_B2(23)/  0.43850/
     * ,TSF_A3(23)/  2.07030/,TSF_B3(23)/ 26.89383/
     * ,TSF_A4(23)/  2.05710/,TSF_B4(23)/102.47810/
     * ,TSF_C (23)/  1.21990/
     * ,TSF_FI(23)/  0.06870/,TSF_FII(23)/  2.10970/
      DATA TSF_ATOM(24)/'CR  '/,TSF_NE(24)/24/,TSF_RAD(24)/1.50/
     * ,TSF_A1(24)/ 10.64061/,TSF_B1(24)/  6.10381/
     * ,TSF_A2(24)/  7.35371/,TSF_B2(24)/  0.39200/
     * ,TSF_A3(24)/  3.32400/,TSF_B3(24)/ 20.26262/
     * ,TSF_A4(24)/  1.49220/,TSF_B4(24)/ 98.73999/
     * ,TSF_C (24)/  1.18320/
     * ,TSF_FI(24)/ -0.16350/,TSF_FII(24)/  2.44390/
      DATA TSF_ATOM(25)/'MN  '/,TSF_NE(25)/25/,TSF_RAD(25)/1.50/
     * ,TSF_A1(25)/ 11.28191/,TSF_B1(25)/  5.34091/
     * ,TSF_A2(25)/  7.35731/,TSF_B2(25)/  0.34320/
     * ,TSF_A3(25)/  3.01930/,TSF_B3(25)/ 17.86742/
     * ,TSF_A4(25)/  2.24410/,TSF_B4(25)/ 83.75438/
     * ,TSF_C (25)/  1.08960/
     * ,TSF_FI(25)/ -0.52990/,TSF_FII(25)/  2.80520/
      DATA TSF_ATOM(26)/'FE  '/,TSF_NE(26)/26/,TSF_RAD(26)/1.50/
     * ,TSF_A1(26)/ 11.76951/,TSF_B1(26)/  4.76111/
     * ,TSF_A2(26)/  7.35731/,TSF_B2(26)/  0.30720/
     * ,TSF_A3(26)/  3.52220/,TSF_B3(26)/ 15.35351/
     * ,TSF_A4(26)/  2.30450/,TSF_B4(26)/ 76.88058/
     * ,TSF_C (26)/  1.03690/
     * ,TSF_FI(26)/ -1.13360/,TSF_FII(26)/  3.19740/
      DATA TSF_ATOM(27)/'CO  '/,TSF_NE(27)/27/,TSF_RAD(27)/1.50/
     * ,TSF_A1(27)/ 12.28411/,TSF_B1(27)/  4.27910/
     * ,TSF_A2(27)/  7.34091/,TSF_B2(27)/  0.27840/
     * ,TSF_A3(27)/  4.00340/,TSF_B3(27)/ 13.53591/
     * ,TSF_A4(27)/  2.34880/,TSF_B4(27)/ 71.16927/
     * ,TSF_C (27)/  1.01180/
     * ,TSF_FI(27)/ -2.36530/,TSF_FII(27)/  3.61430/
      DATA TSF_ATOM(28)/'NI  '/,TSF_NE(28)/28/,TSF_RAD(28)/1.50/
     * ,TSF_A1(28)/ 12.83761/,TSF_B1(28)/  3.87850/
     * ,TSF_A2(28)/  7.29201/,TSF_B2(28)/  0.25650/
     * ,TSF_A3(28)/  4.44380/,TSF_B3(28)/ 12.17631/
     * ,TSF_A4(28)/  2.38000/,TSF_B4(28)/ 66.34216/
     * ,TSF_C (28)/  1.03410/
     * ,TSF_FI(28)/ -3.00290/,TSF_FII(28)/  0.50910/
      DATA TSF_ATOM(29)/'CU  '/,TSF_NE(29)/29/,TSF_RAD(29)/1.50/
     * ,TSF_A1(29)/ 13.33801/,TSF_B1(29)/  3.58280/
     * ,TSF_A2(29)/  7.16761/,TSF_B2(29)/  0.24700/
     * ,TSF_A3(29)/  5.61581/,TSF_B3(29)/ 11.39661/
     * ,TSF_A4(29)/  1.67350/,TSF_B4(29)/ 64.81267/
     * ,TSF_C (29)/  1.19100/
     * ,TSF_FI(29)/ -1.96460/,TSF_FII(29)/  0.58880/
      DATA TSF_ATOM(30)/'ZN  '/,TSF_NE(30)/30/,TSF_RAD(30)/1.50/
     * ,TSF_A1(30)/ 14.07431/,TSF_B1(30)/  3.26550/
     * ,TSF_A2(30)/  7.03181/,TSF_B2(30)/  0.23330/
     * ,TSF_A3(30)/  5.16521/,TSF_B3(30)/ 10.31631/
     * ,TSF_A4(30)/  2.41000/,TSF_B4(30)/ 58.70976/
     * ,TSF_C (30)/  1.30410/
     * ,TSF_FI(30)/ -1.54910/,TSF_FII(30)/  0.67780/
      DATA TSF_ATOM(31)/'GA  '/,TSF_NE(31)/31/,TSF_RAD(31)/1.50/
     * ,TSF_A1(31)/ 15.23541/,TSF_B1(31)/  3.06690/
     * ,TSF_A2(31)/  6.70061/,TSF_B2(31)/  0.24120/
     * ,TSF_A3(31)/  4.35910/,TSF_B3(31)/ 10.78051/
     * ,TSF_A4(31)/  2.96230/,TSF_B4(31)/ 61.41357/
     * ,TSF_C (31)/  1.71890/
     * ,TSF_FI(31)/ -1.28460/,TSF_FII(31)/  0.77630/
      DATA TSF_ATOM(32)/'GE  '/,TSF_NE(32)/32/,TSF_RAD(32)/1.50/
     * ,TSF_A1(32)/ 16.08162/,TSF_B1(32)/  2.85090/
     * ,TSF_A2(32)/  6.37471/,TSF_B2(32)/  0.25160/
     * ,TSF_A3(32)/  3.70680/,TSF_B3(32)/ 11.44681/
     * ,TSF_A4(32)/  3.68300/,TSF_B4(32)/ 54.76256/
     * ,TSF_C (32)/  2.13130/
     * ,TSF_FI(32)/ -1.08850/,TSF_FII(32)/  0.88550/
      DATA TSF_ATOM(33)/'AS  '/,TSF_NE(33)/33/,TSF_RAD(33)/1.50/
     * ,TSF_A1(33)/ 16.67232/,TSF_B1(33)/  2.63450/
     * ,TSF_A2(33)/  6.07011/,TSF_B2(33)/  0.26470/
     * ,TSF_A3(33)/  3.43130/,TSF_B3(33)/ 12.94791/
     * ,TSF_A4(33)/  4.27790/,TSF_B4(33)/ 47.79726/
     * ,TSF_C (33)/  2.53100/
     * ,TSF_FI(33)/ -0.93000/,TSF_FII(33)/  1.00510/
      DATA TSF_ATOM(34)/'SE  '/,TSF_NE(34)/34/,TSF_RAD(34)/1.50/
     * ,TSF_A1(34)/ 17.00063/,TSF_B1(34)/  2.40980/
     * ,TSF_A2(34)/  5.81961/,TSF_B2(34)/  0.27260/
     * ,TSF_A3(34)/  3.97310/,TSF_B3(34)/ 15.23721/
     * ,TSF_A4(34)/  4.35430/,TSF_B4(34)/ 43.81635/
     * ,TSF_C (34)/  2.84090/
     * ,TSF_FI(34)/ -0.79430/,TSF_FII(34)/  1.13720/
      DATA TSF_ATOM(35)/'BR  '/,TSF_NE(35)/35/,TSF_RAD(35)/1.50/
     * ,TSF_A1(35)/ 17.17892/,TSF_B1(35)/  2.17230/
     * ,TSF_A2(35)/  5.23581/,TSF_B2(35)/ 16.57962/
     * ,TSF_A3(35)/  5.63771/,TSF_B3(35)/  0.26090/
     * ,TSF_A4(35)/  3.98510/,TSF_B4(35)/ 41.43285/
     * ,TSF_C (35)/  2.95570/
     * ,TSF_FI(35)/ -0.67630/,TSF_FII(35)/  1.28050/
      DATA TSF_ATOM(36)/'KR  '/,TSF_NE(36)/36/,TSF_RAD(36)/1.50/
     * ,TSF_A1(36)/ 17.35551/,TSF_B1(36)/  1.93840/
     * ,TSF_A2(36)/  6.72861/,TSF_B2(36)/ 16.56232/
     * ,TSF_A3(36)/  5.54931/,TSF_B3(36)/  0.22610/
     * ,TSF_A4(36)/  3.53750/,TSF_B4(36)/ 39.39723/
     * ,TSF_C (36)/  2.82500/
     * ,TSF_FI(36)/ -0.56570/,TSF_FII(36)/  1.43850/
      DATA TSF_ATOM(37)/'RB  '/,TSF_NE(37)/37/,TSF_RAD(37)/1.50/
     * ,TSF_A1(37)/ 17.17842/,TSF_B1(37)/  1.78880/
     * ,TSF_A2(37)/  9.64351/,TSF_B2(37)/ 17.31512/
     * ,TSF_A3(37)/  5.13990/,TSF_B3(37)/  0.27480/
     * ,TSF_A4(37)/  1.52920/,TSF_B4(37)/164.93420/
     * ,TSF_C (37)/  3.48730/
     * ,TSF_FI(37)/ -0.46880/,TSF_FII(37)/  1.60790/
      DATA TSF_ATOM(38)/'SR  '/,TSF_NE(38)/38/,TSF_RAD(38)/1.50/
     * ,TSF_A1(38)/ 17.56631/,TSF_B1(38)/  1.55640/
     * ,TSF_A2(38)/  9.81841/,TSF_B2(38)/ 14.09881/
     * ,TSF_A3(38)/  5.42200/,TSF_B3(38)/  0.16640/
     * ,TSF_A4(38)/  2.66940/,TSF_B4(38)/132.37610/
     * ,TSF_C (38)/  2.50640/
     * ,TSF_FI(38)/ -0.35280/,TSF_FII(38)/  1.82000/
      DATA TSF_ATOM(39)/'Y   '/,TSF_NE(39)/39/,TSF_RAD(39)/1.50/
     * ,TSF_A1(39)/ 17.77602/,TSF_B1(39)/  1.40290/
     * ,TSF_A2(39)/ 10.29461/,TSF_B2(39)/ 12.80061/
     * ,TSF_A3(39)/  5.72630/,TSF_B3(39)/  0.12560/
     * ,TSF_A4(39)/  3.26588/,TSF_B4(39)/104.35410/
     * ,TSF_C (39)/  1.91213/
     * ,TSF_FI(39)/ -0.26700/,TSF_FII(39)/  2.02440/
      DATA TSF_ATOM(40)/'ZR  '/,TSF_NE(40)/40/,TSF_RAD(40)/1.50/
     * ,TSF_A1(40)/ 17.87653/,TSF_B1(40)/  1.27618/
     * ,TSF_A2(40)/ 10.94801/,TSF_B2(40)/ 11.91601/
     * ,TSF_A3(40)/  5.41733/,TSF_B3(40)/  0.11762/
     * ,TSF_A4(40)/  3.65721/,TSF_B4(40)/ 87.66278/
     * ,TSF_C (40)/  2.06929/
     * ,TSF_FI(40)/ -0.18620/,TSF_FII(40)/  2.24490/
      DATA TSF_ATOM(41)/'NB  '/,TSF_NE(41)/41/,TSF_RAD(41)/1.50/
     * ,TSF_A1(41)/ 17.61423/,TSF_B1(41)/  1.18865/
     * ,TSF_A2(41)/ 12.01441/,TSF_B2(41)/ 11.76601/
     * ,TSF_A3(41)/  4.04183/,TSF_B3(41)/  0.20479/
     * ,TSF_A4(41)/  3.53346/,TSF_B4(41)/ 69.79576/
     * ,TSF_C (41)/  3.75591/
     * ,TSF_FI(41)/ -0.11210/,TSF_FII(41)/  2.48260/
      DATA TSF_ATOM(42)/'MO  '/,TSF_NE(42)/42/,TSF_RAD(42)/1.50/
     * ,TSF_A1(42)/  3.70250/,TSF_B1(42)/  0.27720/
     * ,TSF_A2(42)/ 17.23563/,TSF_B2(42)/  1.09580/
     * ,TSF_A3(42)/ 12.88761/,TSF_B3(42)/ 11.00401/
     * ,TSF_A4(42)/  3.74290/,TSF_B4(42)/ 61.65846/
     * ,TSF_C (42)/  4.38750/
     * ,TSF_FI(42)/ -0.04830/,TSF_FII(42)/  2.73390/
      DATA TSF_ATOM(43)/'TC  '/,TSF_NE(43)/43/,TSF_RAD(43)/1.50/
     * ,TSF_A1(43)/ 19.13013/,TSF_B1(43)/  0.86413/
     * ,TSF_A2(43)/ 11.09481/,TSF_B2(43)/  8.14488/
     * ,TSF_A3(43)/  4.64902/,TSF_B3(43)/ 21.57072/
     * ,TSF_A4(43)/  2.71263/,TSF_B4(43)/ 86.84727/
     * ,TSF_C (43)/  5.40429/
     * ,TSF_FI(43)/  0.00570/,TSF_FII(43)/  3.00490/
      DATA TSF_ATOM(44)/'RU  '/,TSF_NE(44)/44/,TSF_RAD(44)/1.50/
     * ,TSF_A1(44)/ 19.26743/,TSF_B1(44)/  0.80852/
     * ,TSF_A2(44)/ 12.91821/,TSF_B2(44)/  8.43468/
     * ,TSF_A3(44)/  4.86337/,TSF_B3(44)/ 24.79974/
     * ,TSF_A4(44)/  1.56756/,TSF_B4(44)/ 94.29289/
     * ,TSF_C (44)/  5.37875/
     * ,TSF_FI(44)/  0.05520/,TSF_FII(44)/  3.29600/
      DATA TSF_ATOM(45)/'RH  '/,TSF_NE(45)/45/,TSF_RAD(45)/1.50/
     * ,TSF_A1(45)/ 19.29572/,TSF_B1(45)/  0.75154/
     * ,TSF_A2(45)/ 14.35011/,TSF_B2(45)/  8.21759/
     * ,TSF_A3(45)/  4.73425/,TSF_B3(45)/ 25.87494/
     * ,TSF_A4(45)/  1.28918/,TSF_B4(45)/ 98.60629/
     * ,TSF_C (45)/  5.32800/
     * ,TSF_FI(45)/  0.09270/,TSF_FII(45)/  3.60450/
      DATA TSF_ATOM(46)/'PD  '/,TSF_NE(46)/46/,TSF_RAD(46)/1.50/
     * ,TSF_A1(46)/ 19.33192/,TSF_B1(46)/  0.69866/
     * ,TSF_A2(46)/ 15.50172/,TSF_B2(46)/  7.98930/
     * ,TSF_A3(46)/  5.29537/,TSF_B3(46)/ 25.20523/
     * ,TSF_A4(46)/  0.60584/,TSF_B4(46)/ 76.89868/
     * ,TSF_C (46)/  5.26593/
     * ,TSF_FI(46)/  0.12150/,TSF_FII(46)/  3.93370/
      DATA TSF_ATOM(47)/'AG  '/,TSF_NE(47)/47/,TSF_RAD(47)/1.50/
     * ,TSF_A1(47)/ 19.28082/,TSF_B1(47)/  0.64460/
     * ,TSF_A2(47)/ 16.68852/,TSF_B2(47)/  7.47261/
     * ,TSF_A3(47)/  4.80451/,TSF_B3(47)/ 24.66054/
     * ,TSF_A4(47)/  1.04630/,TSF_B4(47)/ 99.81570/
     * ,TSF_C (47)/  5.17900/
     * ,TSF_FI(47)/  0.13060/,TSF_FII(47)/  4.28200/
      DATA TSF_ATOM(48)/'CD  '/,TSF_NE(48)/48/,TSF_RAD(48)/1.50/
     * ,TSF_A1(48)/ 19.22142/,TSF_B1(48)/  0.59460/
     * ,TSF_A2(48)/ 17.64442/,TSF_B2(48)/  6.90891/
     * ,TSF_A3(48)/  4.46100/,TSF_B3(48)/ 24.70084/
     * ,TSF_A4(48)/  1.60290/,TSF_B4(48)/ 87.48257/
     * ,TSF_C (48)/  5.06941/
     * ,TSF_FI(48)/  0.11850/,TSF_FII(48)/  4.65330/
      DATA TSF_ATOM(49)/'IN  '/,TSF_NE(49)/49/,TSF_RAD(49)/1.50/
     * ,TSF_A1(49)/ 19.16241/,TSF_B1(49)/  0.54760/
     * ,TSF_A2(49)/ 18.55962/,TSF_B2(49)/  6.37761/
     * ,TSF_A3(49)/  4.29480/,TSF_B3(49)/ 25.84993/
     * ,TSF_A4(49)/  2.03960/,TSF_B4(49)/ 92.80299/
     * ,TSF_C (49)/  4.93911/
     * ,TSF_FI(49)/  0.08220/,TSF_FII(49)/  5.04490/
      DATA TSF_ATOM(50)/'SN  '/,TSF_NE(50)/50/,TSF_RAD(50)/1.50/
     * ,TSF_A1(50)/ 19.18892/,TSF_B1(50)/  5.83031/
     * ,TSF_A2(50)/ 19.10052/,TSF_B2(50)/  0.50310/
     * ,TSF_A3(50)/  4.45850/,TSF_B3(50)/ 26.89093/
     * ,TSF_A4(50)/  2.46630/,TSF_B4(50)/ 83.95718/
     * ,TSF_C (50)/  4.78211/
     * ,TSF_FI(50)/  0.02590/,TSF_FII(50)/  5.45910/
      DATA TSF_ATOM(51)/'SB  '/,TSF_NE(51)/51/,TSF_RAD(51)/1.50/
     * ,TSF_A1(51)/ 19.64182/,TSF_B1(51)/  5.30340/
     * ,TSF_A2(51)/ 19.04552/,TSF_B2(51)/  0.46070/
     * ,TSF_A3(51)/  5.03711/,TSF_B3(51)/ 27.90744/
     * ,TSF_A4(51)/  2.68270/,TSF_B4(51)/ 75.28258/
     * ,TSF_C (51)/  4.59091/
     * ,TSF_FI(51)/ -0.05620/,TSF_FII(51)/  5.89460/
      DATA TSF_ATOM(52)/'TE  '/,TSF_NE(52)/52/,TSF_RAD(52)/1.50/
     * ,TSF_A1(52)/ 19.96442/,TSF_B1(52)/  4.81742/
     * ,TSF_A2(52)/ 19.01382/,TSF_B2(52)/  0.42089/
     * ,TSF_A3(52)/  6.14488/,TSF_B3(52)/ 28.52844/
     * ,TSF_A4(52)/  2.52390/,TSF_B4(52)/ 70.84036/
     * ,TSF_C (52)/  4.35200/
     * ,TSF_FI(52)/ -0.17590/,TSF_FII(52)/  6.35310/
      DATA TSF_ATOM(53)/'I   '/,TSF_NE(53)/53/,TSF_RAD(53)/1.50/
     * ,TSF_A1(53)/ 20.14722/,TSF_B1(53)/  4.34700/
     * ,TSF_A2(53)/ 18.99492/,TSF_B2(53)/  0.38140/
     * ,TSF_A3(53)/  7.51381/,TSF_B3(53)/ 27.76604/
     * ,TSF_A4(53)/  2.27350/,TSF_B4(53)/ 66.87767/
     * ,TSF_C (53)/  4.07120/
     * ,TSF_FI(53)/ -0.32570/,TSF_FII(53)/  6.83620/
      DATA TSF_ATOM(54)/'XE  '/,TSF_NE(54)/54/,TSF_RAD(54)/1.50/
     * ,TSF_A1(54)/ 20.29332/,TSF_B1(54)/  3.92820/
     * ,TSF_A2(54)/ 19.02982/,TSF_B2(54)/  0.34400/
     * ,TSF_A3(54)/  8.97671/,TSF_B3(54)/ 26.46594/
     * ,TSF_A4(54)/  1.99000/,TSF_B4(54)/ 64.26587/
     * ,TSF_C (54)/  3.71180/
     * ,TSF_FI(54)/ -0.51790/,TSF_FII(54)/  7.35000/
      DATA TSF_ATOM(55)/'CS  '/,TSF_NE(55)/55/,TSF_RAD(55)/1.50/
     * ,TSF_A1(55)/ 20.38922/,TSF_B1(55)/  3.56900/
     * ,TSF_A2(55)/ 19.10622/,TSF_B2(55)/  0.31070/
     * ,TSF_A3(55)/ 10.66201/,TSF_B3(55)/ 24.38794/
     * ,TSF_A4(55)/  1.49530/,TSF_B4(55)/213.90421/
     * ,TSF_C (55)/  3.33520/
     * ,TSF_FI(55)/ -0.74570/,TSF_FII(55)/  7.90520/
      DATA TSF_ATOM(56)/'BA  '/,TSF_NE(56)/56/,TSF_RAD(56)/1.50/
     * ,TSF_A1(56)/ 20.33612/,TSF_B1(56)/  3.21600/
     * ,TSF_A2(56)/ 19.29703/,TSF_B2(56)/  0.27560/
     * ,TSF_A3(56)/ 10.88801/,TSF_B3(56)/ 20.20732/
     * ,TSF_A4(56)/  2.69590/,TSF_B4(56)/167.20219/
     * ,TSF_C (56)/  2.77310/
     * ,TSF_FI(56)/ -1.04560/,TSF_FII(56)/  8.46170/
      DATA TSF_ATOM(57)/'LA  '/,TSF_NE(57)/57/,TSF_RAD(57)/1.50/
     * ,TSF_A1(57)/ 20.57802/,TSF_B1(57)/  2.94817/
     * ,TSF_A2(57)/ 19.59901/,TSF_B2(57)/  0.24448/
     * ,TSF_A3(57)/ 11.37271/,TSF_B3(57)/ 18.77261/
     * ,TSF_A4(57)/  3.28719/,TSF_B4(57)/133.12410/
     * ,TSF_C (57)/  2.14678/
     * ,TSF_FI(57)/ -1.40940/,TSF_FII(57)/  9.03760/
      DATA TSF_ATOM(58)/'CE  '/,TSF_NE(58)/58/,TSF_RAD(58)/1.50/
     * ,TSF_A1(58)/ 21.16711/,TSF_B1(58)/  2.81219/
     * ,TSF_A2(58)/ 19.76952/,TSF_B2(58)/  0.22684/
     * ,TSF_A3(58)/ 11.85131/,TSF_B3(58)/ 17.60832/
     * ,TSF_A4(58)/  3.33049/,TSF_B4(58)/127.11310/
     * ,TSF_C (58)/  1.86264/
     * ,TSF_FI(58)/ -1.84820/,TSF_FII(58)/  9.65960/
      DATA TSF_ATOM(59)/'PR  '/,TSF_NE(59)/59/,TSF_RAD(59)/1.50/
     * ,TSF_A1(59)/ 22.04402/,TSF_B1(59)/  2.77393/
     * ,TSF_A2(59)/ 19.66972/,TSF_B2(59)/  0.22209/
     * ,TSF_A3(59)/ 12.38561/,TSF_B3(59)/ 16.76692/
     * ,TSF_A4(59)/  2.82428/,TSF_B4(59)/143.64410/
     * ,TSF_C (59)/  2.05830/
     * ,TSF_FI(59)/ -2.41640/,TSF_FII(59)/ 10.28200/
      DATA TSF_ATOM(60)/'ND  '/,TSF_NE(60)/60/,TSF_RAD(60)/1.50/
     * ,TSF_A1(60)/ 22.68452/,TSF_B1(60)/  2.66248/
     * ,TSF_A2(60)/ 19.68472/,TSF_B2(60)/  0.21063/
     * ,TSF_A3(60)/ 12.77401/,TSF_B3(60)/ 15.88502/
     * ,TSF_A4(60)/  2.85137/,TSF_B4(60)/137.90311/
     * ,TSF_C (60)/  1.98486/
     * ,TSF_FI(60)/ -3.18070/,TSF_FII(60)/ 10.90790/
      DATA TSF_ATOM(61)/'PM  '/,TSF_NE(61)/61/,TSF_RAD(61)/1.50/
     * ,TSF_A1(61)/ 23.34052/,TSF_B1(61)/  2.56270/
     * ,TSF_A2(61)/ 19.60953/,TSF_B2(61)/  0.20209/
     * ,TSF_A3(61)/ 13.12351/,TSF_B3(61)/ 15.10091/
     * ,TSF_A4(61)/  2.87516/,TSF_B4(61)/132.72110/
     * ,TSF_C (61)/  2.02876/
     * ,TSF_FI(61)/ -4.05980/,TSF_FII(61)/ 11.55230/
      DATA TSF_ATOM(62)/'SM  '/,TSF_NE(62)/62/,TSF_RAD(62)/1.50/
     * ,TSF_A1(62)/ 24.00424/,TSF_B1(62)/  2.47274/
     * ,TSF_A2(62)/ 19.42583/,TSF_B2(62)/  0.19645/
     * ,TSF_A3(62)/ 13.43961/,TSF_B3(62)/ 14.39961/
     * ,TSF_A4(62)/  2.89604/,TSF_B4(62)/128.00710/
     * ,TSF_C (62)/  2.20963/
     * ,TSF_FI(62)/ -5.32360/,TSF_FII(62)/ 12.21780/
      DATA TSF_ATOM(63)/'EU  '/,TSF_NE(63)/63/,TSF_RAD(63)/1.50/
     * ,TSF_A1(63)/ 24.62744/,TSF_B1(63)/  2.38790/
     * ,TSF_A2(63)/ 19.08862/,TSF_B2(63)/  0.19420/
     * ,TSF_A3(63)/ 13.76031/,TSF_B3(63)/ 13.75461/
     * ,TSF_A4(63)/  2.92270/,TSF_B4(63)/123.17410/
     * ,TSF_C (63)/  2.57450/
     * ,TSF_FI(63)/ -8.92940/,TSF_FII(63)/ 11.18570/
      DATA TSF_ATOM(64)/'GD  '/,TSF_NE(64)/64/,TSF_RAD(64)/1.50/
     * ,TSF_A1(64)/ 25.07094/,TSF_B1(64)/  2.25341/
     * ,TSF_A2(64)/ 19.07982/,TSF_B2(64)/  0.18195/
     * ,TSF_A3(64)/ 13.85181/,TSF_B3(64)/ 12.93311/
     * ,TSF_A4(64)/  3.54545/,TSF_B4(64)/101.39810/
     * ,TSF_C (64)/  2.41960/
     * ,TSF_FI(64)/ -8.83800/,TSF_FII(64)/ 11.91570/
      DATA TSF_ATOM(65)/'TB  '/,TSF_NE(65)/65/,TSF_RAD(65)/1.50/
     * ,TSF_A1(65)/ 25.89763/,TSF_B1(65)/  2.24256/
     * ,TSF_A2(65)/ 18.21852/,TSF_B2(65)/  0.19614/
     * ,TSF_A3(65)/ 14.31671/,TSF_B3(65)/ 12.66481/
     * ,TSF_A4(65)/  2.95354/,TSF_B4(65)/115.36210/
     * ,TSF_C (65)/  3.58324/
     * ,TSF_FI(65)/ -9.14720/,TSF_FII(65)/  9.18910/
      DATA TSF_ATOM(66)/'DY  '/,TSF_NE(66)/66/,TSF_RAD(66)/1.50/
     * ,TSF_A1(66)/ 26.50703/,TSF_B1(66)/  2.18020/
     * ,TSF_A2(66)/ 17.63832/,TSF_B2(66)/  0.20217/
     * ,TSF_A3(66)/ 14.55962/,TSF_B3(66)/ 12.18991/
     * ,TSF_A4(66)/  2.96577/,TSF_B4(66)/111.87410/
     * ,TSF_C (66)/  4.29728/
     * ,TSF_FI(66)/ -9.80460/,TSF_FII(66)/  9.84770/
      DATA TSF_ATOM(67)/'HO  '/,TSF_NE(67)/67/,TSF_RAD(67)/1.50/
     * ,TSF_A1(67)/ 26.90494/,TSF_B1(67)/  2.07051/
     * ,TSF_A2(67)/ 17.29402/,TSF_B2(67)/  0.19794/
     * ,TSF_A3(67)/ 14.55831/,TSF_B3(67)/ 11.44071/
     * ,TSF_A4(67)/  3.63837/,TSF_B4(67)/ 92.65669/
     * ,TSF_C (67)/  4.56797/
     * ,TSF_FI(67)/-14.97340/,TSF_FII(67)/  3.70460/
      DATA TSF_ATOM(68)/'ER  '/,TSF_NE(68)/68/,TSF_RAD(68)/1.50/
     * ,TSF_A1(68)/ 27.65634/,TSF_B1(68)/  2.07356/
     * ,TSF_A2(68)/ 16.42853/,TSF_B2(68)/  0.22355/
     * ,TSF_A3(68)/ 14.97791/,TSF_B3(68)/ 11.36041/
     * ,TSF_A4(68)/  2.98233/,TSF_B4(68)/105.70310/
     * ,TSF_C (68)/  5.92047/
     * ,TSF_FI(68)/ -9.43670/,TSF_FII(68)/  3.93800/
      DATA TSF_ATOM(69)/'TM  '/,TSF_NE(69)/69/,TSF_RAD(69)/1.50/
     * ,TSF_A1(69)/ 28.18193/,TSF_B1(69)/  2.02859/
     * ,TSF_A2(69)/ 15.88512/,TSF_B2(69)/  0.23885/
     * ,TSF_A3(69)/ 15.15421/,TSF_B3(69)/ 10.99751/
     * ,TSF_A4(69)/  2.98706/,TSF_B4(69)/102.96110/
     * ,TSF_C (69)/  6.75622/
     * ,TSF_FI(69)/ -8.03930/,TSF_FII(69)/  4.18210/
      DATA TSF_ATOM(70)/'YB  '/,TSF_NE(70)/70/,TSF_RAD(70)/1.50/
     * ,TSF_A1(70)/ 28.66414/,TSF_B1(70)/  1.98890/
     * ,TSF_A2(70)/ 15.43451/,TSF_B2(70)/  0.25712/
     * ,TSF_A3(70)/ 15.30871/,TSF_B3(70)/ 10.66471/
     * ,TSF_A4(70)/  2.98963/,TSF_B4(70)/100.41710/
     * ,TSF_C (70)/  7.56673/
     * ,TSF_FI(70)/ -7.21080/,TSF_FII(70)/  4.43290/
      DATA TSF_ATOM(71)/'LU  '/,TSF_NE(71)/71/,TSF_RAD(71)/1.50/
     * ,TSF_A1(71)/ 28.94763/,TSF_B1(71)/  1.90182/
     * ,TSF_A2(71)/ 15.22081/,TSF_B2(71)/  9.98520/
     * ,TSF_A3(71)/ 15.10001/,TSF_B3(71)/  0.26103/
     * ,TSF_A4(71)/  3.71601/,TSF_B4(71)/ 84.32988/
     * ,TSF_C (71)/  7.97629/
     * ,TSF_FI(71)/ -6.61790/,TSF_FII(71)/  4.69370/
      DATA TSF_ATOM(72)/'HF  '/,TSF_NE(72)/72/,TSF_RAD(72)/1.50/
     * ,TSF_A1(72)/ 29.14404/,TSF_B1(72)/  1.83262/
     * ,TSF_A2(72)/ 15.17261/,TSF_B2(72)/  9.59991/
     * ,TSF_A3(72)/ 14.75861/,TSF_B3(72)/  0.27512/
     * ,TSF_A4(72)/  4.30013/,TSF_B4(72)/ 72.02908/
     * ,TSF_C (72)/  8.58155/
     * ,TSF_FI(72)/ -6.17940/,TSF_FII(72)/  4.97760/
      DATA TSF_ATOM(73)/'TA  '/,TSF_NE(73)/73/,TSF_RAD(73)/1.50/
     * ,TSF_A1(73)/ 29.20244/,TSF_B1(73)/  1.77333/
     * ,TSF_A2(73)/ 15.22931/,TSF_B2(73)/  9.37047/
     * ,TSF_A3(73)/ 14.51351/,TSF_B3(73)/  0.29598/
     * ,TSF_A4(73)/  4.76492/,TSF_B4(73)/ 63.36447/
     * ,TSF_C (73)/  9.24355/
     * ,TSF_FI(73)/ -5.79590/,TSF_FII(73)/  5.27180/
      DATA TSF_ATOM(74)/'W   '/,TSF_NE(74)/74/,TSF_RAD(74)/1.50/
     * ,TSF_A1(74)/ 29.08183/,TSF_B1(74)/  1.72029/
     * ,TSF_A2(74)/ 15.43001/,TSF_B2(74)/  9.22591/
     * ,TSF_A3(74)/ 14.43271/,TSF_B3(74)/  0.32170/
     * ,TSF_A4(74)/  5.11983/,TSF_B4(74)/ 57.05606/
     * ,TSF_C (74)/  9.88751/
     * ,TSF_FI(74)/ -5.47340/,TSF_FII(74)/  5.57740/
      DATA TSF_ATOM(75)/'RE  '/,TSF_NE(75)/75/,TSF_RAD(75)/1.50/
     * ,TSF_A1(75)/ 28.76213/,TSF_B1(75)/  1.67191/
     * ,TSF_A2(75)/ 15.71892/,TSF_B2(75)/  9.09228/
     * ,TSF_A3(75)/ 14.55641/,TSF_B3(75)/  0.35050/
     * ,TSF_A4(75)/  5.44174/,TSF_B4(75)/ 52.08615/
     * ,TSF_C (75)/ 10.47201/
     * ,TSF_FI(75)/ -5.20830/,TSF_FII(75)/  5.89230/
      DATA TSF_ATOM(76)/'OS  '/,TSF_NE(76)/76/,TSF_RAD(76)/1.50/
     * ,TSF_A1(76)/ 28.18944/,TSF_B1(76)/  1.62903/
     * ,TSF_A2(76)/ 16.15501/,TSF_B2(76)/  8.97949/
     * ,TSF_A3(76)/ 14.93051/,TSF_B3(76)/  0.38266/
     * ,TSF_A4(76)/  5.67590/,TSF_B4(76)/ 48.16475/
     * ,TSF_C (76)/ 11.00051/
     * ,TSF_FI(76)/ -4.98010/,TSF_FII(76)/  6.22160/
      DATA TSF_ATOM(77)/'IR  '/,TSF_NE(77)/77/,TSF_RAD(77)/1.50/
     * ,TSF_A1(77)/ 27.30493/,TSF_B1(77)/  1.59279/
     * ,TSF_A2(77)/ 16.72961/,TSF_B2(77)/  8.86554/
     * ,TSF_A3(77)/ 15.61152/,TSF_B3(77)/  0.41792/
     * ,TSF_A4(77)/  5.83378/,TSF_B4(77)/ 45.00114/
     * ,TSF_C (77)/ 11.47221/
     * ,TSF_FI(77)/ -4.77100/,TSF_FII(77)/  6.56670/
      DATA TSF_ATOM(78)/'PT  '/,TSF_NE(78)/78/,TSF_RAD(78)/1.50/
     * ,TSF_A1(78)/ 27.00594/,TSF_B1(78)/  1.51293/
     * ,TSF_A2(78)/ 17.76392/,TSF_B2(78)/  8.81175/
     * ,TSF_A3(78)/ 15.71312/,TSF_B3(78)/  0.42459/
     * ,TSF_A4(78)/  5.78371/,TSF_B4(78)/ 38.61034/
     * ,TSF_C (78)/ 11.68831/
     * ,TSF_FI(78)/ -4.59320/,TSF_FII(78)/  6.92640/
      DATA TSF_ATOM(79)/'AU  '/,TSF_NE(79)/79/,TSF_RAD(79)/1.50/
     * ,TSF_A1(79)/ 16.88193/,TSF_B1(79)/  0.46110/
     * ,TSF_A2(79)/ 18.59132/,TSF_B2(79)/  8.62161/
     * ,TSF_A3(79)/ 25.55824/,TSF_B3(79)/  1.48260/
     * ,TSF_A4(79)/  5.86001/,TSF_B4(79)/ 36.39563/
     * ,TSF_C (79)/ 12.06581/
     * ,TSF_FI(79)/ -4.41970/,TSF_FII(79)/  7.29800/
      DATA TSF_ATOM(80)/'HG  '/,TSF_NE(80)/80/,TSF_RAD(80)/1.50/
     * ,TSF_A1(80)/ 20.68092/,TSF_B1(80)/  0.54500/
     * ,TSF_A2(80)/ 19.04172/,TSF_B2(80)/  8.44841/
     * ,TSF_A3(80)/ 21.65752/,TSF_B3(80)/  1.57290/
     * ,TSF_A4(80)/  5.96761/,TSF_B4(80)/ 38.32463/
     * ,TSF_C (80)/ 12.60891/
     * ,TSF_FI(80)/ -4.29230/,TSF_FII(80)/  7.68490/
      DATA TSF_ATOM(81)/'TL  '/,TSF_NE(81)/81/,TSF_RAD(81)/1.50/
     * ,TSF_A1(81)/ 27.54463/,TSF_B1(81)/  0.65515/
     * ,TSF_A2(81)/ 19.15842/,TSF_B2(81)/  8.70752/
     * ,TSF_A3(81)/ 15.53802/,TSF_B3(81)/  1.96347/
     * ,TSF_A4(81)/  5.52594/,TSF_B4(81)/ 45.81496/
     * ,TSF_C (81)/ 13.17461/
     * ,TSF_FI(81)/ -4.16270/,TSF_FII(81)/  8.09000/
      DATA TSF_ATOM(82)/'PB  '/,TSF_NE(82)/82/,TSF_RAD(82)/1.50/
     * ,TSF_A1(82)/ 31.06174/,TSF_B1(82)/  0.69020/
     * ,TSF_A2(82)/ 13.06371/,TSF_B2(82)/  2.35760/
     * ,TSF_A3(82)/ 18.44202/,TSF_B3(82)/  8.61801/
     * ,TSF_A4(82)/  5.96961/,TSF_B4(82)/ 47.25795/
     * ,TSF_C (82)/ 13.41181/
     * ,TSF_FI(82)/ -4.07530/,TSF_FII(82)/  8.50600/
      DATA TSF_ATOM(83)/'BI  '/,TSF_NE(83)/83/,TSF_RAD(83)/1.50/
     * ,TSF_A1(83)/ 33.36894/,TSF_B1(83)/  0.70400/
     * ,TSF_A2(83)/ 12.95101/,TSF_B2(83)/  2.92380/
     * ,TSF_A3(83)/ 16.58772/,TSF_B3(83)/  8.79371/
     * ,TSF_A4(83)/  6.46921/,TSF_B4(83)/ 48.00935/
     * ,TSF_C (83)/ 13.57821/
     * ,TSF_FI(83)/ -4.01110/,TSF_FII(83)/  8.93100/
      DATA TSF_ATOM(84)/'PO  '/,TSF_NE(84)/84/,TSF_RAD(84)/1.50/
     * ,TSF_A1(84)/ 34.67264/,TSF_B1(84)/  0.70100/
     * ,TSF_A2(84)/ 15.47331/,TSF_B2(84)/  3.55078/
     * ,TSF_A3(84)/ 13.11381/,TSF_B3(84)/  9.55643/
     * ,TSF_A4(84)/  7.02589/,TSF_B4(84)/ 47.00455/
     * ,TSF_C (84)/ 13.67701/
     * ,TSF_FI(84)/ -3.96700/,TSF_FII(84)/  9.38340/
      DATA TSF_ATOM(85)/'AT  '/,TSF_NE(85)/85/,TSF_RAD(85)/1.50/
     * ,TSF_A1(85)/ 35.31633/,TSF_B1(85)/  0.68587/
     * ,TSF_A2(85)/ 19.02112/,TSF_B2(85)/  3.97458/
     * ,TSF_A3(85)/  9.49888/,TSF_B3(85)/ 11.38241/
     * ,TSF_A4(85)/  7.42519/,TSF_B4(85)/ 45.47156/
     * ,TSF_C (85)/ 13.71081/
     * ,TSF_FI(85)/ -3.95880/,TSF_FII(85)/  9.84330/
      DATA TSF_ATOM(86)/'RN  '/,TSF_NE(86)/86/,TSF_RAD(86)/1.50/
     * ,TSF_A1(86)/ 35.56314/,TSF_B1(86)/  0.66310/
     * ,TSF_A2(86)/ 21.28162/,TSF_B2(86)/  4.06910/
     * ,TSF_A3(86)/  8.00371/,TSF_B3(86)/ 14.04221/
     * ,TSF_A4(86)/  7.44331/,TSF_B4(86)/ 44.24734/
     * ,TSF_C (86)/ 13.69051/
     * ,TSF_FI(86)/ -3.94870/,TSF_FII(86)/ 10.31810/
      DATA TSF_ATOM(87)/'FR  '/,TSF_NE(87)/87/,TSF_RAD(87)/1.50/
     * ,TSF_A1(87)/ 35.92993/,TSF_B1(87)/  0.64645/
     * ,TSF_A2(87)/ 23.05472/,TSF_B2(87)/  4.17619/
     * ,TSF_A3(87)/ 12.14391/,TSF_B3(87)/ 23.10522/
     * ,TSF_A4(87)/  2.11253/,TSF_B4(87)/150.64510/
     * ,TSF_C (87)/ 13.72471/
     * ,TSF_FI(87)/ -3.96890/,TSF_FII(87)/ 10.80380/
      DATA TSF_ATOM(88)/'RA  '/,TSF_NE(88)/88/,TSF_RAD(88)/1.50/
     * ,TSF_A1(88)/ 35.76303/,TSF_B1(88)/  0.61634/
     * ,TSF_A2(88)/ 22.90642/,TSF_B2(88)/  3.87135/
     * ,TSF_A3(88)/ 12.47391/,TSF_B3(88)/ 19.98872/
     * ,TSF_A4(88)/  3.21097/,TSF_B4(88)/142.32510/
     * ,TSF_C (88)/ 13.62111/
     * ,TSF_FI(88)/ -4.00880/,TSF_FII(88)/ 11.29690/
      DATA TSF_ATOM(89)/'AC  '/,TSF_NE(89)/89/,TSF_RAD(89)/1.50/
     * ,TSF_A1(89)/ 35.65973/,TSF_B1(89)/  0.58909/
     * ,TSF_A2(89)/ 23.10323/,TSF_B2(89)/  3.65155/
     * ,TSF_A3(89)/ 12.59771/,TSF_B3(89)/ 18.59901/
     * ,TSF_A4(89)/  4.08655/,TSF_B4(89)/117.02010/
     * ,TSF_C (89)/ 13.52661/
     * ,TSF_FI(89)/ -4.07940/,TSF_FII(89)/ 11.79940/
      DATA TSF_ATOM(90)/'TH  '/,TSF_NE(90)/90/,TSF_RAD(90)/1.50/
     * ,TSF_A1(90)/ 35.56453/,TSF_B1(90)/  0.56336/
     * ,TSF_A2(90)/ 23.42192/,TSF_B2(90)/  3.46204/
     * ,TSF_A3(90)/ 12.74731/,TSF_B3(90)/ 17.83092/
     * ,TSF_A4(90)/  4.80704/,TSF_B4(90)/ 99.17230/
     * ,TSF_C (90)/ 13.43141/
     * ,TSF_FI(90)/ -4.14910/,TSF_FII(90)/ 12.32960/
      DATA TSF_ATOM(91)/'PA  '/,TSF_NE(91)/91/,TSF_RAD(91)/1.50/
     * ,TSF_A1(91)/ 35.88474/,TSF_B1(91)/  0.54775/
     * ,TSF_A2(91)/ 23.29482/,TSF_B2(91)/  3.41519/
     * ,TSF_A3(91)/ 14.18911/,TSF_B3(91)/ 16.92352/
     * ,TSF_A4(91)/  4.17287/,TSF_B4(91)/105.25110/
     * ,TSF_C (91)/ 13.42871/
     * ,TSF_FI(91)/ -4.24730/,TSF_FII(91)/ 12.86810/
      DATA TSF_ATOM(92)/'U   '/,TSF_NE(92)/92/,TSF_RAD(92)/1.50/
     * ,TSF_A1(92)/ 36.02284/,TSF_B1(92)/  0.52930/
     * ,TSF_A2(92)/ 23.41283/,TSF_B2(92)/  3.32530/
     * ,TSF_A3(92)/ 14.94911/,TSF_B3(92)/ 16.09273/
     * ,TSF_A4(92)/  4.18800/,TSF_B4(92)/100.61310/
     * ,TSF_C (92)/ 13.39661/
     * ,TSF_FI(92)/ -4.36380/,TSF_FII(92)/ 13.40900/
      DATA TSF_ATOM(93)/'NP  '/,TSF_NE(93)/93/,TSF_RAD(93)/1.50/
     * ,TSF_A1(93)/ 36.18744/,TSF_B1(93)/  0.51193/
     * ,TSF_A2(93)/ 23.59642/,TSF_B2(93)/  3.25396/
     * ,TSF_A3(93)/ 15.64022/,TSF_B3(93)/ 15.36222/
     * ,TSF_A4(93)/  4.18550/,TSF_B4(93)/ 97.49089/
     * ,TSF_C (93)/ 13.35731/
     * ,TSF_FI(93)/ -4.50530/,TSF_FII(93)/ 13.96660/
      DATA TSF_ATOM(94)/'PU  '/,TSF_NE(94)/94/,TSF_RAD(94)/1.50/
     * ,TSF_A1(94)/ 36.52544/,TSF_B1(94)/  0.49938/
     * ,TSF_A2(94)/ 23.80832/,TSF_B2(94)/  3.26371/
     * ,TSF_A3(94)/ 16.77072/,TSF_B3(94)/ 14.94551/
     * ,TSF_A4(94)/  3.47947/,TSF_B4(94)/105.98010/
     * ,TSF_C (94)/ 13.38121/
     * ,TSF_FI(94)/ -4.65630/,TSF_FII(94)/ 14.37290/
C -----------------------------------------------------
      IERR=0
      DO I=1,TSF_N
        IF(ASYMB(1:2).EQ.TSF_ATOM(I)(1:2)) GO TO 100
      ENDDO
      IERR=1
      I = 7
  100 CONTINUE
      N  = I
      NEL= TSF_NE (I)
      A1 = TSF_A1 (I)
      A2 = TSF_A2 (I)
      A3 = TSF_A3 (I)
      A4 = TSF_A4 (I)
      B1 = TSF_B1 (I)
      B2 = TSF_B2 (I)
      B3 = TSF_B3 (I)
      B4 = TSF_B4 (I)
      C  = TSF_C  (I)
      FI = TSF_FI (I)
      FII= TSF_FII(I)
      RAD= TSF_RAD(I)
      RETURN
      END

c      FUNCTION AATAN2(A,B)
c      REAL A,B,C,T,PIBY2
C --------------------------------------
calpha  IF(ABS(B).GT.0.0000001) THEN
c          AATAN2=ATAN2(A,B)
calpha  ELSE
calpha    IF(ABS(A).GT.0.00001) THEN
calpha      PIBY2=2.0*ATAN(1.0)
calpha      C=PIBY2
calpha      IF(A.LT.0.0) C=-C
calpha      AATAN2=C
calpha    ELSE
calpha      C=0.0
calpha      T=A*B
calpha      IF(T.LT.0.0) THEN
calpha        C= PIBY2*2.0
calpha      ENDIF         
calpha      AATAN2=C
calpha    ENDIF
calpha  ENDIF
c      RETURN
c      END

      FUNCTION AATAN2(A,B)
      REAL A,B,C,T,PIBY2
C --------------------------------------
        IF(ABS(B).GT.0.0000001) THEN
          AATAN2=ATAN2(A,B)
        ELSE
          IF(ABS(A).GT.0.00001) THEN
            PIBY2=2.0*ATAN(1.0)
            C=PIBY2
            IF(A.LT.0.0) C=-C
            AATAN2=C
          ELSE
            C=0.0
            T=A*B
            IF(T.LT.0.0) THEN
              C= PIBY2*2.0
            ENDIF         
            AATAN2=C
          ENDIF
        ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IERR    = 0
      NO_TAB  =   0
      NS_TAB  =   0
      SG_TAB1 = ' '
      SG_TAB2 = ' '
      SG_TAB3 = ' '
      OP      = ' '
C ----
      IF(I.GE.  1.AND.I.LE.30) THEN
        CALL GET_SPACE_GROUP_INFO_1(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.31.AND.I.LE.62) THEN
        CALL GET_SPACE_GROUP_INFO_11(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.63.AND.I.LE.86) THEN
        CALL GET_SPACE_GROUP_INFO_12(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.87.AND.I.LE.114) THEN
        CALL GET_SPACE_GROUP_INFO_13(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.115.AND.I.LE.130) THEN
        CALL GET_SPACE_GROUP_INFO_14(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.131.AND.I.LE.145) THEN
        CALL GET_SPACE_GROUP_INFO_2(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.146.AND.I.LE.162) THEN
        CALL GET_SPACE_GROUP_INFO_21(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.163.AND.I.LE.188) THEN
        CALL GET_SPACE_GROUP_INFO_22(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.189.AND.I.LE.202) THEN
        CALL GET_SPACE_GROUP_INFO_23(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.203.AND.I.LE.215) THEN
        CALL GET_SPACE_GROUP_INFO_24(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.216.AND.I.LE.221) THEN
        CALL GET_SPACE_GROUP_INFO_3(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.222.AND.I.LE.226) THEN
        CALL GET_SPACE_GROUP_INFO_31(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.227.AND.I.LE.230) THEN
        CALL GET_SPACE_GROUP_INFO_32(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.231.AND.I.LE.235) THEN
        CALL GET_SPACE_GROUP_INFO_33(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.236.AND.I.LE.239) THEN
        CALL GET_SPACE_GROUP_INFO_34(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.240.AND.I.LE.243) THEN
        CALL GET_SPACE_GROUP_INFO_35(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.244.AND.I.LE.245) THEN
        CALL GET_SPACE_GROUP_INFO_4(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.246.AND.I.LE.246) THEN
        CALL GET_SPACE_GROUP_INFO_41(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.247.AND.I.LE.247) THEN
        CALL GET_SPACE_GROUP_INFO_42(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.248.AND.I.LE.248) THEN
        CALL GET_SPACE_GROUP_INFO_43(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE IF(I.GE.249.AND.I.LE.259) THEN
        CALL GET_SPACE_GROUP_INFO_44(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
      ELSE
        NO_TAB  =    1
        NS_TAB  =    1
        SG_TAB1 = 'P 1'
        SG_TAB2 = 'P1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IERR = 1
      ENDIF
C ----
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_1(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IERR    = 0
      NO_TAB  =   0
      NS_TAB  =   0
      SG_TAB1 = ' '
      SG_TAB2 = ' '
      SG_TAB3 = ' '
      OP      = ' '
C ----
      IF(I.EQ.  1) THEN
        NO_TAB  =    1
        NS_TAB  =    1
        SG_TAB1 = 'P 1'
        SG_TAB2 = 'P1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.  2) THEN
        NO_TAB  =    2
        NS_TAB  =    2
        SG_TAB1 = 'P -1'
        SG_TAB2 = 'P-1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.  3) THEN
        NO_TAB  =    3
        NS_TAB  =    2
        SG_TAB1 = 'P 1 2 1'
        SG_TAB2 = 'P2'
        SG_TAB3 = 'P 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        RETURN
      ENDIF 
      IF(I.EQ.  4) THEN
        NO_TAB  = 1003
        NS_TAB  =    2
        SG_TAB1 = 'P 1 1 2'
        SG_TAB2 = 'P112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.  5) THEN
        NO_TAB  =    4
        NS_TAB  =    2
        SG_TAB1 = 'P 1 21 1'
        SG_TAB2 = 'P1211'
        SG_TAB3 = 'P 21'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y+1/2,-Z'
        RETURN
      ENDIF
      IF(I.EQ.  6) THEN
        NO_TAB  = 3004
        NS_TAB  =    4
        SG_TAB1 = 'I 1 21 1'
        SG_TAB2 = 'I1211'
        SG_TAB3 = 'I 21'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X+1/2,Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.  7) THEN
        NO_TAB  = 1004
        NS_TAB  =    2
        SG_TAB1 = 'P 1 1 21'
        SG_TAB2 = 'P1121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.  8) THEN
        NO_TAB  = 2005
        NS_TAB  =    4
        SG_TAB1 = 'A 2 1 1'
        SG_TAB2 = 'A211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X, Y, Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.  9) THEN
        NO_TAB  =    5
        NS_TAB  =    4
        SG_TAB1 = 'C 1 2 1'
        SG_TAB2 = 'C121'
        SG_TAB3 = 'C 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 10) THEN
        NO_TAB  = 4004
        NS_TAB  =    4
        SG_TAB1 = 'C 1 21 1'
        SG_TAB2 = 'C1211'
        SG_TAB3 = 'C 21'
        IF(IS.EQ.  1) OP =' X, Y, Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X, Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 11) THEN
        NO_TAB  = 1005
        NS_TAB  =    4
        SG_TAB1 = 'B 1 1 2'
        SG_TAB2 = 'B112'
        SG_TAB3 = 'B 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,+Y,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 12) THEN
        NO_TAB  =    6
        NS_TAB  =    2
        SG_TAB1 = 'P 1 m 1'
        SG_TAB2 = 'Pm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 13) THEN
        NO_TAB  =    7
        NS_TAB  =    2
        SG_TAB1 = 'P 1 c 1'
        SG_TAB2 = 'Pc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 14) THEN
        NO_TAB  =    8
        NS_TAB  =    4
        SG_TAB1 = 'C 1 m 1'
        SG_TAB2 = 'Cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 15) THEN
        NO_TAB  =    9
        NS_TAB  =    4
        SG_TAB1 = 'C 1 c 1'
        SG_TAB2 = 'Cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 16) THEN
        NO_TAB  =   10
        NS_TAB  =    4
        SG_TAB1 = 'P 1 2/m 1'
        SG_TAB2 = 'P2/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 17) THEN
        NO_TAB  =   11
        NS_TAB  =    4
        SG_TAB1 = 'P 1 21/m 1'
        SG_TAB2 = 'P21/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 18) THEN
        NO_TAB  =   12
        NS_TAB  =    8
        SG_TAB1 = 'C 1 2/m 1'
        SG_TAB2 = 'C2/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 19) THEN
        NO_TAB  =   13
        NS_TAB  =    4
        SG_TAB1 = 'P 1 2/c 1'
        SG_TAB2 = 'P2/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 20) THEN
        NO_TAB  =   14
        NS_TAB  =    4
        SG_TAB1 = 'P 1 21/c 1'
        SG_TAB2 = 'P21/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 21) THEN
        NO_TAB  =   15
        NS_TAB  =    8
        SG_TAB1 = 'C 1 2/c 1'
        SG_TAB2 = 'C2/c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  3) OP =' -X,-Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 22) THEN
        NO_TAB  =   16
        NS_TAB  =    4
        SG_TAB1 = 'P 2 2 2'
        SG_TAB2 = 'P222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 23) THEN
        NO_TAB  =   17
        NS_TAB  =    4
        SG_TAB1 = 'P 2 2 21'
        SG_TAB2 = 'P2221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 24) THEN
        NO_TAB  = 1017
        NS_TAB  =    4
        SG_TAB1 = 'P 21 2 2'
        SG_TAB2 = 'P2122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 25) THEN
        NO_TAB  = 2017
        NS_TAB  =    4
        SG_TAB1 = 'P 2 21 2'
        SG_TAB2 = 'P2212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 26) THEN
        NO_TAB  =   18
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 2'
        SG_TAB2 = 'P21212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 27) THEN
        NO_TAB  = 1018
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 2 (a)'
        SG_TAB2 = 'P21212a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 28) THEN
        NO_TAB  = 2018
        NS_TAB  =    4
        SG_TAB1 = 'P 21 2 21'
        SG_TAB2 = 'P21221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2-X,-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 29) THEN
        NO_TAB  = 3018
        NS_TAB  =    4
        SG_TAB1 = 'P 2 21 21'
        SG_TAB2 = 'P22121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' -X,1/2-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 30) THEN
        NO_TAB  =   19
        NS_TAB  =    4
        SG_TAB1 = 'P 21 21 21'
        SG_TAB2 = 'P212121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_11(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 31) THEN
        NO_TAB  =   20
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 21'
        SG_TAB2 = 'C2221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 32) THEN
        NO_TAB  = 1020
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 21 (a)'
        SG_TAB2 = 'C2221a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 33) THEN
        NO_TAB  =   21
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 2'
        SG_TAB2 = 'C222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 34) THEN
        NO_TAB  = 1021
        NS_TAB  =    8
        SG_TAB1 = 'C 2 2 2 (a)'
        SG_TAB2 = 'C222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' 1/2+ X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' -X,-Y,Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 35) THEN
        NO_TAB  =   22
        NS_TAB  =   16
        SG_TAB1 = 'F 2 2 2'
        SG_TAB2 = 'F222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  8) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 16) OP =' 1/2+X,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 36) THEN
        NO_TAB  = 1022
        NS_TAB  =   16
        SG_TAB1 = 'F 2 2 2 (a)'
        SG_TAB2 = 'F222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  6) OP =' 1/2-X,-Y,Z+1/2'
        IF(IS.EQ.  7) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  8) OP =' -X,Y,-Z+1/2'
        IF(IS.EQ.  9) OP =' X+1/2,Y,Z+1/2'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,Z+1/2'
        IF(IS.EQ. 11) OP =' X,-Y,-Z+1/2'
        IF(IS.EQ. 12) OP =' -X+1/2,Y+1/2,-Z+1/2'
        IF(IS.EQ. 13) OP =' X+1/2,Y+1/2,Z'
        IF(IS.EQ. 14) OP =' -X,-Y,Z'
        IF(IS.EQ. 15) OP =' X,-Y+1/2,-Z'
        IF(IS.EQ. 16) OP =' -X+1/2,Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 37) THEN
        NO_TAB  =   23
        NS_TAB  =    8
        SG_TAB1 = 'I 2 2 2'
        SG_TAB2 = 'I222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y,-Z'
        IF(IS.EQ.  5) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  6) OP =' -X+1/2,-Y+1/2,Z+1/2'
        IF(IS.EQ.  7) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  8) OP =' -X+1/2,Y+1/2,-Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ. 38) THEN
        NO_TAB  = 1023
        NS_TAB  =    8
        SG_TAB1 = 'I 2 2 2 (a)'
        SG_TAB2 = 'I222a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP ='  -X,-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.  8) OP ='  X,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 39) THEN
        NO_TAB  =   24
        NS_TAB  =    8
        SG_TAB1 = 'I 21 21 21'
        SG_TAB2 = 'I212121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ.  8) OP =' X,-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 40) THEN
        NO_TAB  =   25
        NS_TAB  =    4
        SG_TAB1 = 'P m m 2'
        SG_TAB2 = 'Pmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 41) THEN
        NO_TAB  =   26
        NS_TAB  =    4
        SG_TAB1 = 'P m c 21'
        SG_TAB2 = 'Pmc21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 42) THEN
        NO_TAB  =   27
        NS_TAB  =    4
        SG_TAB1 = 'P c c 2'
        SG_TAB2 = 'Pcc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 43) THEN
        NO_TAB  =   28
        NS_TAB  =    4
        SG_TAB1 = 'P m a 2'
        SG_TAB2 = 'Pma2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 44) THEN
        NO_TAB  =   29
        NS_TAB  =    4
        SG_TAB1 = 'P c a 21'
        SG_TAB2 = 'Pca21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 45) THEN
        NO_TAB  =   30
        NS_TAB  =    4
        SG_TAB1 = 'P n c 2'
        SG_TAB2 = 'Pnc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 46) THEN
        NO_TAB  =   31
        NS_TAB  =    4
        SG_TAB1 = 'P m n 21'
        SG_TAB2 = 'Pmn21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 47) THEN
        NO_TAB  =   32
        NS_TAB  =    4
        SG_TAB1 = 'P b a 2'
        SG_TAB2 = 'Pba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 48) THEN
        NO_TAB  =   33
        NS_TAB  =    4
        SG_TAB1 = 'P n a 21'
        SG_TAB2 = 'Pna21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 49) THEN
        NO_TAB  =   34
        NS_TAB  =    4
        SG_TAB1 = 'P n n 2'
        SG_TAB2 = 'Pnn2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 50) THEN
        NO_TAB  =   35
        NS_TAB  =    8
        SG_TAB1 = 'C m m 2'
        SG_TAB2 = 'Cmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 51) THEN
        NO_TAB  =   36
        NS_TAB  =    8
        SG_TAB1 = 'C m c 21'
        SG_TAB2 = 'Cmc21'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 52) THEN
        NO_TAB  =   37
        NS_TAB  =    8
        SG_TAB1 = 'C c c 2'
        SG_TAB2 = 'Ccc2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  4) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 53) THEN
        NO_TAB  =   38
        NS_TAB  =    8
        SG_TAB1 = 'A m m 2'
        SG_TAB2 = 'Amm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 54) THEN
        NO_TAB  =   39
        NS_TAB  =    8
        SG_TAB1 = 'A b m 2'
        SG_TAB2 = 'Abm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' -X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 55) THEN
        NO_TAB  =   40
        NS_TAB  =    8
        SG_TAB1 = 'A m a 2'
        SG_TAB2 = 'Ama2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 56) THEN
        NO_TAB  =   41
        NS_TAB  =    8
        SG_TAB1 = 'A b a 2'
        SG_TAB2 = 'Aba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 57) THEN
        NO_TAB  =   42
        NS_TAB  =   16
        SG_TAB1 = 'F m m 2'
        SG_TAB2 = 'Fmm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 58) THEN
        NO_TAB  =   43
        NS_TAB  =   16
        SG_TAB1 = 'F d d 2'
        SG_TAB2 = 'Fdd2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.  5) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 12) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-X,3/4+Y,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 59) THEN
        NO_TAB  =   44
        NS_TAB  =    8
        SG_TAB1 = 'I m m 2'
        SG_TAB2 = 'Imm2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,-Y,Z'
        IF(IS.EQ.  4) OP =' -X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 60) THEN
        NO_TAB  =   45
        NS_TAB  =    8
        SG_TAB1 = 'I b a 2'
        SG_TAB2 = 'Iba2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 61) THEN
        NO_TAB  =   46
        NS_TAB  =    8
        SG_TAB1 = 'I m a 2'
        SG_TAB2 = 'Ima2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ.  4) OP =' 1/2-X,Y,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 62) THEN
        NO_TAB  =   47
        NS_TAB  =    8
        SG_TAB1 = 'P 2/m 2/m 2/m'
        SG_TAB2 = 'Pmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_12(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 63) THEN
        NO_TAB  =   48
        NS_TAB  =    8
        SG_TAB1 = 'P 2/n 2/n 2/n'
        SG_TAB2 = 'Pnnn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 64) THEN
        NO_TAB  =   49
        NS_TAB  =    8
        SG_TAB1 = 'P 2/c 2/c 2/m'
        SG_TAB2 = 'Pccm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 65) THEN
        NO_TAB  =   50
        NS_TAB  =    8
        SG_TAB1 = 'P 2/b 2/a 2/n'
        SG_TAB2 = 'Pban'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 66) THEN
        NO_TAB  =   51
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 2/m 2/a'
        SG_TAB2 = 'Pmma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 67) THEN
        NO_TAB  =   52
        NS_TAB  =    8
        SG_TAB1 = 'P 2/n 21/n 2/a'
        SG_TAB2 = 'Pnna'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 68) THEN
        NO_TAB  =   53
        NS_TAB  =    8
        SG_TAB1 = 'P 2/m 2/n 21/a'
        SG_TAB2 = 'Pmna'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 69) THEN
        NO_TAB  =   54
        NS_TAB  =    8
        SG_TAB1 = 'P 21/c 2/c 2/a'
        SG_TAB2 = 'Pcca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 70) THEN
        NO_TAB  =   55
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 21/a 2/m'
        SG_TAB2 = 'Pbam'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 71) THEN
        NO_TAB  =   56
        NS_TAB  =    8
        SG_TAB1 = 'P 21/c 21/c 2/n'
        SG_TAB2 = 'Pccn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 72) THEN
        NO_TAB  =   57
        NS_TAB  =    8
        SG_TAB1 = 'P 2/b 21/c 21/m'
        SG_TAB2 = 'Pbcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 73) THEN
        NO_TAB  =   58
        NS_TAB  =    8
        SG_TAB1 = 'P 21/n 21/n 2/m'
        SG_TAB2 = 'Pnnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 74) THEN
        NO_TAB  =   59
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 21/m 2/n'
        SG_TAB2 = 'Pmmn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,Y+1/2,-Z'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y+1/2,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 75) THEN
        NO_TAB  = 1059
        NS_TAB  =    8
        SG_TAB1 = 'P 21/m 21/m 2/n (2)'
        SG_TAB2 = 'Pmmn2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y+1/2,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 76) THEN
        NO_TAB  =   60
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 2/c 21/n'
        SG_TAB2 = 'Pbcn'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 77) THEN
        NO_TAB  =   61
        NS_TAB  =    8
        SG_TAB1 = 'P 21/b 21/c 21/a'
        SG_TAB2 = 'Pbca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 78) THEN
        NO_TAB  =   62
        NS_TAB  =    8
        SG_TAB1 = 'P 21/n 21/m 21/a'
        SG_TAB2 = 'Pnma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X+1/2,-Y,Z+1/2'
        IF(IS.EQ.  3) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  4) OP =' X+1/2,-Y+1/2,-Z+1/2'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,Y,-Z+1/2'
        IF(IS.EQ.  7) OP =' X,-Y+1/2,Z'
        IF(IS.EQ.  8) OP =' -X+1/2,Y+1/2,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ. 79) THEN
        NO_TAB  =   63
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/c 21/m'
        SG_TAB2 = 'Cmcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 80) THEN
        NO_TAB  =   64
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/c 21/a'
        SG_TAB2 = 'Cmca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 81) THEN
        NO_TAB  =   65
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/m 2/m'
        SG_TAB2 = 'Cmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 82) THEN
        NO_TAB  =   66
        NS_TAB  =   16
        SG_TAB1 = 'C 2/c 2/c 2/m'
        SG_TAB2 = 'Cccm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  4) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 83) THEN
        NO_TAB  =   67
        NS_TAB  =   16
        SG_TAB1 = 'C 2/m 2/m 2/a'
        SG_TAB2 = 'Cmma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 84) THEN
        NO_TAB  =   68
        NS_TAB  =   16
        SG_TAB1 = 'C 2/c 2/c 2/a'
        SG_TAB2 = 'Ccca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 12) OP =' X,-Y,-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 85) THEN
        NO_TAB  =   69
        NS_TAB  =   32
        SG_TAB1 = 'F 2/m 2/m 2/m'
        SG_TAB2 = 'Fmmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 20) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 21) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 23) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 30) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 31) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 32) OP =' 1/2-X,1/2+Y,Z'
        RETURN
      ENDIF
      IF(I.EQ. 86) THEN
        NO_TAB  =   70
        NS_TAB  =   32
        SG_TAB1 = 'F 2/d 2/d 2/d'
        SG_TAB2 = 'Fddd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.  8) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.  9) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 20) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 21) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ. 22) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ. 23) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 24) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ. 30) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ. 31) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 32) OP =' 3/4-X,3/4+Y,1/4+Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_13(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ. 87) THEN
        NO_TAB  =   71
        NS_TAB  =   16
        SG_TAB1 = 'I 2/m 2/m 2/m'
        SG_TAB2 = 'Immm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' X,-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 88) THEN
        NO_TAB  =   72
        NS_TAB  =   16
        SG_TAB1 = 'I 2/b 2/a 2/m'
        SG_TAB2 = 'Ibam'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' -X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 89) THEN
        NO_TAB  =   73
        NS_TAB  =   16
        SG_TAB1 = 'I 21/b 21/c 21/a'
        SG_TAB2 = 'Ibca'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 90) THEN
        NO_TAB  =   74
        NS_TAB  =   16
        SG_TAB1 = 'I 21/m 21/m 21/a'
        SG_TAB2 = 'Imma'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' X,1/2-Y,Z'
        IF(IS.EQ.  8) OP =' -X,Y,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 91) THEN
        NO_TAB  =   75
        NS_TAB  =    4
        SG_TAB1 = 'P 4'
        SG_TAB2 = 'P4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        RETURN
      ENDIF
      IF(I.EQ. 92) THEN
        NO_TAB  =   76
        NS_TAB  =    4
        SG_TAB1 = 'P 41'
        SG_TAB2 = 'P41'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 93) THEN
        NO_TAB  =   77
        NS_TAB  =    4
        SG_TAB1 = 'P 42'
        SG_TAB2 = 'P42'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 94) THEN
        NO_TAB  =   78
        NS_TAB  =    4
        SG_TAB1 = 'P 43'
        SG_TAB2 = 'P43'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,3/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 95) THEN
        NO_TAB  =   79
        NS_TAB  =    8
        SG_TAB1 = 'I 4'
        SG_TAB2 = 'I4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ. 96) THEN
        NO_TAB  =   80
        NS_TAB  =    8
        SG_TAB1 = 'I 41'
        SG_TAB2 = 'I41'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,-Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ.  8) OP =' Y,1/2-X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ. 97) THEN
        NO_TAB  =   81
        NS_TAB  =    4
        SG_TAB1 = 'P -4'
        SG_TAB2 = 'P-4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ. 98) THEN
        NO_TAB  =   82
        NS_TAB  =    8
        SG_TAB1 = 'I -4'
        SG_TAB2 = 'I-4'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2+X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ. 99) THEN
        NO_TAB  =   83
        NS_TAB  =    8
        SG_TAB1 = 'P 4/m'
        SG_TAB2 = 'P4/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.100) THEN
        NO_TAB  =   84
        NS_TAB  =    8
        SG_TAB1 = 'P 42/m'
        SG_TAB2 = 'P42/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,X,1/2-Z'
        RETURN
      ENDIF   
      IF(I.EQ.101) THEN
        NO_TAB  =   85
        NS_TAB  =    8
        SG_TAB1 = 'P 4/n'
        SG_TAB2 = 'P4/n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.102) THEN
        NO_TAB  =   86
        NS_TAB  =    8
        SG_TAB1 = 'P 42/n'
        SG_TAB2 = 'P42/n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.103) THEN
        NO_TAB  =   87
        NS_TAB  =   16
        SG_TAB1 = 'I 4/m'
        SG_TAB2 = 'I4/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,-Y,-Z'
        IF(IS.EQ.  6) OP =' X,Y,-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' -Y,X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.104) THEN
        NO_TAB  =   88
        NS_TAB  =   16
        SG_TAB1 = 'I 41/a'
        SG_TAB2 = 'I41/a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ.  7) OP =' Y,-X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 14) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.105) THEN
        NO_TAB  =   89
        NS_TAB  =    8
        SG_TAB1 = 'P 4 2 2'
        SG_TAB2 = 'P422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.106) THEN
        NO_TAB  =   90
        NS_TAB  =    8
        SG_TAB1 = 'P 4 21 2'
        SG_TAB2 = 'P4212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.107) THEN
        NO_TAB  =   91
        NS_TAB  =    8
        SG_TAB1 = 'P 41 2 2'
        SG_TAB2 = 'P4122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,3/4-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/4-Z'
        RETURN
      ENDIF
      IF(I.EQ.108) THEN
        NO_TAB  =   92
        NS_TAB  =    8
        SG_TAB1 = 'P 41 21 2'
        SG_TAB2 = 'P41212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.109) THEN
        NO_TAB  =   93
        NS_TAB  =    8
        SG_TAB1 = 'P 42 2 2'
        SG_TAB2 = 'P4222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.110) THEN
        NO_TAB  =   94
        NS_TAB  =    8
        SG_TAB1 = 'P 42 21 2'
        SG_TAB2 = 'P42212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.111) THEN
        NO_TAB  = 1094
        NS_TAB  =    8
        SG_TAB1 = 'P 42 21 2 (a)'
        SG_TAB2 = 'P42212a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X+1/2,1/2+Z'
        IF(IS.EQ.  4) OP =' Y+1/2,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  6) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.112) THEN
        NO_TAB  =   95
        NS_TAB  =    8
        SG_TAB1 = 'P 43 2 2'
        SG_TAB2 = 'P4322'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,X,3/4+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/4+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/4-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,3/4-Z'
        RETURN
      ENDIF
      IF(I.EQ.113) THEN
        NO_TAB  =   96
        NS_TAB  =    8
        SG_TAB1 = 'P 43 21 2'
        SG_TAB2 = 'P43212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,3/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,3/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.114) THEN
        NO_TAB  =   97
        NS_TAB  =   16
        SG_TAB1 = 'I 4 2 2'
        SG_TAB2 = 'I422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_14(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.115) THEN
        NO_TAB  =   98
        NS_TAB  =   16
        SG_TAB1 = 'I 41 2 2'
        SG_TAB2 = 'I4122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ. 15) OP =' Y,X,-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.116) THEN
        NO_TAB  =   99
        NS_TAB  =    8
        SG_TAB1 = 'P 4 m m'
        SG_TAB2 = 'P4mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.117) THEN
        NO_TAB  =  100
        NS_TAB  =    8
        SG_TAB1 = 'P 4 b m'
        SG_TAB2 = 'P4bm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.118) THEN
        NO_TAB  =  101
        NS_TAB  =    8
        SG_TAB1 = 'P 42 c m'
        SG_TAB2 = 'P42cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.119) THEN
        NO_TAB  =  102
        NS_TAB  =    8
        SG_TAB1 = 'P 42 n m'
        SG_TAB2 = 'P42nm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.120) THEN
        NO_TAB  =  103
        NS_TAB  =    8
        SG_TAB1 = 'P 4 c c'
        SG_TAB2 = 'P4cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.121) THEN
        NO_TAB  =  104
        NS_TAB  =    8
        SG_TAB1 = 'P 4 n c'
        SG_TAB2 = 'P4nc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.122) THEN
        NO_TAB  =  105
        NS_TAB  =    8
        SG_TAB1 = 'P 42 m c'
        SG_TAB2 = 'P42mc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.123) THEN
        NO_TAB  =  106
        NS_TAB  =    8
        SG_TAB1 = 'P 42 b c'
        SG_TAB2 = 'P42bc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.124) THEN
        NO_TAB  =  107
        NS_TAB  =   16
        SG_TAB1 = 'I 4 m m'
        SG_TAB2 = 'I4mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.125) THEN
        NO_TAB  =  108
        NS_TAB  =   16
        SG_TAB1 = 'I 4 c m'
        SG_TAB2 = 'I4cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.126) THEN
        NO_TAB  =  109
        NS_TAB  =   16
        SG_TAB1 = 'I 41 m d'
        SG_TAB2 = 'I41md'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.127) THEN
        NO_TAB  =  110
        NS_TAB  =   16
        SG_TAB1 = 'I 41 c d'
        SG_TAB2 = 'I41cd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' -Y,1/2-X,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,1/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -X,-Y,Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 12) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.128) THEN
        NO_TAB  =  111
        NS_TAB  =    8
        SG_TAB1 = 'P -4 2 m'
        SG_TAB2 = 'P-42m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.129) THEN
        NO_TAB  =  112
        NS_TAB  =    8
        SG_TAB1 = 'P -4 2 c'
        SG_TAB2 = 'P-42c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.130) THEN
        NO_TAB  =  113
        NS_TAB  =    8
        SG_TAB1 = 'P -4 21 m'
        SG_TAB2 = 'P-421m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_2(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.131) THEN
        NO_TAB  =  114
        NS_TAB  =    8
        SG_TAB1 = 'P -4 21 c'
        SG_TAB2 = 'P-421c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.132) THEN
        NO_TAB  =  115
        NS_TAB  =    8
        SG_TAB1 = 'P -4 m 2'
        SG_TAB2 = 'P-4m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' Y,-X,-Z'
        IF(IS.EQ.  4) OP =' -Y,X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.133) THEN
        NO_TAB  =  116
        NS_TAB  =    8
        SG_TAB1 = 'P -4 c 2'
        SG_TAB2 = 'P-4c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.134) THEN
        NO_TAB  =  117
        NS_TAB  =    8
        SG_TAB1 = 'P -4 b 2'
        SG_TAB2 = 'P-4b2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.135) THEN
        NO_TAB  =  118
        NS_TAB  =    8
        SG_TAB1 = 'P -4 n 2'
        SG_TAB2 = 'P-4n2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.136) THEN
        NO_TAB  =  119
        NS_TAB  =   16
        SG_TAB1 = 'I -4 m 2'
        SG_TAB2 = 'I-4m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.137) THEN
        NO_TAB  =  120
        NS_TAB  =   16
        SG_TAB1 = 'I -4 c 2'
        SG_TAB2 = 'I-4c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' X,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.138) THEN
        NO_TAB  =  121
        NS_TAB  =   16
        SG_TAB1 = 'I -4 2 m'
        SG_TAB2 = 'I-42m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y,X,Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.139) THEN
        NO_TAB  =  122
        NS_TAB  =   16
        SG_TAB1 = 'I -4 2 d'
        SG_TAB2 = 'I-42d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,-Z'
        IF(IS.EQ.  4) OP =' Y,-X,-Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ.  8) OP =' 1/2+Y,X,3/4+Z'
        IF(IS.EQ.  9) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 10) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 11) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 14) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ. 15) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.140) THEN
        NO_TAB  =  123
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 2/m 2/m'
        SG_TAB2 = 'P4/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.141) THEN
        NO_TAB  =  124
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 2/c 2/c'
        SG_TAB2 = 'P4/mcc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.142) THEN
        NO_TAB  =  125
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/b 2/m'
        SG_TAB2 = 'P4/nbm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.143) THEN
        NO_TAB  =  126
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/n 2/c'
        SG_TAB2 = 'P4/nnc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.144) THEN
        NO_TAB  =  127
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 21/b 2/m'
        SG_TAB2 = 'P4/mbm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.145) THEN
        NO_TAB  =  128
        NS_TAB  =   16
        SG_TAB1 = 'P 4/m 21/n 2/c'
        SG_TAB2 = 'P4/mnc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_21(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.146) THEN
        NO_TAB  =  129
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 21/m 2/m'
        SG_TAB2 = 'P4/nmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.147) THEN
        NO_TAB  =  130
        NS_TAB  =   16
        SG_TAB1 = 'P 4/n 2/c 2/c'
        SG_TAB2 = 'P4/ncc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.148) THEN
        NO_TAB  =  131
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 2/m 2/c'
        SG_TAB2 = 'P42/mmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.149) THEN
        NO_TAB  =  132
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 2/c 2/m'
        SG_TAB2 = 'P42/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.150) THEN
        NO_TAB  =  133
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 2/b 2/c'
        SG_TAB2 = 'P42/nbc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.151) THEN
        NO_TAB  =  134
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 2/n 2/m'
        SG_TAB2 = 'P42/nnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.152) THEN
        NO_TAB  =  135
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 21/b 2/c'
        SG_TAB2 = 'P42/mbc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.  4) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 12) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.153) THEN
        NO_TAB  =  136
        NS_TAB  =   16
        SG_TAB1 = 'P 42/m 21/n 2/m'
        SG_TAB2 = 'P42/mnm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,X+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' Y+1/2,1/2-X,Z+1/2'
        IF(IS.EQ.  5) OP =' 1/2-X,Y+1/2,1/2-Z'
        IF(IS.EQ.  6) OP =' X+1/2,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y+1/2,1/2-X,1/2-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,X+1/2,1/2-Z'
        IF(IS.EQ. 13) OP =' X+1/2,1/2-Y,Z+1/2'
        IF(IS.EQ. 14) OP =' 1/2-X,Y+1/2,Z+1/2'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.154) THEN
        NO_TAB  =  137
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 21/m 2/c'
        SG_TAB2 = 'P42/nmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.155) THEN
        NO_TAB  =  138
        NS_TAB  =   16
        SG_TAB1 = 'P 42/n 21/c 2/m'
        SG_TAB2 = 'P42/ncm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  6) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 16) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.156) THEN
        NO_TAB  =  139
        NS_TAB  =   32
        SG_TAB1 = 'I 4/m 2/m 2/m'
        SG_TAB2 = 'I4/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,-Y,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' -Y,-X,Z'
        IF(IS.EQ. 16) OP =' Y,X,Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 20) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 21) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 31) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,1/2+X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.157) THEN
        NO_TAB  =  140
        NS_TAB  =   32
        SG_TAB1 = 'I 4/m 2/c 2/m'
        SG_TAB2 = 'I4/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -Y,X,Z'
        IF(IS.EQ.  4) OP =' Y,-X,Z'
        IF(IS.EQ.  5) OP =' -X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,-Y,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' -Y,X,-Z'
        IF(IS.EQ. 13) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 16) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 20) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 21) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 31) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,1/2+X,Z'
        RETURN
      ENDIF
      IF(I.EQ.158) THEN
        NO_TAB  =  141
        NS_TAB  =   32
        SG_TAB1 = 'I 41/a 2/m 2/d'
        SG_TAB2 = 'I41/amd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,3/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,1/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,-Z'
        IF(IS.EQ.  9) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,3/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' -X,-Y,Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 20) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 21) OP =' -X,1/2+Y,1/4-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,-Y,3/4-Z'
        IF(IS.EQ. 23) OP =' Y,X,-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' -Y,X,-Z'
        IF(IS.EQ. 29) OP =' X,-Y,Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 31) OP =' -Y,1/2-X,1/4+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,X,3/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.159) THEN
        NO_TAB  =  142
        NS_TAB  =   32
        SG_TAB1 = 'I 41/a 2/c 2/d'
        SG_TAB2 = 'I41/acd'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -Y,1/2+X,1/4+Z'
        IF(IS.EQ.  4) OP =' 1/2+Y,-X,3/4+Z'
        IF(IS.EQ.  5) OP =' 1/2-X,Y,1/4-Z'
        IF(IS.EQ.  6) OP =' X,1/2-Y,3/4-Z'
        IF(IS.EQ.  7) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.  8) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,1/2-Y,1/4-Z'
        IF(IS.EQ. 10) OP =' 1/2+X,Y,3/4-Z'
        IF(IS.EQ. 11) OP =' Y,-X,-Z'
        IF(IS.EQ. 12) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 14) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-Y,-X,1/4+Z'
        IF(IS.EQ. 16) OP =' Y,1/2+X,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 18) OP =' -X,-Y,Z'
        IF(IS.EQ. 19) OP =' 1/2-Y,X,3/4+Z'
        IF(IS.EQ. 20) OP =' Y,1/2-X,1/4+Z'
        IF(IS.EQ. 21) OP =' -X,1/2+Y,3/4-Z'
        IF(IS.EQ. 22) OP =' 1/2+X,-Y,1/4-Z'
        IF(IS.EQ. 23) OP =' Y,X,1/2-Z'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 25) OP =' 1/2-X,-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' X,1/2+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 28) OP =' -Y,X,-Z'
        IF(IS.EQ. 29) OP =' X,-Y,1/2+Z'
        IF(IS.EQ. 30) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 31) OP =' -Y,1/2-X,3/4+Z'
        IF(IS.EQ. 32) OP =' 1/2+Y,X,1/4+Z'
        RETURN
      ENDIF
      IF(I.EQ.160) THEN
        NO_TAB  =  143
        NS_TAB  =    3
        SG_TAB1 = 'P 3'
        SG_TAB2 = 'P3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.161) THEN
        NO_TAB  =  144
        NS_TAB  =    3
        SG_TAB1 = 'P 31'
        SG_TAB2 = 'P31'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        RETURN
      ENDIF
      IF(I.EQ.162) THEN
        NO_TAB  =  145
        NS_TAB  =    3
        SG_TAB1 = 'P 32'
        SG_TAB2 = 'P32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_22(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.163) THEN
        NO_TAB  =  146
        NS_TAB  =    9
        SG_TAB1 = 'H 3'
        SG_TAB2 = 'H3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X+2/3,Y+1/3,Z+1/3'
        IF(IS.EQ.  5) OP =' -Y+2/3,X-Y+1/3,Z+1/3'
        IF(IS.EQ.  6) OP =' Y-X+2/3,-X+1/3,Z+1/3'
        IF(IS.EQ.  7) OP =' X+1/3,Y+2/3,Z+2/3'
        IF(IS.EQ.  8) OP =' -Y+1/3,X-Y+2/3,Z+2/3'
        IF(IS.EQ.  9) OP =' Y-X+1/3,-X+2/3,Z+2/3'
        RETURN
      ENDIF
      IF(I.EQ.164) THEN
        NO_TAB  = 1146
        NS_TAB  =    3
        SG_TAB1 = 'R 3'
        SG_TAB2 = 'R3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' Z,X,Y'
        IF(IS.EQ.  3) OP =' Y,Z,X'
        RETURN
      ENDIF
      IF(I.EQ.165) THEN
        NO_TAB  =  147
        NS_TAB  =    6
        SG_TAB1 = 'P -3'
        SG_TAB2 = 'P-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  6) OP =' X-Y,X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.166) THEN
        NO_TAB  =  148
        NS_TAB  =   18
        SG_TAB1 = 'R -3'
        SG_TAB2 = 'R-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  6) OP =' X-Y,X,-Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 11) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 12) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 17) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 18) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.167) THEN
        NO_TAB  =  149
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 2'
        SG_TAB2 = 'P312'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.168) THEN
        NO_TAB  =  150
        NS_TAB  =    6
        SG_TAB1 = 'P 3 2 1'
        SG_TAB2 = 'P321'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.169) THEN
        NO_TAB  =  151
        NS_TAB  =    6
        SG_TAB1 = 'P 31 1 2'
        SG_TAB2 = 'P3112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -Y,-X,2/3-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/3-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.170) THEN
        NO_TAB  =  152
        NS_TAB  =    6
        SG_TAB1 = 'P 31 2 1'
        SG_TAB2 = 'P3121'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,2/3-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.171) THEN
        NO_TAB  =  153
        NS_TAB  =    6
        SG_TAB1 = 'P 32 1 2'
        SG_TAB2 = 'P3212'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/3-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,2/3-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.172) THEN
        NO_TAB  =  154
        NS_TAB  =    6
        SG_TAB1 = 'P 32 2 1'
        SG_TAB2 = 'P3221'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/3-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.173) THEN
        NO_TAB  =  155
        NS_TAB  =   18
        SG_TAB1 = 'H 3 2'
        SG_TAB2 = 'H32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3+Y,1/3+X,1/3-Z'
        IF(IS.EQ. 11) OP =' 2/3+X-Y,1/3-Y,1/3-Z'
        IF(IS.EQ. 12) OP =' 2/3-X,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3+Y,2/3+X,2/3-Z'
        IF(IS.EQ. 17) OP =' 1/3+X-Y,2/3-Y,2/3-Z'
        IF(IS.EQ. 18) OP =' 1/3-X,2/3+Y-X,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.174) THEN
        NO_TAB  = 1155
        NS_TAB  =    6
        SG_TAB1 = 'R 3 2'
        SG_TAB2 = 'R32'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' Z,X,Y'
        IF(IS.EQ.  3) OP =' Y,Z,X'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' -Z,-Y,-X'
        IF(IS.EQ.  6) OP =' -X,-Z,-Y'
        RETURN
      ENDIF
      IF(I.EQ.175) THEN
        NO_TAB  =  156
        NS_TAB  =    6
        SG_TAB1 = 'P 3 m 1'
        SG_TAB2 = 'P3m1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,Z'
        IF(IS.EQ.  6) OP =' X,X-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.176) THEN
        NO_TAB  =  157
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 m'
        SG_TAB2 = 'P31m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.177) THEN
        NO_TAB  =  158
        NS_TAB  =    6
        SG_TAB1 = 'P 3 c 1'
        SG_TAB2 = 'P3c1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.178) THEN
        NO_TAB  =  159
        NS_TAB  =    6
        SG_TAB1 = 'P 3 1 c'
        SG_TAB2 = 'P31c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2+Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.179) THEN
        NO_TAB  =  160
        NS_TAB  =   18
        SG_TAB1 = 'R 3 m'
        SG_TAB2 = 'R3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,Z'
        IF(IS.EQ.  6) OP =' X,X-Y,Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-Y,1/3-X,1/3+Z'
        IF(IS.EQ. 11) OP =' 2/3+Y-X,1/3+Y,1/3+Z'
        IF(IS.EQ. 12) OP =' 2/3+X,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-Y,2/3-X,2/3+Z'
        IF(IS.EQ. 17) OP =' 1/3+Y-X,2/3+Y,2/3+Z'
        IF(IS.EQ. 18) OP =' 1/3+X,2/3+X-Y,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.180) THEN
        NO_TAB  =  161
        NS_TAB  =   18
        SG_TAB1 = 'R 3 c'
        SG_TAB2 = 'R3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ.  7) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ.  8) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ.  9) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 10) OP =' 2/3-Y,1/3-X,5/6+Z'
        IF(IS.EQ. 11) OP =' 2/3+Y-X,1/3+Y,5/6+Z'
        IF(IS.EQ. 12) OP =' 2/3+X,1/3+X-Y,5/6+Z'
        IF(IS.EQ. 13) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 14) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 15) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 16) OP =' 1/3-Y,2/3-X,1/6+Z'
        IF(IS.EQ. 17) OP =' 1/3+Y-X,2/3+Y,1/6+Z'
        IF(IS.EQ. 18) OP =' 1/3+X,2/3+X-Y,1/6+Z'
        RETURN
      ENDIF
      IF(I.EQ.181) THEN
        NO_TAB  =  162
        NS_TAB  =   12
        SG_TAB1 = 'P -31 2/m'
        SG_TAB2 = 'P-31m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.182) THEN
        NO_TAB  =  163
        NS_TAB  =   12
        SG_TAB1 = 'P -31 2/c'
        SG_TAB2 = 'P-31c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.  5) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ.  6) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.183) THEN
        NO_TAB  =  164
        NS_TAB  =   12
        SG_TAB1 = 'P -3 2/m 1'
        SG_TAB2 = 'P-3m1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,Z'
        IF(IS.EQ. 12) OP =' X,X-Y,Z'
        RETURN
      ENDIF
      IF(I.EQ.184) THEN
        NO_TAB  =  165
        NS_TAB  =   12
        SG_TAB1 = 'P -3 2/c 1'
        SG_TAB2 = 'P-3c1'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.185) THEN
        NO_TAB  =  166
        NS_TAB  =   36
        SG_TAB1 = 'R -3 2/m'
        SG_TAB2 = 'R-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,Z'
        IF(IS.EQ. 12) OP =' X,X-Y,Z'
        IF(IS.EQ. 13) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ. 14) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 15) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 16) OP =' 2/3+Y,1/3+X,1/3-Z'
        IF(IS.EQ. 17) OP =' 2/3+X-Y,1/3-Y,1/3-Z'
        IF(IS.EQ. 18) OP =' 2/3-X,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 19) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 20) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 21) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 22) OP =' 2/3-Y,1/3-X,1/3+Z'
        IF(IS.EQ. 23) OP =' 2/3+Y-X,1/3+Y,1/3+Z'
        IF(IS.EQ. 24) OP =' 2/3+X,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 25) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 26) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 27) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 28) OP =' 1/3+Y,2/3+X,2/3-Z'
        IF(IS.EQ. 29) OP =' 1/3+X-Y,2/3-Y,2/3-Z'
        IF(IS.EQ. 30) OP =' 1/3-X,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 31) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 32) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 33) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        IF(IS.EQ. 34) OP =' 1/3-Y,2/3-X,2/3+Z'
        IF(IS.EQ. 35) OP =' 1/3+Y-X,2/3+Y,2/3+Z'
        IF(IS.EQ. 36) OP =' 1/3+X,2/3+X-Y,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.186) THEN
        NO_TAB  =  167
        NS_TAB  =   36
        SG_TAB1 = 'R -3 2/c'
        SG_TAB2 = 'R-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  5) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 13) OP =' 2/3+X,1/3+Y,1/3+Z'
        IF(IS.EQ. 14) OP =' 2/3-Y,1/3+X-Y,1/3+Z'
        IF(IS.EQ. 15) OP =' 2/3+Y-X,1/3-X,1/3+Z'
        IF(IS.EQ. 16) OP =' 2/3+Y,1/3+X,5/6-Z'
        IF(IS.EQ. 17) OP =' 2/3+X-Y,1/3-Y,5/6-Z'
        IF(IS.EQ. 18) OP =' 2/3-X,1/3+Y-X,5/6-Z'
        IF(IS.EQ. 19) OP =' 2/3-X,1/3-Y,1/3-Z'
        IF(IS.EQ. 20) OP =' 2/3+Y,1/3+Y-X,1/3-Z'
        IF(IS.EQ. 21) OP =' 2/3+X-Y,1/3+X,1/3-Z'
        IF(IS.EQ. 22) OP =' 2/3-Y,1/3-X,5/6+Z'
        IF(IS.EQ. 23) OP =' 2/3+Y-X,1/3+Y,5/6+Z'
        IF(IS.EQ. 24) OP =' 2/3+X,1/3+X-Y,5/6+Z'
        IF(IS.EQ. 25) OP =' 1/3+X,2/3+Y,2/3+Z'
        IF(IS.EQ. 26) OP =' 1/3-Y,2/3+X-Y,2/3+Z'
        IF(IS.EQ. 27) OP =' 1/3+Y-X,2/3-X,2/3+Z'
        IF(IS.EQ. 28) OP =' 1/3+Y,2/3+X,1/6-Z'
        IF(IS.EQ. 29) OP =' 1/3+X-Y,2/3-Y,1/6-Z'
        IF(IS.EQ. 30) OP =' 1/3-X,2/3+Y-X,1/6-Z'
        IF(IS.EQ. 31) OP =' 1/3-X,2/3-Y,2/3-Z'
        IF(IS.EQ. 32) OP =' 1/3+Y,2/3+Y-X,2/3-Z'
        IF(IS.EQ. 33) OP =' 1/3+X-Y,2/3+X,2/3-Z'
        IF(IS.EQ. 34) OP =' 1/3-Y,2/3-X,1/6+Z'
        IF(IS.EQ. 35) OP =' 1/3+Y-X,2/3+Y,1/6+Z'
        IF(IS.EQ. 36) OP =' 1/3+X,2/3+X-Y,1/6+Z'
        RETURN
      ENDIF
      IF(I.EQ.187) THEN
        NO_TAB  =  168
        NS_TAB  =    6
        SG_TAB1 = 'P 6'
        SG_TAB2 = 'P6'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        RETURN
      ENDIF
      IF(I.EQ.188) THEN
        NO_TAB  =  169
        NS_TAB  =    6
        SG_TAB1 = 'P 61'
        SG_TAB2 = 'P61'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+1/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+2/3'
        IF(IS.EQ.  4) OP =' -X,-Y,Z+1/2'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z+5/6'
        IF(IS.EQ.  6) OP =' X-Y,X,Z+1/6'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_23(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.189) THEN
        NO_TAB  =  170
        NS_TAB  =    6
        SG_TAB1 = 'P 65'
        SG_TAB2 = 'P65'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z+2/3'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z+1/3'
        IF(IS.EQ.  4) OP =' -X,-Y,Z+1/2'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z+1/6'
        IF(IS.EQ.  6) OP =' X-Y,X,Z+5/6'
        RETURN
      ENDIF
      IF(I.EQ.190) THEN
        NO_TAB  =  171
        NS_TAB  =    6
        SG_TAB1 = 'P 62'
        SG_TAB2 = 'P62'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,2/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.191) THEN
        NO_TAB  =  172
        NS_TAB  =    6
        SG_TAB1 = 'P 64'
        SG_TAB2 = 'P64'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,2/3+Z'
        RETURN
      ENDIF
      IF(I.EQ.192) THEN
        NO_TAB  =  173
        NS_TAB  =    6
        SG_TAB1 = 'P 63'
        SG_TAB2 = 'P63'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.193) THEN
        NO_TAB  =  174
        NS_TAB  =    6
        SG_TAB1 = 'P -6'
        SG_TAB2 = 'P-6'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.194) THEN
        NO_TAB  =  175
        NS_TAB  =   12
        SG_TAB1 = 'P 6/m'
        SG_TAB2 = 'P6/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' X,Y,-Z'
        IF(IS.EQ. 11) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 12) OP =' Y-X,-X,-Z'
        RETURN
      ENDIF
      IF(I.EQ.195) THEN
        NO_TAB  =  176
        NS_TAB  =   12
        SG_TAB1 = 'P 63/m'
        SG_TAB2 = 'P63/m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -X,-Y,-Z'
        IF(IS.EQ.  8) OP =' Y,Y-X,-Z'
        IF(IS.EQ.  9) OP =' X-Y,X,-Z'
        IF(IS.EQ. 10) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 11) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 12) OP =' Y-X,-X,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.196) THEN
        NO_TAB  =  177
        NS_TAB  =   12
        SG_TAB1 = 'P 6 2 2'
        SG_TAB2 = 'P622'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.197) THEN
        NO_TAB  =  178
        NS_TAB  =   12
        SG_TAB1 = 'P 61 2 2'
        SG_TAB2 = 'P6122'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,5/6+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/6+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,2/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,5/6-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/6-Z'
        RETURN
      ENDIF
      IF(I.EQ.198) THEN
        NO_TAB  =  179
        NS_TAB  =   12
        SG_TAB1 = 'P 65 2 2'
        SG_TAB2 = 'P6522'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/6+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,5/6+Z'
        IF(IS.EQ.  7) OP =' Y,X,2/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/6-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,5/6-Z'
        RETURN
      ENDIF
      IF(I.EQ.199) THEN
        NO_TAB  =  180
        NS_TAB  =   12
        SG_TAB1 = 'P 62 2 2'
        SG_TAB2 = 'P6222'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,2/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,1/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,2/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/3+Z'
        IF(IS.EQ.  7) OP =' Y,X,2/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,2/3-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.200) THEN
        NO_TAB  =  181
        NS_TAB  =   12
        SG_TAB1 = 'P 64 2 2'
        SG_TAB2 = 'P6422'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,1/3+Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,2/3+Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/3+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,2/3+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/3-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,2/3-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/3-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,2/3-Z'
        RETURN
      ENDIF
      IF(I.EQ.201) THEN
        NO_TAB  =  182
        NS_TAB  =   12
        SG_TAB1 = 'P 63 2 2'
        SG_TAB2 = 'P6322'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.202) THEN
        NO_TAB  =  183
        NS_TAB  =   12
        SG_TAB1 = 'P 6 m m'
        SG_TAB2 = 'P6mm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_24(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.203) THEN
        NO_TAB  =  184
        NS_TAB  =   12
        SG_TAB1 = 'P 6 c c'
        SG_TAB2 = 'P6cc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.204) THEN
        NO_TAB  =  185
        NS_TAB  =   12
        SG_TAB1 = 'P 63 c m'
        SG_TAB2 = 'P63cm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.205) THEN
        NO_TAB  =  186
        NS_TAB  =   12
        SG_TAB1 = 'P 63 m c'
        SG_TAB2 = 'P63mc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.206) THEN
        NO_TAB  =  187
        NS_TAB  =   12
        SG_TAB1 = 'P -6 m 2'
        SG_TAB2 = 'P-6m2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,Z'
        IF(IS.EQ.  9) OP =' X,X-Y,Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.207) THEN
        NO_TAB  =  188
        NS_TAB  =   12
        SG_TAB1 = 'P -6 c 2'
        SG_TAB2 = 'P-6c2'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ.  7) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.  8) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ.  9) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.208) THEN
        NO_TAB  =  189
        NS_TAB  =   12
        SG_TAB1 = 'P -6 2 m'
        SG_TAB2 = 'P-62m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.209) THEN
        NO_TAB  =  190
        NS_TAB  =   12
        SG_TAB1 = 'P -6 2 c'
        SG_TAB2 = 'P-62c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' X,Y,1/2-Z'
        IF(IS.EQ.  5) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ.  6) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 11) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 12) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.210) THEN
        NO_TAB  =  191
        NS_TAB  =   24
        SG_TAB1 = 'P 6/m 2/m 2/m'
        SG_TAB2 = 'P6/mmm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,Z'
        IF(IS.EQ. 21) OP =' X,X-Y,Z'
        IF(IS.EQ. 22) OP =' Y,X,Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.211) THEN
        NO_TAB  =  192
        NS_TAB  =   24
        SG_TAB1 = 'P 6/m 2/c 2/c'
        SG_TAB2 = 'P6/mcc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,Z'
        IF(IS.EQ.  6) OP =' X-Y,X,Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 21) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 22) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.212) THEN
        NO_TAB  =  193
        NS_TAB  =   24
        SG_TAB1 = 'P 63/m 2/c 2/m'
        SG_TAB2 = 'P63/mcm'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,1/2-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,1/2-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,1/2-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,1/2+Z'
        IF(IS.EQ. 21) OP =' X,X-Y,1/2+Z'
        IF(IS.EQ. 22) OP =' Y,X,Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,Z'
        RETURN
      ENDIF
      IF(I.EQ.213) THEN
        NO_TAB  =  194
        NS_TAB  =   24
        SG_TAB1 = 'P 63/m 2/m 2/c'
        SG_TAB2 = 'P63/mmc'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -Y,X-Y,Z'
        IF(IS.EQ.  3) OP =' Y-X,-X,Z'
        IF(IS.EQ.  4) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ.  5) OP =' Y,Y-X,1/2+Z'
        IF(IS.EQ.  6) OP =' X-Y,X,1/2+Z'
        IF(IS.EQ.  7) OP =' Y,X,-Z'
        IF(IS.EQ.  8) OP =' X-Y,-Y,-Z'
        IF(IS.EQ.  9) OP =' -X,Y-X,-Z'
        IF(IS.EQ. 10) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ. 11) OP =' Y-X,Y,1/2-Z'
        IF(IS.EQ. 12) OP =' X,X-Y,1/2-Z'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' Y,Y-X,-Z'
        IF(IS.EQ. 15) OP =' X-Y,X,-Z'
        IF(IS.EQ. 16) OP =' X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Y-X,-X,1/2-Z'
        IF(IS.EQ. 18) OP =' -Y,X-Y,1/2-Z'
        IF(IS.EQ. 19) OP =' -Y,-X,Z'
        IF(IS.EQ. 20) OP =' Y-X,Y,Z'
        IF(IS.EQ. 21) OP =' X,X-Y,Z'
        IF(IS.EQ. 22) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 23) OP =' X-Y,-Y,1/2+Z'
        IF(IS.EQ. 24) OP =' -X,Y-X,1/2+Z'
        RETURN
      ENDIF
      IF(I.EQ.214) THEN
        NO_TAB  =  195
        NS_TAB  =   12
        SG_TAB1 = 'P 2 3'
        SG_TAB2 = 'P23'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        RETURN
      ENDIF
      IF(I.EQ.215) THEN
        NO_TAB  =  196
        NS_TAB  =   48
        SG_TAB1 = 'F 2 3'
        SG_TAB2 = 'F23'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 16) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 19) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 20) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 21) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 23) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 24) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 25) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 38) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 39) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 40) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 41) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 42) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 43) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 44) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 45) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 46) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 47) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 48) OP =' 1/2-Y,1/2-Z,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_3(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.216) THEN
        NO_TAB  =  197
        NS_TAB  =   24
        SG_TAB1 = 'I 2 3'
        SG_TAB2 = 'I23'
        SG_TAB3 = 'I 23'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Y,1/2-Z,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.217) THEN
        NO_TAB  = 1197
        NS_TAB  =   24
        SG_TAB1 = 'I 2 3 (a)'
        SG_TAB2 = 'I23a'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,-Y,-Z'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,-Z'
        IF(IS.EQ.  5) OP =' Y,Z,X'
        IF(IS.EQ.  6) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.  7) OP =' Y+1/2,-Z,-X'
        IF(IS.EQ.  8) OP =' -Y,Z+1/2,-X'
        IF(IS.EQ.  9) OP =' Z,X,Y'
        IF(IS.EQ. 10) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 11) OP =' Z+1/2,-X,-Y'
        IF(IS.EQ. 12) OP =' -Z,X+1/2,-Y'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,-Y,1/2+Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 18) OP =' -Y,-Z,1/2+X'
        IF(IS.EQ. 19) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 20) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 22) OP =' -Z,-X,1/2+Y'
        IF(IS.EQ. 23) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 24) OP =' 1/2-Z,X,1/2-Y'
        RETURN
      ENDIF
      IF(I.EQ.218) THEN
        NO_TAB  =  198
        NS_TAB  =   12
        SG_TAB1 = 'P 21 3'
        SG_TAB2 = 'P213'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.219) THEN
        NO_TAB  =  199
        NS_TAB  =   24
        SG_TAB1 = 'I 21 3'
        SG_TAB2 = 'I213'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 14) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 15) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 16) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 18) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 19) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 20) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 21) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 23) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 24) OP =' -Y,1/2-Z,X'
        RETURN
      ENDIF
      IF(I.EQ.220) THEN
        NO_TAB  =  200
        NS_TAB  =   24
        SG_TAB1 = 'P 2/m -3'
        SG_TAB2 = 'Pm-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        RETURN
      ENDIF
      IF(I.EQ.221) THEN
        NO_TAB  =  201
        NS_TAB  =   24
        SG_TAB1 = 'P 2/n -3'
        SG_TAB2 = 'Pn-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2+Y,1/2+Z,1/2-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_31(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.222) THEN
        NO_TAB  =  202
        NS_TAB  =   96
        SG_TAB1 = 'F 2/m -3'
        SG_TAB2 = 'Fm-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 39) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 40) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 41) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 43) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 44) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 45) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 47) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 48) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ. 86) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ. 87) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ. 88) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 89) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ. 90) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 91) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ. 92) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ. 93) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ. 94) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ. 95) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 96) OP =' 1/2+Y,1/2+Z,-X'
        RETURN
      ENDIF
      IF(I.EQ.223) THEN
        NO_TAB  =  203
        NS_TAB  =   96
        SG_TAB1 = 'F 2/d -3'
        SG_TAB2 = 'Fd-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 14) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ. 17) OP =' 1/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ. 21) OP =' 1/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 38) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 39) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ. 40) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ. 41) OP =' 1/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 42) OP =' 1/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 44) OP =' 1/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ. 45) OP =' 1/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 46) OP =' 1/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ. 47) OP =' 1/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ. 62) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 67) OP =' 3/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 69) OP =' 3/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 72) OP =' 3/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ. 86) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ. 87) OP =' 3/4+X,3/4-Y,Z+1/4'
        IF(IS.EQ. 88) OP =' 3/4-X,3/4+Y,Z+1/4'
        IF(IS.EQ. 89) OP =' 3/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ. 90) OP =' 3/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 91) OP =' 3/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ. 92) OP =' 3/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 93) OP =' 3/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ. 94) OP =' 3/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 95) OP =' 3/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 96) OP =' 3/4+Y,3/4+Z,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.224) THEN
        NO_TAB  =  204
        NS_TAB  =   48
        SG_TAB1 = 'I 2/m -3'
        SG_TAB2 = 'Im-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' X,Y,-Z'
        IF(IS.EQ. 15) OP =' X,-Y,Z'
        IF(IS.EQ. 16) OP =' -X,Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' -Z,X,Y'
        IF(IS.EQ. 19) OP =' Z,X,-Y'
        IF(IS.EQ. 20) OP =' Z,-X,Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,-Z,X'
        IF(IS.EQ. 23) OP =' -Y,Z,X'
        IF(IS.EQ. 24) OP =' Y,Z,-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 39) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 40) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 43) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 44) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 45) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 47) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 48) OP =' 1/2+Y,1/2+Z,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.225) THEN
        NO_TAB  =  205
        NS_TAB  =   24
        SG_TAB1 = 'P 21/a -3'
        SG_TAB2 = 'Pa-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 20) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 24) OP =' 1/2+Y,Z,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.226) THEN
        NO_TAB  =  206
        NS_TAB  =   48
        SG_TAB1 = 'I 21/a -3'
        SG_TAB2 = 'Ia-3'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' -X,-Y,-Z'
        IF(IS.EQ. 14) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 15) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 17) OP =' -Z,-X,-Y'
        IF(IS.EQ. 18) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 19) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 20) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 21) OP =' -Y,-Z,-X'
        IF(IS.EQ. 22) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 24) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,+Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 38) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 39) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 40) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 42) OP =' -Z,X,1/2+Y'
        IF(IS.EQ. 43) OP =' Z,1/2+X,-Y'
        IF(IS.EQ. 44) OP =' 1/2+Z,-X,Y'
        IF(IS.EQ. 45) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Y,-Z,X'
        IF(IS.EQ. 47) OP =' -Y,Z,1/2+X'
        IF(IS.EQ. 48) OP =' Y,1/2+Z,-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_32(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.227) THEN
        NO_TAB  =  207
        NS_TAB  =   24
        SG_TAB1 = 'P 4 3 2'
        SG_TAB2 = 'P432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        RETURN
      ENDIF
      IF(I.EQ.228) THEN
        NO_TAB  =  208
        NS_TAB  =   24
        SG_TAB1 = 'P 42 3 2'
        SG_TAB2 = 'P4232'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.229) THEN
        NO_TAB  =  209
        NS_TAB  =   96
        SG_TAB1 = 'F 4 3 2'
        SG_TAB2 = 'F432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' Y,1/2+X,1/2-Z'
        IF(IS.EQ. 38) OP =' -Y,1/2-X,1/2-Z'
        IF(IS.EQ. 39) OP =' Y,1/2-X,1/2+Z'
        IF(IS.EQ. 40) OP =' -Y,1/2+X,1/2+Z'
        IF(IS.EQ. 41) OP =' X,1/2+Z,1/2-Y'
        IF(IS.EQ. 42) OP =' -X,1/2+Z,1/2+Y'
        IF(IS.EQ. 43) OP =' -X,1/2-Z,1/2-Y'
        IF(IS.EQ. 44) OP =' X,1/2-Z,1/2+Y'
        IF(IS.EQ. 45) OP =' Z,1/2+Y,1/2-X'
        IF(IS.EQ. 46) OP =' Z,1/2-Y,1/2+X'
        IF(IS.EQ. 47) OP =' -Z,1/2+Y,1/2+X'
        IF(IS.EQ. 48) OP =' -Z,1/2-Y,1/2-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ. 86) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ. 87) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ. 88) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ. 89) OP =' 1/2+X,1/2+Z,-Y'
        IF(IS.EQ. 90) OP =' 1/2-X,1/2+Z,Y'
        IF(IS.EQ. 91) OP =' 1/2-X,1/2-Z,-Y'
        IF(IS.EQ. 92) OP =' 1/2+X,1/2-Z,Y'
        IF(IS.EQ. 93) OP =' 1/2+Z,1/2+Y,-X'
        IF(IS.EQ. 94) OP =' 1/2+Z,1/2-Y,X'
        IF(IS.EQ. 95) OP =' 1/2-Z,1/2+Y,X'
        IF(IS.EQ. 96) OP =' 1/2-Z,1/2-Y,-X'
        RETURN
      ENDIF
      IF(I.EQ.230) THEN
        NO_TAB  =  210
        NS_TAB  =   96
        SG_TAB1 = 'F 41 3 2'
        SG_TAB2 = 'F4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 31) OP =' -Z,-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 36) OP =' -Y,-Z,X'
        IF(IS.EQ. 37) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 38) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 39) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 40) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 41) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 42) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 44) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 45) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 46) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 47) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,-Y,-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,-X,-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,-Z,-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 61) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 75) OP =' -X,Y,-Z'
        IF(IS.EQ. 76) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 80) OP =' -Z,X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' -Y,Z,-X'
        IF(IS.EQ. 83) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 85) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 86) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ. 87) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 88) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ. 89) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 90) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ. 91) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ. 92) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 93) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 94) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 95) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ. 96) OP =' 3/4-Z,3/4-Y,1/4-X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_33(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.231) THEN
        NO_TAB  =  211
        NS_TAB  =   48
        SG_TAB1 = 'I 4 3 2'
        SG_TAB2 = 'I432'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 41) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 42) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 43) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 44) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 46) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 47) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 48) OP =' 1/2-Z,1/2-Y,1/2-X'
        RETURN
      ENDIF
      IF(I.EQ.232) THEN
        NO_TAB  =  212
        NS_TAB  =   24
        SG_TAB1 = 'P 43 3 2'
        SG_TAB2 = 'P4332'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 17) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 21) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.233) THEN
        NO_TAB  =  213
        NS_TAB  =   24
        SG_TAB1 = 'P 41 3 2'
        SG_TAB2 = 'P4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        RETURN
      ENDIF
      IF(I.EQ.234) THEN
        NO_TAB  =  214
        NS_TAB  =   48
        SG_TAB1 = 'I 41 3 2'
        SG_TAB2 = 'I4132'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 38) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 39) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 40) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 41) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 42) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 43) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 44) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 45) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 46) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 47) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 48) OP =' 1/4-Z,1/4-Y,1/4-X'
        RETURN
      ENDIF
      IF(I.EQ.235) THEN
        NO_TAB  =  215
        NS_TAB  =   24
        SG_TAB1 = 'P -4 3 m'
        SG_TAB2 = 'P-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_34(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.236) THEN
        NO_TAB  =  216
        NS_TAB  =   96
        SG_TAB1 = 'F -4 3 m'
        SG_TAB2 = 'F-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 38) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ. 39) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ. 40) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 41) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 42) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 43) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ. 44) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ. 45) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 46) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ. 47) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 48) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ. 86) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 87) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 88) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ. 89) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ. 90) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ. 92) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2+Z,1/2+Y,X'
        IF(IS.EQ. 94) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ. 95) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ. 96) OP =' 1/2-Z,1/2-Y,X'
        RETURN
      ENDIF
      IF(I.EQ.237) THEN
        NO_TAB  =  217
        NS_TAB  =   48
        SG_TAB1 = 'I -4 3 m'
        SG_TAB2 = 'I-43m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,Z'
        IF(IS.EQ. 14) OP =' -Y,-X,Z'
        IF(IS.EQ. 15) OP =' Y,-X,-Z'
        IF(IS.EQ. 16) OP =' -Y,X,-Z'
        IF(IS.EQ. 17) OP =' X,Z,Y'
        IF(IS.EQ. 18) OP =' -X,Z,-Y'
        IF(IS.EQ. 19) OP =' -X,-Z,Y'
        IF(IS.EQ. 20) OP =' X,-Z,-Y'
        IF(IS.EQ. 21) OP =' Z,Y,X'
        IF(IS.EQ. 22) OP =' Z,-Y,-X'
        IF(IS.EQ. 23) OP =' -Z,Y,-X'
        IF(IS.EQ. 24) OP =' -Z,-Y,X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2-Z,1/2-Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.238) THEN
        NO_TAB  =  218
        NS_TAB  =   24
        SG_TAB1 = 'P -4 3 n'
        SG_TAB2 = 'P-43n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.239) THEN
        NO_TAB  =  219
        NS_TAB  =   96
        SG_TAB1 = 'F -4 3 c'
        SG_TAB2 = 'F-43c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 25) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 27) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 28) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 32) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 33) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 35) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 37) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 38) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ. 39) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ. 40) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 41) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 42) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 43) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ. 44) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ. 45) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 46) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ. 47) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 48) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ. 49) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 61) OP =' Y,1/2+X,Z'
        IF(IS.EQ. 62) OP =' -Y,1/2-X,Z'
        IF(IS.EQ. 63) OP =' Y,1/2-X,-Z'
        IF(IS.EQ. 64) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ. 65) OP =' X,1/2+Z,Y'
        IF(IS.EQ. 66) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ. 67) OP =' -X,1/2-Z,Y'
        IF(IS.EQ. 68) OP =' X,1/2-Z,-Y'
        IF(IS.EQ. 69) OP =' Z,1/2+Y,X'
        IF(IS.EQ. 70) OP =' Z,1/2-Y,-X'
        IF(IS.EQ. 71) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ. 72) OP =' -Z,1/2-Y,X'
        IF(IS.EQ. 73) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ. 74) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 75) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ. 76) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 77) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ. 78) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 79) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ. 80) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ. 81) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ. 82) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 83) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 84) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ. 85) OP =' Y,X,1/2+Z'
        IF(IS.EQ. 86) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 87) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 88) OP =' -Y,X,1/2-Z'
        IF(IS.EQ. 89) OP =' X,Z,1/2+Y'
        IF(IS.EQ. 90) OP =' -X,Z,1/2-Y'
        IF(IS.EQ. 91) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ. 92) OP =' X,-Z,1/2-Y'
        IF(IS.EQ. 93) OP =' Z,Y,1/2+X'
        IF(IS.EQ. 94) OP =' Z,-Y,1/2-X'
        IF(IS.EQ. 95) OP =' -Z,Y,1/2-X'
        IF(IS.EQ. 96) OP =' -Z,-Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END


      SUBROUTINE GET_SPACE_GROUP_INFO_35(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.240) THEN
        NO_TAB  =  220
        NS_TAB  =   48
        SG_TAB1 = 'I -4 3 d'
        SG_TAB2 = 'I-43d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 1/4+Y,1/4+X,1/4+Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,3/4-X,3/4+Z'
        IF(IS.EQ. 15) OP =' 3/4+Y,1/4-X,3/4-Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4-Z'
        IF(IS.EQ. 17) OP =' 1/4+X,1/4+Z,1/4+Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4-Y'
        IF(IS.EQ. 19) OP =' 1/4-X,3/4-Z,3/4+Y'
        IF(IS.EQ. 20) OP =' 3/4+X,1/4-Z,3/4-Y'
        IF(IS.EQ. 21) OP =' 1/4+Z,1/4+Y,1/4+X'
        IF(IS.EQ. 22) OP =' 3/4+Z,1/4-Y,3/4-X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4-X'
        IF(IS.EQ. 24) OP =' 1/4-Z,3/4-Y,3/4+X'
        IF(IS.EQ. 25) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 26) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 27) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 28) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 29) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 30) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 31) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 32) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 33) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 34) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 35) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 36) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 37) OP =' 3/4+Y,3/4+X,3/4+Z'
        IF(IS.EQ. 38) OP =' 3/4-Y,1/4-X,1/4+Z'
        IF(IS.EQ. 39) OP =' 1/4+Y,3/4-X,1/4-Z'
        IF(IS.EQ. 40) OP =' 1/4-Y,1/4+X,3/4-Z'
        IF(IS.EQ. 41) OP =' 3/4+X,3/4+Z,3/4+Y'
        IF(IS.EQ. 42) OP =' 1/4-X,1/4+Z,3/4-Y'
        IF(IS.EQ. 43) OP =' 3/4-X,1/4-Z,1/4+Y'
        IF(IS.EQ. 44) OP =' 1/4+X,3/4-Z,1/4-Y'
        IF(IS.EQ. 45) OP =' 3/4+Z,3/4+Y,3/4+X'
        IF(IS.EQ. 46) OP =' 1/4+Z,3/4-Y,1/4-X'
        IF(IS.EQ. 47) OP =' 1/4-Z,1/4+Y,3/4-X'
        IF(IS.EQ. 48) OP =' 3/4-Z,1/4-Y,1/4+X'
        RETURN
      ENDIF
      IF(I.EQ.241) THEN
        NO_TAB  =  221
        NS_TAB  =   48
        SG_TAB1 = 'P 4/m -3 2/m'
        SG_TAB2 = 'Pm-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        RETURN
      ENDIF
      IF(I.EQ.242) THEN
        NO_TAB  =  222
        NS_TAB  =   48
        SG_TAB1 = 'P 4/n -3 2/n'
        SG_TAB2 = 'Pn-3n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 29) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 32) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 34) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 36) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.243) THEN
        NO_TAB  =  223
        NS_TAB  =   48
        SG_TAB1 = 'P 42/m -3 2/n'
        SG_TAB2 = 'Pm-3n'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_4(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.244) THEN
        NO_TAB  =  224
        NS_TAB  =   48
        SG_TAB1 = 'P 42/n -3 2/m'
        SG_TAB2 = 'Pn-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 27) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 29) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 32) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 34) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 36) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        RETURN
      ENDIF
      IF(I.EQ.245) THEN
        NO_TAB  =  225
        NS_TAB  =  192
        SG_TAB1 = 'F 4/m -3 2/m'
        SG_TAB2 = 'Fm-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' Y,1/2+X,1/2-Z'
        IF(IS.EQ. 62) OP =' -Y,1/2-X,1/2-Z'
        IF(IS.EQ. 63) OP =' Y,1/2-X,1/2+Z'
        IF(IS.EQ. 64) OP =' -Y,1/2+X,1/2+Z'
        IF(IS.EQ. 65) OP =' X,1/2+Z,1/2-Y'
        IF(IS.EQ. 66) OP =' -X,1/2+Z,1/2+Y'
        IF(IS.EQ. 67) OP =' -X,1/2-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' X,1/2-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' Z,1/2+Y,1/2-X'
        IF(IS.EQ. 70) OP =' Z,1/2-Y,1/2+X'
        IF(IS.EQ. 71) OP =' -Z,1/2+Y,1/2+X'
        IF(IS.EQ. 72) OP =' -Z,1/2-Y,1/2-X'
        IF(IS.EQ. 73) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ. 86) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ. 89) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ. 94) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ. 96) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 99) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.100) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.104) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ.107) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ.108) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.109) OP =' 1/2+Y,X,1/2-Z'
        IF(IS.EQ.110) OP =' 1/2-Y,-X,1/2-Z'
        IF(IS.EQ.111) OP =' 1/2+Y,-X,1/2+Z'
        IF(IS.EQ.112) OP =' 1/2-Y,X,1/2+Z'
        IF(IS.EQ.113) OP =' 1/2+X,Z,1/2-Y'
        IF(IS.EQ.114) OP =' 1/2-X,Z,1/2+Y'
        IF(IS.EQ.115) OP =' 1/2-X,-Z,1/2-Y'
        IF(IS.EQ.116) OP =' 1/2+X,-Z,1/2+Y'
        IF(IS.EQ.117) OP =' 1/2+Z,Y,1/2-X'
        IF(IS.EQ.118) OP =' 1/2+Z,-Y,1/2+X'
        IF(IS.EQ.119) OP =' 1/2-Z,Y,1/2+X'
        IF(IS.EQ.120) OP =' 1/2-Z,-Y,1/2-X'
        IF(IS.EQ.121) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ.122) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.123) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.124) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.125) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ.126) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ.127) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ.128) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ.129) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ.130) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ.131) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ.132) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ.133) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ.134) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ.135) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ.136) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ.137) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ.138) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ.139) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ.140) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ.141) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ.142) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ.143) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ.144) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.147) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.148) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.152) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ.155) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ.156) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.157) OP =' 1/2+Y,1/2+X,-Z'
        IF(IS.EQ.158) OP =' 1/2-Y,1/2-X,-Z'
        IF(IS.EQ.159) OP =' 1/2+Y,1/2-X,Z'
        IF(IS.EQ.160) OP =' 1/2-Y,1/2+X,Z'
        IF(IS.EQ.161) OP =' 1/2+X,1/2+Z,-Y'
        IF(IS.EQ.162) OP =' 1/2-X,1/2+Z,Y'
        IF(IS.EQ.163) OP =' 1/2-X,1/2-Z,-Y'
        IF(IS.EQ.164) OP =' 1/2+X,1/2-Z,Y'
        IF(IS.EQ.165) OP =' 1/2+Z,1/2+Y,-X'
        IF(IS.EQ.166) OP =' 1/2+Z,1/2-Y,X'
        IF(IS.EQ.167) OP =' 1/2-Z,1/2+Y,X'
        IF(IS.EQ.168) OP =' 1/2-Z,1/2-Y,-X'
        IF(IS.EQ.169) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.170) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.171) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.172) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.173) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ.174) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ.175) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ.176) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ.177) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ.178) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ.179) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ.180) OP =' 1/2+Y,1/2+Z,-X'
        IF(IS.EQ.181) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ.182) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ.183) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ.184) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ.185) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ.186) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ.187) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ.188) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ.189) OP =' 1/2-Z,1/2-Y,X'
        IF(IS.EQ.190) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ.191) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ.192) OP =' 1/2+Z,1/2+Y,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_41(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.246) THEN
        NO_TAB  =  226
        NS_TAB  =  192
        SG_TAB1 = 'F 4/m -3 2/c'
        SG_TAB2 = 'Fm-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 14) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 15) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 16) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 17) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 18) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 19) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 20) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 21) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 22) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 23) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 24) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 46) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,X,-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,-X,-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,-X,Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,X,Z'
        IF(IS.EQ. 65) OP =' 1/2+X,Z,-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,Z,Y'
        IF(IS.EQ. 67) OP =' 1/2-X,-Z,-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,-Z,Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,Y,-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,-Y,X'
        IF(IS.EQ. 71) OP =' 1/2-Z,Y,X'
        IF(IS.EQ. 72) OP =' 1/2-Z,-Y,-X'
        IF(IS.EQ. 73) OP =' -X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' -X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' -Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' -Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' -Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ. 90) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 92) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ. 94) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ. 99) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ.100) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.104) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ.107) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ.108) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.109) OP =' Y,1/2+X,-Z'
        IF(IS.EQ.110) OP =' -Y,1/2-X,-Z'
        IF(IS.EQ.111) OP =' Y,1/2-X,Z'
        IF(IS.EQ.112) OP =' -Y,1/2+X,Z'
        IF(IS.EQ.113) OP =' X,1/2+Z,-Y'
        IF(IS.EQ.114) OP =' -X,1/2+Z,Y'
        IF(IS.EQ.115) OP =' -X,1/2-Z,-Y'
        IF(IS.EQ.116) OP =' X,1/2-Z,Y'
        IF(IS.EQ.117) OP =' Z,1/2+Y,-X'
        IF(IS.EQ.118) OP =' Z,1/2-Y,X'
        IF(IS.EQ.119) OP =' -Z,1/2+Y,X'
        IF(IS.EQ.120) OP =' -Z,1/2-Y,-X'
        IF(IS.EQ.121) OP =' 1/2-X,-Y,1/2-Z'
        IF(IS.EQ.122) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ.123) OP =' 1/2+X,-Y,1/2+Z'
        IF(IS.EQ.124) OP =' 1/2-X,Y,1/2+Z'
        IF(IS.EQ.125) OP =' 1/2-Z,-X,1/2-Y'
        IF(IS.EQ.126) OP =' 1/2-Z,X,1/2+Y'
        IF(IS.EQ.127) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ.128) OP =' 1/2+Z,-X,1/2+Y'
        IF(IS.EQ.129) OP =' 1/2-Y,-Z,1/2-X'
        IF(IS.EQ.130) OP =' 1/2+Y,-Z,1/2+X'
        IF(IS.EQ.131) OP =' 1/2-Y,Z,1/2+X'
        IF(IS.EQ.132) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ.133) OP =' -Y,1/2-X,Z'
        IF(IS.EQ.134) OP =' Y,1/2+X,Z'
        IF(IS.EQ.135) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ.136) OP =' Y,1/2-X,-Z'
        IF(IS.EQ.137) OP =' -X,1/2-Z,Y'
        IF(IS.EQ.138) OP =' X,1/2-Z,-Y'
        IF(IS.EQ.139) OP =' X,1/2+Z,Y'
        IF(IS.EQ.140) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ.141) OP =' -Z,1/2-Y,X'
        IF(IS.EQ.142) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ.143) OP =' Z,1/2-Y,-X'
        IF(IS.EQ.144) OP =' Z,1/2+Y,X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ.147) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.148) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.152) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ.155) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ.156) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.157) OP =' Y,X,1/2-Z'
        IF(IS.EQ.158) OP =' -Y,-X,1/2-Z'
        IF(IS.EQ.159) OP =' Y,-X,1/2+Z'
        IF(IS.EQ.160) OP =' -Y,X,1/2+Z'
        IF(IS.EQ.161) OP =' X,Z,1/2-Y'
        IF(IS.EQ.162) OP =' -X,Z,1/2+Y'
        IF(IS.EQ.163) OP =' -X,-Z,1/2-Y'
        IF(IS.EQ.164) OP =' X,-Z,1/2+Y'
        IF(IS.EQ.165) OP =' Z,Y,1/2-X'
        IF(IS.EQ.166) OP =' Z,-Y,1/2+X'
        IF(IS.EQ.167) OP =' -Z,Y,1/2+X'
        IF(IS.EQ.168) OP =' -Z,-Y,1/2-X'
        IF(IS.EQ.169) OP =' 1/2-X,1/2-Y,-Z'
        IF(IS.EQ.170) OP =' 1/2+X,1/2+Y,-Z'
        IF(IS.EQ.171) OP =' 1/2+X,1/2-Y,Z'
        IF(IS.EQ.172) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ.173) OP =' 1/2-Z,1/2-X,-Y'
        IF(IS.EQ.174) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ.175) OP =' 1/2+Z,1/2+X,-Y'
        IF(IS.EQ.176) OP =' 1/2+Z,1/2-X,Y'
        IF(IS.EQ.177) OP =' 1/2-Y,1/2-Z,-X'
        IF(IS.EQ.178) OP =' 1/2+Y,1/2-Z,X'
        IF(IS.EQ.179) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ.180) OP =' 1/2+Y,1/2+Z,-X'
        IF(IS.EQ.181) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ.182) OP =' Y,X,1/2+Z'
        IF(IS.EQ.183) OP =' -Y,X,1/2-Z'
        IF(IS.EQ.184) OP =' Y,-X,1/2-Z'
        IF(IS.EQ.185) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ.186) OP =' X,-Z,1/2-Y'
        IF(IS.EQ.187) OP =' X,Z,1/2+Y'
        IF(IS.EQ.188) OP =' -X,Z,1/2-Y'
        IF(IS.EQ.189) OP =' -Z,-Y,1/2+X'
        IF(IS.EQ.190) OP =' -Z,Y,1/2-X'
        IF(IS.EQ.191) OP =' Z,-Y,1/2-X'
        IF(IS.EQ.192) OP =' Z,Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_42(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.247) THEN
        NO_TAB  =  227
        NS_TAB  =  192
        SG_TAB1 = 'F 41/d -3 2/m'
        SG_TAB2 = 'Fd-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' 1/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 26) OP =' 1/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 27) OP =' 3/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 28) OP =' 3/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 29) OP =' 1/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 30) OP =' 3/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 31) OP =' 1/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 32) OP =' 3/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 33) OP =' 1/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 34) OP =' 3/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 35) OP =' 3/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 36) OP =' 1/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 37) OP =' 1/2-Y,-X,1/2+Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,1/2+X,1/2-Z'
        IF(IS.EQ. 40) OP =' 1/2+Y,1/2-X,-Z'
        IF(IS.EQ. 41) OP =' 1/2-X,-Z,1/2+Y'
        IF(IS.EQ. 42) OP =' 1/2+X,1/2-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,1/2+Z,1/2-Y'
        IF(IS.EQ. 45) OP =' 1/2-Z,-Y,1/2+X'
        IF(IS.EQ. 46) OP =' -Z,1/2+Y,1/2-X'
        IF(IS.EQ. 47) OP =' 1/2+Z,1/2-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 55) OP =' -Z,-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 60) OP =' -Y,-Z,X'
        IF(IS.EQ. 61) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 1/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 74) OP =' 1/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 75) OP =' 3/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 76) OP =' 3/4-X,3/4+Y,1/4+Z'
        IF(IS.EQ. 77) OP =' 1/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 78) OP =' 3/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 79) OP =' 1/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 80) OP =' 3/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 81) OP =' 1/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 82) OP =' 3/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 83) OP =' 3/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 84) OP =' 1/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,1/2-X,Z'
        IF(IS.EQ. 86) OP =' Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' -Y,X,-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,-X,1/2-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,1/2-Z,Y'
        IF(IS.EQ. 90) OP =' 1/2+X,-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' -X,Z,-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,1/2-Y,X'
        IF(IS.EQ. 94) OP =' -Z,Y,-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,-Y,1/2-X'
        IF(IS.EQ. 96) OP =' Z,1/2+Y,1/2+X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 99) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.100) OP =' X,-Y,-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' Z,-X,-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.104) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ.107) OP =' Y,-Z,-X'
        IF(IS.EQ.108) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.109) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ.110) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ.111) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ.112) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ.113) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ.114) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ.115) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ.116) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ.117) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ.118) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ.119) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ.120) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ.121) OP =' 3/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ.122) OP =' 3/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ.123) OP =' 1/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.124) OP =' 1/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.125) OP =' 3/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ.126) OP =' 1/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ.127) OP =' 3/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ.128) OP =' 1/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ.129) OP =' 3/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ.130) OP =' 1/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ.131) OP =' 1/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ.132) OP =' 3/4+Y,3/4+Z,1/4-X'
        IF(IS.EQ.133) OP =' -Y,-X,Z'
        IF(IS.EQ.134) OP =' 1/2+Y,X,1/2+Z'
        IF(IS.EQ.135) OP =' 1/2-Y,1/2+X,-Z'
        IF(IS.EQ.136) OP =' Y,1/2-X,1/2-Z'
        IF(IS.EQ.137) OP =' -X,-Z,Y'
        IF(IS.EQ.138) OP =' X,1/2-Z,1/2-Y'
        IF(IS.EQ.139) OP =' 1/2+X,Z,1/2+Y'
        IF(IS.EQ.140) OP =' 1/2-X,1/2+Z,-Y'
        IF(IS.EQ.141) OP =' -Z,-Y,X'
        IF(IS.EQ.142) OP =' 1/2-Z,1/2+Y,-X'
        IF(IS.EQ.143) OP =' Z,1/2-Y,1/2-X'
        IF(IS.EQ.144) OP =' 1/2+Z,Y,1/2+X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.147) OP =' -X,Y,-Z'
        IF(IS.EQ.148) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.152) OP =' -Z,X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' -Y,Z,-X'
        IF(IS.EQ.155) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ.156) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.157) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ.158) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ.159) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ.160) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ.161) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ.162) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ.163) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ.164) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ.165) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ.166) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ.167) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ.168) OP =' 3/4-Z,3/4-Y,1/4-X'
        IF(IS.EQ.169) OP =' 3/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ.170) OP =' 3/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ.171) OP =' 1/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.172) OP =' 1/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.173) OP =' 3/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ.174) OP =' 1/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ.175) OP =' 3/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ.176) OP =' 1/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ.177) OP =' 3/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ.178) OP =' 1/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ.179) OP =' 1/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ.180) OP =' 3/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ.181) OP =' -Y,1/2-X,1/2+Z'
        IF(IS.EQ.182) OP =' 1/2+Y,1/2+X,Z'
        IF(IS.EQ.183) OP =' 1/2-Y,X,1/2-Z'
        IF(IS.EQ.184) OP =' Y,-X,-Z'
        IF(IS.EQ.185) OP =' -X,1/2-Z,1/2+Y'
        IF(IS.EQ.186) OP =' X,-Z,-Y'
        IF(IS.EQ.187) OP =' 1/2+X,1/2+Z,Y'
        IF(IS.EQ.188) OP =' 1/2-X,Z,1/2-Y'
        IF(IS.EQ.189) OP =' -Z,1/2-Y,1/2+X'
        IF(IS.EQ.190) OP =' 1/2-Z,Y,1/2-X'
        IF(IS.EQ.191) OP =' Z,-Y,-X'
        IF(IS.EQ.192) OP =' 1/2+Z,1/2+Y,X'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_SPACE_GROUP_INFO_43(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.248) THEN
        NO_TAB  =  228
        NS_TAB  =  192
        SG_TAB1 = 'F 41/d -3 2/c'
        SG_TAB2 = 'Fd-3c'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,1/2-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' 1/2-X,1/2+Y,-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,-Y,1/2-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,-X,1/2-Y'
        IF(IS.EQ.  7) OP =' -Z,1/2-X,1/2+Y'
        IF(IS.EQ.  8) OP =' 1/2-Z,1/2+X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' 1/2-Y,1/2+Z,-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,-Z,1/2-X'
        IF(IS.EQ. 12) OP =' -Y,1/2-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,3/4-Z'
        IF(IS.EQ. 14) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,3/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 3/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,3/4-Y'
        IF(IS.EQ. 18) OP =' 3/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,3/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,3/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,3/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 3/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 25) OP =' 3/4-X,3/4-Y,3/4-Z'
        IF(IS.EQ. 26) OP =' 3/4+X,1/4+Y,1/4-Z'
        IF(IS.EQ. 27) OP =' 1/4+X,1/4-Y,3/4+Z'
        IF(IS.EQ. 28) OP =' 1/4-X,3/4+Y,1/4+Z'
        IF(IS.EQ. 29) OP =' 3/4-Z,3/4-X,3/4-Y'
        IF(IS.EQ. 30) OP =' 1/4-Z,3/4+X,1/4+Y'
        IF(IS.EQ. 31) OP =' 3/4+Z,1/4+X,1/4-Y'
        IF(IS.EQ. 32) OP =' 1/4+Z,1/4-X,3/4+Y'
        IF(IS.EQ. 33) OP =' 3/4-Y,3/4-Z,3/4-X'
        IF(IS.EQ. 34) OP =' 1/4+Y,1/4-Z,3/4+X'
        IF(IS.EQ. 35) OP =' 1/4-Y,3/4+Z,1/4+X'
        IF(IS.EQ. 36) OP =' 3/4+Y,1/4+Z,1/4-X'
        IF(IS.EQ. 37) OP =' -Y,1/2-X,Z'
        IF(IS.EQ. 38) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 39) OP =' 1/2-Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,1/2-Z'
        IF(IS.EQ. 41) OP =' -X,1/2-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,1/2-Y'
        IF(IS.EQ. 43) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 44) OP =' 1/2-X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,1/2-Y,X'
        IF(IS.EQ. 46) OP =' 1/2-Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,1/2-X'
        IF(IS.EQ. 48) OP =' 1/2+Z,1/2+Y,1/2+X'
        IF(IS.EQ. 49) OP =' X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ. 53) OP =' Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ. 55) OP =' -Z,-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,1/2-Y'
        IF(IS.EQ. 57) OP =' Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 60) OP =' -Y,-Z,X'
        IF(IS.EQ. 61) OP =' 3/4+Y,3/4+X,1/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 63) OP =' 1/4+Y,1/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 3/4+X,3/4+Z,1/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 68) OP =' 1/4+X,1/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 3/4+Z,3/4+Y,1/4-X'
        IF(IS.EQ. 70) OP =' 1/4+Z,1/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 73) OP =' 3/4-X,1/4-Y,1/4-Z'
        IF(IS.EQ. 74) OP =' 3/4+X,3/4+Y,3/4-Z'
        IF(IS.EQ. 75) OP =' 1/4+X,3/4-Y,1/4+Z'
        IF(IS.EQ. 76) OP =' 1/4-X,1/4+Y,3/4+Z'
        IF(IS.EQ. 77) OP =' 3/4-Z,1/4-X,1/4-Y'
        IF(IS.EQ. 78) OP =' 1/4-Z,1/4+X,3/4+Y'
        IF(IS.EQ. 79) OP =' 3/4+Z,3/4+X,3/4-Y'
        IF(IS.EQ. 80) OP =' 1/4+Z,3/4-X,1/4+Y'
        IF(IS.EQ. 81) OP =' 3/4-Y,1/4-Z,1/4-X'
        IF(IS.EQ. 82) OP =' 1/4+Y,3/4-Z,1/4+X'
        IF(IS.EQ. 83) OP =' 1/4-Y,1/4+Z,3/4+X'
        IF(IS.EQ. 84) OP =' 3/4+Y,3/4+Z,3/4-X'
        IF(IS.EQ. 85) OP =' -Y,-X,1/2+Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,X,Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' Y,1/2-X,-Z'
        IF(IS.EQ. 89) OP =' -X,-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' X,1/2-Z,-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,Z,Y'
        IF(IS.EQ. 92) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' -Z,-Y,1/2+X'
        IF(IS.EQ. 94) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' Z,1/2-Y,-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,Y,X'
        IF(IS.EQ. 97) OP =' 1/2+X,Y,1/2+Z'
        IF(IS.EQ. 98) OP =' 1/2-X,1/2-Y,Z'
        IF(IS.EQ. 99) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.100) OP =' X,-Y,-Z'
        IF(IS.EQ.101) OP =' 1/2+Z,X,1/2+Y'
        IF(IS.EQ.102) OP =' Z,-X,-Y'
        IF(IS.EQ.103) OP =' 1/2-Z,1/2-X,Y'
        IF(IS.EQ.104) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.105) OP =' 1/2+Y,Z,1/2+X'
        IF(IS.EQ.106) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ.107) OP =' Y,-Z,-X'
        IF(IS.EQ.108) OP =' 1/2-Y,1/2-Z,X'
        IF(IS.EQ.109) OP =' 1/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ.110) OP =' 3/4-Y,1/4-X,3/4-Z'
        IF(IS.EQ.111) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ.112) OP =' 1/4-Y,3/4+X,3/4+Z'
        IF(IS.EQ.113) OP =' 1/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ.114) OP =' 1/4-X,3/4+Z,3/4+Y'
        IF(IS.EQ.115) OP =' 3/4-X,1/4-Z,3/4-Y'
        IF(IS.EQ.116) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ.117) OP =' 1/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ.118) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ.119) OP =' 1/4-Z,3/4+Y,3/4+X'
        IF(IS.EQ.120) OP =' 3/4-Z,1/4-Y,3/4-X'
        IF(IS.EQ.121) OP =' 1/4-X,3/4-Y,1/4-Z'
        IF(IS.EQ.122) OP =' 1/4+X,1/4+Y,3/4-Z'
        IF(IS.EQ.123) OP =' 3/4+X,1/4-Y,1/4+Z'
        IF(IS.EQ.124) OP =' 3/4-X,3/4+Y,3/4+Z'
        IF(IS.EQ.125) OP =' 1/4-Z,3/4-X,1/4-Y'
        IF(IS.EQ.126) OP =' 3/4-Z,3/4+X,3/4+Y'
        IF(IS.EQ.127) OP =' 1/4+Z,1/4+X,3/4-Y'
        IF(IS.EQ.128) OP =' 3/4+Z,1/4-X,1/4+Y'
        IF(IS.EQ.129) OP =' 1/4-Y,3/4-Z,1/4-X'
        IF(IS.EQ.130) OP =' 3/4+Y,1/4-Z,1/4+X'
        IF(IS.EQ.131) OP =' 3/4-Y,3/4+Z,3/4+X'
        IF(IS.EQ.132) OP =' 1/4+Y,1/4+Z,3/4-X'
        IF(IS.EQ.133) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ.134) OP =' Y,1/2+X,Z'
        IF(IS.EQ.135) OP =' -Y,X,1/2-Z'
        IF(IS.EQ.136) OP =' 1/2+Y,-X,-Z'
        IF(IS.EQ.137) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ.138) OP =' 1/2+X,-Z,-Y'
        IF(IS.EQ.139) OP =' X,1/2+Z,Y'
        IF(IS.EQ.140) OP =' -X,Z,1/2-Y'
        IF(IS.EQ.141) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ.142) OP =' -Z,Y,1/2-X'
        IF(IS.EQ.143) OP =' 1/2+Z,-Y,-X'
        IF(IS.EQ.144) OP =' Z,1/2+Y,X'
        IF(IS.EQ.145) OP =' 1/2+X,1/2+Y,Z'
        IF(IS.EQ.146) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.147) OP =' -X,Y,-Z'
        IF(IS.EQ.148) OP =' X,1/2-Y,1/2-Z'
        IF(IS.EQ.149) OP =' 1/2+Z,1/2+X,Y'
        IF(IS.EQ.150) OP =' Z,1/2-X,1/2-Y'
        IF(IS.EQ.151) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.152) OP =' -Z,X,-Y'
        IF(IS.EQ.153) OP =' 1/2+Y,1/2+Z,X'
        IF(IS.EQ.154) OP =' -Y,Z,-X'
        IF(IS.EQ.155) OP =' Y,1/2-Z,1/2-X'
        IF(IS.EQ.156) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ.157) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ.158) OP =' 3/4-Y,3/4-X,1/4-Z'
        IF(IS.EQ.159) OP =' 3/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ.160) OP =' 1/4-Y,1/4+X,1/4+Z'
        IF(IS.EQ.161) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ.162) OP =' 1/4-X,1/4+Z,1/4+Y'
        IF(IS.EQ.163) OP =' 3/4-X,3/4-Z,1/4-Y'
        IF(IS.EQ.164) OP =' 3/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ.165) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ.166) OP =' 3/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ.167) OP =' 1/4-Z,1/4+Y,1/4+X'
        IF(IS.EQ.168) OP =' 3/4-Z,3/4-Y,1/4-X'
        IF(IS.EQ.169) OP =' 1/4-X,1/4-Y,3/4-Z'
        IF(IS.EQ.170) OP =' 1/4+X,3/4+Y,1/4-Z'
        IF(IS.EQ.171) OP =' 3/4+X,3/4-Y,3/4+Z'
        IF(IS.EQ.172) OP =' 3/4-X,1/4+Y,1/4+Z'
        IF(IS.EQ.173) OP =' 1/4-Z,1/4-X,3/4-Y'
        IF(IS.EQ.174) OP =' 3/4-Z,1/4+X,1/4+Y'
        IF(IS.EQ.175) OP =' 1/4+Z,3/4+X,1/4-Y'
        IF(IS.EQ.176) OP =' 3/4+Z,3/4-X,3/4+Y'
        IF(IS.EQ.177) OP =' 1/4-Y,1/4-Z,3/4-X'
        IF(IS.EQ.178) OP =' 3/4+Y,3/4-Z,3/4+X'
        IF(IS.EQ.179) OP =' 3/4-Y,1/4+Z,1/4+X'
        IF(IS.EQ.180) OP =' 1/4+Y,3/4+Z,1/4-X'
        IF(IS.EQ.181) OP =' 1/2-Y,-X,Z'
        IF(IS.EQ.182) OP =' Y,X,1/2+Z'
        IF(IS.EQ.183) OP =' -Y,1/2+X,-Z'
        IF(IS.EQ.184) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ.185) OP =' 1/2-X,-Z,Y'
        IF(IS.EQ.186) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ.187) OP =' X,Z,1/2+Y'
        IF(IS.EQ.188) OP =' -X,1/2+Z,-Y'
        IF(IS.EQ.189) OP =' 1/2-Z,-Y,X'
        IF(IS.EQ.190) OP =' -Z,1/2+Y,-X'
        IF(IS.EQ.191) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ.192) OP =' Z,Y,1/2+X'
        RETURN
      ENDIF
      RETURN
      END
 
      SUBROUTINE GET_SPACE_GROUP_INFO_44(I,IS,NO_TAB,NS_TAB
     *                               ,SG_TAB1,SG_TAB2,SG_TAB3,OP,IERR)
C -------------------------------------------------------------
      INTEGER   I,IS,NO_TAB,NS_TAB
      CHARACTER SG_TAB1*(*),SG_TAB2*(*),SG_TAB3*(*),OP*(*)
C ---------------------------------------------------------------
      IF(I.EQ.249) THEN
        NO_TAB  =  229
        NS_TAB  =   96
        SG_TAB1 = 'I 4/m -3 2/m'
        SG_TAB2 = 'Im-3m'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' -X,Y,-Z'
        IF(IS.EQ.  4) OP =' X,-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' Z,-X,-Y'
        IF(IS.EQ.  7) OP =' -Z,-X,Y'
        IF(IS.EQ.  8) OP =' -Z,X,-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,Z,-X'
        IF(IS.EQ. 11) OP =' Y,-Z,-X'
        IF(IS.EQ. 12) OP =' -Y,-Z,X'
        IF(IS.EQ. 13) OP =' Y,X,-Z'
        IF(IS.EQ. 14) OP =' -Y,-X,-Z'
        IF(IS.EQ. 15) OP =' Y,-X,Z'
        IF(IS.EQ. 16) OP =' -Y,X,Z'
        IF(IS.EQ. 17) OP =' X,Z,-Y'
        IF(IS.EQ. 18) OP =' -X,Z,Y'
        IF(IS.EQ. 19) OP =' -X,-Z,-Y'
        IF(IS.EQ. 20) OP =' X,-Z,Y'
        IF(IS.EQ. 21) OP =' Z,Y,-X'
        IF(IS.EQ. 22) OP =' Z,-Y,X'
        IF(IS.EQ. 23) OP =' -Z,Y,X'
        IF(IS.EQ. 24) OP =' -Z,-Y,-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' X,Y,-Z'
        IF(IS.EQ. 27) OP =' X,-Y,Z'
        IF(IS.EQ. 28) OP =' -X,Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' -Z,X,Y'
        IF(IS.EQ. 31) OP =' Z,X,-Y'
        IF(IS.EQ. 32) OP =' Z,-X,Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,-Z,X'
        IF(IS.EQ. 35) OP =' -Y,Z,X'
        IF(IS.EQ. 36) OP =' Y,Z,-X'
        IF(IS.EQ. 37) OP =' -Y,-X,Z'
        IF(IS.EQ. 38) OP =' Y,X,Z'
        IF(IS.EQ. 39) OP =' -Y,X,-Z'
        IF(IS.EQ. 40) OP =' Y,-X,-Z'
        IF(IS.EQ. 41) OP =' -X,-Z,Y'
        IF(IS.EQ. 42) OP =' X,-Z,-Y'
        IF(IS.EQ. 43) OP =' X,Z,Y'
        IF(IS.EQ. 44) OP =' -X,Z,-Y'
        IF(IS.EQ. 45) OP =' -Z,-Y,X'
        IF(IS.EQ. 46) OP =' -Z,Y,-X'
        IF(IS.EQ. 47) OP =' Z,-Y,-X'
        IF(IS.EQ. 48) OP =' Z,Y,X'
        IF(IS.EQ. 49) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' 1/2-X,1/2-Y,1/2+Z'
        IF(IS.EQ. 51) OP =' 1/2-X,1/2+Y,1/2-Z'
        IF(IS.EQ. 52) OP =' 1/2+X,1/2-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' 1/2+Z,1/2-X,1/2-Y'
        IF(IS.EQ. 55) OP =' 1/2-Z,1/2-X,1/2+Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,1/2+X,1/2-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,1/2+Z,1/2-X'
        IF(IS.EQ. 59) OP =' 1/2+Y,1/2-Z,1/2-X'
        IF(IS.EQ. 60) OP =' 1/2-Y,1/2-Z,1/2+X'
        IF(IS.EQ. 61) OP =' 1/2+Y,1/2+X,1/2-Z'
        IF(IS.EQ. 62) OP =' 1/2-Y,1/2-X,1/2-Z'
        IF(IS.EQ. 63) OP =' 1/2+Y,1/2-X,1/2+Z'
        IF(IS.EQ. 64) OP =' 1/2-Y,1/2+X,1/2+Z'
        IF(IS.EQ. 65) OP =' 1/2+X,1/2+Z,1/2-Y'
        IF(IS.EQ. 66) OP =' 1/2-X,1/2+Z,1/2+Y'
        IF(IS.EQ. 67) OP =' 1/2-X,1/2-Z,1/2-Y'
        IF(IS.EQ. 68) OP =' 1/2+X,1/2-Z,1/2+Y'
        IF(IS.EQ. 69) OP =' 1/2+Z,1/2+Y,1/2-X'
        IF(IS.EQ. 70) OP =' 1/2+Z,1/2-Y,1/2+X'
        IF(IS.EQ. 71) OP =' 1/2-Z,1/2+Y,1/2+X'
        IF(IS.EQ. 72) OP =' 1/2-Z,1/2-Y,1/2-X'
        IF(IS.EQ. 73) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' 1/2+X,1/2+Y,1/2-Z'
        IF(IS.EQ. 75) OP =' 1/2+X,1/2-Y,1/2+Z'
        IF(IS.EQ. 76) OP =' 1/2-X,1/2+Y,1/2+Z'
        IF(IS.EQ. 77) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' 1/2-Z,1/2+X,1/2+Y'
        IF(IS.EQ. 79) OP =' 1/2+Z,1/2+X,1/2-Y'
        IF(IS.EQ. 80) OP =' 1/2+Z,1/2-X,1/2+Y'
        IF(IS.EQ. 81) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' 1/2+Y,1/2-Z,1/2+X'
        IF(IS.EQ. 83) OP =' 1/2-Y,1/2+Z,1/2+X'
        IF(IS.EQ. 84) OP =' 1/2+Y,1/2+Z,1/2-X'
        IF(IS.EQ. 85) OP =' 1/2-Y,1/2-X,1/2+Z'
        IF(IS.EQ. 86) OP =' 1/2+Y,1/2+X,1/2+Z'
        IF(IS.EQ. 87) OP =' 1/2-Y,1/2+X,1/2-Z'
        IF(IS.EQ. 88) OP =' 1/2+Y,1/2-X,1/2-Z'
        IF(IS.EQ. 89) OP =' 1/2-X,1/2-Z,1/2+Y'
        IF(IS.EQ. 90) OP =' 1/2+X,1/2-Z,1/2-Y'
        IF(IS.EQ. 91) OP =' 1/2+X,1/2+Z,1/2+Y'
        IF(IS.EQ. 92) OP =' 1/2-X,1/2+Z,1/2-Y'
        IF(IS.EQ. 93) OP =' 1/2-Z,1/2-Y,1/2+X'
        IF(IS.EQ. 94) OP =' 1/2-Z,1/2+Y,1/2-X'
        IF(IS.EQ. 95) OP =' 1/2+Z,1/2-Y,1/2-X'
        IF(IS.EQ. 96) OP =' 1/2+Z,1/2+Y,1/2+X'
        RETURN
      ENDIF
      IF(I.EQ.250) THEN
        NO_TAB  =  230
        NS_TAB  =   96
        SG_TAB1 = 'I 41/a -3 2/d'
        SG_TAB2 = 'Ia-3d'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' 1/2-X,-Y,1/2+Z'
        IF(IS.EQ.  3) OP =' -X,1/2+Y,1/2-Z'
        IF(IS.EQ.  4) OP =' 1/2+X,1/2-Y,-Z'
        IF(IS.EQ.  5) OP =' Z,X,Y'
        IF(IS.EQ.  6) OP =' 1/2+Z,1/2-X,-Y'
        IF(IS.EQ.  7) OP =' 1/2-Z,-X,1/2+Y'
        IF(IS.EQ.  8) OP =' -Z,1/2+X,1/2-Y'
        IF(IS.EQ.  9) OP =' Y,Z,X'
        IF(IS.EQ. 10) OP =' -Y,1/2+Z,1/2-X'
        IF(IS.EQ. 11) OP =' 1/2+Y,1/2-Z,-X'
        IF(IS.EQ. 12) OP =' 1/2-Y,-Z,1/2+X'
        IF(IS.EQ. 13) OP =' 3/4+Y,1/4+X,1/4-Z'
        IF(IS.EQ. 14) OP =' 3/4-Y,3/4-X,3/4-Z'
        IF(IS.EQ. 15) OP =' 1/4+Y,1/4-X,3/4+Z'
        IF(IS.EQ. 16) OP =' 1/4-Y,3/4+X,1/4+Z'
        IF(IS.EQ. 17) OP =' 3/4+X,1/4+Z,1/4-Y'
        IF(IS.EQ. 18) OP =' 1/4-X,3/4+Z,1/4+Y'
        IF(IS.EQ. 19) OP =' 3/4-X,3/4-Z,3/4-Y'
        IF(IS.EQ. 20) OP =' 1/4+X,1/4-Z,3/4+Y'
        IF(IS.EQ. 21) OP =' 3/4+Z,1/4+Y,1/4-X'
        IF(IS.EQ. 22) OP =' 1/4+Z,1/4-Y,3/4+X'
        IF(IS.EQ. 23) OP =' 1/4-Z,3/4+Y,1/4+X'
        IF(IS.EQ. 24) OP =' 3/4-Z,3/4-Y,3/4-X'
        IF(IS.EQ. 25) OP =' -X,-Y,-Z'
        IF(IS.EQ. 26) OP =' 1/2+X,Y,1/2-Z'
        IF(IS.EQ. 27) OP =' X,1/2-Y,1/2+Z'
        IF(IS.EQ. 28) OP =' 1/2-X,1/2+Y,Z'
        IF(IS.EQ. 29) OP =' -Z,-X,-Y'
        IF(IS.EQ. 30) OP =' 1/2-Z,1/2+X,Y'
        IF(IS.EQ. 31) OP =' 1/2+Z,X,1/2-Y'
        IF(IS.EQ. 32) OP =' Z,1/2-X,1/2+Y'
        IF(IS.EQ. 33) OP =' -Y,-Z,-X'
        IF(IS.EQ. 34) OP =' Y,1/2-Z,1/2+X'
        IF(IS.EQ. 35) OP =' 1/2-Y,1/2+Z,X'
        IF(IS.EQ. 36) OP =' 1/2+Y,Z,1/2-X'
        IF(IS.EQ. 37) OP =' 1/4-Y,3/4-X,3/4+Z'
        IF(IS.EQ. 38) OP =' 1/4+Y,1/4+X,1/4+Z'
        IF(IS.EQ. 39) OP =' 3/4-Y,3/4+X,1/4-Z'
        IF(IS.EQ. 40) OP =' 3/4+Y,1/4-X,3/4-Z'
        IF(IS.EQ. 41) OP =' 1/4-X,3/4-Z,3/4+Y'
        IF(IS.EQ. 42) OP =' 3/4+X,1/4-Z,3/4-Y'
        IF(IS.EQ. 43) OP =' 1/4+X,1/4+Z,1/4+Y'
        IF(IS.EQ. 44) OP =' 3/4-X,3/4+Z,1/4-Y'
        IF(IS.EQ. 45) OP =' 1/4-Z,3/4-Y,3/4+X'
        IF(IS.EQ. 46) OP =' 3/4-Z,3/4+Y,1/4-X'
        IF(IS.EQ. 47) OP =' 3/4+Z,1/4-Y,3/4-X'
        IF(IS.EQ. 48) OP =' 1/4+Z,1/4+Y,1/4+X'
        IF(IS.EQ. 49) OP =' 1/2+X,1/2+Y,1/2+Z'
        IF(IS.EQ. 50) OP =' -X,1/2-Y,Z'
        IF(IS.EQ. 51) OP =' 1/2-X,Y,-Z'
        IF(IS.EQ. 52) OP =' X,-Y,1/2-Z'
        IF(IS.EQ. 53) OP =' 1/2+Z,1/2+X,1/2+Y'
        IF(IS.EQ. 54) OP =' Z,-X,1/2-Y'
        IF(IS.EQ. 55) OP =' -Z,1/2-X,Y'
        IF(IS.EQ. 56) OP =' 1/2-Z,X,-Y'
        IF(IS.EQ. 57) OP =' 1/2+Y,1/2+Z,1/2+X'
        IF(IS.EQ. 58) OP =' 1/2-Y,Z,-X'
        IF(IS.EQ. 59) OP =' Y,-Z,1/2-X'
        IF(IS.EQ. 60) OP =' -Y,1/2-Z,X'
        IF(IS.EQ. 61) OP =' 1/4+Y,3/4+X,3/4-Z'
        IF(IS.EQ. 62) OP =' 1/4-Y,1/4-X,1/4-Z'
        IF(IS.EQ. 63) OP =' 3/4+Y,3/4-X,1/4+Z'
        IF(IS.EQ. 64) OP =' 3/4-Y,1/4+X,3/4+Z'
        IF(IS.EQ. 65) OP =' 1/4+X,3/4+Z,3/4-Y'
        IF(IS.EQ. 66) OP =' 3/4-X,1/4+Z,3/4+Y'
        IF(IS.EQ. 67) OP =' 1/4-X,1/4-Z,1/4-Y'
        IF(IS.EQ. 68) OP =' 3/4+X,3/4-Z,1/4+Y'
        IF(IS.EQ. 69) OP =' 1/4+Z,3/4+Y,3/4-X'
        IF(IS.EQ. 70) OP =' 3/4+Z,3/4-Y,1/4+X'
        IF(IS.EQ. 71) OP =' 3/4-Z,1/4+Y,3/4+X'
        IF(IS.EQ. 72) OP =' 1/4-Z,1/4-Y,1/4-X'
        IF(IS.EQ. 73) OP =' 1/2-X,1/2-Y,1/2-Z'
        IF(IS.EQ. 74) OP =' X,1/2+Y,-Z'
        IF(IS.EQ. 75) OP =' 1/2+X,-Y,Z'
        IF(IS.EQ. 76) OP =' -X,Y,1/2+Z'
        IF(IS.EQ. 77) OP =' 1/2-Z,1/2-X,1/2-Y'
        IF(IS.EQ. 78) OP =' -Z,X,1/2+Y'
        IF(IS.EQ. 79) OP =' Z,1/2+X,-Y'
        IF(IS.EQ. 80) OP =' 1/2+Z,-X,Y'
        IF(IS.EQ. 81) OP =' 1/2-Y,1/2-Z,1/2-X'
        IF(IS.EQ. 82) OP =' 1/2+Y,-Z,X'
        IF(IS.EQ. 83) OP =' -Y,Z,1/2+X'
        IF(IS.EQ. 84) OP =' Y,1/2+Z,-X'
        IF(IS.EQ. 85) OP =' 3/4-Y,1/4-X,1/4+Z'
        IF(IS.EQ. 86) OP =' 3/4+Y,3/4+X,3/4+Z'
        IF(IS.EQ. 87) OP =' 1/4-Y,1/4+X,3/4-Z'
        IF(IS.EQ. 88) OP =' 1/4+Y,3/4-X,1/4-Z'
        IF(IS.EQ. 89) OP =' 3/4-X,1/4-Z,1/4+Y'
        IF(IS.EQ. 90) OP =' 1/4+X,3/4-Z,1/4-Y'
        IF(IS.EQ. 91) OP =' 3/4+X,3/4+Z,3/4+Y'
        IF(IS.EQ. 92) OP =' 1/4-X,1/4+Z,3/4-Y'
        IF(IS.EQ. 93) OP =' 3/4-Z,1/4-Y,1/4+X'
        IF(IS.EQ. 94) OP =' 1/4-Z,1/4+Y,3/4-X'
        IF(IS.EQ. 95) OP =' 1/4+Z,3/4-Y,1/4-X'
        IF(IS.EQ. 96) OP =' 3/4+Z,3/4+Y,3/4+X'
        RETURN
      ENDIF     
      IF(I.EQ.251) THEN
        NO_TAB  = 4005
        NS_TAB  =    4
        SG_TAB1 = 'I 1 2 1'
        SG_TAB2 = 'I121'
        SG_TAB3 = 'I 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X+1/2,Y+1/2,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.252) THEN
        NO_TAB  = 3005
        NS_TAB  =    4
        SG_TAB1 = 'A 1 2 1'
        SG_TAB2 = 'A121'
        SG_TAB3 = 'A 2'
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,Y,-Z'
        IF(IS.EQ.  3) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X,Y+1/2,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.253) THEN
        NO_TAB  = 9005
        NS_TAB  =    4
        SG_TAB1 = 'A 1 1 2'
        SG_TAB2 = 'A112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' -X,1/2-Y,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ.254) THEN
        NO_TAB  = 5005
        NS_TAB  =    4
        SG_TAB1 = 'I 1 1 2'
        SG_TAB2 = 'I112'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' -X,-Y,Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' 1/2-X,1/2-Y,Z+1/2'
        RETURN
      ENDIF
      IF(I.EQ.255) THEN
        NO_TAB  = 7005
        NS_TAB  =    4
        SG_TAB1 = 'I 2 1 1'
        SG_TAB2 = 'I211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z+1/2'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.256) THEN
        NO_TAB  = 6005
        NS_TAB  =    4
        SG_TAB1 = 'B 2 1 1'
        SG_TAB2 = 'B211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y,Z+1/2'
        IF(IS.EQ.  4) OP =' X+1/2,-Y,1/2-Z'
        RETURN
      ENDIF
      IF(I.EQ.257) THEN
        NO_TAB  = 8005
        NS_TAB  =    4
        SG_TAB1 = 'C 2 1 1'
        SG_TAB2 = 'C211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        IF(IS.EQ.  3) OP =' X+1/2,Y+1/2,Z'
        IF(IS.EQ.  4) OP =' X+1/2,1/2-Y,-Z'
        RETURN
      ENDIF
      IF(I.EQ.258) THEN
        NO_TAB  = 2003
        NS_TAB  =    2
        SG_TAB1 = 'P 2 1 1'
        SG_TAB2 = 'P211'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X,-Y,-Z'
        RETURN
      ENDIF 
      IF(I.EQ.259) THEN
        NO_TAB  = 2004
        NS_TAB  =    2
        SG_TAB1 = 'P 21 1 1'
        SG_TAB2 = 'P2111'
        SG_TAB3 = ' '
        IF(IS.EQ.  1) OP =' X,Y,Z'
        IF(IS.EQ.  2) OP =' X+1/2,-Y,-Z'
        RETURN
      ENDIF
      RETURN
      END

      SUBROUTINE GET_BZEROS(BZ,NMAXP,LMAXP,IERR)
C ------------------------------------------------------
C      REAL    BZ(30,*)
C      1 =<NMAXP=<30, 0=<LMAXP=<60
C ------------------------------------------------------
C     IPRBES=200 --> T2=48.0 ; IPRBES=400 --> T2=98.0
C                    LMAXP=30                 LMAXP=60
C                    NMAXP=15                 NMAXP=30
C
C      PARAMETER ( IPRBES = 400                 )
C      PARAMETER ( IPRLMX = IPRBES*3/20   60    )
C      PARAMETER ( IPRNMX = IPRLMX/2      30    )
C      PARAMETER ( IPRLM2 = IPRLMX+2      62    )
C      REAL    BZEROS(IPRNMX,IPRLM2)
C -------------------------------------------------------
      INTEGER IERR,NMAXP,LMAXP
      REAL    BZ(30,*)
      REAL    BZEROS(30,62)
C -----------------------
      REAL  BZ_1(30),BZ_2(30),BZ_3(30),BZ_4(30),BZ_5(30)
      REAL  BZ_6(30),BZ_7(30),BZ_8(30),BZ_9(30),BZ10(30)
      REAL  BZ11(30),BZ12(30),BZ13(30),BZ14(30),BZ15(30)
      REAL  BZ16(30),BZ17(30),BZ18(30),BZ19(30),BZ20(30)
      REAL  BZ21(30),BZ22(30),BZ23(30),BZ24(30),BZ25(30)
      REAL  BZ26(30),BZ27(30),BZ28(30),BZ29(30),BZ30(30)
      REAL  BZ31(30),BZ32(30),BZ33(30),BZ34(30),BZ35(30)
      REAL  BZ36(30),BZ37(30),BZ38(30),BZ39(30),BZ40(30)
      REAL  BZ41(30),BZ42(30),BZ43(30),BZ44(30),BZ45(30)
      REAL  BZ46(30),BZ47(30),BZ48(30),BZ49(30),BZ50(30)
      REAL  BZ51(30),BZ52(30),BZ53(30),BZ54(30),BZ55(30)
      REAL  BZ56(30),BZ57(30),BZ58(30),BZ59(30),BZ60(30)
      REAL  BZ61(30),BZ62(30)
C ------------------------
C   L=0    
      DATA BZ_1 /
     *    1.57080,    4.71239,    7.85398,   10.99557,   14.13717, 
     *   17.27876,   20.42035,   23.56194,   26.70354,   29.84513, 
     *   32.98672,   36.12832,   39.26991,   42.41150,   45.55309, 
     *   48.69469,   51.83628,   54.97787,   58.11946,   61.26106, 
     *   64.40265,   67.54424,   70.68583,   73.82743,   76.96902, 
     *   80.11061,   83.25221,   86.39380,   89.53539,   92.67698
     * /
C   L=1                
      DATA BZ_2 /
     *    3.14159,    6.28319,    9.42478,   12.56637,   15.70796, 
     *   18.84956,   21.99115,   25.13274,   28.27433,   31.41593, 
     *   34.55752,   37.69911,   40.84070,   43.98230,   47.12389, 
     *   50.26548,   53.40708,   56.54867,   59.69026,   62.83185, 
     *   65.97345,   69.11504,   72.25663,   75.39822,   78.53982, 
     *   81.68141,   84.82300,   87.96459,   91.10619,   94.24778 
     * /
C   L=2                
      DATA BZ_3 /
     *    4.49340,    7.72530,   10.90410,   14.06620,   17.22070, 
     *   20.37130,   23.51950,   26.66610,   29.81160,   32.95640, 
     *   36.10060,   39.24440,   42.38790,   45.53110,   48.67410, 
     *   51.81700,   54.95970,   58.10230,   61.24470,   64.38710, 
     *   67.52940,   70.67101,   73.81390,   76.95551,   80.09810, 
     *   83.23970,   86.38220,   89.52380,   92.66541,   95.80811 
     * /
C   L=3                
      DATA BZ_4 /
     *    5.76350,    9.09500,   12.32290,   15.51460,   18.68900, 
     *   21.85390,   25.01280,   28.16780,   31.32010,   34.47050, 
     *   37.61940,   40.76710,   43.91400,   47.06010,   50.20570, 
     *   53.35080,   56.49560,   59.64000,   62.78410,   65.92790, 
     *   69.07159,   72.21510,   75.35789,   78.50160,   81.64430, 
     *   84.78760,   87.93010,   91.07320,   94.21590,   97.35870 
     * /
C   L=4                
      DATA BZ_5 /
     *    6.98790,   10.41710,   13.69800,   16.92360,   20.12180, 
     *   23.30420,   26.47680,   29.64260,   32.80370,   35.96140, 
     *   39.11650,   42.26950,   45.42100,   48.57110,   51.72020, 
     *   54.86850,   58.01600,   61.16290,   64.30930,   67.45531, 
     *   70.60080,   73.74609,   76.89101,   80.03560,   83.18010, 
     *   86.32339,   89.46831,   92.61150,   95.75591,   98.89861 
     * /
C   L=5                
      DATA BZ_6 /
     *    8.18260,   11.70490,   15.03950,   18.30120,   21.52540, 
     *   24.72760,   27.91560,   31.09390,   34.26540,   37.43170, 
     *   40.59420,   43.75360,   46.91060,   50.06570,   53.21910, 
     *   56.37120,   59.52220,   62.67220,   65.82150,   68.97000, 
     *   72.11790,   75.26530,   78.41229,   81.55881,   84.70490, 
     *   87.85069,   90.99561,   94.14149,   97.28600,  100.43140 
     * /
C   L=6                
      DATA BZ_7 /
     *    9.35580,   12.96650,   16.35460,   19.65310,   22.90450, 
     *   26.12770,   29.33260,   32.52470,   35.70760,   38.88360, 
     *   42.05440,   45.22110,   48.38440,   51.54510,   54.70350, 
     *   57.86010,   61.01510,   64.16879,   67.32130,   70.47290, 
     *   73.62360,   76.77361,   79.92290,   83.07159,   86.21980, 
     *   89.36749,   92.51480,   95.66170,   98.80830,  101.95370 
     * /
C   L=7                
      DATA BZ_8 /
     *   10.51280,   14.20740,   17.64790,   20.98340,   24.26270, 
     *   27.50790,   30.73040,   33.93710,   37.13230,   40.31890, 
     *   43.49880,   46.67330,   49.84370,   53.01050,   56.17450, 
     *   59.33600,   62.49560,   65.65340,   68.80969,   71.96471, 
     *   75.11850,   78.27139,   81.42340,   84.57460,   87.72510, 
     *   90.87500,   94.02440,   97.17320,  100.32159,  103.46950 
     * /
C   L=8                
      DATA BZ_9 /
     *   11.65700,   15.43130,   18.92290,   22.29530,   25.60280, 
     *   28.87040,   32.11120,   35.33320,   38.54140,   41.73910, 
     *   44.92860,   48.11170,   51.28950,   54.46300,   57.63300, 
     *   60.80000,   63.96450,   67.12669,   70.28709,   73.44591, 
     *   76.60320,   79.75929,   82.91431,   86.06830,   89.22141, 
     *   92.37370,   95.52530,   98.67630,  101.82671,  104.97650 
     * /
C   L=9                
      DATA BZ10 /
     *   12.79080,   16.64100,   20.18240,   23.59120,   26.92700, 
     *   30.21720,   33.47680,   36.71450,   39.93610,   43.14540, 
     *   46.34510,   49.53710,   52.72290,   55.90360,   59.08000, 
     *   62.25270,   65.42250,   68.58960,   71.75439,   74.91721, 
     *   78.07829,   81.23790,   84.39610,   87.55310,   90.70900, 
     *   93.86400,   97.01810,  100.17140,  103.32401,  106.47591 
     * /
C   L=10               
      DATA BZ11 /
     *   13.91580,   17.83860,   21.42840,   24.87320,   28.23710, 
     *   31.55020,   34.82870,   38.08250,   41.31790,   44.53910, 
     *   47.74930,   50.95070,   54.14480,   57.33290,   60.51600, 
     *   63.69490,   66.87019,   70.04240,   73.21201,   76.37910, 
     *   79.54430,   82.70760,   85.86920,   89.02950,   92.18840, 
     *   95.34621,   98.50301,  101.65880,  104.81371,  107.96790 
     * /
C   L=11               
      DATA BZ12 /
     *   15.03350,   19.02570,   22.66260,   26.14270,   29.53460, 
     *   32.87050,   36.16810,   39.43820,   42.68760,   45.92120, 
     *   49.14220,   52.35320,   55.55590,   58.75170,   61.94190, 
     *   65.12720,   68.30840,   71.48590,   74.66040,   77.83220, 
     *   81.00150,   84.16879,   87.33411,   90.49780,   93.66000, 
     *   96.82080,   99.98039,  103.13890,  106.29630,  109.45290 
     * /
C   L=12               
      DATA BZ13 /
     *   16.14470,   20.20380,   23.88650,   27.40120,   30.82080, 
     *   34.17950,   37.49630,   40.78270,   44.04640,   47.29250, 
     *   50.52450,   53.74530,   56.95690,   60.16080,   63.35820, 
     *   66.55009,   69.73740,   72.92050,   76.10020,   79.27670, 
     *   82.45050,   85.62190,   88.79111,   91.95840,   95.12390, 
     *   98.28790,  101.45050,  104.61180,  107.77200,  110.93111 
     * /
C   L=13               
      DATA BZ14 /
     *   17.25050,   21.37380,   25.10100,   28.64980,   32.09670, 
     *   35.47800,   38.81400,   42.11700,   45.39500,   48.65370, 
     *   51.89700,   55.12790,   58.34850,   61.56060,   64.76550, 
     *   67.96420,   71.15770,   74.34669,   77.53169,   80.71320, 
     *   83.89160,   87.06731,   90.24049,   93.41161,   96.58070, 
     *   99.74800,  102.91370,  106.07800,  109.24100,  112.40269 
     * /
C   L=14               
      DATA BZ15 /
     *   18.35130,   22.53670,   26.30710,   29.88930,   33.36320, 
     *   36.76700,   40.12210,   43.44160,   46.73410,   50.00560, 
     *   53.26030,   56.50140,   59.73120,   62.95170,   66.16420, 
     *   69.37000,   72.56990,   75.76480,   78.95531,   82.14191, 
     *   85.32510,   88.50529,   91.68269,   94.85770,   98.03050, 
     *  101.20129,  104.37030,  107.53770,  110.70351,  113.86810 
     * /
C   L=15               
      DATA BZ16 /
     *   19.44770,   23.69310,   27.50570,   31.12060,   34.62110, 
     *   38.04720,   41.42140,   44.75740,   48.06440,   51.34880, 
     *   54.61490,   57.86640,   61.10560,   64.33459,   67.55490, 
     *   70.76781,   73.97440,   77.17540,   80.37151,   83.56340, 
     *   86.75150,   89.93620,   93.11800,   96.29700,   99.47360, 
     *  102.64799,  105.82040,  108.99100,  112.15990,  115.32730 
     * /
C   L=16               
      DATA BZ17 /
     *   20.54020,   24.84370,   28.69740,   32.34440,   35.87110, 
     *   39.31930,   42.71240,   46.06500,   49.38650,   52.68370, 
     *   55.96150,   59.22330,   62.47200,   65.70970,   68.93790, 
     *   72.15810,   75.37140,   78.57860,   81.78050,   84.97780, 
     *   88.17101,   91.36040,   94.54660,   97.72980,  100.91029, 
     *  104.08839,  107.26430,  110.43820,  113.61031,  116.78070 
     * /
C   L=17               
      DATA BZ18 /
     *   21.62920,   25.98890,   29.88280,   33.56120,   37.11390, 
     *   40.58390,   43.99580,   47.36480,   50.70080,   54.01100, 
     *   57.30040,   60.57280,   63.83100,   67.07739,   70.31360, 
     *   73.54120,   76.76131,   79.97490,   83.18280,   86.38550, 
     *   89.58380,   92.77811,   95.96880,   99.15630,  102.34081, 
     *  105.52271,  108.70230,  111.87959,  115.05490,  118.22839 
     * /
C   L=18               
      DATA BZ19 /
     *   22.71500,   27.12930,   31.06230,   34.77170,   38.34980, 
     *   41.84150,   45.27210,   48.65740,   52.00790,   55.33110, 
     *   58.63210,   61.91500,   65.18291,   68.43810,   71.68250, 
     *   74.91750,   78.14461,   81.36459,   84.57840,   87.78680, 
     *   90.99040,   94.18961,   97.38490,  100.57671,  103.76540, 
     *  106.95120,  110.13440,  113.31531,  116.49390,  119.67059 
     * /
C   L=19               
      DATA BZ20 /
     *   23.79780,   28.26530,   32.23650,   35.97630,   39.57950, 
     *   43.09250,   46.54160,   49.94320,   53.30820,   56.64430, 
     *   59.95700,   63.25050,   66.52811,   69.79210,   73.04469, 
     *   76.28729,   79.52139,   82.74789,   85.96780,   89.18190, 
     *   92.39079,   95.59500,   98.79510,  101.99139,  105.18430, 
     *  108.37410,  111.56110,  114.74550,  117.92751,  121.10741 
     * /
C   L=20               
      DATA BZ21 /
     *   24.87800,   29.39710,   33.40580,   37.17530,   40.80330, 
     *   44.33740,   47.80490,   51.22260,   54.60200,   57.95100, 
     *   61.27540,   64.57961,   67.86681,   71.13980,   74.40060, 
     *   77.65089,   80.89200,   84.12520,   87.35130,   90.57111, 
     *   93.78540,   96.99471,  100.19960,  103.40041,  106.59760, 
     *  109.79150,  112.98230,  116.17039,  119.35590,  122.53909 
     * /
C   L=21               
      DATA BZ22 /
     *   25.95570,   30.52510,   34.57040,   38.36920,   42.02150, 
     *   45.57650,   49.06220,   52.49600,   55.88970,   59.25160, 
     *   62.58770,   65.90250,   69.19949,   72.48151,   75.75050, 
     *   79.00850,   82.25681,   85.49660,   88.72890,   91.95461, 
     *   95.17439,   98.38890,  101.59860,  104.80400,  108.00560, 
     *  111.20360,  114.39841,  117.59019,  120.77930,  123.96590 
     * /
C   L=22               
      DATA BZ23 /
     *   27.03110,   31.64960,   35.73080,   39.55820,   43.23460, 
     *   46.81020,   50.31390,   53.76360,   57.17160,   60.54630, 
     *   63.89410,   67.21960,   70.52631,   73.81731,   77.09470, 
     *   80.36040,   83.61591,   86.86240,   90.10100,   93.33260, 
     *   96.55791,   99.77769,  102.99229,  106.20239,  109.40840, 
     *  112.61060,  115.80940,  119.00500,  122.19769,  125.38770 
     * /
C   L=23               
      DATA BZ24 /
     *   28.10430,   32.77070,   36.88710,   40.74280,   44.44280, 
     *   48.03880,   51.56030,   55.02590,   58.44800,   61.83560, 
     *   65.19501,   68.53110,   71.84760,   75.14760,   78.43340, 
     *   81.70680,   84.96950,   88.22279,   91.46780,   94.70531, 
     *   97.93629,  101.16130,  104.38091,  107.59579,  110.80620, 
     *  114.01270,  117.21550,  120.41490,  123.61130,  126.80490 
     * /
C   L=24               
      DATA BZ25 /
     *   29.17560,   33.88880,   38.03960,   41.92300,   45.64650, 
     *   49.26260,   52.80180,   56.28300,   59.71930,   63.11950, 
     *   66.49049,   69.83730,   73.16360,   76.47260,   79.76669, 
     *   83.04800,   86.31799,   89.57800,   92.82941,   96.07291, 
     *   99.30949,  102.53990,  105.76460,  108.98421,  112.19920, 
     *  115.41000,  118.61690,  121.82030,  125.02040,  128.21750 
     * /
C   L=25               
      DATA BZ26 /
     *   30.24500,   35.00400,   39.18860,   43.09930,   46.84570, 
     *   50.48180,   54.03840,   57.53530,   60.98550,   64.39850, 
     *   67.78101,   71.13840,   74.47450,   77.79250,   81.09500, 
     *   84.38409,   87.66141,   90.92830,   94.18610,   97.43570, 
     *  100.67799,  103.91370,  107.14349,  110.36790,  113.58749, 
     *  116.80260,  120.01370,  123.22099,  126.42490,  129.62561 
     * /
C   L=26               
      DATA BZ27 /
     *   31.31270,   36.11640,   40.33420,   44.27180,   48.04090, 
     *   51.69660,   55.27060,   58.78290,   62.24700,   65.67261, 
     *   69.06670,   72.43460,   75.78040,   79.10750,   82.41850, 
     *   85.71530,   88.99989,   92.27370,   95.53799,   98.79359, 
     *  102.04170,  105.28281,  108.51781,  111.74710,  114.97130, 
     *  118.19080,  121.40610,  124.61740,  127.82510,  131.02951 
     * /
C   L=27               
      DATA BZ28 /
     *   32.37870,   37.22630,   41.47660,   45.44070,   49.23220, 
     *   52.90740,   56.49850,   60.02610,   63.50400,   66.94209, 
     *   70.34770,   73.72610,   77.08170,   80.41789,   83.73720, 
     *   87.04190,   90.33389,   93.61450,   96.88519,  100.14700, 
     *  103.40080,  106.64740,  109.88760,  113.12180,  116.35069, 
     *  119.57460,  122.79410,  126.00951,  129.22110,  132.42911 
     * /
C   L=28               
      DATA BZ29 /
     *   33.44320,   38.33380,   42.61610,   46.60620,   50.41980, 
     *   54.11410,   57.72220,   61.26500,   64.75670,   68.20731, 
     *   71.62421,   75.01320,   78.37849,   81.72369,   85.05141, 
     *   88.36400,   91.66330,   94.95090,   98.22810,  101.49600, 
     *  104.75560,  108.00771,  111.25301,  114.49220,  117.72580, 
     *  120.95419,  124.17799,  127.39740,  130.61292,  133.82471 
     * /
C   L=29               
      DATA BZ30 /
     *   34.50630,   39.43900,   43.75270,   47.76850,   51.60390, 
     *   55.31720,   58.94210,   62.49990,   66.00520,   69.46820, 
     *   72.89650,   76.29601,   79.67101,   83.02510,   86.36130, 
     *   89.68170,   92.98840,   96.28290,   99.56660,  102.84061, 
     *  106.10609,  109.36369,  112.61420,  115.85840,  119.09669, 
     *  122.32970,  125.55769,  128.78131,  132.00070,  135.21631
     * /
C   L=30               
      DATA BZ31 /
     *   35.56800,   40.54200,   44.88670,   48.92770,   52.78460, 
     *   56.51670,   60.15820,   63.73090,   67.24969,   70.72501, 
     *   74.16470,   77.57460,   80.95930,   84.32240,   87.66690, 
     *   90.99519,   94.30920,   97.61070,  100.90089,  104.18120, 
     *  107.45239,  110.71561,  113.97141,  117.22050,  120.46359, 
     *  123.70110,  126.93350,  130.16129,  133.38461,  136.60400 
     * /
C   L=31               
      DATA BZ32 /
     *   36.62840,   41.64300,   46.01800,   50.08390,   53.96210, 
     *   57.71270,   61.37070,   64.95821,   68.49040,   71.97800, 
     *   75.42889,   78.84920,   82.24350,   85.61560,   88.96851, 
     *   92.30470,   95.62610,   98.93440,  102.23120,  105.51759, 
     *  108.79480,  112.06351,  115.32460,  118.57880,  121.82660, 
     *  125.06870,  128.30551,  131.53741,  134.76480,  137.98801 
     * /
C   L=32               
      DATA BZ33 /
     *   37.68750,   42.74200,   47.14700,   51.23740,   55.13650, 
     *   58.90550,   62.57980,   66.18201,   69.72749,   73.22729, 
     *   76.68941,   80.12000,   83.52390,   86.90500,   90.26620, 
     *   93.61020,   96.93890,  100.25430,  103.55760,  106.85020, 
     *  110.13319,  113.40750,  116.67390,  119.93320,  123.18581, 
     *  126.43250,  129.67371,  132.90979,  136.14120,  139.36829 
     * /
C   L=33               
      DATA BZ34 /
     *   38.74550,   43.83910,   48.27360,   52.38820,   56.30800, 
     *   60.09510,   63.78560,   67.40230,   70.96111,   74.47290, 
     *   77.94620,   81.38710,   84.80060,   88.19051,   91.56010, 
     *   94.91190,   98.24800,  101.57030,  104.88020,  108.17900, 
     *  111.46790,  114.74780,  118.01950,  121.28380,  124.54131, 
     *  127.79260,  131.03821,  134.27850,  137.51401,  140.74500 
     * /
C   L=34               
      DATA BZ35 /
     *   39.80240,   44.93450,   49.39790,   53.53650,   57.47670, 
     *   61.28180,   64.98820,   68.61940,   72.19119,   75.71510, 
     *   79.19940,   82.65060,   86.07359,   89.47250,   92.85040, 
     *   96.21001,   99.55350,  102.88271,  106.19910,  109.50420, 
     *  112.79890,  116.08440,  119.36150,  122.63091,  125.89320, 
     *  129.14920,  132.39920,  135.64371,  138.88330,  142.11819 
     * /
C   L=35               
      DATA BZ36 /
     *   40.85830,   46.02820,   50.52020,   54.68230,   58.64280, 
     *   62.46550,   66.18781,   69.83330,   73.41811,   76.95390, 
     *   80.44920,   83.91060,   87.34309,   90.75079,   94.13710, 
     *   97.50450,  100.85530,  104.19141,  107.51450,  110.82570, 
     *  114.12640,  117.41750,  120.69991,  123.97440,  127.24159, 
     *  130.50220,  133.75671,  137.00549,  140.24911,  143.48792 
     * /
C   L=36               
      DATA BZ37 /
     *   41.91310,   47.12020,   51.64040,   55.82570,   59.80620, 
     *   63.64650,   67.38451,   71.04410,   74.64191,   78.18950, 
     *   81.69580,   85.16730,   88.60930,   92.02580,   95.42030, 
     *   98.79550,  102.15370,  105.49680,  108.82629,  112.14380, 
     *  115.45039,  118.74710,  122.03490,  125.31450,  128.58661, 
     *  131.85181,  135.11081,  138.36389,  141.61160,  144.85440 
     * /
C   L=37               
      DATA BZ38 /
     *   42.96690,   48.21070,   52.75870,   56.96700,   60.96710, 
     *   64.82480,   68.57829,   72.25200,   75.86259,   79.42200, 
     *   82.93919,   86.42081,   89.87210,   93.29750,   96.70030, 
     *  100.08321,  103.44870,  106.79871,  110.13480,  113.45850, 
     *  116.77100,  120.07339,  123.36650,  126.65120,  129.92819, 
     *  133.19821,  136.46161,  139.71899,  142.97089,  146.21759 
     * /
C   L=38               
      DATA BZ39 /
     *   44.01990,   49.29970,   53.87510,   58.10600,   62.12570, 
     *   66.00060,   69.76950,   73.45711,   77.08040,   80.65150, 
     *   84.17950,   87.67110,   91.13190,   94.56599,   97.97701, 
     *  101.36771,  104.74049,  108.09740,  111.44009,  114.77000, 
     *  118.08839,  121.39639,  124.69490,  127.98470,  131.26660, 
     *  134.54120,  137.80920,  141.07089,  144.32690,  147.57761 
     * /
C   L=39               
      DATA BZ40 /
     *   45.07190,   50.38730,   54.98960,   59.24300,   63.28190, 
     *   67.17390,   70.95799,   74.65939,   78.29530,   81.87810, 
     *   85.41679,   88.91840,   92.38850,   95.83130,   99.25050, 
     *  102.64900,  106.02910,  109.39290,  112.74210,  116.07820, 
     *  119.40250,  122.71620,  126.02000,  129.31500,  132.60181, 
     *  135.88120,  139.15359,  142.41971,  145.67981,  148.93460 
     * /
C   L=40               
      DATA BZ41 /
     *   46.12310,   51.47350,   56.10250,   60.37790,   64.43600, 
     *   68.34480,   72.14400,   75.85910,   79.50760,   83.10181, 
     *   86.65120,   90.16280,   93.64211,   97.09370,  100.52110, 
     *  103.92720,  107.31461,  110.68530,  114.04100,  117.38341, 
     *  120.71359,  124.03281,  127.34210,  130.64221,  133.93390, 
     *  137.21799,  140.49500,  143.76541,  147.02969,  150.28839 
     * /
C   L=41               
      DATA BZ42 /
     *   47.17350,   52.55840,   57.21370,   61.51100,   65.58791, 
     *   69.51331,   73.32750,   77.05620,   80.71710,   84.32291, 
     *   87.88290,   91.40430,   94.89290,   98.35310,  101.78860, 
     *  105.20239,  108.59711,  111.97459,  115.33690,  118.68550, 
     *  122.02161,  125.34650,  128.66110,  131.96640,  135.26300, 
     *  138.55179,  141.83331,  145.10809,  148.37659,  151.63931 
     * /
C   L=42               
      DATA BZ43 /
     *   48.22310,   53.64200,   58.32330,   62.64220,   66.73770, 
     *   70.67970,   74.50870,   78.25090,   81.92410,   85.54120, 
     *   89.11180,   92.64310,   96.14090,   99.60970,  103.05330, 
     *  106.47479,  109.87669,  113.26109,  116.62990,  119.98460, 
     *  123.32671,  126.65720,  129.97720,  133.28760,  136.58920, 
     *  139.88269,  143.16870,  146.44791,  149.72061,  152.98740 
     * /
C   L=43               
      DATA BZ44 /
     *   49.27190,   54.72450,   59.43130,   63.77150,   67.88560, 
     *   71.84390,   75.68761,   79.44321,   83.12860,   86.75710, 
     *   90.33810,   93.87920,   97.38609,  100.86349,  104.31520, 
     *  107.74429,  111.15340,  114.54469,  117.92000,  121.28090, 
     *  124.62891,  127.96500,  131.29041,  134.60590,  137.91251, 
     *  141.21069,  144.50131,  147.78479,  151.06171,  154.33249 
     * /
C   L=44               
      DATA BZ45 /
     *   50.32010,   55.80570,   60.53790,   64.89920,   69.03149, 
     *   73.00600,   76.86430,   80.63310,   84.33070,   87.97040, 
     *   91.56190,   95.11259,   98.62869,  102.11459,  105.57440, 
     *  109.01109,  112.42740,  115.82550,  119.20731,  122.57440, 
     *  125.92821,  129.26999,  132.60080,  135.92151,  139.23291, 
     *  142.53589,  145.83099,  149.11890,  152.39999,  155.67490 
     * /
C   L=45               
      DATA BZ46 /
     *   51.36820,   56.88580,   61.64300,   66.02521,   70.17551, 
     *   74.16611,   78.03880,   81.82080,   85.53050,   89.18130, 
     *   92.78310,   96.34360,   99.86870,  103.36320,  106.83090, 
     *  110.27521,  113.69870,  117.10361,  120.49190,  123.86520, 
     *  127.22490,  130.57230,  133.90839,  137.23419,  140.55069, 
     *  143.85840,  147.15799,  150.45029,  153.73560,  157.01459 
     * /
C   L=46               
      DATA BZ47 /
     *   52.41420,   57.96480,   62.74670,   67.14951,   71.31779, 
     *   75.32420,   79.21130,   83.00630,   86.72800,   90.38989, 
     *   94.00200,   97.57210,  101.10620,  104.60910,  108.08490, 
     *  111.53670,  114.96741,  118.37910,  121.77380,  125.15320, 
     *  128.51880,  131.87180,  135.21329,  138.54431,  141.86569, 
     *  145.17810,  148.48230,  151.77899,  155.06851,  158.35159 
     * /
C   L=47               
      DATA BZ48 /
     *   53.46030,   59.04270,   63.84910,   68.27229,   72.45830, 
     *   76.48050,   80.38170,   84.18970,   87.92329,   91.59621, 
     *   95.21851,   98.79820,  102.34120,  105.85260,  109.33630, 
     *  112.79570,  116.23351,  119.65190,  123.05310,  126.43871, 
     *  129.81021,  133.16879,  136.51559,  139.85181,  143.17810, 
     *  146.49530,  149.80399,  153.10510,  156.39880,  159.68591 
     * /
C   L=48               
      DATA BZ49 /
     *   54.50630,   60.11960,   64.95020,   69.39349,   73.59711, 
     *   77.63490,   81.55020,   85.37100,   89.11639,   92.80020, 
     *   96.43280,  100.02190,  103.57390,  107.09370,  110.58530, 
     *  114.05220,  117.49710,  120.92230,  124.32990,  127.72160, 
     *  131.09891,  134.46310,  137.81540,  141.15671,  144.48792, 
     *  147.80981,  151.12320,  154.42859,  157.72659,  161.01770 
     * /
C   L=49               
      DATA BZ50 /
     *   55.55070,   61.19560,   66.05000,   70.51331,   74.73430, 
     *   78.78751,   82.71680,   86.55029,   90.30750,   94.00211, 
     *   97.64481,  101.24339,  104.80420,  108.33240,  111.83189, 
     *  115.30630,  118.75819,  122.19020,  125.60420,  129.00211, 
     *  132.38519,  135.75500,  139.11261,  142.45901,  145.79520, 
     *  149.12180,  152.43979,  155.74960,  159.05179,  162.34698 
     * /
C   L=50               
      DATA BZ51 /
     *   56.59500,   62.27060,   67.14861,   71.63170,   75.86990, 
     *   79.93840,   83.88161,   87.72771,   91.49651,   95.20200, 
     *   98.85471,  102.46271,  106.03230,  109.56880,  113.07620, 
     *  116.55800,  120.01700,  123.45570,  126.87610,  130.28009, 
     *  133.66901,  137.04440,  140.40741,  143.75891,  147.10001, 
     *  150.43140,  153.75391,  157.06812,  160.37460,  163.67389 
     * /
C   L=51               
      DATA BZ52 /
     *   57.63940,   63.34460,   68.24600,   72.74870,   77.00391, 
     *   81.08760,   85.04449,   88.90320,   92.68359,   96.39970, 
     *  100.06239,  103.67979,  107.25819,  110.80299,  114.31821, 
     *  117.80740,  121.27341,  124.71880,  128.14560,  131.55569, 
     *  134.95050,  138.33139,  141.69971,  145.05640,  148.40240, 
     *  151.73859,  155.06561,  158.38419,  161.69489,  164.99829 
     * /
C   L=52               
      DATA BZ53 /
     *   58.68190,   64.41769,   69.34219,   73.86430,   78.13640, 
     *   82.23520,   86.20570,   90.07690,   93.86870,   97.59550, 
     *  101.26810,  104.89481,  108.48199,  112.03500,  115.55800, 
     *  119.05460,  122.52760,  125.97971,  129.41290,  132.82901, 
     *  136.22961,  139.61609,  142.98969,  146.35159,  149.70251, 
     *  153.04340,  156.37491,  159.69791,  163.01291,  166.32040 
     * /
C   L=53               
      DATA BZ54 /
     *   59.72430,   65.49001,   70.43730,   74.97861,   79.26750, 
     *   83.38120,   87.36520,   91.24879,   95.05200,   98.78940, 
     *  102.47189,  106.10770,  109.70360,  113.26480,  116.79559, 
     *  120.29950,  123.77960,  127.23830,  130.67780,  134.10001, 
     *  137.50641,  140.89850,  144.27740,  147.64441,  151.00021, 
     *  154.34579,  157.68201,  161.00931,  164.32849,  167.64011 
     * /
C   L=54               
      DATA BZ55 /
     *   60.76680,   66.56140,   71.53140,   76.09171,   80.39709, 
     *   84.52570,   88.52310,   92.41890,   96.23340,   99.98129, 
     *  103.67360,  107.31870,  110.92329,  114.49260,  118.03110, 
     *  121.54240,  125.02940,  128.49469,  131.94061,  135.36880, 
     *  138.78101,  142.17859,  145.56290,  148.93491,  152.29568, 
     *  155.64600,  158.98669,  162.31851,  165.64191,  168.95761 
     * /
C   L=55               
      DATA BZ56 /
     *   61.80820,   67.63200,   72.62440,   77.20351,   81.52541, 
     *   85.66859,   89.67931,   93.58730,   97.41310,  101.17140, 
     *  104.87350,  108.52769,  112.14090,  115.71831,  119.26450, 
     *  122.78310,  126.27699,  129.74899,  133.20111,  136.63541, 
     *  140.05341,  143.45651,  146.84610,  150.22321,  153.58890, 
     *  156.94400,  160.28922,  163.62531,  166.95300,  170.27280 
     * /
C   L=56               
      DATA BZ57 /
     *   62.84960,   68.70190,   73.71640,   78.31419,   82.65230, 
     *   86.81010,   90.83400,   94.75410,   98.59100,  102.35980, 
     *  106.07150,  109.73480,  113.35651,  116.94209,  120.49590, 
     *  124.02180,  127.52260,  131.00119,  134.45959,  137.89990, 
     *  141.32361,  144.73230,  148.12720,  151.50940,  154.87991, 
     *  158.23969,  161.58951,  164.92999,  168.26199,  171.58578 
     * /
C   L=57               
      DATA BZ58 /
     *   63.89000,   69.77090,   74.80740,   79.42360,   83.77789, 
     *   87.95010,   91.98711,   95.91920,   99.76730,  103.54630, 
     *  107.26770,  110.94009,  114.57030,  118.16389,  121.72540, 
     *  125.25841,  128.76620,  132.25131,  135.71600,  139.16229, 
     *  142.59171,  146.00589,  149.40610,  152.79340,  156.16879, 
     *  159.53329,  162.88770,  166.23260,  169.56870,  172.89670 
     * /
C   L=58               
      DATA BZ59 /
     *   64.93040,   70.83920,   75.89740,   80.53191,   84.90230, 
     *   89.08881,   93.13879,   97.08279,  100.94189,  104.73120, 
     *  108.46210,  112.14349,  115.78220,  119.38380,  122.95290, 
     *  126.49310,  130.00781,  133.49939,  136.97040,  140.42261, 
     *  143.85779,  147.27750,  150.68289,  154.07529,  157.45560, 
     *  160.82480,  164.18369,  167.53299,  170.87341,  174.20551 
     * /
C   L=59               
      DATA BZ60 /
     *   65.97079,   71.90669,   76.98650,   81.63921,   86.02541, 
     *   90.22610,   94.28900,   98.24480,  102.11481,  105.91431, 
     *  109.65480,  113.34509,  116.99229,  120.60190,  124.17850, 
     *  127.72591,  131.24741,  134.74551,  138.22269,  141.68091, 
     *  145.12189,  148.54700,  151.95770,  155.35519,  158.74039, 
     *  162.11429,  165.47769,  168.83139,  172.17599,  175.51208 
     * /
C   L=60               
      DATA BZ61 /
     *   67.00929,   72.97350,   78.07460,   82.74530,   87.14729, 
     *   91.36211,   95.43781,   99.40540,  103.28630,  107.09590, 
     *  110.84579,  114.54500,  118.20061,  121.81810,  125.40221, 
     *  128.95679,  132.48511,  135.98981,  139.47321,  142.93729, 
     *  146.38391,  149.81451,  153.23050,  156.63300,  160.02310, 
     *  163.40170,  166.76959,  170.12769,  173.47650,  176.81680 
     * /
C   L=61               
      DATA BZ62 /
     *   68.04781,   74.03970,   79.16190,   83.85040,   88.26801, 
     *   92.49680,   96.58521,  100.56450,  104.45610,  108.27580, 
     *  112.03520,  115.74319,  119.40710,  123.03250,  126.62421, 
     *  130.18591,  133.72089,  137.23209,  140.72171,  144.19171, 
     *  147.64401,  151.08011,  154.50131,  157.90891,  161.30380, 
     *  164.68710,  168.05960,  171.42200,  174.77499,  178.11938 
     * /
C -------------------------
      IERR = 0
      IF(NMAXP.LE.0.OR.NMAXP.GT.30.OR.LMAXP.LE.0.OR.LMAXP.GT.60) THEN
        IERR = 1
        RETURN
      ENDIF
      LMAX2 = LMAXP + 2

      DO J=1,NMAXP

        BZEROS(J,1) = BZ_1(J)
        BZEROS(J,2) = BZ_2(J)
        BZEROS(J,3) = BZ_3(J)
        BZEROS(J,4) = BZ_4(J)
        BZEROS(J,5) = BZ_5(J)
        BZEROS(J,6) = BZ_6(J)
        BZEROS(J,7) = BZ_7(J)
        BZEROS(J,8) = BZ_8(J)
        BZEROS(J,9) = BZ_9(J)

        BZEROS(J,10) = BZ10(J)
        BZEROS(J,11) = BZ11(J)
        BZEROS(J,12) = BZ12(J)
        BZEROS(J,13) = BZ13(J)
        BZEROS(J,14) = BZ14(J)
        BZEROS(J,15) = BZ15(J)
        BZEROS(J,16) = BZ16(J)
        BZEROS(J,17) = BZ17(J)
        BZEROS(J,18) = BZ18(J)
        BZEROS(J,19) = BZ19(J)

        BZEROS(J,20) = BZ20(J)
        BZEROS(J,21) = BZ21(J)
        BZEROS(J,22) = BZ22(J)
        BZEROS(J,23) = BZ23(J)
        BZEROS(J,24) = BZ24(J)
        BZEROS(J,25) = BZ25(J)
        BZEROS(J,26) = BZ26(J)
        BZEROS(J,27) = BZ27(J)
        BZEROS(J,28) = BZ28(J)
        BZEROS(J,29) = BZ29(J)

        BZEROS(J,30) = BZ30(J)
        BZEROS(J,31) = BZ31(J)
        BZEROS(J,32) = BZ32(J)
        BZEROS(J,33) = BZ33(J)
        BZEROS(J,34) = BZ34(J)
        BZEROS(J,35) = BZ35(J)
        BZEROS(J,36) = BZ36(J)
        BZEROS(J,37) = BZ37(J)
        BZEROS(J,38) = BZ38(J)
        BZEROS(J,39) = BZ39(J)

        BZEROS(J,40) = BZ40(J)
        BZEROS(J,41) = BZ41(J)
        BZEROS(J,42) = BZ42(J)
        BZEROS(J,43) = BZ43(J)
        BZEROS(J,44) = BZ44(J)
        BZEROS(J,45) = BZ45(J)
        BZEROS(J,46) = BZ46(J)
        BZEROS(J,47) = BZ47(J)
        BZEROS(J,48) = BZ48(J)
        BZEROS(J,49) = BZ49(J)

        BZEROS(J,50) = BZ50(J)
        BZEROS(J,51) = BZ51(J)
        BZEROS(J,52) = BZ52(J)
        BZEROS(J,53) = BZ53(J)
        BZEROS(J,54) = BZ54(J)
        BZEROS(J,55) = BZ55(J)
        BZEROS(J,56) = BZ56(J)
        BZEROS(J,57) = BZ57(J)
        BZEROS(J,58) = BZ58(J)
        BZEROS(J,59) = BZ59(J)

        BZEROS(J,60) = BZ60(J)
        BZEROS(J,61) = BZ61(J)
        BZEROS(J,62) = BZ62(J)

      ENDDO
C ------------------------
      DO J=1,NMAXP
      DO I=1,LMAX2
        BZ(J,I) = BZEROS(J,I)
      ENDDO
      ENDDO
C -------------------------
      RETURN
      END
